/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var K=["require","exports","vs/base/common/platform","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/core/range","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/stopwatch","vs/base/common/event","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/base/common/uri","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/editor/common/core/characterClassifier","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ee=function(T){for(var t=[],M=0,p=T.length;M<p;M++)t[M]=K[T[M]];return t};"use strict";var be=this,Se=typeof global=="object"?global:{},ue;(function(T){T.global=be;var t=function(){function M(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1}return Object.defineProperty(M.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),M.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=M._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof T.global.importScripts=="function")},M._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},M}();T.Environment=t})(ue||(ue={}));var ue;(function(T){var t=function(){function P(l,b,s){this.type=l,this.detail=b,this.timestamp=s}return P}();T.LoaderEvent=t;var M=function(){function P(l){this._events=[new t(1,"",l)]}return P.prototype.record=function(l,b){this._events.push(new t(l,b,T.Utilities.getHighPerformanceTimestamp()))},P.prototype.getEvents=function(){return this._events},P}();T.LoaderEventRecorder=M;var p=function(){function P(){}return P.prototype.record=function(l,b){},P.prototype.getEvents=function(){return[]},P.INSTANCE=new P,P}();T.NullLoaderEventRecorder=p})(ue||(ue={}));var ue;(function(T){var t=function(){function M(){}return M.fileUriToFilePath=function(p,P){if(P=decodeURI(P).replace(/%23/g,"#"),p){if(/^file:\/\/\//.test(P))return P.substr(8);if(/^file:\/\//.test(P))return P.substr(5)}else if(/^file:\/\//.test(P))return P.substr(7);return P},M.startsWith=function(p,P){return p.length>=P.length&&p.substr(0,P.length)===P},M.endsWith=function(p,P){return p.length>=P.length&&p.substr(p.length-P.length)===P},M.containsQueryString=function(p){return/^[^\#]*\?/gi.test(p)},M.isAbsolutePath=function(p){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(p)},M.forEachProperty=function(p,P){if(p){var l=void 0;for(l in p)p.hasOwnProperty(l)&&P(l,p[l])}},M.isEmpty=function(p){var P=!0;return M.forEachProperty(p,function(){P=!1}),P},M.recursiveClone=function(p){if(!p||typeof p!="object"||p instanceof RegExp||!Array.isArray(p)&&Object.getPrototypeOf(p)!==Object.prototype)return p;var P=Array.isArray(p)?[]:{};return M.forEachProperty(p,function(l,b){b&&typeof b=="object"?P[l]=M.recursiveClone(b):P[l]=b}),P},M.generateAnonymousModule=function(){return"===anonymous"+M.NEXT_ANONYMOUS_ID+++"==="},M.isAnonymousModule=function(p){return M.startsWith(p,"===anonymous")},M.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=T.global.performance&&typeof T.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?T.global.performance.now():Date.now()},M.NEXT_ANONYMOUS_ID=1,M.PERFORMANCE_NOW_PROBED=!1,M.HAS_PERFORMANCE_NOW=!1,M}();T.Utilities=t})(ue||(ue={}));var ue;(function(T){function t(P){if(P instanceof Error)return P;var l=new Error(P.message||String(P)||"Unknown Error");return P.stack&&(l.stack=P.stack),l}T.ensureError=t;var M=function(){function P(){}return P.validateConfigurationOptions=function(l){function b(u){if(u.phase==="loading"){console.error('Loading "'+u.moduleId+'" failed'),console.error(u),console.error("Here are the modules that depend on it:"),console.error(u.neededBy);return}if(u.phase==="factory"){console.error('The factory method of "'+u.moduleId+'" has thrown an exception'),console.error(u);return}}if(l=l||{},typeof l.baseUrl!="string"&&(l.baseUrl=""),typeof l.isBuild!="boolean"&&(l.isBuild=!1),typeof l.paths!="object"&&(l.paths={}),typeof l.config!="object"&&(l.config={}),typeof l.catchError=="undefined"&&(l.catchError=!1),typeof l.recordStats=="undefined"&&(l.recordStats=!1),typeof l.urlArgs!="string"&&(l.urlArgs=""),typeof l.onError!="function"&&(l.onError=b),Array.isArray(l.ignoreDuplicateModules)||(l.ignoreDuplicateModules=[]),l.baseUrl.length>0&&(T.Utilities.endsWith(l.baseUrl,"/")||(l.baseUrl+="/")),typeof l.cspNonce!="string"&&(l.cspNonce=""),typeof l.preferScriptTags=="undefined"&&(l.preferScriptTags=!1),Array.isArray(l.nodeModules)||(l.nodeModules=[]),l.nodeCachedData&&typeof l.nodeCachedData=="object"&&(typeof l.nodeCachedData.seed!="string"&&(l.nodeCachedData.seed="seed"),(typeof l.nodeCachedData.writeDelay!="number"||l.nodeCachedData.writeDelay<0)&&(l.nodeCachedData.writeDelay=1e3*7),!l.nodeCachedData.path||typeof l.nodeCachedData.path!="string")){var s=t(new Error("INVALID cached data configuration, 'path' MUST be set"));s.phase="configuration",l.onError(s),l.nodeCachedData=void 0}return l},P.mergeConfigurationOptions=function(l,b){l===void 0&&(l=null),b===void 0&&(b=null);var s=T.Utilities.recursiveClone(b||{});return T.Utilities.forEachProperty(l,function(u,a){u==="ignoreDuplicateModules"&&typeof s.ignoreDuplicateModules!="undefined"?s.ignoreDuplicateModules=s.ignoreDuplicateModules.concat(a):u==="paths"&&typeof s.paths!="undefined"?T.Utilities.forEachProperty(a,function(L,w){return s.paths[L]=w}):u==="config"&&typeof s.config!="undefined"?T.Utilities.forEachProperty(a,function(L,w){return s.config[L]=w}):s[u]=T.Utilities.recursiveClone(a)}),P.validateConfigurationOptions(s)},P}();T.ConfigurationOptionsUtil=M;var p=function(){function P(l,b){if(this._env=l,this.options=M.mergeConfigurationOptions(b),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var s=this.options.nodeRequire.main.filename,u=Math.max(s.lastIndexOf("/"),s.lastIndexOf("\\"));this.options.baseUrl=s.substring(0,u+1)}if(this.options.nodeMain&&this._env.isNode){var s=this.options.nodeMain,u=Math.max(s.lastIndexOf("/"),s.lastIndexOf("\\"));this.options.baseUrl=s.substring(0,u+1)}}}return P.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var l=0;l<this.options.ignoreDuplicateModules.length;l++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[l]]=!0},P.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var l=0,b=this.options.nodeModules;l<b.length;l++){var s=b[l];this.nodeModulesMap[s]=!0}},P.prototype._createSortedPathsRules=function(){var l=this;this.sortedPathsRules=[],T.Utilities.forEachProperty(this.options.paths,function(b,s){Array.isArray(s)?l.sortedPathsRules.push({from:b,to:s}):l.sortedPathsRules.push({from:b,to:[s]})}),this.sortedPathsRules.sort(function(b,s){return s.from.length-b.from.length})},P.prototype.cloneAndMerge=function(l){return new P(this._env,M.mergeConfigurationOptions(l,this.options))},P.prototype.getOptionsLiteral=function(){return this.options},P.prototype._applyPaths=function(l){for(var b,s=0,u=this.sortedPathsRules.length;s<u;s++)if(b=this.sortedPathsRules[s],T.Utilities.startsWith(l,b.from)){for(var a=[],L=0,w=b.to.length;L<w;L++)a.push(b.to[L]+l.substr(b.from.length));return a}return[l]},P.prototype._addUrlArgsToUrl=function(l){return T.Utilities.containsQueryString(l)?l+"&"+this.options.urlArgs:l+"?"+this.options.urlArgs},P.prototype._addUrlArgsIfNecessaryToUrl=function(l){return this.options.urlArgs?this._addUrlArgsToUrl(l):l},P.prototype._addUrlArgsIfNecessaryToUrls=function(l){if(this.options.urlArgs)for(var b=0,s=l.length;b<s;b++)l[b]=this._addUrlArgsToUrl(l[b]);return l},P.prototype.moduleIdToPaths=function(l){var b=this.nodeModulesMap[l]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(l);if(b)return this.isBuild()?["empty:"]:["node|"+l];var s=l,u;if(!T.Utilities.endsWith(s,".js")&&!T.Utilities.isAbsolutePath(s)){u=this._applyPaths(s);for(var a=0,L=u.length;a<L;a++)this.isBuild()&&u[a]==="empty:"||(T.Utilities.isAbsolutePath(u[a])||(u[a]=this.options.baseUrl+u[a]),!T.Utilities.endsWith(u[a],".js")&&!T.Utilities.containsQueryString(u[a])&&(u[a]=u[a]+".js"))}else!T.Utilities.endsWith(s,".js")&&!T.Utilities.containsQueryString(s)&&(s=s+".js"),u=[s];return this._addUrlArgsIfNecessaryToUrls(u)},P.prototype.requireToUrl=function(l){var b=l;return T.Utilities.isAbsolutePath(b)||(b=this._applyPaths(b)[0],T.Utilities.isAbsolutePath(b)||(b=this.options.baseUrl+b)),this._addUrlArgsIfNecessaryToUrl(b)},P.prototype.isBuild=function(){return this.options.isBuild},P.prototype.isDuplicateMessageIgnoredFor=function(l){return this.ignoreDuplicateModulesMap.hasOwnProperty(l)},P.prototype.getConfigForModule=function(l){if(this.options.config)return this.options.config[l]},P.prototype.shouldCatchError=function(){return this.options.catchError},P.prototype.shouldRecordStats=function(){return this.options.recordStats},P.prototype.onError=function(l){this.options.onError(l)},P}();T.Configuration=p})(ue||(ue={}));var ue;(function(T){var t=function(){function s(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}return s.prototype.load=function(u,a,L,w){var g=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new p;else if(this._env.isElectronRenderer){var f=u.getConfig().getOptionsLiteral().preferScriptTags;f?this._scriptLoader=new M:this._scriptLoader=new P(this._env)}else this._env.isNode?this._scriptLoader=new P(this._env):this._scriptLoader=new M;var m={callback:L,errorback:w};if(this._callbackMap.hasOwnProperty(a)){this._callbackMap[a].push(m);return}this._callbackMap[a]=[m],this._scriptLoader.load(u,a,function(){return g.triggerCallback(a)},function(A){return g.triggerErrorback(a,A)})},s.prototype.triggerCallback=function(u){var a=this._callbackMap[u];delete this._callbackMap[u];for(var L=0;L<a.length;L++)a[L].callback()},s.prototype.triggerErrorback=function(u,a){var L=this._callbackMap[u];delete this._callbackMap[u];for(var w=0;w<L.length;w++)L[w].errorback(a)},s}(),M=function(){function s(){}return s.prototype.attachListeners=function(u,a,L){var w=function(){u.removeEventListener("load",g),u.removeEventListener("error",f)},g=function(m){w(),a()},f=function(m){w(),L(m)};u.addEventListener("load",g),u.addEventListener("error",f)},s.prototype.load=function(u,a,L,w){if(/^node\|/.test(a)){var g=u.getConfig().getOptionsLiteral(),f=l(u.getRecorder(),g.nodeRequire||T.global.nodeRequire),m=a.split("|"),A=null;try{A=f(m[1])}catch(r){w(r);return}u.enqueueDefineAnonymousModule([],function(){return A}),L()}else{var _=document.createElement("script");_.setAttribute("async","async"),_.setAttribute("type","text/javascript"),this.attachListeners(_,L,w);var v=u.getConfig().getOptionsLiteral().trustedTypesPolicy;v&&(a=v.createScriptURL(a)),_.setAttribute("src",a);var n=u.getConfig().getOptionsLiteral().cspNonce;n&&_.setAttribute("nonce",n),document.getElementsByTagName("head")[0].appendChild(_)}},s}(),p=function(){function s(){}return s.prototype.load=function(u,a,L,w){var g=u.getConfig().getOptionsLiteral().trustedTypesPolicy;g&&(a=g.createScriptURL(a));try{importScripts(a),L()}catch(f){w(f)}},s}(),P=function(){function s(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}return s.prototype._init=function(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))},s.prototype._initNodeRequire=function(u,a){var L=a.getConfig().getOptionsLiteral().nodeCachedData;if(!!L&&!this._didPatchNodeRequire){this._didPatchNodeRequire=!0;var w=this,g=u("module");function f(m){var A=m.constructor,_=function(n){try{return m.require(n)}finally{}};return _.resolve=function(n,r){return A._resolveFilename(n,m,!1,r)},_.main=process.mainModule,_.extensions=A._extensions,_.cache=A._cache,_}g.prototype._compile=function(m,A){var _=g.wrap(m.replace(/^#!.*/,"")),v=a.getRecorder(),n=w._getCachedDataPath(L,A),r={filename:A},i;try{var o=w._fs.readFileSync(n);i=o.slice(0,16),r.cachedData=o.slice(16),v.record(60,n)}catch(D){v.record(61,n)}var h=new w._vm.Script(_,r),E=h.runInThisContext(r),d=w._path.dirname(A),S=f(this),c=[this.exports,S,this,A,d,process,Se,Buffer],C=E.apply(this.exports,c);return w._handleCachedData(h,_,n,!r.cachedData,a),w._verifyCachedData(h,_,n,i,a),C}}},s.prototype.load=function(u,a,L,w){var g=this,f=u.getConfig().getOptionsLiteral(),m=l(u.getRecorder(),f.nodeRequire||T.global.nodeRequire),A=f.nodeInstrumenter||function(E){return E};this._init(m),this._initNodeRequire(m,u);var _=u.getRecorder();if(/^node\|/.test(a)){var v=a.split("|"),n=null;try{n=m(v[1])}catch(E){w(E);return}u.enqueueDefineAnonymousModule([],function(){return n}),L()}else{a=T.Utilities.fileUriToFilePath(this._env.isWindows,a);var r=this._path.normalize(a),i=this._getElectronRendererScriptPathOrUri(r),o=Boolean(f.nodeCachedData),h=o?this._getCachedDataPath(f.nodeCachedData,a):void 0;this._readSourceAndCachedData(r,h,_,function(E,d,S,c){if(E){w(E);return}var C;d.charCodeAt(0)===s._BOM?C=s._PREFIX+d.substring(1)+s._SUFFIX:C=s._PREFIX+d+s._SUFFIX,C=A(C,r);var D={filename:i,cachedData:S},F=g._createAndEvalScript(u,C,D,L,w);g._handleCachedData(F,C,h,o&&!S,u),g._verifyCachedData(F,C,h,c,u)})}},s.prototype._createAndEvalScript=function(u,a,L,w,g){var f=u.getRecorder();f.record(31,L.filename);var m=new this._vm.Script(a,L),A=m.runInThisContext(L),_=u.getGlobalAMDDefineFunc(),v=!1,n=function(){return v=!0,_.apply(null,arguments)};return n.amd=_.amd,A.call(T.global,u.getGlobalAMDRequireFunc(),n,L.filename,this._path.dirname(L.filename)),f.record(32,L.filename),v?w():g(new Error("Didn't receive define call in "+L.filename+"!")),m},s.prototype._getElectronRendererScriptPathOrUri=function(u){if(!this._env.isElectronRenderer)return u;var a=u.match(/^([a-z])\:(.*)/i);return a?"file:///"+(a[1].toUpperCase()+":"+a[2]).replace(/\\/g,"/"):"file://"+u},s.prototype._getCachedDataPath=function(u,a){var L=this._crypto.createHash("md5").update(a,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),w=this._path.basename(a).replace(/\.js$/,"");return this._path.join(u.path,w+"-"+L+".code")},s.prototype._handleCachedData=function(u,a,L,w,g){var f=this;u.cachedDataRejected?this._fs.unlink(L,function(m){g.getRecorder().record(62,L),f._createAndWriteCachedData(u,a,L,g),m&&g.getConfig().onError(m)}):w&&this._createAndWriteCachedData(u,a,L,g)},s.prototype._createAndWriteCachedData=function(u,a,L,w){var g=this,f=Math.ceil(w.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),m=-1,A=0,_=void 0,v=function(){setTimeout(function(){_||(_=g._crypto.createHash("md5").update(a,"utf8").digest());var n=u.createCachedData();if(!(n.length===0||n.length===m||A>=5)){if(n.length<m){v();return}m=n.length,g._fs.writeFile(L,Buffer.concat([_,n]),function(r){r&&w.getConfig().onError(r),w.getRecorder().record(63,L),v()})}},f*Math.pow(4,A++))};v()},s.prototype._readSourceAndCachedData=function(u,a,L,w){if(!a)this._fs.readFile(u,{encoding:"utf8"},w);else{var g=void 0,f=void 0,m=void 0,A=2,_=function(v){v?w(v):--A==0&&w(void 0,g,f,m)};this._fs.readFile(u,{encoding:"utf8"},function(v,n){g=n,_(v)}),this._fs.readFile(a,function(v,n){!v&&n&&n.length>0?(m=n.slice(0,16),f=n.slice(16),L.record(60,a)):L.record(61,a),_()})}},s.prototype._verifyCachedData=function(u,a,L,w,g){var f=this;!w||u.cachedDataRejected||setTimeout(function(){var m=f._crypto.createHash("md5").update(a,"utf8").digest();w.equals(m)||(g.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+L+"' now, but a RESTART IS REQUIRED")),f._fs.unlink(L,function(A){A&&g.getConfig().onError(A)}))},Math.ceil(5e3*(1+Math.random())))},s._BOM=65279,s._PREFIX="(function (require, define, __filename, __dirname) { ",s._SUFFIX=`
});`,s}();function l(s,u){if(u.__$__isRecorded)return u;var a=function(w){s.record(33,w);try{return u(w)}finally{s.record(34,w)}};return a.__$__isRecorded=!0,a}T.ensureRecordedNodeRequire=l;function b(s){return new t(s)}T.createScriptLoader=b})(ue||(ue={}));var ue;(function(T){var t=function(){function s(u){var a=u.lastIndexOf("/");a!==-1?this.fromModulePath=u.substr(0,a+1):this.fromModulePath=""}return s._normalizeModuleId=function(u){var a=u,L;for(L=/\/\.\//;L.test(a);)a=a.replace(L,"/");for(a=a.replace(/^\.\//g,""),L=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;L.test(a);)a=a.replace(L,"/");return a=a.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),a},s.prototype.resolveModule=function(u){var a=u;return T.Utilities.isAbsolutePath(a)||(T.Utilities.startsWith(a,"./")||T.Utilities.startsWith(a,"../"))&&(a=s._normalizeModuleId(this.fromModulePath+a)),a},s.ROOT=new s(""),s}();T.ModuleIdResolver=t;var M=function(){function s(u,a,L,w,g,f){this.id=u,this.strId=a,this.dependencies=L,this._callback=w,this._errorback=g,this.moduleIdResolver=f,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return s._safeInvokeFunction=function(u,a){try{return{returnedValue:u.apply(T.global,a),producedError:null}}catch(L){return{returnedValue:null,producedError:L}}},s._invokeFactory=function(u,a,L,w){return u.isBuild()&&!T.Utilities.isAnonymousModule(a)?{returnedValue:null,producedError:null}:u.shouldCatchError()?this._safeInvokeFunction(L,w):{returnedValue:L.apply(T.global,w),producedError:null}},s.prototype.complete=function(u,a,L){this._isComplete=!0;var w=null;if(this._callback)if(typeof this._callback=="function"){u.record(21,this.strId);var g=s._invokeFactory(a,this.strId,this._callback,L);w=g.producedError,u.record(22,this.strId),!w&&typeof g.returnedValue!="undefined"&&(!this.exportsPassedIn||T.Utilities.isEmpty(this.exports))&&(this.exports=g.returnedValue)}else this.exports=this._callback;if(w){var f=T.ensureError(w);f.phase="factory",f.moduleId=this.strId,this.error=f,a.onError(f)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},s.prototype.onDependencyError=function(u){return this._isComplete=!0,this.error=u,this._errorback?(this._errorback(u),!0):!1},s.prototype.isComplete=function(){return this._isComplete},s}();T.Module=M;var p=function(){function s(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return s.prototype.getMaxModuleId=function(){return this._nextId},s.prototype.getModuleId=function(u){var a=this._strModuleIdToIntModuleId.get(u);return typeof a=="undefined"&&(a=this._nextId++,this._strModuleIdToIntModuleId.set(u,a),this._intModuleIdToStrModuleId[a]=u),a},s.prototype.getStrModuleId=function(u){return this._intModuleIdToStrModuleId[u]},s}(),P=function(){function s(u){this.id=u}return s.EXPORTS=new s(0),s.MODULE=new s(1),s.REQUIRE=new s(2),s}();T.RegularDependency=P;var l=function(){function s(u,a,L){this.id=u,this.pluginId=a,this.pluginParam=L}return s}();T.PluginDependency=l;var b=function(){function s(u,a,L,w,g){g===void 0&&(g=0),this._env=u,this._scriptLoader=a,this._loaderAvailableTimestamp=g,this._defineFunc=L,this._requireFunc=w,this._moduleIdProvider=new p,this._config=new T.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return s.prototype.reset=function(){return new s(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},s.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},s.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},s._findRelevantLocationInStack=function(u,a){for(var L=function(i){return i.replace(/\\/g,"/")},w=L(u),g=a.split(/\n/),f=0;f<g.length;f++){var m=g[f].match(/(.*):(\d+):(\d+)\)?$/);if(m){var A=m[1],_=m[2],v=m[3],n=Math.max(A.lastIndexOf(" ")+1,A.lastIndexOf("(")+1);if(A=A.substr(n),A=L(A),A===w){var r={line:parseInt(_,10),col:parseInt(v,10)};return r.line===1&&(r.col-="(function (require, define, __filename, __dirname) { ".length),r}}}throw new Error("Could not correlate define call site for needle "+u)},s.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var u=[],a=0,L=0,w=this._modules2.length;L<w;L++){var g=this._modules2[L];if(!!g){var f=this._buildInfoPath[g.id]||null,m=this._buildInfoDefineStack[g.id]||null,A=this._buildInfoDependencies[g.id];u[a++]={id:g.strId,path:f,defineLocation:f&&m?s._findRelevantLocationInStack(f,m):null,dependencies:A,shim:null,exports:g.exports}}}return u},s.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new T.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=T.NullLoaderEventRecorder.INSTANCE),this._recorder},s.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},s.prototype.enqueueDefineAnonymousModule=function(u,a){if(this._currentAnnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var L=null;this._config.isBuild()&&(L=new Error("StackLocation").stack||null),this._currentAnnonymousDefineCall={stack:L,dependencies:u,callback:a}},s.prototype.defineModule=function(u,a,L,w,g,f){var m=this;f===void 0&&(f=new t(u));var A=this._moduleIdProvider.getModuleId(u);if(this._modules2[A]){this._config.isDuplicateMessageIgnoredFor(u)||console.warn("Duplicate definition of module '"+u+"'");return}var _=new M(A,u,this._normalizeDependencies(a,f),L,w,f);this._modules2[A]=_,this._config.isBuild()&&(this._buildInfoDefineStack[A]=g,this._buildInfoDependencies[A]=(_.dependencies||[]).map(function(v){return m._moduleIdProvider.getStrModuleId(v.id)})),this._resolve(_)},s.prototype._normalizeDependency=function(u,a){if(u==="exports")return P.EXPORTS;if(u==="module")return P.MODULE;if(u==="require")return P.REQUIRE;var L=u.indexOf("!");if(L>=0){var w=a.resolveModule(u.substr(0,L)),g=a.resolveModule(u.substr(L+1)),f=this._moduleIdProvider.getModuleId(w+"!"+g),m=this._moduleIdProvider.getModuleId(w);return new l(f,m,g)}return new P(this._moduleIdProvider.getModuleId(a.resolveModule(u)))},s.prototype._normalizeDependencies=function(u,a){for(var L=[],w=0,g=0,f=u.length;g<f;g++)L[w++]=this._normalizeDependency(u[g],a);return L},s.prototype._relativeRequire=function(u,a,L,w){if(typeof a=="string")return this.synchronousRequire(a,u);this.defineModule(T.Utilities.generateAnonymousModule(),a,L,w,null,u)},s.prototype.synchronousRequire=function(u,a){a===void 0&&(a=new t(u));var L=this._normalizeDependency(u,a),w=this._modules2[L.id];if(!w)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This is the first mention of this module!");if(!w.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This module has not been resolved completely yet.");if(w.error)throw w.error;return w.exports},s.prototype.configure=function(u,a){var L=this._config.shouldRecordStats();a?this._config=new T.Configuration(this._env,u):this._config=this._config.cloneAndMerge(u),this._config.shouldRecordStats()&&!L&&(this._recorder=null)},s.prototype.getConfig=function(){return this._config},s.prototype._onLoad=function(u){if(this._currentAnnonymousDefineCall!==null){var a=this._currentAnnonymousDefineCall;this._currentAnnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(u),a.dependencies,a.callback,null,a.stack)}},s.prototype._createLoadError=function(u,a){var L=this,w=this._moduleIdProvider.getStrModuleId(u),g=(this._inverseDependencies2[u]||[]).map(function(m){return L._moduleIdProvider.getStrModuleId(m)}),f=T.ensureError(a);return f.phase="loading",f.moduleId=w,f.neededBy=g,f},s.prototype._onLoadError=function(u,a){var L=this._createLoadError(u,a);this._modules2[u]||(this._modules2[u]=new M(u,this._moduleIdProvider.getStrModuleId(u),[],function(){},function(){},null));for(var w=[],g=0,f=this._moduleIdProvider.getMaxModuleId();g<f;g++)w[g]=!1;var m=!1,A=[];for(A.push(u),w[u]=!0;A.length>0;){var _=A.shift(),v=this._modules2[_];v&&(m=v.onDependencyError(L)||m);var n=this._inverseDependencies2[_];if(n)for(var g=0,f=n.length;g<f;g++){var r=n[g];w[r]||(A.push(r),w[r]=!0)}}m||this._config.onError(L)},s.prototype._hasDependencyPath=function(u,a){var L=this._modules2[u];if(!L)return!1;for(var w=[],g=0,f=this._moduleIdProvider.getMaxModuleId();g<f;g++)w[g]=!1;var m=[];for(m.push(L),w[u]=!0;m.length>0;){var A=m.shift(),_=A.dependencies;if(_)for(var g=0,f=_.length;g<f;g++){var v=_[g];if(v.id===a)return!0;var n=this._modules2[v.id];n&&!w[v.id]&&(w[v.id]=!0,m.push(n))}}return!1},s.prototype._findCyclePath=function(u,a,L){if(u===a||L===50)return[u];var w=this._modules2[u];if(!w)return null;var g=w.dependencies;if(g)for(var f=0,m=g.length;f<m;f++){var A=this._findCyclePath(g[f].id,a,L+1);if(A!==null)return A.push(u),A}return null},s.prototype._createRequire=function(u){var a=this,L=function(w,g,f){return a._relativeRequire(u,w,g,f)};return L.toUrl=function(w){return a._config.requireToUrl(u.resolveModule(w))},L.getStats=function(){return a.getLoaderEvents()},L.hasDependencyCycle=function(){return a._hasDependencyCycle},L.config=function(w,g){g===void 0&&(g=!1),a.configure(w,g)},L.__$__nodeRequire=T.global.nodeRequire,L},s.prototype._loadModule=function(u){var a=this;if(!(this._modules2[u]||this._knownModules2[u])){this._knownModules2[u]=!0;var L=this._moduleIdProvider.getStrModuleId(u),w=this._config.moduleIdToPaths(L),g=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(L.indexOf("/")===-1||g.test(L))&&w.push("node|"+L);var f=-1,m=function(A){if(f++,f>=w.length)a._onLoadError(u,A);else{var _=w[f],v=a.getRecorder();if(a._config.isBuild()&&_==="empty:"){a._buildInfoPath[u]=_,a.defineModule(a._moduleIdProvider.getStrModuleId(u),[],null,null,null),a._onLoad(u);return}v.record(10,_),a._scriptLoader.load(a,_,function(){a._config.isBuild()&&(a._buildInfoPath[u]=_),v.record(11,_),a._onLoad(u)},function(n){v.record(12,_),m(n)})}};m(null)}},s.prototype._loadPluginDependency=function(u,a){var L=this;if(!(this._modules2[a.id]||this._knownModules2[a.id])){this._knownModules2[a.id]=!0;var w=function(g){L.defineModule(L._moduleIdProvider.getStrModuleId(a.id),[],g,null,null)};w.error=function(g){L._config.onError(L._createLoadError(a.id,g))},u.load(a.pluginParam,this._createRequire(t.ROOT),w,this._config.getOptionsLiteral())}},s.prototype._resolve=function(u){var a=this,L=u.dependencies;if(L)for(var w=0,g=L.length;w<g;w++){var f=L[w];if(f===P.EXPORTS){u.exportsPassedIn=!0,u.unresolvedDependenciesCount--;continue}if(f===P.MODULE){u.unresolvedDependenciesCount--;continue}if(f===P.REQUIRE){u.unresolvedDependenciesCount--;continue}var m=this._modules2[f.id];if(m&&m.isComplete()){if(m.error){u.onDependencyError(m.error);return}u.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(f.id,u.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(f.id)+"' and '"+this._moduleIdProvider.getStrModuleId(u.id)+"'. The cyclic path follows:");var A=this._findCyclePath(f.id,u.id,0)||[];A.reverse(),A.push(f.id),console.warn(A.map(function(n){return a._moduleIdProvider.getStrModuleId(n)}).join(` => 
`)),u.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[f.id]=this._inverseDependencies2[f.id]||[],this._inverseDependencies2[f.id].push(u.id),f instanceof l){var _=this._modules2[f.pluginId];if(_&&_.isComplete()){this._loadPluginDependency(_.exports,f);continue}var v=this._inversePluginDependencies2.get(f.pluginId);v||(v=[],this._inversePluginDependencies2.set(f.pluginId,v)),v.push(f),this._loadModule(f.pluginId);continue}this._loadModule(f.id)}u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)},s.prototype._onModuleComplete=function(u){var a=this,L=this.getRecorder();if(!u.isComplete()){var w=u.dependencies,g=[];if(w)for(var f=0,m=w.length;f<m;f++){var A=w[f];if(A===P.EXPORTS){g[f]=u.exports;continue}if(A===P.MODULE){g[f]={id:u.strId,config:function(){return a._config.getConfigForModule(u.strId)}};continue}if(A===P.REQUIRE){g[f]=this._createRequire(u.moduleIdResolver);continue}var _=this._modules2[A.id];if(_){g[f]=_.exports;continue}g[f]=null}u.complete(L,this._config,g);var v=this._inverseDependencies2[u.id];if(this._inverseDependencies2[u.id]=null,v)for(var f=0,m=v.length;f<m;f++){var n=v[f],r=this._modules2[n];r.unresolvedDependenciesCount--,r.unresolvedDependenciesCount===0&&this._onModuleComplete(r)}var i=this._inversePluginDependencies2.get(u.id);if(i){this._inversePluginDependencies2.delete(u.id);for(var f=0,m=i.length;f<m;f++)this._loadPluginDependency(u.exports,i[f])}}},s}();T.ModuleManager=b})(ue||(ue={}));var x,ue;(function(T){var t=new T.Environment,M=null,p=function(s,u,a){typeof s!="string"&&(a=u,u=s,s=null),(typeof u!="object"||!Array.isArray(u))&&(a=u,u=null),u||(u=["require","exports","module"]),s?M.defineModule(s,u,a,null,null):M.enqueueDefineAnonymousModule(u,a)};p.amd={jQuery:!0};var P=function(s,u){u===void 0&&(u=!1),M.configure(s,u)},l=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){P(arguments[0]);return}if(typeof arguments[0]=="string")return M.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){M.defineModule(T.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};l.config=P,l.getConfig=function(){return M.getConfig().getOptionsLiteral()},l.reset=function(){M=M.reset()},l.getBuildInfo=function(){return M.getBuildInfo()},l.getStats=function(){return M.getLoaderEvents()},l.define=function(){return p.apply(null,arguments)};function b(){if(typeof T.global.require!="undefined"||typeof require!="undefined"){var s=T.global.require||require;if(typeof s=="function"&&typeof s.resolve=="function"){var u=T.ensureRecordedNodeRequire(M.getRecorder(),s);T.global.nodeRequire=u,l.nodeRequire=u,l.__$__nodeRequire=u}}t.isNode&&!t.isElectronRenderer?(module.exports=l,require=l):(t.isElectronRenderer||(T.global.define=p),T.global.require=l)}T.init=b,(typeof T.global.define!="function"||!T.global.define.amd)&&(M=new T.ModuleManager(t,T.createScriptLoader(t),p,l,T.Utilities.getHighPerformanceTimestamp()),typeof T.global.require!="undefined"&&typeof T.global.require!="function"&&l.config(T.global.require),x=function(){return p.apply(null,arguments)},x.amd=p.amd,typeof doNotInitLoader=="undefined"&&b())})(ue||(ue={}));"use strict";var Ee=this,ve;(function(T){var t=Ee||{},M=t.Plugin&&t.Plugin.Resources?t.Plugin.Resources:void 0,p=t&&t.document&&t.document.location&&t.document.location.hash.indexOf("pseudo=true")>=0;function P(a,L){var w;return L.length===0?w=a:w=a.replace(/\{(\d+)\}/g,function(g,f){var m=f[0];return typeof L[m]!="undefined"?L[m]:g}),p&&(w="\uFF3B"+w.replace(/[aouei]/g,"$&$&")+"\uFF3D"),w}function l(a,L){var w=a[L];return w||(w=a["*"],w)?w:null}function b(a,L){for(var w=[],g=0;g<arguments.length-2;g++)w[g]=arguments[g+2];return P(L,w)}function s(a){return function(L,w){var g=Array.prototype.slice.call(arguments,2);return P(a[L],g)}}var u=function(){function a(){this.localize=b}return a.prototype.setPseudoTranslation=function(L){p=L},a.prototype.create=function(L,w){return{localize:s(w[L])}},a.prototype.load=function(L,w,g,f){if(f=f||{},!L||L.length===0)g({localize:b});else{var m=void 0;if(M&&M.getString)m=".nls.keys",w([L+m],function(v){g({localize:function(n,r){if(!v[n])return"NLS error: unknown key "+n;var i=v[n].keys;if(r>=i.length)return"NLS error unknow index "+r;var o=i[r],h=[];h[0]=n+"_"+o;for(var E=0;E<arguments.length-2;E++)h[E+1]=arguments[E+2];return M.getString.apply(M,h)}})});else if(f.isBuild)w([L+".nls",L+".nls.keys"],function(v,n){a.BUILD_MAP[L]=v,a.BUILD_MAP_KEYS[L]=n,g(v)});else{var A=f["vs/nls"]||{},_=A.availableLanguages?l(A.availableLanguages,L):null;m=".nls",_!==null&&_!==a.DEFAULT_TAG&&(m=m+"."+_),w([L+m],function(v){Array.isArray(v)?v.localize=s(v):v.localize=s(v[L]),g(v)})}}},a.prototype._getEntryPointsMap=function(){return t.nlsPluginEntryPoints=t.nlsPluginEntryPoints||{},t.nlsPluginEntryPoints},a.prototype.write=function(L,w,g){var f=g.getEntryPoint(),m=this._getEntryPointsMap();m[f]=m[f]||[],m[f].push(w),w!==f&&g.asModule(L+"!"+w,"define(['vs/nls', 'vs/nls!"+f+`'], function(nls, data) { return nls.create("`+w+'", data); });')},a.prototype.writeFile=function(L,w,g,f,m){var A=this._getEntryPointsMap();if(A.hasOwnProperty(w)){for(var _=g.toUrl(w+".nls.js"),v=["/*---------------------------------------------------------"," * Copyright (c) Microsoft Corporation. All rights reserved."," *--------------------------------------------------------*/"],n=A[w],r={},i=0;i<n.length;i++)r[n[i]]=a.BUILD_MAP[n[i]];v.push('define("'+w+'.nls", '+JSON.stringify(r,null,"	")+");"),f(_,v.join(`\r
`))}},a.prototype.finishBuild=function(L){L("nls.metadata.json",JSON.stringify({keys:a.BUILD_MAP_KEYS,messages:a.BUILD_MAP,bundles:this._getEntryPointsMap()},null,"	"))},a.DEFAULT_TAG="i-default",a.BUILD_MAP={},a.BUILD_MAP_KEYS={},a}();T.NLSPlugin=u,function(){x("vs/nls",new u)}()})(ve||(ve={})),x(K[15],ee([0,1]),function(T,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class M{constructor(P,l,b,s){this.originalStart=P,this.originalLength=l,this.modifiedStart=b,this.modifiedLength=s}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=M}),x(K[4],ee([0,1]),function(T,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class M{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(i=>{i(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}t.ErrorHandler=M,t.errorHandler=new M;function p(n){t.errorHandler.setUnexpectedErrorHandler(n)}t.setUnexpectedErrorHandler=p;function P(n){u(n)||t.errorHandler.onUnexpectedError(n)}t.onUnexpectedError=P;function l(n){u(n)||t.errorHandler.onUnexpectedExternalError(n)}t.onUnexpectedExternalError=l;function b(n){if(n instanceof Error){let{name:r,message:i}=n;const o=n.stacktrace||n.stack;return{$isError:!0,name:r,message:i,stack:o}}return n}t.transformErrorForSerialization=b;const s="Canceled";function u(n){return n instanceof Error&&n.name===s&&n.message===s}t.isPromiseCanceledError=u;class a extends Error{constructor(){super(s);this.name=this.message}}t.CancellationError=a;function L(){const n=new Error(s);return n.name=n.message,n}t.canceled=L;function w(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}t.illegalArgument=w;function g(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}t.illegalState=g;function f(n){return n?new Error(`readonly property '${n} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=f;function m(n){const r=new Error(`${n} has been disposed`);return r.name="DISPOSED",r}t.disposed=m;function A(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}t.getErrorMessage=A;class _ extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}t.NotImplementedError=_;class v extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}t.NotSupportedError=v}),x(K[16],ee([0,1,4]),function(T,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.mergeSort=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function p(U,k=0){return U[U.length-(1+k)]}t.tail=p;function P(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}t.tail2=P;function l(U,k,y=(B,j)=>B===j){if(U===k)return!0;if(!U||!k||U.length!==k.length)return!1;for(let B=0,j=U.length;B<j;B++)if(!y(U[B],k[B]))return!1;return!0}t.equals=l;function b(U,k,y){let B=0,j=U.length-1;for(;B<=j;){const Z=(B+j)/2|0,ie=y(U[Z],k);if(ie<0)B=Z+1;else if(ie>0)j=Z-1;else return Z}return-(B+1)}t.binarySearch=b;function s(U,k){let y=0,B=U.length;if(B===0)return 0;for(;y<B;){const j=Math.floor((y+B)/2);k(U[j])?B=j:y=j+1}return y}t.findFirstInSorted=s;function u(U,k,y){if(U=U|0,U>=k.length)throw new TypeError("invalid index");let B=k[Math.floor(k.length*Math.random())],j=[],Z=[],ie=[];for(let le of k){const re=y(le,B);re<0?j.push(le):re>0?Z.push(le):ie.push(le)}return U<j.length?u(U,j,y):U<j.length+ie.length?ie[0]:u(U-(j.length+ie.length),Z,y)}t.quickSelect=u;function a(U,k){return w(U,k,0,U.length-1,[]),U}t.mergeSort=a;function L(U,k,y,B,j,Z){let ie=y,le=B+1;for(let re=y;re<=j;re++)Z[re]=U[re];for(let re=y;re<=j;re++)ie>B?U[re]=Z[le++]:le>j?U[re]=Z[ie++]:k(Z[le],Z[ie])<0?U[re]=Z[le++]:U[re]=Z[ie++]}function w(U,k,y,B,j){if(!(B<=y)){const Z=y+(B-y)/2|0;w(U,k,y,Z,j),w(U,k,Z+1,B,j),!(k(U[Z],U[Z+1])<=0)&&L(U,k,y,Z,B,j)}}function g(U,k){const y=[];let B;for(const j of a(U.slice(0),k))!B||k(B[0],j)!==0?(B=[j],y.push(B)):B.push(j);return y}t.groupBy=g;function f(U,k,y){const B=[];function j(le,re,ae){if(!(re===0&&ae.length===0)){const he=B[B.length-1];he&&he.start+he.deleteCount===le?(he.deleteCount+=re,he.toInsert.push(...ae)):B.push({start:le,deleteCount:re,toInsert:ae})}}let Z=0,ie=0;for(;;){if(Z===U.length){j(Z,0,k.slice(ie));break}if(ie===k.length){j(Z,U.length-Z,[]);break}const le=U[Z],re=k[ie],ae=y(le,re);ae===0?(Z+=1,ie+=1):ae<0?(j(Z,1,[]),Z+=1):ae>0&&(j(Z,0,[re]),ie+=1)}return B}t.sortedDiff=f;function m(U,k,y){const B=f(U,k,y),j=[],Z=[];for(const ie of B)j.push(...U.slice(ie.start,ie.start+ie.deleteCount)),Z.push(...ie.toInsert);return{removed:j,added:Z}}t.delta=m;function A(U,k,y){if(y===0)return[];const B=U.slice(0,y).sort(k);return v(U,k,B,y,U.length),B}t.top=A;function _(U,k,y,B,j){return y===0?Promise.resolve([]):new Promise((Z,ie)=>{(async()=>{const le=U.length,re=U.slice(0,y).sort(k);for(let ae=y,he=Math.min(y+B,le);ae<le;ae=he,he=Math.min(he+B,le)){if(ae>y&&await new Promise(_e=>setTimeout(_e)),j&&j.isCancellationRequested)throw M.canceled();v(U,k,re,ae,he)}return re})().then(Z,ie)})}t.topAsync=_;function v(U,k,y,B,j){for(const Z=y.length;B<j;B++){const ie=U[B];if(k(ie,y[Z-1])<0){y.pop();const le=s(y,re=>k(ie,re)<0);y.splice(le,0,ie)}}}function n(U){return U.filter(k=>!!k)}t.coalesce=n;function r(U){let k=0;for(let y=0;y<U.length;y++)U[y]&&(U[k]=U[y],k+=1);U.length=k}t.coalesceInPlace=r;function i(U,k,y){U.splice(y,0,U.splice(k,1)[0])}t.move=i;function o(U){return!Array.isArray(U)||U.length===0}t.isFalsyOrEmpty=o;function h(U){return Array.isArray(U)&&U.length>0}t.isNonEmptyArray=h;function E(U,k){if(!k)return U.filter((B,j)=>U.indexOf(B)===j);const y=Object.create(null);return U.filter(B=>{const j=k(B);return y[j]?!1:(y[j]=!0,!0)})}t.distinct=E;function d(U){const k=new Set;return U.filter(y=>k.has(y)?!1:(k.add(y),!0))}t.distinctES6=d;function S(U){const k=Object.create(null);return y=>{const B=U(y);return k[B]?!1:(k[B]=!0,!0)}}t.uniqueFilter=S;function c(U,k){for(let y=U.length-1;y>=0;y--){const B=U[y];if(k(B))return y}return-1}t.lastIndex=c;function C(U,k){return U.length>0?U[0]:k}t.firstOrDefault=C;function D(U,k,y=(B,j)=>B===j){let B=0;for(let j=0,Z=Math.min(U.length,k.length);j<Z&&y(U[j],k[j]);j++)B++;return B}t.commonPrefixLength=D;function F(U){return[].concat(...U)}t.flatten=F;function I(U,k){let y=typeof k=="number"?U:0;typeof k=="number"?y=U:(y=0,k=U);const B=[];if(y<=k)for(let j=y;j<k;j++)B.push(j);else for(let j=y;j>k;j--)B.push(j);return B}t.range=I;function W(U,k,y){return U.reduce((B,j)=>(B[k(j)]=y?y(j):j,B),Object.create(null))}t.index=W;function V(U,k){return U.push(k),()=>X(U,k)}t.insert=V;function X(U,k){const y=U.indexOf(k);if(y>-1)return U.splice(y,1),k}t.remove=X;function ne(U,k,y){const B=U.slice(0,k),j=U.slice(k);return B.concat(y,j)}t.arrayInsert=ne;function e(U,k){let y;if(typeof k=="number"){let B=k;y=()=>{const j=Math.sin(B++)*179426549;return j-Math.floor(j)}}else y=Math.random;for(let B=U.length-1;B>0;B-=1){const j=Math.floor(y()*(B+1)),Z=U[B];U[B]=U[j],U[j]=Z}}t.shuffle=e;function se(U,k){const y=U.indexOf(k);y>-1&&(U.splice(y,1),U.unshift(k))}t.pushToStart=se;function z(U,k){const y=U.indexOf(k);y>-1&&(U.splice(y,1),U.push(k))}t.pushToEnd=z;function H(U,k){return Array.isArray(U)?U.map(k):k(U)}t.mapArrayOrNot=H;function Y(U){return Array.isArray(U)?U:[U]}t.asArray=Y;function Q(U){return U[Math.floor(Math.random()*U.length)]}t.getRandomElement=Q;function te(U,k){for(const y of U){const B=k(y);if(B!==void 0)return B}}t.mapFind=te}),x(K[7],ee([0,1]),function(T,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function M(p){const P=this;let l=!1,b;return function(){return l||(l=!0,b=p.apply(P,arguments)),b}}t.once=M}),x(K[17],ee([0,1]),function(T,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var M;(function(p){function P(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}p.is=P;const l=Object.freeze([]);function b(){return l}p.empty=b;function*s(n){yield n}p.single=s;function u(n){return n||l}p.from=u;function a(n){return!n||n[Symbol.iterator]().next().done===!0}p.isEmpty=a;function L(n){return n[Symbol.iterator]().next().value}p.first=L;function w(n,r){for(const i of n)if(r(i))return!0;return!1}p.some=w;function*g(n,r){for(const i of n)r(i)&&(yield i)}p.filter=g;function*f(n,r){for(const i of n)yield r(i)}p.map=f;function*m(...n){for(const r of n)for(const i of r)yield i}p.concat=m;function*A(n){for(const r of n)for(const i of r)yield i}p.concatNested=A;function*_(n,r,i=n.length){for(r<0&&(r+=n.length),i<0?i+=n.length:i>n.length&&(i=n.length);r<i;r++)yield n[r]}p.slice=_;function v(n,r=Number.POSITIVE_INFINITY){const i=[];if(r===0)return[i,n];const o=n[Symbol.iterator]();for(let h=0;h<r;h++){const E=o.next();if(E.done)return[i,p.empty()];i.push(E.value)}return[i,{[Symbol.iterator](){return o}}]}p.consume=v})(M=t.Iterable||(t.Iterable={}))}),x(K[18],ee([0,1,4]),function(T,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.KeyCode=void 0;var p;(function(n){n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.KEY_0=21]="KEY_0",n[n.KEY_1=22]="KEY_1",n[n.KEY_2=23]="KEY_2",n[n.KEY_3=24]="KEY_3",n[n.KEY_4=25]="KEY_4",n[n.KEY_5=26]="KEY_5",n[n.KEY_6=27]="KEY_6",n[n.KEY_7=28]="KEY_7",n[n.KEY_8=29]="KEY_8",n[n.KEY_9=30]="KEY_9",n[n.KEY_A=31]="KEY_A",n[n.KEY_B=32]="KEY_B",n[n.KEY_C=33]="KEY_C",n[n.KEY_D=34]="KEY_D",n[n.KEY_E=35]="KEY_E",n[n.KEY_F=36]="KEY_F",n[n.KEY_G=37]="KEY_G",n[n.KEY_H=38]="KEY_H",n[n.KEY_I=39]="KEY_I",n[n.KEY_J=40]="KEY_J",n[n.KEY_K=41]="KEY_K",n[n.KEY_L=42]="KEY_L",n[n.KEY_M=43]="KEY_M",n[n.KEY_N=44]="KEY_N",n[n.KEY_O=45]="KEY_O",n[n.KEY_P=46]="KEY_P",n[n.KEY_Q=47]="KEY_Q",n[n.KEY_R=48]="KEY_R",n[n.KEY_S=49]="KEY_S",n[n.KEY_T=50]="KEY_T",n[n.KEY_U=51]="KEY_U",n[n.KEY_V=52]="KEY_V",n[n.KEY_W=53]="KEY_W",n[n.KEY_X=54]="KEY_X",n[n.KEY_Y=55]="KEY_Y",n[n.KEY_Z=56]="KEY_Z",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.US_SEMICOLON=80]="US_SEMICOLON",n[n.US_EQUAL=81]="US_EQUAL",n[n.US_COMMA=82]="US_COMMA",n[n.US_MINUS=83]="US_MINUS",n[n.US_DOT=84]="US_DOT",n[n.US_SLASH=85]="US_SLASH",n[n.US_BACKTICK=86]="US_BACKTICK",n[n.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",n[n.US_BACKSLASH=88]="US_BACKSLASH",n[n.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",n[n.US_QUOTE=90]="US_QUOTE",n[n.OEM_8=91]="OEM_8",n[n.OEM_102=92]="OEM_102",n[n.NUMPAD_0=93]="NUMPAD_0",n[n.NUMPAD_1=94]="NUMPAD_1",n[n.NUMPAD_2=95]="NUMPAD_2",n[n.NUMPAD_3=96]="NUMPAD_3",n[n.NUMPAD_4=97]="NUMPAD_4",n[n.NUMPAD_5=98]="NUMPAD_5",n[n.NUMPAD_6=99]="NUMPAD_6",n[n.NUMPAD_7=100]="NUMPAD_7",n[n.NUMPAD_8=101]="NUMPAD_8",n[n.NUMPAD_9=102]="NUMPAD_9",n[n.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",n[n.NUMPAD_ADD=104]="NUMPAD_ADD",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",n[n.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",n[n.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.MAX_VALUE=112]="MAX_VALUE"})(p=t.KeyCode||(t.KeyCode={}));class P{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(r,i){this._keyCodeToStr[r]=i,this._strToKeyCode[i.toLowerCase()]=r}keyCodeToStr(r){return this._keyCodeToStr[r]}strToKeyCode(r){return this._strToKeyCode[r.toLowerCase()]||0}}const l=new P,b=new P,s=new P;(function(){function n(r,i,o=i,h=o){l.define(r,i),b.define(r,o),s.define(r,h)}n(0,"unknown"),n(1,"Backspace"),n(2,"Tab"),n(3,"Enter"),n(4,"Shift"),n(5,"Ctrl"),n(6,"Alt"),n(7,"PauseBreak"),n(8,"CapsLock"),n(9,"Escape"),n(10,"Space"),n(11,"PageUp"),n(12,"PageDown"),n(13,"End"),n(14,"Home"),n(15,"LeftArrow","Left"),n(16,"UpArrow","Up"),n(17,"RightArrow","Right"),n(18,"DownArrow","Down"),n(19,"Insert"),n(20,"Delete"),n(21,"0"),n(22,"1"),n(23,"2"),n(24,"3"),n(25,"4"),n(26,"5"),n(27,"6"),n(28,"7"),n(29,"8"),n(30,"9"),n(31,"A"),n(32,"B"),n(33,"C"),n(34,"D"),n(35,"E"),n(36,"F"),n(37,"G"),n(38,"H"),n(39,"I"),n(40,"J"),n(41,"K"),n(42,"L"),n(43,"M"),n(44,"N"),n(45,"O"),n(46,"P"),n(47,"Q"),n(48,"R"),n(49,"S"),n(50,"T"),n(51,"U"),n(52,"V"),n(53,"W"),n(54,"X"),n(55,"Y"),n(56,"Z"),n(57,"Meta"),n(58,"ContextMenu"),n(59,"F1"),n(60,"F2"),n(61,"F3"),n(62,"F4"),n(63,"F5"),n(64,"F6"),n(65,"F7"),n(66,"F8"),n(67,"F9"),n(68,"F10"),n(69,"F11"),n(70,"F12"),n(71,"F13"),n(72,"F14"),n(73,"F15"),n(74,"F16"),n(75,"F17"),n(76,"F18"),n(77,"F19"),n(78,"NumLock"),n(79,"ScrollLock"),n(80,";",";","OEM_1"),n(81,"=","=","OEM_PLUS"),n(82,",",",","OEM_COMMA"),n(83,"-","-","OEM_MINUS"),n(84,".",".","OEM_PERIOD"),n(85,"/","/","OEM_2"),n(86,"`","`","OEM_3"),n(110,"ABNT_C1"),n(111,"ABNT_C2"),n(87,"[","[","OEM_4"),n(88,"\\","\\","OEM_5"),n(89,"]","]","OEM_6"),n(90,"'","'","OEM_7"),n(91,"OEM_8"),n(92,"OEM_102"),n(93,"NumPad0"),n(94,"NumPad1"),n(95,"NumPad2"),n(96,"NumPad3"),n(97,"NumPad4"),n(98,"NumPad5"),n(99,"NumPad6"),n(100,"NumPad7"),n(101,"NumPad8"),n(102,"NumPad9"),n(103,"NumPad_Multiply"),n(104,"NumPad_Add"),n(105,"NumPad_Separator"),n(106,"NumPad_Subtract"),n(107,"NumPad_Decimal"),n(108,"NumPad_Divide")})();var u;(function(n){function r(d){return l.keyCodeToStr(d)}n.toString=r;function i(d){return l.strToKeyCode(d)}n.fromString=i;function o(d){return b.keyCodeToStr(d)}n.toUserSettingsUS=o;function h(d){return s.keyCodeToStr(d)}n.toUserSettingsGeneral=h;function E(d){return b.strToKeyCode(d)||s.strToKeyCode(d)}n.fromUserSettings=E})(u=t.KeyCodeUtils||(t.KeyCodeUtils={}));var a;(function(n){n[n.CtrlCmd=2048]="CtrlCmd",n[n.Shift=1024]="Shift",n[n.Alt=512]="Alt",n[n.WinCtrl=256]="WinCtrl",n[n.KeyCode=255]="KeyCode"})(a||(a={}));var L;(function(n){n[n.CtrlCmd=2048]="CtrlCmd",n[n.Shift=1024]="Shift",n[n.Alt=512]="Alt",n[n.WinCtrl=256]="WinCtrl"})(L=t.KeyMod||(t.KeyMod={}));function w(n,r){const i=(r&65535)<<16>>>0;return(n|i)>>>0}t.KeyChord=w;function g(n,r){if(n===0)return null;const i=(n&65535)>>>0,o=(n&4294901760)>>>16;return o!==0?new A([f(i,r),f(o,r)]):new A([f(i,r)])}t.createKeybinding=g;function f(n,r){const i=!!(n&2048),o=!!(n&256),h=r===2?o:i,E=!!(n&1024),d=!!(n&512),S=r===2?i:o,c=n&255;return new m(h,E,d,S,c)}t.createSimpleKeybinding=f;class m{constructor(r,i,o,h,E){this.ctrlKey=r,this.shiftKey=i,this.altKey=o,this.metaKey=h,this.keyCode=E}equals(r){return this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.keyCode===r.keyCode}getHashCode(){const r=this.ctrlKey?"1":"0",i=this.shiftKey?"1":"0",o=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`${r}${i}${o}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new A([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=m;class A{constructor(r){if(r.length===0)throw M.illegalArgument("parts");this.parts=r}getHashCode(){let r="";for(let i=0,o=this.parts.length;i<o;i++)i!==0&&(r+=";"),r+=this.parts[i].getHashCode();return r}equals(r){if(r===null||this.parts.length!==r.parts.length)return!1;for(let i=0;i<this.parts.length;i++)if(!this.parts[i].equals(r.parts[i]))return!1;return!0}}t.ChordKeybinding=A;class _{constructor(r,i,o,h,E,d){this.ctrlKey=r,this.shiftKey=i,this.altKey=o,this.metaKey=h,this.keyLabel=E,this.keyAriaLabel=d}}t.ResolvedKeybindingPart=_;class v{}t.ResolvedKeybinding=v}),x(K[8],ee([0,1,7,17]),function(T,t,M,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ImmortalReference=t.ReferenceCollection=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.trackDisposable=t.setDisposableTracker=void 0;const P=!1;let l=null;function b(r){l=r}if(t.setDisposableTracker=b,P){const r="__is_disposable_tracked__";l=new class{trackDisposable(i){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[r]||console.log(o)},3e3)}markTracked(i){if(i&&i!==A.None)try{i[r]=!0}catch(o){}}}}function s(r){!l||l.markTracked(r)}function u(r){return l&&l.trackDisposable(r),r}t.trackDisposable=u;class a extends Error{constructor(i){super(`Encounter errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}t.MultiDisposeError=a;function L(r){return typeof r.dispose=="function"&&r.dispose.length===0}t.isDisposable=L;function w(r){if(p.Iterable.is(r)){let i=[];for(const o of r)if(o){s(o);try{o.dispose()}catch(h){i.push(h)}}if(i.length===1)throw i[0];if(i.length>1)throw new a(i);return Array.isArray(r)?[]:r}else if(r)return s(r),r.dispose(),r}t.dispose=w;function g(...r){return r.forEach(s),f(()=>w(r))}t.combinedDisposable=g;function f(r){const i=u({dispose:()=>{s(i),r()}});return i}t.toDisposable=f;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(s(this),this._isDisposed=!0,this.clear())}clear(){try{w(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return s(i),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}t.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class A{constructor(){this._store=new m,u(this)}dispose(){s(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}t.Disposable=A,A.None=Object.freeze({dispose(){}});class _{constructor(){this._isDisposed=!1,u(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value&&this._value.dispose(),i&&s(i),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,s(this),this._value&&this._value.dispose(),this._value=void 0}}t.MutableDisposable=_;class v{constructor(){this.references=new Map}acquire(i,...o){let h=this.references.get(i);h||(h={counter:0,object:this.createReferencedObject(i,...o)},this.references.set(i,h));const{object:E}=h,d=M.once(()=>{--h.counter==0&&(this.destroyReferencedObject(i,h.object),this.references.delete(i))});return h.counter++,{object:E,dispose:d}}}t.ReferenceCollection=v;class n{constructor(i){this.object=i}dispose(){}}t.ImmortalReference=n}),x(K[19],ee([0,1]),function(T,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class M{constructor(l){this.element=l,this.next=M.Undefined,this.prev=M.Undefined}}M.Undefined=new M(void 0);class p{constructor(){this._first=M.Undefined,this._last=M.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===M.Undefined}clear(){this._first=M.Undefined,this._last=M.Undefined,this._size=0}unshift(l){return this._insert(l,!1)}push(l){return this._insert(l,!0)}_insert(l,b){const s=new M(l);if(this._first===M.Undefined)this._first=s,this._last=s;else if(b){const a=this._last;this._last=s,s.prev=a,a.next=s}else{const a=this._first;this._first=s,s.next=a,a.prev=s}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(s))}}shift(){if(this._first!==M.Undefined){const l=this._first.element;return this._remove(this._first),l}}pop(){if(this._last!==M.Undefined){const l=this._last.element;return this._remove(this._last),l}}_remove(l){if(l.prev!==M.Undefined&&l.next!==M.Undefined){const b=l.prev;b.next=l.next,l.next.prev=b}else l.prev===M.Undefined&&l.next===M.Undefined?(this._first=M.Undefined,this._last=M.Undefined):l.next===M.Undefined?(this._last=this._last.prev,this._last.next=M.Undefined):l.prev===M.Undefined&&(this._first=this._first.next,this._first.prev=M.Undefined);this._size-=1}*[Symbol.iterator](){let l=this._first;for(;l!==M.Undefined;)yield l.element,l=l.next}}t.LinkedList=p}),x(K[2],ee([0,1]),function(T,t){"use strict";var M;Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.OperatingSystem=t.setImmediate=t.globals=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isIOS=t.isWeb=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.isPreferringBrowserCodeLoad=t.browserCodeLoadingCacheStrategy=t.isElectronSandboxed=void 0;const p="en";let P=!1,l=!1,b=!1,s=!1,u=!1,a=!1,L=!1,w,g=p,f,m;const A=typeof self=="object"?self:typeof global=="object"?global:{};let _;typeof process!="undefined"?_=process:typeof A.vscode!="undefined"&&(_=A.vscode.process);const v=typeof((M=_==null?void 0:_.versions)===null||M===void 0?void 0:M.electron)=="string"&&_.type==="renderer";if(t.isElectronSandboxed=v&&(_==null?void 0:_.sandboxed),t.browserCodeLoadingCacheStrategy=(()=>{if(t.isElectronSandboxed)return"bypassHeatCheck";const c=_==null?void 0:_.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof c=="string")return c==="none"||c==="code"||c==="bypassHeatCheck"||c==="bypassHeatCheckAndEagerCompile"?c:"bypassHeatCheck"})(),t.isPreferringBrowserCodeLoad=typeof t.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!v)m=navigator.userAgent,P=m.indexOf("Windows")>=0,l=m.indexOf("Macintosh")>=0,L=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,b=m.indexOf("Linux")>=0,a=!0,w=navigator.language,g=w;else if(typeof _=="object"){P=_.platform==="win32",l=_.platform==="darwin",b=_.platform==="linux",s=b&&!!_.env.SNAP&&!!_.env.SNAP_REVISION,w=p,g=p;const c=_.env.VSCODE_NLS_CONFIG;if(c)try{const C=JSON.parse(c),D=C.availableLanguages["*"];w=C.locale,g=D||p,f=C._translationsConfigFile}catch(C){}u=!0}else console.error("Unable to resolve platform.");var n;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(n=t.Platform||(t.Platform={}));function r(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=r;let i=0;l?i=1:P?i=3:b&&(i=2),t.isWindows=P,t.isMacintosh=l,t.isLinux=b,t.isLinuxSnap=s,t.isNative=u,t.isWeb=a,t.isIOS=L,t.platform=i,t.userAgent=m,t.language=g;var o;(function(c){function C(){return t.language}c.value=C;function D(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}c.isDefaultVariant=D;function F(){return t.language==="en"}c.isDefault=F})(o=t.Language||(t.Language={})),t.locale=w,t.translationsConfigFile=f,t.globals=A,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if(typeof t.globals.postMessage=="function"&&!t.globals.importScripts){let D=[];t.globals.addEventListener("message",I=>{if(I.data&&I.data.vscodeSetImmediateId)for(let W=0,V=D.length;W<V;W++){const X=D[W];if(X.id===I.data.vscodeSetImmediateId){D.splice(W,1),X.callback();return}}});let F=0;return I=>{const W=++F;D.push({id:W,callback:I}),t.globals.postMessage({vscodeSetImmediateId:W},"*")}}if(_)return _.nextTick.bind(_);const C=Promise.resolve();return D=>C.then(D)}();var h;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(h=t.OperatingSystem||(t.OperatingSystem={})),t.OS=l||L?2:P?1:3;let E=!0,d=!1;function S(){if(!d){d=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,E=new Uint16Array(c.buffer)[0]===(2<<8)+1}return E}t.isLittleEndian=S}),x(K[20],ee([0,1,2]),function(T,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.nextTick=t.platform=t.env=t.cwd=void 0;let p;typeof process!="undefined"?p=process:typeof M.globals.vscode!="undefined"?p={get platform(){return M.globals.vscode.process.platform},get env(){return M.globals.vscode.process.env},nextTick(P){return M.setImmediate(P)},cwd(){return M.globals.vscode.process.env.VSCODE_CWD||M.globals.vscode.process.execPath.substr(0,M.globals.vscode.process.execPath.lastIndexOf(M.globals.vscode.process.platform==="win32"?"\\":"/"))}}:p={get platform(){return M.isWindows?"win32":M.isMacintosh?"darwin":"linux"},nextTick(P){return M.setImmediate(P)},get env(){return Object.create(null)},cwd(){return"/"}},t.cwd=p.cwd,t.env=p.env,t.platform=p.platform,t.nextTick=p.nextTick}),x(K[21],ee([0,1,20]),function(T,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const p=65,P=97,l=90,b=122,s=46,u=47,a=92,L=58,w=63;class g extends Error{constructor(i,o,h){let E;typeof o=="string"&&o.indexOf("not ")===0?(E="must not be",o=o.replace(/^not /,"")):E="must be";const d=i.indexOf(".")!==-1?"property":"argument";let S=`The "${i}" ${d} ${E} of type ${o}`;S+=`. Received type ${typeof h}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function f(r,i){if(typeof r!="string")throw new g(i,"string",r)}function m(r){return r===u||r===a}function A(r){return r===u}function _(r){return r>=p&&r<=l||r>=P&&r<=b}function v(r,i,o,h){let E="",d=0,S=-1,c=0,C=0;for(let D=0;D<=r.length;++D){if(D<r.length)C=r.charCodeAt(D);else{if(h(C))break;C=u}if(h(C)){if(!(S===D-1||c===1))if(c===2){if(E.length<2||d!==2||E.charCodeAt(E.length-1)!==s||E.charCodeAt(E.length-2)!==s){if(E.length>2){const F=E.lastIndexOf(o);F===-1?(E="",d=0):(E=E.slice(0,F),d=E.length-1-E.lastIndexOf(o)),S=D,c=0;continue}else if(E.length!==0){E="",d=0,S=D,c=0;continue}}i&&(E+=E.length>0?`${o}..`:"..",d=2)}else E.length>0?E+=`${o}${r.slice(S+1,D)}`:E=r.slice(S+1,D),d=D-S-1;S=D,c=0}else C===s&&c!==-1?++c:c=-1}return E}function n(r,i){if(i===null||typeof i!="object")throw new g("pathObject","Object",i);const o=i.dir||i.root,h=i.base||`${i.name||""}${i.ext||""}`;return o?o===i.root?`${o}${h}`:`${o}${r}${h}`:h}t.win32={resolve(...r){let i="",o="",h=!1;for(let E=r.length-1;E>=-1;E--){let d;if(E>=0){if(d=r[E],f(d,"path"),d.length===0)continue}else i.length===0?d=M.cwd():(d=M.env[`=${i}`]||M.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==i.toLowerCase()&&d.charCodeAt(2)===a)&&(d=`${i}\\`));const S=d.length;let c=0,C="",D=!1;const F=d.charCodeAt(0);if(S===1)m(F)&&(c=1,D=!0);else if(m(F))if(D=!0,m(d.charCodeAt(1))){let I=2,W=I;for(;I<S&&!m(d.charCodeAt(I));)I++;if(I<S&&I!==W){const V=d.slice(W,I);for(W=I;I<S&&m(d.charCodeAt(I));)I++;if(I<S&&I!==W){for(W=I;I<S&&!m(d.charCodeAt(I));)I++;(I===S||I!==W)&&(C=`\\\\${V}\\${d.slice(W,I)}`,c=I)}}}else c=1;else _(F)&&d.charCodeAt(1)===L&&(C=d.slice(0,2),c=2,S>2&&m(d.charCodeAt(2))&&(D=!0,c=3));if(C.length>0)if(i.length>0){if(C.toLowerCase()!==i.toLowerCase())continue}else i=C;if(h){if(i.length>0)break}else if(o=`${d.slice(c)}\\${o}`,h=D,D&&i.length>0)break}return o=v(o,!h,"\\",m),h?`${i}\\${o}`:`${i}${o}`||"."},normalize(r){f(r,"path");const i=r.length;if(i===0)return".";let o=0,h,E=!1;const d=r.charCodeAt(0);if(i===1)return A(d)?"\\":r;if(m(d))if(E=!0,m(r.charCodeAt(1))){let c=2,C=c;for(;c<i&&!m(r.charCodeAt(c));)c++;if(c<i&&c!==C){const D=r.slice(C,c);for(C=c;c<i&&m(r.charCodeAt(c));)c++;if(c<i&&c!==C){for(C=c;c<i&&!m(r.charCodeAt(c));)c++;if(c===i)return`\\\\${D}\\${r.slice(C)}\\`;c!==C&&(h=`\\\\${D}\\${r.slice(C,c)}`,o=c)}}}else o=1;else _(d)&&r.charCodeAt(1)===L&&(h=r.slice(0,2),o=2,i>2&&m(r.charCodeAt(2))&&(E=!0,o=3));let S=o<i?v(r.slice(o),!E,"\\",m):"";return S.length===0&&!E&&(S="."),S.length>0&&m(r.charCodeAt(i-1))&&(S+="\\"),h===void 0?E?`\\${S}`:S:E?`${h}\\${S}`:`${h}${S}`},isAbsolute(r){f(r,"path");const i=r.length;if(i===0)return!1;const o=r.charCodeAt(0);return m(o)||i>2&&_(o)&&r.charCodeAt(1)===L&&m(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let i,o;for(let d=0;d<r.length;++d){const S=r[d];f(S,"path"),S.length>0&&(i===void 0?i=o=S:i+=`\\${S}`)}if(i===void 0)return".";let h=!0,E=0;if(typeof o=="string"&&m(o.charCodeAt(0))){++E;const d=o.length;d>1&&m(o.charCodeAt(1))&&(++E,d>2&&(m(o.charCodeAt(2))?++E:h=!1))}if(h){for(;E<i.length&&m(i.charCodeAt(E));)E++;E>=2&&(i=`\\${i.slice(E)}`)}return t.win32.normalize(i)},relative(r,i){if(f(r,"from"),f(i,"to"),r===i)return"";const o=t.win32.resolve(r),h=t.win32.resolve(i);if(o===h||(r=o.toLowerCase(),i=h.toLowerCase(),r===i))return"";let E=0;for(;E<r.length&&r.charCodeAt(E)===a;)E++;let d=r.length;for(;d-1>E&&r.charCodeAt(d-1)===a;)d--;const S=d-E;let c=0;for(;c<i.length&&i.charCodeAt(c)===a;)c++;let C=i.length;for(;C-1>c&&i.charCodeAt(C-1)===a;)C--;const D=C-c,F=S<D?S:D;let I=-1,W=0;for(;W<F;W++){const X=r.charCodeAt(E+W);if(X!==i.charCodeAt(c+W))break;X===a&&(I=W)}if(W!==F){if(I===-1)return h}else{if(D>F){if(i.charCodeAt(c+W)===a)return h.slice(c+W+1);if(W===2)return h.slice(c+W)}S>F&&(r.charCodeAt(E+W)===a?I=W:W===2&&(I=3)),I===-1&&(I=0)}let V="";for(W=E+I+1;W<=d;++W)(W===d||r.charCodeAt(W)===a)&&(V+=V.length===0?"..":"\\..");return c+=I,V.length>0?`${V}${h.slice(c,C)}`:(h.charCodeAt(c)===a&&++c,h.slice(c,C))},toNamespacedPath(r){if(typeof r!="string")return r;if(r.length===0)return"";const i=t.win32.resolve(r);if(i.length<=2)return r;if(i.charCodeAt(0)===a){if(i.charCodeAt(1)===a){const o=i.charCodeAt(2);if(o!==w&&o!==s)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(_(i.charCodeAt(0))&&i.charCodeAt(1)===L&&i.charCodeAt(2)===a)return`\\\\?\\${i}`;return r},dirname(r){f(r,"path");const i=r.length;if(i===0)return".";let o=-1,h=0;const E=r.charCodeAt(0);if(i===1)return m(E)?r:".";if(m(E)){if(o=h=1,m(r.charCodeAt(1))){let c=2,C=c;for(;c<i&&!m(r.charCodeAt(c));)c++;if(c<i&&c!==C){for(C=c;c<i&&m(r.charCodeAt(c));)c++;if(c<i&&c!==C){for(C=c;c<i&&!m(r.charCodeAt(c));)c++;if(c===i)return r;c!==C&&(o=h=c+1)}}}}else _(E)&&r.charCodeAt(1)===L&&(o=i>2&&m(r.charCodeAt(2))?3:2,h=o);let d=-1,S=!0;for(let c=i-1;c>=h;--c)if(m(r.charCodeAt(c))){if(!S){d=c;break}}else S=!1;if(d===-1){if(o===-1)return".";d=o}return r.slice(0,d)},basename(r,i){i!==void 0&&f(i,"ext"),f(r,"path");let o=0,h=-1,E=!0,d;if(r.length>=2&&_(r.charCodeAt(0))&&r.charCodeAt(1)===L&&(o=2),i!==void 0&&i.length>0&&i.length<=r.length){if(i===r)return"";let S=i.length-1,c=-1;for(d=r.length-1;d>=o;--d){const C=r.charCodeAt(d);if(m(C)){if(!E){o=d+1;break}}else c===-1&&(E=!1,c=d+1),S>=0&&(C===i.charCodeAt(S)?--S==-1&&(h=d):(S=-1,h=c))}return o===h?h=c:h===-1&&(h=r.length),r.slice(o,h)}for(d=r.length-1;d>=o;--d)if(m(r.charCodeAt(d))){if(!E){o=d+1;break}}else h===-1&&(E=!1,h=d+1);return h===-1?"":r.slice(o,h)},extname(r){f(r,"path");let i=0,o=-1,h=0,E=-1,d=!0,S=0;r.length>=2&&r.charCodeAt(1)===L&&_(r.charCodeAt(0))&&(i=h=2);for(let c=r.length-1;c>=i;--c){const C=r.charCodeAt(c);if(m(C)){if(!d){h=c+1;break}continue}E===-1&&(d=!1,E=c+1),C===s?o===-1?o=c:S!==1&&(S=1):o!==-1&&(S=-1)}return o===-1||E===-1||S===0||S===1&&o===E-1&&o===h+1?"":r.slice(o,E)},format:n.bind(null,"\\"),parse(r){f(r,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return i;const o=r.length;let h=0,E=r.charCodeAt(0);if(o===1)return m(E)?(i.root=i.dir=r,i):(i.base=i.name=r,i);if(m(E)){if(h=1,m(r.charCodeAt(1))){let I=2,W=I;for(;I<o&&!m(r.charCodeAt(I));)I++;if(I<o&&I!==W){for(W=I;I<o&&m(r.charCodeAt(I));)I++;if(I<o&&I!==W){for(W=I;I<o&&!m(r.charCodeAt(I));)I++;I===o?h=I:I!==W&&(h=I+1)}}}}else if(_(E)&&r.charCodeAt(1)===L){if(o<=2)return i.root=i.dir=r,i;if(h=2,m(r.charCodeAt(2))){if(o===3)return i.root=i.dir=r,i;h=3}}h>0&&(i.root=r.slice(0,h));let d=-1,S=h,c=-1,C=!0,D=r.length-1,F=0;for(;D>=h;--D){if(E=r.charCodeAt(D),m(E)){if(!C){S=D+1;break}continue}c===-1&&(C=!1,c=D+1),E===s?d===-1?d=D:F!==1&&(F=1):d!==-1&&(F=-1)}return c!==-1&&(d===-1||F===0||F===1&&d===c-1&&d===S+1?i.base=i.name=r.slice(S,c):(i.name=r.slice(S,d),i.base=r.slice(S,c),i.ext=r.slice(d,c))),S>0&&S!==h?i.dir=r.slice(0,S-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...r){let i="",o=!1;for(let h=r.length-1;h>=-1&&!o;h--){const E=h>=0?r[h]:M.cwd();f(E,"path"),E.length!==0&&(i=`${E}/${i}`,o=E.charCodeAt(0)===u)}return i=v(i,!o,"/",A),o?`/${i}`:i.length>0?i:"."},normalize(r){if(f(r,"path"),r.length===0)return".";const i=r.charCodeAt(0)===u,o=r.charCodeAt(r.length-1)===u;return r=v(r,!i,"/",A),r.length===0?i?"/":o?"./":".":(o&&(r+="/"),i?`/${r}`:r)},isAbsolute(r){return f(r,"path"),r.length>0&&r.charCodeAt(0)===u},join(...r){if(r.length===0)return".";let i;for(let o=0;o<r.length;++o){const h=r[o];f(h,"path"),h.length>0&&(i===void 0?i=h:i+=`/${h}`)}return i===void 0?".":t.posix.normalize(i)},relative(r,i){if(f(r,"from"),f(i,"to"),r===i||(r=t.posix.resolve(r),i=t.posix.resolve(i),r===i))return"";const o=1,h=r.length,E=h-o,d=1,S=i.length-d,c=E<S?E:S;let C=-1,D=0;for(;D<c;D++){const I=r.charCodeAt(o+D);if(I!==i.charCodeAt(d+D))break;I===u&&(C=D)}if(D===c)if(S>c){if(i.charCodeAt(d+D)===u)return i.slice(d+D+1);if(D===0)return i.slice(d+D)}else E>c&&(r.charCodeAt(o+D)===u?C=D:D===0&&(C=0));let F="";for(D=o+C+1;D<=h;++D)(D===h||r.charCodeAt(D)===u)&&(F+=F.length===0?"..":"/..");return`${F}${i.slice(d+C)}`},toNamespacedPath(r){return r},dirname(r){if(f(r,"path"),r.length===0)return".";const i=r.charCodeAt(0)===u;let o=-1,h=!0;for(let E=r.length-1;E>=1;--E)if(r.charCodeAt(E)===u){if(!h){o=E;break}}else h=!1;return o===-1?i?"/":".":i&&o===1?"//":r.slice(0,o)},basename(r,i){i!==void 0&&f(i,"ext"),f(r,"path");let o=0,h=-1,E=!0,d;if(i!==void 0&&i.length>0&&i.length<=r.length){if(i===r)return"";let S=i.length-1,c=-1;for(d=r.length-1;d>=0;--d){const C=r.charCodeAt(d);if(C===u){if(!E){o=d+1;break}}else c===-1&&(E=!1,c=d+1),S>=0&&(C===i.charCodeAt(S)?--S==-1&&(h=d):(S=-1,h=c))}return o===h?h=c:h===-1&&(h=r.length),r.slice(o,h)}for(d=r.length-1;d>=0;--d)if(r.charCodeAt(d)===u){if(!E){o=d+1;break}}else h===-1&&(E=!1,h=d+1);return h===-1?"":r.slice(o,h)},extname(r){f(r,"path");let i=-1,o=0,h=-1,E=!0,d=0;for(let S=r.length-1;S>=0;--S){const c=r.charCodeAt(S);if(c===u){if(!E){o=S+1;break}continue}h===-1&&(E=!1,h=S+1),c===s?i===-1?i=S:d!==1&&(d=1):i!==-1&&(d=-1)}return i===-1||h===-1||d===0||d===1&&i===h-1&&i===o+1?"":r.slice(i,h)},format:n.bind(null,"/"),parse(r){f(r,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return i;const o=r.charCodeAt(0)===u;let h;o?(i.root="/",h=1):h=0;let E=-1,d=0,S=-1,c=!0,C=r.length-1,D=0;for(;C>=h;--C){const F=r.charCodeAt(C);if(F===u){if(!c){d=C+1;break}continue}S===-1&&(c=!1,S=C+1),F===s?E===-1?E=C:D!==1&&(D=1):E!==-1&&(D=-1)}if(S!==-1){const F=d===0&&o?1:d;E===-1||D===0||D===1&&E===S-1&&E===d+1?i.base=i.name=r.slice(F,S):(i.name=r.slice(F,E),i.base=r.slice(F,S),i.ext=r.slice(E,S))}return d>0?i.dir=r.slice(0,d-1):o&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=M.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=M.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=M.platform==="win32"?t.win32.join:t.posix.join,t.resolve=M.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=M.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=M.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=M.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=M.platform==="win32"?t.win32.extname:t.posix.extname,t.format=M.platform==="win32"?t.win32.format:t.posix.format,t.parse=M.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=M.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=M.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=M.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),x(K[9],ee([0,1,2]),function(T,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const p=M.globals.performance&&typeof M.globals.performance.now=="function";class P{constructor(b){this._highResolution=p&&b,this._startTime=this._now(),this._stopTime=-1}static create(b=!0){return new P(b)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?M.globals.performance.now():Date.now()}}t.StopWatch=P}),x(K[10],ee([0,1,4,7,8,19,9]),function(T,t,M,p,P,l,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.AsyncEmitter=t.PauseableEmitter=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0;var s;(function(n){n.None=()=>P.Disposable.None;function r(z){return(H,Y=null,Q)=>{let te=!1,U;return U=z(k=>{if(!te)return U?U.dispose():te=!0,H.call(Y,k)},null,Q),te&&U.dispose(),U}}n.once=r;function i(z,H){return c((Y,Q=null,te)=>z(U=>Y.call(Q,H(U)),null,te))}n.map=i;function o(z,H){return c((Y,Q=null,te)=>z(U=>{H(U),Y.call(Q,U)},null,te))}n.forEach=o;function h(z,H){return c((Y,Q=null,te)=>z(U=>H(U)&&Y.call(Q,U),null,te))}n.filter=h;function E(z){return z}n.signal=E;function d(...z){return(H,Y=null,Q)=>P.combinedDisposable(...z.map(te=>te(U=>H.call(Y,U),null,Q)))}n.any=d;function S(z,H,Y){let Q=Y;return i(z,te=>(Q=H(Q,te),Q))}n.reduce=S;function c(z){let H;const Y=new g({onFirstListenerAdd(){H=z(Y.fire,Y)},onLastListenerRemove(){H.dispose()}});return Y.event}n.snapshot=c;function C(z,H,Y=100,Q=!1,te){let U,k,y,B=0;const j=new g({leakWarningThreshold:te,onFirstListenerAdd(){U=z(Z=>{B++,k=H(k,Z),Q&&!y&&(j.fire(k),k=void 0),clearTimeout(y),y=setTimeout(()=>{const ie=k;k=void 0,y=void 0,(!Q||B>1)&&j.fire(ie),B=0},Y)})},onLastListenerRemove(){U.dispose()}});return j.event}n.debounce=C;function D(z){const H=new Date().getTime();return i(r(z),Y=>new Date().getTime()-H)}n.stopwatch=D;function F(z){let H=!0,Y;return h(z,Q=>{const te=H||Q!==Y;return H=!1,Y=Q,te})}n.latch=F;function I(z,H=!1,Y=[]){let Q=Y.slice(),te=z(y=>{Q?Q.push(y):k.fire(y)});const U=()=>{Q&&Q.forEach(y=>k.fire(y)),Q=null},k=new g({onFirstListenerAdd(){te||(te=z(y=>k.fire(y)))},onFirstListenerDidAdd(){Q&&(H?setTimeout(U):U())},onLastListenerRemove(){te&&te.dispose(),te=null}});return k.event}n.buffer=I;class W{constructor(H){this.event=H}map(H){return new W(i(this.event,H))}forEach(H){return new W(o(this.event,H))}filter(H){return new W(h(this.event,H))}reduce(H,Y){return new W(S(this.event,H,Y))}latch(){return new W(F(this.event))}debounce(H,Y=100,Q=!1,te){return new W(C(this.event,H,Y,Q,te))}on(H,Y,Q){return this.event(H,Y,Q)}once(H,Y,Q){return r(this.event)(H,Y,Q)}}function V(z){return new W(z)}n.chain=V;function X(z,H,Y=Q=>Q){const Q=(...y)=>k.fire(Y(...y)),te=()=>z.on(H,Q),U=()=>z.removeListener(H,Q),k=new g({onFirstListenerAdd:te,onLastListenerRemove:U});return k.event}n.fromNodeEventEmitter=X;function ne(z,H,Y=Q=>Q){const Q=(...y)=>k.fire(Y(...y)),te=()=>z.addEventListener(H,Q),U=()=>z.removeEventListener(H,Q),k=new g({onFirstListenerAdd:te,onLastListenerRemove:U});return k.event}n.fromDOMEventEmitter=ne;function e(z){const H=new g;let Y=!1;return z.then(void 0,()=>null).then(()=>{Y?H.fire(void 0):setTimeout(()=>H.fire(void 0),0)}),Y=!0,H.event}n.fromPromise=e;function se(z){return new Promise(H=>r(z)(H))}n.toPromise=se})(s=t.Event||(t.Event={}));class u{constructor(r){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${r}_${u._idPool++}`}start(r){this._stopWatch=new b.StopWatch(!0),this._listenerCount=r}stop(){if(this._stopWatch){const r=this._stopWatch.elapsed();this._elapsedOverall+=r,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${r.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}u._idPool=0;let a=-1;function L(n){const r=a;return a=n,{dispose(){a=r}}}t.setGlobalLeakWarningThreshold=L;class w{constructor(r,i=Math.random().toString(18).slice(2,5)){this.customThreshold=r,this.name=i,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(r){let i=a;if(typeof this.customThreshold=="number"&&(i=this.customThreshold),!(i<=0||r<i)){this._stacks||(this._stacks=new Map);const o=new Error().stack.split(`
`).slice(3).join(`
`),h=this._stacks.get(o)||0;if(this._stacks.set(o,h+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=i*.5;let E,d=0;for(const[S,c]of this._stacks)(!E||d<c)&&(E=S,d=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${d}):`),console.warn(E)}return()=>{const E=this._stacks.get(o)||0;this._stacks.set(o,E-1)}}}}class g{constructor(r){var i;this._disposed=!1,this._options=r,this._leakageMon=a>0?new w(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((i=this._options)===null||i===void 0?void 0:i._profName)?new u(this._options._profName):void 0}get event(){return this._event||(this._event=(r,i,o)=>{var h;this._listeners||(this._listeners=new l.LinkedList);const E=this._listeners.isEmpty();E&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const d=this._listeners.push(i?[r,i]:r);E&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,r,i);const S=(h=this._leakageMon)===null||h===void 0?void 0:h.check(this._listeners.size);let c;return c={dispose:()=>{S&&S(),c.dispose=g._noop,this._disposed||(d(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},o instanceof P.DisposableStore?o.add(c):Array.isArray(o)&&o.push(c),c}),this._event}fire(r){var i,o;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new l.LinkedList);for(let h of this._listeners)this._deliveryQueue.push([h,r]);for((i=this._perfMon)===null||i===void 0||i.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[h,E]=this._deliveryQueue.shift();try{typeof h=="function"?h.call(void 0,E):h[0].call(h[1],E)}catch(d){M.onUnexpectedError(d)}}(o=this._perfMon)===null||o===void 0||o.stop()}}dispose(){var r,i,o;(r=this._listeners)===null||r===void 0||r.clear(),(i=this._deliveryQueue)===null||i===void 0||i.clear(),(o=this._leakageMon)===null||o===void 0||o.dispose(),this._disposed=!0}}t.Emitter=g,g._noop=function(){};class f extends g{constructor(r){super(r);this._isPaused=0,this._eventQueue=new l.LinkedList,this._mergeFn=r==null?void 0:r.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const r=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(r))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(r){this._listeners&&(this._isPaused!==0?this._eventQueue.push(r):super.fire(r))}}t.PauseableEmitter=f;class m extends g{async fireAsync(r,i,o){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new l.LinkedList);for(const h of this._listeners)this._asyncDeliveryQueue.push([h,r]);for(;this._asyncDeliveryQueue.size>0&&!i.isCancellationRequested;){const[h,E]=this._asyncDeliveryQueue.shift(),d=[],S=Object.assign(Object.assign({},E),{waitUntil:c=>{if(Object.isFrozen(d))throw new Error("waitUntil can NOT be called asynchronous");o&&(c=o(c,typeof h=="function"?h:h[0])),d.push(c)}});try{typeof h=="function"?h.call(void 0,S):h[0].call(h[1],S)}catch(c){M.onUnexpectedError(c);continue}Object.freeze(d),await Promise.all(d).catch(c=>M.onUnexpectedError(c))}}}}t.AsyncEmitter=m;class A{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(r){const i={event:r,listener:null};this.events.push(i),this.hasListeners&&this.hook(i);const o=()=>{this.hasListeners&&this.unhook(i);const h=this.events.indexOf(i);this.events.splice(h,1)};return P.toDisposable(p.once(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(r=>this.hook(r))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(r=>this.unhook(r))}hook(r){r.listener=r.event(i=>this.emitter.fire(i))}unhook(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=A;class _{constructor(){this.buffers=[]}wrapEvent(r){return(i,o,h)=>r(E=>{const d=this.buffers[this.buffers.length-1];d?d.push(()=>i.call(o,E)):i.call(o,E)},void 0,h)}bufferEvents(r){const i=[];this.buffers.push(i);const o=r();return this.buffers.pop(),i.forEach(h=>h()),o}}t.EventBufferer=_;class v{constructor(){this.listening=!1,this.inputEvent=s.None,this.inputEventListener=P.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(r){this.inputEvent=r,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=r(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=v}),x(K[22],ee([0,1,10]),function(T,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const p=Object.freeze(function(s,u){const a=setTimeout(s.bind(u),0);return{dispose(){clearTimeout(a)}}});var P;(function(s){function u(a){return a===s.None||a===s.Cancelled||a instanceof l?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}s.isCancellationToken=u,s.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:M.Event.None}),s.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:p})})(P=t.CancellationToken||(t.CancellationToken={}));class l{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?p:(this._emitter||(this._emitter=new M.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class b{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new l),this._token}cancel(){this._token?this._token instanceof l&&this._token.cancel():this._token=P.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof l&&this._token.dispose():this._token=P.None}}t.CancellationTokenSource=b}),x(K[5],ee([0,1]),function(T,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GraphemeBreakType=t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.decodeUTF8=t.encodeUTF8=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format=t.isFalsyOrWhitespace=void 0;function M(N){return!N||typeof N!="string"?!0:N.trim().length===0}t.isFalsyOrWhitespace=M;const p=/{(\d+)}/g;function P(N,...R){return R.length===0?N:N.replace(p,function(O,q){const $=parseInt(q,10);return isNaN($)||$<0||$>=R.length?O:R[$]})}t.format=P;function l(N){return N.replace(/[<>&]/g,function(R){switch(R){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return R}})}t.escape=l;function b(N){return N.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=b;function s(N,R){let O=0;const q=R.charCodeAt(0);for(let $=N.length-1;$>=0;$--)N.charCodeAt($)===q&&O++;return O}t.count=s;function u(N,R,O="\u2026"){return N.length<=R?N:`${N.substr(0,R)}${O}`}t.truncate=u;function a(N,R=" "){const O=L(N,R);return w(O,R)}t.trim=a;function L(N,R){if(!N||!R)return N;const O=R.length;if(O===0||N.length===0)return N;let q=0;for(;N.indexOf(R,q)===q;)q=q+O;return N.substring(q)}t.ltrim=L;function w(N,R){if(!N||!R)return N;const O=R.length,q=N.length;if(O===0||q===0)return N;let $=q,G=-1;for(;G=N.lastIndexOf(R,$-1),!(G===-1||G+O!==$);){if(G===0)return"";$=G}return N.substring(0,$)}t.rtrim=w;function g(N){return N.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=g;function f(N){return N.replace(/\*/g,"")}t.stripWildcards=f;function m(N,R,O={}){if(!N)throw new Error("Cannot create regex from empty string");R||(N=b(N)),O.wholeWord&&(/\B/.test(N.charAt(0))||(N="\\b"+N),/\B/.test(N.charAt(N.length-1))||(N=N+"\\b"));let q="";return O.global&&(q+="g"),O.matchCase||(q+="i"),O.multiline&&(q+="m"),O.unicode&&(q+="u"),new RegExp(N,q)}t.createRegExp=m;function A(N){return N.source==="^"||N.source==="^$"||N.source==="$"||N.source==="^\\s*$"?!1:!!(N.exec("")&&N.lastIndex===0)}t.regExpLeadsToEndlessLoop=A;function _(N){return!!N.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=_;function v(N){return(N.global?"g":"")+(N.ignoreCase?"i":"")+(N.multiline?"m":"")+(N.unicode?"u":"")}t.regExpFlags=v;function n(N){return N.split(/\r\n|\r|\n/)}t.splitLines=n;function r(N){for(let R=0,O=N.length;R<O;R++){const q=N.charCodeAt(R);if(q!==32&&q!==9)return R}return-1}t.firstNonWhitespaceIndex=r;function i(N,R=0,O=N.length){for(let q=R;q<O;q++){const $=N.charCodeAt(q);if($!==32&&$!==9)return N.substring(R,q)}return N.substring(R,O)}t.getLeadingWhitespace=i;function o(N,R=N.length-1){for(let O=R;O>=0;O--){const q=N.charCodeAt(O);if(q!==32&&q!==9)return O}return-1}t.lastNonWhitespaceIndex=o;function h(N,R){return N<R?-1:N>R?1:0}t.compare=h;function E(N,R,O=0,q=N.length,$=0,G=R.length){for(;O<q&&$<G;O++,$++){let ce=N.charCodeAt(O),fe=R.charCodeAt($);if(ce<fe)return-1;if(ce>fe)return 1}const J=q-O,oe=G-$;return J<oe?-1:J>oe?1:0}t.compareSubstring=E;function d(N,R){return S(N,R,0,N.length,0,R.length)}t.compareIgnoreCase=d;function S(N,R,O=0,q=N.length,$=0,G=R.length){for(;O<q&&$<G;O++,$++){let ce=N.charCodeAt(O),fe=R.charCodeAt($);if(ce!==fe){const ge=ce-fe;if(!(ge===32&&C(fe))&&!(ge===-32&&C(ce)))return c(ce)&&c(fe)?ge:E(N.toLowerCase(),R.toLowerCase(),O,q,$,G)}}const J=q-O,oe=G-$;return J<oe?-1:J>oe?1:0}t.compareSubstringIgnoreCase=S;function c(N){return N>=97&&N<=122}t.isLowerAsciiLetter=c;function C(N){return N>=65&&N<=90}t.isUpperAsciiLetter=C;function D(N){return c(N)||C(N)}function F(N,R){return N.length===R.length&&I(N,R)}t.equalsIgnoreCase=F;function I(N,R,O=N.length){for(let q=0;q<O;q++){const $=N.charCodeAt(q),G=R.charCodeAt(q);if($!==G){if(D($)&&D(G)){const J=Math.abs($-G);if(J!==0&&J!==32)return!1}else if(String.fromCharCode($).toLowerCase()!==String.fromCharCode(G).toLowerCase())return!1}}return!0}function W(N,R){const O=R.length;return R.length>N.length?!1:I(N,R,O)}t.startsWithIgnoreCase=W;function V(N,R){let O,q=Math.min(N.length,R.length);for(O=0;O<q;O++)if(N.charCodeAt(O)!==R.charCodeAt(O))return O;return q}t.commonPrefixLength=V;function X(N,R){let O,q=Math.min(N.length,R.length);const $=N.length-1,G=R.length-1;for(O=0;O<q;O++)if(N.charCodeAt($-O)!==R.charCodeAt(G-O))return O;return q}t.commonSuffixLength=X;function ne(N){return 55296<=N&&N<=56319}t.isHighSurrogate=ne;function e(N){return 56320<=N&&N<=57343}t.isLowSurrogate=e;function se(N,R){return(N-55296<<10)+(R-56320)+65536}t.computeCodePoint=se;function z(N,R,O){const q=N.charCodeAt(O);if(ne(q)&&O+1<R){const $=N.charCodeAt(O+1);if(e($))return se(q,$)}return q}t.getNextCodePoint=z;function H(N,R){const O=N.charCodeAt(R-1);if(e(O)&&R>1){const q=N.charCodeAt(R-2);if(ne(q))return se(q,O)}return O}function Y(N,R){const O=de.getInstance(),q=R,$=N.length,G=z(N,$,R);R+=G>=65536?2:1;let J=O.getGraphemeBreakType(G);for(;R<$;){const oe=z(N,$,R),ce=O.getGraphemeBreakType(oe);if(me(J,ce))break;R+=oe>=65536?2:1,J=ce}return R-q}t.nextCharLength=Y;function Q(N,R){const O=de.getInstance(),q=R,$=H(N,R);R-=$>=65536?2:1;let G=O.getGraphemeBreakType($);for(;R>0;){const J=H(N,R),oe=O.getGraphemeBreakType(J);if(me(oe,G))break;R-=J>=65536?2:1,G=oe}return q-R}t.prevCharLength=Q;function te(N,R){const O=de.getInstance(),q=N.length,$=R,G=z(N,q,R),J=O.getGraphemeBreakType(G);R+=G>=65536?2:1;let oe=J;for(;R<q;){const fe=z(N,q,R),ge=O.getGraphemeBreakType(fe);if(me(oe,ge))break;R+=fe>=65536?2:1,oe=ge}const ce=R;for(R=$,oe=J;R>0;){const fe=H(N,R),ge=O.getGraphemeBreakType(fe);if(me(ge,oe))break;R-=fe>=65536?2:1,oe=ge}return[R,ce]}function U(N,R){return R>0&&e(N.charCodeAt(R))?te(N,R-1):te(N,R)}t.getCharContainingOffset=U;function k(N){const R=N.length;let O=0,q=0;for(;q<R;){const J=z(N,R,q);q+=J>=65536?2:1,J<128?O+=1:J<2048?O+=2:J<65536?O+=3:O+=4}const $=new Uint8Array(O);q=0;let G=0;for(;q<R;){const J=z(N,R,q);q+=J>=65536?2:1,J<128?$[G++]=J:J<2048?($[G++]=192|(J&1984)>>>6,$[G++]=128|(J&63)>>>0):J<65536?($[G++]=224|(J&61440)>>>12,$[G++]=128|(J&4032)>>>6,$[G++]=128|(J&63)>>>0):($[G++]=240|(J&1835008)>>>18,$[G++]=128|(J&258048)>>>12,$[G++]=128|(J&4032)>>>6,$[G++]=128|(J&63)>>>0)}return $}t.encodeUTF8=k;function y(N){const R=N.byteLength,O=[];let q=0;for(;q<R;){const $=N[q];let G;if($>=240&&q+3<R?G=(N[q++]&7)<<18>>>0|(N[q++]&63)<<12>>>0|(N[q++]&63)<<6>>>0|(N[q++]&63)<<0>>>0:$>=224&&q+2<R?G=(N[q++]&15)<<12>>>0|(N[q++]&63)<<6>>>0|(N[q++]&63)<<0>>>0:$>=192&&q+1<R?G=(N[q++]&31)<<6>>>0|(N[q++]&63)<<0>>>0:G=N[q++],G>=0&&G<=55295||G>=57344&&G<=65535)O.push(String.fromCharCode(G));else if(G>=65536&&G<=1114111){const J=G-65536,oe=55296+((J&1047552)>>>10),ce=56320+((J&1023)>>>0);O.push(String.fromCharCode(oe)),O.push(String.fromCharCode(ce))}else O.push(String.fromCharCode(65533))}return O.join("")}t.decodeUTF8=y;const B=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function j(N){return B.test(N)}t.containsRTL=j;const Z=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDE73\uDE78-\uDE82\uDE90-\uDE95])/;function ie(N){return Z.test(N)}t.containsEmoji=ie;const le=/^[\t\n\r\x20-\x7E]*$/;function re(N){return le.test(N)}t.isBasicASCII=re,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ae(N){return t.UNUSUAL_LINE_TERMINATORS.test(N)}t.containsUnusualLineTerminators=ae;function he(N){for(let R=0,O=N.length;R<O;R++)if(_e(N.charCodeAt(R)))return!0;return!1}t.containsFullWidthCharacter=he;function _e(N){return N=+N,N>=11904&&N<=55215||N>=63744&&N<=64255||N>=65281&&N<=65374}t.isFullWidthCharacter=_e;function Ae(N){return N>=127462&&N<=127487||N>=9728&&N<=10175||N>=127744&&N<=128591||N>=128640&&N<=128764||N>=128992&&N<=129003||N>=129280&&N<=129535||N>=129648&&N<=129651||N>=129656&&N<=129666||N>=129680&&N<=129685}t.isEmojiImprecise=Ae;function Ne(N,R){if(N.length<R)return N;const O=/\b/g;let q=0;for(;O.test(N)&&!(N.length-O.lastIndex<R);)q=O.lastIndex,O.lastIndex+=1;return N.substring(q).replace(/^\s/,"")}t.lcut=Ne;const we=/\x1B\x5B[12]?K/g,Ce=/\x1b\[\d+m/g,Pe=/\x1b\[0?m/g;function Me(N){return N&&(N=N.replace(we,""),N=N.replace(Ce,""),N=N.replace(Pe,"")),N}t.removeAnsiEscapeCodes=Me,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(N){return!!(N&&N.length>0&&N.charCodeAt(0)===65279)}t.startsWithUTF8BOM=Le;function De(N){return Le(N)?N.substr(1):N}t.stripUTF8BOM=De;function pe(N,R){if(!N||!R||N.length<R.length)return!1;const O=R.length,q=N.toLowerCase();let $=0,G=-1;for(;$<O;){const J=q.indexOf(R[$],G+1);if(J<0)return!1;G=J,$++}return!0}t.fuzzyContains=pe;function Ue(N,R=!1){return N?(R&&(N=N.replace(/\\./g,"")),N.toLowerCase()!==N):!1}t.containsUppercaseCharacter=Ue;function Re(N){return N.charAt(0).toUpperCase()+N.slice(1)}t.uppercaseFirstLetter=Re;function Ie(N,R=1){if(R===0)return"";let O=-1;do O=N.indexOf(`
`,O+1),R--;while(R>0&&O>=0);return O===-1?N:(N[O-1]==="\r"&&O--,N.substr(0,O))}t.getNLines=Ie;function Fe(N){const R=90-65+1;return N=N%(2*R),N<R?String.fromCharCode(97+N):String.fromCharCode(65+N-R)}t.singleLetterHash=Fe;function Te(N){return de.getInstance().getGraphemeBreakType(N)}t.getGraphemeBreakType=Te;function me(N,R){return N===0?R!==5&&R!==7:N===2&&R===3?!1:N===4||N===2||N===3||R===4||R===2||R===3?!0:!(N===8&&(R===8||R===9||R===11||R===12)||(N===11||N===9)&&(R===9||R===10)||(N===12||N===10)&&R===10||R===5||R===13||R===7||N===1||N===13&&R===14||N===6&&R===6)}t.breakBetweenGraphemeBreakType=me;var ke;(function(N){N[N.Other=0]="Other",N[N.Prepend=1]="Prepend",N[N.CR=2]="CR",N[N.LF=3]="LF",N[N.Control=4]="Control",N[N.Extend=5]="Extend",N[N.Regional_Indicator=6]="Regional_Indicator",N[N.SpacingMark=7]="SpacingMark",N[N.L=8]="L",N[N.V=9]="V",N[N.T=10]="T",N[N.LV=11]="LV",N[N.LVT=12]="LVT",N[N.ZWJ=13]="ZWJ",N[N.Extended_Pictographic=14]="Extended_Pictographic"})(ke=t.GraphemeBreakType||(t.GraphemeBreakType={}));class de{constructor(){this._data=ye()}static getInstance(){return de._INSTANCE||(de._INSTANCE=new de),de._INSTANCE}getGraphemeBreakType(R){if(R<32)return R===10?3:R===13?2:4;if(R<127)return 0;const O=this._data,q=O.length/3;let $=1;for(;$<=q;)if(R<O[3*$])$=2*$;else if(R>O[3*$+1])$=2*$+1;else return O[3*$+2];return 0}}de._INSTANCE=null;function ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),x(K[23],ee([0,1,5]),function(T,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.doHash=t.hash=void 0;function p(v){return P(v,0)}t.hash=p;function P(v,n){switch(typeof v){case"object":return v===null?l(349,n):Array.isArray(v)?u(v,n):a(v,n);case"string":return s(v,n);case"boolean":return b(v,n);case"number":return l(v,n);case"undefined":return l(937,n);default:return l(617,n)}}t.doHash=P;function l(v,n){return(n<<5)-n+v|0}function b(v,n){return l(v?433:863,n)}function s(v,n){n=l(149417,n);for(let r=0,i=v.length;r<i;r++)n=l(v.charCodeAt(r),n);return n}t.stringHash=s;function u(v,n){return n=l(104579,n),v.reduce((r,i)=>P(i,r),n)}function a(v,n){return n=l(181387,n),Object.keys(v).sort().reduce((r,i)=>(r=s(i,r),P(v[i],r)),n)}class L{constructor(){this._value=0}get value(){return this._value}hash(n){return this._value=P(n,this._value),this._value}}t.Hasher=L;var w;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function g(v,n,r=32){const i=r-n,o=~((1<<i)-1);return(v<<n|(o&v)>>>i)>>>0}function f(v,n=0,r=v.byteLength,i=0){for(let o=0;o<r;o++)v[n+o]=i}function m(v,n,r="0"){for(;v.length<n;)v=r+v;return v}function A(v,n=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(r=>r.toString(16).padStart(2,"0")).join(""):m((v>>>0).toString(16),n/4)}t.toHexString=A;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(n){const r=n.length;if(r!==0){const i=this._buff;let o=this._buffLen,h=this._leftoverHighSurrogate,E,d;for(h!==0?(E=h,d=-1,h=0):(E=n.charCodeAt(0),d=0);;){let S=E;if(M.isHighSurrogate(E))if(d+1<r){const c=n.charCodeAt(d+1);M.isLowSurrogate(c)?(d++,S=M.computeCodePoint(E,c)):S=65533}else{h=E;break}else M.isLowSurrogate(E)&&(S=65533);if(o=this._push(i,o,S),d++,d<r)E=n.charCodeAt(d);else break}this._buffLen=o,this._leftoverHighSurrogate=h}}_push(n,r,i){return i<128?n[r++]=i:i<2048?(n[r++]=192|(i&1984)>>>6,n[r++]=128|(i&63)>>>0):i<65536?(n[r++]=224|(i&61440)>>>12,n[r++]=128|(i&4032)>>>6,n[r++]=128|(i&63)>>>0):(n[r++]=240|(i&1835008)>>>18,n[r++]=128|(i&258048)>>>12,n[r++]=128|(i&4032)>>>6,n[r++]=128|(i&63)>>>0),r>=64&&(this._step(),r-=64,this._totalLen+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),r}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),A(this._h0)+A(this._h1)+A(this._h2)+A(this._h3)+A(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const n=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(n/4294967296),!1),this._buffDV.setUint32(60,n%4294967296,!1),this._step()}_step(){const n=_._bigBlock32,r=this._buffDV;for(let D=0;D<64;D+=4)n.setUint32(D,r.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)n.setUint32(D,g(n.getUint32(D-12,!1)^n.getUint32(D-32,!1)^n.getUint32(D-56,!1)^n.getUint32(D-64,!1),1),!1);let i=this._h0,o=this._h1,h=this._h2,E=this._h3,d=this._h4,S,c,C;for(let D=0;D<80;D++)D<20?(S=o&h|~o&E,c=1518500249):D<40?(S=o^h^E,c=1859775393):D<60?(S=o&h|o&E|h&E,c=2400959708):(S=o^h^E,c=3395469782),C=g(i,5)+S+d+c+n.getUint32(D*4,!1)&4294967295,d=E,E=h,h=g(o,30),o=i,i=C;this._h0=this._h0+i&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+h&4294967295,this._h3=this._h3+E&4294967295,this._h4=this._h4+d&4294967295}}t.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),x(K[11],ee([0,1,15,23]),function(T,t,M,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class P{constructor(g){this.source=g}getElements(){const g=this.source,f=new Int32Array(g.length);for(let m=0,A=g.length;m<A;m++)f[m]=g.charCodeAt(m);return f}}t.StringDiffSequence=P;function l(w,g,f){return new L(new P(w),new P(g)).ComputeDiff(f).changes}t.stringDiff=l;class b{static Assert(g,f){if(!g)throw new Error(f)}}t.Debug=b;class s{static Copy(g,f,m,A,_){for(let v=0;v<_;v++)m[A+v]=g[f+v]}static Copy2(g,f,m,A,_){for(let v=0;v<_;v++)m[A+v]=g[f+v]}}t.MyArray=s;var u;(function(w){w[w.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class a{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new M.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(g,f){this.m_originalStart=Math.min(this.m_originalStart,g),this.m_modifiedStart=Math.min(this.m_modifiedStart,f),this.m_originalCount++}AddModifiedElement(g,f){this.m_originalStart=Math.min(this.m_originalStart,g),this.m_modifiedStart=Math.min(this.m_modifiedStart,f),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class L{constructor(g,f,m=null){this.ContinueProcessingPredicate=m;const[A,_,v]=L._getElements(g),[n,r,i]=L._getElements(f);this._hasStrings=v&&i,this._originalStringElements=A,this._originalElementsOrHash=_,this._modifiedStringElements=n,this._modifiedElementsOrHash=r,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(g){return g.length>0&&typeof g[0]=="string"}static _getElements(g){const f=g.getElements();if(L._isStringArray(f)){const m=new Int32Array(f.length);for(let A=0,_=f.length;A<_;A++)m[A]=p.stringHash(f[A],0);return[f,m,!0]}return f instanceof Int32Array?[[],f,!1]:[[],new Int32Array(f),!1]}ElementsAreEqual(g,f){return this._originalElementsOrHash[g]!==this._modifiedElementsOrHash[f]?!1:this._hasStrings?this._originalStringElements[g]===this._modifiedStringElements[f]:!0}OriginalElementsAreEqual(g,f){return this._originalElementsOrHash[g]!==this._originalElementsOrHash[f]?!1:this._hasStrings?this._originalStringElements[g]===this._originalStringElements[f]:!0}ModifiedElementsAreEqual(g,f){return this._modifiedElementsOrHash[g]!==this._modifiedElementsOrHash[f]?!1:this._hasStrings?this._modifiedStringElements[g]===this._modifiedStringElements[f]:!0}ComputeDiff(g){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,g)}_ComputeDiff(g,f,m,A,_){const v=[!1];let n=this.ComputeDiffRecursive(g,f,m,A,v);return _&&(n=this.PrettifyChanges(n)),{quitEarly:v[0],changes:n}}ComputeDiffRecursive(g,f,m,A,_){for(_[0]=!1;g<=f&&m<=A&&this.ElementsAreEqual(g,m);)g++,m++;for(;f>=g&&A>=m&&this.ElementsAreEqual(f,A);)f--,A--;if(g>f||m>A){let h;return m<=A?(b.Assert(g===f+1,"originalStart should only be one more than originalEnd"),h=[new M.DiffChange(g,0,m,A-m+1)]):g<=f?(b.Assert(m===A+1,"modifiedStart should only be one more than modifiedEnd"),h=[new M.DiffChange(g,f-g+1,m,0)]):(b.Assert(g===f+1,"originalStart should only be one more than originalEnd"),b.Assert(m===A+1,"modifiedStart should only be one more than modifiedEnd"),h=[]),h}const v=[0],n=[0],r=this.ComputeRecursionPoint(g,f,m,A,v,n,_),i=v[0],o=n[0];if(r!==null)return r;if(!_[0]){const h=this.ComputeDiffRecursive(g,i,m,o,_);let E=[];return _[0]?E=[new M.DiffChange(i+1,f-(i+1)+1,o+1,A-(o+1)+1)]:E=this.ComputeDiffRecursive(i+1,f,o+1,A,_),this.ConcatenateChanges(h,E)}return[new M.DiffChange(g,f-g+1,m,A-m+1)]}WALKTRACE(g,f,m,A,_,v,n,r,i,o,h,E,d,S,c,C,D,F){let I=null,W=null,V=new a,X=f,ne=m,e=d[0]-C[0]-A,se=-1073741824,z=this.m_forwardHistory.length-1;do{const H=e+g;H===X||H<ne&&i[H-1]<i[H+1]?(h=i[H+1],S=h-e-A,h<se&&V.MarkNextChange(),se=h,V.AddModifiedElement(h+1,S),e=H+1-g):(h=i[H-1]+1,S=h-e-A,h<se&&V.MarkNextChange(),se=h-1,V.AddOriginalElement(h,S+1),e=H-1-g),z>=0&&(i=this.m_forwardHistory[z],g=i[0],X=1,ne=i.length-1)}while(--z>=-1);if(I=V.getReverseChanges(),F[0]){let H=d[0]+1,Y=C[0]+1;if(I!==null&&I.length>0){const Q=I[I.length-1];H=Math.max(H,Q.getOriginalEnd()),Y=Math.max(Y,Q.getModifiedEnd())}W=[new M.DiffChange(H,E-H+1,Y,c-Y+1)]}else{V=new a,X=v,ne=n,e=d[0]-C[0]-r,se=1073741824,z=D?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const H=e+_;H===X||H<ne&&o[H-1]>=o[H+1]?(h=o[H+1]-1,S=h-e-r,h>se&&V.MarkNextChange(),se=h+1,V.AddOriginalElement(h+1,S+1),e=H+1-_):(h=o[H-1],S=h-e-r,h>se&&V.MarkNextChange(),se=h,V.AddModifiedElement(h+1,S+1),e=H-1-_),z>=0&&(o=this.m_reverseHistory[z],_=o[0],X=1,ne=o.length-1)}while(--z>=-1);W=V.getChanges()}return this.ConcatenateChanges(I,W)}ComputeRecursionPoint(g,f,m,A,_,v,n){let r=0,i=0,o=0,h=0,E=0,d=0;g--,m--,_[0]=0,v[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const S=f-g+(A-m),c=S+1,C=new Int32Array(c),D=new Int32Array(c),F=A-m,I=f-g,W=g-m,V=f-A,ne=(I-F)%2==0;C[F]=g,D[I]=f,n[0]=!1;for(let e=1;e<=S/2+1;e++){let se=0,z=0;o=this.ClipDiagonalBound(F-e,e,F,c),h=this.ClipDiagonalBound(F+e,e,F,c);for(let Y=o;Y<=h;Y+=2){Y===o||Y<h&&C[Y-1]<C[Y+1]?r=C[Y+1]:r=C[Y-1]+1,i=r-(Y-F)-W;const Q=r;for(;r<f&&i<A&&this.ElementsAreEqual(r+1,i+1);)r++,i++;if(C[Y]=r,r+i>se+z&&(se=r,z=i),!ne&&Math.abs(Y-I)<=e-1&&r>=D[Y])return _[0]=r,v[0]=i,Q<=D[Y]&&1447>0&&e<=1447+1?this.WALKTRACE(F,o,h,W,I,E,d,V,C,D,r,f,_,i,A,v,ne,n):null}const H=(se-g+(z-m)-e)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(se,H))return n[0]=!0,_[0]=se,v[0]=z,H>0&&1447>0&&e<=1447+1?this.WALKTRACE(F,o,h,W,I,E,d,V,C,D,r,f,_,i,A,v,ne,n):(g++,m++,[new M.DiffChange(g,f-g+1,m,A-m+1)]);E=this.ClipDiagonalBound(I-e,e,I,c),d=this.ClipDiagonalBound(I+e,e,I,c);for(let Y=E;Y<=d;Y+=2){Y===E||Y<d&&D[Y-1]>=D[Y+1]?r=D[Y+1]-1:r=D[Y-1],i=r-(Y-I)-V;const Q=r;for(;r>g&&i>m&&this.ElementsAreEqual(r,i);)r--,i--;if(D[Y]=r,ne&&Math.abs(Y-F)<=e&&r<=C[Y])return _[0]=r,v[0]=i,Q>=C[Y]&&1447>0&&e<=1447+1?this.WALKTRACE(F,o,h,W,I,E,d,V,C,D,r,f,_,i,A,v,ne,n):null}if(e<=1447){let Y=new Int32Array(h-o+2);Y[0]=F-o+1,s.Copy2(C,o,Y,1,h-o+1),this.m_forwardHistory.push(Y),Y=new Int32Array(d-E+2),Y[0]=I-E+1,s.Copy2(D,E,Y,1,d-E+1),this.m_reverseHistory.push(Y)}}return this.WALKTRACE(F,o,h,W,I,E,d,V,C,D,r,f,_,i,A,v,ne,n)}PrettifyChanges(g){for(let f=0;f<g.length;f++){const m=g[f],A=f<g.length-1?g[f+1].originalStart:this._originalElementsOrHash.length,_=f<g.length-1?g[f+1].modifiedStart:this._modifiedElementsOrHash.length,v=m.originalLength>0,n=m.modifiedLength>0;for(;m.originalStart+m.originalLength<A&&m.modifiedStart+m.modifiedLength<_&&(!v||this.OriginalElementsAreEqual(m.originalStart,m.originalStart+m.originalLength))&&(!n||this.ModifiedElementsAreEqual(m.modifiedStart,m.modifiedStart+m.modifiedLength));)m.originalStart++,m.modifiedStart++;let r=[null];if(f<g.length-1&&this.ChangesOverlap(g[f],g[f+1],r)){g[f]=r[0],g.splice(f+1,1),f--;continue}}for(let f=g.length-1;f>=0;f--){const m=g[f];let A=0,_=0;if(f>0){const o=g[f-1];o.originalLength>0&&(A=o.originalStart+o.originalLength),o.modifiedLength>0&&(_=o.modifiedStart+o.modifiedLength)}const v=m.originalLength>0,n=m.modifiedLength>0;let r=0,i=this._boundaryScore(m.originalStart,m.originalLength,m.modifiedStart,m.modifiedLength);for(let o=1;;o++){const h=m.originalStart-o,E=m.modifiedStart-o;if(h<A||E<_||v&&!this.OriginalElementsAreEqual(h,h+m.originalLength)||n&&!this.ModifiedElementsAreEqual(E,E+m.modifiedLength))break;const d=this._boundaryScore(h,m.originalLength,E,m.modifiedLength);d>i&&(i=d,r=o)}m.originalStart-=r,m.modifiedStart-=r}if(this._hasStrings)for(let f=1,m=g.length;f<m;f++){const A=g[f-1],_=g[f],v=_.originalStart-A.originalStart-A.originalLength,n=A.originalStart,r=_.originalStart+_.originalLength,i=r-n,o=A.modifiedStart,h=_.modifiedStart+_.modifiedLength,E=h-o;if(v<5&&i<20&&E<20){const d=this._findBetterContiguousSequence(n,i,o,E,v);if(d){const[S,c]=d;(S!==A.originalStart+A.originalLength||c!==A.modifiedStart+A.modifiedLength)&&(A.originalLength=S-A.originalStart,A.modifiedLength=c-A.modifiedStart,_.originalStart=S+v,_.modifiedStart=c+v,_.originalLength=r-_.originalStart,_.modifiedLength=h-_.modifiedStart)}}}return g}_findBetterContiguousSequence(g,f,m,A,_){if(f<_||A<_)return null;const v=g+f-_+1,n=m+A-_+1;let r=0,i=0,o=0;for(let h=g;h<v;h++)for(let E=m;E<n;E++){const d=this._contiguousSequenceScore(h,E,_);d>0&&d>r&&(r=d,i=h,o=E)}return r>0?[i,o]:null}_contiguousSequenceScore(g,f,m){let A=0;for(let _=0;_<m;_++){if(!this.ElementsAreEqual(g+_,f+_))return 0;A+=this._originalStringElements[g+_].length}return A}_OriginalIsBoundary(g){return g<=0||g>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[g])}_OriginalRegionIsBoundary(g,f){if(this._OriginalIsBoundary(g)||this._OriginalIsBoundary(g-1))return!0;if(f>0){const m=g+f;if(this._OriginalIsBoundary(m-1)||this._OriginalIsBoundary(m))return!0}return!1}_ModifiedIsBoundary(g){return g<=0||g>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[g])}_ModifiedRegionIsBoundary(g,f){if(this._ModifiedIsBoundary(g)||this._ModifiedIsBoundary(g-1))return!0;if(f>0){const m=g+f;if(this._ModifiedIsBoundary(m-1)||this._ModifiedIsBoundary(m))return!0}return!1}_boundaryScore(g,f,m,A){const _=this._OriginalRegionIsBoundary(g,f)?1:0,v=this._ModifiedRegionIsBoundary(m,A)?1:0;return _+v}ConcatenateChanges(g,f){let m=[];if(g.length===0||f.length===0)return f.length>0?f:g;if(this.ChangesOverlap(g[g.length-1],f[0],m)){const A=new Array(g.length+f.length-1);return s.Copy(g,0,A,0,g.length-1),A[g.length-1]=m[0],s.Copy(f,1,A,g.length,f.length-1),A}else{const A=new Array(g.length+f.length);return s.Copy(g,0,A,0,g.length),s.Copy(f,0,A,g.length,f.length),A}}ChangesOverlap(g,f,m){if(b.Assert(g.originalStart<=f.originalStart,"Left change is not less than or equal to right change"),b.Assert(g.modifiedStart<=f.modifiedStart,"Left change is not less than or equal to right change"),g.originalStart+g.originalLength>=f.originalStart||g.modifiedStart+g.modifiedLength>=f.modifiedStart){const A=g.originalStart;let _=g.originalLength;const v=g.modifiedStart;let n=g.modifiedLength;return g.originalStart+g.originalLength>=f.originalStart&&(_=f.originalStart+f.originalLength-g.originalStart),g.modifiedStart+g.modifiedLength>=f.modifiedStart&&(n=f.modifiedStart+f.modifiedLength-g.modifiedStart),m[0]=new M.DiffChange(A,_,v,n),!0}else return m[0]=null,!1}ClipDiagonalBound(g,f,m,A){if(g>=0&&g<A)return g;const _=m,v=A-m-1,n=f%2==0;if(g<0){const r=_%2==0;return n===r?0:1}else{const r=v%2==0;return n===r?A-1:A-2}}}t.LcsDiff=L}),x(K[12],ee([0,1]),function(T,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NotImplementedProxy=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isNumber=t.isObject=t.isStringArray=t.isString=t.isArray=void 0;function M(c){return Array.isArray(c)}t.isArray=M;function p(c){return typeof c=="string"}t.isString=p;function P(c){return Array.isArray(c)&&c.every(C=>p(C))}t.isStringArray=P;function l(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}t.isObject=l;function b(c){return typeof c=="number"&&!isNaN(c)}t.isNumber=b;function s(c){return c===!0||c===!1}t.isBoolean=s;function u(c){return typeof c=="undefined"}t.isUndefined=u;function a(c){return!L(c)}t.isDefined=a;function L(c){return u(c)||c===null}t.isUndefinedOrNull=L;function w(c,C){if(!c)throw new Error(C?`Unexpected type, expected '${C}'`:"Unexpected type")}t.assertType=w;function g(c){if(L(c))throw new Error("Assertion Failed: argument is undefined or null");return c}t.assertIsDefined=g;function f(...c){const C=[];for(let D=0;D<c.length;D++){const F=c[D];if(L(F))throw new Error(`Assertion Failed: argument at index ${D} is undefined or null`);C.push(F)}return C}t.assertAllDefined=f;const m=Object.prototype.hasOwnProperty;function A(c){if(!l(c))return!1;for(let C in c)if(m.call(c,C))return!1;return!0}t.isEmptyObject=A;function _(c){return typeof c=="function"}t.isFunction=_;function v(...c){return c.length>0&&c.every(_)}t.areFunctions=v;function n(c,C){const D=Math.min(c.length,C.length);for(let F=0;F<D;F++)r(c[F],C[F])}t.validateConstraints=n;function r(c,C){if(p(C)){if(typeof c!==C)throw new Error(`argument does not match constraint: typeof ${C}`)}else if(_(C)){try{if(c instanceof C)return}catch(D){}if(!L(c)&&c.constructor===C||C.length===1&&C.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=r;function i(c){let C=[],D=Object.getPrototypeOf(c);for(;Object.prototype!==D;)C=C.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return C}t.getAllPropertyNames=i;function o(c){const C=[];for(const D of i(c))typeof c[D]=="function"&&C.push(D);return C}t.getAllMethodNames=o;function h(c,C){const D=I=>function(){const W=Array.prototype.slice.call(arguments,0);return C(I,W)};let F={};for(const I of c)F[I]=D(I);return F}t.createProxyObject=h;function E(c){return c===null?void 0:c}t.withNullAsUndefined=E;function d(c){return typeof c=="undefined"?null:c}t.withUndefinedAsNull=d;function S(c){return class{constructor(){return new Proxy({},{get(C,D){if(C[D])return C[D];throw new Error(`Not Implemented: ${c}->${String(D)}`)}})}}}t.NotImplementedProxy=S}),x(K[13],ee([0,1]),function(T,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var M;(function(l){l[l.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",l[l.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",l[l.MAX_UINT_8=255]="MAX_UINT_8",l[l.MAX_UINT_16=65535]="MAX_UINT_16",l[l.MAX_UINT_32=4294967295]="MAX_UINT_32",l[l.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(M=t.Constants||(t.Constants={}));function p(l){return l<0?0:l>255?255:l|0}t.toUint8=p;function P(l){return l<0?0:l>4294967295?4294967295:l|0}t.toUint32=P}),x(K[14],ee([0,1,2,21]),function(T,t,M,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const P=/^\w[\w\d+.-]*$/,l=/^\//,b=/^\/\//;function s(d,S){if(!d.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!P.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!l.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(d,S){return!d&&!S?"file":d}function a(d,S){switch(d){case"https":case"http":case"file":S?S[0]!==w&&(S=w+S):S=w;break}return S}const L="",w="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(S,c,C,D,F,I=!1){typeof S=="object"?(this.scheme=S.scheme||L,this.authority=S.authority||L,this.path=S.path||L,this.query=S.query||L,this.fragment=S.fragment||L):(this.scheme=u(S,I),this.authority=c||L,this.path=a(this.scheme,C||L),this.query=D||L,this.fragment=F||L,s(this,I))}static isUri(S){return S instanceof f?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}get fsPath(){return r(this,!1)}with(S){if(!S)return this;let{scheme:c,authority:C,path:D,query:F,fragment:I}=S;return c===void 0?c=this.scheme:c===null&&(c=L),C===void 0?C=this.authority:C===null&&(C=L),D===void 0?D=this.path:D===null&&(D=L),F===void 0?F=this.query:F===null&&(F=L),I===void 0?I=this.fragment:I===null&&(I=L),c===this.scheme&&C===this.authority&&D===this.path&&F===this.query&&I===this.fragment?this:new A(c,C,D,F,I)}static parse(S,c=!1){const C=g.exec(S);return C?new A(C[2]||L,E(C[4]||L),E(C[5]||L),E(C[7]||L),E(C[9]||L),c):new A(L,L,L,L,L)}static file(S){let c=L;if(M.isWindows&&(S=S.replace(/\\/g,w)),S[0]===w&&S[1]===w){const C=S.indexOf(w,2);C===-1?(c=S.substring(2),S=w):(c=S.substring(2,C),S=S.substring(C)||w)}return new A("file",c,S,L,L)}static from(S){return new A(S.scheme,S.authority,S.path,S.query,S.fragment)}static joinPath(S,...c){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return M.isWindows&&S.scheme==="file"?C=f.file(p.win32.join(r(S,!0),...c)).path:C=p.posix.join(S.path,...c),S.with({path:C})}toString(S=!1){return i(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof f)return S;{const c=new A(S);return c._formatted=S.external,c._fsPath=S._sep===m?S.fsPath:null,c}}else return S}}t.URI=f;const m=M.isWindows?1:void 0;class A extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(S=!1){return S?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const S={$mid:1};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=m),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(d,S){let c,C=-1;for(let D=0;D<d.length;D++){const F=d.charCodeAt(D);if(F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57||F===45||F===46||F===95||F===126||S&&F===47)C!==-1&&(c+=encodeURIComponent(d.substring(C,D)),C=-1),c!==void 0&&(c+=d.charAt(D));else{c===void 0&&(c=d.substr(0,D));const I=_[F];I!==void 0?(C!==-1&&(c+=encodeURIComponent(d.substring(C,D)),C=-1),c+=I):C===-1&&(C=D)}}return C!==-1&&(c+=encodeURIComponent(d.substring(C))),c!==void 0?c:d}function n(d){let S;for(let c=0;c<d.length;c++){const C=d.charCodeAt(c);C===35||C===63?(S===void 0&&(S=d.substr(0,c)),S+=_[C]):S!==void 0&&(S+=d[c])}return S!==void 0?S:d}function r(d,S){let c;return d.authority&&d.path.length>1&&d.scheme==="file"?c=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?S?c=d.path.substr(1):c=d.path[1].toLowerCase()+d.path.substr(2):c=d.path,M.isWindows&&(c=c.replace(/\//g,"\\")),c}t.uriToFsPath=r;function i(d,S){const c=S?n:v;let C="",{scheme:D,authority:F,path:I,query:W,fragment:V}=d;if(D&&(C+=D,C+=":"),(F||D==="file")&&(C+=w,C+=w),F){let X=F.indexOf("@");if(X!==-1){const ne=F.substr(0,X);F=F.substr(X+1),X=ne.indexOf(":"),X===-1?C+=c(ne,!1):(C+=c(ne.substr(0,X),!1),C+=":",C+=c(ne.substr(X+1),!1)),C+="@"}F=F.toLowerCase(),X=F.indexOf(":"),X===-1?C+=c(F,!1):(C+=c(F.substr(0,X),!1),C+=F.substr(X))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const X=I.charCodeAt(1);X>=65&&X<=90&&(I=`/${String.fromCharCode(X+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const X=I.charCodeAt(0);X>=65&&X<=90&&(I=`${String.fromCharCode(X+32)}:${I.substr(2)}`)}C+=c(I,!0)}return W&&(C+="?",C+=c(W,!1)),V&&(C+="#",C+=S?V:v(V,!1)),C}function o(d){try{return decodeURIComponent(d)}catch(S){return d.length>3?d.substr(0,3)+o(d.substr(3)):d}}const h=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function E(d){return d.match(h)?d.replace(h,S=>o(S)):d}}),x(K[35],ee([0,1,4,8,2,12]),function(T,t,M,p,P,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const b="$initialize";let s=!1;function u(f){!P.isWeb||(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(f.message))}t.logOnceWebWorkerWarning=u;class a{constructor(m){this._workerId=-1,this._handler=m,this._lastSentReq=0,this._pendingReplies=Object.create(null)}setWorkerId(m){this._workerId=m}sendMessage(m,A){let _=String(++this._lastSentReq);return new Promise((v,n)=>{this._pendingReplies[_]={resolve:v,reject:n},this._send({vsWorker:this._workerId,req:_,method:m,args:A})})}handleMessage(m){!m||!m.vsWorker||this._workerId!==-1&&m.vsWorker!==this._workerId||this._handleMessage(m)}_handleMessage(m){if(m.seq){let n=m;if(!this._pendingReplies[n.seq]){console.warn("Got reply to unknown seq");return}let r=this._pendingReplies[n.seq];if(delete this._pendingReplies[n.seq],n.err){let i=n.err;n.err.$isError&&(i=new Error,i.name=n.err.name,i.message=n.err.message,i.stack=n.err.stack),r.reject(i);return}r.resolve(n.res);return}let A=m,_=A.req;this._handler.handleMessage(A.method,A.args).then(n=>{this._send({vsWorker:this._workerId,seq:_,res:n,err:void 0})},n=>{n.detail instanceof Error&&(n.detail=M.transformErrorForSerialization(n.detail)),this._send({vsWorker:this._workerId,seq:_,res:void 0,err:M.transformErrorForSerialization(n)})})}_send(m){let A=[];if(m.req){const _=m;for(let v=0;v<_.args.length;v++)_.args[v]instanceof ArrayBuffer&&A.push(_.args[v])}else{const _=m;_.res instanceof ArrayBuffer&&A.push(_.res)}this._handler.sendMessage(m,A)}}class L extends p.Disposable{constructor(m,A,_){super();let v=null;this._worker=this._register(m.create("vs/base/common/worker/simpleWorker",o=>{this._protocol.handleMessage(o)},o=>{v&&v(o)})),this._protocol=new a({sendMessage:(o,h)=>{this._worker.postMessage(o,h)},handleMessage:(o,h)=>{if(typeof _[o]!="function")return Promise.reject(new Error("Missing method "+o+" on main thread host."));try{return Promise.resolve(_[o].apply(_,h))}catch(E){return Promise.reject(E)}}}),this._protocol.setWorkerId(this._worker.getId());let n=null;typeof self.require!="undefined"&&typeof self.require.getConfig=="function"?n=self.require.getConfig():typeof self.requirejs!="undefined"&&(n=self.requirejs.s.contexts._.config);const r=l.getAllMethodNames(_);this._onModuleLoaded=this._protocol.sendMessage(b,[this._worker.getId(),JSON.parse(JSON.stringify(n)),A,r]);const i=(o,h)=>this._request(o,h);this._lazyProxy=new Promise((o,h)=>{v=h,this._onModuleLoaded.then(E=>{o(l.createProxyObject(E,i))},E=>{h(E),this._onError("Worker failed to load "+A,E)})})}getProxyObject(){return this._lazyProxy}_request(m,A){return new Promise((_,v)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(m,A).then(_,v)},v)})}_onError(m,A){console.error(m),console.info(A)}}t.SimpleWorkerClient=L;class w{constructor(m,A){this._requestHandlerFactory=A,this._requestHandler=null,this._protocol=new a({sendMessage:(_,v)=>{m(_,v)},handleMessage:(_,v)=>this._handleMessage(_,v)})}onmessage(m){this._protocol.handleMessage(m)}_handleMessage(m,A){if(m===b)return this.initialize(A[0],A[1],A[2],A[3]);if(!this._requestHandler||typeof this._requestHandler[m]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+m));try{return Promise.resolve(this._requestHandler[m].apply(this._requestHandler,A))}catch(_){return Promise.reject(_)}}initialize(m,A,_,v){this._protocol.setWorkerId(m);const n=(i,o)=>this._protocol.sendMessage(i,o),r=l.createProxyObject(v,n);return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(r),Promise.resolve(l.getAllMethodNames(this._requestHandler))):(A&&(typeof A.baseUrl!="undefined"&&delete A.baseUrl,typeof A.paths!="undefined"&&typeof A.paths.vs!="undefined"&&delete A.paths.vs,typeof A.trustedTypesPolicy!==void 0&&delete A.trustedTypesPolicy,A.catchError=!0,self.require.config(A)),new Promise((i,o)=>{self.require([_],h=>{if(this._requestHandler=h.create(r),!this._requestHandler){o(new Error("No RequestHandler!"));return}i(l.getAllMethodNames(this._requestHandler))},o)}))}}t.SimpleWorkerServer=w;function g(f){return new w(f,null)}t.create=g}),x(K[24],ee([0,1,13]),function(T,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class p{constructor(s){let u=M.toUint8(s);this._defaultValue=u,this._asciiMap=p._createAsciiMap(u),this._map=new Map}static _createAsciiMap(s){let u=new Uint8Array(256);for(let a=0;a<256;a++)u[a]=s;return u}set(s,u){let a=M.toUint8(u);s>=0&&s<256?this._asciiMap[s]=a:this._map.set(s,a)}get(s){return s>=0&&s<256?this._asciiMap[s]:this._map.get(s)||this._defaultValue}}t.CharacterClassifier=p;var P;(function(b){b[b.False=0]="False",b[b.True=1]="True"})(P||(P={}));class l{constructor(){this._actual=new p(0)}add(s){this._actual.set(s,1)}has(s){return this._actual.get(s)===1}}t.CharacterSet=l}),x(K[3],ee([0,1]),function(T,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class M{constructor(P,l){this.lineNumber=P,this.column=l}with(P=this.lineNumber,l=this.column){return P===this.lineNumber&&l===this.column?this:new M(P,l)}delta(P=0,l=0){return this.with(this.lineNumber+P,this.column+l)}equals(P){return M.equals(this,P)}static equals(P,l){return!P&&!l?!0:!!P&&!!l&&P.lineNumber===l.lineNumber&&P.column===l.column}isBefore(P){return M.isBefore(this,P)}static isBefore(P,l){return P.lineNumber<l.lineNumber?!0:l.lineNumber<P.lineNumber?!1:P.column<l.column}isBeforeOrEqual(P){return M.isBeforeOrEqual(this,P)}static isBeforeOrEqual(P,l){return P.lineNumber<l.lineNumber?!0:l.lineNumber<P.lineNumber?!1:P.column<=l.column}static compare(P,l){let b=P.lineNumber|0,s=l.lineNumber|0;if(b===s){let u=P.column|0,a=l.column|0;return u-a}return b-s}clone(){return new M(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(P){return new M(P.lineNumber,P.column)}static isIPosition(P){return P&&typeof P.lineNumber=="number"&&typeof P.column=="number"}}t.Position=M}),x(K[6],ee([0,1,3]),function(T,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class p{constructor(l,b,s,u){l>s||l===s&&b>u?(this.startLineNumber=s,this.startColumn=u,this.endLineNumber=l,this.endColumn=b):(this.startLineNumber=l,this.startColumn=b,this.endLineNumber=s,this.endColumn=u)}isEmpty(){return p.isEmpty(this)}static isEmpty(l){return l.startLineNumber===l.endLineNumber&&l.startColumn===l.endColumn}containsPosition(l){return p.containsPosition(this,l)}static containsPosition(l,b){return!(b.lineNumber<l.startLineNumber||b.lineNumber>l.endLineNumber||b.lineNumber===l.startLineNumber&&b.column<l.startColumn||b.lineNumber===l.endLineNumber&&b.column>l.endColumn)}containsRange(l){return p.containsRange(this,l)}static containsRange(l,b){return!(b.startLineNumber<l.startLineNumber||b.endLineNumber<l.startLineNumber||b.startLineNumber>l.endLineNumber||b.endLineNumber>l.endLineNumber||b.startLineNumber===l.startLineNumber&&b.startColumn<l.startColumn||b.endLineNumber===l.endLineNumber&&b.endColumn>l.endColumn)}strictContainsRange(l){return p.strictContainsRange(this,l)}static strictContainsRange(l,b){return!(b.startLineNumber<l.startLineNumber||b.endLineNumber<l.startLineNumber||b.startLineNumber>l.endLineNumber||b.endLineNumber>l.endLineNumber||b.startLineNumber===l.startLineNumber&&b.startColumn<=l.startColumn||b.endLineNumber===l.endLineNumber&&b.endColumn>=l.endColumn)}plusRange(l){return p.plusRange(this,l)}static plusRange(l,b){let s,u,a,L;return b.startLineNumber<l.startLineNumber?(s=b.startLineNumber,u=b.startColumn):b.startLineNumber===l.startLineNumber?(s=b.startLineNumber,u=Math.min(b.startColumn,l.startColumn)):(s=l.startLineNumber,u=l.startColumn),b.endLineNumber>l.endLineNumber?(a=b.endLineNumber,L=b.endColumn):b.endLineNumber===l.endLineNumber?(a=b.endLineNumber,L=Math.max(b.endColumn,l.endColumn)):(a=l.endLineNumber,L=l.endColumn),new p(s,u,a,L)}intersectRanges(l){return p.intersectRanges(this,l)}static intersectRanges(l,b){let s=l.startLineNumber,u=l.startColumn,a=l.endLineNumber,L=l.endColumn,w=b.startLineNumber,g=b.startColumn,f=b.endLineNumber,m=b.endColumn;return s<w?(s=w,u=g):s===w&&(u=Math.max(u,g)),a>f?(a=f,L=m):a===f&&(L=Math.min(L,m)),s>a||s===a&&u>L?null:new p(s,u,a,L)}equalsRange(l){return p.equalsRange(this,l)}static equalsRange(l,b){return!!l&&!!b&&l.startLineNumber===b.startLineNumber&&l.startColumn===b.startColumn&&l.endLineNumber===b.endLineNumber&&l.endColumn===b.endColumn}getEndPosition(){return p.getEndPosition(this)}static getEndPosition(l){return new M.Position(l.endLineNumber,l.endColumn)}getStartPosition(){return p.getStartPosition(this)}static getStartPosition(l){return new M.Position(l.startLineNumber,l.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(l,b){return new p(this.startLineNumber,this.startColumn,l,b)}setStartPosition(l,b){return new p(l,b,this.endLineNumber,this.endColumn)}collapseToStart(){return p.collapseToStart(this)}static collapseToStart(l){return new p(l.startLineNumber,l.startColumn,l.startLineNumber,l.startColumn)}static fromPositions(l,b=l){return new p(l.lineNumber,l.column,b.lineNumber,b.column)}static lift(l){return l?new p(l.startLineNumber,l.startColumn,l.endLineNumber,l.endColumn):null}static isIRange(l){return l&&typeof l.startLineNumber=="number"&&typeof l.startColumn=="number"&&typeof l.endLineNumber=="number"&&typeof l.endColumn=="number"}static areIntersectingOrTouching(l,b){return!(l.endLineNumber<b.startLineNumber||l.endLineNumber===b.startLineNumber&&l.endColumn<b.startColumn||b.endLineNumber<l.startLineNumber||b.endLineNumber===l.startLineNumber&&b.endColumn<l.startColumn)}static areIntersecting(l,b){return!(l.endLineNumber<b.startLineNumber||l.endLineNumber===b.startLineNumber&&l.endColumn<=b.startColumn||b.endLineNumber<l.startLineNumber||b.endLineNumber===l.startLineNumber&&b.endColumn<=l.startColumn)}static compareRangesUsingStarts(l,b){if(l&&b){const a=l.startLineNumber|0,L=b.startLineNumber|0;if(a===L){const w=l.startColumn|0,g=b.startColumn|0;if(w===g){const f=l.endLineNumber|0,m=b.endLineNumber|0;if(f===m){const A=l.endColumn|0,_=b.endColumn|0;return A-_}return f-m}return w-g}return a-L}return(l?1:0)-(b?1:0)}static compareRangesUsingEnds(l,b){return l.endLineNumber===b.endLineNumber?l.endColumn===b.endColumn?l.startLineNumber===b.startLineNumber?l.startColumn-b.startColumn:l.startLineNumber-b.startLineNumber:l.endColumn-b.endColumn:l.endLineNumber-b.endLineNumber}static spansMultipleLines(l){return l.endLineNumber>l.startLineNumber}}t.Range=p}),x(K[25],ee([0,1,3,6]),function(T,t,M,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var P;(function(b){b[b.LTR=0]="LTR",b[b.RTL=1]="RTL"})(P=t.SelectionDirection||(t.SelectionDirection={}));class l extends p.Range{constructor(s,u,a,L){super(s,u,a,L);this.selectionStartLineNumber=s,this.selectionStartColumn=u,this.positionLineNumber=a,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(s){return l.selectionsEqual(this,s)}static selectionsEqual(s,u){return s.selectionStartLineNumber===u.selectionStartLineNumber&&s.selectionStartColumn===u.selectionStartColumn&&s.positionLineNumber===u.positionLineNumber&&s.positionColumn===u.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(s,u){return this.getDirection()===0?new l(this.startLineNumber,this.startColumn,s,u):new l(s,u,this.startLineNumber,this.startColumn)}getPosition(){return new M.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(s,u){return this.getDirection()===0?new l(s,u,this.endLineNumber,this.endColumn):new l(this.endLineNumber,this.endColumn,s,u)}static fromPositions(s,u=s){return new l(s.lineNumber,s.column,u.lineNumber,u.column)}static liftSelection(s){return new l(s.selectionStartLineNumber,s.selectionStartColumn,s.positionLineNumber,s.positionColumn)}static selectionsArrEqual(s,u){if(s&&!u||!s&&u)return!1;if(!s&&!u)return!0;if(s.length!==u.length)return!1;for(let a=0,L=s.length;a<L;a++)if(!this.selectionsEqual(s[a],u[a]))return!1;return!0}static isISelection(s){return s&&typeof s.selectionStartLineNumber=="number"&&typeof s.selectionStartColumn=="number"&&typeof s.positionLineNumber=="number"&&typeof s.positionColumn=="number"}static createWithDirection(s,u,a,L,w){return w===0?new l(s,u,a,L):new l(a,L,s,u)}}t.Selection=l}),x(K[26],ee([0,1]),function(T,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationResult2=t.TokenizationResult=t.Token=void 0;class M{constructor(b,s,u){this.offset=b|0,this.type=s,this.language=u}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=M;class p{constructor(b,s){this.tokens=b,this.endState=s}}t.TokenizationResult=p;class P{constructor(b,s){this.tokens=b,this.endState=s}}t.TokenizationResult2=P}),x(K[27],ee([0,1,11,5]),function(T,t,M,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=void 0;const P=3;function l(A,_,v,n){return new M.LcsDiff(A,_,v).ComputeDiff(n)}class b{constructor(_){const v=[],n=[];for(let r=0,i=_.length;r<i;r++)v[r]=g(_[r],1),n[r]=f(_[r],1);this.lines=_,this._startColumns=v,this._endColumns=n}getElements(){const _=[];for(let v=0,n=this.lines.length;v<n;v++)_[v]=this.lines[v].substring(this._startColumns[v]-1,this._endColumns[v]-1);return _}getStartLineNumber(_){return _+1}getEndLineNumber(_){return _+1}createCharSequence(_,v,n){const r=[],i=[],o=[];let h=0;for(let E=v;E<=n;E++){const d=this.lines[E],S=_?this._startColumns[E]:1,c=_?this._endColumns[E]:d.length+1;for(let C=S;C<c;C++)r[h]=d.charCodeAt(C-1),i[h]=E+1,o[h]=C,h++}return new s(r,i,o)}}class s{constructor(_,v,n){this._charCodes=_,this._lineNumbers=v,this._columns=n}getElements(){return this._charCodes}getStartLineNumber(_){return this._lineNumbers[_]}getStartColumn(_){return this._columns[_]}getEndLineNumber(_){return this._lineNumbers[_]}getEndColumn(_){return this._columns[_]+1}}class u{constructor(_,v,n,r,i,o,h,E){this.originalStartLineNumber=_,this.originalStartColumn=v,this.originalEndLineNumber=n,this.originalEndColumn=r,this.modifiedStartLineNumber=i,this.modifiedStartColumn=o,this.modifiedEndLineNumber=h,this.modifiedEndColumn=E}static createFromDiffChange(_,v,n){let r,i,o,h,E,d,S,c;return _.originalLength===0?(r=0,i=0,o=0,h=0):(r=v.getStartLineNumber(_.originalStart),i=v.getStartColumn(_.originalStart),o=v.getEndLineNumber(_.originalStart+_.originalLength-1),h=v.getEndColumn(_.originalStart+_.originalLength-1)),_.modifiedLength===0?(E=0,d=0,S=0,c=0):(E=n.getStartLineNumber(_.modifiedStart),d=n.getStartColumn(_.modifiedStart),S=n.getEndLineNumber(_.modifiedStart+_.modifiedLength-1),c=n.getEndColumn(_.modifiedStart+_.modifiedLength-1)),new u(r,i,o,h,E,d,S,c)}}function a(A){if(A.length<=1)return A;const _=[A[0]];let v=_[0];for(let n=1,r=A.length;n<r;n++){const i=A[n],o=i.originalStart-(v.originalStart+v.originalLength),h=i.modifiedStart-(v.modifiedStart+v.modifiedLength);Math.min(o,h)<P?(v.originalLength=i.originalStart+i.originalLength-v.originalStart,v.modifiedLength=i.modifiedStart+i.modifiedLength-v.modifiedStart):(_.push(i),v=i)}return _}class L{constructor(_,v,n,r,i){this.originalStartLineNumber=_,this.originalEndLineNumber=v,this.modifiedStartLineNumber=n,this.modifiedEndLineNumber=r,this.charChanges=i}static createFromDiffResult(_,v,n,r,i,o,h){let E,d,S,c,C;if(v.originalLength===0?(E=n.getStartLineNumber(v.originalStart)-1,d=0):(E=n.getStartLineNumber(v.originalStart),d=n.getEndLineNumber(v.originalStart+v.originalLength-1)),v.modifiedLength===0?(S=r.getStartLineNumber(v.modifiedStart)-1,c=0):(S=r.getStartLineNumber(v.modifiedStart),c=r.getEndLineNumber(v.modifiedStart+v.modifiedLength-1)),o&&v.originalLength>0&&v.originalLength<20&&v.modifiedLength>0&&v.modifiedLength<20&&i()){const D=n.createCharSequence(_,v.originalStart,v.originalStart+v.originalLength-1),F=r.createCharSequence(_,v.modifiedStart,v.modifiedStart+v.modifiedLength-1);let I=l(D,F,i,!0).changes;h&&(I=a(I)),C=[];for(let W=0,V=I.length;W<V;W++)C.push(u.createFromDiffChange(I[W],D,F))}return new L(E,d,S,c,C)}}class w{constructor(_,v,n){this.shouldComputeCharChanges=n.shouldComputeCharChanges,this.shouldPostProcessCharChanges=n.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=n.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=n.shouldMakePrettyDiff,this.originalLines=_,this.modifiedLines=v,this.original=new b(_),this.modified=new b(v),this.continueLineDiff=m(n.maxComputationTime),this.continueCharDiff=m(n.maxComputationTime===0?0:Math.min(n.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const _=l(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),v=_.changes,n=_.quitEarly;if(this.shouldIgnoreTrimWhitespace){const h=[];for(let E=0,d=v.length;E<d;E++)h.push(L.createFromDiffResult(this.shouldIgnoreTrimWhitespace,v[E],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:n,changes:h}}const r=[];let i=0,o=0;for(let h=-1,E=v.length;h<E;h++){const d=h+1<E?v[h+1]:null,S=d?d.originalStart:this.originalLines.length,c=d?d.modifiedStart:this.modifiedLines.length;for(;i<S&&o<c;){const C=this.originalLines[i],D=this.modifiedLines[o];if(C!==D){{let F=g(C,1),I=g(D,1);for(;F>1&&I>1;){const W=C.charCodeAt(F-2),V=D.charCodeAt(I-2);if(W!==V)break;F--,I--}(F>1||I>1)&&this._pushTrimWhitespaceCharChange(r,i+1,1,F,o+1,1,I)}{let F=f(C,1),I=f(D,1);const W=C.length+1,V=D.length+1;for(;F<W&&I<V;){const X=C.charCodeAt(F-1),ne=C.charCodeAt(I-1);if(X!==ne)break;F++,I++}(F<W||I<V)&&this._pushTrimWhitespaceCharChange(r,i+1,F,W,o+1,I,V)}}i++,o++}d&&(r.push(L.createFromDiffResult(this.shouldIgnoreTrimWhitespace,d,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),i+=d.originalLength,o+=d.modifiedLength)}return{quitEarly:n,changes:r}}_pushTrimWhitespaceCharChange(_,v,n,r,i,o,h){if(!this._mergeTrimWhitespaceCharChange(_,v,n,r,i,o,h)){let E;this.shouldComputeCharChanges&&(E=[new u(v,n,v,r,i,o,i,h)]),_.push(new L(v,v,i,i,E))}}_mergeTrimWhitespaceCharChange(_,v,n,r,i,o,h){const E=_.length;if(E===0)return!1;const d=_[E-1];return d.originalEndLineNumber===0||d.modifiedEndLineNumber===0?!1:d.originalEndLineNumber+1===v&&d.modifiedEndLineNumber+1===i?(d.originalEndLineNumber=v,d.modifiedEndLineNumber=i,this.shouldComputeCharChanges&&d.charChanges&&d.charChanges.push(new u(v,n,v,r,i,o,i,h)),!0):!1}}t.DiffComputer=w;function g(A,_){const v=p.firstNonWhitespaceIndex(A);return v===-1?_:v+1}function f(A,_){const v=p.lastNonWhitespaceIndex(A);return v===-1?_:v+2}function m(A){if(A===0)return()=>!0;const _=Date.now();return()=>Date.now()-_<A}}),x(K[28],ee([0,1]),function(T,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function M(s=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const a of t.USUAL_WORD_SEPARATORS)s.indexOf(a)>=0||(u+="\\"+a);return u+="\\s]+)",new RegExp(u,"g")}t.DEFAULT_WORD_REGEXP=M();function p(s){let u=t.DEFAULT_WORD_REGEXP;if(s&&s instanceof RegExp)if(s.global)u=s;else{let a="g";s.ignoreCase&&(a+="i"),s.multiline&&(a+="m"),s.unicode&&(a+="u"),u=new RegExp(s.source,a)}return u.lastIndex=0,u}t.ensureValidWordDefinition=p;const P={maxLen:1e3,windowSize:15,timeBudget:150};function l(s,u,a,L,w=P){if(a.length>w.maxLen){let _=s-w.maxLen/2;return _<0?_=0:L+=_,a=a.substring(_,s+w.maxLen/2),l(s,u,a,L,w)}const g=Date.now(),f=s-1-L;let m=-1,A=null;for(let _=1;!(Date.now()-g>=w.timeBudget);_++){const v=f-w.windowSize*_;u.lastIndex=Math.max(0,v);const n=b(u,a,f,m);if(!n&&A||(A=n,v<=0))break;m=v}if(A){let _={word:A[0],startColumn:L+1+A.index,endColumn:L+1+A.index+A[0].length};return u.lastIndex=0,_}return null}t.getWordAtText=l;function b(s,u,a,L){let w;for(;w=s.exec(u);){const g=w.index||0;if(g<=a&&s.lastIndex>=a)return w;if(L>0&&g>L)return null}return null}}),x(K[29],ee([0,1,24]),function(T,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.Uint8Matrix=t.State=void 0;var p;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(p=t.State||(t.State={}));class P{constructor(m,A,_){const v=new Uint8Array(m*A);for(let n=0,r=m*A;n<r;n++)v[n]=_;this._data=v,this.rows=m,this.cols=A}get(m,A){return this._data[m*this.cols+A]}set(m,A,_){this._data[m*this.cols+A]=_}}t.Uint8Matrix=P;class l{constructor(m){let A=0,_=0;for(let n=0,r=m.length;n<r;n++){let[i,o,h]=m[n];o>A&&(A=o),i>_&&(_=i),h>_&&(_=h)}A++,_++;let v=new P(_,A,0);for(let n=0,r=m.length;n<r;n++){let[i,o,h]=m[n];v.set(i,o,h)}this._states=v,this._maxCharCode=A}nextState(m,A){return A<0||A>=this._maxCharCode?0:this._states.get(m,A)}}t.StateMachine=l;let b=null;function s(){return b===null&&(b=new l([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),b}var u;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let a=null;function L(){if(a===null){a=new M.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let A=0;A<f.length;A++)a.set(f.charCodeAt(A),1);const m=".,;";for(let A=0;A<m.length;A++)a.set(m.charCodeAt(A),2)}return a}class w{static _createLink(m,A,_,v,n){let r=n-1;do{const i=A.charCodeAt(r);if(m.get(i)!==2)break;r--}while(r>v);if(v>0){const i=A.charCodeAt(v-1),o=A.charCodeAt(r);(i===40&&o===41||i===91&&o===93||i===123&&o===125)&&r--}return{range:{startLineNumber:_,startColumn:v+1,endLineNumber:_,endColumn:r+2},url:A.substring(v,r+1)}}static computeLinks(m,A=s()){const _=L();let v=[];for(let n=1,r=m.getLineCount();n<=r;n++){const i=m.getLineContent(n),o=i.length;let h=0,E=0,d=0,S=1,c=!1,C=!1,D=!1,F=!1;for(;h<o;){let I=!1;const W=i.charCodeAt(h);if(S===13){let V;switch(W){case 40:c=!0,V=0;break;case 41:V=c?0:1;break;case 91:D=!0,C=!0,V=0;break;case 93:D=!1,V=C?0:1;break;case 123:F=!0,V=0;break;case 125:V=F?0:1;break;case 39:V=d===34||d===96?0:1;break;case 34:V=d===39||d===96?0:1;break;case 96:V=d===39||d===34?0:1;break;case 42:V=d===42?1:0;break;case 124:V=d===124?1:0;break;case 32:V=D?0:1;break;default:V=_.get(W)}V===1&&(v.push(w._createLink(_,i,n,E,h)),I=!0)}else if(S===12){let V;W===91?(C=!0,V=0):V=_.get(W),V===1?I=!0:S=13}else S=A.nextState(S,W),S===0&&(I=!0);I&&(S=1,c=!1,C=!1,F=!1,E=h+1,d=W),h++}S===13&&v.push(w._createLink(_,i,n,E,o))}return v}}t.LinkComputer=w;function g(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:w.computeLinks(f)}t.computeLinks=g}),x(K[30],ee([0,1]),function(T,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class M{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(P,l,b,s,u){if(P&&l){let a=this.doNavigateValueSet(l,u);if(a)return{range:P,value:a}}if(b&&s){let a=this.doNavigateValueSet(s,u);if(a)return{range:b,value:a}}return null}doNavigateValueSet(P,l){let b=this.numberReplace(P,l);return b!==null?b:this.textReplace(P,l)}numberReplace(P,l){let b=Math.pow(10,P.length-(P.lastIndexOf(".")+1)),s=Number(P),u=parseFloat(P);return!isNaN(s)&&!isNaN(u)&&s===u?s===0&&!l?null:(s=Math.floor(s*b),s+=l?b:-b,String(s/b)):null}textReplace(P,l){return this.valueSetsReplace(this._defaultValueSet,P,l)}valueSetsReplace(P,l,b){let s=null;for(let u=0,a=P.length;s===null&&u<a;u++)s=this.valueSetReplace(P[u],l,b);return s}valueSetReplace(P,l,b){let s=P.indexOf(l);return s>=0?(s+=b?1:-1,s<0?s=P.length-1:s%=P.length,P[s]):null}}t.BasicInplaceReplace=M,M.INSTANCE=new M}),x(K[31],ee([0,1]),function(T,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.AccessibilitySupport=void 0;var M;(function(e){e[e.Unknown=0]="Unknown",e[e.Disabled=1]="Disabled",e[e.Enabled=2]="Enabled"})(M=t.AccessibilitySupport||(t.AccessibilitySupport={}));var p;(function(e){e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"})(p=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var P;(function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet"})(P=t.CompletionItemKind||(t.CompletionItemKind={}));var l;(function(e){e[e.Deprecated=1]="Deprecated"})(l=t.CompletionItemTag||(t.CompletionItemTag={}));var b;(function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var s;(function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"})(s=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var u;(function(e){e[e.NotSet=0]="NotSet",e[e.ContentFlush=1]="ContentFlush",e[e.RecoverFromMarkers=2]="RecoverFromMarkers",e[e.Explicit=3]="Explicit",e[e.Paste=4]="Paste",e[e.Undo=5]="Undo",e[e.Redo=6]="Redo"})(u=t.CursorChangeReason||(t.CursorChangeReason={}));var a;(function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(a=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var L;(function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"})(L=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var w;(function(e){e[e.None=0]="None",e[e.Keep=1]="Keep",e[e.Brackets=2]="Brackets",e[e.Advanced=3]="Advanced",e[e.Full=4]="Full"})(w=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var g;(function(e){e[e.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",e[e.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",e[e.accessibilitySupport=2]="accessibilitySupport",e[e.accessibilityPageSize=3]="accessibilityPageSize",e[e.ariaLabel=4]="ariaLabel",e[e.autoClosingBrackets=5]="autoClosingBrackets",e[e.autoClosingOvertype=6]="autoClosingOvertype",e[e.autoClosingQuotes=7]="autoClosingQuotes",e[e.autoIndent=8]="autoIndent",e[e.automaticLayout=9]="automaticLayout",e[e.autoSurround=10]="autoSurround",e[e.codeLens=11]="codeLens",e[e.codeLensFontFamily=12]="codeLensFontFamily",e[e.codeLensFontSize=13]="codeLensFontSize",e[e.colorDecorators=14]="colorDecorators",e[e.columnSelection=15]="columnSelection",e[e.comments=16]="comments",e[e.contextmenu=17]="contextmenu",e[e.copyWithSyntaxHighlighting=18]="copyWithSyntaxHighlighting",e[e.cursorBlinking=19]="cursorBlinking",e[e.cursorSmoothCaretAnimation=20]="cursorSmoothCaretAnimation",e[e.cursorStyle=21]="cursorStyle",e[e.cursorSurroundingLines=22]="cursorSurroundingLines",e[e.cursorSurroundingLinesStyle=23]="cursorSurroundingLinesStyle",e[e.cursorWidth=24]="cursorWidth",e[e.disableLayerHinting=25]="disableLayerHinting",e[e.disableMonospaceOptimizations=26]="disableMonospaceOptimizations",e[e.dragAndDrop=27]="dragAndDrop",e[e.emptySelectionClipboard=28]="emptySelectionClipboard",e[e.extraEditorClassName=29]="extraEditorClassName",e[e.fastScrollSensitivity=30]="fastScrollSensitivity",e[e.find=31]="find",e[e.fixedOverflowWidgets=32]="fixedOverflowWidgets",e[e.folding=33]="folding",e[e.foldingStrategy=34]="foldingStrategy",e[e.foldingHighlight=35]="foldingHighlight",e[e.unfoldOnClickAfterEndOfLine=36]="unfoldOnClickAfterEndOfLine",e[e.fontFamily=37]="fontFamily",e[e.fontInfo=38]="fontInfo",e[e.fontLigatures=39]="fontLigatures",e[e.fontSize=40]="fontSize",e[e.fontWeight=41]="fontWeight",e[e.formatOnPaste=42]="formatOnPaste",e[e.formatOnType=43]="formatOnType",e[e.glyphMargin=44]="glyphMargin",e[e.gotoLocation=45]="gotoLocation",e[e.hideCursorInOverviewRuler=46]="hideCursorInOverviewRuler",e[e.highlightActiveIndentGuide=47]="highlightActiveIndentGuide",e[e.hover=48]="hover",e[e.inDiffEditor=49]="inDiffEditor",e[e.letterSpacing=50]="letterSpacing",e[e.lightbulb=51]="lightbulb",e[e.lineDecorationsWidth=52]="lineDecorationsWidth",e[e.lineHeight=53]="lineHeight",e[e.lineNumbers=54]="lineNumbers",e[e.lineNumbersMinChars=55]="lineNumbersMinChars",e[e.linkedEditing=56]="linkedEditing",e[e.links=57]="links",e[e.matchBrackets=58]="matchBrackets",e[e.minimap=59]="minimap",e[e.mouseStyle=60]="mouseStyle",e[e.mouseWheelScrollSensitivity=61]="mouseWheelScrollSensitivity",e[e.mouseWheelZoom=62]="mouseWheelZoom",e[e.multiCursorMergeOverlapping=63]="multiCursorMergeOverlapping",e[e.multiCursorModifier=64]="multiCursorModifier",e[e.multiCursorPaste=65]="multiCursorPaste",e[e.occurrencesHighlight=66]="occurrencesHighlight",e[e.overviewRulerBorder=67]="overviewRulerBorder",e[e.overviewRulerLanes=68]="overviewRulerLanes",e[e.padding=69]="padding",e[e.parameterHints=70]="parameterHints",e[e.peekWidgetDefaultFocus=71]="peekWidgetDefaultFocus",e[e.definitionLinkOpensInPeek=72]="definitionLinkOpensInPeek",e[e.quickSuggestions=73]="quickSuggestions",e[e.quickSuggestionsDelay=74]="quickSuggestionsDelay",e[e.readOnly=75]="readOnly",e[e.renameOnType=76]="renameOnType",e[e.renderControlCharacters=77]="renderControlCharacters",e[e.renderIndentGuides=78]="renderIndentGuides",e[e.renderFinalNewline=79]="renderFinalNewline",e[e.renderLineHighlight=80]="renderLineHighlight",e[e.renderLineHighlightOnlyWhenFocus=81]="renderLineHighlightOnlyWhenFocus",e[e.renderValidationDecorations=82]="renderValidationDecorations",e[e.renderWhitespace=83]="renderWhitespace",e[e.revealHorizontalRightPadding=84]="revealHorizontalRightPadding",e[e.roundedSelection=85]="roundedSelection",e[e.rulers=86]="rulers",e[e.scrollbar=87]="scrollbar",e[e.scrollBeyondLastColumn=88]="scrollBeyondLastColumn",e[e.scrollBeyondLastLine=89]="scrollBeyondLastLine",e[e.scrollPredominantAxis=90]="scrollPredominantAxis",e[e.selectionClipboard=91]="selectionClipboard",e[e.selectionHighlight=92]="selectionHighlight",e[e.selectOnLineNumbers=93]="selectOnLineNumbers",e[e.showFoldingControls=94]="showFoldingControls",e[e.showUnused=95]="showUnused",e[e.snippetSuggestions=96]="snippetSuggestions",e[e.smartSelect=97]="smartSelect",e[e.smoothScrolling=98]="smoothScrolling",e[e.stickyTabStops=99]="stickyTabStops",e[e.stopRenderingLineAfter=100]="stopRenderingLineAfter",e[e.suggest=101]="suggest",e[e.suggestFontSize=102]="suggestFontSize",e[e.suggestLineHeight=103]="suggestLineHeight",e[e.suggestOnTriggerCharacters=104]="suggestOnTriggerCharacters",e[e.suggestSelection=105]="suggestSelection",e[e.tabCompletion=106]="tabCompletion",e[e.tabIndex=107]="tabIndex",e[e.unusualLineTerminators=108]="unusualLineTerminators",e[e.useTabStops=109]="useTabStops",e[e.wordSeparators=110]="wordSeparators",e[e.wordWrap=111]="wordWrap",e[e.wordWrapBreakAfterCharacters=112]="wordWrapBreakAfterCharacters",e[e.wordWrapBreakBeforeCharacters=113]="wordWrapBreakBeforeCharacters",e[e.wordWrapColumn=114]="wordWrapColumn",e[e.wordWrapOverride1=115]="wordWrapOverride1",e[e.wordWrapOverride2=116]="wordWrapOverride2",e[e.wrappingIndent=117]="wrappingIndent",e[e.wrappingStrategy=118]="wrappingStrategy",e[e.showDeprecated=119]="showDeprecated",e[e.inlineHints=120]="inlineHints",e[e.editorClassName=121]="editorClassName",e[e.pixelRatio=122]="pixelRatio",e[e.tabFocusMode=123]="tabFocusMode",e[e.layoutInfo=124]="layoutInfo",e[e.wrappingInfo=125]="wrappingInfo"})(g=t.EditorOption||(t.EditorOption={}));var f;(function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(f=t.EndOfLinePreference||(t.EndOfLinePreference={}));var m;(function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"})(m=t.EndOfLineSequence||(t.EndOfLineSequence={}));var A;(function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"})(A=t.IndentAction||(t.IndentAction={}));var _;(function(e){e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.MAX_VALUE=112]="MAX_VALUE"})(_=t.KeyCode||(t.KeyCode={}));var v;(function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"})(v=t.MarkerSeverity||(t.MarkerSeverity={}));var n;(function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"})(n=t.MarkerTag||(t.MarkerTag={}));var r;(function(e){e[e.Inline=1]="Inline",e[e.Gutter=2]="Gutter"})(r=t.MinimapPosition||(t.MinimapPosition={}));var i;(function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",e[e.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(i=t.MouseTargetType||(t.MouseTargetType={}));var o;(function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",e[e.TOP_CENTER=2]="TOP_CENTER"})(o=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var h;(function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"})(h=t.OverviewRulerLane||(t.OverviewRulerLane={}));var E;(function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"})(E=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var d;(function(e){e[e.None=0]="None",e[e.Text=1]="Text",e[e.Blocks=2]="Blocks"})(d=t.RenderMinimap||(t.RenderMinimap={}));var S;(function(e){e[e.Smooth=0]="Smooth",e[e.Immediate=1]="Immediate"})(S=t.ScrollType||(t.ScrollType={}));var c;(function(e){e[e.Auto=1]="Auto",e[e.Hidden=2]="Hidden",e[e.Visible=3]="Visible"})(c=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var C;(function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"})(C=t.SelectionDirection||(t.SelectionDirection={}));var D;(function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"})(D=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var F;(function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"})(F=t.SymbolKind||(t.SymbolKind={}));var I;(function(e){e[e.Deprecated=1]="Deprecated"})(I=t.SymbolTag||(t.SymbolTag={}));var W;(function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"})(W=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var V;(function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"})(V=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var X;(function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(X=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var ne;(function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"})(ne=t.WrappingIndent||(t.WrappingIndent={}))}),x(K[32],ee([0,1,22,10,18,14,3,6,25,26,31]),function(T,t,M,p,P,l,b,s,u,a,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class w{static chord(m,A){return P.KeyChord(m,A)}}t.KeyMod=w,w.CtrlCmd=2048,w.Shift=1024,w.Alt=512,w.WinCtrl=256;function g(){return{editor:void 0,languages:void 0,CancellationTokenSource:M.CancellationTokenSource,Emitter:p.Emitter,KeyCode:L.KeyCode,KeyMod:w,Position:b.Position,Range:s.Range,Selection:u.Selection,SelectionDirection:L.SelectionDirection,MarkerSeverity:L.MarkerSeverity,MarkerTag:L.MarkerTag,Uri:l.URI,Token:a.Token}}t.createMonacoBaseAPI=g}),x(K[33],ee([0,1,13]),function(T,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumComputer=t.PrefixSumIndexOfResult=void 0;class p{constructor(b,s){this.index=b,this.remainder=s}}t.PrefixSumIndexOfResult=p;class P{constructor(b){this.values=b,this.prefixSum=new Uint32Array(b.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(b,s){b=M.toUint32(b);const u=this.values,a=this.prefixSum,L=s.length;return L===0?!1:(this.values=new Uint32Array(u.length+L),this.values.set(u.subarray(0,b),0),this.values.set(u.subarray(b),b+L),this.values.set(s,b),b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(a.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(b,s){return b=M.toUint32(b),s=M.toUint32(s),this.values[b]===s?!1:(this.values[b]=s,b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),!0)}removeValues(b,s){b=M.toUint32(b),s=M.toUint32(s);const u=this.values,a=this.prefixSum;if(b>=u.length)return!1;let L=u.length-b;return s>=L&&(s=L),s===0?!1:(this.values=new Uint32Array(u.length-s),this.values.set(u.subarray(0,b),0),this.values.set(u.subarray(b+s),b),this.prefixSum=new Uint32Array(this.values.length),b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(a.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(b){return b<0?0:(b=M.toUint32(b),this._getAccumulatedValue(b))}_getAccumulatedValue(b){if(b<=this.prefixSumValidIndex[0])return this.prefixSum[b];let s=this.prefixSumValidIndex[0]+1;s===0&&(this.prefixSum[0]=this.values[0],s++),b>=this.values.length&&(b=this.values.length-1);for(let u=s;u<=b;u++)this.prefixSum[u]=this.prefixSum[u-1]+this.values[u];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],b),this.prefixSum[b]}getIndexOf(b){b=Math.floor(b),this.getTotalValue();let s=0,u=this.values.length-1,a=0,L=0,w=0;for(;s<=u;)if(a=s+(u-s)/2|0,L=this.prefixSum[a],w=L-this.values[a],b<w)u=a-1;else if(b>=L)s=a+1;else break;return new p(a,b-w)}}t.PrefixSumComputer=P}),x(K[34],ee([0,1,5,3,33]),function(T,t,M,p,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class l{constructor(s,u,a,L){this._uri=s,this._lines=u,this._eol=a,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(s){s.eol&&s.eol!==this._eol&&(this._eol=s.eol,this._lineStarts=null);const u=s.changes;for(const a of u)this._acceptDeleteRange(a.range),this._acceptInsertText(new p.Position(a.range.startLineNumber,a.range.startColumn),a.text);this._versionId=s.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const s=this._eol.length,u=this._lines.length,a=new Uint32Array(u);for(let L=0;L<u;L++)a[L]=this._lines[L].length+s;this._lineStarts=new P.PrefixSumComputer(a)}}_setLineText(s,u){this._lines[s]=u,this._lineStarts&&this._lineStarts.changeValue(s,this._lines[s].length+this._eol.length)}_acceptDeleteRange(s){if(s.startLineNumber===s.endLineNumber){if(s.startColumn===s.endColumn)return;this._setLineText(s.startLineNumber-1,this._lines[s.startLineNumber-1].substring(0,s.startColumn-1)+this._lines[s.startLineNumber-1].substring(s.endColumn-1));return}this._setLineText(s.startLineNumber-1,this._lines[s.startLineNumber-1].substring(0,s.startColumn-1)+this._lines[s.endLineNumber-1].substring(s.endColumn-1)),this._lines.splice(s.startLineNumber,s.endLineNumber-s.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(s.startLineNumber,s.endLineNumber-s.startLineNumber)}_acceptInsertText(s,u){if(u.length!==0){let a=M.splitLines(u);if(a.length===1){this._setLineText(s.lineNumber-1,this._lines[s.lineNumber-1].substring(0,s.column-1)+a[0]+this._lines[s.lineNumber-1].substring(s.column-1));return}a[a.length-1]+=this._lines[s.lineNumber-1].substring(s.column-1),this._setLineText(s.lineNumber-1,this._lines[s.lineNumber-1].substring(0,s.column-1)+a[0]);let L=new Uint32Array(a.length-1);for(let w=1;w<a.length;w++)this._lines.splice(s.lineNumber+w-1,0,a[w]),L[w-1]=a[w].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(s.lineNumber,L)}}}t.MirrorTextModel=l}),x(K[36],ee([0,1,16,11,2,14,3,6,27,34,28,29,30,32,12,9]),function(T,t,M,p,P,l,b,s,u,a,L,w,g,f,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class _ extends a.MirrorTextModel{get uri(){return this._uri}get version(){return this._versionId}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,o){let h=L.getWordAtText(i.column,L.ensureValidWordDefinition(o),this._lines[i.lineNumber-1],0);return h?new s.Range(i.lineNumber,h.startColumn,i.lineNumber,h.endColumn):null}getWordUntilPosition(i,o){const h=this.getWordAtPosition(i,o);return h?{word:this._lines[i.lineNumber-1].substring(h.startColumn-1,i.column-1),startColumn:h.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const o=this._lines,h=this._wordenize.bind(this);let E=0,d="",S=0,c=[];return{*[Symbol.iterator](){for(;;)if(S<c.length){const C=d.substring(c[S].start,c[S].end);S+=1,yield C}else if(E<o.length)d=o[E],c=h(d,i),S=0,E+=1;else break}}}getLineWords(i,o){let h=this._lines[i-1],E=this._wordenize(h,o),d=[];for(const S of E)d.push({word:h.substring(S.start,S.end),startColumn:S.start+1,endColumn:S.end+1});return d}_wordenize(i,o){const h=[];let E;for(o.lastIndex=0;(E=o.exec(i))&&E[0].length!==0;)h.push({start:E.index,end:E.index+E[0].length});return h}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);let o=this._eol,h=i.startLineNumber-1,E=i.endLineNumber-1,d=[];d.push(this._lines[h].substring(i.startColumn-1));for(let S=h+1;S<E;S++)d.push(this._lines[S]);return d.push(this._lines[E].substring(0,i.endColumn-1)),d.join(o)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();let o=this._lineStarts.getIndexOf(i),h=this._lines[o.index].length;return{lineNumber:1+o.index,column:1+Math.min(o.remainder,h)}}_validateRange(i){const o=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),h=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return o.lineNumber!==i.startLineNumber||o.column!==i.startColumn||h.lineNumber!==i.endLineNumber||h.column!==i.endColumn?{startLineNumber:o.lineNumber,startColumn:o.column,endLineNumber:h.lineNumber,endColumn:h.column}:i}_validatePosition(i){if(!b.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:o,column:h}=i,E=!1;if(o<1)o=1,h=1,E=!0;else if(o>this._lines.length)o=this._lines.length,h=this._lines[o-1].length+1,E=!0;else{let d=this._lines[o-1].length+1;h<1?(h=1,E=!0):h>d&&(h=d,E=!0)}return E?{lineNumber:o,column:h}:i}}class v{constructor(i,o){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=o,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){let i=[];return Object.keys(this._models).forEach(o=>i.push(this._models[o])),i}acceptNewModel(i){this._models[i.url]=new _(l.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,o){!this._models[i]||this._models[i].onEvents(o)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}async computeDiff(i,o,h,E){const d=this._getModel(i),S=this._getModel(o);if(!d||!S)return null;const c=d.getLinesContent(),C=S.getLinesContent(),F=new u.DiffComputer(c,C,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:h,shouldMakePrettyDiff:!0,maxComputationTime:E}).computeDiff(),I=F.changes.length>0?!1:this._modelsAreIdentical(d,S);return{quitEarly:F.quitEarly,identical:I,changes:F.changes}}_modelsAreIdentical(i,o){const h=i.getLineCount(),E=o.getLineCount();if(h!==E)return!1;for(let d=1;d<=h;d++){const S=i.getLineContent(d),c=o.getLineContent(d);if(S!==c)return!1}return!0}async computeDirtyDiff(i,o,h){let E=this._getModel(i),d=this._getModel(o);if(!E||!d)return null;let S=E.getLinesContent(),c=d.getLinesContent();return new u.DiffComputer(S,c,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:h,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,o){const h=this._getModel(i);if(!h)return o;const E=[];let d;o=M.mergeSort(o,(S,c)=>{if(S.range&&c.range)return s.Range.compareRangesUsingStarts(S.range,c.range);let C=S.range?0:1,D=c.range?0:1;return C-D});for(let{range:S,text:c,eol:C}of o)if(typeof C=="number"&&(d=C),!(s.Range.isEmpty(S)&&!c)){const D=h.getValueInRange(S);if(c=c.replace(/\r\n|\n|\r/g,h.eol),D!==c){if(Math.max(c.length,D.length)>v._diffLimit){E.push({range:S,text:c});continue}const F=p.stringDiff(D,c,!1),I=h.offsetAt(s.Range.lift(S).getStartPosition());for(const W of F){const V=h.positionAt(I+W.originalStart),X=h.positionAt(I+W.originalStart+W.originalLength),ne={text:c.substr(W.modifiedStart,W.modifiedLength),range:{startLineNumber:V.lineNumber,startColumn:V.column,endLineNumber:X.lineNumber,endColumn:X.column}};h.getValueInRange(ne.range)!==ne.text&&E.push(ne)}}}return typeof d=="number"&&E.push({eol:d,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),E}async computeLinks(i){let o=this._getModel(i);return o?w.computeLinks(o):null}async textualSuggest(i,o,h,E){const d=new A.StopWatch(!0),S=new RegExp(h,E),c=new Set;e:for(let C of i){const D=this._getModel(C);if(!!D){for(let F of D.words(S))if(!(F===o||!isNaN(Number(F)))&&(c.add(F),c.size>v._suggestionsLimit))break e}}return{words:Array.from(c),duration:d.elapsed()}}async computeWordRanges(i,o,h,E){let d=this._getModel(i);if(!d)return Object.create(null);const S=new RegExp(h,E),c=Object.create(null);for(let C=o.startLineNumber;C<o.endLineNumber;C++){let D=d.getLineWords(C,S);for(const F of D)if(!!isNaN(Number(F.word))){let I=c[F.word];I||(I=[],c[F.word]=I),I.push({startLineNumber:C,startColumn:F.startColumn,endLineNumber:C,endColumn:F.endColumn})}}return c}async navigateValueSet(i,o,h,E,d){let S=this._getModel(i);if(!S)return null;let c=new RegExp(E,d);o.startColumn===o.endColumn&&(o={startLineNumber:o.startLineNumber,startColumn:o.startColumn,endLineNumber:o.endLineNumber,endColumn:o.endColumn+1});let C=S.getValueInRange(o),D=S.getWordAtPosition({lineNumber:o.startLineNumber,column:o.startColumn},c);if(!D)return null;let F=S.getValueInRange(D);return g.BasicInplaceReplace.INSTANCE.navigateValueSet(o,C,D,F,h)}loadForeignModule(i,o,h){const E=(c,C)=>this._host.fhr(c,C);let S={host:m.createProxyObject(h,E),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(S,o),Promise.resolve(m.getAllMethodNames(this._foreignModule))):new Promise((c,C)=>{T([i],D=>{this._foreignModule=D.create(S,o),c(m.getAllMethodNames(this._foreignModule))},C)})}fmr(i,o){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,o))}catch(h){return Promise.reject(h)}}}t.EditorSimpleWorker=v,v._diffLimit=1e5,v._suggestionsLimit=1e4;function n(r){return new v(r,null)}t.create=n,typeof importScripts=="function"&&(P.globals.monaco=f.createMonacoBaseAPI())});"use strict";(function(){var T;let t=self.MonacoEnvironment,M=t&&t.baseUrl?t.baseUrl:"../../../";const p=(T=self.trustedTypes)===null||T===void 0?void 0:T.createPolicy("amdLoader",{createScriptURL:s=>s});if(typeof self.define!="function"||!self.define.amd){let s=M+"vs/loader.js";p&&(s=p.createScriptURL(s)),importScripts(s)}require.config({baseUrl:M,catchError:!0,trustedTypesPolicy:p});let P=function(s){require([s],function(u){setTimeout(function(){let a=u.create((L,w)=>{self.postMessage(L,w)},null);for(self.onmessage=L=>a.onmessage(L.data);b.length>0;)self.onmessage(b.shift())},0)})},l=!0,b=[];self.onmessage=s=>{if(!l){b.push(s);return}l=!1,P(s.data)}})()}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/622cb03f7e070a9670c94bae1a45d78d7181fbd4/core/vs/base/worker/workerMain.js.map
