/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/path","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/uri","vs/base/common/async","vs/platform/environment/common/environment","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/network","vs/platform/log/common/log","vs/base/common/buffer","vs/base/common/types","vs/base/common/resources","vs/base/common/arrays","vs/base/common/strings","vs/platform/storage/common/storage","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/platform/userDataSync/common/userDataSync","vs/base/common/objects","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/json","vs/base/common/uuid","vs/base/parts/ipc/common/ipc","vs/base/common/map","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/extpath","fs","vs/platform/product/common/product","vs/platform/product/common/productService","vs/base/common/jsonEdit","os","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/process","child_process","vs/base/parts/sandbox/electron-sandbox/globals","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/stream","util","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/normalization","vs/base/node/decoder","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/node/spdlogService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/glob","vs/base/common/marshalling","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/paths","vs/base/node/extpath","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/common/ipc.net","vs/base/parts/request/browser/request","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/base/parts/ipc/electron-sandbox/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/workspaces/common/workspaces","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/localizations/node/localizations","crypto","vs/platform/log/common/bufferLog","vs/platform/log/common/fileLogService","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/code/electron-browser/sharedProcess/contrib/nodeCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/node/storageIpc","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/workspaces/common/workspaces","vs/platform/storage/node/storageService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/environment/node/environmentService","string_decoder","yauzl","yazl","net","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],te=function(G){for(var e=[],v=0,k=G.length;v<k;v++)e[v]=ee[G[v]];return e};define(ee[80],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(k,_){if(!k)throw new Error(_?`Assertion failed (${_})`:"Assertion Failed")}e.ok=v}),define(ee[62],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const v=Object.prototype.hasOwnProperty;function k(I){const f=[];for(let b in I)v.call(I,b)&&f.push(I[b]);return f}e.values=k;function _(I,f){for(let b in I)if(v.call(I,b)&&f({key:b,value:I[b]},function(){delete I[b]})===!1)return}e.forEach=_;function R(I,f){const b=Object.create(null);for(const C of I){const u=f(C);let D=b[u];D||(D=b[u]=[]),D.push(C)}return b}e.groupBy=R;function P(I){const f=Object.create(null);return I&&I.forEach((b,C)=>{f[C]=b}),f}e.fromMap=P;function L(I,f){const b=[],C=[];for(let u of I)f.has(u)||b.push(u);for(let u of f)I.has(u)||C.push(u);return{removed:b,added:C}}e.diffSets=L;function p(I,f){const b=[],C=[];for(let[u,D]of I)f.has(u)||b.push(D);for(let[u,D]of f)I.has(u)||C.push(D);return{removed:b,added:C}}e.diffMaps=p;class g{constructor(){this.map=new Map}add(f,b){let C=this.map.get(f);C||(C=new Set,this.map.set(f,C)),C.add(b)}delete(f,b){const C=this.map.get(f);!C||(C.delete(b),C.size===0&&this.map.delete(f))}forEach(f,b){const C=this.map.get(f);!C||C.forEach(b)}}e.SetMap=g}),define(ee[81],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function v(p){return(g,I,f)=>{let b=null,C=null;if(typeof f.value=="function"?(b="value",C=f.value):typeof f.get=="function"&&(b="get",C=f.get),!C)throw new Error("not supported");f[b]=p(C,I)}}e.createDecorator=v;let k=0;function _(){const p=`$memoize${k++}`;let g;const I=function(b,C,u){let D=null,S=null;if(typeof u.value=="function"?(D="value",S=u.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(D="get",S=u.get),!S)throw new Error("not supported");const w=`${p}:${C}`;u[D]=function(...m){return g=this,this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!0,enumerable:!1,writable:!0,value:S.apply(this,m)}),this[w]}};return I.clear=()=>{typeof g!="undefined"&&Object.getOwnPropertyNames(g).forEach(f=>{f.indexOf(p)===0&&delete g[f]})},I}e.createMemoizer=_;function R(p,g,I){return _()(p,g,I)}e.memoize=R;function P(p,g,I){return v((f,b)=>{const C=`$debounce$${b}`,u=`$debounce$result$${b}`;return function(...D){this[u]||(this[u]=I?I():void 0),clearTimeout(this[C]),g&&(this[u]=g(this[u],...D),D=[this[u]]),this[C]=setTimeout(()=>{f.apply(this,D),this[u]=I?I():void 0},p)}})}e.debounce=P;function L(p,g,I){return v((f,b)=>{const C=`$throttle$timer$${b}`,u=`$throttle$result$${b}`,D=`$throttle$lastRun$${b}`,S=`$throttle$pending$${b}`;return function(...w){if(this[u]||(this[u]=I?I():void 0),(this[D]===null||this[D]===void 0)&&(this[D]=-Number.MAX_VALUE),g&&(this[u]=g(this[u],...w)),!this[S]){const m=this[D]+p;m<=Date.now()?(this[D]=Date.now(),f.apply(this,[this[u]]),this[u]=I?I():void 0):(this[S]=!0,this[C]=setTimeout(()=>{this[S]=!1,this[D]=Date.now(),f.apply(this,[this[u]]),this[u]=I?I():void 0},m-Date.now()))}}})}e.throttle=L}),define(ee[13],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(l){setTimeout(()=>{throw l.stack?new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.listeners.push(l),()=>{this._removeListener(l)}}emit(l){this.listeners.forEach(o=>{o(l)})}_removeListener(l){this.listeners.splice(this.listeners.indexOf(l),1)}setUnexpectedErrorHandler(l){this.unexpectedErrorHandler=l}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(l){this.unexpectedErrorHandler(l),this.emit(l)}onUnexpectedExternalError(l){this.unexpectedErrorHandler(l)}}e.ErrorHandler=v,e.errorHandler=new v;function k(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=k;function _(m){p(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=_;function R(m){p(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=R;function P(m){if(m instanceof Error){let{name:l,message:o}=m;const s=m.stacktrace||m.stack;return{$isError:!0,name:l,message:o,stack:s}}return m}e.transformErrorForSerialization=P;const L="Canceled";function p(m){return m instanceof Error&&m.name===L&&m.message===L}e.isPromiseCanceledError=p;class g extends Error{constructor(){super(L);this.name=this.message}}e.CancellationError=g;function I(){const m=new Error(L);return m.name=m.message,m}e.canceled=I;function f(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=f;function b(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=b;function C(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=C;function u(m){const l=new Error(`${m} has been disposed`);return l.name="DISPOSED",l}e.disposed=u;function D(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=D;class S extends Error{constructor(l){super("NotImplemented");l&&(this.message=l)}}e.NotImplementedError=S;class w extends Error{constructor(l){super("NotSupported");l&&(this.message=l)}}e.NotSupportedError=w}),define(ee[19],te([0,1,13]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.mergeSort=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k($,T=0){return $[$.length-(1+T)]}e.tail=k;function _($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=_;function R($,T,U=(M,q)=>M===q){if($===T)return!0;if(!$||!T||$.length!==T.length)return!1;for(let M=0,q=$.length;M<q;M++)if(!U($[M],T[M]))return!1;return!0}e.equals=R;function P($,T,U){let M=0,q=$.length-1;for(;M<=q;){const H=(M+q)/2|0,X=U($[H],T);if(X<0)M=H+1;else if(X>0)q=H-1;else return H}return-(M+1)}e.binarySearch=P;function L($,T){let U=0,M=$.length;if(M===0)return 0;for(;U<M;){const q=Math.floor((U+M)/2);T($[q])?M=q:U=q+1}return U}e.findFirstInSorted=L;function p($,T,U){if($=$|0,$>=T.length)throw new TypeError("invalid index");let M=T[Math.floor(T.length*Math.random())],q=[],H=[],X=[];for(let Q of T){const Z=U(Q,M);Z<0?q.push(Q):Z>0?H.push(Q):X.push(Q)}return $<q.length?p($,q,U):$<q.length+X.length?X[0]:p($-(q.length+X.length),H,U)}e.quickSelect=p;function g($,T){return f($,T,0,$.length-1,[]),$}e.mergeSort=g;function I($,T,U,M,q,H){let X=U,Q=M+1;for(let Z=U;Z<=q;Z++)H[Z]=$[Z];for(let Z=U;Z<=q;Z++)X>M?$[Z]=H[Q++]:Q>q?$[Z]=H[X++]:T(H[Q],H[X])<0?$[Z]=H[Q++]:$[Z]=H[X++]}function f($,T,U,M,q){if(!(M<=U)){const H=U+(M-U)/2|0;f($,T,U,H,q),f($,T,H+1,M,q),!(T($[H],$[H+1])<=0)&&I($,T,U,H,M,q)}}function b($,T){const U=[];let M;for(const q of g($.slice(0),T))!M||T(M[0],q)!==0?(M=[q],U.push(M)):M.push(q);return U}e.groupBy=b;function C($,T,U){const M=[];function q(Q,Z,ne){if(!(Z===0&&ne.length===0)){const le=M[M.length-1];le&&le.start+le.deleteCount===Q?(le.deleteCount+=Z,le.toInsert.push(...ne)):M.push({start:Q,deleteCount:Z,toInsert:ne})}}let H=0,X=0;for(;;){if(H===$.length){q(H,0,T.slice(X));break}if(X===T.length){q(H,$.length-H,[]);break}const Q=$[H],Z=T[X],ne=U(Q,Z);ne===0?(H+=1,X+=1):ne<0?(q(H,1,[]),H+=1):ne>0&&(q(H,0,[Z]),X+=1)}return M}e.sortedDiff=C;function u($,T,U){const M=C($,T,U),q=[],H=[];for(const X of M)q.push(...$.slice(X.start,X.start+X.deleteCount)),H.push(...X.toInsert);return{removed:q,added:H}}e.delta=u;function D($,T,U){if(U===0)return[];const M=$.slice(0,U).sort(T);return w($,T,M,U,$.length),M}e.top=D;function S($,T,U,M,q){return U===0?Promise.resolve([]):new Promise((H,X)=>{(async()=>{const Q=$.length,Z=$.slice(0,U).sort(T);for(let ne=U,le=Math.min(U+M,Q);ne<Q;ne=le,le=Math.min(le+M,Q)){if(ne>U&&await new Promise(me=>setTimeout(me)),q&&q.isCancellationRequested)throw v.canceled();w($,T,Z,ne,le)}return Z})().then(H,X)})}e.topAsync=S;function w($,T,U,M,q){for(const H=U.length;M<q;M++){const X=$[M];if(T(X,U[H-1])<0){U.pop();const Q=L(U,Z=>T(X,Z)<0);U.splice(Q,0,X)}}}function m($){return $.filter(T=>!!T)}e.coalesce=m;function l($){let T=0;for(let U=0;U<$.length;U++)$[U]&&($[T]=$[U],T+=1);$.length=T}e.coalesceInPlace=l;function o($,T,U){$.splice(U,0,$.splice(T,1)[0])}e.move=o;function s($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=s;function t($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=t;function r($,T){if(!T)return $.filter((M,q)=>$.indexOf(M)===q);const U=Object.create(null);return $.filter(M=>{const q=T(M);return U[q]?!1:(U[q]=!0,!0)})}e.distinct=r;function i($){const T=new Set;return $.filter(U=>T.has(U)?!1:(T.add(U),!0))}e.distinctES6=i;function a($){const T=Object.create(null);return U=>{const M=$(U);return T[M]?!1:(T[M]=!0,!0)}}e.uniqueFilter=a;function n($,T){for(let U=$.length-1;U>=0;U--){const M=$[U];if(T(M))return U}return-1}e.lastIndex=n;function c($,T){return $.length>0?$[0]:T}e.firstOrDefault=c;function h($,T,U=(M,q)=>M===q){let M=0;for(let q=0,H=Math.min($.length,T.length);q<H&&U($[q],T[q]);q++)M++;return M}e.commonPrefixLength=h;function y($){return[].concat(...$)}e.flatten=y;function E($,T){let U=typeof T=="number"?$:0;typeof T=="number"?U=$:(U=0,T=$);const M=[];if(U<=T)for(let q=U;q<T;q++)M.push(q);else for(let q=U;q>T;q--)M.push(q);return M}e.range=E;function d($,T,U){return $.reduce((M,q)=>(M[T(q)]=U?U(q):q,M),Object.create(null))}e.index=d;function O($,T){return $.push(T),()=>A($,T)}e.insert=O;function A($,T){const U=$.indexOf(T);if(U>-1)return $.splice(U,1),T}e.remove=A;function j($,T,U){const M=$.slice(0,T),q=$.slice(T);return M.concat(U,q)}e.arrayInsert=j;function z($,T){let U;if(typeof T=="number"){let M=T;U=()=>{const q=Math.sin(M++)*179426549;return q-Math.floor(q)}}else U=Math.random;for(let M=$.length-1;M>0;M-=1){const q=Math.floor(U()*(M+1)),H=$[M];$[M]=$[q],$[q]=H}}e.shuffle=z;function W($,T){const U=$.indexOf(T);U>-1&&($.splice(U,1),$.unshift(T))}e.pushToStart=W;function N($,T){const U=$.indexOf(T);U>-1&&($.splice(U,1),$.push(T))}e.pushToEnd=N;function x($,T){return Array.isArray($)?$.map(T):T($)}e.mapArrayOrNot=x;function F($){return Array.isArray($)?$:[$]}e.asArray=F;function B($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=B;function K($,T){for(const U of $){const M=T(U);if(M!==void 0)return M}}e.mapFind=K}),define(ee[63],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(k){const _=this;let R=!1,P;return function(){return R||(R=!0,P=k.apply(_,arguments)),P}}e.once=v}),define(ee[51],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(k){function _(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}k.is=_;const R=Object.freeze([]);function P(){return R}k.empty=P;function*L(m){yield m}k.single=L;function p(m){return m||R}k.from=p;function g(m){return!m||m[Symbol.iterator]().next().done===!0}k.isEmpty=g;function I(m){return m[Symbol.iterator]().next().value}k.first=I;function f(m,l){for(const o of m)if(l(o))return!0;return!1}k.some=f;function*b(m,l){for(const o of m)l(o)&&(yield o)}k.filter=b;function*C(m,l){for(const o of m)yield l(o)}k.map=C;function*u(...m){for(const l of m)for(const o of l)yield o}k.concat=u;function*D(m){for(const l of m)for(const o of l)yield o}k.concatNested=D;function*S(m,l,o=m.length){for(l<0&&(l+=m.length),o<0?o+=m.length:o>m.length&&(o=m.length);l<o;l++)yield m[l]}k.slice=S;function w(m,l=Number.POSITIVE_INFINITY){const o=[];if(l===0)return[o,m];const s=m[Symbol.iterator]();for(let t=0;t<l;t++){const r=s.next();if(r.done)return[o,k.empty()];o.push(r.value)}return[o,{[Symbol.iterator](){return s}}]}k.consume=w})(v=e.Iterable||(e.Iterable={}))}),define(ee[29],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var _;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(_=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function P(t,r=!1){let i=0,a=t.length,n="",c=0,h=16,y=0;function E(N){let x=0,F=0;for(;x<N;){const B=t.charCodeAt(i);if(B>=48&&B<=57)F=F*16+B-48;else if(B>=65&&B<=70)F=F*16+B-65+10;else if(B>=97&&B<=102)F=F*16+B-97+10;else break;i++,x++}return x<N&&(F=-1),F}function d(N){i=N,n="",c=0,h=16,y=0}function O(){const N=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&g(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&g(t.charCodeAt(i)))for(i++;i<t.length&&g(t.charCodeAt(i));)i++;else return y=3,t.substring(N,i);let x=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&g(t.charCodeAt(i))){for(i++;i<t.length&&g(t.charCodeAt(i));)i++;x=i}else y=3;return t.substring(N,x)}function A(){let N="",x=i;for(;;){if(i>=a){N+=t.substring(x,i),y=2;break}const F=t.charCodeAt(i);if(F===34){N+=t.substring(x,i),i++;break}if(F===92){if(N+=t.substring(x,i),i++,i>=a){y=2;break}switch(t.charCodeAt(i++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:const K=E(4);K>=0?N+=String.fromCharCode(K):y=4;break;default:y=5}x=i;continue}if(F>=0&&F<=31)if(p(F)){N+=t.substring(x,i),y=2;break}else y=6;i++}return N}function j(){if(n="",y=0,c=i,i>=a)return c=a,h=17;let N=t.charCodeAt(i);if(L(N)){do i++,n+=String.fromCharCode(N),N=t.charCodeAt(i);while(L(N));return h=15}if(p(N))return i++,n+=String.fromCharCode(N),N===13&&t.charCodeAt(i)===10&&(i++,n+=`
`),h=14;switch(N){case 123:return i++,h=1;case 125:return i++,h=2;case 91:return i++,h=3;case 93:return i++,h=4;case 58:return i++,h=6;case 44:return i++,h=5;case 34:return i++,n=A(),h=10;case 47:const x=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<a&&!p(t.charCodeAt(i));)i++;return n=t.substring(x,i),h=12}if(t.charCodeAt(i+1)===42){i+=2;const F=a-1;let B=!1;for(;i<F;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,B=!0;break}i++}return B||(i++,y=1),n=t.substring(x,i),h=13}return n+=String.fromCharCode(N),i++,h=16;case 45:if(n+=String.fromCharCode(N),i++,i===a||!g(t.charCodeAt(i)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=O(),h=11;default:for(;i<a&&z(N);)i++,N=t.charCodeAt(i);if(c!==i){switch(n=t.substring(c,i),n){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return n+=String.fromCharCode(N),i++,h=16}}function z(N){if(L(N)||p(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let N;do N=j();while(N>=12&&N<=15);return N}return{setPosition:d,getPosition:()=>i,scan:r?W:j,getToken:()=>h,getTokenValue:()=>n,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>y}}e.createScanner=P;function L(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function f(t,r){const i=[],a=new Object;let n;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function y(E,d,O,A){c.value=E,c.offset=d,c.length=O,c.type=A,c.colonOffset=void 0,n=c}try{l(t,{onObjectBegin:(E,d)=>{if(r<=E)throw a;n=void 0,h=r>E,i.push("")},onObjectProperty:(E,d,O)=>{if(r<d||(y(E,d,O,"property"),i[i.length-1]=E,r<=d+O))throw a},onObjectEnd:(E,d)=>{if(r<=E)throw a;n=void 0,i.pop()},onArrayBegin:(E,d)=>{if(r<=E)throw a;n=void 0,i.push(0)},onArrayEnd:(E,d)=>{if(r<=E)throw a;n=void 0,i.pop()},onLiteralValue:(E,d,O)=>{if(r<d||(y(E,d,O,s(E)),r<=d+O))throw a},onSeparator:(E,d,O)=>{if(r<=d)throw a;if(E===":"&&n&&n.type==="property")n.colonOffset=d,h=!1,n=void 0;else if(E===","){const A=i[i.length-1];typeof A=="number"?i[i.length-1]=A+1:(h=!0,i[i.length-1]=""),n=void 0}}})}catch(E){if(E!==a)throw E}return{path:i,previousNode:n,isAtPropertyKey:h,matches:E=>{let d=0;for(let O=0;d<E.length&&O<i.length;O++)if(E[d]===i[O]||E[d]==="*")d++;else if(E[d]!=="**")return!1;return d===E.length}}}e.getLocation=f;function b(t,r=[],i=R.DEFAULT){let a=null,n=[];const c=[];function h(E){Array.isArray(n)?n.push(E):a!==null&&(n[a]=E)}return l(t,{onObjectBegin:()=>{const E={};h(E),c.push(n),n=E,a=null},onObjectProperty:E=>{a=E},onObjectEnd:()=>{n=c.pop()},onArrayBegin:()=>{const E=[];h(E),c.push(n),n=E,a=null},onArrayEnd:()=>{n=c.pop()},onLiteralValue:h,onError:(E,d,O)=>{r.push({error:E,offset:d,length:O})}},i),n[0]}e.parse=b;function C(t,r=[],i=R.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(E){a.type==="property"&&(a.length=E-a.offset,a=a.parent)}function c(E){return a.children.push(E),E}l(t,{onObjectBegin:E=>{a=c({type:"object",offset:E,length:-1,parent:a,children:[]})},onObjectProperty:(E,d,O)=>{a=c({type:"property",offset:d,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:E,offset:d,length:O,parent:a})},onObjectEnd:(E,d)=>{a.length=E+d-a.offset,a=a.parent,n(E+d)},onArrayBegin:(E,d)=>{a=c({type:"array",offset:E,length:-1,parent:a,children:[]})},onArrayEnd:(E,d)=>{a.length=E+d-a.offset,a=a.parent,n(E+d)},onLiteralValue:(E,d,O)=>{c({type:s(E),offset:d,length:O,parent:a,value:E}),n(d+O)},onSeparator:(E,d,O)=>{a.type==="property"&&(E===":"?a.colonOffset=d:E===","&&n(d))},onError:(E,d,O)=>{r.push({error:E,offset:d,length:O})}},i);const y=a.children[0];return y&&delete y.parent,y}e.parseTree=C;function u(t,r){if(!!t){let i=t;for(let a of r)if(typeof a=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let n=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===a){i=c.children[1],n=!0;break}if(!n)return}else{const n=a;if(i.type!=="array"||n<0||!Array.isArray(i.children)||n>=i.children.length)return;i=i.children[n]}return i}}e.findNodeAtLocation=u;function D(t){if(!t.parent||!t.parent.children)return[];const r=D(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=D;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const r=Object.create(null);for(let i of t.children){const a=i.children[1];a&&(r[i.children[0].value]=S(a))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function w(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=w;function m(t,r,i=!1){if(w(t,r,i)){const a=t.children;if(Array.isArray(a))for(let n=0;n<a.length&&a[n].offset<=r;n++){const c=m(a[n],r,i);if(c)return c}return t}}e.findNodeAtOffset=m;function l(t,r,i=R.DEFAULT){const a=P(t,!1);function n(H){return H?()=>H(a.getTokenOffset(),a.getTokenLength()):()=>!0}function c(H){return H?X=>H(X,a.getTokenOffset(),a.getTokenLength()):()=>!0}const h=n(r.onObjectBegin),y=c(r.onObjectProperty),E=n(r.onObjectEnd),d=n(r.onArrayBegin),O=n(r.onArrayEnd),A=c(r.onLiteralValue),j=c(r.onSeparator),z=n(r.onComment),W=c(r.onError),N=i&&i.disallowComments,x=i&&i.allowTrailingComma;function F(){for(;;){const H=a.scan();switch(a.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:N||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(H){case 12:case 13:N?B(10):z();break;case 16:B(1);break;case 15:case 14:break;default:return H}}}function B(H,X=[],Q=[]){if(W(H),X.length+Q.length>0){let Z=a.getToken();for(;Z!==17;){if(X.indexOf(Z)!==-1){F();break}else if(Q.indexOf(Z)!==-1)break;Z=F()}}}function K(H){const X=a.getTokenValue();return H?A(X):y(X),F(),!0}function $(){switch(a.getToken()){case 11:let H=0;try{H=JSON.parse(a.getTokenValue()),typeof H!="number"&&(B(2),H=0)}catch(X){B(2)}A(H);break;case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return F(),!0}function T(){return a.getToken()!==10?(B(3,[],[2,5]),!1):(K(!1),a.getToken()===6?(j(":"),F(),q()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function U(){h(),F();let H=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(H||B(4,[],[]),j(","),F(),a.getToken()===2&&x)break}else H&&B(6,[],[]);T()||B(4,[],[2,5]),H=!0}return E(),a.getToken()!==2?B(7,[2],[]):F(),!0}function M(){d(),F();let H=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(H||B(4,[],[]),j(","),F(),a.getToken()===4&&x)break}else H&&B(6,[],[]);q()||B(4,[],[4,5]),H=!0}return O(),a.getToken()!==4?B(8,[4],[]):F(),!0}function q(){switch(a.getToken()){case 3:return M();case 1:return U();case 10:return K(!0);default:return $()}}return F(),a.getToken()===17?i.allowEmptyContent?!0:(B(4,[],[]),!1):q()?(a.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=l;function o(t,r){let i=P(t),a=[],n,c=0,h;do switch(h=i.getPosition(),n=i.scan(),n){case 12:case 13:case 17:c!==h&&a.push(t.substring(c,h)),r!==void 0&&a.push(i.getTokenValue().replace(/[^\r\n]/g,r)),c=i.getPosition();break}while(n!==17);return a.join("")}e.stripComments=o;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),define(ee[45],te([0,1,29]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(p,g,I){let f,b,C,u,D;if(g){for(u=g.offset,D=u+g.length,C=u;C>0&&!L(p,C-1);)C--;let c=D;for(;c<p.length&&!L(p,c);)c++;b=p.substring(C,c),f=R(b,I)}else b=p,f=0,C=0,u=0,D=p.length;const S=P(I,p);let w=!1,m=0,l;I.insertSpaces?l=_(" ",I.tabSize||4):l="	";const o=v.createScanner(b,!1);let s=!1;function t(){return S+_(l,f+m)}function r(){let c=o.scan();for(w=!1;c===15||c===14;)w=w||c===14,c=o.scan();return s=c===16||o.getTokenError()!==0,c}const i=[];function a(c,h,y){!s&&h<D&&y>u&&p.substring(h,y)!==c&&i.push({offset:h,length:y-h,content:c})}let n=r();if(n!==17){const c=o.getTokenOffset()+C,h=_(l,f);a(h,C,c)}for(;n!==17;){let c=o.getTokenOffset()+o.getTokenLength()+C,h=r(),y="";for(;!w&&(h===12||h===13);){const d=o.getTokenOffset()+C;a(" ",c,d),c=o.getTokenOffset()+o.getTokenLength()+C,y=h===12?t():"",h=r()}if(h===2)n!==1&&(m--,y=t());else if(h===4)n!==3&&(m--,y=t());else{switch(n){case 3:case 1:m++,y=t();break;case 5:case 12:y=t();break;case 13:w?y=t():y=" ";break;case 6:y=" ";break;case 10:if(h===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?y=" ":h!==5&&h!==17&&(s=!0);break;case 16:s=!0;break}w&&(h===12||h===13)&&(y=t())}const E=o.getTokenOffset()+C;a(y,c,E),n=h}return i}e.format=k;function _(p,g){let I="";for(let f=0;f<g;f++)I+=p;return I}function R(p,g){let I=0,f=0;const b=g.tabSize||4;for(;I<p.length;){const C=p.charAt(I);if(C===" ")f++;else if(C==="	")f+=b;else break;I++}return Math.floor(f/b)}function P(p,g){for(let I=0;I<g.length;I++){const f=g.charAt(I);if(f==="\r")return I+1<g.length&&g.charAt(I+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return p&&p.eol||`
`}e.getEOL=P;function L(p,g){return`\r
`.indexOf(p.charAt(g))!==-1}e.isEOL=L}),define(ee[39],te([0,1,29,45,19]),function(G,e,v,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(I,f,b){return P(I,f,void 0,b)}e.removeProperty=R;function P(I,f,b,C,u){const D=f.slice(),S=[],w=v.parseTree(I,S);let m,l;for(;D.length>0&&(l=D.pop(),m=v.findNodeAtLocation(w,D),m===void 0&&b!==void 0);)typeof l=="string"?b={[l]:b}:b=[b];if(m)if(m.type==="object"&&typeof l=="string"&&Array.isArray(m.children)){const o=v.findNodeAtLocation(m,[l]);if(o!==void 0)if(b===void 0){if(!o.parent)throw new Error("Malformed AST");const s=m.children.indexOf(o.parent);let t,r=o.parent.offset+o.parent.length;if(s>0){const i=m.children[s-1];t=i.offset+i.length}else t=m.offset+1,m.children.length>1&&(r=m.children[1].offset);return L(I,{offset:t,length:r-t,content:""},C)}else return L(I,{offset:o.offset,length:o.length,content:JSON.stringify(b)},C);else{if(b===void 0)return[];const s=`${JSON.stringify(l)}: ${JSON.stringify(b)}`,t=u?u(m.children.map(i=>i.children[0].value)):m.children.length;let r;if(t>0){const i=m.children[t-1];r={offset:i.offset+i.length,length:0,content:","+s}}else m.children.length===0?r={offset:m.offset+1,length:0,content:s}:r={offset:m.offset+1,length:0,content:s+","};return L(I,r,C)}}else if(m.type==="array"&&typeof l=="number"&&Array.isArray(m.children))if(b!==void 0){const o=`${JSON.stringify(b)}`;let s;if(m.children.length===0||l===0)s={offset:m.offset+1,length:0,content:m.children.length===0?o:o+","};else{const t=l===-1||l>m.children.length?m.children.length:l,r=m.children[t-1];s={offset:r.offset+r.length,length:0,content:","+o}}return L(I,s,C)}else{const o=l,s=m.children[o];let t;if(m.children.length===1)t={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===o){const r=m.children[o-1],i=r.offset+r.length,a=m.offset+m.length;t={offset:i,length:a-2-i,content:""}}else t={offset:s.offset,length:m.children[o+1].offset-s.offset,content:""};return L(I,t,C)}else throw new Error(`Can not add ${typeof l!="number"?"index":"property"} to parent of type ${m.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return L(I,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(b)},C)}}e.setProperty=P;function L(I,f,b){let C=p(I,f),u=f.offset,D=f.offset+f.content.length;if(f.length===0||f.content.length===0){for(;u>0&&!k.isEOL(C,u-1);)u--;for(;D<C.length&&!k.isEOL(C,D);)D++}const S=k.format(C,{offset:u,length:D-u},b);for(let m=S.length-1;m>=0;m--){const l=S[m];C=p(C,l),u=Math.min(u,l.offset),D=Math.max(D,l.offset+l.length),D+=l.content.length-l.length}const w=I.length-(C.length-D)-u;return[{offset:u,length:w,content:C.substring(u,D)}]}e.withFormatting=L;function p(I,f){return I.substring(0,f.offset)+f.content+I.substring(f.offset+f.length)}e.applyEdit=p;function g(I,f){let b=_.mergeSort(f,(u,D)=>{const S=u.offset-D.offset;return S===0?u.length-D.length:S}),C=I.length;for(let u=b.length-1;u>=0;u--){let D=b[u];if(D.offset+D.length<=C)I=p(I,D);else throw new Error("Overlapping edit");C=D.offset}return I}e.applyEdits=g}),define(ee[2],te([0,1,63,51]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const _=!1;let R=null;function P(l){R=l}if(e.setDisposableTracker=P,_){const l="__is_disposable_tracked__";R=new class{trackDisposable(o){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[l]||console.log(s)},3e3)}markTracked(o){if(o&&o!==D.None)try{o[l]=!0}catch(s){}}}}function L(l){!R||R.markTracked(l)}function p(l){return R&&R.trackDisposable(l),l}e.trackDisposable=p;class g extends Error{constructor(o){super(`Encounter errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=g;function I(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=I;function f(l){if(k.Iterable.is(l)){let o=[];for(const s of l)if(s){L(s);try{s.dispose()}catch(t){o.push(t)}}if(o.length===1)throw o[0];if(o.length>1)throw new g(o);return Array.isArray(l)?[]:l}else if(l)return L(l),l.dispose(),l}e.dispose=f;function b(...l){return l.forEach(L),C(()=>f(l))}e.combinedDisposable=b;function C(l){const o=p({dispose:()=>{L(o),l()}});return o}e.toDisposable=C;class u{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(L(this),this._isDisposed=!0,this.clear())}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return L(o),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class D{constructor(){this._store=new u,p(this)}dispose(){L(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=D,D.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,p(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value&&this._value.dispose(),o&&L(o),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,L(this),this._value&&this._value.dispose(),this._value=void 0}}e.MutableDisposable=S;class w{constructor(){this.references=new Map}acquire(o,...s){let t=this.references.get(o);t||(t={counter:0,object:this.createReferencedObject(o,...s)},this.references.set(o,t));const{object:r}=t,i=v.once(()=>{--t.counter==0&&(this.destroyReferencedObject(o,t.object),this.references.delete(o))});return t.counter++,{object:r,dispose:i}}}e.ReferenceCollection=w;class m{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=m}),define(ee[82],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(R){this.element=R,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class k{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,P){const L=new v(R);if(this._first===v.Undefined)this._first=L,this._last=L;else if(P){const g=this._last;this._last=L,L.prev=g,g.next=L}else{const g=this._first;this._first=L,L.next=g,g.prev=L}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(L))}}shift(){if(this._first!==v.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==v.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==v.Undefined&&R.next!==v.Undefined){const P=R.prev;P.next=R.next,R.next.prev=P}else R.prev===v.Undefined&&R.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):R.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):R.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==v.Undefined;)yield R.element,R=R.next}}e.LinkedList=k});"use strict";function Ke(G){const e=[];typeof G=="number"&&e.push("code/timeOrigin",G);function v(_){e.push(_,Date.now())}function k(){const _=[];for(let R=0;R<e.length;R+=2)_.push({name:e[R],startTime:e[R+1]});return _}return{mark:v,getMarks:k}}function ot(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Ke():{mark(G){performance.mark(G)},getMarks(){let G=performance.timeOrigin;typeof G!="number"&&(G=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const e=[{name:"code/timeOrigin",startTime:Math.round(G)}];for(const v of performance.getEntriesByType("mark"))e.push({name:v.name,startTime:Math.round(G+v.startTime)});return e}};if(typeof process=="object"){const G=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Ke(G)}else return console.trace("perf-util loaded in UNKNOWN environment"),Ke()}function Ye(G){return G.MonacoPerformanceMarks||(G.MonacoPerformanceMarks=ot()),G.MonacoPerformanceMarks}var ze;typeof global=="object"?ze=global:typeof self=="object"?ze=self:ze={},typeof define=="function"?define("vs/base/common/performance",[],function(){return Ye(ze)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=Ye(ze):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),ze.perf=Ye(ze)),define(ee[6],te([0,1]),function(G,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.globals=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=void 0;const k="en";let _=!1,R=!1,P=!1,L=!1,p=!1,g=!1,I=!1,f,b=k,C,u;const D=typeof self=="object"?self:typeof global=="object"?global:{};let S;typeof process!="undefined"?S=process:typeof D.vscode!="undefined"&&(S=D.vscode.process);const w=typeof((v=S==null?void 0:S.versions)===null||v===void 0?void 0:v.electron)=="string"&&S.type==="renderer";if(e.isElectronSandboxed=w&&(S==null?void 0:S.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const n=S==null?void 0:S.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof n=="string")return n==="none"||n==="code"||n==="bypassHeatCheck"||n==="bypassHeatCheckAndEagerCompile"?n:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!w)u=navigator.userAgent,_=u.indexOf("Windows")>=0,R=u.indexOf("Macintosh")>=0,I=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=u.indexOf("Linux")>=0,g=!0,f=navigator.language,b=f;else if(typeof S=="object"){_=S.platform==="win32",R=S.platform==="darwin",P=S.platform==="linux",L=P&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,f=k,b=k;const n=S.env.VSCODE_NLS_CONFIG;if(n)try{const c=JSON.parse(n),h=c.availableLanguages["*"];f=c.locale,b=h||k,C=c._translationsConfigFile}catch(c){}p=!0}else console.error("Unable to resolve platform.");var m;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function l(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let o=0;R?o=1:_?o=3:P&&(o=2),e.isWindows=_,e.isMacintosh=R,e.isLinux=P,e.isLinuxSnap=L,e.isNative=p,e.isWeb=g,e.isIOS=I,e.platform=o,e.userAgent=u,e.language=b;var s;(function(n){function c(){return e.language}n.value=c;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=h;function y(){return e.language==="en"}n.isDefault=y})(s=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=C,e.globals=D,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let h=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeSetImmediateId)for(let d=0,O=h.length;d<O;d++){const A=h[d];if(A.id===E.data.vscodeSetImmediateId){h.splice(d,1),A.callback();return}}});let y=0;return E=>{const d=++y;h.push({id:d,callback:E}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(S)return S.nextTick.bind(S);const c=Promise.resolve();return h=>c.then(h)}();var t;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||I?2:_?1:3;let r=!0,i=!1;function a(){if(!i){i=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,r=new Uint16Array(n.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=a}),define(ee[46],te([0,1,6]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let k;typeof process!="undefined"?k=process:typeof v.globals.vscode!="undefined"?k={get platform(){return v.globals.vscode.process.platform},get env(){return v.globals.vscode.process.env},nextTick(_){return v.setImmediate(_)},cwd(){return v.globals.vscode.process.env.VSCODE_CWD||v.globals.vscode.process.execPath.substr(0,v.globals.vscode.process.execPath.lastIndexOf(v.globals.vscode.process.platform==="win32"?"\\":"/"))}}:k={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(_){return v.setImmediate(_)},get env(){return Object.create(null)},cwd(){return"/"}},e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick}),define(ee[4],te([0,1,46]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,_=97,R=90,P=122,L=46,p=47,g=92,I=58,f=63;class b extends Error{constructor(o,s,t){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const i=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${i} ${r} of type ${s}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function C(l,o){if(typeof l!="string")throw new b(o,"string",l)}function u(l){return l===p||l===g}function D(l){return l===p}function S(l){return l>=k&&l<=R||l>=_&&l<=P}function w(l,o,s,t){let r="",i=0,a=-1,n=0,c=0;for(let h=0;h<=l.length;++h){if(h<l.length)c=l.charCodeAt(h);else{if(t(c))break;c=p}if(t(c)){if(!(a===h-1||n===1))if(n===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==L||r.charCodeAt(r.length-2)!==L){if(r.length>2){const y=r.lastIndexOf(s);y===-1?(r="",i=0):(r=r.slice(0,y),i=r.length-1-r.lastIndexOf(s)),a=h,n=0;continue}else if(r.length!==0){r="",i=0,a=h,n=0;continue}}o&&(r+=r.length>0?`${s}..`:"..",i=2)}else r.length>0?r+=`${s}${l.slice(a+1,h)}`:r=l.slice(a+1,h),i=h-a-1;a=h,n=0}else c===L&&n!==-1?++n:n=-1}return r}function m(l,o){if(o===null||typeof o!="object")throw new b("pathObject","Object",o);const s=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${t}`:`${s}${l}${t}`:t}e.win32={resolve(...l){let o="",s="",t=!1;for(let r=l.length-1;r>=-1;r--){let i;if(r>=0){if(i=l[r],C(i,"path"),i.length===0)continue}else o.length===0?i=v.cwd():(i=v.env[`=${o}`]||v.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==o.toLowerCase()&&i.charCodeAt(2)===g)&&(i=`${o}\\`));const a=i.length;let n=0,c="",h=!1;const y=i.charCodeAt(0);if(a===1)u(y)&&(n=1,h=!0);else if(u(y))if(h=!0,u(i.charCodeAt(1))){let E=2,d=E;for(;E<a&&!u(i.charCodeAt(E));)E++;if(E<a&&E!==d){const O=i.slice(d,E);for(d=E;E<a&&u(i.charCodeAt(E));)E++;if(E<a&&E!==d){for(d=E;E<a&&!u(i.charCodeAt(E));)E++;(E===a||E!==d)&&(c=`\\\\${O}\\${i.slice(d,E)}`,n=E)}}}else n=1;else S(y)&&i.charCodeAt(1)===I&&(c=i.slice(0,2),n=2,a>2&&u(i.charCodeAt(2))&&(h=!0,n=3));if(c.length>0)if(o.length>0){if(c.toLowerCase()!==o.toLowerCase())continue}else o=c;if(t){if(o.length>0)break}else if(s=`${i.slice(n)}\\${s}`,t=h,h&&o.length>0)break}return s=w(s,!t,"\\",u),t?`${o}\\${s}`:`${o}${s}`||"."},normalize(l){C(l,"path");const o=l.length;if(o===0)return".";let s=0,t,r=!1;const i=l.charCodeAt(0);if(o===1)return D(i)?"\\":l;if(u(i))if(r=!0,u(l.charCodeAt(1))){let n=2,c=n;for(;n<o&&!u(l.charCodeAt(n));)n++;if(n<o&&n!==c){const h=l.slice(c,n);for(c=n;n<o&&u(l.charCodeAt(n));)n++;if(n<o&&n!==c){for(c=n;n<o&&!u(l.charCodeAt(n));)n++;if(n===o)return`\\\\${h}\\${l.slice(c)}\\`;n!==c&&(t=`\\\\${h}\\${l.slice(c,n)}`,s=n)}}}else s=1;else S(i)&&l.charCodeAt(1)===I&&(t=l.slice(0,2),s=2,o>2&&u(l.charCodeAt(2))&&(r=!0,s=3));let a=s<o?w(l.slice(s),!r,"\\",u):"";return a.length===0&&!r&&(a="."),a.length>0&&u(l.charCodeAt(o-1))&&(a+="\\"),t===void 0?r?`\\${a}`:a:r?`${t}\\${a}`:`${t}${a}`},isAbsolute(l){C(l,"path");const o=l.length;if(o===0)return!1;const s=l.charCodeAt(0);return u(s)||o>2&&S(s)&&l.charCodeAt(1)===I&&u(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let o,s;for(let i=0;i<l.length;++i){const a=l[i];C(a,"path"),a.length>0&&(o===void 0?o=s=a:o+=`\\${a}`)}if(o===void 0)return".";let t=!0,r=0;if(typeof s=="string"&&u(s.charCodeAt(0))){++r;const i=s.length;i>1&&u(s.charCodeAt(1))&&(++r,i>2&&(u(s.charCodeAt(2))?++r:t=!1))}if(t){for(;r<o.length&&u(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(l,o){if(C(l,"from"),C(o,"to"),l===o)return"";const s=e.win32.resolve(l),t=e.win32.resolve(o);if(s===t||(l=s.toLowerCase(),o=t.toLowerCase(),l===o))return"";let r=0;for(;r<l.length&&l.charCodeAt(r)===g;)r++;let i=l.length;for(;i-1>r&&l.charCodeAt(i-1)===g;)i--;const a=i-r;let n=0;for(;n<o.length&&o.charCodeAt(n)===g;)n++;let c=o.length;for(;c-1>n&&o.charCodeAt(c-1)===g;)c--;const h=c-n,y=a<h?a:h;let E=-1,d=0;for(;d<y;d++){const A=l.charCodeAt(r+d);if(A!==o.charCodeAt(n+d))break;A===g&&(E=d)}if(d!==y){if(E===-1)return t}else{if(h>y){if(o.charCodeAt(n+d)===g)return t.slice(n+d+1);if(d===2)return t.slice(n+d)}a>y&&(l.charCodeAt(r+d)===g?E=d:d===2&&(E=3)),E===-1&&(E=0)}let O="";for(d=r+E+1;d<=i;++d)(d===i||l.charCodeAt(d)===g)&&(O+=O.length===0?"..":"\\..");return n+=E,O.length>0?`${O}${t.slice(n,c)}`:(t.charCodeAt(n)===g&&++n,t.slice(n,c))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const o=e.win32.resolve(l);if(o.length<=2)return l;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const s=o.charCodeAt(2);if(s!==f&&s!==L)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(S(o.charCodeAt(0))&&o.charCodeAt(1)===I&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return l},dirname(l){C(l,"path");const o=l.length;if(o===0)return".";let s=-1,t=0;const r=l.charCodeAt(0);if(o===1)return u(r)?l:".";if(u(r)){if(s=t=1,u(l.charCodeAt(1))){let n=2,c=n;for(;n<o&&!u(l.charCodeAt(n));)n++;if(n<o&&n!==c){for(c=n;n<o&&u(l.charCodeAt(n));)n++;if(n<o&&n!==c){for(c=n;n<o&&!u(l.charCodeAt(n));)n++;if(n===o)return l;n!==c&&(s=t=n+1)}}}}else S(r)&&l.charCodeAt(1)===I&&(s=o>2&&u(l.charCodeAt(2))?3:2,t=s);let i=-1,a=!0;for(let n=o-1;n>=t;--n)if(u(l.charCodeAt(n))){if(!a){i=n;break}}else a=!1;if(i===-1){if(s===-1)return".";i=s}return l.slice(0,i)},basename(l,o){o!==void 0&&C(o,"ext"),C(l,"path");let s=0,t=-1,r=!0,i;if(l.length>=2&&S(l.charCodeAt(0))&&l.charCodeAt(1)===I&&(s=2),o!==void 0&&o.length>0&&o.length<=l.length){if(o===l)return"";let a=o.length-1,n=-1;for(i=l.length-1;i>=s;--i){const c=l.charCodeAt(i);if(u(c)){if(!r){s=i+1;break}}else n===-1&&(r=!1,n=i+1),a>=0&&(c===o.charCodeAt(a)?--a==-1&&(t=i):(a=-1,t=n))}return s===t?t=n:t===-1&&(t=l.length),l.slice(s,t)}for(i=l.length-1;i>=s;--i)if(u(l.charCodeAt(i))){if(!r){s=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":l.slice(s,t)},extname(l){C(l,"path");let o=0,s=-1,t=0,r=-1,i=!0,a=0;l.length>=2&&l.charCodeAt(1)===I&&S(l.charCodeAt(0))&&(o=t=2);for(let n=l.length-1;n>=o;--n){const c=l.charCodeAt(n);if(u(c)){if(!i){t=n+1;break}continue}r===-1&&(i=!1,r=n+1),c===L?s===-1?s=n:a!==1&&(a=1):s!==-1&&(a=-1)}return s===-1||r===-1||a===0||a===1&&s===r-1&&s===t+1?"":l.slice(s,r)},format:m.bind(null,"\\"),parse(l){C(l,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return o;const s=l.length;let t=0,r=l.charCodeAt(0);if(s===1)return u(r)?(o.root=o.dir=l,o):(o.base=o.name=l,o);if(u(r)){if(t=1,u(l.charCodeAt(1))){let E=2,d=E;for(;E<s&&!u(l.charCodeAt(E));)E++;if(E<s&&E!==d){for(d=E;E<s&&u(l.charCodeAt(E));)E++;if(E<s&&E!==d){for(d=E;E<s&&!u(l.charCodeAt(E));)E++;E===s?t=E:E!==d&&(t=E+1)}}}}else if(S(r)&&l.charCodeAt(1)===I){if(s<=2)return o.root=o.dir=l,o;if(t=2,u(l.charCodeAt(2))){if(s===3)return o.root=o.dir=l,o;t=3}}t>0&&(o.root=l.slice(0,t));let i=-1,a=t,n=-1,c=!0,h=l.length-1,y=0;for(;h>=t;--h){if(r=l.charCodeAt(h),u(r)){if(!c){a=h+1;break}continue}n===-1&&(c=!1,n=h+1),r===L?i===-1?i=h:y!==1&&(y=1):i!==-1&&(y=-1)}return n!==-1&&(i===-1||y===0||y===1&&i===n-1&&i===a+1?o.base=o.name=l.slice(a,n):(o.name=l.slice(a,i),o.base=l.slice(a,n),o.ext=l.slice(i,n))),a>0&&a!==t?o.dir=l.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let o="",s=!1;for(let t=l.length-1;t>=-1&&!s;t--){const r=t>=0?l[t]:v.cwd();C(r,"path"),r.length!==0&&(o=`${r}/${o}`,s=r.charCodeAt(0)===p)}return o=w(o,!s,"/",D),s?`/${o}`:o.length>0?o:"."},normalize(l){if(C(l,"path"),l.length===0)return".";const o=l.charCodeAt(0)===p,s=l.charCodeAt(l.length-1)===p;return l=w(l,!o,"/",D),l.length===0?o?"/":s?"./":".":(s&&(l+="/"),o?`/${l}`:l)},isAbsolute(l){return C(l,"path"),l.length>0&&l.charCodeAt(0)===p},join(...l){if(l.length===0)return".";let o;for(let s=0;s<l.length;++s){const t=l[s];C(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(l,o){if(C(l,"from"),C(o,"to"),l===o||(l=e.posix.resolve(l),o=e.posix.resolve(o),l===o))return"";const s=1,t=l.length,r=t-s,i=1,a=o.length-i,n=r<a?r:a;let c=-1,h=0;for(;h<n;h++){const E=l.charCodeAt(s+h);if(E!==o.charCodeAt(i+h))break;E===p&&(c=h)}if(h===n)if(a>n){if(o.charCodeAt(i+h)===p)return o.slice(i+h+1);if(h===0)return o.slice(i+h)}else r>n&&(l.charCodeAt(s+h)===p?c=h:h===0&&(c=0));let y="";for(h=s+c+1;h<=t;++h)(h===t||l.charCodeAt(h)===p)&&(y+=y.length===0?"..":"/..");return`${y}${o.slice(i+c)}`},toNamespacedPath(l){return l},dirname(l){if(C(l,"path"),l.length===0)return".";const o=l.charCodeAt(0)===p;let s=-1,t=!0;for(let r=l.length-1;r>=1;--r)if(l.charCodeAt(r)===p){if(!t){s=r;break}}else t=!1;return s===-1?o?"/":".":o&&s===1?"//":l.slice(0,s)},basename(l,o){o!==void 0&&C(o,"ext"),C(l,"path");let s=0,t=-1,r=!0,i;if(o!==void 0&&o.length>0&&o.length<=l.length){if(o===l)return"";let a=o.length-1,n=-1;for(i=l.length-1;i>=0;--i){const c=l.charCodeAt(i);if(c===p){if(!r){s=i+1;break}}else n===-1&&(r=!1,n=i+1),a>=0&&(c===o.charCodeAt(a)?--a==-1&&(t=i):(a=-1,t=n))}return s===t?t=n:t===-1&&(t=l.length),l.slice(s,t)}for(i=l.length-1;i>=0;--i)if(l.charCodeAt(i)===p){if(!r){s=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":l.slice(s,t)},extname(l){C(l,"path");let o=-1,s=0,t=-1,r=!0,i=0;for(let a=l.length-1;a>=0;--a){const n=l.charCodeAt(a);if(n===p){if(!r){s=a+1;break}continue}t===-1&&(r=!1,t=a+1),n===L?o===-1?o=a:i!==1&&(i=1):o!==-1&&(i=-1)}return o===-1||t===-1||i===0||i===1&&o===t-1&&o===s+1?"":l.slice(o,t)},format:m.bind(null,"/"),parse(l){C(l,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return o;const s=l.charCodeAt(0)===p;let t;s?(o.root="/",t=1):t=0;let r=-1,i=0,a=-1,n=!0,c=l.length-1,h=0;for(;c>=t;--c){const y=l.charCodeAt(c);if(y===p){if(!n){i=c+1;break}continue}a===-1&&(n=!1,a=c+1),y===L?r===-1?r=c:h!==1&&(h=1):r!==-1&&(h=-1)}if(a!==-1){const y=i===0&&s?1:i;r===-1||h===0||h===1&&r===a-1&&r===i+1?o.base=o.name=l.slice(y,a):(o.name=l.slice(y,r),o.base=l.slice(y,a),o.ext=l.slice(r,a))}return i>0?o.dir=l.slice(0,i-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var k in v)(typeof exports=="object"?exports:G)[k]=v[k]}}(typeof self!="undefined"?self:this,function(){return function(G){var e={};function v(k){if(e[k])return e[k].exports;var _=e[k]={i:k,l:!1,exports:{}};return G[k].call(_.exports,_,_.exports,v),_.l=!0,_.exports}return v.m=G,v.c=e,v.d=function(k,_,R){v.o(k,_)||Object.defineProperty(k,_,{enumerable:!0,get:R})},v.r=function(k){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},v.t=function(k,_){if(1&_&&(k=v(k)),8&_||4&_&&typeof k=="object"&&k&&k.__esModule)return k;var R=Object.create(null);if(v.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:k}),2&_&&typeof k!="string")for(var P in k)v.d(R,P,function(L){return k[L]}.bind(null,P));return R},v.n=function(k){var _=k&&k.__esModule?function(){return k.default}:function(){return k};return v.d(_,"a",_),_},v.o=function(k,_){return Object.prototype.hasOwnProperty.call(k,_)},v.p="",v(v.s=0)}([function(G,e,v){(function(k){var _;e=G.exports=Q,_=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,P=Number.MAX_SAFE_INTEGER||9007199254740991,L=e.re=[],p=e.src=[],g=0,I=g++;p[I]="0|[1-9]\\d*";var f=g++;p[f]="[0-9]+";var b=g++;p[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=g++;p[C]="("+p[I]+")\\.("+p[I]+")\\.("+p[I]+")";var u=g++;p[u]="("+p[f]+")\\.("+p[f]+")\\.("+p[f]+")";var D=g++;p[D]="(?:"+p[I]+"|"+p[b]+")";var S=g++;p[S]="(?:"+p[f]+"|"+p[b]+")";var w=g++;p[w]="(?:-("+p[D]+"(?:\\."+p[D]+")*))";var m=g++;p[m]="(?:-?("+p[S]+"(?:\\."+p[S]+")*))";var l=g++;p[l]="[0-9A-Za-z-]+";var o=g++;p[o]="(?:\\+("+p[l]+"(?:\\."+p[l]+")*))";var s=g++,t="v?"+p[C]+p[w]+"?"+p[o]+"?";p[s]="^"+t+"$";var r="[v=\\s]*"+p[u]+p[m]+"?"+p[o]+"?",i=g++;p[i]="^"+r+"$";var a=g++;p[a]="((?:<|>)?=?)";var n=g++;p[n]=p[f]+"|x|X|\\*";var c=g++;p[c]=p[I]+"|x|X|\\*";var h=g++;p[h]="[v=\\s]*("+p[c]+")(?:\\.("+p[c]+")(?:\\.("+p[c]+")(?:"+p[w]+")?"+p[o]+"?)?)?";var y=g++;p[y]="[v=\\s]*("+p[n]+")(?:\\.("+p[n]+")(?:\\.("+p[n]+")(?:"+p[m]+")?"+p[o]+"?)?)?";var E=g++;p[E]="^"+p[a]+"\\s*"+p[h]+"$";var d=g++;p[d]="^"+p[a]+"\\s*"+p[y]+"$";var O=g++;p[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=g++;p[A]="(?:~>?)";var j=g++;p[j]="(\\s*)"+p[A]+"\\s+",L[j]=new RegExp(p[j],"g");var z=g++;p[z]="^"+p[A]+p[h]+"$";var W=g++;p[W]="^"+p[A]+p[y]+"$";var N=g++;p[N]="(?:\\^)";var x=g++;p[x]="(\\s*)"+p[N]+"\\s+",L[x]=new RegExp(p[x],"g");var F=g++;p[F]="^"+p[N]+p[h]+"$";var B=g++;p[B]="^"+p[N]+p[y]+"$";var K=g++;p[K]="^"+p[a]+"\\s*("+r+")$|^$";var $=g++;p[$]="^"+p[a]+"\\s*("+t+")$|^$";var T=g++;p[T]="(\\s*)"+p[a]+"\\s*("+r+"|"+p[h]+")",L[T]=new RegExp(p[T],"g");var U=g++;p[U]="^\\s*("+p[h]+")\\s+-\\s+("+p[h]+")\\s*$";var M=g++;p[M]="^\\s*("+p[y]+")\\s+-\\s+("+p[y]+")\\s*$";var q=g++;p[q]="(<|>)?=?\\s*\\*";for(var H=0;H<35;H++)_(H,p[H]),L[H]||(L[H]=new RegExp(p[H]));function X(J,re){if(J instanceof Q)return J;if(typeof J!="string"||J.length>R||!(re?L[i]:L[s]).test(J))return null;try{return new Q(J,re)}catch(oe){return null}}function Q(J,re){if(J instanceof Q){if(J.loose===re)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Q))return new Q(J,re);_("SemVer",J,re),this.loose=re;var oe=J.trim().match(re?L[i]:L[s]);if(!oe)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+oe[1],this.minor=+oe[2],this.patch=+oe[3],this.major>P||this.major<0)throw new TypeError("Invalid major version");if(this.minor>P||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>P||this.patch<0)throw new TypeError("Invalid patch version");oe[4]?this.prerelease=oe[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var V=+Se;if(V>=0&&V<P)return V}return Se}):this.prerelease=[],this.build=oe[5]?oe[5].split("."):[],this.format()}e.parse=X,e.valid=function(J,re){var oe=X(J,re);return oe?oe.version:null},e.clean=function(J,re){var oe=X(J.trim().replace(/^[=v]+/,""),re);return oe?oe.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(J){return _("SemVer.compare",this.version,this.loose,J),J instanceof Q||(J=new Q(J,this.loose)),this.compareMain(J)||this.comparePre(J)},Q.prototype.compareMain=function(J){return J instanceof Q||(J=new Q(J,this.loose)),ne(this.major,J.major)||ne(this.minor,J.minor)||ne(this.patch,J.patch)},Q.prototype.comparePre=function(J){if(J instanceof Q||(J=new Q(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var re=0;do{var oe=this.prerelease[re],Se=J.prerelease[re];if(_("prerelease compare",re,oe,Se),oe===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(oe===void 0)return-1;if(oe!==Se)return ne(oe,Se)}while(++re)},Q.prototype.inc=function(J,re){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var oe=this.prerelease.length;--oe>=0;)typeof this.prerelease[oe]=="number"&&(this.prerelease[oe]++,oe=-2);oe===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,re,oe,Se){typeof oe=="string"&&(Se=oe,oe=void 0);try{return new Q(J,oe).inc(re,Se).version}catch(V){return null}},e.diff=function(J,re){if(ce(J,re))return null;var oe=X(J),Se=X(re);if(oe.prerelease.length||Se.prerelease.length){for(var V in oe)if((V==="major"||V==="minor"||V==="patch")&&oe[V]!==Se[V])return"pre"+V;return"prerelease"}for(var V in oe)if((V==="major"||V==="minor"||V==="patch")&&oe[V]!==Se[V])return V},e.compareIdentifiers=ne;var Z=/^[0-9]+$/;function ne(J,re){var oe=Z.test(J),Se=Z.test(re);return oe&&Se&&(J=+J,re=+re),oe&&!Se?-1:Se&&!oe?1:J<re?-1:J>re?1:0}function le(J,re,oe){return new Q(J,oe).compare(new Q(re,oe))}function me(J,re,oe){return le(J,re,oe)>0}function se(J,re,oe){return le(J,re,oe)<0}function ce(J,re,oe){return le(J,re,oe)===0}function fe(J,re,oe){return le(J,re,oe)!==0}function ye(J,re,oe){return le(J,re,oe)>=0}function De(J,re,oe){return le(J,re,oe)<=0}function Le(J,re,oe,Se){var V;switch(re){case"===":typeof J=="object"&&(J=J.version),typeof oe=="object"&&(oe=oe.version),V=J===oe;break;case"!==":typeof J=="object"&&(J=J.version),typeof oe=="object"&&(oe=oe.version),V=J!==oe;break;case"":case"=":case"==":V=ce(J,oe,Se);break;case"!=":V=fe(J,oe,Se);break;case">":V=me(J,oe,Se);break;case">=":V=ye(J,oe,Se);break;case"<":V=se(J,oe,Se);break;case"<=":V=De(J,oe,Se);break;default:throw new TypeError("Invalid operator: "+re)}return V}function Ce(J,re){if(J instanceof Ce){if(J.loose===re)return J;J=J.value}if(!(this instanceof Ce))return new Ce(J,re);_("comparator",J,re),this.loose=re,this.parse(J),this.semver===Ae?this.value="":this.value=this.operator+this.semver.version,_("comp",this)}e.rcompareIdentifiers=function(J,re){return ne(re,J)},e.major=function(J,re){return new Q(J,re).major},e.minor=function(J,re){return new Q(J,re).minor},e.patch=function(J,re){return new Q(J,re).patch},e.compare=le,e.compareLoose=function(J,re){return le(J,re,!0)},e.rcompare=function(J,re,oe){return le(re,J,oe)},e.sort=function(J,re){return J.sort(function(oe,Se){return e.compare(oe,Se,re)})},e.rsort=function(J,re){return J.sort(function(oe,Se){return e.rcompare(oe,Se,re)})},e.gt=me,e.lt=se,e.eq=ce,e.neq=fe,e.gte=ye,e.lte=De,e.cmp=Le,e.Comparator=Ce;var Ae={};function Re(J,re){if(J instanceof Re)return J.loose===re?J:new Re(J.raw,re);if(J instanceof Ce)return new Re(J.value,re);if(!(this instanceof Re))return new Re(J,re);if(this.loose=re,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(oe){return this.parseRange(oe.trim())},this).filter(function(oe){return oe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function _e(J){return!J||J.toLowerCase()==="x"||J==="*"}function Me(J,re,oe,Se,V,ie,ae,ue,de,ve,pe,he,Ee){return((re=_e(oe)?"":_e(Se)?">="+oe+".0.0":_e(V)?">="+oe+"."+Se+".0":">="+re)+" "+(ue=_e(de)?"":_e(ve)?"<"+(+de+1)+".0.0":_e(pe)?"<"+de+"."+(+ve+1)+".0":he?"<="+de+"."+ve+"."+pe+"-"+he:"<="+ue)).trim()}function Ve(J,re){for(var oe=0;oe<J.length;oe++)if(!J[oe].test(re))return!1;if(re.prerelease.length){for(oe=0;oe<J.length;oe++)if(_(J[oe].semver),J[oe].semver!==Ae&&J[oe].semver.prerelease.length>0){var Se=J[oe].semver;if(Se.major===re.major&&Se.minor===re.minor&&Se.patch===re.patch)return!0}return!1}return!0}function Ne(J,re,oe){try{re=new Re(re,oe)}catch(Se){return!1}return re.test(J)}function We(J,re,oe,Se){var V,ie,ae,ue,de;switch(J=new Q(J,Se),re=new Re(re,Se),oe){case">":V=me,ie=De,ae=se,ue=">",de=">=";break;case"<":V=se,ie=ye,ae=me,ue="<",de="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(J,re,Se))return!1;for(var ve=0;ve<re.set.length;++ve){var pe=re.set[ve],he=null,Ee=null;if(pe.forEach(function(Ie){Ie.semver===Ae&&(Ie=new Ce(">=0.0.0")),he=he||Ie,Ee=Ee||Ie,V(Ie.semver,he.semver,Se)?he=Ie:ae(Ie.semver,Ee.semver,Se)&&(Ee=Ie)}),he.operator===ue||he.operator===de||(!Ee.operator||Ee.operator===ue)&&ie(J,Ee.semver)||Ee.operator===de&&ae(J,Ee.semver))return!1}return!0}Ce.prototype.parse=function(J){var re=this.loose?L[K]:L[$],oe=J.match(re);if(!oe)throw new TypeError("Invalid comparator: "+J);this.operator=oe[1],this.operator==="="&&(this.operator=""),oe[2]?this.semver=new Q(oe[2],this.loose):this.semver=Ae},Ce.prototype.toString=function(){return this.value},Ce.prototype.test=function(J){return _("Comparator.test",J,this.loose),this.semver===Ae||(typeof J=="string"&&(J=new Q(J,this.loose)),Le(J,this.operator,this.semver,this.loose))},Ce.prototype.intersects=function(J,re){if(!(J instanceof Ce))throw new TypeError("a Comparator is required");var oe;if(this.operator==="")return oe=new Re(J.value,re),Ne(this.value,oe,re);if(J.operator==="")return oe=new Re(this.value,re),Ne(J.semver,oe,re);var Se=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),V=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),ie=this.semver.version===J.semver.version,ae=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),ue=Le(this.semver,"<",J.semver,re)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),de=Le(this.semver,">",J.semver,re)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Se||V||ie&&ae||ue||de},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(J){var re=this.loose;J=J.trim(),_("range",J,re);var oe=re?L[M]:L[U];J=J.replace(oe,Me),_("hyphen replace",J),J=J.replace(L[T],"$1$2$3"),_("comparator trim",J,L[T]),J=(J=(J=J.replace(L[j],"$1~")).replace(L[x],"$1^")).split(/\s+/).join(" ");var Se=re?L[K]:L[$],V=J.split(" ").map(function(ie){return function(ae,ue){return _("comp",ae),ae=function(de,ve){return de.trim().split(/\s+/).map(function(pe){return function(he,Ee){_("caret",he,Ee);var Ie=Ee?L[B]:L[F];return he.replace(Ie,function(Oe,we,be,Pe,ke){var Te;return _("caret",he,Oe,we,be,Pe,ke),_e(we)?Te="":_e(be)?Te=">="+we+".0.0 <"+(+we+1)+".0.0":_e(Pe)?Te=we==="0"?">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0":">="+we+"."+be+".0 <"+(+we+1)+".0.0":ke?(_("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Te=we==="0"?be==="0"?">="+we+"."+be+"."+Pe+ke+" <"+we+"."+be+"."+(+Pe+1):">="+we+"."+be+"."+Pe+ke+" <"+we+"."+(+be+1)+".0":">="+we+"."+be+"."+Pe+ke+" <"+(+we+1)+".0.0"):(_("no pr"),Te=we==="0"?be==="0"?">="+we+"."+be+"."+Pe+" <"+we+"."+be+"."+(+Pe+1):">="+we+"."+be+"."+Pe+" <"+we+"."+(+be+1)+".0":">="+we+"."+be+"."+Pe+" <"+(+we+1)+".0.0"),_("caret return",Te),Te})}(pe,ve)}).join(" ")}(ae,ue),_("caret",ae),ae=function(de,ve){return de.trim().split(/\s+/).map(function(pe){return function(he,Ee){var Ie=Ee?L[W]:L[z];return he.replace(Ie,function(Oe,we,be,Pe,ke){var Te;return _("tilde",he,Oe,we,be,Pe,ke),_e(we)?Te="":_e(be)?Te=">="+we+".0.0 <"+(+we+1)+".0.0":_e(Pe)?Te=">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0":ke?(_("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Te=">="+we+"."+be+"."+Pe+ke+" <"+we+"."+(+be+1)+".0"):Te=">="+we+"."+be+"."+Pe+" <"+we+"."+(+be+1)+".0",_("tilde return",Te),Te})}(pe,ve)}).join(" ")}(ae,ue),_("tildes",ae),ae=function(de,ve){return _("replaceXRanges",de,ve),de.split(/\s+/).map(function(pe){return function(he,Ee){he=he.trim();var Ie=Ee?L[d]:L[E];return he.replace(Ie,function(Oe,we,be,Pe,ke,Te){_("xRange",he,Oe,we,be,Pe,ke,Te);var je=_e(be),Ue=je||_e(Pe),Fe=Ue||_e(ke);return we==="="&&Fe&&(we=""),je?Oe=we===">"||we==="<"?"<0.0.0":"*":we&&Fe?(Ue&&(Pe=0),Fe&&(ke=0),we===">"?(we=">=",Ue?(be=+be+1,Pe=0,ke=0):Fe&&(Pe=+Pe+1,ke=0)):we==="<="&&(we="<",Ue?be=+be+1:Pe=+Pe+1),Oe=we+be+"."+Pe+"."+ke):Ue?Oe=">="+be+".0.0 <"+(+be+1)+".0.0":Fe&&(Oe=">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0"),_("xRange return",Oe),Oe})}(pe,ve)}).join(" ")}(ae,ue),_("xrange",ae),ae=function(de,ve){return _("replaceStars",de,ve),de.trim().replace(L[q],"")}(ae,ue),_("stars",ae),ae}(ie,re)}).join(" ").split(/\s+/);return this.loose&&(V=V.filter(function(ie){return!!ie.match(Se)})),V=V.map(function(ie){return new Ce(ie,re)})},Re.prototype.intersects=function(J,re){if(!(J instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(oe){return oe.every(function(Se){return J.set.some(function(V){return V.every(function(ie){return Se.intersects(ie,re)})})})})},e.toComparators=function(J,re){return new Re(J,re).set.map(function(oe){return oe.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new Q(J,this.loose));for(var re=0;re<this.set.length;re++)if(Ve(this.set[re],J))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(J,re,oe){var Se=null,V=null;try{var ie=new Re(re,oe)}catch(ae){return null}return J.forEach(function(ae){ie.test(ae)&&(Se&&V.compare(ae)!==-1||(V=new Q(Se=ae,oe)))}),Se},e.minSatisfying=function(J,re,oe){var Se=null,V=null;try{var ie=new Re(re,oe)}catch(ae){return null}return J.forEach(function(ae){ie.test(ae)&&(Se&&V.compare(ae)!==1||(V=new Q(Se=ae,oe)))}),Se},e.validRange=function(J,re){try{return new Re(J,re).range||"*"}catch(oe){return null}},e.ltr=function(J,re,oe){return We(J,re,"<",oe)},e.gtr=function(J,re,oe){return We(J,re,">",oe)},e.outside=We,e.prerelease=function(J,re){var oe=X(J,re);return oe&&oe.prerelease.length?oe.prerelease:null},e.intersects=function(J,re,oe){return J=new Re(J,oe),re=new Re(re,oe),J.intersects(re)},e.coerce=function(J){if(J instanceof Q)return J;if(typeof J!="string")return null;var re=J.match(L[O]);return re==null?null:X((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,v(1))},function(G,e){var v,k,_=G.exports={};function R(){throw new Error("setTimeout has not been defined")}function P(){throw new Error("clearTimeout has not been defined")}function L(S){if(v===setTimeout)return setTimeout(S,0);if((v===R||!v)&&setTimeout)return v=setTimeout,setTimeout(S,0);try{return v(S,0)}catch(w){try{return v.call(null,S,0)}catch(m){return v.call(this,S,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:R}catch(S){v=R}try{k=typeof clearTimeout=="function"?clearTimeout:P}catch(S){k=P}})();var p,g=[],I=!1,f=-1;function b(){I&&p&&(I=!1,p.length?g=p.concat(g):f=-1,g.length&&C())}function C(){if(!I){var S=L(b);I=!0;for(var w=g.length;w;){for(p=g,g=[];++f<w;)p&&p[f].run();f=-1,w=g.length}p=null,I=!1,function(m){if(k===clearTimeout)return clearTimeout(m);if((k===P||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(m);try{k(m)}catch(l){try{return k.call(null,m)}catch(o){return k.call(this,m)}}}(S)}}function u(S,w){this.fun=S,this.array=w}function D(){}_.nextTick=function(S){var w=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)w[m-1]=arguments[m];g.push(new u(S,w)),g.length!==1||I||L(C)},u.prototype.run=function(){this.fun.apply(null,this.array)},_.title="browser",_.browser=!0,_.env={},_.argv=[],_.version="",_.versions={},_.on=D,_.addListener=D,_.once=D,_.off=D,_.removeListener=D,_.removeAllListeners=D,_.emit=D,_.prependListener=D,_.prependOnceListener=D,_.listeners=function(S){return[]},_.binding=function(S){throw new Error("process.binding is not supported")},_.cwd=function(){return"/"},_.chdir=function(S){throw new Error("process.chdir is not supported")},_.umask=function(){return 0}}])}),define(ee[83],te([0,1,6]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=v.globals.performance&&typeof v.globals.performance.now=="function";class _{constructor(P){this._highResolution=k&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new _(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=_}),define(ee[3],te([0,1,13,63,2,82,83]),function(G,e,v,k,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.AsyncEmitter=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var L;(function(m){m.None=()=>_.Disposable.None;function l(N){return(x,F=null,B)=>{let K=!1,$;return $=N(T=>{if(!K)return $?$.dispose():K=!0,x.call(F,T)},null,B),K&&$.dispose(),$}}m.once=l;function o(N,x){return n((F,B=null,K)=>N($=>F.call(B,x($)),null,K))}m.map=o;function s(N,x){return n((F,B=null,K)=>N($=>{x($),F.call(B,$)},null,K))}m.forEach=s;function t(N,x){return n((F,B=null,K)=>N($=>x($)&&F.call(B,$),null,K))}m.filter=t;function r(N){return N}m.signal=r;function i(...N){return(x,F=null,B)=>_.combinedDisposable(...N.map(K=>K($=>x.call(F,$),null,B)))}m.any=i;function a(N,x,F){let B=F;return o(N,K=>(B=x(B,K),B))}m.reduce=a;function n(N){let x;const F=new b({onFirstListenerAdd(){x=N(F.fire,F)},onLastListenerRemove(){x.dispose()}});return F.event}m.snapshot=n;function c(N,x,F=100,B=!1,K){let $,T,U,M=0;const q=new b({leakWarningThreshold:K,onFirstListenerAdd(){$=N(H=>{M++,T=x(T,H),B&&!U&&(q.fire(T),T=void 0),clearTimeout(U),U=setTimeout(()=>{const X=T;T=void 0,U=void 0,(!B||M>1)&&q.fire(X),M=0},F)})},onLastListenerRemove(){$.dispose()}});return q.event}m.debounce=c;function h(N){const x=new Date().getTime();return o(l(N),F=>new Date().getTime()-x)}m.stopwatch=h;function y(N){let x=!0,F;return t(N,B=>{const K=x||B!==F;return x=!1,F=B,K})}m.latch=y;function E(N,x=!1,F=[]){let B=F.slice(),K=N(U=>{B?B.push(U):T.fire(U)});const $=()=>{B&&B.forEach(U=>T.fire(U)),B=null},T=new b({onFirstListenerAdd(){K||(K=N(U=>T.fire(U)))},onFirstListenerDidAdd(){B&&(x?setTimeout($):$())},onLastListenerRemove(){K&&K.dispose(),K=null}});return T.event}m.buffer=E;class d{constructor(x){this.event=x}map(x){return new d(o(this.event,x))}forEach(x){return new d(s(this.event,x))}filter(x){return new d(t(this.event,x))}reduce(x,F){return new d(a(this.event,x,F))}latch(){return new d(y(this.event))}debounce(x,F=100,B=!1,K){return new d(c(this.event,x,F,B,K))}on(x,F,B){return this.event(x,F,B)}once(x,F,B){return l(this.event)(x,F,B)}}function O(N){return new d(N)}m.chain=O;function A(N,x,F=B=>B){const B=(...U)=>T.fire(F(...U)),K=()=>N.on(x,B),$=()=>N.removeListener(x,B),T=new b({onFirstListenerAdd:K,onLastListenerRemove:$});return T.event}m.fromNodeEventEmitter=A;function j(N,x,F=B=>B){const B=(...U)=>T.fire(F(...U)),K=()=>N.addEventListener(x,B),$=()=>N.removeEventListener(x,B),T=new b({onFirstListenerAdd:K,onLastListenerRemove:$});return T.event}m.fromDOMEventEmitter=j;function z(N){const x=new b;let F=!1;return N.then(void 0,()=>null).then(()=>{F?x.fire(void 0):setTimeout(()=>x.fire(void 0),0)}),F=!0,x.event}m.fromPromise=z;function W(N){return new Promise(x=>l(N)(x))}m.toPromise=W})(L=e.Event||(e.Event={}));class p{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${p._idPool++}`}start(l){this._stopWatch=new P.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}p._idPool=0;let g=-1;function I(m){const l=g;return g=m,{dispose(){g=l}}}e.setGlobalLeakWarningThreshold=I;class f{constructor(l,o=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let o=g;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),!(o<=0||l<o)){this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),t=this._stacks.get(s)||0;if(this._stacks.set(s,t+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let r,i=0;for(const[a,n]of this._stacks)(!r||i<n)&&(r=a,i=n);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${i}):`),console.warn(r)}return()=>{const r=this._stacks.get(s)||0;this._stacks.set(s,r-1)}}}}class b{constructor(l){var o;this._disposed=!1,this._options=l,this._leakageMon=g>0?new f(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((o=this._options)===null||o===void 0?void 0:o._profName)?new p(this._options._profName):void 0}get event(){return this._event||(this._event=(l,o,s)=>{var t;this._listeners||(this._listeners=new R.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(o?[l,o]:l);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,o);const a=(t=this._leakageMon)===null||t===void 0?void 0:t.check(this._listeners.size);let n;return n={dispose:()=>{a&&a(),n.dispose=b._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},s instanceof _.DisposableStore?s.add(n):Array.isArray(s)&&s.push(n),n}),this._event}fire(l){var o,s;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new R.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,l]);for((o=this._perfMon)===null||o===void 0||o.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,r]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,r):t[0].call(t[1],r)}catch(i){v.onUnexpectedError(i)}}(s=this._perfMon)===null||s===void 0||s.stop()}}dispose(){var l,o,s;(l=this._listeners)===null||l===void 0||l.clear(),(o=this._deliveryQueue)===null||o===void 0||o.clear(),(s=this._leakageMon)===null||s===void 0||s.dispose(),this._disposed=!0}}e.Emitter=b,b._noop=function(){};class C extends b{constructor(l){super(l);this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=l==null?void 0:l.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=C;class u extends b{async fireAsync(l,o,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const t of this._listeners)this._asyncDeliveryQueue.push([t,l]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[t,r]=this._asyncDeliveryQueue.shift(),i=[],a=Object.assign(Object.assign({},r),{waitUntil:n=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");s&&(n=s(n,typeof t=="function"?t:t[0])),i.push(n)}});try{typeof t=="function"?t.call(void 0,a):t[0].call(t[1],a)}catch(n){v.onUnexpectedError(n);continue}Object.freeze(i),await Promise.all(i).catch(n=>v.onUnexpectedError(n))}}}}e.AsyncEmitter=u;class D{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const o={event:l,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const s=()=>{this.hasListeners&&this.unhook(o);const t=this.events.indexOf(o);this.events.splice(t,1)};return _.toDisposable(k.once(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(o=>this.emitter.fire(o))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=D;class S{constructor(){this.buffers=[]}wrapEvent(l){return(o,s,t)=>l(r=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>o.call(s,r)):o.call(s,r)},void 0,t)}bufferEvents(l){const o=[];this.buffers.push(o);const s=l();return this.buffers.pop(),o.forEach(t=>t()),s}}e.EventBufferer=S;class w{constructor(){this.listening=!1,this.inputEvent=L.None,this.inputEventListener=_.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(ee[28],te([0,1,3]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(L,p){const g=setTimeout(L.bind(p),0);return{dispose(){clearTimeout(g)}}});var _;(function(L){function p(g){return g===L.None||g===L.Cancelled||g instanceof R?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}L.isCancellationToken=p,L.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),L.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(_=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=_.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=_.None}}e.CancellationTokenSource=P}),define(ee[8],te([0,1,28,13,3,2]),function(G,e,v,k,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(W){return W&&typeof W.then=="function"}e.isThenable=P;function L(W){const N=new v.CancellationTokenSource,x=W(N.token),F=new Promise((B,K)=>{N.token.onCancellationRequested(()=>{K(k.canceled())}),Promise.resolve(x).then($=>{N.dispose(),B($)},$=>{N.dispose(),K($)})});return new class{cancel(){N.cancel()}then(B,K){return F.then(B,K)}catch(B){return this.then(void 0,B)}finally(B){return F.finally(B)}}}e.createCancelablePromise=L;function p(W,N,x){return Promise.race([W,new Promise(F=>N.onCancellationRequested(()=>F(x)))])}e.raceCancellation=p;async function g(W){let N=-1;const x=W.map((B,K)=>B.then($=>(N=K,$))),F=await Promise.race(x);return W.forEach((B,K)=>{K!==N&&B.cancel()}),F}e.raceCancellablePromises=g;function I(W,N,x){let F;const B=setTimeout(()=>{F==null||F(void 0),x==null||x()},N);return Promise.race([W.finally(()=>clearTimeout(B)),new Promise(K=>F=K)])}e.raceTimeout=I;function f(W){return new Promise((N,x)=>{const F=W();P(F)?F.then(N,x):N(F)})}e.asPromise=f;class b{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(x,x).then(F)})}return new Promise((x,F)=>{this.queuedPromise.then(x,F)})}return this.activePromise=N(),new Promise((x,F)=>{this.activePromise.then(B=>{this.activePromise=null,x(B)},B=>{this.activePromise=null,F(B)})})}}e.Throttler=b;class C{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=C;class u{constructor(){this.promiseMap=new Map}queue(N,x){var F;const K=((F=this.promiseMap.get(N))!==null&&F!==void 0?F:Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(N)===K&&this.promiseMap.delete(N)});return this.promiseMap.set(N,K),K}}e.SequencerByKey=u;class D{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,x=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,B)=>{this.doResolve=F,this.doReject=B}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(k.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=D;class S{constructor(N){this.delayer=new D(N),this.throttler=new b}trigger(N,x){return this.delayer.trigger(()=>this.throttler.queue(N),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class w{constructor(){this._isOpen=!1,this._promise=new Promise((N,x)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=w;function m(W,N){return N?new Promise((x,F)=>{const B=setTimeout(x,W);N.onCancellationRequested(()=>{clearTimeout(B),F(k.canceled())})}):L(x=>m(W,x))}e.timeout=m;function l(W,N=0){const x=setTimeout(W,N);return R.toDisposable(()=>clearTimeout(x))}e.disposableTimeout=l;function o(W){return W.then(void 0,N=>{})}e.ignoreErrors=o;function s(W){const N=[];let x=0;const F=W.length;function B(){return x<F?W[x++]():null}function K($){$!=null&&N.push($);const T=B();return T?T.then(K):Promise.resolve(N)}return Promise.resolve(null).then(K)}e.sequence=s;function t(W,N=F=>!!F,x=null){let F=0;const B=W.length,K=()=>{if(F>=B)return Promise.resolve(x);const $=W[F++];return Promise.resolve($()).then(U=>N(U)?Promise.resolve(U):K())};return K()}e.first=t;function r(W,N=F=>!!F,x=null){if(W.length===0)return Promise.resolve(x);let F=W.length;const B=()=>{var K,$;F=-1;for(const T of W)($=(K=T).cancel)===null||$===void 0||$.call(K)};return new Promise((K,$)=>{for(const T of W)T.then(U=>{--F>=0&&N(U)?(B(),K(U)):F===0&&K(x)}).catch(U=>{--F>=0&&(B(),$(U))})})}e.firstParallel=r;class i{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new _.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((x,F)=>{this.outstandingPromises.push({factory:N,c:x,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const x=N.factory();x.then(N.c,N.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class a extends i{constructor(){super(1)}}e.Queue=a;class n{constructor(){this.queues=new Map}queueFor(N){const x=N.toString();if(!this.queues.has(x)){const F=new a;F.onFinished(()=>{F.dispose(),this.queues.delete(x)}),this.queues.set(x,F)}return this.queues.get(x)}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=n;class c{constructor(N,x){this._token=-1,typeof N=="function"&&typeof x=="number"&&this.setIfNotSet(N,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},x)}setIfNotSet(N,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},x))}}e.TimeoutTimer=c;class h{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,x){this.cancel(),this._token=setInterval(()=>{N()},x)}}e.IntervalTimer=h;class y{constructor(N,x){this.timeoutToken=-1,this.runner=N,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=y;class E extends y{constructor(N,x){super(N,x);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=E,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const W=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const x=setTimeout(()=>N(W));let F=!1;return{dispose(){F||(F=!0,clearTimeout(x))}}}}else e.runWhenIdle=(W,N)=>{const x=requestIdleCallback(W,typeof N=="number"?{timeout:N}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(x))}}}}();class d{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=d;async function O(W,N,x){let F;for(let B=0;B<x;B++)try{return await W()}catch(K){F=K,await m(N)}throw F}e.retry=O;class A{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var N;(N=this._pending)===null||N===void 0||N.cancel()}setPending(N,x,F){return this._pending={taskId:N,cancel:()=>F==null?void 0:F(),promise:x},x.then(()=>this.donePending(N),()=>this.donePending(N)),x}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let x,F;const B=new Promise((K,$)=>{x=K,F=$});this._next={run:N,promise:B,promiseResolve:x,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=A;class j{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=j;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,x)=>{this.completeCallback=N,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(x=>{this.completeCallback(N),this.resolved=!0,x()})}error(N){return new Promise(x=>{this.errorCallback(N),this.rejected=!0,x()})}cancel(){new Promise(N=>{this.errorCallback(k.canceled()),this.rejected=!0,N()})}}e.DeferredPromise=z}),define(ee[52],te([0,1,13,2]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.observe=e.transform=e.toReadable=e.toStream=e.peekStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function _(S){const w=S;return w&&[w.on,w.pause,w.resume,w.destroy].every(m=>typeof m=="function")}e.isReadableStream=_;function R(S){const w=S;return w&&_(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean"}e.isReadableBufferedStream=R;function P(S,w){return new L(S,w)}e.newWriteableStream=P;class L{constructor(w,m){this.reducer=w,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){var m;if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof((m=this.options)===null||m===void 0?void 0:m.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(w instanceof Error?this.error(w):w&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(m=>m(w))}emitError(w){this.listeners.error.length===0?v.onUnexpectedError(w):this.listeners.error.slice(0).forEach(m=>m(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,m){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(w,m){if(!this.state.destroyed){let l;switch(w){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const o=l.indexOf(m);o>=0&&l.splice(o,1)}}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(S,w){const m=[];let l;for(;(l=S.read())!==null;)m.push(l);return w(m)}e.consumeReadable=p;function g(S,w,m){const l=[];let o;for(;(o=S.read())!==null&&l.length<m;)l.push(o);return o===null&&l.length>0?w(l):{read:()=>{if(l.length>0)return l.shift();if(typeof o!="undefined"){const s=o;return o=void 0,s}return S.read()}}}e.peekReadable=g;function I(S,w){return new Promise((m,l)=>{const o=[];S.on("error",s=>l(s)),S.on("end",()=>m(w(o))),S.on("data",s=>o.push(s))})}e.consumeStream=I;function f(S,w){return new Promise((m,l)=>{const o=new k.DisposableStore,s=[],t=a=>{if(s.push(a),s.length>w)return o.dispose(),S.pause(),m({stream:S,buffer:s,ended:!1})};o.add(k.toDisposable(()=>S.removeListener("data",t))),S.on("data",t);const r=a=>l(a);o.add(k.toDisposable(()=>S.removeListener("error",r))),S.on("error",r);const i=()=>m({stream:S,buffer:s,ended:!0});o.add(k.toDisposable(()=>S.removeListener("end",i))),S.on("end",i)})}e.peekStream=f;function b(S,w){const m=P(w);return m.end(S),m}e.toStream=b;function C(S){let w=!1;return{read:()=>w?null:(w=!0,S)}}e.toReadable=C;function u(S,w,m){const l=P(m);return S.on("data",o=>l.write(w.data(o))),S.on("end",()=>l.end()),S.on("error",o=>l.error(w.error?w.error(o):o)),l}e.transform=u;function D(S){const w=Promise.race([new Promise(m=>S.on("end",()=>m())),new Promise(m=>S.on("error",()=>m()))]);return{errorOrEnd(){return S.resume(),w}}}e.observe=D}),define(ee[20],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(V){return!V||typeof V!="string"?!0:V.trim().length===0}e.isFalsyOrWhitespace=v;const k=/{(\d+)}/g;function _(V,...ie){return ie.length===0?V:V.replace(k,function(ae,ue){const de=parseInt(ue,10);return isNaN(de)||de<0||de>=ie.length?ae:ie[de]})}e.format=_;function R(V){return V.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=R;function P(V){return V.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function L(V,ie){let ae=0;const ue=ie.charCodeAt(0);for(let de=V.length-1;de>=0;de--)V.charCodeAt(de)===ue&&ae++;return ae}e.count=L;function p(V,ie,ae="\u2026"){return V.length<=ie?V:`${V.substr(0,ie)}${ae}`}e.truncate=p;function g(V,ie=" "){const ae=I(V,ie);return f(ae,ie)}e.trim=g;function I(V,ie){if(!V||!ie)return V;const ae=ie.length;if(ae===0||V.length===0)return V;let ue=0;for(;V.indexOf(ie,ue)===ue;)ue=ue+ae;return V.substring(ue)}e.ltrim=I;function f(V,ie){if(!V||!ie)return V;const ae=ie.length,ue=V.length;if(ae===0||ue===0)return V;let de=ue,ve=-1;for(;ve=V.lastIndexOf(ie,de-1),!(ve===-1||ve+ae!==de);){if(ve===0)return"";de=ve}return V.substring(0,de)}e.rtrim=f;function b(V){return V.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=b;function C(V){return V.replace(/\*/g,"")}e.stripWildcards=C;function u(V,ie,ae={}){if(!V)throw new Error("Cannot create regex from empty string");ie||(V=P(V)),ae.wholeWord&&(/\B/.test(V.charAt(0))||(V="\\b"+V),/\B/.test(V.charAt(V.length-1))||(V=V+"\\b"));let ue="";return ae.global&&(ue+="g"),ae.matchCase||(ue+="i"),ae.multiline&&(ue+="m"),ae.unicode&&(ue+="u"),new RegExp(V,ue)}e.createRegExp=u;function D(V){return V.source==="^"||V.source==="^$"||V.source==="$"||V.source==="^\\s*$"?!1:!!(V.exec("")&&V.lastIndex===0)}e.regExpLeadsToEndlessLoop=D;function S(V){return!!V.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function w(V){return(V.global?"g":"")+(V.ignoreCase?"i":"")+(V.multiline?"m":"")+(V.unicode?"u":"")}e.regExpFlags=w;function m(V){return V.split(/\r\n|\r|\n/)}e.splitLines=m;function l(V){for(let ie=0,ae=V.length;ie<ae;ie++){const ue=V.charCodeAt(ie);if(ue!==32&&ue!==9)return ie}return-1}e.firstNonWhitespaceIndex=l;function o(V,ie=0,ae=V.length){for(let ue=ie;ue<ae;ue++){const de=V.charCodeAt(ue);if(de!==32&&de!==9)return V.substring(ie,ue)}return V.substring(ie,ae)}e.getLeadingWhitespace=o;function s(V,ie=V.length-1){for(let ae=ie;ae>=0;ae--){const ue=V.charCodeAt(ae);if(ue!==32&&ue!==9)return ae}return-1}e.lastNonWhitespaceIndex=s;function t(V,ie){return V<ie?-1:V>ie?1:0}e.compare=t;function r(V,ie,ae=0,ue=V.length,de=0,ve=ie.length){for(;ae<ue&&de<ve;ae++,de++){let Ee=V.charCodeAt(ae),Ie=ie.charCodeAt(de);if(Ee<Ie)return-1;if(Ee>Ie)return 1}const pe=ue-ae,he=ve-de;return pe<he?-1:pe>he?1:0}e.compareSubstring=r;function i(V,ie){return a(V,ie,0,V.length,0,ie.length)}e.compareIgnoreCase=i;function a(V,ie,ae=0,ue=V.length,de=0,ve=ie.length){for(;ae<ue&&de<ve;ae++,de++){let Ee=V.charCodeAt(ae),Ie=ie.charCodeAt(de);if(Ee!==Ie){const Oe=Ee-Ie;if(!(Oe===32&&c(Ie))&&!(Oe===-32&&c(Ee)))return n(Ee)&&n(Ie)?Oe:r(V.toLowerCase(),ie.toLowerCase(),ae,ue,de,ve)}}const pe=ue-ae,he=ve-de;return pe<he?-1:pe>he?1:0}e.compareSubstringIgnoreCase=a;function n(V){return V>=97&&V<=122}e.isLowerAsciiLetter=n;function c(V){return V>=65&&V<=90}e.isUpperAsciiLetter=c;function h(V){return n(V)||c(V)}function y(V,ie){return V.length===ie.length&&E(V,ie)}e.equalsIgnoreCase=y;function E(V,ie,ae=V.length){for(let ue=0;ue<ae;ue++){const de=V.charCodeAt(ue),ve=ie.charCodeAt(ue);if(de!==ve){if(h(de)&&h(ve)){const pe=Math.abs(de-ve);if(pe!==0&&pe!==32)return!1}else if(String.fromCharCode(de).toLowerCase()!==String.fromCharCode(ve).toLowerCase())return!1}}return!0}function d(V,ie){const ae=ie.length;return ie.length>V.length?!1:E(V,ie,ae)}e.startsWithIgnoreCase=d;function O(V,ie){let ae,ue=Math.min(V.length,ie.length);for(ae=0;ae<ue;ae++)if(V.charCodeAt(ae)!==ie.charCodeAt(ae))return ae;return ue}e.commonPrefixLength=O;function A(V,ie){let ae,ue=Math.min(V.length,ie.length);const de=V.length-1,ve=ie.length-1;for(ae=0;ae<ue;ae++)if(V.charCodeAt(de-ae)!==ie.charCodeAt(ve-ae))return ae;return ue}e.commonSuffixLength=A;function j(V){return 55296<=V&&V<=56319}e.isHighSurrogate=j;function z(V){return 56320<=V&&V<=57343}e.isLowSurrogate=z;function W(V,ie){return(V-55296<<10)+(ie-56320)+65536}e.computeCodePoint=W;function N(V,ie,ae){const ue=V.charCodeAt(ae);if(j(ue)&&ae+1<ie){const de=V.charCodeAt(ae+1);if(z(de))return W(ue,de)}return ue}e.getNextCodePoint=N;function x(V,ie){const ae=V.charCodeAt(ie-1);if(z(ae)&&ie>1){const ue=V.charCodeAt(ie-2);if(j(ue))return W(ue,ae)}return ae}function F(V,ie){const ae=oe.getInstance(),ue=ie,de=V.length,ve=N(V,de,ie);ie+=ve>=65536?2:1;let pe=ae.getGraphemeBreakType(ve);for(;ie<de;){const he=N(V,de,ie),Ee=ae.getGraphemeBreakType(he);if(J(pe,Ee))break;ie+=he>=65536?2:1,pe=Ee}return ie-ue}e.nextCharLength=F;function B(V,ie){const ae=oe.getInstance(),ue=ie,de=x(V,ie);ie-=de>=65536?2:1;let ve=ae.getGraphemeBreakType(de);for(;ie>0;){const pe=x(V,ie),he=ae.getGraphemeBreakType(pe);if(J(he,ve))break;ie-=pe>=65536?2:1,ve=he}return ue-ie}e.prevCharLength=B;function K(V,ie){const ae=oe.getInstance(),ue=V.length,de=ie,ve=N(V,ue,ie),pe=ae.getGraphemeBreakType(ve);ie+=ve>=65536?2:1;let he=pe;for(;ie<ue;){const Ie=N(V,ue,ie),Oe=ae.getGraphemeBreakType(Ie);if(J(he,Oe))break;ie+=Ie>=65536?2:1,he=Oe}const Ee=ie;for(ie=de,he=pe;ie>0;){const Ie=x(V,ie),Oe=ae.getGraphemeBreakType(Ie);if(J(Oe,he))break;ie-=Ie>=65536?2:1,he=Oe}return[ie,Ee]}function $(V,ie){return ie>0&&z(V.charCodeAt(ie))?K(V,ie-1):K(V,ie)}e.getCharContainingOffset=$;function T(V){const ie=V.length;let ae=0,ue=0;for(;ue<ie;){const pe=N(V,ie,ue);ue+=pe>=65536?2:1,pe<128?ae+=1:pe<2048?ae+=2:pe<65536?ae+=3:ae+=4}const de=new Uint8Array(ae);ue=0;let ve=0;for(;ue<ie;){const pe=N(V,ie,ue);ue+=pe>=65536?2:1,pe<128?de[ve++]=pe:pe<2048?(de[ve++]=192|(pe&1984)>>>6,de[ve++]=128|(pe&63)>>>0):pe<65536?(de[ve++]=224|(pe&61440)>>>12,de[ve++]=128|(pe&4032)>>>6,de[ve++]=128|(pe&63)>>>0):(de[ve++]=240|(pe&1835008)>>>18,de[ve++]=128|(pe&258048)>>>12,de[ve++]=128|(pe&4032)>>>6,de[ve++]=128|(pe&63)>>>0)}return de}e.encodeUTF8=T;function U(V){const ie=V.byteLength,ae=[];let ue=0;for(;ue<ie;){const de=V[ue];let ve;if(de>=240&&ue+3<ie?ve=(V[ue++]&7)<<18>>>0|(V[ue++]&63)<<12>>>0|(V[ue++]&63)<<6>>>0|(V[ue++]&63)<<0>>>0:de>=224&&ue+2<ie?ve=(V[ue++]&15)<<12>>>0|(V[ue++]&63)<<6>>>0|(V[ue++]&63)<<0>>>0:de>=192&&ue+1<ie?ve=(V[ue++]&31)<<6>>>0|(V[ue++]&63)<<0>>>0:ve=V[ue++],ve>=0&&ve<=55295||ve>=57344&&ve<=65535)ae.push(String.fromCharCode(ve));else if(ve>=65536&&ve<=1114111){const pe=ve-65536,he=55296+((pe&1047552)>>>10),Ee=56320+((pe&1023)>>>0);ae.push(String.fromCharCode(he)),ae.push(String.fromCharCode(Ee))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=U;const M=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function q(V){return M.test(V)}e.containsRTL=q;const H=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDE73\uDE78-\uDE82\uDE90-\uDE95])/;function X(V){return H.test(V)}e.containsEmoji=X;const Q=/^[\t\n\r\x20-\x7E]*$/;function Z(V){return Q.test(V)}e.isBasicASCII=Z,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ne(V){return e.UNUSUAL_LINE_TERMINATORS.test(V)}e.containsUnusualLineTerminators=ne;function le(V){for(let ie=0,ae=V.length;ie<ae;ie++)if(me(V.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=le;function me(V){return V=+V,V>=11904&&V<=55215||V>=63744&&V<=64255||V>=65281&&V<=65374}e.isFullWidthCharacter=me;function se(V){return V>=127462&&V<=127487||V>=9728&&V<=10175||V>=127744&&V<=128591||V>=128640&&V<=128764||V>=128992&&V<=129003||V>=129280&&V<=129535||V>=129648&&V<=129651||V>=129656&&V<=129666||V>=129680&&V<=129685}e.isEmojiImprecise=se;function ce(V,ie){if(V.length<ie)return V;const ae=/\b/g;let ue=0;for(;ae.test(V)&&!(V.length-ae.lastIndex<ie);)ue=ae.lastIndex,ae.lastIndex+=1;return V.substring(ue).replace(/^\s/,"")}e.lcut=ce;const fe=/\x1B\x5B[12]?K/g,ye=/\x1b\[\d+m/g,De=/\x1b\[0?m/g;function Le(V){return V&&(V=V.replace(fe,""),V=V.replace(ye,""),V=V.replace(De,"")),V}e.removeAnsiEscapeCodes=Le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(V){return!!(V&&V.length>0&&V.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Ae(V){return Ce(V)?V.substr(1):V}e.stripUTF8BOM=Ae;function Re(V,ie){if(!V||!ie||V.length<ie.length)return!1;const ae=ie.length,ue=V.toLowerCase();let de=0,ve=-1;for(;de<ae;){const pe=ue.indexOf(ie[de],ve+1);if(pe<0)return!1;ve=pe,de++}return!0}e.fuzzyContains=Re;function _e(V,ie=!1){return V?(ie&&(V=V.replace(/\\./g,"")),V.toLowerCase()!==V):!1}e.containsUppercaseCharacter=_e;function Me(V){return V.charAt(0).toUpperCase()+V.slice(1)}e.uppercaseFirstLetter=Me;function Ve(V,ie=1){if(ie===0)return"";let ae=-1;do ae=V.indexOf(`
`,ae+1),ie--;while(ie>0&&ae>=0);return ae===-1?V:(V[ae-1]==="\r"&&ae--,V.substr(0,ae))}e.getNLines=Ve;function Ne(V){const ie=90-65+1;return V=V%(2*ie),V<ie?String.fromCharCode(97+V):String.fromCharCode(65+V-ie)}e.singleLetterHash=Ne;function We(V){return oe.getInstance().getGraphemeBreakType(V)}e.getGraphemeBreakType=We;function J(V,ie){return V===0?ie!==5&&ie!==7:V===2&&ie===3?!1:V===4||V===2||V===3||ie===4||ie===2||ie===3?!0:!(V===8&&(ie===8||ie===9||ie===11||ie===12)||(V===11||V===9)&&(ie===9||ie===10)||(V===12||V===10)&&ie===10||ie===5||ie===13||ie===7||V===1||V===13&&ie===14||V===6&&ie===6)}e.breakBetweenGraphemeBreakType=J;var re;(function(V){V[V.Other=0]="Other",V[V.Prepend=1]="Prepend",V[V.CR=2]="CR",V[V.LF=3]="LF",V[V.Control=4]="Control",V[V.Extend=5]="Extend",V[V.Regional_Indicator=6]="Regional_Indicator",V[V.SpacingMark=7]="SpacingMark",V[V.L=8]="L",V[V.V=9]="V",V[V.T=10]="T",V[V.LV=11]="LV",V[V.LVT=12]="LVT",V[V.ZWJ=13]="ZWJ",V[V.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class oe{constructor(){this._data=Se()}static getInstance(){return oe._INSTANCE||(oe._INSTANCE=new oe),oe._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ae=this._data,ue=ae.length/3;let de=1;for(;de<=ue;)if(ie<ae[3*de])de=2*de;else if(ie>ae[3*de+1])de=2*de+1;else return ae[3*de+2];return 0}}oe._INSTANCE=null;function Se(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(ee[16],te([0,1,20,52]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const _=typeof Buffer!="undefined",R=typeof TextEncoder!="undefined",P=typeof TextDecoder!="undefined";let L,p;class g{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return _?new g(Buffer.allocUnsafe(n)):new g(new Uint8Array(n))}static wrap(n){return _&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new g(n)}static fromString(n,c){return!((c==null?void 0:c.dontUseNodeBuffer)||!1)&&_?new g(Buffer.from(n)):R?(L||(L=new TextEncoder),new g(L.encode(n))):new g(v.encodeUTF8(n))}static concat(n,c){if(typeof c=="undefined"){c=0;for(let E=0,d=n.length;E<d;E++)c+=n[E].byteLength}const h=g.alloc(c);let y=0;for(let E=0,d=n.length;E<d;E++){const O=n[E];h.set(O,y),y+=O.byteLength}return h}toString(){return _?this.buffer.toString():P?(p||(p=new TextDecoder),p.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(n,c){return new g(this.buffer.subarray(n,c))}set(n,c){n instanceof g?this.buffer.set(n.buffer,c):this.buffer.set(n,c)}readUInt32BE(n){return b(this.buffer,n)}writeUInt32BE(n,c){C(this.buffer,n,c)}readUInt32LE(n){return u(this.buffer,n)}writeUInt32LE(n,c){D(this.buffer,n,c)}readUInt8(n){return S(this.buffer,n)}writeUInt8(n,c){w(this.buffer,n,c)}}e.VSBuffer=g;function I(a,n){return a[n+0]<<0>>>0|a[n+1]<<8>>>0}e.readUInt16LE=I;function f(a,n,c){a[c+0]=n&255,n=n>>>8,a[c+1]=n&255}e.writeUInt16LE=f;function b(a,n){return a[n]*2**24+a[n+1]*2**16+a[n+2]*2**8+a[n+3]}e.readUInt32BE=b;function C(a,n,c){a[c+3]=n,n=n>>>8,a[c+2]=n,n=n>>>8,a[c+1]=n,n=n>>>8,a[c]=n}e.writeUInt32BE=C;function u(a,n){return a[n+0]<<0>>>0|a[n+1]<<8>>>0|a[n+2]<<16>>>0|a[n+3]<<24>>>0}e.readUInt32LE=u;function D(a,n,c){a[c+0]=n&255,n=n>>>8,a[c+1]=n&255,n=n>>>8,a[c+2]=n&255,n=n>>>8,a[c+3]=n&255}e.writeUInt32LE=D;function S(a,n){return a[n]}e.readUInt8=S;function w(a,n,c){a[c]=n}e.writeUInt8=w;function m(a){return k.consumeReadable(a,n=>g.concat(n))}e.readableToBuffer=m;function l(a){return k.toReadable(a)}e.bufferToReadable=l;function o(a){return k.consumeStream(a,n=>g.concat(n))}e.streamToBuffer=o;async function s(a){return a.ended?g.concat(a.buffer):g.concat([...a.buffer,await o(a.stream)])}e.bufferedStreamToBuffer=s;function t(a){return k.toStream(a,n=>g.concat(n))}e.bufferToStream=t;function r(a){return k.transform(a,{data:n=>typeof n=="string"?g.fromString(n):g.wrap(n)},n=>g.concat(n))}e.streamToBufferReadableStream=r;function i(a){return k.newWriteableStream(n=>g.concat(n),a)}e.newWriteableBufferStream=i}),define(ee[17],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(n){return Array.isArray(n)}e.isArray=v;function k(n){return typeof n=="string"}e.isString=k;function _(n){return Array.isArray(n)&&n.every(c=>k(c))}e.isStringArray=_;function R(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}e.isObject=R;function P(n){return typeof n=="number"&&!isNaN(n)}e.isNumber=P;function L(n){return n===!0||n===!1}e.isBoolean=L;function p(n){return typeof n=="undefined"}e.isUndefined=p;function g(n){return!I(n)}e.isDefined=g;function I(n){return p(n)||n===null}e.isUndefinedOrNull=I;function f(n,c){if(!n)throw new Error(c?`Unexpected type, expected '${c}'`:"Unexpected type")}e.assertType=f;function b(n){if(I(n))throw new Error("Assertion Failed: argument is undefined or null");return n}e.assertIsDefined=b;function C(...n){const c=[];for(let h=0;h<n.length;h++){const y=n[h];if(I(y))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);c.push(y)}return c}e.assertAllDefined=C;const u=Object.prototype.hasOwnProperty;function D(n){if(!R(n))return!1;for(let c in n)if(u.call(n,c))return!1;return!0}e.isEmptyObject=D;function S(n){return typeof n=="function"}e.isFunction=S;function w(...n){return n.length>0&&n.every(S)}e.areFunctions=w;function m(n,c){const h=Math.min(n.length,c.length);for(let y=0;y<h;y++)l(n[y],c[y])}e.validateConstraints=m;function l(n,c){if(k(c)){if(typeof n!==c)throw new Error(`argument does not match constraint: typeof ${c}`)}else if(S(c)){try{if(n instanceof c)return}catch(h){}if(!I(n)&&n.constructor===c||c.length===1&&c.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function o(n){let c=[],h=Object.getPrototypeOf(n);for(;Object.prototype!==h;)c=c.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return c}e.getAllPropertyNames=o;function s(n){const c=[];for(const h of o(n))typeof n[h]=="function"&&c.push(h);return c}e.getAllMethodNames=s;function t(n,c){const h=E=>function(){const d=Array.prototype.slice.call(arguments,0);return c(E,d)};let y={};for(const E of n)y[E]=h(E);return y}e.createProxyObject=t;function r(n){return n===null?void 0:n}e.withNullAsUndefined=r;function i(n){return typeof n=="undefined"?null:n}e.withUndefinedAsNull=i;function a(n){return class{constructor(){return new Proxy({},{get(c,h){if(c[h])return c[h];throw new Error(`Not Implemented: ${n}->${String(h)}`)}})}}}e.NotImplementedProxy=a}),define(ee[35],te([0,1,6,20,4,17]),function(G,e,v,k,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function P(r){return r===47||r===92}e.isPathSeparator=P;function L(r){return r.replace(/[\\/]/g,_.posix.sep)}e.toSlashes=L;function p(r,i=_.posix.sep){if(!r)return"";const a=r.length,n=r.charCodeAt(0);if(P(n)){if(P(r.charCodeAt(1))&&!P(r.charCodeAt(2))){let h=3;const y=h;for(;h<a&&!P(r.charCodeAt(h));h++);if(y!==h&&!P(r.charCodeAt(h+1))){for(h+=1;h<a;h++)if(P(r.charCodeAt(h)))return r.slice(0,h+1).replace(/[\\/]/g,i)}}return i}else if(S(n)&&r.charCodeAt(1)===58)return P(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let c=r.indexOf("://");if(c!==-1){for(c+=3;c<a;c++)if(P(r.charCodeAt(c)))return r.slice(0,c+1)}return""}e.getRoot=p;function g(r){if(!v.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let a=2;const n=a;for(;a<r.length&&(i=r.charCodeAt(a),i!==92);a++);return!(n===a||(i=r.charCodeAt(a+1),isNaN(i)||i===92))}e.isUNC=g;const I=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function C(r,i=v.isWindows){const a=i?I:f;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||i&&b.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=C;function u(r,i,a){const n=r===i;return!a||n?n:!r||!i?!1:k.equalsIgnoreCase(r,i)}e.isEqual=u;function D(r,i,a,n=_.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(a){if(!k.startsWithIgnoreCase(r,i))return!1;if(i.length===r.length)return!0;let h=i.length;return i.charAt(i.length-1)===n&&h--,r.charAt(h)===n}return i.charAt(i.length-1)!==n&&(i+=n),r.indexOf(i)===0}e.isEqualOrParent=D;function S(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=S;function w(r,i){return v.isWindows&&r.endsWith(":")&&(r+=_.sep),_.isAbsolute(r)||(r=_.join(i,r)),r=_.normalize(r),v.isWindows?(r=k.rtrim(r,_.sep),r.endsWith(":")&&(r+=_.sep)):(r=k.rtrim(r,_.sep),r||(r=_.sep)),r}e.sanitizeFilePath=w;function m(r){const i=_.normalize(r);return v.isWindows?r.length>3?!1:l(i)&&(r.length===2||i.charCodeAt(2)===92):i===_.posix.sep}e.isRootOrDriveLetter=m;function l(r){return v.isWindows?S(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function o(r){return l(r)?r[0]:void 0}e.getDriveLetter=o;function s(r,i,a){return i.length>r.length?-1:r===i?0:(a&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=s;function t(r){const i=r.split(":");let a,n,c;if(i.forEach(h=>{const y=Number(h);R.isNumber(y)?n===void 0?n=y:c===void 0&&(c=y):a=a?[a,h].join(":"):h}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:n!==void 0?n:void 0,column:c!==void 0?c:n!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ee[25],te([0,1,17]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const D=Array.isArray(u)?[]:{};return Object.keys(u).forEach(S=>{u[S]&&typeof u[S]=="object"?D[S]=k(u[S]):D[S]=u[S]}),D}e.deepClone=k;function _(u){if(!u||typeof u!="object")return u;const D=[u];for(;D.length>0;){const S=D.shift();Object.freeze(S);for(const w in S)if(R.call(S,w)){const m=S[w];typeof m=="object"&&!Object.isFrozen(m)&&D.push(m)}}return u}e.deepFreeze=_;const R=Object.prototype.hasOwnProperty;function P(u,D){return L(u,D,new Set)}e.cloneAndChange=P;function L(u,D,S){if(v.isUndefinedOrNull(u))return u;const w=D(u);if(typeof w!="undefined")return w;if(v.isArray(u)){const m=[];for(const l of u)m.push(L(l,D,S));return m}if(v.isObject(u)){if(S.has(u))throw new Error("Cannot clone recursive data-structure");S.add(u);const m={};for(let l in u)R.call(u,l)&&(m[l]=L(u[l],D,S));return S.delete(u),m}return u}function p(u,D,S=!0){return v.isObject(u)?(v.isObject(D)&&Object.keys(D).forEach(w=>{w in u?S&&(v.isObject(u[w])&&v.isObject(D[w])?p(u[w],D[w],S):u[w]=D[w]):u[w]=D[w]}),u):D}e.mixin=p;function g(u,D){if(u===D)return!0;if(u==null||D===null||D===void 0||typeof u!=typeof D||typeof u!="object"||Array.isArray(u)!==Array.isArray(D))return!1;let S,w;if(Array.isArray(u)){if(u.length!==D.length)return!1;for(S=0;S<u.length;S++)if(!g(u[S],D[S]))return!1}else{const m=[];for(w in u)m.push(w);m.sort();const l=[];for(w in D)l.push(w);if(l.sort(),!g(m,l))return!1;for(S=0;S<m.length;S++)if(!g(u[m[S]],D[m[S]]))return!1}return!0}e.equals=g;function I(u){const D=new Set;return JSON.stringify(u,(S,w)=>{if(v.isObject(w)||Array.isArray(w)){if(D.has(w))return"[Circular]";D.add(w)}return w})}e.safeStringify=I;function f(u,D,S){const w=D(u);return typeof w=="undefined"?S:w}e.getOrDefault=f;function b(u,D){const S=Object.create(null);return!u||!D||Object.keys(D).forEach(m=>{const l=u[m],o=D[m];g(l,o)||(S[m]=o)}),S}e.distinct=b;function C(u,D){const S=D.toLowerCase(),w=Object.keys(u).find(m=>m.toLowerCase()===S);return w?u[w]:u[D]}e.getCaseInsensitive=C}),define(ee[7],te([0,1,6,4]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const _=/^\w[\w\d+.-]*$/,R=/^\//,P=/^\/\//;function L(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!_.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(i,a){return!i&&!a?"file":i}function g(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==f&&(a=f+a):a=f;break}return a}const I="",f="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class C{constructor(a,n,c,h,y,E=!1){typeof a=="object"?(this.scheme=a.scheme||I,this.authority=a.authority||I,this.path=a.path||I,this.query=a.query||I,this.fragment=a.fragment||I):(this.scheme=p(a,E),this.authority=n||I,this.path=g(this.scheme,c||I),this.query=h||I,this.fragment=y||I,L(this,E))}static isUri(a){return a instanceof C?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return l(this,!1)}with(a){if(!a)return this;let{scheme:n,authority:c,path:h,query:y,fragment:E}=a;return n===void 0?n=this.scheme:n===null&&(n=I),c===void 0?c=this.authority:c===null&&(c=I),h===void 0?h=this.path:h===null&&(h=I),y===void 0?y=this.query:y===null&&(y=I),E===void 0?E=this.fragment:E===null&&(E=I),n===this.scheme&&c===this.authority&&h===this.path&&y===this.query&&E===this.fragment?this:new D(n,c,h,y,E)}static parse(a,n=!1){const c=b.exec(a);return c?new D(c[2]||I,r(c[4]||I),r(c[5]||I),r(c[7]||I),r(c[9]||I),n):new D(I,I,I,I,I)}static file(a){let n=I;if(v.isWindows&&(a=a.replace(/\\/g,f)),a[0]===f&&a[1]===f){const c=a.indexOf(f,2);c===-1?(n=a.substring(2),a=f):(n=a.substring(2,c),a=a.substring(c)||f)}return new D("file",n,a,I,I)}static from(a){return new D(a.scheme,a.authority,a.path,a.query,a.fragment)}static joinPath(a,...n){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return v.isWindows&&a.scheme==="file"?c=C.file(k.win32.join(l(a,!0),...n)).path:c=k.posix.join(a.path,...n),a.with({path:c})}toString(a=!1){return o(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof C)return a;{const n=new D(a);return n._formatted=a.external,n._fsPath=a._sep===u?a.fsPath:null,n}}else return a}}e.URI=C;const u=v.isWindows?1:void 0;class D extends C{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(a=!1){return a?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=u),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(i,a){let n,c=-1;for(let h=0;h<i.length;h++){const y=i.charCodeAt(h);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||a&&y===47)c!==-1&&(n+=encodeURIComponent(i.substring(c,h)),c=-1),n!==void 0&&(n+=i.charAt(h));else{n===void 0&&(n=i.substr(0,h));const E=S[y];E!==void 0?(c!==-1&&(n+=encodeURIComponent(i.substring(c,h)),c=-1),n+=E):c===-1&&(c=h)}}return c!==-1&&(n+=encodeURIComponent(i.substring(c))),n!==void 0?n:i}function m(i){let a;for(let n=0;n<i.length;n++){const c=i.charCodeAt(n);c===35||c===63?(a===void 0&&(a=i.substr(0,n)),a+=S[c]):a!==void 0&&(a+=i[n])}return a!==void 0?a:i}function l(i,a){let n;return i.authority&&i.path.length>1&&i.scheme==="file"?n=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?n=i.path.substr(1):n=i.path[1].toLowerCase()+i.path.substr(2):n=i.path,v.isWindows&&(n=n.replace(/\//g,"\\")),n}e.uriToFsPath=l;function o(i,a){const n=a?m:w;let c="",{scheme:h,authority:y,path:E,query:d,fragment:O}=i;if(h&&(c+=h,c+=":"),(y||h==="file")&&(c+=f,c+=f),y){let A=y.indexOf("@");if(A!==-1){const j=y.substr(0,A);y=y.substr(A+1),A=j.indexOf(":"),A===-1?c+=n(j,!1):(c+=n(j.substr(0,A),!1),c+=":",c+=n(j.substr(A+1),!1)),c+="@"}y=y.toLowerCase(),A=y.indexOf(":"),A===-1?c+=n(y,!1):(c+=n(y.substr(0,A),!1),c+=y.substr(A))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const A=E.charCodeAt(1);A>=65&&A<=90&&(E=`/${String.fromCharCode(A+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const A=E.charCodeAt(0);A>=65&&A<=90&&(E=`${String.fromCharCode(A+32)}:${E.substr(2)}`)}c+=n(E,!0)}return d&&(c+="?",c+=n(d,!1)),O&&(c+="#",c+=a?O:w(O,!1)),c}function s(i){try{return decodeURIComponent(i)}catch(a){return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,a=>s(a)):i}}),define(ee[84],te([0,1,7]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function k(g){const I=g;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=k;function _(g){const I=[];let f;try{const b=JSON.parse(g.arguments),C=b[b.length-1];C&&C.__$stack&&(b.pop(),f=C.__$stack),I.push(...b)}catch(b){I.push("Unable to log remote console arguments",g.arguments)}return{args:I,stack:f}}e.parse=_;function R(g){if(typeof g!="string")return R(_(g).stack);const I=g;if(I){const f=P(I),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(f||"");if(b&&b.length===4)return{uri:v.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=R;function P(g){if(!g)return g;const I=g.indexOf(`
`);return I===-1?g:g.substring(0,I)}function L(g,I){const{args:f,stack:b}=_(g),C=typeof f[0]=="string"&&f.length===1;let u=P(b);u&&(u=`(${u.trim()})`);let D=[];if(typeof f[0]=="string"?u&&C?D=[`%c[${I}] %c${f[0]} %c${u}`,p("blue"),p(""),p("grey")]:D=[`%c[${I}] %c${f[0]}`,p("blue"),p(""),...f.slice(1)]:D=[`%c[${I}]%`,p("blue"),...f],u&&!C&&D.push(u),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,D)}e.log=L;function p(g){return`color: ${g}`}}),define(ee[32],te([0,1,7,20]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function _(m,l,o){let s=m.get(l);return s===void 0&&(s=o,m.set(l,s)),s}e.getOrSet=_;function R(m){const l=[];return m.forEach((o,s)=>{l.push(`${s} => ${o}`)}),`Map(${m.size}) {${l.join(", ")}}`}e.mapToString=R;function P(m){const l=[];return m.forEach(o=>{l.push(o)}),`Set(${m.size}) {${l.join(", ")}}`}e.setToString=P;class L{constructor(){this._value="",this._pos=0}reset(l){return this._value=l,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(l){const o=l.charCodeAt(0),s=this._value.charCodeAt(this._pos);return o-s}value(){return this._value[this._pos]}}e.StringIterator=L;class p{constructor(l=!0){this._caseSensitive=l}reset(l){return this._value=l,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(l)this._from++;else break;else l=!1;return this}cmp(l){return this._caseSensitive?k.compareSubstring(l,this._value,0,l.length,this._from,this._to):k.compareSubstringIgnoreCase(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=p;class g{constructor(l=!0,o=!0){this._splitOnBackslash=l,this._caseSensitive=o}reset(l){return this._value=l.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(l)this._from++;else break;else l=!1}return this}cmp(l){return this._caseSensitive?k.compareSubstring(l,this._value,0,l.length,this._from,this._to):k.compareSubstringIgnoreCase(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var I;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(I||(I={}));class f{constructor(l){this._ignorePathCasing=l,this._states=[],this._stateIdx=0}reset(l){return this._value=l,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(l)),this._pathIterator.reset(l.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(l){if(this._states[this._stateIdx]===1)return k.compareIgnoreCase(l,this._value.scheme);if(this._states[this._stateIdx]===2)return k.compareIgnoreCase(l,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(l);if(this._states[this._stateIdx]===4)return k.compare(l,this._value.query);if(this._states[this._stateIdx]===5)return k.compare(l,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class b{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class C{constructor(l){this._iter=l}static forUris(l=()=>!1){return new C(new f(l))}static forPaths(){return new C(new g)}static forStrings(){return new C(new L)}static forConfigKeys(){return new C(new p)}clear(){this._root=void 0}set(l,o){const s=this._iter.reset(l);let t;for(this._root||(this._root=new b,this._root.segment=s.value()),t=this._root;;){const i=s.cmp(t.segment);if(i>0)t.left||(t.left=new b,t.left.segment=s.value()),t=t.left;else if(i<0)t.right||(t.right=new b,t.right.segment=s.value()),t=t.right;else if(s.hasNext())s.next(),t.mid||(t.mid=new b,t.mid.segment=s.value()),t=t.mid;else break}const r=t.value;return t.value=o,t.key=l,r}get(l){var o;return(o=this._getNode(l))===null||o===void 0?void 0:o.value}_getNode(l){const o=this._iter.reset(l);let s=this._root;for(;s;){const t=o.cmp(s.segment);if(t>0)s=s.left;else if(t<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else break}return s}has(l){const o=this._getNode(l);return!((o==null?void 0:o.value)===void 0&&(o==null?void 0:o.mid)===void 0)}delete(l){return this._delete(l,!1)}deleteSuperstr(l){return this._delete(l,!0)}_delete(l,o){const s=this._iter.reset(l),t=[];let r=this._root;for(;r;){const i=s.cmp(r.segment);if(i>0)t.push([1,r]),r=r.left;else if(i<0)t.push([-1,r]),r=r.right;else if(s.hasNext())s.next(),t.push([0,r]),r=r.mid;else{for(o?(r.left=void 0,r.mid=void 0,r.right=void 0):r.value=void 0;t.length>0&&r.isEmpty();){let[a,n]=t.pop();switch(a){case 1:n.left=void 0;break;case 0:n.mid=void 0;break;case-1:n.right=void 0;break}r=n}break}}}findSubstr(l){const o=this._iter.reset(l);let s=this._root,t;for(;s;){const r=o.cmp(s.segment);if(r>0)s=s.left;else if(r<0)s=s.right;else if(o.hasNext())o.next(),t=s.value||t,s=s.mid;else break}return s&&s.value||t}findSuperstr(l){const o=this._iter.reset(l);let s=this._root;for(;s;){const t=o.cmp(s.segment);if(t>0)s=s.left;else if(t<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(l){for(const[o,s]of this)l(s,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(l){l&&(yield*this._entries(l.left),l.value&&(yield[l.key,l.value]),yield*this._entries(l.mid),yield*this._entries(l.right))}}e.TernarySearchTree=C;class u{constructor(l,o){this[Symbol.toStringTag]="ResourceMap",l instanceof u?(this.map=new Map(l.map),this.toKey=o!=null?o:u.defaultToKey):(this.map=new Map,this.toKey=l!=null?l:u.defaultToKey)}set(l,o){return this.map.set(this.toKey(l),o),this}get(l){return this.map.get(this.toKey(l))}has(l){return this.map.has(this.toKey(l))}get size(){return this.map.size}clear(){this.map.clear()}delete(l){return this.map.delete(this.toKey(l))}forEach(l,o){typeof o!="undefined"&&(l=l.bind(o));for(let[s,t]of this.map)l(t,v.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let l of this.map.keys())yield v.URI.parse(l)}*entries(){for(let l of this.map.entries())yield[v.URI.parse(l[0]),l[1]]}*[Symbol.iterator](){for(let l of this.map)yield[v.URI.parse(l[0]),l[1]]}}e.ResourceMap=u,u.defaultToKey=m=>m.toString();var D;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(D=e.Touch||(e.Touch={}));class S{constructor(){this[Symbol.toStringTag]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var l;return(l=this._head)===null||l===void 0?void 0:l.value}get last(){var l;return(l=this._tail)===null||l===void 0?void 0:l.value}has(l){return this._map.has(l)}get(l,o=0){const s=this._map.get(l);if(!!s)return o!==0&&this.touch(s,o),s.value}set(l,o,s=0){let t=this._map.get(l);if(t)t.value=o,s!==0&&this.touch(t,s);else{switch(t={key:l,value:o,next:void 0,previous:void 0},s){case 0:this.addItemLast(t);break;case 1:this.addItemFirst(t);break;case 2:this.addItemLast(t);break;default:this.addItemLast(t);break}this._map.set(l,t),this._size++}return this}delete(l){return!!this.remove(l)}remove(l){const o=this._map.get(l);if(!!o)return this._map.delete(l),this.removeItem(o),this._size--,o.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const l=this._head;return this._map.delete(l.key),this.removeItem(l),this._size--,l.value}}forEach(l,o){const s=this._state;let t=this._head;for(;t;){if(o?l.bind(o)(t.value,t.key,this):l(t.value,t.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const l=this,o=this._state;let s=this._head;const t={[Symbol.iterator](){return t},next(){if(l._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const r={value:s.key,done:!1};return s=s.next,r}else return{value:void 0,done:!0}}};return t}values(){const l=this,o=this._state;let s=this._head;const t={[Symbol.iterator](){return t},next(){if(l._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const r={value:s.value,done:!1};return s=s.next,r}else return{value:void 0,done:!0}}};return t}entries(){const l=this,o=this._state;let s=this._head;const t={[Symbol.iterator](){return t},next(){if(l._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const r={value:[s.key,s.value],done:!1};return s=s.next,r}else return{value:void 0,done:!0}}};return t}[Symbol.iterator](){return this.entries()}trimOld(l){if(!(l>=this.size)){if(l===0){this.clear();return}let o=this._head,s=this.size;for(;o&&s>l;)this._map.delete(o.key),o=o.next,s--;this._head=o,this._size=s,o&&(o.previous=void 0),this._state++}}addItemFirst(l){if(!this._head&&!this._tail)this._tail=l;else if(this._head)l.next=this._head,this._head.previous=l;else throw new Error("Invalid list");this._head=l,this._state++}addItemLast(l){if(!this._head&&!this._tail)this._head=l;else if(this._tail)l.previous=this._tail,this._tail.next=l;else throw new Error("Invalid list");this._tail=l,this._state++}removeItem(l){if(l===this._head&&l===this._tail)this._head=void 0,this._tail=void 0;else if(l===this._head){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this._head=l.next}else if(l===this._tail){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this._tail=l.previous}else{const o=l.next,s=l.previous;if(!o||!s)throw new Error("Invalid list");o.previous=s,s.next=o}l.next=void 0,l.previous=void 0,this._state++}touch(l,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(l===this._head)return;const s=l.next,t=l.previous;l===this._tail?(t.next=void 0,this._tail=t):(s.previous=t,t.next=s),l.previous=void 0,l.next=this._head,this._head.previous=l,this._head=l,this._state++}else if(o===2){if(l===this._tail)return;const s=l.next,t=l.previous;l===this._head?(s.previous=void 0,this._head=s):(s.previous=t,t.next=s),l.next=void 0,l.previous=this._tail,this._tail.next=l,this._tail=l,this._state++}}}toJSON(){const l=[];return this.forEach((o,s)=>{l.push([s,o])}),l}fromJSON(l){this.clear();for(const[o,s]of l)this.set(o,s)}}e.LinkedMap=S;class w extends S{constructor(l,o=1){super();this._limit=l,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(l){this._limit=l,this.checkTrim()}get ratio(){return this._ratio}set ratio(l){this._ratio=Math.min(Math.max(0,l),1),this.checkTrim()}get(l,o=2){return super.get(l,o)}peek(l){return super.get(l,0)}set(l,o){return super.set(l,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=w}),define(ee[85],te([0,1,20,35,4,32,8]),function(G,e,v,k,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function L(){return Object.create(null)}e.getEmptyExpression=L;const p="**",g="/",I="[/\\\\]",f="[^/\\\\]",b=/\//g;function C(T){switch(T){case 0:return"";case 1:return`${f}*?`;default:return`(?:${I}|${f}+${I}|${I}${f}+)*?`}}function u(T,U){if(!T)return[];const M=[];let q=!1,H=!1,X="";for(const Q of T){switch(Q){case U:if(!q&&!H){M.push(X),X="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":H=!0;break;case"]":H=!1;break}X+=Q}return X&&M.push(X),M}e.splitGlobAware=u;function D(T){if(!T)return"";let U="";const M=u(T,g);if(M.every(q=>q===p))U=".*";else{let q=!1;M.forEach((H,X)=>{if(H===p){q||(U+=C(2),q=!0);return}let Q=!1,Z="",ne=!1,le="";for(const me of H){if(me!=="}"&&Q){Z+=me;continue}if(ne&&(me!=="]"||!le)){let se;me==="-"?se=me:(me==="^"||me==="!")&&!le?se="^":me===g?se="":se=v.escapeRegExpCharacters(me),le+=se;continue}switch(me){case"{":Q=!0;continue;case"[":ne=!0;continue;case"}":U+=`(?:${u(Z,",").map(fe=>D(fe)).join("|")})`,Q=!1,Z="";break;case"]":U+="["+le+"]",ne=!1,le="";break;case"?":U+=f;continue;case"*":U+=C(1);continue;default:U+=v.escapeRegExpCharacters(me)}}X<M.length-1&&(M[X+1]!==p||X+2<M.length)&&(U+=I),q=!1})}return U}const S=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),r=function(){return!1},i=function(){return null};function a(T,U){if(!T)return i;let M;typeof T!="string"?M=T.pattern:M=T,M=M.trim();const q=`${M}_${!!U.trimForExclusions}`;let H=t.get(q);if(H)return n(H,T);let X;if(S.test(M)){const Q=M.substr(4);H=function(Z,ne){return typeof Z=="string"&&Z.endsWith(Q)?M:null}}else(X=w.exec(c(M,U)))?H=h(X[1],M):(U.trimForExclusions?l:m).test(M)?H=y(M,U):(X=o.exec(c(M,U)))?H=E(X[1].substr(1),M,!0):(X=s.exec(c(M,U)))?H=E(X[1],M,!1):H=d(M);return t.set(q,H),n(H,T)}function n(T,U){return typeof U=="string"?T:function(M,q){return k.isEqualOrParent(M,U.base)?T(_.relative(U.base,M),q):null}}function c(T,U){return U.trimForExclusions&&T.endsWith("/**")?T.substr(0,T.length-2):T}function h(T,U){const M=`/${T}`,q=`\\${T}`,H=function(Q,Z){return typeof Q!="string"?null:Z?Z===T?U:null:Q===T||Q.endsWith(M)||Q.endsWith(q)?U:null},X=[T];return H.basenames=X,H.patterns=[U],H.allBasenames=X,H}function y(T,U){const M=$(T.slice(1,-1).split(",").map(Z=>a(Z,U)).filter(Z=>Z!==i),T),q=M.length;if(!q)return i;if(q===1)return M[0];const H=function(Z,ne){for(let le=0,me=M.length;le<me;le++)if(M[le](Z,ne))return T;return null},X=M.find(Z=>!!Z.allBasenames);X&&(H.allBasenames=X.allBasenames);const Q=M.reduce((Z,ne)=>ne.allPaths?Z.concat(ne.allPaths):Z,[]);return Q.length&&(H.allPaths=Q),H}function E(T,U,M){const q=_.sep===_.posix.sep,H=q?T:T.replace(b,_.sep),X=_.sep+H,Q=_.posix.sep+T,Z=M?function(ne,le){return typeof ne=="string"&&(ne===H||ne.endsWith(X)||!q&&(ne===T||ne.endsWith(Q)))?U:null}:function(ne,le){return typeof ne=="string"&&(ne===H||!q&&ne===T)?U:null};return Z.allPaths=[(M?"*/":"./")+T],Z}function d(T){try{const U=new RegExp(`^${D(T)}$`);return function(M){return U.lastIndex=0,typeof M=="string"&&U.test(M)?T:null}}catch(U){return i}}function O(T,U,M){return!T||typeof U!="string"?!1:A(T)(U,void 0,M)}e.match=O;function A(T,U={}){if(!T)return r;if(typeof T=="string"||N(T)){const M=a(T,U);if(M===i)return r;const q=function(H,X){return!!M(H,X)};return M.allBasenames&&(q.allBasenames=M.allBasenames),M.allPaths&&(q.allPaths=M.allPaths),q}return B(T,U)}e.parse=A;function j(T){if(!!T){let U;return M=>(U||(U=(T()||Promise.resolve([])).then(q=>q?W(q):{})),U.then(q=>!!q[M]))}}e.hasSiblingPromiseFn=j;function z(T){if(!!T){let U;return M=>{if(!U){const q=T();U=q?W(q):{}}return!!U[M]}}}e.hasSiblingFn=z;function W(T){const U={};for(const M of T)U[M]=!0;return U}function N(T){const U=T;return U&&typeof U.base=="string"&&typeof U.pattern=="string"}e.isRelativePattern=N;function x(T){return T.allBasenames||[]}e.getBasenameTerms=x;function F(T){return T.allPaths||[]}e.getPathTerms=F;function B(T,U){const M=$(Object.getOwnPropertyNames(T).map(Z=>K(Z,T[Z],U)).filter(Z=>Z!==i)),q=M.length;if(!q)return i;if(!M.some(Z=>!!Z.requiresSiblings)){if(q===1)return M[0];const Z=function(me,se){for(let ce=0,fe=M.length;ce<fe;ce++){const ye=M[ce](me,se);if(ye)return ye}return null},ne=M.find(me=>!!me.allBasenames);ne&&(Z.allBasenames=ne.allBasenames);const le=M.reduce((me,se)=>se.allPaths?me.concat(se.allPaths):me,[]);return le.length&&(Z.allPaths=le),Z}const H=function(Z,ne,le){let me;for(let se=0,ce=M.length;se<ce;se++){const fe=M[se];fe.requiresSiblings&&le&&(ne||(ne=_.basename(Z)),me||(me=ne.substr(0,ne.length-_.extname(Z).length)));const ye=fe(Z,ne,me,le);if(ye)return ye}return null},X=M.find(Z=>!!Z.allBasenames);X&&(H.allBasenames=X.allBasenames);const Q=M.reduce((Z,ne)=>ne.allPaths?Z.concat(ne.allPaths):Z,[]);return Q.length&&(H.allPaths=Q),H}function K(T,U,M){if(U===!1)return i;const q=a(T,M);if(q===i)return i;if(typeof U=="boolean")return q;if(U){const H=U.when;if(typeof H=="string"){const X=(Q,Z,ne,le)=>{if(!le||!q(Q,Z))return null;const me=H.replace("$(basename)",ne),se=le(me);return P.isThenable(se)?se.then(ce=>ce?T:null):se?T:null};return X.requiresSiblings=!0,X}}return q}function $(T,U){const M=T.filter(Z=>!!Z.basenames);if(M.length<2)return T;const q=M.reduce((Z,ne)=>{const le=ne.basenames;return le?Z.concat(le):Z},[]);let H;if(U){H=[];for(let Z=0,ne=q.length;Z<ne;Z++)H.push(U)}else H=M.reduce((Z,ne)=>{const le=ne.patterns;return le?Z.concat(le):Z},[]);const X=function(Z,ne){if(typeof Z!="string")return null;if(!ne){let me;for(me=Z.length;me>0;me--){const se=Z.charCodeAt(me-1);if(se===47||se===92)break}ne=Z.substr(me)}const le=q.indexOf(ne);return le!==-1?H[le]:null};X.basenames=q,X.patterns=H,X.allBasenames=q;const Q=T.filter(Z=>!Z.basenames);return Q.push(X),Q}}),define(ee[86],te([0,1,16,20,7]),function(G,e,v,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(g){return JSON.stringify(g,L)}e.stringify=R;function P(g){let I=JSON.parse(g);return I=p(I),I}e.parse=P;function L(g,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:k.regExpFlags(I)}:I}function p(g,I=0){if(!g||I>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return _.URI.revive(g);case 2:return new RegExp(g.source,g.flags)}if(g instanceof v.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let f=0;f<g.length;++f)g[f]=p(g[f],I+1);else for(const f in g)Object.hasOwnProperty.call(g,f)&&(g[f]=p(g[f],I+1))}return g}e.revive=p}),define(ee[14],te([0,1,7,6]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var _;(function(L){L.inMemory="inmemory",L.vscode="vscode",L.internal="private",L.walkThrough="walkThrough",L.walkThroughSnippet="walkThroughSnippet",L.http="http",L.https="https",L.file="file",L.mailto="mailto",L.untitled="untitled",L.data="data",L.command="command",L.vscodeRemote="vscode-remote",L.vscodeRemoteResource="vscode-remote-resource",L.userData="vscode-userdata",L.vscodeCustomEditor="vscode-custom-editor",L.vscodeNotebook="vscode-notebook",L.vscodeNotebookCell="vscode-notebook-cell",L.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",L.vscodeSettings="vscode-settings",L.webviewPanel="webview-panel",L.vscodeWebview="vscode-webview",L.vscodeWebviewResource="vscode-webview-resource",L.extension="extension",L.vscodeFileResource="vscode-file"})(_=e.Schemas||(e.Schemas={}));class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}set(p,g,I){this._hosts[p]=g,this._ports[p]=I}setConnectionToken(p,g){this._connectionTokens[p]=g}rewrite(p){if(this._delegate)return this._delegate(p);const g=p.authority;let I=this._hosts[g];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const f=this._ports[g],b=this._connectionTokens[g];let C=`path=${encodeURIComponent(p.path)}`;return typeof b=="string"&&(C+=`&tkn=${encodeURIComponent(b)}`),v.URI.from({scheme:k.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${I}:${f}`,path:"/vscode-remote-resource",query:C})}}e.RemoteAuthorities=new R;class P{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(p,g,I){const f=this.toUri(p,g);return f.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(f):k.isNative&&(I||k.isPreferringBrowserCodeLoad)&&f.scheme===_.file?f.with({scheme:_.vscodeFileResource,authority:f.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):f}asFileUri(p,g){const I=this.toUri(p,g);return I.scheme===_.vscodeFileResource?I.with({scheme:_.file,authority:I.authority!==this.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(p,g){return v.URI.isUri(p)?p:v.URI.parse(g.toUrl(p))}}e.FileAccess=new P}),define(ee[64],te([0,1,32]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const k=new v.LRUCache(1e4);function _(g){return p(g,"NFC",k)}e.normalizeNFC=_;const R=new v.LRUCache(1e4);function P(g){return p(g,"NFD",R)}e.normalizeNFD=P;const L=/[^\u0000-\u0080]/;function p(g,I,f){if(!e.canNormalize||!g)return g;const b=f.get(g);if(b)return b;let C;return L.test(g)?C=g.normalize(I):C=g,f.set(g,C),C}e.removeAccents=function(){if(e.canNormalize){const g=/[\u0300-\u036f]/g;return function(I){return P(I).replace(g,"")}}else return function(g){return g}}()}),define(ee[18],te([0,1,35,4,7,20,14,6]),function(G,e,v,k,_,R,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(C){return _.uriToFsPath(C,!0)}e.originalFSPath=p;class g{constructor(u){this._ignorePathCasing=u}compare(u,D,S=!1){return u===D?0:R.compare(this.getComparisonKey(u,S),this.getComparisonKey(D,S))}isEqual(u,D,S=!1){return u===D?!0:!u||!D?!1:this.getComparisonKey(u,S)===this.getComparisonKey(D,S)}getComparisonKey(u,D=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:D?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,D,S=!1){if(u.scheme===D.scheme){if(u.scheme===P.Schemas.file)return v.isEqualOrParent(p(u),p(D),this._ignorePathCasing(u))&&u.query===D.query&&(S||u.fragment===D.fragment);if(e.isEqualAuthority(u.authority,D.authority))return v.isEqualOrParent(u.path,D.path,this._ignorePathCasing(u),"/")&&u.query===D.query&&(S||u.fragment===D.fragment)}return!1}joinPath(u,...D){return _.URI.joinPath(u,...D)}basenameOrAuthority(u){return e.basename(u)||u.authority}basename(u){return k.posix.basename(u.path)}extname(u){return k.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let D;return u.scheme===P.Schemas.file?D=_.URI.file(k.dirname(p(u))).path:(D=k.posix.dirname(u.path),u.authority&&D.length&&D.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),D="/")),u.with({path:D})}normalizePath(u){if(!u.path.length)return u;let D;return u.scheme===P.Schemas.file?D=_.URI.file(k.normalize(p(u))).path:D=k.posix.normalize(u.path),u.with({path:D})}relativePath(u,D){if(!(u.scheme!==D.scheme||!e.isEqualAuthority(u.authority,D.authority))){if(u.scheme===P.Schemas.file){const m=k.relative(p(u),p(D));return L.isWindows?v.toSlashes(m):m}let S=u.path||"/",w=D.path||"/";if(this._ignorePathCasing(u)){let m=0;for(const l=Math.min(S.length,w.length);m<l&&!(S.charCodeAt(m)!==w.charCodeAt(m)&&S.charAt(m).toLowerCase()!==w.charAt(m).toLowerCase());m++);S=w.substr(0,m)+S.substr(m)}return k.posix.relative(S,w)}}resolvePath(u,D){if(u.scheme===P.Schemas.file){const S=_.URI.file(k.resolve(p(u),D));return u.with({authority:S.authority,path:S.path})}return D.indexOf("/")===-1&&(D=v.toSlashes(D),/^[a-zA-Z]:(\/|$)/.test(D)&&(D="/"+D)),u.with({path:k.posix.resolve(u.path,D)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,D){return u===D||R.equalsIgnoreCase(u,D)}hasTrailingPathSeparator(u,D=k.sep){if(u.scheme===P.Schemas.file){const S=p(u);return S.length>v.getRoot(S).length&&S[S.length-1]===D}else{const S=u.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,D=k.sep){return e.hasTrailingPathSeparator(u,D)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,D=k.sep){let S=!1;if(u.scheme===P.Schemas.file){const w=p(u);S=w!==void 0&&w.length===v.getRoot(w).length&&w[w.length-1]===D}else{D="/";const w=u.path;S=w.length===1&&w.charCodeAt(w.length-1)===47}return!S&&!e.hasTrailingPathSeparator(u,D)?u.with({path:u.path+"/"}):u}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(C=>C.scheme===P.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new g(C=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(C,u){const D=[];for(let S=0;S<C.length;S++){const w=u(C[S]);C.some((m,l)=>l===S?!1:e.isEqualOrParent(w,u(m)))||D.push(C[S])}return D}e.distinctParents=I;var f;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function u(D){const S=new Map;D.path.substring(D.path.indexOf(";")+1,D.path.lastIndexOf(";")).split(";").forEach(l=>{const[o,s]=l.split(":");o&&s&&S.set(o,s)});const m=D.path.substring(0,D.path.indexOf(";"));return m&&S.set(C.META_DATA_MIME,m),S}C.parseMetaData=u})(f=e.DataUri||(e.DataUri={}));function b(C,u,D){if(u){let S=C.path;return S&&S[0]!==k.posix.sep&&(S=k.posix.sep+S),C.with({scheme:D,authority:u,path:S})}return C.with({scheme:D})}e.toLocalResource=b}),define(ee[87],te([0,1,7,4,20,14,6,18,35]),function(G,e,v,k,_,R,P,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function g(a,n,c){if(typeof a=="string"&&(a=v.URI.file(a)),c){const y=c.getWorkspaceFolder(a);if(y){const E=c.getWorkspace().folders.length>1;let d;if(L.isEqual(y.uri,a)?d="":d=L.relativePath(y.uri,a),E){const O=y.name?y.name:L.basename(y.uri);d=d?O+" \u2022 "+d:O}return d}}if(a.scheme!==R.Schemas.file&&a.scheme!==R.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if(p.hasDriveLetter(a.fsPath))return k.normalize(f(a.fsPath));let h=k.normalize(a.fsPath);return!P.isWindows&&(n==null?void 0:n.userHome)&&(h=C(h,n.userHome.fsPath)),h}e.getPathLabel=g;function I(a){if(!!a){typeof a=="string"&&(a=v.URI.file(a));const n=L.basename(a)||(a.scheme===R.Schemas.file?a.fsPath:a.path);return P.isWindows&&p.isRootOrDriveLetter(n)?f(n):n}}e.getBaseLabel=I;function f(a){return p.hasDriveLetter(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=f;let b=Object.create(null);function C(a,n){if(P.isWindows||!a||!n)return a;let c=b.original===n?b.normalized:void 0;return c||(c=`${_.rtrim(n,k.posix.sep)}${k.posix.sep}`,b={original:n,normalized:c}),(P.isLinux?a.startsWith(c):_.startsWithIgnoreCase(a,c))&&(a=`~/${a.substr(c.length)}`),a}e.tildify=C;function u(a,n){return a.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=u;const D="\u2026",S="\\\\",w="~";function m(a,n=k.sep){const c=new Array(a.length);let h=!1;for(let y=0;y<a.length;y++){let E=a[y];if(E===""){c[y]=`.${n}`;continue}if(!E){c[y]=E;continue}h=!0;let d="";E.indexOf(S)===0?(d=E.substr(0,E.indexOf(S)+S.length),E=E.substr(E.indexOf(S)+S.length)):E.indexOf(n)===0?(d=E.substr(0,E.indexOf(n)+n.length),E=E.substr(E.indexOf(n)+n.length)):E.indexOf(w)===0&&(d=E.substr(0,E.indexOf(w)+w.length),E=E.substr(E.indexOf(w)+w.length));const O=E.split(n);for(let A=1;h&&A<=O.length;A++)for(let j=O.length-A;h&&j>=0;j--){h=!1;let z=O.slice(j,j+A).join(n);for(let W=0;!h&&W<a.length;W++)if(W!==y&&a[W]&&a[W].indexOf(z)>-1){const N=j+A===O.length,x=j>0&&a[W].indexOf(n)>-1?n+z:z,F=a[W].endsWith(x);h=!N||F}if(!h){let W="";(O[0].endsWith(":")||d!=="")&&(j===1&&(j=0,A++,z=O[0]+n+z),j>0&&(W=O[0]+n),W=d+W),j>0&&(W=W+D+n),W=W+z,j+A<O.length&&(W=W+n+D),c[y]=W}}h&&(c[y]=E)}return c}e.shorten=m;var l;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function o(a,n=Object.create(null)){const c=[];let h=!1,y="";for(const E of a)if(E==="$"||h&&E==="{")y&&c.push({value:y,type:l.TEXT}),y="",h=!0;else if(E==="}"&&h){const d=n[y];if(typeof d=="string")d.length&&c.push({value:d,type:l.VARIABLE});else if(d){const O=c[c.length-1];(!O||O.type!==l.SEPARATOR)&&c.push({value:d.label,type:l.SEPARATOR})}y="",h=!1}else y+=E;return y&&!h&&c.push({value:y,type:l.TEXT}),c.filter((E,d)=>{if(E.type===l.SEPARATOR){const O=c[d-1],A=c[d+1];return[O,A].every(j=>j&&(j.type===l.VARIABLE||j.type===l.TEXT)&&j.value.length>0)}return!0}).map(E=>E.value).join("")}e.template=o;function s(a,n){return P.isMacintosh||n?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):a.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=s;function t(a,n){return P.isMacintosh||n?a.replace(/\(&&\w\)|&&/g,""):P.isWindows?a.replace(/&&|&/g,c=>c==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=r;function i(a){const n=a.indexOf("/")!==-1?k.posix:k.win32,c=n.basename(a),h=n.dirname(a);return c.length?{name:c,parentPath:h}:{name:h,parentPath:""}}e.splitName=i}),define(ee[88],te([0,1,7]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(I){return I.toJSON()}class _{constructor(f){this._uriTransformer=f}transformIncoming(f){const b=this._uriTransformer.transformIncoming(f);return b===f?f:k(v.URI.from(b))}transformOutgoing(f){const b=this._uriTransformer.transformOutgoing(f);return b===f?f:k(v.URI.from(b))}transformOutgoingURI(f){const b=this._uriTransformer.transformOutgoing(f);return b===f?f:v.URI.from(b)}transformOutgoingScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,f,b){if(!I||b>200)return null;if(typeof I=="object"){if(I instanceof v.URI)return f.transformOutgoing(I);for(let C in I)if(Object.hasOwnProperty.call(I,C)){const u=R(I[C],f,b+1);u!==null&&(I[C]=u)}}return null}function P(I,f){const b=R(I,f,0);return b===null?I:b}e.transformOutgoingURIs=P;function L(I,f,b,C){if(!I||C>200)return null;if(typeof I=="object"){if(I.$mid===1)return b?v.URI.revive(f.transformIncoming(I)):f.transformIncoming(I);for(let u in I)if(Object.hasOwnProperty.call(I,u)){const D=L(I[u],f,b,C+1);D!==null&&(I[u]=D)}}return null}function p(I,f){const b=L(I,f,!1,0);return b===null?I:b}e.transformIncomingURIs=p;function g(I,f){const b=L(I,f,!0,0);return b===null?I:b}e.transformAndReviveIncomingURIs=g}),define(ee[30],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(p){return v.test(p)}e.isUUID=k;const _=new Uint8Array(16),R=[];for(let p=0;p<256;p++)R.push(p.toString(16).padStart(2,"0"));const P=function(p){for(let g=0;g<p.length;g++)p[g]=Math.floor(Math.random()*256);return p};function L(){P(_),_[6]=_[6]&15|64,_[8]=_[8]&63|128;let p=0,g="";return g+=R[_[p++]],g+=R[_[p++]],g+=R[_[p++]],g+=R[_[p++]],g+="-",g+=R[_[p++]],g+=R[_[p++]],g+="-",g+=R[_[p++]],g+=R[_[p++]],g+="-",g+=R[_[p++]],g+=R[_[p++]],g+="-",g+=R[_[p++]],g+=R[_[p++]],g+=R[_[p++]],g+=R[_[p++]],g+=R[_[p++]],g+=R[_[p++]],g}e.generateUuid=L}),define(ee[65],te([0,1,202]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class k{constructor(R="utf8"){this.stringDecoder=new v.StringDecoder(R),this.remaining=null}write(R){const P=[],L=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(L.length<1)return P;let p=0,g,I=p;for(;I<L.length;)if(g=L.charCodeAt(I),g===13||g===10){if(P.push(L.substring(p,I)),I++,I<L.length){const f=g;g=L.charCodeAt(I),(f===13&&g===10||f===10&&g===13)&&I++}p=I}else I++;return this.remaining=p<L.length?L.substr(p):null,P}end(){return this.remaining}}e.LineDecoder=k}),define(ee[89],te([0,1,40]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const k=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function _(L){const p=L.replace(/\-/g,":").toLowerCase();return!k.has(p)}function R(){return new Promise(async(L,p)=>{const g=setTimeout(()=>p("Unable to retrieve mac address (timeout after 10s)"),1e4);try{L(await P())}catch(I){p(I)}finally{clearTimeout(g)}})}e.getMac=R;function P(){return new Promise((L,p)=>{try{const g=v.networkInterfaces();for(const[,I]of Object.entries(g))for(const f of I)if(_(f.mac))return L(f.mac);p("Unable to retrieve mac address (unexpected format)")}catch(g){p(g)}})}}),define(ee[90],te([0,1,13,30,40,32,89]),function(G,e,v,k,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,f=0;const b=_.networkInterfaces();for(let C in b)if(Object.prototype.hasOwnProperty.call(b,C))for(const{mac:u,internal:D}of b[C])D||(f+=1,this._isVirtualMachineMacAdress(u.toUpperCase())&&(I+=1));this._value=f>0?I/f:0}return this._value}};let L;async function p(){return L||(L=(async()=>await g()||k.generateUuid())()),L}e.getMachineId=p;async function g(){try{const I=await new Promise((b,C)=>{G(["crypto"],b,C)}),f=await P.getMac();return I.createHash("sha256").update(f,"utf8").digest("hex")}catch(I){v.onUnexpectedError(I);return}}}),define(ee[91],te([0,1,14]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getDefaultUserDataPath=void 0;const k=v.FileAccess.asFileUri("paths",G).fsPath,_=G.__$__nodeRequire(k);e.getDefaultUserDataPath=_.getDefaultUserDataPath}),define(ee[22],te([0,1,36,40,4,8,6,3,53,35,30,64]),function(G,e,v,k,_,R,P,L,p,g,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.copy=e.move=e.whenDeleted=e.fileExists=e.dirExists=e.readDirsInDir=e.writeFileSync=e.writeFile=e.mkdirp=e.readFile=e.truncate=e.symlink=e.unlink=e.readlink=e.renameIgnoreError=e.rename=e.lstat=e.statLink=e.stat=e.chmod=e.exists=e.readdirSync=e.readdirWithFileTypes=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=e.MAX_HEAP_SIZE=e.MAX_FILE_SIZE=void 0;const b=300*1024*1024,C=16*1024*1024*1024,u=700*1024*1024,D=700*2*1024*1024;e.MAX_FILE_SIZE=process.arch==="ia32"?b:C,e.MAX_HEAP_SIZE=process.arch==="ia32"?u:D;var S;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function w(se,ce=S.UNLINK){if(g.isRootOrDriveLetter(se))throw new Error("rimraf - will refuse to recursively delete root");return ce===S.UNLINK?m(se):l(se)}e.rimraf=w;async function m(se){try{const ce=await y(se);if(ce.isDirectory()&&!ce.isSymbolicLink()){const fe=await s(se);await Promise.all(fe.map(ye=>m(_.join(se,ye)))),await p.promisify(v.rmdir)(se)}else{const fe=ce.mode;return fe&v.constants.S_IWUSR||await n(se,fe|v.constants.S_IWUSR),A(se)}}catch(ce){if(ce.code!=="ENOENT")throw ce}}async function l(se){try{const ce=_.join(k.tmpdir(),I.generateUuid());try{await E(se,ce)}catch(fe){return m(se)}m(ce)}catch(ce){if(ce.code!=="ENOENT")throw ce}}function o(se){if(g.isRootOrDriveLetter(se))throw new Error("rimraf - will refuse to recursively delete root");try{const ce=v.lstatSync(se);if(ce.isDirectory()&&!ce.isSymbolicLink())r(se).map(ye=>o(_.join(se,ye))),v.rmdirSync(se);else{const fe=ce.mode;return fe&v.constants.S_IWUSR||v.chmodSync(se,fe|v.constants.S_IWUSR),v.unlinkSync(se)}}catch(ce){if(ce.code!=="ENOENT")throw ce}}e.rimrafSync=o;async function s(se){return i(await p.promisify(v.readdir)(se))}e.readdir=s;async function t(se){const ce=await p.promisify(v.readdir)(se,{withFileTypes:!0});if(P.isMacintosh)for(const fe of ce)fe.name=f.normalizeNFC(fe.name);return ce}e.readdirWithFileTypes=t;function r(se){return i(v.readdirSync(se))}e.readdirSync=r;function i(se){return P.isMacintosh?se.map(ce=>f.normalizeNFC(ce)):se}function a(se){return p.promisify(v.exists)(se)}e.exists=a;function n(se,ce){return p.promisify(v.chmod)(se,ce)}e.chmod=n;function c(se){return p.promisify(v.stat)(se)}e.stat=c;async function h(se){let ce;try{if(ce=await y(se),!ce.isSymbolicLink())return{stat:ce}}catch(fe){}try{return{stat:await c(se),symbolicLink:(ce==null?void 0:ce.isSymbolicLink())?{dangling:!1}:void 0}}catch(fe){if(fe.code==="ENOENT"&&ce)return{stat:ce,symbolicLink:{dangling:!0}};if(P.isWindows&&fe.code==="EACCES"&&ce)try{return{stat:await c(await O(se)),symbolicLink:ce.isSymbolicLink()?{dangling:!1}:void 0}}catch(ye){if(ye.code==="ENOENT")return{stat:ce,symbolicLink:{dangling:!0}};throw ye}throw fe}}e.statLink=h;function y(se){return p.promisify(v.lstat)(se)}e.lstat=y;function E(se,ce){return p.promisify(v.rename)(se,ce)}e.rename=E;function d(se,ce){return new Promise(fe=>v.rename(se,ce,()=>fe()))}e.renameIgnoreError=d;function O(se){return p.promisify(v.readlink)(se)}e.readlink=O;function A(se){return p.promisify(v.unlink)(se)}e.unlink=A;function j(se,ce,fe){return p.promisify(v.symlink)(se,ce,fe)}e.symlink=j;function z(se,ce){return p.promisify(v.truncate)(se,ce)}e.truncate=z;function W(se,ce){return p.promisify(v.readFile)(se,ce)}e.readFile=W;async function N(se,ce){return p.promisify(v.mkdir)(se,{mode:ce,recursive:!0})}e.mkdirp=N;const x=new Map;function F(se,ce,fe){const ye=B(se);return K(ye).queue(()=>{const De=M(fe);return new Promise((Le,Ce)=>T(se,ce,De,Ae=>Ae?Ce(Ae):Le()))})}e.writeFile=F;function B(se){let ce=se;return(P.isWindows||P.isMacintosh)&&(ce=ce.toLowerCase()),ce}function K(se){const ce=x.get(se);if(ce)return ce;const fe=new R.Queue;return x.set(se,fe),L.Event.once(fe.onFinished)(()=>{x.delete(se),fe.dispose()}),fe}let $=!0;function T(se,ce,fe,ye){if(!$)return v.writeFile(se,ce,{mode:fe.mode,flag:fe.flag},ye);v.open(se,fe.flag,fe.mode,(De,Le)=>{if(De)return ye(De);v.writeFile(Le,ce,Ce=>{if(Ce)return v.close(Le,()=>ye(Ce));v.fdatasync(Le,Ae=>(Ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Ae),$=!1),v.close(Le,Re=>ye(Re))))})})}function U(se,ce,fe){const ye=M(fe);if(!$)return v.writeFileSync(se,ce,{mode:ye.mode,flag:ye.flag});const De=v.openSync(se,ye.flag,ye.mode);try{v.writeFileSync(De,ce);try{v.fdatasyncSync(De)}catch(Le){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Le),$=!1}}finally{v.closeSync(De)}}e.writeFileSync=U;function M(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function q(se){const ce=await s(se),fe=[];for(const ye of ce)await H(_.join(se,ye))&&fe.push(ye);return fe}e.readDirsInDir=q;async function H(se){try{const{stat:ce,symbolicLink:fe}=await h(se);return ce.isDirectory()&&(fe==null?void 0:fe.dangling)!==!0}catch(ce){}return!1}e.dirExists=H;async function X(se){try{const{stat:ce,symbolicLink:fe}=await h(se);return ce.isFile()&&(fe==null?void 0:fe.dangling)!==!0}catch(ce){}return!1}e.fileExists=X;function Q(se){return new Promise(ce=>{let fe=!1;const ye=setInterval(()=>{fe||(fe=!0,v.exists(se,De=>{fe=!1,De||(clearInterval(ye),ce(void 0))}))},1e3)})}e.whenDeleted=Q;async function Z(se,ce){if(se!==ce){async function fe(ye){const De=await y(ye);if(!(De.isDirectory()||De.isSymbolicLink())){const Le=await p.promisify(v.open)(ye,"a");try{await p.promisify(v.futimes)(Le,De.atime,new Date)}catch(Ce){}return p.promisify(v.close)(Le)}}try{await E(se,ce),await fe(ce)}catch(ye){if(se.toLowerCase()!==ce.toLowerCase()&&ye.code==="EXDEV"||se.endsWith("."))await le(se,ce),await w(se,S.MOVE),await fe(ce);else throw ye}}}e.move=Z;const ne=511;async function le(se,ce,fe){const ye=fe!=null?fe:Object.create(null);if(!ye[se]){ye[se]=!0;const{stat:De,symbolicLink:Le}=await h(se);if(!(Le==null?void 0:Le.dangling)){if(!De.isDirectory())return me(se,ce,De.mode&ne);await N(ce,De.mode&ne);const Ce=await s(se);for(let Ae=0;Ae<Ce.length;Ae++){const Re=Ce[Ae];await le(_.join(se,Re),_.join(ce,Re),ye)}}}}e.copy=le;async function me(se,ce,fe){return new Promise((ye,De)=>{const Le=v.createReadStream(se),Ce=v.createWriteStream(ce,{mode:fe});let Ae=!1;const Re=_e=>{if(!Ae){if(Ae=!0,_e)return De(_e);v.chmod(ce,fe,Me=>Me?De(Me):ye())}};Le.once("error",_e=>Re(_e)),Ce.once("error",_e=>Re(_e)),Ce.once("close",()=>Re()),Le.pipe(Ce)})}}),define(ee[92],te([0,1,36,20,4,22,53]),function(G,e,v,k,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function L(f){const b=_.dirname(f);if(f===b)return f;const C=(_.basename(f)||f).toLowerCase();try{const D=R.readdirSync(b).filter(S=>S.toLowerCase()===C);if(D.length===1){const S=L(b);if(S)return _.join(S,D[0])}else if(D.length>1){const S=D.indexOf(C);if(S>=0){const w=L(b);if(w)return _.join(w,D[S])}}}catch(u){}return null}e.realcaseSync=L;async function p(f){try{return await P.promisify(v.realpath)(f)}catch(b){const C=I(f);return await P.promisify(v.access)(C,v.constants.R_OK),C}}e.realpath=p;function g(f){try{return v.realpathSync(f)}catch(b){const C=I(f);return v.accessSync(C,v.constants.R_OK),C}}e.realpathSync=g;function I(f){return k.rtrim(_.normalize(f),_.sep)}}),define(ee[93],te([0,1,47,14]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function _(P){return new Promise((L,p)=>{let g;const I=new Map;function f(u,D,S,w,m){const l=I.get(D);if(u===P||l){const o={name:b(S),cmd:S,pid:u,ppid:D,load:w,mem:m};I.set(u,o),u===P&&(g=o),l&&(l.children||(l.children=[]),l.children.push(o),l.children.length>1&&(l.children=l.children.sort((s,t)=>s.pid-t.pid)))}}function b(u){const D=/--disable-blink-features=Auxclick/,S=/\\watcher\\win32\\CodeHelper\.exe/,w=/--crashes-directory/,m=/\\pipe\\winpty-control/,l=/conhost\.exe/,o=/--type=([a-zA-Z-]+)/;if(S.exec(u))return"watcherService ";if(w.exec(u))return"electron-crash-reporter";if(m.exec(u))return"winpty-process";if(l.exec(u))return"console-window-host (Windows internal process)";let s=o.exec(u);if(s&&s.length===2)return s[1]==="renderer"?D.exec(u)?"shared-process":"window":s[1];const t=/[a-zA-Z-]+\.js/g;let r="";do s=t.exec(u),s&&(r+=s+" ");while(s);return r&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron_node ${r}`:u}if(process.platform==="win32"){const u=D=>D.indexOf("\\\\?\\")===0||D.indexOf("\\??\\")===0?D.substr(4):D.indexOf('"\\\\?\\')===0||D.indexOf('"\\??\\')===0?'"'+D.substr(5):D;new Promise((D,S)=>{G(["windows-process-tree"],D,S)}).then(D=>{D.getProcessList(P,S=>{D.getProcessCpuUsage(S,w=>{const m=new Map;w.forEach(l=>{const o=u(l.commandLine||"");m.set(l.pid,{name:b(o),cmd:o,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),g=m.get(P),g?(m.forEach(l=>{const o=m.get(l.ppid);o&&(o.children||(o.children=[]),o.children.push(l))}),m.forEach(l=>{l.children&&(l.children=l.children.sort((o,s)=>o.pid-s.pid))}),L(g)):p(new Error(`Root process ${P} not found`))})},D.ProcessDataFlag.CommandLine|D.ProcessDataFlag.Memory)})}else{function C(){let u=[g];const D=[];for(;u.length;){const w=u.shift();w&&(D.push(w.pid),w.children&&(u=u.concat(w.children)))}let S=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",G).fsPath);S+=" "+D.join(" "),v.exec(S,{},(w,m,l)=>{if(w||l)p(w||new Error(l.toString()));else{const o=m.toString().split(`
`);for(let s=0;s<D.length;s++){const t=I.get(D[s]);t.load=parseFloat(o[s])}if(!g){p(new Error(`Root process ${P} not found`));return}L(g)}})}v.exec("which ps",{},(u,D,S)=>{if(u||S)if(process.platform!=="linux")p(u||new Error(S.toString()));else{const w=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/ps.sh",G).fsPath);v.exec(w,{},(m,l,o)=>{m||o?p(m||new Error(o.toString())):(R(l,f),C())})}else{const w=D.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";v.exec(`${w} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,o,s)=>{l||s&&!s.includes("screen size is bogus")?p(l||new Error(s.toString())):(R(o,f),process.platform==="linux"?C():g?L(g):p(new Error(`Root process ${P} not found`)))})}})}})}e.listProcesses=_;function R(P,L){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=P.toString().split(`
`);for(const I of g){const f=p.exec(I.trim());f&&f.length===6&&L(parseInt(f[1]),parseInt(f[2]),f[5],parseFloat(f[3]),parseFloat(f[4]))}}}),define(ee[94],te([0,1,4,36,6,64,2,22]),function(G,e,v,k,_,R,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function p(f,b,C){return I({path:f,isDirectory:!1},b,C)}e.watchFile=p;function g(f,b,C){return I({path:f,isDirectory:!0},b,C)}e.watchFolder=g,e.CHANGE_BUFFER_DELAY=100;function I(f,b,C){const u=v.basename(f.path),D=new Map;let S=!1,w=[P.toDisposable(()=>{D.forEach(m=>P.dispose(m)),D.clear()})];try{const m=k.watch(f.path);w.push(P.toDisposable(()=>{m.removeAllListeners(),m.close()}));const l=new Set;f.isDirectory&&L.readdir(f.path).then(o=>o.forEach(s=>l.add(s))),m.on("error",(o,s)=>{S||C(`Failed to watch ${f.path} for changes using fs.watch() (${o}, ${s})`)}),m.on("change",(o,s)=>{if(!S){let t="";if(s&&(t=s.toString(),_.isMacintosh&&(t=R.normalizeNFC(t))),!(!t||o!=="change"&&o!=="rename")){const r=f.isDirectory?v.join(f.path,t):f.path;if(f.isDirectory)if(o==="rename"){const i=D.get(r);i&&P.dispose(i);const a=setTimeout(async()=>{D.delete(r);const n=await L.exists(r);if(!S){let c;n?l.has(t)?c="changed":(c="added",l.add(t)):(l.delete(t),c="deleted"),b(c,r)}},e.CHANGE_BUFFER_DELAY);D.set(r,P.toDisposable(()=>clearTimeout(a)))}else{let i;l.has(t)?i="changed":(i="added",l.add(t)),b(i,r)}else if(o==="rename"||t!==u){const i=setTimeout(async()=>{const a=await L.exists(r);S||(a?(b("changed",r),w=[I(f,b,C)]):b("deleted",r))},e.CHANGE_BUFFER_DELAY);P.dispose(w),w=[P.toDisposable(()=>clearTimeout(i))]}else b("changed",r)}}})}catch(m){L.exists(f.path).then(l=>{l&&!S&&C(`Failed to watch ${f.path} for changes using fs.watch() (${m.toString()})`)})}return P.toDisposable(()=>{S=!0,w=P.dispose(w)})}}),define(ee[31],te([0,1,3,2,8,28,13,16,19,17,86,20]),function(G,e,v,k,_,R,P,L,p,g,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.createChannelSender=e.createChannelReceiver=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function C(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(u=e.ResponseType||(e.ResponseType={}));function D(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(S||(S={}));class w{constructor(U){this.buffer=U,this.pos=0}read(U){const M=this.buffer.slice(this.pos,this.pos+U);return this.pos+=M.byteLength,M}}class m{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var l;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object"})(l||(l={}));function o(T){const U=L.VSBuffer.alloc(4);return U.writeUInt32BE(T,0),U}function s(T){return T.read(4).readUInt32BE(0)}function t(T){const U=L.VSBuffer.alloc(1);return U.writeUInt8(T,0),U}const r={Undefined:t(l.Undefined),String:t(l.String),Buffer:t(l.Buffer),VSBuffer:t(l.VSBuffer),Array:t(l.Array),Object:t(l.Object)},i=typeof Buffer!="undefined";function a(T,U){if(typeof U=="undefined")T.write(r.Undefined);else if(typeof U=="string"){const M=L.VSBuffer.fromString(U);T.write(r.String),T.write(o(M.byteLength)),T.write(M)}else if(i&&Buffer.isBuffer(U)){const M=L.VSBuffer.wrap(U);T.write(r.Buffer),T.write(o(M.byteLength)),T.write(M)}else if(U instanceof L.VSBuffer)T.write(r.VSBuffer),T.write(o(U.byteLength)),T.write(U);else if(Array.isArray(U)){T.write(r.Array),T.write(o(U.length));for(const M of U)a(T,M)}else{const M=L.VSBuffer.fromString(JSON.stringify(U));T.write(r.Object),T.write(o(M.byteLength)),T.write(M)}}function n(T){switch(T.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return T.read(s(T)).toString();case l.Buffer:return T.read(s(T)).buffer;case l.VSBuffer:return T.read(s(T));case l.Array:{const M=s(T),q=[];for(let H=0;H<M;H++)q.push(n(T));return q}case l.Object:return JSON.parse(T.read(s(T)).toString())}}class c{constructor(U,M,q=null,H=1e3){this.protocol=U,this.ctx=M,this.logger=q,this.timeoutDelay=H,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(U,M){this.channels.set(U,M),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const M=this.send([U.type]);this.logger&&this.logger.logOutgoing(M,0,1,D(U.type));return}case 201:case 202:case 204:case 203:{const M=this.send([U.type,U.id],U.data);this.logger&&this.logger.logOutgoing(M,U.id,1,D(U.type),U.data);return}}}send(U,M=void 0){const q=new m;return a(q,U),a(q,M),this.sendBuffer(q.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(M){return 0}}onRawMessage(U){const M=new w(U),q=n(M),H=n(M),X=q[0];switch(X){case 100:return this.logger&&this.logger.logIncoming(U.byteLength,q[1],1,`${C(X)}: ${q[2]}.${q[3]}`,H),this.onPromise({type:X,id:q[1],channelName:q[2],name:q[3],arg:H});case 102:return this.logger&&this.logger.logIncoming(U.byteLength,q[1],1,`${C(X)}: ${q[2]}.${q[3]}`,H),this.onEventListen({type:X,id:q[1],channelName:q[2],name:q[3],arg:H});case 101:return this.logger&&this.logger.logIncoming(U.byteLength,q[1],1,`${C(X)}`),this.disposeActiveRequest({type:X,id:q[1]});case 103:return this.logger&&this.logger.logIncoming(U.byteLength,q[1],1,`${C(X)}`),this.disposeActiveRequest({type:X,id:q[1]})}}onPromise(U){const M=this.channels.get(U.channelName);if(!M){this.collectPendingRequest(U);return}const q=new R.CancellationTokenSource;let H;try{H=M.call(this.ctx,U.name,U.arg,q.token)}catch(Z){H=Promise.reject(Z)}const X=U.id;H.then(Z=>{this.sendResponse({id:X,data:Z,type:201}),this.activeRequests.delete(U.id)},Z=>{Z instanceof Error?this.sendResponse({id:X,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:X,data:Z,type:203}),this.activeRequests.delete(U.id)});const Q=k.toDisposable(()=>q.cancel());this.activeRequests.set(U.id,Q)}onEventListen(U){const M=this.channels.get(U.channelName);if(!M){this.collectPendingRequest(U);return}const q=U.id,X=M.listen(this.ctx,U.name,U.arg)(Q=>this.sendResponse({id:q,data:Q,type:204}));this.activeRequests.set(U.id,X)}disposeActiveRequest(U){const M=this.activeRequests.get(U.id);M&&(M.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let M=this.pendingRequests.get(U.channelName);M||(M=[],this.pendingRequests.set(U.channelName,M));const q=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:U,timeoutTimer:q})}flushPendingRequests(U){const M=this.pendingRequests.get(U);if(M){for(const q of M)switch(clearTimeout(q.timeoutTimer),q.request.type){case 100:this.onPromise(q.request);break;case 102:this.onEventListen(q.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var h;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class y{constructor(U,M=null){this.protocol=U,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(q=>this.onBuffer(q)),this.logger=M}getChannel(U){const M=this;return{call(q,H,X){return M.isDisposed?Promise.reject(P.canceled()):M.requestPromise(U,q,H,X)},listen(q,H){return M.isDisposed?Promise.reject(P.canceled()):M.requestEvent(U,q,H)}}}requestPromise(U,M,q,H=R.CancellationToken.None){const X=this.lastRequestId++,Z={id:X,type:100,channelName:U,name:M,arg:q};if(H.isCancellationRequested)return Promise.reject(P.canceled());let ne;return new Promise((me,se)=>{if(H.isCancellationRequested)return se(P.canceled());const ce=()=>{const Le=Ce=>{switch(Ce.type){case 201:this.handlers.delete(X),me(Ce.data);break;case 202:this.handlers.delete(X);const Ae=new Error(Ce.data.message);Ae.stack=Ce.data.stack,Ae.name=Ce.data.name,se(Ae);break;case 203:this.handlers.delete(X),se(Ce.data);break}};this.handlers.set(X,Le),this.sendRequest(Z)};let fe=null;this.state===S.Idle?ce():(fe=_.createCancelablePromise(Le=>this.whenInitialized()),fe.then(()=>{fe=null,ce()}));const ye=()=>{fe?(fe.cancel(),fe=null):this.sendRequest({id:X,type:101}),se(P.canceled())},De=H.onCancellationRequested(ye);ne=k.combinedDisposable(k.toDisposable(ye),De),this.activeRequests.add(ne)}).finally(()=>{this.activeRequests.delete(ne)})}requestEvent(U,M,q){const H=this.lastRequestId++,Q={id:H,type:102,channelName:U,name:M,arg:q};let Z=null;const ne=new v.Emitter({onFirstListenerAdd:()=>{Z=_.createCancelablePromise(me=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(ne),this.sendRequest(Q)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(ne),this.sendRequest({id:H,type:103}))}}),le=me=>ne.fire(me.data);return this.handlers.set(H,le),ne.event}sendRequest(U){switch(U.type){case 100:case 102:{const M=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger&&this.logger.logOutgoing(M,U.id,0,`${C(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const M=this.send([U.type,U.id]);this.logger&&this.logger.logOutgoing(M,U.id,0,C(U.type));return}}}send(U,M=void 0){const q=new m;return a(q,U),a(q,M),this.sendBuffer(q.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(M){return 0}}onBuffer(U){const M=new w(U),q=n(M),H=n(M),X=q[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(U.byteLength,0,0,D(X)),this.onResponse({type:q[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(U.byteLength,q[1],0,D(X),H),this.onResponse({type:q[0],id:q[1],data:H})}}onResponse(U){if(U.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(U.id);M&&M(U)}whenInitialized(){return this.state===S.Idle?Promise.resolve():v.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelClient=y;class E{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:M,onDidClientDisconnect:q})=>{v.Event.once(M.onMessage)(X=>{const Q=new w(X),Z=n(Q),ne=new c(M,Z),le=new y(M);this.channels.forEach((se,ce)=>ne.registerChannel(ce,se));const me={channelServer:ne,channelClient:le,ctx:Z};this._connections.add(me),this._onDidAddConnection.fire(me),q(()=>{ne.dispose(),le.dispose(),this._connections.delete(me),this._onDidRemoveConnection.fire(me)})})})}get connections(){const U=[];return this._connections.forEach(M=>U.push(M)),U}getChannel(U,M){const q=this;return{call(H,X,Q){let Z;if(g.isFunction(M)){let le=p.getRandomElement(q.connections.filter(M));Z=le?Promise.resolve(le):v.Event.toPromise(v.Event.filter(q.onDidAddConnection,M))}else Z=M.routeCall(q,H,X);const ne=Z.then(le=>le.channelClient.getChannel(U));return O(ne).call(H,X,Q)},listen(H,X){if(g.isFunction(M))return q.getMulticastEvent(U,M,H,X);const Q=M.routeEvent(q,H,X).then(Z=>Z.channelClient.getChannel(U));return O(Q).listen(H,X)}}}getMulticastEvent(U,M,q,H){const X=this;let Q=new k.DisposableStore;const Z=new v.Emitter({onFirstListenerAdd:()=>{Q=new k.DisposableStore;const ne=new v.EventMultiplexer,le=new Map,me=ce=>{const ye=ce.channelClient.getChannel(U).listen(q,H),De=ne.add(ye);le.set(ce,De)},se=ce=>{const fe=le.get(ce);!fe||(fe.dispose(),le.delete(ce))};X.connections.filter(M).forEach(me),v.Event.filter(X.onDidAddConnection,M)(me,void 0,Q),X.onDidRemoveConnection(se,void 0,Q),ne.event(Z.fire,Z,Q),Q.add(ne)},onLastListenerRemove:()=>{Q.dispose()}});return Z.event}registerChannel(U,M){this.channels.set(U,M),this._connections.forEach(q=>{q.channelServer.registerChannel(U,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=E;class d{constructor(U,M,q=null){const H=new m;a(H,M),U.send(H.buffer),this.channelClient=new y(U,q),this.channelServer=new c(U,M,q)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,M){this.channelServer.registerChannel(U,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=d;function O(T){return{call(U,M,q){return T.then(H=>H.call(U,M,q))},listen(U,M){const q=new v.Relay;return T.then(H=>q.input=H.listen(U,M)),q.event}}}e.getDelayedChannel=O;function A(T){let U=!1;return{call(M,q,H){return U?T.call(M,q,H):_.timeout(0).then(()=>U=!0).then(()=>T.call(M,q,H))},listen(M,q){if(U)return T.listen(M,q);const H=new v.Relay;return _.timeout(0).then(()=>U=!0).then(()=>H.input=T.listen(M,q)),H.event}}}e.getNextTickChannel=A;class j{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const M of U.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await v.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=j;function z(T,U){const M=T,q=U&&U.disableMarshalling,H=new Map;for(const X in M)N(X)&&H.set(X,v.Event.buffer(M[X],!0));return new class{listen(X,Q){const Z=H.get(Q);if(Z)return Z;throw new Error(`Event not found: ${Q}`)}call(X,Q,Z){const ne=M[Q];if(typeof ne=="function"){if(!q&&Array.isArray(Z))for(let le=0;le<Z.length;le++)Z[le]=I.revive(Z[le]);return ne.apply(M,Z)}throw new Error(`Method not found: ${Q}`)}}}e.createChannelReceiver=z;function W(T,U){const M=U&&U.disableMarshalling;return new Proxy({},{get(q,H){var X;if(typeof H=="string")return((X=U==null?void 0:U.properties)===null||X===void 0?void 0:X.has(H))?U.properties.get(H):N(H)?T.listen(H):async function(...Q){let Z;U&&!g.isUndefinedOrNull(U.context)?Z=[U.context,...Q]:Z=Q;const ne=await T.call(H,Z);return M?ne:I.revive(ne)};throw new Error(`Property not found: ${String(H)}`)}})}e.createChannelSender=W;function N(T){return T[0]==="o"&&T[1]==="n"&&f.isUpperAsciiLetter(T.charCodeAt(2))}const x=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){let U=T.toString();if(U!=="[object Object]")return U}return T}function B(T){return Array.isArray(T)?T.map(F):F(T)}function K(T,U,M,q,H,X,Q){Q=B(Q);const Z=x[H],ne=Z[q%Z.length];let le=[`%c[${T}]%c[${String(U).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${ne}`];/\($/.test(X)?(le=le.concat(Q),le.push(")")):le.push(Q),console.log.apply(console,le)}e.logWithColors=K;class ${constructor(U,M){this._outgoingPrefix=U,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,M,q,H,X){this._totalOutgoing+=U,K(this._outgoingPrefix,this._totalOutgoing,U,M,q,H,X)}logIncoming(U,M,q,H,X){this._totalIncoming+=U,K(this._incomingPrefix,this._totalIncoming,U,M,q,H,X)}}e.IPCLogger=$}),define(ee[95],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(_,R){this.sender=_,this.onMessage=R}send(_){try{this.sender.send("vscode:message",_.buffer)}catch(R){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(ee[96],te([0,1,3,31,16]),function(G,e,v,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(p){this.port=p,this.onMessage=v.Event.fromDOMEventEmitter(this.port,"message",g=>_.VSBuffer.wrap(g.data)),p.start()}send(p){this.port.postMessage(p.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class P extends k.IPCClient{constructor(p,g){const I=new R(p);super(I,g);this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=P}),define(ee[97],te([0,1,3,31,2,16,6,46]),function(G,e,v,k,_,R,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let p=null;function g(){return p||(p=R.VSBuffer.alloc(0)),p}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,a){if(i===0)return g();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const y=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=i),y}if(this._chunks[0].byteLength>i){const y=this._chunks[0].slice(0,i);return a&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),y}let n=R.VSBuffer.alloc(i),c=0,h=0;for(;i>0;){const y=this._chunks[h];if(y.byteLength>i){const E=y.slice(0,i);n.set(E,c),c+=i,a&&(this._chunks[h]=y.slice(i),this._totalLength-=i),i-=i}else n.set(y,c),c+=y.byteLength,a?(this._chunks.shift(),this._totalLength-=y.byteLength):h++,i-=y.byteLength}return n}}e.ChunkStream=I;var f;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(f||(f={}));var b;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(b=e.ProtocolConstants||(e.ProtocolConstants={}));class C{constructor(i,a,n,c){this.type=i,this.id=a,this.ack=n,this.data=c,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends _.Disposable{constructor(i){super();this._onMessage=this._register(new v.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const n=this._state.messageType,c=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new C(n,c,h,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class D{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(!this._isDisposed){i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=R.VSBuffer.alloc(13);a.writeUInt8(i.type,0),a.writeUInt32BE(i.id,1),a.writeUInt32BE(i.ack,5),a.writeUInt32BE(i.data.byteLength,9),this._writeSoon(a,i.data)}}_bufferAdd(i,a){const n=this._totalLength===0;return this._data.push(i,a),this._totalLength+=i.byteLength+a.byteLength,n}_bufferTake(){const i=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,a){this._bufferAdd(i,a)&&P.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends _.Disposable{constructor(i){super();this._onMessage=new v.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new v.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new D(this._socket)),this._socketReader=this._register(new u(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new C(1,0,0,i))}}e.Protocol=S;class w extends k.IPCClient{constructor(i,a,n=null){super(i,a,n);this.protocol=i}static fromSocket(i,a){return new w(new S(i),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=w;class m{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new v.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,L.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=m;class l{constructor(i){this.data=i,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],a=0,n=this._first;for(;n;)i[a++]=n.data,n=n.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const a=new l(i);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class s{constructor(){this.lastRuns=[];const i=Date.now();for(let a=0;a<s._HISTORY_LENGTH;a++)this.lastRuns[a]=i-1e3*a;setInterval(()=>{for(let a=s._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const i=Date.now(),a=(1+s._HISTORY_LENGTH)*1e3;let n=0;for(let c=0;c<s._HISTORY_LENGTH;c++)i-this.lastRuns[c]<=a&&n++;return 1-n/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class t{constructor(i,a=null){this._loadEstimator=s.getInstance(),this._onControlMessage=new m,this.onControlMessage=this._onControlMessage.event,this._onMessage=new m,this.onMessage=this._onMessage.event,this._onDidDispose=new m,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new m,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new m,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new u(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=_.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new C(5,0,0,g());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const a=new C(4,0,0,g());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,a){this._isReconnecting=!0,this._socketDisposables=_.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new u(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let a=0,n=i.length;a<n;a++)this._socketWriter.write(i[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new C(6,0,0,g())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const a=this._outgoingUnackMsg.toArray();for(let n=0,c=a.length;n<c;n++)this._socketWriter.write(a[n]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const n=new C(1,a,this._incomingAckId,i);this._outgoingUnackMsg.push(n),this._isReconnecting||(this._socketWriter.write(n),this._recvAckCheck())}sendControl(i){const a=new C(2,0,0,i);this._socketWriter.write(a)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const i=this._outgoingUnackMsg.peek(),a=Date.now()-i.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const i=new C(3,0,this._incomingAckId,g());this._socketWriter.write(i)}}}e.PersistentProtocol=t}),define(ee[98],te([0,1,13,16]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function _(L,p){L.proxyAuthorization&&(L.headers=Object.assign(Object.assign({},L.headers||{}),{"Proxy-Authorization":L.proxyAuthorization}));const g=new XMLHttpRequest;return new Promise((I,f)=>{g.open(L.type||"GET",L.url||"",!0,L.user,L.password),R(g,L),g.responseType="arraybuffer",g.onerror=b=>f(new Error(g.statusText&&"XHR failed: "+g.statusText||"XHR failed")),g.onload=b=>{I({res:{statusCode:g.status,headers:P(g)},stream:k.bufferToStream(k.VSBuffer.wrap(new Uint8Array(g.response)))})},g.ontimeout=b=>f(new Error(`XHR timeout: ${L.timeout}ms`)),L.timeout&&(g.timeout=L.timeout),g.send(L.data),p.onCancellationRequested(()=>{g.abort(),f(v.canceled())})})}e.request=_;function R(L,p){if(p.headers){e:for(let g in p.headers){switch(g){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}L.setRequestHeader(g,p.headers[g])}}}function P(L){const p=Object.create(null);for(const g of L.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(g){const I=g.indexOf(":");p[g.substr(0,I).trim().toLowerCase()]=g.substr(I+1).trim()}return p}}),define(ee[48],te([0,1,6]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.context=e.process=e.crashReporter=e.webFrame=e.ipcRenderer=void 0,e.ipcRenderer=v.globals.vscode.ipcRenderer,e.webFrame=v.globals.vscode.webFrame,e.crashReporter=v.globals.vscode.crashReporter,e.process=v.globals.vscode.process,e.context=v.globals.vscode.context}),define(ee[99],te([0,1,3,31,95,16,48]),function(G,e,v,k,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=void 0;class L extends k.IPCClient{constructor(g){const I=L.createProtocol();super(I,g);this.protocol=I}static createProtocol(){const g=v.Event.fromNodeEventEmitter(P.ipcRenderer,"vscode:message",(I,f)=>R.VSBuffer.wrap(f));return P.ipcRenderer.send("vscode:hello"),new _.Protocol(P.ipcRenderer,g)}dispose(){this.protocol.disconnect()}}e.Client=L}),define(ee[100],te([0,1,48,3,31,96]),function(G,e,v,k,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class P extends _.IPCServer{static getOnDidClientConnect(){const p=k.Event.fromNodeEventEmitter(v.ipcRenderer,"vscode:createMessageChannel",(g,I)=>I);return k.Event.map(p,g=>{const{port1:I,port2:f}=new MessageChannel,C={protocol:new R.Protocol(I),onDidClientDisconnect:k.Event.fromDOMEventEmitter(I,"close")};return v.ipcRenderer.postMessage("vscode:createMessageChannelResult",g,[f]),C})}constructor(){super(P.getOnDidClientConnect())}}e.Server=P}),define(ee[101],te([0,1,2,3,8,17]),function(G,e,v,k,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var P;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(P=e.StorageHint||(e.StorageHint={}));var L;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(L||(L={}));class p extends v.Disposable{constructor(f,b=Object.create(null)){super();this.database=f,this.options=b,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=L.None,this.cache=new Map,this.flushDelayer=this._register(new _.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){var b,C;(b=f.changed)===null||b===void 0||b.forEach((u,D)=>this.accept(D,u)),(C=f.deleted)===null||C===void 0||C.forEach(u=>this.accept(u,void 0))}accept(f,b){if(this.state!==L.Closed){let C=!1;R.isUndefinedOrNull(b)?C=this.cache.delete(f):this.cache.get(f)!==b&&(this.cache.set(f,b),C=!0),C&&this._onDidChangeStorage.fire(f)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===L.None&&(this.state=L.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,b){const C=this.cache.get(f);return R.isUndefinedOrNull(C)?b:C}getBoolean(f,b){const C=this.get(f);return R.isUndefinedOrNull(C)?b:C==="true"}getNumber(f,b){const C=this.get(f);return R.isUndefinedOrNull(C)?b:parseInt(C,10)}async set(f,b){if(this.state!==L.Closed){if(R.isUndefinedOrNull(b))return this.delete(f);const C=String(b);if(this.cache.get(f)!==C)return this.cache.set(f,C),this.pendingInserts.set(f,C),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(f){if(this.state!==L.Closed&&!!this.cache.delete(f))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async close(){if(this.state!==L.Closed){this.state=L.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(f){}await this.database.close(()=>this.cache)}}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{var b;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(b=this.whenFlushedCallbacks.pop())===null||b===void 0||b()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}}e.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class g{constructor(){this.onDidChangeItemsExternal=k.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((b,C)=>this.items.set(C,b)),f.delete&&f.delete.forEach(b=>this.items.delete(b))}async close(){}}e.InMemoryStorageDatabase=g}),define(ee[102],te([0,1,3,8,32,4,22]),function(G,e,v,k,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class L{constructor(I,f=Object.create(null)){this.path=I,this.options=f,this.name=R.basename(this.path),this.logger=new p(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return v.Event.None}async getItems(){const I=await this.whenConnected,f=new Map;return(await this.all(I,"SELECT * FROM ItemTable")).forEach(C=>f.set(C.key,C.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${f.size} rows`),f}async updateItems(I){const f=await this.whenConnected;return this.doUpdateItems(f,I)}doUpdateItems(I,f){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${f.insert?_.mapToString(f.insert):"0"}), delete(${f.delete?_.setToString(f.delete):"0"})`),this.transaction(I,()=>{const b=f.insert,C=f.delete;if(b&&b.size>0){const u=[];u.push([]);let D=0;b.forEach((S,w)=>{let m=u[D];m.length>L.MAX_HOST_PARAMETERS&&(D++,m=[],u.push(m)),m.push(w,S)}),u.forEach(S=>{this.prepare(I,`INSERT INTO ItemTable VALUES ${new Array(S.length/2).fill("(?,?)").join(",")}`,w=>w.run(S),()=>{const w=[];let m=0;return b.forEach((l,o)=>{w.push(o),m+=l.length}),`Keys: ${w.join(", ")} Length: ${m}`})})}if(C&&C.size){const u=[];u.push([]);let D=0;C.forEach(S=>{let w=u[D];w.length>L.MAX_HOST_PARAMETERS&&(D++,w=[],u.push(w)),w.push(S)}),u.forEach(S=>{this.prepare(I,`DELETE FROM ItemTable WHERE key IN (${new Array(S.length).fill("?").join(",")})`,w=>w.run(S),()=>{const w=[];return C.forEach(m=>{w.push(m)}),`Keys: ${w.join(", ")}`})})}})}async close(I){this.logger.trace(`[storage ${this.name}] close()`);const f=await this.whenConnected;return this.doClose(f,I)}doClose(I,f){return new Promise((b,C)=>{I.db.close(u=>(u&&this.handleSQLiteError(I,`[storage ${this.name}] close(): ${u}`),this.path===L.IN_MEMORY_PATH?b():!I.isErroneous&&!I.isInMemory?this.backup().then(b,D=>(this.logger.error(`[storage ${this.name}] backup(): ${D}`),b())):typeof f=="function"?P.unlink(this.path).then(()=>this.doConnect(this.path).then(D=>{const S=()=>this.doClose(D,void 0);return this.doUpdateItems(D,{insert:f()}).then(()=>S(),w=>(S(),Promise.reject(w)))})).then(b,C):C(u||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const I=this.toBackupPath(this.path);return P.copy(this.path,I)}toBackupPath(I){return`${I}.backup`}async checkIntegrity(I){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${I})`);const f=await this.whenConnected,b=await this.get(f,I?"PRAGMA integrity_check":"PRAGMA quick_check"),C=I?b.integrity_check:b.quick_check;return f.isErroneous?`${C} (last error: ${f.lastError})`:f.isInMemory?`${C} (in-memory!)`:C}async connect(I,f=!0){this.logger.trace(`[storage ${this.name}] open(${I}, retryOnBusy: ${f})`);try{return await this.doConnect(I)}catch(b){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&f)return await k.timeout(L.BUSY_OPEN_TIMEOUT),this.connect(I,!1);try{return await P.unlink(I),await P.renameIgnoreError(this.toBackupPath(I),I),await this.doConnect(I)}catch(C){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${C}`),this.doConnect(L.IN_MEMORY_PATH)}}}handleSQLiteError(I,f){I.isErroneous=!0,I.lastError=f,this.logger.error(f)}doConnect(I){return new Promise((f,b)=>{new Promise((C,u)=>{G(["vscode-sqlite3"],C,u)}).then(C=>{const u={db:new(this.logger.isTracing?C.verbose().Database:C.Database)(I,D=>D?u.db?u.db.close(()=>b(D)):b(D):this.exec(u,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>f(u),S=>u.db.close(()=>b(S)))),isInMemory:I===L.IN_MEMORY_PATH};u.db.on("error",D=>this.handleSQLiteError(u,`[storage ${this.name}] Error (event): ${D}`)),this.logger.isTracing&&u.db.on("trace",D=>this.logger.trace(`[storage ${this.name}] Trace (event): ${D}`))},b)})}exec(I,f){return new Promise((b,C)=>{I.db.exec(f,u=>u?(this.handleSQLiteError(I,`[storage ${this.name}] exec(): ${u}`),C(u)):b())})}get(I,f){return new Promise((b,C)=>{I.db.get(f,(u,D)=>u?(this.handleSQLiteError(I,`[storage ${this.name}] get(): ${u}`),C(u)):b(D))})}all(I,f){return new Promise((b,C)=>{I.db.all(f,(u,D)=>u?(this.handleSQLiteError(I,`[storage ${this.name}] all(): ${u}`),C(u)):b(D))})}transaction(I,f){return new Promise((b,C)=>{I.db.serialize(()=>{I.db.run("BEGIN TRANSACTION"),f(),I.db.run("END TRANSACTION",u=>u?(this.handleSQLiteError(I,`[storage ${this.name}] transaction(): ${u}`),C(u)):b())})})}prepare(I,f,b,C){const u=I.db.prepare(f),D=S=>{this.handleSQLiteError(I,`[storage ${this.name}] prepare(): ${S} (${f}). Details: ${C()}`)};u.on("error",D),b(u),u.finalize(S=>{S&&D(S),u.removeListener("error",D)})}}e.SQLiteStorageDatabase=L,L.IN_MEMORY_PATH=":memory:",L.BUSY_OPEN_TIMEOUT=2e3,L.MAX_HOST_PARAMETERS=256;class p{constructor(I){I&&typeof I.logTrace=="function"&&process.env[p.VSCODE_TRACE_STORAGE]&&(this.logTrace=I.logTrace),I&&typeof I.logError=="function"&&(this.logError=I.logError)}get isTracing(){return!!this.logTrace}trace(I){this.logTrace&&this.logTrace(I)}error(I){this.logError&&this.logError(I)}}p.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[103],te([10,11]),function(G,e){return G.create("vs/base/common/date",e)}),define(ee[54],te([0,1,103]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,_=k*60,R=_*24,P=R*7,L=R*30,p=R*365;function g(f,b){typeof f!="number"&&(f=f.getTime());const C=Math.round((new Date().getTime()-f)/1e3);if(C<-30)return v.localize(0,null,g(new Date().getTime()+C*1e3,!1));if(C<30)return v.localize(1,null);let u;return C<k?(u=C,b?u===1?v.localize(2,null,u):v.localize(3,null,u):u===1?v.localize(4,null,u):v.localize(5,null,u)):C<_?(u=Math.floor(C/k),b?u===1?v.localize(6,null,u):v.localize(7,null,u):u===1?v.localize(8,null,u):v.localize(9,null,u)):C<R?(u=Math.floor(C/_),b?u===1?v.localize(10,null,u):v.localize(11,null,u):u===1?v.localize(12,null,u):v.localize(13,null,u)):C<P?(u=Math.floor(C/R),b?u===1?v.localize(14,null,u):v.localize(15,null,u):u===1?v.localize(16,null,u):v.localize(17,null,u)):C<L?(u=Math.floor(C/P),b?u===1?v.localize(18,null,u):v.localize(19,null,u):u===1?v.localize(20,null,u):v.localize(21,null,u)):C<p?(u=Math.floor(C/L),b?u===1?v.localize(22,null,u):v.localize(23,null,u):u===1?v.localize(24,null,u):v.localize(25,null,u)):(u=Math.floor(C/p),b?u===1?v.localize(26,null,u):v.localize(27,null,u):u===1?v.localize(28,null,u):v.localize(29,null,u))}e.fromNow=g;function I(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(ee[104],te([10,11]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ee[43],te([0,1,104,17,19]),function(G,e,v,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function R(g,I){return I&&(g.stack||g.stacktrace)?v.localize(0,null,L(g),P(g.stack)||P(g.stacktrace)):L(g)}function P(g){return Array.isArray(g)?g.join(`
`):g}function L(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?v.localize(1,null,g.message):g.message||v.localize(2,null)}function p(g=null,I=!1){if(!g)return v.localize(3,null);if(Array.isArray(g)){const f=_.coalesce(g),b=p(f[0],I);return f.length>1?v.localize(4,null,b,f.length):b}if(k.isString(g))return g;if(g.detail){const f=g.detail;if(f.error)return R(f.error,I);if(f.exception)return R(f.exception,I)}return g.stack?R(g,I):g.message?g.message:v.localize(5,null)}e.toErrorMessage=p}),define(ee[105],te([10,11]),function(G,e){return G.create("vs/base/node/processes",e)}),define(ee[106],te([0,1,4,36,53,47,105,17,25,35,6,65,14]),function(G,e,v,k,_,R,P,L,p,g,I,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function C(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(o,s){if(I.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};s&&(t.cwd=s);const r=R.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(i=>{r.once("error",a=>{i({success:!1,error:a})}),r.once("exit",(a,n)=>{i(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?C(t.status):1})}else if(I.isLinux||I.isMacintosh)try{const t=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(r=>{R.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(i,a,n)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function D(o=process.env){return o.comspec||"cmd.exe"}e.getWindowsShell=D;class S{constructor(s,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=s,this.args=t,this.shell=r,this.options=i;else{const a=s;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(process.env).forEach(n=>{a[n]=process.env[n]}),Object.keys(this.options.env).forEach(n=>{a[n]=this.options.env[n]}),this.options.env=a}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const t=s.lastIndexOf(v.sep);return t!==-1&&(s=s.substring(t+1)),S.WellKnowCommands[s]?s:"other"}start(s){return I.isWindows&&(this.options&&this.options.cwd&&g.isUNC(this.options.cwd)||!this.options&&g.isUNC(process.cwd()))?Promise.reject(new Error(P.localize(0,null))):this.useExec().then(t=>{let r,i;const a=new Promise((n,c)=>{r=n,i=c});if(t){let n=this.cmd;this.args&&(n=n+" "+this.args.join(" ")),this.childProcess=R.exec(n,this.options,(c,h,y)=>{this.childProcess=null;const E=c;E&&E.killed?i({killed:this.terminateRequested,stdout:h.toString(),stderr:y.toString()}):this.handleExec(r,s,c,h,y)})}else{let n=null;const c=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,r,s,i);const y={terminated:this.terminateRequested};L.isNumber(h)&&(y.cmdCode=h),r(y)};if(this.shell&&I.isWindows){const h=p.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let y=!1,E=!1;const d=[];let O=this.ensureQuotes(this.cmd);d.push(O.value),y=O.quoted,this.args&&this.args.forEach(j=>{O=this.ensureQuotes(j),d.push(O.value),E=E&&O.quoted});const A=["/s","/c"];y?E?A.push('"'+d.join(" ")+'"'):d.length>1?A.push('"'+d[0]+'" '+d.slice(1).join(" ")):A.push('"'+d[0]+'"'):A.push(d.join(" ")),n=R.spawn(D(),A,h)}else this.cmd&&(n=R.spawn(this.cmd,this.args,this.options));n&&(this.childProcess=n,this.childProcessPromise=Promise.resolve(n),this.pidResolve&&(this.pidResolve(L.isNumber(n.pid)?n.pid:-1),this.pidResolve=void 0),n.on("error",h=>{this.childProcess=null,i({terminated:this.terminateRequested,error:h})}),n.pid&&(this.childProcess.on("close",c),this.handleSpawn(n,r,s,i,!0)))}return a})}handleClose(s,t,r,i){}ensureQuotes(s){return S.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,u(s,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!I.isWindows)return s(!1);const t=R.spawn(D(),["/s","/c"]);t.on("error",r=>s(!0)),t.on("exit",r=>s(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class w extends S{constructor(s,t,r,i){super(s,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,t,r,i,a){[i,a].forEach((n,c)=>{const h=new f.LineDecoder;h.write(n).forEach(d=>{t({line:d,source:c===0?0:1})});const E=h.end();E&&t({line:E,source:c===0?0:1})}),s({terminated:this.terminateRequested,error:r})}handleSpawn(s,t,r,i,a){const n=new f.LineDecoder,c=new f.LineDecoder;s.stdout.on("data",h=>{n.write(h).forEach(E=>r({line:E,source:0}))}),s.stderr.on("data",h=>{c.write(h).forEach(E=>r({line:E,source:1}))}),this.stdoutLineDecoder=n,this.stderrLineDecoder=c}handleClose(s,t,r,i){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&r({line:a,source:0});const n=this.stderrLineDecoder?this.stderrLineDecoder.end():null;n&&r({line:n,source:1})}}e.LineProcess=w;function m(o){let s=[],t=!1;const r=function(i){if(t){s.push(i);return}(!o.send(i,n=>{if(n&&console.error(n),t=!1,s.length>0){const c=s.slice(0);s=[],c.forEach(h=>r(h))}})||I.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=m;var l;(function(o){async function s(t,r,i){if(v.isAbsolute(t))return t;if(r===void 0&&(r=process.cwd()),v.dirname(t)!=="."||(i===void 0&&L.isString(process.env.PATH)&&(i=process.env.PATH.split(v.delimiter)),i===void 0||i.length===0))return v.join(r,t);async function n(c){return await _.promisify(k.exists)(c)?!(await _.promisify(k.stat)(c)).isDirectory():!1}for(let c of i){let h;if(v.isAbsolute(c)?h=v.join(c,t):h=v.join(r,c,t),await n(h))return h;let y=h+".com";if(await n(y)||(y=h+".exe",await n(y)))return y}return v.join(r,t)}o.findExecutable=s})(l=e.win32||(e.win32={}))}),define(ee[66],te([0,1,47,2,8,25,3,106,31,84,28,13,16,6]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends p.ChannelServer{constructor(w){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(l){}},onMessage:P.Event.fromNodeEventEmitter(process,"message",m=>b.VSBuffer.wrap(Buffer.from(m,"base64")))},w);process.once("disconnect",()=>this.dispose())}}e.Server=u;class D{constructor(w,m){this.modulePath=w,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new P.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const l=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new _.Delayer(l),this.child=null,this._client=null}getChannel(w){const m=this;return{call(l,o,s){return m.requestPromise(w,l,o,s)},listen(l,o){return m.requestEvent(w,l,o)}}}requestPromise(w,m,l,o=I.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(f.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(w),t=_.createCancelablePromise(a=>s.call(m,l,a)),r=o.onCancellationRequested(()=>t.cancel()),i=k.toDisposable(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(w,m,l){if(!this.disposeDelayer)return P.Event.None;this.disposeDelayer.cancel();let o;const s=new P.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(w).listen(m,l)(s.fire,s),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const w=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env=Object.assign(Object.assign({},R.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(m.env=Object.assign(Object.assign({},m.env),this.options.env)),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),C.isMacintosh&&m.env&&delete m.env.DYLD_LIBRARY_PATH,this.child=v.fork(this.modulePath,w,m);const l=new P.Emitter;P.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if(g.isRemoteConsoleLog(n)){g.log(n,`IPC Library: ${this.options.serverName}`);return}l.fire(b.VSBuffer.wrap(Buffer.from(n,"base64")))});const s=this.options.useQueue?L.createQueuedSender(this.child):this.child,t=n=>this.child&&this.child.connected&&s.send(n.buffer.toString("base64")),r=l.event,i={send:t,onMessage:r};this._client=new p.ChannelClient(i);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,c)=>{process.removeListener("exit",a),this.activeRequests.forEach(h=>k.dispose(h)),this.activeRequests.clear(),n!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+c),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:c})})}return this._client}getCachedChannel(w){let m=this.channels.get(w);return m||(m=this.client.getChannel(w),this.channels.set(w,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=D}),define(ee[107],te([10,11]),function(G,e){return G.create("vs/base/node/zip",e)}),define(ee[108],te([10,11]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[109],te([10,11]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[110],te([10,11]),function(G,e){return G.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ee[111],te([10,11]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ee[112],te([10,11]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ee[113],te([10,11]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(ee[114],te([10,11]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[115],te([10,11]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ee[116],te([10,11]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(ee[117],te([10,11]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ee[118],te([10,11]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[119],te([10,11]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ee[120],te([10,11]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[121],te([10,11]),function(G,e){return G.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ee[122],te([10,11]),function(G,e){return G.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ee[123],te([10,11]),function(G,e){return G.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ee[124],te([10,11]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ee[125],te([10,11]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ee[126],te([10,11]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ee[127],te([10,11]),function(G,e){return G.create("vs/platform/workspaces/common/workspaces",e)}),define(ee[128],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=void 0;function v(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=v}),define(ee[129],te([0,1,7]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const k=/^([^@:]+@)?([^:]+):/,_=/^([^@:]+@)?([^:]+):(.+)$/,R=/^([^@]+@)?([^:]+)(:\d+)?$/,P=/([^@:.]+\.[^@:.]+)(:\d+)?$/,L=/^\s*url\s*=\s*(.+\S)\s*$/mg,p=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function g(S){const w=S.match(P);return w?w[1]:null}function I(S){if(S.indexOf("://")===-1){const w=S.match(k);return w?g(w[2]):null}try{const w=v.URI.parse(S);if(w.authority)return g(w.authority)}catch(w){}return null}function f(S,w){const m=new Set;let l;for(;l=L.exec(S);){const s=I(l[1]);s&&m.add(s)}const o=new Set(w);return Array.from(m).map(s=>o.has(s)?s:s.replace(p,"a"))}e.getDomainsOfRemotes=f;function b(S){const w=S.match(R);return w?w[2]:null}function C(S,w,m){return S&&w?(m&&w.endsWith(".git")&&(w=w.substr(0,w.length-4)),w.indexOf("/")===0?`${S}${w}`:`${S}/${w}`):null}function u(S,w){if(S.indexOf("://")===-1){const m=S.match(_);if(m)return C(m[2],m[3],w)}try{const m=v.URI.parse(S);if(m.authority)return C(b(m.authority),m.path,w)}catch(m){}return null}function D(S,w=!1){const m=[];let l;for(;l=L.exec(S);){const o=u(l[1],w);o&&m.push(o)}return m}e.getRemotes=D}),define(ee[130],te([0,1,3,7,88,25,2]),function(G,e,v,k,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function L(u,D){return k.URI.revive(D?D.transformIncoming(u):u)}function p(u,D){return D?D.transformOutgoingURI(u):u}function g(u,D){D=D||_.DefaultURITransformer;const S=u.manifest,w=_.transformAndReviveIncomingURIs(Object.assign(Object.assign({},u),{manifest:void 0}),D);return Object.assign(Object.assign({},w),{manifest:S})}function I(u,D){return D?R.cloneAndChange(u,S=>S instanceof k.URI?D.transformOutgoingURI(S):void 0):u}class f{constructor(D,S){this.service=D,this.getUriTransformer=S,this.onInstallExtension=v.Event.buffer(D.onInstallExtension,!0),this.onDidInstallExtension=v.Event.buffer(D.onDidInstallExtension,!0),this.onUninstallExtension=v.Event.buffer(D.onUninstallExtension,!0),this.onDidUninstallExtension=v.Event.buffer(D.onDidUninstallExtension,!0)}listen(D,S){const w=this.getUriTransformer(D);switch(S){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return v.Event.map(this.onDidInstallExtension,m=>Object.assign(Object.assign({},m),{local:m.local?I(m.local,w):m.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(D,S,w){const m=this.getUriTransformer(D);switch(S){case"zip":return this.service.zip(g(w[0],m)).then(l=>p(l,m));case"unzip":return this.service.unzip(L(w[0],m));case"install":return this.service.install(L(w[0],m));case"getManifest":return this.service.getManifest(L(w[0],m));case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(g(w[0],m),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(g(w[0],m));case"getInstalled":return this.service.getInstalled(w[0]).then(l=>l.map(o=>I(o,m)));case"updateMetadata":return this.service.updateMetadata(g(w[0],m),w[1]).then(l=>I(l,m));case"updateExtensionScope":return this.service.updateExtensionScope(g(w[0],m),w[1]).then(l=>I(l,m));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class b extends P.Disposable{constructor(D){super();this.channel=D,this._onInstallExtension=this._register(new v.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new v.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new v.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new v.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(S=>this._onInstallExtension.fire(S))),this._register(this.channel.listen("onDidInstallExtension")(S=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},S),{local:S.local?g(S.local,null):S.local})))),this._register(this.channel.listen("onUninstallExtension")(S=>this._onUninstallExtension.fire(S))),this._register(this.channel.listen("onDidUninstallExtension")(S=>this._onDidUninstallExtension.fire(S)))}zip(D){return Promise.resolve(this.channel.call("zip",[D]).then(S=>k.URI.revive(S)))}unzip(D){return Promise.resolve(this.channel.call("unzip",[D]))}install(D){return Promise.resolve(this.channel.call("install",[D])).then(S=>g(S,null))}getManifest(D){return Promise.resolve(this.channel.call("getManifest",[D]))}async canInstall(D){return!0}installFromGallery(D,S){return Promise.resolve(this.channel.call("installFromGallery",[D,S])).then(w=>g(w,null))}uninstall(D,S){return Promise.resolve(this.channel.call("uninstall",[D,S]))}reinstallFromGallery(D){return Promise.resolve(this.channel.call("reinstallFromGallery",[D]))}getInstalled(D=null){return Promise.resolve(this.channel.call("getInstalled",[D])).then(S=>S.map(w=>g(w,null)))}updateMetadata(D,S){return Promise.resolve(this.channel.call("updateMetadata",[D,S])).then(w=>g(w,null))}updateExtensionScope(D,S){return Promise.resolve(this.channel.call("updateExtensionScope",[D,S])).then(w=>g(w,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=b;class C{constructor(D){this.service=D}listen(D,S){throw new Error("Invalid listen")}call(D,S,w){switch(S){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=C}),define(ee[131],te([0,1,25]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const k=/^%([\w\d.-]+)%$/i;function _(R,P){const L=p=>{if(typeof p=="string"){const g=k.exec(p);if(!!g)return P[g[1]]||p}};return v.cloneAndChange(R,L)}e.localizeManifest=_}),define(ee[132],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class v{constructor(R){this.channel=R}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(R,P,L,p){return this.channel.call("promptImportantExtensionsInstallNotification",[R,P,L,p])}promptWorkspaceRecommendations(R){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=v;class k{constructor(R){this.service=R}listen(R,P){throw new Error(`Event not found: ${P}`)}call(R,P,L){switch(P){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(L[0],L[1],L[2],L[3])}throw new Error(`Call not found: ${P}`)}}e.ExtensionRecommendationNotificationServiceChannel=k}),define(ee[67],te([0,1,114]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function _(f){return f=f.trim(),f==="*"||k.test(f)}e.isValidVersionStr=_;function R(f){if(!_(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=f.match(k);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=R;function P(f){if(!f)return null;let b=f.majorBase,C=f.majorMustEqual,u=f.minorBase,D=f.minorMustEqual,S=f.patchBase,w=f.patchMustEqual;return f.hasCaret&&(b===0||(D=!1),w=!1),{majorBase:b,majorMustEqual:C,minorBase:u,minorMustEqual:D,patchBase:S,patchMustEqual:w,isMinimum:f.hasGreaterEquals}}e.normalizeVersion=P;function L(f,b){let C;typeof f=="string"?C=P(R(f)):C=f;let u;if(typeof b=="string"?u=P(R(b)):u=b,!C||!u)return!1;let D=C.majorBase,S=C.minorBase,w=C.patchBase,m=u.majorBase,l=u.minorBase,o=u.patchBase,s=u.majorMustEqual,t=u.minorMustEqual,r=u.patchMustEqual;return u.isMinimum?D>m?!0:D<m?!1:S>l?!0:S<l?!1:w>=o:(D===1&&m===0&&(!s||!t||!r)&&(m=1,l=0,o=0,s=!0,t=!1,r=!1),D<m?!1:D>m?!s:S<l?!1:S>l?!t:w<o?!1:w>o?!r:!0)}e.isValidVersion=L;function p(f,b,C){return b.isBuiltin||typeof b.main=="undefined"?!0:I(f,b.engines.vscode,C)}e.isValidExtensionVersion=p;function g(f,b){return f==="*"||I(b,f)}e.isEngineValid=g;function I(f,b,C=[]){let u=P(R(b));if(!u)return C.push(v.localize(0,null,b)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return C.push(v.localize(1,null,b)),!1}else if(!u.majorMustEqual)return C.push(v.localize(2,null,b)),!1;return L(f,u)?!0:(C.push(v.localize(3,null,f,b)),!1)}e.isVersionValid=I}),define(ee[133],te([0,1,31,66,2,14]),function(G,e,v,k,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends _.Disposable{constructor(p,g,I,f){super();this.folders=p,this.onDidFilesChange=g,this.onLogMessage=I,this.verboseLogging=f,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new k.Client(R.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.createChannelSender(v.getNextTickChannel(p.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.setFolders(this.folders)}setVerboseLogging(p){this.verboseLogging=p,!this.isDisposed&&this.service&&this.service.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${p}`})}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(ee[134],te([0,1,31,66,2,14]),function(G,e,v,k,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends _.Disposable{constructor(p,g,I,f,b={}){super();this.folders=p,this.onDidFilesChange=g,this.onLogMessage=I,this.verboseLogging=f,this.watcherOptions=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new k.Client(R.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.createChannelSender(v.getNextTickChannel(p.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.service.setRoots(this.folders)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${p}`})}setVerboseLogging(p){this.verboseLogging=p,this.service&&this.service.setVerboseLogging(p)}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(ee[135],te([0,1,47,65,85,14]),function(G,e,v,k,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class P{constructor(p,g,I,f,b){this.watchedFolder=p,this.eventCallback=I,this.logCallback=f,this.verboseLogging=b,this.restartCounter=0,Array.isArray(g)?this.ignored=g.map(C=>_.parse(C)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${p}`),this.startWatcher()}startWatcher(){const p=[this.watchedFolder];this.verboseLogging&&p.push("-verbose"),this.handle=v.spawn(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",G).fsPath,p);const g=new k.LineDecoder;this.handle.stdout.on("data",I=>{const f=[];g.write(I).forEach(b=>{const C=b.split("|");if(C.length===2){const u=Number(C[0]),D=C[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(S=>S(D))){this.verboseLogging&&this.log(D);return}f.push({type:P.changeTypeMap[u],path:D})}else this.log(C[1])}}),f.length>0&&this.eventCallback(f)}),this.handle.on("error",I=>this.onError(I)),this.handle.stderr.on("data",I=>this.onError(I)),this.handle.on("exit",(I,f)=>this.onExit(I,f))}onError(p){this.error("process error: "+p.toString())}onExit(p,g){this.handle&&(this.error(`terminated unexpectedly (code: ${p}, signal: ${g})`),this.restartCounter<=P.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(p){this.logCallback({type:"error",message:`[File Watcher (C#)] ${p}`})}log(p){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${p}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=P,P.MAX_RESTARTS=5,P.changeTypeMap=[0,1,2]}),define(ee[136],te([0,1,135,4,20]),function(G,e,v,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class R{constructor(L,p,g,I){this.onDidFilesChange=p,this.onLogMessage=g,this.verboseLogging=I,this.service=void 0,this.folder=L[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(k.posix.sep)&&(this.folder.path=_.rtrim(this.folder.path,k.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new v.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,L=>this.onFileEvents(L),L=>this.onLogMessage(L),this.verboseLogging)}setVerboseLogging(L){this.verboseLogging=L,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(L){this.isDisposed||L.length>0&&this.onDidFilesChange(L)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=R}),define(ee[68],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(R,P=[],L=!1){this.ctor=R,this.staticArguments=P,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=v;const k=(_,...R)=>new v(_,R);e.createSyncDescriptor=k}),define(ee[137],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=v;class k{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let P of this._nodes.values())P.outgoing.size===0&&R.push(P);return R}insertEdge(R,P){const L=this.lookupOrInsertNode(R),p=this.lookupOrInsertNode(P);L.outgoing.set(this._hashFn(P),p),p.incoming.set(this._hashFn(R),L)}removeNode(R){const P=this._hashFn(R);this._nodes.delete(P);for(let L of this._nodes.values())L.outgoing.delete(P),L.incoming.delete(P)}lookupOrInsertNode(R){const P=this._hashFn(R);let L=this._nodes.get(P);return L||(L=new v(R),this._nodes.set(P,L)),L}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[P,L]of this._nodes)R.push(`${P}, (incoming)[${[...L.incoming.keys()].join(", ")}], (outgoing)[${[...L.outgoing.keys()].join(",")}]`);return R.join(`
`)}}e.Graph=k}),define(ee[5],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function L(p){return p[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=L})(v=e._util||(e._util={})),e.IInstantiationService=_("instantiationService");function k(P,L,p,g){L[v.DI_TARGET]===L?L[v.DI_DEPENDENCIES].push({id:P,index:p,optional:g}):(L[v.DI_DEPENDENCIES]=[{id:P,index:p,optional:g}],L[v.DI_TARGET]=L)}function _(P){if(v.serviceIds.has(P))return v.serviceIds.get(P);const L=function(p,g,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(L,p,I,!1)};return L.toString=()=>P,v.serviceIds.set(P,L),L}e.createDecorator=_;function R(P){return function(L,p,g){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(P,L,g,!0)}}e.optional=R}),define(ee[138],te([0,1,20,5,6]),function(G,e,v,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let R=_.userAgent||"";const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",_.isMacintosh),P.set("isLinux",_.isLinux),P.set("isWindows",_.isWindows),P.set("isWeb",_.isWeb),P.set("isMacNative",_.isMacintosh&&!_.isWeb),P.set("isEdge",R.indexOf("Edg/")>=0),P.set("isFirefox",R.indexOf("Firefox")>=0),P.set("isChrome",R.indexOf("Chrome")>=0),P.set("isSafari",R.indexOf("Safari")>=0),P.set("isIPad",R.indexOf("iPad")>=0);const L=Object.prototype.hasOwnProperty;var p;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(p=e.ContextKeyExprType||(e.ContextKeyExprType={}));class g{static false(){return f.INSTANCE}static true(){return b.INSTANCE}static has(d){return C.create(d)}static equals(d,O){return u.create(d,O)}static notEquals(d,O){return w.create(d,O)}static regex(d,O){return r.create(d,O)}static in(d,O){return D.create(d,O)}static not(d){return m.create(d)}static and(...d){return a.create(d)}static or(...d){return n.create(d)}static greater(d,O){return l.create(d,O)}static less(d,O){return s.create(d,O)}static deserialize(d,O=!1){if(!!d)return this._deserializeOrExpression(d,O)}static _deserializeOrExpression(d,O){let A=d.split("||");return n.create(A.map(j=>this._deserializeAndExpression(j,O)))}static _deserializeAndExpression(d,O){let A=d.split("&&");return a.create(A.map(j=>this._deserializeOne(j,O)))}static _deserializeOne(d,O){if(d=d.trim(),d.indexOf("!=")>=0){let A=d.split("!=");return w.create(A[0].trim(),this._deserializeValue(A[1],O))}if(d.indexOf("==")>=0){let A=d.split("==");return u.create(A[0].trim(),this._deserializeValue(A[1],O))}if(d.indexOf("=~")>=0){let A=d.split("=~");return r.create(A[0].trim(),this._deserializeRegexValue(A[1],O))}if(d.indexOf(" in ")>=0){let A=d.split(" in ");return D.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(d)){const A=d.split(">=");return o.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(d)){const A=d.split(">");return l.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(d)){const A=d.split("<=");return t.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(d)){const A=d.split("<");return s.create(A[0].trim(),A[1].trim())}return/^\!\s*/.test(d)?m.create(d.substr(1).trim()):C.create(d)}static _deserializeValue(d,O){if(d=d.trim(),d==="true")return!0;if(d==="false")return!1;let A=/^'([^']*)'$/.exec(d);return A?A[1].trim():d}static _deserializeRegexValue(d,O){if(v.isFalsyOrWhitespace(d)){if(O)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let A=d.indexOf("/"),j=d.lastIndexOf("/");if(A===j||A<0){if(O)throw new Error(`bad regexp-value '${d}', missing /-enclosure`);return console.warn(`bad regexp-value '${d}', missing /-enclosure`),null}let z=d.slice(A+1,j),W=d[j+1]==="i"?"i":"";try{return new RegExp(z,W)}catch(N){if(O)throw new Error(`bad regexp-value '${d}', parse error: ${N}`);return console.warn(`bad regexp-value '${d}', parse error: ${N}`),null}}}e.ContextKeyExpr=g;function I(E,d){return E.cmp(d)}class f{constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=f,f.INSTANCE=new f;class b{constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return f.INSTANCE}}e.ContextKeyTrueExpr=b,b.INSTANCE=new b;class C{constructor(d){this.key=d,this.type=2}static create(d){const O=P.get(d);return typeof O=="boolean"?O?b.INSTANCE:f.INSTANCE:new C(d)}cmp(d){return d.type!==this.type?this.type-d.type:h(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return m.create(this.key)}}e.ContextKeyDefinedExpr=C;class u{constructor(d,O){this.key=d,this.value=O,this.type=4}static create(d,O){if(typeof O=="boolean")return O?C.create(d):m.create(d);const A=P.get(d);return typeof A=="boolean"?O===(A?"true":"false")?b.INSTANCE:f.INSTANCE:new u(d,O)}cmp(d){return d.type!==this.type?this.type-d.type:y(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return d.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(d){return d.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=u;class D{constructor(d,O){this.key=d,this.valueKey=O,this.type=10}static create(d,O){return new D(d,O)}cmp(d){return d.type!==this.type?this.type-d.type:y(this.key,this.valueKey,d.key,d.valueKey)}equals(d){return d.type===this.type?this.key===d.key&&this.valueKey===d.valueKey:!1}evaluate(d){const O=d.getValue(this.valueKey),A=d.getValue(this.key);return Array.isArray(O)?O.indexOf(A)>=0:typeof A=="string"&&typeof O=="object"&&O!==null?L.call(O,A):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(d){return d.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=D;class S{constructor(d){this._actual=d,this.type=11}static create(d){return new S(d)}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}evaluate(d){return!this._actual.evaluate(d)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(d){return new S(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class w{constructor(d,O){this.key=d,this.value=O,this.type=5}static create(d,O){if(typeof O=="boolean")return O?m.create(d):C.create(d);const A=P.get(d);return typeof A=="boolean"?O===(A?"true":"false")?f.INSTANCE:b.INSTANCE:new w(d,O)}cmp(d){return d.type!==this.type?this.type-d.type:y(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return d.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(d){return d.mapNotEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class m{constructor(d){this.key=d,this.type=3}static create(d){const O=P.get(d);return typeof O=="boolean"?O?f.INSTANCE:b.INSTANCE:new m(d)}cmp(d){return d.type!==this.type?this.type-d.type:h(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}evaluate(d){return!d.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(d){return d.mapNot(this.key)}negate(){return C.create(this.key)}}e.ContextKeyNotExpr=m;class l{constructor(d,O){this.key=d,this.value=O,this.type=12}static create(d,O){return new l(d,O)}cmp(d){return d.type!==this.type?this.type-d.type:y(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=l;class o{constructor(d,O){this.key=d,this.value=O,this.type=13}static create(d,O){return new o(d,O)}cmp(d){return d.type!==this.type?this.type-d.type:y(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreaterEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=o;class s{constructor(d,O){this.key=d,this.value=O,this.type=14}static create(d,O){return new s(d,O)}cmp(d){return d.type!==this.type?this.type-d.type:y(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmaller(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeySmallerExpr=s;class t{constructor(d,O){this.key=d,this.value=O,this.type=15}static create(d,O){return new t(d,O)}cmp(d){return d.type!==this.type?this.type-d.type:y(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmallerEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(d,O){this.key=d,this.regexp=O,this.type=7}static create(d,O){return new r(d,O)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.key<d.key)return-1;if(this.key>d.key)return 1;const O=this.regexp?this.regexp.source:"",A=d.regexp?d.regexp.source:"";return O<A?-1:O>A?1:0}equals(d){if(d.type===this.type){const O=this.regexp?this.regexp.source:"",A=d.regexp?d.regexp.source:"";return this.key===d.key&&O===A}return!1}evaluate(d){let O=d.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const d=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${d}`}keys(){return[this.key]}map(d){return d.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(d){this._actual=d,this.type=8}static create(d){return new i(d)}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}evaluate(d){return!this._actual.evaluate(d)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(d){return new i(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class a{constructor(d){this.expr=d,this.type=6}static create(d){return a._normalizeArr(d)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let O=0,A=this.expr.length;O<A;O++){const j=I(this.expr[O],d.expr[O]);if(j!==0)return j}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let O=0,A=this.expr.length;O<A;O++)if(!this.expr[O].equals(d.expr[O]))return!1;return!0}return!1}evaluate(d){for(let O=0,A=this.expr.length;O<A;O++)if(!this.expr[O].evaluate(d))return!1;return!0}static _normalizeArr(d){const O=[];let A=!1;for(const j of d)if(!!j){if(j.type===1){A=!0;continue}if(j.type===0)return f.INSTANCE;if(j.type===6){O.push(...j.expr);continue}O.push(j)}if(O.length===0&&A)return b.INSTANCE;if(O.length!==0){if(O.length===1)return O[0];for(O.sort(I);O.length>1;){const j=O[O.length-1];if(j.type!==9)break;O.pop();const z=O.pop(),W=n.create(j.expr.map(N=>a.create([N,z])));W&&(O.push(W),O.sort(I))}return O.length===1?O[0]:new a(O)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(let O of this.expr)d.push(...O.keys());return d}map(d){return new a(this.expr.map(O=>O.map(d)))}negate(){let d=[];for(let O of this.expr)d.push(O.negate());return n.create(d)}}e.ContextKeyAndExpr=a;class n{constructor(d){this.expr=d,this.type=9}static create(d){const O=n._normalizeArr(d);if(O.length!==0)return O.length===1?O[0]:new n(O)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let O=0,A=this.expr.length;O<A;O++){const j=I(this.expr[O],d.expr[O]);if(j!==0)return j}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let O=0,A=this.expr.length;O<A;O++)if(!this.expr[O].equals(d.expr[O]))return!1;return!0}return!1}evaluate(d){for(let O=0,A=this.expr.length;O<A;O++)if(this.expr[O].evaluate(d))return!0;return!1}static _normalizeArr(d){let O=[],A=!1;if(d){for(let j=0,z=d.length;j<z;j++){const W=d[j];if(!!W){if(W.type===0){A=!0;continue}if(W.type===1)return[b.INSTANCE];if(W.type===9){O=O.concat(W.expr);continue}O.push(W)}}if(O.length===0&&A)return[f.INSTANCE];O.sort(I)}return O}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(let O of this.expr)d.push(...O.keys());return d}map(d){return new n(this.expr.map(O=>O.map(d)))}negate(){let d=[];for(let A of this.expr)d.push(A.negate());const O=A=>A.type===9?A.expr:[A];for(;d.length>1;){const A=d.shift(),j=d.shift(),z=[];for(const W of O(A))for(const N of O(j))z.push(g.and(W,N));d.unshift(g.or(...z))}return d[0]}}e.ContextKeyOrExpr=n;class c extends C{constructor(d,O){super(d);this._defaultValue=O}bindTo(d){return d.createKey(this.key,this._defaultValue)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return g.not(this.key)}isEqualTo(d){return g.equals(this.key,d)}notEqualsTo(d){return g.notEquals(this.key,d)}}e.RawContextKey=c,e.IContextKeyService=k.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(E,d){return E<d?-1:E>d?1:0}function y(E,d,O,A){return E<O?-1:E>O?1:d<A?-1:d>A?1:0}}),define(ee[69],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=v.createDecorator("downloadService")}),define(ee[9],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=v.createDecorator("environmentService"),e.INativeEnvironmentService=v.createDecorator("nativeEnvironmentService")});var ge=this&&this.__decorate||function(G,e,v,k){var _=arguments.length,R=_<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,v):k,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(G,e,v,k);else for(var L=G.length-1;L>=0;L--)(P=G[L])&&(R=(_<3?P(R):_>3?P(e,v,R):P(e,v))||R);return _>3&&R&&Object.defineProperty(e,v,R),R},Y=this&&this.__param||function(G,e){return function(v,k){e(v,k,G)}};define(ee[139],te([0,1,9,4,22,13,2]),function(G,e,v,k,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let L=class extends P.Disposable{constructor(g){super();this.environmentService=g,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let g=setTimeout(()=>{g=void 0;const I=k.basename(this.environmentService.logsPath),f=k.dirname(this.environmentService.logsPath);_.readdir(f).then(b=>{const u=b.filter(S=>/^\d{8}T\d{6}$/.test(S)).sort().filter((S,w)=>S!==I),D=u.slice(0,Math.max(0,u.length-9));return Promise.all(D.map(S=>_.rimraf(k.join(f,S))))}).then(null,R.onUnexpectedError)},10*1e3);this._register(P.toDisposable(()=>{g&&(clearTimeout(g),g=void 0)}))}};L=ge([Y(0,v.IEnvironmentService)],L),e.LogsDataCleaner=L}),define(ee[140],te([0,1,9,4,22,13,2]),function(G,e,v,k,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let L=class rt extends P.Disposable{constructor(g,I){super();this.backupWorkspacesPath=g,this.environmentService=I,this.cleanUpStorageSoon()}cleanUpStorageSoon(){let g=setTimeout(()=>{g=void 0,(async()=>{try{const I=await _.readFile(this.backupWorkspacesPath,"utf8"),b=JSON.parse(I).emptyWorkspaceInfos.map(D=>D.backupFolder),C=await _.readdir(this.environmentService.workspaceStorageHome.fsPath),u=[];C.forEach(D=>{D.length!==rt.NON_EMPTY_WORKSPACE_ID_LENGTH&&b.indexOf(D)===-1&&u.push(_.rimraf(k.join(this.environmentService.workspaceStorageHome.fsPath,D)))}),await Promise.all(u)}catch(I){R.onUnexpectedError(I)}})()},30*1e3);this._register(P.toDisposable(()=>{g&&(clearTimeout(g),g=void 0)}))}};L.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,L=ge([Y(1,v.INativeEnvironmentService)],L),e.StorageDataCleaner=L}),define(ee[27],te([0,1,109,5,14]),function(G,e,v,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function R(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=R;var P;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=5]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var L;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(L=e.SortOrder||(e.SortOrder={}));var p;(function(f){f.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var g;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=k.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class I extends Error{constructor(b,C){super(b);this.code=C}}e.ExtensionManagementError=I,e.IExtensionManagementService=k.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=k.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=k.createDecorator("IExtensionTipsService"),e.DefaultIconPath=_.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=v.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=v.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=k.createDecorator("IExtensionManagementCLIService")}),define(ee[141],te([0,1,2,27]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let _=class extends v.Disposable{constructor(P){super();this.extensionManagementService=P,this._register(P),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};_=ge([Y(0,k.IExtensionManagementService)],_),e.DeprecatedExtensionsCleaner=_}),define(ee[70],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var k;(function(P){P[P.FILE=1]="FILE",P[P.WORKSPACE=2]="WORKSPACE",P[P.EXE=3]="EXE"})(k=e.RecommendationSource||(e.RecommendationSource={}));function _(P){switch(P){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=_;var R;(function(P){P.Ignored="ignored",P.Cancelled="cancelled",P.TooMany="toomany",P.IncompatibleWindow="incompatibleWindow",P.Accepted="reacted"})(R=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=v.createDecorator("IExtensionRecommendationNotificationService")}),define(ee[71],te([0,1,20,5]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function _(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Themes","Testing","Visualization","Other"];var R;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class P{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,f){if(typeof I=="undefined"||I===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof I=="string"||typeof f=="string"){let b=typeof I=="string"?I:I.value,C=typeof f=="string"?f:f.value;return v.equalsIgnoreCase(b,C)}return I._lower===f._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=P;function L(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=L;function p(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=p,e.IBuiltinExtensionsScannerService=k.createDecorator("IBuiltinExtensionsScannerService")}),define(ee[33],te([0,1,20,71]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function _(C,u){return C.uuid&&u.uuid?C.uuid===u.uuid:C.id===u.id?!0:v.compareIgnoreCase(C.id,u.id)===0}e.areSameExtensions=_;class R{constructor(u,D){this.version=D,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof R?_(this,u)&&this.version===u.version:!1}}e.ExtensionIdentifierWithVersion=R;function P(C,u){return`${C}.${u}`}e.getExtensionId=P;function L(C){return C.toLocaleLowerCase()}e.adoptToGalleryExtensionId=L;function p(C,u){return L(P(C,u))}e.getGalleryExtensionId=p;function g(C,u){const D=[],S=w=>{for(const m of D)if(m.some(l=>_(u(l),u(w))))return m;return null};for(const w of C){const m=S(w);m?m.push(w):D.push([w])}return D}e.groupByExtension=g;function I(C){return{id:C.identifier.id,name:C.manifest.name,galleryId:null,publisherId:C.publisherId,publisherName:C.manifest.publisher,publisherDisplayName:C.publisherDisplayName,dependencies:C.manifest.extensionDependencies&&C.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=I;function f(C){return Object.assign({id:C.identifier.id,name:C.name,galleryId:C.identifier.uuid,publisherId:C.publisherId,publisherName:C.publisher,publisherDisplayName:C.publisherDisplayName,dependencies:!!(C.properties.dependencies&&C.properties.dependencies.length>0)},C.telemetryData)}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function b(C){const u=new Set;for(const D of C)D.malicious&&u.add(D.id.id);return u}e.getMaliciousExtensionsSet=b}),define(ee[142],te([0,1,2,4,71,22]),function(G,e,v,k,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class P extends v.Disposable{constructor(p,g){super();this.environmentService=p,this.extensionsManifestCache=k.join(this.environmentService.userDataPath,_.MANIFEST_CACHE_FOLDER,_.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtension(I=>this.onDidInstallExtension(I))),this._register(g.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtension(p){p.error||this.invalidate()}onDidUnInstallExtension(p){p.error||this.invalidate()}invalidate(){R.rimraf(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=P}),define(ee[12],te([0,1,116,4,7,5,20,17,32]),function(G,e,v,k,_,R,P,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.IFileService=void 0,e.IFileService=R.createDecorator("fileService");var g;(function(A){A[A.Unknown=0]="Unknown",A[A.File=1]="File",A[A.Directory=2]="Directory",A[A.SymbolicLink=64]="SymbolicLink"})(g=e.FileType||(e.FileType={}));var I;(function(A){A[A.FileReadWrite=2]="FileReadWrite",A[A.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",A[A.FileReadStream=16]="FileReadStream",A[A.FileFolderCopy=8]="FileFolderCopy",A[A.PathCaseSensitive=1024]="PathCaseSensitive",A[A.Readonly=2048]="Readonly",A[A.Trash=4096]="Trash"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(A){return!!(A.capabilities&2)}e.hasReadWriteCapability=f;function b(A){return!!(A.capabilities&8)}e.hasFileFolderCopyCapability=b;function C(A){return!!(A.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function u(A){return!!(A.capabilities&16)}e.hasFileReadStreamCapability=u;var D;(function(A){A.FileExists="EntryExists",A.FileNotFound="EntryNotFound",A.FileNotADirectory="EntryNotADirectory",A.FileIsADirectory="EntryIsADirectory",A.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",A.FileTooLarge="EntryTooLarge",A.NoPermissions="NoPermissions",A.Unavailable="Unavailable",A.Unknown="Unknown"})(D=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(j,z){super(j);this.code=z}}e.FileSystemProviderError=S;function w(A,j){const z=new S(A.toString(),j);return l(z,j),z}e.createFileSystemProviderError=w;function m(A){return A||w(v.localize(0,null),D.Unknown)}e.ensureFileSystemProviderError=m;function l(A,j){return A.name=j?`${j} (FileSystemError)`:"FileSystemError",A}e.markAsFileSystemProviderError=l;function o(A){if(!A)return D.Unknown;if(A instanceof S)return A.code;const j=/^(.+) \(FileSystemError\)$/.exec(A.name);if(!j)return D.Unknown;switch(j[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileExceedsMemoryLimit:return D.FileExceedsMemoryLimit;case D.FileTooLarge:return D.FileTooLarge;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=o;function s(A){if(A instanceof c)return A.fileOperationResult;switch(o(A)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 10;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileExceedsMemoryLimit:return 9;case D.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var t;(function(A){A[A.CREATE=0]="CREATE",A[A.DELETE=1]="DELETE",A[A.MOVE=2]="MOVE",A[A.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class r{constructor(j,z,W){this.resource=j,this.operation=z,this.target=W}isOperation(j){return this.operation===j}}e.FileOperationEvent=r;var i;(function(A){A[A.UPDATED=0]="UPDATED",A[A.ADDED=1]="ADDED",A[A.DELETED=2]="DELETED"})(i=e.FileChangeType||(e.FileChangeType={}));class a{constructor(j,z){this.ignorePathCasing=z,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=j;for(const W of j)switch(W.type){case 1:this.added||(this.added=p.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(W.resource,W);break;case 0:this.updated||(this.updated=p.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(W.resource,W);break;case 2:this.deleted||(this.deleted=p.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(W.resource,W);break}}contains(j,...z){return this.doContains(j,{includeChildren:!1},...z)}affects(j,...z){return this.doContains(j,{includeChildren:!0},...z)}doContains(j,z,...W){var N,x,F,B,K,$;if(!j)return!1;const T=W.length>0;return!!((!T||W.includes(1))&&(((N=this.added)===null||N===void 0?void 0:N.get(j))||z.includeChildren&&((x=this.added)===null||x===void 0?void 0:x.findSuperstr(j)))||(!T||W.includes(0))&&(((F=this.updated)===null||F===void 0?void 0:F.get(j))||z.includeChildren&&((B=this.updated)===null||B===void 0?void 0:B.findSuperstr(j)))||(!T||W.includes(2))&&(((K=this.deleted)===null||K===void 0?void 0:K.findSubstr(j))||z.includeChildren&&(($=this.deleted)===null||$===void 0?void 0:$.findSuperstr(j))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(j){const z=[],W=j===1?this.added:j===0?this.updated:this.deleted;if(W)for(const[,N]of W)z.push(N);return z}filter(j){return new a(this.changes.filter(z=>j(z)),this.ignorePathCasing)}}e.FileChangesEvent=a;function n(A,j,z){return!A||!j||A===j||j.length>A.length?!1:(j.charAt(j.length-1)!==k.sep&&(j+=k.sep),z?P.startsWithIgnoreCase(A,j):A.indexOf(j)===0)}e.isParent=n;class c extends Error{constructor(j,z,W){super(j);this.fileOperationResult=z,this.options=W}static isFileOperationError(j){return j instanceof Error&&!L.isUndefinedOrNull(j.fileOperationResult)}}e.FileOperationError=c;var h;(function(A){A[A.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",A[A.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",A[A.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",A[A.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",A[A.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",A[A.FILE_READ_ONLY=5]="FILE_READ_ONLY",A[A.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",A[A.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",A[A.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",A[A.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",A[A.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",A[A.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(h=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var y;(function(A){A[A.FILE=0]="FILE",A[A.FOLDER=1]="FOLDER",A[A.ROOT_FOLDER=2]="ROOT_FOLDER"})(y=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function E(A){if(!(typeof A.size!="number"||typeof A.mtime!="number"))return A.mtime.toString(29)+A.size.toString(31)}e.etag=E;async function d(A,j){if(!j.canHandleResource(_.URI.from({scheme:A.scheme})))return new Promise(z=>{const W=j.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===A.scheme&&N.added&&(W.dispose(),z())})})}e.whenProviderRegistered=d,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(j){return L.isNumber(j)||(j=0),j<O.KB?v.localize(1,null,j.toFixed(0)):j<O.MB?v.localize(2,null,(j/O.KB).toFixed(2)):j<O.GB?v.localize(3,null,(j/O.MB).toFixed(2)):j<O.TB?v.localize(4,null,(j/O.GB).toFixed(2)):v.localize(5,null,(j/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB}),define(ee[72],te([0,1,117,16,12,13]),function(G,e,v,k,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(I,f,b,C,u,D){let S;try{await L(I,f,b,C,u,D)}catch(w){S=w}finally{S&&u.errorTransformer&&(S=u.errorTransformer(S)),b.end(S)}}e.readFileIntoStream=P;async function L(I,f,b,C,u,D){p(D);const S=await I.open(f,{create:!1});try{p(D);let w=0,m=0,l=u&&typeof u.length=="number"?u.length:void 0,o=k.VSBuffer.alloc(Math.min(u.bufferSize,typeof l=="number"?l:u.bufferSize)),s=u&&typeof u.position=="number"?u.position:0,t=0;do m=await I.read(S,s,o.buffer,t,o.byteLength-t),s+=m,t+=m,w+=m,typeof l=="number"&&(l-=m),t===o.byteLength&&(await b.write(C(o)),o=k.VSBuffer.alloc(Math.min(u.bufferSize,typeof l=="number"?l:u.bufferSize)),t=0);while(m>0&&(typeof l!="number"||l>0)&&p(D)&&g(w,u));if(t>0){let r=t;typeof l=="number"&&(r=Math.min(t,l)),b.write(C(o.slice(0,r)))}}catch(w){throw _.ensureFileSystemProviderError(w)}finally{await I.close(S)}}function p(I){if(I.isCancellationRequested)throw R.canceled();return!0}function g(I,f){if(f==null?void 0:f.limits){if(typeof f.limits.memory=="number"&&I>f.limits.memory)throw _.createFileSystemProviderError(v.localize(0,null),_.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof f.limits.size=="number"&&I>f.limits.size)throw _.createFileSystemProviderError(v.localize(1,null),_.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[73],te([0,1,7,12,6]),function(G,e,v,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function R(p){return p.map(g=>({type:g.type,resource:v.URI.file(g.path)}))}e.toFileChanges=R;function P(p){const g=new L;for(const I of p)g.processEvent(I);return g.normalize()}e.normalizeFileChanges=P;class L{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(g){const I=this.mapPathToChange.get(g.path);if(I){const f=I.type,b=g.type;f===1&&b===2?(this.mapPathToChange.delete(g.path),this.normalized.splice(this.normalized.indexOf(I),1)):f===2&&b===1?I.type=0:f===1&&b===0||(I.type=b)}else this.normalized.push(g),this.mapPathToChange.set(g.path,g)}normalize(){const g=[],I=[];return this.normalized.filter(f=>f.type!==2?(g.push(f),!1):!0).sort((f,b)=>f.path.length-b.path.length).filter(f=>I.some(b=>k.isParent(f.path,b,!_.isLinux))?!1:(I.push(f.path),!0)).concat(g)}}}),define(ee[143],te([0,1,73,2,22,92,94,8,4]),function(G,e,v,k,_,R,P,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class g extends k.Disposable{constructor(f,b,C,u){super();this.path=f,this.onDidFilesChange=b,this.onLogMessage=C,this.verboseLogging=u,this.fileChangesDelayer=this._register(new L.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(f){this.verboseLogging=f}async startWatching(){try{const{stat:f,symbolicLink:b}=await _.statLink(this.path);if(this.isDisposed)return;let C=this.path;if(b)try{C=await R.realpath(C)}catch(u){this.onError(u)}f.isDirectory()?this._register(P.watchFolder(C,(u,D)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:p.join(this.path,p.basename(D))})},u=>this.onError(u))):this._register(P.watchFile(C,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(f){this.onError(f)}}onFileChange(f){this.fileChangesBuffer.push(f),this.verboseLogging&&this.onVerbose(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),this.fileChangesDelayer.trigger(async()=>{const b=this.fileChangesBuffer;this.fileChangesBuffer=[];const C=v.normalizeFileChanges(b);this.verboseLogging&&C.forEach(u=>{this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`)}),C.length>0&&this.onDidFilesChange(C)})}onError(f){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${f}`})}onVerbose(f){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=g}),define(ee[74],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(..._){this._entries=new Map;for(let[R,P]of _)this.set(R,P)}set(_,R){const P=this._entries.get(_);return this._entries.set(_,R),P}has(_){return this._entries.has(_)}get(_){return this._entries.get(_)}}e.ServiceCollection=v}),define(ee[144],te([0,1,13,137,68,5,74,8]),function(G,e,v,k,_,R,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const p=!1;class g extends Error{constructor(u){super("cyclic dependency between services");this.message=u.toString()}}class I{constructor(u=new P.ServiceCollection,D=!1,S){this._activeInstantiations=new Set,this._services=u,this._strict=D,this._parent=S,this._services.set(R.IInstantiationService,this)}createChild(u){return new I(u,this._strict,this)}invokeFunction(u,...D){let S=b.traceInvocation(u),w=!1;try{return u({get:(l,o)=>{if(w)throw v.illegalState("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(l,S);if(!s&&o!==R.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return s}},...D)}finally{w=!0,S.stop()}}createInstance(u,...D){let S,w;return u instanceof _.SyncDescriptor?(S=b.traceCreation(u.ctor),w=this._createInstance(u.ctor,u.staticArguments.concat(D),S)):(S=b.traceCreation(u),w=this._createInstance(u,D,S)),S.stop(),w}_createInstance(u,D=[],S){let w=R._util.getServiceDependencies(u).sort((o,s)=>o.index-s.index),m=[];for(const o of w){let s=this._getOrCreateServiceInstance(o.id,S);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);m.push(s)}let l=w.length>0?w[0].index:D.length;if(D.length!==l){console.warn(`[createInstance] First service dependency of ${u.name} at position ${l+1} conflicts with ${D.length} static arguments`);let o=l-D.length;o>0?D=D.concat(new Array(o)):D=D.slice(0,l)}return new u(...[...D,...m])}_setServiceInstance(u,D){if(this._services.get(u)instanceof _.SyncDescriptor)this._services.set(u,D);else if(this._parent)this._parent._setServiceInstance(u,D);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let D=this._services.get(u);return!D&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):D}_getOrCreateServiceInstance(u,D){let S=this._getServiceInstanceOrDescriptor(u);return S instanceof _.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,S,D.branch(u,!0)):(D.branch(u,!1),S)}_safeCreateAndCacheServiceInstance(u,D,S){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,D,S)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,D,S){const w=new k.Graph(o=>o.id.toString());let m=0;const l=[{id:u,desc:D,_trace:S}];for(;l.length;){const o=l.pop();if(w.lookupOrInsertNode(o),m++>1e3)throw new g(w);for(let s of R._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(!t&&!s.optional&&console.warn(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`),t instanceof _.SyncDescriptor){const r={id:s.id,desc:t,_trace:o._trace.branch(s.id,!0)};w.insertEdge(o,r),l.push(r)}}}for(;;){const o=w.roots();if(o.length===0){if(!w.isEmpty())throw new g(w);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof _.SyncDescriptor){const r=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,r)}w.removeNode(s)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,D,S=[],w,m){if(this._services.get(u)instanceof _.SyncDescriptor)return this._createServiceInstance(D,S,w,m);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,D,S,w,m);throw new Error(`illegalState - creating UNKNOWN service instance ${D.name}`)}_createServiceInstance(u,D=[],S,w){if(S){const m=new L.IdleValue(()=>this._createInstance(u,D,w));return new Proxy(Object.create(null),{get(l,o){if(o in l)return l[o];let s=m.value,t=s[o];return typeof t!="function"||(t=t.bind(s),l[o]=t),t},set(l,o,s){return m.value[o]=s,!0}})}else return this._createInstance(u,D,w)}}e.InstantiationService=I;var f;(function(C){C[C.Creation=0]="Creation",C[C.Invocation=1]="Invocation",C[C.Branch=2]="Branch"})(f||(f={}));class b{constructor(u,D){this.type=u,this.name=D,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return p?new b(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(u){return p?new b(0,u.name):b._None}branch(u,D){let S=new b(2,u.toString());return this._dep.push([u,D,S]),S}stop(){let u=Date.now()-this._start;b._totals+=u;let D=!1;function S(m,l){let o=[],s=new Array(m+1).join("	");for(const[t,r,i]of l._dep)if(r&&i){D=!0,o.push(`${s}CREATES -> ${t}`);let a=S(m+1,i);a&&o.push(a)}else o.push(`${s}uses -> ${t}`);return o.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(u>2||D)&&console.log(w.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(ee[145],te([0,1,99,2,5]),function(G,e,v,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=e.ElectronIPCMainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=_.createDecorator("mainProcessService");class R extends k.Disposable{constructor(p){super();this.mainProcessConnection=this._register(new v.Client(`window:${p}`))}getChannel(p){return this.mainProcessConnection.getChannel(p)}registerChannel(p,g){this.mainProcessConnection.registerChannel(p,g)}}e.ElectronIPCMainProcessService=R;class P{constructor(p,g){this.server=p,this.router=g}getChannel(p){return this.server.getChannel(p,this.router)}registerChannel(p,g){this.server.registerChannel(p,g)}}e.MessagePortMainProcessService=P}),define(ee[55],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=v.createDecorator("localizationsService");function k(_){if(typeof _.languageId!="string"||!Array.isArray(_.translations)||_.translations.length===0)return!1;for(const R of _.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(_.languageName&&typeof _.languageName!="string"||_.localizedLanguageName&&typeof _.localizedLanguageName!="string")}e.isValidLocalization=k}),define(ee[146],te([0,1,2,55]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let _=class extends v.Disposable{constructor(P){super();this.localizationsService=P,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};_=ge([Y(0,k.ILocalizationsService)],_),e.LocalizationsUpdater=_}),define(ee[15],te([0,1,5,2,6,3,43]),function(G,e,v,k,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.DelegatedLogService=e.MultiplexLogService=e.ConsoleLogInMainService=e.LogServiceAdapter=e.ConsoleLogService=e.ConsoleLogMainService=e.AbstractLogService=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=v.createDecorator("logService"),e.ILoggerService=v.createDecorator("loggerService");function L(){return new Date().toISOString()}var p;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;class g extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogService=g;class I extends g{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!_.isWindows}trace(s,...t){this.getLevel()<=p.Trace&&(this.useColors?console.log(`[90m[main ${L()}][0m`,s,...t):console.log(`[main ${L()}]`,s,...t))}debug(s,...t){this.getLevel()<=p.Debug&&(this.useColors?console.log(`[90m[main ${L()}][0m`,s,...t):console.log(`[main ${L()}]`,s,...t))}info(s,...t){this.getLevel()<=p.Info&&(this.useColors?console.log(`[90m[main ${L()}][0m`,s,...t):console.log(`[main ${L()}]`,s,...t))}warn(s,...t){this.getLevel()<=p.Warning&&(this.useColors?console.warn(`[93m[main ${L()}][0m`,s,...t):console.warn(`[main ${L()}]`,s,...t))}error(s,...t){this.getLevel()<=p.Error&&(this.useColors?console.error(`[91m[main ${L()}][0m`,s,...t):console.error(`[main ${L()}]`,s,...t))}critical(s,...t){this.getLevel()<=p.Critical&&(this.useColors?console.error(`[90m[main ${L()}][0m`,s,...t):console.error(`[main ${L()}]`,s,...t))}dispose(){}flush(){}}e.ConsoleLogMainService=I;class f extends g{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...t){this.getLevel()<=p.Trace&&console.log("%cTRACE","color: #888",s,...t)}debug(s,...t){this.getLevel()<=p.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...t)}info(s,...t){this.getLevel()<=p.Info&&console.log("%c INFO","color: #33f",s,...t)}warn(s,...t){this.getLevel()<=p.Warning&&console.log("%c WARN","color: #993",s,...t)}error(s,...t){this.getLevel()<=p.Error&&console.log("%c  ERR","color: #f33",s,...t)}critical(s,...t){this.getLevel()<=p.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...t)}dispose(){}flush(){}}e.ConsoleLogService=f;class b extends g{constructor(s,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(t)}trace(s,...t){this.getLevel()<=p.Trace&&this.adapter.consoleLog("trace",[this.extractMessage(s),...t])}debug(s,...t){this.getLevel()<=p.Debug&&this.adapter.consoleLog("debug",[this.extractMessage(s),...t])}info(s,...t){this.getLevel()<=p.Info&&this.adapter.consoleLog("info",[this.extractMessage(s),...t])}warn(s,...t){this.getLevel()<=p.Warning&&this.adapter.consoleLog("warn",[this.extractMessage(s),...t])}error(s,...t){this.getLevel()<=p.Error&&this.adapter.consoleLog("error",[this.extractMessage(s),...t])}critical(s,...t){this.getLevel()<=p.Critical&&this.adapter.consoleLog("critical",[this.extractMessage(s),...t])}extractMessage(s){return typeof s=="string"?s:P.toErrorMessage(s,this.getLevel()<=p.Trace)}dispose(){}flush(){}}e.LogServiceAdapter=b;class C extends b{constructor(s,t=e.DEFAULT_LOG_LEVEL){super({consoleLog:(r,i)=>s.consoleLog(r,i)},t)}}e.ConsoleLogInMainService=C;class u extends g{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const t of this.logServices)t.setLevel(s);super.setLevel(s)}trace(s,...t){for(const r of this.logServices)r.trace(s,...t)}debug(s,...t){for(const r of this.logServices)r.debug(s,...t)}info(s,...t){for(const r of this.logServices)r.info(s,...t)}warn(s,...t){for(const r of this.logServices)r.warn(s,...t)}error(s,...t){for(const r of this.logServices)r.error(s,...t)}critical(s,...t){for(const r of this.logServices)r.critical(s,...t)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=u;class D extends k.Disposable{constructor(s){super();this.logService=s,this._register(s)}get onDidChangeLogLevel(){return this.logService.onDidChangeLogLevel}setLevel(s){this.logService.setLevel(s)}getLevel(){return this.logService.getLevel()}trace(s,...t){this.logService.trace(s,...t)}debug(s,...t){this.logService.debug(s,...t)}info(s,...t){this.logService.info(s,...t)}warn(s,...t){this.logService.warn(s,...t)}error(s,...t){this.logService.error(s,...t)}critical(s,...t){this.logService.critical(s,...t)}flush(){this.logService.flush()}}e.DelegatedLogService=D;class S{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(s){}getLevel(){return p.Info}trace(s,...t){}debug(s,...t){}info(s,...t){}warn(s,...t){}error(s,...t){}critical(s,...t){}dispose(){}flush(){}}e.NullLogService=S;function w(o){if(o.verbose)return p.Trace;if(typeof o.logLevel=="string"){const s=m(o.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function m(o){switch(o){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Critical;case"off":return p.Off}}e.parseLogLevel=m;function l(o){switch(o){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Critical:return"critical";case p.Off:return"off"}}e.LogLevelToString=l}),define(ee[147],te([0,1,2,22,12,27,9,7,18,33,15,30,56,6]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const u=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let D=class extends v.Disposable{constructor(w,m,l,o){super();this.fileService=m,this.extensionGalleryService=l,this.logService=o,this.extensionsDownloadDir=L.URI.file(w.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(w,m){await this.cleanUpPromise;const l=this.getName(w),o=p.joinPath(this.extensionsDownloadDir,l);if(!await this.fileService.exists(o)){const s=p.joinPath(this.extensionsDownloadDir,`.${l}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(w,s,m),await this.rename(s,o,Date.now()+2*60*1e3)}return o}async delete(w){}async rename(w,m,l){try{await k.rename(w.fsPath,m.fsPath)}catch(o){if(C.isWindows&&o&&o.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${w} to ${m} with 'EPERM' error. Trying again...`),this.rename(w,m,l);throw o}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const w=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(w.children){const m=[],l=[];for(const t of w.children){const r=this.parse(t.name);r&&l.push([r,t])}const o=g.groupByExtension(l,([t])=>t),s=[];for(const t of o)t.sort((r,i)=>b.rcompare(r[0].version,i[0].version)),m.push(...t.slice(1).map(r=>r[1].resource)),s.push(t[0][1]);s.sort((t,r)=>t.mtime-r.mtime),m.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(t=>t.resource)),await Promise.all(m.map(t=>(this.logService.trace("Deleting vsix from cache",t.path),this.fileService.del(t))))}}catch(w){this.logService.error(w)}}getName(w){return this.cache?new g.ExtensionIdentifierWithVersion(w.identifier,w.version).key().toLowerCase():f.generateUuid()}parse(w){const m=u.exec(w);return m&&m[1]&&m[2]?new g.ExtensionIdentifierWithVersion({id:m[1]},m[2]):null}};D=ge([Y(0,P.INativeEnvironmentService),Y(1,_.IFileService),Y(2,R.IExtensionGalleryService),Y(3,I.ILogService)],D),e.ExtensionsDownloader=D}),define(ee[148],te([0,1,2,15,47,43,4,8,3,14,22,9]),function(G,e,v,k,_,R,P,L,p,g,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let b=class extends v.Disposable{constructor(u,D){super();this.environmentService=u,this.logService=D,this.processesLimiter=new L.Limiter(5)}async postUninstall(u){const D=this.parseScript(u,"uninstall");return D&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(D.script,"uninstall",D.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${S}`)))),I.rimraf(this.getExtensionStoragePath(u)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(u,D){const S=`vscode:${D}`;if(u.location.scheme===g.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[S]=="string"){const w=u.manifest.scripts[S].split(" ");return w.length<2||w[0]!=="node"||!w[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${S} should be a node script`),null):{script:P.join(u.location.fsPath,w[1]),args:w.slice(2)||[]}}return null}runLifecycleHook(u,D,S,w,m){return new Promise((l,o)=>{const s=this.start(u,D,S,m);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?o(i):l(void 0)};s.on("error",i=>{r(R.toErrorMessage(i)||"Unknown")}),s.on("exit",(i,a)=>{r(i?`post-${D} process exited with code ${i}`:void 0)}),w&&(t=setTimeout(()=>{t=null,s.kill(),o("timed out")},5e3))})}start(u,D,S,w){const m={silent:!0,execArgv:void 0},l=_.fork(u,[`--type=extension-post-${D}`,...S],m);l.stdout.setEncoding("utf8"),l.stderr.setEncoding("utf8");const o=p.Event.fromNodeEventEmitter(l.stdout,"data"),s=p.Event.fromNodeEventEmitter(l.stderr,"data");o(i=>this.logService.info(w.identifier.id,w.manifest.version,`post-${D}`,i)),s(i=>this.logService.error(w.identifier.id,w.manifest.version,`post-${D}`,i));const t=p.Event.any(p.Event.map(o,i=>({data:`%c${i}`,format:[""]})),p.Event.map(s,i=>({data:`%c${i}`,format:["color: red"]})));return p.Event.debounce(t,(i,a)=>i?{data:i.data+a.data,format:[...i.format,...a.format]}:{data:a.data,format:a.format},100)(i=>{console.group(w.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),l}getExtensionStoragePath(u){return P.join(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};b=ge([Y(0,f.IEnvironmentService),Y(1,k.ILogService)],b),e.ExtensionsLifecycle=b}),define(ee[149],te([0,1,115,150,2,12,3,18,32,19,15,16,52,8,28,14,72,51]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u,D,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let m=class extends _.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new P.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new P.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new P.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new P.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new P.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueues=new Map}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);k.mark(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const t=new _.DisposableStore;return t.add(s.onDidChangeFile(r=>this._onDidFilesChange.fire(new R.FileChangesEvent(r,!this.isPathCaseSensitive(s))))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&t.add(s.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),_.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),_.dispose(t)})}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){t&&s.push(t)}}),!this.provider.has(o)&&await Promise.all(s)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,s){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return w.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!L.isAbsolutePath(o))throw new R.FileOperationError(v.localize(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const t=new Error;throw t.name="ENOPRO",t.message=v.localize(1,null,o.toString()),t}return s}async withReadProvider(o){const s=await this.withProvider(o);if(R.hasOpenReadWriteCloseCapability(s)||R.hasReadWriteCapability(s)||R.hasFileReadStreamCapability(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if(R.hasOpenReadWriteCloseCapability(s)||R.hasReadWriteCapability(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(t){throw R.toFileSystemProviderErrorCode(t)===R.FileSystemProviderErrorCode.FileNotFound?new R.FileOperationError(v.localize(2,null,this.resourceForError(o)),1):R.ensureFileSystemProviderError(t)}}async doResolveFile(o,s){const t=await this.withProvider(o),r=this.isPathCaseSensitive(t),i=s==null?void 0:s.resolveTo,a=s==null?void 0:s.resolveSingleChildDescendants,n=s==null?void 0:s.resolveMetadata,c=await t.stat(o);let h;return this.toFileStat(t,o,c,void 0,!!n,(y,E)=>(h||(h=p.TernarySearchTree.forUris(()=>!r),h.set(o,!0),g.isNonEmptyArray(i)&&i.forEach(d=>h.set(d,!0))),Boolean(h.findSuperstr(y.resource)||h.get(y.resource))?!0:y.isDirectory&&a?E===1:!1))}async toFileStat(o,s,t,r,i,a){const{providerExtUri:n}=this.getExtUri(o),c={resource:s,name:n.basename(s),isFile:(t.type&R.FileType.File)!=0,isDirectory:(t.type&R.FileType.Directory)!=0,isSymbolicLink:(t.type&R.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:R.etag({mtime:t.mtime,size:t.size})};if(c.isDirectory&&a(c,r)){try{const h=await o.readdir(s),y=await Promise.all(h.map(async([E,d])=>{try{const O=n.joinPath(s,E),A=i?await o.stat(O):{type:d};return await this.toFileStat(o,O,A,h.length,i,a)}catch(O){return this.logService.trace(O),null}}));c.children=g.coalesce(y)}catch(h){this.logService.trace(h),c.children=[]}return c}return c}async resolveAll(o){return Promise.all(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(t){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(t){return t}return!0}async doValidateCreateFile(o,s){if(!(s==null?void 0:s.overwrite)&&await this.exists(o))throw new R.FileOperationError(v.localize(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=f.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const r=await this.writeFile(o,s);return this._onDidRunOperation.fire(new R.FileOperationEvent(o,0,r)),r}async writeFile(o,s,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,o,t)||await this.mkdirp(r,i.dirname(o));let n;if(R.hasReadWriteCapability(r)&&!(s instanceof f.VSBuffer))if(b.isReadableStream(s)){const c=await b.peekStream(s,3);c.ended?n=f.VSBuffer.concat(c.buffer):n=c}else n=b.peekReadable(s,c=>f.VSBuffer.concat(c),3);else n=s;!R.hasOpenReadWriteCloseCapability(r)||R.hasReadWriteCapability(r)&&n instanceof f.VSBuffer?await this.doWriteUnbuffered(r,o,n):await this.doWriteBuffered(r,o,n instanceof f.VSBuffer?f.bufferToReadable(n):n)}catch(a){throw new R.FileOperationError(v.localize(4,null,this.resourceForError(o),R.ensureFileSystemProviderError(a).toString()),R.toFileOperationResult(a),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,t){let r;try{r=await o.stat(s)}catch(i){return}if((r.type&R.FileType.Directory)!=0)throw new R.FileOperationError(v.localize(5,null,this.resourceForError(s)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==R.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==R.etag({mtime:t.mtime,size:r.size}))throw new R.FileOperationError(v.localize(6,null),3,t);return r}async readFile(o,s){const t=await this.withReadProvider(o),r=await this.doReadAsFileStream(t,o,Object.assign(Object.assign({},s),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await f.streamToBuffer(r.value)})}async readFileStream(o,s){const t=await this.withReadProvider(o);return this.doReadAsFileStream(t,o,s)}async doReadAsFileStream(o,s,t){const r=new u.CancellationTokenSource,i=this.validateReadFile(s,t).then(n=>n,n=>{throw r.cancel(),n});let a;try{t&&typeof t.etag=="string"&&t.etag!==R.ETAG_DISABLED&&await i;let n;!(R.hasOpenReadWriteCloseCapability(o)||R.hasFileReadStreamCapability(o))||R.hasReadWriteCapability(o)&&(t==null?void 0:t.preferUnbuffered)?n=this.readFileUnbuffered(o,s,t):R.hasFileReadStreamCapability(o)?n=this.readFileStreamed(o,s,r.token,t):n=this.readFileBuffered(o,s,r.token,t),a=b.observe(n);const c=await i;return Object.assign(Object.assign({},c),{value:n})}catch(n){throw a&&await a.errorOrEnd(),new R.FileOperationError(v.localize(7,null,this.resourceForError(s),R.ensureFileSystemProviderError(n).toString()),R.toFileOperationResult(n),t)}}readFileStreamed(o,s,t,r=Object.create(null)){const i=o.readFileStream(s,r,t);return b.transform(i,{data:a=>a instanceof f.VSBuffer?a:f.VSBuffer.wrap(a),error:a=>new R.FileOperationError(v.localize(8,null,this.resourceForError(s),R.ensureFileSystemProviderError(a).toString()),R.toFileOperationResult(a),r)},a=>f.VSBuffer.concat(a))}readFileBuffered(o,s,t,r=Object.create(null)){const i=f.newWriteableBufferStream();return S.readFileIntoStream(o,s,i,a=>a,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new R.FileOperationError(v.localize(9,null,this.resourceForError(s),R.ensureFileSystemProviderError(a).toString()),R.toFileOperationResult(a),r)}),t),i}readFileUnbuffered(o,s,t){const r=b.newWriteableStream(i=>f.VSBuffer.concat(i));return(async()=>{try{let i=await o.readFile(s);t&&typeof t.position=="number"&&(i=i.slice(t.position)),t&&typeof t.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(s,i.byteLength,t),r.end(f.VSBuffer.wrap(i))}catch(i){r.error(i)}})(),r}async validateReadFile(o,s){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new R.FileOperationError(v.localize(10,null,this.resourceForError(o)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==R.ETAG_DISABLED&&s.etag===t.etag)throw new R.FileOperationError(v.localize(11,null),2,s);return this.validateReadFileLimits(o,t.size,s),t}validateReadFileLimits(o,s,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&s>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&s>t.limits.size&&(r=7),typeof r=="number")throw new R.FileOperationError(v.localize(12,null,this.resourceForError(o)),r)}}async canMove(o,s,t){return this.doCanMoveCopy(o,s,"move",t)}async canCopy(o,s,t){return this.doCanMoveCopy(o,s,"copy",t)}async doCanMoveCopy(o,s,t,r){if(o.toString()!==s.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(i,o,a,s,t,r)}catch(i){return i}return!0}async move(o,s,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),a=await this.doMoveCopy(r,o,i,s,"move",!!t),n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(o,a==="move"?2:3,n)),n}async copy(o,s,t){const r=await this.withReadProvider(o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),a=await this.doMoveCopy(r,o,i,s,"copy",!!t),n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(o,a==="copy"?3:2,n)),n}async doMoveCopy(o,s,t,r,i,a){if(s.toString()===r.toString())return i;const{exists:n,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(o,s,t,r,i,a);if(n&&!c&&a&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),i==="copy"){if(o===t&&R.hasFileFolderCopyCapability(o))await o.copy(s,r,{overwrite:a});else{const h=await this.resolve(s);h.isDirectory?await this.doCopyFolder(o,h,t,r):await this.doCopyFile(o,s,t,r)}return i}else return o===t?(await o.rename(s,r,{overwrite:a}),i):(await this.doMoveCopy(o,s,t,r,"copy",a),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,t,r){if(R.hasOpenReadWriteCloseCapability(o)&&R.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(o,s,t,r);if(R.hasOpenReadWriteCloseCapability(o)&&R.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(o,s,t,r);if(R.hasReadWriteCapability(o)&&R.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(o,s,t,r);if(R.hasReadWriteCapability(o)&&R.hasReadWriteCapability(t))return this.doPipeUnbuffered(o,s,t,r)}async doCopyFolder(o,s,t,r){await t.mkdir(r),Array.isArray(s.children)&&await Promise.all(s.children.map(async i=>{const a=this.getExtUri(t).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(o,await this.resolve(i.resource),t,a):this.doCopyFile(o,i.resource,t,a)}))}async doValidateMoveCopy(o,s,t,r,i,a){let n=!1;if(o===t){const{providerExtUri:h,isPathCaseSensitive:y}=this.getExtUri(o);if(y||(n=h.isEqual(s,r)),n&&i==="copy")throw new Error(v.localize(13,null,this.resourceForError(s),this.resourceForError(r)));if(!n&&h.isEqualOrParent(r,s))throw new Error(v.localize(14,null,this.resourceForError(s),this.resourceForError(r)))}const c=await this.exists(r);if(c&&!n){if(!a)throw new R.FileOperationError(v.localize(15,null,this.resourceForError(s),this.resourceForError(r)),4);if(o===t){const{providerExtUri:h}=this.getExtUri(o);if(h.isEqualOrParent(s,r))throw new Error(v.localize(16,null,this.resourceForError(s),this.resourceForError(r)))}}return{exists:c,isSameResourceWithDifferentPathCase:n}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?L.extUri:L.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(o,0,t)),t}async mkdirp(o,s){const t=[],{providerExtUri:r}=this.getExtUri(o);for(;!r.isEqual(s,r.dirname(s));)try{if(((await o.stat(s)).type&R.FileType.Directory)==0)throw new Error(v.localize(17,null,this.resourceForError(s)));break}catch(i){if(R.toFileSystemProviderErrorCode(i)!==R.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(r.basename(s)),s=r.dirname(s)}for(let i=t.length-1;i>=0;i--){s=r.joinPath(s,t[i]);try{await o.mkdir(s)}catch(a){if(R.toFileSystemProviderErrorCode(a)!==R.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(t){return t}return!0}async doValidateDelete(o,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(s==null?void 0:s.useTrash)&&!(t.capabilities&4096))throw new Error(v.localize(18,null,this.resourceForError(o)));const i=await this.exists(o);if(!i)throw new R.FileOperationError(v.localize(19,null,this.resourceForError(o)),1);if(!!!(s==null?void 0:s.recursive)&&i){const n=await this.resolve(o);if(n.isDirectory&&Array.isArray(n.children)&&n.children.length>0)throw new Error(v.localize(20,null,this.resourceForError(o)))}return t}async del(o,s){const t=await this.doValidateDelete(o,s),r=!!(s==null?void 0:s.useTrash),i=!!(s==null?void 0:s.recursive);await t.delete(o,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new R.FileOperationEvent(o,1))}watch(o,s={recursive:!1,excludes:[]}){let t=!1,r=()=>{t=!0};return this.doWatch(o,s).then(i=>{t?_.dispose(i):r=()=>_.dispose(i)},i=>this.logService.error(i)),_.toDisposable(()=>r())}async doWatch(o,s){const t=await this.withProvider(o),r=this.toWatchKey(t,o,s),i=this.activeWatchers.get(r)||{count:0,disposable:t.watch(o,s)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,_.toDisposable(()=>{i.count--,i.count===0&&(_.dispose(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(o,s,t){const{providerExtUri:r}=this.getExtUri(o);return[r.getComparisonKey(s),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>_.dispose(o.disposable)),this.activeWatchers.clear()}ensureWriteQueue(o,s){const{providerExtUri:t}=this.getExtUri(o),r=t.getComparisonKey(s);let i=this.writeQueues.get(r);return i||(i=new C.Queue,this.writeQueues.set(r,i),P.Event.once(i.onFinished)(()=>{this.writeQueues.delete(r),_.dispose(i)})),i}async doWriteBuffered(o,s,t){return this.ensureWriteQueue(o,s).queue(async()=>{const r=await o.open(s,{create:!0});try{b.isReadableStream(t)||b.isReadableBufferedStream(t)?await this.doWriteStreamBufferedQueued(o,r,t):await this.doWriteReadableBufferedQueued(o,r,t)}catch(i){throw R.ensureFileSystemProviderError(i)}finally{await o.close(r)}})}async doWriteStreamBufferedQueued(o,s,t){let r=0,i;if(b.isReadableBufferedStream(t)){if(t.buffer.length>0){const a=f.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,s,a,a.byteLength,r,0),r+=a.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(a,n)=>{i.on("data",async c=>{i.pause();try{await this.doWriteBuffer(o,s,c,c.byteLength,r,0)}catch(h){return n(h)}r+=c.byteLength,setTimeout(()=>i.resume())}),i.on("error",c=>n(c)),i.on("end",()=>a())})}async doWriteReadableBufferedQueued(o,s,t){let r=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(o,s,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(o,s,t,r,i,a){let n=0;for(;n<r;)n+=await o.write(s,i+n,t.buffer,a+n,r-n)}async doWriteUnbuffered(o,s,t){return this.ensureWriteQueue(o,s).queue(()=>this.doWriteUnbufferedQueued(o,s,t))}async doWriteUnbufferedQueued(o,s,t){let r;t instanceof f.VSBuffer?r=t:b.isReadableStream(t)?r=await f.streamToBuffer(t):b.isReadableBufferedStream(t)?r=await f.bufferedStreamToBuffer(t):r=f.readableToBuffer(t),await o.writeFile(s,r.buffer,{create:!0,overwrite:!0})}async doPipeBuffered(o,s,t,r){return this.ensureWriteQueue(t,r).queue(()=>this.doPipeBufferedQueued(o,s,t,r))}async doPipeBufferedQueued(o,s,t,r){let i,a;try{i=await o.open(s,{create:!1}),a=await t.open(r,{create:!0});const n=f.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,h=0,y=0;do y=await o.read(i,c,n.buffer,h,n.byteLength-h),await this.doWriteBuffer(t,a,n,y,c,h),c+=y,h+=y,h===n.byteLength&&(h=0);while(y>0)}catch(n){throw R.ensureFileSystemProviderError(n)}finally{await Promise.all([typeof i=="number"?o.close(i):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(o,s,t,r){return this.ensureWriteQueue(t,r).queue(()=>this.doPipeUnbufferedQueued(o,s,t,r))}async doPipeUnbufferedQueued(o,s,t,r){return t.writeFile(r,await o.readFile(s),{create:!0,overwrite:!0})}async doPipeUnbufferedToBuffered(o,s,t,r){return this.ensureWriteQueue(t,r).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,t,r))}async doPipeUnbufferedToBufferedQueued(o,s,t,r){const i=await t.open(r,{create:!0});try{const a=await o.readFile(s);await this.doWriteBuffer(t,i,f.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw R.ensureFileSystemProviderError(a)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(o,s,t,r){const i=await f.streamToBuffer(this.readFileBuffered(o,s,u.CancellationToken.None));await this.doWriteUnbuffered(t,r,i)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new R.FileOperationError(v.localize(21,null,this.resourceForError(s)),6);return o}resourceForError(o){return o.scheme===D.Schemas.file?o.fsPath:o.toString(!0)}};m=ge([Y(0,I.ILogService)],m),e.FileService=m}),define(ee[151],te([0,1,36,53,2,12,3,6,22,4,18,35,8,15,118,73,134,136,133,143,52,72,19,16]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u,D,S,w,m,l,o,s,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class i extends _.Disposable{constructor(n,c){var h;super();this.logService=n,this.options=c,this.BUFFER_SIZE=((h=this.options)===null||h===void 0?void 0:h.bufferSize)||64*1024,this.onDidChangeCapabilities=P.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Set,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new P.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new b.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8,L.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:c,symbolicLink:h}=await p.statLink(this.toFilePath(n));return{type:this.toType(c,h),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size}}catch(c){throw this.toFileSystemProviderError(c)}}async readdir(n){try{const c=await p.readdirWithFileTypes(this.toFilePath(n)),h=[];return await Promise.all(c.map(async y=>{try{let E;y.isSymbolicLink()?E=(await this.stat(I.joinPath(n,y.name))).type:E=this.toType(y),h.push([y.name,E])}catch(E){this.logService.trace(E)}})),h}catch(c){throw this.toFileSystemProviderError(c)}}toType(n,c){let h;return(c==null?void 0:c.dangling)?h=R.FileType.Unknown:n.isFile()?h=R.FileType.File:n.isDirectory()?h=R.FileType.Directory:h=R.FileType.Unknown,c&&(h|=R.FileType.SymbolicLink),h}async readFile(n){try{const c=this.toFilePath(n);return await p.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}}readFileStream(n,c,h){const y=o.newWriteableStream(E=>r.VSBuffer.concat(E.map(d=>r.VSBuffer.wrap(d))).buffer);return s.readFileIntoStream(this,n,y,E=>E.buffer,Object.assign(Object.assign({},c),{bufferSize:this.BUFFER_SIZE}),h),y}async writeFile(n,c,h){let y;try{const E=this.toFilePath(n);if(!h.create||!h.overwrite){if(await p.exists(E)){if(!h.overwrite)throw R.createFileSystemProviderError(u.localize(0,null),R.FileSystemProviderErrorCode.FileExists)}else if(!h.create)throw R.createFileSystemProviderError(u.localize(1,null),R.FileSystemProviderErrorCode.FileNotFound)}y=await this.open(n,{create:!0}),await this.write(y,0,c,0,c.byteLength)}catch(E){throw this.toFileSystemProviderError(E)}finally{typeof y=="number"&&await this.close(y)}}async open(n,c){try{const h=this.toFilePath(n);let y;if(c.create){if(L.isWindows&&await p.exists(h))try{await p.truncate(h,0),y="r+"}catch(d){this.logService.trace(d)}y||(y="w")}else y="r";const E=await k.promisify(v.open)(h,y);return this.mapHandleToPos.set(E,0),c.create&&this.writeHandles.add(E),E}catch(h){throw this.toFileSystemProviderError(h)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await k.promisify(v.fdatasync)(n)}catch(c){this.canFlush=!1,this.logService.error(c)}return await k.promisify(v.close)(n)}catch(c){throw this.toFileSystemProviderError(c)}}async read(n,c,h,y,E){const d=this.normalizePos(n,c);let O=null;try{const A=await k.promisify(v.read)(n,h,y,E,d);return typeof A=="number"?O=A:O=A.bytesRead,O}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(n,d,O)}}normalizePos(n,c){return c===this.mapHandleToPos.get(n)?null:c}updatePos(n,c,h){const y=this.mapHandleToPos.get(n);typeof y=="number"&&(typeof c=="number"||(typeof h=="number"?this.mapHandleToPos.set(n,y+h):this.mapHandleToPos.delete(n)))}async write(n,c,h,y,E){return b.retry(()=>this.doWrite(n,c,h,y,E),100,3)}async doWrite(n,c,h,y,E){const d=this.normalizePos(n,c);let O=null;try{const A=await k.promisify(v.write)(n,h,y,E,d);return typeof A=="number"?O=A:O=A.bytesWritten,O}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(n,d,O)}}async mkdir(n){try{await k.promisify(v.mkdir)(this.toFilePath(n))}catch(c){throw this.toFileSystemProviderError(c)}}async delete(n,c){try{const h=this.toFilePath(n);await this.doDelete(h,c)}catch(h){throw this.toFileSystemProviderError(h)}}async doDelete(n,c){c.recursive?await p.rimraf(n,p.RimRafMode.MOVE):await p.unlink(n)}async rename(n,c,h){const y=this.toFilePath(n),E=this.toFilePath(c);if(y!==E)try{await this.validateTargetDeleted(n,c,"move",h.overwrite),await p.move(y,E)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error(u.localize(2,null,g.basename(y),g.basename(g.dirname(E)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(n,c,h){const y=this.toFilePath(n),E=this.toFilePath(c);if(y!==E)try{await this.validateTargetDeleted(n,c,"copy",h.overwrite),await p.copy(y,E)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error(u.localize(3,null,g.basename(y),g.basename(g.dirname(E)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(n,c,h,y){const E=this.toFilePath(n),d=this.toFilePath(c);let O=!1;if(!!(this.capabilities&1024)||(O=f.isEqual(E,d,!0)),O&&h==="copy")throw R.createFileSystemProviderError(u.localize(4,null),R.FileSystemProviderErrorCode.FileExists);if(!O&&await p.exists(d)){if(!y)throw R.createFileSystemProviderError(u.localize(5,null),R.FileSystemProviderErrorCode.FileExists);await this.delete(c,{recursive:!0,useTrash:!1})}}watch(n,c){return c.recursive?this.watchRecursive(n,c.excludes):this.watchNonRecursive(n)}watchRecursive(n,c){const h={path:this.toFilePath(n),excludes:c},y=t.insert(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),_.toDisposable(()=>{y(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var n,c,h;if(this.recursiveWatcher instanceof m.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(_.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let y,E;((c=(n=this.options)===null||n===void 0?void 0:n.watcher)===null||c===void 0?void 0:c.usePolling)?(y=S.FileWatcher,E=(h=this.options)===null||h===void 0?void 0:h.watcher):this.recursiveFoldersToWatch.length===1?L.isWindows?y=w.FileWatcher:y=S.FileWatcher:y=m.FileWatcher,this.recursiveWatcher=new y(this.recursiveFoldersToWatch,d=>this._onDidChangeFile.fire(D.toFileChanges(d)),d=>{d.type==="error"&&this._onDidWatchErrorOccur.fire(d.message),this.logService[d.type](d.message)},this.logService.getLevel()===C.LogLevel.Trace,E),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)}))}}watchNonRecursive(n){const c=new l.FileWatcher(this.toFilePath(n),y=>this._onDidChangeFile.fire(D.toFileChanges(y)),y=>{y.type==="error"&&this._onDidWatchErrorOccur.fire(y.message),this.logService[y.type](y.message)},this.logService.getLevel()===C.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{c.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)});return _.combinedDisposable(c,h)}toFilePath(n){return g.normalize(n.fsPath)}toFileSystemProviderError(n){if(n instanceof R.FileSystemProviderError)return n;let c;switch(n.code){case"ENOENT":c=R.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=R.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=R.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=R.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=R.FileSystemProviderErrorCode.NoPermissions;break;default:c=R.FileSystemProviderErrorCode.Unknown}return R.createFileSystemProviderError(n,c)}dispose(){super.dispose(),_.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,_.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=i}),define(ee[152],te([0,1,22,153,27,2,9,8,33,15,55,19,3,14,4]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let D=class extends R.Disposable{constructor(m,l,o){super();this.extensionManagementService=m,this.logService=o,this._onDidLanguagesChange=this._register(new b.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new S(l,o)),this._register(m.onDidInstallExtension(({local:s})=>this.onDidInstallExtension(s))),this._register(m.onDidUninstallExtension(({identifier:s})=>this.onDidUninstallExtension(s)))}getLanguageIds(){return this.cache.getLanguagePacks().then(m=>{const l=["en",...Object.keys(m)];return f.distinct(l)})}onDidInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",m.identifier.id),this.update().then(l=>{l&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(m){this.cache.getLanguagePacks().then(l=>{Object.keys(l).some(o=>l[o]&&l[o].extensions.some(s=>p.areSameExtensions(s.extensionIdentifier,m)))&&(this.logService.debug("Removing language packs from the extension",m.id),this.update().then(o=>{o&&this._onDidLanguagesChange.fire()}))})}update(){return Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]).then(([m,l])=>this.cache.update(l).then(o=>!f.equals(Object.keys(m),Object.keys(o))))}};D=ge([Y(0,_.IExtensionManagementService),Y(1,P.INativeEnvironmentService),Y(2,g.ILogService)],D),e.LocalizationsService=D;let S=class extends R.Disposable{constructor(m,l){super();this.logService=l,this.languagePacks={},this.languagePacksFilePath=u.join(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(l=>{Object.keys(l).forEach(o=>delete l[o]),this.createLanguagePacksFromExtensions(l,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...l){for(const o of l)o&&o.manifest&&o.manifest.contributes&&o.manifest.contributes.localizations&&o.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,o);Object.keys(m).forEach(o=>this.updateHash(m[o]))}createLanguagePacksFromExtension(m,l){const o=l.identifier,s=l.manifest.contributes&&l.manifest.contributes.localizations?l.manifest.contributes.localizations:[];for(const t of s)if(l.location.scheme===C.Schemas.file&&I.isValidLocalization(t)){let r=m[t.languageId];r||(r={hash:"",extensions:[],translations:{}},m[t.languageId]=r);let i=r.extensions.filter(a=>p.areSameExtensions(a.extensionIdentifier,o))[0];i?i.version=l.manifest.version:r.extensions.push({extensionIdentifier:o,version:l.manifest.version});for(const a of t.translations)r.translations[a.id]=u.join(l.location.fsPath,a.path)}}updateHash(m){if(m){const l=k.createHash("md5");for(const o of m.extensions)l.update(o.extensionIdentifier.uuid||o.extensionIdentifier.id).update(o.version);m.hash=l.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let l=null;return v.readFile(this.languagePacksFilePath,"utf8").then(void 0,o=>o.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(o)).then(o=>{try{return JSON.parse(o)}catch(s){return{}}}).then(o=>(l=m(o),o)).then(o=>{for(const t of Object.keys(o))o[t]||delete o[t];this.languagePacks=o,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),v.writeFile(this.languagePacksFilePath,s)}).then(()=>l,o=>this.logService.error(o))})}};S=ge([Y(0,P.INativeEnvironmentService),Y(1,g.ILogService)],S)}),define(ee[154],te([0,1,15]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function k(R,P){switch(P){case v.LogLevel.Trace:return R.trace;case v.LogLevel.Debug:return R.debug;case v.LogLevel.Info:return R.info;case v.LogLevel.Warning:return R.warn;case v.LogLevel.Error:return R.error;case v.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class _ extends v.AbstractLogService{constructor(P=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(P),this._register(this.onDidChangeLogLevel(L=>{this._logger&&this._logger.setLevel(L)}))}set logger(P){this._logger=P;for(const{level:L,args:p}of this.buffer)k(P,L).apply(P,p);this.buffer=[]}_log(P,...L){this._logger?k(this._logger,P).apply(this._logger,L):this.getLevel()<=P&&this.buffer.push({level:P,args:L})}trace(P,...L){this._log(v.LogLevel.Trace,P,...L)}debug(P,...L){this._log(v.LogLevel.Debug,P,...L)}info(P,...L){this._log(v.LogLevel.Info,P,...L)}warn(P,...L){this._log(v.LogLevel.Warning,P,...L)}error(P,...L){this._log(v.LogLevel.Error,P,...L)}critical(P,...L){this._log(v.LogLevel.Critical,P,...L)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=_}),define(ee[155],te([0,1,15,12,8,16,18,2,5,154]),function(G,e,v,k,_,R,P,L,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogService=void 0;const I=5*k.ByteSize.MB;let f=class extends v.AbstractLogService{constructor(u,D,S,w){super();this.name=u,this.resource=D,this.fileService=w,this.backupIndex=1,this.setLevel(S),this.queue=this._register(new _.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=v.LogLevel.Trace&&this._log(v.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=v.LogLevel.Debug&&this._log(v.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=v.LogLevel.Info&&this._log(v.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=v.LogLevel.Warning&&this._log(v.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=v.LogLevel.Error){const u=arguments[0];if(u instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=u.stack,this._log(v.LogLevel.Error,this.format(D))}else this._log(v.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=v.LogLevel.Critical&&this._log(v.LogLevel.Critical,this.format(arguments))}flush(){}log(u,D){this._log(u,this.format(D))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(u){if(u.fileOperationResult!==3)throw u}}_log(u,D){this.queue.queue(async()=>{await this.initializePromise;let S=await this.loadContent();S.length>I&&(await this.fileService.writeFile(this.getBackupResource(),R.VSBuffer.fromString(S)),S=""),S+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(u)}] ${D}
`,await this.fileService.writeFile(this.resource,R.VSBuffer.fromString(S))})}getCurrentTimestamp(){const u=w=>w<10?`0${w}`:w,D=w=>w<10?`00${w}`:w<100?`0${w}`:w,S=new Date;return`${S.getFullYear()}-${u(S.getMonth()+1)}-${u(S.getDate())} ${u(S.getHours())}:${u(S.getMinutes())}:${u(S.getSeconds())}.${D(S.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,P.joinPath(P.dirname(this.resource),`${P.basename(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(u){return""}}stringifyLogLevel(u){switch(u){case v.LogLevel.Critical:return"critical";case v.LogLevel.Debug:return"debug";case v.LogLevel.Error:return"error";case v.LogLevel.Info:return"info";case v.LogLevel.Trace:return"trace";case v.LogLevel.Warning:return"warning"}return""}format(u){let D="";for(let S=0;S<u.length;S++){let w=u[S];if(typeof w=="object")try{w=JSON.stringify(w)}catch(m){}D+=(S>0?" ":"")+w}return D}};f=ge([Y(3,k.IFileService)],f),e.FileLogService=f;let b=class extends L.Disposable{constructor(u,D,S){super();this.logService=u,this.instantiationService=D,this.fileService=S,this.loggers=new Map,this._register(u.onDidChangeLogLevel(w=>this.loggers.forEach(m=>m.setLevel(w))))}getLogger(u){let D=this.loggers.get(u.toString());return D||(D=new g.BufferLogService(this.logService.getLevel()),this.loggers.set(u.toString(),D),k.whenProviderRegistered(u,this.fileService).then(()=>D.logger=this.instantiationService.createInstance(f,P.basename(u),u,this.logService.getLevel()))),D}dispose(){this.loggers.forEach(u=>u.dispose()),this.loggers.clear(),super.dispose()}};b=ge([Y(0,v.ILogService),Y(1,p.IInstantiationService),Y(2,k.IFileService)],b),e.FileLoggerService=b}),define(ee[156],te([0,1,15,3]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=void 0;class _{constructor(p){this.service=p,this.onDidChangeLogLevel=k.Event.buffer(p.onDidChangeLogLevel,!0)}listen(p,g){switch(g){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${g}`)}call(p,g,I){switch(g){case"setLevel":return this.service.setLevel(I),Promise.resolve();case"consoleLog":return this.consoleLog(I[0],I[1]),Promise.resolve()}throw new Error(`Call not found: ${g}`)}consoleLog(p,g){let I=console.log;switch(p){case"error":I=console.error;break;case"warn":I=console.warn;break;case"info":I=console.info;break}I.call(console,...g)}}e.LoggerChannel=_;class R{constructor(p){this.channel=p}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(p){R.setLevel(this.channel,p)}static setLevel(p,g){return p.call("setLevel",g)}consoleLog(p,g){this.channel.call("consoleLog",[p,g])}}e.LoggerChannelClient=R;class P extends v.DelegatedLogService{constructor(p,g){super(g);this.parent=p,this._register(p.onDidChangeLogLevel(I=>g.setLevel(I)))}setLevel(p){super.setLevel(p),this.parent.setLevel(p)}}e.FollowerLogService=P}),define(ee[75],te([0,1,4,15,12]),function(G,e,v,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogService=e.createRotatingLogger=void 0;async function R(g,I){try{const f=await new Promise((C,u)=>{G(["spdlog"],C,u)});f.setAsyncMode(8192,500);const b=v.join(I,`${g}.log`);return f.createRotatingLoggerAsync(g,b,5*_.ByteSize.MB,6)}catch(f){console.error(f)}return null}function P(g,I,f,b){return G.__$__nodeRequire("spdlog").createRotatingLogger(g,I,f,b)}e.createRotatingLogger=P;function L(g,I,f){switch(I){case k.LogLevel.Trace:g.trace(f);break;case k.LogLevel.Debug:g.debug(f);break;case k.LogLevel.Info:g.info(f);break;case k.LogLevel.Warning:g.warn(f);break;case k.LogLevel.Error:g.error(f);break;case k.LogLevel.Critical:g.critical(f);break;default:throw new Error("Invalid log level")}}class p extends k.AbstractLogService{constructor(I,f,b){super();this.name=I,this.logsFolder=f,this.buffer=[],this._loggerCreationPromise=void 0,this.setLevel(b),this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(C=>{this._logger&&this._logger.setLevel(C)}))}_createSpdLogLogger(){return this._loggerCreationPromise||(this._loggerCreationPromise=R(this.name,this.logsFolder).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:f,message:b}of this.buffer)L(this._logger,f,b);this.buffer=[]}})),this._loggerCreationPromise}_log(I,f){this._logger?L(this._logger,I,f):this.getLevel()<=I&&this.buffer.push({level:I,message:f})}trace(I,...f){this.getLevel()<=k.LogLevel.Trace&&this._log(k.LogLevel.Trace,this.format([I,...f]))}debug(I,...f){this.getLevel()<=k.LogLevel.Debug&&this._log(k.LogLevel.Debug,this.format([I,...f]))}info(I,...f){this.getLevel()<=k.LogLevel.Info&&this._log(k.LogLevel.Info,this.format([I,...f]))}warn(I,...f){this.getLevel()<=k.LogLevel.Warning&&this._log(k.LogLevel.Warning,this.format([I,...f]))}error(I,...f){if(this.getLevel()<=k.LogLevel.Error)if(I instanceof Error){const b=Array.prototype.slice.call(arguments);b[0]=I.stack,this._log(k.LogLevel.Error,this.format(b))}else this._log(k.LogLevel.Error,this.format([I,...f]))}critical(I,...f){this.getLevel()<=k.LogLevel.Critical&&this._log(k.LogLevel.Critical,this.format([I,...f]))}flush(){this._logger?this._logger.flush():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.disposeLogger()),this._loggerCreationPromise=void 0}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}format(I){let f="";for(let b=0;b<I.length;b++){let C=I[b];if(typeof C=="object")try{C=JSON.stringify(C)}catch(u){}f+=(b>0?" ":"")+C}return f}}e.SpdLogService=p}),define(ee[157],te([0,1,15,2,18,14,155,75,12]),function(G,e,v,k,_,R,P,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let g=class extends k.Disposable{constructor(f,b){super();this.logService=f,this.fileService=b,this.loggers=new Map,this._register(f.onDidChangeLogLevel(C=>this.loggers.forEach(u=>u.setLevel(C))))}getLogger(f){let b=this.loggers.get(f.toString());if(!b){if(f.scheme===R.Schemas.file){const C=_.basename(f),u=_.extname(f);b=new L.SpdLogService(C.substring(0,C.length-u.length),_.dirname(f).fsPath,this.logService.getLevel())}else b=new P.FileLogService(_.basename(f),f,this.logService.getLevel(),this.fileService);this.loggers.set(f.toString(),b)}return b}dispose(){this.loggers.forEach(f=>f.dispose()),this.loggers.clear(),super.dispose()}};g=ge([Y(0,v.ILogService),Y(1,p.IFileService)],g),e.LoggerService=g}),define(ee[57],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=v.createDecorator("nativeHostService")}),define(ee[37],te([0,1,6,46,14,18]),function(G,e,v,k,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(v.isWeb||typeof G=="undefined"||typeof G.__$__nodeRequire!="function")P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.53.0-dev",nameShort:v.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:v.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/master/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser"]});else{const L=R.dirname(_.FileAccess.asFileUri("",G));P=G.__$__nodeRequire(R.joinPath(L,"product.json").fsPath);const p=G.__$__nodeRequire(R.joinPath(L,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:p.version})}e.default=P}),define(ee[158],te([0,1,4,22,37,2,13,15,9]),function(G,e,v,k,_,R,P,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let g=class extends R.Disposable{constructor(f,b){super();this._environmentService=f,this._logService=b,this._environmentService.isBuilt&&this._manageCachedDataSoon()}_manageCachedDataSoon(){let f=setTimeout(async()=>{f=void 0,this._logService.info("Starting to clean up unused language packs.");const b=_.default.nameLong.indexOf("Insiders")>=0?1e3*60*60*24*7:1e3*60*60*24*30*3;try{const C=Object.create(null),u=JSON.parse(await k.readFile(v.join(this._environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let m of Object.keys(u)){const l=u[m];C[`${l.hash}.${m}`]=!0}const D=v.join(this._environmentService.userDataPath,"clp");if(!await k.exists(D))return;for(let m of await k.readdir(D)){if(C[m]){this._logService.info(`Skipping directory ${m}. Language pack still in use.`);continue}this._logService.info("Removing unused language pack:",m),await k.rimraf(v.join(D,m))}const w=Date.now();for(let m of Object.keys(C)){const l=v.join(D,m);for(let o of await k.readdir(l))if(o!=="tcf.json"){const s=v.join(l,o),t=await k.stat(s);t.isDirectory()&&w-t.mtime.getTime()>b&&(this._logService.info("Removing language pack cache entry: ",v.join(m,o)),await k.rimraf(s))}}}catch(C){P.onUnexpectedError(C)}},40*1e3);this._register(R.toDisposable(()=>{f!==void 0&&clearTimeout(f)}))}};g=ge([Y(0,p.INativeEnvironmentService),Y(1,L.ILogService)],g),e.LanguagePackCachedDataCleaner=g}),define(ee[159],te([0,1,4,13,2,22,37]),function(G,e,v,k,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeCachedDataCleaner=void 0;class L{constructor(g){this.nodeCachedDataDir=g,this._disposables=new _.DisposableStore,this._manageCachedDataSoon()}dispose(){this._disposables.dispose()}_manageCachedDataSoon(){if(!!this.nodeCachedDataDir){const g=v.dirname(this.nodeCachedDataDir),I=v.basename(this.nodeCachedDataDir);let f=setTimeout(()=>{f=void 0,R.readdir(g).then(b=>{const C=Date.now(),u=[];return b.forEach(D=>{if(D!==I){const S=v.join(g,D);u.push(R.stat(S).then(w=>{if(w.isDirectory()&&C-w.mtime.getTime()>L._DataMaxAge)return R.rimraf(S)}))}}),Promise.all(u)}).then(void 0,k.onUnexpectedError)},30*1e3);this._disposables.add(_.toDisposable(()=>{f&&(clearTimeout(f),f=void 0)}))}}}e.NodeCachedDataCleaner=L,L._DataMaxAge=P.default.nameLong.indexOf("Insiders")>=0?1e3*60*60*24*7:1e3*60*60*24*30*3}),define(ee[38],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=v.createDecorator("productService")}),define(ee[34],te([0,1,17,80]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class _{constructor(){this.data=new Map}add(P,L){k.ok(v.isString(P)),k.ok(v.isObject(L)),k.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,L)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new _}),define(ee[76],te([0,1,34,3]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function _(L){return L.length>0&&L.charAt(L.length-1)==="#"?L.substring(0,L.length-1):L}class R{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,g){this.schemasById[_(p)]=g,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new R;v.Registry.add(e.Extensions.JSONContribution,P)}),define(ee[41],te([0,1,108,3,34,17,76]),function(G,e,v,k,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const p=_.Registry.as(P.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,m=!0){this.registerConfigurations([w],m)}registerConfigurations(w,m=!0){const l=[];w.forEach(o=>{l.push(...this.validateAndRegisterProperties(o,m)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(w){const m=[],l=o=>{if(o.properties)for(const s in o.properties)m.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,o.properties[s]);o.allOf&&o.allOf.forEach(s=>l(s))};for(const o of w){l(o);const s=this.configurationContributors.indexOf(o);s!==-1&&this.configurationContributors.splice(s,1)}p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}registerDefaultConfigurations(w){const m=[],l=[];for(const o of w)for(const s in o)if(m.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]=Object.assign(Object.assign({},this.defaultValues[s]||{}),o[s]);const t={type:"object",default:this.defaultValues[s],description:v.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};l.push(f(s)),this.configurationProperties[s]=t,this.defaultLanguageConfigurationOverridesNode.properties[s]=t}else{this.defaultValues[s]=o[s];const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterDefaultConfigurations(w){const m=[];for(const l of w)for(const o in l)if(m.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const s=this.configurationProperties[o];s&&(this.updatePropertyDefaultValue(o,s),this.updateSchema(o,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const m of w)this.overrideIdentifiers.add(m);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,m=!0,l=3){l=R.isUndefinedOrNull(w.scope)?l:w.scope;let o=[],s=w.properties;if(s)for(let r in s){if(m&&u(r)){delete s[r];continue}const i=s[r];if(this.updatePropertyDefaultValue(r,i),e.OVERRIDE_PROPERTY_PATTERN.test(r)?i.scope=void 0:i.scope=R.isUndefinedOrNull(i.scope)?l:i.scope,s[r].hasOwnProperty("included")&&!s[r].included){this.excludedConfigurationProperties[r]=s[r],delete s[r];continue}else this.configurationProperties[r]=s[r];!s[r].deprecationMessage&&s[r].markdownDeprecationMessage&&(s[r].deprecationMessage=s[r].markdownDeprecationMessage),o.push(r)}let t=w.allOf;if(t)for(let r of t)o.push(...this.validateAndRegisterProperties(r,m,l));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const m=l=>{let o=l.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let s=l.allOf;s&&s.forEach(m)};m(w)}updateSchema(w,m){switch(e.allSettings.properties[w]=m,m.scope){case 1:e.applicationSettings.properties[w]=m;break;case 2:e.machineSettings.properties[w]=m;break;case 6:e.machineOverridableSettings.properties[w]=m;break;case 3:e.windowSettings.properties[w]=m;break;case 4:e.resourceSettings.properties[w]=m;break;case 5:e.resourceSettings.properties[w]=m,this.resourceLanguageSettingsSchema.properties[w]=m;break}}removeFromSchema(w,m){switch(delete e.allSettings.properties[w],m.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const m=`[${w}]`,l={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(m,l),e.allSettings.properties[m]=l,e.applicationSettings.properties[m]=l,e.machineSettings.properties[m]=l,e.machineOverridableSettings.properties[m]=l,e.windowSettings.properties[m]=l,e.resourceSettings.properties[m]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,m){let l=this.defaultValues[w];R.isUndefined(l)&&(l=m.default),R.isUndefined(l)&&(l=b(m.type)),m.default=l}}const I="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function f(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=f;function b(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=b;const C=new g;_.Registry.add(e.Extensions.Configuration,C);function u(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?v.localize(5,null,S):C.getConfigurationProperties()[S]!==void 0?v.localize(6,null,S):null:v.localize(4,null)}e.validateProperty=u;function D(){const S=[],w=C.getConfigurationProperties();for(const m of Object.keys(w))S.push([m,w[m].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=D}),define(ee[26],te([0,1,25,17,7,34,5,41]),function(G,e,v,k,_,R,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=P.createDecorator("configurationService");function p(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof _.URI)}e.isConfigurationOverrides=p;var g;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(g=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=I;function f(r,i){const a=i?r?i.keys.filter(O=>r.keys.indexOf(O)===-1):[...i.keys]:[],n=r?i?r.keys.filter(O=>i.keys.indexOf(O)===-1):[...r.keys]:[],c=[];if(i&&r){for(const O of r.keys)if(i.keys.indexOf(O)!==-1){const A=w(r.contents,O),j=w(i.contents,O);v.equals(A,j)||c.push(O)}}const h=[],y=O=>{const A={};for(const j of O)for(const z of j.identifiers)A[s(z)]=j;return A},E=i?y(i.overrides):{},d=r?y(r.overrides):{};if(Object.keys(E).length)for(const O of a){const A=E[O];A&&h.push([L.overrideIdentifierFromKey(O),A.keys])}if(Object.keys(d).length)for(const O of n){const A=d[O];A&&h.push([L.overrideIdentifierFromKey(O),A.keys])}if(Object.keys(E).length&&Object.keys(d).length)for(const O of c){const A=d[O],j=E[O];if(A&&j){const z=f({contents:A.contents,keys:A.keys,overrides:[]},{contents:j.contents,keys:j.keys,overrides:[]});h.push([L.overrideIdentifierFromKey(O),[...z.added,...z.removed,...z.updated]])}}return{added:a,removed:n,updated:c,overrides:h}}e.compare=f;function b(r,i){const a=[];for(const n of Object.keys(r))if(L.OVERRIDE_PROPERTY_PATTERN.test(n)){const c={};for(const h in r[n])c[h]=r[n][h];a.push({identifiers:[L.overrideIdentifierFromKey(n).trim()],keys:Object.keys(c),contents:C(c,i)})}return a}e.toOverrides=b;function C(r,i){const a=Object.create(null);for(let n in r)u(a,n,r[n],i);return a}e.toValuesTree=C;function u(r,i,a,n){const c=i.split("."),h=c.pop();let y=r;for(let E=0;E<c.length;E++){let d=c[E],O=y[d];switch(typeof O){case"undefined":O=y[d]=Object.create(null);break;case"object":break;default:n(`Ignoring ${i} as ${c.slice(0,E+1).join(".")} is ${JSON.stringify(O)}`);return}y=O}if(typeof y=="object"&&y!==null)try{y[h]=a}catch(E){n(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(y)}`)}else n(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(y)}`)}e.addToValueTree=u;function D(r,i){const a=i.split(".");S(r,a)}e.removeFromValueTree=D;function S(r,i){const a=i.shift();if(i.length===0){delete r[a];return}if(Object.keys(r).indexOf(a)!==-1){const n=r[a];typeof n=="object"&&!Array.isArray(n)&&(S(n,i),Object.keys(n).length===0&&delete r[a])}}function w(r,i,a){function n(y,E){let d=y;for(const O of E){if(typeof d!="object"||d===null)return;d=d[O]}return d}const c=i.split("."),h=n(r,c);return typeof h=="undefined"?a:h}e.getConfigurationValue=w;function m(r,i,a){Object.keys(i).forEach(n=>{n!=="__proto__"&&(n in r?k.isObject(r[n])&&k.isObject(i[n])?m(r[n],i[n],a):a&&(r[n]=i[n]):r[n]=i[n])})}e.merge=m;function l(){const r=R.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=l;function o(){const r=Object.create(null),i=R.Registry.as(L.Extensions.Configuration).getConfigurationProperties();for(let a in i){let n=i[a].default;u(r,a,n,c=>console.error(`Conflict in default settings: ${c}`))}return r}e.getDefaultValues=o;function s(r){return`[${r}]`}e.keyFromOverrideIdentifier=s;function t(r,i,a){const n=r.inspect(i),c=r.inspect(a);return typeof n.userValue!="undefined"||typeof n.workspaceValue!="undefined"||typeof n.workspaceFolderValue!="undefined"?n.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:n.defaultValue}e.getMigratedSettingValue=t}),define(ee[160],te([0,1,29,32,19,17,25,7,41,26,34,2,3]),function(G,e,v,k,_,R,P,L,p,g,I,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class C{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?g.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?g.getConfigurationValue(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const a of _.distinct([...Object.keys(this.contents),...Object.keys(r)])){let n=this.contents[a],c=r[a];c&&(typeof n=="object"&&typeof c=="object"?(n=P.deepClone(n),this.mergeContents(n,c)):n=c),i[a]=n}return new C(i,this.keys,this.overrides)}merge(...t){const r=P.deepClone(this.contents),i=P.deepClone(this.overrides),a=[...this.keys];for(const n of t){this.mergeContents(r,n.contents);for(const c of n.overrides){const[h]=i.filter(y=>_.equals(y.identifiers,c.identifiers));h?this.mergeContents(h.contents,c.contents):i.push(P.deepClone(c))}for(const c of n.keys)a.indexOf(c)===-1&&a.push(c)}return new C(r,a,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&R.isObject(t[i])&&R.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=P.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),g.addToValueTree(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&g.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=C;class u extends C{constructor(){const t=g.getDefaultValues(),r=g.getConfigurationKeys(),i=[];for(const a of Object.keys(t))p.OVERRIDE_PROPERTY_PATTERN.test(a)&&i.push({identifiers:[p.overrideIdentifierFromKey(a).trim()],keys:Object.keys(t[a]),contents:g.toValuesTree(t[a],n=>console.error(`Conflict in default settings file: ${n}`))});super(t,r,i)}}e.DefaultConfigurationModel=u;class D{constructor(t,r){this._name=t,this._scopes=r,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new C}get errors(){return this._parseErrors}parseContent(t){if(!R.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r)}}parseRaw(t){this._raw=t;const r=this.doParseRaw(t);this._configurationModel=new C(r.contents,r.keys,r.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let r={},i=null,a=[],n=[],c=[];function h(E){Array.isArray(a)?a.push(E):i&&(a[i]=E)}let y={onObjectBegin:()=>{let E={};h(E),n.push(a),a=E,i=null},onObjectProperty:E=>{i=E},onObjectEnd:()=>{a=n.pop()},onArrayBegin:()=>{let E=[];h(E),n.push(a),a=E,i=null},onArrayEnd:()=>{a=n.pop()},onLiteralValue:h,onError:(E,d,O)=>{c.push({error:E,offset:d,length:O})}};if(t)try{v.visit(t,y),r=a[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return r}doParseRaw(t){if(this._scopes){const n=I.Registry.as(p.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,n,!0,this._scopes)}const r=g.toValuesTree(t,n=>console.error(`Conflict in settings file ${this._name}: ${n}`)),i=Object.keys(t),a=g.toOverrides(t,n=>console.error(`Conflict in settings file ${this._name}: ${n}`));return{contents:r,keys:i,overrides:a}}filterByScope(t,r,i,a){const n={};for(let c in t)if(p.OVERRIDE_PROPERTY_PATTERN.test(c)&&i)n[c]=this.filterByScope(t[c],r,!1,a);else{const h=this.getScope(c,r);(h===void 0||a.indexOf(h)!==-1)&&(n[c]=t[c])}return n}getScope(t,r){const i=r[t];return i?typeof i.scope!="undefined"?i.scope:3:void 0}}e.ConfigurationModelParser=D;class S extends f.Disposable{constructor(t,r,i,a){super();this.userSettingsResource=t,this.scopes=r,this.fileService=a,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new D(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(b.Event.filter(this.fileService.onDidFilesChange,n=>n.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new C}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=S;class w{constructor(t,r,i=new C,a=new C,n=new k.ResourceMap,c=new C,h=new k.ResourceMap,y=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=a,this._folderConfigurations=n,this._memoryConfiguration=c,this._memoryConfigurationByResource=h,this._freeze=y,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let a;i.resource?(a=this._memoryConfigurationByResource.get(i.resource),a||(a=new C,this._memoryConfigurationByResource.set(i.resource,a))):a=this._memoryConfiguration,r===void 0?a.removeValue(t):a.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const a=this.getConsolidateConfigurationModel(r,i),n=this.getFolderConfigurationModelForResource(r.resource,i),c=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,h=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),y=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),d=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),O=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,A=n?r.overrideIdentifier?n.freeze().override(r.overrideIdentifier).getValue(t):n.freeze().getValue(t):void 0,j=r.overrideIdentifier?c.override(r.overrideIdentifier).getValue(t):c.getValue(t),z=a.getValue(t),W=_.distinct(_.flatten(a.overrides.map(N=>N.identifiers))).filter(N=>a.getOverrideValue(t,N)!==void 0);return{defaultValue:h,userValue:y,userLocalValue:E,userRemoteValue:d,workspaceValue:O,workspaceFolderValue:A,memoryValue:j,value:z,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:y!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:d!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:A!==void 0?{value:n==null?void 0:n.freeze().getValue(t),override:r.overrideIdentifier?n==null?void 0:n.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:j!==void 0?{value:c.getValue(t),override:r.overrideIdentifier?c.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(a=>p.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const n=p.overrideIdentifierFromKey(a),c=this._defaultConfiguration.getKeysForOverrideIdentifier(n),h=t.getKeysForOverrideIdentifier(n),y=[...h.filter(E=>c.indexOf(E)===-1),...c.filter(E=>h.indexOf(E)===-1),...c.filter(E=>!P.equals(this._defaultConfiguration.override(n).getValue(E),t.override(n).getValue(E)))];return[n,y]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:a,overrides:n}=g.compare(this.localUserConfiguration,t),c=[...r,...i,...a];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:n}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:a,overrides:n}=g.compare(this.remoteUserConfiguration,t);let c=[...r,...i,...a];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:n}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:a,overrides:n}=g.compare(this.workspaceConfiguration,t);let c=[...r,...i,...a];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:n}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:a,updated:n,removed:c,overrides:h}=g.compare(i,r);let y=[...a,...n,...c];return(y.length||!i)&&this.updateFolderConfiguration(t,r),{keys:y,overrides:h}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:a,removed:n,overrides:c}=g.compare(r,void 0);return{keys:[...i,...a,...n],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const a=r.getFolder(t);a&&(i=this.getFolderConsolidatedConfiguration(a.uri)||i);const n=this._memoryConfigurationByResource.get(t);n&&(i=i.merge(n))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(r=i.merge(a),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:a,keys:n}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:a,keys:n}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),n=t.folders.reduce((c,h)=>(c.set(L.URI.revive(h[0]),this.parseConfigurationModel(h[1])),c),new k.ResourceMap);return new w(r,i,new C,a,n,new C,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new C(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function m(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,r=new Map;for(const a of s)a.keys.forEach(n=>t.add(n)),a.overrides.forEach(([n,c])=>{const h=k.getOrSet(r,n,new Set);c.forEach(y=>h.add(y))});const i=[];return r.forEach((a,n)=>i.push([n,[...a.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=m;class l{constructor(t,r,i,a){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=a,this._previousConfiguration=void 0;const n=new Set;t.keys.forEach(h=>n.add(h)),t.overrides.forEach(([,h])=>h.forEach(y=>n.add(y))),this.affectedKeys=[...n.values()];const c=new C;this.affectedKeys.forEach(h=>c.setValue(h,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var i;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(i=this.previous)===null||i===void 0?void 0:i.workspace):void 0,n=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!P.equals(a,n)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=g.toValuesTree({[r]:!0},()=>{}),a;for(;typeof i=="object"&&(a=Object.keys(i)[0]);){if(t=t[a],!t)return!1;i=i[a]}return!0}}e.ConfigurationChangeEvent=l;class o extends l{constructor(t,r,i,a){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=o}),define(ee[161],te([0,1,34,41,2,26,160,3,8,18]),function(G,e,v,k,_,R,P,L,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends _.Disposable{constructor(b,C){super();this.settingsResource=b,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,g.extUriBiasedIgnorePathCase,C)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(k.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const b=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,b)}getConfigurationData(){return this.configuration.toData()}getValue(b,C){const u=typeof b=="string"?b:void 0,D=R.isConfigurationOverrides(b)?b:R.isConfigurationOverrides(C)?C:{};return this.configuration.getValue(u,D,void 0)}updateValue(b,C,u,D){return Promise.reject(new Error("not supported"))}inspect(b){return this.configuration.inspect(b,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const b=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(b)}onDidChangeUserConfiguration(b){const C=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(b);this.trigger(u,C,1)}onDidDefaultConfigurationChange(b){const C=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,b);this.trigger(u,C,6)}trigger(b,C,u){const D=new P.ConfigurationChangeEvent(b,{data:C},this.configuration);D.source=u,D.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(D)}getTargetConfiguration(b){switch(b){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(ee[162],te([0,1,14]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function k(R){return R.scheme===v.Schemas.vscodeRemote?R.authority:void 0}e.getRemoteAuthority=k;function _(R){if(!!R){const P=R.indexOf("+");return P<0?R:R.substr(0,P)}}e.getRemoteName=_}),define(ee[163],te([0,1,26,15,98]),function(G,e,v,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let R=class{constructor(L,p){this.configurationService=L,this.logService=p}request(L,p){return this.logService.trace("RequestService#request",L.url),L.proxyAuthorization||(L.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),_.request(L,p)}async resolveProxy(L){}};R=ge([Y(0,v.IConfigurationService),Y(1,k.ILogService)],R),e.RequestService=R}),define(ee[42],te([0,1,119,5,41,34,16]),function(G,e,v,k,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=k.createDecorator("requestService");function L(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}e.isSuccess=L;function p(f){return f.res.statusCode===204}async function g(f){if(!L(f))throw new Error("Server returned "+f.res.statusCode);return p(f)?null:(await P.streamToBuffer(f.stream)).toString()}e.asText=g;async function I(f){if(!L(f))throw new Error("Server returned "+f.res.statusCode);if(p(f))return null;const C=(await P.streamToBuffer(f.stream)).toString();try{return JSON.parse(C)}catch(u){throw u.message+=`:
`+C,u}}e.asJson=I,R.Registry.as(_.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:v.localize(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:v.localize(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:v.localize(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:v.localize(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[v.localize(4,null),v.localize(5,null),v.localize(6,null)],default:"override",description:v.localize(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:v.localize(8,null)}}})}),define(ee[164],te([0,1,42,28,12,14]),function(G,e,v,k,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let P=class{constructor(p,g){this.requestService=p,this.fileService=g}async download(p,g,I=k.CancellationToken.None){if(p.scheme===R.Schemas.file||p.scheme===R.Schemas.vscodeRemote){await this.fileService.copy(p,g);return}const f={type:"GET",url:p.toString()},b=await this.requestService.request(f,I);if(b.res.statusCode===200)await this.fileService.writeFile(g,b.stream);else{const C=await v.asText(b);throw new Error(`Expected 200, got back ${b.res.statusCode} instead.

${C}`)}}};P=ge([Y(0,v.IRequestService),Y(1,_.IFileService)],P),e.DownloadService=P}),define(ee[165],te([0,1,38,12,19,62,42,28,15,18,129,2]),function(G,e,v,k,_,R,P,L,p,g,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let b=class extends f.Disposable{constructor(u,D,S,w){super();this.fileService=u,this.productService=D,this.requestService=S,this.logService=w,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&R.forEach(this.productService.configBasedExtensionTips,({value:m})=>this.allConfigBasedTips.set(m.configPath,m))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const D=[];for(const[S,w]of this.allConfigBasedTips)try{const m=await this.fileService.readFile(g.joinPath(u,S)),l=new Map;R.forEach(w.recommendations,({key:s,value:t})=>{if(_.isNonEmptyArray(t.remotes))for(const r of t.remotes)l.set(r,{extensionId:s,extensionName:t.name,configName:w.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else D.push({extensionId:s,extensionName:t.name,configName:w.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const o=I.getDomainsOfRemotes(m.value.toString(),[...l.keys()]);for(const s of o){const t=l.get(s);t&&D.push(t)}}catch(m){}return D}async fetchWorkspacesTips(){var u,D;if(!((u=this.productService.extensionsGallery)===null||u===void 0?void 0:u.recommendationsUrl))return[];try{const S=await this.requestService.request({type:"GET",url:(D=this.productService.extensionsGallery)===null||D===void 0?void 0:D.recommendationsUrl},L.CancellationToken.None);if(S.res.statusCode!==200)return[];const w=await P.asJson(S);return w?w.workspaceRecommendations||[]:[]}catch(S){return this.logService.error(S),[]}}};b=ge([Y(0,k.IFileService),Y(1,v.IProductService),Y(2,P.IRequestService),Y(3,p.ILogService)],b),e.ExtensionTipsService=b}),define(ee[49],te([0,1,30,16]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function _(R,P,L){let p=L&&L.get("storage.serviceMachineId",0)||null;if(p)return p;try{const I=(await P.readFile(R.serviceMachineIdResource)).value.toString();p=v.isUUID(I)?I:null}catch(g){p=null}if(!p){p=v.generateUuid();try{await P.writeFile(R.serviceMachineIdResource,k.VSBuffer.fromString(p))}catch(g){}}return L&&L.store("storage.serviceMachineId",p,0,1),p}e.getServiceMachineId=_}),define(ee[21],te([0,1,5,3,2,17]),function(G,e,v,k,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const P="__$__targetStorageMarker";e.IStorageService=v.createDecorator("storageService");var L;(function(C){C[C.NONE=0]="NONE",C[C.SHUTDOWN=1]="SHUTDOWN"})(L=e.WillSaveStateReason||(e.WillSaveStateReason={}));var p;(function(C){C[C.GLOBAL=0]="GLOBAL",C[C.WORKSPACE=1]="WORKSPACE"})(p=e.StorageScope||(e.StorageScope={}));var g;(function(C){C[C.USER=0]="USER",C[C.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class I extends _.Disposable{constructor(){super(...arguments);this._onDidChangeValue=this._register(new k.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new k.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new k.Emitter),this.onWillSaveState=this._onWillSaveState.event,this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}emitDidChangeValue(u,D){D===P?(u===0?this._globalKeyTargets=void 0:u===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:u})):this._onDidChangeValue.fire({scope:u,key:D,target:this.getKeyTargets(u)[D]})}emitWillSaveState(u){this._onWillSaveState.fire({reason:u})}store(u,D,S,w){if(R.isUndefinedOrNull(D)){this.remove(u,S);return}this.withPausedEmitters(()=>{this.updateKeyTarget(u,S,w),this.doStore(u,D,S)})}remove(u,D){this.withPausedEmitters(()=>{this.updateKeyTarget(u,D,void 0),this.doRemove(u,D)})}withPausedEmitters(u){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{u()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(u,D){const S=[],w=this.getKeyTargets(u);for(const m of Object.keys(w))w[m]===D&&S.push(m);return S}updateKeyTarget(u,D,S){const w=this.getKeyTargets(D);typeof S=="number"?w[u]!==S&&(w[u]=S,this.doStore(P,JSON.stringify(w),D)):typeof w[u]=="number"&&(delete w[u],this.doStore(P,JSON.stringify(w),D))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(u){return u===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(u){const D=this.get(P,u);if(D)try{return JSON.parse(D)}catch(S){}return Object.create(null)}isNew(u){return this.getBoolean(e.IS_NEW_KEY,u)===!0}flush(){return this._onWillSaveState.fire({reason:L.NONE}),this.doFlush()}}e.AbstractStorageService=I;class f extends I{constructor(){super(...arguments);this.globalCache=new Map,this.workspaceCache=new Map}getCache(u){return u===0?this.globalCache:this.workspaceCache}get(u,D,S){const w=this.getCache(D).get(u);return R.isUndefinedOrNull(w)?S:w}getBoolean(u,D,S){const w=this.getCache(D).get(u);return R.isUndefinedOrNull(w)?S:w==="true"}getNumber(u,D,S){const w=this.getCache(D).get(u);return R.isUndefinedOrNull(w)?S:parseInt(w,10)}doStore(u,D,S){const w=String(D);this.getCache(S).get(u)!==w&&(this.getCache(S).set(u,w),this.emitDidChangeValue(S,u))}doRemove(u,D){!this.getCache(D).delete(u)||this.emitDidChangeValue(D,u)}logStorage(){b(this.globalCache,this.workspaceCache,"inMemory","inMemory")}async migrate(u){}async doFlush(){}async close(){}}e.InMemoryStorageService=f;async function b(C,u,D,S){const w=i=>{try{return JSON.parse(i)}catch(a){return i}},m=new Map,l=new Map;C.forEach((i,a)=>{m.set(a,i),l.set(a,w(i))});const o=new Map,s=new Map;u.forEach((i,a)=>{o.set(a,i),s.set(a,w(i))}),console.group(`Storage: Global (path: ${D})`);let t=[];m.forEach((i,a)=>{t.push({key:a,value:i})}),console.table(t),console.groupEnd(),console.log(l),console.group(`Storage: Workspace (path: ${S})`);let r=[];o.forEach((i,a)=>{r.push({key:a,value:i})}),console.table(r),console.groupEnd(),console.log(s)}e.logStorage=b}),define(ee[166],te([0,1,3,2,27,33,21,17]),function(G,e,v,k,_,R,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let p=class extends k.Disposable{constructor(f){super();this._onDidChangeEnablement=new v.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new g(f)),this._register(this.storageManger.onDidChange(b=>this._onDidChangeEnablement.fire({extensions:b,source:"storage"})))}async enableExtension(f,b){return this._removeFromDisabledExtensions(f)?(this._onDidChangeEnablement.fire({extensions:[f],source:b}),!0):!1}async disableExtension(f,b){return this._addToDisabledExtensions(f)?(this._onDidChangeEnablement.fire({extensions:[f],source:b}),!0):!1}getDisabledExtensions(){return this._getExtensions(_.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(f){let b=this.getDisabledExtensions();return b.every(C=>!R.areSameExtensions(C,f))?(b.push(f),this._setDisabledExtensions(b),!0):!1}_removeFromDisabledExtensions(f){let b=this.getDisabledExtensions();for(let C=0;C<b.length;C++){const u=b[C];if(R.areSameExtensions(u,f))return b.splice(C,1),this._setDisabledExtensions(b),!0}return!1}_setDisabledExtensions(f){this._setExtensions(_.DISABLED_EXTENSIONS_STORAGE_PATH,f)}_getExtensions(f){return this.storageManger.get(f,0)}_setExtensions(f,b){this.storageManger.set(f,b,0)}};p=ge([Y(0,P.IStorageService)],p),e.GlobalExtensionEnablementService=p;class g extends k.Disposable{constructor(f){super();this.storageService=f,this.storage=Object.create(null),this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this._register(f.onDidChangeValue(b=>this.onDidStorageChange(b)))}get(f,b){let C;return b===0?(L.isUndefinedOrNull(this.storage[f])&&(this.storage[f]=this._get(f,b)),C=this.storage[f]):C=this._get(f,b),JSON.parse(C)}set(f,b,C){let u=JSON.stringify(b.map(({id:S,uuid:w})=>({id:S,uuid:w})));this._get(f,C)!==u&&(C===0&&(b.length?this.storage[f]=u:delete this.storage[f]),this._set(f,b.length?u:void 0,C))}onDidStorageChange(f){if(f.scope===0&&!L.isUndefinedOrNull(this.storage[f.key])&&this._get(f.key,f.scope)!==this.storage[f.key]){const C=this.get(f.key,f.scope);delete this.storage[f.key];const u=this.get(f.key,f.scope),D=C.filter(w=>!u.some(m=>R.areSameExtensions(w,m))),S=u.filter(w=>!C.some(m=>R.areSameExtensions(m,w)));(D.length||S.length)&&this._onDidChange.fire([...D,...S])}}_get(f,b){return this.storageService.get(f,b,"[]")}_set(f,b,C){b?this.storageService.store(f,b,C,1):this.storageService.remove(f,C)}}e.StorageManager=g}),define(ee[167],te([0,1,6,46,30,7]),function(G,e,v,k,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;async function P(p,g,I,f,b,C,u,D,S){const w=Object.create(null);w["common.machineId"]=C,w.sessionID=_.generateUuid()+Date.now(),w.commitHash=f,w.version=b,w["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=v.PlatformToString(v.platform),w["common.nodePlatform"]=k.platform,w["common.nodeArch"]=I,w["common.product"]=S||"desktop";const m=L(u||[]);m&&(w["common.msftInternal"]=m);let l=0;const o=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),v.isLinuxSnap&&(w["common.snap"]="true");try{const s=await p.readFile(R.URI.file(D));w["common.source"]=s.value.toString().slice(0,30)}catch(s){}return w}e.resolveCommonProperties=P;function L(p){const g=k.env.USERDNSDOMAIN;if(!g)return!1;const I=g.toLowerCase();return p.some(f=>I===f)}}),define(ee[23],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ITelemetryService=void 0,e.ITelemetryService=v.createDecorator("telemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(ee[168],te([0,1,40,90,128,36,4,29,93,37,6,7,23,5,51,14,12]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=C.createDecorator(e.ID);async function w(t,r){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],a=new Map,n=new Map,c=2e4;function h(d,O,A,j){const z=O.substring(d.length+1);return new Promise(W=>{R.readdir(O,{withFileTypes:!0},async(N,x)=>{var F,B,K;if(N){W();return}if(j.count>=c){j.count+=x.length,j.maxReached=!0,W();return}let $=x.length;if($===0){W();return}let T=x;j.count+x.length>c&&(j.maxReached=!0,$=c-j.count,T=x.slice(0,$)),j.count+=x.length;for(const U of T)if(U.isDirectory()){if(A.includes(U.name)||await h(d,P.join(O,U.name),A,j),--$==0){W();return}}else{const M=U.name.lastIndexOf(".");if(M>=0){const q=U.name.substring(M+1);q&&a.set(q,((F=a.get(q))!==null&&F!==void 0?F:0)+1)}for(const q of i)((B=q.relativePathPattern)===null||B===void 0?void 0:B.test(z))!==!1&&q.filePattern.test(U.name)&&n.set(q.tag,((K=n.get(q.tag))!==null&&K!==void 0?K:0)+1);if(--$==0){W();return}}})})}const y={count:0,maxReached:!1};await h(t,t,r,y);const E=await o(t);return{configFiles:m(n),fileTypes:m(a),fileCount:y.count,maxFilesReached:y.maxReached,launchConfigFiles:E}}e.collectWorkspaceStats=w;function m(t){return[...u.Iterable.map(t.entries(),([r,i])=>({name:r,count:i}))].sort((r,i)=>i.count-r.count)}function l(){const t={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/S.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/S.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(k.virtualMachineHint.value()*100)}%`},r=v.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}e.getMachineInfo=l;function o(t){let r=new Map,i=P.join(t,".vscode","launch.json");return new Promise((a,n)=>{R.exists(i,c=>{if(c)R.readFile(i,(h,y)=>{if(h)return a([]);const E=[],d=L.parse(y.toString(),E);if(E.length)return console.log(`Unable to parse ${i}`),a([]);if(L.getNodeType(d)==="object"&&d.configurations)for(const O of d.configurations){const A=O.type;A&&(r.has(A)?r.set(A,r.get(A)+1):r.set(A,1))}return a(m(r))});else return a([])})})}e.collectLaunchConfigs=o;let s=class{constructor(r){this.telemetryService=r}formatMachineInfo(r){const i=[];return i.push(`OS Version:       ${r.os}`),i.push(`CPUs:             ${r.cpus}`),i.push(`Memory (System):  ${r.memory}`),i.push(`VM:               ${r.vmHint}`),i.join(`
`)}formatEnvironment(r){const i=[];i.push(`Version:          ${g.default.nameShort} ${g.default.version} (${g.default.commit||"Commit unknown"}, ${g.default.date||"Date unknown"})`),i.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const a=v.cpus();return a&&a.length>0&&i.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),i.push(`Memory (System):  ${(v.totalmem()/S.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/S.ByteSize.GB).toFixed(2)}GB free)`),I.isWindows||i.push(`Load (avg):       ${v.loadavg().map(n=>Math.round(n)).join(", ")}`),i.push(`VM:               ${Math.round(k.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${r.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(r,i){return Promise.all([p.listProcesses(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async a=>{let[n,c]=a,h=this.formatProcessList(r,n);return i.forEach(y=>{if(_.isRemoteDiagnosticError(y))h+=`
${y.errorMessage}`,c+=`
${y.errorMessage}`;else if(h+=`

Remote: ${y.hostName}`,y.processes&&(h+=`
${this.formatProcessList(r,y.processes)}`),y.workspaceMetadata){c+=`
|  Remote: ${y.hostName}`;for(const E of Object.keys(y.workspaceMetadata)){const d=y.workspaceMetadata[E];let O=`${d.fileCount} files`;d.maxFilesReached&&(O=`more than ${O}`),c+=`|    Folder (${E}): ${O}`,c+=this.formatWorkspaceStats(d)}}}),{processInfo:h,workspaceInfo:c}})}async getSystemInfo(r,i){const{memory:a,vmHint:n,os:c,cpus:h}=l(),y={os:c,memory:a,cpus:h,vmHint:n,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:i};return I.isWindows||(y.load=`${v.loadavg().map(E=>Math.round(E)).join(", ")}`),I.isLinux&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(r,i){const a=[];return p.listProcesses(r.mainPID).then(async n=>(a.push(""),a.push(this.formatEnvironment(r)),a.push(""),a.push(this.formatProcessList(r,n)),r.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.formatWorkspaceMetadata(r))),i.forEach(c=>{if(_.isRemoteDiagnosticError(c))a.push(`
${c.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${c.hostName}`),a.push(this.formatMachineInfo(c.machineInfo)),c.processes&&a.push(this.formatProcessList(r,c.processes)),c.workspaceMetadata)for(const h of Object.keys(c.workspaceMetadata)){const y=c.workspaceMetadata[h];let E=`${y.fileCount} files`;y.maxFilesReached&&(E=`more than ${E}`),a.push(`Folder (${h}): ${E}`),a.push(this.formatWorkspaceStats(y))}}),a.push(""),a.push(""),a.join(`
`)))}formatWorkspaceStats(r){const i=[],a=60;let n=0;const c=(d,O)=>{const A=` ${d}(${O})`;n+A.length>a?(i.push(h),h="|                 ",n=h.length):n+=A.length,h+=A};let h="|      File types:";const y=10;let E=r.fileTypes.length>y?y:r.fileTypes.length;for(let d=0;d<E;d++){const O=r.fileTypes[d];c(O.name,O.count)}if(i.push(h),r.configFiles.length>=0&&(h="|      Conf files:",n=0,r.configFiles.forEach(d=>{c(d.name,d.count)}),i.push(h)),r.launchConfigFiles.length>0){let d="|      Launch Configs:";r.launchConfigFiles.forEach(O=>{d+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),i.push(d)}return i.join(`
`)}expandGPUFeatures(r){const i=Math.max(...Object.keys(r).map(a=>a.length));return Object.keys(r).map(a=>`${a}:  ${" ".repeat(i-a.length)}  ${r[a]}`).join(`
                  `)}formatWorkspaceMetadata(r){const i=[],a=[];return r.windows.forEach(n=>{n.folderURIs.length===0||!!n.remoteAuthority||(i.push(`|  Window (${n.title})`),n.folderURIs.forEach(c=>{const h=f.URI.revive(c);if(h.scheme===D.Schemas.file){const y=h.fsPath;a.push(w(y,["node_modules",".git"]).then(E=>{let d=`${E.fileCount} files`;E.maxFilesReached&&(d=`more than ${d}`),i.push(`|    Folder (${P.basename(y)}): ${d}`),i.push(this.formatWorkspaceStats(E))}).catch(E=>{i.push(`|      Error: Unable to collect workspace stats for folder ${y} (${E.toString()})`)}))}else i.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(n=>i.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}formatProcessList(r,i){const a=new Map;r.windows.forEach(c=>a.set(c.pid,c.title));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(r.mainPID,a,n,i,0),n.join(`
`)}formatProcessItem(r,i,a,n,c){const h=c===0;let y;h?y=n.pid===r?`${g.default.applicationName} main`:"remote agent":(y=`${"  ".repeat(c)} ${n.name}`,n.name==="window"&&(y=`${y} (${i.get(n.pid)})`));const E=process.platform==="win32"?n.mem:v.totalmem()*(n.mem/100);a.push(`${n.load.toFixed(0).padStart(5," ")}	${(E/S.ByteSize.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(n.children)&&n.children.forEach(d=>this.formatProcessItem(r,i,a,d,c+1))}async reportWorkspaceStats(r){for(const{uri:i}of r.folders){const a=f.URI.revive(i);if(a.scheme===D.Schemas.file){const n=a.fsPath;try{const c=await w(n,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),c.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:h.name,count:h.count})}),c.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:h.name,count:h.count})}),c.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:h.name,count:h.count})})}catch(c){}}}}};s=ge([Y(0,b.ITelemetryService)],s),e.DiagnosticsService=s}),define(ee[169],te([0,1,13,27,33,25,23,42,67,9,28,15,12,7,38,21,49,5,18]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u,D,S,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var l;(function($){$[$.None=0]="None",$[$.IncludeVersions=1]="IncludeVersions",$[$.IncludeFiles=2]="IncludeFiles",$[$.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",$[$.IncludeSharedAccounts=8]="IncludeSharedAccounts",$[$.IncludeVersionProperties=16]="IncludeVersionProperties",$[$.ExcludeNonValidated=32]="ExcludeNonValidated",$[$.IncludeInstallationTargets=64]="IncludeInstallationTargets",$[$.IncludeAssetUri=128]="IncludeAssetUri",$[$.IncludeStatistics=256]="IncludeStatistics",$[$.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",$[$.Unpublished=4096]="Unpublished"})(l||(l={}));function o(...$){return String($.reduce((T,U)=>T|U,0))}var s;(function($){$[$.Tag=1]="Tag",$[$.ExtensionId=4]="ExtensionId",$[$.Category=5]="Category",$[$.ExtensionName=7]="ExtensionName",$[$.Target=8]="Target",$[$.Featured=9]="Featured",$[$.SearchText=10]="SearchText",$[$.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:l.None,criteria:[],assetTypes:[]};class n{constructor(T=a){this.state=T}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(T,U=this.state.pageSize){return new n(Object.assign(Object.assign({},this.state),{pageNumber:T,pageSize:U}))}withFilter(T,...U){const M=[...this.state.criteria,...U.length?U.map(q=>({filterType:T,value:q})):[{filterType:T}]];return new n(Object.assign(Object.assign({},this.state),{criteria:M}))}withSortBy(T){return new n(Object.assign(Object.assign({},this.state),{sortBy:T}))}withSortOrder(T){return new n(Object.assign(Object.assign({},this.state),{sortOrder:T}))}withFlags(...T){return new n(Object.assign(Object.assign({},this.state),{flags:T.reduce((U,M)=>U|M,0)}))}withAssetTypes(...T){return new n(Object.assign(Object.assign({},this.state),{assetTypes:T}))}get raw(){const{criteria:T,pageNumber:U,pageSize:M,sortBy:q,sortOrder:H,flags:X,assetTypes:Q}=this.state;return{filters:[{criteria:T,pageNumber:U,pageSize:M,sortBy:q,sortOrder:H}],assetTypes:Q,flags:X}}get searchText(){const T=this.state.criteria.filter(U=>U.filterType===s.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(T=>String(T.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function c($,T){const U=($||[]).filter(M=>M.statisticName===T)[0];return U?U.value:0}function h($){const T="Microsoft.VisualStudio.Code.Translation.";return $.files.filter(M=>M.assetType.indexOf(T)===0).reduce((M,q)=>{const H=O($,q.assetType);return H&&M.push([q.assetType.substring(T.length),H]),M},[])}function y($){if($.properties){const T=$.properties.filter(q=>q.key===t.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),M=T.filter(q=>U.test(q.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return O($,t.Repository)}function E($){return{uri:`${$.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${$.fallbackAssetUri}/${t.VSIX}`}}function d($){const T=O($,t.Icon);if(T)return T;const U=k.DefaultIconPath;return{uri:U,fallbackUri:U}}function O($,T){return $.files.filter(M=>M.assetType===T)[0]?{uri:`${$.assetUri}/${T}`,fallbackUri:`${$.fallbackAssetUri}/${T}`}:null}function A($,T){const U=$.properties?$.properties.filter(q=>q.key===T):[],M=U.length>0&&U[0].value;return M?M.split(",").map(q=>_.adoptToGalleryExtensionId(q)):[]}function j($){const T=$.properties?$.properties.filter(U=>U.key===r.Engine):[];return T.length>0&&T[0].value||""}function z($){const T=$.properties?$.properties.filter(M=>M.key===r.LocalizedLanguages):[],U=T.length>0&&T[0].value||"";return U?U.split(","):[]}function W($){return $.indexOf("preview")!==-1}function N($){const T=$.properties?$.properties.find(U=>U.key===r.WebExtension):void 0;return!!T&&T.value==="true"}function x($){return $.files.some(T=>T.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?m.joinPath(C.URI.parse($.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function F($,T,U,M,q){const H={manifest:O(T,t.Manifest),readme:O(T,t.Details),changelog:O(T,t.Changelog),license:O(T,t.License),repository:y(T),download:E(T),icon:d(T),coreTranslations:h(T)};return{identifier:{id:_.getGalleryExtensionId($.publisher.publisherName,$.extensionName),uuid:$.extensionId},name:$.extensionName,version:T.version,date:T.lastUpdated,displayName:$.displayName,publisherId:$.publisher.publisherId,publisher:$.publisher.publisherName,publisherDisplayName:$.publisher.displayName,description:$.shortDescription||"",installCount:c($.statistics,"install"),rating:c($.statistics,"averagerating"),ratingCount:c($.statistics,"ratingcount"),assetUri:C.URI.parse(T.assetUri),webResource:x(T),assetTypes:T.files.map(({assetType:X})=>X),assets:H,properties:{dependencies:A(T,r.Dependency),extensionPack:A(T,r.ExtensionPack),engine:j(T),localizedLanguages:z(T),webExtension:N(T)},telemetryData:{index:(M.pageNumber-1)*M.pageSize+U,searchText:M.searchText,querySource:q},preview:W($.flags)}}let B=class{constructor(T,U,M,q,H,X,Q){this.requestService=T,this.logService=U,this.environmentService=M,this.telemetryService=q,this.fileService=H,this.productService=X;const Z=X.extensionsGallery;this.extensionsGalleryUrl=Z&&Z.serviceUrl,this.extensionsControlUrl=Z&&Z.controlUrl,this.commonHeadersPromise=K(X.version,this.environmentService,this.fileService,Q)}api(T=""){return`${this.extensionsGalleryUrl}${T}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(T,U){const M=[];let{total:q,firstPage:H,getPage:X}=await this.query({names:T,pageSize:T.length},U);M.push(...H);for(let Q=1;M.length<q&&(H=await X(Q,U),H.length);Q++)M.push(...H);return M}async getCompatibleExtension(T,U){const M=await this.getCompatibleExtensionByEngine(T,U);return(M==null?void 0:M.properties.webExtension)?M.webResource?M:null:M}async getCompatibleExtensionByEngine(T,U){const M=k.isIExtensionIdentifier(T)?null:T;if(M&&M.properties.engine&&p.isEngineValid(M.properties.engine,this.productService.version))return M;const{id:q,uuid:H}=M?M.identifier:T;let X=new n().withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");H?X=X.withFilter(s.ExtensionId,H):X=X.withFilter(s.ExtensionName,q);const{galleryExtensions:Q}=await this.queryGallery(X,I.CancellationToken.None),[Z]=Q;if(!Z||!Z.versions.length)return null;if(U){const le=Z.versions.filter(me=>me.version===U)[0];if(le){const me=F(Z,le,0,X);if(me.properties.engine&&p.isEngineValid(me.properties.engine,this.productService.version))return me}return null}const ne=await this.getLastValidExtensionVersion(Z,Z.versions);return ne?F(Z,ne,0,X):null}async query(T,U){const M=I.CancellationToken.isCancellationToken(T)?{}:T,q=I.CancellationToken.isCancellationToken(T)?T:U;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let H=M.text||"";const X=R.getOrDefault(M,se=>se.pageSize,50);let Q=new n().withFlags(l.IncludeLatestVersionOnly,l.IncludeAssetUri,l.IncludeStatistics,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,X).withFilter(s.Target,"Microsoft.VisualStudio.Code");H?(H=H.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,ce,fe)=>(Q=Q.withFilter(s.Category,fe||ce),"")),H=H.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,ce,fe)=>(Q=Q.withFilter(s.Tag,fe||ce),"")),H=H.replace(/\bfeatured(\s+|\b|$)/g,()=>(Q=Q.withFilter(s.Featured),"")),H=H.trim(),H&&(H=H.length<200?H:H.substring(0,200),Q=Q.withFilter(s.SearchText,H)),Q=Q.withSortBy(0)):M.ids?Q=Q.withFilter(s.ExtensionId,...M.ids):M.names?Q=Q.withFilter(s.ExtensionName,...M.names):Q=Q.withSortBy(4),typeof M.sortBy=="number"&&(Q=Q.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(Q=Q.withSortOrder(M.sortOrder));const{galleryExtensions:Z,total:ne}=await this.queryGallery(Q,q),le=Z.map((se,ce)=>F(se,se.versions[0],ce,Q,M.source)),me=async(se,ce)=>{if(ce.isCancellationRequested)throw v.canceled();const fe=Q.withPage(se+1),{galleryExtensions:ye}=await this.queryGallery(fe,ce);return ye.map((De,Le)=>F(De,De.versions[0],Le,fe,M.source))};return{firstPage:le,total:ne,pageSize:Q.pageSize,getPage:me}}async queryGallery(T,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,l.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,o(l.Unpublished));const M=await this.commonHeadersPromise,q=JSON.stringify(T.raw),H=Object.assign(Object.assign({},M),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)}),X=new Date().getTime();let Q,Z,ne=0;try{if(Q=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:q,headers:H},U),Q.res.statusCode&&Q.res.statusCode>=400&&Q.res.statusCode<500)return{galleryExtensions:[],total:ne};const le=await L.asJson(Q);if(le){const me=le.results[0],se=me.extensions,ce=me.resultMetadata&&me.resultMetadata.filter(fe=>fe.metadataType==="ResultCount")[0];return ne=ce&&ce.metadataItems.filter(fe=>fe.name==="TotalCount")[0].count||0,{galleryExtensions:se,total:ne}}return{galleryExtensions:[],total:ne}}catch(le){throw Z=le,le}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},T.telemetryData),{requestBodySize:String(q.length),duration:new Date().getTime()-X,success:!!Q&&L.isSuccess(Q),responseBodySize:Q==null?void 0:Q.res.headers["Content-Length"],statusCode:Q?String(Q.res.statusCode):void 0,errorCode:Z?v.isPromiseCanceledError(Z)?"canceled":v.getErrorMessage(Z).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ne)}))}}async reportStatistic(T,U,M,q){if(!!this.isEnabled()){const H=await this.commonHeadersPromise,X=Object.assign(Object.assign({},H),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${T}/extensions/${U}/${M}/stats?statType=${q}`),headers:X},I.CancellationToken.None)}catch(Q){}}}async download(T,U,M){this.logService.trace("ExtensionGalleryService#download",T.identifier.id);const q=_.getGalleryExtensionTelemetryData(T),H=new Date().getTime(),X=le=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},q),{duration:le})),Q=M===1?"install":M===2?"update":"",Z=Q?{uri:`${T.assets.download.uri}&${Q}=true`,fallbackUri:`${T.assets.download.fallbackUri}?${Q}=true`}:T.assets.download,ne=await this.getAsset(Z);await this.fileService.writeFile(U,ne.stream),X(new Date().getTime()-H)}async getReadme(T,U){if(T.assets.readme){const M=await this.getAsset(T.assets.readme,{},U);return await L.asText(M)||""}return""}async getManifest(T,U){if(T.assets.manifest){const M=await this.getAsset(T.assets.manifest,{},U),q=await L.asText(M);return q?JSON.parse(q):null}return null}async getCoreTranslation(T,U){const M=T.assets.coreTranslations.filter(q=>q[0]===U.toUpperCase())[0];if(M){const q=await this.getAsset(M[1]),H=await L.asText(q);return H?JSON.parse(H):null}return null}async getChangelog(T,U){if(T.assets.changelog){const M=await this.getAsset(T.assets.changelog,{},U);return await L.asText(M)||""}return""}async getAllVersions(T,U){let M=new n().withFlags(l.IncludeVersions,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");T.identifier.uuid?M=M.withFilter(s.ExtensionId,T.identifier.uuid):M=M.withFilter(s.ExtensionName,T.identifier.id);const q=[],{galleryExtensions:H}=await this.queryGallery(M,I.CancellationToken.None);return H.length&&(U?await Promise.all(H[0].versions.map(async X=>{let Q;try{Q=await this.getEngine(X)}catch(Z){}Q&&p.isEngineValid(Q,this.productService.version)&&q.push({version:X.version,date:X.lastUpdated})})):q.push(...H[0].versions.map(X=>({version:X.version,date:X.lastUpdated})))),q}async getAsset(T,U={},M=I.CancellationToken.None){const q=await this.commonHeadersPromise,H={type:"GET"},X=Object.assign(Object.assign({},q),U.headers||{});U=Object.assign(Object.assign(Object.assign({},U),H),{headers:X});const Q=T.uri,Z=T.fallbackUri,ne=Object.assign(Object.assign({},U),{url:Q});try{const le=await this.requestService.request(ne,M);if(le.res.statusCode===200)return le;const me=await L.asText(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${me}`)}catch(le){if(v.isPromiseCanceledError(le))throw le;const me=v.getErrorMessage(le);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Q,message:me});const se=Object.assign(Object.assign({},U),{url:Z});return this.requestService.request(se,M)}}async getLastValidExtensionVersion(T,U){const M=this.getLastValidExtensionVersionFromProperties(T,U);return M||this.getLastValidExtensionVersionRecursively(T,U)}getLastValidExtensionVersionFromProperties(T,U){for(const M of U){const q=j(M);if(!q)return null;if(p.isEngineValid(q,this.productService.version))return M}return null}async getEngine(T){const U=j(T);if(U)return U;const M=O(T,t.Manifest);if(!M)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},H=await this.getAsset(M,{headers:q}),X=await L.asJson(H);if(X)return X.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(T,U){if(!U.length)return null;const M=U[0],q=await this.getEngine(M);return p.isEngineValid(q,this.productService.version)?(M.properties=M.properties||[],M.properties.push({key:r.Engine,value:q}),M):this.getLastValidExtensionVersionRecursively(T,U.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const T=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},I.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await L.asJson(T),M=new Map;if(U)for(const q of U.malicious){const H=M.get(q)||{id:{id:q},malicious:!0,slow:!1};H.malicious=!0,M.set(q,H)}return[...M.values()]}};B=ge([Y(0,L.IRequestService),Y(1,f.ILogService),Y(2,g.IEnvironmentService),Y(3,P.ITelemetryService),Y(4,b.IFileService),Y(5,u.IProductService),Y(6,w.optional(D.IStorageService))],B),e.ExtensionGalleryService=B;async function K($,T,U,M){const q={"X-Market-Client-Id":`VSCode ${$}`,"User-Agent":`VSCode ${$}`},H=await S.getServiceMachineId(T,U,M);return q["X-Market-User-Id"]=H,q}e.resolveMarketplaceHeaders=K}),define(ee[170],te([0,1,7,4,38,9,48,12,6,19,27,62,42,15,165,8,23,70,110,21,3,57]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u,D,S,w,m,l,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let i=class extends u.ExtensionTipsService{constructor(n,c,h,y,E,d,O,A,j,z){super(O,A,j,z);this.environmentService=n,this.telemetryService=c,this.extensionManagementService=h,this.storageService=y,this.nativeHostService=E,this.extensionRecommendationNotificationService=d,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,A.exeBasedExtensionTips&&f.forEach(A.exeBasedExtensionTips,({key:W,value:N})=>{const x=[],F=[],B=[];f.forEach(N.recommendations,({key:K,value:$})=>{$.important?N.important?x.push({extensionId:K,extensionName:$.name,isExtensionPack:!!$.isExtensionPack}):F.push({extensionId:K,extensionName:$.name,isExtensionPack:!!$.isExtensionPack}):B.push({extensionId:K,extensionName:$.name,isExtensionPack:!!$.isExtensionPack})}),x.length&&this.highImportanceExecutableTips.set(W,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:x}),F.length&&this.mediumImportanceExecutableTips.set(W,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:F}),B.length&&this.allOtherExecutableTips.set(W,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:B})}),D.timeout(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const n=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...n,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const n=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),h=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(n,h),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,h)}groupImportantTipsByExe(n,c){const h=new Map;n.forEach(A=>h.set(A.extensionId.toLowerCase(),A));const{installed:y,uninstalled:E}=this.groupByInstalled([...h.keys()],c);for(const A of y){const j=h.get(A);j&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:A,exeName:k.basename(j.windowsPath)})}for(const A of E){const j=h.get(A);j&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:A,exeName:k.basename(j.windowsPath)})}const d=this.getPromptedExecutableTips(),O=new Map;for(const A of E){const j=h.get(A);if(j&&(!d[j.exeName]||!d[j.exeName].includes(j.extensionId))){let z=O.get(j.exeName);z||(z=[],O.set(j.exeName,z)),z.push(j)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size!==0){const[n,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(h=>{switch(h){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(n);break;case"incompatibleWindow":const y=o.Event.once(o.Event.latch(o.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(y(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const E=this._register(D.disposableTimeout(()=>{E.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size!==0){const n=this.getLastPromptedMediumExeTime(),c=Date.now()-n,h=7*24*60*60*1e3;if(c<h){const d=this._register(D.disposableTimeout(()=>{d.dispose(),this.promptMediumImportanceExeBasedTip()},h-c));return}const[y,E]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(E).then(d=>{switch(d){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(y),this.addToRecommendedExecutables(E[0].exeName,E);const O=this._register(D.disposableTimeout(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},h));break;case"ignored":this.mediumImportanceTipsByExe.delete(y),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const A=o.Event.once(o.Event.latch(o.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(A(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const j=this._register(D.disposableTimeout(()=>{j.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}}promptExeRecommendations(n){const c=n.map(({extensionId:y})=>y.toLowerCase()),h=m.localize(0,null,n[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(c,h,`@exe:"${n[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let n=this.storageService.getNumber(r,0);return n||(n=Date.now(),this.updateLastPromptedMediumExeTime(n)),n}updateLastPromptedMediumExeTime(n){this.storageService.store(r,n,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(n,c){const h=this.getPromptedExecutableTips();h[n]=c.map(({extensionId:y})=>y.toLowerCase()),this.storageService.store(t,JSON.stringify(h),0,0)}groupByInstalled(n,c){const h=[],y=[],E=c.reduce((d,O)=>(d.add(O.identifier.id.toLowerCase()),d),new Set);return n.forEach(d=>{E.has(d.toLowerCase())?h.push(d):y.push(d)}),{installed:h,uninstalled:y}}async getValidExecutableBasedExtensionTips(n){const c=[],h=new Map;for(const y of n.keys()){const E=n.get(y);if(!(!E||!g.isNonEmptyArray(E.recommendations))){const d=[];p.isWindows?E.windowsPath&&d.push(E.windowsPath.replace("%USERPROFILE%",P.process.env.USERPROFILE).replace("%ProgramFiles(x86)%",P.process.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",P.process.env.ProgramFiles).replace("%APPDATA%",P.process.env.APPDATA).replace("%WINDIR%",P.process.env.WINDIR)):(d.push(k.join("/usr/local/bin",y)),d.push(k.join("/usr/bin",y)),d.push(k.join(this.environmentService.userHome.fsPath,y)));for(const O of d){let A=h.get(O);if(A===void 0&&(A=await this.fileService.exists(v.URI.file(O)),h.set(O,A)),A)for(const{extensionId:j,extensionName:z,isExtensionPack:W}of E.recommendations)c.push({extensionId:j,extensionName:z,isExtensionPack:W,exeName:y,exeFriendlyName:E.exeFriendlyName,windowsPath:E.windowsPath})}}}return c}};i=ge([Y(0,R.INativeEnvironmentService),Y(1,S.ITelemetryService),Y(2,I.IExtensionManagementService),Y(3,l.IStorageService),Y(4,s.INativeHostService),Y(5,w.IExtensionRecommendationNotificationService),Y(6,L.IFileService),Y(7,_.IProductService),Y(8,b.IRequestService),Y(9,C.ILogService)],i),e.ExtensionTipsService=i}),define(ee[171],te([0,1,3,2,30,23]),function(G,e,v,k,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStorageDatabaseChannelClient=e.GlobalStorageDatabaseChannel=void 0;class P extends k.Disposable{constructor(g,I){super();this.logService=g,this.storageMainService=I,this._onDidChangeItems=this._register(new v.Emitter),this.onDidChangeItems=this._onDidChangeItems.event,this.whenReady=this.init()}async init(){try{await this.storageMainService.initialize()}catch(g){this.logService.error(`[storage] init(): Unable to init global storage due to ${g}`)}this.initTelemetry(),this.registerListeners()}initTelemetry(){this.storageMainService.get(R.instanceStorageKey,void 0)===void 0&&this.storageMainService.store(R.instanceStorageKey,_.generateUuid()),this.storageMainService.get(R.firstSessionDateStorageKey,void 0)===void 0&&this.storageMainService.store(R.firstSessionDateStorageKey,new Date().toUTCString());const f=this.storageMainService.get(R.currentSessionDateStorageKey,void 0),b=new Date().toUTCString();this.storageMainService.store(R.lastSessionDateStorageKey,typeof f=="undefined"?null:f),this.storageMainService.store(R.currentSessionDateStorageKey,b)}registerListeners(){this._register(v.Event.debounce(this.storageMainService.onDidChangeStorage,(g,I)=>(g?g.push(I):g=[I],g),P.STORAGE_CHANGE_DEBOUNCE_TIME)(g=>{g.length&&this._onDidChangeItems.fire(this.serializeEvents(g))}))}serializeEvents(g){const I=new Map,f=new Set;return g.forEach(b=>{const C=this.storageMainService.get(b.key);typeof C=="string"?I.set(b.key,C):f.add(b.key)}),{changed:Array.from(I.entries()),deleted:Array.from(f.values())}}listen(g,I){switch(I){case"onDidChangeItems":return this.onDidChangeItems}throw new Error(`Event not found: ${I}`)}async call(g,I,f){switch(await this.whenReady,I){case"getItems":return Array.from(this.storageMainService.items.entries());case"updateItems":{const b=f;if(b.insert)for(const[C,u]of b.insert)this.storageMainService.store(C,u);b.delete&&b.delete.forEach(C=>this.storageMainService.remove(C));break}default:throw new Error(`Call not found: ${I}`)}}}e.GlobalStorageDatabaseChannel=P,P.STORAGE_CHANGE_DEBOUNCE_TIME=100;class L extends k.Disposable{constructor(g){super();this.channel=g,this._onDidChangeItemsExternal=this._register(new v.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this.onDidChangeItemsOnMainListener=this.channel.listen("onDidChangeItems")(g=>this.onDidChangeItemsOnMain(g))}onDidChangeItemsOnMain(g){(Array.isArray(g.changed)||Array.isArray(g.deleted))&&this._onDidChangeItemsExternal.fire({changed:g.changed?new Map(g.changed):void 0,deleted:g.deleted?new Set(g.deleted):void 0})}async getItems(){const g=await this.channel.call("getItems");return new Map(g)}updateItems(g){const I=Object.create(null);return g.insert&&(I.insert=Array.from(g.insert.entries())),g.delete&&(I.delete=Array.from(g.delete.values())),this.channel.call("updateItems",I)}async close(){k.dispose(this.onDidChangeItemsOnMainListener)}dispose(){super.dispose(),k.dispose(this.onDidChangeItemsOnMainListener)}}e.GlobalStorageDatabaseChannelClient=L}),define(ee[172],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(R){this.appender=R}listen(R,P){throw new Error(`Event not found: ${P}`)}call(R,P,{eventName:L,data:p}){return this.appender.log(L,p),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class k{constructor(R){this.channel=R}log(R,P){return this.channel.call("log",{eventName:R,data:P}).then(void 0,L=>`Failed to log telemetry: ${console.warn(L)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=k}),define(ee[173],te([0,1,37,120,20,5,26,41,2,25,34]),function(G,e,v,k,_,R,P,L,p,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{constructor(u,D){this._configurationService=D,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appender=u.appender,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp(_.escapeRegExpCharacters(S),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(S=>{const w=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!w})}))}setExperimentProperty(u,D){this._experimentProperties[u]=D}setEnabled(u){this._enabled=u}_updateUserOptIn(){var u;const D=(u=this._configurationService)===null||u===void 0?void 0:u.getValue(b);this._userOptIn=D?D.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const u=await this._commonProperties;let D=u.sessionID,S=u["common.instanceId"],w=u["common.machineId"],m=u["common.msftInternal"];return{sessionId:D,instanceId:S,machineId:w,msftInternal:m}}dispose(){this._disposables.dispose()}publicLog(u,D,S){return this.isOptedIn?this._commonProperties.then(w=>{D=g.mixin(D,w),D=g.mixin(D,this._experimentProperties),D=g.cloneAndChange(D,m=>{if(typeof m=="string")return this._cleanupInfo(m,S)}),this._appender.log(u,D)},w=>{console.error(w)}):Promise.resolve(void 0)}publicLog2(u,D,S){return this.publicLog(u,D,S)}publicLogError(u,D){return this.sendErrorTelemetry?this.publicLog(u,D,!0):Promise.resolve(void 0)}publicLogError2(u,D){return this.publicLogError(u,D)}_cleanupInfo(u,D){let S=u;if(D){const w=[];for(let s of this._cleanupPatterns)for(;;){const t=s.exec(u);if(!t)break;w.push([t.index,s.lastIndex])}const m=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(S="";;){const s=l.exec(u);if(!s)break;!m.test(s[0])&&w.every(([t,r])=>s.index<t||s.index>=r)&&(S+=u.substring(o,s.index)+"<REDACTED: user-file-path>",o=l.lastIndex)}o<u.length&&(S+=u.substr(o))}for(let w of this._cleanupPatterns)S=S.replace(w,"");return S}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=ge([Y(1,R.optional(P.IConfigurationService))],f),e.TelemetryService=f;const b="telemetry";I.Registry.as(L.Extensions.Configuration).registerConfiguration({id:b,order:110,type:"object",title:k.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:v.default.privacyStatementUrl?k.localize(2,null,v.default.privacyStatementUrl):k.localize(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(ee[58],te([0,1,26,25,17]),function(G,e,v,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(b,C){return Promise.resolve(void 0)}publicLog2(b,C){return this.publicLog(b,C)}publicLogError(b,C){return Promise.resolve(void 0)}publicLogError2(b,C){return this.publicLogError(b,C)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId"})}};function R(...b){return{log:(C,u)=>b.forEach(D=>D.log(C,u)),flush:()=>Promise.all(b.map(C=>C.flush()))}}e.combinedAppender=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(b,C){return C.onDidChangeConfiguration(u=>{u.source!==6&&b.publicLog2("updateConfiguration",{configurationSource:v.ConfigurationTargetToString(u.source),configurationKeys:I(u.sourceConfig)})})}e.configurationTelemetry=P;function L(b){const C=Object.create(null),u=Object.create(null),D=Object.create(null);g(b,D);for(let S in D){S=S.length>150?S.substr(S.length-149):S;const w=D[S];typeof w=="number"?u[S]=w:typeof w=="boolean"?u[S]=w?1:0:typeof w=="string"?C[S]=w.substring(0,1023):typeof w!="undefined"&&w!==null&&(C[S]=w)}return{properties:C,measurements:u}}e.validateTelemetryData=L;function p(b){if(!b)return"none";let C="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(D=>{b.indexOf(`${D}+`)===0&&(C=D)}),C}e.cleanRemoteAuthority=p;function g(b,C,u=0,D){if(!!b)for(let S of Object.getOwnPropertyNames(b)){const w=b[S],m=D?D+S:S;Array.isArray(w)?C[m]=k.safeStringify(w):w instanceof Date?C[m]=w.toISOString():_.isObject(w)?u<2?g(w,C,u+1,m+"."):C[m]=k.safeStringify(w):C[m]=w}}function I(b){if(!b)return[];const C=[];return f(C,"",b),C}function f(b,C,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(D=>f(b,C?`${C}.${D}`:D,u[D])):b.push(C)}}),define(ee[174],te([0,1,2,9,15,58]),function(G,e,v,k,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let P=class extends v.Disposable{constructor(p,g){super();this.logger=this._register(p.getLogger(g.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(p,g){this.logger.trace(`telemetry/${p}`,R.validateTelemetryData(g))}};P=ge([Y(0,_.ILoggerService),Y(1,k.IEnvironmentService)],P),e.TelemetryLogAppender=P}),define(ee[175],te([0,1,13,25,58]),function(G,e,v,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function R(L){const p=await new Promise((I,f)=>{G(["applicationinsights"],I,f)});let g;return p.defaultClient?(g=new p.TelemetryClient(L),g.channel.setUseDiskRetryCaching(!0)):(p.setup(L).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),g=p.defaultClient),L.indexOf("AIF-")===0&&(g.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),g}class P{constructor(p,g,I){this._eventPrefix=p,this._defaultData=g,this._defaultData||(this._defaultData=Object.create(null)),typeof I=="function"?this._aiClient=I():this._aiClient=I,this._asyncAIClient=null}_withAIClient(p){if(!!this._aiClient){if(typeof this._aiClient!="string"){p(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient)),this._asyncAIClient.then(g=>{p(g)},g=>{v.onUnexpectedError(g),console.error(g)})}}log(p,g){!this._aiClient||(g=k.mixin(g,this._defaultData),g=_.validateTelemetryData(g),this._withAIClient(I=>I.trackEvent({name:this._eventPrefix+"/"+p,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(p=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,p(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=P}),define(ee[50],te([0,1,39]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function k(P,L,p,g){const I=v.setProperty(P,L,p,g)[0];return I&&(P=P.substring(0,I.offset)+I.content+P.substring(I.offset+I.length)),P}e.edit=k;function _(P,L,p){let g=p;for(;g>=0;){if(P.charAt(g)===L.charAt(L.length-1)&&L.length===1)return g+1;if(g--,L.length===2&&g>=0&&P.charAt(g)===L.charAt(0))return g+2}return 0}e.getLineStartOffset=_;function R(P,L,p){let g=p;for(;g>=0;)if(P.charAt(g)===L.charAt(L.length-1)&&L.length===1||(g++,L.length===2&&g>=0&&P.charAt(g)===L.charAt(1)))return g;return P.length-1}e.getLineEndOffset=R}),define(ee[176],te([0,1,25,56]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function _(f,b,C,u,D){var S,w;const m=[],l=[],o=[];if(!b){const j=f.filter(({identifier:z})=>D.every(W=>W.toLowerCase()!==z.id.toLowerCase()));return{added:m,removed:l,updated:o,remote:j.length>0?j:null}}f=f.map(g),b=b.map(g),C=C?C.map(g):null;const s=new Map,t=j=>{j.uuid&&s.set(j.id.toLowerCase(),j.uuid)};f.forEach(({identifier:j})=>t(j)),b.forEach(({identifier:j})=>t(j)),C&&C.forEach(({identifier:j})=>t(j));const r=j=>{const z=j.identifier.uuid||s.get(j.identifier.id.toLowerCase());return z?`uuid:${z}`:`id:${j.identifier.id.toLowerCase()}`},i=(j,z)=>(j.set(r(z),z),j),a=f.reduce(i,new Map),n=b.reduce(i,new Map),c=b.reduce((j,z)=>{const W=r(z);z=v.deepClone(z);const N=a.get(W);return N&&(N.installed&&(z.installed=!0),z.version||(z.version=N.version)),i(j,z)},new Map),h=C?C.reduce(i,new Map):null,y=u.reduce(i,new Map),E=D.reduce((j,z)=>{const W=s.get(z.toLowerCase());return j.add(W?`uuid:${W}`:`id:${z.toLowerCase()}`)},new Set),d=R(a,n,E);if(d.added.size>0||d.removed.size>0||d.updated.size>0){const j=R(h,a,E),z=R(h,n,E),W=(N,x)=>{const F=a.get(N);if(F){const B=n.get(N);return Object.assign(Object.assign({},x?B:F),{version:(B.version&&k.gt(B.version,F.version),F.version),state:P(F,B,h==null?void 0:h.get(N))})}};for(const N of z.removed.values()){const x=a.get(N);x&&l.push(x.identifier)}for(const N of z.added.values())if(j.added.has(N)){if(d.updated.has(N)){const x=W(N,!0);x&&(o.push(I(x,N)),c.set(N,x))}}else{const x=n.get(N);x.installed&&m.push(I(x,N))}for(const N of z.updated.values()){const x=W(N,!0);x&&(o.push(I(x,N)),c.set(N,x))}for(const N of j.added.values())z.added.has(N)||c.set(N,a.get(N));for(const N of j.updated.values())if(!z.removed.has(N)&&!z.updated.has(N)){const x=W(N,!1);x&&(((S=c.get(N))===null||S===void 0?void 0:S.installed)&&(x.installed=!0),c.set(N,x))}for(const N of j.removed.values())!y.has(N)&&!z.updated.has(N)&&((w=h==null?void 0:h.get(N))===null||w===void 0?void 0:w.installed)&&c.delete(N)}const O=[],A=R(n,c,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(A.added.size>0||A.updated.size>0||A.removed.size>0)&&c.forEach((j,z)=>O.push(I(j,z))),{added:m,removed:l,updated:o,remote:O.length?O:null}}e.merge=_;function R(f,b,C,{checkInstalledProperty:u,checkVersionProperty:D}={checkInstalledProperty:!1,checkVersionProperty:!1}){const S=f?[...f.keys()].filter(s=>!C.has(s)):[],w=[...b.keys()].filter(s=>!C.has(s)),m=w.filter(s=>S.indexOf(s)===-1).reduce((s,t)=>(s.add(t),s),new Set),l=S.filter(s=>w.indexOf(s)===-1).reduce((s,t)=>(s.add(t),s),new Set),o=new Set;for(const s of S)if(!l.has(s)){const t=f.get(s),r=b.get(s);(!r||t.disabled!==r.disabled||!p(t.state,r.state)||D&&t.version!==r.version||u&&t.installed!==r.installed)&&o.add(s)}return{added:m,removed:l,updated:o}}function P(f,b,C){const u=f.state,D=b.state,S=C==null?void 0:C.state;if(!b.version||u&&k.gt(f.version,b.version))return u;if(D&&k.gt(b.version,f.version)||!u)return D;if(!D)return u;const w=v.deepClone(u),m=S?L(S,D):{added:Object.keys(D).reduce((o,s)=>(o.add(s),o),new Set),removed:new Set,updated:new Set},l=S?L(S,u):{added:Object.keys(u).reduce((o,s)=>(o.add(s),o),new Set),removed:new Set,updated:new Set};for(const o of[...m.added.values(),...m.updated.values()])w[o]=D[o];for(const o of m.removed.values())l.updated.has(o)||delete w[o];return w}function L(f,b){const C=Object.keys(f),u=Object.keys(b),D=u.filter(m=>C.indexOf(m)===-1).reduce((m,l)=>(m.add(l),m),new Set),S=C.filter(m=>u.indexOf(m)===-1).reduce((m,l)=>(m.add(l),m),new Set),w=new Set;for(const m of C)if(!S.has(m)){const l=f[m],o=b[m];v.equals(l,o)||w.add(m)}return{added:D,removed:S,updated:w}}function p(f={},b={}){const{added:C,removed:u,updated:D}=L(f,b);return C.size===0&&u.size===0&&D.size===0}function g(f){return Object.assign(Object.assign({},f),{disabled:!!f.disabled,installed:!!f.installed})}function I(f,b){const C={identifier:{id:f.identifier.id,uuid:b.startsWith("uuid:")?b.substring("uuid:".length):void 0}};return f.version&&(C.version=f.version),f.disabled&&(C.disabled=!0),f.installed&&(C.installed=!0),f.state&&(C.state=f.state),C}}),define(ee[77],te([0,1,3,2,33,5,21]),function(G,e,v,k,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=R.createDecorator("IExtensionsStorageSyncService");const L=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class xe extends k.Disposable{constructor(I){super();this.storageService=I,this._onDidChangeExtensionsStorage=this._register(new v.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(f=>this.onDidChangeStorageValue(f)))}static toKey(I){return`extensionKeys/${_.adoptToGalleryExtensionId(I.id)}@${I.version}`}static fromKey(I){const f=L.exec(I);if(f&&f[1])return{id:f[1],version:f[2]}}initialize(){const I=this.storageService.keys(0,1);for(const f of I){const b=xe.fromKey(f);b&&this.extensionsWithKeysForSync.add(b.id.toLowerCase())}}onDidChangeStorageValue(I){if(I.scope===0){if(this.extensionsWithKeysForSync.has(I.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const f=xe.fromKey(I.key);if(f){this.extensionsWithKeysForSync.add(f.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}}setKeysForSync(I,f){this.storageService.store(xe.toKey(I),JSON.stringify(f),0,1)}getKeysForSync(I){const f=this.storageService.get(xe.toKey(I),0);return f?JSON.parse(f):void 0}};p=ge([Y(0,P.IStorageService)],p),e.ExtensionsStorageSyncService=p}),define(ee[177],te([0,1,25]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(P,L,p,g,I){if(!L)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const f=_(P,L);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const b=p?_(p,L):{added:Object.keys(L).reduce((S,w)=>(S.add(w),S),new Set),removed:new Set,updated:new Set},C=p?_(p,P):{added:Object.keys(P).reduce((S,w)=>(S.add(w),S),new Set),removed:new Set,updated:new Set},u={added:{},removed:[],updated:{}},D=v.deepClone(L);for(const S of C.added.values())!p&&b.added.has(S)||(D[S]=P[S]);for(const S of C.updated.values())D[S]=P[S];for(const S of C.removed.values())g.unregistered.includes(S)||delete D[S];for(const S of b.added.values()){const w=L[S];if(g.machine.includes(S)){I.info(`GlobalState: Skipped adding ${S} in local storage because it is declared as machine scoped.`);continue}if(!(p&&C.added.has(S))){const m=P[S];m&&m.value===w.value||(m?u.updated[S]=w:u.added[S]=w)}}for(const S of b.updated.values()){const w=L[S];if(g.machine.includes(S)){I.info(`GlobalState: Skipped updating ${S} in local storage because it is declared as machine scoped.`);continue}if(!(C.updated.has(S)||C.removed.has(S))){const m=P[S];m&&m.value===w.value||(u.updated[S]=w)}}for(const S of b.removed.values()){if(g.machine.includes(S)){I.trace(`GlobalState: Skipped removing ${S} in local storage because it is declared as machine scoped.`);continue}C.updated.has(S)||C.removed.has(S)||u.removed.push(S)}return{local:u,remote:R(D,L)?null:D}}e.merge=k;function _(P,L){const p=Object.keys(P),g=Object.keys(L),I=g.filter(C=>p.indexOf(C)===-1).reduce((C,u)=>(C.add(u),C),new Set),f=p.filter(C=>g.indexOf(C)===-1).reduce((C,u)=>(C.add(u),C),new Set),b=new Set;for(const C of p)if(!f.has(C)){const u=P[C],D=L[C];v.equals(u,D)||b.add(C)}return{added:I,removed:f,updated:b}}function R(P,L){const{added:p,removed:g,updated:I}=_(P,L);return p.size===0&&g.size===0&&I.size===0}}),define(ee[78],te([0,1,19,26,5]),function(G,e,v,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=_.createDecorator("IIgnoredExtensionsManagementService");let R=class{constructor(L){this.configurationService=L}hasToNeverSyncExtension(L){return this.getConfiguredIgnoredExtensions().includes(L.toLowerCase())}hasToAlwaysSyncExtension(L){return this.getConfiguredIgnoredExtensions().includes(`-${L.toLowerCase()}`)}updateIgnoredExtensions(L,p){let g=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return g=g.filter(I=>I!==L&&I!==`-${L}`),p&&g.push(L.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,1)}updateSynchronizedExtensions(L,p){let g=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return g=g.filter(I=>I!==L&&I!==`-${L}`),p&&g.push(`-${L.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,1)}getIgnoredExtensions(L){const p=L.filter(b=>b.isMachineScoped).map(b=>b.identifier.id.toLowerCase()),g=this.getConfiguredIgnoredExtensions().map(b=>b.toLowerCase()),I=[],f=[];if(Array.isArray(g))for(const b of g)b.startsWith("-")?f.push(b.substring(1)):I.push(b);return v.distinct([...p,...I].filter(b=>f.indexOf(b)===-1))}getConfiguredIgnoredExtensions(){let L=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return L!==void 0||(L=this.configurationService.inspect("sync.ignoredExtensions").userValue,L!==void 0)?L:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(p=>p.toLowerCase())}};R=ge([Y(0,k.IConfigurationService)],R),e.IgnoredExtensionsManagementService=R}),define(ee[178],te([0,1,25,29,19,138,50]),function(G,e,v,k,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function L(o){return k.parse(o)||[]}e.parseKeybindings=L;async function p(o,s,t,r,i){const a=L(o),n=L(s),c=t?L(t):null,h=[...a,...n,...c||[]].map(F=>F.key),y=await i.resolveUserBindings(h);let E=I(a,n,c,y);if(!E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:o,hasChanges:!1,hasConflicts:!1};if(!E.hasLocalForwarded&&E.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};if(E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};const d=b(a),O=b(n),A=c?b(c):null,j=u(d,O,y),z=A?u(A,d,y):{added:[...d.keys()].reduce((F,B)=>(F.add(B),F),new Set),removed:new Set,updated:new Set},W=A?u(A,O,y):{added:[...O.keys()].reduce((F,B)=>(F.add(B),F),new Set),removed:new Set,updated:new Set},N=g(j,z,W);let x=o;for(const F of N.removed.values())N.conflicts.has(F)||(x=m(x,F,r));for(const F of N.added.values())if(!N.conflicts.has(F)){const B=O.get(F);if(B.some(K=>K.command!==`-${F}`&&E.conflicts.has(y[K.key]))){N.conflicts.add(F);continue}x=w(x,B,r)}for(const F of N.updated.values())if(!N.conflicts.has(F)){const B=O.get(F);if(B.some(K=>K.command!==`-${F}`&&E.conflicts.has(y[K.key]))){N.conflicts.add(F);continue}x=l(x,F,B,r)}return{mergeContent:x,hasChanges:!0,hasConflicts:N.conflicts.size>0}}e.merge=p;function g(o,s,t){const r=new Set,i=new Set,a=new Set,n=new Set;for(const c of s.removed.values())t.updated.has(c)&&n.add(c);for(const c of t.removed.values())n.has(c)||(s.updated.has(c)?n.add(c):i.add(c));for(const c of s.added.values())n.has(c)||t.added.has(c)&&o.updated.has(c)&&n.add(c);for(const c of t.added.values())n.has(c)||(s.added.has(c)?o.updated.has(c)&&n.add(c):r.add(c));for(const c of s.updated.values())n.has(c)||t.updated.has(c)&&o.updated.has(c)&&n.add(c);for(const c of t.updated.values())n.has(c)||(s.updated.has(c)?o.updated.has(c)&&n.add(c):a.add(c));return{added:r,removed:i,updated:a,conflicts:n}}function I(o,s,t,r){const i=new Set,a=f(o,r),n=f(s,r),c=t?f(t,r):null,h=C(a,n);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const y=c?C(c,a):{added:[...a.keys()].reduce((z,W)=>(z.add(W),z),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const E=c?C(c,n):{added:[...n.keys()].reduce((z,W)=>(z.add(W),z),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:d,removed:O,updated:A,conflicts:j}=g(h,y,E);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:d,removed:O,updated:A,conflicts:j}}function f(o,s){const t=new Map;for(const r of o){const i=s[r.key];let a=t.get(i);a||(a=[],t.set(i,a)),a.push(r)}return t}function b(o){const s=new Map;for(const t of o){const r=t.command[0]==="-"?t.command.substring(1):t.command;let i=s.get(r);i||(i=[],s.set(r,i)),i.push(t)}return s}function C(o,s){const t=[...o.keys()],r=[...s.keys()],i=r.filter(c=>t.indexOf(c)===-1).reduce((c,h)=>(c.add(h),c),new Set),a=t.filter(c=>r.indexOf(c)===-1).reduce((c,h)=>(c.add(h),c),new Set),n=new Set;for(const c of t)if(!a.has(c)){const h=o.get(c).map(E=>Object.assign(Object.assign({},E),{key:c})),y=s.get(c).map(E=>Object.assign(Object.assign({},E),{key:c}));_.equals(h,y,(E,d)=>S(E,d))||n.add(c)}return{added:i,removed:a,updated:n}}function u(o,s,t){const r=[...o.keys()],i=[...s.keys()],a=i.filter(h=>r.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),n=r.filter(h=>i.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),c=new Set;for(const h of r)if(!n.has(h)){const y=o.get(h).map(d=>Object.assign(Object.assign({},d),{key:t[d.key]})),E=s.get(h).map(d=>Object.assign(Object.assign({},d),{key:t[d.key]}));D(y,E)||c.add(h)}return{added:a,removed:n,updated:c}}function D(o,s){return!(!_.equals(o.filter(({command:t})=>t[0]!=="-"),s.filter(({command:t})=>t[0]!=="-"),(t,r)=>S(t,r))||!_.equals(o.filter(({command:t})=>t[0]==="-"),s.filter(({command:t})=>t[0]==="-"),(t,r)=>S(t,r)))}function S(o,s){if(o.command!==s.command||o.key!==s.key)return!1;const t=R.ContextKeyExpr.deserialize(o.when),r=R.ContextKeyExpr.deserialize(s.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!v.equals(o.args,s.args))}function w(o,s,t){for(const r of s)o=P.edit(o,[-1],r,t);return o}function m(o,s,t){const r=L(o);for(let i=r.length-1;i>=0;i--)(r[i].command===s||r[i].command===`-${s}`)&&(o=P.edit(o,[i],void 0,t));return o}function l(o,s,t,r){const i=L(o),a=i.findIndex(n=>n.command===s||n.command===`-${s}`);for(let n=i.length-1;n>=0;n--)(i[n].command===s||i[n].command===`-${s}`)&&(o=P.edit(o,[n],void 0,r));for(let n=t.length-1;n>=0;n--)o=P.edit(o,[a],t[n],r);return o}}),define(ee[179],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function v(R,P,L){const p={},g={},I=new Set;if(!P)return{local:{added:p,updated:g,removed:[...I.values()]},remote:{added:R,updated:{},removed:[]},conflicts:[]};const f=k(R,P);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{local:{added:p,updated:g,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const b=k(L,R),C=k(L,P),u={},D={},S=new Set,w=new Set;for(const m of b.removed.values())C.updated.has(m)?p[m]=P[m]:S.add(m);for(const m of C.removed.values())w.has(m)||(b.updated.has(m)?w.add(m):I.add(m));for(const m of b.updated.values())w.has(m)||(C.updated.has(m)?f.updated.has(m)&&w.add(m):D[m]=R[m]);for(const m of C.updated.values())w.has(m)||(b.updated.has(m)?f.updated.has(m)&&w.add(m):R[m]!==void 0&&(g[m]=P[m]));for(const m of b.added.values())w.has(m)||(C.added.has(m)?f.updated.has(m)&&w.add(m):u[m]=R[m]);for(const m of C.added.values())w.has(m)||(b.added.has(m)?f.updated.has(m)&&w.add(m):p[m]=P[m]);return{local:{added:p,removed:[...I.values()],updated:g},remote:{added:u,removed:[...S.values()],updated:D},conflicts:[...w.values()]}}e.merge=v;function k(R,P){const L=R?Object.keys(R):[],p=P?Object.keys(P):[],g=p.filter(b=>L.indexOf(b)===-1).reduce((b,C)=>(b.add(C),b),new Set),I=L.filter(b=>p.indexOf(b)===-1).reduce((b,C)=>(b.add(C),b),new Set),f=new Set;for(const b of L)if(!I.has(b)){const C=R[b],u=P[b];C!==u&&f.add(b)}return{added:g,removed:I,updated:f}}function _(R,P){const{added:L,removed:p,updated:g}=k(R,P);return L.size===0&&p.size===0&&g.size===0}e.areSame=_}),define(ee[24],te([0,1,5,27,34,41,125,76,18,19,17]),function(G,e,v,k,_,R,P,L,p,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function f(){const i=_.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(i).filter(a=>!!i[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=f;function b(){const i=_.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(i).filter(h=>!!i[h].ignoreSync),n=Object.keys(i).filter(h=>i[h].scope===2||i[h].scope===6),c=f();return g.distinct([e.CONFIGURATION_SYNC_STORE_KEY,...a,...n,...c])}e.getDefaultIgnoredSettings=b;function C(){const i="vscode://schemas/ignoredSettings",a=_.Registry.as(R.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:P.localize(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:P.localize(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:P.localize(2,null),items:[{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN,errorMessage:P.localize(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:P.localize(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const n=_.Registry.as(L.Extensions.JSONContribution),c=()=>{const h=f(),y=b().filter(A=>A!==e.CONFIGURATION_SYNC_STORE_KEY),E=Object.keys(R.allSettings.properties).filter(A=>y.indexOf(A)===-1),d=y.filter(A=>h.indexOf(A)===-1),O={items:{type:"string",enum:[...E,...d.map(A=>`-${A}`)]}};n.registerSchema(i,O)};return a.onDidUpdateConfiguration(()=>c())}e.registerConfiguration=C;function u(i){return i&&I.isObject(i)&&I.isString(i.id)&&I.isArray(i.scopes)}e.isAuthenticationProvider=u;var D;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Extensions="extensions",i.GlobalState="globalState"})(D=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"],e.IUserDataSyncStoreManagementService=v.createDecorator("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=v.createDecorator("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=v.createDecorator("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";var S;(function(i){i.Unauthorized="Unauthorized",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.NoRef="NoRef",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.UnresolvedConflicts="UnresolvedConflicts",i.Unknown="Unknown"})(S=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class w extends Error{constructor(a,n,c,h){super(a);this.code=n,this.resource=c,this.operationId=h,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=w;class m extends w{constructor(a,n,c,h){super(a,c,void 0,h);this.url=n,this.operationId=h}}e.UserDataSyncStoreError=m;class l extends w{constructor(a,n){super(a,n)}}e.UserDataAutoSyncError=l,function(i){function a(n){if(n instanceof i)return n;const c=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(n.name);if(c&&c[1]){const h=c[2]==="unknown"?void 0:c[2],y=c[3]==="unknown"?void 0:c[3];return new i(n.message,c[1],h,y)}return new i(n.message,S.Unknown)}i.toUserDataSyncError=a}(w=e.UserDataSyncError||(e.UserDataSyncError={}));var o;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(o=e.SyncStatus||(e.SyncStatus={}));var s;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var t;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.IUserDataSyncResourceEnablementService=v.createDecorator("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=v.createDecorator("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=v.createDecorator("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=v.createDecorator("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=v.createDecorator("IUserDataSyncUtilService"),e.IUserDataSyncLogService=v.createDecorator("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function r(i,a){if(i.scheme!==e.USER_DATA_SYNC_SCHEME)return i=i.with({scheme:a.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(n=>p.isEqualOrParent(i,p.joinPath(a.userDataSyncHome,n,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=r}),define(ee[44],te([0,1,2,12,16,7,24,9,18,8,3,23,29,121,26,17,20,19,49,21,28]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u,D,S,w,m,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=void 0;function s(c){return!!(c&&c.version!==void 0&&typeof c.version=="number"&&c.content!==void 0&&typeof c.content=="string"&&(Object.keys(c).length===2||Object.keys(c).length===3&&c.machineId!==void 0&&typeof c.machineId=="string"))}function t(c,h,y){return y.joinPath(h.userDataSyncHome,c,`lastSync${c}.json`)}let r=class extends v.Disposable{constructor(h,y,E,d,O,A,j,z,W,N){super();this.resource=h,this.fileService=y,this.environmentService=E,this.userDataSyncStoreService=O,this.userDataSyncBackupStoreService=A,this.userDataSyncResourceEnablementService=j,this.telemetryService=z,this.logService=W,this.configurationService=N,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new I.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new I.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new g.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new I.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.syncHeaders={},this.syncResourceLogLabel=S.uppercaseFirstLetter(this.resource),this.extUri=this.fileService.hasCapability(E.userDataSyncHome,1024)?p.extUri:p.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(E.userDataSyncHome,h),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,P.PREVIEW_DIR_NAME),this.lastSyncResource=t(h,E,this.extUri),this.currentMachineIdPromise=m.getServiceMachineId(E,y,d)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const h=await this.syncPreviewPromise;this.syncPreviewPromise=null;const y=await this.performSync(h.remoteUserData,h.lastSyncUserData,!0);this.setStatus(y)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const h=await this.getLastSyncUserData();(h?(await this.doGenerateSyncResourcePreview(h,h,!0,o.CancellationToken.None)).resourcePreviews.some(({remoteChange:E})=>E!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(h){if(this._status!==h){const y=this._status;h==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),y==="hasConflicts"&&h==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=h,this._onDidChangStatus.fire(h)}}async sync(h,y={}){await this._sync(h,!0,y)}async preview(h,y={}){return this._sync(h,!1,y)}async apply(h,y={}){try{this.syncHeaders=Object.assign({},y);const E=await this.doApply(h);return this.setStatus(E),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(h,y,E){try{if(this.syncHeaders=Object.assign({},E),!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let d="idle";try{const O=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(h,O);return d=await this.performSync(A,O,y),d==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):d==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(d)}}finally{this.syncHeaders={}}}async replace(h){const y=await this.resolveContent(h);if(!y)return!1;const E=this.parseSyncData(y);if(!E)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const d=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(null,d),A=await this.generateSyncPreview({ref:O.ref,syncData:E},d,o.CancellationToken.None),j=[];for(const z of A){const W=await this.getAcceptResult(z,z.remoteResource,void 0,o.CancellationToken.None),{remoteChange:N}=await this.getAcceptResult(z,z.previewResource,z.remoteContent,o.CancellationToken.None);j.push([z,Object.assign(Object.assign({},W),{remoteChange:N!==0?N:2})])}await this.applyResult(O,d,j,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async getLatestRemoteUserData(h,y){if(y){const E=h&&h.latest?h.latest[this.resource]:void 0;if(y.ref===E||E===void 0&&y.syncData===null)return y}return this.getRemoteUserData(y)}async performSync(h,y,E){if(h.syncData&&h.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new P.UserDataSyncError(C.localize(0,null,this.resource,this.version,h.syncData.version),P.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(h,y,E)}catch(d){if(d instanceof P.UserDataSyncError)switch(d.code){case P.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(h,y,E);case P.UserDataSyncErrorCode.Conflict:case P.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),h=await this.getRemoteUserData(null),y=await this.getLastSyncUserData(),this.performSync(h,y,E)}throw d}}async doSync(h,y,E){try{this.syncPreviewPromise||(this.syncPreviewPromise=g.createCancelablePromise(O=>this.doGenerateSyncResourcePreview(h,y,E,O)));const d=await this.syncPreviewPromise;return this.updateConflicts(d.resourcePreviews),d.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":E?await this.doApply(!1):"syncing"}catch(d){throw this.syncPreviewPromise=null,d}}async merge(h){return await this.updateSyncResourcePreview(h,async y=>{const E=await this.getMergeResult(y,o.CancellationToken.None);await this.fileService.writeFile(y.previewResource,_.VSBuffer.fromString((E==null?void 0:E.content)||""));const d=E&&!E.hasConflicts?await this.getAcceptResult(y,y.previewResource,void 0,o.CancellationToken.None):void 0;return y.acceptResult=d,y.mergeState=E.hasConflicts?"conflict":d?"accepted":"preview",y.localChange=d?d.localChange:E.localChange,y.remoteChange=d?d.remoteChange:E.remoteChange,y}),this.syncPreviewPromise}async accept(h,y){return await this.updateSyncResourcePreview(h,async E=>{const d=await this.getAcceptResult(E,h,y,o.CancellationToken.None);return E.acceptResult=d,E.mergeState="accepted",E.localChange=d.localChange,E.remoteChange=d.remoteChange,E}),this.syncPreviewPromise}async discard(h){return await this.updateSyncResourcePreview(h,async y=>{const E=await this.getMergeResult(y,o.CancellationToken.None);return await this.fileService.writeFile(y.previewResource,_.VSBuffer.fromString(E.content||"")),y.acceptResult=void 0,y.mergeState="preview",y.localChange=E.localChange,y.remoteChange=E.remoteChange,y}),this.syncPreviewPromise}async updateSyncResourcePreview(h,y){if(!!this.syncPreviewPromise){let E=await this.syncPreviewPromise;const d=E.resourcePreviews.findIndex(({localResource:O,remoteResource:A,previewResource:j})=>this.extUri.isEqual(O,h)||this.extUri.isEqual(A,h)||this.extUri.isEqual(j,h));d!==-1&&(this.syncPreviewPromise=g.createCancelablePromise(async O=>{const A=[...E.resourcePreviews];return A[d]=await y(A[d]),Object.assign(Object.assign({},E),{resourcePreviews:A})}),E=await this.syncPreviewPromise,this.updateConflicts(E.resourcePreviews),E.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}}async doApply(h){if(!this.syncPreviewPromise)return"idle";const y=await this.syncPreviewPromise;return y.resourcePreviews.some(({mergeState:E})=>E==="conflict")?"hasConflicts":y.resourcePreviews.some(({mergeState:E})=>E!=="accepted")?"syncing":(await this.applyResult(y.remoteUserData,y.lastSyncUserData,y.resourcePreviews.map(E=>[E,E.acceptResult]),h),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(h){}}updateConflicts(h){const y=h.filter(({mergeState:E})=>E==="conflict");w.equals(this._conflicts,y,(E,d)=>this.extUri.isEqual(E.previewResource,d.previewResource))||(this._conflicts=y,this._onDidChangeConflicts.fire(y))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:y,ref:E})=>({created:y,uri:this.toRemoteBackupResource(E)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:y,ref:E})=>({created:y,uri:this.toLocalBackupResource(E)}))}toRemoteBackupResource(h){return R.URI.from({scheme:P.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${h}`})}toLocalBackupResource(h){return R.URI.from({scheme:P.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${h}`})}async getMachineId({uri:h}){const y=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(y))){const{content:E}=await this.getUserData(y);if(E){const d=this.parseSyncData(E);return d==null?void 0:d.machineId}}}async resolveContent(h){const y=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(y))){const{content:E}=await this.getUserData(y);return E}return this.extUri.isEqual(h,this.toLocalBackupResource(y))?this.userDataSyncBackupStoreService.resolveContent(this.resource,y):null}async resolvePreviewContent(h){const y=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(y)for(const E of y.resourcePreviews){if(this.extUri.isEqual(E.acceptedResource,h))return E.acceptResult?E.acceptResult.content:null;if(this.extUri.isEqual(E.remoteResource,h))return E.remoteContent;if(this.extUri.isEqual(E.localResource,h))return E.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(h){}}async doGenerateSyncResourcePreview(h,y,E,d){var O;const A=await this.currentMachineIdPromise,j=!!((O=h.syncData)===null||O===void 0?void 0:O.machineId)&&h.syncData.machineId===A,z=y===null&&j?h:y,W=await this.generateSyncPreview(h,z,d),N=[];for(const x of W){const F=x.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(x.localChange===0&&x.remoteChange===0)N.push(Object.assign(Object.assign({},x),{acceptedResource:F,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"}));else{const B=E?await this.getMergeResult(x,d):void 0;if(d.isCancellationRequested)break;await this.fileService.writeFile(x.previewResource,_.VSBuffer.fromString((B==null?void 0:B.content)||""));const K=B&&!B.hasConflicts?await this.getAcceptResult(x,x.previewResource,void 0,d):void 0;N.push(Object.assign(Object.assign({},x),{acceptResult:K,mergeState:(B==null?void 0:B.hasConflicts)?"conflict":K?"accepted":"preview",localChange:K?K.localChange:B?B.localChange:x.localChange,remoteChange:K?K.remoteChange:B?B.remoteChange:x.remoteChange}))}}return{remoteUserData:h,lastSyncUserData:y,resourcePreviews:N,isLastSyncFromCurrentMachine:j}}async getLastSyncUserData(){try{const h=await this.fileService.readFile(this.lastSyncResource),y=JSON.parse(h.value.toString()),E=y;if(E.content===null)return{ref:y.ref,syncData:null};const d=JSON.parse(E.content);if(s(d))return Object.assign(Object.assign({},y),{syncData:d,content:void 0})}catch(h){h instanceof k.FileOperationError&&h.fileOperationResult===1||this.logService.error(h)}return null}async updateLastSyncUserData(h,y={}){const E=Object.assign({ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null},y);await this.fileService.writeFile(this.lastSyncResource,_.VSBuffer.fromString(JSON.stringify(E)))}async getRemoteUserData(h){const{ref:y,content:E}=await this.getUserData(h);let d=null;return E!==null&&(d=this.parseSyncData(E)),{ref:y,syncData:d}}parseSyncData(h){try{const y=JSON.parse(h);if(s(y))return y}catch(y){this.logService.error(y)}throw new P.UserDataSyncError(C.localize(1,null),P.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(h){if(D.isString(h)){const y=await this.userDataSyncStoreService.resolveContent(this.resource,h);return{ref:h,content:y}}else{const y=h?{ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,y,this.syncHeaders)}}async updateRemoteUserData(h,y){const E=await this.currentMachineIdPromise,d={version:this.version,machineId:E,content:h};return y=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(d),y,this.syncHeaders),{ref:y,syncData:d}}async backupLocal(h){const y={version:this.version,content:h};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(y))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};r=ge([Y(1,k.IFileService),Y(2,L.IEnvironmentService),Y(3,l.IStorageService),Y(4,P.IUserDataSyncStoreService),Y(5,P.IUserDataSyncBackupStoreService),Y(6,P.IUserDataSyncResourceEnablementService),Y(7,f.ITelemetryService),Y(8,P.IUserDataSyncLogService),Y(9,u.IConfigurationService)],r),e.AbstractSynchroniser=r;let i=class extends r{constructor(h,y,E,d,O,A,j,z,W,N,x){super(y,E,d,O,A,j,z,W,N,x);this.file=h,this._register(this.fileService.watch(this.extUri.dirname(h))),this._register(this.fileService.onDidFilesChange(F=>this.onFileChanges(F)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(h){return null}}async updateLocalFileContent(h,y,E){try{y?await this.fileService.writeFile(this.file,_.VSBuffer.fromString(h),E?void 0:y):await this.fileService.createFile(this.file,_.VSBuffer.fromString(h),{overwrite:E})}catch(d){throw d instanceof k.FileOperationError&&d.fileOperationResult===1||d instanceof k.FileOperationError&&d.fileOperationResult===3?new P.UserDataSyncError(d.message,P.UserDataSyncErrorCode.LocalPreconditionFailed):d}}onFileChanges(h){!h.contains(this.file)||this.triggerLocalChange()}};i=ge([Y(2,k.IFileService),Y(3,L.IEnvironmentService),Y(4,l.IStorageService),Y(5,P.IUserDataSyncStoreService),Y(6,P.IUserDataSyncBackupStoreService),Y(7,P.IUserDataSyncResourceEnablementService),Y(8,f.ITelemetryService),Y(9,P.IUserDataSyncLogService),Y(10,u.IConfigurationService)],i),e.AbstractFileSynchroniser=i;let a=class extends i{constructor(h,y,E,d,O,A,j,z,W,N,x,F){super(h,y,E,d,O,A,j,z,W,N,F);this.userDataSyncUtilService=x,this._formattingOptions=void 0}hasErrors(h){const y=[];return b.parse(h,y,{allowEmptyContent:!0,allowTrailingComma:!0}),y.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};a=ge([Y(2,k.IFileService),Y(3,L.IEnvironmentService),Y(4,l.IStorageService),Y(5,P.IUserDataSyncStoreService),Y(6,P.IUserDataSyncBackupStoreService),Y(7,P.IUserDataSyncResourceEnablementService),Y(8,f.ITelemetryService),Y(9,P.IUserDataSyncLogService),Y(10,P.IUserDataSyncUtilService),Y(11,u.IConfigurationService)],a),e.AbstractJsonFileSynchroniser=a;let n=class{constructor(h,y,E,d){this.resource=h,this.environmentService=y,this.logService=E,this.fileService=d,this.extUri=this.fileService.hasCapability(y.userDataSyncHome,1024)?p.extUri:p.extUriIgnorePathCase,this.lastSyncResource=t(this.resource,y,p.extUri)}async initialize({ref:h,content:y}){if(!y){this.logService.info("Remote content does not exist.",this.resource);return}const E=this.parseSyncData(y);if(!!E){if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:h,syncData:E})}catch(O){this.logService.error(O)}}}parseSyncData(h){try{const y=JSON.parse(h);if(s(y))return y}catch(y){this.logService.error(y)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(h,y={}){const E=Object.assign({ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null},y);await this.fileService.writeFile(this.lastSyncResource,_.VSBuffer.fromString(JSON.stringify(E)))}};n=ge([Y(1,L.IEnvironmentService),Y(2,P.IUserDataSyncLogService),Y(3,k.IFileService)],n),e.AbstractInitializer=n}),define(ee[180],te([0,1,24,3,9,27,33,12,26,176,44,23,7,45,39,20,21,28,78,13,77]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u,D,S,w,m,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function s(n,c){const h=JSON.parse(n.content);if(n.version===1||n.version===2){const y=(await c.getInstalled(0)).filter(E=>E.isBuiltin);for(const E of h)n.version===1&&(E.enabled===!1&&(E.disabled=!0),delete E.enabled),n.version===2&&y.every(d=>!P.areSameExtensions(d.identifier,E.identifier))&&(E.installed=!0)}return h}function t(n,c,h){const y=h.get(P.getExtensionId(n,c),0)||"{}";return JSON.parse(y)}function r(n,c,h,y){y.store(P.getExtensionId(n,c),JSON.stringify(h),0,1)}let i=class nt extends I.AbstractSynchroniser{constructor(c,h,y,E,d,O,A,j,z,W,N,x,F,B){super("extensions",h,c,y,E,d,x,F,z,N);this.storageService=y,this.extensionManagementService=O,this.extensionEnablementService=A,this.ignoredExtensionsManagementService=j,this.extensionGalleryService=W,this.extensionsStorageSyncService=B,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.debounce(k.Event.any(k.Event.filter(this.extensionManagementService.onDidInstallExtension,K=>!!K.gallery),k.Event.filter(this.extensionManagementService.onDidUninstallExtension,K=>!K.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(c,h){const y=c.syncData?await s(c.syncData,this.extensionManagementService):null,E=(h==null?void 0:h.skippedExtensions)||[],d=(h==null?void 0:h.syncData)?await s(h.syncData,this.extensionManagementService):null,O=await this.extensionManagementService.getInstalled(),A=this.getLocalExtensions(O),j=this.ignoredExtensionsManagementService.getIgnoredExtensions(O);y?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{added:z,removed:W,updated:N,remote:x}=g.merge(A,y,d,E,j),F={added:z,removed:W,updated:N,remote:x,content:this.getPreviewContent(A,z,N,W),localChange:z.length>0||W.length>0||N.length>0?2:0,remoteChange:x!==null?2:0};return[{skippedExtensions:E,localResource:this.localResource,localContent:this.format(A),localExtensions:A,remoteResource:this.remoteResource,remoteContent:y?this.format(y):null,previewResource:this.previewResource,previewResult:F,localChange:F.localChange,remoteChange:F.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(c,h,y,E){const d=[...h,...y],O=new Set,A=j=>{O.add(j.id.toLowerCase()),j.uuid&&O.add(j.uuid)};d.forEach(({identifier:j})=>A(j)),E.forEach(A);for(const j of c)O.has(j.identifier.id.toLowerCase())||j.identifier.uuid&&O.has(j.identifier.uuid)||d.push(j);return this.format(d)}async getMergeResult(c,h){return Object.assign(Object.assign({},c.previewResult),{hasConflicts:!1})}async getAcceptResult(c,h,y,E){if(this.extUri.isEqual(h,this.localResource))return this.acceptLocal(c);if(this.extUri.isEqual(h,this.remoteResource))return this.acceptRemote(c);if(this.extUri.isEqual(h,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${h.toString()}`)}async acceptLocal(c){const h=await this.extensionManagementService.getInstalled(),y=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),E=g.merge(c.localExtensions,null,null,c.skippedExtensions,y),{added:d,removed:O,updated:A,remote:j}=E;return{content:c.localContent,added:d,removed:O,updated:A,remote:j,localChange:d.length>0||O.length>0||A.length>0?2:0,remoteChange:j!==null?2:0}}async acceptRemote(c){const h=await this.extensionManagementService.getInstalled(),y=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),E=c.remoteContent?JSON.parse(c.remoteContent):null;if(E!==null){const d=g.merge(c.localExtensions,E,c.localExtensions,[],y),{added:O,removed:A,updated:j,remote:z}=d;return{content:c.remoteContent,added:O,removed:A,updated:j,remote:z,localChange:O.length>0||A.length>0||j.length>0?2:0,remoteChange:z!==null?2:0}}else return{content:c.remoteContent,added:[],removed:[],updated:[],remote:null,localChange:0,remoteChange:0}}async applyResult(c,h,y,E){let{skippedExtensions:d,localExtensions:O}=y[0][0],{added:A,removed:j,updated:z,remote:W,localChange:N,remoteChange:x}=y[0][1];if(N===0&&x===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),N!==0&&(await this.backupLocal(JSON.stringify(O)),d=await this.updateLocalExtensions(A,j,z,d)),W){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const F=JSON.stringify(W);c=await this.updateRemoteUserData(F,E?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions`)}(h==null?void 0:h.ref)!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(c,{skippedExtensions:d}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions`))}async getAssociatedResources({uri:c}){return[{resource:this.extUri.joinPath(c,"extensions.json"),comparableResource:nt.EXTENSIONS_DATA_URI}]}async resolveContent(c){if(this.extUri.isEqual(c,nt.EXTENSIONS_DATA_URI)){const y=await this.extensionManagementService.getInstalled(),E=this.ignoredExtensionsManagementService.getIgnoredExtensions(y),d=this.getLocalExtensions(y).filter(O=>!E.some(A=>P.areSameExtensions({id:A},O.identifier)));return this.format(d)}if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let h=await super.resolveContent(c);if(h)return h;if(h=await super.resolveContent(this.extUri.dirname(c)),h){const y=this.parseSyncData(h);if(y)switch(this.extUri.basename(c)){case"extensions.json":return this.format(this.parseExtensions(y))}}return null}format(c){c.sort((E,d)=>!E.identifier.uuid&&d.identifier.uuid?-1:E.identifier.uuid&&!d.identifier.uuid?1:D.compare(E.identifier.id,d.identifier.id));const h=JSON.stringify(c),y=C.format(h,void 0,{});return u.applyEdits(h,y)}async hasLocalData(){try{const c=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(c).some(y=>y.installed||y.disabled))return!0}catch(c){}return!1}async updateLocalExtensions(c,h,y,E){const d=[],O=[],A=await this.extensionManagementService.getInstalled();if(h.length){const z=A.filter(({identifier:W,isBuiltin:N})=>!N&&h.some(x=>P.areSameExtensions(W,x)));await Promise.all(z.map(async W=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,W.identifier.id),await this.extensionManagementService.uninstall(W,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,W.identifier.id),d.push(W.identifier)}))}(c.length||y.length)&&await Promise.all([...c,...y].map(async z=>{const W=A.find(x=>P.areSameExtensions(x.identifier,z.identifier));if(W&&W.isBuiltin){z.state&&W.manifest.version===z.version&&this.updateExtensionState(z.state,W.manifest.publisher,W.manifest.name,W.manifest.version),z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id),await this.extensionEnablementService.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id),await this.extensionEnablementService.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id)),d.push(z.identifier);return}const N=await this.extensionGalleryService.getCompatibleExtension(z.identifier);if(z.state&&(W?W.manifest.version===z.version:!!N)){const x=W?W.manifest.publisher:N.publisher,F=W?W.manifest.name:N.name;this.updateExtensionState(z.state,x,F,W==null?void 0:W.manifest.version)}if(N)try{z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id,N.version),await this.extensionEnablementService.disableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id,N.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id,N.version),await this.extensionEnablementService.enableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id,N.version)),W||(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,z.identifier.id,N.version),await this.extensionManagementService.installFromGallery(N,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,z.identifier.id,N.version),d.push(N.identifier))}catch(x){O.push(z),this.logService.error(x),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,N.displayName||N.identifier.id)}else O.push(z)}));const j=[];for(const z of E)d.some(W=>P.areSameExtensions(W,z.identifier))||j.push(z);for(const z of O)j.some(W=>P.areSameExtensions(W.identifier,z.identifier))||j.push(z);return j}updateExtensionState(c,h,y,E){const d=t(h,y,this.storageService),O=E?this.extensionsStorageSyncService.getKeysForSync({id:P.getGalleryExtensionId(h,y),version:E}):void 0;O?O.forEach(A=>{d[A]=c[A]}):Object.keys(c).forEach(A=>d[A]=c[A]),r(h,y,d,this.storageService)}parseExtensions(c){return JSON.parse(c.content)}getLocalExtensions(c){const h=this.extensionEnablementService.getDisabledExtensions();return c.map(({identifier:y,isBuiltin:E,manifest:d})=>{const O={identifier:y,version:d.version};h.some(A=>P.areSameExtensions(A,y))&&(O.disabled=!0),E||(O.installed=!0);try{const A=this.extensionsStorageSyncService.getKeysForSync({id:y.id,version:d.version});if(A){const j=t(d.publisher,d.name,this.storageService);O.state=Object.keys(j).reduce((z,W)=>(A.includes(W)&&(z[W]=j[W]),z),{})}}catch(A){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,l.getErrorMessage(A))}return O})}};i.EXTENSIONS_DATA_URI=b.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=ge([Y(0,_.IEnvironmentService),Y(1,L.IFileService),Y(2,S.IStorageService),Y(3,v.IUserDataSyncStoreService),Y(4,v.IUserDataSyncBackupStoreService),Y(5,R.IExtensionManagementService),Y(6,R.IGlobalExtensionEnablementService),Y(7,m.IIgnoredExtensionsManagementService),Y(8,v.IUserDataSyncLogService),Y(9,R.IExtensionGalleryService),Y(10,p.IConfigurationService),Y(11,v.IUserDataSyncResourceEnablementService),Y(12,f.ITelemetryService),Y(13,o.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let a=class extends I.AbstractInitializer{constructor(c,h,y,E,d,O,A,j){super("extensions",A,j,O);this.extensionManagementService=c,this.galleryService=h,this.extensionEnablementService=y,this.storageService=E,this.ignoredExtensionsManagementService=d}async doInitialize(c){const h=c.syncData?await s(c.syncData,this.extensionManagementService):null;if(!h){this.logService.info("Skipping initializing extensions because remote extensions does not exist.");return}await this.initializeRemoteExtensions(h)}async initializeRemoteExtensions(c){const h=[],y=await this.extensionManagementService.getInstalled(),E=new Map,d=[],O={names:[],uuids:[]},A=[];for(const j of c)if(!this.ignoredExtensionsManagementService.hasToNeverSyncExtension(j.identifier.id)){const z=y.find(W=>P.areSameExtensions(W.identifier,j.identifier));z?(d.push({syncExtension:j,installedExtension:z}),j.disabled&&A.push(j.identifier)):j.installed&&(E.set(j.identifier.id.toLowerCase(),j),j.identifier.uuid?O.uuids.push(j.identifier.uuid):O.names.push(j.identifier.id),j.disabled&&A.push(j.identifier))}for(const{syncExtension:j,installedExtension:z}of d)if(j.state){const W=t(z.manifest.publisher,z.manifest.name,this.storageService);Object.keys(j.state).forEach(N=>W[N]=j.state[N]),r(z.manifest.publisher,z.manifest.name,W,this.storageService)}if(A.length)for(const j of A)this.logService.trace("Disabling extension...",j.id),await this.extensionEnablementService.disableExtension(j),this.logService.info("Disabling extension",j.id);if(O.names.length||O.uuids.length){const j=(await this.galleryService.query({ids:O.uuids,names:O.names,pageSize:O.uuids.length+O.names.length},w.CancellationToken.None)).firstPage;for(const z of j)try{const W=E.get(z.identifier.id.toLowerCase());W.state&&r(z.publisher,z.name,W.state,this.storageService),this.logService.trace("Installing extension...",z.identifier.id);const N=await this.extensionManagementService.installFromGallery(z,{isMachineScoped:!1});A.some(x=>P.areSameExtensions(x,z.identifier))||h.push(N),this.logService.info("Installed extension.",z.identifier.id)}catch(W){this.logService.error(W)}}return h}};a=ge([Y(0,R.IExtensionManagementService),Y(1,R.IExtensionGalleryService),Y(2,R.IGlobalExtensionEnablementService),Y(3,S.IStorageService),Y(4,m.IIgnoredExtensionsManagementService),Y(5,L.IFileService),Y(6,_.IEnvironmentService),Y(7,v.IUserDataSyncLogService)],a),e.ExtensionsInitializer=a}),define(ee[181],te([0,1,24,16,3,9,12,50,177,29,44,23,26,7,45,39,21]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const w="globalState.argv.",m=["locale"];let l=class st extends I.AbstractSynchroniser{constructor(t,r,i,a,n,c,h,y,E){super("globalState",t,n,E,r,i,c,h,a,y);this.environmentService=n,this.storageService=E,this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(t.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(_.Event.any(_.Event.filter(t.onDidFilesChange,d=>d.contains(this.environmentService.argvResource)),_.Event.filter(E.onDidChangeValue,d=>d.scope===0&&d.target!==void 0?d.target===0:E.keys(0,0).includes(d.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(t,r,i){const a=t.syncData?JSON.parse(t.syncData.content):null,n=r&&r.syncData?JSON.parse(r.syncData.content):null,c=await this.getLocalGlobalState();a?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const h=this.getStorageKeys(n),{local:y,remote:E}=p.merge(c.storage,a?a.storage:null,n?n.storage:null,h,this.logService),d={content:null,local:y,remote:E,localChange:Object.keys(y.added).length>0||Object.keys(y.updated).length>0||y.removed.length>0?2:0,remoteChange:E!==null?2:0};return[{localResource:this.localResource,localContent:this.format(c),localUserData:c,remoteResource:this.remoteResource,remoteContent:a?this.format(a):null,previewResource:this.previewResource,previewResult:d,localChange:d.localChange,remoteChange:d.remoteChange,acceptedResource:this.acceptedResource,storageKeys:h}]}async getMergeResult(t,r){return Object.assign(Object.assign({},t.previewResult),{hasConflicts:!1})}async getAcceptResult(t,r,i,a){if(this.extUri.isEqual(r,this.localResource))return this.acceptLocal(t);if(this.extUri.isEqual(r,this.remoteResource))return this.acceptRemote(t);if(this.extUri.isEqual(r,this.previewResource))return t.previewResult;throw new Error(`Invalid Resource: ${r.toString()}`)}async acceptLocal(t){return{content:t.localContent,local:{added:{},removed:[],updated:{}},remote:t.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(t){if(t.remoteContent!==null){const r=JSON.parse(t.remoteContent),{local:i,remote:a}=p.merge(t.localUserData.storage,r.storage,null,t.storageKeys,this.logService);return{content:t.remoteContent,local:i,remote:a,localChange:Object.keys(i.added).length>0||Object.keys(i.updated).length>0||i.removed.length>0?2:0,remoteChange:a!==null?2:0}}else return{content:t.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(t,r,i,a){let{localUserData:n}=i[0][0],{local:c,remote:h,localChange:y,remoteChange:E}=i[0][1];if(y===0&&E===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),y!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(n)),await this.writeLocalGlobalState(c),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),E!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const d=JSON.stringify({storage:h});t=await this.updateRemoteUserData(d,a?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}(r==null?void 0:r.ref)!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:t}){return[{resource:this.extUri.joinPath(t,"globalState.json"),comparableResource:st.GLOBAL_STATE_DATA_URI}]}async resolveContent(t){if(this.extUri.isEqual(t,st.GLOBAL_STATE_DATA_URI)){const i=await this.getLocalGlobalState();return this.format(i)}if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i)switch(this.extUri.basename(t)){case"globalState.json":return this.format(JSON.parse(i.content))}}return null}format(t){const r=t.storage?Object.keys(t.storage).sort():[],i={};r.forEach(c=>i[c]=t.storage[c]),t.storage=i;const a=JSON.stringify(t),n=u.format(a,void 0,{});return D.applyEdits(a,n)}async hasLocalData(){var t;try{const{storage:r}=await this.getLocalGlobalState();if(Object.keys(r).length>1||((t=r[`${w}.locale`])===null||t===void 0?void 0:t.value)!=="en")return!0}catch(r){}return!1}async getLocalGlobalState(){const t={},r=await this.getLocalArgvContent(),i=g.parse(r);for(const a of m)i[a]!==void 0&&(t[`${w}${a}`]={version:1,value:i[a]});for(const a of this.storageService.keys(0,0)){const n=this.storageService.get(a,0);n&&(t[a]={version:1,value:n})}return{storage:t}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(t){}return"{}"}async writeLocalGlobalState({added:t,removed:r,updated:i}){const a={},n={},c=(y,E)=>{for(const d of y){if(d.startsWith(w)){a[d.substring(w.length)]=E?E[d].value:void 0;continue}if(E){const O=E[d];O.value!==String(this.storageService.get(d,0))&&(n[d]=O.value)}else this.storageService.get(d,0)!==void 0&&(n[d]=void 0)}};if(c(Object.keys(t),t),c(Object.keys(i),i),c(r),Object.keys(a).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(a),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(n).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const y of Object.keys(n))this.storageService.store(y,n[y],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(n))}}async updateArgv(t){const r=await this.getLocalArgvContent();let i=r;for(const a of Object.keys(t))i=L.edit(i,[a],t[a],{});r!==i&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(i)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(t){const r=this.storageService.keys(0,0),i=this.storageService.keys(0,1),a=[...r,...i],n=(t==null?void 0:t.storage)?Object.keys(t.storage).filter(c=>!c.startsWith(w)&&!a.includes(c)&&this.storageService.get(c,0)!==void 0):[];return{user:r,machine:i,unregistered:n}}};l.GLOBAL_STATE_DATA_URI=C.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),l=ge([Y(0,P.IFileService),Y(1,v.IUserDataSyncStoreService),Y(2,v.IUserDataSyncBackupStoreService),Y(3,v.IUserDataSyncLogService),Y(4,R.IEnvironmentService),Y(5,v.IUserDataSyncResourceEnablementService),Y(6,f.ITelemetryService),Y(7,b.IConfigurationService),Y(8,S.IStorageService)],l),e.GlobalStateSynchroniser=l;let o=class extends I.AbstractInitializer{constructor(t,r,i,a){super("globalState",i,a,r);this.storageService=t}async doInitialize(t){const r=t.syncData?JSON.parse(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const i={},a={};for(const n of Object.keys(r.storage))n.startsWith(w)?i[n.substring(w.length)]=r.storage[n].value:this.storageService.get(n,0)===void 0&&(a[n]=r.storage[n].value);if(Object.keys(i).length){let n="{}";try{n=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(c){}for(const c of Object.keys(i))n=L.edit(n,[c],i[c],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(n))}if(Object.keys(a).length)for(const n of Object.keys(a))this.storageService.store(n,a[n],0,0)}};o=ge([Y(0,S.IStorageService),Y(1,P.IFileService),Y(2,R.IEnvironmentService),Y(3,v.IUserDataSyncLogService)],o),e.GlobalStateInitializer=o}),define(ee[182],te([0,1,12,24,178,29,122,9,26,6,17,19,44,23,21,16,3]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(o,s){const t=JSON.parse(o);if(!s)return I.isUndefined(t.all)?null:t.all;switch(g.OS){case 2:return I.isUndefined(t.mac)?null:t.mac;case 3:return I.isUndefined(t.linux)?null:t.linux;case 1:return I.isUndefined(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=w;let m=class extends b.AbstractJsonFileSynchroniser{constructor(s,t,r,i,a,n,c,h,y,E){super(c.keybindingsResource,"keybindings",n,c,h,s,t,a,E,r,y,i);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(S.Event.filter(i.onDidChangeConfiguration,d=>d.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(s,t,r){const i=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null,a=t?this.getKeybindingsContentFromLastSyncUserData(t):null,n=await this.getLocalFileContent(),c=await this.getFormattingOptions();let h=null,y=!1,E=!1,d=!1;if(i){let A=n?n.value.toString():"[]";if(A=A||"[]",this.hasErrors(A))throw new k.UserDataSyncError(P.localize(0,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!a||a!==A||a!==i){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const j=await _.merge(A,i,a,c,this.userDataSyncUtilService);j.hasChanges&&(h=j.mergeContent,d=j.hasConflicts,y=d||j.mergeContent!==A,E=d||j.mergeContent!==i)}}else n&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),h=n.value.toString(),E=!0);const O={content:h,localChange:y?n?2:1:0,remoteChange:E?2:0,hasConflicts:d};return[{fileContent:n,localResource:this.localResource,localContent:n?n.value.toString():null,localChange:O.localChange,remoteResource:this.remoteResource,remoteContent:i,remoteChange:O.remoteChange,previewResource:this.previewResource,previewResult:O,acceptedResource:this.acceptedResource}]}async getMergeResult(s,t){return s.previewResult}async getAcceptResult(s,t,r,i){if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,r,i){var a;const{fileContent:n}=r[0][0];let{content:c,localChange:h,remoteChange:y}=r[0][1];if(h===0&&y===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.hasErrors(c)))throw new k.UserDataSyncError(P.localize(1,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),n&&await this.backupLocal(this.toSyncContent(n.value.toString())),await this.updateLocalFileContent(c||"[]",n,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),y!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const E=this.toSyncContent(c||"[]",(a=s.syncData)===null||a===void 0?void 0:a.content);s=await this.updateRemoteUserData(E,i?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(E){}(t==null?void 0:t.ref)!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(s,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=R.parse(s.value.toString());if(f.isNonEmptyArray(t))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"keybindings.json"),comparableResource:t}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let t=await super.resolveContent(s);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(s)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(s)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(s.syncData.content)}getKeybindingsContentFromSyncContent(s){try{return w(s,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(s,t){let r={};try{r=JSON.parse(t||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=s,g.OS){case 2:r.mac=s;break;case 3:r.linux=s;break;case 1:r.windows=s;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){let s=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return s!==void 0||(s=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,s!==void 0)?s:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};m=ge([Y(0,k.IUserDataSyncStoreService),Y(1,k.IUserDataSyncBackupStoreService),Y(2,k.IUserDataSyncLogService),Y(3,p.IConfigurationService),Y(4,k.IUserDataSyncResourceEnablementService),Y(5,v.IFileService),Y(6,L.IEnvironmentService),Y(7,u.IStorageService),Y(8,k.IUserDataSyncUtilService),Y(9,C.ITelemetryService)],m),e.KeybindingsSynchroniser=m;let l=class extends b.AbstractInitializer{constructor(s,t,r){super("keybindings",t,r,s)}async doInitialize(s){const t=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,D.VSBuffer.fromString(t)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.environmentService.settingsResource),t=R.parse(s.value.toString());return!f.isNonEmptyArray(t)}catch(s){return s.fileOperationResult===1}}getKeybindingsContentFromSyncContent(s){try{return w(s,!0)}catch(t){return this.logService.error(t),null}}};l=ge([Y(0,v.IFileService),Y(1,L.IEnvironmentService),Y(2,k.IUserDataSyncLogService)],l),e.KeybindingsInitializer=l}),define(ee[183],te([0,1,25,29,39,45,50,24,19]),function(G,e,v,k,_,R,P,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function g(c,h,y){let E=[];y?E=f(y):E=I(h);const d=[],O=[...L.getDisallowedIgnoredSettings()];if(Array.isArray(E))for(const A of E)A.startsWith("-")?O.push(A.substring(1)):d.push(A);return p.distinct([...c,...d].filter(A=>O.indexOf(A)===-1))}e.getIgnoredSettings=g;function I(c){let h=c.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=c.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:c.getValue("settingsSync.ignoredSettings")||[]}function f(c){const h=k.parse(c);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function b(c,h,y,E){if(y.length){const d=n(h),O=k.parse(h),A=k.parse(c),j=[];for(const z of y){const W=O[z],N=A[z];W===void 0?c=P.edit(c,[z],void 0,E):N!==void 0?c=P.edit(c,[z],W,E):j.push(s(z,d))}j.sort((z,W)=>z.startOffset-W.startOffset),j.forEach(z=>c=w(z.setting.key,h,c,E))}return c}e.updateIgnoredSettings=b;function C(c,h,y,E,d,O){const A=b(c,h,E,O),j=y!==A,z=y!==h;if(!j&&!z)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(j&&!z)return{conflictsSettings:[],localContent:null,remoteContent:A,hasConflicts:!1};if(z&&!j)return{conflictsSettings:[],localContent:b(h,c,E,O),remoteContent:null,hasConflicts:!1};if(y===null&&D(c)){const ne=u(c,h,E)?null:b(h,c,E,O);return{conflictsSettings:[],localContent:ne,remoteContent:null,hasConflicts:!1}}let W=c,N=h;const x=k.parse(c),F=k.parse(h),B=y?k.parse(y):null,K=E.reduce((ne,le)=>(ne.add(le),ne),new Set),$=S(x,F,K),T=S(B,x,K),U=S(B,F,K),M=new Map,q=new Set,H=ne=>{q.add(ne);const le=d.filter(({key:me})=>me===ne)[0];le?(W=P.edit(W,[ne],le.value,O),N=P.edit(N,[ne],le.value,O)):M.set(ne,{key:ne,localValue:x[ne],remoteValue:F[ne]})};for(const ne of T.removed.values())U.updated.has(ne)?H(ne):N=P.edit(N,[ne],void 0,O);for(const ne of U.removed.values())q.has(ne)||(T.updated.has(ne)?H(ne):W=P.edit(W,[ne],void 0,O));for(const ne of T.updated.values())q.has(ne)||(U.updated.has(ne)?$.updated.has(ne)&&H(ne):N=P.edit(N,[ne],x[ne],O));for(const ne of U.updated.values())q.has(ne)||(T.updated.has(ne)?$.updated.has(ne)&&H(ne):W=P.edit(W,[ne],F[ne],O));for(const ne of T.added.values())q.has(ne)||(U.added.has(ne)?$.updated.has(ne)&&H(ne):N=w(ne,W,N,O));for(const ne of U.added.values())q.has(ne)||(T.added.has(ne)?$.updated.has(ne)&&H(ne):W=w(ne,N,W,O));const X=M.size>0||!u(W,N,E),Q=X||!u(W,c,[]),Z=X||!u(N,h,[]);return{localContent:Q?W:null,remoteContent:Z?N:null,conflictsSettings:[...M.values()],hasConflicts:X}}e.merge=C;function u(c,h,y){if(c===h)return!0;const E=k.parse(c),d=k.parse(h),O=y.reduce((z,W)=>(z.add(W),z),new Set),A=n(c).filter(z=>!(z.setting&&O.has(z.setting.key))),j=n(h).filter(z=>!(z.setting&&O.has(z.setting.key)));if(A.length!==j.length)return!1;for(let z=0;z<A.length;z++){const W=A[z],N=j[z];if(W.setting&&N.setting){if(W.setting.key!==N.setting.key||!v.equals(E[W.setting.key],d[W.setting.key]))return!1}else if(!W.setting&&!N.setting){if(W.value!==N.value)return!1}else return!1}return!0}e.areSame=u;function D(c){return c?n(c).length===0:!0}e.isEmpty=D;function S(c,h,y){const E=c?Object.keys(c).filter(z=>!y.has(z)):[],d=Object.keys(h).filter(z=>!y.has(z)),O=d.filter(z=>E.indexOf(z)===-1).reduce((z,W)=>(z.add(W),z),new Set),A=E.filter(z=>d.indexOf(z)===-1).reduce((z,W)=>(z.add(W),z),new Set),j=new Set;if(c){for(const z of E)if(!A.has(z)){const W=c[z],N=h[z];v.equals(W,N)||j.add(z)}}return{added:O,removed:A,updated:j}}function w(c,h,y,E){const d=k.parse(h),O=n(h),A=n(y),j=m(c,O,A);return l(y,c,d[c],j,A,E)}e.addSetting=w;function m(c,h,y){const E=h.findIndex(O=>{var A;return((A=O.setting)===null||A===void 0?void 0:A.key)===c}),d=h[E-1];if(d){if(d.setting){const A=s(d.setting.key,y);if(A)return{index:y.indexOf(A),insertAfter:!0}}else{const A=t(E,h);if(A){const j=s(A.setting.key,y);if(j){const z=r(y.indexOf(j),y),W=i(h,A,h[E]);if(z){const N=i(y,j,z),x=a(W,N);return x?{index:y.indexOf(x),insertAfter:!0}:{index:y.indexOf(z),insertAfter:!1}}else{const N=i(y,j,y[y.length-1]),x=a(W,N);return x?{index:y.indexOf(x),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const O=h[E+1];if(O)if(O.setting){const A=s(O.setting.key,y);if(A)return{index:y.indexOf(A),insertAfter:!1}}else{const A=r(E,h);if(A){const j=s(A.setting.key,y);if(j){const z=t(y.indexOf(j),y),W=i(h,h[E],A);if(z){const N=i(y,z,j),x=a(W.reverse(),N.reverse());return x?{index:y.indexOf(x),insertAfter:!1}:{index:y.indexOf(z),insertAfter:!0}}else{const N=i(y,y[0],j),x=a(W.reverse(),N.reverse());return x?{index:y.indexOf(x),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function l(c,h,y,E,d,O){let A;return E.index===-1?A=_.setProperty(c,[h],y,O):A=o(c,h,y,E,d,O).map(j=>_.withFormatting(c,j,O)[0]),_.applyEdits(c,A)}function o(c,h,y,E,d,O){var A;const j=`${JSON.stringify(h)}: ${JSON.stringify(y)}`,z=R.getEOL(O,c),W=d[E.index];if(E.insertAfter){const N=[];if(W.setting)N.push({offset:W.endOffset,length:0,content:","+j});else{const x=r(E.index,d),F=t(E.index,d),B=(A=F==null?void 0:F.setting)===null||A===void 0?void 0:A.commaOffset;F&&B===void 0&&N.push({offset:F.endOffset,length:0,content:","});const K=B!==void 0&&B>W.endOffset;N.push({offset:K?B+1:W.endOffset,length:0,content:x?z+j+",":z+j})}return N}else{if(W.setting)return[{offset:W.startOffset,length:0,content:j+","}];const N=(d[E.index-1]&&!d[E.index-1].setting?z:"")+j+(r(E.index,d)?",":"")+z;return[{offset:W.startOffset,length:0,content:N}]}}function s(c,h){return h.filter(y=>{var E;return((E=y.setting)===null||E===void 0?void 0:E.key)===c})[0]}function t(c,h){for(let y=c-1;y>=0;y--)if(h[y].setting)return h[y]}function r(c,h){for(let y=c+1;y<h.length;y++)if(h[y].setting)return h[y]}function i(c,h,y){const E=c.indexOf(h),d=c.indexOf(y);return c.filter((O,A)=>E<A&&A<d)}function a(c,h){if(c.length&&h.length){let y=0;for(;y<h.length&&y<c.length;y++)if(c[y].value!==h[y].value)return h[y-1];return h[y-1]}}function n(c){const h=[];let y=-1,E,d;const O={onObjectBegin:A=>{y++},onObjectProperty:(A,j,z)=>{y===0&&(E=j,d=A)},onObjectEnd:(A,j)=>{y--,y===0&&h.push({startOffset:E,endOffset:A+j,value:c.substring(E,A+j),setting:{key:d,commaOffset:void 0}})},onArrayBegin:(A,j)=>{y++},onArrayEnd:(A,j)=>{y--,y===0&&h.push({startOffset:E,endOffset:A+j,value:c.substring(E,A+j),setting:{key:d,commaOffset:void 0}})},onLiteralValue:(A,j,z)=>{y===0&&h.push({startOffset:E,endOffset:j+z,value:c.substring(E,j+z),setting:{key:d,commaOffset:void 0}})},onSeparator:(A,j,z)=>{if(y===0&&A===","){let W=h.length-1;for(;W>=0&&!h[W].setting;W--);const N=h[W];N&&h.splice(W,1,{startOffset:N.startOffset,endOffset:N.endOffset,value:N.value,setting:{key:N.setting.key,commaOffset:j}})}},onComment:(A,j)=>{y===0&&h.push({startOffset:A,endOffset:A+j,value:c.substring(A,A+j)})}};return k.visit(c,O),h}}),define(ee[184],te([0,1,12,24,16,123,3,9,26,183,50,44,23,27,21,39]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function S(s){return s&&s.settings&&typeof s.settings=="string"&&Object.keys(s).length===1}function w(s){const t=JSON.parse(s);return S(t)?t:{settings:s}}e.parseSettingsSyncContent=w;let m=class extends f.AbstractJsonFileSynchroniser{constructor(t,r,i,a,n,c,h,y,E,d,O){super(r.settingsResource,"settings",t,r,i,a,n,E,d,c,h,y);this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,i){const a=await this.getLocalFileContent(),n=await this.getFormattingOptions(),c=this.getSettingsSyncContent(t),h=r?this.getSettingsSyncContent(r):null,y=await this.getIgnoredSettings();let E=null,d=!1,O=!1,A=!1;if(c){let z=a?a.value.toString().trim():"{}";z=z||"{}",this.validateContent(z),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const W=g.merge(z,c.settings,h?h.settings:null,y,[],n);E=W.localContent||W.remoteContent,d=W.localContent!==null,O=W.remoteContent!==null,A=W.hasConflicts}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),E=a.value.toString(),O=!0);const j={content:E,localChange:d?2:0,remoteChange:O?2:0,hasConflicts:A};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:j.localChange,remoteResource:this.remoteResource,remoteContent:c?c.settings:null,remoteChange:j.remoteChange,previewResource:this.previewResource,previewResult:j,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();return Object.assign(Object.assign({},t.previewResult),{content:t.previewResult.content?g.updateIgnoredSettings(t.previewResult.content,"{}",a,i):null})}async getAcceptResult(t,r,i,a){const n=await this.getFormattingOptions(),c=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?g.updateIgnoredSettings(t.fileContent.value.toString(),"{}",c,n):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?g.updateIgnoredSettings(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",c,n):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i!==null?g.updateIgnoredSettings(i,t.fileContent?t.fileContent.value.toString():"{}",c,n):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,i,a){const{fileContent:n}=i[0][0];let{content:c,localChange:h,remoteChange:y}=i[0][1];if(h===0&&y===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.validateContent(c),h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),n&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(n.value.toString()))),await this.updateLocalFileContent(c,n,a),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),y!==0){const E=await this.getFormattingOptions(),d=this.getSettingsSyncContent(t),O=await this.getIgnoredSettings(c);c=g.updateIgnoredSettings(c,d?d.settings:"{}",O,E),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(c)),a?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(E){}(r==null?void 0:r.ref)!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),i=I.edit(t.value.toString(),[k.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!g.isEmpty(i)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i){const a=this.parseSettingsSyncContent(i.content);if(a)switch(this.extUri.basename(t)){case"settings.json":return a.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();r=g.updateIgnoredSettings(r,"{}",a,i)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return w(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=P.Event.any(P.Event.filter(this.extensionManagementService.onDidInstallExtension,a=>!!a.gallery),P.Event.filter(this.extensionManagementService.onDidUninstallExtension,a=>!a.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return g.getIgnoredSettings(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new k.UserDataSyncError(R.localize(0,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!o(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let a=i.settings;const n=await this.getFormattingOptions();for(const c in r)if(["version","content","machineId"].indexOf(c)===-1&&r[c]!==void 0){const h=D.setProperty(a,[c],r[c],n);h.length&&(a=D.applyEdits(a,h))}await this.fileService.writeFile(this.file,_.VSBuffer.fromString(a))}catch(t){}}};m=ge([Y(0,v.IFileService),Y(1,L.IEnvironmentService),Y(2,u.IStorageService),Y(3,k.IUserDataSyncStoreService),Y(4,k.IUserDataSyncBackupStoreService),Y(5,k.IUserDataSyncLogService),Y(6,k.IUserDataSyncUtilService),Y(7,p.IConfigurationService),Y(8,k.IUserDataSyncResourceEnablementService),Y(9,b.ITelemetryService),Y(10,C.IExtensionManagementService)],m),e.SettingsSynchroniser=m;let l=class extends f.AbstractInitializer{constructor(t,r,i){super("settings",r,i,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,_.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return g.isEmpty(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return w(t)}catch(r){this.logService.error(r)}return null}};l=ge([Y(0,v.IFileService),Y(1,L.IEnvironmentService),Y(2,k.IUserDataSyncLogService)],l),e.SettingsInitializer=l;function o(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&s.machineId!==void 0&&typeof s.machineId=="string")}}),define(ee[185],te([0,1,24,9,12,26,44,23,16,179,21,25,3]),function(G,e,v,k,_,R,P,L,p,g,I,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let C=class extends P.AbstractSynchroniser{constructor(S,w,m,l,o,s,t,r,i){super("snippets",w,S,m,l,o,r,i,s,t);this.version=1,this.snippetsFolder=S.snippetsHome,this._register(this.fileService.watch(S.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(b.Event.filter(this.fileService.onDidFilesChange,a=>a.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(S,w,m){const l=await this.getSnippetsFileContents(),o=this.toSnippetsContents(l),s=S.syncData?this.parseSnippets(S.syncData):null,t=w&&w.syncData?this.parseSnippets(w.syncData):null;s?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const r=g.merge(o,s,t);return this.getResourcePreviews(r,l,s||{})}async getMergeResult(S,w){return S.previewResult}async getAcceptResult(S,w,m,l){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:S.fileContent?S.fileContent.value.toString():null,localChange:0,remoteChange:S.fileContent?S.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:S.remoteContent,localChange:S.remoteContent!==null?S.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return m===void 0?{content:S.previewResult.content,localChange:S.previewResult.localChange,remoteChange:S.previewResult.remoteChange}:{content:m,localChange:m===null?S.fileContent!==null?3:0:2,remoteChange:m===null?S.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(S,w,m,l){const o=m.map(([s,t])=>Object.assign(Object.assign({},s),{acceptResult:t}));o.every(({localChange:s,remoteChange:t})=>s===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:s})=>s!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,l)),o.some(({remoteChange:s})=>s!==0)&&(S=await this.updateRemoteSnippets(o,S,l)),(w==null?void 0:w.ref)!==S.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(S),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:s}of o)try{await this.fileService.del(s)}catch(t){}}getResourcePreviews(S,w,m){const l=new Map;for(const o of Object.keys(S.local.added)){const s={content:S.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};l.set(o,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(S.local.updated)){const s={content:S.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0};l.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o],localContent:w[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of S.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0};l.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o],localContent:w[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(S.remote.added)){const s={content:S.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1};l.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o],localContent:w[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(S.remote.updated)){const s={content:S.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2};l.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o],localContent:w[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of S.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};l.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of S.conflicts){const s={content:w[o]?w[o].value.toString():null,hasConflicts:!0,localChange:w[o]?2:1,remoteChange:m[o]?2:1};l.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o]||null,localContent:w[o]?w[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(w))if(!l.has(o)){const s={content:w[o]?w[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};l.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o]||null,localContent:w[o]?w[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...l.values()]}async getAssociatedResources({uri:S}){let w=await super.resolveContent(S);if(w){const m=this.parseSyncData(w);if(m){const l=this.parseSnippets(m),o=[];for(const s of Object.keys(l)){const t=this.extUri.joinPath(S,s),r=this.extUri.joinPath(this.snippetsFolder,s),i=await this.fileService.exists(r);o.push({resource:t,comparableResource:i?r:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})})}return o}}return[]}async resolveContent(S){if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(S);let w=await super.resolveContent(S);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(S)),w){const m=this.parseSyncData(w);if(m)return this.parseSnippets(m)[this.extUri.basename(S)]||null}return null}async hasLocalData(){try{const S=await this.getSnippetsFileContents();if(Object.keys(S).length)return!0}catch(S){}return!1}async updateLocalBackup(S){const w={};for(const m of S)m.fileContent&&(w[this.extUri.basename(m.localResource)]=m.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(S,w){for(const{fileContent:m,acceptResult:l,localResource:o,remoteResource:s,localChange:t}of S)if(t!==0){const r=s?this.extUri.basename(s):this.extUri.basename(o),i=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(i)),await this.fileService.del(i),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(i))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(i)),await this.fileService.createFile(i,p.VSBuffer.fromString(l.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(i))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(i)),await this.fileService.writeFile(i,p.VSBuffer.fromString(l.content),w?void 0:m),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(i)))}}async updateRemoteSnippets(S,w,m){const l=w.syncData?this.parseSnippets(w.syncData):{},o=f.deepClone(l);for(const{acceptResult:s,localResource:t,remoteResource:r,remoteChange:i}of S)if(i!==0){const a=t?this.extUri.basename(t):this.extUri.basename(r);i===3?delete o[a]:o[a]=s.content}return g.areSame(l,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(o),m?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(S){return JSON.parse(S.content)}toSnippetsContents(S){const w={};for(const m of Object.keys(S))w[m]=S[m].value.toString();return w}async getSnippetsFileContents(){const S={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(m){if(m instanceof _.FileOperationError&&m.fileOperationResult===1)return S;throw m}for(const m of w.children||[]){const l=m.resource,o=this.extUri.extname(l);if(o===".json"||o===".code-snippets"){const s=this.extUri.relativePath(this.snippetsFolder,l),t=await this.fileService.readFile(l);S[s]=t}}return S}};C=ge([Y(0,k.IEnvironmentService),Y(1,_.IFileService),Y(2,I.IStorageService),Y(3,v.IUserDataSyncStoreService),Y(4,v.IUserDataSyncBackupStoreService),Y(5,v.IUserDataSyncLogService),Y(6,R.IConfigurationService),Y(7,v.IUserDataSyncResourceEnablementService),Y(8,L.ITelemetryService)],C),e.SnippetsSynchroniser=C;let u=class extends P.AbstractInitializer{constructor(S,w,m){super("snippets",w,m,S)}async doInitialize(S){const w=S.syncData?JSON.parse(S.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const l of Object.keys(w)){const o=w[l];if(o){const s=this.extUri.joinPath(this.environmentService.snippetsHome,l);await this.fileService.createFile(s,p.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(s))}}await this.updateLastSyncUserData(S)}async isEmpty(){var S;try{return!((S=(await this.fileService.resolve(this.environmentService.snippetsHome)).children)===null||S===void 0?void 0:S.length)}catch(w){return w.fileOperationResult===1}}};u=ge([Y(0,_.IFileService),Y(1,k.IEnvironmentService),Y(2,v.IUserDataSyncLogService)],u),e.SnippetsInitializer=u}),define(ee[59],te([0,1,5,3,2,24]),function(G,e,v,k,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=v.createDecorator("IUserDataSyncAccountService");let P=class extends _.Disposable{constructor(p){super();this.userDataSyncStoreService=p,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(p.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(p.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(p){(p&&this._account?p.token!==this._account.token||p.authenticationProviderId!==this._account.authenticationProviderId:p!==this._account)&&(this._account=p,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(p))}};P=ge([Y(0,R.IUserDataSyncStoreService)],P),e.UserDataSyncAccountService=P}),define(ee[186],te([0,1,2,24,18,26,12,9,54,16]),function(G,e,v,k,_,R,P,L,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let I=class extends v.Disposable{constructor(b,C,u,D){super();this.environmentService=b,this.fileService=C,this.configurationService=u,this.logService=D,k.ALL_SYNC_RESOURCES.forEach(S=>this.cleanUpBackup(S))}async getAllRefs(b){const C=_.joinPath(this.environmentService.userDataSyncHome,b),u=await this.fileService.resolve(C);return u.children?u.children.filter(S=>S.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(S.name)).sort().reverse().map(S=>({ref:S.name,created:this.getCreationTime(S)})):[]}async resolveContent(b,C){if(!C){const u=await this.getAllRefs(b);u.length&&(C=u[u.length-1].ref)}if(C){const u=_.joinPath(this.environmentService.userDataSyncHome,b,C);return(await this.fileService.readFile(u)).value.toString()}return null}async backup(b,C){const u=_.joinPath(this.environmentService.userDataSyncHome,b),D=_.joinPath(u,`${p.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(D,g.VSBuffer.fromString(C))}catch(S){this.logService.error(S)}try{this.cleanUpBackup(b)}catch(S){}}async cleanUpBackup(b){const C=_.joinPath(this.environmentService.userDataSyncHome,b);try{try{if(!await this.fileService.exists(C))return}catch(D){return}const u=await this.fileService.resolve(C);if(u.children){const D=u.children.filter(l=>l.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(l.name)).sort(),S=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=D.filter(l=>Date.now()-this.getCreationTime(l)>S);const m=D.length-w.length;m<10&&(w=w.slice(10-m)),await Promise.all(w.map(l=>{this.logService.info("Deleting from backup",l.resource.path),this.fileService.del(l.resource)}))}}catch(u){this.logService.error(u)}}getCreationTime(b){return b.ctime||new Date(parseInt(b.name.substring(0,4)),parseInt(b.name.substring(4,6))-1,parseInt(b.name.substring(6,8)),parseInt(b.name.substring(9,11)),parseInt(b.name.substring(11,13)),parseInt(b.name.substring(13,15))).getTime()}};I=ge([Y(0,L.IEnvironmentService),Y(1,P.IFileService),Y(2,R.IConfigurationService),Y(3,k.IUserDataSyncLogService)],I),e.UserDataSyncBackupStoreService=I}),define(ee[187],te([0,1,7]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=e.UserDataSyncChannel=void 0;class k{constructor(b,C,u){this.server=b,this.service=C,this.logService=u}listen(b,C){switch(C){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote}throw new Error(`Event not found: ${C}`)}async call(b,C,u){try{return await this._call(b,C,u)}catch(D){throw this.logService.error(D),D}}_call(b,C,u){switch(C){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"createManualSyncTask":return this.createManualSyncTask();case"replace":return this.service.replace(v.URI.revive(u[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(u[0],v.URI.revive(u[1]),u[2],u[3]);case"resolveContent":return this.service.resolveContent(v.URI.revive(u[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(u[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(u[0]);case"getAssociatedResources":return this.service.getAssociatedResources(u[0],{created:u[1].created,uri:v.URI.revive(u[1].uri)});case"getMachineId":return this.service.getMachineId(u[0],{created:u[1].created,uri:v.URI.revive(u[1].uri)})}throw new Error("Invalid call")}async createManualSyncTask(){const b=await this.service.createManualSyncTask(),C=new _(b,this.logService);return this.server.registerChannel(`manualSyncTask-${b.id}`,C),{id:b.id,manifest:b.manifest,status:b.status}}}e.UserDataSyncChannel=k;class _{constructor(b,C){this.manualSyncTask=b,this.logService=C}listen(b,C){switch(C){case"onSynchronizeResources":return this.manualSyncTask.onSynchronizeResources}throw new Error(`Event not found: ${C}`)}async call(b,C,u){try{return await this._call(b,C,u)}catch(D){throw this.logService.error(D),D}}async _call(b,C,u){switch(C){case"preview":return this.manualSyncTask.preview();case"accept":return this.manualSyncTask.accept(v.URI.revive(u[0]),u[1]);case"merge":return this.manualSyncTask.merge(v.URI.revive(u[0]));case"discard":return this.manualSyncTask.discard(v.URI.revive(u[0]));case"discardConflicts":return this.manualSyncTask.discardConflicts();case"apply":return this.manualSyncTask.apply();case"pull":return this.manualSyncTask.pull();case"push":return this.manualSyncTask.push();case"stop":return this.manualSyncTask.stop();case"_getStatus":return this.manualSyncTask.status;case"dispose":return this.manualSyncTask.dispose()}throw new Error("Invalid call")}}class R{constructor(b){this.service=b}listen(b,C){switch(C){case"onError":return this.service.onError}throw new Error(`Event not found: ${C}`)}call(b,C,u){switch(C){case"triggerSync":return this.service.triggerSync(u[0],u[1],u[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(u[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class P{constructor(b){this.service=b}listen(b,C){throw new Error(`Event not found: ${C}`)}call(b,C,u){switch(C){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(u[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(v.URI.revive(u[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=P;class L{constructor(b){this.channel=b}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(b){return this.channel.call("resolveUserKeybindings",[b])}async resolveFormattingOptions(b){return this.channel.call("resolveFormattingOptions",[b])}}e.UserDataSyncUtilServiceClient=L;class p{constructor(b){this.service=b}listen(b,C){switch(C){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${C}`)}async call(b,C,u){switch(C){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(u[0],u[1]);case"setEnablement":return this.service.setEnablement(u[0],u[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=p;class g{constructor(b){this.service=b}listen(b,C){switch(C){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${C}`)}call(b,C,u){switch(C){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(u)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=g;class I{constructor(b){this.service=b}listen(b,C){switch(C){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${C}`)}call(b,C,u){switch(C){case"switch":return this.service.switch(u[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=I}),define(ee[188],te([0,1,15,9]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let _=class extends v.AbstractLogService{constructor(P,L){super();this.logger=this._register(P.getLogger(L.userDataSyncLogResource))}trace(P,...L){this.logger.trace(P,...L)}debug(P,...L){this.logger.debug(P,...L)}info(P,...L){this.logger.info(P,...L)}warn(P,...L){this.logger.warn(P,...L)}error(P,...L){this.logger.error(P,...L)}critical(P,...L){this.logger.critical(P,...L)}flush(){this.logger.flush()}};_=ge([Y(0,v.ILoggerService),Y(1,k.IEnvironmentService)],_),e.UserDataSyncLogService=_}),define(ee[60],te([0,1,5,2,49,9,12,21,24,126,38,6,20,3]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=v.createDecorator("IUserDataSyncMachinesService");const u="sync.currentMachineName";let D=class qe extends k.Disposable{constructor(w,m,l,o,s,t){super();this.storageService=l,this.userDataSyncStoreService=o,this.logService=s,this.productService=t,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=_.getServiceMachineId(w,m,l)}async getMachines(w){const m=await this.currentMachineIdPromise;return(await this.readMachinesData(w)).machines.map(o=>Object.assign(Object.assign({},o),{isCurrent:o.id===m}))}async addCurrentMachine(w){const m=await this.currentMachineIdPromise,l=await this.readMachinesData(w);l.machines.some(({id:o})=>o===m)||(l.machines.push({id:m,name:this.computeCurrentMachineName(l.machines)}),await this.writeMachinesData(l))}async removeCurrentMachine(w){const m=await this.currentMachineIdPromise,l=await this.readMachinesData(w),o=l.machines.filter(({id:s})=>s!==m);o.length!==l.machines.length&&(l.machines=o,await this.writeMachinesData(l))}async renameMachine(w,m,l){const o=await this.currentMachineIdPromise,s=await this.readMachinesData(l),t=s.machines.find(({id:r})=>r===w);t&&(t.name=m,await this.writeMachinesData(s),s.machines.some(({id:r})=>r===o)&&this.storageService.store(u,m,0,1))}async setEnablement(w,m){const l=await this.readMachinesData(),o=l.machines.find(({id:s})=>s===w);o&&(o.disabled=m?void 0:!0,await this.writeMachinesData(l))}computeCurrentMachineName(w){const m=this.storageService.get(u,0);if(m)return m;const l=`${this.productService.nameLong} (${f.PlatformToString(f.isWeb?0:f.platform)})`,o=new RegExp(`${b.escapeRegExpCharacters(l)}\\s#(\\d+)`);let s=0;for(const t of w){const r=o.exec(t.name),i=r?parseInt(r[1]):0;s=i>s?i:s}return`${l} #${s+1}`}async readMachinesData(w){this.userData=await this.readUserData(w);const m=this.parse(this.userData);if(m.version!==qe.VERSION)throw new Error(g.localize(0,null,this.productService.nameLong));return m}async writeMachinesData(w){var m;const l=JSON.stringify(w),o=await this.userDataSyncStoreService.write(qe.RESOURCE,l,((m=this.userData)===null||m===void 0?void 0:m.ref)||null);this.userData={ref:o,content:l},this._onDidChange.fire()}async readUserData(w){if(this.userData){const m=w&&w.latest?w.latest[qe.RESOURCE]:void 0;if(this.userData.ref===m)return this.userData;if(m===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(qe.RESOURCE,this.userData)}parse(w){if(w.content!==null)try{return JSON.parse(w.content)}catch(m){this.logService.error(m)}return{version:qe.VERSION,machines:[]}}};D.VERSION=1,D.RESOURCE="machines",D=ge([Y(0,R.IEnvironmentService),Y(1,P.IFileService),Y(2,L.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncLogService),Y(5,I.IProductService)],D),e.UserDataSyncMachinesService=D}),define(ee[79],te([0,1,8,3,2,24,59,23,13,21,9,60,124,54,7,18]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const S="sync.enable",w="sync.disableMachineEventually",m="sync.sessionId",l="sync.storeUrl";let o=class extends _.Disposable{constructor(i,a,n){super();this.storageService=i,this.environmentService=a,this.userDataSyncStoreManagementService=n,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(i.onDidChangeValue(c=>this.onDidStorageChange(c)))}isEnabled(i){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(S,0,!!i)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(i){this.storageService.store(S,i,0,1)}onDidStorageChange(i){if(i.scope===0&&S===i.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};o=ge([Y(0,g.IStorageService),Y(1,I.IEnvironmentService),Y(2,R.IUserDataSyncStoreManagementService)],o),e.UserDataAutoSyncEnablementService=o;let s=class extends _.Disposable{constructor(i,a,n,c,h,y,E,d,O,A){var j;super();this.userDataSyncStoreManagementService=i,this.userDataSyncStoreService=a,this.userDataSyncResourceEnablementService=n,this.userDataSyncService=c,this.logService=h,this.userDataSyncAccountService=y,this.telemetryService=E,this.userDataSyncMachinesService=d,this.storageService=O,this.autoSync=this._register(new _.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=A,this.syncTriggerDelayer=this._register(new v.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=(j=i.userDataSyncStore)===null||j===void 0?void 0:j.url,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(i.onDidChangeUserDataSyncStore(()=>{var z,W;D.isEqual(this.syncUrl,(z=i.userDataSyncStore)===null||z===void 0?void 0:z.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=(W=i.userDataSyncStore)===null||W===void 0?void 0:W.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(y.onDidChangeAccount(()=>this.updateAutoSync())),this._register(a.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(c.onDidChangeLocal,(z,W)=>z?[...z,W]:[W],1e3)(z=>this.triggerSync(z,!1,!1))),this._register(k.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,z])=>z)(()=>this.triggerSync(["resourceEnablement"],!1,!1))))}get syncUrl(){const i=this.storageService.get(l,0);return i?u.URI.parse(i):void 0}set syncUrl(i){i?this.storageService.store(l,i.toString(),0,1):this.storageService.remove(l,0)}updateAutoSync(){const{enabled:i,message:a}=this.isAutoSyncEnabled();i?this.autoSync.value===void 0&&(this.autoSync.value=new t(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(n=>this.onDidFinishSync(n))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(a&&this.logService.info(a),this.autoSync.clear()):a&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(a))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${C.toLocalISOString(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(i,a,n){try{this.userDataSyncAccountService.account&&!n&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(m,0),i?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(c){if(a)this.logService.error(c),this.updateEnablement(!1);else throw c}}updateEnablement(i){this.userDataAutoSyncEnablementService.isEnabled()!==i&&(this.telemetryService.publicLog2(S,{enabled:i}),this.userDataAutoSyncEnablementService.setEnablement(i),this.updateAutoSync())}async onDidFinishSync(i){if(!i){this.successiveFailures=0;return}const a=R.UserDataSyncError.toUserDataSyncError(i);a instanceof R.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:a.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),a.code===R.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):a.code===R.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):a.code===R.UserDataSyncErrorCode.LocalTooManyRequests||a.code===R.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):a.code===R.UserDataSyncErrorCode.UpgradeRequired||a.code===R.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):a.code===R.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${a.resource} content with newer version than of client. Requires client upgrade.`)):a.code===R.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${a.resource} content with older version than of client. Requires server reset.`)):a.code===R.UserDataSyncErrorCode.ServiceChanged||a.code===R.UserDataSyncErrorCode.DefaultServiceChanged?(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(a),this.successiveFailures++),this._onError.fire(a)}async disableMachineEventually(){this.storageService.store(w,!0,0,1),await v.timeout(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(w,0,!1)}stopDisableMachineEventually(){this.storageService.remove(w,0)}async triggerSync(i,a,n){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(a&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...i),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",n)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};s=ge([Y(0,R.IUserDataSyncStoreManagementService),Y(1,R.IUserDataSyncStoreService),Y(2,R.IUserDataSyncResourceEnablementService),Y(3,R.IUserDataSyncService),Y(4,R.IUserDataSyncLogService),Y(5,P.IUserDataSyncAccountService),Y(6,L.ITelemetryService),Y(7,f.IUserDataSyncMachinesService),Y(8,g.IStorageService),Y(9,R.IUserDataAutoSyncEnablementService)],s),e.UserDataAutoSyncService=s;class t extends _.Disposable{constructor(i,a,n,c,h,y,E,d){super();this.lastSyncUrl=i,this.interval=a,this.userDataSyncStoreManagementService=n,this.userDataSyncStoreService=c,this.userDataSyncService=h,this.userDataSyncMachinesService=y,this.logService=E,this.storageService=d,this.intervalHandler=this._register(new _.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register(_.toDisposable(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(t.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=v.disposableTimeout(()=>this.sync(t.INTERVAL_SYNCING,!1),this.interval)}sync(i,a){const n=v.createCancelablePromise(async c=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if(p.isPromiseCanceledError(h))return}return this.doSync(i,a,c)});return this.syncPromise=n,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){var i;return this.lastSyncUrl!==void 0&&!D.isEqual(this.lastSyncUrl,(i=this.userDataSyncStoreManagementService.userDataSyncStore)===null||i===void 0?void 0:i.url)}async hasDefaultServiceChanged(){const i=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),a=this.userDataSyncStoreManagementService.userDataSyncStore;return!!a&&!!i&&(!D.isEqual(a.defaultUrl,i.defaultUrl)||!D.isEqual(a.insidersUrl,i.insidersUrl)||!D.isEqual(a.stableUrl,i.stableUrl))}async doSync(i,a,n){this.logService.info(`Auto Sync: Triggered by ${i}`),this._onDidStartSync.fire();let c;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(a),n.isCancellationRequested)return;let h=this.syncTask.manifest;if(h===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new R.UserDataAutoSyncError(b.localize(0,null),R.UserDataSyncErrorCode.DefaultServiceChanged):new R.UserDataAutoSyncError(b.localize(1,null),R.UserDataSyncErrorCode.ServiceChanged):new R.UserDataAutoSyncError(b.localize(2,null),R.UserDataSyncErrorCode.TurnedOff);const y=this.storageService.get(m,0);if(y&&h&&y!==h.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new R.UserDataAutoSyncError(b.localize(3,null),R.UserDataSyncErrorCode.DefaultServiceChanged):new R.UserDataAutoSyncError(b.localize(4,null),R.UserDataSyncErrorCode.ServiceChanged):new R.UserDataAutoSyncError(b.localize(5,null),R.UserDataSyncErrorCode.SessionExpired);const E=await this.userDataSyncMachinesService.getMachines(h||void 0);if(n.isCancellationRequested)return;const d=E.find(O=>O.isCurrent);if(d==null?void 0:d.disabled)throw new R.UserDataAutoSyncError(b.localize(6,null),R.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),h===null&&(h=await this.userDataSyncStoreService.manifest()),h&&h.session!==y&&this.storageService.store(m,h.session,0,1),n.isCancellationRequested)return;d||await this.userDataSyncMachinesService.addCurrentMachine(h||void 0)}catch(h){this.logService.error(h),c=h}this._onDidFinishSync.fire(c)}register(i){return super._register(i)}}t.INTERVAL_SYNCING="Interval"}),define(ee[189],te([0,1,24,2,3,21,23]),function(G,e,v,k,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;const L="sync.enable";function p(I){return`${L}.${I}`}let g=class extends k.Disposable{constructor(f,b){super();this.storageService=f,this.telemetryService=b,this._onDidChangeResourceEnablement=new _.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(f.onDidChangeValue(C=>this.onDidStorageChange(C)))}isResourceEnabled(f){return this.storageService.getBoolean(p(f),0,!0)}setResourceEnablement(f,b){if(this.isResourceEnabled(f)!==b){const C=p(f);this.telemetryService.publicLog2(C,{enabled:b}),this.storageService.store(C,b,0,1)}}onDidStorageChange(f){if(f.scope===0){const b=v.ALL_SYNC_RESOURCES.filter(C=>p(C)===f.key)[0];if(b){this._onDidChangeResourceEnablement.fire([b,this.isResourceEnabled(b)]);return}}}};g=ge([Y(0,R.IStorageService),Y(1,P.ITelemetryService)],g),e.UserDataSyncResourceEnablementService=g}),define(ee[190],te([0,1,24,2,5,3,180,182,181,43,23,19,21,184,18,185,30,8,13]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u,D,S,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const l="sync.lastSyncTime";function o(i){const a={};return a[v.HEADER_EXECUTION_ID]=i,a}let s=class extends k.Disposable{constructor(a,n,c,h,y,E){super();this.userDataSyncStoreService=a,this.userDataSyncStoreManagementService=n,this.instantiationService=c,this.logService=h,this.telemetryService=y,this.storageService=E,this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new R.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new R.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(C.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(L.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(D.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(p.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(P.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(R.Event.any(...this.synchronisers.map(d=>R.Event.map(d.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(R.Event.any(...this.synchronisers.map(d=>R.Event.map(d.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(l,0,void 0),this.onDidChangeLocal=R.Event.any(...this.synchronisers.map(d=>R.Event.map(d.onDidChangeLocal,()=>d.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(a){await this.checkEnablement();const n=S.generateUuid();let c;try{const d=o(n);a&&(d["Cache-Control"]="no-cache"),c=await this.userDataSyncStoreService.manifest(d)}catch(d){const O=v.UserDataSyncError.toUserDataSyncError(d);throw this.reportUserDataSyncError(O,n),O}let h=!1;const y=this;let E;return{manifest:c,run(){if(h)throw new Error("Can run a task only once");return E=w.createCancelablePromise(d=>y.sync(c,n,d)),E.finally(()=>E=void 0)},async stop(){if(E&&E.cancel(),y.status!=="idle")return y.stop()}}}async createManualSyncTask(){await this.checkEnablement();const a=S.generateUuid(),n=o(a);let c;try{c=await this.userDataSyncStoreService.manifest(n)}catch(h){const y=v.UserDataSyncError.toUserDataSyncError(h);throw this.reportUserDataSyncError(y,a),y}return new t(a,c,n,this.synchronisers,this.logService)}async sync(a,n,c){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),!c.isCancellationRequested){const h=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const y=o(n);for(const E of this.synchronisers){if(c.isCancellationRequested)return;try{await E.sync(a,y)}catch(d){this.handleSynchronizerError(d,E.resource),this._syncErrors.push([E.resource,v.UserDataSyncError.toUserDataSyncError(d)])}}this.logService.info(`Sync done. Took ${new Date().getTime()-h}ms`),this.updateLastSyncTime()}catch(y){const E=v.UserDataSyncError.toUserDataSyncError(y);throw this.reportUserDataSyncError(E,n),E}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}}async stop(){if(this.status!=="idle")for(const a of this.synchronisers)try{a.status!=="idle"&&await a.stop()}catch(n){this.logService.error(n)}}async replace(a){await this.checkEnablement();for(const n of this.synchronisers)if(await n.replace(a))return}async accept(a,n,c,h){await this.checkEnablement();const y=this.getSynchroniser(a);await y.accept(n,c),h&&await y.apply(!1,o(S.generateUuid()))}async resolveContent(a){for(const n of this.synchronisers){const c=await n.resolveContent(a);if(c)return c}return null}getRemoteSyncResourceHandles(a){return this.getSynchroniser(a).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(a){return this.getSynchroniser(a).getLocalSyncResourceHandles()}getAssociatedResources(a,n){return this.getSynchroniser(a).getAssociatedResources(n)}getMachineId(a,n){return this.getSynchroniser(a).getMachineId(n)}async hasLocalData(){const a=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const n of a)if(await n.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(a){this.logService.error(a)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(l,0);for(const a of this.synchronisers)try{await a.resetLocal()}catch(n){this.logService.error(`${a.resource}: ${g.toErrorMessage(n)}`),this.logService.error(n)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const a of this.synchronisers)if(await a.hasPreviouslySynced())return!0;return!1}setStatus(a){const n=this._status;this._status!==a&&(this._status=a,this._onDidChangeStatus.fire(a),n==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const a=this.computeStatus();this.setStatus(a)}updateConflicts(){const a=this.computeConflicts();f.equals(this._conflicts,a,([n,c],[h,y])=>n===n&&f.equals(c,y,(E,d)=>u.isEqual(E.previewResource,d.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(a))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(a=>a.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(a=>a.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(l,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}handleSynchronizerError(a,n){if(a instanceof v.UserDataSyncError)switch(a.code){case v.UserDataSyncErrorCode.TooLarge:throw new v.UserDataSyncError(a.message,a.code,n);case v.UserDataSyncErrorCode.TooManyRequests:case v.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case v.UserDataSyncErrorCode.LocalTooManyRequests:case v.UserDataSyncErrorCode.Gone:case v.UserDataSyncErrorCode.UpgradeRequired:case v.UserDataSyncErrorCode.IncompatibleRemoteContent:case v.UserDataSyncErrorCode.IncompatibleLocalContent:throw a}this.logService.error(a),this.logService.error(`${n}: ${g.toErrorMessage(a)}`)}reportUserDataSyncError(a,n){this.telemetryService.publicLog2("sync/error",{code:a.code,url:a instanceof v.UserDataSyncStoreError?a.url:void 0,resource:a.resource,executionId:n,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(a=>a.status==="hasConflicts").map(a=>[a.resource,a.conflicts.map(r)])}getSynchroniser(a){return this.synchronisers.find(n=>n.resource===a)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};s=ge([Y(0,v.IUserDataSyncStoreService),Y(1,v.IUserDataSyncStoreManagementService),Y(2,_.IInstantiationService),Y(3,v.IUserDataSyncLogService),Y(4,I.ITelemetryService),Y(5,b.IStorageService)],s),e.UserDataSyncService=s;class t extends k.Disposable{constructor(a,n,c,h,y){super();this.id=a,this.manifest=n,this.syncHeaders=c,this.synchronisers=h,this.logService=y,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new R.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(a=>a.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(a=>a.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=w.createCancelablePromise(a=>this.getPreviews(a))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(a){throw this.logService.error(a),a}}async accept(a,n){try{return await this.performAction(a,c=>c.accept(a,n))}catch(c){throw this.logService.error(c),c}}async merge(a){try{return a?await this.performAction(a,n=>n.merge(a)):await this.mergeAll()}catch(n){throw this.logService.error(n),n}}async discard(a){try{return await this.performAction(a,n=>n.discard(a))}catch(n){throw this.logService.error(n),n}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const a=[];for(const[,n]of this.previews)for(const c of n.resourcePreviews)c.mergeState==="conflict"&&a.push(c.previewResource);for(const n of a)await this.discard(n);return this.previews}catch(a){throw this.logService.error(a),a}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const a=[];for(const[n,c]of this.previews){this.synchronizingResources.push([n,c.resourcePreviews.map(E=>E.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(E=>E.resource===n);for(const E of c.resourcePreviews)(E.localChange!==0||E.remoteChange!==0)&&E.mergeState==="preview"&&await h.merge(E.previewResource);const y=await h.apply(!1,this.syncHeaders);y&&a.push(this.toSyncResourcePreview(h.resource,y)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(E=>E[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}catch(a){throw this.logService.error(a),a}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,n]of this.previews){this.synchronizingResources.push([a,n.resourcePreviews.map(h=>h.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(h=>h.resource===a);for(const h of n.resourcePreviews)await c.accept(h.remoteResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(h=>h[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,n]of this.previews){this.synchronizingResources.push([a,n.resourcePreviews.map(h=>h.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(h=>h.resource===a);for(const h of n.resourcePreviews)await c.accept(h.localResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(h=>h[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async stop(){for(const a of this.synchronisers)try{await a.stop()}catch(n){m.isPromiseCanceledError(n)||this.logService.error(n)}this.reset()}async performAction(a,n){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const c=this.previews.findIndex(([,z])=>z.resourcePreviews.some(({localResource:W,previewResource:N,remoteResource:x})=>u.isEqual(a,W)||u.isEqual(a,N)||u.isEqual(a,x)));if(c===-1)return this.previews;const[h,y]=this.previews[c],E=y.resourcePreviews.find(({localResource:z,remoteResource:W,previewResource:N})=>u.isEqual(z,a)||u.isEqual(W,a)||u.isEqual(N,a));if(!E)return this.previews;let d=this.synchronizingResources.find(z=>z[0]===h);d||(d=[h,[]],this.synchronizingResources.push(d)),d[1].some(z=>u.isEqual(z,E.localResource))||(d[1].push(E.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const O=this.synchronisers.find(z=>z.resource===this.previews[c][0]),A=await n(O);A?this.previews.splice(c,1,this.toSyncResourcePreview(O.resource,A)):this.previews.splice(c,1);const j=this.synchronizingResources.findIndex(z=>z[0]===h);return this.synchronizingResources[j][1].splice(d[1].findIndex(z=>u.isEqual(z,E.localResource)),1),d[1].length||(this.synchronizingResources.splice(j,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const a=[];for(const[n,c]of this.previews){this.synchronizingResources.push([n,c.resourcePreviews.map(E=>E.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(E=>E.resource===n);let y=c;for(const E of c.resourcePreviews)(E.localChange!==0||E.remoteChange!==0)&&E.mergeState==="preview"&&(y=await h.merge(E.previewResource));y&&a.push(this.toSyncResourcePreview(h.resource,y)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(E=>E[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}async getPreviews(a){const n=[];for(const c of this.synchronisers){if(a.isCancellationRequested)return[];const h=await c.preview(this.manifest,this.syncHeaders);h&&n.push(this.toSyncResourcePreview(c.resource,h))}return n}toSyncResourcePreview(a,n){return[a,{isLastSyncFromCurrentMachine:n.isLastSyncFromCurrentMachine,resourcePreviews:n.resourcePreviews.map(r)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function r(i){return{localResource:i.localResource,previewResource:i.previewResource,remoteResource:i.remoteResource,acceptedResource:i.acceptedResource,localChange:i.localChange,remoteChange:i.remoteChange,mergeState:i.mergeState}}}),define(ee[191],te([0,1,2,24,42,18,28,26,38,49,9,12,21,30,6,3,8,17,7,13]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u,D,S,w,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const o="sync.store.url.type",s="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",a=100,n=1e3*60*5;let c=class extends v.Disposable{constructor(A,j,z){super();this.productService=A,this.configurationService=j,this.storageService=z,this._onDidChangeUserDataSyncStore=this._register(new D.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore()}get userDataSyncStore(){return this._userDataSyncStore}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[k.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(k.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(A,j){A=u.isWeb&&(A==null?void 0:A.web)?Object.assign(Object.assign({},A),A.web):A;const z=Object.assign(Object.assign({},A||{}),j||{});if(z&&w.isString(z.url)&&w.isObject(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(W=>w.isArray(z.authenticationProviders[W].scopes))){const W=z,x=!!W.canSwitch&&!(j==null?void 0:j.url)?this.storageService.get(o,0):void 0,F=(j==null?void 0:j.url)||(x==="insiders"?W.insidersUrl:x==="stable"?W.stableUrl:W.url);return{url:m.URI.parse(F),type:x,defaultType:W.url===W.insidersUrl?"insiders":W.url===W.stableUrl?"stable":void 0,defaultUrl:m.URI.parse(W.url),stableUrl:m.URI.parse(W.stableUrl),insidersUrl:m.URI.parse(W.insidersUrl),canSwitch:!!W.canSwitch&&!(j==null?void 0:j.url),authenticationProviders:Object.keys(W.authenticationProviders).reduce((B,K)=>(B.push({id:K,scopes:W.authenticationProviders[K].scopes}),B),[])}}}};c=ge([Y(0,p.IProductService),Y(1,L.IConfigurationService),Y(2,b.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let h=class extends c{constructor(A,j,z){super(A,j,z);const W=this.storageService.get(s,0);W&&(this.previousConfigurationSyncStore=JSON.parse(W));const N=this.productService[k.CONFIGURATION_SYNC_STORE_KEY];N?this.storageService.store(s,JSON.stringify(N),0,1):this.storageService.remove(s,0)}async switch(A){var j;((j=this.userDataSyncStore)===null||j===void 0?void 0:j.canSwitch)&&A!==this.userDataSyncStore.type&&(A===this.userDataSyncStore.defaultType?this.storageService.remove(o,0):this.storageService.store(o,A,0,1),this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};h=ge([Y(0,p.IProductService),Y(1,L.IConfigurationService),Y(2,b.IStorageService)],h),e.UserDataSyncStoreManagementService=h;let y=class extends v.Disposable{constructor(A,j,z,W,N,x,F){super();this.requestService=z,this.logService=W,this.storageService=F,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new D.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new D.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(A),this.commonHeadersPromise=g.getServiceMachineId(N,x,F).then(B=>{const K={"X-Client-Name":`${j.applicationName}${u.isWeb?"-web":""}`,"X-Client-Version":j.version,"X-Machine-Id":B};return j.commit&&(K["X-Client-Commit"]=j.commit),K}),this.session=new d(a,n,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register(v.toDisposable(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(A,j){this.authToken={token:A,type:j}}updateUserDataSyncStoreUrl(A){this.userDataSyncStoreUrl=A?R.joinPath(A,"v1"):void 0}initDonotMakeRequestsUntil(){const A=this.storageService.getNumber(t,0);A&&Date.now()<A&&this.setDonotMakeRequestsUntil(new Date(A))}setDonotMakeRequestsUntil(A){var j;((j=this._donotMakeRequestsUntil)===null||j===void 0?void 0:j.getTime())!==(A==null?void 0:A.getTime())&&(this._donotMakeRequestsUntil=A,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=S.createCancelablePromise(z=>S.timeout(this._donotMakeRequestsUntil.getTime()-Date.now(),z).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,z=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(A){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=R.joinPath(this.userDataSyncStoreUrl,"resource",A),z={},W=await this.request(j.toString(),{type:"GET",headers:z},[],P.CancellationToken.None);return(await _.asJson(W)||[]).map(({url:x,created:F})=>({ref:R.relativePath(j,j.with({path:x})),created:F*1e3}))}async resolveContent(A,j){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=R.joinPath(this.userDataSyncStoreUrl,"resource",A,j).toString(),W={};W["Cache-Control"]="no-cache";const N=await this.request(z,{type:"GET",headers:W},[],P.CancellationToken.None);return await _.asText(N)}async delete(A){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=R.joinPath(this.userDataSyncStoreUrl,"resource",A).toString(),z={};await this.request(j,{type:"DELETE",headers:z},[],P.CancellationToken.None)}async read(A,j,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=R.joinPath(this.userDataSyncStoreUrl,"resource",A,"latest").toString();z=Object.assign({},z),z["Cache-Control"]="no-cache",j&&(z["If-None-Match"]=j.ref);const N=await this.request(W,{type:"GET",headers:z},[304],P.CancellationToken.None);if(N.res.statusCode===304)return j;const x=N.res.headers.etag;if(!x)throw new k.UserDataSyncStoreError("Server did not return the ref",W,k.UserDataSyncErrorCode.NoRef,N.res.headers[k.HEADER_OPERATION_ID]);const F=await _.asText(N);return{ref:x,content:F}}async write(A,j,z,W={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=R.joinPath(this.userDataSyncStoreUrl,"resource",A).toString();W=Object.assign({},W),W["Content-Type"]="text/plain",z&&(W["If-Match"]=z);const x=await this.request(N,{type:"POST",data:j,headers:W},[],P.CancellationToken.None),F=x.res.headers.etag;if(!F)throw new k.UserDataSyncStoreError("Server did not return the ref",N,k.UserDataSyncErrorCode.NoRef,x.res.headers[k.HEADER_OPERATION_ID]);return F}async manifest(A={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=R.joinPath(this.userDataSyncStoreUrl,"manifest").toString();A=Object.assign({},A),A["Content-Type"]="application/json";const z=await this.request(j,{type:"GET",headers:A},[],P.CancellationToken.None),W=await _.asJson(z),N=this.storageService.get(r,0);return N&&W&&N!==W.session&&this.clearSession(),W===null&&N&&this.clearSession(),W&&this.storageService.store(r,W.session,0,1),W}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const A=R.joinPath(this.userDataSyncStoreUrl,"resource").toString(),j={"Content-Type":"text/plain"};await this.request(A,{type:"DELETE",headers:j},[],P.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(i,0)}async request(A,j,z,W){if(!this.authToken)throw new k.UserDataSyncStoreError("No Auth Token Available",A,k.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new k.UserDataSyncStoreError(`${j.type} request '${A}' failed because of too many requests (429).`,A,k.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const N=await this.commonHeadersPromise;j.headers=Object.assign(Object.assign(Object.assign({},j.headers||{}),N),{"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`}),this.addSessionHeaders(j.headers),this.logService.trace("Sending request to server",{url:A,type:j.type,headers:Object.assign(Object.assign({},j.headers),{authorization:void 0})});let x;try{x=await this.session.request(A,j,W)}catch($){if(!($ instanceof k.UserDataSyncStoreError)){const T=l.isPromiseCanceledError($)?k.UserDataSyncErrorCode.RequestCanceled:l.getErrorMessage($).startsWith("XHR timeout")?k.UserDataSyncErrorCode.RequestTimeout:k.UserDataSyncErrorCode.RequestFailed;$=new k.UserDataSyncStoreError(`Connection refused for the request '${A}'.`,A,T,void 0)}throw this.logService.info("Request failed",A),$}const F=x.res.headers[k.HEADER_OPERATION_ID],B={url:A,status:x.res.statusCode,"execution-id":j.headers[k.HEADER_EXECUTION_ID],"operation-id":F},K=_.isSuccess(x)||x.res.statusCode&&z.indexOf(x.res.statusCode)!==-1;if(K?this.logService.trace("Request succeeded",B):this.logService.info("Request failed",B),x.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new k.UserDataSyncStoreError(`Request '${A}' failed because of Unauthorized (401).`,A,k.UserDataSyncErrorCode.Unauthorized,F);if(this._onTokenSucceed.fire(),x.res.statusCode===409)throw new k.UserDataSyncStoreError(`${j.type} request '${A}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,A,k.UserDataSyncErrorCode.Conflict,F);if(x.res.statusCode===410)throw new k.UserDataSyncStoreError(`${j.type} request '${A}' failed because the requested resource is not longer available (410).`,A,k.UserDataSyncErrorCode.Gone,F);if(x.res.statusCode===412)throw new k.UserDataSyncStoreError(`${j.type} request '${A}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,A,k.UserDataSyncErrorCode.PreconditionFailed,F);if(x.res.statusCode===413)throw new k.UserDataSyncStoreError(`${j.type} request '${A}' failed because of too large payload (413).`,A,k.UserDataSyncErrorCode.TooLarge,F);if(x.res.statusCode===426)throw new k.UserDataSyncStoreError(`${j.type} request '${A}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,A,k.UserDataSyncErrorCode.UpgradeRequired,F);if(x.res.statusCode===429){const $=x.res.headers["retry-after"];throw $?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt($)*1e3)),new k.UserDataSyncStoreError(`${j.type} request '${A}' failed because of too many requests (429).`,A,k.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,F)):new k.UserDataSyncStoreError(`${j.type} request '${A}' failed because of too many requests (429).`,A,k.UserDataSyncErrorCode.TooManyRequests,F)}if(!K)throw new k.UserDataSyncStoreError("Server returned "+x.res.statusCode,A,k.UserDataSyncErrorCode.Unknown,F);return x}addSessionHeaders(A){let j=this.storageService.get(i,0);j===void 0&&(j=C.generateUuid(),this.storageService.store(i,j,0,1)),A["X-Machine-Session-Id"]=j;const z=this.storageService.get(r,0);z!==void 0&&(A["X-User-Session-Id"]=z)}};y=ge([Y(1,p.IProductService),Y(2,_.IRequestService),Y(3,k.IUserDataSyncLogService),Y(4,I.IEnvironmentService),Y(5,f.IFileService),Y(6,b.IStorageService)],y),e.UserDataSyncStoreClient=y;let E=class extends y{constructor(A,j,z,W,N,x,F){var B;super((B=A.userDataSyncStore)===null||B===void 0?void 0:B.url,j,z,W,N,x,F);this._register(A.onDidChangeUserDataSyncStore(()=>{var K;return this.updateUserDataSyncStoreUrl((K=A.userDataSyncStore)===null||K===void 0?void 0:K.url)}))}};E=ge([Y(0,k.IUserDataSyncStoreManagementService),Y(1,p.IProductService),Y(2,_.IRequestService),Y(3,k.IUserDataSyncLogService),Y(4,I.IEnvironmentService),Y(5,f.IFileService),Y(6,b.IStorageService)],E),e.UserDataSyncStoreService=E;class d{constructor(A,j,z,W){this.limit=A,this.interval=j,this.requestService=z,this.logService=W,this.requests=[],this.startTime=void 0}request(A,j,z){if(this.isExpired()&&this.reset(),j.url=A,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new k.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,A,k.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(A),this.requestService.request(j,z)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=d}),define(ee[192],te([0,1,24,3,57,79,59,23,21,60]),function(G,e,v,k,_,R,P,L,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let I=class extends R.UserDataAutoSyncService{constructor(b,C,u,D,S,w,m,l,o,s,t){super(b,C,u,D,w,m,l,o,s,t);this._register(k.Event.debounce(k.Event.any(k.Event.map(S.onDidFocusWindow,()=>"windowFocus"),k.Event.map(S.onDidOpenWindow,()=>"windowOpen")),(r,i)=>r?[...r,i]:[i],1e3)(r=>this.triggerSync(r,!0,!1)))}};I=ge([Y(0,v.IUserDataSyncStoreManagementService),Y(1,v.IUserDataSyncStoreService),Y(2,v.IUserDataSyncResourceEnablementService),Y(3,v.IUserDataSyncService),Y(4,_.INativeHostService),Y(5,v.IUserDataSyncLogService),Y(6,P.IUserDataSyncAccountService),Y(7,L.ITelemetryService),Y(8,g.IUserDataSyncMachinesService),Y(9,p.IStorageService),Y(10,v.IUserDataAutoSyncEnablementService)],I),e.UserDataAutoSyncService=I}),define(ee[193],te([0,1,3,2,8]),function(G,e,v,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:L,onDidFocusWindow:p,getActiveWindowId:g}){super();this.disposables=this._register(new k.DisposableStore),v.Event.latch(v.Event.any(L,p))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=_.createCancelablePromise(()=>g()),(async()=>{try{const f=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:f}catch(f){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(L){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=L}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(ee[194],te([0,1,7,18,5,32]),function(G,e,v,k,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=_.createDecorator("contextService");var P;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function L(b){const C=b;return!!(C&&typeof C=="object"&&typeof C.id=="string"&&Array.isArray(C.folders))}e.isWorkspace=L;function p(b){const C=b;return!!(C&&typeof C=="object"&&v.URI.isUri(C.uri)&&typeof C.name=="string"&&typeof C.toResource=="function")}e.isWorkspaceFolder=p;class g{constructor(C,u,D,S){this._id=C,this._configuration=D,this._ignorePathCasing=S,this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=u}update(C){this._id=C.id,this._configuration=C.configuration,this._ignorePathCasing=C._ignorePathCasing,this.folders=C.folders}get folders(){return this._folders}set folders(C){this._folders=C,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(C){this._configuration=C}getFolder(C){return C&&this._foldersMap.findSubstr(C.with({scheme:C.scheme,authority:C.authority,path:C.path}))||null}updateFoldersMap(){this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing);for(const C of this.folders)this._foldersMap.set(C.uri,C)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=g;class I{constructor(C,u){this.raw=u,this.uri=C.uri,this.index=C.index,this.name=C.name}toResource(C){return k.joinPath(this.uri,C)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=I;function f(b){return new I({uri:b,index:0,name:k.basenameOrAuthority(b)},{uri:b.toString()})}e.toWorkspaceFolder=f}),define(ee[195],te([0,1,5,127,194,7,6,4,18,39,29,14,87,35,162]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const D=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:k.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(z){return(typeof z=="string"?L.extname(z):p.extname(z))===D}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=v.createDecorator("workspacesService");function w(z){return z.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function m(z){return z.hasOwnProperty("folderUri")}e.isRecentFolder=m;function l(z){return z.hasOwnProperty("fileUri")}e.isRecentFile=l;function o(z){const W=z;return typeof(W==null?void 0:W.id)=="string"&&R.URI.isUri(W.uri)}e.isSingleFolderWorkspaceIdentifier=o;function s(z){if(z.configuration)return{id:z.id,configPath:z.configuration};if(z.folders.length===1)return{id:z.id,uri:z.folders[0].uri}}e.toWorkspaceIdentifier=s;function t(z){const W=z;return typeof(W==null?void 0:W.id)=="string"&&R.URI.isUri(W.configPath)}e.isWorkspaceIdentifier=t;function r(z){if(z==null?void 0:z.uri)return{id:z.id,uri:R.URI.revive(z.uri)};if(z==null?void 0:z.configPath)return{id:z.id,configPath:R.URI.revive(z.configPath)}}e.reviveIdentifier=r;function i(z,W){return p.extUriBiasedIgnorePathCase.isEqualOrParent(z,W.untitledWorkspacesHome)}e.isUntitledWorkspace=i;function a(z){return n(z)||c(z)}e.isStoredWorkspaceFolder=a;function n(z){const W=z;return typeof(W==null?void 0:W.path)=="string"&&(!W.name||typeof W.name=="string")}e.isRawFileWorkspaceFolder=n;function c(z){const W=z;return typeof(W==null?void 0:W.uri)=="string"&&(!W.name||typeof W.name=="string")}e.isRawUriWorkspaceFolder=c;function h(z,W,N,x,F=!P.isWindows,B){if(z.scheme!==x.scheme)return{name:N,uri:z.toString(!0)};let K=W?void 0:B.relativePath(x,z);if(K!==void 0)K.length===0?K=".":P.isWindows&&z.scheme===f.Schemas.file&&!F&&(K=K.replace(/\//g,"\\"));else if(z.scheme===f.Schemas.file)K=z.fsPath,P.isWindows&&(K=b.normalizeDriveLetter(K),F&&(K=C.toSlashes(K)));else{if(!B.isEqualAuthority(z.authority,x.authority))return{name:N,uri:z.toString(!0)};K=z.path}return{name:N,path:K}}e.getStoredWorkspaceFolder=h;function y(z,W,N){let x=[],F=new Set;const B=N.dirname(W);for(let K of z){let $=null;if(n(K))K.path&&($=N.resolvePath(B,K.path));else if(c(K))try{$=R.URI.parse(K.uri),$.path[0]!=="/"&&($=$.with({path:"/"+$.path}))}catch(T){console.warn(T)}if($){let T=N.getComparisonKey($);if(!F.has(T)){F.add(T);const U=K.name||N.basenameOrAuthority($);x.push(new _.WorkspaceFolder({uri:$,name:U,index:x.length},K))}}}return x}e.toWorkspaceFolders=y;function E(z,W,N,x,F){let B=d(W,z);const K=F.dirname(W),$=F.dirname(x),T=[],U=O(B.folders);for(const X of B.folders){const Q=n(X)?F.resolvePath(K,X.path):R.URI.parse(X.uri);let Z;N?Z=!1:Z=!n(X)||L.isAbsolute(X.path),T.push(h(Q,Z,X.name,$,U,F))}const M={insertSpaces:!1,tabSize:4,eol:P.isLinux||P.isMacintosh?`
`:`\r
`},q=g.setProperty(z,["folders"],T,M);let H=g.applyEdits(z,q);return B.remoteAuthority===u.getRemoteAuthority(x)&&(H=g.applyEdits(H,g.removeProperty(H,["remoteAuthority"],M))),H}e.rewriteWorkspaceFileForNewLocation=E;function d(z,W){let N=I.parse(W);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(x=>a(x));else throw new Error(`${z} looks like an invalid workspace file.`);return N}function O(z){return P.isWindows?z.some(W=>n(W)&&W.path.indexOf("/")>=0):!0}e.useSlashForPath=O;function A(z,W){const N={workspaces:[],files:[]};if(z){const x=function(B,K){for(let $=0;$<B.length;$++)try{K(B[$],$)}catch(T){W.warn(`Error restoring recent entry ${JSON.stringify(B[$])}: ${T.toString()}. Skip entry.`)}},F=z;Array.isArray(F.workspaces3)&&x(F.workspaces3,(B,K)=>{const $=Array.isArray(F.workspaceLabels)&&F.workspaceLabels[K]||void 0;typeof B=="object"&&typeof B.id=="string"&&typeof B.configURIPath=="string"?N.workspaces.push({label:$,workspace:{id:B.id,configPath:R.URI.parse(B.configURIPath)}}):typeof B=="string"&&N.workspaces.push({label:$,folderUri:R.URI.parse(B)})}),Array.isArray(F.files2)&&x(F.files2,(B,K)=>{const $=Array.isArray(F.fileLabels)&&F.fileLabels[K]||void 0;typeof B=="string"&&N.files.push({label:$,fileUri:R.URI.parse(B)})})}return N}e.restoreRecentlyOpened=A;function j(z){const W={workspaces3:[],files2:[]};let N=!1;const x=[];for(const B of z.workspaces)m(B)?W.workspaces3.push(B.folderUri.toString()):W.workspaces3.push({id:B.workspace.id,configURIPath:B.workspace.configPath.toString()}),x.push(B.label||null),N=N||!!B.label;N&&(W.workspaceLabels=x),N=!1;const F=[];for(const B of z.files)W.files2.push(B.fileUri.toString()),F.push(B.label||null),N=N||!!B.label;return N&&(W.fileLabels=F),W}e.toStoreData=j}),define(ee[196],te([0,1,2,15,21,102,101,150,4,22,9,195,17,8]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;let u=class Ge extends _.AbstractStorageService{constructor(S,w,m){super();this.globalStorageDatabase=S,this.logService=w,this.environmentService=m,this.globalStorage=new P.Storage(this.globalStorageDatabase),this.periodicFlushScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),6e4)),this.runWhenIdleDisposable=void 0,this.registerListeners()}registerListeners(){this._register(this.globalStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S)))}initialize(S){return this.initializePromise||(this.initializePromise=this.doInitialize(S)),this.initializePromise}async doInitialize(S){await Promise.all([this.initializeGlobalStorage(),S?this.initializeWorkspaceStorage(S):Promise.resolve()]),this.periodicFlushScheduler.schedule()}initializeGlobalStorage(){return this.globalStorage.init()}async initializeWorkspaceStorage(S){try{const w=await this.prepareWorkspaceStorageFolder(S),m=!!this.environmentService.extensionTestsLocationURI;L.mark("code/willInitWorkspaceStorage");try{const l=this.createWorkspaceStorage(m?R.SQLiteStorageDatabase.IN_MEMORY_PATH:p.join(w.path,Ge.WORKSPACE_STORAGE_NAME),w.wasCreated?P.StorageHint.STORAGE_DOES_NOT_EXIST:void 0);await l.init();const o=l.getBoolean(_.IS_NEW_KEY);o===void 0?l.set(_.IS_NEW_KEY,w.wasCreated):o&&l.set(_.IS_NEW_KEY,!1)}finally{L.mark("code/didInitWorkspaceStorage")}}catch(w){this.logService.error(`[storage] initializeWorkspaceStorage(): Unable to init workspace storage due to ${w}`)}}createWorkspaceStorage(S,w){const m={logTrace:this.logService.getLevel()===k.LogLevel.Trace?l=>this.logService.trace(l):void 0,logError:l=>this.logService.error(l)};return v.dispose(this.workspaceStorage),v.dispose(this.workspaceStorageListener),this.workspaceStoragePath=S,this.workspaceStorage=new P.Storage(new R.SQLiteStorageDatabase(S,{logging:m}),{hint:w}),this.workspaceStorageListener=this.workspaceStorage.onDidChangeStorage(l=>this.emitDidChangeValue(1,l)),this.workspaceStorage}getWorkspaceStorageFolderPath(S){return p.join(this.environmentService.workspaceStorageHome.fsPath,S.id)}async prepareWorkspaceStorageFolder(S){const w=this.getWorkspaceStorageFolderPath(S);return await g.exists(w)?{path:w,wasCreated:!1}:(await g.mkdirp(w),this.ensureWorkspaceStorageFolderMeta(S),{path:w,wasCreated:!0})}ensureWorkspaceStorageFolderMeta(S){let w;f.isSingleFolderWorkspaceIdentifier(S)?w={folder:S.uri.toString()}:f.isWorkspaceIdentifier(S)&&(w={workspace:S.configPath.toString()}),w&&(async()=>{try{const m=p.join(this.getWorkspaceStorageFolderPath(S),Ge.WORKSPACE_META_NAME);await g.exists(m)||await g.writeFile(m,JSON.stringify(w,void 0,2))}catch(m){this.logService.error(m)}})()}get(S,w,m){return this.getStorage(w).get(S,m)}getBoolean(S,w,m){return this.getStorage(w).getBoolean(S,m)}getNumber(S,w,m){return this.getStorage(w).getNumber(S,m)}doStore(S,w,m){this.getStorage(m).set(S,w)}doRemove(S,w){this.getStorage(w).delete(S)}getStorage(S){return b.assertIsDefined(S===0?this.globalStorage:this.workspaceStorage)}async doFlush(){const S=[];this.globalStorage&&S.push(this.globalStorage.whenFlushed()),this.workspaceStorage&&S.push(this.workspaceStorage.whenFlushed()),await Promise.all(S)}doFlushWhenIdle(){v.dispose(this.runWhenIdleDisposable),this.runWhenIdleDisposable=C.runWhenIdle(()=>{this.flush(),this.periodicFlushScheduler.schedule()})}async close(){this.periodicFlushScheduler.dispose(),v.dispose(this.runWhenIdleDisposable),this.runWhenIdleDisposable=void 0,this.emitWillSaveState(_.WillSaveStateReason.SHUTDOWN),await Promise.all([this.globalStorage.close(),this.workspaceStorage?this.workspaceStorage.close():Promise.resolve()])}async logStorage(){return _.logStorage(this.globalStorage.items,this.workspaceStorage?this.workspaceStorage.items:new Map,this.environmentService.globalStorageHome.fsPath,this.workspaceStoragePath||"")}async migrate(S){if(this.workspaceStoragePath!==R.SQLiteStorageDatabase.IN_MEMORY_PATH){await this.getStorage(1).close();const w=await this.prepareWorkspaceStorageFolder(S),m=p.join(w.path,Ge.WORKSPACE_STORAGE_NAME);return await g.copy(b.assertIsDefined(this.workspaceStoragePath),m),this.createWorkspaceStorage(m).init()}}};u.WORKSPACE_STORAGE_NAME="state.vscdb",u.WORKSPACE_META_NAME="workspace.json",u=ge([Y(1,k.ILogService),Y(2,I.IEnvironmentService)],u),e.NativeStorageService=u}),define(ee[61],te([0,1,107,4,36,8,22,203,204,17]),function(G,e,v,k,_,R,P,L,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=I;function f(s){const t=s.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function b(s){if(s instanceof I)return s;let t;return/end of central directory record signature not found/.test(s.message)&&(t="CorruptZip"),new I(t,s)}function C(s,t,r,i,a,n){const c=k.dirname(t),h=k.join(i,c);if(!h.startsWith(i))return Promise.reject(new Error(v.localize(0,null,t)));const y=k.join(i,t);let E;return n.onCancellationRequested(()=>{E&&E.destroy()}),Promise.resolve(P.mkdirp(h)).then(()=>new Promise((d,O)=>{if(!n.isCancellationRequested)try{E=_.createWriteStream(y,{mode:r}),E.once("close",()=>d()),E.once("error",O),s.once("error",O),s.pipe(E)}catch(A){O(A)}}))}function u(s,t,r,i){let a=R.createCancelablePromise(()=>Promise.resolve()),n=0;return i.onCancellationRequested(()=>{a.cancel(),s.close()}),new Promise((c,h)=>{const y=new R.Sequencer,E=d=>{d.isCancellationRequested||(n++,s.readEntry())};s.once("error",h),s.once("close",()=>a.then(()=>{i.isCancellationRequested||s.entryCount===n?c():h(new I("Incomplete",new Error(v.localize(1,null,n,s.entryCount))))},h)),s.readEntry(),s.on("entry",d=>{if(!i.isCancellationRequested){if(!r.sourcePathRegex.test(d.fileName)){E(i);return}const O=d.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(O)){const z=k.join(t,O);a=R.createCancelablePromise(W=>P.mkdirp(z).then(()=>E(W)).then(void 0,h));return}const A=S(s,d),j=f(d);a=R.createCancelablePromise(z=>y.queue(()=>A.then(W=>C(W,O,j,t,r,z).then(()=>E(z)))).then(null,h))}})})}function D(s,t=!1){return new Promise((r,i)=>{L.open(s,t?{lazyEntries:!0}:void 0,(a,n)=>{a?i(b(a)):r(g.assertIsDefined(n))})})}function S(s,t){return new Promise((r,i)=>{s.openReadStream(t,(a,n)=>{a?i(b(a)):r(g.assertIsDefined(n))})})}function w(s,t){return new Promise((r,i)=>{const a=new p.ZipFile;t.forEach(c=>{c.contents?a.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&a.addFile(c.localPath,c.path)}),a.end();const n=_.createWriteStream(s);a.outputStream.pipe(n),a.outputStream.once("error",i),n.once("error",i),n.once("finish",()=>r(s))})}e.zip=w;function m(s,t,r={},i){const a=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let n=D(s,!0);return r.overwrite&&(n=n.then(c=>P.rimraf(t).then(()=>c))),n.then(c=>u(c,t,{sourcePathRegex:a},i))}e.extract=m;function l(s,t){return D(s).then(r=>new Promise((i,a)=>{r.on("entry",n=>{n.fileName===t&&S(r,n).then(c=>i(c),c=>a(c))}),r.once("close",()=>a(new Error(v.localize(2,null,t))))}))}function o(s,t){return l(s,t).then(r=>new Promise((i,a)=>{const n=[];r.once("error",a),r.on("data",c=>n.push(c)),r.on("end",()=>i(Buffer.concat(n)))}))}e.buffer=o}),define(ee[197],te([0,1,61,112]),function(G,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function _(R){return v.buffer(R,"extension/package.json").then(P=>{try{return JSON.parse(P.toString("utf8"))}catch(L){throw new Error(k.localize(0,null))}})}e.getManifest=_}),define(ee[198],te([0,1,56,2,22,4,15,27,33,8,7,9,131,113,38,61,6,19,14]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u,D,S,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const l="scanningSystem",o="scanningUser",s="extracting",t="deleting",r="renaming";let i=class extends k.Disposable{constructor(n,c,h,y){super();this.beforeRemovingExtension=n,this.logService=c,this.environmentService=h,this.productService=y,this._devSystemExtensionsPath=null,this.systemExtensionsPath=h.builtinExtensionsPath,this.extensionsPath=h.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new g.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(n){const c=[];(n===null||n===0)&&c.push(this.scanSystemExtensions().then(null,h=>Promise.reject(new L.ExtensionManagementError(this.joinErrors(h).message,l)))),(n===null||n===1)&&c.push(this.scanUserExtensions(!0).then(null,h=>Promise.reject(new L.ExtensionManagementError(this.joinErrors(h).message,o))));try{const h=await Promise.all(c);return w.flatten(h)}catch(h){throw this.joinErrors(h)}}async scanUserExtensions(n){this.logService.trace("Started scanning user extensions");let[c,h]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return h=h.filter(y=>!c[new p.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).key()]),n&&(h=p.groupByExtension(h,E=>E.identifier).map(E=>E.sort((d,O)=>v.rcompare(d.manifest.version,O.manifest.version))[0])),this.logService.trace("Scanned user extensions:",h.length),h}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(n,c,h){const y=n.key(),E=R.join(this.extensionsPath,`.${y}`),d=R.join(this.extensionsPath,y);try{await _.rimraf(d)}catch(A){try{await _.rimraf(d)}catch(j){}throw new L.ExtensionManagementError(C.localize(0,null,d,n.id),t)}await this.extractAtLocation(n,c,E,h);try{await this.rename(n,E,d,Date.now()+2*60*1e3),this.logService.info("Renamed to",d)}catch(A){this.logService.info("Rename failed. Deleting from extracted location",E);try{_.rimraf(E)}catch(j){}throw A}let O=null;try{O=await this.scanExtension(y,this.extensionsPath,1)}catch(A){}if(O)return O;throw new Error(C.localize(1,null,this.extensionsPath))}async saveMetadataForLocalExtension(n,c){this.setMetadata(n,c),c.isMachineScoped=c.isMachineScoped||void 0,c.isBuiltin=c.isBuiltin||void 0;const h=R.join(n.location.fsPath,"package.json"),y=await _.readFile(h,"utf8"),{manifest:E}=await this.parseManifest(y);return E.__metadata=c,await _.writeFile(h,JSON.stringify(E,null,"	")),n}getUninstalledExtensions(){return this.withUninstalledExtensions(n=>n)}async withUninstalledExtensions(n){return this.uninstalledFileLimiter.queue(async()=>{let c;try{c=await _.readFile(this.uninstalledPath,"utf8")}catch(E){if(E.code!=="ENOENT")throw E}let h={};if(c)try{h=JSON.parse(c)}catch(E){}const y=n(h);return Object.keys(h).length?await _.writeFile(this.uninstalledPath,JSON.stringify(h)):await _.rimraf(this.uninstalledPath),y})}async removeExtension(n,c){this.logService.trace(`Deleting ${c} extension from disk`,n.identifier.id,n.location.fsPath),await _.rimraf(n.location.fsPath),this.logService.info("Deleted from disk",n.identifier.id,n.location.fsPath)}async removeUninstalledExtension(n){await this.removeExtension(n,"uninstalled"),await this.withUninstalledExtensions(c=>delete c[new p.ExtensionIdentifierWithVersion(n.identifier,n.manifest.version).key()])}async extractAtLocation(n,c,h,y){this.logService.trace(`Started extracting the extension from ${c} to ${h}`);try{await _.rimraf(h)}catch(E){throw new L.ExtensionManagementError(this.joinErrors(E).message,t)}try{await D.extract(c,h,{sourcePath:"extension",overwrite:!0},y),this.logService.info(`Extracted extension to ${h}:`,n.id)}catch(E){try{await _.rimraf(h)}catch(d){}throw new L.ExtensionManagementError(E.message,E instanceof D.ExtractError&&E.type?E.type:s)}}async rename(n,c,h,y){try{await _.rename(c,h)}catch(E){if(S.isWindows&&E&&E.code==="EPERM"&&Date.now()<y)return this.logService.info(`Failed renaming ${c} to ${h} with 'EPERM' error. Trying again...`,n.id),this.rename(n,c,h,y);throw new L.ExtensionManagementError(E.message||C.localize(2,null,c,h),E.code||r)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const n=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return n;const c=this.scanDevSystemExtensions(),[h,y]=await Promise.all([n,c]);return[...h,...y]}async scanExtensionsInDir(n,c){const h=new g.Limiter(10),y=await _.readdir(n);return(await Promise.all(y.map(d=>h.queue(()=>this.scanExtension(d,n,c))))).filter(d=>d&&d.identifier)}async scanExtension(n,c,h){if(h===1&&n.indexOf(".")===0)return null;const y=R.join(c,n);try{const E=await _.readdir(y),{manifest:d,metadata:O}=await this.readManifest(y),A=E.filter(F=>/^readme(\.txt|\.md|)$/i.test(F))[0],j=A?I.URI.file(R.join(y,A)):void 0,z=E.filter(F=>/^changelog(\.txt|\.md|)$/i.test(F))[0],W=z?I.URI.file(R.join(y,z)):void 0,N={id:p.getGalleryExtensionId(d.publisher,d.name)},x={type:h,identifier:N,manifest:d,location:I.URI.file(y),readmeUrl:j,changelogUrl:W,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:h===0};return O&&this.setMetadata(x,O),x}catch(E){return this.logService.trace(E),null}}async scanDefaultSystemExtensions(){const n=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",n.length),n}async scanDevSystemExtensions(){const n=this.getDevSystemExtensionsList();if(n.length){const c=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",c.length),c.filter(h=>n.some(y=>p.areSameExtensions(h.identifier,{id:y})))}else return[]}setMetadata(n,c){n.publisherDisplayName=c.publisherDisplayName||null,n.publisherId=c.publisherId||null,n.identifier.uuid=c.id,n.isMachineScoped=!!c.isMachineScoped,n.isBuiltin=n.type===0||!!c.isBuiltin}async removeUninstalledExtensions(){const n=await this.getUninstalledExtensions(),c=await this.scanAllUserExtensions(),h=new Set;for(const d of c)n[new p.ExtensionIdentifierWithVersion(d.identifier,d.manifest.version).key()]||h.add(d.identifier.id.toLowerCase());const y=p.groupByExtension(c,d=>d.identifier);await Promise.all(y.map(async d=>{const O=d.sort((A,j)=>v.rcompare(A.manifest.version,j.manifest.version))[0];h.has(O.identifier.id.toLowerCase())||await this.beforeRemovingExtension(O)}));const E=c.filter(d=>n[new p.ExtensionIdentifierWithVersion(d.identifier,d.manifest.version).key()]);await Promise.all(E.map(d=>this.removeUninstalledExtension(d)))}async removeOutdatedExtensions(){const n=await this.scanAllUserExtensions(),c=[],h=p.groupByExtension(n,y=>y.identifier);c.push(...w.flatten(h.map(y=>y.sort((E,d)=>v.rcompare(E.manifest.version,d.manifest.version)).slice(1)))),await Promise.all(c.map(y=>this.removeExtension(y,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(n=>n.name)}joinErrors(n){const c=Array.isArray(n)?n:[n];return c.length===1?c[0]instanceof Error?c[0]:new Error(c[0]):c.reduce((h,y)=>new Error(`${h.message}${h.message?",":""}${y instanceof Error?y.message:y}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(m.FileAccess.asFileUri("",G).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(n){const c=[_.readFile(R.join(n,"package.json"),"utf8").then(d=>this.parseManifest(d)),_.readFile(R.join(n,"package.nls.json"),"utf8").then(void 0,d=>d.code!=="ENOENT"?Promise.reject(d):"{}").then(d=>JSON.parse(d))],[{manifest:h,metadata:y},E]=await Promise.all(c);return{manifest:b.localizeManifest(h,E),metadata:y}}parseManifest(n){return new Promise((c,h)=>{try{const y=JSON.parse(n),E=y.__metadata||null;c({manifest:y,metadata:E})}catch(y){h(new Error(C.localize(3,null)))}})}};i=ge([Y(1,P.ILogService),Y(2,f.INativeEnvironmentService),Y(3,u.IProductService)],i),e.ExtensionsScanner=i}),define(ee[199],te([0,1,111,4,22,2,19,61,27,33,9,8,3,56,7,37,6,15,142,43,23,67,18,30,69,5,14,28,197,147,198,148]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u,D,S,w,m,l,o,s,t,r,i,a,n,c,h,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const O="unsetUninstalled",A="downloading",j="validating",z="local",W="unknown";let N=class extends R.Disposable{constructor(F,B,K,$,T,U){super();this.environmentService=F,this.galleryService=B,this.logService=K,this.downloadService=$,this.telemetryService=T,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new b.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new b.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new b.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new b.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const M=this._register(U.createInstance(d.ExtensionsLifecycle));this.extensionsScanner=this._register(U.createInstance(E.ExtensionsScanner,q=>M.postUninstall(q))),this.manifestCache=this._register(new m.ExtensionsManifestCache(F,this)),this.extensionsDownloader=this._register(U.createInstance(y.ExtensionsDownloader)),this._register(R.toDisposable(()=>{this.installingExtensions.forEach(q=>q.cancel()),this.uninstallingExtensions.forEach(q=>q.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(F){this.logService.trace("ExtensionManagementService#zip",F.identifier.id);const B=await this.collectFiles(F),K=await L.zip(t.joinPath(this.environmentService.tmpDir,r.generateUuid()).fsPath,B);return u.URI.file(K)}async unzip(F){return this.logService.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const B=await this.downloadVsix(F),K=k.resolve(B.fsPath);return h.getManifest(K)}async collectFiles(F){const B=async $=>{let T=await _.readdir($);T=T.map(q=>k.join($,q));const U=await Promise.all(T.map(q=>_.stat(q)));let M=Promise.resolve([]);return U.forEach((q,H)=>{const X=T[H];q.isFile()&&(M=M.then(Q=>[...Q,X])),q.isDirectory()&&(M=M.then(Q=>B(X).then(Z=>[...Q,...Z])))}),M};return(await B(F.location.fsPath)).map($=>({path:`extension/${k.relative(F.location.fsPath,$)}`,localPath:$}))}async install(F,B={}){return this.logService.trace("ExtensionManagementService#install",F.toString()),f.createCancelablePromise(async K=>{const $=await this.downloadVsix(F),T=k.resolve($.fsPath),U=await h.getManifest(T),M={id:g.getGalleryExtensionId(U.publisher,U.name)};let q=1;if(U.engines&&U.engines.vscode&&!s.isEngineValid(U.engines.vscode,D.default.version))throw new Error(v.localize(0,null,M.id,D.default.version));const H=new g.ExtensionIdentifierWithVersion(M,U.version),Q=(await this.getInstalled(1)).find(ne=>g.areSameExtensions(M,ne.identifier));if(Q)if(B.isMachineScoped=B.isMachineScoped||Q.isMachineScoped,B.isBuiltin=B.isBuiltin||Q.isBuiltin,q=2,H.equals(new g.ExtensionIdentifierWithVersion(Q.identifier,Q.manifest.version)))try{await this.extensionsScanner.removeExtension(Q,"existing")}catch(ne){throw new Error(v.localize(1,null,U.displayName||U.name))}else C.gt(Q.manifest.version,U.version)&&await this.uninstallExtension(Q);else{const ne=await this.unsetUninstalledAndGetLocal(H);if(ne)try{await this.extensionsScanner.removeExtension(ne,"existing")}catch(le){throw new Error(v.localize(2,null,U.displayName||U.name))}}this.logService.info("Installing the extension:",M.id),this._onInstallExtension.fire({identifier:M,zipPath:T});let Z;try{Z=await this.getGalleryMetadata(g.getGalleryExtensionId(U.publisher,U.name))}catch(ne){}try{const ne=await this.installFromZipPath(H,T,Object.assign(Object.assign({},Z||{}),B),B,q,K);return this.logService.info("Successfully installed the extension:",M.id),ne}catch(ne){throw this.logService.error("Failed to install the extension:",M.id,ne.message),ne}})}async downloadVsix(F){if(F.scheme===n.Schemas.file)return F;if(!this.downloadService)throw new Error("Download service is not available");const B=t.joinPath(this.environmentService.tmpDir,r.generateUuid());return await this.downloadService.download(F,B),B}async installFromZipPath(F,B,K,$,T,U){try{const M=await this.installExtension({zipPath:B,identifierWithVersion:F,metadata:K},U);try{await this.installDependenciesAndPackExtensions(M,void 0,$)}catch(q){P.isNonEmptyArray(M.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",M.identifier.id,q.message),P.isNonEmptyArray(M.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",M.identifier.id,q.message)}return this._onDidInstallExtension.fire({identifier:F,zipPath:B,local:M,operation:T}),M}catch(M){throw this._onDidInstallExtension.fire({identifier:F,zipPath:B,operation:T,error:M}),M}}async canInstall(F){return!0}async installFromGallery(F,B={}){if(!this.galleryService.isEnabled())throw new Error(v.localize(3,null));try{F=await this.checkAndGetCompatibleVersion(F)}catch(T){const U=T&&T.code?T.code:W;throw this.logService.error("Failed to install extension:",F.identifier.id,T?T.message:U),this.reportTelemetry(this.getTelemetryEvent(1),g.getGalleryExtensionTelemetryData(F),void 0,T),T instanceof Error&&(T.name=U),T}const K=new g.ExtensionIdentifierWithVersion(F.identifier,F.version).key();let $=this.installingExtensions.get(K);return $||($=f.createCancelablePromise(T=>this.doInstallFromGallery(F,B,T)),this.installingExtensions.set(K,$),$.finally(()=>this.installingExtensions.delete(K))),$}async doInstallFromGallery(F,B,K){const $=new Date().getTime();let T=1;this.logService.info("Installing extension:",F.identifier.id),this._onInstallExtension.fire({identifier:F.identifier,gallery:F});try{const M=(await this.getInstalled(1)).find(X=>g.areSameExtensions(X.identifier,F.identifier));M&&(T=2);const q=await this.downloadInstallableExtension(F,T);q.metadata.isMachineScoped=B.isMachineScoped||(M==null?void 0:M.isMachineScoped),q.metadata.isBuiltin=B.isBuiltin||(M==null?void 0:M.isBuiltin);const H=await this.installExtension(q,K);try{await this.extensionsDownloader.delete(u.URI.file(q.zipPath))}catch(X){}if(!B.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(H,M,B)}catch(X){try{await this.uninstall(H)}catch(Q){}throw X}return M&&C.neq(M.manifest.version,F.version)&&await this.setUninstalled(M),this.logService.info("Extensions installed successfully:",F.identifier.id),this._onDidInstallExtension.fire({identifier:F.identifier,gallery:F,local:H,operation:T}),this.reportTelemetry(this.getTelemetryEvent(T),g.getGalleryExtensionTelemetryData(F),new Date().getTime()-$,void 0),H}catch(U){const M=U&&U.code?U.code:W;throw this.logService.error("Failed to install extension:",F.identifier.id,U?U.message:M),this._onDidInstallExtension.fire({identifier:F.identifier,gallery:F,operation:T,error:M}),this.reportTelemetry(this.getTelemetryEvent(T),g.getGalleryExtensionTelemetryData(F),new Date().getTime()-$,U),U instanceof Error&&(U.name=M),U}}async checkAndGetCompatibleVersion(F){if(await this.isMalicious(F))throw new p.ExtensionManagementError(v.localize(4,null),p.INSTALL_ERROR_MALICIOUS);const B=await this.galleryService.getCompatibleExtension(F);if(!B)throw new p.ExtensionManagementError(v.localize(5,null,F.identifier.id,D.default.version),p.INSTALL_ERROR_INCOMPATIBLE);return B}async reinstallFromGallery(F){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.galleryService.isEnabled())throw new Error(v.localize(6,null));const B=await this.findGalleryExtension(F);if(!B)throw new Error(v.localize(7,null));await this.setUninstalled(F);try{await this.extensionsScanner.removeUninstalledExtension(F)}catch(K){throw new Error(v.localize(8,null,l.toErrorMessage(K)))}await this.installFromGallery(B)}getTelemetryEvent(F){return F===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(F){const B=await this.getExtensionsReport();return g.getMaliciousExtensionsSet(B).has(F.identifier.id)}async downloadInstallableExtension(F,B){const K={id:F.identifier.uuid,publisherId:F.publisherId,publisherDisplayName:F.publisherDisplayName};let $;try{this.logService.trace("Started downloading extension:",F.identifier.id);const T=await this.extensionsDownloader.downloadExtension(F,B);this.logService.info("Downloaded extension:",F.identifier.id,$),$=T.fsPath}catch(T){throw new p.ExtensionManagementError(this.joinErrors(T).message,A)}try{const T=await h.getManifest($);return{zipPath:$,identifierWithVersion:new g.ExtensionIdentifierWithVersion(F.identifier,T.version),metadata:K}}catch(T){throw new p.ExtensionManagementError(this.joinErrors(T).message,j)}}async installExtension(F,B){try{const K=await this.unsetUninstalledAndGetLocal(F.identifierWithVersion);if(K)return F.metadata?this.extensionsScanner.saveMetadataForLocalExtension(K,F.metadata):K}catch(K){throw S.isMacintosh?new p.ExtensionManagementError(v.localize(9,null),O):new p.ExtensionManagementError(v.localize(10,null),O)}return this.extractAndInstall(F,B)}async unsetUninstalledAndGetLocal(F){return await this.isUninstalled(F)?(this.logService.trace("Removing the extension from uninstalled list:",F.id),await this.unsetUninstalled(F),this.logService.info("Removed the extension from uninstalled list:",F.id),(await this.getInstalled(1)).find($=>new g.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).equals(F))||null):null}async extractAndInstall({zipPath:F,identifierWithVersion:B,metadata:K},$){let T=await this.extensionsScanner.extractUserExtension(B,F,$);return this.logService.info("Installation completed.",B.id),K&&(T=await this.extensionsScanner.saveMetadataForLocalExtension(T,K)),T}async installDependenciesAndPackExtensions(F,B,K){if(!!this.galleryService.isEnabled()){const $=F.manifest.extensionDependencies||[];if(F.manifest.extensionPack)for(const T of F.manifest.extensionPack)B&&B.manifest.extensionPack&&B.manifest.extensionPack.some(U=>g.areSameExtensions({id:U},{id:T}))||$.every(U=>!g.areSameExtensions({id:U},{id:T}))&&$.push(T);if($.length){const T=await this.getInstalled(),U=$.filter(M=>T.every(({identifier:q})=>!g.areSameExtensions(q,{id:M})));if(U.length){const q=(await this.galleryService.query({names:U,pageSize:$.length},c.CancellationToken.None)).firstPage;try{await Promise.all(q.map(H=>this.installFromGallery(H,K)))}catch(H){try{await this.rollback(q)}catch(X){}throw H}}}}}async rollback(F){const K=(await this.getInstalled(1)).filter($=>F.some(T=>new g.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).equals(new g.ExtensionIdentifierWithVersion(T.identifier,T.version))));await Promise.all(K.map($=>this.uninstall($)))}async uninstall(F,B={}){this.logService.trace("ExtensionManagementService#uninstall",F.identifier.id);const K=await this.getInstalled(1),$=K.find(T=>g.areSameExtensions(T.identifier,F.identifier));if(!$)throw new Error(v.localize(11,null,F.manifest.displayName||F.manifest.name));try{await this.checkForDependenciesAndUninstall($,K,B)}catch(T){throw this.joinErrors(T)}}async updateMetadata(F,B){return this.logService.trace("ExtensionManagementService#updateMetadata",F.identifier.id),F=await this.extensionsScanner.saveMetadataForLocalExtension(F,Object.assign(Object.assign({},F.manifest.__metadata||{}),B)),this.manifestCache.invalidate(),F}async updateExtensionScope(F,B){return this.logService.trace("ExtensionManagementService#updateExtensionScope",F.identifier.id),F=await this.extensionsScanner.saveMetadataForLocalExtension(F,Object.assign(Object.assign({},F.manifest.__metadata||{}),{isMachineScoped:B})),this.manifestCache.invalidate(),F}async getGalleryMetadata(F){const B=await this.findGalleryExtensionByName(F);return B?{id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId}:void 0}async findGalleryExtension(F){if(F.identifier.uuid){const B=await this.findGalleryExtensionById(F.identifier.uuid);return B||this.findGalleryExtensionByName(F.identifier.id)}return this.findGalleryExtensionByName(F.identifier.id)}async findGalleryExtensionById(F){return(await this.galleryService.query({ids:[F],pageSize:1},c.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(F){return(await this.galleryService.query({names:[F],pageSize:1},c.CancellationToken.None)).firstPage[0]}joinErrors(F){const B=Array.isArray(F)?F:[F];return B.length===1?B[0]instanceof Error?B[0]:new Error(B[0]):B.reduce((K,$)=>new Error(`${K.message}${K.message?",":""}${$ instanceof Error?$.message:$}`),new Error(""))}async checkForDependenciesAndUninstall(F,B,K){try{await this.preUninstallExtension(F);const $=K.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(F,B);await this.uninstallExtensions(F,$,B,K)}catch($){throw await this.postUninstallExtension(F,new p.ExtensionManagementError($ instanceof Error?$.message:$,z)),$}await this.postUninstallExtension(F)}async uninstallExtensions(F,B,K,$){const T=[F,...B];if(!$.donotCheckDependents)for(const U of T)this.checkForDependents(U,T,K,F);await Promise.all([this.uninstallExtension(F),...B.map(U=>this.doUninstall(U))])}checkForDependents(F,B,K,$){const T=this.getDependents(F,K);if(T.length){const U=T.filter(M=>B.indexOf(M)===-1);if(U.length)throw new Error(this.getDependentsErrorMessage(F,U,$))}}getDependentsErrorMessage(F,B,K){return K===F?B.length===1?v.localize(12,null,K.manifest.displayName||K.manifest.name,B[0].manifest.displayName||B[0].manifest.name):B.length===2?v.localize(13,null,K.manifest.displayName||K.manifest.name,B[0].manifest.displayName||B[0].manifest.name,B[1].manifest.displayName||B[1].manifest.name):v.localize(14,null,K.manifest.displayName||K.manifest.name,B[0].manifest.displayName||B[0].manifest.name,B[1].manifest.displayName||B[1].manifest.name):B.length===1?v.localize(15,null,K.manifest.displayName||K.manifest.name,F.manifest.displayName||F.manifest.name,B[0].manifest.displayName||B[0].manifest.name):B.length===2?v.localize(16,null,K.manifest.displayName||K.manifest.name,F.manifest.displayName||F.manifest.name,B[0].manifest.displayName||B[0].manifest.name,B[1].manifest.displayName||B[1].manifest.name):v.localize(17,null,K.manifest.displayName||K.manifest.name,F.manifest.displayName||F.manifest.name,B[0].manifest.displayName||B[0].manifest.name,B[1].manifest.displayName||B[1].manifest.name)}getAllPackExtensionsToUninstall(F,B,K=[]){if(K.indexOf(F)!==-1)return[];K.push(F);const $=F.manifest.extensionPack?F.manifest.extensionPack:[];if($.length){const T=B.filter(M=>!M.isBuiltin&&$.some(q=>g.areSameExtensions({id:q},M.identifier))),U=[];for(const M of T)U.push(...this.getAllPackExtensionsToUninstall(M,B,K));return[...T,...U]}return[]}getDependents(F,B){return B.filter(K=>K.manifest.extensionDependencies&&K.manifest.extensionDependencies.some($=>g.areSameExtensions({id:$},F.identifier)))}async doUninstall(F){try{await this.preUninstallExtension(F),await this.uninstallExtension(F)}catch(B){throw await this.postUninstallExtension(F,new p.ExtensionManagementError(B instanceof Error?B.message:B,z)),B}await this.postUninstallExtension(F)}async preUninstallExtension(F){if(!await _.exists(F.location.fsPath))throw new Error(v.localize(18,null));this.logService.info("Uninstalling extension:",F.identifier.id),this._onUninstallExtension.fire(F.identifier)}async uninstallExtension(F){let B=this.uninstallingExtensions.get(F.identifier.id);return B||(B=f.createCancelablePromise(async()=>{const K=await this.extensionsScanner.scanUserExtensions(!1);await this.setUninstalled(...K.filter($=>g.areSameExtensions($.identifier,F.identifier)))}),this.uninstallingExtensions.set(F.identifier.id,B),B.finally(()=>this.uninstallingExtensions.delete(F.identifier.id))),B}async postUninstallExtension(F,B){if(B)this.logService.error("Failed to uninstall extension:",F.identifier.id,B.message);else if(this.logService.info("Successfully uninstalled extension:",F.identifier.id),F.identifier.uuid)try{await this.galleryService.reportStatistic(F.manifest.publisher,F.manifest.name,F.manifest.version,"uninstall")}catch($){}this.reportTelemetry("extensionGallery:uninstall",g.getLocalExtensionTelemetryData(F),void 0,B);const K=B?B instanceof p.ExtensionManagementError?B.code:W:void 0;this._onDidUninstallExtension.fire({identifier:F.identifier,error:K})}getInstalled(F=null){return this.extensionsScanner.scanExtensions(F)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(F){return(await this.filterUninstalled(F)).length===1}filterUninstalled(...F){return this.extensionsScanner.withUninstalledExtensions(B=>{const K=[];for(const $ of F)B[$.key()]&&K.push($.key());return K})}setUninstalled(...F){const B=F.map(K=>new g.ExtensionIdentifierWithVersion(K.identifier,K.manifest.version));return this.extensionsScanner.withUninstalledExtensions(K=>(B.forEach($=>K[$.key()]=!0),K))}unsetUninstalled(F){return this.extensionsScanner.withUninstalledExtensions(B=>delete B[F.key()])}getExtensionsReport(){const F=new Date().getTime();return(!this.reportedExtensions||F-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=F),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const F=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${F.length} reported extensions from service`),F}catch(F){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(F,B,K,$){const T=$?$ instanceof p.ExtensionManagementError?$.code:W:void 0;this.telemetryService.publicLogError(F,Object.assign(Object.assign({},B),{success:!$,duration:K,errorcode:T}))}};N=ge([Y(0,I.INativeEnvironmentService),Y(1,p.IExtensionGalleryService),Y(2,w.ILogService),Y(3,a.optional(i.IDownloadService)),Y(4,o.ITelemetryService),Y(5,a.IInstantiationService)],N),e.ExtensionManagementService=N}),define(ee[200],te([0,1,153,205,206,3,31,4,40,30,2,16,97,13,6]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class D{constructor(h){this.socket=h}dispose(){this.socket.destroy()}onData(h){const y=E=>h(f.VSBuffer.wrap(E));return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(h){return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(h){return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(h){if(!this.socket.destroyed)try{this.socket.write(h.buffer)}catch(y){if(y.code==="EPIPE")return;C.onUnexpectedError(y)}}end(){this.socket.end()}drain(){return new Promise((h,y)=>{if(this.socket.bufferSize===0){h();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),h()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.NodeSocket=D;var S;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var w;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(w||(w={}));class m extends I.Disposable{constructor(h,y,E,d){super();this._onDidZlibFlush=this._register(new R.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=h,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=y,this._recordInflateBytes=d,y?(this._zlibInflate=_.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",O=>{console.error(O),C.onUnexpectedError(O),this._onClose.fire()}),this._zlibInflate.on("data",O=>{this._pendingInflateData.push(O)}),E&&(this._zlibInflate.write(E.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=_.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{console.error(O),C.onUnexpectedError(O),this._onClose.fire()}),this._zlibDeflate.on("data",O=>{this._pendingDeflateData.push(O)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new b.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?f.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):f.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this._onData.event(h)}onClose(h){return this._onClose.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){this._totalOutgoingDataBytes+=h.byteLength,this._zlibDeflate?(this._zlibDeflate.write(h.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let y=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,y=y.slice(0,y.length-4),this._isEnded||this._write(f.VSBuffer.wrap(y),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(h,!1)}_write(h,y){let E=2;h.byteLength<126?E+=0:h.byteLength<2**16?E+=2:E+=8;const d=f.VSBuffer.alloc(E);if(y?d.writeUInt8(194,0):d.writeUInt8(130,0),h.byteLength<126)d.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){d.writeUInt8(126,1);let O=1;d.writeUInt8(h.byteLength>>>8&255,++O),d.writeUInt8(h.byteLength>>>0&255,++O)}else{d.writeUInt8(127,1);let O=1;d.writeUInt8(0,++O),d.writeUInt8(0,++O),d.writeUInt8(0,++O),d.writeUInt8(0,++O),d.writeUInt8(h.byteLength>>>24&255,++O),d.writeUInt8(h.byteLength>>>16&255,++O),d.writeUInt8(h.byteLength>>>8&255,++O),d.writeUInt8(h.byteLength>>>0&255,++O)}this._totalOutgoingWireBytes+=d.byteLength+h.byteLength,this.socket.write(f.VSBuffer.concat([d,h]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(h){if(h.byteLength!==0){for(this._totalIncomingWireBytes+=h.byteLength,this._incomingData.acceptChunk(h);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const y=this._incomingData.peek(this._state.readLen),d=(y.readUInt8(0)&128)>>>7,O=y.readUInt8(1),A=(O&128)>>>7,j=O&127;this._state.state=2,this._state.readLen=2+(A?4:0)+(j===126?2:0)+(j===127?8:0),this._state.fin=d,this._state.mask=0}else if(this._state.state===2){const y=this._incomingData.read(this._state.readLen),E=y.readUInt8(1),d=(E&128)>>>7;let O=E&127,A=1;O===126?O=y.readUInt8(++A)*2**8+y.readUInt8(++A):O===127&&(O=y.readUInt8(++A)*0+y.readUInt8(++A)*0+y.readUInt8(++A)*0+y.readUInt8(++A)*0+y.readUInt8(++A)*2**24+y.readUInt8(++A)*2**16+y.readUInt8(++A)*2**8+y.readUInt8(++A));let j=0;d&&(j=y.readUInt8(++A)*2**24+y.readUInt8(++A)*2**16+y.readUInt8(++A)*2**8+y.readUInt8(++A)),this._state.state=3,this._state.readLen=O,this._state.mask=j}else if(this._state.state===3){const y=this._incomingData.read(this._state.readLen);l(y,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(y.buffer)),this._zlibInflate.write(y.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const E=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=E.length,this._onData.fire(f.VSBuffer.wrap(E))})):(this._totalIncomingDataBytes+=y.byteLength,this._onData.fire(y))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await R.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=m;function l(c,h){if(h!==0){let y=c.byteLength>>>2;for(let z=0;z<y;z++){const W=c.readUInt32BE(z*4);c.writeUInt32BE(W^h,z*4)}let E=y*4,d=c.byteLength-E;const O=h>>>24&255,A=h>>>16&255,j=h>>>8&255;d>=1&&c.writeUInt8(c.readUInt8(E)^O,E),d>=2&&c.writeUInt8(c.readUInt8(E+1)^A,E+1),d>=3&&c.writeUInt8(c.readUInt8(E+2)^j,E+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function s(){const c=g.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let h;return e.XDG_RUNTIME_DIR?h=L.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):h=L.join(p.tmpdir(),`vscode-ipc-${c}.sock`),r(h),h}e.createRandomIPCHandle=s;function t(c,h,y){const E=v.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${E}-${y}-${h}-sock`;let d;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?d=L.join(e.XDG_RUNTIME_DIR,`vscode-${E.substr(0,8)}-${y}-${h}.sock`):d=L.join(c,`${y}-${h}.sock`),r(d),d}e.createStaticIPCHandle=t;function r(c){const h=o[u.platform];typeof h=="number"&&c.length>=h&&console.warn(`WARNING: IPC handle "${c}" is longer than ${h} chars, try a shorter --user-data-dir`)}class i extends P.IPCServer{constructor(h){super(i.toClientConnectionEvent(h));this.server=h}static toClientConnectionEvent(h){const y=R.Event.fromNodeEventEmitter(h,"connection");return R.Event.map(y,E=>({protocol:new b.Protocol(new D(E)),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(E,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function a(c){return new Promise((h,y)=>{const E=k.createServer();E.on("error",y),E.listen(c,()=>{E.removeListener("error",y),h(new i(E))})})}e.serve=a;function n(c,h){return new Promise((y,E)=>{const d=k.createConnection(c,()=>{d.removeListener("error",E),y(b.Client.fromSocket(new D(d),h))});d.once("error",E)})}e.connect=n}),define(ee[201],te([0,1,40,91,4,18,81,37,54,14,7,200]),function(G,e,v,k,_,R,P,L,p,g,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataDir=e.parsePathArg=e.parseSearchPort=e.parseExtensionHostPort=e.NativeEnvironmentService=void 0;class b{constructor(l){if(this._args=l,!l.logsPath){const o=p.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");l.logsPath=_.join(this.userDataPath,"logs",o)}this.logsPath=l.logsPath}get args(){return this._args}get appRoot(){return _.dirname(g.FileAccess.asFileUri("",G).fsPath)}get userHome(){return I.URI.file(v.homedir())}get userDataPath(){const l=process.env.VSCODE_PORTABLE;return l?_.join(l,"user-data"):w(this._args,process)}get appSettingsHome(){return I.URI.file(_.join(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(v.tmpdir())}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return R.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return R.joinPath(this.userRoamingDataHome,"sync")}get userDataSyncLogResource(){return I.URI.file(_.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return R.joinPath(I.URI.file(_.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return I.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return I.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return R.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return R.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=process.env.VSCODE_PORTABLE;return l?I.URI.file(_.join(l,"argv.json")):R.joinPath(this.userHome,L.default.dataFolderName,"argv.json")}get snippetsHome(){return R.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this._args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file(_.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return _.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const l=S(this._args["builtin-extensions-dir"],process);return l||_.normalize(_.join(g.FileAccess.asFileUri("",G).fsPath,"..","extensions"))}get extensionsDownloadPath(){const l=S(this._args["extensions-download-dir"],process);return l||_.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const l=S(this._args["extensions-dir"],process);if(l)return l;const o=process.env.VSCODE_EXTENSIONS;if(o)return o;const s=process.env.VSCODE_PORTABLE;return s?_.join(s,"extensions"):R.joinPath(this.userHome,L.default.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this._args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(o=>/^[^:/?#]+?:\/\//.test(o)?I.URI.parse(o):I.URI.file(_.normalize(o)))}get extensionTestsLocationURI(){const l=this._args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?I.URI.parse(l):I.URI.file(_.normalize(l))}get disableExtensions(){if(this._args["disable-extensions"])return!0;const l=this._args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return C(this._args,this.isBuilt)}get debugRenderer(){return!!this._args.debugRenderer}get isBuilt(){return!process.env.VSCODE_DEV}get verbose(){return!!this._args.verbose}get logLevel(){return this._args.log}get sharedIPCHandle(){return f.createStaticIPCHandle(this.userDataPath,"shared",L.default.version)}get serviceMachineIdResource(){return R.joinPath(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this._args["crash-reporter-id"]}get crashReporterDirectory(){return this._args["crash-reporter-directory"]}get driverHandle(){return this._args.driver}get telemetryLogResource(){return I.URI.file(_.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this._args["disable-telemetry"]}}ge([P.memoize],b.prototype,"appRoot",null),ge([P.memoize],b.prototype,"userHome",null),ge([P.memoize],b.prototype,"userDataPath",null),ge([P.memoize],b.prototype,"appSettingsHome",null),ge([P.memoize],b.prototype,"tmpDir",null),ge([P.memoize],b.prototype,"userRoamingDataHome",null),ge([P.memoize],b.prototype,"settingsResource",null),ge([P.memoize],b.prototype,"userDataSyncHome",null),ge([P.memoize],b.prototype,"userDataSyncLogResource",null),ge([P.memoize],b.prototype,"sync",null),ge([P.memoize],b.prototype,"machineSettingsResource",null),ge([P.memoize],b.prototype,"globalStorageHome",null),ge([P.memoize],b.prototype,"workspaceStorageHome",null),ge([P.memoize],b.prototype,"keybindingsResource",null),ge([P.memoize],b.prototype,"keyboardLayoutResource",null),ge([P.memoize],b.prototype,"argvResource",null),ge([P.memoize],b.prototype,"snippetsHome",null),ge([P.memoize],b.prototype,"isExtensionDevelopment",null),ge([P.memoize],b.prototype,"untitledWorkspacesHome",null),ge([P.memoize],b.prototype,"installSourcePath",null),ge([P.memoize],b.prototype,"builtinExtensionsPath",null),ge([P.memoize],b.prototype,"extensionsPath",null),ge([P.memoize],b.prototype,"extensionDevelopmentLocationURI",null),ge([P.memoize],b.prototype,"extensionTestsLocationURI",null),ge([P.memoize],b.prototype,"debugExtensionHost",null),ge([P.memoize],b.prototype,"sharedIPCHandle",null),ge([P.memoize],b.prototype,"serviceMachineIdResource",null),ge([P.memoize],b.prototype,"telemetryLogResource",null),e.NativeEnvironmentService=b;function C(m,l){return D(m["inspect-extensions"],m["inspect-brk-extensions"],5870,l,m.debugId)}e.parseExtensionHostPort=C;function u(m,l){return D(m["inspect-search"],m["inspect-brk-search"],5876,l)}e.parseSearchPort=u;function D(m,l,o,s,t){const i=Number(l||m)||(s?null:o),a=i?Boolean(!!l):!1;return{port:i,break:a,debugId:t}}function S(m,l){if(!!m){const o=_.resolve(m);return _.normalize(m)===o?o:_.resolve(l.env.VSCODE_CWD||l.cwd(),m)}}e.parsePathArg=S;function w(m,l){return S(m["user-data-dir"],l)||_.resolve(k.getDefaultUserDataPath())}e.parseUserDataDir=w}),define(ee[207],te([0,1,37,36,40,208,100,31,74,68,144,9,201,130,27,199,169,26,161,42,163,23,58,167,172,173,175,48,15,156,152,55,2,164,69,159,158,140,139,145,75,168,149,12,151,14,38,24,190,191,187,57,157,188,192,196,171,21,166,189,59,186,170,60,70,132,193,174,79,78,77,5,146,141,13,43]),function(G,e,v,k,_,R,P,L,p,g,I,f,b,C,u,D,S,w,m,l,o,s,t,r,i,a,n,c,h,y,E,d,O,A,j,z,W,N,x,F,B,K,$,T,U,M,q,H,X,Q,Z,ne,le,me,se,ce,fe,ye,De,Le,Ce,Ae,Re,_e,Me,Ve,Ne,We,J,re,oe,Se,V,ie,ae,ue){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends O.Disposable{constructor(he){super();this.configuration=he,this.server=this._register(new P.Server),R.gracefulify(k),this.registerListeners()}registerListeners(){const he=()=>this.dispose();process.once("exit",he),c.ipcRenderer.once("vscode:electron-main->shared-process=exit",he)}async open(){const he=await this.initServices();H.registerConfiguration(),he.invokeFunction(Ee=>{const Ie=Ee.get(h.ILogService);Ie.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ee),this.registerErrorHandler(Ie)}),this._register(O.combinedDisposable(new z.NodeCachedDataCleaner(this.configuration.nodeCachedDataDir),he.createInstance(W.LanguagePackCachedDataCleaner),he.createInstance(N.StorageDataCleaner,this.configuration.backupWorkspacesPath),he.createInstance(x.LogsDataCleaner),he.createInstance(V.LocalizationsUpdater),he.createInstance(ie.DeprecatedExtensionsCleaner)))}async initServices(){const he=new p.ServiceCollection,Ee=new b.NativeEnvironmentService(this.configuration.args);he.set(f.IEnvironmentService,Ee),he.set(f.INativeEnvironmentService,Ee);const Ie=new L.StaticRouter($e=>$e==="main"),Oe=new y.LoggerChannelClient(this.server.getChannel("logger",Ie)),we=this._register(new h.MultiplexLogService([this._register(new h.ConsoleLogService(this.configuration.logLevel)),this._register(new B.SpdLogService("sharedprocess",Ee.logsPath,this.configuration.logLevel))])),be=this._register(new y.FollowerLogService(Oe,we));he.set(h.ILogService,be);const Pe=new F.MessagePortMainProcessService(this.server,Ie);he.set(F.IMainProcessService,Pe);const ke=this._register(new $.FileService(be));he.set(T.IFileService,ke);const Te=this._register(new U.DiskFileSystemProvider(be));ke.registerProvider(M.Schemas.file,Te);const je=this._register(new m.ConfigurationService(Ee.settingsResource,ke));he.set(w.IConfigurationService,je),await je.initialize();const Ue=new ce.NativeStorageService(new fe.GlobalStorageDatabaseChannelClient(Pe.getChannel("storage")),be,Ee);he.set(ye.IStorageService,Ue),await Ue.initialize(),this._register(O.toDisposable(()=>Ue.flush())),he.set(q.IProductService,Object.assign({_serviceBrand:void 0},v.default)),he.set(l.IRequestService,new g.SyncDescriptor(o.RequestService));const Fe=L.createChannelSender(Pe.getChannel("nativeHost"),{context:this.configuration.windowId});he.set(ne.INativeHostService,Fe),he.set(j.IDownloadService,new g.SyncDescriptor(A.DownloadService));const Je=this._register(new Ne.ActiveWindowManager(Fe)),Xe=new L.StaticRouter($e=>Je.getActiveClientId().then(ct=>$e===ct));he.set(Me.IExtensionRecommendationNotificationService,new Ve.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Xe)));const He=this._register(new le.LoggerService(be,ke));he.set(h.ILoggerService,He);const{appRoot:Qe,extensionsPath:Ze,extensionDevelopmentLocationURI:et,isBuilt:tt,installSourcePath:at}=Ee;let it,Be;if(!et&&!Ee.disableTelemetry&&v.default.enableTelemetry){if(Be=new We.TelemetryLogAppender(He,Ee),v.default.aiConfig&&v.default.aiConfig.asimovKey&&tt){const $e=new n.AppInsightsAppender("monacoworkbench",null,v.default.aiConfig.asimovKey);this._register(O.toDisposable(()=>$e.flush())),Be=t.combinedAppender($e,Be)}it=new a.TelemetryService({appender:Be,commonProperties:r.resolveCommonProperties(ke,_.release(),process.arch,v.default.commit,v.default.version,this.configuration.machineId,v.default.msftInternalDomains,at),sendErrorTelemetry:!0,piiPaths:[Qe,Ze]},je)}else it=t.NullTelemetryService,Be=t.NullAppender;return this.server.registerChannel("telemetryAppender",new i.TelemetryAppenderChannel(Be)),he.set(s.ITelemetryService,it),he.set(u.IExtensionManagementService,new g.SyncDescriptor(D.ExtensionManagementService)),he.set(u.IExtensionGalleryService,new g.SyncDescriptor(S.ExtensionGalleryService)),he.set(u.IExtensionTipsService,new g.SyncDescriptor(Re.ExtensionTipsService)),he.set(d.ILocalizationsService,new g.SyncDescriptor(E.LocalizationsService)),he.set(K.IDiagnosticsService,new g.SyncDescriptor(K.DiagnosticsService)),he.set(Ce.IUserDataSyncAccountService,new g.SyncDescriptor(Ce.UserDataSyncAccountService)),he.set(H.IUserDataSyncLogService,new g.SyncDescriptor(me.UserDataSyncLogService)),he.set(H.IUserDataSyncUtilService,new Z.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",$e=>$e.ctx!=="main"))),he.set(u.IGlobalExtensionEnablementService,new g.SyncDescriptor(De.GlobalExtensionEnablementService)),he.set(re.IIgnoredExtensionsManagementService,new g.SyncDescriptor(re.IgnoredExtensionsManagementService)),he.set(oe.IExtensionsStorageSyncService,new g.SyncDescriptor(oe.ExtensionsStorageSyncService)),he.set(H.IUserDataSyncStoreManagementService,new g.SyncDescriptor(Q.UserDataSyncStoreManagementService)),he.set(H.IUserDataSyncStoreService,new g.SyncDescriptor(Q.UserDataSyncStoreService)),he.set(_e.IUserDataSyncMachinesService,new g.SyncDescriptor(_e.UserDataSyncMachinesService)),he.set(H.IUserDataSyncBackupStoreService,new g.SyncDescriptor(Ae.UserDataSyncBackupStoreService)),he.set(H.IUserDataAutoSyncEnablementService,new g.SyncDescriptor(J.UserDataAutoSyncEnablementService)),he.set(H.IUserDataSyncResourceEnablementService,new g.SyncDescriptor(Le.UserDataSyncResourceEnablementService)),he.set(H.IUserDataSyncService,new g.SyncDescriptor(X.UserDataSyncService)),new I.InstantiationService(he)}initChannels(he){const Ee=he.get(u.IExtensionManagementService),Ie=new C.ExtensionManagementChannel(Ee,()=>null);this.server.registerChannel("extensions",Ie);const Oe=he.get(d.ILocalizationsService),we=L.createChannelReceiver(Oe);this.server.registerChannel("localizations",we);const be=he.get(K.IDiagnosticsService),Pe=L.createChannelReceiver(be);this.server.registerChannel("diagnostics",Pe);const ke=he.get(u.IExtensionTipsService),Te=new C.ExtensionTipsChannel(ke);this.server.registerChannel("extensionTipsService",Te);const je=he.get(_e.IUserDataSyncMachinesService),Ue=new Z.UserDataSyncMachinesServiceChannel(je);this.server.registerChannel("userDataSyncMachines",Ue);const Fe=he.get(Ce.IUserDataSyncAccountService),Je=new Z.UserDataSyncAccountServiceChannel(Fe);this.server.registerChannel("userDataSyncAccount",Je);const Xe=he.get(H.IUserDataSyncStoreManagementService),He=new Z.UserDataSyncStoreManagementServiceChannel(Xe);this.server.registerChannel("userDataSyncStoreManagement",He);const Qe=he.get(H.IUserDataSyncService),Ze=new Z.UserDataSyncChannel(this.server,Qe,he.get(h.ILogService));this.server.registerChannel("userDataSync",Ze);const et=this._register(he.get(Se.IInstantiationService).createInstance(se.UserDataAutoSyncService)),tt=new Z.UserDataAutoSyncChannel(et);this.server.registerChannel("userDataAutoSync",tt)}registerErrorHandler(he){window.addEventListener("unhandledrejection",Ee=>{ae.onUnexpectedError(Ee.reason),Ee.preventDefault()}),ae.setUnexpectedErrorHandler(Ee=>{const Ie=ue.toErrorMessage(Ee,!0);!Ie||he.error(`[uncaught exception in sharedProcess]: ${Ie}`)})}}async function ve(pe){const he=new de(pe);c.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await he.open(),c.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=ve})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/622cb03f7e070a9670c94bae1a45d78d7181fbd4/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
