/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/async","vs/base/common/network","electron","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/platform/product/common/product","vs/base/common/errors","vs/base/common/strings","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","fs","vs/base/node/pfs","os","vs/base/common/extpath","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/platform/workspaces/common/workspaces","vs/base/common/arrays","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/node/state","vs/base/common/labels","vs/platform/request/common/request","vs/base/common/json","vs/base/common/objects","vs/platform/update/common/update","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/functional","child_process","vs/platform/configuration/common/configurationRegistry","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/base/parts/ipc/node/ipc.net","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/process","vs/platform/environment/common/environment","vs/platform/environment/node/argvHelper","vs/platform/remote/common/tunnel","vs/base/common/keyCodes","crypto","net","vs/platform/environment/node/argv","vs/platform/product/common/productService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","util","vs/base/common/errorMessage","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/diagnostics/node/diagnosticsService","vs/platform/theme/electron-main/themeMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/scanCode","vs/base/common/glob","vs/base/node/decoder","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/storage/node/storageMainService","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/webview/common/resourceLoader","vs/platform/windows/electron-main/windowsFinder","vs/code/electron-main/window","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/node/crypto","vs/base/node/macAddress","vs/base/node/paths","vs/base/node/extpath","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/common/storage","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/code/electron-main/window","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/waitMarkerFile","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/display/electron-main/displayMainService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/code/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/lifecycle/common/lifecycle","vs/code/electron-main/protocol","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/storage/node/storageIpc","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/electron-main/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/mimeTypes","vs/platform/webview/common/webviewManagerService","vs/platform/webview/common/webviewPortMapping","vs/platform/webview/electron-main/webviewPortMappingProvider","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","zlib","vs/platform/driver/node/driver","vs/platform/environment/node/environmentService","vs/code/electron-main/sharedProcess","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","stream","vs/code/electron-main/main"],J=function($){for(var e=[],w=0,R=$.length;w<R;w++)e[w]=Q[$[w]];return e};define(Q[97],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(R,D){if(!R)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=w}),define(Q[51],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function w(S){return(i,E,m)=>{let P=null,f=null;if(typeof m.value=="function"?(P="value",f=m.value):typeof m.get=="function"&&(P="get",f=m.get),!f)throw new Error("not supported");m[P]=S(f,E)}}e.createDecorator=w;let R=0;function D(){const S=`$memoize${R++}`;let i;const E=function(P,f,h){let v=null,p=null;if(typeof h.value=="function"?(v="value",p=h.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(v="get",p=h.get),!p)throw new Error("not supported");const b=`${S}:${f}`;h[v]=function(...l){return i=this,this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!0,enumerable:!1,writable:!0,value:p.apply(this,l)}),this[b]}};return E.clear=()=>{typeof i!="undefined"&&Object.getOwnPropertyNames(i).forEach(m=>{m.indexOf(S)===0&&delete i[m]})},E}e.createMemoizer=D;function y(S,i,E){return D()(S,i,E)}e.memoize=y;function M(S,i,E){return w((m,P)=>{const f=`$debounce$${P}`,h=`$debounce$result$${P}`;return function(...v){this[h]||(this[h]=E?E():void 0),clearTimeout(this[f]),i&&(this[h]=i(this[h],...v),v=[this[h]]),this[f]=setTimeout(()=>{m.apply(this,v),this[h]=E?E():void 0},S)}})}e.debounce=M;function n(S,i,E){return w((m,P)=>{const f=`$throttle$timer$${P}`,h=`$throttle$result$${P}`,v=`$throttle$lastRun$${P}`,p=`$throttle$pending$${P}`;return function(...b){if(this[h]||(this[h]=E?E():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),i&&(this[h]=i(this[h],...b)),!this[p]){const l=this[v]+S;l<=Date.now()?(this[v]=Date.now(),m.apply(this,[this[h]]),this[h]=E?E():void 0):(this[p]=!0,this[f]=setTimeout(()=>{this[p]=!1,this[v]=Date.now(),m.apply(this,[this[h]]),this[h]=E?E():void 0},l-Date.now()))}}})}e.throttle=n}),define(Q[16],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(s=>{s(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}e.ErrorHandler=w,e.errorHandler=new w;function R(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=R;function D(l){S(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=D;function y(l){S(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=y;function M(l){if(l instanceof Error){let{name:a,message:s}=l;const u=l.stacktrace||l.stack;return{$isError:!0,name:a,message:s,stack:u}}return l}e.transformErrorForSerialization=M;const n="Canceled";function S(l){return l instanceof Error&&l.name===n&&l.message===n}e.isPromiseCanceledError=S;class i extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=i;function E(){const l=new Error(n);return l.name=l.message,l}e.canceled=E;function m(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=m;function P(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=P;function f(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function h(l){const a=new Error(`${l} has been disposed`);return a.name="DISPOSED",a}e.disposed=h;function v(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=v;class p extends Error{constructor(a){super("NotImplemented");a&&(this.message=a)}}e.NotImplementedError=p;class b extends Error{constructor(a){super("NotSupported");a&&(this.message=a)}}e.NotSupportedError=b}),define(Q[32],J([0,1,16]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.mergeSort=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(O,k=0){return O[O.length-(1+k)]}e.tail=R;function D(O){if(O.length===0)throw new Error("Invalid tail call");return[O.slice(0,O.length-1),O[O.length-1]]}e.tail2=D;function y(O,k,L=(_,W)=>_===W){if(O===k)return!0;if(!O||!k||O.length!==k.length)return!1;for(let _=0,W=O.length;_<W;_++)if(!L(O[_],k[_]))return!1;return!0}e.equals=y;function M(O,k,L){let _=0,W=O.length-1;for(;_<=W;){const B=(_+W)/2|0,K=L(O[B],k);if(K<0)_=B+1;else if(K>0)W=B-1;else return B}return-(_+1)}e.binarySearch=M;function n(O,k){let L=0,_=O.length;if(_===0)return 0;for(;L<_;){const W=Math.floor((L+_)/2);k(O[W])?_=W:L=W+1}return L}e.findFirstInSorted=n;function S(O,k,L){if(O=O|0,O>=k.length)throw new TypeError("invalid index");let _=k[Math.floor(k.length*Math.random())],W=[],B=[],K=[];for(let X of k){const Y=L(X,_);Y<0?W.push(X):Y>0?B.push(X):K.push(X)}return O<W.length?S(O,W,L):O<W.length+K.length?K[0]:S(O-(W.length+K.length),B,L)}e.quickSelect=S;function i(O,k){return m(O,k,0,O.length-1,[]),O}e.mergeSort=i;function E(O,k,L,_,W,B){let K=L,X=_+1;for(let Y=L;Y<=W;Y++)B[Y]=O[Y];for(let Y=L;Y<=W;Y++)K>_?O[Y]=B[X++]:X>W?O[Y]=B[K++]:k(B[X],B[K])<0?O[Y]=B[X++]:O[Y]=B[K++]}function m(O,k,L,_,W){if(!(_<=L)){const B=L+(_-L)/2|0;m(O,k,L,B,W),m(O,k,B+1,_,W),!(k(O[B],O[B+1])<=0)&&E(O,k,L,B,_,W)}}function P(O,k){const L=[];let _;for(const W of i(O.slice(0),k))!_||k(_[0],W)!==0?(_=[W],L.push(_)):_.push(W);return L}e.groupBy=P;function f(O,k,L){const _=[];function W(X,Y,oe){if(!(Y===0&&oe.length===0)){const le=_[_.length-1];le&&le.start+le.deleteCount===X?(le.deleteCount+=Y,le.toInsert.push(...oe)):_.push({start:X,deleteCount:Y,toInsert:oe})}}let B=0,K=0;for(;;){if(B===O.length){W(B,0,k.slice(K));break}if(K===k.length){W(B,O.length-B,[]);break}const X=O[B],Y=k[K],oe=L(X,Y);oe===0?(B+=1,K+=1):oe<0?(W(B,1,[]),B+=1):oe>0&&(W(B,0,[Y]),K+=1)}return _}e.sortedDiff=f;function h(O,k,L){const _=f(O,k,L),W=[],B=[];for(const K of _)W.push(...O.slice(K.start,K.start+K.deleteCount)),B.push(...K.toInsert);return{removed:W,added:B}}e.delta=h;function v(O,k,L){if(L===0)return[];const _=O.slice(0,L).sort(k);return b(O,k,_,L,O.length),_}e.top=v;function p(O,k,L,_,W){return L===0?Promise.resolve([]):new Promise((B,K)=>{(async()=>{const X=O.length,Y=O.slice(0,L).sort(k);for(let oe=L,le=Math.min(L+_,X);oe<X;oe=le,le=Math.min(le+_,X)){if(oe>L&&await new Promise(ie=>setTimeout(ie)),W&&W.isCancellationRequested)throw w.canceled();b(O,k,Y,oe,le)}return Y})().then(B,K)})}e.topAsync=p;function b(O,k,L,_,W){for(const B=L.length;_<W;_++){const K=O[_];if(k(K,L[B-1])<0){L.pop();const X=n(L,Y=>k(K,Y)<0);L.splice(X,0,K)}}}function l(O){return O.filter(k=>!!k)}e.coalesce=l;function a(O){let k=0;for(let L=0;L<O.length;L++)O[L]&&(O[k]=O[L],k+=1);O.length=k}e.coalesceInPlace=a;function s(O,k,L){O.splice(L,0,O.splice(k,1)[0])}e.move=s;function u(O){return!Array.isArray(O)||O.length===0}e.isFalsyOrEmpty=u;function t(O){return Array.isArray(O)&&O.length>0}e.isNonEmptyArray=t;function r(O,k){if(!k)return O.filter((_,W)=>O.indexOf(_)===W);const L=Object.create(null);return O.filter(_=>{const W=k(_);return L[W]?!1:(L[W]=!0,!0)})}e.distinct=r;function o(O){const k=new Set;return O.filter(L=>k.has(L)?!1:(k.add(L),!0))}e.distinctES6=o;function d(O){const k=Object.create(null);return L=>{const _=O(L);return k[_]?!1:(k[_]=!0,!0)}}e.uniqueFilter=d;function c(O,k){for(let L=O.length-1;L>=0;L--){const _=O[L];if(k(_))return L}return-1}e.lastIndex=c;function g(O,k){return O.length>0?O[0]:k}e.firstOrDefault=g;function I(O,k,L=(_,W)=>_===W){let _=0;for(let W=0,B=Math.min(O.length,k.length);W<B&&L(O[W],k[W]);W++)_++;return _}e.commonPrefixLength=I;function A(O){return[].concat(...O)}e.flatten=A;function T(O,k){let L=typeof k=="number"?O:0;typeof k=="number"?L=O:(L=0,k=O);const _=[];if(L<=k)for(let W=L;W<k;W++)_.push(W);else for(let W=L;W>k;W--)_.push(W);return _}e.range=T;function U(O,k,L){return O.reduce((_,W)=>(_[k(W)]=L?L(W):W,_),Object.create(null))}e.index=U;function j(O,k){return O.push(k),()=>C(O,k)}e.insert=j;function C(O,k){const L=O.indexOf(k);if(L>-1)return O.splice(L,1),k}e.remove=C;function x(O,k,L){const _=O.slice(0,k),W=O.slice(k);return _.concat(L,W)}e.arrayInsert=x;function ee(O,k){let L;if(typeof k=="number"){let _=k;L=()=>{const W=Math.sin(_++)*179426549;return W-Math.floor(W)}}else L=Math.random;for(let _=O.length-1;_>0;_-=1){const W=Math.floor(L()*(_+1)),B=O[_];O[_]=O[W],O[W]=B}}e.shuffle=ee;function Z(O,k){const L=O.indexOf(k);L>-1&&(O.splice(L,1),O.unshift(k))}e.pushToStart=Z;function H(O,k){const L=O.indexOf(k);L>-1&&(O.splice(L,1),O.push(k))}e.pushToEnd=H;function N(O,k){return Array.isArray(O)?O.map(k):k(O)}e.mapArrayOrNot=N;function q(O){return Array.isArray(O)?O:[O]}e.asArray=q;function F(O){return O[Math.floor(Math.random()*O.length)]}e.getRandomElement=F;function z(O,k){for(const L of O){const _=k(L);if(_!==void 0)return _}}e.mapFind=z}),define(Q[44],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(R){const D=this;let y=!1,M;return function(){return y||(y=!0,M=R.apply(D,arguments)),M}}e.once=w}),define(Q[63],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(R){function D(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}R.is=D;const y=Object.freeze([]);function M(){return y}R.empty=M;function*n(l){yield l}R.single=n;function S(l){return l||y}R.from=S;function i(l){return!l||l[Symbol.iterator]().next().done===!0}R.isEmpty=i;function E(l){return l[Symbol.iterator]().next().value}R.first=E;function m(l,a){for(const s of l)if(a(s))return!0;return!1}R.some=m;function*P(l,a){for(const s of l)a(s)&&(yield s)}R.filter=P;function*f(l,a){for(const s of l)yield a(s)}R.map=f;function*h(...l){for(const a of l)for(const s of a)yield s}R.concat=h;function*v(l){for(const a of l)for(const s of a)yield s}R.concatNested=v;function*p(l,a,s=l.length){for(a<0&&(a+=l.length),s<0?s+=l.length:s>l.length&&(s=l.length);a<s;a++)yield l[a]}R.slice=p;function b(l,a=Number.POSITIVE_INFINITY){const s=[];if(a===0)return[s,l];const u=l[Symbol.iterator]();for(let t=0;t<a;t++){const r=u.next();if(r.done)return[s,R.empty()];s.push(r.value)}return[s,{[Symbol.iterator](){return u}}]}R.consume=b})(w=e.Iterable||(e.Iterable={}))}),define(Q[40],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function M(t,r=!1){let o=0,d=t.length,c="",g=0,I=16,A=0;function T(H){let N=0,q=0;for(;N<H;){const F=t.charCodeAt(o);if(F>=48&&F<=57)q=q*16+F-48;else if(F>=65&&F<=70)q=q*16+F-65+10;else if(F>=97&&F<=102)q=q*16+F-97+10;else break;o++,N++}return N<H&&(q=-1),q}function U(H){o=H,c="",g=0,I=16,A=0}function j(){const H=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&i(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&i(t.charCodeAt(o)))for(o++;o<t.length&&i(t.charCodeAt(o));)o++;else return A=3,t.substring(H,o);let N=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&i(t.charCodeAt(o))){for(o++;o<t.length&&i(t.charCodeAt(o));)o++;N=o}else A=3;return t.substring(H,N)}function C(){let H="",N=o;for(;;){if(o>=d){H+=t.substring(N,o),A=2;break}const q=t.charCodeAt(o);if(q===34){H+=t.substring(N,o),o++;break}if(q===92){if(H+=t.substring(N,o),o++,o>=d){A=2;break}switch(t.charCodeAt(o++)){case 34:H+='"';break;case 92:H+="\\";break;case 47:H+="/";break;case 98:H+="\b";break;case 102:H+="\f";break;case 110:H+=`
`;break;case 114:H+="\r";break;case 116:H+="	";break;case 117:const z=T(4);z>=0?H+=String.fromCharCode(z):A=4;break;default:A=5}N=o;continue}if(q>=0&&q<=31)if(S(q)){H+=t.substring(N,o),A=2;break}else A=6;o++}return H}function x(){if(c="",A=0,g=o,o>=d)return g=d,I=17;let H=t.charCodeAt(o);if(n(H)){do o++,c+=String.fromCharCode(H),H=t.charCodeAt(o);while(n(H));return I=15}if(S(H))return o++,c+=String.fromCharCode(H),H===13&&t.charCodeAt(o)===10&&(o++,c+=`
`),I=14;switch(H){case 123:return o++,I=1;case 125:return o++,I=2;case 91:return o++,I=3;case 93:return o++,I=4;case 58:return o++,I=6;case 44:return o++,I=5;case 34:return o++,c=C(),I=10;case 47:const N=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<d&&!S(t.charCodeAt(o));)o++;return c=t.substring(N,o),I=12}if(t.charCodeAt(o+1)===42){o+=2;const q=d-1;let F=!1;for(;o<q;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,F=!0;break}o++}return F||(o++,A=1),c=t.substring(N,o),I=13}return c+=String.fromCharCode(H),o++,I=16;case 45:if(c+=String.fromCharCode(H),o++,o===d||!i(t.charCodeAt(o)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=j(),I=11;default:for(;o<d&&ee(H);)o++,H=t.charCodeAt(o);if(g!==o){switch(c=t.substring(g,o),c){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return c+=String.fromCharCode(H),o++,I=16}}function ee(H){if(n(H)||S(H))return!1;switch(H){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Z(){let H;do H=x();while(H>=12&&H<=15);return H}return{setPosition:U,getPosition:()=>o,scan:r?Z:x,getToken:()=>I,getTokenValue:()=>c,getTokenOffset:()=>g,getTokenLength:()=>o-g,getTokenError:()=>A}}e.createScanner=M;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function i(t){return t>=48&&t<=57}var E;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(E||(E={}));function m(t,r){const o=[],d=new Object;let c;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function A(T,U,j,C){g.value=T,g.offset=U,g.length=j,g.type=C,g.colonOffset=void 0,c=g}try{a(t,{onObjectBegin:(T,U)=>{if(r<=T)throw d;c=void 0,I=r>T,o.push("")},onObjectProperty:(T,U,j)=>{if(r<U||(A(T,U,j,"property"),o[o.length-1]=T,r<=U+j))throw d},onObjectEnd:(T,U)=>{if(r<=T)throw d;c=void 0,o.pop()},onArrayBegin:(T,U)=>{if(r<=T)throw d;c=void 0,o.push(0)},onArrayEnd:(T,U)=>{if(r<=T)throw d;c=void 0,o.pop()},onLiteralValue:(T,U,j)=>{if(r<U||(A(T,U,j,u(T)),r<=U+j))throw d},onSeparator:(T,U,j)=>{if(r<=U)throw d;if(T===":"&&c&&c.type==="property")c.colonOffset=U,I=!1,c=void 0;else if(T===","){const C=o[o.length-1];typeof C=="number"?o[o.length-1]=C+1:(I=!0,o[o.length-1]=""),c=void 0}}})}catch(T){if(T!==d)throw T}return{path:o,previousNode:c,isAtPropertyKey:I,matches:T=>{let U=0;for(let j=0;U<T.length&&j<o.length;j++)if(T[U]===o[j]||T[U]==="*")U++;else if(T[U]!=="**")return!1;return U===T.length}}}e.getLocation=m;function P(t,r=[],o=y.DEFAULT){let d=null,c=[];const g=[];function I(T){Array.isArray(c)?c.push(T):d!==null&&(c[d]=T)}return a(t,{onObjectBegin:()=>{const T={};I(T),g.push(c),c=T,d=null},onObjectProperty:T=>{d=T},onObjectEnd:()=>{c=g.pop()},onArrayBegin:()=>{const T=[];I(T),g.push(c),c=T,d=null},onArrayEnd:()=>{c=g.pop()},onLiteralValue:I,onError:(T,U,j)=>{r.push({error:T,offset:U,length:j})}},o),c[0]}e.parse=P;function f(t,r=[],o=y.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(T){d.type==="property"&&(d.length=T-d.offset,d=d.parent)}function g(T){return d.children.push(T),T}a(t,{onObjectBegin:T=>{d=g({type:"object",offset:T,length:-1,parent:d,children:[]})},onObjectProperty:(T,U,j)=>{d=g({type:"property",offset:U,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:T,offset:U,length:j,parent:d})},onObjectEnd:(T,U)=>{d.length=T+U-d.offset,d=d.parent,c(T+U)},onArrayBegin:(T,U)=>{d=g({type:"array",offset:T,length:-1,parent:d,children:[]})},onArrayEnd:(T,U)=>{d.length=T+U-d.offset,d=d.parent,c(T+U)},onLiteralValue:(T,U,j)=>{g({type:u(T),offset:U,length:j,parent:d,value:T}),c(U+j)},onSeparator:(T,U,j)=>{d.type==="property"&&(T===":"?d.colonOffset=U:T===","&&c(U))},onError:(T,U,j)=>{r.push({error:T,offset:U,length:j})}},o);const A=d.children[0];return A&&delete A.parent,A}e.parseTree=f;function h(t,r){if(!!t){let o=t;for(let d of r)if(typeof d=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let c=!1;for(const g of o.children)if(Array.isArray(g.children)&&g.children[0].value===d){o=g.children[1],c=!0;break}if(!c)return}else{const c=d;if(o.type!=="array"||c<0||!Array.isArray(o.children)||c>=o.children.length)return;o=o.children[c]}return o}}e.findNodeAtLocation=h;function v(t){if(!t.parent||!t.parent.children)return[];const r=v(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;r.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&r.push(o)}return r}e.getNodePath=v;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":const r=Object.create(null);for(let o of t.children){const d=o.children[1];d&&(r[o.children[0].value]=p(d))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=p;function b(t,r,o=!1){return r>=t.offset&&r<t.offset+t.length||o&&r===t.offset+t.length}e.contains=b;function l(t,r,o=!1){if(b(t,r,o)){const d=t.children;if(Array.isArray(d))for(let c=0;c<d.length&&d[c].offset<=r;c++){const g=l(d[c],r,o);if(g)return g}return t}}e.findNodeAtOffset=l;function a(t,r,o=y.DEFAULT){const d=M(t,!1);function c(B){return B?()=>B(d.getTokenOffset(),d.getTokenLength()):()=>!0}function g(B){return B?K=>B(K,d.getTokenOffset(),d.getTokenLength()):()=>!0}const I=c(r.onObjectBegin),A=g(r.onObjectProperty),T=c(r.onObjectEnd),U=c(r.onArrayBegin),j=c(r.onArrayEnd),C=g(r.onLiteralValue),x=g(r.onSeparator),ee=c(r.onComment),Z=g(r.onError),H=o&&o.disallowComments,N=o&&o.allowTrailingComma;function q(){for(;;){const B=d.scan();switch(d.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:H||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(B){case 12:case 13:H?F(10):ee();break;case 16:F(1);break;case 15:case 14:break;default:return B}}}function F(B,K=[],X=[]){if(Z(B),K.length+X.length>0){let Y=d.getToken();for(;Y!==17;){if(K.indexOf(Y)!==-1){q();break}else if(X.indexOf(Y)!==-1)break;Y=q()}}}function z(B){const K=d.getTokenValue();return B?C(K):A(K),q(),!0}function O(){switch(d.getToken()){case 11:let B=0;try{B=JSON.parse(d.getTokenValue()),typeof B!="number"&&(F(2),B=0)}catch(K){F(2)}C(B);break;case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return q(),!0}function k(){return d.getToken()!==10?(F(3,[],[2,5]),!1):(z(!1),d.getToken()===6?(x(":"),q(),W()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function L(){I(),q();let B=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(B||F(4,[],[]),x(","),q(),d.getToken()===2&&N)break}else B&&F(6,[],[]);k()||F(4,[],[2,5]),B=!0}return T(),d.getToken()!==2?F(7,[2],[]):q(),!0}function _(){U(),q();let B=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(B||F(4,[],[]),x(","),q(),d.getToken()===4&&N)break}else B&&F(6,[],[]);W()||F(4,[],[4,5]),B=!0}return j(),d.getToken()!==4?F(8,[4],[]):q(),!0}function W(){switch(d.getToken()){case 3:return _();case 1:return L();case 10:return z(!0);default:return O()}}return q(),d.getToken()===17?o.allowEmptyContent?!0:(F(4,[],[]),!1):W()?(d.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=a;function s(t,r){let o=M(t),d=[],c,g=0,I;do switch(I=o.getPosition(),c=o.scan(),c){case 12:case 13:case 17:g!==I&&d.push(t.substring(g,I)),r!==void 0&&d.push(o.getTokenValue().replace(/[^\r\n]/g,r)),g=o.getPosition();break}while(c!==17);return d.join("")}e.stripComments=s;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(Q[98],J([0,1,40]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(S,i,E){let m,P,f,h,v;if(i){for(h=i.offset,v=h+i.length,f=h;f>0&&!n(S,f-1);)f--;let g=v;for(;g<S.length&&!n(S,g);)g++;P=S.substring(f,g),m=y(P,E)}else P=S,m=0,f=0,h=0,v=S.length;const p=M(E,S);let b=!1,l=0,a;E.insertSpaces?a=D(" ",E.tabSize||4):a="	";const s=w.createScanner(P,!1);let u=!1;function t(){return p+D(a,m+l)}function r(){let g=s.scan();for(b=!1;g===15||g===14;)b=b||g===14,g=s.scan();return u=g===16||s.getTokenError()!==0,g}const o=[];function d(g,I,A){!u&&I<v&&A>h&&S.substring(I,A)!==g&&o.push({offset:I,length:A-I,content:g})}let c=r();if(c!==17){const g=s.getTokenOffset()+f,I=D(a,m);d(I,f,g)}for(;c!==17;){let g=s.getTokenOffset()+s.getTokenLength()+f,I=r(),A="";for(;!b&&(I===12||I===13);){const U=s.getTokenOffset()+f;d(" ",g,U),g=s.getTokenOffset()+s.getTokenLength()+f,A=I===12?t():"",I=r()}if(I===2)c!==1&&(l--,A=t());else if(I===4)c!==3&&(l--,A=t());else{switch(c){case 3:case 1:l++,A=t();break;case 5:case 12:A=t();break;case 13:b?A=t():A=" ";break;case 6:A=" ";break;case 10:if(I===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?A=" ":I!==5&&I!==17&&(u=!0);break;case 16:u=!0;break}b&&(I===12||I===13)&&(A=t())}const T=s.getTokenOffset()+f;d(A,g,T),c=I}return o}e.format=R;function D(S,i){let E="";for(let m=0;m<i;m++)E+=S;return E}function y(S,i){let E=0,m=0;const P=i.tabSize||4;for(;E<S.length;){const f=S.charAt(E);if(f===" ")m++;else if(f==="	")m+=P;else break;E++}return Math.floor(m/P)}function M(S,i){for(let E=0;E<i.length;E++){const m=i.charAt(E);if(m==="\r")return E+1<i.length&&i.charAt(E+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=M;function n(S,i){return`\r
`.indexOf(S.charAt(i))!==-1}e.isEOL=n}),define(Q[99],J([0,1,40,98,32]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function y(E,m,P){return M(E,m,void 0,P)}e.removeProperty=y;function M(E,m,P,f,h){const v=m.slice(),p=[],b=w.parseTree(E,p);let l,a;for(;v.length>0&&(a=v.pop(),l=w.findNodeAtLocation(b,v),l===void 0&&P!==void 0);)typeof a=="string"?P={[a]:P}:P=[P];if(l)if(l.type==="object"&&typeof a=="string"&&Array.isArray(l.children)){const s=w.findNodeAtLocation(l,[a]);if(s!==void 0)if(P===void 0){if(!s.parent)throw new Error("Malformed AST");const u=l.children.indexOf(s.parent);let t,r=s.parent.offset+s.parent.length;if(u>0){const o=l.children[u-1];t=o.offset+o.length}else t=l.offset+1,l.children.length>1&&(r=l.children[1].offset);return n(E,{offset:t,length:r-t,content:""},f)}else return n(E,{offset:s.offset,length:s.length,content:JSON.stringify(P)},f);else{if(P===void 0)return[];const u=`${JSON.stringify(a)}: ${JSON.stringify(P)}`,t=h?h(l.children.map(o=>o.children[0].value)):l.children.length;let r;if(t>0){const o=l.children[t-1];r={offset:o.offset+o.length,length:0,content:","+u}}else l.children.length===0?r={offset:l.offset+1,length:0,content:u}:r={offset:l.offset+1,length:0,content:u+","};return n(E,r,f)}}else if(l.type==="array"&&typeof a=="number"&&Array.isArray(l.children))if(P!==void 0){const s=`${JSON.stringify(P)}`;let u;if(l.children.length===0||a===0)u={offset:l.offset+1,length:0,content:l.children.length===0?s:s+","};else{const t=a===-1||a>l.children.length?l.children.length:a,r=l.children[t-1];u={offset:r.offset+r.length,length:0,content:","+s}}return n(E,u,f)}else{const s=a,u=l.children[s];let t;if(l.children.length===1)t={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===s){const r=l.children[s-1],o=r.offset+r.length,d=l.offset+l.length;t={offset:o,length:d-2-o,content:""}}else t={offset:u.offset,length:l.children[s+1].offset-u.offset,content:""};return n(E,t,f)}else throw new Error(`Can not add ${typeof a!="number"?"index":"property"} to parent of type ${l.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return n(E,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(P)},f)}}e.setProperty=M;function n(E,m,P){let f=S(E,m),h=m.offset,v=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;h>0&&!R.isEOL(f,h-1);)h--;for(;v<f.length&&!R.isEOL(f,v);)v++}const p=R.format(f,{offset:h,length:v-h},P);for(let l=p.length-1;l>=0;l--){const a=p[l];f=S(f,a),h=Math.min(h,a.offset),v=Math.max(v,a.offset+a.length),v+=a.content.length-a.length}const b=E.length-(f.length-v)-h;return[{offset:h,length:b,content:f.substring(h,v)}]}e.withFormatting=n;function S(E,m){return E.substring(0,m.offset)+m.content+E.substring(m.offset+m.length)}e.applyEdit=S;function i(E,m){let P=D.mergeSort(m,(h,v)=>{const p=h.offset-v.offset;return p===0?h.length-v.length:p}),f=E.length;for(let h=P.length-1;h>=0;h--){let v=P[h];if(v.offset+v.length<=f)E=S(E,v);else throw new Error("Overlapping edit");f=v.offset}return E}e.applyEdits=i}),define(Q[56],J([0,1,16]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var R;(function(l){l[l.Unknown=0]="Unknown",l[l.Backspace=1]="Backspace",l[l.Tab=2]="Tab",l[l.Enter=3]="Enter",l[l.Shift=4]="Shift",l[l.Ctrl=5]="Ctrl",l[l.Alt=6]="Alt",l[l.PauseBreak=7]="PauseBreak",l[l.CapsLock=8]="CapsLock",l[l.Escape=9]="Escape",l[l.Space=10]="Space",l[l.PageUp=11]="PageUp",l[l.PageDown=12]="PageDown",l[l.End=13]="End",l[l.Home=14]="Home",l[l.LeftArrow=15]="LeftArrow",l[l.UpArrow=16]="UpArrow",l[l.RightArrow=17]="RightArrow",l[l.DownArrow=18]="DownArrow",l[l.Insert=19]="Insert",l[l.Delete=20]="Delete",l[l.KEY_0=21]="KEY_0",l[l.KEY_1=22]="KEY_1",l[l.KEY_2=23]="KEY_2",l[l.KEY_3=24]="KEY_3",l[l.KEY_4=25]="KEY_4",l[l.KEY_5=26]="KEY_5",l[l.KEY_6=27]="KEY_6",l[l.KEY_7=28]="KEY_7",l[l.KEY_8=29]="KEY_8",l[l.KEY_9=30]="KEY_9",l[l.KEY_A=31]="KEY_A",l[l.KEY_B=32]="KEY_B",l[l.KEY_C=33]="KEY_C",l[l.KEY_D=34]="KEY_D",l[l.KEY_E=35]="KEY_E",l[l.KEY_F=36]="KEY_F",l[l.KEY_G=37]="KEY_G",l[l.KEY_H=38]="KEY_H",l[l.KEY_I=39]="KEY_I",l[l.KEY_J=40]="KEY_J",l[l.KEY_K=41]="KEY_K",l[l.KEY_L=42]="KEY_L",l[l.KEY_M=43]="KEY_M",l[l.KEY_N=44]="KEY_N",l[l.KEY_O=45]="KEY_O",l[l.KEY_P=46]="KEY_P",l[l.KEY_Q=47]="KEY_Q",l[l.KEY_R=48]="KEY_R",l[l.KEY_S=49]="KEY_S",l[l.KEY_T=50]="KEY_T",l[l.KEY_U=51]="KEY_U",l[l.KEY_V=52]="KEY_V",l[l.KEY_W=53]="KEY_W",l[l.KEY_X=54]="KEY_X",l[l.KEY_Y=55]="KEY_Y",l[l.KEY_Z=56]="KEY_Z",l[l.Meta=57]="Meta",l[l.ContextMenu=58]="ContextMenu",l[l.F1=59]="F1",l[l.F2=60]="F2",l[l.F3=61]="F3",l[l.F4=62]="F4",l[l.F5=63]="F5",l[l.F6=64]="F6",l[l.F7=65]="F7",l[l.F8=66]="F8",l[l.F9=67]="F9",l[l.F10=68]="F10",l[l.F11=69]="F11",l[l.F12=70]="F12",l[l.F13=71]="F13",l[l.F14=72]="F14",l[l.F15=73]="F15",l[l.F16=74]="F16",l[l.F17=75]="F17",l[l.F18=76]="F18",l[l.F19=77]="F19",l[l.NumLock=78]="NumLock",l[l.ScrollLock=79]="ScrollLock",l[l.US_SEMICOLON=80]="US_SEMICOLON",l[l.US_EQUAL=81]="US_EQUAL",l[l.US_COMMA=82]="US_COMMA",l[l.US_MINUS=83]="US_MINUS",l[l.US_DOT=84]="US_DOT",l[l.US_SLASH=85]="US_SLASH",l[l.US_BACKTICK=86]="US_BACKTICK",l[l.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",l[l.US_BACKSLASH=88]="US_BACKSLASH",l[l.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",l[l.US_QUOTE=90]="US_QUOTE",l[l.OEM_8=91]="OEM_8",l[l.OEM_102=92]="OEM_102",l[l.NUMPAD_0=93]="NUMPAD_0",l[l.NUMPAD_1=94]="NUMPAD_1",l[l.NUMPAD_2=95]="NUMPAD_2",l[l.NUMPAD_3=96]="NUMPAD_3",l[l.NUMPAD_4=97]="NUMPAD_4",l[l.NUMPAD_5=98]="NUMPAD_5",l[l.NUMPAD_6=99]="NUMPAD_6",l[l.NUMPAD_7=100]="NUMPAD_7",l[l.NUMPAD_8=101]="NUMPAD_8",l[l.NUMPAD_9=102]="NUMPAD_9",l[l.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",l[l.NUMPAD_ADD=104]="NUMPAD_ADD",l[l.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",l[l.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",l[l.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",l[l.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",l[l.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",l[l.ABNT_C1=110]="ABNT_C1",l[l.ABNT_C2=111]="ABNT_C2",l[l.MAX_VALUE=112]="MAX_VALUE"})(R=e.KeyCode||(e.KeyCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(a,s){this._keyCodeToStr[a]=s,this._strToKeyCode[s.toLowerCase()]=a}keyCodeToStr(a){return this._keyCodeToStr[a]}strToKeyCode(a){return this._strToKeyCode[a.toLowerCase()]||0}}const y=new D,M=new D,n=new D;(function(){function l(a,s,u=s,t=u){y.define(a,s),M.define(a,u),n.define(a,t)}l(0,"unknown"),l(1,"Backspace"),l(2,"Tab"),l(3,"Enter"),l(4,"Shift"),l(5,"Ctrl"),l(6,"Alt"),l(7,"PauseBreak"),l(8,"CapsLock"),l(9,"Escape"),l(10,"Space"),l(11,"PageUp"),l(12,"PageDown"),l(13,"End"),l(14,"Home"),l(15,"LeftArrow","Left"),l(16,"UpArrow","Up"),l(17,"RightArrow","Right"),l(18,"DownArrow","Down"),l(19,"Insert"),l(20,"Delete"),l(21,"0"),l(22,"1"),l(23,"2"),l(24,"3"),l(25,"4"),l(26,"5"),l(27,"6"),l(28,"7"),l(29,"8"),l(30,"9"),l(31,"A"),l(32,"B"),l(33,"C"),l(34,"D"),l(35,"E"),l(36,"F"),l(37,"G"),l(38,"H"),l(39,"I"),l(40,"J"),l(41,"K"),l(42,"L"),l(43,"M"),l(44,"N"),l(45,"O"),l(46,"P"),l(47,"Q"),l(48,"R"),l(49,"S"),l(50,"T"),l(51,"U"),l(52,"V"),l(53,"W"),l(54,"X"),l(55,"Y"),l(56,"Z"),l(57,"Meta"),l(58,"ContextMenu"),l(59,"F1"),l(60,"F2"),l(61,"F3"),l(62,"F4"),l(63,"F5"),l(64,"F6"),l(65,"F7"),l(66,"F8"),l(67,"F9"),l(68,"F10"),l(69,"F11"),l(70,"F12"),l(71,"F13"),l(72,"F14"),l(73,"F15"),l(74,"F16"),l(75,"F17"),l(76,"F18"),l(77,"F19"),l(78,"NumLock"),l(79,"ScrollLock"),l(80,";",";","OEM_1"),l(81,"=","=","OEM_PLUS"),l(82,",",",","OEM_COMMA"),l(83,"-","-","OEM_MINUS"),l(84,".",".","OEM_PERIOD"),l(85,"/","/","OEM_2"),l(86,"`","`","OEM_3"),l(110,"ABNT_C1"),l(111,"ABNT_C2"),l(87,"[","[","OEM_4"),l(88,"\\","\\","OEM_5"),l(89,"]","]","OEM_6"),l(90,"'","'","OEM_7"),l(91,"OEM_8"),l(92,"OEM_102"),l(93,"NumPad0"),l(94,"NumPad1"),l(95,"NumPad2"),l(96,"NumPad3"),l(97,"NumPad4"),l(98,"NumPad5"),l(99,"NumPad6"),l(100,"NumPad7"),l(101,"NumPad8"),l(102,"NumPad9"),l(103,"NumPad_Multiply"),l(104,"NumPad_Add"),l(105,"NumPad_Separator"),l(106,"NumPad_Subtract"),l(107,"NumPad_Decimal"),l(108,"NumPad_Divide")})();var S;(function(l){function a(o){return y.keyCodeToStr(o)}l.toString=a;function s(o){return y.strToKeyCode(o)}l.fromString=s;function u(o){return M.keyCodeToStr(o)}l.toUserSettingsUS=u;function t(o){return n.keyCodeToStr(o)}l.toUserSettingsGeneral=t;function r(o){return M.strToKeyCode(o)||n.strToKeyCode(o)}l.fromUserSettings=r})(S=e.KeyCodeUtils||(e.KeyCodeUtils={}));var i;(function(l){l[l.CtrlCmd=2048]="CtrlCmd",l[l.Shift=1024]="Shift",l[l.Alt=512]="Alt",l[l.WinCtrl=256]="WinCtrl",l[l.KeyCode=255]="KeyCode"})(i||(i={}));var E;(function(l){l[l.CtrlCmd=2048]="CtrlCmd",l[l.Shift=1024]="Shift",l[l.Alt=512]="Alt",l[l.WinCtrl=256]="WinCtrl"})(E=e.KeyMod||(e.KeyMod={}));function m(l,a){const s=(a&65535)<<16>>>0;return(l|s)>>>0}e.KeyChord=m;function P(l,a){if(l===0)return null;const s=(l&65535)>>>0,u=(l&4294901760)>>>16;return u!==0?new v([f(s,a),f(u,a)]):new v([f(s,a)])}e.createKeybinding=P;function f(l,a){const s=!!(l&2048),u=!!(l&256),t=a===2?u:s,r=!!(l&1024),o=!!(l&512),d=a===2?s:u,c=l&255;return new h(t,r,o,d,c)}e.createSimpleKeybinding=f;class h{constructor(a,s,u,t,r){this.ctrlKey=a,this.shiftKey=s,this.altKey=u,this.metaKey=t,this.keyCode=r}equals(a){return this.ctrlKey===a.ctrlKey&&this.shiftKey===a.shiftKey&&this.altKey===a.altKey&&this.metaKey===a.metaKey&&this.keyCode===a.keyCode}getHashCode(){const a=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",u=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${a}${s}${u}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new v([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=h;class v{constructor(a){if(a.length===0)throw w.illegalArgument("parts");this.parts=a}getHashCode(){let a="";for(let s=0,u=this.parts.length;s<u;s++)s!==0&&(a+=";"),a+=this.parts[s].getHashCode();return a}equals(a){if(a===null||this.parts.length!==a.parts.length)return!1;for(let s=0;s<this.parts.length;s++)if(!this.parts[s].equals(a.parts[s]))return!1;return!0}}e.ChordKeybinding=v;class p{constructor(a,s,u,t,r,o){this.ctrlKey=a,this.shiftKey=s,this.altKey=u,this.metaKey=t,this.keyLabel=r,this.keyAriaLabel=o}}e.ResolvedKeybindingPart=p;class b{}e.ResolvedKeybinding=b}),define(Q[2],J([0,1,44,63]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const D=!1;let y=null;function M(a){y=a}if(e.setDisposableTracker=M,D){const a="__is_disposable_tracked__";y=new class{trackDisposable(s){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[a]||console.log(u)},3e3)}markTracked(s){if(s&&s!==v.None)try{s[a]=!0}catch(u){}}}}function n(a){!y||y.markTracked(a)}function S(a){return y&&y.trackDisposable(a),a}e.trackDisposable=S;class i extends Error{constructor(s){super(`Encounter errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=i;function E(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=E;function m(a){if(R.Iterable.is(a)){let s=[];for(const u of a)if(u){n(u);try{u.dispose()}catch(t){s.push(t)}}if(s.length===1)throw s[0];if(s.length>1)throw new i(s);return Array.isArray(a)?[]:a}else if(a)return n(a),a.dispose(),a}e.dispose=m;function P(...a){return a.forEach(n),f(()=>m(a))}e.combinedDisposable=P;function f(a){const s=S({dispose:()=>{n(s),a()}});return s}e.toDisposable=f;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(n(this),this._isDisposed=!0,this.clear())}clear(){try{m(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return n(s),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new h,S(this)}dispose(){n(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value&&this._value.dispose(),s&&n(s),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,n(this),this._value&&this._value.dispose(),this._value=void 0}}e.MutableDisposable=p;class b{constructor(){this.references=new Map}acquire(s,...u){let t=this.references.get(s);t||(t={counter:0,object:this.createReferencedObject(s,...u)},this.references.set(s,t));const{object:r}=t,o=w.once(()=>{--t.counter==0&&(this.destroyReferencedObject(s,t.object),this.references.delete(s))});return t.counter++,{object:r,dispose:o}}}e.ReferenceCollection=b;class l{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=l}),define(Q[100],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(y){this.element=y,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class R{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,M){const n=new w(y);if(this._first===w.Undefined)this._first=n,this._last=n;else if(M){const i=this._last;this._last=n,n.prev=i,i.next=n}else{const i=this._first;this._first=n,n.next=i,i.prev=n}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(n))}}shift(){if(this._first!==w.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==w.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==w.Undefined&&y.next!==w.Undefined){const M=y.prev;M.next=y.next,y.next.prev=M}else y.prev===w.Undefined&&y.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):y.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):y.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==w.Undefined;)yield y.element,y=y.next}}e.LinkedList=R});"use strict";function rt($){const e=[];typeof $=="number"&&e.push("code/timeOrigin",$);function w(D){e.push(D,Date.now())}function R(){const D=[];for(let y=0;y<e.length;y+=2)D.push({name:e[y],startTime:e[y+1]});return D}return{mark:w,getMarks:R}}function Wt(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?rt():{mark($){performance.mark($)},getMarks(){let $=performance.timeOrigin;typeof $!="number"&&($=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const e=[{name:"code/timeOrigin",startTime:Math.round($)}];for(const w of performance.getEntriesByType("mark"))e.push({name:w.name,startTime:Math.round($+w.startTime)});return e}};if(typeof process=="object"){const $=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return rt($)}else return console.trace("perf-util loaded in UNKNOWN environment"),rt()}function st($){return $.MonacoPerformanceMarks||($.MonacoPerformanceMarks=Wt()),$.MonacoPerformanceMarks}var Ve;typeof global=="object"?Ve=global:typeof self=="object"?Ve=self:Ve={},typeof define=="function"?define("vs/base/common/performance",[],function(){return st(Ve)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=st(Ve):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),Ve.perf=st(Ve)),define(Q[3],J([0,1]),function($,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.globals=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=void 0;const R="en";let D=!1,y=!1,M=!1,n=!1,S=!1,i=!1,E=!1,m,P=R,f,h;const v=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof process!="undefined"?p=process:typeof v.vscode!="undefined"&&(p=v.vscode.process);const b=typeof((w=p==null?void 0:p.versions)===null||w===void 0?void 0:w.electron)=="string"&&p.type==="renderer";if(e.isElectronSandboxed=b&&(p==null?void 0:p.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const c=p==null?void 0:p.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof c=="string")return c==="none"||c==="code"||c==="bypassHeatCheck"||c==="bypassHeatCheckAndEagerCompile"?c:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!b)h=navigator.userAgent,D=h.indexOf("Windows")>=0,y=h.indexOf("Macintosh")>=0,E=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=h.indexOf("Linux")>=0,i=!0,m=navigator.language,P=m;else if(typeof p=="object"){D=p.platform==="win32",y=p.platform==="darwin",M=p.platform==="linux",n=M&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,m=R,P=R;const c=p.env.VSCODE_NLS_CONFIG;if(c)try{const g=JSON.parse(c),I=g.availableLanguages["*"];m=g.locale,P=I||R,f=g._translationsConfigFile}catch(g){}S=!0}else console.error("Unable to resolve platform.");var l;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(l=e.Platform||(e.Platform={}));function a(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=a;let s=0;y?s=1:D?s=3:M&&(s=2),e.isWindows=D,e.isMacintosh=y,e.isLinux=M,e.isLinuxSnap=n,e.isNative=S,e.isWeb=i,e.isIOS=E,e.platform=s,e.userAgent=h,e.language=P;var u;(function(c){function g(){return e.language}c.value=g;function I(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}c.isDefaultVariant=I;function A(){return e.language==="en"}c.isDefault=A})(u=e.Language||(e.Language={})),e.locale=m,e.translationsConfigFile=f,e.globals=v,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let I=[];e.globals.addEventListener("message",T=>{if(T.data&&T.data.vscodeSetImmediateId)for(let U=0,j=I.length;U<j;U++){const C=I[U];if(C.id===T.data.vscodeSetImmediateId){I.splice(U,1),C.callback();return}}});let A=0;return T=>{const U=++A;I.push({id:U,callback:T}),e.globals.postMessage({vscodeSetImmediateId:U},"*")}}if(p)return p.nextTick.bind(p);const g=Promise.resolve();return I=>g.then(I)}();var t;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||E?2:D?1:3;let r=!0,o=!1;function d(){if(!o){o=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,r=new Uint16Array(c.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=d}),define(Q[52],J([0,1,3]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;typeof process!="undefined"?R=process:typeof w.globals.vscode!="undefined"?R={get platform(){return w.globals.vscode.process.platform},get env(){return w.globals.vscode.process.env},nextTick(D){return w.setImmediate(D)},cwd(){return w.globals.vscode.process.env.VSCODE_CWD||w.globals.vscode.process.execPath.substr(0,w.globals.vscode.process.execPath.lastIndexOf(w.globals.vscode.process.platform==="win32"?"\\":"/"))}}:R={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},nextTick(D){return w.setImmediate(D)},get env(){return Object.create(null)},cwd(){return"/"}},e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(Q[6],J([0,1,52]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,D=97,y=90,M=122,n=46,S=47,i=92,E=58,m=63;class P extends Error{constructor(s,u,t){let r;typeof u=="string"&&u.indexOf("not ")===0?(r="must not be",u=u.replace(/^not /,"")):r="must be";const o=s.indexOf(".")!==-1?"property":"argument";let d=`The "${s}" ${o} ${r} of type ${u}`;d+=`. Received type ${typeof t}`,super(d),this.code="ERR_INVALID_ARG_TYPE"}}function f(a,s){if(typeof a!="string")throw new P(s,"string",a)}function h(a){return a===S||a===i}function v(a){return a===S}function p(a){return a>=R&&a<=y||a>=D&&a<=M}function b(a,s,u,t){let r="",o=0,d=-1,c=0,g=0;for(let I=0;I<=a.length;++I){if(I<a.length)g=a.charCodeAt(I);else{if(t(g))break;g=S}if(t(g)){if(!(d===I-1||c===1))if(c===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==n||r.charCodeAt(r.length-2)!==n){if(r.length>2){const A=r.lastIndexOf(u);A===-1?(r="",o=0):(r=r.slice(0,A),o=r.length-1-r.lastIndexOf(u)),d=I,c=0;continue}else if(r.length!==0){r="",o=0,d=I,c=0;continue}}s&&(r+=r.length>0?`${u}..`:"..",o=2)}else r.length>0?r+=`${u}${a.slice(d+1,I)}`:r=a.slice(d+1,I),o=I-d-1;d=I,c=0}else g===n&&c!==-1?++c:c=-1}return r}function l(a,s){if(s===null||typeof s!="object")throw new P("pathObject","Object",s);const u=s.dir||s.root,t=s.base||`${s.name||""}${s.ext||""}`;return u?u===s.root?`${u}${t}`:`${u}${a}${t}`:t}e.win32={resolve(...a){let s="",u="",t=!1;for(let r=a.length-1;r>=-1;r--){let o;if(r>=0){if(o=a[r],f(o,"path"),o.length===0)continue}else s.length===0?o=w.cwd():(o=w.env[`=${s}`]||w.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==s.toLowerCase()&&o.charCodeAt(2)===i)&&(o=`${s}\\`));const d=o.length;let c=0,g="",I=!1;const A=o.charCodeAt(0);if(d===1)h(A)&&(c=1,I=!0);else if(h(A))if(I=!0,h(o.charCodeAt(1))){let T=2,U=T;for(;T<d&&!h(o.charCodeAt(T));)T++;if(T<d&&T!==U){const j=o.slice(U,T);for(U=T;T<d&&h(o.charCodeAt(T));)T++;if(T<d&&T!==U){for(U=T;T<d&&!h(o.charCodeAt(T));)T++;(T===d||T!==U)&&(g=`\\\\${j}\\${o.slice(U,T)}`,c=T)}}}else c=1;else p(A)&&o.charCodeAt(1)===E&&(g=o.slice(0,2),c=2,d>2&&h(o.charCodeAt(2))&&(I=!0,c=3));if(g.length>0)if(s.length>0){if(g.toLowerCase()!==s.toLowerCase())continue}else s=g;if(t){if(s.length>0)break}else if(u=`${o.slice(c)}\\${u}`,t=I,I&&s.length>0)break}return u=b(u,!t,"\\",h),t?`${s}\\${u}`:`${s}${u}`||"."},normalize(a){f(a,"path");const s=a.length;if(s===0)return".";let u=0,t,r=!1;const o=a.charCodeAt(0);if(s===1)return v(o)?"\\":a;if(h(o))if(r=!0,h(a.charCodeAt(1))){let c=2,g=c;for(;c<s&&!h(a.charCodeAt(c));)c++;if(c<s&&c!==g){const I=a.slice(g,c);for(g=c;c<s&&h(a.charCodeAt(c));)c++;if(c<s&&c!==g){for(g=c;c<s&&!h(a.charCodeAt(c));)c++;if(c===s)return`\\\\${I}\\${a.slice(g)}\\`;c!==g&&(t=`\\\\${I}\\${a.slice(g,c)}`,u=c)}}}else u=1;else p(o)&&a.charCodeAt(1)===E&&(t=a.slice(0,2),u=2,s>2&&h(a.charCodeAt(2))&&(r=!0,u=3));let d=u<s?b(a.slice(u),!r,"\\",h):"";return d.length===0&&!r&&(d="."),d.length>0&&h(a.charCodeAt(s-1))&&(d+="\\"),t===void 0?r?`\\${d}`:d:r?`${t}\\${d}`:`${t}${d}`},isAbsolute(a){f(a,"path");const s=a.length;if(s===0)return!1;const u=a.charCodeAt(0);return h(u)||s>2&&p(u)&&a.charCodeAt(1)===E&&h(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let s,u;for(let o=0;o<a.length;++o){const d=a[o];f(d,"path"),d.length>0&&(s===void 0?s=u=d:s+=`\\${d}`)}if(s===void 0)return".";let t=!0,r=0;if(typeof u=="string"&&h(u.charCodeAt(0))){++r;const o=u.length;o>1&&h(u.charCodeAt(1))&&(++r,o>2&&(h(u.charCodeAt(2))?++r:t=!1))}if(t){for(;r<s.length&&h(s.charCodeAt(r));)r++;r>=2&&(s=`\\${s.slice(r)}`)}return e.win32.normalize(s)},relative(a,s){if(f(a,"from"),f(s,"to"),a===s)return"";const u=e.win32.resolve(a),t=e.win32.resolve(s);if(u===t||(a=u.toLowerCase(),s=t.toLowerCase(),a===s))return"";let r=0;for(;r<a.length&&a.charCodeAt(r)===i;)r++;let o=a.length;for(;o-1>r&&a.charCodeAt(o-1)===i;)o--;const d=o-r;let c=0;for(;c<s.length&&s.charCodeAt(c)===i;)c++;let g=s.length;for(;g-1>c&&s.charCodeAt(g-1)===i;)g--;const I=g-c,A=d<I?d:I;let T=-1,U=0;for(;U<A;U++){const C=a.charCodeAt(r+U);if(C!==s.charCodeAt(c+U))break;C===i&&(T=U)}if(U!==A){if(T===-1)return t}else{if(I>A){if(s.charCodeAt(c+U)===i)return t.slice(c+U+1);if(U===2)return t.slice(c+U)}d>A&&(a.charCodeAt(r+U)===i?T=U:U===2&&(T=3)),T===-1&&(T=0)}let j="";for(U=r+T+1;U<=o;++U)(U===o||a.charCodeAt(U)===i)&&(j+=j.length===0?"..":"\\..");return c+=T,j.length>0?`${j}${t.slice(c,g)}`:(t.charCodeAt(c)===i&&++c,t.slice(c,g))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const s=e.win32.resolve(a);if(s.length<=2)return a;if(s.charCodeAt(0)===i){if(s.charCodeAt(1)===i){const u=s.charCodeAt(2);if(u!==m&&u!==n)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(p(s.charCodeAt(0))&&s.charCodeAt(1)===E&&s.charCodeAt(2)===i)return`\\\\?\\${s}`;return a},dirname(a){f(a,"path");const s=a.length;if(s===0)return".";let u=-1,t=0;const r=a.charCodeAt(0);if(s===1)return h(r)?a:".";if(h(r)){if(u=t=1,h(a.charCodeAt(1))){let c=2,g=c;for(;c<s&&!h(a.charCodeAt(c));)c++;if(c<s&&c!==g){for(g=c;c<s&&h(a.charCodeAt(c));)c++;if(c<s&&c!==g){for(g=c;c<s&&!h(a.charCodeAt(c));)c++;if(c===s)return a;c!==g&&(u=t=c+1)}}}}else p(r)&&a.charCodeAt(1)===E&&(u=s>2&&h(a.charCodeAt(2))?3:2,t=u);let o=-1,d=!0;for(let c=s-1;c>=t;--c)if(h(a.charCodeAt(c))){if(!d){o=c;break}}else d=!1;if(o===-1){if(u===-1)return".";o=u}return a.slice(0,o)},basename(a,s){s!==void 0&&f(s,"ext"),f(a,"path");let u=0,t=-1,r=!0,o;if(a.length>=2&&p(a.charCodeAt(0))&&a.charCodeAt(1)===E&&(u=2),s!==void 0&&s.length>0&&s.length<=a.length){if(s===a)return"";let d=s.length-1,c=-1;for(o=a.length-1;o>=u;--o){const g=a.charCodeAt(o);if(h(g)){if(!r){u=o+1;break}}else c===-1&&(r=!1,c=o+1),d>=0&&(g===s.charCodeAt(d)?--d==-1&&(t=o):(d=-1,t=c))}return u===t?t=c:t===-1&&(t=a.length),a.slice(u,t)}for(o=a.length-1;o>=u;--o)if(h(a.charCodeAt(o))){if(!r){u=o+1;break}}else t===-1&&(r=!1,t=o+1);return t===-1?"":a.slice(u,t)},extname(a){f(a,"path");let s=0,u=-1,t=0,r=-1,o=!0,d=0;a.length>=2&&a.charCodeAt(1)===E&&p(a.charCodeAt(0))&&(s=t=2);for(let c=a.length-1;c>=s;--c){const g=a.charCodeAt(c);if(h(g)){if(!o){t=c+1;break}continue}r===-1&&(o=!1,r=c+1),g===n?u===-1?u=c:d!==1&&(d=1):u!==-1&&(d=-1)}return u===-1||r===-1||d===0||d===1&&u===r-1&&u===t+1?"":a.slice(u,r)},format:l.bind(null,"\\"),parse(a){f(a,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return s;const u=a.length;let t=0,r=a.charCodeAt(0);if(u===1)return h(r)?(s.root=s.dir=a,s):(s.base=s.name=a,s);if(h(r)){if(t=1,h(a.charCodeAt(1))){let T=2,U=T;for(;T<u&&!h(a.charCodeAt(T));)T++;if(T<u&&T!==U){for(U=T;T<u&&h(a.charCodeAt(T));)T++;if(T<u&&T!==U){for(U=T;T<u&&!h(a.charCodeAt(T));)T++;T===u?t=T:T!==U&&(t=T+1)}}}}else if(p(r)&&a.charCodeAt(1)===E){if(u<=2)return s.root=s.dir=a,s;if(t=2,h(a.charCodeAt(2))){if(u===3)return s.root=s.dir=a,s;t=3}}t>0&&(s.root=a.slice(0,t));let o=-1,d=t,c=-1,g=!0,I=a.length-1,A=0;for(;I>=t;--I){if(r=a.charCodeAt(I),h(r)){if(!g){d=I+1;break}continue}c===-1&&(g=!1,c=I+1),r===n?o===-1?o=I:A!==1&&(A=1):o!==-1&&(A=-1)}return c!==-1&&(o===-1||A===0||A===1&&o===c-1&&o===d+1?s.base=s.name=a.slice(d,c):(s.name=a.slice(d,o),s.base=a.slice(d,c),s.ext=a.slice(o,c))),d>0&&d!==t?s.dir=a.slice(0,d-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let s="",u=!1;for(let t=a.length-1;t>=-1&&!u;t--){const r=t>=0?a[t]:w.cwd();f(r,"path"),r.length!==0&&(s=`${r}/${s}`,u=r.charCodeAt(0)===S)}return s=b(s,!u,"/",v),u?`/${s}`:s.length>0?s:"."},normalize(a){if(f(a,"path"),a.length===0)return".";const s=a.charCodeAt(0)===S,u=a.charCodeAt(a.length-1)===S;return a=b(a,!s,"/",v),a.length===0?s?"/":u?"./":".":(u&&(a+="/"),s?`/${a}`:a)},isAbsolute(a){return f(a,"path"),a.length>0&&a.charCodeAt(0)===S},join(...a){if(a.length===0)return".";let s;for(let u=0;u<a.length;++u){const t=a[u];f(t,"path"),t.length>0&&(s===void 0?s=t:s+=`/${t}`)}return s===void 0?".":e.posix.normalize(s)},relative(a,s){if(f(a,"from"),f(s,"to"),a===s||(a=e.posix.resolve(a),s=e.posix.resolve(s),a===s))return"";const u=1,t=a.length,r=t-u,o=1,d=s.length-o,c=r<d?r:d;let g=-1,I=0;for(;I<c;I++){const T=a.charCodeAt(u+I);if(T!==s.charCodeAt(o+I))break;T===S&&(g=I)}if(I===c)if(d>c){if(s.charCodeAt(o+I)===S)return s.slice(o+I+1);if(I===0)return s.slice(o+I)}else r>c&&(a.charCodeAt(u+I)===S?g=I:I===0&&(g=0));let A="";for(I=u+g+1;I<=t;++I)(I===t||a.charCodeAt(I)===S)&&(A+=A.length===0?"..":"/..");return`${A}${s.slice(o+g)}`},toNamespacedPath(a){return a},dirname(a){if(f(a,"path"),a.length===0)return".";const s=a.charCodeAt(0)===S;let u=-1,t=!0;for(let r=a.length-1;r>=1;--r)if(a.charCodeAt(r)===S){if(!t){u=r;break}}else t=!1;return u===-1?s?"/":".":s&&u===1?"//":a.slice(0,u)},basename(a,s){s!==void 0&&f(s,"ext"),f(a,"path");let u=0,t=-1,r=!0,o;if(s!==void 0&&s.length>0&&s.length<=a.length){if(s===a)return"";let d=s.length-1,c=-1;for(o=a.length-1;o>=0;--o){const g=a.charCodeAt(o);if(g===S){if(!r){u=o+1;break}}else c===-1&&(r=!1,c=o+1),d>=0&&(g===s.charCodeAt(d)?--d==-1&&(t=o):(d=-1,t=c))}return u===t?t=c:t===-1&&(t=a.length),a.slice(u,t)}for(o=a.length-1;o>=0;--o)if(a.charCodeAt(o)===S){if(!r){u=o+1;break}}else t===-1&&(r=!1,t=o+1);return t===-1?"":a.slice(u,t)},extname(a){f(a,"path");let s=-1,u=0,t=-1,r=!0,o=0;for(let d=a.length-1;d>=0;--d){const c=a.charCodeAt(d);if(c===S){if(!r){u=d+1;break}continue}t===-1&&(r=!1,t=d+1),c===n?s===-1?s=d:o!==1&&(o=1):s!==-1&&(o=-1)}return s===-1||t===-1||o===0||o===1&&s===t-1&&s===u+1?"":a.slice(s,t)},format:l.bind(null,"/"),parse(a){f(a,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return s;const u=a.charCodeAt(0)===S;let t;u?(s.root="/",t=1):t=0;let r=-1,o=0,d=-1,c=!0,g=a.length-1,I=0;for(;g>=t;--g){const A=a.charCodeAt(g);if(A===S){if(!c){o=g+1;break}continue}d===-1&&(c=!1,d=g+1),A===n?r===-1?r=g:I!==1&&(I=1):r!==-1&&(I=-1)}if(d!==-1){const A=o===0&&u?1:o;r===-1||I===0||I===1&&r===d-1&&r===o+1?s.base=s.name=a.slice(A,d):(s.name=a.slice(A,r),s.base=a.slice(A,d),s.ext=a.slice(r,d))}return o>0?s.dir=a.slice(0,o-1):u&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Q[74],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var w;(function(n){n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(w=e.ScanCode||(e.ScanCode={}));const R=[],D=Object.create(null),y=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>y[n]||0,toEnum:n=>D[n]||0,toString:n=>R[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class M{constructor(S,i,E,m,P){this.ctrlKey=S,this.shiftKey=i,this.altKey=E,this.metaKey=m,this.scanCode=P}equals(S){return this.ctrlKey===S.ctrlKey&&this.shiftKey===S.shiftKey&&this.altKey===S.altKey&&this.metaKey===S.metaKey&&this.scanCode===S.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=M,function(){function n(S,i){R[S]=i,D[i]=S,y[i.toLowerCase()]=S}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let S=0;S<=193;S++)e.IMMUTABLE_CODE_TO_KEY_CODE[S]=-1;for(let S=0;S<=112;S++)e.IMMUTABLE_KEY_CODE_TO_CODE[S]=-1;function n(S,i){e.IMMUTABLE_CODE_TO_KEY_CODE[S]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[i]=S)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(Q[101],J([0,1,56,74]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(M){M=M.toLowerCase().trim();let n=!1,S=!1,i=!1,E=!1,m;do m=!1,/^ctrl(\+|\-)/.test(M)&&(n=!0,M=M.substr("ctrl-".length),m=!0),/^shift(\+|\-)/.test(M)&&(S=!0,M=M.substr("shift-".length),m=!0),/^alt(\+|\-)/.test(M)&&(i=!0,M=M.substr("alt-".length),m=!0),/^meta(\+|\-)/.test(M)&&(E=!0,M=M.substr("meta-".length),m=!0),/^win(\+|\-)/.test(M)&&(E=!0,M=M.substr("win-".length),m=!0),/^cmd(\+|\-)/.test(M)&&(E=!0,M=M.substr("cmd-".length),m=!0);while(m);let P;const f=M.indexOf(" ");return f>0?(P=M.substring(0,f),M=M.substring(f)):(P=M,M=""),{remains:M,ctrl:n,shift:S,alt:i,meta:E,key:P}}static parseSimpleKeybinding(M){const n=this._readModifiers(M),S=w.KeyCodeUtils.fromUserSettings(n.key);return[new w.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,S),n.remains]}static parseKeybinding(M,n){if(!M)return null;const S=[];let i;do[i,M]=this.parseSimpleKeybinding(M),S.push(i);while(M.length>0);return new w.ChordKeybinding(S)}static parseSimpleUserBinding(M){const n=this._readModifiers(M),S=n.key.match(/^\[([^\]]+)\]$/);if(S){const E=S[1],m=R.ScanCodeUtils.lowerCaseToEnum(E);return[new R.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,m),n.remains]}const i=w.KeyCodeUtils.fromUserSettings(n.key);return[new w.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,i),n.remains]}static parseUserBinding(M){if(!M)return[];const n=[];let S;for(;M.length>0;)[S,M]=this.parseSimpleUserBinding(M),n.push(S);return n}}e.KeybindingParser=D}),define(Q[102],J([0,1,3]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=w.globals.performance&&typeof w.globals.performance.now=="function";class D{constructor(M){this._highResolution=R&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new D(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=D}),define(Q[4],J([0,1,16,44,2,100,102]),function($,e,w,R,D,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.AsyncEmitter=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(l){l.None=()=>D.Disposable.None;function a(H){return(N,q=null,F)=>{let z=!1,O;return O=H(k=>{if(!z)return O?O.dispose():z=!0,N.call(q,k)},null,F),z&&O.dispose(),O}}l.once=a;function s(H,N){return c((q,F=null,z)=>H(O=>q.call(F,N(O)),null,z))}l.map=s;function u(H,N){return c((q,F=null,z)=>H(O=>{N(O),q.call(F,O)},null,z))}l.forEach=u;function t(H,N){return c((q,F=null,z)=>H(O=>N(O)&&q.call(F,O),null,z))}l.filter=t;function r(H){return H}l.signal=r;function o(...H){return(N,q=null,F)=>D.combinedDisposable(...H.map(z=>z(O=>N.call(q,O),null,F)))}l.any=o;function d(H,N,q){let F=q;return s(H,z=>(F=N(F,z),F))}l.reduce=d;function c(H){let N;const q=new P({onFirstListenerAdd(){N=H(q.fire,q)},onLastListenerRemove(){N.dispose()}});return q.event}l.snapshot=c;function g(H,N,q=100,F=!1,z){let O,k,L,_=0;const W=new P({leakWarningThreshold:z,onFirstListenerAdd(){O=H(B=>{_++,k=N(k,B),F&&!L&&(W.fire(k),k=void 0),clearTimeout(L),L=setTimeout(()=>{const K=k;k=void 0,L=void 0,(!F||_>1)&&W.fire(K),_=0},q)})},onLastListenerRemove(){O.dispose()}});return W.event}l.debounce=g;function I(H){const N=new Date().getTime();return s(a(H),q=>new Date().getTime()-N)}l.stopwatch=I;function A(H){let N=!0,q;return t(H,F=>{const z=N||F!==q;return N=!1,q=F,z})}l.latch=A;function T(H,N=!1,q=[]){let F=q.slice(),z=H(L=>{F?F.push(L):k.fire(L)});const O=()=>{F&&F.forEach(L=>k.fire(L)),F=null},k=new P({onFirstListenerAdd(){z||(z=H(L=>k.fire(L)))},onFirstListenerDidAdd(){F&&(N?setTimeout(O):O())},onLastListenerRemove(){z&&z.dispose(),z=null}});return k.event}l.buffer=T;class U{constructor(N){this.event=N}map(N){return new U(s(this.event,N))}forEach(N){return new U(u(this.event,N))}filter(N){return new U(t(this.event,N))}reduce(N,q){return new U(d(this.event,N,q))}latch(){return new U(A(this.event))}debounce(N,q=100,F=!1,z){return new U(g(this.event,N,q,F,z))}on(N,q,F){return this.event(N,q,F)}once(N,q,F){return a(this.event)(N,q,F)}}function j(H){return new U(H)}l.chain=j;function C(H,N,q=F=>F){const F=(...L)=>k.fire(q(...L)),z=()=>H.on(N,F),O=()=>H.removeListener(N,F),k=new P({onFirstListenerAdd:z,onLastListenerRemove:O});return k.event}l.fromNodeEventEmitter=C;function x(H,N,q=F=>F){const F=(...L)=>k.fire(q(...L)),z=()=>H.addEventListener(N,F),O=()=>H.removeEventListener(N,F),k=new P({onFirstListenerAdd:z,onLastListenerRemove:O});return k.event}l.fromDOMEventEmitter=x;function ee(H){const N=new P;let q=!1;return H.then(void 0,()=>null).then(()=>{q?N.fire(void 0):setTimeout(()=>N.fire(void 0),0)}),q=!0,N.event}l.fromPromise=ee;function Z(H){return new Promise(N=>a(H)(N))}l.toPromise=Z})(n=e.Event||(e.Event={}));class S{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${S._idPool++}`}start(a){this._stopWatch=new M.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let i=-1;function E(l){const a=i;return i=l,{dispose(){i=a}}}e.setGlobalLeakWarningThreshold=E;class m{constructor(a,s=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let s=i;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),!(s<=0||a<s)){this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),t=this._stacks.get(u)||0;if(this._stacks.set(u,t+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let r,o=0;for(const[d,c]of this._stacks)(!r||o<c)&&(r=d,o=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${o}):`),console.warn(r)}return()=>{const r=this._stacks.get(u)||0;this._stacks.set(u,r-1)}}}}class P{constructor(a){var s;this._disposed=!1,this._options=a,this._leakageMon=i>0?new m(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((s=this._options)===null||s===void 0?void 0:s._profName)?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(a,s,u)=>{var t;this._listeners||(this._listeners=new y.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const o=this._listeners.push(s?[a,s]:a);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,s);const d=(t=this._leakageMon)===null||t===void 0?void 0:t.check(this._listeners.size);let c;return c={dispose:()=>{d&&d(),c.dispose=P._noop,this._disposed||(o(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},u instanceof D.DisposableStore?u.add(c):Array.isArray(u)&&u.push(c),c}),this._event}fire(a){var s,u;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,a]);for((s=this._perfMon)===null||s===void 0||s.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,r]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,r):t[0].call(t[1],r)}catch(o){w.onUnexpectedError(o)}}(u=this._perfMon)===null||u===void 0||u.stop()}}dispose(){var a,s,u;(a=this._listeners)===null||a===void 0||a.clear(),(s=this._deliveryQueue)===null||s===void 0||s.clear(),(u=this._leakageMon)===null||u===void 0||u.dispose(),this._disposed=!0}}e.Emitter=P,P._noop=function(){};class f extends P{constructor(a){super(a);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=a==null?void 0:a.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=f;class h extends P{async fireAsync(a,s,u){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const t of this._listeners)this._asyncDeliveryQueue.push([t,a]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[t,r]=this._asyncDeliveryQueue.shift(),o=[],d=Object.assign(Object.assign({},r),{waitUntil:c=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");u&&(c=u(c,typeof t=="function"?t:t[0])),o.push(c)}});try{typeof t=="function"?t.call(void 0,d):t[0].call(t[1],d)}catch(c){w.onUnexpectedError(c);continue}Object.freeze(o),await Promise.all(o).catch(c=>w.onUnexpectedError(c))}}}}e.AsyncEmitter=h;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new P({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const s={event:a,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const u=()=>{this.hasListeners&&this.unhook(s);const t=this.events.indexOf(s);this.events.splice(t,1)};return D.toDisposable(R.once(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(s=>this.emitter.fire(s))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=v;class p{constructor(){this.buffers=[]}wrapEvent(a){return(s,u,t)=>a(r=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>s.call(u,r)):s.call(u,r)},void 0,t)}bufferEvents(a){const s=[];this.buffers.push(s);const u=a();return this.buffers.pop(),s.forEach(t=>t()),u}}e.EventBufferer=p;class b{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=D.Disposable.None,this.emitter=new P({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=b}),define(Q[24],J([0,1,4]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(n,S){const i=setTimeout(n.bind(S),0);return{dispose(){clearTimeout(i)}}});var D;(function(n){function S(i){return i===n.None||i===n.Cancelled||i instanceof y?!0:!i||typeof i!="object"?!1:typeof i.isCancellationRequested=="boolean"&&typeof i.onCancellationRequested=="function"}n.isCancellationToken=S,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(D=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=D.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=M}),define(Q[9],J([0,1,24,16,4,2]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function M(Z){return Z&&typeof Z.then=="function"}e.isThenable=M;function n(Z){const H=new w.CancellationTokenSource,N=Z(H.token),q=new Promise((F,z)=>{H.token.onCancellationRequested(()=>{z(R.canceled())}),Promise.resolve(N).then(O=>{H.dispose(),F(O)},O=>{H.dispose(),z(O)})});return new class{cancel(){H.cancel()}then(F,z){return q.then(F,z)}catch(F){return this.then(void 0,F)}finally(F){return q.finally(F)}}}e.createCancelablePromise=n;function S(Z,H,N){return Promise.race([Z,new Promise(q=>H.onCancellationRequested(()=>q(N)))])}e.raceCancellation=S;async function i(Z){let H=-1;const N=Z.map((F,z)=>F.then(O=>(H=z,O))),q=await Promise.race(N);return Z.forEach((F,z)=>{z!==H&&F.cancel()}),q}e.raceCancellablePromises=i;function E(Z,H,N){let q;const F=setTimeout(()=>{q==null||q(void 0),N==null||N()},H);return Promise.race([Z.finally(()=>clearTimeout(F)),new Promise(z=>q=z)])}e.raceTimeout=E;function m(Z){return new Promise((H,N)=>{const q=Z();M(q)?q.then(H,N):H(q)})}e.asPromise=m;class P{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(H){if(this.activePromise){if(this.queuedPromiseFactory=H,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,q};this.queuedPromise=new Promise(q=>{this.activePromise.then(N,N).then(q)})}return new Promise((N,q)=>{this.queuedPromise.then(N,q)})}return this.activePromise=H(),new Promise((N,q)=>{this.activePromise.then(F=>{this.activePromise=null,N(F)},F=>{this.activePromise=null,q(F)})})}}e.Throttler=P;class f{constructor(){this.current=Promise.resolve(null)}queue(H){return this.current=this.current.then(()=>H(),()=>H())}}e.Sequencer=f;class h{constructor(){this.promiseMap=new Map}queue(H,N){var q;const z=((q=this.promiseMap.get(H))!==null&&q!==void 0?q:Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(H)===z&&this.promiseMap.delete(H)});return this.promiseMap.set(H,z),z}}e.SequencerByKey=h;class v{constructor(H){this.defaultDelay=H,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(H,N=this.defaultDelay){return this.task=H,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((q,F)=>{this.doResolve=q,this.doReject=F}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const q=this.task;return this.task=null,q()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},N),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(R.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=v;class p{constructor(H){this.delayer=new v(H),this.throttler=new P}trigger(H,N){return this.delayer.trigger(()=>this.throttler.queue(H),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=p;class b{constructor(){this._isOpen=!1,this._promise=new Promise((H,N)=>{this._completePromise=H})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;function l(Z,H){return H?new Promise((N,q)=>{const F=setTimeout(N,Z);H.onCancellationRequested(()=>{clearTimeout(F),q(R.canceled())})}):n(N=>l(Z,N))}e.timeout=l;function a(Z,H=0){const N=setTimeout(Z,H);return y.toDisposable(()=>clearTimeout(N))}e.disposableTimeout=a;function s(Z){return Z.then(void 0,H=>{})}e.ignoreErrors=s;function u(Z){const H=[];let N=0;const q=Z.length;function F(){return N<q?Z[N++]():null}function z(O){O!=null&&H.push(O);const k=F();return k?k.then(z):Promise.resolve(H)}return Promise.resolve(null).then(z)}e.sequence=u;function t(Z,H=q=>!!q,N=null){let q=0;const F=Z.length,z=()=>{if(q>=F)return Promise.resolve(N);const O=Z[q++];return Promise.resolve(O()).then(L=>H(L)?Promise.resolve(L):z())};return z()}e.first=t;function r(Z,H=q=>!!q,N=null){if(Z.length===0)return Promise.resolve(N);let q=Z.length;const F=()=>{var z,O;q=-1;for(const k of Z)(O=(z=k).cancel)===null||O===void 0||O.call(z)};return new Promise((z,O)=>{for(const k of Z)k.then(L=>{--q>=0&&H(L)?(F(),z(L)):q===0&&z(N)}).catch(L=>{--q>=0&&(F(),O(L))})})}e.firstParallel=r;class o{constructor(H){this._size=0,this.maxDegreeOfParalellism=H,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(H){return this._size++,new Promise((N,q)=>{this.outstandingPromises.push({factory:H,c:N,e:q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const H=this.outstandingPromises.shift();this.runningPromises++;const N=H.factory();N.then(H.c,H.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class d extends o{constructor(){super(1)}}e.Queue=d;class c{constructor(){this.queues=new Map}queueFor(H){const N=H.toString();if(!this.queues.has(N)){const q=new d;q.onFinished(()=>{q.dispose(),this.queues.delete(N)}),this.queues.set(N,q)}return this.queues.get(N)}dispose(){this.queues.forEach(H=>H.dispose()),this.queues.clear()}}e.ResourceQueue=c;class g{constructor(H,N){this._token=-1,typeof H=="function"&&typeof N=="number"&&this.setIfNotSet(H,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(H,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,H()},N)}setIfNotSet(H,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,H()},N))}}e.TimeoutTimer=g;class I{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(H,N){this.cancel(),this._token=setInterval(()=>{H()},N)}}e.IntervalTimer=I;class A{constructor(H,N){this.timeoutToken=-1,this.runner=H,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(H=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,H)}get delay(){return this.timeout}set delay(H){this.timeout=H}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=A;class T extends A{constructor(H,N){super(H,N);this.units=[]}work(H){this.units.push(H),this.isScheduled()||this.schedule()}doRun(){const H=this.units;this.units=[],this.runner&&this.runner(H)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=T,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const Z=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=H=>{const N=setTimeout(()=>H(Z));let q=!1;return{dispose(){q||(q=!0,clearTimeout(N))}}}}else e.runWhenIdle=(Z,H)=>{const N=requestIdleCallback(Z,typeof H=="number"?{timeout:H}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(N))}}}}();class U{constructor(H){this._didRun=!1,this._executor=()=>{try{this._value=H()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=U;async function j(Z,H,N){let q;for(let F=0;F<N;F++)try{return await Z()}catch(z){q=z,await l(H)}throw q}e.retry=j;class C{hasPending(H){return this._pending?typeof H=="number"?this._pending.taskId===H:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var H;(H=this._pending)===null||H===void 0||H.cancel()}setPending(H,N,q){return this._pending={taskId:H,cancel:()=>q==null?void 0:q(),promise:N},N.then(()=>this.donePending(H),()=>this.donePending(H)),N}donePending(H){this._pending&&H===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const H=this._next;this._next=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}setNext(H){if(this._next)this._next.run=H;else{let N,q;const F=new Promise((z,O)=>{N=z,q=O});this._next={run:H,promise:F,promiseResolve:N,promiseReject:q}}return this._next.promise}}e.TaskSequentializer=C;class x{constructor(H){this.interval=H,this.lastIncrementTime=0,this.value=0}increment(){const H=Date.now();return H-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=H,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class ee{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((H,N)=>{this.completeCallback=H,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(H){return new Promise(N=>{this.completeCallback(H),this.resolved=!0,N()})}error(H){return new Promise(N=>{this.errorCallback(H),this.rejected=!0,N()})}cancel(){new Promise(H=>{this.errorCallback(R.canceled()),this.rejected=!0,H()})}}e.DeferredPromise=ee}),define(Q[103],J([0,1,4]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new w.Emitter}add(E){const m=this._icons.get(E.id);m?E.description?m.description=E.description:console.error(`Duplicate registration of codicon ${E.id}`):(this._icons.set(E.id,E),this._onDidRegister.fire(E))}get(E){return this._icons.get(E)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new R;e.iconRegistry=D;function y(i,E){return new M(i,E)}e.registerCodicon=y;class M{constructor(E,m,P){this.id=E,this.definition=m,this.description=P,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=M;function n(i,E){const m=["codicon","codicon-"+i];return E&&m.push("codicon-modifier-"+E),m}e.getClassNamesArray=n;var S;(function(i){i.iconIdRegex=/^(codicon\/)?([a-z\-]+)(?:~([a-z\-]+))?$/i;function E(f){if(f instanceof M)return["codicon","codicon-"+f.id];const h=i.iconIdRegex.exec(f.id);if(!h)return E(M.error);let[,,v,p]=h;const b=["codicon","codicon-"+v];return p&&b.push("codicon-modifier-"+p),b}i.asClassNameArray=E;function m(f){return E(f).join(" ")}i.asClassName=m;function P(f){return"."+E(f).join(".")}i.asCSSSelector=P})(S=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{character:"\\ea60"}),i.plus=new i("plus",{character:"\\ea60"}),i.gistNew=new i("gist-new",{character:"\\ea60"}),i.repoCreate=new i("repo-create",{character:"\\ea60"}),i.lightbulb=new i("lightbulb",{character:"\\ea61"}),i.lightBulb=new i("light-bulb",{character:"\\ea61"}),i.repo=new i("repo",{character:"\\ea62"}),i.repoDelete=new i("repo-delete",{character:"\\ea62"}),i.gistFork=new i("gist-fork",{character:"\\ea63"}),i.repoForked=new i("repo-forked",{character:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{character:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{character:"\\ea64"}),i.recordKeys=new i("record-keys",{character:"\\ea65"}),i.keyboard=new i("keyboard",{character:"\\ea65"}),i.tag=new i("tag",{character:"\\ea66"}),i.tagAdd=new i("tag-add",{character:"\\ea66"}),i.tagRemove=new i("tag-remove",{character:"\\ea66"}),i.person=new i("person",{character:"\\ea67"}),i.personAdd=new i("person-add",{character:"\\ea67"}),i.personFollow=new i("person-follow",{character:"\\ea67"}),i.personOutline=new i("person-outline",{character:"\\ea67"}),i.personFilled=new i("person-filled",{character:"\\ea67"}),i.gitBranch=new i("git-branch",{character:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{character:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{character:"\\ea68"}),i.sourceControl=new i("source-control",{character:"\\ea68"}),i.mirror=new i("mirror",{character:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{character:"\\ea69"}),i.star=new i("star",{character:"\\ea6a"}),i.starAdd=new i("star-add",{character:"\\ea6a"}),i.starDelete=new i("star-delete",{character:"\\ea6a"}),i.starEmpty=new i("star-empty",{character:"\\ea6a"}),i.comment=new i("comment",{character:"\\ea6b"}),i.commentAdd=new i("comment-add",{character:"\\ea6b"}),i.alert=new i("alert",{character:"\\ea6c"}),i.warning=new i("warning",{character:"\\ea6c"}),i.search=new i("search",{character:"\\ea6d"}),i.searchSave=new i("search-save",{character:"\\ea6d"}),i.logOut=new i("log-out",{character:"\\ea6e"}),i.signOut=new i("sign-out",{character:"\\ea6e"}),i.logIn=new i("log-in",{character:"\\ea6f"}),i.signIn=new i("sign-in",{character:"\\ea6f"}),i.eye=new i("eye",{character:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{character:"\\ea70"}),i.eyeWatch=new i("eye-watch",{character:"\\ea70"}),i.circleFilled=new i("circle-filled",{character:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{character:"\\ea71"}),i.closeDirty=new i("close-dirty",{character:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{character:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{character:"\\ea71"}),i.debugHint=new i("debug-hint",{character:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{character:"\\ea72"}),i.edit=new i("edit",{character:"\\ea73"}),i.pencil=new i("pencil",{character:"\\ea73"}),i.info=new i("info",{character:"\\ea74"}),i.issueOpened=new i("issue-opened",{character:"\\ea74"}),i.gistPrivate=new i("gist-private",{character:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{character:"\\ea75"}),i.lock=new i("lock",{character:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{character:"\\ea75"}),i.close=new i("close",{character:"\\ea76"}),i.removeClose=new i("remove-close",{character:"\\ea76"}),i.x=new i("x",{character:"\\ea76"}),i.repoSync=new i("repo-sync",{character:"\\ea77"}),i.sync=new i("sync",{character:"\\ea77"}),i.clone=new i("clone",{character:"\\ea78"}),i.desktopDownload=new i("desktop-download",{character:"\\ea78"}),i.beaker=new i("beaker",{character:"\\ea79"}),i.microscope=new i("microscope",{character:"\\ea79"}),i.vm=new i("vm",{character:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{character:"\\ea7a"}),i.file=new i("file",{character:"\\ea7b"}),i.fileText=new i("file-text",{character:"\\ea7b"}),i.more=new i("more",{character:"\\ea7c"}),i.ellipsis=new i("ellipsis",{character:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{character:"\\ea7c"}),i.mailReply=new i("mail-reply",{character:"\\ea7d"}),i.reply=new i("reply",{character:"\\ea7d"}),i.organization=new i("organization",{character:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{character:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{character:"\\ea7e"}),i.newFile=new i("new-file",{character:"\\ea7f"}),i.fileAdd=new i("file-add",{character:"\\ea7f"}),i.newFolder=new i("new-folder",{character:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{character:"\\ea80"}),i.trash=new i("trash",{character:"\\ea81"}),i.trashcan=new i("trashcan",{character:"\\ea81"}),i.history=new i("history",{character:"\\ea82"}),i.clock=new i("clock",{character:"\\ea82"}),i.folder=new i("folder",{character:"\\ea83"}),i.fileDirectory=new i("file-directory",{character:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{character:"\\ea83"}),i.logoGithub=new i("logo-github",{character:"\\ea84"}),i.markGithub=new i("mark-github",{character:"\\ea84"}),i.github=new i("github",{character:"\\ea84"}),i.terminal=new i("terminal",{character:"\\ea85"}),i.console=new i("console",{character:"\\ea85"}),i.repl=new i("repl",{character:"\\ea85"}),i.zap=new i("zap",{character:"\\ea86"}),i.symbolEvent=new i("symbol-event",{character:"\\ea86"}),i.error=new i("error",{character:"\\ea87"}),i.stop=new i("stop",{character:"\\ea87"}),i.variable=new i("variable",{character:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{character:"\\ea88"}),i.array=new i("array",{character:"\\ea8a"}),i.symbolArray=new i("symbol-array",{character:"\\ea8a"}),i.symbolModule=new i("symbol-module",{character:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{character:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{character:"\\ea8b"}),i.symbolObject=new i("symbol-object",{character:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{character:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{character:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{character:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{character:"\\ea8f"}),i.symbolNull=new i("symbol-null",{character:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{character:"\\ea90"}),i.symbolNumber=new i("symbol-number",{character:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{character:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{character:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{character:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{character:"\\ea92"}),i.symbolKey=new i("symbol-key",{character:"\\ea93"}),i.symbolText=new i("symbol-text",{character:"\\ea93"}),i.symbolReference=new i("symbol-reference",{character:"\\ea94"}),i.goToFile=new i("go-to-file",{character:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{character:"\\ea95"}),i.symbolValue=new i("symbol-value",{character:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{character:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{character:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{character:"\\ea97"}),i.archive=new i("archive",{character:"\\ea98"}),i.arrowBoth=new i("arrow-both",{character:"\\ea99"}),i.arrowDown=new i("arrow-down",{character:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{character:"\\ea9b"}),i.arrowRight=new i("arrow-right",{character:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{character:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{character:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{character:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{character:"\\eaa0"}),i.arrowUp=new i("arrow-up",{character:"\\eaa1"}),i.bell=new i("bell",{character:"\\eaa2"}),i.bold=new i("bold",{character:"\\eaa3"}),i.book=new i("book",{character:"\\eaa4"}),i.bookmark=new i("bookmark",{character:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{character:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{character:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{character:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{character:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{character:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{character:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{character:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{character:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{character:"\\eaab"}),i.briefcase=new i("briefcase",{character:"\\eaac"}),i.broadcast=new i("broadcast",{character:"\\eaad"}),i.browser=new i("browser",{character:"\\eaae"}),i.bug=new i("bug",{character:"\\eaaf"}),i.calendar=new i("calendar",{character:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{character:"\\eab1"}),i.check=new i("check",{character:"\\eab2"}),i.checklist=new i("checklist",{character:"\\eab3"}),i.chevronDown=new i("chevron-down",{character:"\\eab4"}),i.chevronLeft=new i("chevron-left",{character:"\\eab5"}),i.chevronRight=new i("chevron-right",{character:"\\eab6"}),i.chevronUp=new i("chevron-up",{character:"\\eab7"}),i.chromeClose=new i("chrome-close",{character:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{character:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{character:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{character:"\\eabb"}),i.circleOutline=new i("circle-outline",{character:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{character:"\\eabc"}),i.circleSlash=new i("circle-slash",{character:"\\eabd"}),i.circuitBoard=new i("circuit-board",{character:"\\eabe"}),i.clearAll=new i("clear-all",{character:"\\eabf"}),i.clippy=new i("clippy",{character:"\\eac0"}),i.closeAll=new i("close-all",{character:"\\eac1"}),i.cloudDownload=new i("cloud-download",{character:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{character:"\\eac3"}),i.code=new i("code",{character:"\\eac4"}),i.collapseAll=new i("collapse-all",{character:"\\eac5"}),i.colorMode=new i("color-mode",{character:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{character:"\\eac7"}),i.compareChanges=new i("compare-changes",{character:"\\eafd"}),i.creditCard=new i("credit-card",{character:"\\eac9"}),i.dash=new i("dash",{character:"\\eacc"}),i.dashboard=new i("dashboard",{character:"\\eacd"}),i.database=new i("database",{character:"\\eace"}),i.debugContinue=new i("debug-continue",{character:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{character:"\\ead0"}),i.debugPause=new i("debug-pause",{character:"\\ead1"}),i.debugRestart=new i("debug-restart",{character:"\\ead2"}),i.debugStart=new i("debug-start",{character:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{character:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{character:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{character:"\\ead6"}),i.debugStop=new i("debug-stop",{character:"\\ead7"}),i.debug=new i("debug",{character:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{character:"\\ead9"}),i.deviceCamera=new i("device-camera",{character:"\\eada"}),i.deviceMobile=new i("device-mobile",{character:"\\eadb"}),i.diffAdded=new i("diff-added",{character:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{character:"\\eadd"}),i.diffModified=new i("diff-modified",{character:"\\eade"}),i.diffRemoved=new i("diff-removed",{character:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{character:"\\eae0"}),i.diff=new i("diff",{character:"\\eae1"}),i.discard=new i("discard",{character:"\\eae2"}),i.editorLayout=new i("editor-layout",{character:"\\eae3"}),i.emptyWindow=new i("empty-window",{character:"\\eae4"}),i.exclude=new i("exclude",{character:"\\eae5"}),i.extensions=new i("extensions",{character:"\\eae6"}),i.eyeClosed=new i("eye-closed",{character:"\\eae7"}),i.fileBinary=new i("file-binary",{character:"\\eae8"}),i.fileCode=new i("file-code",{character:"\\eae9"}),i.fileMedia=new i("file-media",{character:"\\eaea"}),i.filePdf=new i("file-pdf",{character:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{character:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{character:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{character:"\\eaee"}),i.fileZip=new i("file-zip",{character:"\\eaef"}),i.files=new i("files",{character:"\\eaf0"}),i.filter=new i("filter",{character:"\\eaf1"}),i.flame=new i("flame",{character:"\\eaf2"}),i.foldDown=new i("fold-down",{character:"\\eaf3"}),i.foldUp=new i("fold-up",{character:"\\eaf4"}),i.fold=new i("fold",{character:"\\eaf5"}),i.folderActive=new i("folder-active",{character:"\\eaf6"}),i.folderOpened=new i("folder-opened",{character:"\\eaf7"}),i.gear=new i("gear",{character:"\\eaf8"}),i.gift=new i("gift",{character:"\\eaf9"}),i.gistSecret=new i("gist-secret",{character:"\\eafa"}),i.gist=new i("gist",{character:"\\eafb"}),i.gitCommit=new i("git-commit",{character:"\\eafc"}),i.gitCompare=new i("git-compare",{character:"\\eafd"}),i.gitMerge=new i("git-merge",{character:"\\eafe"}),i.githubAction=new i("github-action",{character:"\\eaff"}),i.githubAlt=new i("github-alt",{character:"\\eb00"}),i.globe=new i("globe",{character:"\\eb01"}),i.grabber=new i("grabber",{character:"\\eb02"}),i.graph=new i("graph",{character:"\\eb03"}),i.gripper=new i("gripper",{character:"\\eb04"}),i.heart=new i("heart",{character:"\\eb05"}),i.home=new i("home",{character:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{character:"\\eb07"}),i.hubot=new i("hubot",{character:"\\eb08"}),i.inbox=new i("inbox",{character:"\\eb09"}),i.issueClosed=new i("issue-closed",{character:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{character:"\\eb0b"}),i.issues=new i("issues",{character:"\\eb0c"}),i.italic=new i("italic",{character:"\\eb0d"}),i.jersey=new i("jersey",{character:"\\eb0e"}),i.json=new i("json",{character:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{character:"\\eb10"}),i.key=new i("key",{character:"\\eb11"}),i.law=new i("law",{character:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{character:"\\eb13"}),i.linkExternal=new i("link-external",{character:"\\eb14"}),i.link=new i("link",{character:"\\eb15"}),i.listOrdered=new i("list-ordered",{character:"\\eb16"}),i.listUnordered=new i("list-unordered",{character:"\\eb17"}),i.liveShare=new i("live-share",{character:"\\eb18"}),i.loading=new i("loading",{character:"\\eb19"}),i.location=new i("location",{character:"\\eb1a"}),i.mailRead=new i("mail-read",{character:"\\eb1b"}),i.mail=new i("mail",{character:"\\eb1c"}),i.markdown=new i("markdown",{character:"\\eb1d"}),i.megaphone=new i("megaphone",{character:"\\eb1e"}),i.mention=new i("mention",{character:"\\eb1f"}),i.milestone=new i("milestone",{character:"\\eb20"}),i.mortarBoard=new i("mortar-board",{character:"\\eb21"}),i.move=new i("move",{character:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{character:"\\eb23"}),i.mute=new i("mute",{character:"\\eb24"}),i.noNewline=new i("no-newline",{character:"\\eb25"}),i.note=new i("note",{character:"\\eb26"}),i.octoface=new i("octoface",{character:"\\eb27"}),i.openPreview=new i("open-preview",{character:"\\eb28"}),i.package_=new i("package",{character:"\\eb29"}),i.paintcan=new i("paintcan",{character:"\\eb2a"}),i.pin=new i("pin",{character:"\\eb2b"}),i.play=new i("play",{character:"\\eb2c"}),i.run=new i("run",{character:"\\eb2c"}),i.plug=new i("plug",{character:"\\eb2d"}),i.preserveCase=new i("preserve-case",{character:"\\eb2e"}),i.preview=new i("preview",{character:"\\eb2f"}),i.project=new i("project",{character:"\\eb30"}),i.pulse=new i("pulse",{character:"\\eb31"}),i.question=new i("question",{character:"\\eb32"}),i.quote=new i("quote",{character:"\\eb33"}),i.radioTower=new i("radio-tower",{character:"\\eb34"}),i.reactions=new i("reactions",{character:"\\eb35"}),i.references=new i("references",{character:"\\eb36"}),i.refresh=new i("refresh",{character:"\\eb37"}),i.regex=new i("regex",{character:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{character:"\\eb39"}),i.remote=new i("remote",{character:"\\eb3a"}),i.remove=new i("remove",{character:"\\eb3b"}),i.replaceAll=new i("replace-all",{character:"\\eb3c"}),i.replace=new i("replace",{character:"\\eb3d"}),i.repoClone=new i("repo-clone",{character:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{character:"\\eb3f"}),i.repoPull=new i("repo-pull",{character:"\\eb40"}),i.repoPush=new i("repo-push",{character:"\\eb41"}),i.report=new i("report",{character:"\\eb42"}),i.requestChanges=new i("request-changes",{character:"\\eb43"}),i.rocket=new i("rocket",{character:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{character:"\\eb45"}),i.rootFolder=new i("root-folder",{character:"\\eb46"}),i.rss=new i("rss",{character:"\\eb47"}),i.ruby=new i("ruby",{character:"\\eb48"}),i.saveAll=new i("save-all",{character:"\\eb49"}),i.saveAs=new i("save-as",{character:"\\eb4a"}),i.save=new i("save",{character:"\\eb4b"}),i.screenFull=new i("screen-full",{character:"\\eb4c"}),i.screenNormal=new i("screen-normal",{character:"\\eb4d"}),i.searchStop=new i("search-stop",{character:"\\eb4e"}),i.server=new i("server",{character:"\\eb50"}),i.settingsGear=new i("settings-gear",{character:"\\eb51"}),i.settings=new i("settings",{character:"\\eb52"}),i.shield=new i("shield",{character:"\\eb53"}),i.smiley=new i("smiley",{character:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{character:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{character:"\\eb56"}),i.splitVertical=new i("split-vertical",{character:"\\eb57"}),i.squirrel=new i("squirrel",{character:"\\eb58"}),i.starFull=new i("star-full",{character:"\\eb59"}),i.starHalf=new i("star-half",{character:"\\eb5a"}),i.symbolClass=new i("symbol-class",{character:"\\eb5b"}),i.symbolColor=new i("symbol-color",{character:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{character:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{character:"\\eb5e"}),i.symbolField=new i("symbol-field",{character:"\\eb5f"}),i.symbolFile=new i("symbol-file",{character:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{character:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{character:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{character:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{character:"\\eb64"}),i.symbolProperty=new i("symbol-property",{character:"\\eb65"}),i.wrench=new i("wrench",{character:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{character:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{character:"\\eb66"}),i.tasklist=new i("tasklist",{character:"\\eb67"}),i.telescope=new i("telescope",{character:"\\eb68"}),i.textSize=new i("text-size",{character:"\\eb69"}),i.threeBars=new i("three-bars",{character:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{character:"\\eb6b"}),i.thumbsup=new i("thumbsup",{character:"\\eb6c"}),i.tools=new i("tools",{character:"\\eb6d"}),i.triangleDown=new i("triangle-down",{character:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{character:"\\eb6f"}),i.triangleRight=new i("triangle-right",{character:"\\eb70"}),i.triangleUp=new i("triangle-up",{character:"\\eb71"}),i.twitter=new i("twitter",{character:"\\eb72"}),i.unfold=new i("unfold",{character:"\\eb73"}),i.unlock=new i("unlock",{character:"\\eb74"}),i.unmute=new i("unmute",{character:"\\eb75"}),i.unverified=new i("unverified",{character:"\\eb76"}),i.verified=new i("verified",{character:"\\eb77"}),i.versions=new i("versions",{character:"\\eb78"}),i.vmActive=new i("vm-active",{character:"\\eb79"}),i.vmOutline=new i("vm-outline",{character:"\\eb7a"}),i.vmRunning=new i("vm-running",{character:"\\eb7b"}),i.watch=new i("watch",{character:"\\eb7c"}),i.whitespace=new i("whitespace",{character:"\\eb7d"}),i.wholeWord=new i("whole-word",{character:"\\eb7e"}),i.window=new i("window",{character:"\\eb7f"}),i.wordWrap=new i("word-wrap",{character:"\\eb80"}),i.zoomIn=new i("zoom-in",{character:"\\eb81"}),i.zoomOut=new i("zoom-out",{character:"\\eb82"}),i.listFilter=new i("list-filter",{character:"\\eb83"}),i.listFlat=new i("list-flat",{character:"\\eb84"}),i.listSelection=new i("list-selection",{character:"\\eb85"}),i.selection=new i("selection",{character:"\\eb85"}),i.listTree=new i("list-tree",{character:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{character:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{character:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{character:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{character:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{character:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{character:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{character:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{character:"\\eb8c"}),i.symbolString=new i("symbol-string",{character:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{character:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{character:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{character:"\\eb90"}),i.callIncoming=new i("call-incoming",{character:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{character:"\\eb93"}),i.menu=new i("menu",{character:"\\eb94"}),i.expandAll=new i("expand-all",{character:"\\eb95"}),i.feedback=new i("feedback",{character:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{character:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{character:"\\eb98"}),i.account=new i("account",{character:"\\eb99"}),i.bellDot=new i("bell-dot",{character:"\\eb9a"}),i.debugConsole=new i("debug-console",{character:"\\eb9b"}),i.library=new i("library",{character:"\\eb9c"}),i.output=new i("output",{character:"\\eb9d"}),i.runAll=new i("run-all",{character:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{character:"\\eb9f"}),i.pinned=new i("pinned",{character:"\\eba0"}),i.githubInverted=new i("github-inverted",{character:"\\eba1"}),i.debugAlt=new i("debug-alt",{character:"\\eb91"}),i.serverProcess=new i("server-process",{character:"\\eba2"}),i.serverEnvironment=new i("server-environment",{character:"\\eba3"}),i.pass=new i("pass",{character:"\\eba4"}),i.stopCircle=new i("stop-circle",{character:"\\eba5"}),i.playCircle=new i("play-circle",{character:"\\eba6"}),i.record=new i("record",{character:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{character:"\\eba8"}),i.vmConnect=new i("vm-connect",{character:"\\eba9"}),i.cloud=new i("cloud",{character:"\\ebaa"}),i.merge=new i("merge",{character:"\\ebab"}),i.exportIcon=new i("export",{character:"\\ebac"}),i.graphLeft=new i("graph-left",{character:"\\ebad"}),i.magnet=new i("magnet",{character:"\\ebae"}),i.notebook=new i("notebook",{character:"\\ebaf"}),i.redo=new i("redo",{character:"\\ebb0"}),i.checkAll=new i("check-all",{character:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{character:"\\ebb2"}),i.passFilled=new i("pass-filled",{character:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{character:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{character:"\\ebb5"}),i.combine=new i("combine",{character:"\\ebb6"}),i.gather=new i("gather",{character:"\\ebb6"}),i.table=new i("table",{character:"\\ebb7"}),i.variableGroup=new i("variable-group",{character:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{character:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{character:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{character:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{character:"\\ebbc"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(M=e.Codicon||(e.Codicon={}))}),define(Q[64],J([0,1,16,2]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.observe=e.transform=e.toReadable=e.toStream=e.peekStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(p){const b=p;return b&&[b.on,b.pause,b.resume,b.destroy].every(l=>typeof l=="function")}e.isReadableStream=D;function y(p){const b=p;return b&&D(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean"}e.isReadableBufferedStream=y;function M(p,b){return new n(p,b)}e.newWriteableStream=M;class n{constructor(b,l){this.reducer=b,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(b){var l;if(!this.state.destroyed){if(this.state.flowing)this.emitData(b);else if(this.buffer.data.push(b),typeof((l=this.options)===null||l===void 0?void 0:l.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(b){this.state.destroyed||(this.state.flowing?this.emitError(b):this.buffer.error.push(b))}end(b){this.state.destroyed||(b instanceof Error?this.error(b):b&&this.write(b),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(b){this.listeners.data.slice(0).forEach(l=>l(b))}emitError(b){this.listeners.error.length===0?w.onUnexpectedError(b):this.listeners.error.slice(0).forEach(l=>l(b))}emitEnd(){this.listeners.end.slice(0).forEach(b=>b())}on(b,l){if(!this.state.destroyed)switch(b){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(b,l){if(!this.state.destroyed){let a;switch(b){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const s=a.indexOf(l);s>=0&&a.splice(s,1)}}}flowData(){if(this.buffer.data.length>0){const b=this.reducer(this.buffer.data);this.emitData(b),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const b of this.buffer.error)this.emitError(b);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(p,b){const l=[];let a;for(;(a=p.read())!==null;)l.push(a);return b(l)}e.consumeReadable=S;function i(p,b,l){const a=[];let s;for(;(s=p.read())!==null&&a.length<l;)a.push(s);return s===null&&a.length>0?b(a):{read:()=>{if(a.length>0)return a.shift();if(typeof s!="undefined"){const u=s;return s=void 0,u}return p.read()}}}e.peekReadable=i;function E(p,b){return new Promise((l,a)=>{const s=[];p.on("error",u=>a(u)),p.on("end",()=>l(b(s))),p.on("data",u=>s.push(u))})}e.consumeStream=E;function m(p,b){return new Promise((l,a)=>{const s=new R.DisposableStore,u=[],t=d=>{if(u.push(d),u.length>b)return s.dispose(),p.pause(),l({stream:p,buffer:u,ended:!1})};s.add(R.toDisposable(()=>p.removeListener("data",t))),p.on("data",t);const r=d=>a(d);s.add(R.toDisposable(()=>p.removeListener("error",r))),p.on("error",r);const o=()=>l({stream:p,buffer:u,ended:!0});s.add(R.toDisposable(()=>p.removeListener("end",o))),p.on("end",o)})}e.peekStream=m;function P(p,b){const l=M(b);return l.end(p),l}e.toStream=P;function f(p){let b=!1;return{read:()=>b?null:(b=!0,p)}}e.toReadable=f;function h(p,b,l){const a=M(l);return p.on("data",s=>a.write(b.data(s))),p.on("end",()=>a.end()),p.on("error",s=>a.error(b.error?b.error(s):s)),a}e.transform=h;function v(p){const b=Promise.race([new Promise(l=>p.on("end",()=>l())),new Promise(l=>p.on("error",()=>l()))]);return{errorOrEnd(){return p.resume(),b}}}e.observe=v}),define(Q[17],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function w(V){return!V||typeof V!="string"?!0:V.trim().length===0}e.isFalsyOrWhitespace=w;const R=/{(\d+)}/g;function D(V,...ne){return ne.length===0?V:V.replace(R,function(ce,ue){const ge=parseInt(ue,10);return isNaN(ge)||ge<0||ge>=ne.length?ce:ne[ge]})}e.format=D;function y(V){return V.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}e.escape=y;function M(V){return V.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=M;function n(V,ne){let ce=0;const ue=ne.charCodeAt(0);for(let ge=V.length-1;ge>=0;ge--)V.charCodeAt(ge)===ue&&ce++;return ce}e.count=n;function S(V,ne,ce="\u2026"){return V.length<=ne?V:`${V.substr(0,ne)}${ce}`}e.truncate=S;function i(V,ne=" "){const ce=E(V,ne);return m(ce,ne)}e.trim=i;function E(V,ne){if(!V||!ne)return V;const ce=ne.length;if(ce===0||V.length===0)return V;let ue=0;for(;V.indexOf(ne,ue)===ue;)ue=ue+ce;return V.substring(ue)}e.ltrim=E;function m(V,ne){if(!V||!ne)return V;const ce=ne.length,ue=V.length;if(ce===0||ue===0)return V;let ge=ue,we=-1;for(;we=V.lastIndexOf(ne,ge-1),!(we===-1||we+ce!==ge);){if(we===0)return"";ge=we}return V.substring(0,ge)}e.rtrim=m;function P(V){return V.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=P;function f(V){return V.replace(/\*/g,"")}e.stripWildcards=f;function h(V,ne,ce={}){if(!V)throw new Error("Cannot create regex from empty string");ne||(V=M(V)),ce.wholeWord&&(/\B/.test(V.charAt(0))||(V="\\b"+V),/\B/.test(V.charAt(V.length-1))||(V=V+"\\b"));let ue="";return ce.global&&(ue+="g"),ce.matchCase||(ue+="i"),ce.multiline&&(ue+="m"),ce.unicode&&(ue+="u"),new RegExp(V,ue)}e.createRegExp=h;function v(V){return V.source==="^"||V.source==="^$"||V.source==="$"||V.source==="^\\s*$"?!1:!!(V.exec("")&&V.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function p(V){return!!V.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function b(V){return(V.global?"g":"")+(V.ignoreCase?"i":"")+(V.multiline?"m":"")+(V.unicode?"u":"")}e.regExpFlags=b;function l(V){return V.split(/\r\n|\r|\n/)}e.splitLines=l;function a(V){for(let ne=0,ce=V.length;ne<ce;ne++){const ue=V.charCodeAt(ne);if(ue!==32&&ue!==9)return ne}return-1}e.firstNonWhitespaceIndex=a;function s(V,ne=0,ce=V.length){for(let ue=ne;ue<ce;ue++){const ge=V.charCodeAt(ue);if(ge!==32&&ge!==9)return V.substring(ne,ue)}return V.substring(ne,ce)}e.getLeadingWhitespace=s;function u(V,ne=V.length-1){for(let ce=ne;ce>=0;ce--){const ue=V.charCodeAt(ce);if(ue!==32&&ue!==9)return ce}return-1}e.lastNonWhitespaceIndex=u;function t(V,ne){return V<ne?-1:V>ne?1:0}e.compare=t;function r(V,ne,ce=0,ue=V.length,ge=0,we=ne.length){for(;ce<ue&&ge<we;ce++,ge++){let Fe=V.charCodeAt(ce),We=ne.charCodeAt(ge);if(Fe<We)return-1;if(Fe>We)return 1}const Ee=ue-ce,Re=we-ge;return Ee<Re?-1:Ee>Re?1:0}e.compareSubstring=r;function o(V,ne){return d(V,ne,0,V.length,0,ne.length)}e.compareIgnoreCase=o;function d(V,ne,ce=0,ue=V.length,ge=0,we=ne.length){for(;ce<ue&&ge<we;ce++,ge++){let Fe=V.charCodeAt(ce),We=ne.charCodeAt(ge);if(Fe!==We){const ze=Fe-We;if(!(ze===32&&g(We))&&!(ze===-32&&g(Fe)))return c(Fe)&&c(We)?ze:r(V.toLowerCase(),ne.toLowerCase(),ce,ue,ge,we)}}const Ee=ue-ce,Re=we-ge;return Ee<Re?-1:Ee>Re?1:0}e.compareSubstringIgnoreCase=d;function c(V){return V>=97&&V<=122}e.isLowerAsciiLetter=c;function g(V){return V>=65&&V<=90}e.isUpperAsciiLetter=g;function I(V){return c(V)||g(V)}function A(V,ne){return V.length===ne.length&&T(V,ne)}e.equalsIgnoreCase=A;function T(V,ne,ce=V.length){for(let ue=0;ue<ce;ue++){const ge=V.charCodeAt(ue),we=ne.charCodeAt(ue);if(ge!==we){if(I(ge)&&I(we)){const Ee=Math.abs(ge-we);if(Ee!==0&&Ee!==32)return!1}else if(String.fromCharCode(ge).toLowerCase()!==String.fromCharCode(we).toLowerCase())return!1}}return!0}function U(V,ne){const ce=ne.length;return ne.length>V.length?!1:T(V,ne,ce)}e.startsWithIgnoreCase=U;function j(V,ne){let ce,ue=Math.min(V.length,ne.length);for(ce=0;ce<ue;ce++)if(V.charCodeAt(ce)!==ne.charCodeAt(ce))return ce;return ue}e.commonPrefixLength=j;function C(V,ne){let ce,ue=Math.min(V.length,ne.length);const ge=V.length-1,we=ne.length-1;for(ce=0;ce<ue;ce++)if(V.charCodeAt(ge-ce)!==ne.charCodeAt(we-ce))return ce;return ue}e.commonSuffixLength=C;function x(V){return 55296<=V&&V<=56319}e.isHighSurrogate=x;function ee(V){return 56320<=V&&V<=57343}e.isLowSurrogate=ee;function Z(V,ne){return(V-55296<<10)+(ne-56320)+65536}e.computeCodePoint=Z;function H(V,ne,ce){const ue=V.charCodeAt(ce);if(x(ue)&&ce+1<ne){const ge=V.charCodeAt(ce+1);if(ee(ge))return Z(ue,ge)}return ue}e.getNextCodePoint=H;function N(V,ne){const ce=V.charCodeAt(ne-1);if(ee(ce)&&ne>1){const ue=V.charCodeAt(ne-2);if(x(ue))return Z(ue,ce)}return ce}function q(V,ne){const ce=Be.getInstance(),ue=ne,ge=V.length,we=H(V,ge,ne);ne+=we>=65536?2:1;let Ee=ce.getGraphemeBreakType(we);for(;ne<ge;){const Re=H(V,ge,ne),Fe=ce.getGraphemeBreakType(Re);if(qe(Ee,Fe))break;ne+=Re>=65536?2:1,Ee=Fe}return ne-ue}e.nextCharLength=q;function F(V,ne){const ce=Be.getInstance(),ue=ne,ge=N(V,ne);ne-=ge>=65536?2:1;let we=ce.getGraphemeBreakType(ge);for(;ne>0;){const Ee=N(V,ne),Re=ce.getGraphemeBreakType(Ee);if(qe(Re,we))break;ne-=Ee>=65536?2:1,we=Re}return ue-ne}e.prevCharLength=F;function z(V,ne){const ce=Be.getInstance(),ue=V.length,ge=ne,we=H(V,ue,ne),Ee=ce.getGraphemeBreakType(we);ne+=we>=65536?2:1;let Re=Ee;for(;ne<ue;){const We=H(V,ue,ne),ze=ce.getGraphemeBreakType(We);if(qe(Re,ze))break;ne+=We>=65536?2:1,Re=ze}const Fe=ne;for(ne=ge,Re=Ee;ne>0;){const We=N(V,ne),ze=ce.getGraphemeBreakType(We);if(qe(ze,Re))break;ne-=We>=65536?2:1,Re=ze}return[ne,Fe]}function O(V,ne){return ne>0&&ee(V.charCodeAt(ne))?z(V,ne-1):z(V,ne)}e.getCharContainingOffset=O;function k(V){const ne=V.length;let ce=0,ue=0;for(;ue<ne;){const Ee=H(V,ne,ue);ue+=Ee>=65536?2:1,Ee<128?ce+=1:Ee<2048?ce+=2:Ee<65536?ce+=3:ce+=4}const ge=new Uint8Array(ce);ue=0;let we=0;for(;ue<ne;){const Ee=H(V,ne,ue);ue+=Ee>=65536?2:1,Ee<128?ge[we++]=Ee:Ee<2048?(ge[we++]=192|(Ee&1984)>>>6,ge[we++]=128|(Ee&63)>>>0):Ee<65536?(ge[we++]=224|(Ee&61440)>>>12,ge[we++]=128|(Ee&4032)>>>6,ge[we++]=128|(Ee&63)>>>0):(ge[we++]=240|(Ee&1835008)>>>18,ge[we++]=128|(Ee&258048)>>>12,ge[we++]=128|(Ee&4032)>>>6,ge[we++]=128|(Ee&63)>>>0)}return ge}e.encodeUTF8=k;function L(V){const ne=V.byteLength,ce=[];let ue=0;for(;ue<ne;){const ge=V[ue];let we;if(ge>=240&&ue+3<ne?we=(V[ue++]&7)<<18>>>0|(V[ue++]&63)<<12>>>0|(V[ue++]&63)<<6>>>0|(V[ue++]&63)<<0>>>0:ge>=224&&ue+2<ne?we=(V[ue++]&15)<<12>>>0|(V[ue++]&63)<<6>>>0|(V[ue++]&63)<<0>>>0:ge>=192&&ue+1<ne?we=(V[ue++]&31)<<6>>>0|(V[ue++]&63)<<0>>>0:we=V[ue++],we>=0&&we<=55295||we>=57344&&we<=65535)ce.push(String.fromCharCode(we));else if(we>=65536&&we<=1114111){const Ee=we-65536,Re=55296+((Ee&1047552)>>>10),Fe=56320+((Ee&1023)>>>0);ce.push(String.fromCharCode(Re)),ce.push(String.fromCharCode(Fe))}else ce.push(String.fromCharCode(65533))}return ce.join("")}e.decodeUTF8=L;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(V){return _.test(V)}e.containsRTL=W;const B=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDE73\uDE78-\uDE82\uDE90-\uDE95])/;function K(V){return B.test(V)}e.containsEmoji=K;const X=/^[\t\n\r\x20-\x7E]*$/;function Y(V){return X.test(V)}e.isBasicASCII=Y,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(V){return e.UNUSUAL_LINE_TERMINATORS.test(V)}e.containsUnusualLineTerminators=oe;function le(V){for(let ne=0,ce=V.length;ne<ce;ne++)if(ie(V.charCodeAt(ne)))return!0;return!1}e.containsFullWidthCharacter=le;function ie(V){return V=+V,V>=11904&&V<=55215||V>=63744&&V<=64255||V>=65281&&V<=65374}e.isFullWidthCharacter=ie;function G(V){return V>=127462&&V<=127487||V>=9728&&V<=10175||V>=127744&&V<=128591||V>=128640&&V<=128764||V>=128992&&V<=129003||V>=129280&&V<=129535||V>=129648&&V<=129651||V>=129656&&V<=129666||V>=129680&&V<=129685}e.isEmojiImprecise=G;function te(V,ne){if(V.length<ne)return V;const ce=/\b/g;let ue=0;for(;ce.test(V)&&!(V.length-ce.lastIndex<ne);)ue=ce.lastIndex,ce.lastIndex+=1;return V.substring(ue).replace(/^\s/,"")}e.lcut=te;const se=/\x1B\x5B[12]?K/g,ae=/\x1b\[\d+m/g,he=/\x1b\[0?m/g;function ve(V){return V&&(V=V.replace(se,""),V=V.replace(ae,""),V=V.replace(he,"")),V}e.removeAnsiEscapeCodes=ve,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(V){return!!(V&&V.length>0&&V.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function Ie(V){return be(V)?V.substr(1):V}e.stripUTF8BOM=Ie;function Le(V,ne){if(!V||!ne||V.length<ne.length)return!1;const ce=ne.length,ue=V.toLowerCase();let ge=0,we=-1;for(;ge<ce;){const Ee=ue.indexOf(ne[ge],we+1);if(Ee<0)return!1;we=Ee,ge++}return!0}e.fuzzyContains=Le;function Ae(V,ne=!1){return V?(ne&&(V=V.replace(/\\./g,"")),V.toLowerCase()!==V):!1}e.containsUppercaseCharacter=Ae;function Ne(V){return V.charAt(0).toUpperCase()+V.slice(1)}e.uppercaseFirstLetter=Ne;function je(V,ne=1){if(ne===0)return"";let ce=-1;do ce=V.indexOf(`
`,ce+1),ne--;while(ne>0&&ce>=0);return ce===-1?V:(V[ce-1]==="\r"&&ce--,V.substr(0,ce))}e.getNLines=je;function Ke(V){const ne=90-65+1;return V=V%(2*ne),V<ne?String.fromCharCode(97+V):String.fromCharCode(65+V-ne)}e.singleLetterHash=Ke;function Ze(V){return Be.getInstance().getGraphemeBreakType(V)}e.getGraphemeBreakType=Ze;function qe(V,ne){return V===0?ne!==5&&ne!==7:V===2&&ne===3?!1:V===4||V===2||V===3||ne===4||ne===2||ne===3?!0:!(V===8&&(ne===8||ne===9||ne===11||ne===12)||(V===11||V===9)&&(ne===9||ne===10)||(V===12||V===10)&&ne===10||ne===5||ne===13||ne===7||V===1||V===13&&ne===14||V===6&&ne===6)}e.breakBetweenGraphemeBreakType=qe;var ot;(function(V){V[V.Other=0]="Other",V[V.Prepend=1]="Prepend",V[V.CR=2]="CR",V[V.LF=3]="LF",V[V.Control=4]="Control",V[V.Extend=5]="Extend",V[V.Regional_Indicator=6]="Regional_Indicator",V[V.SpacingMark=7]="SpacingMark",V[V.L=8]="L",V[V.V=9]="V",V[V.T=10]="T",V[V.LV=11]="LV",V[V.LVT=12]="LVT",V[V.ZWJ=13]="ZWJ",V[V.Extended_Pictographic=14]="Extended_Pictographic"})(ot=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=at()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const ce=this._data,ue=ce.length/3;let ge=1;for(;ge<=ue;)if(ne<ce[3*ge])ge=2*ge;else if(ne>ce[3*ge+1])ge=2*ge+1;else return ce[3*ge+2];return 0}}Be._INSTANCE=null;function at(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(Q[20],J([0,1,17,64]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",M=typeof TextDecoder!="undefined";let n,S;class i{constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}static alloc(c){return D?new i(Buffer.allocUnsafe(c)):new i(new Uint8Array(c))}static wrap(c){return D&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new i(c)}static fromString(c,g){return!((g==null?void 0:g.dontUseNodeBuffer)||!1)&&D?new i(Buffer.from(c)):y?(n||(n=new TextEncoder),new i(n.encode(c))):new i(w.encodeUTF8(c))}static concat(c,g){if(typeof g=="undefined"){g=0;for(let T=0,U=c.length;T<U;T++)g+=c[T].byteLength}const I=i.alloc(g);let A=0;for(let T=0,U=c.length;T<U;T++){const j=c[T];I.set(j,A),A+=j.byteLength}return I}toString(){return D?this.buffer.toString():M?(S||(S=new TextDecoder),S.decode(this.buffer)):w.decodeUTF8(this.buffer)}slice(c,g){return new i(this.buffer.subarray(c,g))}set(c,g){c instanceof i?this.buffer.set(c.buffer,g):this.buffer.set(c,g)}readUInt32BE(c){return P(this.buffer,c)}writeUInt32BE(c,g){f(this.buffer,c,g)}readUInt32LE(c){return h(this.buffer,c)}writeUInt32LE(c,g){v(this.buffer,c,g)}readUInt8(c){return p(this.buffer,c)}writeUInt8(c,g){b(this.buffer,c,g)}}e.VSBuffer=i;function E(d,c){return d[c+0]<<0>>>0|d[c+1]<<8>>>0}e.readUInt16LE=E;function m(d,c,g){d[g+0]=c&255,c=c>>>8,d[g+1]=c&255}e.writeUInt16LE=m;function P(d,c){return d[c]*2**24+d[c+1]*2**16+d[c+2]*2**8+d[c+3]}e.readUInt32BE=P;function f(d,c,g){d[g+3]=c,c=c>>>8,d[g+2]=c,c=c>>>8,d[g+1]=c,c=c>>>8,d[g]=c}e.writeUInt32BE=f;function h(d,c){return d[c+0]<<0>>>0|d[c+1]<<8>>>0|d[c+2]<<16>>>0|d[c+3]<<24>>>0}e.readUInt32LE=h;function v(d,c,g){d[g+0]=c&255,c=c>>>8,d[g+1]=c&255,c=c>>>8,d[g+2]=c&255,c=c>>>8,d[g+3]=c&255}e.writeUInt32LE=v;function p(d,c){return d[c]}e.readUInt8=p;function b(d,c,g){d[g]=c}e.writeUInt8=b;function l(d){return R.consumeReadable(d,c=>i.concat(c))}e.readableToBuffer=l;function a(d){return R.toReadable(d)}e.bufferToReadable=a;function s(d){return R.consumeStream(d,c=>i.concat(c))}e.streamToBuffer=s;async function u(d){return d.ended?i.concat(d.buffer):i.concat([...d.buffer,await s(d.stream)])}e.bufferedStreamToBuffer=u;function t(d){return R.toStream(d,c=>i.concat(c))}e.bufferToStream=t;function r(d){return R.transform(d,{data:c=>typeof c=="string"?i.fromString(c):i.wrap(c)},c=>i.concat(c))}e.streamToBufferReadableStream=r;function o(d){return R.newWriteableStream(c=>i.concat(c),d)}e.newWriteableBufferStream=o}),define(Q[104],J([0,1,17]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(b){return D(b,0)}e.hash=R;function D(b,l){switch(typeof b){case"object":return b===null?y(349,l):Array.isArray(b)?S(b,l):i(b,l);case"string":return n(b,l);case"boolean":return M(b,l);case"number":return y(b,l);case"undefined":return y(937,l);default:return y(617,l)}}e.doHash=D;function y(b,l){return(l<<5)-l+b|0}function M(b,l){return y(b?433:863,l)}function n(b,l){l=y(149417,l);for(let a=0,s=b.length;a<s;a++)l=y(b.charCodeAt(a),l);return l}e.stringHash=n;function S(b,l){return l=y(104579,l),b.reduce((a,s)=>D(s,a),l)}function i(b,l){return l=y(181387,l),Object.keys(b).sort().reduce((a,s)=>(a=n(s,a),D(b[s],a)),l)}class E{constructor(){this._value=0}get value(){return this._value}hash(l){return this._value=D(l,this._value),this._value}}e.Hasher=E;var m;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(m||(m={}));function P(b,l,a=32){const s=a-l,u=~((1<<s)-1);return(b<<l|(u&b)>>>s)>>>0}function f(b,l=0,a=b.byteLength,s=0){for(let u=0;u<a;u++)b[l+u]=s}function h(b,l,a="0"){for(;b.length<l;)b=a+b;return b}function v(b,l=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(a=>a.toString(16).padStart(2,"0")).join(""):h((b>>>0).toString(16),l/4)}e.toHexString=v;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(l){const a=l.length;if(a!==0){const s=this._buff;let u=this._buffLen,t=this._leftoverHighSurrogate,r,o;for(t!==0?(r=t,o=-1,t=0):(r=l.charCodeAt(0),o=0);;){let d=r;if(w.isHighSurrogate(r))if(o+1<a){const c=l.charCodeAt(o+1);w.isLowSurrogate(c)?(o++,d=w.computeCodePoint(r,c)):d=65533}else{t=r;break}else w.isLowSurrogate(r)&&(d=65533);if(u=this._push(s,u,d),o++,o<a)r=l.charCodeAt(o);else break}this._buffLen=u,this._leftoverHighSurrogate=t}}_push(l,a,s){return s<128?l[a++]=s:s<2048?(l[a++]=192|(s&1984)>>>6,l[a++]=128|(s&63)>>>0):s<65536?(l[a++]=224|(s&61440)>>>12,l[a++]=128|(s&4032)>>>6,l[a++]=128|(s&63)>>>0):(l[a++]=240|(s&1835008)>>>18,l[a++]=128|(s&258048)>>>12,l[a++]=128|(s&4032)>>>6,l[a++]=128|(s&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,l[0]=l[64+0],l[1]=l[64+1],l[2]=l[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const l=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(l/4294967296),!1),this._buffDV.setUint32(60,l%4294967296,!1),this._step()}_step(){const l=p._bigBlock32,a=this._buffDV;for(let I=0;I<64;I+=4)l.setUint32(I,a.getUint32(I,!1),!1);for(let I=64;I<320;I+=4)l.setUint32(I,P(l.getUint32(I-12,!1)^l.getUint32(I-32,!1)^l.getUint32(I-56,!1)^l.getUint32(I-64,!1),1),!1);let s=this._h0,u=this._h1,t=this._h2,r=this._h3,o=this._h4,d,c,g;for(let I=0;I<80;I++)I<20?(d=u&t|~u&r,c=1518500249):I<40?(d=u^t^r,c=1859775393):I<60?(d=u&t|u&r|t&r,c=2400959708):(d=u^t^r,c=3395469782),g=P(s,5)+d+o+c+l.getUint32(I*4,!1)&4294967295,o=r,r=t,t=P(u,30),u=s,s=g;this._h0=this._h0+s&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[14],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(c){return Array.isArray(c)}e.isArray=w;function R(c){return typeof c=="string"}e.isString=R;function D(c){return Array.isArray(c)&&c.every(g=>R(g))}e.isStringArray=D;function y(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=y;function M(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=M;function n(c){return c===!0||c===!1}e.isBoolean=n;function S(c){return typeof c=="undefined"}e.isUndefined=S;function i(c){return!E(c)}e.isDefined=i;function E(c){return S(c)||c===null}e.isUndefinedOrNull=E;function m(c,g){if(!c)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}e.assertType=m;function P(c){if(E(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=P;function f(...c){const g=[];for(let I=0;I<c.length;I++){const A=c[I];if(E(A))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);g.push(A)}return g}e.assertAllDefined=f;const h=Object.prototype.hasOwnProperty;function v(c){if(!y(c))return!1;for(let g in c)if(h.call(c,g))return!1;return!0}e.isEmptyObject=v;function p(c){return typeof c=="function"}e.isFunction=p;function b(...c){return c.length>0&&c.every(p)}e.areFunctions=b;function l(c,g){const I=Math.min(c.length,g.length);for(let A=0;A<I;A++)a(c[A],g[A])}e.validateConstraints=l;function a(c,g){if(R(g)){if(typeof c!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(p(g)){try{if(c instanceof g)return}catch(I){}if(!E(c)&&c.constructor===g||g.length===1&&g.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function s(c){let g=[],I=Object.getPrototypeOf(c);for(;Object.prototype!==I;)g=g.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return g}e.getAllPropertyNames=s;function u(c){const g=[];for(const I of s(c))typeof c[I]=="function"&&g.push(I);return g}e.getAllMethodNames=u;function t(c,g){const I=T=>function(){const U=Array.prototype.slice.call(arguments,0);return g(T,U)};let A={};for(const T of c)A[T]=I(T);return A}e.createProxyObject=t;function r(c){return c===null?void 0:c}e.withNullAsUndefined=r;function o(c){return typeof c=="undefined"?null:c}e.withUndefinedAsNull=o;function d(c){return class{constructor(){return new Proxy({},{get(g,I){if(g[I])return g[I];throw new Error(`Not Implemented: ${c}->${String(I)}`)}})}}}e.NotImplementedProxy=d}),define(Q[28],J([0,1,3,17,6,14]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function M(r){return r===47||r===92}e.isPathSeparator=M;function n(r){return r.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=n;function S(r,o=D.posix.sep){if(!r)return"";const d=r.length,c=r.charCodeAt(0);if(M(c)){if(M(r.charCodeAt(1))&&!M(r.charCodeAt(2))){let I=3;const A=I;for(;I<d&&!M(r.charCodeAt(I));I++);if(A!==I&&!M(r.charCodeAt(I+1))){for(I+=1;I<d;I++)if(M(r.charCodeAt(I)))return r.slice(0,I+1).replace(/[\\/]/g,o)}}return o}else if(p(c)&&r.charCodeAt(1)===58)return M(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let g=r.indexOf("://");if(g!==-1){for(g+=3;g<d;g++)if(M(r.charCodeAt(g)))return r.slice(0,g+1)}return""}e.getRoot=S;function i(r){if(!w.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let d=2;const c=d;for(;d<r.length&&(o=r.charCodeAt(d),o!==92);d++);return!(c===d||(o=r.charCodeAt(d+1),isNaN(o)||o===92))}e.isUNC=i;const E=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,P=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,o=w.isWindows){const d=o?E:m;return!(!r||r.length===0||/^\s+$/.test(r)||(d.lastIndex=0,d.test(r))||o&&P.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function h(r,o,d){const c=r===o;return!d||c?c:!r||!o?!1:R.equalsIgnoreCase(r,o)}e.isEqual=h;function v(r,o,d,c=D.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(d){if(!R.startsWithIgnoreCase(r,o))return!1;if(o.length===r.length)return!0;let I=o.length;return o.charAt(o.length-1)===c&&I--,r.charAt(I)===c}return o.charAt(o.length-1)!==c&&(o+=c),r.indexOf(o)===0}e.isEqualOrParent=v;function p(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=p;function b(r,o){return w.isWindows&&r.endsWith(":")&&(r+=D.sep),D.isAbsolute(r)||(r=D.join(o,r)),r=D.normalize(r),w.isWindows?(r=R.rtrim(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=R.rtrim(r,D.sep),r||(r=D.sep)),r}e.sanitizeFilePath=b;function l(r){const o=D.normalize(r);return w.isWindows?r.length>3?!1:a(o)&&(r.length===2||o.charCodeAt(2)===92):o===D.posix.sep}e.isRootOrDriveLetter=l;function a(r){return w.isWindows?p(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function s(r){return a(r)?r[0]:void 0}e.getDriveLetter=s;function u(r,o,d){return o.length>r.length?-1:r===o?0:(d&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=u;function t(r){const o=r.split(":");let d,c,g;if(o.forEach(I=>{const A=Number(I);y.isNumber(A)?c===void 0?c=A:g===void 0&&(g=A):d=d?[d,I].join(":"):I}),!d)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:d,line:c!==void 0?c:void 0,column:g!==void 0?g:c!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(Q[41],J([0,1,14]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const v=Array.isArray(h)?[]:{};return Object.keys(h).forEach(p=>{h[p]&&typeof h[p]=="object"?v[p]=R(h[p]):v[p]=h[p]}),v}e.deepClone=R;function D(h){if(!h||typeof h!="object")return h;const v=[h];for(;v.length>0;){const p=v.shift();Object.freeze(p);for(const b in p)if(y.call(p,b)){const l=p[b];typeof l=="object"&&!Object.isFrozen(l)&&v.push(l)}}return h}e.deepFreeze=D;const y=Object.prototype.hasOwnProperty;function M(h,v){return n(h,v,new Set)}e.cloneAndChange=M;function n(h,v,p){if(w.isUndefinedOrNull(h))return h;const b=v(h);if(typeof b!="undefined")return b;if(w.isArray(h)){const l=[];for(const a of h)l.push(n(a,v,p));return l}if(w.isObject(h)){if(p.has(h))throw new Error("Cannot clone recursive data-structure");p.add(h);const l={};for(let a in h)y.call(h,a)&&(l[a]=n(h[a],v,p));return p.delete(h),l}return h}function S(h,v,p=!0){return w.isObject(h)?(w.isObject(v)&&Object.keys(v).forEach(b=>{b in h?p&&(w.isObject(h[b])&&w.isObject(v[b])?S(h[b],v[b],p):h[b]=v[b]):h[b]=v[b]}),h):v}e.mixin=S;function i(h,v){if(h===v)return!0;if(h==null||v===null||v===void 0||typeof h!=typeof v||typeof h!="object"||Array.isArray(h)!==Array.isArray(v))return!1;let p,b;if(Array.isArray(h)){if(h.length!==v.length)return!1;for(p=0;p<h.length;p++)if(!i(h[p],v[p]))return!1}else{const l=[];for(b in h)l.push(b);l.sort();const a=[];for(b in v)a.push(b);if(a.sort(),!i(l,a))return!1;for(p=0;p<l.length;p++)if(!i(h[l[p]],v[l[p]]))return!1}return!0}e.equals=i;function E(h){const v=new Set;return JSON.stringify(h,(p,b)=>{if(w.isObject(b)||Array.isArray(b)){if(v.has(b))return"[Circular]";v.add(b)}return b})}e.safeStringify=E;function m(h,v,p){const b=v(h);return typeof b=="undefined"?p:b}e.getOrDefault=m;function P(h,v){const p=Object.create(null);return!h||!v||Object.keys(v).forEach(l=>{const a=h[l],s=v[l];i(a,s)||(p[l]=s)}),p}e.distinct=P;function f(h,v){const p=v.toLowerCase(),b=Object.keys(h).find(l=>l.toLowerCase()===p);return b?h[b]:h[v]}e.getCaseInsensitive=f}),define(Q[7],J([0,1,3,6]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,y=/^\//,M=/^\/\//;function n(o,d){if(!o.scheme&&d)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!D.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!y.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(o,d){return!o&&!d?"file":o}function i(o,d){switch(o){case"https":case"http":case"file":d?d[0]!==m&&(d=m+d):d=m;break}return d}const E="",m="/",P=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(d,c,g,I,A,T=!1){typeof d=="object"?(this.scheme=d.scheme||E,this.authority=d.authority||E,this.path=d.path||E,this.query=d.query||E,this.fragment=d.fragment||E):(this.scheme=S(d,T),this.authority=c||E,this.path=i(this.scheme,g||E),this.query=I||E,this.fragment=A||E,n(this,T))}static isUri(d){return d instanceof f?!0:d?typeof d.authority=="string"&&typeof d.fragment=="string"&&typeof d.path=="string"&&typeof d.query=="string"&&typeof d.scheme=="string"&&typeof d.fsPath=="string"&&typeof d.with=="function"&&typeof d.toString=="function":!1}get fsPath(){return a(this,!1)}with(d){if(!d)return this;let{scheme:c,authority:g,path:I,query:A,fragment:T}=d;return c===void 0?c=this.scheme:c===null&&(c=E),g===void 0?g=this.authority:g===null&&(g=E),I===void 0?I=this.path:I===null&&(I=E),A===void 0?A=this.query:A===null&&(A=E),T===void 0?T=this.fragment:T===null&&(T=E),c===this.scheme&&g===this.authority&&I===this.path&&A===this.query&&T===this.fragment?this:new v(c,g,I,A,T)}static parse(d,c=!1){const g=P.exec(d);return g?new v(g[2]||E,r(g[4]||E),r(g[5]||E),r(g[7]||E),r(g[9]||E),c):new v(E,E,E,E,E)}static file(d){let c=E;if(w.isWindows&&(d=d.replace(/\\/g,m)),d[0]===m&&d[1]===m){const g=d.indexOf(m,2);g===-1?(c=d.substring(2),d=m):(c=d.substring(2,g),d=d.substring(g)||m)}return new v("file",c,d,E,E)}static from(d){return new v(d.scheme,d.authority,d.path,d.query,d.fragment)}static joinPath(d,...c){if(!d.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return w.isWindows&&d.scheme==="file"?g=f.file(R.win32.join(a(d,!0),...c)).path:g=R.posix.join(d.path,...c),d.with({path:g})}toString(d=!1){return s(this,d)}toJSON(){return this}static revive(d){if(d){if(d instanceof f)return d;{const c=new v(d);return c._formatted=d.external,c._fsPath=d._sep===h?d.fsPath:null,c}}else return d}}e.URI=f;const h=w.isWindows?1:void 0;class v extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(d=!1){return d?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const d={$mid:1};return this._fsPath&&(d.fsPath=this._fsPath,d._sep=h),this._formatted&&(d.external=this._formatted),this.path&&(d.path=this.path),this.scheme&&(d.scheme=this.scheme),this.authority&&(d.authority=this.authority),this.query&&(d.query=this.query),this.fragment&&(d.fragment=this.fragment),d}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(o,d){let c,g=-1;for(let I=0;I<o.length;I++){const A=o.charCodeAt(I);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||d&&A===47)g!==-1&&(c+=encodeURIComponent(o.substring(g,I)),g=-1),c!==void 0&&(c+=o.charAt(I));else{c===void 0&&(c=o.substr(0,I));const T=p[A];T!==void 0?(g!==-1&&(c+=encodeURIComponent(o.substring(g,I)),g=-1),c+=T):g===-1&&(g=I)}}return g!==-1&&(c+=encodeURIComponent(o.substring(g))),c!==void 0?c:o}function l(o){let d;for(let c=0;c<o.length;c++){const g=o.charCodeAt(c);g===35||g===63?(d===void 0&&(d=o.substr(0,c)),d+=p[g]):d!==void 0&&(d+=o[c])}return d!==void 0?d:o}function a(o,d){let c;return o.authority&&o.path.length>1&&o.scheme==="file"?c=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?d?c=o.path.substr(1):c=o.path[1].toLowerCase()+o.path.substr(2):c=o.path,w.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=a;function s(o,d){const c=d?l:b;let g="",{scheme:I,authority:A,path:T,query:U,fragment:j}=o;if(I&&(g+=I,g+=":"),(A||I==="file")&&(g+=m,g+=m),A){let C=A.indexOf("@");if(C!==-1){const x=A.substr(0,C);A=A.substr(C+1),C=x.indexOf(":"),C===-1?g+=c(x,!1):(g+=c(x.substr(0,C),!1),g+=":",g+=c(x.substr(C+1),!1)),g+="@"}A=A.toLowerCase(),C=A.indexOf(":"),C===-1?g+=c(A,!1):(g+=c(A.substr(0,C),!1),g+=A.substr(C))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const C=T.charCodeAt(1);C>=65&&C<=90&&(T=`/${String.fromCharCode(C+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const C=T.charCodeAt(0);C>=65&&C<=90&&(T=`${String.fromCharCode(C+32)}:${T.substr(2)}`)}g+=c(T,!0)}return U&&(g+="?",g+=c(U,!1)),j&&(g+="#",g+=d?j:b(j,!1)),g}function u(o){try{return decodeURIComponent(o)}catch(d){return o.length>3?o.substr(0,3)+u(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(o){return o.match(t)?o.replace(t,d=>u(d)):o}}),define(Q[105],J([0,1,7]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(i){const E=i;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.isRemoteConsoleLog=R;function D(i){const E=[];let m;try{const P=JSON.parse(i.arguments),f=P[P.length-1];f&&f.__$stack&&(P.pop(),m=f.__$stack),E.push(...P)}catch(P){E.push("Unable to log remote console arguments",i.arguments)}return{args:E,stack:m}}e.parse=D;function y(i){if(typeof i!="string")return y(D(i).stack);const E=i;if(E){const m=M(E),P=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(P&&P.length===4)return{uri:w.URI.file(P[1]),line:Number(P[2]),column:Number(P[3])}}}e.getFirstFrame=y;function M(i){if(!i)return i;const E=i.indexOf(`
`);return E===-1?i:i.substring(0,E)}function n(i,E){const{args:m,stack:P}=D(i),f=typeof m[0]=="string"&&m.length===1;let h=M(P);h&&(h=`(${h.trim()})`);let v=[];if(typeof m[0]=="string"?h&&f?v=[`%c[${E}] %c${m[0]} %c${h}`,S("blue"),S(""),S("grey")]:v=[`%c[${E}] %c${m[0]}`,S("blue"),S(""),...m.slice(1)]:v=[`%c[${E}]%`,S("blue"),...m],h&&!f&&v.push(h),typeof console[i.severity]!="function")throw new Error("Unknown console method");console[i.severity].apply(console,v)}e.log=n;function S(i){return`color: ${i}`}}),define(Q[35],J([0,1,7,17]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(l,a,s){let u=l.get(a);return u===void 0&&(u=s,l.set(a,u)),u}e.getOrSet=D;function y(l){const a=[];return l.forEach((s,u)=>{a.push(`${u} => ${s}`)}),`Map(${l.size}) {${a.join(", ")}}`}e.mapToString=y;function M(l){const a=[];return l.forEach(s=>{a.push(s)}),`Set(${l.size}) {${a.join(", ")}}`}e.setToString=M;class n{constructor(){this._value="",this._pos=0}reset(a){return this._value=a,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(a){const s=a.charCodeAt(0),u=this._value.charCodeAt(this._pos);return s-u}value(){return this._value[this._pos]}}e.StringIterator=n;class S{constructor(a=!0){this._caseSensitive=a}reset(a){return this._value=a,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(a)this._from++;else break;else a=!1;return this}cmp(a){return this._caseSensitive?R.compareSubstring(a,this._value,0,a.length,this._from,this._to):R.compareSubstringIgnoreCase(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=S;class i{constructor(a=!0,s=!0){this._splitOnBackslash=a,this._caseSensitive=s}reset(a){return this._value=a.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(a)this._from++;else break;else a=!1}return this}cmp(a){return this._caseSensitive?R.compareSubstring(a,this._value,0,a.length,this._from,this._to):R.compareSubstringIgnoreCase(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=i;var E;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(E||(E={}));class m{constructor(a){this._ignorePathCasing=a,this._states=[],this._stateIdx=0}reset(a){return this._value=a,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new i(!1,!this._ignorePathCasing(a)),this._pathIterator.reset(a.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(a){if(this._states[this._stateIdx]===1)return R.compareIgnoreCase(a,this._value.scheme);if(this._states[this._stateIdx]===2)return R.compareIgnoreCase(a,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(a);if(this._states[this._stateIdx]===4)return R.compare(a,this._value.query);if(this._states[this._stateIdx]===5)return R.compare(a,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=m;class P{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class f{constructor(a){this._iter=a}static forUris(a=()=>!1){return new f(new m(a))}static forPaths(){return new f(new i)}static forStrings(){return new f(new n)}static forConfigKeys(){return new f(new S)}clear(){this._root=void 0}set(a,s){const u=this._iter.reset(a);let t;for(this._root||(this._root=new P,this._root.segment=u.value()),t=this._root;;){const o=u.cmp(t.segment);if(o>0)t.left||(t.left=new P,t.left.segment=u.value()),t=t.left;else if(o<0)t.right||(t.right=new P,t.right.segment=u.value()),t=t.right;else if(u.hasNext())u.next(),t.mid||(t.mid=new P,t.mid.segment=u.value()),t=t.mid;else break}const r=t.value;return t.value=s,t.key=a,r}get(a){var s;return(s=this._getNode(a))===null||s===void 0?void 0:s.value}_getNode(a){const s=this._iter.reset(a);let u=this._root;for(;u;){const t=s.cmp(u.segment);if(t>0)u=u.left;else if(t<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else break}return u}has(a){const s=this._getNode(a);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(a){return this._delete(a,!1)}deleteSuperstr(a){return this._delete(a,!0)}_delete(a,s){const u=this._iter.reset(a),t=[];let r=this._root;for(;r;){const o=u.cmp(r.segment);if(o>0)t.push([1,r]),r=r.left;else if(o<0)t.push([-1,r]),r=r.right;else if(u.hasNext())u.next(),t.push([0,r]),r=r.mid;else{for(s?(r.left=void 0,r.mid=void 0,r.right=void 0):r.value=void 0;t.length>0&&r.isEmpty();){let[d,c]=t.pop();switch(d){case 1:c.left=void 0;break;case 0:c.mid=void 0;break;case-1:c.right=void 0;break}r=c}break}}}findSubstr(a){const s=this._iter.reset(a);let u=this._root,t;for(;u;){const r=s.cmp(u.segment);if(r>0)u=u.left;else if(r<0)u=u.right;else if(s.hasNext())s.next(),t=u.value||t,u=u.mid;else break}return u&&u.value||t}findSuperstr(a){const s=this._iter.reset(a);let u=this._root;for(;u;){const t=s.cmp(u.segment);if(t>0)u=u.left;else if(t<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(a){for(const[s,u]of this)a(u,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(a){a&&(yield*this._entries(a.left),a.value&&(yield[a.key,a.value]),yield*this._entries(a.mid),yield*this._entries(a.right))}}e.TernarySearchTree=f;class h{constructor(a,s){this[Symbol.toStringTag]="ResourceMap",a instanceof h?(this.map=new Map(a.map),this.toKey=s!=null?s:h.defaultToKey):(this.map=new Map,this.toKey=a!=null?a:h.defaultToKey)}set(a,s){return this.map.set(this.toKey(a),s),this}get(a){return this.map.get(this.toKey(a))}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,s){typeof s!="undefined"&&(a=a.bind(s));for(let[u,t]of this.map)a(t,w.URI.parse(u),this)}values(){return this.map.values()}*keys(){for(let a of this.map.keys())yield w.URI.parse(a)}*entries(){for(let a of this.map.entries())yield[w.URI.parse(a[0]),a[1]]}*[Symbol.iterator](){for(let a of this.map)yield[w.URI.parse(a[0]),a[1]]}}e.ResourceMap=h,h.defaultToKey=l=>l.toString();var v;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class p{constructor(){this[Symbol.toStringTag]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var a;return(a=this._head)===null||a===void 0?void 0:a.value}get last(){var a;return(a=this._tail)===null||a===void 0?void 0:a.value}has(a){return this._map.has(a)}get(a,s=0){const u=this._map.get(a);if(!!u)return s!==0&&this.touch(u,s),u.value}set(a,s,u=0){let t=this._map.get(a);if(t)t.value=s,u!==0&&this.touch(t,u);else{switch(t={key:a,value:s,next:void 0,previous:void 0},u){case 0:this.addItemLast(t);break;case 1:this.addItemFirst(t);break;case 2:this.addItemLast(t);break;default:this.addItemLast(t);break}this._map.set(a,t),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const s=this._map.get(a);if(!!s)return this._map.delete(a),this.removeItem(s),this._size--,s.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}}forEach(a,s){const u=this._state;let t=this._head;for(;t;){if(s?a.bind(s)(t.value,t.key,this):a(t.value,t.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const a=this,s=this._state;let u=this._head;const t={[Symbol.iterator](){return t},next(){if(a._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const r={value:u.key,done:!1};return u=u.next,r}else return{value:void 0,done:!0}}};return t}values(){const a=this,s=this._state;let u=this._head;const t={[Symbol.iterator](){return t},next(){if(a._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const r={value:u.value,done:!1};return u=u.next,r}else return{value:void 0,done:!0}}};return t}entries(){const a=this,s=this._state;let u=this._head;const t={[Symbol.iterator](){return t},next(){if(a._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const r={value:[u.key,u.value],done:!1};return u=u.next,r}else return{value:void 0,done:!0}}};return t}[Symbol.iterator](){return this.entries()}trimOld(a){if(!(a>=this.size)){if(a===0){this.clear();return}let s=this._head,u=this.size;for(;s&&u>a;)this._map.delete(s.key),s=s.next,u--;this._head=s,this._size=u,s&&(s.previous=void 0),this._state++}}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const s=a.next,u=a.previous;if(!s||!u)throw new Error("Invalid list");s.previous=u,u.next=s}a.next=void 0,a.previous=void 0,this._state++}touch(a,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(a===this._head)return;const u=a.next,t=a.previous;a===this._tail?(t.next=void 0,this._tail=t):(u.previous=t,t.next=u),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(s===2){if(a===this._tail)return;const u=a.next,t=a.previous;a===this._head?(u.previous=void 0,this._head=u):(u.previous=t,t.next=u),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((s,u)=>{a.push([u,s])}),a}fromJSON(a){this.clear();for(const[s,u]of a)this.set(s,u)}}e.LinkedMap=p;class b extends p{constructor(a,s=1){super();this._limit=a,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,s=2){return super.get(a,s)}peek(a){return super.get(a,0)}set(a,s){return super.set(a,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=b}),define(Q[75],J([0,1,17,28,6,35,9]),function($,e,w,R,D,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const S="**",i="/",E="[/\\\\]",m="[^/\\\\]",P=/\//g;function f(k){switch(k){case 0:return"";case 1:return`${m}*?`;default:return`(?:${E}|${m}+${E}|${E}${m}+)*?`}}function h(k,L){if(!k)return[];const _=[];let W=!1,B=!1,K="";for(const X of k){switch(X){case L:if(!W&&!B){_.push(K),K="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":B=!0;break;case"]":B=!1;break}K+=X}return K&&_.push(K),_}e.splitGlobAware=h;function v(k){if(!k)return"";let L="";const _=h(k,i);if(_.every(W=>W===S))L=".*";else{let W=!1;_.forEach((B,K)=>{if(B===S){W||(L+=f(2),W=!0);return}let X=!1,Y="",oe=!1,le="";for(const ie of B){if(ie!=="}"&&X){Y+=ie;continue}if(oe&&(ie!=="]"||!le)){let G;ie==="-"?G=ie:(ie==="^"||ie==="!")&&!le?G="^":ie===i?G="":G=w.escapeRegExpCharacters(ie),le+=G;continue}switch(ie){case"{":X=!0;continue;case"[":oe=!0;continue;case"}":L+=`(?:${h(Y,",").map(se=>v(se)).join("|")})`,X=!1,Y="";break;case"]":L+="["+le+"]",oe=!1,le="";break;case"?":L+=m;continue;case"*":L+=f(1);continue;default:L+=w.escapeRegExpCharacters(ie)}}K<_.length-1&&(_[K+1]!==S||K+2<_.length)&&(L+=E),W=!1})}return L}const p=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),r=function(){return!1},o=function(){return null};function d(k,L){if(!k)return o;let _;typeof k!="string"?_=k.pattern:_=k,_=_.trim();const W=`${_}_${!!L.trimForExclusions}`;let B=t.get(W);if(B)return c(B,k);let K;if(p.test(_)){const X=_.substr(4);B=function(Y,oe){return typeof Y=="string"&&Y.endsWith(X)?_:null}}else(K=b.exec(g(_,L)))?B=I(K[1],_):(L.trimForExclusions?a:l).test(_)?B=A(_,L):(K=s.exec(g(_,L)))?B=T(K[1].substr(1),_,!0):(K=u.exec(g(_,L)))?B=T(K[1],_,!1):B=U(_);return t.set(W,B),c(B,k)}function c(k,L){return typeof L=="string"?k:function(_,W){return R.isEqualOrParent(_,L.base)?k(D.relative(L.base,_),W):null}}function g(k,L){return L.trimForExclusions&&k.endsWith("/**")?k.substr(0,k.length-2):k}function I(k,L){const _=`/${k}`,W=`\\${k}`,B=function(X,Y){return typeof X!="string"?null:Y?Y===k?L:null:X===k||X.endsWith(_)||X.endsWith(W)?L:null},K=[k];return B.basenames=K,B.patterns=[L],B.allBasenames=K,B}function A(k,L){const _=O(k.slice(1,-1).split(",").map(Y=>d(Y,L)).filter(Y=>Y!==o),k),W=_.length;if(!W)return o;if(W===1)return _[0];const B=function(Y,oe){for(let le=0,ie=_.length;le<ie;le++)if(_[le](Y,oe))return k;return null},K=_.find(Y=>!!Y.allBasenames);K&&(B.allBasenames=K.allBasenames);const X=_.reduce((Y,oe)=>oe.allPaths?Y.concat(oe.allPaths):Y,[]);return X.length&&(B.allPaths=X),B}function T(k,L,_){const W=D.sep===D.posix.sep,B=W?k:k.replace(P,D.sep),K=D.sep+B,X=D.posix.sep+k,Y=_?function(oe,le){return typeof oe=="string"&&(oe===B||oe.endsWith(K)||!W&&(oe===k||oe.endsWith(X)))?L:null}:function(oe,le){return typeof oe=="string"&&(oe===B||!W&&oe===k)?L:null};return Y.allPaths=[(_?"*/":"./")+k],Y}function U(k){try{const L=new RegExp(`^${v(k)}$`);return function(_){return L.lastIndex=0,typeof _=="string"&&L.test(_)?k:null}}catch(L){return o}}function j(k,L,_){return!k||typeof L!="string"?!1:C(k)(L,void 0,_)}e.match=j;function C(k,L={}){if(!k)return r;if(typeof k=="string"||H(k)){const _=d(k,L);if(_===o)return r;const W=function(B,K){return!!_(B,K)};return _.allBasenames&&(W.allBasenames=_.allBasenames),_.allPaths&&(W.allPaths=_.allPaths),W}return F(k,L)}e.parse=C;function x(k){if(!!k){let L;return _=>(L||(L=(k()||Promise.resolve([])).then(W=>W?Z(W):{})),L.then(W=>!!W[_]))}}e.hasSiblingPromiseFn=x;function ee(k){if(!!k){let L;return _=>{if(!L){const W=k();L=W?Z(W):{}}return!!L[_]}}}e.hasSiblingFn=ee;function Z(k){const L={};for(const _ of k)L[_]=!0;return L}function H(k){const L=k;return L&&typeof L.base=="string"&&typeof L.pattern=="string"}e.isRelativePattern=H;function N(k){return k.allBasenames||[]}e.getBasenameTerms=N;function q(k){return k.allPaths||[]}e.getPathTerms=q;function F(k,L){const _=O(Object.getOwnPropertyNames(k).map(Y=>z(Y,k[Y],L)).filter(Y=>Y!==o)),W=_.length;if(!W)return o;if(!_.some(Y=>!!Y.requiresSiblings)){if(W===1)return _[0];const Y=function(ie,G){for(let te=0,se=_.length;te<se;te++){const ae=_[te](ie,G);if(ae)return ae}return null},oe=_.find(ie=>!!ie.allBasenames);oe&&(Y.allBasenames=oe.allBasenames);const le=_.reduce((ie,G)=>G.allPaths?ie.concat(G.allPaths):ie,[]);return le.length&&(Y.allPaths=le),Y}const B=function(Y,oe,le){let ie;for(let G=0,te=_.length;G<te;G++){const se=_[G];se.requiresSiblings&&le&&(oe||(oe=D.basename(Y)),ie||(ie=oe.substr(0,oe.length-D.extname(Y).length)));const ae=se(Y,oe,ie,le);if(ae)return ae}return null},K=_.find(Y=>!!Y.allBasenames);K&&(B.allBasenames=K.allBasenames);const X=_.reduce((Y,oe)=>oe.allPaths?Y.concat(oe.allPaths):Y,[]);return X.length&&(B.allPaths=X),B}function z(k,L,_){if(L===!1)return o;const W=d(k,_);if(W===o)return o;if(typeof L=="boolean")return W;if(L){const B=L.when;if(typeof B=="string"){const K=(X,Y,oe,le)=>{if(!le||!W(X,Y))return null;const ie=B.replace("$(basename)",oe),G=le(ie);return M.isThenable(G)?G.then(te=>te?k:null):G?k:null};return K.requiresSiblings=!0,K}}return W}function O(k,L){const _=k.filter(Y=>!!Y.basenames);if(_.length<2)return k;const W=_.reduce((Y,oe)=>{const le=oe.basenames;return le?Y.concat(le):Y},[]);let B;if(L){B=[];for(let Y=0,oe=W.length;Y<oe;Y++)B.push(L)}else B=_.reduce((Y,oe)=>{const le=oe.patterns;return le?Y.concat(le):Y},[]);const K=function(Y,oe){if(typeof Y!="string")return null;if(!oe){let ie;for(ie=Y.length;ie>0;ie--){const G=Y.charCodeAt(ie-1);if(G===47||G===92)break}oe=Y.substr(ie)}const le=W.indexOf(oe);return le!==-1?B[le]:null};K.basenames=W,K.patterns=B,K.allBasenames=W;const X=k.filter(Y=>!Y.basenames);return X.push(K),X}}),define(Q[106],J([0,1,20,17,7]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function y(i){return JSON.stringify(i,n)}e.stringify=y;function M(i){let E=JSON.parse(i);return E=S(E),E}e.parse=M;function n(i,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:R.regExpFlags(E)}:E}function S(i,E=0){if(!i||E>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return D.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof w.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let m=0;m<i.length;++m)i[m]=S(i[m],E+1);else for(const m in i)Object.hasOwnProperty.call(i,m)&&(i[m]=S(i[m],E+1))}return i}e.revive=S}),define(Q[10],J([0,1,7,3]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeSettings="vscode-settings",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.vscodeWebviewResource="vscode-webview-resource",n.extension="extension",n.vscodeFileResource="vscode-file"})(D=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,i,E){this._hosts[S]=i,this._ports[S]=E}setConnectionToken(S,i){this._connectionTokens[S]=i}rewrite(S){if(this._delegate)return this._delegate(S);const i=S.authority;let E=this._hosts[i];E&&E.indexOf(":")!==-1&&(E=`[${E}]`);const m=this._ports[i],P=this._connectionTokens[i];let f=`path=${encodeURIComponent(S.path)}`;return typeof P=="string"&&(f+=`&tkn=${encodeURIComponent(P)}`),w.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${E}:${m}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new y;class M{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(S,i,E){const m=this.toUri(S,i);return m.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(m):R.isNative&&(E||R.isPreferringBrowserCodeLoad)&&m.scheme===D.file?m.with({scheme:D.vscodeFileResource,authority:m.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):m}asFileUri(S,i){const E=this.toUri(S,i);return E.scheme===D.vscodeFileResource?E.with({scheme:D.file,authority:E.authority!==this.FALLBACK_AUTHORITY?E.authority:null,query:null,fragment:null}):E}toUri(S,i){return w.URI.isUri(S)?S:w.URI.parse(i.toUrl(S))}}e.FileAccess=new M}),define(Q[65],J([0,1,35]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new w.LRUCache(1e4);function D(i){return S(i,"NFC",R)}e.normalizeNFC=D;const y=new w.LRUCache(1e4);function M(i){return S(i,"NFD",y)}e.normalizeNFD=M;const n=/[^\u0000-\u0080]/;function S(i,E,m){if(!e.canNormalize||!i)return i;const P=m.get(i);if(P)return P;let f;return n.test(i)?f=i.normalize(E):f=i,m.set(i,f),f}e.removeAccents=function(){if(e.canNormalize){const i=/[\u0300-\u036f]/g;return function(E){return M(E).replace(i,"")}}else return function(i){return i}}()}),define(Q[18],J([0,1,28,6,7,17,10,3]),function($,e,w,R,D,y,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(f){return D.uriToFsPath(f,!0)}e.originalFSPath=S;class i{constructor(h){this._ignorePathCasing=h}compare(h,v,p=!1){return h===v?0:y.compare(this.getComparisonKey(h,p),this.getComparisonKey(v,p))}isEqual(h,v,p=!1){return h===v?!0:!h||!v?!1:this.getComparisonKey(h,p)===this.getComparisonKey(v,p)}getComparisonKey(h,v=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,v,p=!1){if(h.scheme===v.scheme){if(h.scheme===M.Schemas.file)return w.isEqualOrParent(S(h),S(v),this._ignorePathCasing(h))&&h.query===v.query&&(p||h.fragment===v.fragment);if(e.isEqualAuthority(h.authority,v.authority))return w.isEqualOrParent(h.path,v.path,this._ignorePathCasing(h),"/")&&h.query===v.query&&(p||h.fragment===v.fragment)}return!1}joinPath(h,...v){return D.URI.joinPath(h,...v)}basenameOrAuthority(h){return e.basename(h)||h.authority}basename(h){return R.posix.basename(h.path)}extname(h){return R.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let v;return h.scheme===M.Schemas.file?v=D.URI.file(R.dirname(S(h))).path:(v=R.posix.dirname(h.path),h.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),v="/")),h.with({path:v})}normalizePath(h){if(!h.path.length)return h;let v;return h.scheme===M.Schemas.file?v=D.URI.file(R.normalize(S(h))).path:v=R.posix.normalize(h.path),h.with({path:v})}relativePath(h,v){if(!(h.scheme!==v.scheme||!e.isEqualAuthority(h.authority,v.authority))){if(h.scheme===M.Schemas.file){const l=R.relative(S(h),S(v));return n.isWindows?w.toSlashes(l):l}let p=h.path||"/",b=v.path||"/";if(this._ignorePathCasing(h)){let l=0;for(const a=Math.min(p.length,b.length);l<a&&!(p.charCodeAt(l)!==b.charCodeAt(l)&&p.charAt(l).toLowerCase()!==b.charAt(l).toLowerCase());l++);p=b.substr(0,l)+p.substr(l)}return R.posix.relative(p,b)}}resolvePath(h,v){if(h.scheme===M.Schemas.file){const p=D.URI.file(R.resolve(S(h),v));return h.with({authority:p.authority,path:p.path})}return v.indexOf("/")===-1&&(v=w.toSlashes(v),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v)),h.with({path:R.posix.resolve(h.path,v)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,v){return h===v||y.equalsIgnoreCase(h,v)}hasTrailingPathSeparator(h,v=R.sep){if(h.scheme===M.Schemas.file){const p=S(h);return p.length>w.getRoot(p).length&&p[p.length-1]===v}else{const p=h.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,v=R.sep){return e.hasTrailingPathSeparator(h,v)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,v=R.sep){let p=!1;if(h.scheme===M.Schemas.file){const b=S(h);p=b!==void 0&&b.length===w.getRoot(b).length&&b[b.length-1]===v}else{v="/";const b=h.path;p=b.length===1&&b.charCodeAt(b.length-1)===47}return!p&&!e.hasTrailingPathSeparator(h,v)?h.with({path:h.path+"/"}):h}}e.ExtUri=i,e.extUri=new i(()=>!1),e.extUriBiasedIgnorePathCase=new i(f=>f.scheme===M.Schemas.file?!n.isLinux:!0),e.extUriIgnorePathCase=new i(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function E(f,h){const v=[];for(let p=0;p<f.length;p++){const b=h(f[p]);f.some((l,a)=>a===p?!1:e.isEqualOrParent(b,h(l)))||v.push(f[p])}return v}e.distinctParents=E;var m;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function h(v){const p=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(a=>{const[s,u]=a.split(":");s&&u&&p.set(s,u)});const l=v.path.substring(0,v.path.indexOf(";"));return l&&p.set(f.META_DATA_MIME,l),p}f.parseMetaData=h})(m=e.DataUri||(e.DataUri={}));function P(f,h,v){if(h){let p=f.path;return p&&p[0]!==R.posix.sep&&(p=R.posix.sep+p),f.with({scheme:v,authority:h,path:p})}return f.with({scheme:v})}e.toLocalResource=P}),define(Q[38],J([0,1,7,6,17,10,3,18,28]),function($,e,w,R,D,y,M,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function i(d,c,g){if(typeof d=="string"&&(d=w.URI.file(d)),g){const A=g.getWorkspaceFolder(d);if(A){const T=g.getWorkspace().folders.length>1;let U;if(n.isEqual(A.uri,d)?U="":U=n.relativePath(A.uri,d),T){const j=A.name?A.name:n.basename(A.uri);U=U?j+" \u2022 "+U:j}return U}}if(d.scheme!==y.Schemas.file&&d.scheme!==y.Schemas.untitled)return d.with({query:null,fragment:null}).toString(!0);if(S.hasDriveLetter(d.fsPath))return R.normalize(m(d.fsPath));let I=R.normalize(d.fsPath);return!M.isWindows&&(c==null?void 0:c.userHome)&&(I=f(I,c.userHome.fsPath)),I}e.getPathLabel=i;function E(d){if(!!d){typeof d=="string"&&(d=w.URI.file(d));const c=n.basename(d)||(d.scheme===y.Schemas.file?d.fsPath:d.path);return M.isWindows&&S.isRootOrDriveLetter(c)?m(c):c}}e.getBaseLabel=E;function m(d){return S.hasDriveLetter(d)?d.charAt(0).toUpperCase()+d.slice(1):d}e.normalizeDriveLetter=m;let P=Object.create(null);function f(d,c){if(M.isWindows||!d||!c)return d;let g=P.original===c?P.normalized:void 0;return g||(g=`${D.rtrim(c,R.posix.sep)}${R.posix.sep}`,P={original:c,normalized:g}),(M.isLinux?d.startsWith(g):D.startsWithIgnoreCase(d,g))&&(d=`~/${d.substr(g.length)}`),d}e.tildify=f;function h(d,c){return d.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=h;const v="\u2026",p="\\\\",b="~";function l(d,c=R.sep){const g=new Array(d.length);let I=!1;for(let A=0;A<d.length;A++){let T=d[A];if(T===""){g[A]=`.${c}`;continue}if(!T){g[A]=T;continue}I=!0;let U="";T.indexOf(p)===0?(U=T.substr(0,T.indexOf(p)+p.length),T=T.substr(T.indexOf(p)+p.length)):T.indexOf(c)===0?(U=T.substr(0,T.indexOf(c)+c.length),T=T.substr(T.indexOf(c)+c.length)):T.indexOf(b)===0&&(U=T.substr(0,T.indexOf(b)+b.length),T=T.substr(T.indexOf(b)+b.length));const j=T.split(c);for(let C=1;I&&C<=j.length;C++)for(let x=j.length-C;I&&x>=0;x--){I=!1;let ee=j.slice(x,x+C).join(c);for(let Z=0;!I&&Z<d.length;Z++)if(Z!==A&&d[Z]&&d[Z].indexOf(ee)>-1){const H=x+C===j.length,N=x>0&&d[Z].indexOf(c)>-1?c+ee:ee,q=d[Z].endsWith(N);I=!H||q}if(!I){let Z="";(j[0].endsWith(":")||U!=="")&&(x===1&&(x=0,C++,ee=j[0]+c+ee),x>0&&(Z=j[0]+c),Z=U+Z),x>0&&(Z=Z+v+c),Z=Z+ee,x+C<j.length&&(Z=Z+c+v),g[A]=Z}}I&&(g[A]=T)}return g}e.shorten=l;var a;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function s(d,c=Object.create(null)){const g=[];let I=!1,A="";for(const T of d)if(T==="$"||I&&T==="{")A&&g.push({value:A,type:a.TEXT}),A="",I=!0;else if(T==="}"&&I){const U=c[A];if(typeof U=="string")U.length&&g.push({value:U,type:a.VARIABLE});else if(U){const j=g[g.length-1];(!j||j.type!==a.SEPARATOR)&&g.push({value:U.label,type:a.SEPARATOR})}A="",I=!1}else A+=T;return A&&!I&&g.push({value:A,type:a.TEXT}),g.filter((T,U)=>{if(T.type===a.SEPARATOR){const j=g[U-1],C=g[U+1];return[j,C].every(x=>x&&(x.type===a.VARIABLE||x.type===a.TEXT)&&x.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=s;function u(d,c){return M.isMacintosh||c?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):d.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function t(d,c){return M.isMacintosh||c?d.replace(/\(&&\w\)|&&/g,""):M.isWindows?d.replace(/&&|&/g,g=>g==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(d){return d.replace(/&/g,"&&")}e.unmnemonicLabel=r;function o(d){const c=d.indexOf("/")!==-1?R.posix:R.win32,g=c.basename(d),I=c.dirname(d);return g.length?{name:g,parentPath:I}:{name:I,parentPath:""}}e.splitName=o}),define(Q[107],J([0,1,6,17,75,10,18]),function($,e,w,R,D,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.MIME_UNKNOWN=e.MIME_BINARY=e.MIME_TEXT=void 0,e.MIME_TEXT="text/plain",e.MIME_BINARY="application/octet-stream",e.MIME_UNKNOWN="application/unknown";let n=[],S=[],i=[];function E(s,u=!1){const t=m(s);n.push(t),t.userConfigured?i.push(t):S.push(t),u&&!t.userConfigured&&n.forEach(r=>{r.mime===t.mime||r.userConfigured||(t.extension&&r.extension===t.extension&&console.warn(`Overwriting extension <<${t.extension}>> to now point to mime <<${t.mime}>>`),t.filename&&r.filename===t.filename&&console.warn(`Overwriting filename <<${t.filename}>> to now point to mime <<${t.mime}>>`),t.filepattern&&r.filepattern===t.filepattern&&console.warn(`Overwriting filepattern <<${t.filepattern}>> to now point to mime <<${t.mime}>>`),t.firstline&&r.firstline===t.firstline&&console.warn(`Overwriting firstline <<${t.firstline}>> to now point to mime <<${t.mime}>>`))})}e.registerTextMime=E;function m(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?s.filepattern.toLowerCase():void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(w.posix.sep)>=0:!1}}function P(s){s?(n=n.filter(u=>!u.userConfigured),i=[]):(n=[],S=[],i=[])}e.clearTextMimes=P;function f(s,u){let t;if(s)switch(s.scheme){case y.Schemas.file:t=s.fsPath;break;case y.Schemas.data:t=M.DataUri.parseMetaData(s).get(M.DataUri.META_DATA_LABEL);break;default:t=s.path}if(!t)return[e.MIME_UNKNOWN];t=t.toLowerCase();const r=w.basename(t),o=h(t,r,i);if(o)return[o,e.MIME_TEXT];const d=h(t,r,S);if(d)return[d,e.MIME_TEXT];if(u){const c=v(u);if(c)return[c,e.MIME_TEXT]}return[e.MIME_UNKNOWN]}e.guessMimeTypes=f;function h(s,u,t){let r=null,o=null,d=null;for(let c=t.length-1;c>=0;c--){const g=t[c];if(u===g.filenameLowercase){r=g;break}if(g.filepattern&&(!o||g.filepattern.length>o.filepattern.length)){const I=g.filepatternOnPath?s:u;D.match(g.filepatternLowercase,I)&&(o=g)}g.extension&&(!d||g.extension.length>d.extension.length)&&u.endsWith(g.extensionLowercase)&&(d=g)}return r?r.mime:o?o.mime:d?d.mime:null}function v(s){if(R.startsWithUTF8BOM(s)&&(s=s.substr(1)),s.length>0)for(let u=n.length-1;u>=0;u--){const t=n[u];if(!!t.firstline){const r=s.match(t.firstline);if(r&&r.length>0)return t.mime}}return null}function p(s){return s?typeof s=="string"?s===e.MIME_BINARY||s===e.MIME_TEXT||s===e.MIME_UNKNOWN:s.length===1&&p(s[0]):!0}e.isUnspecific=p;const b={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function l(s){const u=w.extname(s);return b[u.toLowerCase()]}e.getMediaMime=l;function a(s){for(const u in b)if(b[u]===s)return u}e.getExtensionForMimeType=a}),define(Q[29],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(S){return w.test(S)}e.isUUID=R;const D=new Uint8Array(16),y=[];for(let S=0;S<256;S++)y.push(S.toString(16).padStart(2,"0"));const M=function(S){for(let i=0;i<S.length;i++)S[i]=Math.floor(Math.random()*256);return S};function n(){M(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let S=0,i="";return i+=y[D[S++]],i+=y[D[S++]],i+=y[D[S++]],i+=y[D[S++]],i+="-",i+=y[D[S++]],i+=y[D[S++]],i+="-",i+=y[D[S++]],i+=y[D[S++]],i+="-",i+=y[D[S++]],i+=y[D[S++]],i+="-",i+=y[D[S++]],i+=y[D[S++]],i+=y[D[S++]],i+=y[D[S++]],i+=y[D[S++]],i+=y[D[S++]],i}e.generateUuid=n}),define(Q[108],J([0,1,25,57,44]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function y(M,n){if(await new Promise((E,m)=>{const P=w.createReadStream(M),f=R.createHash("sha1");P.pipe(f);const h=D.once((v,p)=>{P.removeAllListeners(),f.removeAllListeners(),v?m(v):E(p)});P.once("error",h),P.once("end",h),f.once("error",h),f.once("data",v=>h(void 0,v.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=y}),define(Q[76],J([0,1,231]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(y="utf8"){this.stringDecoder=new w.StringDecoder(y),this.remaining=null}write(y){const M=[],n=this.remaining?this.remaining+this.stringDecoder.write(y):this.stringDecoder.write(y);if(n.length<1)return M;let S=0,i,E=S;for(;E<n.length;)if(i=n.charCodeAt(E),i===13||i===10){if(M.push(n.substring(S,E)),E++,E<n.length){const m=i;i=n.charCodeAt(E),(m===13&&i===10||m===10&&i===13)&&E++}S=E}else E++;return this.remaining=S<n.length?n.substr(S):null,M}end(){return this.remaining}}e.LineDecoder=R}),define(Q[109],J([0,1,27]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(n){const S=n.replace(/\-/g,":").toLowerCase();return!R.has(S)}function y(){return new Promise(async(n,S)=>{const i=setTimeout(()=>S("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await M())}catch(E){S(E)}finally{clearTimeout(i)}})}e.getMac=y;function M(){return new Promise((n,S)=>{try{const i=w.networkInterfaces();for(const[,E]of Object.entries(i))for(const m of E)if(D(m.mac))return n(m.mac);S("Unable to retrieve mac address (unexpected format)")}catch(i){S(i)}})}}),define(Q[66],J([0,1,16,29,27,35,109]),function($,e,w,R,D,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(E){return this._virtualMachineOUIs||(this._virtualMachineOUIs=y.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(E)}value(){if(this._value===void 0){let E=0,m=0;const P=D.networkInterfaces();for(let f in P)if(Object.prototype.hasOwnProperty.call(P,f))for(const{mac:h,internal:v}of P[f])v||(m+=1,this._isVirtualMachineMacAdress(h.toUpperCase())&&(E+=1));this._value=m>0?E/m:0}return this._value}};let n;async function S(){return n||(n=(async()=>await i()||R.generateUuid())()),n}e.getMachineId=S;async function i(){try{const E=await new Promise((P,f)=>{$(["crypto"],P,f)}),m=await M.getMac();return E.createHash("sha256").update(m,"utf8").digest("hex")}catch(E){w.onUnexpectedError(E);return}}}),define(Q[110],J([0,1,10]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getDefaultUserDataPath=void 0;const R=w.FileAccess.asFileUri("paths",$).fsPath,D=$.__$__nodeRequire(R);e.getDefaultUserDataPath=D.getDefaultUserDataPath}),define(Q[26],J([0,1,25,27,6,9,3,4,67,28,29,65]),function($,e,w,R,D,y,M,n,S,i,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.copy=e.move=e.whenDeleted=e.fileExists=e.dirExists=e.readDirsInDir=e.writeFileSync=e.writeFile=e.mkdirp=e.readFile=e.truncate=e.symlink=e.unlink=e.readlink=e.renameIgnoreError=e.rename=e.lstat=e.statLink=e.stat=e.chmod=e.exists=e.readdirSync=e.readdirWithFileTypes=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=e.MAX_HEAP_SIZE=e.MAX_FILE_SIZE=void 0;const P=300*1024*1024,f=16*1024*1024*1024,h=700*1024*1024,v=700*2*1024*1024;e.MAX_FILE_SIZE=process.arch==="ia32"?P:f,e.MAX_HEAP_SIZE=process.arch==="ia32"?h:v;var p;(function(G){G[G.UNLINK=0]="UNLINK",G[G.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function b(G,te=p.UNLINK){if(i.isRootOrDriveLetter(G))throw new Error("rimraf - will refuse to recursively delete root");return te===p.UNLINK?l(G):a(G)}e.rimraf=b;async function l(G){try{const te=await A(G);if(te.isDirectory()&&!te.isSymbolicLink()){const se=await u(G);await Promise.all(se.map(ae=>l(D.join(G,ae)))),await S.promisify(w.rmdir)(G)}else{const se=te.mode;return se&w.constants.S_IWUSR||await c(G,se|w.constants.S_IWUSR),C(G)}}catch(te){if(te.code!=="ENOENT")throw te}}async function a(G){try{const te=D.join(R.tmpdir(),E.generateUuid());try{await T(G,te)}catch(se){return l(G)}l(te)}catch(te){if(te.code!=="ENOENT")throw te}}function s(G){if(i.isRootOrDriveLetter(G))throw new Error("rimraf - will refuse to recursively delete root");try{const te=w.lstatSync(G);if(te.isDirectory()&&!te.isSymbolicLink())r(G).map(ae=>s(D.join(G,ae))),w.rmdirSync(G);else{const se=te.mode;return se&w.constants.S_IWUSR||w.chmodSync(G,se|w.constants.S_IWUSR),w.unlinkSync(G)}}catch(te){if(te.code!=="ENOENT")throw te}}e.rimrafSync=s;async function u(G){return o(await S.promisify(w.readdir)(G))}e.readdir=u;async function t(G){const te=await S.promisify(w.readdir)(G,{withFileTypes:!0});if(M.isMacintosh)for(const se of te)se.name=m.normalizeNFC(se.name);return te}e.readdirWithFileTypes=t;function r(G){return o(w.readdirSync(G))}e.readdirSync=r;function o(G){return M.isMacintosh?G.map(te=>m.normalizeNFC(te)):G}function d(G){return S.promisify(w.exists)(G)}e.exists=d;function c(G,te){return S.promisify(w.chmod)(G,te)}e.chmod=c;function g(G){return S.promisify(w.stat)(G)}e.stat=g;async function I(G){let te;try{if(te=await A(G),!te.isSymbolicLink())return{stat:te}}catch(se){}try{return{stat:await g(G),symbolicLink:(te==null?void 0:te.isSymbolicLink())?{dangling:!1}:void 0}}catch(se){if(se.code==="ENOENT"&&te)return{stat:te,symbolicLink:{dangling:!0}};if(M.isWindows&&se.code==="EACCES"&&te)try{return{stat:await g(await j(G)),symbolicLink:te.isSymbolicLink()?{dangling:!1}:void 0}}catch(ae){if(ae.code==="ENOENT")return{stat:te,symbolicLink:{dangling:!0}};throw ae}throw se}}e.statLink=I;function A(G){return S.promisify(w.lstat)(G)}e.lstat=A;function T(G,te){return S.promisify(w.rename)(G,te)}e.rename=T;function U(G,te){return new Promise(se=>w.rename(G,te,()=>se()))}e.renameIgnoreError=U;function j(G){return S.promisify(w.readlink)(G)}e.readlink=j;function C(G){return S.promisify(w.unlink)(G)}e.unlink=C;function x(G,te,se){return S.promisify(w.symlink)(G,te,se)}e.symlink=x;function ee(G,te){return S.promisify(w.truncate)(G,te)}e.truncate=ee;function Z(G,te){return S.promisify(w.readFile)(G,te)}e.readFile=Z;async function H(G,te){return S.promisify(w.mkdir)(G,{mode:te,recursive:!0})}e.mkdirp=H;const N=new Map;function q(G,te,se){const ae=F(G);return z(ae).queue(()=>{const he=_(se);return new Promise((ve,be)=>k(G,te,he,Ie=>Ie?be(Ie):ve()))})}e.writeFile=q;function F(G){let te=G;return(M.isWindows||M.isMacintosh)&&(te=te.toLowerCase()),te}function z(G){const te=N.get(G);if(te)return te;const se=new y.Queue;return N.set(G,se),n.Event.once(se.onFinished)(()=>{N.delete(G),se.dispose()}),se}let O=!0;function k(G,te,se,ae){if(!O)return w.writeFile(G,te,{mode:se.mode,flag:se.flag},ae);w.open(G,se.flag,se.mode,(he,ve)=>{if(he)return ae(he);w.writeFile(ve,te,be=>{if(be)return w.close(ve,()=>ae(be));w.fdatasync(ve,Ie=>(Ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Ie),O=!1),w.close(ve,Le=>ae(Le))))})})}function L(G,te,se){const ae=_(se);if(!O)return w.writeFileSync(G,te,{mode:ae.mode,flag:ae.flag});const he=w.openSync(G,ae.flag,ae.mode);try{w.writeFileSync(he,te);try{w.fdatasyncSync(he)}catch(ve){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",ve),O=!1}}finally{w.closeSync(he)}}e.writeFileSync=L;function _(G){return G?{mode:typeof G.mode=="number"?G.mode:438,flag:typeof G.flag=="string"?G.flag:"w"}:{mode:438,flag:"w"}}async function W(G){const te=await u(G),se=[];for(const ae of te)await B(D.join(G,ae))&&se.push(ae);return se}e.readDirsInDir=W;async function B(G){try{const{stat:te,symbolicLink:se}=await I(G);return te.isDirectory()&&(se==null?void 0:se.dangling)!==!0}catch(te){}return!1}e.dirExists=B;async function K(G){try{const{stat:te,symbolicLink:se}=await I(G);return te.isFile()&&(se==null?void 0:se.dangling)!==!0}catch(te){}return!1}e.fileExists=K;function X(G){return new Promise(te=>{let se=!1;const ae=setInterval(()=>{se||(se=!0,w.exists(G,he=>{se=!1,he||(clearInterval(ae),te(void 0))}))},1e3)})}e.whenDeleted=X;async function Y(G,te){if(G!==te){async function se(ae){const he=await A(ae);if(!(he.isDirectory()||he.isSymbolicLink())){const ve=await S.promisify(w.open)(ae,"a");try{await S.promisify(w.futimes)(ve,he.atime,new Date)}catch(be){}return S.promisify(w.close)(ve)}}try{await T(G,te),await se(te)}catch(ae){if(G.toLowerCase()!==te.toLowerCase()&&ae.code==="EXDEV"||G.endsWith("."))await le(G,te),await b(G,p.MOVE),await se(te);else throw ae}}}e.move=Y;const oe=511;async function le(G,te,se){const ae=se!=null?se:Object.create(null);if(!ae[G]){ae[G]=!0;const{stat:he,symbolicLink:ve}=await I(G);if(!(ve==null?void 0:ve.dangling)){if(!he.isDirectory())return ie(G,te,he.mode&oe);await H(te,he.mode&oe);const be=await u(G);for(let Ie=0;Ie<be.length;Ie++){const Le=be[Ie];await le(D.join(G,Le),D.join(te,Le),ae)}}}}e.copy=le;async function ie(G,te,se){return new Promise((ae,he)=>{const ve=w.createReadStream(G),be=w.createWriteStream(te,{mode:se});let Ie=!1;const Le=Ae=>{if(!Ie){if(Ie=!0,Ae)return he(Ae);w.chmod(te,se,Ne=>Ne?he(Ne):ae())}};ve.once("error",Ae=>Le(Ae)),be.once("error",Ae=>Le(Ae)),be.once("close",()=>Le()),ve.pipe(be)})}}),define(Q[111],J([0,1,25,17,6,26,67]),function($,e,w,R,D,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function n(m){const P=D.dirname(m);if(m===P)return m;const f=(D.basename(m)||m).toLowerCase();try{const v=y.readdirSync(P).filter(p=>p.toLowerCase()===f);if(v.length===1){const p=n(P);if(p)return D.join(p,v[0])}else if(v.length>1){const p=v.indexOf(f);if(p>=0){const b=n(P);if(b)return D.join(b,v[p])}}}catch(h){}return null}e.realcaseSync=n;async function S(m){try{return await M.promisify(w.realpath)(m)}catch(P){const f=E(m);return await M.promisify(w.access)(f,w.constants.R_OK),f}}e.realpath=S;function i(m){try{return w.realpathSync(m)}catch(P){const f=E(m);return w.accessSync(f,w.constants.R_OK),f}}e.realpathSync=i;function E(m){return R.rtrim(D.normalize(m),D.sep)}}),define(Q[112],J([0,1,58]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=e.randomPort=void 0;function R(){const S=1025;return S+Math.floor((65535-S)*Math.random())}e.randomPort=R;function D(S,i,E){let m=!1;return new Promise(P=>{const f=setTimeout(()=>{if(!m)return m=!0,P(0)},E);y(S,i,h=>{if(!m)return m=!0,clearTimeout(f),P(h)})})}e.findFreePort=D;function y(S,i,E){if(i===0)return E(0);const m=new w.Socket;m.once("connect",()=>(n(m),y(S+1,i-1,E))),m.once("data",()=>{}),m.once("error",P=>(n(m),P.code!=="ECONNREFUSED"?y(S+1,i-1,E):E(S))),m.connect(S,"127.0.0.1")}function M(S,i,E){let m=!1,P,f=1;const h=w.createServer({pauseOnConnect:!0});function v(p,b){m||(m=!0,h.removeAllListeners(),h.close(),P&&clearTimeout(P),b(p))}return new Promise(p=>{P=setTimeout(()=>{v(0,p)},E),h.on("listening",()=>{v(S,p)}),h.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&f<i?(S++,f++,h.listen(S,"127.0.0.1")):v(0,p)}),h.on("close",()=>{v(0,p)}),h.listen(S,"127.0.0.1")})}e.findFreePortFaster=M;function n(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(i){console.error(i)}}});var De=this&&this.__await||function($){return this instanceof De?(this.v=$,this):new De($)},bt=this&&this.__asyncGenerator||function($,e,w){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var R=w.apply($,e||[]),D,y=[];return D={},M("next"),M("throw"),M("return"),D[Symbol.asyncIterator]=function(){return this},D;function M(P){R[P]&&(D[P]=function(f){return new Promise(function(h,v){y.push([P,f,h,v])>1||n(P,f)})})}function n(P,f){try{S(R[P](f))}catch(h){m(y[0][3],h)}}function S(P){P.value instanceof De?Promise.resolve(P.value.v).then(i,E):m(y[0][2],P)}function i(P){n("next",P)}function E(P){n("throw",P)}function m(P,f){P(f),y.shift(),y.length&&n(y[0][0],y[0][1])}},Et=this&&this.__asyncValues||function($){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=$[Symbol.asyncIterator],w;return e?e.call($):($=typeof __values=="function"?__values($):$[Symbol.iterator](),w={},R("next"),R("throw"),R("return"),w[Symbol.asyncIterator]=function(){return this},w);function R(y){w[y]=$[y]&&function(M){return new Promise(function(n,S){M=$[y](M),D(n,S,M.done,M.value)})}}function D(y,M,n,S){Promise.resolve(S).then(function(i){y({value:i,done:n})},M)}};define(Q[113],J([0,1,26,27,6,52]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M="Windows PowerShell",n="Windows PowerShell (x86)",S=/^\d+$/,i=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/,m=process.arch==="x64",P=m||R.arch()==="x64";class f{constructor(o,d,c){this.exePath=o,this.displayName=d,this.knownToExist=c}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.fileExists(this.exePath)),this.knownToExist}}function h({useAlternateBitness:r=!1}={}){return r?m?y.env["ProgramFiles(x86)"]||null:P&&y.env.ProgramW6432||null:y.env.ProgramFiles||null}function v({useAlternateBitness:r=!1}={}){const o=y.env.windir;return r?m?D.join(o,"SysWOW64"):P?D.join(o,"Sysnative"):D.join(o,"System32"):D.join(o,"System32")}async function p({useAlternateBitness:r=!1,findPreview:o=!1}={}){const d=h({useAlternateBitness:r});if(!d)return null;const c=D.join(d,"PowerShell");if(!await w.dirExists(c))return null;let g=-1,I=null;for(const U of await w.readdir(c)){let j=-1;if(o){const x=U.indexOf("-");if(x<0)continue;const ee=U.substring(0,x);if(!S.test(ee)||U.substring(x+1)!=="preview")continue;j=parseInt(ee,10)}else{if(!S.test(U))continue;j=parseInt(U,10)}if(!(j<=g)){const C=D.join(c,U,"pwsh.exe");!await w.fileExists(C)||(I=C,g=j)}}if(!I)return null;const A=d.includes("x86")?" (x86)":"",T=o?" Preview":"";return new f(I,`PowerShell${T}${A}`,!0)}async function b({findPreview:r}={}){if(!y.env.LOCALAPPDATA)return null;const o=D.join(y.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.dirExists(o))return null;const{pwshMsixDirRegex:d,pwshMsixName:c}=r?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:i,pwshMsixName:"PowerShell (Store)"};for(const g of await w.readdir(o))if(d.test(g)){const I=D.join(o,g,"pwsh.exe");return new f(I,c)}return null}function l(){const r=D.join(R.homedir(),".dotnet","tools","pwsh.exe");return new f(r,".NET Core PowerShell Global Tool")}function a({useAlternateBitness:r=!1}={}){if(!P&&r)return null;const o=v({useAlternateBitness:r}),d=D.join(o,"WindowsPowerShell","v1.0","powershell.exe");let c;return m?c=r?n:M:P?c=r?M:n:c=n,new f(d,c,!0)}function s(){return bt(this,arguments,function*(){let o=yield De(p());o&&(yield yield De(o)),o=yield De(p({useAlternateBitness:!0})),o&&(yield yield De(o)),o=yield De(b()),o&&(yield yield De(o)),o=l(),o&&(yield yield De(o)),o=yield De(p({findPreview:!0})),o&&(yield yield De(o)),o=yield De(b({findPreview:!0})),o&&(yield yield De(o)),o=yield De(p({useAlternateBitness:!0,findPreview:!0})),o&&(yield yield De(o)),o=a(),o&&(yield yield De(o)),o=a({useAlternateBitness:!0}),o&&(yield yield De(o))})}function u(){return bt(this,arguments,function*(){var o,d;try{for(var c=Et(s()),g;g=yield De(c.next()),!g.done;){const I=g.value;(yield De(I.exists()))&&(yield yield De(I))}}catch(I){o={error:I}}finally{try{g&&!g.done&&(d=c.return)&&(yield De(d.call(c)))}finally{if(o)throw o.error}}})}e.enumeratePowerShellInstallations=u;async function t(){var r,o;try{for(var d=Et(u()),c;c=await d.next(),!c.done;)return c.value}catch(g){r={error:g}}finally{try{c&&!c.done&&(o=d.return)&&await o.call(d)}finally{if(r)throw r.error}}return null}e.getFirstAvailablePowerShellInstallation=t}),define(Q[77],J([0,1,45,10]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(M){return new Promise((n,S)=>{let i;const E=new Map;function m(h,v,p,b,l){const a=E.get(v);if(h===M||a){const s={name:P(p),cmd:p,pid:h,ppid:v,load:b,mem:l};E.set(h,s),h===M&&(i=s),a&&(a.children||(a.children=[]),a.children.push(s),a.children.length>1&&(a.children=a.children.sort((u,t)=>u.pid-t.pid)))}}function P(h){const v=/--disable-blink-features=Auxclick/,p=/\\watcher\\win32\\CodeHelper\.exe/,b=/--crashes-directory/,l=/\\pipe\\winpty-control/,a=/conhost\.exe/,s=/--type=([a-zA-Z-]+)/;if(p.exec(h))return"watcherService ";if(b.exec(h))return"electron-crash-reporter";if(l.exec(h))return"winpty-process";if(a.exec(h))return"console-window-host (Windows internal process)";let u=s.exec(h);if(u&&u.length===2)return u[1]==="renderer"?v.exec(h)?"shared-process":"window":u[1];const t=/[a-zA-Z-]+\.js/g;let r="";do u=t.exec(h),u&&(r+=u+" ");while(u);return r&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron_node ${r}`:h}if(process.platform==="win32"){const h=v=>v.indexOf("\\\\?\\")===0||v.indexOf("\\??\\")===0?v.substr(4):v.indexOf('"\\\\?\\')===0||v.indexOf('"\\??\\')===0?'"'+v.substr(5):v;new Promise((v,p)=>{$(["windows-process-tree"],v,p)}).then(v=>{v.getProcessList(M,p=>{v.getProcessCpuUsage(p,b=>{const l=new Map;b.forEach(a=>{const s=h(a.commandLine||"");l.set(a.pid,{name:P(s),cmd:s,pid:a.pid,ppid:a.ppid,load:a.cpu||0,mem:a.memory||0})}),i=l.get(M),i?(l.forEach(a=>{const s=l.get(a.ppid);s&&(s.children||(s.children=[]),s.children.push(a))}),l.forEach(a=>{a.children&&(a.children=a.children.sort((s,u)=>s.pid-u.pid))}),n(i)):S(new Error(`Root process ${M} not found`))})},v.ProcessDataFlag.CommandLine|v.ProcessDataFlag.Memory)})}else{function f(){let h=[i];const v=[];for(;h.length;){const b=h.shift();b&&(v.push(b.pid),b.children&&(h=h.concat(b.children)))}let p=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",$).fsPath);p+=" "+v.join(" "),w.exec(p,{},(b,l,a)=>{if(b||a)S(b||new Error(a.toString()));else{const s=l.toString().split(`
`);for(let u=0;u<v.length;u++){const t=E.get(v[u]);t.load=parseFloat(s[u])}if(!i){S(new Error(`Root process ${M} not found`));return}n(i)}})}w.exec("which ps",{},(h,v,p)=>{if(h||p)if(process.platform!=="linux")S(h||new Error(p.toString()));else{const b=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/ps.sh",$).fsPath);w.exec(b,{},(l,a,s)=>{l||s?S(l||new Error(s.toString())):(y(a,m),f())})}else{const b=v.toString().trim(),l="-ax -o pid=,ppid=,pcpu=,pmem=,command=";w.exec(`${b} ${l}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(a,s,u)=>{a||u&&!u.includes("screen size is bogus")?S(a||new Error(u.toString())):(y(s,m),process.platform==="linux"?f():i?n(i):S(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=D;function y(M,n){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,i=M.toString().split(`
`);for(const E of i){const m=S.exec(E.trim());m&&m.length===6&&n(parseInt(m[1]),parseInt(m[2]),m[5],parseFloat(m[3]),parseFloat(m[4]))}}}),define(Q[114],J([0,1,6,25,3,65,2,26]),function($,e,w,R,D,y,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function S(m,P,f){return E({path:m,isDirectory:!1},P,f)}e.watchFile=S;function i(m,P,f){return E({path:m,isDirectory:!0},P,f)}e.watchFolder=i,e.CHANGE_BUFFER_DELAY=100;function E(m,P,f){const h=w.basename(m.path),v=new Map;let p=!1,b=[M.toDisposable(()=>{v.forEach(l=>M.dispose(l)),v.clear()})];try{const l=R.watch(m.path);b.push(M.toDisposable(()=>{l.removeAllListeners(),l.close()}));const a=new Set;m.isDirectory&&n.readdir(m.path).then(s=>s.forEach(u=>a.add(u))),l.on("error",(s,u)=>{p||f(`Failed to watch ${m.path} for changes using fs.watch() (${s}, ${u})`)}),l.on("change",(s,u)=>{if(!p){let t="";if(u&&(t=u.toString(),D.isMacintosh&&(t=y.normalizeNFC(t))),!(!t||s!=="change"&&s!=="rename")){const r=m.isDirectory?w.join(m.path,t):m.path;if(m.isDirectory)if(s==="rename"){const o=v.get(r);o&&M.dispose(o);const d=setTimeout(async()=>{v.delete(r);const c=await n.exists(r);if(!p){let g;c?a.has(t)?g="changed":(g="added",a.add(t)):(a.delete(t),g="deleted"),P(g,r)}},e.CHANGE_BUFFER_DELAY);v.set(r,M.toDisposable(()=>clearTimeout(d)))}else{let o;a.has(t)?o="changed":(o="added",a.add(t)),P(o,r)}else if(s==="rename"||t!==h){const o=setTimeout(async()=>{const d=await n.exists(r);p||(d?(P("changed",r),b=[E(m,P,f)]):P("deleted",r))},e.CHANGE_BUFFER_DELAY);M.dispose(b),b=[M.toDisposable(()=>clearTimeout(o))]}else P("changed",r)}}})}catch(l){n.exists(m.path).then(a=>{a&&!p&&f(`Failed to watch ${m.path} for changes using fs.watch() (${l.toString()})`)})}return M.toDisposable(()=>{p=!0,b=M.dispose(b)})}}),define(Q[115],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Q[116],J([0,1,11,115,14]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function y(){w.ipcMain.on(R.CONTEXT_MENU_CHANNEL,(n,S,i,E,m)=>{const P=M(n,E,i);P.popup({window:D.withNullAsUndefined(w.BrowserWindow.fromWebContents(n.sender)),x:m?m.x:void 0,y:m?m.y:void 0,positioningItem:m?m.positioningItem:void 0,callback:()=>{P&&n.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,S)}})})}e.registerContextMenuListener=y;function M(n,S,i){const E=new w.Menu;return i.forEach(m=>{let P;m.type==="separator"?P=new w.MenuItem({type:m.type}):Array.isArray(m.submenu)?P=new w.MenuItem({submenu:M(n,S,m.submenu),label:m.label}):P=new w.MenuItem({label:m.label,type:m.type,accelerator:m.accelerator,checked:m.checked,enabled:m.enabled,visible:m.visible,click:(f,h,v)=>n.sender.send(S,m.id,v)}),E.append(P)}),E}}),define(Q[33],J([0,1,4,2,9,24,16,20,32,14,106,17]),function($,e,w,R,D,y,M,n,S,i,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.createChannelSender=e.createChannelReceiver=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var P;(function(k){k[k.Promise=100]="Promise",k[k.PromiseCancel=101]="PromiseCancel",k[k.EventListen=102]="EventListen",k[k.EventDispose=103]="EventDispose"})(P=e.RequestType||(e.RequestType={}));function f(k){switch(k){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(k){k[k.Initialize=200]="Initialize",k[k.PromiseSuccess=201]="PromiseSuccess",k[k.PromiseError=202]="PromiseError",k[k.PromiseErrorObj=203]="PromiseErrorObj",k[k.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function v(k){switch(k){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(k){k[k.Uninitialized=0]="Uninitialized",k[k.Idle=1]="Idle"})(p||(p={}));class b{constructor(L){this.buffer=L,this.pos=0}read(L){const _=this.buffer.slice(this.pos,this.pos+L);return this.pos+=_.byteLength,_}}class l{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(L){this.buffers.push(L)}}var a;(function(k){k[k.Undefined=0]="Undefined",k[k.String=1]="String",k[k.Buffer=2]="Buffer",k[k.VSBuffer=3]="VSBuffer",k[k.Array=4]="Array",k[k.Object=5]="Object"})(a||(a={}));function s(k){const L=n.VSBuffer.alloc(4);return L.writeUInt32BE(k,0),L}function u(k){return k.read(4).readUInt32BE(0)}function t(k){const L=n.VSBuffer.alloc(1);return L.writeUInt8(k,0),L}const r={Undefined:t(a.Undefined),String:t(a.String),Buffer:t(a.Buffer),VSBuffer:t(a.VSBuffer),Array:t(a.Array),Object:t(a.Object)},o=typeof Buffer!="undefined";function d(k,L){if(typeof L=="undefined")k.write(r.Undefined);else if(typeof L=="string"){const _=n.VSBuffer.fromString(L);k.write(r.String),k.write(s(_.byteLength)),k.write(_)}else if(o&&Buffer.isBuffer(L)){const _=n.VSBuffer.wrap(L);k.write(r.Buffer),k.write(s(_.byteLength)),k.write(_)}else if(L instanceof n.VSBuffer)k.write(r.VSBuffer),k.write(s(L.byteLength)),k.write(L);else if(Array.isArray(L)){k.write(r.Array),k.write(s(L.length));for(const _ of L)d(k,_)}else{const _=n.VSBuffer.fromString(JSON.stringify(L));k.write(r.Object),k.write(s(_.byteLength)),k.write(_)}}function c(k){switch(k.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return k.read(u(k)).toString();case a.Buffer:return k.read(u(k)).buffer;case a.VSBuffer:return k.read(u(k));case a.Array:{const _=u(k),W=[];for(let B=0;B<_;B++)W.push(c(k));return W}case a.Object:return JSON.parse(k.read(u(k)).toString())}}class g{constructor(L,_,W=null,B=1e3){this.protocol=L,this.ctx=_,this.logger=W,this.timeoutDelay=B,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(L,_){this.channels.set(L,_),setTimeout(()=>this.flushPendingRequests(L),0)}sendResponse(L){switch(L.type){case 200:{const _=this.send([L.type]);this.logger&&this.logger.logOutgoing(_,0,1,v(L.type));return}case 201:case 202:case 204:case 203:{const _=this.send([L.type,L.id],L.data);this.logger&&this.logger.logOutgoing(_,L.id,1,v(L.type),L.data);return}}}send(L,_=void 0){const W=new l;return d(W,L),d(W,_),this.sendBuffer(W.buffer)}sendBuffer(L){try{return this.protocol.send(L),L.byteLength}catch(_){return 0}}onRawMessage(L){const _=new b(L),W=c(_),B=c(_),K=W[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(L.byteLength,W[1],1,`${f(K)}: ${W[2]}.${W[3]}`,B),this.onPromise({type:K,id:W[1],channelName:W[2],name:W[3],arg:B});case 102:return this.logger&&this.logger.logIncoming(L.byteLength,W[1],1,`${f(K)}: ${W[2]}.${W[3]}`,B),this.onEventListen({type:K,id:W[1],channelName:W[2],name:W[3],arg:B});case 101:return this.logger&&this.logger.logIncoming(L.byteLength,W[1],1,`${f(K)}`),this.disposeActiveRequest({type:K,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(L.byteLength,W[1],1,`${f(K)}`),this.disposeActiveRequest({type:K,id:W[1]})}}onPromise(L){const _=this.channels.get(L.channelName);if(!_){this.collectPendingRequest(L);return}const W=new y.CancellationTokenSource;let B;try{B=_.call(this.ctx,L.name,L.arg,W.token)}catch(Y){B=Promise.reject(Y)}const K=L.id;B.then(Y=>{this.sendResponse({id:K,data:Y,type:201}),this.activeRequests.delete(L.id)},Y=>{Y instanceof Error?this.sendResponse({id:K,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:K,data:Y,type:203}),this.activeRequests.delete(L.id)});const X=R.toDisposable(()=>W.cancel());this.activeRequests.set(L.id,X)}onEventListen(L){const _=this.channels.get(L.channelName);if(!_){this.collectPendingRequest(L);return}const W=L.id,K=_.listen(this.ctx,L.name,L.arg)(X=>this.sendResponse({id:W,data:X,type:204}));this.activeRequests.set(L.id,K)}disposeActiveRequest(L){const _=this.activeRequests.get(L.id);_&&(_.dispose(),this.activeRequests.delete(L.id))}collectPendingRequest(L){let _=this.pendingRequests.get(L.channelName);_||(_=[],this.pendingRequests.set(L.channelName,_));const W=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.sendResponse({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);_.push({request:L,timeoutTimer:W})}flushPendingRequests(L){const _=this.pendingRequests.get(L);if(_){for(const W of _)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(L)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(L=>L.dispose()),this.activeRequests.clear()}}e.ChannelServer=g;var I;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(I=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(L,_=null){this.protocol=L,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=_}getChannel(L){const _=this;return{call(W,B,K){return _.isDisposed?Promise.reject(M.canceled()):_.requestPromise(L,W,B,K)},listen(W,B){return _.isDisposed?Promise.reject(M.canceled()):_.requestEvent(L,W,B)}}}requestPromise(L,_,W,B=y.CancellationToken.None){const K=this.lastRequestId++,Y={id:K,type:100,channelName:L,name:_,arg:W};if(B.isCancellationRequested)return Promise.reject(M.canceled());let oe;return new Promise((ie,G)=>{if(B.isCancellationRequested)return G(M.canceled());const te=()=>{const ve=be=>{switch(be.type){case 201:this.handlers.delete(K),ie(be.data);break;case 202:this.handlers.delete(K);const Ie=new Error(be.data.message);Ie.stack=be.data.stack,Ie.name=be.data.name,G(Ie);break;case 203:this.handlers.delete(K),G(be.data);break}};this.handlers.set(K,ve),this.sendRequest(Y)};let se=null;this.state===p.Idle?te():(se=D.createCancelablePromise(ve=>this.whenInitialized()),se.then(()=>{se=null,te()}));const ae=()=>{se?(se.cancel(),se=null):this.sendRequest({id:K,type:101}),G(M.canceled())},he=B.onCancellationRequested(ae);oe=R.combinedDisposable(R.toDisposable(ae),he),this.activeRequests.add(oe)}).finally(()=>{this.activeRequests.delete(oe)})}requestEvent(L,_,W){const B=this.lastRequestId++,X={id:B,type:102,channelName:L,name:_,arg:W};let Y=null;const oe=new w.Emitter({onFirstListenerAdd:()=>{Y=D.createCancelablePromise(ie=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(oe),this.sendRequest(X)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(oe),this.sendRequest({id:B,type:103}))}}),le=ie=>oe.fire(ie.data);return this.handlers.set(B,le),oe.event}sendRequest(L){switch(L.type){case 100:case 102:{const _=this.send([L.type,L.id,L.channelName,L.name],L.arg);this.logger&&this.logger.logOutgoing(_,L.id,0,`${f(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const _=this.send([L.type,L.id]);this.logger&&this.logger.logOutgoing(_,L.id,0,f(L.type));return}}}send(L,_=void 0){const W=new l;return d(W,L),d(W,_),this.sendBuffer(W.buffer)}sendBuffer(L){try{return this.protocol.send(L),L.byteLength}catch(_){return 0}}onBuffer(L){const _=new b(L),W=c(_),B=c(_),K=W[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(L.byteLength,0,0,v(K)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(L.byteLength,W[1],0,v(K),B),this.onResponse({type:W[0],id:W[1],data:B})}}onResponse(L){if(L.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const _=this.handlers.get(L.id);_&&_(L)}whenInitialized(){return this.state===p.Idle?Promise.resolve():w.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(L=>L.dispose()),this.activeRequests.clear()}}e.ChannelClient=A;class T{constructor(L){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,L(({protocol:_,onDidClientDisconnect:W})=>{w.Event.once(_.onMessage)(K=>{const X=new b(K),Y=c(X),oe=new g(_,Y),le=new A(_);this.channels.forEach((G,te)=>oe.registerChannel(te,G));const ie={channelServer:oe,channelClient:le,ctx:Y};this._connections.add(ie),this._onDidAddConnection.fire(ie),W(()=>{oe.dispose(),le.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)})})})}get connections(){const L=[];return this._connections.forEach(_=>L.push(_)),L}getChannel(L,_){const W=this;return{call(B,K,X){let Y;if(i.isFunction(_)){let le=S.getRandomElement(W.connections.filter(_));Y=le?Promise.resolve(le):w.Event.toPromise(w.Event.filter(W.onDidAddConnection,_))}else Y=_.routeCall(W,B,K);const oe=Y.then(le=>le.channelClient.getChannel(L));return j(oe).call(B,K,X)},listen(B,K){if(i.isFunction(_))return W.getMulticastEvent(L,_,B,K);const X=_.routeEvent(W,B,K).then(Y=>Y.channelClient.getChannel(L));return j(X).listen(B,K)}}}getMulticastEvent(L,_,W,B){const K=this;let X=new R.DisposableStore;const Y=new w.Emitter({onFirstListenerAdd:()=>{X=new R.DisposableStore;const oe=new w.EventMultiplexer,le=new Map,ie=te=>{const ae=te.channelClient.getChannel(L).listen(W,B),he=oe.add(ae);le.set(te,he)},G=te=>{const se=le.get(te);!se||(se.dispose(),le.delete(te))};K.connections.filter(_).forEach(ie),w.Event.filter(K.onDidAddConnection,_)(ie,void 0,X),K.onDidRemoveConnection(G,void 0,X),oe.event(Y.fire,Y,X),X.add(oe)},onLastListenerRemove:()=>{X.dispose()}});return Y.event}registerChannel(L,_){this.channels.set(L,_),this._connections.forEach(W=>{W.channelServer.registerChannel(L,_)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class U{constructor(L,_,W=null){const B=new l;d(B,_),L.send(B.buffer),this.channelClient=new A(L,W),this.channelServer=new g(L,_,W)}getChannel(L){return this.channelClient.getChannel(L)}registerChannel(L,_){this.channelServer.registerChannel(L,_)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function j(k){return{call(L,_,W){return k.then(B=>B.call(L,_,W))},listen(L,_){const W=new w.Relay;return k.then(B=>W.input=B.listen(L,_)),W.event}}}e.getDelayedChannel=j;function C(k){let L=!1;return{call(_,W,B){return L?k.call(_,W,B):D.timeout(0).then(()=>L=!0).then(()=>k.call(_,W,B))},listen(_,W){if(L)return k.listen(_,W);const B=new w.Relay;return D.timeout(0).then(()=>L=!0).then(()=>B.input=k.listen(_,W)),B.event}}}e.getNextTickChannel=C;class x{constructor(L){this.fn=L}routeCall(L){return this.route(L)}routeEvent(L){return this.route(L)}async route(L){for(const _ of L.connections)if(await Promise.resolve(this.fn(_.ctx)))return Promise.resolve(_);return await w.Event.toPromise(L.onDidAddConnection),await this.route(L)}}e.StaticRouter=x;function ee(k,L){const _=k,W=L&&L.disableMarshalling,B=new Map;for(const K in _)H(K)&&B.set(K,w.Event.buffer(_[K],!0));return new class{listen(K,X){const Y=B.get(X);if(Y)return Y;throw new Error(`Event not found: ${X}`)}call(K,X,Y){const oe=_[X];if(typeof oe=="function"){if(!W&&Array.isArray(Y))for(let le=0;le<Y.length;le++)Y[le]=E.revive(Y[le]);return oe.apply(_,Y)}throw new Error(`Method not found: ${X}`)}}}e.createChannelReceiver=ee;function Z(k,L){const _=L&&L.disableMarshalling;return new Proxy({},{get(W,B){var K;if(typeof B=="string")return((K=L==null?void 0:L.properties)===null||K===void 0?void 0:K.has(B))?L.properties.get(B):H(B)?k.listen(B):async function(...X){let Y;L&&!i.isUndefinedOrNull(L.context)?Y=[L.context,...X]:Y=X;const oe=await k.call(B,Y);return _?oe:E.revive(oe)};throw new Error(`Property not found: ${String(B)}`)}})}e.createChannelSender=Z;function H(k){return k[0]==="o"&&k[1]==="n"&&m.isUpperAsciiLetter(k.charCodeAt(2))}const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q(k){if(Array.isArray(k))return k;if(k&&typeof k=="object"&&typeof k.toString=="function"){let L=k.toString();if(L!=="[object Object]")return L}return k}function F(k){return Array.isArray(k)?k.map(q):q(k)}function z(k,L,_,W,B,K,X){X=F(X);const Y=N[B],oe=Y[W%Y.length];let le=[`%c[${k}]%c[${String(L).padStart(7," ")}]%c[len: ${String(_).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${oe}`];/\($/.test(K)?(le=le.concat(X),le.push(")")):le.push(X),console.log.apply(console,le)}e.logWithColors=z;class O{constructor(L,_){this._outgoingPrefix=L,this._incomingPrefix=_,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(L,_,W,B,K){this._totalOutgoing+=L,z(this._outgoingPrefix,this._totalOutgoing,L,_,W,B,K)}logIncoming(L,_,W,B,K){this._totalIncoming+=L,z(this._incomingPrefix,this._totalIncoming,L,_,W,B,K)}}e.IPCLogger=O}),define(Q[117],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class w{constructor(D,y){this.sender=D,this.onMessage=y}send(D){try{this.sender.send("vscode:message",D.buffer)}catch(y){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=w}),define(Q[118],J([0,1,4,33,20]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class y{constructor(S){this.port=S,this.onMessage=w.Event.fromDOMEventEmitter(this.port,"message",i=>D.VSBuffer.wrap(i.data)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}e.Protocol=y;class M extends R.IPCClient{constructor(S,i){const E=new y(S);super(E,i);this.protocol=E}dispose(){this.protocol.disconnect()}}e.Client=M}),define(Q[78],J([0,1,4,33,2,20,3,52]),function($,e,w,R,D,y,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let S=null;function i(){return S||(S=y.VSBuffer.alloc(0)),S}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,d){if(o===0)return i();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const A=this._chunks[0];return d&&(this._chunks.shift(),this._totalLength-=o),A}if(this._chunks[0].byteLength>o){const A=this._chunks[0].slice(0,o);return d&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),A}let c=y.VSBuffer.alloc(o),g=0,I=0;for(;o>0;){const A=this._chunks[I];if(A.byteLength>o){const T=A.slice(0,o);c.set(T,g),g+=o,d&&(this._chunks[I]=A.slice(o),this._totalLength-=o),o-=o}else c.set(A,g),g+=A.byteLength,d?(this._chunks.shift(),this._totalLength-=A.byteLength):I++,o-=A.byteLength}return c}}e.ChunkStream=E;var m;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(m||(m={}));var P;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(P=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(o,d,c,g){this.type=o,this.id=d,this.ack=c,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends D.Disposable{constructor(o){super();this._onMessage=this._register(new w.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const d=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=d.readUInt32BE(9),this._state.messageType=d.readUInt8(0),this._state.id=d.readUInt32BE(1),this._state.ack=d.readUInt32BE(5);else{const c=this._state.messageType,g=this._state.id,I=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new f(c,g,I,d)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(!this._isDisposed){o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=y.VSBuffer.alloc(13);d.writeUInt8(o.type,0),d.writeUInt32BE(o.id,1),d.writeUInt32BE(o.ack,5),d.writeUInt32BE(o.data.byteLength,9),this._writeSoon(d,o.data)}}_bufferAdd(o,d){const c=this._totalLength===0;return this._data.push(o,d),this._totalLength+=o.byteLength+d.byteLength,c}_bufferTake(){const o=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,d){this._bufferAdd(o,d)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class p extends D.Disposable{constructor(o){super();this._onMessage=new w.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new w.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new h(this._socket)),this._register(this._socketReader.onMessage(d=>{d.type===1&&this._onMessage.fire(d.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new f(1,0,0,o))}}e.Protocol=p;class b extends R.IPCClient{constructor(o,d,c=null){super(o,d,c);this.protocol=o}static fromSocket(o,d){return new b(new p(o),d)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=b;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new w.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class a{constructor(o){this.data=o,this.next=null}}class s{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],d=0,c=this._first;for(;c;)o[d++]=c.data,c=c.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const d=new a(o);if(!this._first){this._first=d,this._last=d;return}this._last.next=d,this._last=d}}class u{constructor(){this.lastRuns=[];const o=Date.now();for(let d=0;d<u._HISTORY_LENGTH;d++)this.lastRuns[d]=o-1e3*d;setInterval(()=>{for(let d=u._HISTORY_LENGTH;d>=1;d--)this.lastRuns[d]=this.lastRuns[d-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return u._INSTANCE||(u._INSTANCE=new u),u._INSTANCE}load(){const o=Date.now(),d=(1+u._HISTORY_LENGTH)*1e3;let c=0;for(let g=0;g<u._HISTORY_LENGTH;g++)o-this.lastRuns[g]<=d&&c++;return 1-c/u._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}u._HISTORY_LENGTH=10,u._INSTANCE=null;class t{constructor(o,d=null){this._loadEstimator=u.getInstance(),this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new h(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),d&&this._socketReader.acceptChunk(d),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=D.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new f(5,0,0,i());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const d=new f(4,0,0,i());this._socketWriter.write(d),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,d){this._isReconnecting=!0,this._socketDisposables=D.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new h(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(d)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let d=0,c=o.length;d<c;d++)this._socketWriter.write(o[d]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const d=this._outgoingUnackMsg.peek();if(d&&d.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const d=Date.now();d-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=d,this._socketWriter.write(new f(6,0,0,i())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const d=this._outgoingUnackMsg.toArray();for(let c=0,g=d.length;c<g;c++)this._socketWriter.write(d[c]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const d=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new f(1,d,this._incomingAckId,o);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(o){const d=new f(2,0,0,o);this._socketWriter.write(d)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const o=this._outgoingUnackMsg.peek(),d=Date.now()-o.writtenTime;if(d>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-d,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const o=new f(3,0,this._incomingAckId,i());this._socketWriter.write(o)}}}e.PersistentProtocol=t}),define(Q[119],J([0,1,11,4,33,117,2,20]),function($,e,w,R,D,y,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function S(E,m){const P=R.Event.fromNodeEventEmitter(w.ipcMain,m,(h,v)=>({event:h,message:v})),f=R.Event.filter(P,({event:h})=>h.sender.id===E);return R.Event.map(f,({message:h})=>h&&n.VSBuffer.wrap(h))}class i extends D.IPCServer{constructor(){super(i.getOnDidClientConnect())}static getOnDidClientConnect(){const m=R.Event.fromNodeEventEmitter(w.ipcMain,"vscode:hello",({sender:P})=>P);return R.Event.map(m,P=>{const f=P.id,h=i.Clients.get(f);h&&h.dispose();const v=new R.Emitter;i.Clients.set(f,M.toDisposable(()=>v.fire()));const p=S(f,"vscode:message"),b=R.Event.any(R.Event.signal(S(f,"vscode:disconnect")),v.event);return{protocol:new y.Protocol(P,p),onDidClientDisconnect:b}})}}e.Server=i,i.Clients=new Map}),define(Q[79],J([0,1,11,4,29,118]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends y.Client{constructor(i,E){super({addEventListener:(m,P)=>i.addListener(m,P),removeEventListener:(m,P)=>i.removeListener(m,P),postMessage:m=>i.postMessage(m),start:()=>i.start(),close:()=>i.close()},E)}}e.Client=M;async function n(S){if(S.isDestroyed()||S.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const i=D.generateUuid();S.webContents.send("vscode:createMessageChannel",i);const E=R.Event.fromNodeEventEmitter(w.ipcMain,"vscode:createMessageChannelResult",(P,f)=>({nonce:f,port:P.ports[0]})),{port:m}=await R.Event.toPromise(R.Event.once(R.Event.filter(E,P=>P.nonce===i)));return m}e.connect=n}),define(Q[120],J([0,1,2,4,9,14]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var M;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));var n;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(n||(n={}));class S extends w.Disposable{constructor(m,P=Object.create(null)){super();this.database=m,this.options=P,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=this._register(new D.ThrottledDelayer(S.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){var P,f;(P=m.changed)===null||P===void 0||P.forEach((h,v)=>this.accept(v,h)),(f=m.deleted)===null||f===void 0||f.forEach(h=>this.accept(h,void 0))}accept(m,P){if(this.state!==n.Closed){let f=!1;y.isUndefinedOrNull(P)?f=this.cache.delete(m):this.cache.get(m)!==P&&(this.cache.set(m,P),f=!0),f&&this._onDidChangeStorage.fire(m)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,P){const f=this.cache.get(m);return y.isUndefinedOrNull(f)?P:f}getBoolean(m,P){const f=this.get(m);return y.isUndefinedOrNull(f)?P:f==="true"}getNumber(m,P){const f=this.get(m);return y.isUndefinedOrNull(f)?P:parseInt(f,10)}async set(m,P){if(this.state!==n.Closed){if(y.isUndefinedOrNull(P))return this.delete(m);const f=String(P);if(this.cache.get(m)!==f)return this.cache.set(m,f),this.pendingInserts.set(m,f),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(m){if(this.state!==n.Closed&&!!this.cache.delete(m))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async close(){if(this.state!==n.Closed){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(m){}await this.database.close(()=>this.cache)}}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{var P;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(P=this.whenFlushedCallbacks.pop())===null||P===void 0||P()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}}e.Storage=S,S.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((P,f)=>this.items.set(f,P)),m.delete&&m.delete.forEach(P=>this.items.delete(P))}async close(){}}e.InMemoryStorageDatabase=i}),define(Q[121],J([0,1,4,9,35,6,26]),function($,e,w,R,D,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(E,m=Object.create(null)){this.path=E,this.options=m,this.name=y.basename(this.path),this.logger=new S(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return w.Event.None}async getItems(){const E=await this.whenConnected,m=new Map;return(await this.all(E,"SELECT * FROM ItemTable")).forEach(f=>m.set(f.key,f.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${m.size} rows`),m}async updateItems(E){const m=await this.whenConnected;return this.doUpdateItems(m,E)}doUpdateItems(E,m){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${m.insert?D.mapToString(m.insert):"0"}), delete(${m.delete?D.setToString(m.delete):"0"})`),this.transaction(E,()=>{const P=m.insert,f=m.delete;if(P&&P.size>0){const h=[];h.push([]);let v=0;P.forEach((p,b)=>{let l=h[v];l.length>n.MAX_HOST_PARAMETERS&&(v++,l=[],h.push(l)),l.push(b,p)}),h.forEach(p=>{this.prepare(E,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,b=>b.run(p),()=>{const b=[];let l=0;return P.forEach((a,s)=>{b.push(s),l+=a.length}),`Keys: ${b.join(", ")} Length: ${l}`})})}if(f&&f.size){const h=[];h.push([]);let v=0;f.forEach(p=>{let b=h[v];b.length>n.MAX_HOST_PARAMETERS&&(v++,b=[],h.push(b)),b.push(p)}),h.forEach(p=>{this.prepare(E,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,b=>b.run(p),()=>{const b=[];return f.forEach(l=>{b.push(l)}),`Keys: ${b.join(", ")}`})})}})}async close(E){this.logger.trace(`[storage ${this.name}] close()`);const m=await this.whenConnected;return this.doClose(m,E)}doClose(E,m){return new Promise((P,f)=>{E.db.close(h=>(h&&this.handleSQLiteError(E,`[storage ${this.name}] close(): ${h}`),this.path===n.IN_MEMORY_PATH?P():!E.isErroneous&&!E.isInMemory?this.backup().then(P,v=>(this.logger.error(`[storage ${this.name}] backup(): ${v}`),P())):typeof m=="function"?M.unlink(this.path).then(()=>this.doConnect(this.path).then(v=>{const p=()=>this.doClose(v,void 0);return this.doUpdateItems(v,{insert:m()}).then(()=>p(),b=>(p(),Promise.reject(b)))})).then(P,f):f(h||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const E=this.toBackupPath(this.path);return M.copy(this.path,E)}toBackupPath(E){return`${E}.backup`}async checkIntegrity(E){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${E})`);const m=await this.whenConnected,P=await this.get(m,E?"PRAGMA integrity_check":"PRAGMA quick_check"),f=E?P.integrity_check:P.quick_check;return m.isErroneous?`${f} (last error: ${m.lastError})`:m.isInMemory?`${f} (in-memory!)`:f}async connect(E,m=!0){this.logger.trace(`[storage ${this.name}] open(${E}, retryOnBusy: ${m})`);try{return await this.doConnect(E)}catch(P){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${P}`),P.code==="SQLITE_BUSY"&&m)return await R.timeout(n.BUSY_OPEN_TIMEOUT),this.connect(E,!1);try{return await M.unlink(E),await M.renameIgnoreError(this.toBackupPath(E),E),await this.doConnect(E)}catch(f){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${f}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(E,m){E.isErroneous=!0,E.lastError=m,this.logger.error(m)}doConnect(E){return new Promise((m,P)=>{new Promise((f,h)=>{$(["vscode-sqlite3"],f,h)}).then(f=>{const h={db:new(this.logger.isTracing?f.verbose().Database:f.Database)(E,v=>v?h.db?h.db.close(()=>P(v)):P(v):this.exec(h,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>m(h),p=>h.db.close(()=>P(p)))),isInMemory:E===n.IN_MEMORY_PATH};h.db.on("error",v=>this.handleSQLiteError(h,`[storage ${this.name}] Error (event): ${v}`)),this.logger.isTracing&&h.db.on("trace",v=>this.logger.trace(`[storage ${this.name}] Trace (event): ${v}`))},P)})}exec(E,m){return new Promise((P,f)=>{E.db.exec(m,h=>h?(this.handleSQLiteError(E,`[storage ${this.name}] exec(): ${h}`),f(h)):P())})}get(E,m){return new Promise((P,f)=>{E.db.get(m,(h,v)=>h?(this.handleSQLiteError(E,`[storage ${this.name}] get(): ${h}`),f(h)):P(v))})}all(E,m){return new Promise((P,f)=>{E.db.all(m,(h,v)=>h?(this.handleSQLiteError(E,`[storage ${this.name}] all(): ${h}`),f(h)):P(v))})}transaction(E,m){return new Promise((P,f)=>{E.db.serialize(()=>{E.db.run("BEGIN TRANSACTION"),m(),E.db.run("END TRANSACTION",h=>h?(this.handleSQLiteError(E,`[storage ${this.name}] transaction(): ${h}`),f(h)):P())})})}prepare(E,m,P,f){const h=E.db.prepare(m),v=p=>{this.handleSQLiteError(E,`[storage ${this.name}] prepare(): ${p} (${m}). Details: ${f()}`)};h.on("error",v),P(h),h.finalize(p=>{p&&v(p),h.removeListener("error",v)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class S{constructor(E){E&&typeof E.logTrace=="function"&&process.env[S.VSCODE_TRACE_STORAGE]&&(this.logTrace=E.logTrace),E&&typeof E.logError=="function"&&(this.logError=E.logError)}get isTracing(){return!!this.logTrace}trace(E){this.logTrace&&this.logTrace(E)}error(E){this.logError&&this.logError(E)}}S.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Q[122],J([13,12]),function($,e){return $.create("vs/base/common/date",e)}),define(Q[123],J([0,1,122]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,D=R*60,y=D*24,M=y*7,n=y*30,S=y*365;function i(m,P){typeof m!="number"&&(m=m.getTime());const f=Math.round((new Date().getTime()-m)/1e3);if(f<-30)return w.localize(0,null,i(new Date().getTime()+f*1e3,!1));if(f<30)return w.localize(1,null);let h;return f<R?(h=f,P?h===1?w.localize(2,null,h):w.localize(3,null,h):h===1?w.localize(4,null,h):w.localize(5,null,h)):f<D?(h=Math.floor(f/R),P?h===1?w.localize(6,null,h):w.localize(7,null,h):h===1?w.localize(8,null,h):w.localize(9,null,h)):f<y?(h=Math.floor(f/D),P?h===1?w.localize(10,null,h):w.localize(11,null,h):h===1?w.localize(12,null,h):w.localize(13,null,h)):f<M?(h=Math.floor(f/y),P?h===1?w.localize(14,null,h):w.localize(15,null,h):h===1?w.localize(16,null,h):w.localize(17,null,h)):f<n?(h=Math.floor(f/M),P?h===1?w.localize(18,null,h):w.localize(19,null,h):h===1?w.localize(20,null,h):w.localize(21,null,h)):f<S?(h=Math.floor(f/n),P?h===1?w.localize(22,null,h):w.localize(23,null,h):h===1?w.localize(24,null,h):w.localize(25,null,h)):(h=Math.floor(f/S),P?h===1?w.localize(26,null,h):w.localize(27,null,h):h===1?w.localize(28,null,h):w.localize(29,null,h))}e.fromNow=i;function E(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=E}),define(Q[124],J([13,12]),function($,e){return $.create("vs/base/common/errorMessage",e)}),define(Q[68],J([0,1,124,14,32]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(i,E){return E&&(i.stack||i.stacktrace)?w.localize(0,null,n(i),M(i.stack)||M(i.stacktrace)):n(i)}function M(i){return Array.isArray(i)?i.join(`
`):i}function n(i){return typeof i.code=="string"&&typeof i.errno=="number"&&typeof i.syscall=="string"?w.localize(1,null,i.message):i.message||w.localize(2,null)}function S(i=null,E=!1){if(!i)return w.localize(3,null);if(Array.isArray(i)){const m=D.coalesce(i),P=S(m[0],E);return m.length>1?w.localize(4,null,P,m.length):P}if(R.isString(i))return i;if(i.detail){const m=i.detail;if(m.error)return y(m.error,E);if(m.exception)return y(m.exception,E)}return i.stack?y(i,E):i.message?i.message:w.localize(5,null)}e.toErrorMessage=S}),define(Q[125],J([13,12]),function($,e){return $.create("vs/base/common/keybindingLabels",e)}),define(Q[126],J([0,1,125]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class R{constructor(M,n,S=n){this.modifierLabels=[null],this.modifierLabels[2]=M,this.modifierLabels[1]=n,this.modifierLabels[3]=S}toLabel(M,n,S){if(n.length===0)return null;const i=[];for(let E=0,m=n.length;E<m;E++){const P=n[E],f=S(P);if(f===null)return null;i[E]=D(P,f,this.modifierLabels[M])}return i.join(" ")}}e.ModifierLabelProvider=R,e.UILabelProvider=new R({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:w.localize(0,null),shiftKey:w.localize(1,null),altKey:w.localize(2,null),metaKey:w.localize(3,null),separator:"+"},{ctrlKey:w.localize(4,null),shiftKey:w.localize(5,null),altKey:w.localize(6,null),metaKey:w.localize(7,null),separator:"+"}),e.AriaLabelProvider=new R({ctrlKey:w.localize(8,null),shiftKey:w.localize(9,null),altKey:w.localize(10,null),metaKey:w.localize(11,null),separator:"+"},{ctrlKey:w.localize(12,null),shiftKey:w.localize(13,null),altKey:w.localize(14,null),metaKey:w.localize(15,null),separator:"+"},{ctrlKey:w.localize(16,null),shiftKey:w.localize(17,null),altKey:w.localize(18,null),metaKey:w.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new R({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new R({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(y,M,n){if(M===null)return"";const S=[];return y.ctrlKey&&S.push(n.ctrlKey),y.shiftKey&&S.push(n.shiftKey),y.altKey&&S.push(n.altKey),y.metaKey&&S.push(n.metaKey),M!==""&&S.push(M),S.join(n.separator)}}),define(Q[127],J([13,12]),function($,e){return $.create("vs/base/node/processes",e)}),define(Q[80],J([0,1,6,25,67,45,127,14,41,28,3,76,10]),function($,e,w,R,D,y,M,n,S,i,E,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function f(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(s,u){if(E.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};u&&(t.cwd=u);const r=y.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],t);return new Promise(o=>{r.once("error",d=>{o({success:!1,error:d})}),r.once("exit",(d,c)=>{o(d===0?{success:!0}:{success:!1,code:d!==null?d:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?f(t.status):1})}else if(E.isLinux||E.isMacintosh)try{const t=P.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(r=>{y.execFile(t,[s.pid.toString()],{encoding:"utf8",shell:!0},(o,d,c)=>{r(o?{success:!1,error:o}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function v(s=process.env){return s.comspec||"cmd.exe"}e.getWindowsShell=v;class p{constructor(u,t,r,o){if(t!==void 0&&r!==void 0&&o!==void 0)this.cmd=u,this.args=t,this.shell=r,this.options=o;else{const d=u;this.cmd=d.command,this.shell=d.isShellCommand,this.args=d.args.slice(0),this.options=d.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const d=Object.create(null);Object.keys(process.env).forEach(c=>{d[c]=process.env[c]}),Object.keys(this.options.env).forEach(c=>{d[c]=this.options.env[c]}),this.options.env=d}}getSanitizedCommand(){let u=this.cmd.toLowerCase();const t=u.lastIndexOf(w.sep);return t!==-1&&(u=u.substring(t+1)),p.WellKnowCommands[u]?u:"other"}start(u){return E.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(process.cwd()))?Promise.reject(new Error(M.localize(0,null))):this.useExec().then(t=>{let r,o;const d=new Promise((c,g)=>{r=c,o=g});if(t){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=y.exec(c,this.options,(g,I,A)=>{this.childProcess=null;const T=g;T&&T.killed?o({killed:this.terminateRequested,stdout:I.toString(),stderr:A.toString()}):this.handleExec(r,u,g,I,A)})}else{let c=null;const g=I=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(I,r,u,o);const A={terminated:this.terminateRequested};n.isNumber(I)&&(A.cmdCode=I),r(A)};if(this.shell&&E.isWindows){const I=S.deepClone(this.options);I.windowsVerbatimArguments=!0,I.detached=!1;let A=!1,T=!1;const U=[];let j=this.ensureQuotes(this.cmd);U.push(j.value),A=j.quoted,this.args&&this.args.forEach(x=>{j=this.ensureQuotes(x),U.push(j.value),T=T&&j.quoted});const C=["/s","/c"];A?T?C.push('"'+U.join(" ")+'"'):U.length>1?C.push('"'+U[0]+'" '+U.slice(1).join(" ")):C.push('"'+U[0]+'"'):C.push(U.join(" ")),c=y.spawn(v(),C,I)}else this.cmd&&(c=y.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(n.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",I=>{this.childProcess=null,o({terminated:this.terminateRequested,error:I})}),c.pid&&(this.childProcess.on("close",g),this.handleSpawn(c,r,u,o,!0)))}return d})}handleClose(u,t,r,o){}ensureQuotes(u){return p.regexp.test(u)?{value:'"'+u+'"',quoted:!0}:{value:u,quoted:u.length>0&&u[0]==='"'&&u[u.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(u=>u.pid,u=>-1):new Promise(u=>{this.pidResolve=u})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(u=>(this.terminateRequested=!0,h(u,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),u=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(u=>{if(!this.shell||!E.isWindows)return u(!1);const t=y.spawn(v(),["/s","/c"]);t.on("error",r=>u(!0)),t.on("exit",r=>u(!1))})}}e.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class b extends p{constructor(u,t,r,o){super(u,t,r,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(u,t,r,o,d){[o,d].forEach((c,g)=>{const I=new m.LineDecoder;I.write(c).forEach(U=>{t({line:U,source:g===0?0:1})});const T=I.end();T&&t({line:T,source:g===0?0:1})}),u({terminated:this.terminateRequested,error:r})}handleSpawn(u,t,r,o,d){const c=new m.LineDecoder,g=new m.LineDecoder;u.stdout.on("data",I=>{c.write(I).forEach(T=>r({line:T,source:0}))}),u.stderr.on("data",I=>{g.write(I).forEach(T=>r({line:T,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=g}handleClose(u,t,r,o){const d=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;d&&r({line:d,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&r({line:c,source:1})}}e.LineProcess=b;function l(s){let u=[],t=!1;const r=function(o){if(t){u.push(o);return}(!s.send(o,c=>{if(c&&console.error(c),t=!1,u.length>0){const g=u.slice(0);u=[],g.forEach(I=>r(I))}})||E.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=l;var a;(function(s){async function u(t,r,o){if(w.isAbsolute(t))return t;if(r===void 0&&(r=process.cwd()),w.dirname(t)!=="."||(o===void 0&&n.isString(process.env.PATH)&&(o=process.env.PATH.split(w.delimiter)),o===void 0||o.length===0))return w.join(r,t);async function c(g){return await D.promisify(R.exists)(g)?!(await D.promisify(R.stat)(g)).isDirectory():!1}for(let g of o){let I;if(w.isAbsolute(g)?I=w.join(g,t):I=w.join(r,g,t),await c(I))return I;let A=I+".com";if(await c(A)||(A=I+".exe",await c(A)))return A}return w.join(r,t)}s.findExecutable=u})(a=e.win32||(e.win32={}))}),define(Q[128],J([0,1,27,3,113,80]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(f,h=process.env){return f===3?R.isWindows?m():y.getWindowsShell(h):i(f,h)}e.getSystemShell=M;function n(f,h=process.env){return f===3?R.isWindows?P(h):y.getWindowsShell(h):i(f,h)}e.getSystemShellSync=n;let S=null;function i(f,h){if(R.isLinux&&f===1||R.isMacintosh&&f===2)return"/bin/bash";if(!S){let v;if(R.isWindows)v="/bin/bash";else{if(v=h.SHELL,!v)try{v=w.userInfo().shell}catch(p){}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}S=v}return S}let E=null;async function m(){return E||(E=(await D.getFirstAvailablePowerShellInstallation()).exePath),E}function P(f){if(E)return E;const h=R.isWindows&&parseFloat(w.release())>=10,v=f.hasOwnProperty("PROCESSOR_ARCHITEW6432"),p=`${f.windir}\\${v?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?p:y.getWindowsShell(f)}}),define(Q[81],J([0,1,45,2,9,41,4,80,33,105,24,16,20,3]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends S.ChannelServer{constructor(b){super({send:l=>{try{process.send&&process.send(l.buffer.toString("base64"))}catch(a){}},onMessage:M.Event.fromNodeEventEmitter(process,"message",l=>P.VSBuffer.wrap(Buffer.from(l,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=h;class v{constructor(b,l){this.modulePath=b,this.options=l,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new M.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const a=l&&l.timeout?l.timeout:6e4;this.disposeDelayer=new D.Delayer(a),this.child=null,this._client=null}getChannel(b){const l=this;return{call(a,s,u){return l.requestPromise(b,a,s,u)},listen(a,s){return l.requestEvent(b,a,s)}}}requestPromise(b,l,a,s=E.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(m.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(b),t=D.createCancelablePromise(d=>u.call(l,a,d)),r=s.onCancellationRequested(()=>t.cancel()),o=R.toDisposable(()=>t.cancel());return this.activeRequests.add(o),t.finally(()=>{r.dispose(),this.activeRequests.delete(o),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,l,a){if(!this.disposeDelayer)return M.Event.None;this.disposeDelayer.cancel();let s;const u=new M.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(b).listen(l,a)(u.fire,u),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],l=Object.create(null);l.env=Object.assign(Object.assign({},y.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(l.env=Object.assign(Object.assign({},l.env),this.options.env)),this.options&&this.options.freshExecArgv&&(l.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.isMacintosh&&l.env&&delete l.env.DYLD_LIBRARY_PATH,this.child=w.fork(this.modulePath,b,l);const a=new M.Emitter;M.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if(i.isRemoteConsoleLog(c)){i.log(c,`IPC Library: ${this.options.serverName}`);return}a.fire(P.VSBuffer.wrap(Buffer.from(c,"base64")))});const u=this.options.useQueue?n.createQueuedSender(this.child):this.child,t=c=>this.child&&this.child.connected&&u.send(c.buffer.toString("base64")),r=a.event,o={send:t,onMessage:r};this._client=new S.ChannelClient(o);const d=()=>this.disposeClient();process.once("exit",d),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,g)=>{process.removeListener("exit",d),this.activeRequests.forEach(I=>R.dispose(I)),this.activeRequests.clear(),c!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+g),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:g})})}return this._client}getCachedChannel(b){let l=this.channels.get(b);return l||(l=this.client.getChannel(b),this.channels.set(b,l)),l}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=v}),define(Q[129],J([13,12]),function($,e){return $.create("vs/code/electron-main/app",e)}),define(Q[130],J([13,12]),function($,e){return $.create("vs/code/electron-main/window",e)}),define(Q[131],J([13,12]),function($,e){return $.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[132],J([13,12]),function($,e){return $.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Q[133],J([13,12]),function($,e){return $.create("vs/platform/environment/node/argv",e)}),define(Q[134],J([13,12]),function($,e){return $.create("vs/platform/environment/node/argvHelper",e)}),define(Q[135],J([13,12]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[136],J([13,12]),function($,e){return $.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[137],J([13,12]),function($,e){return $.create("vs/platform/files/common/fileService",e)}),define(Q[138],J([13,12]),function($,e){return $.create("vs/platform/files/common/files",e)}),define(Q[139],J([13,12]),function($,e){return $.create("vs/platform/files/common/io",e)}),define(Q[140],J([13,12]),function($,e){return $.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[141],J([13,12]),function($,e){return $.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Q[142],J([13,12]),function($,e){return $.create("vs/platform/menubar/electron-main/menubar",e)}),define(Q[143],J([13,12]),function($,e){return $.create("vs/platform/request/common/request",e)}),define(Q[144],J([13,12]),function($,e){return $.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[145],J([13,12]),function($,e){return $.create("vs/platform/update/common/update.config.contribution",e)}),define(Q[146],J([13,12]),function($,e){return $.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Q[147],J([13,12]),function($,e){return $.create("vs/platform/workspaces/common/workspaces",e)}),define(Q[148],J([13,12]),function($,e){return $.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Q[149],J([13,12]),function($,e){return $.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Q[82],J([0,1,4,2]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new w.Emitter,this._onReloadEmitter=new w.Emitter,this._onTerminateEmitter=new w.Emitter,this._onAttachEmitter=new w.Emitter}call(n,S,i){switch(S){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:i[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:i[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:i[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:i[0],port:i[1],subId:i[2]}))}throw new Error("Method not implemented.")}listen(n,S,i){switch(S){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class y extends R.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,S,i){this.channel.call("attach",[n,S,i])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,S){this.channel.call("terminate",[n,S])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,S,i){return this.channel.call("openExtensionDevelopmentHostWindow",[n,S,i])}}e.ExtensionHostDebugChannelClient=y}),define(Q[83],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=void 0;function w(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=w}),define(Q[59],J([0,1,232,133,3]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const y={o:R.localize(0,null),e:R.localize(1,null),t:R.localize(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:R.localize(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:R.localize(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:R.localize(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:R.localize(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:R.localize(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:R.localize(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:R.localize(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:R.localize(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:R.localize(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:R.localize(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:R.localize(13,null)},"show-versions":{type:"boolean",cat:"e",description:R.localize(14,null)},category:{type:"string",cat:"e",description:R.localize(15,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:R.localize(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:R.localize(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:R.localize(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:R.localize(19,null)},verbose:{type:"boolean",cat:"t",description:R.localize(20,null)},log:{type:"string",cat:"t",args:"level",description:R.localize(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:R.localize(22,null)},"prof-startup":{type:"boolean",cat:"t",description:R.localize(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:R.localize(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:R.localize(25,null)},sync:{type:"string",cat:"t",description:R.localize(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:R.localize(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:R.localize(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:R.localize(29,null)},"max-memory":{type:"string",cat:"t",description:R.localize(30,null)},telemetry:{type:"boolean",cat:"t",description:R.localize(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(h,v,p=M){const b={},l=[],a=[];for(let r in v){const o=v[r];o.alias&&(b[r]=o.alias),o.type==="string"||o.type==="string[]"?(l.push(r),o.deprecates&&l.push(o.deprecates)):o.type==="boolean"&&(a.push(r),o.deprecates&&a.push(o.deprecates))}const s=w(h,{string:l,boolean:a,alias:b}),u={},t=s;u._=s._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in v){const o=v[r];o.alias&&delete t[o.alias];let d=t[r];o.deprecates&&t.hasOwnProperty(o.deprecates)&&(d||(d=t[o.deprecates]),delete t[o.deprecates]),typeof d!="undefined"&&(o.type==="string[]"?d&&!Array.isArray(d)&&(d=[d]):o.type==="string"&&Array.isArray(d)&&(d=d.pop(),p.onMultipleValues(r,d)),u[r]=d),delete t[r]}for(let r in t)p.onUnknownOption(r);return u}e.parseArgs=n;function S(h,v){let p="";return v.args&&(Array.isArray(v.args)?p=` <${v.args.join("> <")}>`:p=` <${v.args}>`),v.alias?`-${v.alias} --${h}${p}`:`--${h}${p}`}function i(h,v){let p=0,b=[];for(const u in h){const t=h[u],r=S(u,t);p=Math.max(p,r.length),b.push([r,t.description])}let l=p+2+1;if(v-l<25)return b.reduce((u,t)=>u.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let a=v-l-1,s=[];for(const u of b){let t=u[0],r=m(u[1],a),o=E(l-t.length-2);s.push("  "+t+o+r[0]);for(let d=1;d<r.length;d++)s.push(E(l)+r[d])}return s}e.formatOptions=i;function E(h){return" ".repeat(h)}function m(h,v){let p=[];for(;h.length;){let b=h.length<v?h.length:h.lastIndexOf(" ",v),l=h.slice(0,b).trim();h=h.slice(b),p.push(l)}return p}function P(h,v,p,b,l=!0){const a=process.stdout.isTTY&&process.stdout.columns||80;let s=[`${h} ${p}`];s.push(""),s.push(`${R.localize(32,null)}: ${v} [${R.localize(33,null)}][${R.localize(34,null)}...]`),s.push(""),l&&(D.isWindows?s.push(R.localize(35,null,v)):s.push(R.localize(36,null,v)),s.push(""));const u={};for(const t in b){const r=b[t];if(r.description&&r.cat){let o=u[r.cat];o||(u[r.cat]=o={}),o[t]=r}}for(let t in u){const r=t;let o=u[r];o&&(s.push(y[r]),s.push(...i(o,a)),s.push(""))}return s.join(`
`)}e.buildHelpMessage=P;function f(h,v){return`${h||R.localize(37,null)}
${v||R.localize(38,null)}
${process.arch}`}e.buildVersionMessage=f}),define(Q[150],J([0,1,59,58,82]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class y extends D.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,S,i){return S==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(i[0],i[1],i[2]):super.call(n,S,i)}async openExtensionDevelopmentHostWindow(n,S,i){const E=w.parseArgs(n,w.OPTIONS);E.debugRenderer=i;const m=E.extensionDevelopmentPath;if(!m)return{};const[P]=this.windowsMainService.openExtensionDevelopmentHostWindow(m,{context:5,cli:E,userEnv:Object.keys(S).length>0?S:void 0});if(!i)return{};const f=P.win.webContents.debugger;let h=f.isAttached()?Infinity:0;const v=R.createServer(p=>{h++==0&&f.attach();let b=!1;const l=u=>{b||p.write(JSON.stringify(u)+"\0")},a=(u,t,r,o)=>l({method:t,params:r,sessionId:o});P.win.on("close",()=>{f.removeListener("message",a),p.end(),b=!0}),f.addListener("message",a);let s=Buffer.alloc(0);p.on("data",u=>{s=Buffer.concat([s,u]);for(let t=s.indexOf(0);t!==-1;t=s.indexOf(0)){let r;try{const o=s.slice(0,t).toString("utf8");s=s.slice(t+1),r=JSON.parse(o)}catch(o){console.error("error reading cdp line",o)}f.sendCommand(r.method,r.params,r.sessionId).then(o=>l({id:r.id,sessionId:r.sessionId,result:o})).catch(o=>l({id:r.id,sessionId:r.sessionId,error:{code:0,message:o.message}}))}}),p.on("error",u=>{console.error("error on cdp pipe:",u)}),p.on("close",()=>{b=!0,--h==0&&f.detach()})});return await new Promise(p=>v.listen(0,p)),P.win.on("close",()=>v.close()),{rendererDebugPort:v.address().port}}}e.ElectronExtensionHostDebugBroadcastChannel=y}),define(Q[151],J([0,1,6,27,25]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function y(M){const n=w.join(R.tmpdir(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return D.writeFileSync(n,""),M&&console.log(`Marker file for --wait created: ${n}`),n}catch(S){M&&console.error(`Failed to create marker file for --wait: ${S}`);return}}e.createWaitMarkerFile=y}),define(Q[152],J([0,1,136]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function D(m){return m=m.trim(),m==="*"||R.test(m)}e.isValidVersionStr=D;function y(m){if(!D(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let P=m.match(R);return P?{hasCaret:P[1]==="^",hasGreaterEquals:P[1]===">=",majorBase:P[2]==="x"?0:parseInt(P[2],10),majorMustEqual:P[2]!=="x",minorBase:P[4]==="x"?0:parseInt(P[4],10),minorMustEqual:P[4]!=="x",patchBase:P[6]==="x"?0:parseInt(P[6],10),patchMustEqual:P[6]!=="x",preRelease:P[8]||null}:null}e.parseVersion=y;function M(m){if(!m)return null;let P=m.majorBase,f=m.majorMustEqual,h=m.minorBase,v=m.minorMustEqual,p=m.patchBase,b=m.patchMustEqual;return m.hasCaret&&(P===0||(v=!1),b=!1),{majorBase:P,majorMustEqual:f,minorBase:h,minorMustEqual:v,patchBase:p,patchMustEqual:b,isMinimum:m.hasGreaterEquals}}e.normalizeVersion=M;function n(m,P){let f;typeof m=="string"?f=M(y(m)):f=m;let h;if(typeof P=="string"?h=M(y(P)):h=P,!f||!h)return!1;let v=f.majorBase,p=f.minorBase,b=f.patchBase,l=h.majorBase,a=h.minorBase,s=h.patchBase,u=h.majorMustEqual,t=h.minorMustEqual,r=h.patchMustEqual;return h.isMinimum?v>l?!0:v<l?!1:p>a?!0:p<a?!1:b>=s:(v===1&&l===0&&(!u||!t||!r)&&(l=1,a=0,s=0,u=!0,t=!1,r=!1),v<l?!1:v>l?!u:p<a?!1:p>a?!t:b<s?!1:b>s?!r:!0)}e.isValidVersion=n;function S(m,P,f){return P.isBuiltin||typeof P.main=="undefined"?!0:E(m,P.engines.vscode,f)}e.isValidExtensionVersion=S;function i(m,P){return m==="*"||E(P,m)}e.isEngineValid=i;function E(m,P,f=[]){let h=M(y(P));if(!h)return f.push(w.localize(0,null,P)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return f.push(w.localize(1,null,P)),!1}else if(!h.majorMustEqual)return f.push(w.localize(2,null,P)),!1;return n(m,h)?!0:(f.push(w.localize(3,null,m,P)),!1)}e.isVersionValid=E}),define(Q[153],J([0,1,33,81,2,10]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M extends D.Disposable{constructor(S,i,E,m){super();this.folders=S,this.onDidFilesChange=i,this.onLogMessage=E,this.verboseLogging=m,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new R.Client(y.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=M.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=w.createChannelSender(w.getNextTickChannel(S.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(i=>!this.isDisposed&&this.onDidFilesChange(i))),this._register(this.service.onDidLogMessage(i=>this.onLogMessage(i))),this.setFolders(this.folders)}setVerboseLogging(S){this.verboseLogging=S,!this.isDisposed&&this.service&&this.service.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${S}`})}setFolders(S){this.folders=S,this.service&&this.service.setRoots(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=M,M.MAX_RESTARTS=5}),define(Q[154],J([0,1,33,81,2,10]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M extends D.Disposable{constructor(S,i,E,m,P={}){super();this.folders=S,this.onDidFilesChange=i,this.onLogMessage=E,this.verboseLogging=m,this.watcherOptions=P,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new R.Client(y.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=M.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=w.createChannelSender(w.getNextTickChannel(S.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(i=>!this.isDisposed&&this.onDidFilesChange(i))),this._register(this.service.onDidLogMessage(i=>this.onLogMessage(i))),this.service.setRoots(this.folders)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${S}`})}setVerboseLogging(S){this.verboseLogging=S,this.service&&this.service.setVerboseLogging(S)}setFolders(S){this.folders=S,this.service&&this.service.setRoots(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=M,M.MAX_RESTARTS=5}),define(Q[155],J([0,1,45,76,75,10]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class M{constructor(S,i,E,m,P){this.watchedFolder=S,this.eventCallback=E,this.logCallback=m,this.verboseLogging=P,this.restartCounter=0,Array.isArray(i)?this.ignored=i.map(f=>D.parse(f)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${S}`),this.startWatcher()}startWatcher(){const S=[this.watchedFolder];this.verboseLogging&&S.push("-verbose"),this.handle=w.spawn(y.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,S);const i=new R.LineDecoder;this.handle.stdout.on("data",E=>{const m=[];i.write(E).forEach(P=>{const f=P.split("|");if(f.length===2){const h=Number(f[0]),v=f[1];if(h>=0&&h<3){if(this.ignored&&this.ignored.some(p=>p(v))){this.verboseLogging&&this.log(v);return}m.push({type:M.changeTypeMap[h],path:v})}else this.log(f[1])}}),m.length>0&&this.eventCallback(m)}),this.handle.on("error",E=>this.onError(E)),this.handle.stderr.on("data",E=>this.onError(E)),this.handle.on("exit",(E,m)=>this.onExit(E,m))}onError(S){this.error("process error: "+S.toString())}onExit(S,i){this.handle&&(this.error(`terminated unexpectedly (code: ${S}, signal: ${i})`),this.restartCounter<=M.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(S){this.logCallback({type:"error",message:`[File Watcher (C#)] ${S}`})}log(S){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${S}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=M,M.MAX_RESTARTS=5,M.changeTypeMap=[0,1,2]}),define(Q[156],J([0,1,155,6,17]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class y{constructor(n,S,i,E){this.onDidFilesChange=S,this.onLogMessage=i,this.verboseLogging=E,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(R.posix.sep)&&(this.folder.path=D.rtrim(this.folder.path,R.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new w.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=y}),define(Q[69],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class w{constructor(y,M=[],n=!1){this.ctor=y,this.staticArguments=M,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=w;const R=(D,...y)=>new w(D,y);e.createSyncDescriptor=R}),define(Q[157],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=w;class R{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let M of this._nodes.values())M.outgoing.size===0&&y.push(M);return y}insertEdge(y,M){const n=this.lookupOrInsertNode(y),S=this.lookupOrInsertNode(M);n.outgoing.set(this._hashFn(M),S),S.incoming.set(this._hashFn(y),n)}removeNode(y){const M=this._hashFn(y);this._nodes.delete(M);for(let n of this._nodes.values())n.outgoing.delete(M),n.incoming.delete(M)}lookupOrInsertNode(y){const M=this._hashFn(y);let n=this._nodes.get(M);return n||(n=new w(y),this._nodes.set(M,n)),n}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[M,n]of this._nodes)y.push(`${M}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return y.join(`
`)}}e.Graph=R}),define(Q[5],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function n(S){return S[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=n})(w=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function R(M,n,S,i){n[w.DI_TARGET]===n?n[w.DI_DEPENDENCIES].push({id:M,index:S,optional:i}):(n[w.DI_DEPENDENCIES]=[{id:M,index:S,optional:i}],n[w.DI_TARGET]=n)}function D(M){if(w.serviceIds.has(M))return w.serviceIds.get(M);const n=function(S,i,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(n,S,E,!1)};return n.toString=()=>M,w.serviceIds.set(M,n),n}e.createDecorator=D;function y(M){return function(n,S,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(M,n,i,!0)}}e.optional=y}),define(Q[158],J([0,1,5,4,2,11,9]),function($,e,w,R,D,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisplayMainService=e.IDisplayMainService=void 0,e.IDisplayMainService=w.createDecorator("displayMainService");class n extends D.Disposable{constructor(){super();this._onDidDisplayChanged=this._register(new R.Emitter),this.onDidDisplayChanged=this._onDidDisplayChanged.event;const i=this._register(new M.RunOnceScheduler(()=>{this._onDidDisplayChanged.fire()},100));y.app.whenReady().then(()=>{const E=(m,P,f)=>{i.schedule()};y.screen.on("display-metrics-changed",E),this._register(D.toDisposable(()=>y.screen.removeListener("display-metrics-changed",E))),y.screen.on("display-added",E),this._register(D.toDisposable(()=>y.screen.removeListener("display-added",E))),y.screen.on("display-removed",E),this._register(D.toDisposable(()=>y.screen.removeListener("display-removed",E)))})}}e.DisplayMainService=n}),define(Q[84],J([0,1,5]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=w.createDecorator("encryptionMainService");class R{constructor(y){this.machineId=y}encryption(){return new Promise((y,M)=>$(["vscode-encrypt"],y,M))}async encrypt(y){try{return(await this.encryption()).encrypt(this.machineId,y)}catch(M){return y}}async decrypt(y){try{return(await this.encryption()).decrypt(this.machineId,y)}catch(M){return y}}}e.EncryptionMainService=R}),define(Q[53],J([0,1,5]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=w.createDecorator("environmentService"),e.INativeEnvironmentService=w.createDecorator("nativeEnvironmentService")}),define(Q[159],J([0,1,135,5,10]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function y(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=y;var M;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=5]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(M=e.SortBy||(e.SortBy={}));var n;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(n=e.SortOrder||(e.SortOrder={}));var S;(function(m){m.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var i;(function(m){m[m.None=0]="None",m[m.Install=1]="Install",m[m.Update=2]="Update"})(i=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=R.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class E extends Error{constructor(P,f){super(P);this.code=f}}e.ExtensionManagementError=E,e.IExtensionManagementService=R.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=R.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=R.createDecorator("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),e.ExtensionsLabel=w.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=w.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=R.createDecorator("IExtensionManagementCLIService")}),define(Q[160],J([0,1,5]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=w.createDecorator("extensionUrlTrustService")}),define(Q[161],J([0,1,17,5]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Themes","Testing","Visualization","Other"];var y;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));class M{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,m){if(typeof E=="undefined"||E===null)return typeof m=="undefined"||m===null;if(typeof m=="undefined"||m===null)return!1;if(typeof E=="string"||typeof m=="string"){let P=typeof E=="string"?E:E.value,f=typeof m=="string"?m:m.value;return w.equalsIgnoreCase(P,f)}return E._lower===m._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=M;function n(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=n;function S(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=S,e.IBuiltinExtensionsScannerService=R.createDecorator("IBuiltinExtensionsScannerService")}),define(Q[162],J([0,1,17,161]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(f,h){return f.uuid&&h.uuid?f.uuid===h.uuid:f.id===h.id?!0:w.compareIgnoreCase(f.id,h.id)===0}e.areSameExtensions=D;class y{constructor(h,v){this.version=v,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof y?D(this,h)&&this.version===h.version:!1}}e.ExtensionIdentifierWithVersion=y;function M(f,h){return`${f}.${h}`}e.getExtensionId=M;function n(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function S(f,h){return n(M(f,h))}e.getGalleryExtensionId=S;function i(f,h){const v=[],p=b=>{for(const l of v)if(l.some(a=>D(h(a),h(b))))return l;return null};for(const b of f){const l=p(b);l?l.push(b):v.push([b])}return v}e.groupByExtension=i;function E(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function m(f){return Object.assign({id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0)},f.telemetryData)}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function P(f){const h=new Set;for(const v of f)v.malicious&&h.add(v.id.id);return h}e.getMaliciousExtensionsSet=P}),define(Q[21],J([0,1,138,6,7,5,17,14,35]),function($,e,w,R,D,y,M,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.IFileService=void 0,e.IFileService=y.createDecorator("fileService");var i;(function(C){C[C.Unknown=0]="Unknown",C[C.File=1]="File",C[C.Directory=2]="Directory",C[C.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var E;(function(C){C[C.FileReadWrite=2]="FileReadWrite",C[C.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",C[C.FileReadStream=16]="FileReadStream",C[C.FileFolderCopy=8]="FileFolderCopy",C[C.PathCaseSensitive=1024]="PathCaseSensitive",C[C.Readonly=2048]="Readonly",C[C.Trash=4096]="Trash"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(C){return!!(C.capabilities&2)}e.hasReadWriteCapability=m;function P(C){return!!(C.capabilities&8)}e.hasFileFolderCopyCapability=P;function f(C){return!!(C.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function h(C){return!!(C.capabilities&16)}e.hasFileReadStreamCapability=h;var v;(function(C){C.FileExists="EntryExists",C.FileNotFound="EntryNotFound",C.FileNotADirectory="EntryNotADirectory",C.FileIsADirectory="EntryIsADirectory",C.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",C.FileTooLarge="EntryTooLarge",C.NoPermissions="NoPermissions",C.Unavailable="Unavailable",C.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(x,ee){super(x);this.code=ee}}e.FileSystemProviderError=p;function b(C,x){const ee=new p(C.toString(),x);return a(ee,x),ee}e.createFileSystemProviderError=b;function l(C){return C||b(w.localize(0,null),v.Unknown)}e.ensureFileSystemProviderError=l;function a(C,x){return C.name=x?`${x} (FileSystemError)`:"FileSystemError",C}e.markAsFileSystemProviderError=a;function s(C){if(!C)return v.Unknown;if(C instanceof p)return C.code;const x=/^(.+) \(FileSystemError\)$/.exec(C.name);if(!x)return v.Unknown;switch(x[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=s;function u(C){if(C instanceof g)return C.fileOperationResult;switch(s(C)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var t;(function(C){C[C.CREATE=0]="CREATE",C[C.DELETE=1]="DELETE",C[C.MOVE=2]="MOVE",C[C.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class r{constructor(x,ee,Z){this.resource=x,this.operation=ee,this.target=Z}isOperation(x){return this.operation===x}}e.FileOperationEvent=r;var o;(function(C){C[C.UPDATED=0]="UPDATED",C[C.ADDED=1]="ADDED",C[C.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class d{constructor(x,ee){this.ignorePathCasing=ee,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=x;for(const Z of x)switch(Z.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(Z.resource,Z);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(Z.resource,Z);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(Z.resource,Z);break}}contains(x,...ee){return this.doContains(x,{includeChildren:!1},...ee)}affects(x,...ee){return this.doContains(x,{includeChildren:!0},...ee)}doContains(x,ee,...Z){var H,N,q,F,z,O;if(!x)return!1;const k=Z.length>0;return!!((!k||Z.includes(1))&&(((H=this.added)===null||H===void 0?void 0:H.get(x))||ee.includeChildren&&((N=this.added)===null||N===void 0?void 0:N.findSuperstr(x)))||(!k||Z.includes(0))&&(((q=this.updated)===null||q===void 0?void 0:q.get(x))||ee.includeChildren&&((F=this.updated)===null||F===void 0?void 0:F.findSuperstr(x)))||(!k||Z.includes(2))&&(((z=this.deleted)===null||z===void 0?void 0:z.findSubstr(x))||ee.includeChildren&&((O=this.deleted)===null||O===void 0?void 0:O.findSuperstr(x))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(x){const ee=[],Z=x===1?this.added:x===0?this.updated:this.deleted;if(Z)for(const[,H]of Z)ee.push(H);return ee}filter(x){return new d(this.changes.filter(ee=>x(ee)),this.ignorePathCasing)}}e.FileChangesEvent=d;function c(C,x,ee){return!C||!x||C===x||x.length>C.length?!1:(x.charAt(x.length-1)!==R.sep&&(x+=R.sep),ee?M.startsWithIgnoreCase(C,x):C.indexOf(x)===0)}e.isParent=c;class g extends Error{constructor(x,ee,Z){super(x);this.fileOperationResult=ee,this.options=Z}static isFileOperationError(x){return x instanceof Error&&!n.isUndefinedOrNull(x.fileOperationResult)}}e.FileOperationError=g;var I;(function(C){C[C.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",C[C.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",C[C.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",C[C.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",C[C.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",C[C.FILE_READ_ONLY=5]="FILE_READ_ONLY",C[C.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",C[C.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",C[C.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",C[C.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",C[C.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",C[C.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(I=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(C){C[C.FILE=0]="FILE",C[C.FOLDER=1]="FOLDER",C[C.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function T(C){if(!(typeof C.size!="number"||typeof C.mtime!="number"))return C.mtime.toString(29)+C.size.toString(31)}e.etag=T;async function U(C,x){if(!x.canHandleResource(D.URI.from({scheme:C.scheme})))return new Promise(ee=>{const Z=x.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===C.scheme&&H.added&&(Z.dispose(),ee())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class j{static formatSize(x){return n.isNumber(x)||(x=0),x<j.KB?w.localize(1,null,x.toFixed(0)):x<j.MB?w.localize(2,null,(x/j.KB).toFixed(2)):x<j.GB?w.localize(3,null,(x/j.MB).toFixed(2)):x<j.TB?w.localize(4,null,(x/j.GB).toFixed(2)):w.localize(5,null,(x/j.TB).toFixed(2))}}e.ByteSize=j,j.KB=1024,j.MB=j.KB*j.KB,j.GB=j.MB*j.KB,j.TB=j.GB*j.KB}),define(Q[54],J([0,1,233,134,21,59]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function M(P,f){const h={onUnknownOption:p=>{console.warn(R.localize(0,null,p))},onMultipleValues:(p,b)=>{console.warn(R.localize(1,null,p,b))}},v=y.parseArgs(P,y.OPTIONS,f?h:void 0);return v.goto&&v._.forEach(p=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(p),R.localize(2,null))),v["max-memory"]&&w(parseInt(v["max-memory"])>=D.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${D.MIN_MAX_MEMORY_SIZE_MB} MB.`),v}function n(P){const f=P.findIndex(h=>!/^-/.test(h));if(f>-1)return[...P.slice(0,f),...P.slice(f+1)]}function S(P){let[,...f]=P;process.env.VSCODE_DEV&&(f=n(f)||[]);const h=!m(process.env);return M(f,h)}e.parseMainProcessArgv=S;function i(P){const[,,...f]=P;return M(f,!0)}e.parseCLIProcessArgv=i;function E(P,...f){const h=P.indexOf("--");return h===-1?P.push(...f):P.splice(h,0,...f),P}e.addArg=E;function m(P){return P.VSCODE_CLI==="1"}e.isLaunchedFromCli=m}),define(Q[163],J([0,1,45,29,3,54,68,128]),function($,e,w,R,D,y,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function S(m,P,f){return P["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):D.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):y.isLaunchedFromCli(f)&&!P["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):(y.isLaunchedFromCli(f)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),i||(i=E(m)),i)}e.resolveShellEnv=S;let i;async function E(m){const P=new Promise(async(f,h)=>{const v=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",v);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",p);const b=R.generateUuid().replace(/-/g,"").substr(0,12),l=new RegExp(b+"(.*)"+b),a=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"}),s=`'${process.execPath}' -p '"${b}" + JSON.stringify(process.env) + "${b}"'`;m.trace("getUnixShellEnvironment#env",a),m.trace("getUnixShellEnvironment#spawn",s);const u=await n.getSystemShell(D.platform),t=w.spawn(u,["-ilc",s],{detached:!0,stdio:["ignore","pipe",process.stderr],env:a}),r=[];t.on("error",()=>f({})),t.stdout.on("data",o=>r.push(o)),t.on("close",o=>{if(o!==0)return h(new Error("Failed to get environment"));const d=Buffer.concat(r).toString("utf8");m.trace("getUnixShellEnvironment#raw",d);const c=l.exec(d),g=c?c[1]:"{}";try{const I=JSON.parse(g);v?I.ELECTRON_RUN_AS_NODE=v:delete I.ELECTRON_RUN_AS_NODE,p?I.ELECTRON_NO_ATTACH_CONSOLE=p:delete I.ELECTRON_NO_ATTACH_CONSOLE,delete I.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",I),f(I)}catch(I){m.error("getUnixShellEnvironment#error",I),h(I)}})});try{return await P}catch(f){return m.error("getUnixShellEnvironment#error",M.toErrorMessage(f)),{}}}}),define(Q[85],J([0,1,139,20,21,16]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(E,m,P,f,h,v){let p;try{await n(E,m,P,f,h,v)}catch(b){p=b}finally{p&&h.errorTransformer&&(p=h.errorTransformer(p)),P.end(p)}}e.readFileIntoStream=M;async function n(E,m,P,f,h,v){S(v);const p=await E.open(m,{create:!1});try{S(v);let b=0,l=0,a=h&&typeof h.length=="number"?h.length:void 0,s=R.VSBuffer.alloc(Math.min(h.bufferSize,typeof a=="number"?a:h.bufferSize)),u=h&&typeof h.position=="number"?h.position:0,t=0;do l=await E.read(p,u,s.buffer,t,s.byteLength-t),u+=l,t+=l,b+=l,typeof a=="number"&&(a-=l),t===s.byteLength&&(await P.write(f(s)),s=R.VSBuffer.alloc(Math.min(h.bufferSize,typeof a=="number"?a:h.bufferSize)),t=0);while(l>0&&(typeof a!="number"||a>0)&&S(v)&&i(b,h));if(t>0){let r=t;typeof a=="number"&&(r=Math.min(t,a)),P.write(f(s.slice(0,r)))}}catch(b){throw D.ensureFileSystemProviderError(b)}finally{await E.close(p)}}function S(E){if(E.isCancellationRequested)throw y.canceled();return!0}function i(E,m){if(m==null?void 0:m.limits){if(typeof m.limits.memory=="number"&&E>m.limits.memory)throw D.createFileSystemProviderError(w.localize(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof m.limits.size=="number"&&E>m.limits.size)throw D.createFileSystemProviderError(w.localize(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[86],J([0,1,7,21,3]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function y(S){return S.map(i=>({type:i.type,resource:w.URI.file(i.path)}))}e.toFileChanges=y;function M(S){const i=new n;for(const E of S)i.processEvent(E);return i.normalize()}e.normalizeFileChanges=M;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(i){const E=this.mapPathToChange.get(i.path);if(E){const m=E.type,P=i.type;m===1&&P===2?(this.mapPathToChange.delete(i.path),this.normalized.splice(this.normalized.indexOf(E),1)):m===2&&P===1?E.type=0:m===1&&P===0||(E.type=P)}else this.normalized.push(i),this.mapPathToChange.set(i.path,i)}normalize(){const i=[],E=[];return this.normalized.filter(m=>m.type!==2?(i.push(m),!1):!0).sort((m,P)=>m.path.length-P.path.length).filter(m=>E.some(P=>R.isParent(m.path,P,!D.isLinux))?!1:(E.push(m.path),!0)).concat(i)}}}),define(Q[164],J([0,1,86,2,26,111,114,9,6]),function($,e,w,R,D,y,M,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends R.Disposable{constructor(m,P,f,h){super();this.path=m,this.onDidFilesChange=P,this.onLogMessage=f,this.verboseLogging=h,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(M.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(m){this.verboseLogging=m}async startWatching(){try{const{stat:m,symbolicLink:P}=await D.statLink(this.path);if(this.isDisposed)return;let f=this.path;if(P)try{f=await y.realpath(f)}catch(h){this.onError(h)}m.isDirectory()?this._register(M.watchFolder(f,(h,v)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:S.join(this.path,S.basename(v))})},h=>this.onError(h))):this._register(M.watchFile(f,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(m){this.onError(m)}}onFileChange(m){this.fileChangesBuffer.push(m),this.verboseLogging&&this.onVerbose(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),this.fileChangesDelayer.trigger(async()=>{const P=this.fileChangesBuffer;this.fileChangesBuffer=[];const f=w.normalizeFileChanges(P);this.verboseLogging&&f.forEach(h=>{this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`)}),f.length>0&&this.onDidFilesChange(f)})}onError(m){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${m}`})}onVerbose(m){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=i}),define(Q[70],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...D){this._entries=new Map;for(let[y,M]of D)this.set(y,M)}set(D,y){const M=this._entries.get(D);return this._entries.set(D,y),M}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=w}),define(Q[165],J([0,1,16,157,69,5,70,9]),function($,e,w,R,D,y,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class i extends Error{constructor(h){super("cyclic dependency between services");this.message=h.toString()}}class E{constructor(h=new M.ServiceCollection,v=!1,p){this._activeInstantiations=new Set,this._services=h,this._strict=v,this._parent=p,this._services.set(y.IInstantiationService,this)}createChild(h){return new E(h,this._strict,this)}invokeFunction(h,...v){let p=P.traceInvocation(h),b=!1;try{return h({get:(a,s)=>{if(b)throw w.illegalState("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(a,p);if(!u&&s!==y.optional)throw new Error(`[invokeFunction] unknown service '${a}'`);return u}},...v)}finally{b=!0,p.stop()}}createInstance(h,...v){let p,b;return h instanceof D.SyncDescriptor?(p=P.traceCreation(h.ctor),b=this._createInstance(h.ctor,h.staticArguments.concat(v),p)):(p=P.traceCreation(h),b=this._createInstance(h,v,p)),p.stop(),b}_createInstance(h,v=[],p){let b=y._util.getServiceDependencies(h).sort((s,u)=>s.index-u.index),l=[];for(const s of b){let u=this._getOrCreateServiceInstance(s.id,p);if(!u&&this._strict&&!s.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${s.id}.`);l.push(u)}let a=b.length>0?b[0].index:v.length;if(v.length!==a){console.warn(`[createInstance] First service dependency of ${h.name} at position ${a+1} conflicts with ${v.length} static arguments`);let s=a-v.length;s>0?v=v.concat(new Array(s)):v=v.slice(0,a)}return new h(...[...v,...l])}_setServiceInstance(h,v){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,v);else if(this._parent)this._parent._setServiceInstance(h,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let v=this._services.get(h);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):v}_getOrCreateServiceInstance(h,v){let p=this._getServiceInstanceOrDescriptor(h);return p instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,p,v.branch(h,!0)):(v.branch(h,!1),p)}_safeCreateAndCacheServiceInstance(h,v,p){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,v,p)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,v,p){const b=new R.Graph(s=>s.id.toString());let l=0;const a=[{id:h,desc:v,_trace:p}];for(;a.length;){const s=a.pop();if(b.lookupOrInsertNode(s),l++>1e3)throw new i(b);for(let u of y._util.getServiceDependencies(s.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(u.id);if(!t&&!u.optional&&console.warn(`[createInstance] ${h} depends on ${u.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const r={id:u.id,desc:t,_trace:s._trace.branch(u.id,!0)};b.insertEdge(s,r),a.push(r)}}}for(;;){const s=b.roots();if(s.length===0){if(!b.isEmpty())throw new i(b);break}for(const{data:u}of s){if(this._getServiceInstanceOrDescriptor(u.id)instanceof D.SyncDescriptor){const r=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,r)}b.removeNode(u)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,v,p=[],b,l){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(v,p,b,l);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,v,p,b,l);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(h,v=[],p,b){if(p){const l=new n.IdleValue(()=>this._createInstance(h,v,b));return new Proxy(Object.create(null),{get(a,s){if(s in a)return a[s];let u=l.value,t=u[s];return typeof t!="function"||(t=t.bind(u),a[s]=t),t},set(a,s,u){return l.value[s]=u,!0}})}else return this._createInstance(h,v,b)}}e.InstantiationService=E;var m;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(m||(m={}));class P{constructor(h,v){this.type=h,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return S?new P(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):P._None}static traceCreation(h){return S?new P(0,h.name):P._None}branch(h,v){let p=new P(2,h.toString());return this._dep.push([h,v,p]),p}stop(){let h=Date.now()-this._start;P._totals+=h;let v=!1;function p(l,a){let s=[],u=new Array(l+1).join("	");for(const[t,r,o]of a._dep)if(r&&o){v=!0,s.push(`${u}CREATES -> ${t}`);let d=p(l+1,o);d&&s.push(d)}else s.push(`${u}uses -> ${t}`);return s.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${P._totals.toFixed(2)}ms)`];(h>2||v)&&console.log(b.join(`
`))}}P._None=new class extends P{constructor(){super(-1,null)}stop(){}branch(){return this}},P._totals=0}),define(Q[166],J([0,1,16,126,56]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class y extends D.ResolvedKeybinding{constructor(n,S){super();if(S.length===0)throw w.illegalArgument("parts");this._os=n,this._parts=S}getLabel(){return R.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return R.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:R.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return R.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new D.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}}e.BaseResolvedKeybinding=y}),define(Q[167],J([0,1,56,166]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class D extends R.BaseResolvedKeybinding{constructor(M,n){super(n,M.parts)}_keyCodeToUILabel(M){if(this._os===2)switch(M){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return w.KeyCodeUtils.toString(M)}_getLabel(M){return M.isDuplicateModifierCase()?"":this._keyCodeToUILabel(M.keyCode)}_getAriaLabel(M){return M.isDuplicateModifierCase()?"":w.KeyCodeUtils.toString(M.keyCode)}_keyCodeToElectronAccelerator(M){if(M>=93&&M<=108)return null;switch(M){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return w.KeyCodeUtils.toString(M)}_getElectronAccelerator(M){return M.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(M.keyCode)}_getUserSettingsLabel(M){if(M.isDuplicateModifierCase())return"";const n=w.KeyCodeUtils.toUserSettingsUS(M.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(M){return D.getDispatchStr(M)}static getDispatchStr(M){if(M.isModifierKey())return null;let n="";return M.ctrlKey&&(n+="ctrl+"),M.shiftKey&&(n+="shift+"),M.altKey&&(n+="alt+"),M.metaKey&&(n+="meta+"),n+=w.KeyCodeUtils.toString(M.keyCode),n}}e.USLayoutResolvedKeybinding=D}),define(Q[168],J([0,1,5,4,2]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=w.createDecorator("keyboardLayoutMainService");class y extends D.Disposable{constructor(){super();this._onDidChangeKeyboardLayout=this._register(new R.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const S=await new Promise((i,E)=>{$(["native-keymap"],i,E)});this._keyboardLayoutData=M(S),S.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=M(S),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}}e.KeyboardLayoutMainService=y;function M(n){const S=n.getKeyMap(),i=n.getCurrentKeyboardLayout();return{keyboardMapping:S,keyboardLayoutInfo:i}}}),define(Q[169],J([0,1,9]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function R(D,y){if(D.length===0)return Promise.resolve(!1);const M=[];let n=!1;for(let S of D){if(S===!0)return Promise.resolve(!0);w.isThenable(S)&&M.push(S.then(i=>{i&&(n=!0)},i=>{y(i),n=!0}))}return Promise.all(M).then(()=>n)}e.handleVetos=R}),define(Q[8],J([0,1,5,2,3,4,68]),function($,e,w,R,D,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.DelegatedLogService=e.MultiplexLogService=e.ConsoleLogInMainService=e.LogServiceAdapter=e.ConsoleLogService=e.ConsoleLogMainService=e.AbstractLogService=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=w.createDecorator("logService"),e.ILoggerService=w.createDecorator("loggerService");function n(){return new Date().toISOString()}var S;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class i extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(u){this.level!==u&&(this.level=u,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogService=i;class E extends i{constructor(u=e.DEFAULT_LOG_LEVEL){super();this.setLevel(u),this.useColors=!D.isWindows}trace(u,...t){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,u,...t):console.log(`[main ${n()}]`,u,...t))}debug(u,...t){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,u,...t):console.log(`[main ${n()}]`,u,...t))}info(u,...t){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,u,...t):console.log(`[main ${n()}]`,u,...t))}warn(u,...t){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,u,...t):console.warn(`[main ${n()}]`,u,...t))}error(u,...t){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,u,...t):console.error(`[main ${n()}]`,u,...t))}critical(u,...t){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,u,...t):console.error(`[main ${n()}]`,u,...t))}dispose(){}flush(){}}e.ConsoleLogMainService=E;class m extends i{constructor(u=e.DEFAULT_LOG_LEVEL){super();this.setLevel(u)}trace(u,...t){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",u,...t)}debug(u,...t){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",u,...t)}info(u,...t){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",u,...t)}warn(u,...t){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",u,...t)}error(u,...t){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",u,...t)}critical(u,...t){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",u,...t)}dispose(){}flush(){}}e.ConsoleLogService=m;class P extends i{constructor(u,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=u,this.setLevel(t)}trace(u,...t){this.getLevel()<=S.Trace&&this.adapter.consoleLog("trace",[this.extractMessage(u),...t])}debug(u,...t){this.getLevel()<=S.Debug&&this.adapter.consoleLog("debug",[this.extractMessage(u),...t])}info(u,...t){this.getLevel()<=S.Info&&this.adapter.consoleLog("info",[this.extractMessage(u),...t])}warn(u,...t){this.getLevel()<=S.Warning&&this.adapter.consoleLog("warn",[this.extractMessage(u),...t])}error(u,...t){this.getLevel()<=S.Error&&this.adapter.consoleLog("error",[this.extractMessage(u),...t])}critical(u,...t){this.getLevel()<=S.Critical&&this.adapter.consoleLog("critical",[this.extractMessage(u),...t])}extractMessage(u){return typeof u=="string"?u:M.toErrorMessage(u,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.LogServiceAdapter=P;class f extends P{constructor(u,t=e.DEFAULT_LOG_LEVEL){super({consoleLog:(r,o)=>u.consoleLog(r,o)},t)}}e.ConsoleLogInMainService=f;class h extends i{constructor(u){super();this.logServices=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const t of this.logServices)t.setLevel(u);super.setLevel(u)}trace(u,...t){for(const r of this.logServices)r.trace(u,...t)}debug(u,...t){for(const r of this.logServices)r.debug(u,...t)}info(u,...t){for(const r of this.logServices)r.info(u,...t)}warn(u,...t){for(const r of this.logServices)r.warn(u,...t)}error(u,...t){for(const r of this.logServices)r.error(u,...t)}critical(u,...t){for(const r of this.logServices)r.critical(u,...t)}flush(){for(const u of this.logServices)u.flush()}dispose(){for(const u of this.logServices)u.dispose()}}e.MultiplexLogService=h;class v extends R.Disposable{constructor(u){super();this.logService=u,this._register(u)}get onDidChangeLogLevel(){return this.logService.onDidChangeLogLevel}setLevel(u){this.logService.setLevel(u)}getLevel(){return this.logService.getLevel()}trace(u,...t){this.logService.trace(u,...t)}debug(u,...t){this.logService.debug(u,...t)}info(u,...t){this.logService.info(u,...t)}warn(u,...t){this.logService.warn(u,...t)}error(u,...t){this.logService.error(u,...t)}critical(u,...t){this.logService.critical(u,...t)}flush(){this.logService.flush()}}e.DelegatedLogService=v;class p{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(u){}getLevel(){return S.Info}trace(u,...t){}debug(u,...t){}info(u,...t){}warn(u,...t){}error(u,...t){}critical(u,...t){}dispose(){}flush(){}}e.NullLogService=p;function b(s){if(s.verbose)return S.Trace;if(typeof s.logLevel=="string"){const u=l(s.logLevel.toLowerCase());if(u!==void 0)return u}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function l(s){switch(s){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=l;function a(s){switch(s){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=a});var de=this&&this.__decorate||function($,e,w,R){var D=arguments.length,y=D<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,w):R,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate($,e,w,R);else for(var n=$.length-1;n>=0;n--)(M=$[n])&&(y=(D<3?M(y):D>3?M(e,w,y):M(e,w))||y);return D>3&&y&&Object.defineProperty(e,w,y),y},re=this&&this.__param||function($,e){return function(w,R){e(w,R,$)}};define(Q[170],J([0,1,4,2,10,7,53,11,8,35,3]),function($,e,w,R,D,y,M,n,S,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileProtocolHandler=void 0;let m=class extends R.Disposable{constructor(f,h){super();this.logService=h,this.validRoots=i.TernarySearchTree.forUris(()=>!E.isLinux);const{defaultSession:v}=n.session;this.validRoots.set(y.URI.file(f.appRoot),!0),this.validRoots.set(y.URI.file(f.extensionsPath),!0),v.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(p,b)=>this.handleResourceRequest(p,b)),E.isPreferringBrowserCodeLoad&&(this.logService.info(`Intercepting ${D.Schemas.file}: protocol and blocking it`),v.protocol.interceptFileProtocol(D.Schemas.file,(p,b)=>this.handleFileRequest(p,b))),this._register(R.toDisposable(()=>{v.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),E.isPreferringBrowserCodeLoad&&v.protocol.uninterceptProtocol(D.Schemas.file)}))}injectWindowsMainService(f){this._register(f.onWindowReady(h=>{var v,p;if(((v=h.config)===null||v===void 0?void 0:v.extensionDevelopmentPath)||((p=h.config)===null||p===void 0?void 0:p.extensionTestsPath)){const b=new R.DisposableStore;if(b.add(w.Event.any(h.onClose,h.onDestroy)(()=>b.dispose())),h.config.extensionDevelopmentPath)for(const l of h.config.extensionDevelopmentPath)b.add(this.addValidRoot(y.URI.file(l)));h.config.extensionTestsPath&&b.add(this.addValidRoot(y.URI.file(h.config.extensionTestsPath)))}}))}addValidRoot(f){return this.validRoots.get(f)?R.Disposable.None:(this.validRoots.set(f,!0),R.toDisposable(()=>this.validRoots.delete(f)))}async handleFileRequest(f,h){const v=y.URI.parse(f.url);this.logService.error(`Refused to load resource ${v.fsPath} from ${D.Schemas.file}: protocol`),h({error:-3})}async handleResourceRequest(f,h){const v=y.URI.parse(f.url),p=D.FileAccess.asFileUri(v);if(this.validRoots.findSubstr(p))return h({path:p.fsPath});this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${p.fsPath}}`),h({error:-3})}};m=de([re(0,M.INativeEnvironmentService),re(1,S.ILogService)],m),e.FileProtocolHandler=m}),define(Q[171],J([0,1,137,172,2,21,4,18,35,32,8,20,64,9,24,10,85,63]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h,v,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let l=class extends D.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new M.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueues=new Map}registerProvider(s,u){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);R.mark(`code/registerFilesystem/${s}`),this.provider.set(s,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:u});const t=new D.DisposableStore;return t.add(u.onDidChangeFile(r=>this._onDidFilesChange.fire(new y.FileChangesEvent(r,!this.isPathCaseSensitive(u))))),t.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:s}))),typeof u.onDidErrorOccur=="function"&&t.add(u.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),D.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:u}),this.provider.delete(s),D.dispose(t)})}async activateProvider(s){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(t){t&&u.push(t)}}),!this.provider.has(s)&&await Promise.all(u)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,u){const t=this.provider.get(s.scheme);return!!(t&&t.capabilities&u)}listCapabilities(){return b.Iterable.map(this.provider,([s,u])=>({scheme:s,capabilities:u.capabilities}))}async withProvider(s){if(!n.isAbsolutePath(s))throw new y.FileOperationError(w.localize(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const u=this.provider.get(s.scheme);if(!u){const t=new Error;throw t.name="ENOPRO",t.message=w.localize(1,null,s.toString()),t}return u}async withReadProvider(s){const u=await this.withProvider(s);if(y.hasOpenReadWriteCloseCapability(u)||y.hasReadWriteCapability(u)||y.hasFileReadStreamCapability(u))return u;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const u=await this.withProvider(s);if(y.hasOpenReadWriteCloseCapability(u)||y.hasReadWriteCapability(u))return u;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,u){try{return await this.doResolveFile(s,u)}catch(t){throw y.toFileSystemProviderErrorCode(t)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError(w.localize(2,null,this.resourceForError(s)),1):y.ensureFileSystemProviderError(t)}}async doResolveFile(s,u){const t=await this.withProvider(s),r=this.isPathCaseSensitive(t),o=u==null?void 0:u.resolveTo,d=u==null?void 0:u.resolveSingleChildDescendants,c=u==null?void 0:u.resolveMetadata,g=await t.stat(s);let I;return this.toFileStat(t,s,g,void 0,!!c,(A,T)=>(I||(I=S.TernarySearchTree.forUris(()=>!r),I.set(s,!0),i.isNonEmptyArray(o)&&o.forEach(U=>I.set(U,!0))),Boolean(I.findSuperstr(A.resource)||I.get(A.resource))?!0:A.isDirectory&&d?T===1:!1))}async toFileStat(s,u,t,r,o,d){const{providerExtUri:c}=this.getExtUri(s),g={resource:u,name:c.basename(u),isFile:(t.type&y.FileType.File)!=0,isDirectory:(t.type&y.FileType.Directory)!=0,isSymbolicLink:(t.type&y.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:y.etag({mtime:t.mtime,size:t.size})};if(g.isDirectory&&d(g,r)){try{const I=await s.readdir(u),A=await Promise.all(I.map(async([T,U])=>{try{const j=c.joinPath(u,T),C=o?await s.stat(j):{type:U};return await this.toFileStat(s,j,C,I.length,o,d)}catch(j){return this.logService.trace(j),null}}));g.children=i.coalesce(A)}catch(I){this.logService.trace(I),g.children=[]}return g}return g}async resolveAll(s){return Promise.all(s.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(s){const u=await this.withProvider(s);try{return!!await u.stat(s)}catch(t){return!1}}async canCreateFile(s,u){try{await this.doValidateCreateFile(s,u)}catch(t){return t}return!0}async doValidateCreateFile(s,u){if(!(u==null?void 0:u.overwrite)&&await this.exists(s))throw new y.FileOperationError(w.localize(3,null,this.resourceForError(s)),3,u)}async createFile(s,u=m.VSBuffer.fromString(""),t){await this.doValidateCreateFile(s,t);const r=await this.writeFile(s,u);return this._onDidRunOperation.fire(new y.FileOperationEvent(s,0,r)),r}async writeFile(s,u,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:o}=this.getExtUri(r);try{await this.validateWriteFile(r,s,t)||await this.mkdirp(r,o.dirname(s));let c;if(y.hasReadWriteCapability(r)&&!(u instanceof m.VSBuffer))if(P.isReadableStream(u)){const g=await P.peekStream(u,3);g.ended?c=m.VSBuffer.concat(g.buffer):c=g}else c=P.peekReadable(u,g=>m.VSBuffer.concat(g),3);else c=u;!y.hasOpenReadWriteCloseCapability(r)||y.hasReadWriteCapability(r)&&c instanceof m.VSBuffer?await this.doWriteUnbuffered(r,s,c):await this.doWriteBuffered(r,s,c instanceof m.VSBuffer?m.bufferToReadable(c):c)}catch(d){throw new y.FileOperationError(w.localize(4,null,this.resourceForError(s),y.ensureFileSystemProviderError(d).toString()),y.toFileOperationResult(d),t)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,u,t){let r;try{r=await s.stat(u)}catch(o){return}if((r.type&y.FileType.Directory)!=0)throw new y.FileOperationError(w.localize(5,null,this.resourceForError(u)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==y.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==y.etag({mtime:t.mtime,size:r.size}))throw new y.FileOperationError(w.localize(6,null),3,t);return r}async readFile(s,u){const t=await this.withReadProvider(s),r=await this.doReadAsFileStream(t,s,Object.assign(Object.assign({},u),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await m.streamToBuffer(r.value)})}async readFileStream(s,u){const t=await this.withReadProvider(s);return this.doReadAsFileStream(t,s,u)}async doReadAsFileStream(s,u,t){const r=new h.CancellationTokenSource,o=this.validateReadFile(u,t).then(c=>c,c=>{throw r.cancel(),c});let d;try{t&&typeof t.etag=="string"&&t.etag!==y.ETAG_DISABLED&&await o;let c;!(y.hasOpenReadWriteCloseCapability(s)||y.hasFileReadStreamCapability(s))||y.hasReadWriteCapability(s)&&(t==null?void 0:t.preferUnbuffered)?c=this.readFileUnbuffered(s,u,t):y.hasFileReadStreamCapability(s)?c=this.readFileStreamed(s,u,r.token,t):c=this.readFileBuffered(s,u,r.token,t),d=P.observe(c);const g=await o;return Object.assign(Object.assign({},g),{value:c})}catch(c){throw d&&await d.errorOrEnd(),new y.FileOperationError(w.localize(7,null,this.resourceForError(u),y.ensureFileSystemProviderError(c).toString()),y.toFileOperationResult(c),t)}}readFileStreamed(s,u,t,r=Object.create(null)){const o=s.readFileStream(u,r,t);return P.transform(o,{data:d=>d instanceof m.VSBuffer?d:m.VSBuffer.wrap(d),error:d=>new y.FileOperationError(w.localize(8,null,this.resourceForError(u),y.ensureFileSystemProviderError(d).toString()),y.toFileOperationResult(d),r)},d=>m.VSBuffer.concat(d))}readFileBuffered(s,u,t,r=Object.create(null)){const o=m.newWriteableBufferStream();return p.readFileIntoStream(s,u,o,d=>d,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:d=>new y.FileOperationError(w.localize(9,null,this.resourceForError(u),y.ensureFileSystemProviderError(d).toString()),y.toFileOperationResult(d),r)}),t),o}readFileUnbuffered(s,u,t){const r=P.newWriteableStream(o=>m.VSBuffer.concat(o));return(async()=>{try{let o=await s.readFile(u);t&&typeof t.position=="number"&&(o=o.slice(t.position)),t&&typeof t.length=="number"&&(o=o.slice(0,t.length)),this.validateReadFileLimits(u,o.byteLength,t),r.end(m.VSBuffer.wrap(o))}catch(o){r.error(o)}})(),r}async validateReadFile(s,u){const t=await this.resolve(s,{resolveMetadata:!0});if(t.isDirectory)throw new y.FileOperationError(w.localize(10,null,this.resourceForError(s)),0,u);if(u&&typeof u.etag=="string"&&u.etag!==y.ETAG_DISABLED&&u.etag===t.etag)throw new y.FileOperationError(w.localize(11,null),2,u);return this.validateReadFileLimits(s,t.size,u),t}validateReadFileLimits(s,u,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&u>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&u>t.limits.size&&(r=7),typeof r=="number")throw new y.FileOperationError(w.localize(12,null,this.resourceForError(s)),r)}}async canMove(s,u,t){return this.doCanMoveCopy(s,u,"move",t)}async canCopy(s,u,t){return this.doCanMoveCopy(s,u,"copy",t)}async doCanMoveCopy(s,u,t,r){if(s.toString()!==u.toString())try{const o=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),d=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(o,s,d,u,t,r)}catch(o){return o}return!0}async move(s,u,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),d=await this.doMoveCopy(r,s,o,u,"move",!!t),c=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,d==="move"?2:3,c)),c}async copy(s,u,t){const r=await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),d=await this.doMoveCopy(r,s,o,u,"copy",!!t),c=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,d==="copy"?3:2,c)),c}async doMoveCopy(s,u,t,r,o,d){if(u.toString()===r.toString())return o;const{exists:c,isSameResourceWithDifferentPathCase:g}=await this.doValidateMoveCopy(s,u,t,r,o,d);if(c&&!g&&d&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),o==="copy"){if(s===t&&y.hasFileFolderCopyCapability(s))await s.copy(u,r,{overwrite:d});else{const I=await this.resolve(u);I.isDirectory?await this.doCopyFolder(s,I,t,r):await this.doCopyFile(s,u,t,r)}return o}else return s===t?(await s.rename(u,r,{overwrite:d}),o):(await this.doMoveCopy(s,u,t,r,"copy",d),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(s,u,t,r){if(y.hasOpenReadWriteCloseCapability(s)&&y.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(s,u,t,r);if(y.hasOpenReadWriteCloseCapability(s)&&y.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(s,u,t,r);if(y.hasReadWriteCapability(s)&&y.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(s,u,t,r);if(y.hasReadWriteCapability(s)&&y.hasReadWriteCapability(t))return this.doPipeUnbuffered(s,u,t,r)}async doCopyFolder(s,u,t,r){await t.mkdir(r),Array.isArray(u.children)&&await Promise.all(u.children.map(async o=>{const d=this.getExtUri(t).providerExtUri.joinPath(r,o.name);return o.isDirectory?this.doCopyFolder(s,await this.resolve(o.resource),t,d):this.doCopyFile(s,o.resource,t,d)}))}async doValidateMoveCopy(s,u,t,r,o,d){let c=!1;if(s===t){const{providerExtUri:I,isPathCaseSensitive:A}=this.getExtUri(s);if(A||(c=I.isEqual(u,r)),c&&o==="copy")throw new Error(w.localize(13,null,this.resourceForError(u),this.resourceForError(r)));if(!c&&I.isEqualOrParent(r,u))throw new Error(w.localize(14,null,this.resourceForError(u),this.resourceForError(r)))}const g=await this.exists(r);if(g&&!c){if(!d)throw new y.FileOperationError(w.localize(15,null,this.resourceForError(u),this.resourceForError(r)),4);if(s===t){const{providerExtUri:I}=this.getExtUri(s);if(I.isEqualOrParent(u,r))throw new Error(w.localize(16,null,this.resourceForError(u),this.resourceForError(r)))}}return{exists:g,isSameResourceWithDifferentPathCase:c}}getExtUri(s){const u=this.isPathCaseSensitive(s);return{providerExtUri:u?n.extUri:n.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(u,s);const t=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,0,t)),t}async mkdirp(s,u){const t=[],{providerExtUri:r}=this.getExtUri(s);for(;!r.isEqual(u,r.dirname(u));)try{if(((await s.stat(u)).type&y.FileType.Directory)==0)throw new Error(w.localize(17,null,this.resourceForError(u)));break}catch(o){if(y.toFileSystemProviderErrorCode(o)!==y.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(r.basename(u)),u=r.dirname(u)}for(let o=t.length-1;o>=0;o--){u=r.joinPath(u,t[o]);try{await s.mkdir(u)}catch(d){if(y.toFileSystemProviderErrorCode(d)!==y.FileSystemProviderErrorCode.FileExists)throw d}}}async canDelete(s,u){try{await this.doValidateDelete(s,u)}catch(t){return t}return!0}async doValidateDelete(s,u){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!(u==null?void 0:u.useTrash)&&!(t.capabilities&4096))throw new Error(w.localize(18,null,this.resourceForError(s)));const o=await this.exists(s);if(!o)throw new y.FileOperationError(w.localize(19,null,this.resourceForError(s)),1);if(!!!(u==null?void 0:u.recursive)&&o){const c=await this.resolve(s);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error(w.localize(20,null,this.resourceForError(s)))}return t}async del(s,u){const t=await this.doValidateDelete(s,u),r=!!(u==null?void 0:u.useTrash),o=!!(u==null?void 0:u.recursive);await t.delete(s,{recursive:o,useTrash:r}),this._onDidRunOperation.fire(new y.FileOperationEvent(s,1))}watch(s,u={recursive:!1,excludes:[]}){let t=!1,r=()=>{t=!0};return this.doWatch(s,u).then(o=>{t?D.dispose(o):r=()=>D.dispose(o)},o=>this.logService.error(o)),D.toDisposable(()=>r())}async doWatch(s,u){const t=await this.withProvider(s),r=this.toWatchKey(t,s,u),o=this.activeWatchers.get(r)||{count:0,disposable:t.watch(s,u)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,o),o.count+=1,D.toDisposable(()=>{o.count--,o.count===0&&(D.dispose(o.disposable),this.activeWatchers.delete(r))})}toWatchKey(s,u,t){const{providerExtUri:r}=this.getExtUri(s);return[r.getComparisonKey(u),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(s=>D.dispose(s.disposable)),this.activeWatchers.clear()}ensureWriteQueue(s,u){const{providerExtUri:t}=this.getExtUri(s),r=t.getComparisonKey(u);let o=this.writeQueues.get(r);return o||(o=new f.Queue,this.writeQueues.set(r,o),M.Event.once(o.onFinished)(()=>{this.writeQueues.delete(r),D.dispose(o)})),o}async doWriteBuffered(s,u,t){return this.ensureWriteQueue(s,u).queue(async()=>{const r=await s.open(u,{create:!0});try{P.isReadableStream(t)||P.isReadableBufferedStream(t)?await this.doWriteStreamBufferedQueued(s,r,t):await this.doWriteReadableBufferedQueued(s,r,t)}catch(o){throw y.ensureFileSystemProviderError(o)}finally{await s.close(r)}})}async doWriteStreamBufferedQueued(s,u,t){let r=0,o;if(P.isReadableBufferedStream(t)){if(t.buffer.length>0){const d=m.VSBuffer.concat(t.buffer);await this.doWriteBuffer(s,u,d,d.byteLength,r,0),r+=d.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise(async(d,c)=>{o.on("data",async g=>{o.pause();try{await this.doWriteBuffer(s,u,g,g.byteLength,r,0)}catch(I){return c(I)}r+=g.byteLength,setTimeout(()=>o.resume())}),o.on("error",g=>c(g)),o.on("end",()=>d())})}async doWriteReadableBufferedQueued(s,u,t){let r=0,o;for(;(o=t.read())!==null;)await this.doWriteBuffer(s,u,o,o.byteLength,r,0),r+=o.byteLength}async doWriteBuffer(s,u,t,r,o,d){let c=0;for(;c<r;)c+=await s.write(u,o+c,t.buffer,d+c,r-c)}async doWriteUnbuffered(s,u,t){return this.ensureWriteQueue(s,u).queue(()=>this.doWriteUnbufferedQueued(s,u,t))}async doWriteUnbufferedQueued(s,u,t){let r;t instanceof m.VSBuffer?r=t:P.isReadableStream(t)?r=await m.streamToBuffer(t):P.isReadableBufferedStream(t)?r=await m.bufferedStreamToBuffer(t):r=m.readableToBuffer(t),await s.writeFile(u,r.buffer,{create:!0,overwrite:!0})}async doPipeBuffered(s,u,t,r){return this.ensureWriteQueue(t,r).queue(()=>this.doPipeBufferedQueued(s,u,t,r))}async doPipeBufferedQueued(s,u,t,r){let o,d;try{o=await s.open(u,{create:!1}),d=await t.open(r,{create:!0});const c=m.VSBuffer.alloc(this.BUFFER_SIZE);let g=0,I=0,A=0;do A=await s.read(o,g,c.buffer,I,c.byteLength-I),await this.doWriteBuffer(t,d,c,A,g,I),g+=A,I+=A,I===c.byteLength&&(I=0);while(A>0)}catch(c){throw y.ensureFileSystemProviderError(c)}finally{await Promise.all([typeof o=="number"?s.close(o):Promise.resolve(),typeof d=="number"?t.close(d):Promise.resolve()])}}async doPipeUnbuffered(s,u,t,r){return this.ensureWriteQueue(t,r).queue(()=>this.doPipeUnbufferedQueued(s,u,t,r))}async doPipeUnbufferedQueued(s,u,t,r){return t.writeFile(r,await s.readFile(u),{create:!0,overwrite:!0})}async doPipeUnbufferedToBuffered(s,u,t,r){return this.ensureWriteQueue(t,r).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,u,t,r))}async doPipeUnbufferedToBufferedQueued(s,u,t,r){const o=await t.open(r,{create:!0});try{const d=await s.readFile(u);await this.doWriteBuffer(t,o,m.VSBuffer.wrap(d),d.byteLength,0,0)}catch(d){throw y.ensureFileSystemProviderError(d)}finally{await t.close(o)}}async doPipeBufferedToUnbuffered(s,u,t,r){const o=await m.streamToBuffer(this.readFileBuffered(s,u,h.CancellationToken.None));await this.doWriteUnbuffered(t,r,o)}throwIfFileSystemIsReadonly(s,u){if(s.capabilities&2048)throw new y.FileOperationError(w.localize(21,null,this.resourceForError(u)),6);return s}resourceForError(s){return s.scheme===v.Schemas.file?s.fsPath:s.toString(!0)}};l=de([re(0,E.ILogService)],l),e.FileService=l}),define(Q[173],J([0,1,25,67,2,21,4,3,26,6,18,28,9,8,140,86,154,156,153,164,64,85,32,20]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h,v,p,b,l,a,s,u,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class o extends D.Disposable{constructor(c,g){var I;super();this.logService=c,this.options=g,this.BUFFER_SIZE=((I=this.options)===null||I===void 0?void 0:I.bufferSize)||64*1024,this.onDidChangeCapabilities=M.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Set,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new P.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8,n.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(c){try{const{stat:g,symbolicLink:I}=await S.statLink(this.toFilePath(c));return{type:this.toType(g,I),ctime:g.birthtime.getTime(),mtime:g.mtime.getTime(),size:g.size}}catch(g){throw this.toFileSystemProviderError(g)}}async readdir(c){try{const g=await S.readdirWithFileTypes(this.toFilePath(c)),I=[];return await Promise.all(g.map(async A=>{try{let T;A.isSymbolicLink()?T=(await this.stat(E.joinPath(c,A.name))).type:T=this.toType(A),I.push([A.name,T])}catch(T){this.logService.trace(T)}})),I}catch(g){throw this.toFileSystemProviderError(g)}}toType(c,g){let I;return(g==null?void 0:g.dangling)?I=y.FileType.Unknown:c.isFile()?I=y.FileType.File:c.isDirectory()?I=y.FileType.Directory:I=y.FileType.Unknown,g&&(I|=y.FileType.SymbolicLink),I}async readFile(c){try{const g=this.toFilePath(c);return await S.readFile(g)}catch(g){throw this.toFileSystemProviderError(g)}}readFileStream(c,g,I){const A=s.newWriteableStream(T=>r.VSBuffer.concat(T.map(U=>r.VSBuffer.wrap(U))).buffer);return u.readFileIntoStream(this,c,A,T=>T.buffer,Object.assign(Object.assign({},g),{bufferSize:this.BUFFER_SIZE}),I),A}async writeFile(c,g,I){let A;try{const T=this.toFilePath(c);if(!I.create||!I.overwrite){if(await S.exists(T)){if(!I.overwrite)throw y.createFileSystemProviderError(h.localize(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!I.create)throw y.createFileSystemProviderError(h.localize(1,null),y.FileSystemProviderErrorCode.FileNotFound)}A=await this.open(c,{create:!0}),await this.write(A,0,g,0,g.byteLength)}catch(T){throw this.toFileSystemProviderError(T)}finally{typeof A=="number"&&await this.close(A)}}async open(c,g){try{const I=this.toFilePath(c);let A;if(g.create){if(n.isWindows&&await S.exists(I))try{await S.truncate(I,0),A="r+"}catch(U){this.logService.trace(U)}A||(A="w")}else A="r";const T=await R.promisify(w.open)(I,A);return this.mapHandleToPos.set(T,0),g.create&&this.writeHandles.add(T),T}catch(I){throw this.toFileSystemProviderError(I)}}async close(c){try{if(this.mapHandleToPos.delete(c),this.writeHandles.delete(c)&&this.canFlush)try{await R.promisify(w.fdatasync)(c)}catch(g){this.canFlush=!1,this.logService.error(g)}return await R.promisify(w.close)(c)}catch(g){throw this.toFileSystemProviderError(g)}}async read(c,g,I,A,T){const U=this.normalizePos(c,g);let j=null;try{const C=await R.promisify(w.read)(c,I,A,T,U);return typeof C=="number"?j=C:j=C.bytesRead,j}catch(C){throw this.toFileSystemProviderError(C)}finally{this.updatePos(c,U,j)}}normalizePos(c,g){return g===this.mapHandleToPos.get(c)?null:g}updatePos(c,g,I){const A=this.mapHandleToPos.get(c);typeof A=="number"&&(typeof g=="number"||(typeof I=="number"?this.mapHandleToPos.set(c,A+I):this.mapHandleToPos.delete(c)))}async write(c,g,I,A,T){return P.retry(()=>this.doWrite(c,g,I,A,T),100,3)}async doWrite(c,g,I,A,T){const U=this.normalizePos(c,g);let j=null;try{const C=await R.promisify(w.write)(c,I,A,T,U);return typeof C=="number"?j=C:j=C.bytesWritten,j}catch(C){throw this.toFileSystemProviderError(C)}finally{this.updatePos(c,U,j)}}async mkdir(c){try{await R.promisify(w.mkdir)(this.toFilePath(c))}catch(g){throw this.toFileSystemProviderError(g)}}async delete(c,g){try{const I=this.toFilePath(c);await this.doDelete(I,g)}catch(I){throw this.toFileSystemProviderError(I)}}async doDelete(c,g){g.recursive?await S.rimraf(c,S.RimRafMode.MOVE):await S.unlink(c)}async rename(c,g,I){const A=this.toFilePath(c),T=this.toFilePath(g);if(A!==T)try{await this.validateTargetDeleted(c,g,"move",I.overwrite),await S.move(A,T)}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error(h.localize(2,null,i.basename(A),i.basename(i.dirname(T)),U.toString()))),this.toFileSystemProviderError(U)}}async copy(c,g,I){const A=this.toFilePath(c),T=this.toFilePath(g);if(A!==T)try{await this.validateTargetDeleted(c,g,"copy",I.overwrite),await S.copy(A,T)}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error(h.localize(3,null,i.basename(A),i.basename(i.dirname(T)),U.toString()))),this.toFileSystemProviderError(U)}}async validateTargetDeleted(c,g,I,A){const T=this.toFilePath(c),U=this.toFilePath(g);let j=!1;if(!!(this.capabilities&1024)||(j=m.isEqual(T,U,!0)),j&&I==="copy")throw y.createFileSystemProviderError(h.localize(4,null),y.FileSystemProviderErrorCode.FileExists);if(!j&&await S.exists(U)){if(!A)throw y.createFileSystemProviderError(h.localize(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(g,{recursive:!0,useTrash:!1})}}watch(c,g){return g.recursive?this.watchRecursive(c,g.excludes):this.watchNonRecursive(c)}watchRecursive(c,g){const I={path:this.toFilePath(c),excludes:g},A=t.insert(this.recursiveFoldersToWatch,I);return this.refreshRecursiveWatchers(),D.toDisposable(()=>{A(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var c,g,I;if(this.recursiveWatcher instanceof l.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(D.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let A,T;((g=(c=this.options)===null||c===void 0?void 0:c.watcher)===null||g===void 0?void 0:g.usePolling)?(A=p.FileWatcher,T=(I=this.options)===null||I===void 0?void 0:I.watcher):this.recursiveFoldersToWatch.length===1?n.isWindows?A=b.FileWatcher:A=p.FileWatcher:A=l.FileWatcher,this.recursiveWatcher=new A(this.recursiveFoldersToWatch,U=>this._onDidChangeFile.fire(v.toFileChanges(U)),U=>{U.type==="error"&&this._onDidWatchErrorOccur.fire(U.message),this.logService[U.type](U.message)},this.logService.getLevel()===f.LogLevel.Trace,T),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))}}watchNonRecursive(c){const g=new a.FileWatcher(this.toFilePath(c),A=>this._onDidChangeFile.fire(v.toFileChanges(A)),A=>{A.type==="error"&&this._onDidWatchErrorOccur.fire(A.message),this.logService[A.type](A.message)},this.logService.getLevel()===f.LogLevel.Trace),I=this.logService.onDidChangeLogLevel(()=>{g.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)});return D.combinedDisposable(g,I)}toFilePath(c){return i.normalize(c.fsPath)}toFileSystemProviderError(c){if(c instanceof y.FileSystemProviderError)return c;let g;switch(c.code){case"ENOENT":g=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":g=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":g=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":g=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":g=y.FileSystemProviderErrorCode.NoPermissions;break;default:g=y.FileSystemProviderErrorCode.Unknown}return y.createFileSystemProviderError(c,g)}dispose(){super.dispose(),D.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,D.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=o}),define(Q[174],J([0,1,8]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function R(y,M){switch(M){case w.LogLevel.Trace:return y.trace;case w.LogLevel.Debug:return y.debug;case w.LogLevel.Info:return y.info;case w.LogLevel.Warning:return y.warn;case w.LogLevel.Error:return y.error;case w.LogLevel.Critical:return y.critical;default:throw new Error("Invalid log level")}}class D extends w.AbstractLogService{constructor(M=w.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(M){this._logger=M;for(const{level:n,args:S}of this.buffer)R(M,n).apply(M,S);this.buffer=[]}_log(M,...n){this._logger?R(this._logger,M).apply(this._logger,n):this.getLevel()<=M&&this.buffer.push({level:M,args:n})}trace(M,...n){this._log(w.LogLevel.Trace,M,...n)}debug(M,...n){this._log(w.LogLevel.Debug,M,...n)}info(M,...n){this._log(w.LogLevel.Info,M,...n)}warn(M,...n){this._log(w.LogLevel.Warning,M,...n)}error(M,...n){this._log(w.LogLevel.Error,M,...n)}critical(M,...n){this._log(w.LogLevel.Critical,M,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(Q[175],J([0,1,8,4]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=void 0;class D{constructor(S){this.service=S,this.onDidChangeLogLevel=R.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,i){switch(i){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${i}`)}call(S,i,E){switch(i){case"setLevel":return this.service.setLevel(E),Promise.resolve();case"consoleLog":return this.consoleLog(E[0],E[1]),Promise.resolve()}throw new Error(`Call not found: ${i}`)}consoleLog(S,i){let E=console.log;switch(S){case"error":E=console.error;break;case"warn":E=console.warn;break;case"info":E=console.info;break}E.call(console,...i)}}e.LoggerChannel=D;class y{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S){y.setLevel(this.channel,S)}static setLevel(S,i){return S.call("setLevel",i)}consoleLog(S,i){this.channel.call("consoleLog",[S,i])}}e.LoggerChannelClient=y;class M extends w.DelegatedLogService{constructor(S,i){super(i);this.parent=S,this._register(S.onDidChangeLogLevel(E=>i.setLevel(E)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=M}),define(Q[176],J([0,1,6,8,21]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogService=e.createRotatingLogger=void 0;async function y(i,E){try{const m=await new Promise((f,h)=>{$(["spdlog"],f,h)});m.setAsyncMode(8192,500);const P=w.join(E,`${i}.log`);return m.createRotatingLoggerAsync(i,P,5*D.ByteSize.MB,6)}catch(m){console.error(m)}return null}function M(i,E,m,P){return $.__$__nodeRequire("spdlog").createRotatingLogger(i,E,m,P)}e.createRotatingLogger=M;function n(i,E,m){switch(E){case R.LogLevel.Trace:i.trace(m);break;case R.LogLevel.Debug:i.debug(m);break;case R.LogLevel.Info:i.info(m);break;case R.LogLevel.Warning:i.warn(m);break;case R.LogLevel.Error:i.error(m);break;case R.LogLevel.Critical:i.critical(m);break;default:throw new Error("Invalid log level")}}class S extends R.AbstractLogService{constructor(E,m,P){super();this.name=E,this.logsFolder=m,this.buffer=[],this._loggerCreationPromise=void 0,this.setLevel(P),this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(f=>{this._logger&&this._logger.setLevel(f)}))}_createSpdLogLogger(){return this._loggerCreationPromise||(this._loggerCreationPromise=y(this.name,this.logsFolder).then(E=>{if(E){this._logger=E,this._logger.setLevel(this.getLevel());for(const{level:m,message:P}of this.buffer)n(this._logger,m,P);this.buffer=[]}})),this._loggerCreationPromise}_log(E,m){this._logger?n(this._logger,E,m):this.getLevel()<=E&&this.buffer.push({level:E,message:m})}trace(E,...m){this.getLevel()<=R.LogLevel.Trace&&this._log(R.LogLevel.Trace,this.format([E,...m]))}debug(E,...m){this.getLevel()<=R.LogLevel.Debug&&this._log(R.LogLevel.Debug,this.format([E,...m]))}info(E,...m){this.getLevel()<=R.LogLevel.Info&&this._log(R.LogLevel.Info,this.format([E,...m]))}warn(E,...m){this.getLevel()<=R.LogLevel.Warning&&this._log(R.LogLevel.Warning,this.format([E,...m]))}error(E,...m){if(this.getLevel()<=R.LogLevel.Error)if(E instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=E.stack,this._log(R.LogLevel.Error,this.format(P))}else this._log(R.LogLevel.Error,this.format([E,...m]))}critical(E,...m){this.getLevel()<=R.LogLevel.Critical&&this._log(R.LogLevel.Critical,this.format([E,...m]))}flush(){this._logger?this._logger.flush():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.disposeLogger()),this._loggerCreationPromise=void 0}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}format(E){let m="";for(let P=0;P<E.length;P++){let f=E[P];if(typeof f=="object")try{f=JSON.stringify(f)}catch(h){}m+=(P>0?" ":"")+f}return m}}e.SpdLogService=S}),define(Q[177],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemUriAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function w(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=w;function R(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=R;function D(M){return M.uri!==void 0}e.isMenubarMenuItemUriAction=D;function y(M){return!w(M)&&!R(M)&&!D(M)}e.isMenubarMenuItemAction=y}),define(Q[15],J([0,1,3,52,10,18]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(w.isWeb||typeof $=="undefined"||typeof $.__$__nodeRequire!="function")M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.53.0-dev",nameShort:w.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:w.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/master/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser"]});else{const n=y.dirname(D.FileAccess.asFileUri("",$));M=$.__$__nodeRequire(y.joinPath(n,"product.json").fsPath);const S=$.__$__nodeRequire(y.joinPath(n,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`}),Object.assign(M,{version:S.version})}e.default=M}),define(Q[60],J([0,1,5]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=w.createDecorator("productService")}),define(Q[178],J([0,1,57,8,60]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let y=class{constructor(n,S){this.productService=n,this.logService=S,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,S){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const i=/^(.*)#([^#]+)$/.exec(S);if(!i)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",S),!1;const[,E,m]=i;let P=this.trustedExtensionUrlPublicKeys.get(n);if(!P){if(P=this.productService.trustedExtensionUrlPublicKeys[n],!P||P.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...P])}const f=Buffer.from(decodeURIComponent(m),"base64");if(f.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",S),!1;const h=f.slice(0,6),v=f.readUIntBE(0,6),p=Date.now()-v;if(p<0||p>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",S),!1;const b=f.slice(6),l=w.createVerify("SHA256");l.write(h),l.write(Buffer.from(E)),l.end();for(let a=0;a<P.length;a++){let s=P[a];if(s!==null){if(typeof s=="string")try{s=w.createPublicKey({key:Buffer.from(s,"base64"),format:"der",type:"spki"}),P[a]=s}catch(u){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${a+1} for ${n}:`,u),P[a]=null;continue}if(l.verify(s,b))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",S),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",S),!1}};y=de([re(0,D.IProductService),re(1,R.ILogService)],y),e.ExtensionUrlTrustService=y}),define(Q[36],J([0,1,14,97]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(M,n){R.ok(w.isString(M)),R.ok(w.isObject(n)),R.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,n)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new D}),define(Q[179],J([0,1,36,4]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class y{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,i){this.schemasById[D(S)]=i,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new y;w.Registry.add(e.Extensions.JSONContribution,M)}),define(Q[46],J([0,1,131,4,36,14,179]),function($,e,w,R,D,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var n;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(n=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const S=D.Registry.as(M.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:w.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,l=!0){this.registerConfigurations([b],l)}registerConfigurations(b,l=!0){const a=[];b.forEach(s=>{a.push(...this.validateAndRegisterProperties(s,l)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(b){const l=[],a=s=>{if(s.properties)for(const u in s.properties)l.push(u),delete this.configurationProperties[u],this.removeFromSchema(u,s.properties[u]);s.allOf&&s.allOf.forEach(u=>a(u))};for(const s of b){a(s);const u=this.configurationContributors.indexOf(s);u!==-1&&this.configurationContributors.splice(u,1)}S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}registerDefaultConfigurations(b){const l=[],a=[];for(const s of b)for(const u in s)if(l.push(u),e.OVERRIDE_PROPERTY_PATTERN.test(u)){this.defaultValues[u]=Object.assign(Object.assign({},this.defaultValues[u]||{}),s[u]);const t={type:"object",default:this.defaultValues[u],description:w.localize(1,null,u),$ref:e.resourceLanguageSettingsSchemaId};a.push(m(u)),this.configurationProperties[u]=t,this.defaultLanguageConfigurationOverridesNode.properties[u]=t}else{this.defaultValues[u]=s[u];const t=this.configurationProperties[u];t&&(this.updatePropertyDefaultValue(u,t),this.updateSchema(u,t))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterDefaultConfigurations(b){const l=[];for(const a of b)for(const s in a)if(l.push(s),delete this.defaultValues[s],e.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const u=this.configurationProperties[s];u&&(this.updatePropertyDefaultValue(s,u),this.updateSchema(s,u))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const l of b)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,l=!0,a=3){a=y.isUndefinedOrNull(b.scope)?a:b.scope;let s=[],u=b.properties;if(u)for(let r in u){if(l&&h(r)){delete u[r];continue}const o=u[r];if(this.updatePropertyDefaultValue(r,o),e.OVERRIDE_PROPERTY_PATTERN.test(r)?o.scope=void 0:o.scope=y.isUndefinedOrNull(o.scope)?a:o.scope,u[r].hasOwnProperty("included")&&!u[r].included){this.excludedConfigurationProperties[r]=u[r],delete u[r];continue}else this.configurationProperties[r]=u[r];!u[r].deprecationMessage&&u[r].markdownDeprecationMessage&&(u[r].deprecationMessage=u[r].markdownDeprecationMessage),s.push(r)}let t=b.allOf;if(t)for(let r of t)s.push(...this.validateAndRegisterProperties(r,l,a));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const l=a=>{let s=a.properties;if(s)for(const t in s)this.updateSchema(t,s[t]);let u=a.allOf;u&&u.forEach(l)};l(b)}updateSchema(b,l){switch(e.allSettings.properties[b]=l,l.scope){case 1:e.applicationSettings.properties[b]=l;break;case 2:e.machineSettings.properties[b]=l;break;case 6:e.machineOverridableSettings.properties[b]=l;break;case 3:e.windowSettings.properties[b]=l;break;case 4:e.resourceSettings.properties[b]=l;break;case 5:e.resourceSettings.properties[b]=l,this.resourceLanguageSettingsSchema.properties[b]=l;break}}removeFromSchema(b,l){switch(delete e.allSettings.properties[b],l.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const l=`[${b}]`,a={type:"object",description:w.localize(2,null),errorMessage:w.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,a),e.allSettings.properties[l]=a,e.applicationSettings.properties[l]=a,e.machineSettings.properties[l]=a,e.machineOverridableSettings.properties[l]=a,e.windowSettings.properties[l]=a,e.resourceSettings.properties[l]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,l){let a=this.defaultValues[b];y.isUndefined(a)&&(a=l.default),y.isUndefined(a)&&(a=P(l.type)),l.default=a}}const E="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(E);function m(p){return p.substring(1,p.length-1)}e.overrideIdentifierFromKey=m;function P(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=P;const f=new i;D.Registry.add(e.Extensions.Configuration,f);function h(p){return p.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(p)?w.localize(5,null,p):f.getConfigurationProperties()[p]!==void 0?w.localize(6,null,p):null:w.localize(4,null)}e.validateProperty=h;function v(){const p=[],b=f.getConfigurationProperties();for(const l of Object.keys(b))p.push([l,b[l].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=v}),define(Q[19],J([0,1,41,14,7,36,5,46]),function($,e,w,R,D,y,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=M.createDecorator("configurationService");function S(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof D.URI)}e.isConfigurationOverrides=S;var i;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(i=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=E;function m(r,o){const d=o?r?o.keys.filter(j=>r.keys.indexOf(j)===-1):[...o.keys]:[],c=r?o?r.keys.filter(j=>o.keys.indexOf(j)===-1):[...r.keys]:[],g=[];if(o&&r){for(const j of r.keys)if(o.keys.indexOf(j)!==-1){const C=b(r.contents,j),x=b(o.contents,j);w.equals(C,x)||g.push(j)}}const I=[],A=j=>{const C={};for(const x of j)for(const ee of x.identifiers)C[u(ee)]=x;return C},T=o?A(o.overrides):{},U=r?A(r.overrides):{};if(Object.keys(T).length)for(const j of d){const C=T[j];C&&I.push([n.overrideIdentifierFromKey(j),C.keys])}if(Object.keys(U).length)for(const j of c){const C=U[j];C&&I.push([n.overrideIdentifierFromKey(j),C.keys])}if(Object.keys(T).length&&Object.keys(U).length)for(const j of g){const C=U[j],x=T[j];if(C&&x){const ee=m({contents:C.contents,keys:C.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});I.push([n.overrideIdentifierFromKey(j),[...ee.added,...ee.removed,...ee.updated]])}}return{added:d,removed:c,updated:g,overrides:I}}e.compare=m;function P(r,o){const d=[];for(const c of Object.keys(r))if(n.OVERRIDE_PROPERTY_PATTERN.test(c)){const g={};for(const I in r[c])g[I]=r[c][I];d.push({identifiers:[n.overrideIdentifierFromKey(c).trim()],keys:Object.keys(g),contents:f(g,o)})}return d}e.toOverrides=P;function f(r,o){const d=Object.create(null);for(let c in r)h(d,c,r[c],o);return d}e.toValuesTree=f;function h(r,o,d,c){const g=o.split("."),I=g.pop();let A=r;for(let T=0;T<g.length;T++){let U=g[T],j=A[U];switch(typeof j){case"undefined":j=A[U]=Object.create(null);break;case"object":break;default:c(`Ignoring ${o} as ${g.slice(0,T+1).join(".")} is ${JSON.stringify(j)}`);return}A=j}if(typeof A=="object"&&A!==null)try{A[I]=d}catch(T){c(`Ignoring ${o} as ${g.join(".")} is ${JSON.stringify(A)}`)}else c(`Ignoring ${o} as ${g.join(".")} is ${JSON.stringify(A)}`)}e.addToValueTree=h;function v(r,o){const d=o.split(".");p(r,d)}e.removeFromValueTree=v;function p(r,o){const d=o.shift();if(o.length===0){delete r[d];return}if(Object.keys(r).indexOf(d)!==-1){const c=r[d];typeof c=="object"&&!Array.isArray(c)&&(p(c,o),Object.keys(c).length===0&&delete r[d])}}function b(r,o,d){function c(A,T){let U=A;for(const j of T){if(typeof U!="object"||U===null)return;U=U[j]}return U}const g=o.split("."),I=c(r,g);return typeof I=="undefined"?d:I}e.getConfigurationValue=b;function l(r,o,d){Object.keys(o).forEach(c=>{c!=="__proto__"&&(c in r?R.isObject(r[c])&&R.isObject(o[c])?l(r[c],o[c],d):d&&(r[c]=o[c]):r[c]=o[c])})}e.merge=l;function a(){const r=y.Registry.as(n.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=a;function s(){const r=Object.create(null),o=y.Registry.as(n.Extensions.Configuration).getConfigurationProperties();for(let d in o){let c=o[d].default;h(r,d,c,g=>console.error(`Conflict in default settings: ${g}`))}return r}e.getDefaultValues=s;function u(r){return`[${r}]`}e.keyFromOverrideIdentifier=u;function t(r,o,d){const c=r.inspect(o),g=r.inspect(d);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:c.defaultValue}e.getMigratedSettingValue=t}),define(Q[180],J([0,1,40,35,32,14,41,7,46,19,36,2,4]),function($,e,w,R,D,y,M,n,S,i,E,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},r=[],o=[]){this._contents=t,this._keys=r,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?i.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const o=this.getContentsForOverrideIdentifer(r);return o?t?i.getConfigurationValue(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let o={};for(const d of D.distinct([...Object.keys(this.contents),...Object.keys(r)])){let c=this.contents[d],g=r[d];g&&(typeof c=="object"&&typeof g=="object"?(c=M.deepClone(c),this.mergeContents(c,g)):c=g),o[d]=c}return new f(o,this.keys,this.overrides)}merge(...t){const r=M.deepClone(this.contents),o=M.deepClone(this.overrides),d=[...this.keys];for(const c of t){this.mergeContents(r,c.contents);for(const g of c.overrides){const[I]=o.filter(A=>D.equals(A.identifiers,g.identifiers));I?this.mergeContents(I.contents,g.contents):o.push(M.deepClone(g))}for(const g of c.keys)d.indexOf(g)===-1&&d.push(g)}return new f(r,d,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const o of Object.keys(r)){if(o in t&&y.isObject(t[o])&&y.isObject(r[o])){this.mergeContents(t[o],r[o]);continue}t[o]=M.deepClone(r[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?M.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),i.addToValueTree(this.contents,t,r,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&i.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let o=0;o<r;o++)t.indexOf(this.keys[o])===0&&(r=o);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=f;class h extends f{constructor(){const t=i.getDefaultValues(),r=i.getConfigurationKeys(),o=[];for(const d of Object.keys(t))S.OVERRIDE_PROPERTY_PATTERN.test(d)&&o.push({identifiers:[S.overrideIdentifierFromKey(d).trim()],keys:Object.keys(t[d]),contents:i.toValuesTree(t[d],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,r,o)}}e.DefaultConfigurationModel=h;class v{constructor(t,r){this._name=t,this._scopes=r,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get errors(){return this._parseErrors}parseContent(t){if(!y.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r)}}parseRaw(t){this._raw=t;const r=this.doParseRaw(t);this._configurationModel=new f(r.contents,r.keys,r.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let r={},o=null,d=[],c=[],g=[];function I(T){Array.isArray(d)?d.push(T):o&&(d[o]=T)}let A={onObjectBegin:()=>{let T={};I(T),c.push(d),d=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{d=c.pop()},onArrayBegin:()=>{let T=[];I(T),c.push(d),d=T,o=null},onArrayEnd:()=>{d=c.pop()},onLiteralValue:I,onError:(T,U,j)=>{g.push({error:T,offset:U,length:j})}};if(t)try{w.visit(t,A),r=d[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return r}doParseRaw(t){if(this._scopes){const c=E.Registry.as(S.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,c,!0,this._scopes)}const r=i.toValuesTree(t,c=>console.error(`Conflict in settings file ${this._name}: ${c}`)),o=Object.keys(t),d=i.toOverrides(t,c=>console.error(`Conflict in settings file ${this._name}: ${c}`));return{contents:r,keys:o,overrides:d}}filterByScope(t,r,o,d){const c={};for(let g in t)if(S.OVERRIDE_PROPERTY_PATTERN.test(g)&&o)c[g]=this.filterByScope(t[g],r,!1,d);else{const I=this.getScope(g,r);(I===void 0||d.indexOf(I)!==-1)&&(c[g]=t[g])}return c}getScope(t,r){const o=r[t];return o?typeof o.scope!="undefined"?o.scope:3:void 0}}e.ConfigurationModelParser=v;class p extends m.Disposable{constructor(t,r,o,d){super();this.userSettingsResource=t,this.scopes=r,this.fileService=d,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(P.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new f}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=p;class b{constructor(t,r,o=new f,d=new f,c=new R.ResourceMap,g=new f,I=new R.ResourceMap,A=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=o,this._workspaceConfiguration=d,this._folderConfigurations=c,this._memoryConfiguration=g,this._memoryConfigurationByResource=I,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,r,o){return this.getConsolidateConfigurationModel(r,o).getValue(t)}updateValue(t,r,o={}){let d;o.resource?(d=this._memoryConfigurationByResource.get(o.resource),d||(d=new f,this._memoryConfigurationByResource.set(o.resource,d))):d=this._memoryConfiguration,r===void 0?d.removeValue(t):d.setValue(t,r),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,o){const d=this.getConsolidateConfigurationModel(r,o),c=this.getFolderConfigurationModelForResource(r.resource,o),g=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,I=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),A=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),T=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),U=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),j=o?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,C=c?r.overrideIdentifier?c.freeze().override(r.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,x=r.overrideIdentifier?g.override(r.overrideIdentifier).getValue(t):g.getValue(t),ee=d.getValue(t),Z=D.distinct(D.flatten(d.overrides.map(H=>H.identifiers))).filter(H=>d.getOverrideValue(t,H)!==void 0);return{defaultValue:I,userValue:A,userLocalValue:T,userRemoteValue:U,workspaceValue:j,workspaceFolderValue:C,memoryValue:x,value:ee,default:I!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:j!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:C!==void 0?{value:c==null?void 0:c.freeze().getValue(t),override:r.overrideIdentifier?c==null?void 0:c.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:g.getValue(t),override:r.overrideIdentifier?g.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Z.length?Z:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const o=r.filter(d=>S.OVERRIDE_PROPERTY_PATTERN.test(d)).map(d=>{const c=S.overrideIdentifierFromKey(d),g=this._defaultConfiguration.getKeysForOverrideIdentifier(c),I=t.getKeysForOverrideIdentifier(c),A=[...I.filter(T=>g.indexOf(T)===-1),...g.filter(T=>I.indexOf(T)===-1),...g.filter(T=>!M.equals(this._defaultConfiguration.override(c).getValue(T),t.override(c).getValue(T)))];return[c,A]});return this.updateDefaultConfiguration(t),{keys:r,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:o,removed:d,overrides:c}=i.compare(this.localUserConfiguration,t),g=[...r,...o,...d];return g.length&&this.updateLocalUserConfiguration(t),{keys:g,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:o,removed:d,overrides:c}=i.compare(this.remoteUserConfiguration,t);let g=[...r,...o,...d];return g.length&&this.updateRemoteUserConfiguration(t),{keys:g,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:o,removed:d,overrides:c}=i.compare(this.workspaceConfiguration,t);let g=[...r,...o,...d];return g.length&&this.updateWorkspaceConfiguration(t),{keys:g,overrides:c}}compareAndUpdateFolderConfiguration(t,r){const o=this.folderConfigurations.get(t),{added:d,updated:c,removed:g,overrides:I}=i.compare(o,r);let A=[...d,...c,...g];return(A.length||!o)&&this.updateFolderConfiguration(t,r),{keys:A,overrides:I}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:d,removed:c,overrides:g}=i.compare(r,void 0);return{keys:[...o,...d,...c],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let o=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},r){let o=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const d=r.getFolder(t);d&&(o=this.getFolderConsolidatedConfiguration(d.uri)||o);const c=this._memoryConfigurationByResource.get(t);c&&(o=o.merge(c))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const o=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(t);d?(r=o.merge(d),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=o}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const o=r.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:o,overrides:d,keys:c}=this._folderConfigurations.get(r);return t.push([r,{contents:o,overrides:d,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(d=>r.add(d))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),d=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((g,I)=>(g.set(n.URI.revive(I[0]),this.parseConfigurationModel(I[1])),g),new R.ResourceMap);return new b(r,o,new f,d,c,new f,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function l(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const t=new Set,r=new Map;for(const d of u)d.keys.forEach(c=>t.add(c)),d.overrides.forEach(([c,g])=>{const I=R.getOrSet(r,c,new Set);g.forEach(A=>I.add(A))});const o=[];return r.forEach((d,c)=>o.push([c,[...d.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=l;class a{constructor(t,r,o,d){this.change=t,this.previous=r,this.currentConfiguraiton=o,this.currentWorkspace=d,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(I=>c.add(I)),t.overrides.forEach(([,I])=>I.forEach(A=>c.add(A))),this.affectedKeys=[...c.values()];const g=new f;this.affectedKeys.forEach(I=>g.setValue(I,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var o;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const d=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(o=this.previous)===null||o===void 0?void 0:o.workspace):void 0,c=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!M.equals(d,c)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let o=i.toValuesTree({[r]:!0},()=>{}),d;for(;typeof o=="object"&&(d=Object.keys(o)[0]);){if(t=t[d],!t)return!1;o=o[d]}return!0}}e.ConfigurationChangeEvent=a;class s extends a{constructor(t,r,o,d){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=o,this.sourceConfig=d}}e.AllKeysConfigurationChangeEvent=s}),define(Q[181],J([0,1,36,46,2,19,180,4,9,18]),function($,e,w,R,D,y,M,n,S,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class E extends D.Disposable{constructor(P,f){super();this.settingsResource=P,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new M.UserSettings(this.settingsResource,void 0,i.extUriBiasedIgnorePathCase,f)),this.configuration=new M.Configuration(new M.DefaultConfigurationModel,new M.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(w.Registry.as(R.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const P=await this.userConfiguration.loadConfiguration();this.configuration=new M.Configuration(new M.DefaultConfigurationModel,P)}getConfigurationData(){return this.configuration.toData()}getValue(P,f){const h=typeof P=="string"?P:void 0,v=y.isConfigurationOverrides(P)?P:y.isConfigurationOverrides(f)?f:{};return this.configuration.getValue(h,v,void 0)}updateValue(P,f,h,v){return Promise.reject(new Error("not supported"))}inspect(P){return this.configuration.inspect(P,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const P=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(P)}onDidChangeUserConfiguration(P){const f=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(P);this.trigger(h,f,1)}onDidDefaultConfigurationChange(P){const f=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new M.DefaultConfigurationModel,P);this.trigger(h,f,6)}trigger(P,f,h){const v=new M.ConfigurationChangeEvent(P,{data:f},this.configuration);v.source=h,v.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(P){switch(P){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=E}),define(Q[182],J([0,1,5]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=w.createDecorator("remoteAuthorityResolverService");var R;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(M,n=R.Unknown,S){super(M);this._message=M,this._code=n,this._detail=S,this.isHandled=n===R.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(M){return M instanceof D&&M._code===R.TemporarilyNotAvailable}static isNoResolverFound(M){return M instanceof D&&M._code===R.NoResolverFound}static isHandled(M){return M instanceof D&&M.isHandled}}e.RemoteAuthorityResolverError=D}),define(Q[183],J([0,1,78,29,2,20,4,182,16,9]),function($,e,w,R,D,y,M,n,S,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=120*1e3,m=30*1e3;var P;(function(k){k[k.Management=1]="Management",k[k.ExtensionHost=2]="ExtensionHost",k[k.Tunnel=3]="Tunnel"})(P=e.ConnectionType||(e.ConnectionType={}));function f(k){switch(k){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}async function h(k){const L=await M.Event.toPromise(k.onControlMessage),_=JSON.parse(L.toString()),W=N(_);if(W)throw W;return _}function v(k,L){return new Promise((_,W)=>{const B=setTimeout(()=>{const K=new Error("Timeout");K.code="ETIMEDOUT",K.syscall="connect",W(K)},L);k.then(K=>{clearTimeout(B),_(K)},K=>{clearTimeout(B),W(K)})})}function p(k,L,_,W){return new Promise((B,K)=>{k.connect(L,_,W,(X,Y)=>{if(X||!Y)return K(X);B(Y)})})}async function b(k,L,_){const W=z(k,L);k.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let B;try{B=await p(k.socketFactory,k.host,k.port,`reconnectionToken=${k.reconnectionToken}&reconnection=${k.reconnectionProtocol?"true":"false"}`)}catch(oe){throw k.logService.error(`${W} socketFactory.connect() failed. Error:`),k.logService.error(oe),oe}k.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let K,X;k.reconnectionProtocol?(k.reconnectionProtocol.beginAcceptReconnection(B,null),K=k.reconnectionProtocol,X=!1):(K=new w.PersistentProtocol(B,null),X=!0),k.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const Y={type:"auth",auth:k.connectionToken||"00000000000000000000"};K.sendControl(y.VSBuffer.fromString(JSON.stringify(Y)));try{const oe=await v(h(K),1e4);if(oe.type!=="sign"||typeof oe.data!="string"){const G=new Error("Unexpected handshake message");throw G.code="VSCODE_CONNECTION_ERROR",G}k.logService.trace(`${W} 4/6. received SignRequest control message.`);const le=await k.signService.sign(oe.data),ie={type:"connectionType",commit:k.commit,signedData:le,desiredConnectionType:L};return _&&(ie.args=_),k.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),K.sendControl(y.VSBuffer.fromString(JSON.stringify(ie))),{protocol:K,ownsProtocol:X}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(k.logService.error(`${W} the handshake took longer than 10 seconds. Error:`),k.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(k.logService.error(`${W} received error control message when negotiating connection. Error:`),k.logService.error(oe)),X&&H(K),oe}}async function l(k,L,_){const W=Date.now(),B=z(k,L),{protocol:K,ownsProtocol:X}=await b(k,L,_);return new Promise((Y,oe)=>{const le=K.onControlMessage(ie=>{le.dispose();const G=JSON.parse(ie.toString()),te=N(G);if(te)return k.logService.error(`${B} received error control message when negotiating connection. Error:`),k.logService.error(te),X&&H(K),oe(te);k.reconnectionProtocol&&k.reconnectionProtocol.endAcceptReconnection(),k.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${O(W)}!`),Y({protocol:K,firstMessage:G})})})}async function a(k){const{protocol:L}=await l(k,1,void 0);return{protocol:L}}async function s(k,L){const{protocol:_,firstMessage:W}=await l(k,2,L),B=W&&W.debugPort;return{protocol:_,debugPort:B}}async function u(k,L){const _=Date.now(),W=z(k,3),{protocol:B}=await b(k,3,L);return k.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${O(_)}!`),B}async function t(k,L,_){const{host:W,port:B,connectionToken:K}=await k.addressProvider.getAddress();return{commit:k.commit,host:W,port:B,connectionToken:K,reconnectionToken:L,reconnectionProtocol:_,socketFactory:k.socketFactory,signService:k.signService,logService:k.logService}}async function r(k,L,_){try{const W=R.generateUuid(),B=await t(k,W,null),{protocol:K}=await Z(B.logService,a(B),E);return new x(k,L,_,W,K)}catch(W){throw k.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),k.logService.error(W),C.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentManagement=r;async function o(k,L){try{const _=R.generateUuid(),W=await t(k,_,null),{protocol:B,debugPort:K}=await Z(W.logService,s(W,L),E);return new ee(k,L,_,B,K)}catch(_){throw k.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),k.logService.error(_),C.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(_)),_}}e.connectRemoteAgentExtensionHost=o;async function d(k,L){const _=await t(k,R.generateUuid(),null);return await Z(_.logService,u(_,{port:L}),E)}e.connectRemoteAgentTunnel=d;function c(k){return i.createCancelablePromise(L=>new Promise((_,W)=>{const B=setTimeout(_,k*1e3);L.onCancellationRequested(()=>{clearTimeout(B),_()})}))}var g;(function(k){k[k.ConnectionLost=0]="ConnectionLost",k[k.ReconnectionWait=1]="ReconnectionWait",k[k.ReconnectionRunning=2]="ReconnectionRunning",k[k.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",k[k.ConnectionGain=4]="ConnectionGain"})(g=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class I{constructor(L,_){this.reconnectionToken=L,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=I;class A{constructor(L,_,W,B){this.reconnectionToken=L,this.millisSinceLastIncomingData=_,this.durationSeconds=W,this.cancellableTimer=B,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=A;class T{constructor(L,_,W){this.reconnectionToken=L,this.millisSinceLastIncomingData=_,this.attempt=W,this.type=2}}e.ReconnectionRunningEvent=T;class U{constructor(L,_,W){this.reconnectionToken=L,this.millisSinceLastIncomingData=_,this.attempt=W,this.type=4}}e.ConnectionGainEvent=U;class j{constructor(L,_,W,B){this.reconnectionToken=L,this.millisSinceLastIncomingData=_,this.attempt=W,this.handled=B,this.type=3}}e.ReconnectionPermanentFailureEvent=j;class C extends D.Disposable{constructor(L,_,W,B){super();this._connectionType=L,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=_,this.reconnectionToken=W,this.protocol=B,this._isReconnecting=!1,this._onDidStateChange.fire(new U(this.reconnectionToken,0,0)),this._register(B.onSocketClose(()=>this._beginReconnecting())),this._register(B.onSocketTimeout(()=>this._beginReconnecting())),C._instances.push(this),C._permanentFailure&&this._gotoPermanentFailure(C._permanentFailureMillisSinceLastIncomingData,C._permanentFailureAttempt,C._permanentFailureHandled)}static triggerPermanentFailure(L,_,W){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=L,this._permanentFailureAttempt=_,this._permanentFailureHandled=W,this._instances.forEach(B=>B._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(!C._permanentFailure){const L=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${L} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new I(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30],W=Date.now();let B=-1;do{B++;const K=B<_.length?_[B]:_[_.length-1];try{if(K>0){const Y=c(K);this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K,Y)),this._options.logService.info(`${L} waiting for ${K} seconds before reconnecting...`);try{await Y}catch(oe){}}if(C._permanentFailure){this._options.logService.error(`${L} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this._options.logService.info(`${L} resolving connection...`);const X=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${L} connecting to ${X.host}:${X.port}...`),await Z(X.logService,this._reconnect(X),m),this._options.logService.info(`${L} reconnected!`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(X){if(X.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${L} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(X),C.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(Date.now()-W>108e5){this._options.logService.error(`${L} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(X),C.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(X)){this._options.logService.info(`${L} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if((X.code==="ETIMEDOUT"||X.code==="ENETUNREACH"||X.code==="ECONNREFUSED"||X.code==="ECONNRESET")&&X.syscall==="connect"){this._options.logService.info(`${L} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if(S.isPromiseCanceledError(X)){this._options.logService.info(`${L} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if(X instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${L} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(X),C.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,n.RemoteAuthorityResolverError.isHandled(X));break}this._options.logService.error(`${L} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(X),C.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!C._permanentFailure)}}_gotoPermanentFailure(L,_,W){this._onDidStateChange.fire(new j(this.reconnectionToken,L,_,W)),H(this.protocol)}}C._permanentFailure=!1,C._permanentFailureMillisSinceLastIncomingData=0,C._permanentFailureAttempt=0,C._permanentFailureHandled=!1,C._instances=[];class x extends C{constructor(L,_,W,B,K){super(1,L,B,K);this.client=this._register(new w.Client(K,{remoteAuthority:_,clientId:W},L.ipcLogger))}async _reconnect(L){await a(L)}}e.ManagementPersistentConnection=x;class ee extends C{constructor(L,_,W,B,K){super(2,L,W,B);this._startArguments=_,this.debugPort=K}async _reconnect(L){await s(L,this._startArguments)}}e.ExtensionHostPersistentConnection=ee;function Z(k,L,_){return new Promise((W,B)=>{let K=setTimeout(()=>{const X=new Error("Time limit reached");X.code="ETIMEDOUT",X.syscall="connect",k.error("[remote-connection] The time limit has been reached for a connection. Error:"),k.error(X),B(X)},_);L.then(X=>{clearTimeout(K),W(X)},X=>{clearTimeout(K),B(X)})})}function H(k){try{k.acceptDisconnect();const L=k.getSocket();k.dispose(),L.dispose()}catch(L){S.onUnexpectedError(L)}}function N(k){if(k&&k.type==="error"){const L=new Error(`Connection error: ${k.reason}`);return L.code="VSCODE_CONNECTION_ERROR",L}return null}function q(k,L){for(;k.length<L;)k+=" ";return k}function F(k,L,_){return`[remote-connection][${q(f(k),13)}][${L.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function z(k,L){return`${F(L,k.reconnectionToken,!!k.reconnectionProtocol)}[${k.host}:${k.port}]`}function O(k){return`${Date.now()-k} ms`}}),define(Q[87],J([0,1,10]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function R(y){return y.scheme===w.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=R;function D(y){if(!!y){const M=y.indexOf("+");return M<0?y:y.substr(0,M)}}e.getRemoteName=D}),define(Q[55],J([0,1,4,3,5,8]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ITunnelService=void 0,e.ITunnelService=D.createDecorator("tunnelService");function M(P){if(!(P.scheme!=="http"&&P.scheme!=="https")){const f=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(P.authority);if(!!f)return{address:f[1],port:+f[2]}}}e.extractLocalHostUriMetaDataForPortMapping=M,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function n(P){return e.LOCALHOST_ADDRESSES.indexOf(P)>=0}e.isLocalhost=n,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(P){return e.ALL_INTERFACES_ADDRESSES.indexOf(P)>=0}e.isAllInterfaces=S;function i(P){return P==="localhost"?"127.0.0.1":P==="127.0.0.1"?"localhost":void 0}function E(P,f){return f?f!==1&&P<1024:!R.isWindows&&P<1024}e.isPortPrivileged=E;let m=class{constructor(f){this.logService=f,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}setTunnelProvider(f,h){return this._tunnelProvider=f,f?(this._canElevate=h.elevation,this._canMakePublic=h.public,{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async f=>{const h=[],v=Array.from(this._tunnels.values());for(let p of v){const b=Array.from(p.values());for(let l of b){const a=await l.value;a&&h.push(a)}}f(h)})}async dispose(){for(const f of this._tunnels.values()){for(const{value:h}of f.values())await h.then(v=>v==null?void 0:v.dispose());f.clear()}this._tunnels.clear()}openTunnel(f,h,v,p,b=!1,l=!1){if(this.logService.trace(`openTunnel request for ${h}:${v} on local port ${p}.`),!!f){h||(h="localhost");const a=this.retainOrCreateTunnel(f,h,v,p,b,l);return a?a.then(s=>{if(!s){this.logService.trace("New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,v);return}this.logService.trace("New tunnel established.");const u=this.makeTunnel(s);return(s.tunnelRemoteHost!==h||s.tunnelRemotePort!==v)&&this.logService.warn("Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(u),u}):(this.logService.trace("Tunnel was not created."),a)}}makeTunnel(f){return{tunnelRemotePort:f.tunnelRemotePort,tunnelRemoteHost:f.tunnelRemoteHost,tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress,public:f.public,dispose:async()=>{const h=this._tunnels.get(f.tunnelRemoteHost);if(h){const v=h.get(f.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(f.tunnelRemoteHost,f.tunnelRemotePort,v))}}}}async tryDisposeTunnel(f,h,v){if(v.refcount<=0){this.logService.trace(`Tunnel is being disposed ${f}:${h}.`);const p=v.value.then(async b=>{b&&(await b.dispose(!0),this._onTunnelClosed.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this._tunnels.has(f)&&this._tunnels.get(f).delete(h),p}}async closeTunnel(f,h){const v=this._tunnels.get(f);if(v&&v.has(h)){const p=v.get(h);p.refcount=0,await this.tryDisposeTunnel(f,h,p)}}addTunnelToMap(f,h,v){this._tunnels.has(f)||this._tunnels.set(f,new Map),this._tunnels.get(f).set(h,{refcount:1,value:v})}async removeEmptyTunnelFromMap(f,h){const v=this._tunnels.get(f);v&&(await v.get(h)||v.delete(h),v.size===0&&this._tunnels.delete(f))}getTunnelFromMap(f,h){const v=i(f);let p;if(v){const b=this._tunnels.get(f),l=this._tunnels.get(v);b&&l?p=new Map([...Array.from(b.entries()),...Array.from(l.entries())]):p=b!=null?b:l}else p=this._tunnels.get(f);return p?p.get(h):void 0}canTunnel(f){return!!M(f)}createWithProvider(f,h,v,p,b,l){this.logService.trace(`Creating tunnel with provider ${h}:${v} on local port ${p}.`);const s={elevationRequired:b?E(p===void 0?v:p):!1},u={remoteAddress:{host:h,port:v},localAddressPort:p,public:l},t=f.forwardPort(u,s);return this.logService.trace("Tunnel created by provider."),t&&this.addTunnelToMap(h,v,t),t}};m=de([re(0,y.ILogService)],m),e.AbstractTunnelService=m}),define(Q[39],J([0,1,143,5,46,36,20]),function($,e,w,R,D,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=R.createDecorator("requestService");function n(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}e.isSuccess=n;function S(m){return m.res.statusCode===204}async function i(m){if(!n(m))throw new Error("Server returned "+m.res.statusCode);return S(m)?null:(await M.streamToBuffer(m.stream)).toString()}e.asText=i;async function E(m){if(!n(m))throw new Error("Server returned "+m.res.statusCode);if(S(m))return null;const f=(await M.streamToBuffer(m.stream)).toString();try{return JSON.parse(f)}catch(h){throw h.message+=`:
`+f,h}}e.asJson=E,y.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:w.localize(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:w.localize(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:w.localize(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:w.localize(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[w.localize(4,null),w.localize(5,null),w.localize(6,null)],default:"override",description:w.localize(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:w.localize(8,null)}}})}),define(Q[184],J([0,1,185,14]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(M){return M.protocol==="http:"?process.env.HTTP_PROXY||process.env.http_proxy||null:M.protocol==="https:"&&(process.env.HTTPS_PROXY||process.env.https_proxy||process.env.HTTP_PROXY||process.env.http_proxy)||null}async function y(M,n={}){const S=w.parse(M),i=n.proxyUrl||D(S);if(!i)return null;const E=w.parse(i);if(!/^https?:$/.test(E.protocol||""))return null;const m={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:R.isBoolean(n.strictSSL)?n.strictSSL:!0};return S.protocol==="http:"?new(await new Promise((P,f)=>{$(["http-proxy-agent"],P,f)}))(m):new(await new Promise((P,f)=>{$(["https-proxy-agent"],P,f)}))(m)}e.getProxyAgent=y}),define(Q[186],J([0,1,29,20]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(y,M,n){let S=n&&n.get("storage.serviceMachineId",0)||null;if(S)return S;try{const E=(await M.readFile(y.serviceMachineIdResource)).value.toString();S=w.isUUID(E)?E:null}catch(i){S=null}if(!S){S=w.generateUuid();try{await M.writeFile(y.serviceMachineIdResource,R.VSBuffer.fromString(S))}catch(i){}}return n&&n.store("storage.serviceMachineId",S,0,1),S}e.getServiceMachineId=D}),define(Q[88],J([0,1,5]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=w.createDecorator(e.SIGN_SERVICE_ID)}),define(Q[187],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class w{vsda(){return new Promise((D,y)=>$(["vsda"],D,y))}async sign(D){try{const y=await this.vsda(),M=new y.signer;if(M)return M.sign(D)}catch(y){}return D}}e.SignService=w}),define(Q[37],J([0,1,5]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=w.createDecorator("stateService")}),define(Q[22],J([0,1,11,8,37,4,5,169,3,2,9]),function($,e,w,R,D,y,M,n,S,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=M.createDecorator("lifecycleMainService");var m;(function(h){h[h.CLOSE=1]="CLOSE",h[h.QUIT=2]="QUIT",h[h.RELOAD=3]="RELOAD",h[h.LOAD=4]="LOAD"})(m=e.UnloadReason||(e.UnloadReason={}));var P;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen"})(P=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let f=class tt extends i.Disposable{constructor(v,p){super();this.logService=v,this.stateService=p,this._onBeforeShutdown=this._register(new y.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new y.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onBeforeWindowClose=this._register(new y.Emitter),this.onBeforeWindowClose=this._onBeforeWindowClose.event,this._onBeforeWindowUnload=this._register(new y.Emitter),this.onBeforeWindowUnload=this._onBeforeWindowUnload.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=null,this.pendingQuitPromiseResolve=null,this.pendingWillShutdownPromise=null,this.phaseWhen=new Map,this.handleRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}handleRestarted(){this._wasRestarted=!!this.stateService.getItem(tt.QUIT_FROM_RESTART_MARKER),this._wasRestarted&&this.stateService.removeItem(tt.QUIT_FROM_RESTART_MARKER)}registerListeners(){const v=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),S.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};w.app.addListener("before-quit",v);const p=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!S.isMacintosh)&&w.app.quit()};w.app.addListener("window-all-closed",p),w.app.once("will-quit",b=>{this.logService.trace("Lifecycle#app.on(will-quit)"),b.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),w.app.removeListener("before-quit",v),w.app.removeListener("window-all-closed",p),w.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const v=[];return this._onWillShutdown.fire({join(p){p&&v.push(p)}}),this.pendingWillShutdownPromise=Promise.all(v).then(()=>{},p=>this.logService.error(p)),this.pendingWillShutdownPromise}set phase(v){if(v<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase!==v){this.logService.trace(`lifecycle (main): phase changed (value: ${v})`),this._phase=v;const p=this.phaseWhen.get(this._phase);p&&(p.open(),this.phaseWhen.delete(this._phase))}}async when(v){if(!(v<=this._phase)){let p=this.phaseWhen.get(v);p||(p=new E.Barrier,this.phaseWhen.set(v,p)),await p.wait()}}registerWindow(v){this.windowCounter++,v.win.on("close",p=>{const b=v.id;if(this.windowToCloseRequest.has(b)){this.windowToCloseRequest.delete(b);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${v.id}`),p.preventDefault(),this.unload(v,1).then(l=>{if(l){this.windowToCloseRequest.delete(b);return}this.windowToCloseRequest.add(b),this.logService.trace(`Lifecycle#onBeforeWindowClose.fire() - window ID ${b}`),this._onBeforeWindowClose.fire(v),v.close()})}),v.win.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${v.id}`),this.windowCounter--,this.windowCounter===0&&(!S.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(v,p){await this.unload(v,3)||v.reload(p)}async unload(v,p){if(!v.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${v.id}`);const b=this._quitRequested?2:p;let l=await this.onBeforeUnloadWindowInRenderer(v,b);return l?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${v.id})`),this.handleWindowUnloadVeto(l)):(l=await this.onBeforeUnloadWindowInMain(v,b),l?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${v.id})`),this.handleWindowUnloadVeto(l)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${v.id})`),await this.onWillUnloadWindowInRenderer(v,b),!1))}handleWindowUnloadVeto(v){return v?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(v){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(v),this.pendingQuitPromiseResolve=null,this.pendingQuitPromise=null)}onBeforeUnloadWindowInRenderer(v,p){return new Promise(b=>{const l=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${l}`,s=`vscode:cancel${l}`;w.ipcMain.once(a,()=>{b(!1)}),w.ipcMain.once(s,()=>{b(!0)}),v.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:s,reason:p})})}onBeforeUnloadWindowInMain(v,p){const b=[];return this._onBeforeWindowUnload.fire({reason:p,window:v,veto(l){b.push(l)}}),n.handleVetos(b,l=>this.logService.error(l))}onWillUnloadWindowInRenderer(v,p){return new Promise(b=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;w.ipcMain.once(a,()=>b()),v.send("vscode:onWillUnload",{replyChannel:a,reason:p})})}quit(v){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - from update: ${v}`),v&&this.stateService.setItem(tt.QUIT_FROM_RESTART_MARKER,!0),this.pendingQuitPromise=new Promise(p=>{this.pendingQuitPromiseResolve=p,this.logService.trace("Lifecycle#quit() - calling app.quit()"),w.app.quit()}),this.pendingQuitPromise)}relaunch(v){this.logService.trace("Lifecycle#relaunch()");const p=process.argv.slice(1);if((v==null?void 0:v.addArgs)&&p.push(...v.addArgs),v==null?void 0:v.removeArgs)for(const l of v.removeArgs){const a=p.indexOf(l);a>=0&&p.splice(a,1)}let b=!1;w.app.once("quit",()=>{if(!b){this.stateService.setItem(tt.QUIT_FROM_RESTART_MARKER,!0);try{if(S.isWindows){const l=process.env.VSCODE_CWD;l&&process.chdir(l)}}catch(l){this.logService.error(l)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),w.app.relaunch({args:p})}}),this.quit().then(l=>b=l)}async kill(v){this.logService.trace("Lifecycle#kill()"),await Promise.race([E.timeout(1e3),(async()=>{for(const p of w.BrowserWindow.getAllWindows())if(p&&!p.isDestroyed()){let b;p.webContents&&!p.webContents.isDestroyed()?b=new Promise(l=>p.once("closed",l)):b=Promise.resolve(),p.destroy(),await b}})()]),w.app.exit(v)}};f.QUIT_FROM_RESTART_MARKER="quit.from.restart",f=de([re(0,R.ILogService),re(1,D.IStateService)],f),e.LifecycleMainService=f}),define(Q[188],J([0,1,6,25,53,26,14,8]),function($,e,w,R,D,y,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class S{constructor(m,P){this.dbPath=m,this.onError=P,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const m=await this.loadAsync();this._database||(this._database=m)}}loadSync(){try{return this.lastFlushedSerializedDatabase=R.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(m){return m.code!=="ENOENT"&&this.onError(m),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await y.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(m){return m.code!=="ENOENT"&&this.onError(m),{}}}getItem(m,P){const f=this.database[m];return M.isUndefinedOrNull(f)?P:f}setItem(m,P){if(M.isUndefinedOrNull(P))return this.removeItem(m);(typeof P=="string"||typeof P=="number"||typeof P=="boolean")&&this.database[m]===P||(this.database[m]=P,this.saveSync())}removeItem(m){M.isUndefined(this.database[m])||(this.database[m]=void 0,this.saveSync())}saveSync(){const m=JSON.stringify(this.database,null,4);if(m!==this.lastFlushedSerializedDatabase)try{y.writeFileSync(this.dbPath,m),this.lastFlushedSerializedDatabase=m}catch(P){this.onError(P)}}}e.FileStorage=S;let i=class Tt{constructor(m,P){this.fileStorage=new S(w.join(m.userDataPath,Tt.STATE_FILE),f=>P.error(f))}init(){return this.fileStorage.init()}getItem(m,P){return this.fileStorage.getItem(m,P)}setItem(m,P){this.fileStorage.setItem(m,P)}removeItem(m){this.fileStorage.removeItem(m)}};i.STATE_FILE="storage.json",i=de([re(0,D.INativeEnvironmentService),re(1,n.ILogService)],i),e.StateService=i}),define(Q[89],J([0,1,5,4,2,14]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const M="__$__targetStorageMarker";e.IStorageService=w.createDecorator("storageService");var n;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(n=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(f){f[f.GLOBAL=0]="GLOBAL",f[f.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var i;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(i=e.StorageTarget||(e.StorageTarget={}));class E extends D.Disposable{constructor(){super(...arguments);this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}emitDidChangeValue(h,v){v===M?(h===0?this._globalKeyTargets=void 0:h===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:h})):this._onDidChangeValue.fire({scope:h,key:v,target:this.getKeyTargets(h)[v]})}emitWillSaveState(h){this._onWillSaveState.fire({reason:h})}store(h,v,p,b){if(y.isUndefinedOrNull(v)){this.remove(h,p);return}this.withPausedEmitters(()=>{this.updateKeyTarget(h,p,b),this.doStore(h,v,p)})}remove(h,v){this.withPausedEmitters(()=>{this.updateKeyTarget(h,v,void 0),this.doRemove(h,v)})}withPausedEmitters(h){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{h()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(h,v){const p=[],b=this.getKeyTargets(h);for(const l of Object.keys(b))b[l]===v&&p.push(l);return p}updateKeyTarget(h,v,p){const b=this.getKeyTargets(v);typeof p=="number"?b[h]!==p&&(b[h]=p,this.doStore(M,JSON.stringify(b),v)):typeof b[h]=="number"&&(delete b[h],this.doStore(M,JSON.stringify(b),v))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(h){return h===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(h){const v=this.get(M,h);if(v)try{return JSON.parse(v)}catch(p){}return Object.create(null)}isNew(h){return this.getBoolean(e.IS_NEW_KEY,h)===!0}flush(){return this._onWillSaveState.fire({reason:n.NONE}),this.doFlush()}}e.AbstractStorageService=E;class m extends E{constructor(){super(...arguments);this.globalCache=new Map,this.workspaceCache=new Map}getCache(h){return h===0?this.globalCache:this.workspaceCache}get(h,v,p){const b=this.getCache(v).get(h);return y.isUndefinedOrNull(b)?p:b}getBoolean(h,v,p){const b=this.getCache(v).get(h);return y.isUndefinedOrNull(b)?p:b==="true"}getNumber(h,v,p){const b=this.getCache(v).get(h);return y.isUndefinedOrNull(b)?p:parseInt(b,10)}doStore(h,v,p){const b=String(v);this.getCache(p).get(h)!==b&&(this.getCache(p).set(h,b),this.emitDidChangeValue(p,h))}doRemove(h,v){!this.getCache(v).delete(h)||this.emitDidChangeValue(v,h)}logStorage(){P(this.globalCache,this.workspaceCache,"inMemory","inMemory")}async migrate(h){}async doFlush(){}async close(){}}e.InMemoryStorageService=m;async function P(f,h,v,p){const b=o=>{try{return JSON.parse(o)}catch(d){return o}},l=new Map,a=new Map;f.forEach((o,d)=>{l.set(d,o),a.set(d,b(o))});const s=new Map,u=new Map;h.forEach((o,d)=>{s.set(d,o),u.set(d,b(o))}),console.group(`Storage: Global (path: ${v})`);let t=[];l.forEach((o,d)=>{t.push({key:d,value:o})}),console.table(t),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${p})`);let r=[];s.forEach((o,d)=>{r.push({key:d,value:o})}),console.table(r),console.groupEnd(),console.log(u)}e.logStorage=P}),define(Q[90],J([0,1,5,4,2,8,53,121,120,6,89]),function($,e,w,R,D,y,M,n,S,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=w.createDecorator("storageMainService");let m=class Ot extends D.Disposable{constructor(f,h){super();this.logService=f,this.environmentService=h,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.storage=new S.Storage(new S.InMemoryStorageDatabase)}get items(){return this.storage.items}get storagePath(){return this.environmentService.extensionTestsLocationURI?n.SQLiteStorageDatabase.IN_MEMORY_PATH:i.join(this.environmentService.globalStorageHome.fsPath,Ot.STORAGE_NAME)}createLogginOptions(){return{logTrace:this.logService.getLevel()===y.LogLevel.Trace?f=>this.logService.trace(f):void 0,logError:f=>this.logService.error(f)}}initialize(){return this.initializePromise||(this.initializePromise=this.doInitialize()),this.initializePromise}async doInitialize(){this.storage.dispose(),this.storage=new S.Storage(new n.SQLiteStorageDatabase(this.storagePath,{logging:this.createLogginOptions()})),this._register(this.storage.onDidChangeStorage(h=>this._onDidChangeStorage.fire({key:h}))),await this.storage.init();const f=this.storage.getBoolean(E.IS_NEW_KEY);f===void 0?this.storage.set(E.IS_NEW_KEY,!0):f&&this.storage.set(E.IS_NEW_KEY,!1)}get(f,h){return this.storage.get(f,h)}getBoolean(f,h){return this.storage.getBoolean(f,h)}getNumber(f,h){return this.storage.getNumber(f,h)}store(f,h){return this.storage.set(f,h)}remove(f){return this.storage.delete(f)}close(){return this._onWillSaveState.fire(),this.storage.close()}};m.STORAGE_NAME="state.vscdb",m=de([re(0,y.ILogService),re(1,M.IEnvironmentService)],m),e.StorageMainService=m}),define(Q[189],J([0,1,3,52,29,7]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;async function M(S,i,E,m,P,f,h,v,p){const b=Object.create(null);b["common.machineId"]=f,b.sessionID=D.generateUuid()+Date.now(),b.commitHash=m,b.version=P,b["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=w.PlatformToString(w.platform),b["common.nodePlatform"]=R.platform,b["common.nodeArch"]=E,b["common.product"]=p||"desktop";const l=n(h||[]);l&&(b["common.msftInternal"]=l);let a=0;const s=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),w.isLinuxSnap&&(b["common.snap"]="true");try{const u=await S.readFile(y.URI.file(v));b["common.source"]=u.value.toString().slice(0,30)}catch(u){}return b}e.resolveCommonProperties=M;function n(S){const i=R.env.USERDNSDOMAIN;if(!i)return!1;const E=i.toLowerCase();return S.some(m=>E===m)}}),define(Q[30],J([0,1,5]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ITelemetryService=void 0,e.ITelemetryService=w.createDecorator("telemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Q[71],J([0,1,27,66,83,25,6,40,77,15,3,7,30,5,63,10,21]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=f.createDecorator(e.ID);async function b(t,r){const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],d=new Map,c=new Map,g=2e4;function I(U,j,C,x){const ee=j.substring(U.length+1);return new Promise(Z=>{y.readdir(j,{withFileTypes:!0},async(H,N)=>{var q,F,z;if(H){Z();return}if(x.count>=g){x.count+=N.length,x.maxReached=!0,Z();return}let O=N.length;if(O===0){Z();return}let k=N;x.count+N.length>g&&(x.maxReached=!0,O=g-x.count,k=N.slice(0,O)),x.count+=N.length;for(const L of k)if(L.isDirectory()){if(C.includes(L.name)||await I(U,M.join(j,L.name),C,x),--O==0){Z();return}}else{const _=L.name.lastIndexOf(".");if(_>=0){const W=L.name.substring(_+1);W&&d.set(W,((q=d.get(W))!==null&&q!==void 0?q:0)+1)}for(const W of o)((F=W.relativePathPattern)===null||F===void 0?void 0:F.test(ee))!==!1&&W.filePattern.test(L.name)&&c.set(W.tag,((z=c.get(W.tag))!==null&&z!==void 0?z:0)+1);if(--O==0){Z();return}}})})}const A={count:0,maxReached:!1};await I(t,t,r,A);const T=await s(t);return{configFiles:l(c),fileTypes:l(d),fileCount:A.count,maxFilesReached:A.maxReached,launchConfigFiles:T}}e.collectWorkspaceStats=b;function l(t){return[...h.Iterable.map(t.entries(),([r,o])=>({name:r,count:o}))].sort((r,o)=>o.count-r.count)}function a(){const t={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(R.virtualMachineHint.value()*100)}%`},r=w.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}e.getMachineInfo=a;function s(t){let r=new Map,o=M.join(t,".vscode","launch.json");return new Promise((d,c)=>{y.exists(o,g=>{if(g)y.readFile(o,(I,A)=>{if(I)return d([]);const T=[],U=n.parse(A.toString(),T);if(T.length)return console.log(`Unable to parse ${o}`),d([]);if(n.getNodeType(U)==="object"&&U.configurations)for(const j of U.configurations){const C=j.type;C&&(r.has(C)?r.set(C,r.get(C)+1):r.set(C,1))}return d(l(r))});else return d([])})})}e.collectLaunchConfigs=s;let u=class{constructor(r){this.telemetryService=r}formatMachineInfo(r){const o=[];return o.push(`OS Version:       ${r.os}`),o.push(`CPUs:             ${r.cpus}`),o.push(`Memory (System):  ${r.memory}`),o.push(`VM:               ${r.vmHint}`),o.join(`
`)}formatEnvironment(r){const o=[];o.push(`Version:          ${i.default.nameShort} ${i.default.version} (${i.default.commit||"Commit unknown"}, ${i.default.date||"Date unknown"})`),o.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const d=w.cpus();return d&&d.length>0&&o.push(`CPUs:             ${d[0].model} (${d.length} x ${d[0].speed})`),o.push(`Memory (System):  ${(w.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`),E.isWindows||o.push(`Load (avg):       ${w.loadavg().map(c=>Math.round(c)).join(", ")}`),o.push(`VM:               ${Math.round(R.virtualMachineHint.value()*100)}%`),o.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${r.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(r,o){return Promise.all([S.listProcesses(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async d=>{let[c,g]=d,I=this.formatProcessList(r,c);return o.forEach(A=>{if(D.isRemoteDiagnosticError(A))I+=`
${A.errorMessage}`,g+=`
${A.errorMessage}`;else if(I+=`

Remote: ${A.hostName}`,A.processes&&(I+=`
${this.formatProcessList(r,A.processes)}`),A.workspaceMetadata){g+=`
|  Remote: ${A.hostName}`;for(const T of Object.keys(A.workspaceMetadata)){const U=A.workspaceMetadata[T];let j=`${U.fileCount} files`;U.maxFilesReached&&(j=`more than ${j}`),g+=`|    Folder (${T}): ${j}`,g+=this.formatWorkspaceStats(U)}}}),{processInfo:I,workspaceInfo:g}})}async getSystemInfo(r,o){const{memory:d,vmHint:c,os:g,cpus:I}=a(),A={os:g,memory:d,cpus:I,vmHint:c,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:o};return E.isWindows||(A.load=`${w.loadavg().map(T=>Math.round(T)).join(", ")}`),E.isLinux&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(r,o){const d=[];return S.listProcesses(r.mainPID).then(async c=>(d.push(""),d.push(this.formatEnvironment(r)),d.push(""),d.push(this.formatProcessList(r,c)),r.windows.some(g=>g.folderURIs&&g.folderURIs.length>0&&!g.remoteAuthority)&&(d.push(""),d.push("Workspace Stats: "),d.push(await this.formatWorkspaceMetadata(r))),o.forEach(g=>{if(D.isRemoteDiagnosticError(g))d.push(`
${g.errorMessage}`);else if(d.push(`

`),d.push(`Remote:           ${g.hostName}`),d.push(this.formatMachineInfo(g.machineInfo)),g.processes&&d.push(this.formatProcessList(r,g.processes)),g.workspaceMetadata)for(const I of Object.keys(g.workspaceMetadata)){const A=g.workspaceMetadata[I];let T=`${A.fileCount} files`;A.maxFilesReached&&(T=`more than ${T}`),d.push(`Folder (${I}): ${T}`),d.push(this.formatWorkspaceStats(A))}}),d.push(""),d.push(""),d.join(`
`)))}formatWorkspaceStats(r){const o=[],d=60;let c=0;const g=(U,j)=>{const C=` ${U}(${j})`;c+C.length>d?(o.push(I),I="|                 ",c=I.length):c+=C.length,I+=C};let I="|      File types:";const A=10;let T=r.fileTypes.length>A?A:r.fileTypes.length;for(let U=0;U<T;U++){const j=r.fileTypes[U];g(j.name,j.count)}if(o.push(I),r.configFiles.length>=0&&(I="|      Conf files:",c=0,r.configFiles.forEach(U=>{g(U.name,U.count)}),o.push(I)),r.launchConfigFiles.length>0){let U="|      Launch Configs:";r.launchConfigFiles.forEach(j=>{U+=j.count>1?` ${j.name}(${j.count})`:` ${j.name}`}),o.push(U)}return o.join(`
`)}expandGPUFeatures(r){const o=Math.max(...Object.keys(r).map(d=>d.length));return Object.keys(r).map(d=>`${d}:  ${" ".repeat(o-d.length)}  ${r[d]}`).join(`
                  `)}formatWorkspaceMetadata(r){const o=[],d=[];return r.windows.forEach(c=>{c.folderURIs.length===0||!!c.remoteAuthority||(o.push(`|  Window (${c.title})`),c.folderURIs.forEach(g=>{const I=m.URI.revive(g);if(I.scheme===v.Schemas.file){const A=I.fsPath;d.push(b(A,["node_modules",".git"]).then(T=>{let U=`${T.fileCount} files`;T.maxFilesReached&&(U=`more than ${U}`),o.push(`|    Folder (${M.basename(A)}): ${U}`),o.push(this.formatWorkspaceStats(T))}).catch(T=>{o.push(`|      Error: Unable to collect workspace stats for folder ${A} (${T.toString()})`)}))}else o.push(`|    Folder (${I.toString()}): Workspace stats not available.`)}))}),Promise.all(d).then(c=>o.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}formatProcessList(r,o){const d=new Map;r.windows.forEach(g=>d.set(g.pid,g.title));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),o&&this.formatProcessItem(r.mainPID,d,c,o,0),c.join(`
`)}formatProcessItem(r,o,d,c,g){const I=g===0;let A;I?A=c.pid===r?`${i.default.applicationName} main`:"remote agent":(A=`${"  ".repeat(g)} ${c.name}`,c.name==="window"&&(A=`${A} (${o.get(c.pid)})`));const T=process.platform==="win32"?c.mem:w.totalmem()*(c.mem/100);d.push(`${c.load.toFixed(0).padStart(5," ")}	${(T/p.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(c.children)&&c.children.forEach(U=>this.formatProcessItem(r,o,d,U,g+1))}async reportWorkspaceStats(r){for(const{uri:o}of r.folders){const d=m.URI.revive(o);if(d.scheme===v.Schemas.file){const c=d.fsPath;try{const g=await b(c,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),g.fileTypes.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:I.name,count:I.count})}),g.launchConfigFiles.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:I.name,count:I.count})}),g.configFiles.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:I.name,count:I.count})})}catch(g){}}}}};u=de([re(0,P.ITelemetryService)],u),e.DiagnosticsService=u}),define(Q[190],J([0,1,16,159,162,41,30,39,152,53,24,8,21,7,60,89,186,5,18]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h,v,p,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var a;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished"})(a||(a={}));function s(...O){return String(O.reduce((k,L)=>k|L,0))}var u;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(u||(u={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class c{constructor(k=d){this.state=k}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(k,L=this.state.pageSize){return new c(Object.assign(Object.assign({},this.state),{pageNumber:k,pageSize:L}))}withFilter(k,...L){const _=[...this.state.criteria,...L.length?L.map(W=>({filterType:k,value:W})):[{filterType:k}]];return new c(Object.assign(Object.assign({},this.state),{criteria:_}))}withSortBy(k){return new c(Object.assign(Object.assign({},this.state),{sortBy:k}))}withSortOrder(k){return new c(Object.assign(Object.assign({},this.state),{sortOrder:k}))}withFlags(...k){return new c(Object.assign(Object.assign({},this.state),{flags:k.reduce((L,_)=>L|_,0)}))}withAssetTypes(...k){return new c(Object.assign(Object.assign({},this.state),{assetTypes:k}))}get raw(){const{criteria:k,pageNumber:L,pageSize:_,sortBy:W,sortOrder:B,flags:K,assetTypes:X}=this.state;return{filters:[{criteria:k,pageNumber:L,pageSize:_,sortBy:W,sortOrder:B}],assetTypes:X,flags:K}}get searchText(){const k=this.state.criteria.filter(L=>L.filterType===u.SearchText)[0];return k&&k.value?k.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(k=>String(k.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function g(O,k){const L=(O||[]).filter(_=>_.statisticName===k)[0];return L?L.value:0}function I(O){const k="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(_=>_.assetType.indexOf(k)===0).reduce((_,W)=>{const B=j(O,W.assetType);return B&&_.push([W.assetType.substring(k.length),B]),_},[])}function A(O){if(O.properties){const k=O.properties.filter(W=>W.key===t.Repository),L=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),_=k.filter(W=>L.test(W.value))[0];return _?{uri:_.value,fallbackUri:_.value}:null}return j(O,t.Repository)}function T(O){return{uri:`${O.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${O.fallbackAssetUri}/${t.VSIX}`}}function U(O){const k=j(O,t.Icon);if(k)return k;const L=R.DefaultIconPath;return{uri:L,fallbackUri:L}}function j(O,k){return O.files.filter(_=>_.assetType===k)[0]?{uri:`${O.assetUri}/${k}`,fallbackUri:`${O.fallbackAssetUri}/${k}`}:null}function C(O,k){const L=O.properties?O.properties.filter(W=>W.key===k):[],_=L.length>0&&L[0].value;return _?_.split(",").map(W=>D.adoptToGalleryExtensionId(W)):[]}function x(O){const k=O.properties?O.properties.filter(L=>L.key===r.Engine):[];return k.length>0&&k[0].value||""}function ee(O){const k=O.properties?O.properties.filter(_=>_.key===r.LocalizedLanguages):[],L=k.length>0&&k[0].value||"";return L?L.split(","):[]}function Z(O){return O.indexOf("preview")!==-1}function H(O){const k=O.properties?O.properties.find(L=>L.key===r.WebExtension):void 0;return!!k&&k.value==="true"}function N(O){return O.files.some(k=>k.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?l.joinPath(f.URI.parse(O.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function q(O,k,L,_,W){const B={manifest:j(k,t.Manifest),readme:j(k,t.Details),changelog:j(k,t.Changelog),license:j(k,t.License),repository:A(k),download:T(k),icon:U(k),coreTranslations:I(k)};return{identifier:{id:D.getGalleryExtensionId(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:k.version,date:k.lastUpdated,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,description:O.shortDescription||"",installCount:g(O.statistics,"install"),rating:g(O.statistics,"averagerating"),ratingCount:g(O.statistics,"ratingcount"),assetUri:f.URI.parse(k.assetUri),webResource:N(k),assetTypes:k.files.map(({assetType:K})=>K),assets:B,properties:{dependencies:C(k,r.Dependency),extensionPack:C(k,r.ExtensionPack),engine:x(k),localizedLanguages:ee(k),webExtension:H(k)},telemetryData:{index:(_.pageNumber-1)*_.pageSize+L,searchText:_.searchText,querySource:W},preview:Z(O.flags)}}let F=class{constructor(k,L,_,W,B,K,X){this.requestService=k,this.logService=L,this.environmentService=_,this.telemetryService=W,this.fileService=B,this.productService=K;const Y=K.extensionsGallery;this.extensionsGalleryUrl=Y&&Y.serviceUrl,this.extensionsControlUrl=Y&&Y.controlUrl,this.commonHeadersPromise=z(K.version,this.environmentService,this.fileService,X)}api(k=""){return`${this.extensionsGalleryUrl}${k}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(k,L){const _=[];let{total:W,firstPage:B,getPage:K}=await this.query({names:k,pageSize:k.length},L);_.push(...B);for(let X=1;_.length<W&&(B=await K(X,L),B.length);X++)_.push(...B);return _}async getCompatibleExtension(k,L){const _=await this.getCompatibleExtensionByEngine(k,L);return(_==null?void 0:_.properties.webExtension)?_.webResource?_:null:_}async getCompatibleExtensionByEngine(k,L){const _=R.isIExtensionIdentifier(k)?null:k;if(_&&_.properties.engine&&S.isEngineValid(_.properties.engine,this.productService.version))return _;const{id:W,uuid:B}=_?_.identifier:k;let K=new c().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(u.Target,"Microsoft.VisualStudio.Code");B?K=K.withFilter(u.ExtensionId,B):K=K.withFilter(u.ExtensionName,W);const{galleryExtensions:X}=await this.queryGallery(K,E.CancellationToken.None),[Y]=X;if(!Y||!Y.versions.length)return null;if(L){const le=Y.versions.filter(ie=>ie.version===L)[0];if(le){const ie=q(Y,le,0,K);if(ie.properties.engine&&S.isEngineValid(ie.properties.engine,this.productService.version))return ie}return null}const oe=await this.getLastValidExtensionVersion(Y,Y.versions);return oe?q(Y,oe,0,K):null}async query(k,L){const _=E.CancellationToken.isCancellationToken(k)?{}:k,W=E.CancellationToken.isCancellationToken(k)?k:L;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=_.text||"";const K=y.getOrDefault(_,G=>G.pageSize,50);let X=new c().withFlags(a.IncludeLatestVersionOnly,a.IncludeAssetUri,a.IncludeStatistics,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,K).withFilter(u.Target,"Microsoft.VisualStudio.Code");B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(G,te,se)=>(X=X.withFilter(u.Category,se||te),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(G,te,se)=>(X=X.withFilter(u.Tag,se||te),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(u.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),X=X.withFilter(u.SearchText,B)),X=X.withSortBy(0)):_.ids?X=X.withFilter(u.ExtensionId,..._.ids):_.names?X=X.withFilter(u.ExtensionName,..._.names):X=X.withSortBy(4),typeof _.sortBy=="number"&&(X=X.withSortBy(_.sortBy)),typeof _.sortOrder=="number"&&(X=X.withSortOrder(_.sortOrder));const{galleryExtensions:Y,total:oe}=await this.queryGallery(X,W),le=Y.map((G,te)=>q(G,G.versions[0],te,X,_.source)),ie=async(G,te)=>{if(te.isCancellationRequested)throw w.canceled();const se=X.withPage(G+1),{galleryExtensions:ae}=await this.queryGallery(se,te);return ae.map((he,ve)=>q(he,he.versions[0],ve,se,_.source))};return{firstPage:le,total:oe,pageSize:X.pageSize,getPage:ie}}async queryGallery(k,L){if(!this.isEnabled())throw new Error("No extension gallery service configured.");k=k.withFlags(k.flags,a.ExcludeNonValidated).withFilter(u.ExcludeWithFlags,s(a.Unpublished));const _=await this.commonHeadersPromise,W=JSON.stringify(k.raw),B=Object.assign(Object.assign({},_),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)}),K=new Date().getTime();let X,Y,oe=0;try{if(X=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:W,headers:B},L),X.res.statusCode&&X.res.statusCode>=400&&X.res.statusCode<500)return{galleryExtensions:[],total:oe};const le=await n.asJson(X);if(le){const ie=le.results[0],G=ie.extensions,te=ie.resultMetadata&&ie.resultMetadata.filter(se=>se.metadataType==="ResultCount")[0];return oe=te&&te.metadataItems.filter(se=>se.name==="TotalCount")[0].count||0,{galleryExtensions:G,total:oe}}return{galleryExtensions:[],total:oe}}catch(le){throw Y=le,le}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},k.telemetryData),{requestBodySize:String(W.length),duration:new Date().getTime()-K,success:!!X&&n.isSuccess(X),responseBodySize:X==null?void 0:X.res.headers["Content-Length"],statusCode:X?String(X.res.statusCode):void 0,errorCode:Y?w.isPromiseCanceledError(Y)?"canceled":w.getErrorMessage(Y).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(oe)}))}}async reportStatistic(k,L,_,W){if(!!this.isEnabled()){const B=await this.commonHeadersPromise,K=Object.assign(Object.assign({},B),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${k}/extensions/${L}/${_}/stats?statType=${W}`),headers:K},E.CancellationToken.None)}catch(X){}}}async download(k,L,_){this.logService.trace("ExtensionGalleryService#download",k.identifier.id);const W=D.getGalleryExtensionTelemetryData(k),B=new Date().getTime(),K=le=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},W),{duration:le})),X=_===1?"install":_===2?"update":"",Y=X?{uri:`${k.assets.download.uri}&${X}=true`,fallbackUri:`${k.assets.download.fallbackUri}?${X}=true`}:k.assets.download,oe=await this.getAsset(Y);await this.fileService.writeFile(L,oe.stream),K(new Date().getTime()-B)}async getReadme(k,L){if(k.assets.readme){const _=await this.getAsset(k.assets.readme,{},L);return await n.asText(_)||""}return""}async getManifest(k,L){if(k.assets.manifest){const _=await this.getAsset(k.assets.manifest,{},L),W=await n.asText(_);return W?JSON.parse(W):null}return null}async getCoreTranslation(k,L){const _=k.assets.coreTranslations.filter(W=>W[0]===L.toUpperCase())[0];if(_){const W=await this.getAsset(_[1]),B=await n.asText(W);return B?JSON.parse(B):null}return null}async getChangelog(k,L){if(k.assets.changelog){const _=await this.getAsset(k.assets.changelog,{},L);return await n.asText(_)||""}return""}async getAllVersions(k,L){let _=new c().withFlags(a.IncludeVersions,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(u.Target,"Microsoft.VisualStudio.Code");k.identifier.uuid?_=_.withFilter(u.ExtensionId,k.identifier.uuid):_=_.withFilter(u.ExtensionName,k.identifier.id);const W=[],{galleryExtensions:B}=await this.queryGallery(_,E.CancellationToken.None);return B.length&&(L?await Promise.all(B[0].versions.map(async K=>{let X;try{X=await this.getEngine(K)}catch(Y){}X&&S.isEngineValid(X,this.productService.version)&&W.push({version:K.version,date:K.lastUpdated})})):W.push(...B[0].versions.map(K=>({version:K.version,date:K.lastUpdated})))),W}async getAsset(k,L={},_=E.CancellationToken.None){const W=await this.commonHeadersPromise,B={type:"GET"},K=Object.assign(Object.assign({},W),L.headers||{});L=Object.assign(Object.assign(Object.assign({},L),B),{headers:K});const X=k.uri,Y=k.fallbackUri,oe=Object.assign(Object.assign({},L),{url:X});try{const le=await this.requestService.request(oe,_);if(le.res.statusCode===200)return le;const ie=await n.asText(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${ie}`)}catch(le){if(w.isPromiseCanceledError(le))throw le;const ie=w.getErrorMessage(le);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:X,message:ie});const G=Object.assign(Object.assign({},L),{url:Y});return this.requestService.request(G,_)}}async getLastValidExtensionVersion(k,L){const _=this.getLastValidExtensionVersionFromProperties(k,L);return _||this.getLastValidExtensionVersionRecursively(k,L)}getLastValidExtensionVersionFromProperties(k,L){for(const _ of L){const W=x(_);if(!W)return null;if(S.isEngineValid(W,this.productService.version))return _}return null}async getEngine(k){const L=x(k);if(L)return L;const _=j(k,t.Manifest);if(!_)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},B=await this.getAsset(_,{headers:W}),K=await n.asJson(B);if(K)return K.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(k,L){if(!L.length)return null;const _=L[0],W=await this.getEngine(_);return S.isEngineValid(W,this.productService.version)?(_.properties=_.properties||[],_.properties.push({key:r.Engine,value:W}),_):this.getLastValidExtensionVersionRecursively(k,L.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const k=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},E.CancellationToken.None);if(k.res.statusCode!==200)throw new Error("Could not get extensions report.");const L=await n.asJson(k),_=new Map;if(L)for(const W of L.malicious){const B=_.get(W)||{id:{id:W},malicious:!0,slow:!1};B.malicious=!0,_.set(W,B)}return[..._.values()]}};F=de([re(0,n.IRequestService),re(1,m.ILogService),re(2,i.IEnvironmentService),re(3,M.ITelemetryService),re(4,P.IFileService),re(5,h.IProductService),re(6,b.optional(v.IStorageService))],F),e.ExtensionGalleryService=F;async function z(O,k,L,_){const W={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O}`},B=await p.getServiceMachineId(k,L,_);return W["X-Market-User-Id"]=B,W}e.resolveMarketplaceHeaders=z}),define(Q[191],J([0,1,4,2,29,30]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStorageDatabaseChannelClient=e.GlobalStorageDatabaseChannel=void 0;class M extends R.Disposable{constructor(i,E){super();this.logService=i,this.storageMainService=E,this._onDidChangeItems=this._register(new w.Emitter),this.onDidChangeItems=this._onDidChangeItems.event,this.whenReady=this.init()}async init(){try{await this.storageMainService.initialize()}catch(i){this.logService.error(`[storage] init(): Unable to init global storage due to ${i}`)}this.initTelemetry(),this.registerListeners()}initTelemetry(){this.storageMainService.get(y.instanceStorageKey,void 0)===void 0&&this.storageMainService.store(y.instanceStorageKey,D.generateUuid()),this.storageMainService.get(y.firstSessionDateStorageKey,void 0)===void 0&&this.storageMainService.store(y.firstSessionDateStorageKey,new Date().toUTCString());const m=this.storageMainService.get(y.currentSessionDateStorageKey,void 0),P=new Date().toUTCString();this.storageMainService.store(y.lastSessionDateStorageKey,typeof m=="undefined"?null:m),this.storageMainService.store(y.currentSessionDateStorageKey,P)}registerListeners(){this._register(w.Event.debounce(this.storageMainService.onDidChangeStorage,(i,E)=>(i?i.push(E):i=[E],i),M.STORAGE_CHANGE_DEBOUNCE_TIME)(i=>{i.length&&this._onDidChangeItems.fire(this.serializeEvents(i))}))}serializeEvents(i){const E=new Map,m=new Set;return i.forEach(P=>{const f=this.storageMainService.get(P.key);typeof f=="string"?E.set(P.key,f):m.add(P.key)}),{changed:Array.from(E.entries()),deleted:Array.from(m.values())}}listen(i,E){switch(E){case"onDidChangeItems":return this.onDidChangeItems}throw new Error(`Event not found: ${E}`)}async call(i,E,m){switch(await this.whenReady,E){case"getItems":return Array.from(this.storageMainService.items.entries());case"updateItems":{const P=m;if(P.insert)for(const[f,h]of P.insert)this.storageMainService.store(f,h);P.delete&&P.delete.forEach(f=>this.storageMainService.remove(f));break}default:throw new Error(`Call not found: ${E}`)}}}e.GlobalStorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100;class n extends R.Disposable{constructor(i){super();this.channel=i,this._onDidChangeItemsExternal=this._register(new w.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this.onDidChangeItemsOnMainListener=this.channel.listen("onDidChangeItems")(i=>this.onDidChangeItemsOnMain(i))}onDidChangeItemsOnMain(i){(Array.isArray(i.changed)||Array.isArray(i.deleted))&&this._onDidChangeItemsExternal.fire({changed:i.changed?new Map(i.changed):void 0,deleted:i.deleted?new Set(i.deleted):void 0})}async getItems(){const i=await this.channel.call("getItems");return new Map(i)}updateItems(i){const E=Object.create(null);return i.insert&&(E.insert=Array.from(i.insert.entries())),i.delete&&(E.delete=Array.from(i.delete.values())),this.channel.call("updateItems",E)}async close(){R.dispose(this.onDidChangeItemsOnMainListener)}dispose(){super.dispose(),R.dispose(this.onDidChangeItemsOnMainListener)}}e.GlobalStorageDatabaseChannelClient=n}),define(Q[192],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class w{constructor(y){this.appender=y}listen(y,M){throw new Error(`Event not found: ${M}`)}call(y,M,{eventName:n,data:S}){return this.appender.log(n,S),Promise.resolve(null)}}e.TelemetryAppenderChannel=w;class R{constructor(y){this.channel=y}log(y,M){return this.channel.call("log",{eventName:y,data:M}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=R}),define(Q[193],J([0,1,15,144,17,5,19,46,2,41,36]),function($,e,w,R,D,y,M,n,S,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(h,v){this._configurationService=v,this._experimentProperties={},this._disposables=new S.DisposableStore,this._cleanupPatterns=[],this._appender=h.appender,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let p of this._piiPaths)this._cleanupPatterns.push(new RegExp(D.escapeRegExpCharacters(p),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(p=>{const b=/^[a-f0-9]+$/i.test(p["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})}))}setExperimentProperty(h,v){this._experimentProperties[h]=v}setEnabled(h){this._enabled=h}_updateUserOptIn(){var h;const v=(h=this._configurationService)===null||h===void 0?void 0:h.getValue(P);this._userOptIn=v?v.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const h=await this._commonProperties;let v=h.sessionID,p=h["common.instanceId"],b=h["common.machineId"],l=h["common.msftInternal"];return{sessionId:v,instanceId:p,machineId:b,msftInternal:l}}dispose(){this._disposables.dispose()}publicLog(h,v,p){return this.isOptedIn?this._commonProperties.then(b=>{v=i.mixin(v,b),v=i.mixin(v,this._experimentProperties),v=i.cloneAndChange(v,l=>{if(typeof l=="string")return this._cleanupInfo(l,p)}),this._appender.log(h,v)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(h,v,p){return this.publicLog(h,v,p)}publicLogError(h,v){return this.sendErrorTelemetry?this.publicLog(h,v,!0):Promise.resolve(void 0)}publicLogError2(h,v){return this.publicLogError(h,v)}_cleanupInfo(h,v){let p=h;if(v){const b=[];for(let u of this._cleanupPatterns)for(;;){const t=u.exec(h);if(!t)break;b.push([t.index,u.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(p="";;){const u=a.exec(h);if(!u)break;!l.test(u[0])&&b.every(([t,r])=>u.index<t||u.index>=r)&&(p+=h.substring(s,u.index)+"<REDACTED: user-file-path>",s=a.lastIndex)}s<h.length&&(p+=h.substr(s))}for(let b of this._cleanupPatterns)p=p.replace(b,"");return p}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=de([re(1,y.optional(M.IConfigurationService))],m),e.TelemetryService=m;const P="telemetry";E.Registry.as(n.Extensions.Configuration).registerConfiguration({id:P,order:110,type:"object",title:R.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:w.default.privacyStatementUrl?R.localize(2,null,w.default.privacyStatementUrl):R.localize(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(Q[91],J([0,1,19,41,14]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(P,f){return Promise.resolve(void 0)}publicLog2(P,f){return this.publicLog(P,f)}publicLogError(P,f){return Promise.resolve(void 0)}publicLogError2(P,f){return this.publicLogError(P,f)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId"})}};function y(...P){return{log:(f,h)=>P.forEach(v=>v.log(f,h)),flush:()=>Promise.all(P.map(f=>f.flush()))}}e.combinedAppender=y,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function M(P,f){return f.onDidChangeConfiguration(h=>{h.source!==6&&P.publicLog2("updateConfiguration",{configurationSource:w.ConfigurationTargetToString(h.source),configurationKeys:E(h.sourceConfig)})})}e.configurationTelemetry=M;function n(P){const f=Object.create(null),h=Object.create(null),v=Object.create(null);i(P,v);for(let p in v){p=p.length>150?p.substr(p.length-149):p;const b=v[p];typeof b=="number"?h[p]=b:typeof b=="boolean"?h[p]=b?1:0:typeof b=="string"?f[p]=b.substring(0,1023):typeof b!="undefined"&&b!==null&&(f[p]=b)}return{properties:f,measurements:h}}e.validateTelemetryData=n;function S(P){if(!P)return"none";let f="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(v=>{P.indexOf(`${v}+`)===0&&(f=v)}),f}e.cleanRemoteAuthority=S;function i(P,f,h=0,v){if(!!P)for(let p of Object.getOwnPropertyNames(P)){const b=P[p],l=v?v+p:p;Array.isArray(b)?f[l]=R.safeStringify(b):b instanceof Date?f[l]=b.toISOString():D.isObject(b)?h<2?i(b,f,h+1,l+"."):f[l]=R.safeStringify(b):f[l]=b}}function E(P){if(!P)return[];const f=[];return m(f,"",P),f}function m(P,f,h){h&&typeof h=="object"&&!Array.isArray(h)?Object.keys(h).forEach(v=>m(P,f?`${f}.${v}`:v,h[v])):P.push(f)}}),define(Q[194],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(Q[195],J([0,1,5,2,36,4,194,103]),function($,e,w,R,D,y,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=w.createDecorator("themeService");var S;(function(p){function b(l){return l&&typeof l=="object"&&typeof l.id=="string"}p.isThemeColor=b})(S=e.ThemeColor||(e.ThemeColor={}));function i(p){return{id:p}}e.themeColorFromId=i;var E;(function(p){function b(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||S.isThemeColor(t.color))}p.isThemeIcon=b;const l=/^\$\(([a-z.]+\/)?([a-z-~]+)\)$/i;function a(t){const r=l.exec(t);if(!!r){let[,o,d]=r;return!o||o==="codicon/"?{id:d}:{id:o+d}}}p.fromString=a;function s(t,r){let o=t.id;const d=o.lastIndexOf("~");return d!==-1&&(o=o.substring(0,d)),r&&(o=`${o}~${r}`),{id:o}}p.modify=s;function u(t,r){var o,d;return t.id===r.id&&((o=t.color)===null||o===void 0?void 0:o.id)===((d=r.color)===null||d===void 0?void 0:d.id)}p.isEqual=u,p.asClassNameArray=n.CSSIcon.asClassNameArray,p.asClassName=n.CSSIcon.asClassName,p.asCSSSelector=n.CSSIcon.asCSSSelector})(E=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function m(p){switch(p){case M.ColorScheme.DARK:return"vs-dark";case M.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=m,e.Extensions={ThemingContribution:"base.contributions.theming"};class P{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new y.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),R.toDisposable(()=>{const l=this.themingParticipants.indexOf(b);this.themingParticipants.splice(l,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new P;D.Registry.add(e.Extensions.ThemingContribution,f);function h(p){return f.onColorThemeChange(p)}e.registerThemingParticipant=h;class v extends R.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(l=>this.onThemeChange(l)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,l){let a=this.theme.getColor(b);return a&&l&&(a=l(a,this.theme)),a?a.toString():null}}e.Themable=v}),define(Q[72],J([0,1,3,11,37,5]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const M="#FFFFFF",n="#1E1E1E",S="#000000",i="theme",E="themeBackground";e.IThemeMainService=y.createDecorator("themeMainService");let m=class{constructor(f){this.stateService=f,R.ipcMain.on("vscode:changeColorTheme",(h,v,p)=>{typeof p=="string"&&this.storeBackgroundColor(JSON.parse(p))})}storeBackgroundColor(f){this.stateService.setItem(i,f.baseTheme),this.stateService.setItem(E,f.background)}getBackgroundColor(){if((w.isWindows||w.isMacintosh)&&R.nativeTheme.shouldUseInvertedColorScheme)return S;let f=this.stateService.getItem(E,null);if(!f){let h;(w.isWindows||w.isMacintosh)&&R.nativeTheme.shouldUseInvertedColorScheme?h="hc-black":h=this.stateService.getItem(i,"vs-dark").split(" ")[0],f=h==="hc-black"?S:h==="vs"?M:n}return w.isMacintosh&&f.toUpperCase()===n&&(f="#171717"),f}};m=de([re(0,D.IStateService)],m),e.ThemeMainService=m}),define(Q[42],J([0,1,5]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var R;(function(y){y.Uninitialized="uninitialized",y.Idle="idle",y.CheckingForUpdates="checking for updates",y.AvailableForDownload="available for download",y.Downloading="downloading",y.Downloaded="downloaded",y.Updating="updating",y.Ready="ready"})(R=e.StateType||(e.StateType={}));var D;(function(y){y[y.Setup=0]="Setup",y[y.Archive=1]="Archive",y[y.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(y,M)=>({type:"idle",updateType:y,error:M}),CheckingForUpdates:y=>({type:"checking for updates",context:y}),AvailableForDownload:y=>({type:"available for download",update:y}),Downloading:y=>({type:"downloading",update:y}),Downloaded:y=>({type:"downloaded",update:y}),Updating:y=>({type:"updating",update:y}),Ready:y=>({type:"ready",update:y})},e.IUpdateService=w.createDecorator("updateService")}),define(Q[196],J([0,1,36,46,145,3]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),w.Registry.as(R.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:D.localize(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:D.localize(1,null),tags:["usesOnlineServices"],enumDescriptions:[D.localize(2,null),D.localize(3,null),D.localize(4,null),D.localize(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:D.localize(6,null),deprecationMessage:D.localize(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:D.localize(8,null),description:D.localize(9,null),included:y.isWindows&&!y.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:D.localize(10,null),tags:["usesOnlineServices"]}}})}),define(Q[197],J([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannel=void 0;class w{constructor(D){this.service=D}listen(D,y){switch(y){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${y}`)}call(D,y,M){switch(y){case"checkForUpdates":return this.service.checkForUpdates(M);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${y}`)}}e.UpdateChannel=w}),define(Q[92],J([0,1,5]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=w.createDecorator("urlService")}),define(Q[198],J([0,1,7]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class R{constructor(n){this.handler=n}listen(n,S){throw new Error(`Event not found: ${S}`)}call(n,S,i){switch(S){case"handleURL":return this.handler.handleURL(w.URI.revive(i[0]),i[1])}throw new Error(`Call not found: ${S}`)}}e.URLHandlerChannel=R;class D{constructor(n){this.channel=n}handleURL(n,S){return this.channel.call("handleURL",[n.toJSON(),S])}}e.URLHandlerChannelClient=D;class y{constructor(n){this.next=n}async routeCall(n,S,i,E){if(S!=="handleURL")throw new Error(`Call not found: ${S}`);if(i){const m=w.URI.revive(i);if(m&&m.query){const P=/\bwindowId=(\d+)/.exec(m.query);if(P){const f=P[1],h=new RegExp(`window:${f}`),v=n.connections.find(p=>h.test(p.ctx));if(v)return v}}}return this.next.routeCall(n,S,i,E)}routeEvent(n,S){throw new Error(`Event not found: ${S}`)}}e.URLHandlerRouter=y}),define(Q[199],J([0,1,7,9,2,15]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends D.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(i,E){const m=[...this.handlers.values()];return R.first(m.map(P=>()=>P.handleURL(i,E)),void 0,!1).then(P=>P||!1)}registerHandler(i){return this.handlers.add(i),D.toDisposable(()=>this.handlers.delete(i))}}e.AbstractURLService=M;class n extends M{create(i){let{authority:E,path:m,query:P,fragment:f}=i||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return E&&m&&m.indexOf("/")!==0&&(m=`/${m}`),w.URI.from({scheme:y.default.urlProtocol,authority:E,path:m,query:P,fragment:f})}}e.NativeURLService=n}),define(Q[200],J([0,1,4,15,11,7,2,3,9]),function($,e,w,R,D,y,M,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function i(m){try{return y.URI.parse(m)}catch(P){return null}}class E{constructor(P,f,h,v){if(this.urlService=f,this.uris=[],this.retryCount=0,this.flushDisposable=M.Disposable.None,this.disposables=new M.DisposableStore,this.uris=P,n.isWindows){const l=v.isBuilt?[]:[`"${v.appRoot}"`];l.push("--open-url","--"),D.app.setAsDefaultProtocolClient(R.default.urlProtocol,process.execPath,l)}const p=w.Event.map(w.Event.fromNodeEventEmitter(D.app,"open-url",(l,a)=>({event:l,url:a})),({event:l,url:a})=>(l.preventDefault(),a));this.disposables.add(p(l=>{const a=i(l);!a||this.urlService.open(a,{originalUrl:l})})),h.getWindows().filter(l=>l.isReady).length>0?this.flush():w.Event.once(h.onWindowReady)(this.flush,this,this.disposables)}async flush(){if(!(this.retryCount++>10)){const P=[];for(const f of this.uris)await this.urlService.open(f.uri,{originalUrl:f.url})||P.push(f);P.length!==0&&(this.uris=P,this.flushDisposable=S.disposableTimeout(()=>this.flush(),500))}}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=E}),define(Q[201],J([0,1,107,6]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWebviewContentMimeType=void 0;const D=new Map([[".svg","image/svg+xml"],[".txt","text/plain"],[".css","text/css"],[".js","application/javascript"],[".json","application/json"],[".html","text/html"],[".htm","text/html"],[".xhtml","application/xhtml+xml"],[".oft","font/otf"],[".xml","application/xml"]]);function y(M){const n=R.extname(M.fsPath).toLowerCase();return D.get(n)||w.getMediaMime(M.fsPath)||w.MIME_UNKNOWN}e.getWebviewContentMimeType=y}),define(Q[93],J([0,1,24,28,10,6,7,201]),function($,e,w,R,D,y,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.loadLocalResource=e.WebviewResourceResponse=e.webviewPartitionId=void 0,e.webviewPartitionId="webview";var S;(function(f){let h;(function(p){p[p.Success=0]="Success",p[p.Failed=1]="Failed",p[p.AccessDenied=2]="AccessDenied"})(h=f.Type||(f.Type={}));class v{constructor(b,l,a){this.stream=b,this.etag=l,this.mimeType=a,this.type=h.Success}}f.StreamSuccess=v,f.Failed={type:h.Failed},f.AccessDenied={type:h.AccessDenied}})(S=e.WebviewResourceResponse||(e.WebviewResourceResponse={}));async function i(f,h,v,p,b){b.debug(`loadLocalResource - being. requestUri=${f}`);let l=E(f,h.roots);if(b.debug(`loadLocalResource - found resource to load. requestUri=${f}, resourceToLoad=${l}`),!l)return S.AccessDenied;const a=n.getWebviewContentMimeType(f);if(h.rewriteUri&&(l=h.rewriteUri(l)),l.scheme===D.Schemas.http||l.scheme===D.Schemas.https){const s=await p.request({url:l.toString(!0)},w.CancellationToken.None);return b.debug(`loadLocalResource - Loaded over http(s). requestUri=${f}, response=${s.res.statusCode}`),s.res.statusCode===200?new S.StreamSuccess(s.stream,void 0,a):S.Failed}try{const s=await v.readFileStream(l);return b.debug(`loadLocalResource - Loaded using fileReader. requestUri=${f}`),new S.StreamSuccess(s.stream,s.etag,a)}catch(s){return b.debug(`loadLocalResource - Error using fileReader. requestUri=${f}`),console.log(s),S.Failed}}e.loadLocalResource=i;function E(f,h){const v=m(f);for(const p of h)if(P(p,v))return v}function m(f){return f.scheme===D.Schemas.vscodeWebviewResource?M.URI.parse(encodeURIComponent(f.path).replace(/%2F/gi,"/").replace(/^\/([a-z0-9\-]+)(\/{1,2})/i,(v,p,b)=>b.length===1?`${p}:///`:`${p}://`)).with({query:f.query,fragment:f.fragment}):f}function P(f,h){let v=f.fsPath+(f.fsPath.endsWith(y.sep)?"":y.sep),p=h.fsPath;return R.isUNC(f.fsPath)&&R.isUNC(h.fsPath)&&(v=v.toLowerCase(),p=p.toLowerCase()),p.startsWith(v)}}),define(Q[202],J([0,1,5]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=w.createDecorator("webviewManagerService")}),define(Q[203],J([0,1,10,7,55]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewPortMappingManager=void 0;class y{constructor(n,S,i){this._getExtensionLocation=n,this._getMappings=S,this.tunnelService=i,this._tunnels=new Map}async getRedirect(n,S){const i=R.URI.parse(S),E=D.extractLocalHostUriMetaDataForPortMapping(i);if(!!E){for(const m of this._getMappings())if(m.webviewPort===E.port){const P=this._getExtensionLocation();if(P&&P.scheme===w.Schemas.vscodeRemote){const f=n&&await this.getOrCreateTunnel(n,m.extensionHostPort);if(f)return f.tunnelLocalPort===m.webviewPort?void 0:encodeURI(i.with({authority:`127.0.0.1:${f.tunnelLocalPort}`}).toString(!0))}if(m.webviewPort!==m.extensionHostPort)return encodeURI(i.with({authority:`${E.address}:${m.extensionHostPort}`}).toString(!0))}}}async dispose(){for(const n of this._tunnels.values())await n.dispose();this._tunnels.clear()}async getOrCreateTunnel(n,S){const i=this._tunnels.get(S);if(i)return i;const E=await this.tunnelService.openTunnel({getAddress:async()=>n},void 0,S);return E&&this._tunnels.set(S,E),E}}e.WebviewPortMappingManager=y}),define(Q[204],J([0,1,11,2,7,55,93,203]),function($,e,w,R,D,y,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewPortMappingProvider=void 0;let S=class extends R.Disposable{constructor(E){super();this._tunnelService=E,this._webviewData=new Map,w.session.fromPartition(M.webviewPartitionId).webRequest.onBeforeRequest({urls:["*://localhost:*/*","*://127.0.0.1:*/*","*://0.0.0.0:*/*"]},async(P,f)=>{let h;try{h=D.URI.parse(P.lastCommittedOrigin)}catch(l){return f({})}const v=h.authority,p=this._webviewData.get(v);if(!p)return f({});const b=await p.manager.getRedirect(p.metadata.resolvedAuthority,P.url);return f(b?{redirectURL:b}:{})})}async registerWebview(E,m){const P=new n.WebviewPortMappingManager(()=>{var f;return(f=this._webviewData.get(E))===null||f===void 0?void 0:f.metadata.extensionLocation},()=>{var f;return((f=this._webviewData.get(E))===null||f===void 0?void 0:f.metadata.mappings)||[]},this._tunnelService);this._webviewData.set(E,{metadata:m,manager:P})}unregisterWebview(E){const m=this._webviewData.get(E);m&&(m.manager.dispose(),this._webviewData.delete(E))}async updateWebviewMetadata(E,m){const P=this._webviewData.get(E);P&&this._webviewData.set(E,Object.assign(Object.assign({},P),m))}};S=de([re(0,y.ITunnelService)],S),e.WebviewPortMappingProvider=S}),define(Q[61],J([0,1,3]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(i){return!!i.workspaceUri}e.isWorkspaceToOpen=R;function D(i){return!!i.folderUri}e.isFolderToOpen=D;function y(i){return!!i.fileUri}e.isFileToOpen=y;function M(i){const E=n(i),m=i.getValue("window.menuBarVisibility");return E==="native"&&m==="compact"?"default":m}e.getMenuBarVisibility=M;function n(i){if(w.isWeb)return"custom";const E=i.getValue("window");if(E){if(w.isMacintosh&&E.nativeTabs===!0||w.isMacintosh&&E.nativeFullScreen===!1)return"native";const f=E.titleBarStyle;if(f==="native"||f==="custom")return f}return w.isLinux?"native":"custom"}e.getTitleBarStyle=n;function S(i=0){return Math.pow(1.2,i)}e.zoomLevelToZoomFactor=S}),define(Q[34],J([0,1,5]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowMode=e.OpenContext=void 0;var R;(function(y){y[y.CLI=0]="CLI",y[y.DOCK=1]="DOCK",y[y.MENU=2]="MENU",y[y.DIALOG=3]="DIALOG",y[y.DESKTOP=4]="DESKTOP",y[y.API=5]="API"})(R=e.OpenContext||(e.OpenContext={}));var D;(function(y){y[y.Maximized=0]="Maximized",y[y.Normal=1]="Normal",y[y.Minimized=2]="Minimized",y[y.Fullscreen=3]="Fullscreen"})(D=e.WindowMode||(e.WindowMode={})),e.IWindowsMainService=w.createDecorator("windowsMainService")}),define(Q[205],J([0,1,11,234,20,2,10,7,21,8,39,93,34]),function($,e,w,R,D,y,M,n,S,i,E,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;let f=class Ft extends y.Disposable{constructor(v,p,b,l){super();this.fileService=v,this.logService=p,this.requestService=b,this.windowsMainService=l,this.webviewMetadata=new Map,this.requestIdPool=1,this.pendingResourceReads=new Map;const a=w.session.fromPartition(m.webviewPartitionId),s=this.handleWebviewRequest.bind(this);w.protocol.registerFileProtocol(M.Schemas.vscodeWebview,s),a.protocol.registerFileProtocol(M.Schemas.vscodeWebview,s);const u=this.handleWebviewResourceRequest.bind(this);w.protocol.registerStreamProtocol(M.Schemas.vscodeWebviewResource,u),a.protocol.registerStreamProtocol(M.Schemas.vscodeWebviewResource,u),this._register(y.toDisposable(()=>{w.protocol.unregisterProtocol(M.Schemas.vscodeWebviewResource),a.protocol.unregisterProtocol(M.Schemas.vscodeWebviewResource),w.protocol.unregisterProtocol(M.Schemas.vscodeWebview),a.protocol.unregisterProtocol(M.Schemas.vscodeWebview)}))}streamToNodeReadable(v){return new class extends R.Readable{constructor(){super(...arguments);this.listening=!1}_read(p){this.listening||(this.listening=!0,v.on("data",b=>{try{this.push(b.buffer)||v.pause()}catch(l){this.emit(l)}}),v.on("end",()=>{try{this.push(null)}catch(b){this.emit(b)}}),v.on("error",b=>this.emit("error",b))),v.resume()}_destroy(p,b){v.destroy(),b(null)}}}async registerWebview(v,p){this.webviewMetadata.set(v,p)}unregisterWebview(v){this.webviewMetadata.delete(v)}async updateWebviewMetadata(v,p){const b=this.webviewMetadata.get(v);b&&this.webviewMetadata.set(v,Object.assign(Object.assign({},b),p))}async handleWebviewRequest(v,p){try{const b=n.URI.parse(v.url),l=Ft.validWebviewFilePaths.get(b.path);if(typeof l=="string"){const a=b.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${l}`:`vs/workbench/contrib/webview/browser/pre/${l}`,s=M.FileAccess.asFileUri(a,$);return p(decodeURIComponent(s.fsPath))}}catch(b){}p({error:-10})}async handleWebviewResourceRequest(v,p){try{const b=n.URI.parse(v.url),l=b.authority,a=this.webviewMetadata.get(l);if(a){let s;a.remoteConnectionData&&(s=r=>{var o;return a.remoteConnectionData&&(r.scheme===M.Schemas.vscodeRemote||((o=a.extensionLocation)===null||o===void 0?void 0:o.scheme)===M.Schemas.vscodeRemote)?n.URI.parse(`http://${a.remoteConnectionData.host}:${a.remoteConnectionData.port}`).with({path:"/vscode-remote-resource",query:`tkn=${a.remoteConnectionData.connectionToken}&path=${encodeURIComponent(r.path)}`}):r});const u={readFileStream:async r=>{if(r.scheme===M.Schemas.file){const I=await this.fileService.readFileStream(r);return{stream:I.value,etag:I.etag}}const o=this.windowsMainService.getWindowById(a.windowId);if(!o)throw new S.FileOperationError("Could not find window for resource",1);const d=this.requestIdPool++,c=new Promise(I=>{this.pendingResourceReads.set(d,{resolve:I})});o.send(`vscode:loadWebviewResource-${l}`,d,b);const g=await c;if(!g)throw new S.FileOperationError("Could not read file",1);return{stream:D.bufferToStream(g),etag:void 0}}},t=await m.loadLocalResource(b,{extensionLocation:a.extensionLocation,roots:a.localResourceRoots,remoteConnectionData:a.remoteConnectionData,rewriteUri:s},u,this.requestService,this.logService);if(t.type===m.WebviewResourceResponse.Type.Success){const r=t.etag?{ETag:t.etag,"Cache-Control":"no-cache"}:{},o=v.headers["If-None-Match"];return o&&t.etag===o?p({statusCode:304,data:void 0,headers:Object.assign({"Content-Type":t.mimeType,"Access-Control-Allow-Origin":"*"},r)}):p({statusCode:200,data:this.streamToNodeReadable(t.stream),headers:Object.assign({"Content-Type":t.mimeType,"Access-Control-Allow-Origin":"*"},r)})}if(t.type===m.WebviewResourceResponse.Type.AccessDenied)return console.error("Webview: Cannot load resource outside of protocol root"),p({data:void 0,statusCode:401})}}catch(b){}return p({data:void 0,statusCode:404})}didLoadResource(v,p){const b=this.pendingResourceReads.get(v);if(!b)throw new Error("Unknown request");this.pendingResourceReads.delete(v),b.resolve(p)}};f.validWebviewFilePaths=new Map([["/index.html","index.html"],["/electron-browser/index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"]]),f=de([re(0,S.IFileService),re(1,i.ILogService),re(2,E.IRequestService),re(3,P.IWindowsMainService)],f),e.WebviewProtocolProvider=f}),define(Q[206],J([0,1,11,2,7,21,8,55,39,204,205,34]),function($,e,w,R,D,y,M,n,S,i,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends R.Disposable{constructor(h,v,p,b,l){super();this.windowsMainService=l,this.protocolProvider=this._register(new E.WebviewProtocolProvider(h,v,p,l)),this.portMappingProvider=this._register(new i.WebviewPortMappingProvider(b))}async registerWebview(h,v,p){const b=p.extensionLocation?D.URI.from(p.extensionLocation):void 0;this.protocolProvider.registerWebview(h,Object.assign(Object.assign({},p),{windowId:v,extensionLocation:b,localResourceRoots:p.localResourceRoots.map(l=>D.URI.from(l))})),this.portMappingProvider.registerWebview(h,{extensionLocation:b,mappings:p.portMappings,resolvedAuthority:p.remoteConnectionData})}async unregisterWebview(h){this.protocolProvider.unregisterWebview(h),this.portMappingProvider.unregisterWebview(h)}async updateWebviewMetadata(h,v){var p;const b=v.extensionLocation?D.URI.from(v.extensionLocation):void 0;this.protocolProvider.updateWebviewMetadata(h,Object.assign(Object.assign({},v),{extensionLocation:b,localResourceRoots:(p=v.localResourceRoots)===null||p===void 0?void 0:p.map(l=>D.URI.from(l))})),this.portMappingProvider.updateWebviewMetadata(h,Object.assign(Object.assign({},v),{extensionLocation:b}))}async setIgnoreMenuShortcuts(h,v){let p;if(typeof h.windowId=="number"){const{windowId:b}=h,l=this.windowsMainService.getWindowById(b);if(!l)throw new Error(`Invalid windowId: ${b}`);p=l.win.webContents}else{const{webContentsId:b}=h;if(p=w.webContents.fromId(b),!p)throw new Error(`Invalid webContentsId: ${b}`)}p.isDestroyed()||p.setIgnoreMenuShortcuts(v)}async didLoadResource(h,v){this.protocolProvider.didLoadResource(h,v)}};P=de([re(0,y.IFileService),re(1,M.ILogService),re(2,S.IRequestService),re(3,n.ITunnelService),re(4,m.IWindowsMainService)],P),e.WebviewMainService=P}),define(Q[207],J([0,1,4,2,9]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class y extends R.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:S,getActiveWindowId:i}){super();this.disposables=this._register(new R.DisposableStore),w.Event.latch(w.Event.any(n,S))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=D.createCancelablePromise(()=>i()),(async()=>{try{const m=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:m}catch(m){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=y}),define(Q[208],J([0,1,7,18,5,35]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=D.createDecorator("contextService");var M;(function(P){P[P.EMPTY=1]="EMPTY",P[P.FOLDER=2]="FOLDER",P[P.WORKSPACE=3]="WORKSPACE"})(M=e.WorkbenchState||(e.WorkbenchState={}));function n(P){const f=P;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=n;function S(P){const f=P;return!!(f&&typeof f=="object"&&w.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=S;class i{constructor(f,h,v,p){this._id=f,this._configuration=v,this._ignorePathCasing=p,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=i;class E{constructor(f,h){this.raw=h,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return R.joinPath(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=E;function m(P){return new E({uri:P,index:0,name:R.basenameOrAuthority(P)},{uri:P.toString()})}e.toWorkspaceFolder=m}),define(Q[31],J([0,1,5,147,208,7,3,6,18,99,40,10,38,28,87]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:R.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(ee){return(typeof ee=="string"?n.extname(ee):S.extname(ee))===v}e.hasWorkspaceFileExtension=p,e.IWorkspacesService=w.createDecorator("workspacesService");function b(ee){return ee.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function l(ee){return ee.hasOwnProperty("folderUri")}e.isRecentFolder=l;function a(ee){return ee.hasOwnProperty("fileUri")}e.isRecentFile=a;function s(ee){const Z=ee;return typeof(Z==null?void 0:Z.id)=="string"&&y.URI.isUri(Z.uri)}e.isSingleFolderWorkspaceIdentifier=s;function u(ee){if(ee.configuration)return{id:ee.id,configPath:ee.configuration};if(ee.folders.length===1)return{id:ee.id,uri:ee.folders[0].uri}}e.toWorkspaceIdentifier=u;function t(ee){const Z=ee;return typeof(Z==null?void 0:Z.id)=="string"&&y.URI.isUri(Z.configPath)}e.isWorkspaceIdentifier=t;function r(ee){if(ee==null?void 0:ee.uri)return{id:ee.id,uri:y.URI.revive(ee.uri)};if(ee==null?void 0:ee.configPath)return{id:ee.id,configPath:y.URI.revive(ee.configPath)}}e.reviveIdentifier=r;function o(ee,Z){return S.extUriBiasedIgnorePathCase.isEqualOrParent(ee,Z.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function d(ee){return c(ee)||g(ee)}e.isStoredWorkspaceFolder=d;function c(ee){const Z=ee;return typeof(Z==null?void 0:Z.path)=="string"&&(!Z.name||typeof Z.name=="string")}e.isRawFileWorkspaceFolder=c;function g(ee){const Z=ee;return typeof(Z==null?void 0:Z.uri)=="string"&&(!Z.name||typeof Z.name=="string")}e.isRawUriWorkspaceFolder=g;function I(ee,Z,H,N,q=!M.isWindows,F){if(ee.scheme!==N.scheme)return{name:H,uri:ee.toString(!0)};let z=Z?void 0:F.relativePath(N,ee);if(z!==void 0)z.length===0?z=".":M.isWindows&&ee.scheme===m.Schemas.file&&!q&&(z=z.replace(/\//g,"\\"));else if(ee.scheme===m.Schemas.file)z=ee.fsPath,M.isWindows&&(z=P.normalizeDriveLetter(z),q&&(z=f.toSlashes(z)));else{if(!F.isEqualAuthority(ee.authority,N.authority))return{name:H,uri:ee.toString(!0)};z=ee.path}return{name:H,path:z}}e.getStoredWorkspaceFolder=I;function A(ee,Z,H){let N=[],q=new Set;const F=H.dirname(Z);for(let z of ee){let O=null;if(c(z))z.path&&(O=H.resolvePath(F,z.path));else if(g(z))try{O=y.URI.parse(z.uri),O.path[0]!=="/"&&(O=O.with({path:"/"+O.path}))}catch(k){console.warn(k)}if(O){let k=H.getComparisonKey(O);if(!q.has(k)){q.add(k);const L=z.name||H.basenameOrAuthority(O);N.push(new D.WorkspaceFolder({uri:O,name:L,index:N.length},z))}}}return N}e.toWorkspaceFolders=A;function T(ee,Z,H,N,q){let F=U(Z,ee);const z=q.dirname(Z),O=q.dirname(N),k=[],L=j(F.folders);for(const K of F.folders){const X=c(K)?q.resolvePath(z,K.path):y.URI.parse(K.uri);let Y;H?Y=!1:Y=!c(K)||n.isAbsolute(K.path),k.push(I(X,Y,K.name,O,L,q))}const _={insertSpaces:!1,tabSize:4,eol:M.isLinux||M.isMacintosh?`
`:`\r
`},W=i.setProperty(ee,["folders"],k,_);let B=i.applyEdits(ee,W);return F.remoteAuthority===h.getRemoteAuthority(N)&&(B=i.applyEdits(B,i.removeProperty(B,["remoteAuthority"],_))),B}e.rewriteWorkspaceFileForNewLocation=T;function U(ee,Z){let H=E.parse(Z);if(H&&Array.isArray(H.folders))H.folders=H.folders.filter(N=>d(N));else throw new Error(`${ee} looks like an invalid workspace file.`);return H}function j(ee){return M.isWindows?ee.some(Z=>c(Z)&&Z.path.indexOf("/")>=0):!0}e.useSlashForPath=j;function C(ee,Z){const H={workspaces:[],files:[]};if(ee){const N=function(F,z){for(let O=0;O<F.length;O++)try{z(F[O],O)}catch(k){Z.warn(`Error restoring recent entry ${JSON.stringify(F[O])}: ${k.toString()}. Skip entry.`)}},q=ee;Array.isArray(q.workspaces3)&&N(q.workspaces3,(F,z)=>{const O=Array.isArray(q.workspaceLabels)&&q.workspaceLabels[z]||void 0;typeof F=="object"&&typeof F.id=="string"&&typeof F.configURIPath=="string"?H.workspaces.push({label:O,workspace:{id:F.id,configPath:y.URI.parse(F.configURIPath)}}):typeof F=="string"&&H.workspaces.push({label:O,folderUri:y.URI.parse(F)})}),Array.isArray(q.files2)&&N(q.files2,(F,z)=>{const O=Array.isArray(q.fileLabels)&&q.fileLabels[z]||void 0;typeof F=="string"&&H.files.push({label:O,fileUri:y.URI.parse(F)})})}return H}e.restoreRecentlyOpened=C;function x(ee){const Z={workspaces3:[],files2:[]};let H=!1;const N=[];for(const F of ee.workspaces)l(F)?Z.workspaces3.push(F.folderUri.toString()):Z.workspaces3.push({id:F.workspace.id,configURIPath:F.workspace.configPath.toString()}),N.push(F.label||null),H=H||!!F.label;H&&(Z.workspaceLabels=N),H=!1;const q=[];for(const F of ee.files)Z.files2.push(F.fileUri.toString()),q.push(F.label||null),H=H||!!F.label;return H&&(Z.fileLabels=q),Z}e.toStoreData=x}),define(Q[47],J([0,1,5,31]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=w.createDecorator("backupMainService");function D(y){const M=y;return M&&R.isWorkspaceIdentifier(M.workspace)}e.isWorkspaceBackupInfo=D}),define(Q[48],J([0,1,5,11,9,37,3,6,65,26,14,132,31,38]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=w.createDecorator("dialogMainService");let h=class wt{constructor(p){this.stateService=p,this.mapWindowToDialogQueue=new Map,this.noWindowDialogQueue=new D.Queue}pickFileFolder(p,b){return this.doPick(Object.assign(Object.assign({},p),{pickFolders:!0,pickFiles:!0,title:m.localize(0,null)}),b)}pickFolder(p,b){return this.doPick(Object.assign(Object.assign({},p),{pickFolders:!0,title:m.localize(1,null)}),b)}pickFile(p,b){return this.doPick(Object.assign(Object.assign({},p),{pickFiles:!0,title:m.localize(2,null)}),b)}pickWorkspace(p,b){const l=m.localize(3,null),a=f.mnemonicButtonLabel(m.localize(4,null)),s=P.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},p),{pickFiles:!0,title:l,filters:s,buttonLabel:a}),b)}async doPick(p,b){const l={title:p.title,buttonLabel:p.buttonLabel,filters:p.filters};l.defaultPath=p.defaultPath||this.stateService.getItem(wt.workingDirPickerStorageKey),(typeof p.pickFiles=="boolean"||typeof p.pickFolders=="boolean")&&(l.properties=void 0,p.pickFiles&&p.pickFolders&&(l.properties=["multiSelections","openDirectory","openFile","createDirectory"])),l.properties||(l.properties=["multiSelections",p.pickFolders?"openDirectory":"openFile","createDirectory"]),M.isMacintosh&&l.properties.push("treatPackageAsDirectory");const a=b||R.BrowserWindow.getFocusedWindow(),s=await this.showOpenDialog(l,E.withNullAsUndefined(a));if(s&&s.filePaths&&s.filePaths.length>0)return this.stateService.setItem(wt.workingDirPickerStorageKey,n.dirname(s.filePaths[0])),s.filePaths}getDialogQueue(p){if(!p)return this.noWindowDialogQueue;let b=this.mapWindowToDialogQueue.get(p.id);return b||(b=new D.Queue,this.mapWindowToDialogQueue.set(p.id,b)),b}showMessageBox(p,b){return this.getDialogQueue(b).queue(async()=>b?R.dialog.showMessageBox(b,p):R.dialog.showMessageBox(p))}showSaveDialog(p,b){function l(a){return a&&M.isMacintosh&&(a=S.normalizeNFC(a)),a}return this.getDialogQueue(b).queue(async()=>{let a;return b?a=await R.dialog.showSaveDialog(b,p):a=await R.dialog.showSaveDialog(p),a.filePath=l(a.filePath),a})}showOpenDialog(p,b){function l(a){return a&&a.length>0&&M.isMacintosh&&(a=a.map(s=>S.normalizeNFC(s))),a}return this.getDialogQueue(b).queue(async()=>{p.defaultPath&&(await i.exists(p.defaultPath)||(p.defaultPath=void 0));let a;return b?a=await R.dialog.showOpenDialog(b,p):a=await R.dialog.showOpenDialog(p),a.filePaths=l(a.filePaths),a})}};h.workingDirPickerStorageKey="pickerWorkingDir",h=de([re(0,y.IStateService)],h),e.DialogMainService=h}),define(Q[94],J([0,1,7,31,18]),function($,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function y(S,i,E){for(const P of S){const f=P.openedWorkspace;if(R.isWorkspaceIdentifier(f)){const h=E(f);if(h){if(h.folders.some(v=>D.extUriBiasedIgnorePathCase.isEqualOrParent(i,v.uri)))return P}else if(D.extUriBiasedIgnorePathCase.isEqualOrParent(i,f.configPath))return P}}const m=S.filter(P=>R.isSingleFolderWorkspaceIdentifier(P.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqualOrParent(i,P.openedWorkspace.uri));if(m.length)return m.sort((P,f)=>-(P.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=y;function M(S,i){for(const E of S)if(R.isWorkspaceIdentifier(E.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqual(E.openedWorkspace.configPath,i)||R.isSingleFolderWorkspaceIdentifier(E.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqual(E.openedWorkspace.uri,i))return E}e.findWindowOnWorkspaceOrFolder=M;function n(S,i){var E,m;const P=f=>i.some(h=>D.extUriBiasedIgnorePathCase.isEqual(w.URI.file(h),w.URI.file(f)));for(const f of S)if((m=(E=f.config)===null||E===void 0?void 0:E.extensionDevelopmentPath)===null||m===void 0?void 0:m.some(h=>P(h)))return f}e.findWindowOnExtensionDevelopmentPath=n}),define(Q[49],J([0,1,57,58,209,4,33,6,27,29,2,20,78,16,3]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(I){this.socket=I}dispose(){this.socket.destroy()}onData(I){const A=T=>I(m.VSBuffer.wrap(T));return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(I){return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(I){return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(I){if(!this.socket.destroyed)try{this.socket.write(I.buffer)}catch(A){if(A.code==="EPIPE")return;f.onUnexpectedError(A)}}end(){this.socket.end()}drain(){return new Promise((I,A)=>{if(this.socket.bufferSize===0){I();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),I()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=v;var p;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize"})(p||(p={}));var b;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(b||(b={}));class l extends E.Disposable{constructor(I,A,T,U){super();this._onDidZlibFlush=this._register(new y.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=I,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=A,this._recordInflateBytes=U,A?(this._zlibInflate=D.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",j=>{console.error(j),f.onUnexpectedError(j),this._onClose.fire()}),this._zlibInflate.on("data",j=>{this._pendingInflateData.push(j)}),T&&(this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=D.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",j=>{console.error(j),f.onUnexpectedError(j),this._onClose.fire()}),this._zlibDeflate.on("data",j=>{this._pendingDeflateData.push(j)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new P.ChunkStream,this._register(this.socket.onData(j=>this._acceptChunk(j))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?m.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):m.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._totalOutgoingDataBytes+=I.byteLength,this._zlibDeflate?(this._zlibDeflate.write(I.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let A=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,A=A.slice(0,A.length-4),this._isEnded||this._write(m.VSBuffer.wrap(A),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(I,!1)}_write(I,A){let T=2;I.byteLength<126?T+=0:I.byteLength<2**16?T+=2:T+=8;const U=m.VSBuffer.alloc(T);if(A?U.writeUInt8(194,0):U.writeUInt8(130,0),I.byteLength<126)U.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){U.writeUInt8(126,1);let j=1;U.writeUInt8(I.byteLength>>>8&255,++j),U.writeUInt8(I.byteLength>>>0&255,++j)}else{U.writeUInt8(127,1);let j=1;U.writeUInt8(0,++j),U.writeUInt8(0,++j),U.writeUInt8(0,++j),U.writeUInt8(0,++j),U.writeUInt8(I.byteLength>>>24&255,++j),U.writeUInt8(I.byteLength>>>16&255,++j),U.writeUInt8(I.byteLength>>>8&255,++j),U.writeUInt8(I.byteLength>>>0&255,++j)}this._totalOutgoingWireBytes+=U.byteLength+I.byteLength,this.socket.write(m.VSBuffer.concat([U,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._totalIncomingWireBytes+=I.byteLength,this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const A=this._incomingData.peek(this._state.readLen),U=(A.readUInt8(0)&128)>>>7,j=A.readUInt8(1),C=(j&128)>>>7,x=j&127;this._state.state=2,this._state.readLen=2+(C?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=U,this._state.mask=0}else if(this._state.state===2){const A=this._incomingData.read(this._state.readLen),T=A.readUInt8(1),U=(T&128)>>>7;let j=T&127,C=1;j===126?j=A.readUInt8(++C)*2**8+A.readUInt8(++C):j===127&&(j=A.readUInt8(++C)*0+A.readUInt8(++C)*0+A.readUInt8(++C)*0+A.readUInt8(++C)*0+A.readUInt8(++C)*2**24+A.readUInt8(++C)*2**16+A.readUInt8(++C)*2**8+A.readUInt8(++C));let x=0;U&&(x=A.readUInt8(++C)*2**24+A.readUInt8(++C)*2**16+A.readUInt8(++C)*2**8+A.readUInt8(++C)),this._state.state=3,this._state.readLen=j,this._state.mask=x}else if(this._state.state===3){const A=this._incomingData.read(this._state.readLen);a(A,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(A.buffer)),this._zlibInflate.write(A.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const T=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=T.length,this._onData.fire(m.VSBuffer.wrap(T))})):(this._totalIncomingDataBytes+=A.byteLength,this._onData.fire(A))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await y.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=l;function a(g,I){if(I!==0){let A=g.byteLength>>>2;for(let ee=0;ee<A;ee++){const Z=g.readUInt32BE(ee*4);g.writeUInt32BE(Z^I,ee*4)}let T=A*4,U=g.byteLength-T;const j=I>>>24&255,C=I>>>16&255,x=I>>>8&255;U>=1&&g.writeUInt8(g.readUInt8(T)^j,T),U>=2&&g.writeUInt8(g.readUInt8(T+1)^C,T+1),U>=3&&g.writeUInt8(g.readUInt8(T+2)^x,T+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const s={[2]:107,[1]:103};function u(){const g=i.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let I;return e.XDG_RUNTIME_DIR?I=n.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):I=n.join(S.tmpdir(),`vscode-ipc-${g}.sock`),r(I),I}e.createRandomIPCHandle=u;function t(g,I,A){const T=w.createHash("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${A}-${I}-sock`;let U;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=n.join(e.XDG_RUNTIME_DIR,`vscode-${T.substr(0,8)}-${A}-${I}.sock`):U=n.join(g,`${A}-${I}.sock`),r(U),U}e.createStaticIPCHandle=t;function r(g){const I=s[h.platform];typeof I=="number"&&g.length>=I&&console.warn(`WARNING: IPC handle "${g}" is longer than ${I} chars, try a shorter --user-data-dir`)}class o extends M.IPCServer{constructor(I){super(o.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const A=y.Event.fromNodeEventEmitter(I,"connection");return y.Event.map(A,T=>({protocol:new P.Protocol(new v(T)),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(T,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function d(g){return new Promise((I,A)=>{const T=R.createServer();T.on("error",A),T.listen(g,()=>{T.removeListener("error",A),I(new o(T))})})}e.serve=d;function c(g,I){return new Promise((A,T)=>{const U=R.createConnection(g,()=>{U.removeListener("error",T),A(P.Client.fromSocket(new v(U),I))});U.once("error",T)})}e.connect=c}),define(Q[210],J([0,1,49]),function($,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverChannelClient=e.WindowDriverChannel=e.WindowDriverRegistryChannelClient=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class R{constructor(m){this.driver=m}listen(m,P){throw new Error("No event found")}call(m,P,f){switch(P){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(f);case"reloadWindow":return this.driver.reloadWindow(f);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(f[0],f[1]);case"click":return this.driver.click(f[0],f[1],f[2],f[3]);case"doubleClick":return this.driver.doubleClick(f[0],f[1]);case"setValue":return this.driver.setValue(f[0],f[1],f[2]);case"getTitle":return this.driver.getTitle(f[0]);case"isActiveElement":return this.driver.isActiveElement(f[0],f[1]);case"getElements":return this.driver.getElements(f[0],f[1],f[2]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1],f[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f[0],f[1]);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1],f[2])}throw new Error(`Call not found: ${P}`)}}e.DriverChannel=R;class D{constructor(m){this.channel=m}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(m){return this.channel.call("capturePage",m)}reloadWindow(m){return this.channel.call("reloadWindow",m)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(m,P){return this.channel.call("dispatchKeybinding",[m,P])}click(m,P,f,h){return this.channel.call("click",[m,P,f,h])}doubleClick(m,P){return this.channel.call("doubleClick",[m,P])}setValue(m,P,f){return this.channel.call("setValue",[m,P,f])}getTitle(m){return this.channel.call("getTitle",[m])}isActiveElement(m,P){return this.channel.call("isActiveElement",[m,P])}getElements(m,P,f){return this.channel.call("getElements",[m,P,f])}getElementXY(m,P,f,h){return this.channel.call("getElementXY",[m,P,f,h])}typeInEditor(m,P,f){return this.channel.call("typeInEditor",[m,P,f])}getTerminalBuffer(m,P){return this.channel.call("getTerminalBuffer",[m,P])}writeInTerminal(m,P,f){return this.channel.call("writeInTerminal",[m,P,f])}}e.DriverChannelClient=D;class y{constructor(m){this.registry=m}listen(m,P){throw new Error(`Event not found: ${P}`)}call(m,P,f){switch(P){case"registerWindowDriver":return this.registry.registerWindowDriver(f);case"reloadWindowDriver":return this.registry.reloadWindowDriver(f)}throw new Error(`Call not found: ${P}`)}}e.WindowDriverRegistryChannel=y;class M{constructor(m){this.channel=m}registerWindowDriver(m){return this.channel.call("registerWindowDriver",m)}reloadWindowDriver(m){return this.channel.call("reloadWindowDriver",m)}}e.WindowDriverRegistryChannelClient=M;class n{constructor(m){this.driver=m}listen(m,P){throw new Error(`No event found: ${P}`)}call(m,P,f){switch(P){case"click":return this.driver.click(f[0],f[1],f[2]);case"doubleClick":return this.driver.doubleClick(f);case"setValue":return this.driver.setValue(f[0],f[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(f);case"getElements":return this.driver.getElements(f[0],f[1]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1])}throw new Error(`Call not found: ${P}`)}}e.WindowDriverChannel=n;class S{constructor(m){this.channel=m}click(m,P,f){return this.channel.call("click",[m,P,f])}doubleClick(m){return this.channel.call("doubleClick",m)}setValue(m,P){return this.channel.call("setValue",[m,P])}getTitle(){return this.channel.call("getTitle")}isActiveElement(m){return this.channel.call("isActiveElement",m)}getElements(m,P){return this.channel.call("getElements",[m,P])}getElementXY(m,P,f){return this.channel.call("getElementXY",[m,P,f])}typeInEditor(m,P){return this.channel.call("typeInEditor",[m,P])}getTerminalBuffer(m){return this.channel.call("getTerminalBuffer",m)}writeInTerminal(m,P){return this.channel.call("writeInTerminal",[m,P])}}e.WindowDriverChannelClient=S;async function i(E){const m=await w.connect(E,"driverClient"),P=m.getChannel("driver"),f=new D(P);return{client:m,driver:f}}e.connect=i}),define(Q[211],J([0,1,27,110,6,18,51,15,123,10,7,49]),function($,e,w,R,D,y,M,n,S,i,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataDir=e.parsePathArg=e.parseSearchPort=e.parseExtensionHostPort=e.NativeEnvironmentService=void 0;class P{constructor(a){if(this._args=a,!a.logsPath){const s=S.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");a.logsPath=D.join(this.userDataPath,"logs",s)}this.logsPath=a.logsPath}get args(){return this._args}get appRoot(){return D.dirname(i.FileAccess.asFileUri("",$).fsPath)}get userHome(){return E.URI.file(w.homedir())}get userDataPath(){const a=process.env.VSCODE_PORTABLE;return a?D.join(a,"user-data"):b(this._args,process)}get appSettingsHome(){return E.URI.file(D.join(this.userDataPath,"User"))}get tmpDir(){return E.URI.file(w.tmpdir())}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return y.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return y.joinPath(this.userRoamingDataHome,"sync")}get userDataSyncLogResource(){return E.URI.file(D.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return y.joinPath(E.URI.file(D.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return E.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return E.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return y.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return y.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const a=process.env.VSCODE_PORTABLE;return a?E.URI.file(D.join(a,"argv.json")):y.joinPath(this.userHome,n.default.dataFolderName,"argv.json")}get snippetsHome(){return y.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this._args.extensionDevelopmentPath}get untitledWorkspacesHome(){return E.URI.file(D.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return D.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const a=p(this._args["builtin-extensions-dir"],process);return a||D.normalize(D.join(i.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const a=p(this._args["extensions-download-dir"],process);return a||D.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const a=p(this._args["extensions-dir"],process);if(a)return a;const s=process.env.VSCODE_EXTENSIONS;if(s)return s;const u=process.env.VSCODE_PORTABLE;return u?D.join(u,"extensions"):y.joinPath(this.userHome,n.default.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const a=this._args.extensionDevelopmentPath;if(Array.isArray(a))return a.map(s=>/^[^:/?#]+?:\/\//.test(s)?E.URI.parse(s):E.URI.file(D.normalize(s)))}get extensionTestsLocationURI(){const a=this._args.extensionTestsPath;if(a)return/^[^:/?#]+?:\/\//.test(a)?E.URI.parse(a):E.URI.file(D.normalize(a))}get disableExtensions(){if(this._args["disable-extensions"])return!0;const a=this._args["disable-extension"];if(a){if(typeof a=="string")return[a];if(Array.isArray(a)&&a.length>0)return a}return!1}get debugExtensionHost(){return f(this._args,this.isBuilt)}get debugRenderer(){return!!this._args.debugRenderer}get isBuilt(){return!process.env.VSCODE_DEV}get verbose(){return!!this._args.verbose}get logLevel(){return this._args.log}get sharedIPCHandle(){return m.createStaticIPCHandle(this.userDataPath,"shared",n.default.version)}get serviceMachineIdResource(){return y.joinPath(E.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this._args["crash-reporter-id"]}get crashReporterDirectory(){return this._args["crash-reporter-directory"]}get driverHandle(){return this._args.driver}get telemetryLogResource(){return E.URI.file(D.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this._args["disable-telemetry"]}}de([M.memoize],P.prototype,"appRoot",null),de([M.memoize],P.prototype,"userHome",null),de([M.memoize],P.prototype,"userDataPath",null),de([M.memoize],P.prototype,"appSettingsHome",null),de([M.memoize],P.prototype,"tmpDir",null),de([M.memoize],P.prototype,"userRoamingDataHome",null),de([M.memoize],P.prototype,"settingsResource",null),de([M.memoize],P.prototype,"userDataSyncHome",null),de([M.memoize],P.prototype,"userDataSyncLogResource",null),de([M.memoize],P.prototype,"sync",null),de([M.memoize],P.prototype,"machineSettingsResource",null),de([M.memoize],P.prototype,"globalStorageHome",null),de([M.memoize],P.prototype,"workspaceStorageHome",null),de([M.memoize],P.prototype,"keybindingsResource",null),de([M.memoize],P.prototype,"keyboardLayoutResource",null),de([M.memoize],P.prototype,"argvResource",null),de([M.memoize],P.prototype,"snippetsHome",null),de([M.memoize],P.prototype,"isExtensionDevelopment",null),de([M.memoize],P.prototype,"untitledWorkspacesHome",null),de([M.memoize],P.prototype,"installSourcePath",null),de([M.memoize],P.prototype,"builtinExtensionsPath",null),de([M.memoize],P.prototype,"extensionsPath",null),de([M.memoize],P.prototype,"extensionDevelopmentLocationURI",null),de([M.memoize],P.prototype,"extensionTestsLocationURI",null),de([M.memoize],P.prototype,"debugExtensionHost",null),de([M.memoize],P.prototype,"sharedIPCHandle",null),de([M.memoize],P.prototype,"serviceMachineIdResource",null),de([M.memoize],P.prototype,"telemetryLogResource",null),e.NativeEnvironmentService=P;function f(l,a){return v(l["inspect-extensions"],l["inspect-brk-extensions"],5870,a,l.debugId)}e.parseExtensionHostPort=f;function h(l,a){return v(l["inspect-search"],l["inspect-brk-search"],5876,a)}e.parseSearchPort=h;function v(l,a,s,u,t){const o=Number(a||l)||(u?null:s),d=o?Boolean(!!a):!1;return{port:o,break:d,debugId:t}}function p(l,a){if(!!l){const s=D.resolve(l);return D.normalize(l)===s?s:D.resolve(a.env.VSCODE_CWD||a.cwd(),l)}}e.parsePathArg=p;function b(l,a){return p(l["user-data-dir"],a)||D.resolve(R.getDefaultUserDataPath())}e.parseUserDataDir=b}),define(Q[23],J([0,1,6,51,5,211,49,15]),function($,e,w,R,D,y,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=D.createDecorator("nativeEnvironmentService");class S extends y.NativeEnvironmentService{get cachedLanguagesPath(){return w.join(this.userDataPath,"clp")}get backupHome(){return w.join(this.userDataPath,"Backups")}get backupWorkspacesPath(){return w.join(this.backupHome,"workspaces.json")}get mainIPCHandle(){return M.createStaticIPCHandle(this.userDataPath,"main",n.default.version)}get sandbox(){return!!this._args.__sandbox}get driverVerbose(){return!!this._args["driver-verbose"]}get disableUpdates(){return!!this._args["disable-updates"]}get nodeCachedDataDir(){return process.env.VSCODE_NODE_CACHED_DATA_DIR||void 0}}de([R.memoize],S.prototype,"cachedLanguagesPath",null),de([R.memoize],S.prototype,"backupHome",null),de([R.memoize],S.prototype,"backupWorkspacesPath",null),de([R.memoize],S.prototype,"mainIPCHandle",null),de([R.memoize],S.prototype,"sandbox",null),de([R.memoize],S.prototype,"driverVerbose",null),de([R.memoize],S.prototype,"disableUpdates",null),de([R.memoize],S.prototype,"nodeCachedDataDir",null),e.EnvironmentMainService=S}),define(Q[212],J([0,1,11,23,9,8,22,72,10,3,2,79,14]),function($,e,w,R,D,y,M,n,S,i,E,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let f=class extends E.Disposable{constructor(v,p,b,l,a,s){super();this.machineId=v,this.userEnv=p,this.environmentService=b,this.lifecycleMainService=l,this.logService=a,this.themeMainService=s,this.whenSpawnedBarrier=new D.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),w.ipcMain.on("vscode:createSharedProcessMessageChannel",async(v,p)=>{this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),await this.whenReady();const b=await this.connect();if(v.sender.isDestroyed())return b.close();v.sender.postMessage("vscode:createSharedProcessMessageChannelResult",p,[b])})}onWillShutdown(){const v=this.window;!v||(!v.isDestroyed()&&!v.webContents.isDestroyed()&&v.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(v.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{v.close()}catch(p){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(v=>w.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),v()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.whenSpawnedBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(v=>w.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),v()}))})()),this._whenIpcReady}createWindow(){this.window=new w.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:S.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,v8CacheOptions:i.browserCodeLoadingCacheStrategy,nodeIntegration:!0,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}});const v={machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentService.appRoot,nodeCachedDataDir:this.environmentService.nodeCachedDataDir,backupWorkspacesPath:this.environmentService.backupWorkspacesPath,userEnv:this.userEnv,sharedIPCHandle:this.environmentService.sharedIPCHandle,args:this.environmentService.args,logLevel:this.logService.getLevel()};this.window.loadURL(S.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",$).with({query:`config=${encodeURIComponent(JSON.stringify(v))}`}).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=v=>{var p;this.logService.trace("SharedProcess#close prevented"),v.preventDefault(),((p=this.window)===null||p===void 0?void 0:p.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(v,p)=>this.logService.error(`SharedProcess: crashed (detail: ${p==null?void 0:p.reason})`)),this.window.on("unresponsive",()=>this.logService.error("SharedProcess: detected unresponsive window")),this.window.webContents.on("did-fail-load",(v,p,b)=>this.logService.warn("SharedProcess: failed to load window, ",b)))}spawn(v){this.userEnv=Object.assign(Object.assign({},this.userEnv),v),this.whenSpawnedBarrier.open()}async connect(){await this.whenIpcReady;const v=P.assertIsDefined(this.window);return m.connect(v)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}};f=de([re(2,R.IEnvironmentMainService),re(3,M.ILifecycleMainService),re(4,y.ILogService),re(5,n.IThemeMainService)],f),e.SharedProcess=f}),define(Q[213],J([0,1,25,57,6,3,26,47,23,19,21,8,31,7,28,10,18]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let b=class{constructor(a,s,u){this.configurationService=s,this.logService=u,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=p.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,r)=>h.isEqual(t,r,!y.isLinux)},this.backupHome=a.backupHome,this.workspacesJsonPath=a.backupWorkspacesPath}async initialize(){let a;try{a=JSON.parse(await M.readFile(this.workspacesJsonPath,"utf8"))}catch(t){a=Object.create(null)}a.emptyWorkspaceInfos&&(this.emptyWindows=await this.validateEmptyWorkspaces(a.emptyWorkspaceInfos));let s=[];try{Array.isArray(a.rootURIWorkspaces)&&(s=a.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:f.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(s);let u=[];try{Array.isArray(a.folderURIWorkspaces)&&(u=a.folderURIWorkspaces.map(t=>f.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(u),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==E.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===E.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var a;const s=this.configurationService.getValue();return((a=s==null?void 0:s.files)===null||a===void 0?void 0:a.hotExit)||E.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(a,s){this.workspaces.some(t=>a.workspace.id===t.workspace.id)||(this.workspaces.push(a),this.saveSync());const u=this.getBackupPath(a.workspace.id);return s&&this.moveBackupFolderSync(u,s),u}moveBackupFolderSync(a,s){if(w.existsSync(a)&&this.convertToEmptyWindowBackupSync(a),w.existsSync(s))try{w.renameSync(s,a)}catch(u){this.logService.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}unregisterWorkspaceBackupSync(a){const s=a.id,u=this.workspaces.findIndex(t=>t.workspace.id===s);u!==-1&&(this.workspaces.splice(u,1),this.saveSync())}registerFolderBackupSync(a){return this.folders.some(s=>this.backupUriComparer.isEqual(a,s))||(this.folders.push(a),this.saveSync()),this.getBackupPath(this.getFolderHash(a))}unregisterFolderBackupSync(a){const s=this.folders.findIndex(u=>this.backupUriComparer.isEqual(a,u));s!==-1&&(this.folders.splice(s,1),this.saveSync())}registerEmptyWindowBackupSync(a,s){const u=a||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,u))||(this.emptyWindows.push({backupFolder:u,remoteAuthority:s}),this.saveSync()),this.getBackupPath(u)}unregisterEmptyWindowBackupSync(a){const s=this.emptyWindows.findIndex(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,a));s!==-1&&(this.emptyWindows.splice(s,1),this.saveSync())}getBackupPath(a){return D.join(this.backupHome,a)}async validateWorkspaces(a){if(!Array.isArray(a))return[];const s=new Set,u=[];for(let t of a){const r=t.workspace;if(!P.isWorkspaceIdentifier(r))return[];if(!s.has(r.id)){s.add(r.id);const o=this.getBackupPath(r.id);await this.doHasBackups(o)?r.configPath.scheme!==v.Schemas.file||await M.exists(r.configPath.fsPath)?u.push(t):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return u}async validateFolders(a){if(!Array.isArray(a))return[];const s=[],u=new Set;for(let t of a){const r=this.backupUriComparer.getComparisonKey(t);if(!u.has(r)){u.add(r);const o=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(o)?t.scheme!==v.Schemas.file||await M.exists(t.fsPath)?s.push(t):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return s}async validateEmptyWorkspaces(a){if(!Array.isArray(a))return[];const s=[],u=new Set;for(let t of a){const r=t.backupFolder;if(typeof r!="string")return[];if(!u.has(r)){u.add(r);const o=this.getBackupPath(r);await this.doHasBackups(o)?s.push(t):await this.deleteStaleBackup(o)}}return s}async deleteStaleBackup(a){try{await M.exists(a)&&await M.rimraf(a,M.RimRafMode.MOVE)}catch(s){this.logService.error(`Backup: Could not delete stale backup: ${s.toString()}`)}}async convertToEmptyWindowBackup(a){let s=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,s));)s=this.getRandomEmptyWindowId();const u=this.getBackupPath(s);try{await M.rename(a,u)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:s}),!0}convertToEmptyWindowBackupSync(a){let s=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,s));)s=this.getRandomEmptyWindowId();const u=this.getBackupPath(s);try{w.renameSync(a,u)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:s}),!0}async getDirtyWorkspaces(){const a=[];for(const s of this.workspaces)await this.hasBackups(s)&&a.push(s.workspace);for(const s of this.folders)await this.hasBackups(s)&&a.push(s);return a}hasBackups(a){let s;return f.URI.isUri(a)?s=this.getBackupPath(this.getFolderHash(a)):n.isWorkspaceBackupInfo(a)?s=this.getBackupPath(a.workspace.id):s=a.backupFolder,this.doHasBackups(s)}async doHasBackups(a){try{const s=await M.readdir(a);for(const u of s)try{if((await M.readdir(D.join(a,u))).length>0)return!0}catch(t){}}catch(s){}return!1}saveSync(){try{M.writeFileSync(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(a){this.logService.error(`Backup: Could not save workspaces.json: ${a.toString()}`)}}async save(){try{await M.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(a){this.logService.error(`Backup: Could not save workspaces.json: ${a.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(a=>({id:a.workspace.id,configURIPath:a.workspace.configPath.toString(),remoteAuthority:a.remoteAuthority})),folderURIWorkspaces:this.folders.map(a=>a.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(a){let s;return a.scheme===v.Schemas.file?s=y.isLinux?a.fsPath:a.fsPath.toLowerCase():s=a.toString().toLowerCase(),R.createHash("md5").update(s).digest("hex")}};b=de([re(0,S.IEnvironmentMainService),re(1,i.IConfigurationService),re(2,m.ILogService)],b),e.BackupMainService=b}),define(Q[43],J([0,1,4,34,11,22,3,23,48,26,7,30,5,27,66,8,6,15,51,2]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h,v,p,b,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=P.createDecorator("nativeHostMainService");let s=class it extends a.Disposable{constructor(t,r,o,d,c,g,I){super();this.sharedProcess=t,this.windowsMainService=r,this.dialogMainService=o,this.lifecycleMainService=d,this.environmentService=c,this.telemetryService=g,this.logService=I,this.onDidOpenWindow=w.Event.map(this.windowsMainService.onWindowOpened,A=>A.id),this.onDidMaximizeWindow=w.Event.filter(w.Event.fromNodeEventEmitter(D.app,"browser-window-maximize",(A,T)=>T.id),A=>!!this.windowsMainService.getWindowById(A)),this.onDidUnmaximizeWindow=w.Event.filter(w.Event.fromNodeEventEmitter(D.app,"browser-window-unmaximize",(A,T)=>T.id),A=>!!this.windowsMainService.getWindowById(A)),this.onDidBlurWindow=w.Event.filter(w.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(A,T)=>T.id),A=>!!this.windowsMainService.getWindowById(A)),this.onDidFocusWindow=w.Event.any(w.Event.map(w.Event.filter(w.Event.map(this.windowsMainService.onWindowsCountChanged,()=>this.windowsMainService.getLastActiveWindow()),A=>!!A),A=>A.id),w.Event.filter(w.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(A,T)=>T.id),A=>!!this.windowsMainService.getWindowById(A))),this.onDidResumeOS=w.Event.fromNodeEventEmitter(D.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new w.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new w.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.registerListeners()}registerListeners(){D.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:D.nativeTheme.shouldUseInvertedColorScheme||D.nativeTheme.shouldUseHighContrastColors,dark:D.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(r=>({id:r.id,workspace:r.openedWorkspace,title:r.win.getTitle(),filename:r.getRepresentedFilename(),dirty:r.isDocumentEdited()}))}async getWindowCount(t){return this.windowsMainService.getWindowCount()}async getActiveWindowId(t){const r=D.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(r)return r.id}openWindow(t,r,o){return Array.isArray(r)?this.doOpenWindow(t,r,o):this.doOpenEmptyWindow(t,r)}async doOpenWindow(t,r,o=Object.create(null)){r.length>0&&this.windowsMainService.open({context:5,contextWindowId:t,urisToOpen:r,cli:this.environmentService.args,forceNewWindow:o.forceNewWindow,forceReuseWindow:o.forceReuseWindow,preferNewWindow:o.preferNewWindow,diffMode:o.diffMode,addMode:o.addMode,gotoLineMode:o.gotoLineMode,noRecentEntry:o.noRecentEntry,waitMarkerFileURI:o.waitMarkerFileURI})}async doOpenEmptyWindow(t,r){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:t},r)}async toggleFullScreen(t){const r=this.windowById(t);r&&r.toggleFullScreen()}async handleTitleDoubleClick(t){const r=this.windowById(t);r&&r.handleTitleDoubleClick()}async isMaximized(t){const r=this.windowById(t);return r?r.win.isMaximized():!1}async maximizeWindow(t){const r=this.windowById(t);r&&r.win.maximize()}async unmaximizeWindow(t){const r=this.windowById(t);r&&r.win.unmaximize()}async minimizeWindow(t){const r=this.windowById(t);r&&r.win.minimize()}async focusWindow(t,r){var o;r&&typeof r.windowId=="number"&&(t=r.windowId);const d=this.windowById(t);d&&d.focus({force:(o=r==null?void 0:r.force)!==null&&o!==void 0?o:!1})}async setMinimumSize(t,r,o){const d=this.windowById(t);if(d){const[c,g]=d.win.getSize(),[I,A]=d.win.getMinimumSize(),[T,U]=[r!=null?r:I,o!=null?o:A],[j,C]=[Math.max(c,T),Math.max(g,U)];(I!==T||A!==U)&&d.win.setMinimumSize(T,U),(c!==j||g!==C)&&d.win.setSize(j,C)}}async showMessageBox(t,r){return this.dialogMainService.showMessageBox(r,this.toBrowserWindow(t))}async showSaveDialog(t,r){return this.dialogMainService.showSaveDialog(r,this.toBrowserWindow(t))}async showOpenDialog(t,r){return this.dialogMainService.showOpenDialog(r,this.toBrowserWindow(t))}toBrowserWindow(t){const r=this.windowById(t);if(r)return r.win}async pickFileFolderAndOpen(t,r){const o=await this.dialogMainService.pickFileFolder(r);o&&(this.sendPickerTelemetry(o,r.telemetryEventName||"openFileFolder",r.telemetryExtraData),this.doOpenPicked(await Promise.all(o.map(async d=>await i.dirExists(d)?{folderUri:E.URI.file(d)}:{fileUri:E.URI.file(d)})),r,t))}async pickFolderAndOpen(t,r){const o=await this.dialogMainService.pickFolder(r);o&&(this.sendPickerTelemetry(o,r.telemetryEventName||"openFolder",r.telemetryExtraData),this.doOpenPicked(o.map(d=>({folderUri:E.URI.file(d)})),r,t))}async pickFileAndOpen(t,r){const o=await this.dialogMainService.pickFile(r);o&&(this.sendPickerTelemetry(o,r.telemetryEventName||"openFile",r.telemetryExtraData),this.doOpenPicked(o.map(d=>({fileUri:E.URI.file(d)})),r,t))}async pickWorkspaceAndOpen(t,r){const o=await this.dialogMainService.pickWorkspace(r);o&&(this.sendPickerTelemetry(o,r.telemetryEventName||"openWorkspace",r.telemetryExtraData),this.doOpenPicked(o.map(d=>({workspaceUri:E.URI.file(d)})),r,t))}doOpenPicked(t,r,o){this.windowsMainService.open({context:3,contextWindowId:o,cli:this.environmentService.args,urisToOpen:t,forceNewWindow:r.forceNewWindow})}sendPickerTelemetry(t,r,o){const d=t?t.length:0;this.telemetryService.publicLog(r,Object.assign(Object.assign({},o),{outcome:d?"success":"canceled",numberOfPaths:d}))}async showItemInFolder(t,r){D.shell.showItemInFolder(r)}async setRepresentedFilename(t,r){const o=this.windowById(t);o&&o.setRepresentedFilename(r)}async setDocumentEdited(t,r){const o=this.windowById(t);o&&o.setDocumentEdited(r)}async openExternal(t,r){return M.isLinuxSnap?this.safeSnapOpenExternal(r):D.shell.openExternal(r),!0}safeSnapOpenExternal(t){const r=process.env.GDK_PIXBUF_MODULE_FILE,o=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,D.shell.openExternal(t),process.env.GDK_PIXBUF_MODULE_FILE=r,process.env.GDK_PIXBUF_MODULEDIR=o}async moveItemToTrash(t,r){return D.shell.moveItemToTrash(r)}async isAdmin(){let t;return M.isWindows?t=(await new Promise((r,o)=>{$(["native-is-elevated"],r,o)}))():t=process.getuid()===0,t}async writeElevated(t,r,o,d){const c=await new Promise((g,I)=>{$(["sudo-prompt"],g,I)});return new Promise((g,I)=>{const A=[`"${this.cliPath}"`];(d==null?void 0:d.overwriteReadonly)&&A.push("--file-chmod"),A.push("--file-write",`"${r.fsPath}"`,`"${o.fsPath}"`);const T={name:b.default.nameLong.replace("-",""),icns:M.isMacintosh&&this.environmentService.isBuilt?p.join(p.dirname(this.environmentService.appRoot),`${b.default.nameShort}.icns`):void 0};c.exec(A.join(" "),T,(U,j,C)=>{j&&this.logService.trace(`[sudo-prompt] received stdout: ${j}`),C&&this.logService.trace(`[sudo-prompt] received stderr: ${C}`),U?I(U):g(void 0)})})}get cliPath(){return M.isWindows?this.environmentService.isBuilt?p.join(p.dirname(process.execPath),"bin",`${b.default.applicationName}.cmd`):p.join(this.environmentService.appRoot,"scripts","code-cli.bat"):M.isLinux?this.environmentService.isBuilt?p.join(p.dirname(process.execPath),"bin",`${b.default.applicationName}`):p.join(this.environmentService.appRoot,"scripts","code-cli.sh"):this.environmentService.isBuilt?p.join(this.environmentService.appRoot,"bin","code"):p.join(this.environmentService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:f.totalmem(),freemem:f.freemem(),loadavg:f.loadavg()}}async getOSProperties(){return{arch:f.arch(),platform:f.platform(),release:f.release(),type:f.type(),cpus:f.cpus()}}async getOSVirtualMachineHint(){return h.virtualMachineHint.value()}async killProcess(t,r,o){process.kill(r,o)}async readClipboardText(t,r){return D.clipboard.readText(r)}async writeClipboardText(t,r,o){return D.clipboard.writeText(r,o)}async readClipboardFindText(t){return D.clipboard.readFindText()}async writeClipboardFindText(t,r){return D.clipboard.writeFindText(r)}async writeClipboardBuffer(t,r,o,d){return D.clipboard.writeBuffer(r,Buffer.from(o),d)}async readClipboardBuffer(t,r){return D.clipboard.readBuffer(r)}async hasClipboard(t,r,o){return D.clipboard.has(r,o)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentService.args,forceNewTabbedWindow:!0,forceEmpty:!0})}async showPreviousWindowTab(){D.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){D.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){D.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){D.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){D.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(t,r){const o=this.windowById(t);o&&o.updateTouchBar(r)}async notifyReady(t){const r=this.windowById(t);r&&r.setReady()}async relaunch(t,r){return this.lifecycleMainService.relaunch(r)}async reload(t,r){const o=this.windowById(t);if(o)return this.lifecycleMainService.reload(o,(r==null?void 0:r.disableExtensions)!==void 0?{_:[],"disable-extensions":r==null?void 0:r.disableExtensions}:void 0)}async closeWindow(t){this.closeWindowById(t,t)}async closeWindowById(t,r){const o=this.windowById(r);if(o)return o.win.close()}async quit(t){const r=this.windowsMainService.getLastActiveWindow();(r==null?void 0:r.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1?r.win.close():setTimeout(()=>{this.lifecycleMainService.quit()},10)}async exit(t,r){await this.lifecycleMainService.kill(r)}async resolveProxy(t,r){var o,d;const c=this.windowById(t),g=(d=(o=c==null?void 0:c.win)===null||o===void 0?void 0:o.webContents)===null||d===void 0?void 0:d.session;if(g)return g.resolveProxy(r)}async openDevTools(t,r){const o=this.windowById(t);o&&o.win.webContents.openDevTools(r)}async toggleDevTools(t){const r=this.windowById(t);r&&r.win.webContents.toggleDevTools()}async sendInputEvent(t,r){const o=this.windowById(t);o&&(r.type==="mouseDown"||r.type==="mouseUp")&&o.win.webContents.sendInputEvent(r)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(t,r,o,d){if(!!M.isWindows){const c=await new Promise((g,I)=>{$(["vscode-windows-registry"],g,I)});try{return c.GetStringRegKey(r,o,d)}catch(g){return}}}async getPassword(t,r,o){const d=await new Promise((g,I)=>{$(["keytar"],g,I)}),c=await d.getPassword(r,o);if(c)try{let{content:g,hasNextChunk:I}=JSON.parse(c);if(!g||!I)return c;let A=1;for(;I;){const T=await d.getPassword(r,`${o}-${A}`),U=JSON.parse(T);g+=U.content,I=U.hasNextChunk}return g}catch(g){return c}return c}async setPassword(t,r,o,d){const c=await new Promise((g,I)=>{$(["keytar"],g,I)});if(M.isWindows&&d.length>it.MAX_PASSWORD_LENGTH){let g=0,I=0,A=!0;for(;A;){const T=d.substring(g,g+it.PASSWORD_CHUNK_SIZE);g+=it.PASSWORD_CHUNK_SIZE,A=d.length-g>0;const U={content:T,hasNextChunk:A};await c.setPassword(r,I?`${o}-${I}`:o,JSON.stringify(U)),I++}}else await c.setPassword(r,o,d);this._onDidChangePassword.fire({service:r,account:o})}async deletePassword(t,r,o){const c=await(await new Promise((g,I)=>{$(["keytar"],g,I)})).deletePassword(r,o);return c&&this._onDidChangePassword.fire({service:r,account:o}),c}async findPassword(t,r){return(await new Promise((d,c)=>{$(["keytar"],d,c)})).findPassword(r)}async findCredentials(t,r){return(await new Promise((d,c)=>{$(["keytar"],d,c)})).findCredentials(r)}windowById(t){if(typeof t=="number")return this.windowsMainService.getWindowById(t)}};s.MAX_PASSWORD_LENGTH=2500,s.PASSWORD_CHUNK_SIZE=s.MAX_PASSWORD_LENGTH-100,de([l.memoize],s.prototype,"cliPath",null),s=de([re(1,R.IWindowsMainService),re(2,S.IDialogMainService),re(3,y.ILifecycleMainService),re(4,n.IEnvironmentMainService),re(5,m.ITelemetryService),re(6,v.ILogService)],s),e.NativeHostMainService=s}),define(Q[214],J([0,1,2,4,104,11,8,34,43,84,29,15,24]),function($,e,w,R,D,y,M,n,S,i,E,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var f;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(f||(f={}));let h=class nt extends w.Disposable{constructor(p,b,l,a){super();this.logService=p,this.windowsMainService=b,this.nativeHostMainService=l,this.encryptionMainService=a,this.pendingProxyResolve=void 0,this.state=f.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const p=R.Event.fromNodeEventEmitter(y.app,"login",(b,l,a,s,u)=>({event:b,webContents:l,req:a,authInfo:s,callback:u}));this._register(p(this.onLogin,this))}async onLogin({event:p,authInfo:b,req:l,callback:a}){if(!!b.isProxy){if(!this.pendingProxyResolve&&this.state===f.LoginDialogShown&&l.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}p.preventDefault();let s;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),s=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(b);try{s=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}a(s==null?void 0:s.username,s==null?void 0:s.password)}}async resolveProxyCredentials(p){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const b=await this.doResolveProxyCredentials(p);if(b)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),b;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(p){var b,l,a,s;this.logService.trace("auth#doResolveProxyCredentials - enter",p);const u=String(D.hash({scheme:p.scheme,host:p.host,port:p.port}));let t,r;try{const g=await this.nativeHostMainService.getPassword(void 0,nt.PROXY_CREDENTIALS_SERVICE_KEY,u);if(g){const I=JSON.parse(await this.encryptionMainService.decrypt(g));t=I.username,r=I.password}}catch(g){this.logService.error(g)}if(this.state!==f.StoredCredentialsUsed&&typeof t=="string"&&typeof r=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=f.StoredCredentialsUsed,{username:t,password:r};const o=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!o){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${o.id} to handle proxy login`);const d={authInfo:p,username:(l=(b=this.sessionCredentials)===null||b===void 0?void 0:b.username)!==null&&l!==void 0?l:t,password:(s=(a=this.sessionCredentials)===null||a===void 0?void 0:a.password)!==null&&s!==void 0?s:r,replyChannel:`vscode:proxyAuthResponse:${E.generateUuid()}`};o.sendWhenReady("vscode:openProxyAuthenticationDialog",P.CancellationToken.None,d),this.state=f.LoginDialogShown;const c=await new Promise(g=>{const I=async(A,T,U)=>{if(T===d.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${o.id}`),o.win.webContents.off("ipc-message",I),U){const j={username:U.username,password:U.password};try{if(U.remember){const C=await this.encryptionMainService.encrypt(JSON.stringify(j));await this.nativeHostMainService.setPassword(void 0,nt.PROXY_CREDENTIALS_SERVICE_KEY,u,C)}else await this.nativeHostMainService.deletePassword(void 0,nt.PROXY_CREDENTIALS_SERVICE_KEY,u)}catch(C){this.logService.error(C)}g({username:j.username,password:j.password})}else g(void 0)};o.win.webContents.on("ipc-message",I)});return this.sessionCredentials=c,c}};h.PROXY_CREDENTIALS_SERVICE_KEY=`${m.default.urlProtocol}.proxy-credentials`,h=de([re(0,M.ILogService),re(1,n.IWindowsMainService),re(2,S.INativeHostMainService),re(3,i.IEncryptionMainService)],h),e.ProxyAuthHandler=h}),define(Q[215],J([0,1,210,34,49,2,33,56,167,3,4,74,101,9,22,43]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function p(a){return a<21}let b=class{constructor(s,u,t,r,o){this.windowServer=s,this.options=u,this.windowsMainService=t,this.lifecycleMainService=r,this.nativeHostMainService=o,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new E.Emitter}async registerWindowDriver(s){return this.registeredWindowIds.add(s),this.reloadingWindowIds.delete(s),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(s){this.reloadingWindowIds.add(s)}async getWindowIds(){return this.windowsMainService.getWindows().map(s=>s.id).filter(s=>this.registeredWindowIds.has(s)&&!this.reloadingWindowIds.has(s))}async capturePage(s){await this.whenUnfrozen(s);const u=this.windowsMainService.getWindowById(s);if(!u)throw new Error("Invalid window");return(await u.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(s){await this.whenUnfrozen(s);const u=this.windowsMainService.getWindowById(s);if(!u)throw new Error("Invalid window");this.reloadingWindowIds.add(s),this.lifecycleMainService.reload(u)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(s,u){await this.whenUnfrozen(s);const t=P.KeybindingParser.parseUserBinding(u);for(let r of t)await this._dispatchKeybinding(s,r)}async _dispatchKeybinding(s,u){if(u instanceof m.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const t=this.windowsMainService.getWindowById(s);if(!t)throw new Error("Invalid window");const r=t.win.webContents,o=new n.SimpleKeybinding(!1,!1,!1,!1,u.keyCode),c=new S.USLayoutResolvedKeybinding(o.toChord(),i.OS).getElectronAccelerator(),g=[];u.ctrlKey&&g.push("ctrl"),u.metaKey&&g.push("meta"),u.shiftKey&&g.push("shift"),u.altKey&&g.push("alt"),r.sendInputEvent({type:"keyDown",keyCode:c,modifiers:g}),p(u.keyCode)||r.sendInputEvent({type:"char",keyCode:c,modifiers:g}),r.sendInputEvent({type:"keyUp",keyCode:c,modifiers:g}),await f.timeout(100)}async click(s,u,t,r){await(await this.getWindowDriver(s)).click(u,t,r)}async doubleClick(s,u){await(await this.getWindowDriver(s)).doubleClick(u)}async setValue(s,u,t){await(await this.getWindowDriver(s)).setValue(u,t)}async getTitle(s){return await(await this.getWindowDriver(s)).getTitle()}async isActiveElement(s,u){return await(await this.getWindowDriver(s)).isActiveElement(u)}async getElements(s,u,t){return await(await this.getWindowDriver(s)).getElements(u,t)}async getElementXY(s,u,t,r){return await(await this.getWindowDriver(s)).getElementXY(u,t,r)}async typeInEditor(s,u,t){await(await this.getWindowDriver(s)).typeInEditor(u,t)}async getTerminalBuffer(s,u){return await(await this.getWindowDriver(s)).getTerminalBuffer(u)}async writeInTerminal(s,u,t){await(await this.getWindowDriver(s)).writeInTerminal(u,t)}async getWindowDriver(s){await this.whenUnfrozen(s);const u=`window:${s}`,t=new M.StaticRouter(o=>o===u),r=this.windowServer.getChannel("windowDriver",t);return new w.WindowDriverChannelClient(r)}async whenUnfrozen(s){for(;this.reloadingWindowIds.has(s);)await E.Event.toPromise(this.onDidReloadingChange.event)}};b=de([re(2,R.IWindowsMainService),re(3,h.ILifecycleMainService),re(4,v.INativeHostMainService)],b),e.Driver=b;async function l(a,s,u,t){const r=u.driverVerbose,o=t.createInstance(b,a,{verbose:r}),d=new w.WindowDriverRegistryChannel(o);a.registerChannel("windowDriverRegistry",d);const c=await D.serve(s),g=new w.DriverChannel(o);return c.registerChannel("driver",g),y.combinedDisposable(c,a)}e.serve=l}),define(Q[216],J([0,1,58,49]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,y,M,n){const S=E=>n(E,void 0),i=w.createConnection({host:D,port:y},()=>{i.removeListener("error",S);const E=Buffer.alloc(16);for(let h=0;h<16;h++)E[h]=Math.round(Math.random()*256);const m=E.toString("base64");let P=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${y}/?${M}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${m}`];i.write(P.join(`\r
`)+`\r
\r
`);const f=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(i.off("data",f),n(void 0,new R.NodeSocket(i)))};i.on("data",f)});i.once("error",S)}}}),define(Q[217],J([0,1,58,9,2,112,8,60,183,55,216,88]),function($,e,w,R,D,y,M,n,S,i,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function P(p,b,l,a){return new f(p,b,l,a).waitForReady()}class f extends D.Disposable{constructor(b,l,a,s){super();this.suggestedLocalPort=s,this.public=!1,this._socketsDispose=new Map,this._options=b,this._server=w.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=u=>this._onConnection(u),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=a,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(l=>{l()})}async waitForReady(){var b;let l=await y.findFreePortFaster((b=this.suggestedLocalPort)!==null&&b!==void 0?b:this.tunnelRemotePort,2,1e3),a=null;return a=this._server.listen(l).address(),a||(l=0,a=this._server.listen(l).address()),this.tunnelLocalPort=a.port,await this._barrier.wait(),this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async _onConnection(b){b.pause();const l=await S.connectRemoteAgentTunnel(this._options,this.tunnelRemotePort),a=l.getSocket().socket,s=l.readEntireBuffer();l.dispose(),s.byteLength>0&&b.write(s.buffer),b.on("end",()=>{this._socketsDispose.delete(b.localAddress),a.end()}),b.on("close",()=>a.end()),b.on("error",()=>{this._socketsDispose.delete(b.localAddress),a.destroy()}),a.on("end",()=>b.end()),a.on("close",()=>b.end()),a.on("error",()=>{b.destroy()}),b.pipe(a),a.pipe(b),this._socketsDispose.set(b.localAddress,()=>{b.end(),a.end()})}}let h=class extends i.AbstractTunnelService{constructor(b,l,a,s){super(l);this.socketFactory=b,this.signService=a,this.productService=s}retainOrCreateTunnel(b,l,a,s,u,t){const r=this.getTunnelFromMap(l,a);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,l,a,s,u,t);{this.logService.trace(`Creating tunnel without provider ${l}:${a} on local port ${s}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:b,signService:this.signService,logService:this.logService,ipcLogger:null},d=P(o,l,a,s);return this.logService.trace("Tunnel created without provider."),this.addTunnelToMap(l,a,d),d}}};h=de([re(1,M.ILogService),re(2,m.ISignService),re(3,n.IProductService)],h),e.BaseTunnelService=h;let v=class extends h{constructor(b,l,a){super(E.nodeSocketFactory,b,l,a)}};v=de([re(0,M.ILogService),re(1,m.ISignService),re(2,n.IProductService)],v),e.TunnelService=v}),define(Q[218],J([0,1,209,185,2,14,16,184,19,8,20]),function($,e,w,R,D,y,M,n,S,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let m=class extends D.Disposable{constructor(f,h){super();this.logService=h,this.configure(f.getValue()),this._register(f.onDidChangeConfiguration(()=>this.configure(f.getValue()),this))}configure(f){this.proxyUrl=f.http&&f.http.proxy,this.strictSSL=!!(f.http&&f.http.proxyStrictSSL),this.authorization=f.http&&f.http.proxyAuthorization}async request(f,h){this.logService.trace("RequestService#request",f.url);const{proxyUrl:v,strictSSL:p}=this,b=f.agent?f.agent:await n.getProxyAgent(f.url||"",{proxyUrl:v,strictSSL:p});return f.agent=b,f.strictSSL=p,this.authorization&&(f.headers=Object.assign(Object.assign({},f.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(f,h)}async getNodeRequest(f){return(R.parse(f.url).protocol==="https:"?await new Promise((p,b)=>{$(["https"],p,b)}):await new Promise((p,b)=>{$(["http"],p,b)})).request}_request(f,h){return new Promise(async(v,p)=>{let b;const l=R.parse(f.url),a=f.getRawRequest?f.getRawRequest(f):await this.getNodeRequest(f),s={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:y.isBoolean(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(s.auth=f.user+":"+f.password),b=a(s,u=>{const t=y.isNumber(f.followRedirects)?f.followRedirects:3;if(u.statusCode&&u.statusCode>=300&&u.statusCode<400&&t>0&&u.headers.location)this._request(Object.assign(Object.assign({},f),{url:u.headers.location,followRedirects:t-1}),h).then(v,p);else{let r=u;u.headers["content-encoding"]==="gzip"&&(r=u.pipe(w.createGunzip())),v({res:u,stream:E.streamToBufferReadableStream(r)})}}),b.on("error",p),f.timeout&&b.setTimeout(f.timeout),f.data&&typeof f.data=="string"&&b.write(f.data),b.end(),h.onCancellationRequested(()=>{b.abort(),p(M.canceled())})})}async resolveProxy(f){}};m=de([re(0,S.IConfigurationService),re(1,i.ILogService)],m),e.RequestService=m}),define(Q[219],J([0,1,218,11]),function($,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(M){return R.net.request}class y extends w.RequestService{request(n,S){return super.request(Object.assign(Object.assign({},n||{}),{getRawRequest:D}),S)}}e.RequestMainService=y}),define(Q[73],J([0,1,4,9,19,22,15,42,23,8,39,24]),function($,e,w,R,D,y,M,n,S,i,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function P(h,v){return`${M.default.updateUrl}/api/update/${h}/${v}/${M.default.commit}`}e.createUpdateURL=P;let f=class{constructor(v,p,b,l,a){this.lifecycleMainService=v,this.configurationService=p,this.environmentService=b,this.requestService=l,this.logService=a,this._state=n.State.Uninitialized,this._onStateChange=new w.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}initialize(){if(!!this.environmentService.isBuilt){if(this.environmentService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!M.default.updateUrl||!M.default.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const v=D.getMigratedSettingValue(this.configurationService,"update.mode","update.channel"),p=this.getProductQuality(v);if(!p){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(p),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(n.State.Idle(this.getUpdateType())),v==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(null),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,b=>this.logService.error(b))}}getProductQuality(v){return v==="none"?void 0:M.default.quality}scheduleCheckForUpdates(v=60*60*1e3){return R.timeout(v).then(()=>this.checkForUpdates(null)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(v){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},m.CancellationToken.None).then(v=>v.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};f=de([re(0,y.ILifecycleMainService),re(1,D.IConfigurationService),re(2,S.IEnvironmentMainService),re(3,E.IRequestService),re(4,i.ILogService)],f),e.AbstractUpdateService=f}),define(Q[220],J([0,1,11,2,4,51,19,22,42,30,23,8,73,39,15]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let v=class extends P.AbstractUpdateService{constructor(b,l,a,s,u,t){super(b,l,s,u,t);this.telemetryService=a,this.disposables=new R.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(w.autoUpdater,"error",(b,l)=>l)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(w.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(w.autoUpdater,"update-available",(b,l,a)=>({url:l,version:a,productVersion:a}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(w.autoUpdater,"update-downloaded",(b,l,a,s)=>({releaseNotes:l,version:a,productVersion:a,date:s}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(b){this.logService.error("UpdateService error:",b);const a=(this.state.type==="checking for updates"?!!this.state.context:!0)?b:void 0;this.setState(S.State.Idle(1,a))}buildUpdateFeedUrl(b){let l;h.default.darwinUniversalAssetId?l=h.default.darwinUniversalAssetId:l=process.arch==="x64"?"darwin":"darwin-arm64";const a=P.createUpdateURL(l,b);try{w.autoUpdater.setFeedURL({url:a})}catch(s){this.logService.error("Failed to set update feed URL",s);return}return a}doCheckForUpdates(b){this.setState(S.State.CheckingForUpdates(b)),w.autoUpdater.checkForUpdates()}onUpdateAvailable(b){this.state.type==="checking for updates"&&this.setState(S.State.Downloading(b))}onUpdateDownloaded(b){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:b.version}),this.setState(S.State.Ready(b)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!this.state.context}),this.setState(S.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),w.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};de([y.memoize],v.prototype,"onRawError",null),de([y.memoize],v.prototype,"onRawUpdateNotAvailable",null),de([y.memoize],v.prototype,"onRawUpdateAvailable",null),de([y.memoize],v.prototype,"onRawUpdateDownloaded",null),v=de([re(0,n.ILifecycleMainService),re(1,M.IConfigurationService),re(2,i.ITelemetryService),re(3,E.IEnvironmentMainService),re(4,f.IRequestService),re(5,m.ILogService)],v),e.DarwinUpdateService=v}),define(Q[221],J([0,1,15,19,22,42,30,23,8,73,39,24,43]),function($,e,w,R,D,y,M,n,S,i,E,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let f=class extends i.AbstractUpdateService{constructor(v,p,b,l,a,s,u){super(v,p,l,a,s);this.telemetryService=b,this.nativeHostMainService=u}buildUpdateFeedUrl(v){return i.createUpdateURL(`linux-${process.arch}`,v)}doCheckForUpdates(v){!this.url||(this.setState(y.State.CheckingForUpdates(v)),this.requestService.request({url:this.url},m.CancellationToken.None).then(E.asJson).then(p=>{!p||!p.url||!p.version||!p.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v}),this.setState(y.State.Idle(1))):this.setState(y.State.AvailableForDownload(p))}).then(void 0,p=>{this.logService.error(p),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v});const b=v?p.message||p:void 0;this.setState(y.State.Idle(1,b))}))}async doDownloadUpdate(v){w.default.downloadUrl&&w.default.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,w.default.downloadUrl):v.update.url&&this.nativeHostMainService.openExternal(void 0,v.update.url),this.setState(y.State.Idle(1))}};f=de([re(0,D.ILifecycleMainService),re(1,R.IConfigurationService),re(2,M.ITelemetryService),re(3,n.IEnvironmentMainService),re(4,E.IRequestService),re(5,S.ILogService),re(6,P.INativeHostMainService)],f),e.LinuxUpdateService=f}),define(Q[222],J([0,1,4,9,22,42,23,8,6,25,45,30]),function($,e,w,R,D,y,M,n,S,i,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let P=class{constructor(v,p,b){if(this.lifecycleMainService=v,this.logService=b,this._state=y.State.Uninitialized,this._onStateChange=new w.Emitter,this.onStateChange=this._onStateChange.event,p.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(y.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,l=>this.logService.error(l))}get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}scheduleCheckForUpdates(v=60*60*1e3){return R.timeout(v).then(()=>this.checkForUpdates(null)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(v){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};P=de([re(0,D.ILifecycleMainService),re(1,M.IEnvironmentMainService),re(2,n.ILogService)],P);let f=class extends P{constructor(v,p,b,l,a,s){super(b,l,a);this.snap=v,this.snapRevision=p,this.telemetryService=s;const u=i.watch(S.dirname(this.snap)),t=w.Event.fromNodeEventEmitter(u,"change",(c,g)=>g),r=w.Event.filter(t,c=>c==="current"),d=w.Event.debounce(r,(c,g)=>g,2e3)(this.checkForUpdates,this);b.onWillShutdown(()=>{d.dispose(),u.close()})}doCheckForUpdates(v){this.setState(y.State.CheckingForUpdates(v)),this.isUpdateAvailable().then(p=>{p?this.setState(y.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v}),this.setState(y.State.Idle(2)))},p=>{this.logService.error(p),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v}),this.setState(y.State.Idle(2,p.message||p))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.spawn("sleep 3 && "+S.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const v=await new Promise((b,l)=>i.realpath(`${S.dirname(this.snap)}/current`,(a,s)=>a?l(a):b(s))),p=S.basename(v);return this.snapRevision!==p}isLatestVersion(){return this.isUpdateAvailable().then(void 0,v=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};f=de([re(2,D.ILifecycleMainService),re(3,M.IEnvironmentMainService),re(4,n.ILogService),re(5,m.ITelemetryService)],f),e.SnapUpdateService=f}),define(Q[223],J([0,1,25,6,26,51,19,22,15,42,30,23,8,73,39,108,27,45,24,9,21,7,43]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h,v,p,b,l,a,s,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(g,I=1e3){for(;!g();)await a.timeout(I)}let o;function d(){return typeof o=="undefined"&&(o=w.existsSync(R.join(R.dirname(process.execPath),"unins000.exe"))?0:1),o}let c=class extends f.AbstractUpdateService{constructor(I,A,T,U,j,C,x,ee){super(I,A,U,j,C);this.telemetryService=T,this.fileService=x,this.nativeHostMainService=ee}get cachePath(){const I=R.join(p.tmpdir(),`vscode-update-${S.default.target}-${process.arch}`);return D.mkdirp(I).then(()=>I)}initialize(){super.initialize(),d()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:S.default.target})}buildUpdateFeedUrl(I){let A="win32";return process.arch!=="ia32"&&(A+=`-${process.arch}`),d()===1?A+="-archive":S.default.target==="user"&&(A+="-user"),f.createUpdateURL(A,I)}doCheckForUpdates(I){!this.url||(this.setState(i.State.CheckingForUpdates(I)),this.requestService.request({url:this.url},l.CancellationToken.None).then(h.asJson).then(A=>{const T=d();return!A||!A.url||!A.version||!A.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!I}),this.setState(i.State.Idle(T)),Promise.resolve(null)):T===1?(this.setState(i.State.AvailableForDownload(A)),Promise.resolve(null)):(this.setState(i.State.Downloading(A)),this.cleanup(A.version).then(()=>this.getUpdatePackagePath(A.version).then(U=>D.exists(U).then(j=>{if(j)return Promise.resolve(U);const C=A.url,x=A.hash,ee=`${U}.tmp`;return this.requestService.request({url:C},l.CancellationToken.None).then(Z=>this.fileService.writeFile(u.URI.file(ee),Z.stream)).then(x?()=>v.checksum(ee,A.hash):()=>{}).then(()=>D.rename(ee,U)).then(()=>U)})).then(U=>{const j=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:U},j&&A.supportsFastUpdate?S.default.target==="user"?this.doApplyUpdate():this.setState(i.State.Downloaded(A)):this.setState(i.State.Ready(A))})))}).then(void 0,A=>{this.logService.error(A),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!I});const T=I?A.message||A:void 0;this.setState(i.State.Idle(d(),T))}))}async doDownloadUpdate(I){I.update.url&&this.nativeHostMainService.openExternal(void 0,I.update.url),this.setState(i.State.Idle(d()))}async getUpdatePackagePath(I){const A=await this.cachePath;return R.join(A,`CodeSetup-${S.default.quality}-${I}.exe`)}async cleanup(I=null){const A=I?C=>!new RegExp(`${S.default.quality}-${I}\\.exe$`).test(C):()=>!0,T=await this.cachePath,j=(await D.readdir(T)).filter(A).map(async C=>{try{await D.unlink(R.join(T,C))}catch(x){}});await Promise.all(j)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const I=this.state.update;this.setState(i.State.Updating(I));const A=await this.cachePath;this.availableUpdate.updateFilePath=R.join(A,`CodeSetup-${S.default.quality}-${I.version}.flag`),await D.writeFile(this.availableUpdate.updateFilePath,"flag"),b.spawn(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(i.State.Idle(d()))});const U=`${S.default.win32MutexName}-ready`,j=await new Promise((C,x)=>{$(["windows-mutex"],C,x)});r(()=>j.isActive(U)).then(()=>this.setState(i.State.Ready(I)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?w.unlinkSync(this.availableUpdate.updateFilePath):b.spawn(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return d()}};de([y.memoize],c.prototype,"cachePath",null),c=de([re(0,n.ILifecycleMainService),re(1,M.IConfigurationService),re(2,E.ITelemetryService),re(3,m.IEnvironmentMainService),re(4,h.IRequestService),re(5,P.ILogService),re(6,s.IFileService),re(7,t.INativeHostMainService)],c),e.Win32UpdateService=c}),define(Q[50],J([0,1,31,23,6,26,25,3,4,8,57,40,10,2,18,5,149,15,11,14,47,48,94]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h,v,p,b,l,a,s,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=v.createDecorator("workspacesManagementMainService");let r=class extends f.Disposable{constructor(g,I,A,T){super();this.environmentService=g,this.logService=I,this.backupMainService=A,this.dialogMainService=T,this.untitledWorkspacesHome=this.environmentService.untitledWorkspacesHome,this._onUntitledWorkspaceDeleted=this._register(new S.Emitter),this.onUntitledWorkspaceDeleted=this._onUntitledWorkspaceDeleted.event,this._onWorkspaceEntered=this._register(new S.Emitter),this.onWorkspaceEntered=this._onWorkspaceEntered.event}resolveLocalWorkspaceSync(g){if(!this.isWorkspacePath(g)||g.scheme!==P.Schemas.file)return null;let I;try{I=M.readFileSync(g.fsPath,"utf8")}catch(A){return null}return this.doResolveWorkspace(g,I)}isWorkspacePath(g){return w.isUntitledWorkspace(g,this.environmentService)||w.hasWorkspaceFileExtension(g)}doResolveWorkspace(g,I){try{const A=this.doParseStoredWorkspace(g,I),T=o(g);return{id:T.id,configPath:T.configPath,folders:w.toWorkspaceFolders(A.folders,T.configPath,h.extUriBiasedIgnorePathCase),remoteAuthority:A.remoteAuthority}}catch(A){this.logService.warn(A.toString())}return null}doParseStoredWorkspace(g,I){const A=m.parse(I);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(T=>w.isStoredWorkspaceFolder(T));else throw new Error(`${g.toString(!0)} looks like an invalid workspace file.`);return A}async createUntitledWorkspace(g,I){const{workspace:A,storedWorkspace:T}=this.newUntitledWorkspace(g,I),U=A.configPath.fsPath;return await y.mkdirp(D.dirname(U)),await y.writeFile(U,JSON.stringify(T,null,"	")),A}createUntitledWorkspaceSync(g,I){const{workspace:A,storedWorkspace:T}=this.newUntitledWorkspace(g,I),U=A.configPath.fsPath,j=D.dirname(U);if(!M.existsSync(j)){const C=D.dirname(j);M.existsSync(C)||M.mkdirSync(C),M.mkdirSync(j)}return y.writeFileSync(U,JSON.stringify(T,null,"	")),A}newUntitledWorkspace(g=[],I){const A=(Date.now()+Math.round(Math.random()*1e3)).toString(),T=h.joinPath(this.untitledWorkspacesHome,A),U=h.joinPath(T,w.UNTITLED_WORKSPACE_NAME),j=[];for(const C of g)j.push(w.getStoredWorkspaceFolder(C.uri,!0,C.name,T,!n.isWindows,h.extUriBiasedIgnorePathCase));return{workspace:o(U),storedWorkspace:{folders:j,remoteAuthority:I}}}async getWorkspaceIdentifier(g){return o(g)}isUntitledWorkspace(g){return w.isUntitledWorkspace(g.configPath,this.environmentService)}deleteUntitledWorkspaceSync(g){!this.isUntitledWorkspace(g)||(this.doDeleteUntitledWorkspaceSync(g),this._onUntitledWorkspaceDeleted.fire(g))}async deleteUntitledWorkspace(g){this.deleteUntitledWorkspaceSync(g)}doDeleteUntitledWorkspaceSync(g){const I=h.originalFSPath(g.configPath);try{y.rimrafSync(D.dirname(I));const A=D.join(this.environmentService.workspaceStorageHome.fsPath,g.id);M.existsSync(A)&&y.writeFileSync(D.join(A,"obsolete"),"")}catch(A){this.logService.warn(`Unable to delete untitled workspace ${I} (${A}).`)}}getUntitledWorkspacesSync(){const g=[];try{const I=y.readdirSync(this.untitledWorkspacesHome.fsPath).map(A=>h.joinPath(this.untitledWorkspacesHome,A,w.UNTITLED_WORKSPACE_NAME));for(const A of I){const T=o(A),U=this.resolveLocalWorkspaceSync(A);U?g.push({workspace:T,remoteAuthority:U.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(T)}}catch(I){I.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${I}).`)}return g}async enterWorkspace(g,I,A){if(!g||!g.win||!g.isReady||!await this.isValidTargetWorkspacePath(g,I,A))return null;const U=this.doEnterWorkspace(g,o(A));return U?(this._onWorkspaceEntered.fire({window:g,workspace:U.workspace}),U):null}async isValidTargetWorkspacePath(g,I,A){if(!A)return!0;if(w.isWorkspaceIdentifier(g.openedWorkspace)&&h.extUriBiasedIgnorePathCase.isEqual(g.openedWorkspace.configPath,A))return!1;if(t.findWindowOnWorkspaceOrFolder(I,A)){const T={title:b.default.nameLong,type:"info",buttons:[p.localize(0,null)],message:p.localize(1,null,h.basename(A)),detail:p.localize(2,null),noLink:!0};return await this.dialogMainService.showMessageBox(T,a.withNullAsUndefined(l.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(g,I){if(!g.config)return null;g.focus();let A;return g.config.extensionDevelopmentPath||(A=this.backupMainService.registerWorkspaceBackupSync({workspace:I,remoteAuthority:g.remoteAuthority},g.config.backupPath)),w.isWorkspaceIdentifier(g.openedWorkspace)&&this.isUntitledWorkspace(g.openedWorkspace)&&this.deleteUntitledWorkspaceSync(g.openedWorkspace),g.config.workspace=I,g.config.backupPath=A,{workspace:I,backupPath:A}}};r=de([re(0,R.IEnvironmentMainService),re(1,i.ILogService),re(2,s.IBackupMainService),re(3,u.IDialogMainService)],r),e.WorkspacesManagementMainService=r;function o(c){function g(){let I=c.scheme===P.Schemas.file?h.originalFSPath(c):c.toString();return n.isLinux||(I=I.toLowerCase()),E.createHash("md5").update(I).digest("hex")}return{id:g(),configPath:c}}e.getWorkspaceIdentifier=o;function d(c,g){function I(){if(c.scheme!==P.Schemas.file)return E.createHash("md5").update(c.toString()).digest("hex");if(!g)try{g=M.statSync(c.fsPath)}catch(U){return}let T;return n.isLinux?T=g.ino:n.isMacintosh?T=g.birthtime.getTime():n.isWindows&&(typeof g.birthtimeMs=="number"?T=Math.floor(g.birthtimeMs):T=g.birthtime.getTime()),E.createHash("md5").update(c.fsPath).update(T?String(T):"").digest("hex")}const A=I();if(typeof A=="string")return{id:A,uri:c}}e.getSingleFolderWorkspaceIdentifier=d}),define(Q[95],J([0,1,27,6,130,172,4,7,11,23,8,19,59,15,61,2,3,31,50,47,190,72,9,30,48,38,195,22,90,21,10,54,24]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h,v,p,b,l,a,s,u,t,r,o,d,c,g,I,A,T,U,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=e.defaultWindowState=void 0;const C=function(H=1){return{width:1024,height:768,mode:H}};e.defaultWindowState=C;var x;(function(H){H[H.UNRESPONSIVE=1]="UNRESPONSIVE",H[H.CRASHED=2]="CRASHED"})(x||(x={}));var ee;(function(H){H[H.NONE=0]="NONE",H[H.LOADING=1]="LOADING",H[H.NAVIGATING=2]="NAVIGATING",H[H.READY=3]="READY"})(ee||(ee={}));let Z=class pt extends v.Disposable{constructor(N,q,F,z,O,k,L,_,W,B,K,X){super();this.logService=q,this.environmentService=F,this.fileService=z,this.configurationService=k,this.themeMainService=L,this.workspacesManagementMainService=_,this.backupMainService=W,this.telemetryService=B,this.dialogMainService=K,this.lifecycleMainService=X,this._onLoad=this._register(new M.Emitter),this.onLoad=this._onLoad.event,this._onReady=this._register(new M.Emitter),this.onReady=this._onReady.event,this._onClose=this._register(new M.Emitter),this.onClose=this._onClose.event,this._onDestroy=this._register(new M.Emitter),this.onDestroy=this._onDestroy.event,this._lastFocusTime=-1,this._readyState=0,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0;{const[Y,oe]=this.restoreWindowState(N.state);this.windowState=Y,this.logService.trace("window#ctor: using window state",Y);const le=this.windowState.mode===0||this.windowState.mode===3,ie=this.configurationService.getValue("window"),G={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:h.WindowMinimumSize.WIDTH,minHeight:h.WindowMinimumSize.HEIGHT,show:!le,title:f.default.nameLong,webPreferences:Object.assign({preload:T.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,v8CacheOptions:p.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:h.zoomLevelToZoomFactor(ie==null?void 0:ie.zoomLevel)},this.environmentService.sandbox?{sandbox:!0,contextIsolation:!0}:{nodeIntegration:!0})};p.browserCodeLoadingCacheStrategy&&this.logService.info(`window#ctor: using vscode-file protocol and V8 cache options: ${p.browserCodeLoadingCacheStrategy}`),p.isLinux?G.icon=R.join(this.environmentService.appRoot,"resources/linux/code.png"):p.isWindows&&!this.environmentService.isBuilt&&(G.icon=R.join(this.environmentService.appRoot,"resources/win32/code_150x150.png")),p.isMacintosh&&!this.useNativeFullScreen()&&(G.fullscreenable=!1),p.isMacintosh&&(G.acceptFirstMouse=!0,(ie==null?void 0:ie.clickThroughInactive)===!1&&(G.acceptFirstMouse=!1));const te=p.isMacintosh&&(ie==null?void 0:ie.nativeTabs)===!0;te&&(G.tabbingIdentifier=f.default.nameShort);const se=h.getTitleBarStyle(this.configurationService)==="custom";if(se&&(G.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,p.isMacintosh||(G.frame=!1)),this._win=new S.BrowserWindow(G),this._id=this._win.id,this.environmentService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),p.isMacintosh&&se&&this._win.setSheetOffset(22),p.isMacintosh&&oe&&(!te||S.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ae=>typeof ae=="number")){const ae=this.windowState;this._win.setBounds({width:ae.width,height:ae.height,x:ae.x,y:ae.y})}le&&(this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show()),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=s.resolveMarketplaceHeaders(f.default.version,this.environmentService,this.fileService,{get(Y){return O.get(Y)},store(Y,oe){O.store(Y,oe)}}),this.registerListeners()}get config(){return this.currentConfig}get id(){return this._id}get win(){return this._win}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var N;return!!((N=this.currentConfig)===null||N===void 0?void 0:N.extensionDevelopmentPath)}get isExtensionTestHost(){var N;return!!((N=this.currentConfig)===null||N===void 0?void 0:N.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var N;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((N=this.currentConfig)===null||N===void 0?void 0:N.debugId)}setRepresentedFilename(N){p.isMacintosh?this.win.setRepresentedFilename(N):this.representedFilename=N}getRepresentedFilename(){return p.isMacintosh?this.win.getRepresentedFilename():this.representedFilename}setDocumentEdited(N){p.isMacintosh&&this._win.setDocumentEdited(N),this.documentEdited=N}isDocumentEdited(){return p.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(N){p.isMacintosh&&(N==null?void 0:N.force)&&S.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var N;return(N=this.currentConfig)===null||N===void 0?void 0:N.backupPath}get openedWorkspace(){var N;return(N=this.currentConfig)===null||N===void 0?void 0:N.workspace}get remoteAuthority(){var N;return(N=this.currentConfig)===null||N===void 0?void 0:N.remoteAuthority}setReady(){for(this._readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onReady.fire()}ready(){return new Promise(N=>{if(this.isReady)return N(this);this.whenReadyCallbacks.push(N)})}get isReady(){return this._readyState===3}get whenClosedOrLoaded(){return new Promise(N=>{function q(){F.dispose(),z.dispose(),N()}const F=this.onClose(()=>q()),z=this.onLoad(()=>q())})}registerListeners(){this._win.webContents.on("render-process-gone",(F,z)=>this.onWindowError(2,z)),this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("did-fail-load",(F,z,O)=>this.logService.warn("Main: failed to load workbench window, ",O)),this._win.on("closed",()=>{this._onClose.fire(),this.dispose()});const N=new Set([T.Schemas.file,T.Schemas.vscodeFileResource,T.Schemas.vscodeRemoteResource,"devtools"]);if(this._win.webContents.session.webRequest.onBeforeRequest((F,z)=>{const O=n.URI.parse(F.url);return O&&O.path.endsWith(".svg")&&!(N.has(O.scheme)||O.path.includes(T.Schemas.vscodeRemoteResource))?z({cancel:!0}):z({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((F,z)=>{const O=F.responseHeaders,k=O["content-type"]||O["Content-Type"];if(k&&Array.isArray(k)){const L=n.URI.parse(F.url);if(L&&L.path.endsWith(".svg")&&N.has(L.scheme))return O["Content-Type"]=["image/svg+xml"],z({cancel:!1,responseHeaders:O});if(!L.path.includes(T.Schemas.vscodeRemoteResource)&&k.some(_=>_.toLowerCase().includes("image/svg")))return z({cancel:!0})}return z({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this._readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),p.isMacintosh){const F=this._register(new t.RunOnceScheduler(()=>{!this._win||!this.useNativeFullScreen()&&this.isFullScreen&&(this.setFullScreen(!1),this.setFullScreen(!0))},100)),z=(O,k,L)=>{Array.isArray(L)&&L.length===1&&L[0]==="workArea"||F.schedule()};S.screen.on("display-metrics-changed",z),this._register(v.toDisposable(()=>S.screen.removeListener("display-metrics-changed",z))),S.screen.on("display-added",z),this._register(v.toDisposable(()=>S.screen.removeListener("display-added",z))),S.screen.on("display-removed",z),this._register(v.toDisposable(()=>S.screen.removeListener("display-removed",z)))}this._win.on("maximize",F=>{this.currentConfig&&(this.currentConfig.maximized=!0),S.app.emit("browser-window-maximize",F,this._win)}),this._win.on("unmaximize",F=>{this.currentConfig&&(this.currentConfig.maximized=!1),S.app.emit("browser-window-unmaximize",F,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",j.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",j.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(F=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onUntitledWorkspaceDeleted(F=>this.onUntitledWorkspaceDeleted(F)));const q=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:q},(F,z)=>this.marketplaceHeadersPromise.then(O=>z({cancel:!1,requestHeaders:Object.assign(F.requestHeaders,O)})))}onWindowError(N,q){if(this.logService.error(N===2?`Main: renderer process crashed (detail: ${q==null?void 0:q.reason})`:"Main: detected unresponsive"),this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:N}),N===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;this.dialogMainService.showMessageBox({title:f.default.nameLong,type:"warning",buttons:[d.mnemonicButtonLabel(D.localize(0,null)),d.mnemonicButtonLabel(D.localize(1,null)),d.mnemonicButtonLabel(D.localize(2,null))],message:D.localize(3,null),detail:D.localize(4,null),noLink:!0},this._win).then(F=>{!this._win||(F.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):F.response===2&&this.destroyWindow())})}else{let F;q&&q.reason!=="crashed"?F=D.localize(5,null,q==null?void 0:q.reason):F=D.localize(6,null,q==null?void 0:q.reason),this.dialogMainService.showMessageBox({title:f.default.nameLong,type:"warning",buttons:[d.mnemonicButtonLabel(D.localize(7,null)),d.mnemonicButtonLabel(D.localize(8,null))],message:F,detail:D.localize(9,null),noLink:!0},this._win).then(z=>{!this._win||(z.response===0?this.reload():z.response===1&&this.destroyWindow())})}}destroyWindow(){this._onDestroy.fire(),this._win.destroy()}onUntitledWorkspaceDeleted(N){this.openedWorkspace&&this.openedWorkspace.id===N.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const N=this.getMenuBarVisibility();N!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=N,this.setMenuBarVisibility(N));let q=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;(q==null?void 0:q.endsWith("/"))&&(q=q.substr(0,q.length-1));const F=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((q||"").indexOf("@")===-1&&(q!==this.currentHttpProxy||F!==this.currentNoProxy)){this.currentHttpProxy=q,this.currentNoProxy=F;const z=q||"",O=F?`${F},<local>`:"<local>";this.logService.trace(`Setting proxy to '${z}', bypassing '${O}'`),this._win.webContents.session.setProxy({proxyRules:z,proxyBypassRules:O,pacScript:""})}}addTabbedWindow(N){p.isMacintosh&&this._win.addTabbedWindow(N.win)}load(N,{isReload:q,disableExtensions:F}=Object.create(null)){var z,O;const k=(O=(z=this.currentConfig)!==null&&z!==void 0?z:this.pendingLoadConfig)===null||O===void 0?void 0:O.userEnv;k&&U.isLaunchedFromCli(k)&&!U.isLaunchedFromCli(N.userEnv)&&(N.userEnv=Object.assign(Object.assign({},k),N.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(N.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),this._readyState===0?this.currentConfig=N:(this.pendingLoadConfig=N,this._readyState=2);const L=Object.assign({},N);F!==void 0&&(L["disable-extensions"]=F),this.isDocumentEdited()&&(!q||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),q||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(f.default.nameLong)),y.mark("code/willOpenNewWindow"),this._win.loadURL(this.getUrl(L)),!this.environmentService.isBuilt&&!this.environmentService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onLoad.fire()}async reload(N){const q=Object.assign({},this.currentConfig);q.workspace=await this.validateWorkspace(q),delete q.filesToOpenOrCreate,delete q.filesToDiff,delete q.filesToWait,this.isExtensionDevelopmentHost&&N&&(q.verbose=N.verbose,q.debugId=N.debugId,q["inspect-extensions"]=N["inspect-extensions"],q["inspect-brk-extensions"]=N["inspect-brk-extensions"],q["extensions-dir"]=N["extensions-dir"]),q.isInitialStartup=!1,this.load(q,{isReload:!0,disableExtensions:N==null?void 0:N["disable-extensions"]})}async validateWorkspace(N){if(b.isWorkspaceIdentifier(N.workspace)){const q=N.workspace.configPath;if(q.scheme===T.Schemas.file&&!await this.fileService.exists(q))return}else if(b.isSingleFolderWorkspaceIdentifier(N.workspace)){const q=N.workspace.uri;if(q.scheme===T.Schemas.file&&!await this.fileService.exists(q))return}return N.workspace}getUrl(N){var q;N.windowId=this._win.id,N.sessionId=`window:${this._win.id}`,N.logLevel=this.logService.getLevel(),N.logsPath=this.environmentService.logsPath;const F=this.configurationService.getValue("window"),z=F==null?void 0:F.zoomLevel;typeof z=="number"&&(N.zoomLevel=z),N.fullscreen=this.isFullScreen,N.colorScheme={dark:S.nativeTheme.shouldUseDarkColors,highContrast:S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors},N.autoDetectHighContrast=(q=F==null?void 0:F.autoDetectHighContrast)!==null&&q!==void 0?q:!0,N.accessibilitySupport=S.app.accessibilitySupportEnabled,N.maximized=this._win.isMaximized(),N.perfMarks=y.getMarks(),N.partsSplashPath=R.join(this.environmentService.userDataPath,"rapid_render.json"),N.os={release:w.release()};const O=P.parseArgs(process.argv,P.OPTIONS),k=Object.assign(O,N);for(const _ in k){const W=k[_];(W==null||W===""||W===!1)&&delete k[_]}let L=this.doGetUrl(k);return L.length>pt.MAX_URL_LENGTH&&(this.logService.warn("Application URL exceeds maximum of 2MB and was shortened."),L=this.doGetUrl(Object.assign(Object.assign({},k),{userEnv:void 0})),L.length>pt.MAX_URL_LENGTH&&this.logService.error("Application URL exceeds maximum of 2MB and cannot be loaded.")),L}doGetUrl(N){let q;return this.environmentService.sandbox?q="vs/code/electron-sandbox/workbench/workbench.html":q="vs/code/electron-browser/workbench/workbench.html",T.FileAccess.asBrowserUri(q,$).with({query:`config=${encodeURIComponent(JSON.stringify(N))}`}).toString(!0)}serializeWindowState(){if(!this._win)return e.defaultWindowState();if(this.isFullScreen){let F;try{F=S.screen.getDisplayMatching(this.getBounds())}catch(k){}const z=e.defaultWindowState();return{mode:3,display:F?F.id:void 0,width:this.windowState.width||z.width,height:this.windowState.height||z.height,x:this.windowState.x||0,y:this.windowState.y||0}}const N=Object.create(null);let q;if(!p.isMacintosh&&this._win.isMaximized()?q=0:q=1,q===0?N.mode=0:N.mode=1,q===1||q===0){let F;q===1?F=this.getBounds():F=this._win.getNormalBounds(),N.x=F.x,N.y=F.y,N.width=F.width,N.height=F.height}return N}restoreWindowState(N){let q=!1;if(N)try{const F=S.screen.getAllDisplays();q=F.length>1,N=this.validateWindowState(N,F)}catch(F){this.logService.warn(`Unexpected error validating window state: ${F}
${F.stack}`)}return[N||e.defaultWindowState(),q]}validateWindowState(N,q){var F,z;if(this.logService.trace(`window#validateWindowState: validating window state on ${q.length} display(s)`,N),typeof N.x!="number"||typeof N.y!="number"||typeof N.width!="number"||typeof N.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(N.width<=0||N.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(q.length===1){const _=this.getWorkingArea(q[0]);if(_){this.logService.trace("window#validateWindowState: 1 monitor working area",_);function O(){!N||typeof N.x!="number"||typeof N.y!="number"||!_||(N.x<_.x&&(N.x=_.x),N.y<_.y&&(N.y=_.y))}O(),N.width>_.width&&(N.width=_.width),N.height>_.height&&(N.height=_.height),N.x>_.x+_.width-128&&(N.x=_.x+_.width-N.width),N.y>_.y+_.height-128&&(N.y=_.y+_.height-N.height),O()}return N}if(N.display&&N.mode===3){const _=q.find(W=>W.id===N.display);if(_&&typeof((F=_.bounds)===null||F===void 0?void 0:F.x)=="number"&&typeof((z=_.bounds)===null||z===void 0?void 0:z.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const W=e.defaultWindowState(3);return W.x=_.bounds.x,W.y=_.bounds.y,W}}let k,L;try{k=S.screen.getDisplayMatching({x:N.x,y:N.y,width:N.width,height:N.height}),L=this.getWorkingArea(k)}catch(_){}if(k&&L&&N.x+N.width>L.x&&N.y+N.height>L.y&&N.x<L.x+L.width&&N.y<L.y+L.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",L),N}getWorkingArea(N){if(N.workArea.width>0&&N.workArea.height>0)return N.workArea;if(N.bounds.width>0&&N.bounds.height>0)return N.bounds}getBounds(){const N=this._win.getPosition(),q=this._win.getSize();return{x:N[0],y:N[1],width:q[0],height:q[1]}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(N){this.useNativeFullScreen()?this.setNativeFullScreen(N):this.setSimpleFullScreen(N),this.sendWhenReady(N?"vscode:enterFullScreen":"vscode:leaveFullScreen",j.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(N){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(N)}setSimpleFullScreen(N){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(N),this._win.webContents.focus()}useNativeFullScreen(){const N=this.configurationService.getValue("window");return!N||typeof N.nativeFullScreen!="boolean"||N.nativeTabs?!0:N.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let N=h.getMenuBarVisibility(this.configurationService);return["visible","toggle","hidden"].indexOf(N)<0&&(N="default"),N}setMenuBarVisibility(N,q=!0){p.isMacintosh||(N==="toggle"&&q&&this.send("vscode:showInfoMessage",D.localize(10,null)),N==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(N)}):this.doSetMenuBarVisibility(N))}doSetMenuBarVisibility(N){const q=this.isFullScreen;switch(N){case"default":this._win.setMenuBarVisibility(!q),this._win.autoHideMenuBar=q;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(p.isMacintosh)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.win.minimize();break;case"None":break;case"Maximize":default:this.win.isMaximized()?this.win.unmaximize():this.win.maximize()}else this.win.isMaximized()?this.win.unmaximize():this.win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(N,q,...F){this.isReady?this.send(N,...F):this.ready().then(()=>{q.isCancellationRequested||this.send(N,...F)})}send(N,...q){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${N} for window that is destroyed`);return}this._win.webContents.send(N,...q)}}updateTouchBar(N){!p.isMacintosh||this.touchBarGroups.forEach((q,F)=>{const z=N[F];q.segments=this.createTouchBarGroupSegments(z)})}createTouchBar(){if(!!p.isMacintosh){for(let N=0;N<10;N++){const q=this.createTouchBarGroup();this.touchBarGroups.push(q)}this._win.setTouchBar(new S.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(N=[]){const q=this.createTouchBarGroupSegments(N),F=new S.TouchBar.TouchBarSegmentedControl({segments:q,mode:"buttons",segmentStyle:"automatic",change:z=>{this.sendWhenReady("vscode:runAction",j.CancellationToken.None,{id:F.segments[z].id,from:"touchbar"})}});return F}createTouchBarGroupSegments(N=[]){return N.map(F=>{var z,O;let k;F.icon&&!c.ThemeIcon.isThemeIcon(F.icon)&&((O=(z=F.icon)===null||z===void 0?void 0:z.dark)===null||O===void 0?void 0:O.scheme)===T.Schemas.file&&(k=S.nativeImage.createFromPath(n.URI.revive(F.icon.dark).fsPath),k.isEmpty()&&(k=void 0));let L;return typeof F.title=="string"?L=F.title:L=F.title.value,{id:F.id,label:k?void 0:L,icon:k}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};Z.MAX_URL_LENGTH=2*A.ByteSize.MB,Z=de([re(1,E.ILogService),re(2,i.IEnvironmentMainService),re(3,A.IFileService),re(4,I.IStorageMainService),re(5,m.IConfigurationService),re(6,u.IThemeMainService),re(7,l.IWorkspacesManagementMainService),re(8,a.IBackupMainService),re(9,r.ITelemetryService),re(10,o.IDialogMainService),re(11,g.ILifecycleMainService)],Z),e.CodeWindow=Z}),define(Q[96],J([0,1,8,92,3,5,34,26,50,19,7,11,32,54,24,31]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=y.createDecorator(e.ID);let p=class{constructor(l,a,s,u,t){this.logService=l,this.windowsMainService=a,this.urlService=s,this.workspacesManagementMainService=u,this.configurationService=t}async start(l,a){this.logService.trace("Received data from other instance: ",l,a),D.isMacintosh&&m.app.focus({steal:!0});const s=this.parseOpenUrl(l);if(s.length){let u=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(u=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),u.then(()=>{for(const{uri:t,url:r}of s)this.urlService.open(t,{originalUrl:r})})}else return this.startOpenWindow(l,a)}parseOpenUrl(l){return l["open-url"]&&l._urls&&l._urls.length>0?P.coalesce(l._urls.map(a=>{try{return{uri:E.URI.parse(a),url:a}}catch(s){return null}})):[]}async startOpenWindow(l,a){const s=f.isLaunchedFromCli(a)?0:4;let u=[];const t=l.wait&&l.waitMarkerFilePath?E.URI.file(l.waitMarkerFilePath):void 0;if(l.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(l.extensionDevelopmentPath,{context:s,cli:l,userEnv:a,waitMarkerFileURI:t});else if(!l._.length&&!l["folder-uri"]&&!l["file-uri"]){let r=!1;if(l["new-window"]||l["unity-launch"])r=!0;else if(l["reuse-window"])r=!1;else{const o=this.configurationService.getValue("window");switch((o==null?void 0:o.openWithoutArgumentsInNewWindow)||"default"){case"on":r=!0;break;case"off":r=!1;break;default:r=!D.isMacintosh}}if(r)u=this.windowsMainService.open({context:s,cli:l,userEnv:a,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:t});else{const o=this.windowsMainService.getLastActiveWindow();o?(o.focus(),u=[o]):u=this.windowsMainService.open({context:s,cli:l,forceEmpty:!0})}}else u=this.windowsMainService.open({context:s,cli:l,userEnv:a,forceNewWindow:l["new-window"],preferNewWindow:!l["reuse-window"]&&!l.wait,forceReuseWindow:l["reuse-window"],diffMode:l.diff,addMode:l.add,noRecentEntry:!!l["skip-add-to-recently-opened"],waitMarkerFileURI:t,gotoLineMode:l.goto});if(t&&u.length===1&&u[0])return Promise.race([u[0].whenClosedOrLoaded,n.whenDeleted(t.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const l=[];return m.BrowserWindow.getAllWindows().forEach(a=>{const s=this.windowsMainService.getWindowById(a.id);s?l.push(this.codeWindowToInfo(s)):l.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:l,screenReader:!!m.app.accessibilitySupportEnabled,gpuFeatureStatus:m.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(l){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(u=>new Promise(t=>{const r=u.remoteAuthority;if(r){const o=`vscode:getDiagnosticInfoResponse${u.id}`,d={includeProcesses:l.includeProcesses,folders:l.includeWorkspaceMetadata?this.getFolderURIs(u):void 0};u.sendWhenReady("vscode:getDiagnosticInfo",h.CancellationToken.None,{replyChannel:o,args:d}),m.ipcMain.once(o,(c,g)=>{g||t({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),t(g)}),setTimeout(()=>{t({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else t(void 0)})))).filter(u=>!!u)}getFolderURIs(l){const a=[],s=l.openedWorkspace;if(v.isSingleFolderWorkspaceIdentifier(s))a.push(s.uri);else if(v.isWorkspaceIdentifier(s)){const u=this.workspacesManagementMainService.resolveLocalWorkspaceSync(s.configPath);u&&u.folders.forEach(r=>{a.push(r.uri)})}return a}codeWindowToInfo(l){const a=this.getFolderURIs(l);return this.browserWindowToInfo(l.win,a,l.remoteAuthority)}browserWindowToInfo(l,a=[],s){return{pid:l.webContents.getOSProcessId(),title:l.getTitle(),folderURIs:a,remoteAuthority:s}}};p=de([re(0,w.ILogService),re(1,M.IWindowsMainService),re(2,R.IURLService),re(3,S.IWorkspacesManagementMainService),re(4,i.IConfigurationService)],p),e.LaunchMainService=p}),define(Q[224],J([0,1,141,27,15,59,11,96,83,71,23,3,8,77,48,5,61,10,43]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h,v,p,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0;const a="#1E1E1E";e.IIssueMainService=v.createDecorator("issueMainService");let s=class{constructor(r,o,d,c,g,I,A,T){this.machineId=r,this.userEnv=o,this.environmentService=d,this.launchMainService=c,this.logService=g,this.diagnosticsService=I,this.dialogMainService=A,this.nativeHostMainService=T,this._issueWindow=null,this._issueParentWindow=null,this._processExplorerWindow=null,this._processExplorerParentWindow=null,this.registerListeners()}registerListeners(){M.ipcMain.on("vscode:issueSystemInfoRequest",async r=>{Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]).then(o=>{const[d,c]=o;this.diagnosticsService.getSystemInfo(d,c).then(g=>{this.safeSend(r,"vscode:issueSystemInfoResponse",g)})})}),M.ipcMain.on("vscode:listProcesses",async r=>{const o=[];try{const d=await this.launchMainService.getMainProcessId();o.push({name:w.localize(0,null),rootProcess:await f.listProcesses(d)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(c=>{S.isRemoteDiagnosticError(c)?o.push({name:c.hostName,rootProcess:c}):c.processes&&o.push({name:c.hostName,rootProcess:c.processes})})}catch(d){this.logService.error(`Listing processes failed: ${d}`)}this.safeSend(r,"vscode:listProcessesResponse",o)}),M.ipcMain.on("vscode:issueReporterClipboard",r=>{const o={message:w.localize(1,null),type:"warning",buttons:[w.localize(2,null),w.localize(3,null)]};this._issueWindow&&this.dialogMainService.showMessageBox(o,this._issueWindow).then(d=>{this.safeSend(r,"vscode:issueReporterClipboardResponse",d.response===0)})}),M.ipcMain.on("vscode:issuePerformanceInfoRequest",r=>{this.getPerformanceInfo().then(o=>{this.safeSend(r,"vscode:issuePerformanceInfoResponse",o)})}),M.ipcMain.on("vscode:issueReporterConfirmClose",()=>{const r={message:w.localize(4,null),type:"warning",buttons:[w.localize(5,null),w.localize(6,null)]};this._issueWindow&&this.dialogMainService.showMessageBox(r,this._issueWindow).then(o=>{o.response===0&&this._issueWindow&&(this._issueWindow.destroy(),this._issueWindow=null)})}),M.ipcMain.on("vscode:workbenchCommand",(r,o)=>{const{id:d,from:c,args:g}=o;let I;switch(c){case"issueReporter":I=this._issueParentWindow;break;case"processExplorer":I=this._processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${c}`)}I&&I.webContents.send("vscode:runAction",{id:d,from:c,args:g})}),M.ipcMain.on("vscode:openExternal",(r,o)=>{this.nativeHostMainService.openExternal(void 0,o)}),M.ipcMain.on("vscode:closeIssueReporter",r=>{this._issueWindow&&this._issueWindow.close()}),M.ipcMain.on("vscode:closeProcessExplorer",r=>{this._processExplorerWindow&&this._processExplorerWindow.close()}),M.ipcMain.on("vscode:windowsInfoRequest",r=>{this.launchMainService.getMainProcessInfo().then(o=>{this.safeSend(r,"vscode:windowsInfoResponse",o.windows)})})}safeSend(r,o,...d){r.sender.isDestroyed()||r.sender.send(o,...d)}async openReporter(r){if(!this._issueWindow&&(this._issueParentWindow=M.BrowserWindow.getFocusedWindow(),this._issueParentWindow)){const o=this.getWindowPosition(this._issueParentWindow,700,800);this._issueWindow=new M.BrowserWindow({fullscreen:!1,width:o.width,height:o.height,minWidth:300,minHeight:200,x:o.x,y:o.y,title:w.localize(7,null),backgroundColor:r.styles.backgroundColor||a,webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,v8CacheOptions:"bypassHeatCheck",enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:p.zoomLevelToZoomFactor(r.zoomLevel),sandbox:!0,contextIsolation:!0}}),this._issueWindow.setMenuBarVisibility(!1);const d={};this.logService.trace("issueService#openReporter: opening issue reporter"),this._issueWindow.loadURL(this.getIssueReporterPath(r,d)),this._issueWindow.on("close",()=>this._issueWindow=null),this._issueParentWindow.on("closed",()=>{this._issueWindow&&(this._issueWindow.close(),this._issueWindow=null)})}this._issueWindow&&this._issueWindow.focus()}async openProcessExplorer(r){if(!this._processExplorerWindow&&(this._processExplorerParentWindow=M.BrowserWindow.getFocusedWindow(),this._processExplorerParentWindow)){const o=this.getWindowPosition(this._processExplorerParentWindow,800,500);this._processExplorerWindow=new M.BrowserWindow({skipTaskbar:!0,resizable:!0,fullscreen:!1,width:o.width,height:o.height,minWidth:300,minHeight:200,x:o.x,y:o.y,backgroundColor:r.styles.backgroundColor,title:w.localize(8,null),webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,v8CacheOptions:"bypassHeatCheck",enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:p.zoomLevelToZoomFactor(r.zoomLevel),sandbox:!0,contextIsolation:!0}}),this._processExplorerWindow.setMenuBarVisibility(!1);const d={appRoot:this.environmentService.appRoot,windowId:this._processExplorerWindow.id,userEnv:this.userEnv,machineId:this.machineId,data:r};this._processExplorerWindow.loadURL(u("vs/code/electron-sandbox/processExplorer/processExplorer.html",d)),this._processExplorerWindow.on("close",()=>this._processExplorerWindow=null),this._processExplorerParentWindow.on("close",()=>{this._processExplorerWindow&&(this._processExplorerWindow.close(),this._processExplorerWindow=null)})}this._processExplorerWindow&&this._processExplorerWindow.focus()}async getSystemStatus(){return Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]).then(r=>{const[o,d]=r;return this.diagnosticsService.getDiagnostics(o,d)})}getWindowPosition(r,o,d){let c;const g=M.screen.getAllDisplays();if(g.length===1)c=g[0];else{if(m.isMacintosh){const T=M.screen.getCursorScreenPoint();c=M.screen.getDisplayNearestPoint(T)}!c&&r&&(c=M.screen.getDisplayMatching(r.getBounds())),c||(c=M.screen.getPrimaryDisplay()||g[0])}const I={width:o,height:d},A=c.bounds;return I.x=A.x+A.width/2-I.width/2,I.y=A.y+A.height/2-I.height/2,A.width>0&&A.height>0&&(I.x<A.x&&(I.x=A.x),I.y<A.y&&(I.y=A.y),I.x>A.x+A.width&&(I.x=A.x),I.y>A.y+A.height&&(I.y=A.y),I.width>A.width&&(I.width=A.width),I.height>A.height&&(I.height=A.height)),I}getPerformanceInfo(){return new Promise(async(r,o)=>{Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]).then(d=>{const[c,g]=d;this.diagnosticsService.getPerformanceInfo(c,g).then(I=>{r(I)}).catch(I=>{this.logService.warn("issueService#getPerformanceInfo ",I.message),o(I)})})})}getIssueReporterPath(r,o){if(!this._issueWindow)throw new Error("Issue window has been disposed");const d={appRoot:this.environmentService.appRoot,windowId:this._issueWindow.id,machineId:this.machineId,userEnv:this.userEnv,data:r,features:o,disableExtensions:this.environmentService.disableExtensions,os:{type:R.type(),arch:R.arch(),release:R.release()},product:{nameShort:D.default.nameShort,version:D.default.darwinUniversalAssetId?`${D.default.version} (Universal)`:D.default.version,commit:D.default.commit,date:D.default.date,reportIssueUrl:D.default.reportIssueUrl}};return u("vs/code/electron-sandbox/issue/issueReporter.html",d)}};s=de([re(2,E.IEnvironmentMainService),re(3,n.ILaunchMainService),re(4,P.ILogService),re(5,i.IDiagnosticsService),re(6,h.IDialogMainService),re(7,l.INativeHostMainService)],s),e.IssueMainService=s;function u(t,r){const o=y.parseArgs(process.argv,y.OPTIONS),d=Object.assign(o,r);for(const c of Object.keys(d)){const g=c;(d[g]===void 0||d[g]===null||d[g]==="")&&delete d[g]}return b.FileAccess.asBrowserUri(t,$,!0).with({query:`config=${encodeURIComponent(JSON.stringify(d))}`}).toString(!0)}}),define(Q[225],J([0,1,11,2,3,18,7,95,19,22,8,37,34,31]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let h=class yt extends R.Disposable{constructor(s,u,t,r,o){super();this.windowsMainService=s,this.stateService=u,this.lifecycleMainService=t,this.logService=r,this.configurationService=o,this._state=v(this.stateService.getItem(yt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){w.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeWindowClose(s=>this.onBeforeWindowClose(s)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onWindowsCountChanged(s=>{s.newCount-s.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onWindowDestroyed(s=>this.onBeforeWindowClose(s))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const s={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!s.lastActiveWindow){let r=this.windowsMainService.getLastActiveWindow();(!r||r.isExtensionDevelopmentHost)&&(r=this.windowsMainService.getWindows().find(o=>!o.isExtensionDevelopmentHost)),r&&(s.lastActiveWindow=this.toWindowState(r))}const u=this.windowsMainService.getWindows().find(r=>r.isExtensionDevelopmentHost&&!r.isExtensionTestHost);u&&(s.lastPluginDevelopmentHostWindow=this.toWindowState(u)),this.windowsMainService.getWindowCount()>1&&(s.openedWindows=this.windowsMainService.getWindows().filter(r=>!r.isExtensionDevelopmentHost).map(r=>this.toWindowState(r)));const t=b(s);this.stateService.setItem(yt.windowsStateStorageKey,t),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",t)}onBeforeWindowClose(s){if(!this.lifecycleMainService.quitRequested){const u=this.toWindowState(s);s.isExtensionDevelopmentHost&&!s.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=u:!s.isExtensionDevelopmentHost&&s.openedWorkspace&&this._state.openedWindows.forEach(t=>{var r;const o=f.isWorkspaceIdentifier(s.openedWorkspace)&&((r=t.workspace)===null||r===void 0?void 0:r.id)===s.openedWorkspace.id,d=f.isSingleFolderWorkspaceIdentifier(s.openedWorkspace)&&t.folderUri&&y.extUriBiasedIgnorePathCase.isEqual(t.folderUri,s.openedWorkspace.uri);(o||d)&&(t.uiState=u.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=u)}}toWindowState(s){return{workspace:f.isWorkspaceIdentifier(s.openedWorkspace)?s.openedWorkspace:void 0,folderUri:f.isSingleFolderWorkspaceIdentifier(s.openedWorkspace)?s.openedWorkspace.uri:void 0,backupPath:s.backupPath,remoteAuthority:s.remoteAuthority,uiState:s.serializeWindowState()}}getNewWindowState(s){const u=this.doGetNewWindowState(s),t=this.configurationService.getValue("window");let r;return u.hasDefaultState?r=!!((t==null?void 0:t.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):(r=!!(this.lifecycleMainService.wasRestarted||(t==null?void 0:t.restoreFullscreen)),r&&D.isMacintosh&&this.windowsMainService.getWindows().some(o=>o.isFullScreen)&&(r=!1)),u.mode===3&&!r&&(u.mode=1),u}doGetNewWindowState(s){const u=this.windowsMainService.getLastActiveWindow();if(!s.extensionTestsPath){if(!!s.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const g=s.workspace;if(f.isWorkspaceIdentifier(g)){const A=this.state.openedWindows.filter(T=>T.workspace&&T.workspace.id===g.id).map(T=>T.uiState);if(A.length)return A[0]}if(f.isSingleFolderWorkspaceIdentifier(g)){const A=this.state.openedWindows.filter(T=>T.folderUri&&y.extUriBiasedIgnorePathCase.isEqual(T.folderUri,g.uri)).map(T=>T.uiState);if(A.length)return A[0]}else if(s.backupPath){const A=this.state.openedWindows.filter(T=>T.backupPath===s.backupPath).map(T=>T.uiState);if(A.length)return A[0]}const I=this.lastClosedState||this.state.lastActiveWindow;if(!u&&I)return I.uiState}let t;const r=w.screen.getAllDisplays();if(r.length===1)t=r[0];else{if(D.isMacintosh){const g=w.screen.getCursorScreenPoint();t=w.screen.getDisplayNearestPoint(g)}!t&&u&&(t=w.screen.getDisplayMatching(u.getBounds())),t||(t=w.screen.getPrimaryDisplay()||r[0])}let o=n.defaultWindowState();o.x=Math.round(t.bounds.x+t.bounds.width/2-o.width/2),o.y=Math.round(t.bounds.y+t.bounds.height/2-o.height/2);const d=this.configurationService.getValue("window");let c=!0;if(d==null?void 0:d.newWindowDimensions){if(d.newWindowDimensions==="maximized")o.mode=0,c=!1;else if(d.newWindowDimensions==="fullscreen")o.mode=3,c=!1;else if((d.newWindowDimensions==="inherit"||d.newWindowDimensions==="offset")&&u){const g=u.serializeWindowState();g.mode===3?o.mode=3:o=g,c=o.mode!==3&&d.newWindowDimensions==="offset"}}return c&&(o=this.ensureNoOverlap(o)),o.hasDefaultState=!0,o}ensureNoOverlap(s){if(this.windowsMainService.getWindows().length===0)return s;s.x=typeof s.x=="number"?s.x:0,s.y=typeof s.y=="number"?s.y:0;const u=this.windowsMainService.getWindows().map(t=>t.getBounds());for(;u.some(t=>t.x===s.x||t.y===s.y);)s.x+=30,s.y+=30;return s}};h.windowsStateStorageKey="windowsState",h=de([re(0,P.IWindowsMainService),re(1,m.IStateService),re(2,i.ILifecycleMainService),re(3,E.ILogService),re(4,S.IConfigurationService)],h),e.WindowsStateHandler=h;function v(a){const s={openedWindows:[]},u=a||{openedWindows:[]};return u.lastActiveWindow&&(s.lastActiveWindow=p(u.lastActiveWindow)),u.lastPluginDevelopmentHostWindow&&(s.lastPluginDevelopmentHostWindow=p(u.lastPluginDevelopmentHostWindow)),Array.isArray(u.openedWindows)&&(s.openedWindows=u.openedWindows.map(t=>p(t))),s}e.restoreWindowsState=v;function p(a){const s={uiState:a.uiState};return a.backupPath&&(s.backupPath=a.backupPath),a.remoteAuthority&&(s.remoteAuthority=a.remoteAuthority),a.folder&&(s.folderUri=M.URI.parse(a.folder)),a.workspaceIdentifier&&(s.workspace={id:a.workspaceIdentifier.id,configPath:M.URI.parse(a.workspaceIdentifier.configURIPath)}),s}function b(a){return{lastActiveWindow:a.lastActiveWindow&&l(a.lastActiveWindow),lastPluginDevelopmentHostWindow:a.lastPluginDevelopmentHostWindow&&l(a.lastPluginDevelopmentHostWindow),openedWindows:a.openedWindows.map(s=>l(s))}}e.getWindowsStateStoreData=b;function l(a){return{workspaceIdentifier:a.workspace&&{id:a.workspace.id,configURIPath:a.workspace.configPath.toString()},folder:a.folderUri&&a.folderUri.toString(),backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.uiState}}}),define(Q[62],J([0,1,148,32,37,11,8,38,4,3,31,50,9,18,7,10,23,26,22,5,2]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h,v,p,b,l,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=a.createDecorator("workspacesHistoryMainService");let u=class $e extends s.Disposable{constructor(g,I,A,T,U){super();this.stateService=g,this.logService=I,this.workspacesManagementMainService=A,this.environmentService=T,this.lifecycleMainService=U,this._onRecentlyOpenedChange=this._register(new S.Emitter),this.onRecentlyOpenedChange=this._onRecentlyOpenedChange.event,this.macOSRecentDocumentsUpdater=this._register(new P.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onWorkspaceEntered(g=>this.addRecentlyOpened([{workspace:g.workspace}])))}handleWindowsJumpList(){!i.isWindows||(this.updateWindowsJumpList(),this._register(this.onRecentlyOpenedChange(()=>this.updateWindowsJumpList())))}addRecentlyOpened(g){const I=[],A=[];for(let T of g)if(E.isRecentWorkspace(T))!this.workspacesManagementMainService.isUntitledWorkspace(T.workspace)&&r(I,T.workspace)===-1&&I.push(T);else if(E.isRecentFolder(T))o(I,T.folderUri)===-1&&I.push(T);else{const U=d(A,T.fileUri)>=0,j=T.fileUri.scheme===v.Schemas.file&&$e.COMMON_FILES_FILTER.indexOf(f.basename(T.fileUri))>=0;!U&&!j&&(A.push(T),i.isWindows&&T.fileUri.scheme===v.Schemas.file&&y.app.addRecentDocument(T.fileUri.fsPath))}this.addEntriesFromStorage(I,A),I.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(I.length=$e.MAX_TOTAL_RECENT_ENTRIES),A.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(A.length=$e.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:I,files:A}),this._onRecentlyOpenedChange.fire(),i.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(g){const I=j=>{const C=t(j);for(const x of g)if(f.extUriBiasedIgnorePathCase.isEqual(x,C))return!1;return!0},A=this.getRecentlyOpened(),T=A.workspaces.filter(I),U=A.files.filter(I);(T.length!==A.workspaces.length||U.length!==A.files.length)&&(this.saveRecentlyOpened({files:U,workspaces:T}),this._onRecentlyOpenedChange.fire(),i.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!!i.isMacintosh){y.app.clearRecentDocuments();const g=this.getRecentlyOpened(),I=[];let A=0;for(let U=0;U<g.workspaces.length&&A<$e.MAX_MACOS_DOCK_RECENT_WORKSPACES;U++){const j=t(g.workspaces[U]);if(j.scheme===v.Schemas.file){const C=f.originalFSPath(j);await b.exists(C)&&(I.push(C),A++)}}const T=[];for(let U=0;U<g.files.length&&A<$e.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;U++){const j=t(g.files[U]);if(j.scheme===v.Schemas.file){const C=f.originalFSPath(j);if($e.COMMON_FILES_FILTER.includes(f.basename(j))||I.includes(C))continue;await b.exists(C)&&(T.push(C),A++)}}T.reverse().forEach(U=>y.app.addRecentDocument(U)),I.reverse().forEach(U=>y.app.addRecentDocument(U))}}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),y.app.clearRecentDocuments(),this._onRecentlyOpenedChange.fire()}getRecentlyOpened(g){var I,A;const T=[],U=[],j=(I=g==null?void 0:g.config)===null||I===void 0?void 0:I.workspace;E.isWorkspaceIdentifier(j)&&!this.workspacesManagementMainService.isUntitledWorkspace(j)?T.push({workspace:j}):E.isSingleFolderWorkspaceIdentifier(j)&&T.push({folderUri:j.uri});const C=(A=g==null?void 0:g.config)===null||A===void 0?void 0:A.filesToOpenOrCreate;if(C)for(let x of C){const ee=x.fileUri;ee&&d(U,ee)===-1&&U.push({fileUri:ee})}return this.addEntriesFromStorage(T,U),{workspaces:T,files:U}}addEntriesFromStorage(g,I){let A=this.getRecentlyOpenedFromStorage();for(let T of A.workspaces){let U=E.isRecentFolder(T)?o(g,T.folderUri):r(g,T.workspace);U>=0?g[U].label=g[U].label||T.label:g.push(T)}for(let T of A.files){let U=d(I,T.fileUri);U>=0?I[U].label=I[U].label||T.label:I.push(T)}}getRecentlyOpenedFromStorage(){const g=this.stateService.getItem($e.recentlyOpenedStorageKey);return E.restoreRecentlyOpened(g,this.logService)}saveRecentlyOpened(g){const I=E.toStoreData(g);this.stateService.setItem($e.recentlyOpenedStorageKey,I)}updateWindowsJumpList(){if(!!i.isWindows){const g=[];if(g.push({type:"tasks",items:[{type:"task",title:w.localize(0,null),description:w.localize(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let I=[];for(let U of y.app.getJumpListSettings().removedItems){const j=U.args;if(j){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(j);C&&I.push(h.URI.parse(C[2]))}}this.removeRecentlyOpened(I);let A=!1;const T=R.coalesce(this.getRecentlyOpened().workspaces.slice(0,7).map(U=>{const j=E.isRecentWorkspace(U)?U.workspace:U.folderUri,C=U.label?n.splitName(U.label).name:this.getSimpleWorkspaceLabel(j,this.environmentService.untitledWorkspacesHome);let x,ee;return h.URI.isUri(j)?(x=w.localize(2,null,n.getBaseLabel(j),n.getPathLabel(f.dirname(j),this.environmentService)),ee=`--folder-uri "${j.toString()}"`):(A=!0,x=w.localize(3,null,n.getBaseLabel(j.configPath),n.getPathLabel(f.dirname(j.configPath),this.environmentService)),ee=`--file-uri "${j.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:x.substr(0,255),program:process.execPath,args:ee,iconPath:"explorer.exe",iconIndex:0}}));T.length>0&&g.push({type:"custom",name:A?w.localize(4,null):w.localize(5,null),items:T})}g.push({type:"recent"});try{y.app.setJumpList(g)}catch(I){this.logService.warn("updateWindowsJumpList#setJumpList",I)}}}getSimpleWorkspaceLabel(g,I){if(h.URI.isUri(g))return f.basename(g);if(f.extUriBiasedIgnorePathCase.isEqualOrParent(g.configPath,I))return w.localize(6,null);let A=f.basename(g.configPath);return A.endsWith(E.WORKSPACE_EXTENSION)&&(A=A.substr(0,A.length-E.WORKSPACE_EXTENSION.length-1)),w.localize(7,null,A)}};u.MAX_TOTAL_RECENT_ENTRIES=100,u.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,u.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,u.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],u.recentlyOpenedStorageKey="openedPathsList",u=de([re(0,D.IStateService),re(1,M.ILogService),re(2,m.IWorkspacesManagementMainService),re(3,p.IEnvironmentMainService),re(4,l.ILifecycleMainService)],u),e.WorkspacesHistoryMainService=u;function t(c){return E.isRecentFolder(c)?c.folderUri:E.isRecentFile(c)?c.fileUri:c.workspace.configPath}function r(c,g){return c.findIndex(I=>E.isRecentWorkspace(I)&&I.workspace.id===g.id)}function o(c,g){return c.findIndex(I=>E.isRecentFolder(I)&&f.extUriBiasedIgnorePathCase.isEqual(I.folderUri,g))}function d(c,g){return c.findIndex(I=>f.extUriBiasedIgnorePathCase.isEqual(I.fileUri,g))}}),define(Q[226],J([0,1,142,3,23,11,61,19,30,42,15,9,8,38,34,62,177,7,37,22,43,24]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h,v,p,b,l,a,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let r=class St{constructor(c,g,I,A,T,U,j,C,x,ee){this.updateService=c,this.configurationService=g,this.windowsMainService=I,this.environmentService=A,this.telemetryService=T,this.workspacesHistoryMainService=U,this.stateService=j,this.lifecycleMainService=C,this.logService=x,this.nativeHostMainService=ee,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new m.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new m.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(R.isMacintosh||M.getTitleBarStyle(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const c=this.stateService.getItem(St.lastKnownMenubarStorageKey);c&&(c.menus&&(this.menubarMenus=c.menus),c.keybindings&&(this.keybindings=c.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(U,j,C)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:j==null?void 0:j.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(U,j,C)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:j==null?void 0:j.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(U,j,C)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(C),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(U,j,C)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(C),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const c=E.default.twitterUrl;c&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(c,"openTwitterUrl"));const g=E.default.requestFeatureUrl;g&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(g,"openUserVoiceUrl"));const I=E.default.reportIssueUrl;I&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(I,"openReportIssues"));const A=E.default.licenseUrl;A&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(R.language){const U=A.indexOf("?")>0?"&":"?";this.openUrl(`${A}${U}lang=${R.language}`,"openLicenseUrl")}else this.openUrl(A,"openLicenseUrl")});const T=E.default.privacyStatementUrl;T&&A&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(R.language){const U=A.indexOf("?")>0?"&":"?";this.openUrl(`${T}${U}lang=${R.language}`,"openPrivacyStatement")}else this.openUrl(T,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onWindowsCountChanged(c=>this.onWindowsCountChanged(c)),this.nativeHostMainService.onDidBlurWindow(()=>this.onWindowFocusChange()),this.nativeHostMainService.onDidFocusWindow(()=>this.onWindowFocusChange())}get currentEnableMenuBarMnemonics(){let c=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof c!="boolean"&&(c=!0),c}get currentEnableNativeTabs(){if(!R.isMacintosh)return!1;let c=this.configurationService.getValue("window.nativeTabs");return typeof c!="boolean"&&(c=!1),c}updateMenu(c,g){this.menubarMenus=c.menus,this.keybindings=c.keybindings,this.stateService.setItem(St.lastKnownMenubarStorageKey,c),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onWindowsCountChanged(c){!R.isMacintosh||(c.oldCount===0&&c.newCount>0||c.oldCount>0&&c.newCount===0)&&(this.closedLastWindow=c.newCount===0,this.scheduleUpdateMenu())}onWindowFocusChange(){!R.isMacintosh||(this.noActiveWindow=!y.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const c=y.Menu.getApplicationMenu();if(c&&this.oldMenus.push(c),Object.keys(this.menubarMenus).length===0){y.Menu.setApplicationMenu(R.isMacintosh?new y.Menu:null);return}const g=new y.Menu;let I;if(R.isMacintosh){const W=new y.Menu;I=new y.MenuItem({label:E.default.nameShort,submenu:W}),this.setMacApplicationMenu(W),g.append(I)}if(R.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const W=new y.Menu;W.append(new y.MenuItem({label:this.mnemonicLabel(w.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),y.app.dock.setMenu(W)}const A=new y.Menu,T=new y.MenuItem({label:this.mnemonicLabel(w.localize(1,null)),submenu:A});this.setMenuById(A,"File"),g.append(T);const U=new y.Menu,j=new y.MenuItem({label:this.mnemonicLabel(w.localize(2,null)),submenu:U});this.setMenuById(U,"Edit"),g.append(j);const C=new y.Menu,x=new y.MenuItem({label:this.mnemonicLabel(w.localize(3,null)),submenu:C});this.setMenuById(C,"Selection"),g.append(x);const ee=new y.Menu,Z=new y.MenuItem({label:this.mnemonicLabel(w.localize(4,null)),submenu:ee});this.setMenuById(ee,"View"),g.append(Z);const H=new y.Menu,N=new y.MenuItem({label:this.mnemonicLabel(w.localize(5,null)),submenu:H});this.setMenuById(H,"Go"),g.append(N);const q=new y.Menu,F=new y.MenuItem({label:this.mnemonicLabel(w.localize(6,null)),submenu:q});this.setMenuById(q,"Run"),g.append(F);const z=new y.Menu,O=new y.MenuItem({label:this.mnemonicLabel(w.localize(7,null)),submenu:z});this.setMenuById(z,"Terminal"),g.append(O);let k;if(this.shouldDrawMenu("Window")){const W=new y.Menu;k=new y.MenuItem({label:this.mnemonicLabel(w.localize(8,null)),submenu:W,role:"window"}),this.setMacWindowMenu(W)}k&&g.append(k);const L=new y.Menu,_=new y.MenuItem({label:this.mnemonicLabel(w.localize(9,null)),submenu:L,role:"help"});this.setMenuById(L,"Help"),g.append(_),g.items&&g.items.length>0?y.Menu.setApplicationMenu(g):y.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(c){const g=this.createMenuItem(w.localize(10,null,E.default.nameLong),"workbench.action.showAboutDialog"),I=this.getUpdateMenuItems();let A;if(this.shouldDrawMenu("Preferences")){const H=new y.Menu;this.setMenuById(H,"Preferences"),A=new y.MenuItem({label:this.mnemonicLabel(w.localize(11,null)),submenu:H})}const T=new y.Menu,U=new y.MenuItem({label:w.localize(12,null),role:"services",submenu:T}),j=new y.MenuItem({label:w.localize(13,null,E.default.nameLong),role:"hide",accelerator:"Command+H"}),C=new y.MenuItem({label:w.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new y.MenuItem({label:w.localize(15,null),role:"unhide"}),ee=new y.MenuItem(this.likeAction("workbench.action.quit",{label:w.localize(16,null,E.default.nameLong),click:()=>{const H=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!y.BrowserWindow.getFocusedWindow()||(H==null?void 0:H.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),Z=[g];Z.push(...I),A&&Z.push(o(),A),Z.push(o(),U,o(),j,C,x,o(),ee),Z.forEach(H=>c.append(H))}shouldDrawMenu(c){if(!R.isMacintosh&&M.getTitleBarStyle(this.configurationService)==="custom")return!1;switch(c){case"File":case"Help":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[c];case"Window":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[c]}}setMenu(c,g){g.forEach(I=>{if(p.isMenubarMenuItemSeparator(I))c.append(o());else if(p.isMenubarMenuItemSubmenu(I)){const A=new y.Menu,T=new y.MenuItem({label:this.mnemonicLabel(I.label),submenu:A});this.setMenu(A,I.submenu.items),c.append(T)}else p.isMenubarMenuItemUriAction(I)?c.append(this.createOpenRecentMenuItem(I.uri,I.label,I.id)):p.isMenubarMenuItemAction(I)&&(I.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(c),R.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[I.id]?c.append(new y.MenuItem(this.likeAction(I.id,{label:this.mnemonicLabel(I.label),click:this.fallbackMenuHandlers[I.id]}))):c.append(this.createMenuItem(I.label,I.id,!1,I.checked)):c.append(this.createMenuItem(I.label,I.id,I.enabled!==!1,!!I.checked)):c.append(this.createMenuItem(I.label,I.id,I.enabled!==!1,!!I.checked)))})}setMenuById(c,g){this.menubarMenus&&this.menubarMenus[g]&&this.setMenu(c,this.menubarMenus[g].items)}insertCheckForUpdatesItems(c){const g=this.getUpdateMenuItems();g.length&&(g.forEach(I=>c.append(I)),c.append(o()))}createOpenRecentMenuItem(c,g,I){const A=b.URI.revive(c),T=I==="openRecentFile"?{fileUri:A}:I==="openRecentWorkspace"?{workspaceUri:A}:{folderUri:A};return new y.MenuItem(this.likeAction(I,{label:g,click:(U,j,C)=>{const x=this.isOptionClick(C);this.windowsMainService.open({context:2,cli:this.environmentService.args,urisToOpen:[T],forceNewWindow:x,gotoLineMode:!1}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([A])}},!1))}isOptionClick(c){return!!(c&&(!R.isMacintosh&&(c.ctrlKey||c.shiftKey)||R.isMacintosh&&(c.metaKey||c.altKey)))}createRoleMenuItem(c,g,I){const A={label:this.mnemonicLabel(c),role:I,enabled:!0};return new y.MenuItem(this.withKeybinding(g,A))}setMacWindowMenu(c){const g=new y.MenuItem({label:w.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),I=new y.MenuItem({label:w.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),A=new y.MenuItem({label:w.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),T=this.createMenuItem(w.localize(20,null),"workbench.action.switchWindow"),U=[];this.currentEnableNativeTabs&&(U.push(o()),U.push(this.createMenuItem(w.localize(21,null),"workbench.action.newWindowTab")),U.push(this.createRoleMenuItem(w.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),U.push(this.createRoleMenuItem(w.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),U.push(this.createRoleMenuItem(w.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),U.push(this.createRoleMenuItem(w.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[g,I,o(),T,...U,o(),A].forEach(j=>c.append(j))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new y.MenuItem({label:this.mnemonicLabel(w.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate");const g=this.windowsMainService.getLastActiveWindow(),I=g&&`window:${g.id}`;this.updateService.checkForUpdates(I)},0)})];case"checking for updates":return[new y.MenuItem({label:w.localize(27,null),enabled:!1})];case"available for download":return[new y.MenuItem({label:this.mnemonicLabel(w.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new y.MenuItem({label:w.localize(29,null),enabled:!1})];case"downloaded":return[new y.MenuItem({label:this.mnemonicLabel(w.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new y.MenuItem({label:w.localize(31,null),enabled:!1})];case"ready":return[new y.MenuItem({label:this.mnemonicLabel(w.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(c,g,I,A){const T=this.mnemonicLabel(c),U=typeof g=="function"?g:(Z,H,N)=>{const q=Z?Z.userSettingsLabel:null;let F=g;Array.isArray(g)&&(F=this.isOptionClick(N)?g[1]:g[0]),q&&N.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:q}):this.runActionInRenderer({type:"commandId",commandId:F})},j=typeof I=="boolean"?I:this.windowsMainService.getWindowCount()>0,C=typeof A=="boolean"?A:!1,x={label:T,click:U,enabled:j};C&&(x.type="checkbox",x.checked=C);let ee;return typeof g=="string"?ee=g:Array.isArray(g)&&(ee=g[0]),R.isMacintosh&&(ee==="editor.action.clipboardCutAction"?x.role="cut":ee==="editor.action.clipboardCopyAction"?x.role="copy":ee==="editor.action.clipboardPasteAction"&&(x.role="paste"),ee==="undo"?x.click=this.makeContextAwareClickHandler(U,{inDevTools:Z=>Z.undo(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("undo:")}):ee==="redo"?x.click=this.makeContextAwareClickHandler(U,{inDevTools:Z=>Z.redo(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("redo:")}):ee==="editor.action.selectAll"&&(x.click=this.makeContextAwareClickHandler(U,{inDevTools:Z=>Z.selectAll(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("selectAll:")}))),new y.MenuItem(this.withKeybinding(ee,x))}makeContextAwareClickHandler(c,g){return(I,A,T)=>{const U=y.BrowserWindow.getFocusedWindow();if(!U)return g.inNoWindow();if(U.webContents.isDevToolsFocused()&&U.webContents.devToolsWebContents)return g.inDevTools(U.webContents.devToolsWebContents);c(I,A||U,T)}}runActionInRenderer(c){let g=y.BrowserWindow.getFocusedWindow();if(!g){const A=this.windowsMainService.getLastActiveWindow();(A==null?void 0:A.isMinimized())&&(g=A.win)}const I=g?this.windowsMainService.getWindowById(g.id):void 0;if(I){if(this.logService.trace("menubar#runActionInRenderer",c),R.isMacintosh&&!this.environmentService.isBuilt&&!I.isReady&&(c.type==="commandId"&&c.commandId==="workbench.action.toggleDevTools"||c.type!=="commandId"&&c.userSettingsLabel==="alt+cmd+i"))return;if(c.type==="commandId"){const A={id:c.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",u.CancellationToken.None,A)}else{const A={userSettingsLabel:c.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",u.CancellationToken.None,A)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",c)}withKeybinding(c,g){const I=typeof c=="string"?this.keybindings[c]:void 0;if(I==null?void 0:I.label){if(I.isNative!==!1)g.accelerator=I.label,g.userSettingsLabel=I.userSettingsLabel;else if(typeof g.label=="string"){const A=g.label.indexOf("[");A>=0?g.label=`${g.label.substr(0,A)} [${I.label}]`:g.label=`${g.label} [${I.label}]`}}else g.accelerator=void 0;return g}likeAction(c,g,I=!g.accelerator){I&&(g=this.withKeybinding(c,g));const A=g.click;return g.click=(T,U,j)=>{this.reportMenuActionTelemetry(c),A&&A(T,U,j)},g}openUrl(c,g){this.nativeHostMainService.openExternal(void 0,c),this.reportMenuActionTelemetry(g)}reportMenuActionTelemetry(c){this.telemetryService.publicLog2("workbenchActionExecuted",{id:c,from:t})}mnemonicLabel(c){return f.mnemonicMenuLabel(c,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=de([re(0,i.IUpdateService),re(1,n.IConfigurationService),re(2,h.IWindowsMainService),re(3,D.IEnvironmentMainService),re(4,S.ITelemetryService),re(5,v.IWorkspacesHistoryMainService),re(6,l.IStateService),re(7,a.ILifecycleMainService),re(8,P.ILogService),re(9,s.INativeHostMainService)],r),e.Menubar=r;function o(){return new y.MenuItem({type:"separator"})}}),define(Q[227],J([0,1,226,8,5,22]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=D.createDecorator("menubarMainService");let M=class{constructor(S,i,E){this.instantiationService=S,this.lifecycleMainService=i,this.logService=E,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(w.Menubar)}async updateMenubar(S,i){this.logService.trace("menubarService#updateMenubar",S),(await this.menubar).updateMenu(i,S)}};M=de([re(0,D.IInstantiationService),re(1,y.ILifecycleMainService),re(2,R.ILogService)],M),e.MenubarMainService=M}),define(Q[228],J([0,1,25,6,146,32,47,23,37,95,11,22,19,8,61,94,4,15,62,3,31,5,10,7,18,87,225,50,44,2,48,14,28,38,24,21]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h,v,p,b,l,a,s,u,t,r,o,d,c,g,I,A,T,U,j,C,x,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function Z(q){return s.isWorkspaceIdentifier(q==null?void 0:q.workspace)}function H(q){return s.isSingleFolderWorkspaceIdentifier(q==null?void 0:q.workspace)}let N=class Je extends A.Disposable{constructor(F,z,O,k,L,_,W,B,K,X,Y,oe,le){super();this.machineId=F,this.initialUserEnv=z,this.logService=O,this.stateService=k,this.environmentService=L,this.lifecycleMainService=_,this.backupMainService=W,this.configurationService=B,this.workspacesHistoryMainService=K,this.workspacesManagementMainService=X,this.instantiationService=Y,this.dialogMainService=oe,this.fileService=le,this._onWindowOpened=this._register(new p.Emitter),this.onWindowOpened=this._onWindowOpened.event,this._onWindowReady=this._register(new p.Emitter),this.onWindowReady=this._onWindowReady.event,this._onWindowDestroyed=this._register(new p.Emitter),this.onWindowDestroyed=this._onWindowDestroyed.event,this._onWindowsCountChanged=this._register(new p.Emitter),this.onWindowsCountChanged=this._onWindowsCountChanged.event,this.windowsStateHandler=this._register(new c.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.lifecycleMainService.when(2).then(()=>this.registerListeners())}registerListeners(){this._register(this.workspacesManagementMainService.onWorkspaceEntered(F=>this._onWindowReady.fire(F.window)))}openEmptyWindow(F,z){let O=this.environmentService.args;const k=z==null?void 0:z.remoteAuthority;O&&O.remote!==k&&(O=Object.assign(Object.assign({},O),{remote:k}));const L=!0,_=z==null?void 0:z.forceReuseWindow,W=!_;return this.open(Object.assign(Object.assign({},F),{cli:O,forceEmpty:L,forceNewWindow:W,forceReuseWindow:_}))}open(F){this.logService.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const z=[],O=[],k=[],L=[],_=[];let W,B=0;const K=this.getPathsToOpen(F);this.logService.trace("windowsManager#open pathsToOpen",K);for(const ie of K)H(ie)?F.addMode?z.push(ie):O.push(ie):Z(ie)?k.push(ie):ie.fileUri?(W||(W={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ie.remoteAuthority}),W.filesToOpenOrCreate.push(ie)):ie.backupPath?_.push({backupFolder:R.basename(ie.backupPath),remoteAuthority:ie.remoteAuthority}):B++;F.diffMode&&(W==null?void 0:W.filesToOpenOrCreate.length)===2&&(W.filesToDiff=W.filesToOpenOrCreate,W.filesToOpenOrCreate=[]),W&&F.waitMarkerFileURI&&(W.filesToWait={paths:[...W.filesToDiff,...W.filesToOpenOrCreate],waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(L.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),k.push(...L),_.push(...this.backupMainService.getEmptyWindowBackupPaths())):_.length=0;const{windows:X,filesOpenedInWindow:Y}=this.doOpen(F,k,O,_,B,W,z);if(this.logService.trace(`windowsManager#open used window count ${X.length} (workspacesToOpen: ${k.length}, foldersToOpen: ${O.length}, emptyToRestore: ${_.length}, emptyToOpen: ${B})`),X.length>1)if(Y)Y.focus();else{const ie=this.windowsStateHandler.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let G=!0,te=!0;if(ie){const se=X.filter(ae=>this.windowsStateHandler.state.lastActiveWindow&&ae.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);se.length&&(se[0].focus(),G=!1,te=!1)}if(G)for(let se=X.length-1;se>=0;se--){const ae=X[se];if(!(ae.openedWorkspace&&L.some(he=>ae.openedWorkspace&&he.workspace.id===ae.openedWorkspace.id)||ae.backupPath&&_.some(he=>ae.backupPath&&he.backupFolder===R.basename(ae.backupPath)))){ae.focus(),te=!1;break}}te&&X[X.length-1].focus()}const oe=W&&W.filesToDiff.length>0;if(!X.some(ie=>ie.isExtensionDevelopmentHost)&&!oe&&!F.noRecentEntry){const ie=[];for(const G of K)Z(G)?ie.push({label:G.label,workspace:G.workspace}):H(G)?ie.push({label:G.label,folderUri:G.workspace.uri}):G.fileUri&&ie.push({label:G.label,fileUri:G.fileUri});this.workspacesHistoryMainService.addRecentlyOpened(ie)}const le=F.waitMarkerFileURI;return F.context===0&&le&&X.length===1&&X[0]&&X[0].whenClosedOrLoaded.then(()=>this.fileService.del(le),()=>{}),X}doOpen(F,z,O,k,L,_,W){const B=[];let K;function X(se,ae){B.push(se),ae&&(K=se,_=void 0)}let{openFolderInNewWindow:Y,openFilesInNewWindow:oe}=this.shouldOpenNewWindow(F);if(!F.initialStartup&&W.length>0){const se=W[0].remoteAuthority,ae=this.getLastActiveWindowForAuthority(se);ae&&X(this.doAddFoldersToExistingWindow(ae,W.map(he=>he.workspace.uri)))}const le=O.length+z.length+k.length;if(_&&le===0){const se=_.filesToOpenOrCreate[0]||_.filesToDiff[0],ae=this.getWindows().filter(ve=>_&&ve.remoteAuthority===_.remoteAuthority);let he;(se==null?void 0:se.fileUri)&&!oe&&((F.context===4||F.context===0||F.context===1)&&(he=v.findWindowOnFile(ae,se.fileUri,ve=>ve.configPath.scheme===t.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(ve.configPath):null)),he||(he=this.doGetLastActiveWindow(ae))),he?s.isWorkspaceIdentifier(he.openedWorkspace)?z.push({workspace:he.openedWorkspace,remoteAuthority:he.remoteAuthority}):s.isSingleFolderWorkspaceIdentifier(he.openedWorkspace)?O.push({workspace:he.openedWorkspace,remoteAuthority:he.remoteAuthority}):X(this.doOpenFilesInExistingWindow(F,he,_),!0):X(this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:_,forceNewWindow:!0,remoteAuthority:_.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow}),!0)}const ie=y.distinct(z,se=>se.workspace.id);if(ie.length>0){const se=y.coalesce(ie.map(ae=>v.findWindowOnWorkspaceOrFolder(this.getWindows(),ae.workspace.configPath)));if(se.length>0){const ae=se[0],he=(_==null?void 0:_.remoteAuthority)===ae.remoteAuthority?_:void 0;X(this.doOpenFilesInExistingWindow(F,ae,he),!!he),Y=!0}ie.forEach(ae=>{if(!se.some(be=>be.openedWorkspace&&be.openedWorkspace.id===ae.workspace.id)){const he=ae.remoteAuthority,ve=(_==null?void 0:_.remoteAuthority)===he?_:void 0;X(this.doOpenFolderOrWorkspace(F,ae,Y,ve),!!ve),Y=!0}})}const G=y.distinct(O,se=>o.extUriBiasedIgnorePathCase.getComparisonKey(se.workspace.uri));if(G.length>0){const se=y.coalesce(G.map(ae=>v.findWindowOnWorkspaceOrFolder(this.getWindows(),ae.workspace.uri)));if(se.length>0){const ae=se[0],he=(_==null?void 0:_.remoteAuthority)===ae.remoteAuthority?_:void 0;X(this.doOpenFilesInExistingWindow(F,ae,he),!!he),Y=!0}G.forEach(ae=>{if(!se.some(be=>s.isSingleFolderWorkspaceIdentifier(be.openedWorkspace)&&o.extUriBiasedIgnorePathCase.isEqual(be.openedWorkspace.uri,ae.workspace.uri))){const he=ae.remoteAuthority,ve=(_==null?void 0:_.remoteAuthority)===he?_:void 0;X(this.doOpenFolderOrWorkspace(F,ae,Y,ve),!!ve),Y=!0}})}const te=y.distinct(k,se=>se.backupFolder);if(te.length>0&&te.forEach(se=>{const ae=se.remoteAuthority,he=(_==null?void 0:_.remoteAuthority)===ae?_:void 0;X(this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:he,remoteAuthority:ae,forceNewWindow:!0,forceNewTabbedWindow:F.forceNewTabbedWindow,emptyWindowBackupInfo:se}),!!he),Y=!0}),B.length===0||_){_&&!L&&L++;const se=_?_.remoteAuthority:F.cli&&F.cli.remote||void 0;for(let ae=0;ae<L;ae++)X(this.doOpenEmpty(F,Y,se,_),!!_),Y=!0}return{windows:y.distinct(B),filesOpenedInWindow:K}}doOpenFilesInExistingWindow(F,z,O){var k;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),z.focus();const L={filesToOpenOrCreate:O==null?void 0:O.filesToOpenOrCreate,filesToDiff:O==null?void 0:O.filesToDiff,filesToWait:O==null?void 0:O.filesToWait,termProgram:(k=F==null?void 0:F.userEnv)===null||k===void 0?void 0:k.TERM_PROGRAM};return z.sendWhenReady("vscode:openFiles",x.CancellationToken.None,L),z}doAddFoldersToExistingWindow(F,z){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),F.focus();const O={foldersToAdd:z};return F.sendWhenReady("vscode:addFolders",x.CancellationToken.None,O),F}doOpenEmpty(F,z,O,k,L){return!z&&!L&&typeof F.contextWindowId=="number"&&(L=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:O,forceNewWindow:z,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:k,windowToUse:L})}doOpenFolderOrWorkspace(F,z,O,k,L){return!O&&!L&&typeof F.contextWindowId=="number"&&(L=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({workspace:z.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:z.remoteAuthority,forceNewWindow:O,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:k,windowToUse:L})}getPathsToOpen(F){var z;let O,k=!1,L=!1;if(F.urisToOpen&&F.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(F),k=!0):F.forceEmpty?O=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?(O=this.doExtractPathsFromCLI(F.cli),O.length===0&&O.push(Object.create(null)),k=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),L=!0),!F.addMode&&k){const _=O.filter(W=>H(W));if(_.length>1){const W=_[0].remoteAuthority;if(_.every(B=>B.remoteAuthority===W)){const B=this.workspacesManagementMainService.createUntitledWorkspaceSync(_.map(K=>({uri:K.workspace.uri})));O.push({workspace:B,remoteAuthority:W}),O=O.filter(K=>!H(K))}}}return F.initialStartup&&!L&&((z=this.configurationService.getValue("window"))===null||z===void 0?void 0:z.restoreWindows)==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter(_=>Z(_)||H(_)||_.backupPath)),O}doExtractPathsFromAPI(F){const z=[],O={gotoLineMode:F.gotoLineMode};for(const k of y.coalesce(F.urisToOpen||[])){const L=this.resolveOpenable(k,O);if(L)L.label=k.label,z.push(L);else{const _=this.resourceFromOpenable(k),W={title:b.default.nameLong,type:"info",buttons:[D.localize(0,null)],message:_.scheme===t.Schemas.file?D.localize(1,null):D.localize(2,null),detail:_.scheme===t.Schemas.file?D.localize(3,null,C.getPathLabel(_.fsPath,this.environmentService)):D.localize(4,null,_.toString()),noLink:!0};this.dialogMainService.showMessageBox(W,U.withNullAsUndefined(E.BrowserWindow.getFocusedWindow()))}}return z}doExtractPathsFromCLI(F){const z=[],O={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0},k=F["folder-uri"];if(k)for(const W of k){const B=this.cliArgToUri(W);if(B){const K=this.resolveOpenable({folderUri:B},O);K&&z.push(K)}}const L=F["file-uri"];if(L)for(const W of L){const B=this.cliArgToUri(W);if(B){const K=this.resolveOpenable(s.hasWorkspaceFileExtension(W)?{workspaceUri:B}:{fileUri:B},O);K&&z.push(K)}}const _=F._;for(const W of _){const B=this.doResolveFileOpenable(W,O);B&&z.push(B)}return z}cliArgToUri(F){try{const z=r.URI.parse(F);if(!z.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${F}`);return}return z}catch(z){this.logService.error(`Invalid URI input string: ${F}, ${z.message}`)}}doGetPathsFromLastSession(){const F=this.getRestoreWindowsSetting();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":const z=[];F!=="one"&&z.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&z.push(this.windowsStateHandler.state.lastActiveWindow);const O=[];for(const k of z)if(k.workspace){const L=this.resolveOpenable({workspaceUri:k.workspace.configPath},{remoteAuthority:k.remoteAuthority});Z(L)&&O.push(L)}else if(k.folderUri){const L=this.resolveOpenable({folderUri:k.folderUri},{remoteAuthority:k.remoteAuthority});H(L)&&O.push(L)}else F!=="folders"&&k.backupPath&&O.push({backupPath:k.backupPath,remoteAuthority:k.remoteAuthority});return O}}getRestoreWindowsSetting(){let F;if(this.lifecycleMainService.wasRestarted)F="all";else{const z=this.configurationService.getValue("window");F=(z==null?void 0:z.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")}return F}resolveOpenable(F,z={}){return this.resourceFromOpenable(F).scheme===t.Schemas.file?this.doResolveFileOpenable(F,z):this.doResolveRemoteOpenable(F,z)}doResolveRemoteOpenable(F,z){let O=this.resourceFromOpenable(F);const k=z.remoteAuthority||d.getRemoteAuthority(O);if(O=o.removeTrailingPathSeparator(o.normalizePath(O)),h.isFileToOpen(F)){if(z.gotoLineMode){const{path:L,line:_,column:W}=j.parseLineAndColumnAware(O.path);return{fileUri:O.with({path:L}),lineNumber:_,columnNumber:W,remoteAuthority:k}}return{fileUri:O,remoteAuthority:k}}else if(h.isWorkspaceToOpen(F))return{workspace:g.getWorkspaceIdentifier(O),remoteAuthority:k};return{workspace:g.getSingleFolderWorkspaceIdentifier(O),remoteAuthority:k}}resourceFromOpenable(F){return h.isWorkspaceToOpen(F)?F.workspaceUri:h.isFolderToOpen(F)?F.folderUri:F.fileUri}doResolveFileOpenable(F,z){let O,k=!1;typeof F=="string"?O=F:(O=this.resourceFromOpenable(F).fsPath,k=h.isFileToOpen(F));let L,_;if(z.gotoLineMode){const B=j.parseLineAndColumnAware(O);L=B.line,_=B.column,O=B.path}const W=z.remoteAuthority;return W?this.doResolvePathRemote(O,W,k):this.doResolvePathLocal(O,z,L,_,k)}doResolvePathRemote(F,z,O){const k=F.charCodeAt(0);k!==47&&(j.isWindowsDriveLetter(k)&&F.charCodeAt(F.charCodeAt(1))===58&&(F=j.toSlashes(F)),F=`/${F}`);const L=r.URI.from({scheme:t.Schemas.vscodeRemote,authority:z,path:F});if(F.charCodeAt(F.length-1)!==47){if(s.hasWorkspaceFileExtension(F))return O?{fileUri:L,remoteAuthority:z}:{workspace:g.getWorkspaceIdentifier(L),remoteAuthority:z};if(R.posix.basename(F).indexOf(".")!==-1)return{fileUri:L,remoteAuthority:z}}return{workspace:g.getSingleFolderWorkspaceIdentifier(L),remoteAuthority:z}}doResolvePathLocal(F,z,O,k,L){F=j.sanitizeFilePath(R.normalize(F),process.env.VSCODE_CWD||process.cwd());try{const _=w.statSync(F);if(_.isFile()){if(!L){const W=this.workspacesManagementMainService.resolveLocalWorkspaceSync(r.URI.file(F));if(W)return{workspace:{id:W.id,configPath:W.configPath},remoteAuthority:W.remoteAuthority,exists:!0}}return{fileUri:r.URI.file(F),lineNumber:O,columnNumber:k,exists:!0}}else if(_.isDirectory())return{workspace:g.getSingleFolderWorkspaceIdentifier(r.URI.file(F),_),exists:!0}}catch(_){const W=r.URI.file(F);if(this.workspacesHistoryMainService.removeRecentlyOpened([W]),z==null?void 0:z.ignoreFileNotFound)return{fileUri:W,exists:!1}}}shouldOpenNewWindow(F){const z=this.configurationService.getValue("window"),O=(z==null?void 0:z.openFoldersInNewWindow)||"default",k=(z==null?void 0:z.openFilesInNewWindow)||"off";let L=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(O==="on"||O==="off")&&(L=O==="on");let _=!1;return F.forceNewWindow||F.forceReuseWindow?_=!!F.forceNewWindow&&!F.forceReuseWindow:(a.isMacintosh?F.context===1&&(_=!0):F.context!==3&&F.context!==2&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&(_=!0),!F.cli.extensionDevelopmentPath&&(k==="on"||k==="off")&&(_=k==="on")),{openFolderInNewWindow:!!L,openFilesInNewWindow:_}}openExtensionDevelopmentHostWindow(F,z){const O=v.findWindowOnExtensionDevelopmentPath(this.getWindows(),F);if(O)return this.lifecycleMainService.reload(O,z.cli),O.focus(),[O];let k=z.cli["folder-uri"]||[],L=z.cli["file-uri"]||[],_=z.cli._;if(!_.length&&!k.length&&!L.length&&!z.cli.extensionTestsPath){const X=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,Y=X&&(X.workspace||X.folderUri);Y&&(r.URI.isUri(Y)?Y.scheme===t.Schemas.file?_=[Y.fsPath]:k=[Y.toString()]:Y.configPath.scheme===t.Schemas.file?_=[o.originalFSPath(Y.configPath)]:L=[Y.configPath.toString()])}let W="";for(const X of F)if(X.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const Y=r.URI.parse(X);Y.scheme===t.Schemas.vscodeRemote&&(W?Y.authority!==W&&this.logService.error("more than one extension development path authority"):W=Y.authority)}_=_.filter(X=>{const Y=r.URI.file(X);return v.findWindowOnWorkspaceOrFolder(this.getWindows(),Y)?!1:Y.authority===W}),k=k.filter(X=>{const Y=this.cliArgToUri(X);return Y&&!!v.findWindowOnWorkspaceOrFolder(this.getWindows(),Y)?!1:Y?Y.authority===W:!1}),L=L.filter(X=>{const Y=this.cliArgToUri(X);return Y&&!!v.findWindowOnWorkspaceOrFolder(this.getWindows(),Y)?!1:Y?Y.authority===W:!1}),z.cli._=_,z.cli["folder-uri"]=k,z.cli["file-uri"]=L;const B=!_.length&&!k.length&&!L.length;B&&W&&(z.cli.remote=W);const K={context:z.context,cli:z.cli,forceNewWindow:!0,forceEmpty:B,userEnv:z.userEnv,noRecentEntry:!0,waitMarkerFileURI:z.waitMarkerFileURI};return this.open(K)}openInBrowserWindow(F){const z=Object.assign({},F.cli);z.appRoot=this.environmentService.appRoot,z.machineId=this.machineId,z.nodeCachedDataDir=this.environmentService.nodeCachedDataDir,z.mainPid=process.pid,z.execPath=process.execPath,z.userEnv=Object.assign(Object.assign({},this.initialUserEnv),F.userEnv),z.isInitialStartup=F.initialStartup,z.workspace=F.workspace,z.remoteAuthority=F.remoteAuthority;const O=F.filesToOpen;O&&(z.filesToOpenOrCreate=O.filesToOpenOrCreate,z.filesToDiff=O.filesToDiff,z.filesToWait=O.filesToWait),F.emptyWindowBackupInfo&&(z.backupPath=R.join(this.environmentService.backupHome,F.emptyWindowBackupInfo.backupFolder));let k;if(!F.forceNewWindow&&!F.forceNewTabbedWindow&&(k=F.windowToUse||this.getLastActiveWindow(),k&&k.focus()),k){const L=k.config;!z.extensionDevelopmentPath&&L&&!!L.extensionDevelopmentPath&&(z.extensionDevelopmentPath=L.extensionDevelopmentPath,z.verbose=L.verbose,z["inspect-brk-extensions"]=L["inspect-brk-extensions"],z.debugId=L.debugId,z["inspect-extensions"]=L["inspect-extensions"],z["extensions-dir"]=L["extensions-dir"])}else{const L=this.windowsStateHandler.getNewWindowState(z),_=k=this.instantiationService.createInstance(i.CodeWindow,{state:L,extensionDevelopmentPath:z.extensionDevelopmentPath,isExtensionTestHost:!!z.extensionTestsPath});if(F.forceNewTabbedWindow){const W=this.getLastActiveWindow();W&&W.addTabbedWindow(_)}Je.WINDOWS.push(_),this._onWindowOpened.fire(_),this._onWindowsCountChanged.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),I.once(_.onReady)(()=>this._onWindowReady.fire(_)),I.once(_.onClose)(()=>this.onWindowClosed(_)),I.once(_.onDestroy)(()=>this._onWindowDestroyed.fire(_)),_.win.webContents.removeAllListeners("devtools-reload-page"),_.win.webContents.on("devtools-reload-page",()=>this.lifecycleMainService.reload(_)),this.lifecycleMainService.registerWindow(_)}return k.isReady?this.lifecycleMainService.unload(k,4).then(L=>{L||this.doOpenInBrowserWindow(k,z,F)}):this.doOpenInBrowserWindow(k,z,F),k}doOpenInBrowserWindow(F,z,O){if(!z.extensionDevelopmentPath)if(s.isWorkspaceIdentifier(z.workspace))z.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:z.workspace,remoteAuthority:z.remoteAuthority});else if(s.isSingleFolderWorkspaceIdentifier(z.workspace))z.backupPath=this.backupMainService.registerFolderBackupSync(z.workspace.uri);else{const k=O.emptyWindowBackupInfo&&O.emptyWindowBackupInfo.backupFolder;z.backupPath=this.backupMainService.registerEmptyWindowBackupSync(k,z.remoteAuthority)}F.load(z)}onWindowClosed(F){const z=Je.WINDOWS.indexOf(F);Je.WINDOWS.splice(z,1),this._onWindowsCountChanged.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const F=E.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(F){return this.doGetLastActiveWindow(this.getWindows().filter(z=>z.remoteAuthority===F))}doGetLastActiveWindow(F){const z=Math.max.apply(Math,F.map(O=>O.lastFocusTime));return F.find(O=>O.lastFocusTime===z)}sendToFocused(F,...z){const O=this.getFocusedWindow()||this.getLastActiveWindow();O&&O.sendWhenReady(F,x.CancellationToken.None,...z)}sendToAll(F,z,O){for(const k of this.getWindows())O&&O.indexOf(k.id)>=0||k.sendWhenReady(F,x.CancellationToken.None,z)}getWindows(){return Je.WINDOWS}getWindowCount(){return Je.WINDOWS.length}getWindowById(F){const z=this.getWindows().filter(O=>O.id===F);return y.firstOrDefault(z)}getWindowByWebContents(F){const z=E.BrowserWindow.fromWebContents(F);if(!!z)return this.getWindowById(z.id)}};N.WINDOWS=[],N=de([re(2,f.ILogService),re(3,S.IStateService),re(4,n.IEnvironmentMainService),re(5,m.ILifecycleMainService),re(6,M.IBackupMainService),re(7,P.IConfigurationService),re(8,l.IWorkspacesHistoryMainService),re(9,g.IWorkspacesManagementMainService),re(10,u.IInstantiationService),re(11,T.IDialogMainService),re(12,ee.IFileService)],N),e.WindowsMainService=N}),define(Q[229],J([0,1,50,34,62,47]),function($,e,w,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(S,i,E,m){this.workspacesManagementMainService=S,this.windowsMainService=i,this.workspacesHistoryMainService=E,this.backupMainService=m,this.onRecentlyOpenedChange=this.workspacesHistoryMainService.onRecentlyOpenedChange}async enterWorkspace(S,i){const E=this.windowsMainService.getWindowById(S);return E?this.workspacesManagementMainService.enterWorkspace(E,this.windowsMainService.getWindows(),i):null}createUntitledWorkspace(S,i,E){return this.workspacesManagementMainService.createUntitledWorkspace(i,E)}deleteUntitledWorkspace(S,i){return this.workspacesManagementMainService.deleteUntitledWorkspace(i)}getWorkspaceIdentifier(S,i){return this.workspacesManagementMainService.getWorkspaceIdentifier(i)}async getRecentlyOpened(S){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(S))}async addRecentlyOpened(S,i){return this.workspacesHistoryMainService.addRecentlyOpened(i)}async removeRecentlyOpened(S,i){return this.workspacesHistoryMainService.removeRecentlyOpened(i)}async clearRecentlyOpened(S){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=de([re(0,w.IWorkspacesManagementMainService),re(1,R.IWindowsMainService),re(2,D.IWorkspacesHistoryMainService),re(3,y.IBackupMainService)],M),e.WorkspacesMainService=M}),define(Q[230],J([0,1,11,27,3,228,22,163,42,197,33,119,79,212,96,5,70,69,8,37,23,19,92,198,30,91,192,193,189,15,214,170,2,34,7,31,229,66,223,221,220,224,175,16,200,215,227,9,116,6,18,129,10,222,90,191,213,47,62,199,50,25,71,82,150,43,48,14,38,206,202,21,40,29,20,84,207,168,158,54,28,24,160,178,44]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h,v,p,b,l,a,s,u,t,r,o,d,c,g,I,A,T,U,j,C,x,ee,Z,H,N,q,F,z,O,k,L,_,W,B,K,X,Y,oe,le,ie,G,te,se,ae,he,ve,be,Ie,Le,Ae,Ne,je,Ke,Ze,qe,ot,Be,at,V,ne,ce,ue,ge,we,Ee,Re,Fe,We,ze,Ut,Nt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let lt=class extends j.Disposable{constructor(me,ye,Me,fe,Se,pe,Pe,ke,Ce){super();this.mainIpcServer=me,this.userEnv=ye,this.instantiationService=Me,this.logService=fe,this.environmentService=Se,this.lifecycleMainService=pe,this.configurationService=Pe,this.stateService=ke,this.fileService=Ce,this.registerListeners()}registerListeners(){k.setUnexpectedErrorHandler(fe=>this.onUnexpectedError(fe)),process.on("uncaughtException",fe=>this.onUnexpectedError(fe)),process.on("unhandledRejection",fe=>k.onUnexpectedError(fe)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),K.registerContextMenuListener(),w.app.on("accessibility-support-changed",(fe,Se)=>{var pe;(pe=this.windowsMainService)===null||pe===void 0||pe.sendToAll("vscode:accessibilitySupportChanged",Se)}),w.app.on("activate",(fe,Se)=>{var pe;this.logService.trace("app#activate"),Se||(pe=this.windowsMainService)===null||pe===void 0||pe.openEmptyWindow({context:1})}),w.app.on("remote-require",(fe,Se,pe)=>{this.logService.trace("app#on(remote-require): prevented"),fe.preventDefault()}),w.app.on("remote-get-global",(fe,Se,pe)=>{this.logService.trace(`app#on(remote-get-global): prevented on ${pe}`),fe.preventDefault()}),w.app.on("remote-get-builtin",(fe,Se,pe)=>{this.logService.trace(`app#on(remote-get-builtin): prevented on ${pe}`),pe!=="clipboard"&&fe.preventDefault()}),w.app.on("remote-get-current-window",fe=>{this.logService.trace("app#on(remote-get-current-window): prevented"),fe.preventDefault()}),w.app.on("remote-get-current-web-contents",fe=>{this.environmentService.args.driver||(this.logService.trace("app#on(remote-get-current-web-contents): prevented"),fe.preventDefault())}),w.app.on("web-contents-created",(fe,Se)=>{Se.on("will-attach-webview",(pe,Pe,ke)=>{const Ce=_e=>{if(!_e)return!1;const Oe=x.URI.parse(_e);if(Oe.scheme===le.Schemas.vscodeWebview)return Oe.path==="/index.html"||Oe.path==="/electron-browser/index.html";const Ge=Oe.fsPath.toLowerCase(),Ye=x.URI.file(this.environmentService.appRoot).fsPath.toLowerCase();return Ge.startsWith(Ye+X.sep)};delete Pe.preload,Pe.nodeIntegration=!1,!(Ce(ke.src)&&Ce(Pe.preloadURL))&&(delete Pe.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),pe.preventDefault())}),Se.on("will-navigate",pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),pe.preventDefault()}),Se.on("new-window",(pe,Pe)=>{var ke;pe.preventDefault(),(ke=this.nativeHostMainService)===null||ke===void 0||ke.openExternal(void 0,Pe)}),w.session.defaultSession.setPermissionRequestHandler((pe,Pe,ke)=>ke(!1)),w.session.defaultSession.setPermissionCheckHandler((pe,Pe)=>!1)});let me=[],ye=null;w.app.on("open-file",(fe,Se)=>{this.logService.trace("app#open-file: ",Se),fe.preventDefault(),me.push(this.getWindowOpenableFromPathSync(Se)),ye!==null&&(clearTimeout(ye),ye=null),ye=setTimeout(()=>{var pe;(pe=this.windowsMainService)===null||pe===void 0||pe.open({context:1,cli:this.environmentService.args,urisToOpen:me,gotoLineMode:!1,preferNewWindow:!0}),me=[],ye=null},100)}),w.app.on("new-window-for-tab",()=>{var fe;(fe=this.windowsMainService)===null||fe===void 0||fe.openEmptyWindow({context:4})});let Me=!1;w.ipcMain.on("vscode:fetchShellEnv",async fe=>{var Se;const pe=fe.sender;let Pe=!1;function ke(Xe){clearTimeout(_e),clearTimeout(Ge),Pe||(Pe=!0,pe.isDestroyed()||pe.send("vscode:acceptShellEnv",Xe))}const Ce=new We.CancellationTokenSource,_e=setTimeout(()=>{var Xe;Me||((Xe=this.windowsMainService)===null||Xe===void 0||Xe.sendToFocused("vscode:showShellEnvSlowWarning",Ce.token),Me=!0)},3e3),Oe=(Se=this.windowsMainService)===null||Se===void 0?void 0:Se.getWindowByWebContents(fe.sender),Ge=setTimeout(()=>{Ce.dispose(!0),Oe==null||Oe.sendWhenReady("vscode:showShellEnvTimeoutError",We.CancellationToken.None),ke({})},1e4);let Ye,xe;(Oe==null?void 0:Oe.config)?(Ye=Oe.config,xe=Object.assign(Object.assign({},process.env),Oe.config.userEnv)):(Ye=this.environmentService.args,xe=process.env);const ct=await n.resolveShellEnv(this.logService,Ye,xe);ke(ct)}),w.ipcMain.handle("vscode:writeNlsFile",async(fe,Se,pe)=>{const Pe=this.validateNlsPath([Se]);if(!Pe||typeof pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Pe,ce.VSBuffer.fromString(pe))}),w.ipcMain.handle("vscode:readNlsFile",async(fe,...Se)=>{const pe=this.validateNlsPath(Se);if(!pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(pe)).value.toString()}),w.ipcMain.on("vscode:toggleDevTools",fe=>fe.sender.toggleDevTools()),w.ipcMain.on("vscode:openDevTools",fe=>fe.sender.openDevTools()),w.ipcMain.on("vscode:reloadWindow",fe=>fe.sender.reload())}validateNlsPath(me){let ye;for(const Me of me)typeof Me=="string"&&(typeof ye!="string"?ye=Me:ye=X.join(ye,Me));if(!(typeof ye!="string"||!X.isAbsolute(ye)||!Fe.isEqualOrParent(ye,this.environmentService.cachedLanguagesPath,!D.isLinux)))return x.URI.file(ye)}onUnexpectedError(me){var ye;if(me){const Me={message:me.message,stack:me.stack};(ye=this.windowsMainService)===null||ye===void 0||ye.sendToFocused("vscode:reportError",JSON.stringify(Me))}this.logService.error(`[uncaught exception in main]: ${me}`),me.stack&&this.logService.error(me.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentService.appRoot}`),this.logService.debug("args:",this.environmentService.args);const me=A.default.win32AppUserModelId;D.isWindows&&me&&w.app.setAppUserModelId(me);try{D.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!w.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&w.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(_e){this.logService.error(_e)}const ye=this._register(this.instantiationService.createInstance(U.FileProtocolHandler)),Me=new m.Server;this.logService.trace("Resolving machine identifier...");const fe=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${fe}`);const Se=this.instantiationService.createInstance(f.SharedProcess,fe,this.userEnv),pe=(async()=>{this.logService.trace("Main->SharedProcess#connect");const _e=await Se.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new P.Client(_e,"main")})(),Pe=(async()=>(await Se.whenReady(),pe))();this.lifecycleMainService.when(3).then(()=>{this._register(new B.RunOnceScheduler(async()=>{Se.spawn(await n.resolveShellEnv(this.logService,this.environmentService.args,process.env))},3e3)).schedule()});const ke=await this.createServices(fe,Se,Pe);if(this.environmentService.driverHandle){const _e=await _.serve(Me,this.environmentService.driverHandle,this.environmentService,ke);this.logService.info("Driver started at:",this.environmentService.driverHandle),this._register(_e)}this._register(ke.createInstance(T.ProxyAuthHandler));const Ce=ke.invokeFunction(_e=>this.openFirstWindow(_e,Me,pe,ye));ke.invokeFunction(_e=>this.afterWindowOpen(_e)),this.environmentService.args.trace&&this.stopTracingEventually(Ce)}async resolveMachineId(){let me=this.stateService.getItem(o.machineIdKey);return(!me||D.isMacintosh&&me==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(me=await H.getMachineId(),this.stateService.setItem(o.machineIdKey,me)),me}async createServices(me,ye,Me){const fe=new p.ServiceCollection;switch(process.platform){case"win32":fe.set(S.IUpdateService,new b.SyncDescriptor(N.Win32UpdateService));break;case"linux":D.isLinuxSnap?fe.set(S.IUpdateService,new b.SyncDescriptor(ie.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):fe.set(S.IUpdateService,new b.SyncDescriptor(q.LinuxUpdateService));break;case"darwin":fe.set(S.IUpdateService,new b.SyncDescriptor(F.DarwinUpdateService));break}fe.set(C.IWindowsMainService,new b.SyncDescriptor(y.WindowsMainService,[me,this.userEnv])),fe.set(Ke.IDialogMainService,new b.SyncDescriptor(Ke.DialogMainService)),fe.set(h.ILaunchMainService,new b.SyncDescriptor(h.LaunchMainService)),fe.set(Le.IDiagnosticsService,E.createChannelSender(E.getDelayedChannel(Me.then(Pe=>Pe.getChannel("diagnostics"))))),fe.set(z.IIssueMainService,new b.SyncDescriptor(z.IssueMainService,[me,this.userEnv])),fe.set(ue.IEncryptionMainService,new b.SyncDescriptor(ue.EncryptionMainService,[me])),fe.set(we.IKeyboardLayoutMainService,new b.SyncDescriptor(we.KeyboardLayoutMainService)),fe.set(Ee.IDisplayMainService,new b.SyncDescriptor(Ee.DisplayMainService)),fe.set(je.INativeHostMainService,new b.SyncDescriptor(je.NativeHostMainService,[ye])),fe.set(Be.IWebviewManagerService,new b.SyncDescriptor(ot.WebviewMainService)),fe.set(ee.IWorkspacesService,new b.SyncDescriptor(Z.WorkspacesMainService)),fe.set(W.IMenubarMainService,new b.SyncDescriptor(W.MenubarMainService)),fe.set(ze.IExtensionUrlTrustService,new b.SyncDescriptor(Ut.ExtensionUrlTrustService));const Se=new G.StorageMainService(this.logService,this.environmentService);fe.set(G.IStorageMainService,Se),this.lifecycleMainService.onWillShutdown(Pe=>Pe.join(Se.close()));const pe=new se.BackupMainService(this.environmentService,this.configurationService,this.logService);if(fe.set(ae.IBackupMainService,pe),fe.set(he.IWorkspacesHistoryMainService,new b.SyncDescriptor(he.WorkspacesHistoryMainService)),fe.set(t.IURLService,new b.SyncDescriptor(ve.NativeURLService)),fe.set(be.IWorkspacesManagementMainService,new b.SyncDescriptor(be.WorkspacesManagementMainService)),!this.environmentService.isExtensionDevelopment&&!this.environmentService.args["disable-telemetry"]&&!!A.default.enableTelemetry){const Pe=E.getDelayedChannel(Me.then(Ge=>Ge.getChannel("telemetryAppender"))),ke=new c.TelemetryAppenderClient(Pe),Ce=I.resolveCommonProperties(this.fileService,R.release(),process.arch,A.default.commit,A.default.version,me,A.default.msftInternalDomains,this.environmentService.installSourcePath),_e=[this.environmentService.appRoot,this.environmentService.extensionsPath],Oe={appender:ke,commonProperties:Ce,piiPaths:_e,sendErrorTelemetry:!0};fe.set(o.ITelemetryService,new b.SyncDescriptor(g.TelemetryService,[Oe]))}else fe.set(o.ITelemetryService,d.NullTelemetryService);return await pe.initialize(),this.instantiationService.createChild(fe)}stopTracingEventually(me){this.logService.info("Tracing: waiting for windows to get ready...");let ye=!1;const Me=async Se=>{var pe;if(!ye){ye=!0;const Pe=await w.contentTracing.stopRecording(Y.joinPath(this.environmentService.userHome,`${A.default.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Se?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Pe}`):(pe=this.dialogMainService)===null||pe===void 0||pe.showMessageBox({type:"info",message:oe.localize(0,null),detail:oe.localize(1,null,Pe),buttons:[oe.localize(2,null)]},Ze.withNullAsUndefined(w.BrowserWindow.getFocusedWindow()))}},fe=setTimeout(()=>Me(!0),3e4);Promise.all(me.map(Se=>Se.ready())).then(()=>{clearTimeout(fe),Me(!1)})}openFirstWindow(me,ye,Me,fe){const Se=me.get(h.ILaunchMainService),pe=E.createChannelReceiver(Se,{disableMarshalling:!0});this.mainIpcServer.registerChannel("launch",pe);const Pe=me.get(S.IUpdateService),ke=new i.UpdateChannel(Pe);ye.registerChannel("update",ke);const Ce=me.get(z.IIssueMainService),_e=E.createChannelReceiver(Ce);ye.registerChannel("issue",_e);const Oe=me.get(ue.IEncryptionMainService),Ge=E.createChannelReceiver(Oe);ye.registerChannel("encryption",Ge);const Ye=me.get(we.IKeyboardLayoutMainService),xe=E.createChannelReceiver(Ye);ye.registerChannel("keyboardLayout",xe);const ct=me.get(Ee.IDisplayMainService),Xe=E.createChannelReceiver(ct);ye.registerChannel("display",Xe);const ut=this.nativeHostMainService=me.get(je.INativeHostMainService),It=E.createChannelReceiver(this.nativeHostMainService);ye.registerChannel("nativeHost",It),Me.then(Te=>Te.registerChannel("nativeHost",It));const Ct=me.get(ee.IWorkspacesService),Bt=E.createChannelReceiver(Ct);ye.registerChannel("workspaces",Bt);const zt=me.get(W.IMenubarMainService),$t=E.createChannelReceiver(zt);ye.registerChannel("menubar",$t);const et=me.get(t.IURLService),jt=E.createChannelReceiver(et);ye.registerChannel("url",jt);const Ht=me.get(ze.IExtensionUrlTrustService),qt=E.createChannelReceiver(Ht);ye.registerChannel("extensionUrlTrust",qt);const Vt=me.get(Be.IWebviewManagerService),Kt=E.createChannelReceiver(Vt);ye.registerChannel("webview",Kt);const Gt=me.get(G.IStorageMainService),Pt=this._register(new te.GlobalStorageDatabaseChannel(this.logService,Gt));ye.registerChannel("storage",Pt),Me.then(Te=>Te.registerChannel("storage",Pt));const Mt=new O.LoggerChannel(me.get(l.ILogService));ye.registerChannel("logger",Mt),Me.then(Te=>Te.registerChannel("logger",Mt));const He=this.windowsMainService=me.get(C.IWindowsMainService);fe.injectWindowsMainService(He),ye.registerChannel(Ae.ExtensionHostDebugBroadcastChannel.ChannelName,new Ne.ElectronExtensionHostDebugBroadcastChannel(He)),this.lifecycleMainService.phase=2,this.dialogMainService=me.get(Ke.IDialogMainService);const ht=[],Yt=[...this.environmentService.args["open-url"]?this.environmentService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Te=>{try{return{uri:x.URI.parse(Te),url:Te}}catch(Qe){return null}}).filter(Te=>{if(!Te||this.shouldBlockURI(Te.uri))return!1;const Qe=this.getWindowOpenableFromProtocolLink(Te.uri);return Qe?(ht.push(Qe),!1):!0}),kt=this,Dt=this.environmentService;et.registerHandler({async handleURL(Te,Qe){if(kt.shouldBlockURI(Te))return!0;const _t=kt.getWindowOpenableFromProtocolLink(Te);if(_t){const[vt]=He.open({context:5,cli:Object.assign({},Dt.args),urisToOpen:[_t],gotoLineMode:!0});return vt.focus(),!0}if(D.isMacintosh&&He.getWindowCount()===0){const[vt]=He.open({context:5,cli:Object.assign({},Dt.args),forceEmpty:!0,gotoLineMode:!0});return await vt.ready(),et.open(Te,Qe)}return!1}});const Xt=this._register(new ge.ActiveWindowManager({onDidOpenWindow:ut.onDidOpenWindow,onDidFocusWindow:ut.onDidFocusWindow,getActiveWindowId:()=>ut.getActiveWindowId(-1)})),Qt=new E.StaticRouter(Te=>Xt.getActiveClientId().then(Qe=>Te===Qe)),Jt=new r.URLHandlerRouter(Qt),Zt=ye.getChannel("urlHandler",Jt);et.registerHandler(new r.URLHandlerChannelClient(Zt)),this._register(new L.ElectronURLListener(Yt,et,He,this.environmentService));const Ue=this.environmentService.args,Lt=global.macOpenFiles,dt=Re.isLaunchedFromCli(process.env)?0:4,ft=Ue._.length,Rt=!!Ue["folder-uri"],At=!!Ue["file-uri"],gt=Ue["skip-add-to-recently-opened"]===!0,mt=Ue.wait&&Ue.waitMarkerFilePath?x.URI.file(Ue.waitMarkerFilePath):void 0;return ht.length>0?He.open({context:dt,cli:Ue,urisToOpen:ht,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!ft&&!Rt&&!At?He.open({context:dt,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:gt,waitMarkerFileURI:mt,initialStartup:!0}):Lt.length&&!ft&&!Rt&&!At?He.open({context:1,cli:Ue,urisToOpen:Lt.map(Te=>this.getWindowOpenableFromPathSync(Te)),noRecentEntry:gt,waitMarkerFileURI:mt,initialStartup:!0}):He.open({context:dt,cli:Ue,forceNewWindow:Ue["new-window"]||!ft&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:gt,waitMarkerFileURI:mt,gotoLineMode:Ue.goto,initialStartup:!0})}shouldBlockURI(me){return!!(me.authority===le.Schemas.file&&D.isWindows&&w.dialog.showMessageBoxSync({title:A.default.nameLong,type:"question",buttons:[qe.mnemonicButtonLabel(oe.localize(3,null)),qe.mnemonicButtonLabel(oe.localize(4,null))],cancelId:1,message:oe.localize(5,null,qe.getPathLabel(me.fsPath,this.environmentService),A.default.nameShort),detail:oe.localize(6,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(me){if(!!me.path){if(me.authority===le.Schemas.file)return{fileUri:x.URI.file(me.fsPath)};if(me.authority===le.Schemas.vscodeRemote){const ye=me.path.indexOf(X.posix.sep,1);if(ye!==-1){const Me=me.path.substring(1,ye),fe=me.path.substring(ye),Se=x.URI.from({scheme:le.Schemas.vscodeRemote,authority:Me,path:fe,query:me.query,fragment:me.fragment});return ee.hasWorkspaceFileExtension(fe)?{workspaceUri:Se}:{folderUri:Se}}}}}getWindowOpenableFromPathSync(me){try{if(Ie.statSync(me).isDirectory())return{folderUri:x.URI.file(me)};if(ee.hasWorkspaceFileExtension(me))return{workspaceUri:x.URI.file(me)}}catch(ye){}return{fileUri:x.URI.file(me)}}async afterWindowOpen(me){var ye;this.lifecycleMainService.phase=3;const Me=A.default.win32MutexName;if(D.isWindows&&Me)try{const Se=$.__$__nodeRequire("windows-mutex").Mutex,pe=new Se(Me);Nt.once(this.lifecycleMainService.onWillShutdown)(()=>pe.release())}catch(Se){this.logService.error(Se)}w.protocol.registerHttpProtocol(le.Schemas.vscodeRemoteResource,(Se,pe)=>{pe({url:Se.url.replace(/^vscode-remote-resource:/,"http:"),method:Se.method})});const fe=me.get(S.IUpdateService);(fe instanceof N.Win32UpdateService||fe instanceof q.LinuxUpdateService||fe instanceof F.DarwinUpdateService)&&fe.initialize(),n.resolveShellEnv(this.logService,this.environmentService.args,process.env);try{const pe=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString();if(JSON.parse(V.stripComments(pe))["enable-crash-reporter"]===void 0){const ke=(ye=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&ye!==void 0?ye:!0,Ce=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${ne.generateUuid()}"`,"}"],_e=pe.substring(0,pe.length-2).concat(`,
`,Ce.join(`
`));await this.fileService.writeFile(this.environmentService.argvResource,ce.VSBuffer.fromString(_e))}}catch(Se){this.logService.error(Se)}}};lt=de([re(2,v.IInstantiationService),re(3,l.ILogService),re(4,s.IEnvironmentMainService),re(5,M.ILifecycleMainService),re(6,u.IConfigurationService),re(7,a.IStateService),re(8,at.IFileService)],lt),e.CodeApplication=lt}),define(Q[235],J([0,1,11,25,12,3,15,54,151,26,22,33,49,165,70,69,8,188,37,53,19,181,39,219,230,38,176,174,16,72,44,88,187,71,171,173,10,21,55,217,60,28,14,17,6,32,23,68,91,196]),function($,e,w,R,D,y,M,n,S,i,E,m,P,f,h,v,p,b,l,a,s,u,t,r,o,d,c,g,I,A,T,U,j,C,x,ee,Z,H,N,q,F,z,O,k,L,_,W,B,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class X extends Error{constructor(){super(...arguments);this.isExpected=!0}}class Y{main(){I.setUnexpectedErrorHandler(G=>console.error(G));let ie;try{ie=n.parseMainProcessArgv(process.argv),ie=this.validatePaths(ie)}catch(G){console.error(G.message),w.app.exit(1);return}if(ie.wait&&!ie.waitMarkerFilePath){const G=S.createWaitMarkerFile(ie.verbose);G&&(n.addArg(process.argv,"--waitMarkerFilePath",G),ie.waitMarkerFilePath=G)}this.startup(ie)}async startup(ie){const G=new g.BufferLogService,[te,se,ae]=this.createServices(ie,G);try{await te.invokeFunction(async he=>{const ve=he.get(s.IConfigurationService),be=he.get(l.IStateService);try{await this.initServices(ae,ve,be)}catch(Ie){throw this.handleStartupDataDirError(ae,Ie),Ie}}),await te.invokeFunction(async he=>{const ve=he.get(p.ILogService),be=he.get(E.ILifecycleMainService),Ie=he.get(H.IFileService),Le=he.get(s.IConfigurationService),Ae=await this.doStartup(ie,ve,ae,be,te,!0);return G.logger=new c.SpdLogService("main",ae.logsPath,G.getLevel()),T.once(be.onWillShutdown)(()=>{Ie.dispose(),Le.dispose()}),te.createInstance(o.CodeApplication,Ae,se).startup()})}catch(he){te.invokeFunction(this.quit,he)}}createServices(ie,G){const te=new h.ServiceCollection,se=new W.EnvironmentMainService(ie),ae=this.patchEnvironment(se);te.set(a.IEnvironmentService,se),te.set(W.IEnvironmentMainService,se);const he=new p.MultiplexLogService([new p.ConsoleLogMainService(p.getLogLevel(se)),G]);process.once("exit",()=>he.dispose()),te.set(p.ILogService,he);const ve=new x.FileService(he);te.set(H.IFileService,ve);const be=new ee.DiskFileSystemProvider(he);return ve.registerProvider(Z.Schemas.file,be),te.set(s.IConfigurationService,new u.ConfigurationService(se.settingsResource,ve)),te.set(E.ILifecycleMainService,new v.SyncDescriptor(E.LifecycleMainService)),te.set(l.IStateService,new v.SyncDescriptor(b.StateService)),te.set(t.IRequestService,new v.SyncDescriptor(r.RequestMainService)),te.set(A.IThemeMainService,new v.SyncDescriptor(A.ThemeMainService)),te.set(U.ISignService,new v.SyncDescriptor(j.SignService)),te.set(F.IProductService,Object.assign({_serviceBrand:void 0},M.default)),te.set(N.ITunnelService,new v.SyncDescriptor(q.TunnelService)),[new f.InstantiationService(te,!0),ae,se]}initServices(ie,G,te){const se=Promise.all([ie.extensionsPath,ie.nodeCachedDataDir,ie.logsPath,ie.globalStorageHome.fsPath,ie.workspaceStorageHome.fsPath,ie.backupHome].map(ve=>ve?i.mkdirp(ve):void 0)),ae=G.initialize(),he=te.init();return Promise.all([se,ae,he])}patchEnvironment(ie){const G={VSCODE_IPC_HOOK:ie.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(te=>{const se=process.env[te];typeof se=="string"&&(G[te]=se)}),Object.assign(process.env,G),G}async doStartup(ie,G,te,se,ae,he){let ve;try{ve=await P.serve(te.mainIPCHandle),T.once(se.onWillShutdown)(()=>ve.dispose())}catch(be){if(be.code!=="EADDRINUSE")throw this.handleStartupDataDirError(te,be),be;let Ie;try{Ie=await P.connect(te.mainIPCHandle,"main")}catch(Ne){if(!he||y.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog(D.localize(0,null,M.default.nameShort),D.localize(1,null)),Ne;try{R.unlinkSync(te.mainIPCHandle)}catch(je){throw G.warn("Could not delete obsolete instance handle",je),je}return this.doStartup(ie,G,te,se,ae,!1)}if(te.extensionTestsLocationURI&&!te.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw G.error(Ne),Ie.dispose(),new Error(Ne)}let Le;!ie.wait&&!ie.status&&(Le=setTimeout(()=>{this.showStartupWarningDialog(D.localize(2,null,M.default.nameShort),D.localize(3,null))},1e4));const Ae=m.createChannelSender(Ie.getChannel("launch"),{disableMarshalling:!0});if(ie.status)return ae.invokeFunction(async()=>{const Ne=new C.DiagnosticsService(K.NullTelemetryService),je=await Ae.getMainProcessInfo(),Ke=await Ae.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ze=await Ne.getDiagnostics(je,Ke);throw console.log(Ze),new X});throw y.isWindows&&await this.windowsAllowSetForegroundWindow(Ae,G),G.trace("Sending env to running instance..."),await Ae.start(ie,process.env),Ie.dispose(),Le&&clearTimeout(Le),new X("Sent env to running instance. Terminating...")}if(ie.status)throw G.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new X("Terminating...");return process.env.VSCODE_PID=String(process.pid),ve}handleStartupDataDirError(ie,G){if(G.code==="EACCES"||G.code==="EPERM"){const te=_.coalesce([ie.userDataPath,ie.extensionsPath,P.XDG_RUNTIME_DIR]).map(se=>d.getPathLabel(se,ie));this.showStartupWarningDialog(D.localize(4,null),D.localize(5,null,B.toErrorMessage(G),te.join(`
`)))}}showStartupWarningDialog(ie,G){w.dialog.showMessageBoxSync({title:M.default.nameLong,type:"warning",buttons:[d.mnemonicButtonLabel(D.localize(6,null))],message:ie,detail:G,noLink:!0})}async windowsAllowSetForegroundWindow(ie,G){if(y.isWindows){const te=await ie.getMainProcessId();G.trace("Sending some foreground love to the running instance:",te);try{(await new Promise((se,ae)=>{$(["windows-foreground-love"],se,ae)})).allowSetForegroundWindow(te)}catch(se){G.error(se)}}}quit(ie,G){const te=ie.get(p.ILogService),se=ie.get(E.ILifecycleMainService);let ae=0;G&&(G.isExpected?G.message&&te.trace(G.message):(ae=1,G.stack?te.error(G.stack):te.error(`Startup error: ${G.toString()}`))),se.kill(ae)}validatePaths(ie){if(ie["open-url"]&&(ie._urls=ie._,ie._=[]),!ie.remote){const G=this.doValidatePaths(ie._,ie.goto);ie._=G}return ie}doValidatePaths(ie,G){const te=process.env.VSCODE_CWD||process.cwd(),se=ie.map(ve=>{let be=String(ve),Ie;G&&(Ie=z.parseLineAndColumnAware(be),be=Ie.path),be&&(be=this.preparePath(te,be));const Le=z.sanitizeFilePath(be,te),Ae=L.basename(Le);return Ae&&!z.isValidBasename(Ae)?null:G&&Ie?(Ie.path=Le,this.toPath(Ie)):Le}),ae=y.isWindows||y.isMacintosh,he=_.distinct(se,ve=>ve&&ae?ve.toLowerCase():ve||"");return _.coalesce(he)}preparePath(ie,G){return y.isWindows&&(G=k.rtrim(G,'"')),G=k.trim(k.trim(G," "),"	"),y.isWindows&&(G=L.resolve(ie,G),G=k.rtrim(G,".")),G}toPath(ie){const G=[ie.path];return O.isNumber(ie.line)&&G.push(String(ie.line)),O.isNumber(ie.column)&&G.push(String(ie.column)),G.join(":")}}new Y().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/622cb03f7e070a9670c94bae1a45d78d7181fbd4/core/vs/code/electron-main/main.js.map
