/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/network","vs/base/common/event","vs/base/common/types","vs/base/common/uri","vs/base/common/async","vs/base/node/pfs","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/buffer","vs/base/common/strings","vs/base/common/objects","vs/base/common/arrays","vs/platform/environment/common/environment","vs/base/common/resources","fs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/configuration/common/configuration","vs/base/parts/ipc/common/ipc","vs/base/common/cancellation","vs/platform/configuration/common/configurationRegistry","vs/base/common/errorMessage","vs/base/common/uuid","vs/base/common/stream","vs/base/common/extpath","child_process","vs/platform/extensions/common/extensions","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/product/common/product","vs/base/node/zip","vs/base/common/map","vs/base/node/decoder","util","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","os","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/console","vs/base/common/glob","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/paths","vs/base/node/extpath","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.net","vs/base/common/process","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/localizations/node/localizations","crypto","vs/platform/log/node/spdlogService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","zlib","vs/platform/environment/node/environmentService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/base/common/performance","vs/base/common/iterator","yauzl","yazl","net","vs/code/node/cliProcessMain","graceful-fs"],Y=function(q){for(var t=[],y=0,M=q.length;y<M;y++)t[y]=Q[q[y]];return t};define(Q[55],Y([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function y(M,D){if(!M)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}t.ok=y}),define(Q[56],Y([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createMemoizer=t.createDecorator=void 0;function y(m){return(g,T,f)=>{let I=null,w=null;if(typeof f.value=="function"?(I="value",w=f.value):typeof f.get=="function"&&(I="get",w=f.get),!w)throw new Error("not supported");f[I]=m(w,T)}}t.createDecorator=y;let M=0;function D(){const m=`$memoize${M++}`;let g;const T=function(I,w,l){let L=null,E=null;if(typeof l.value=="function"?(L="value",E=l.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(L="get",E=l.get),!E)throw new Error("not supported");const p=`${m}:${w}`;l[L]=function(...S){return g=this,this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!0,enumerable:!1,writable:!0,value:E.apply(this,S)}),this[p]}};return T.clear=()=>{typeof g!="undefined"&&Object.getOwnPropertyNames(g).forEach(f=>{f.indexOf(m)===0&&delete g[f]})},T}t.createMemoizer=D;function b(m,g,T){return D()(m,g,T)}t.memoize=b;function A(m,g,T){return y((f,I)=>{const w=`$debounce$${I}`,l=`$debounce$result$${I}`;return function(...L){this[l]||(this[l]=T?T():void 0),clearTimeout(this[w]),g&&(this[l]=g(this[l],...L),L=[this[l]]),this[w]=setTimeout(()=>{f.apply(this,L),this[l]=T?T():void 0},m)}})}t.debounce=A;function _(m,g,T){return y((f,I)=>{const w=`$throttle$timer$${I}`,l=`$throttle$result$${I}`,L=`$throttle$lastRun$${I}`,E=`$throttle$pending$${I}`;return function(...p){if(this[l]||(this[l]=T?T():void 0),(this[L]===null||this[L]===void 0)&&(this[L]=-Number.MAX_VALUE),g&&(this[l]=g(this[l],...p)),!this[E]){const S=this[L]+m;S<=Date.now()?(this[L]=Date.now(),f.apply(this,[this[l]]),this[l]=T?T():void 0):(this[E]=!0,this[w]=setTimeout(()=>{this[E]=!1,this[L]=Date.now(),f.apply(this,[this[l]]),this[l]=T?T():void 0},S-Date.now()))}}})}t.throttle=_}),define(Q[19],Y([0,1,15]),function(q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.mergeSort=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function M(C,c=0){return C[C.length-(1+c)]}t.tail=M;function D(C){if(C.length===0)throw new Error("Invalid tail call");return[C.slice(0,C.length-1),C[C.length-1]]}t.tail2=D;function b(C,c,h=(d,P)=>d===P){if(C===c)return!0;if(!C||!c||C.length!==c.length)return!1;for(let d=0,P=C.length;d<P;d++)if(!h(C[d],c[d]))return!1;return!0}t.equals=b;function A(C,c,h){let d=0,P=C.length-1;for(;d<=P;){const F=(d+P)/2|0,B=h(C[F],c);if(B<0)d=F+1;else if(B>0)P=F-1;else return F}return-(d+1)}t.binarySearch=A;function _(C,c){let h=0,d=C.length;if(d===0)return 0;for(;h<d;){const P=Math.floor((h+d)/2);c(C[P])?d=P:h=P+1}return h}t.findFirstInSorted=_;function m(C,c,h){if(C=C|0,C>=c.length)throw new TypeError("invalid index");let d=c[Math.floor(c.length*Math.random())],P=[],F=[],B=[];for(let V of c){const $=h(V,d);$<0?P.push(V):$>0?F.push(V):B.push(V)}return C<P.length?m(C,P,h):C<P.length+B.length?B[0]:m(C-(P.length+B.length),F,h)}t.quickSelect=m;function g(C,c){return f(C,c,0,C.length-1,[]),C}t.mergeSort=g;function T(C,c,h,d,P,F){let B=h,V=d+1;for(let $=h;$<=P;$++)F[$]=C[$];for(let $=h;$<=P;$++)B>d?C[$]=F[V++]:V>P?C[$]=F[B++]:c(F[V],F[B])<0?C[$]=F[V++]:C[$]=F[B++]}function f(C,c,h,d,P){if(!(d<=h)){const F=h+(d-h)/2|0;f(C,c,h,F,P),f(C,c,F+1,d,P),!(c(C[F],C[F+1])<=0)&&T(C,c,h,F,d,P)}}function I(C,c){const h=[];let d;for(const P of g(C.slice(0),c))!d||c(d[0],P)!==0?(d=[P],h.push(d)):d.push(P);return h}t.groupBy=I;function w(C,c,h){const d=[];function P(V,$,K){if(!($===0&&K.length===0)){const J=d[d.length-1];J&&J.start+J.deleteCount===V?(J.deleteCount+=$,J.toInsert.push(...K)):d.push({start:V,deleteCount:$,toInsert:K})}}let F=0,B=0;for(;;){if(F===C.length){P(F,0,c.slice(B));break}if(B===c.length){P(F,C.length-F,[]);break}const V=C[F],$=c[B],K=h(V,$);K===0?(F+=1,B+=1):K<0?(P(F,1,[]),F+=1):K>0&&(P(F,0,[$]),B+=1)}return d}t.sortedDiff=w;function l(C,c,h){const d=w(C,c,h),P=[],F=[];for(const B of d)P.push(...C.slice(B.start,B.start+B.deleteCount)),F.push(...B.toInsert);return{removed:P,added:F}}t.delta=l;function L(C,c,h){if(h===0)return[];const d=C.slice(0,h).sort(c);return p(C,c,d,h,C.length),d}t.top=L;function E(C,c,h,d,P){return h===0?Promise.resolve([]):new Promise((F,B)=>{(async()=>{const V=C.length,$=C.slice(0,h).sort(c);for(let K=h,J=Math.min(h+d,V);K<V;K=J,J=Math.min(J+d,V)){if(K>h&&await new Promise(te=>setTimeout(te)),P&&P.isCancellationRequested)throw y.canceled();p(C,c,$,K,J)}return $})().then(F,B)})}t.topAsync=E;function p(C,c,h,d,P){for(const F=h.length;d<P;d++){const B=C[d];if(c(B,h[F-1])<0){h.pop();const V=_(h,$=>c(B,$)<0);h.splice(V,0,B)}}}function S(C){return C.filter(c=>!!c)}t.coalesce=S;function k(C){let c=0;for(let h=0;h<C.length;h++)C[h]&&(C[c]=C[h],c+=1);C.length=c}t.coalesceInPlace=k;function a(C,c,h){C.splice(h,0,C.splice(c,1)[0])}t.move=a;function s(C){return!Array.isArray(C)||C.length===0}t.isFalsyOrEmpty=s;function e(C){return Array.isArray(C)&&C.length>0}t.isNonEmptyArray=e;function r(C,c){if(!c)return C.filter((d,P)=>C.indexOf(d)===P);const h=Object.create(null);return C.filter(d=>{const P=c(d);return h[P]?!1:(h[P]=!0,!0)})}t.distinct=r;function i(C){const c=new Set;return C.filter(h=>c.has(h)?!1:(c.add(h),!0))}t.distinctES6=i;function o(C){const c=Object.create(null);return h=>{const d=C(h);return c[d]?!1:(c[d]=!0,!0)}}t.uniqueFilter=o;function n(C,c){for(let h=C.length-1;h>=0;h--){const d=C[h];if(c(d))return h}return-1}t.lastIndex=n;function u(C,c){return C.length>0?C[0]:c}t.firstOrDefault=u;function v(C,c,h=(d,P)=>d===P){let d=0;for(let P=0,F=Math.min(C.length,c.length);P<F&&h(C[P],c[P]);P++)d++;return d}t.commonPrefixLength=v;function O(C){return[].concat(...C)}t.flatten=O;function R(C,c){let h=typeof c=="number"?C:0;typeof c=="number"?h=C:(h=0,c=C);const d=[];if(h<=c)for(let P=h;P<c;P++)d.push(P);else for(let P=h;P>c;P--)d.push(P);return d}t.range=R;function N(C,c,h){return C.reduce((d,P)=>(d[c(P)]=h?h(P):P,d),Object.create(null))}t.index=N;function j(C,c){return C.push(c),()=>H(C,c)}t.insert=j;function H(C,c){const h=C.indexOf(c);if(h>-1)return C.splice(h,1),c}t.remove=H;function Z(C,c,h){const d=C.slice(0,c),P=C.slice(c);return d.concat(h,P)}t.arrayInsert=Z;function oe(C,c){let h;if(typeof c=="number"){let d=c;h=()=>{const P=Math.sin(d++)*179426549;return P-Math.floor(P)}}else h=Math.random;for(let d=C.length-1;d>0;d-=1){const P=Math.floor(h()*(d+1)),F=C[d];C[d]=C[P],C[P]=F}}t.shuffle=oe;function ne(C,c){const h=C.indexOf(c);h>-1&&(C.splice(h,1),C.unshift(c))}t.pushToStart=ne;function ee(C,c){const h=C.indexOf(c);h>-1&&(C.splice(h,1),C.push(c))}t.pushToEnd=ee;function ce(C,c){return Array.isArray(C)?C.map(c):c(C)}t.mapArrayOrNot=ce;function U(C){return Array.isArray(C)?C:[C]}t.asArray=U;function W(C){return C[Math.floor(Math.random()*C.length)]}t.getRandomElement=W;function X(C,c){for(const h of C){const d=c(h);if(d!==void 0)return d}}t.mapFind=X}),define(Q[57],Y([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var y;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(y=t.ScanError||(t.ScanError={}));var M;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(M=t.SyntaxKind||(t.SyntaxKind={}));var D;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(D=t.ParseErrorCode||(t.ParseErrorCode={}));var b;(function(e){e.DEFAULT={allowTrailingComma:!0}})(b=t.ParseOptions||(t.ParseOptions={}));function A(e,r=!1){let i=0,o=e.length,n="",u=0,v=16,O=0;function R(ee){let ce=0,U=0;for(;ce<ee;){const W=e.charCodeAt(i);if(W>=48&&W<=57)U=U*16+W-48;else if(W>=65&&W<=70)U=U*16+W-65+10;else if(W>=97&&W<=102)U=U*16+W-97+10;else break;i++,ce++}return ce<ee&&(U=-1),U}function N(ee){i=ee,n="",u=0,v=16,O=0}function j(){const ee=i;if(e.charCodeAt(i)===48)i++;else for(i++;i<e.length&&g(e.charCodeAt(i));)i++;if(i<e.length&&e.charCodeAt(i)===46)if(i++,i<e.length&&g(e.charCodeAt(i)))for(i++;i<e.length&&g(e.charCodeAt(i));)i++;else return O=3,e.substring(ee,i);let ce=i;if(i<e.length&&(e.charCodeAt(i)===69||e.charCodeAt(i)===101))if(i++,(i<e.length&&e.charCodeAt(i)===43||e.charCodeAt(i)===45)&&i++,i<e.length&&g(e.charCodeAt(i))){for(i++;i<e.length&&g(e.charCodeAt(i));)i++;ce=i}else O=3;return e.substring(ee,ce)}function H(){let ee="",ce=i;for(;;){if(i>=o){ee+=e.substring(ce,i),O=2;break}const U=e.charCodeAt(i);if(U===34){ee+=e.substring(ce,i),i++;break}if(U===92){if(ee+=e.substring(ce,i),i++,i>=o){O=2;break}switch(e.charCodeAt(i++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:const X=R(4);X>=0?ee+=String.fromCharCode(X):O=4;break;default:O=5}ce=i;continue}if(U>=0&&U<=31)if(m(U)){ee+=e.substring(ce,i),O=2;break}else O=6;i++}return ee}function Z(){if(n="",O=0,u=i,i>=o)return u=o,v=17;let ee=e.charCodeAt(i);if(_(ee)){do i++,n+=String.fromCharCode(ee),ee=e.charCodeAt(i);while(_(ee));return v=15}if(m(ee))return i++,n+=String.fromCharCode(ee),ee===13&&e.charCodeAt(i)===10&&(i++,n+=`
`),v=14;switch(ee){case 123:return i++,v=1;case 125:return i++,v=2;case 91:return i++,v=3;case 93:return i++,v=4;case 58:return i++,v=6;case 44:return i++,v=5;case 34:return i++,n=H(),v=10;case 47:const ce=i-1;if(e.charCodeAt(i+1)===47){for(i+=2;i<o&&!m(e.charCodeAt(i));)i++;return n=e.substring(ce,i),v=12}if(e.charCodeAt(i+1)===42){i+=2;const U=o-1;let W=!1;for(;i<U;){if(e.charCodeAt(i)===42&&e.charCodeAt(i+1)===47){i+=2,W=!0;break}i++}return W||(i++,O=1),n=e.substring(ce,i),v=13}return n+=String.fromCharCode(ee),i++,v=16;case 45:if(n+=String.fromCharCode(ee),i++,i===o||!g(e.charCodeAt(i)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=j(),v=11;default:for(;i<o&&oe(ee);)i++,ee=e.charCodeAt(i);if(u!==i){switch(n=e.substring(u,i),n){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return n+=String.fromCharCode(ee),i++,v=16}}function oe(ee){if(_(ee)||m(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let ee;do ee=Z();while(ee>=12&&ee<=15);return ee}return{setPosition:N,getPosition:()=>i,scan:r?ne:Z,getToken:()=>v,getTokenValue:()=>n,getTokenOffset:()=>u,getTokenLength:()=>i-u,getTokenError:()=>O}}t.createScanner=A;function _(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function m(e){return e===10||e===13||e===8232||e===8233}function g(e){return e>=48&&e<=57}var T;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(T||(T={}));function f(e,r){const i=[],o=new Object;let n;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function O(R,N,j,H){u.value=R,u.offset=N,u.length=j,u.type=H,u.colonOffset=void 0,n=u}try{k(e,{onObjectBegin:(R,N)=>{if(r<=R)throw o;n=void 0,v=r>R,i.push("")},onObjectProperty:(R,N,j)=>{if(r<N||(O(R,N,j,"property"),i[i.length-1]=R,r<=N+j))throw o},onObjectEnd:(R,N)=>{if(r<=R)throw o;n=void 0,i.pop()},onArrayBegin:(R,N)=>{if(r<=R)throw o;n=void 0,i.push(0)},onArrayEnd:(R,N)=>{if(r<=R)throw o;n=void 0,i.pop()},onLiteralValue:(R,N,j)=>{if(r<N||(O(R,N,j,s(R)),r<=N+j))throw o},onSeparator:(R,N,j)=>{if(r<=N)throw o;if(R===":"&&n&&n.type==="property")n.colonOffset=N,v=!1,n=void 0;else if(R===","){const H=i[i.length-1];typeof H=="number"?i[i.length-1]=H+1:(v=!0,i[i.length-1]=""),n=void 0}}})}catch(R){if(R!==o)throw R}return{path:i,previousNode:n,isAtPropertyKey:v,matches:R=>{let N=0;for(let j=0;N<R.length&&j<i.length;j++)if(R[N]===i[j]||R[N]==="*")N++;else if(R[N]!=="**")return!1;return N===R.length}}}t.getLocation=f;function I(e,r=[],i=b.DEFAULT){let o=null,n=[];const u=[];function v(R){Array.isArray(n)?n.push(R):o!==null&&(n[o]=R)}return k(e,{onObjectBegin:()=>{const R={};v(R),u.push(n),n=R,o=null},onObjectProperty:R=>{o=R},onObjectEnd:()=>{n=u.pop()},onArrayBegin:()=>{const R=[];v(R),u.push(n),n=R,o=null},onArrayEnd:()=>{n=u.pop()},onLiteralValue:v,onError:(R,N,j)=>{r.push({error:R,offset:N,length:j})}},i),n[0]}t.parse=I;function w(e,r=[],i=b.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(R){o.type==="property"&&(o.length=R-o.offset,o=o.parent)}function u(R){return o.children.push(R),R}k(e,{onObjectBegin:R=>{o=u({type:"object",offset:R,length:-1,parent:o,children:[]})},onObjectProperty:(R,N,j)=>{o=u({type:"property",offset:N,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:R,offset:N,length:j,parent:o})},onObjectEnd:(R,N)=>{o.length=R+N-o.offset,o=o.parent,n(R+N)},onArrayBegin:(R,N)=>{o=u({type:"array",offset:R,length:-1,parent:o,children:[]})},onArrayEnd:(R,N)=>{o.length=R+N-o.offset,o=o.parent,n(R+N)},onLiteralValue:(R,N,j)=>{u({type:s(R),offset:N,length:j,parent:o,value:R}),n(N+j)},onSeparator:(R,N,j)=>{o.type==="property"&&(R===":"?o.colonOffset=N:R===","&&n(N))},onError:(R,N,j)=>{r.push({error:R,offset:N,length:j})}},i);const O=o.children[0];return O&&delete O.parent,O}t.parseTree=w;function l(e,r){if(!!e){let i=e;for(let o of r)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let n=!1;for(const u of i.children)if(Array.isArray(u.children)&&u.children[0].value===o){i=u.children[1],n=!0;break}if(!n)return}else{const n=o;if(i.type!=="array"||n<0||!Array.isArray(i.children)||n>=i.children.length)return;i=i.children[n]}return i}}t.findNodeAtLocation=l;function L(e){if(!e.parent||!e.parent.children)return[];const r=L(e.parent);if(e.parent.type==="property"){const i=e.parent.children[0].value;r.push(i)}else if(e.parent.type==="array"){const i=e.parent.children.indexOf(e);i!==-1&&r.push(i)}return r}t.getNodePath=L;function E(e){switch(e.type){case"array":return e.children.map(E);case"object":const r=Object.create(null);for(let i of e.children){const o=i.children[1];o&&(r[i.children[0].value]=E(o))}return r;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=E;function p(e,r,i=!1){return r>=e.offset&&r<e.offset+e.length||i&&r===e.offset+e.length}t.contains=p;function S(e,r,i=!1){if(p(e,r,i)){const o=e.children;if(Array.isArray(o))for(let n=0;n<o.length&&o[n].offset<=r;n++){const u=S(o[n],r,i);if(u)return u}return e}}t.findNodeAtOffset=S;function k(e,r,i=b.DEFAULT){const o=A(e,!1);function n(F){return F?()=>F(o.getTokenOffset(),o.getTokenLength()):()=>!0}function u(F){return F?B=>F(B,o.getTokenOffset(),o.getTokenLength()):()=>!0}const v=n(r.onObjectBegin),O=u(r.onObjectProperty),R=n(r.onObjectEnd),N=n(r.onArrayBegin),j=n(r.onArrayEnd),H=u(r.onLiteralValue),Z=u(r.onSeparator),oe=n(r.onComment),ne=u(r.onError),ee=i&&i.disallowComments,ce=i&&i.allowTrailingComma;function U(){for(;;){const F=o.scan();switch(o.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:ee||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(F){case 12:case 13:ee?W(10):oe();break;case 16:W(1);break;case 15:case 14:break;default:return F}}}function W(F,B=[],V=[]){if(ne(F),B.length+V.length>0){let $=o.getToken();for(;$!==17;){if(B.indexOf($)!==-1){U();break}else if(V.indexOf($)!==-1)break;$=U()}}}function X(F){const B=o.getTokenValue();return F?H(B):O(B),U(),!0}function C(){switch(o.getToken()){case 11:let F=0;try{F=JSON.parse(o.getTokenValue()),typeof F!="number"&&(W(2),F=0)}catch(B){W(2)}H(F);break;case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return U(),!0}function c(){return o.getToken()!==10?(W(3,[],[2,5]),!1):(X(!1),o.getToken()===6?(Z(":"),U(),P()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function h(){v(),U();let F=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(F||W(4,[],[]),Z(","),U(),o.getToken()===2&&ce)break}else F&&W(6,[],[]);c()||W(4,[],[2,5]),F=!0}return R(),o.getToken()!==2?W(7,[2],[]):U(),!0}function d(){N(),U();let F=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(F||W(4,[],[]),Z(","),U(),o.getToken()===4&&ce)break}else F&&W(6,[],[]);P()||W(4,[],[4,5]),F=!0}return j(),o.getToken()!==4?W(8,[4],[]):U(),!0}function P(){switch(o.getToken()){case 3:return d();case 1:return h();case 10:return X(!0);default:return C()}}return U(),o.getToken()===17?i.allowEmptyContent?!0:(W(4,[],[]),!1):P()?(o.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}t.visit=k;function a(e,r){let i=A(e),o=[],n,u=0,v;do switch(v=i.getPosition(),n=i.scan(),n){case 12:case 13:case 17:u!==v&&o.push(e.substring(u,v)),r!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,r)),u=i.getPosition();break}while(n!==17);return o.join("")}t.stripComments=a;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s});"use strict";function ze(q){const t=[];typeof q=="number"&&t.push("code/timeOrigin",q);function y(D){t.push(D,Date.now())}function M(){const D=[];for(let b=0;b<t.length;b+=2)D.push({name:t[b],startTime:t[b+1]});return D}return{mark:y,getMarks:M}}function $e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ze():{mark(q){performance.mark(q)},getMarks(){let q=performance.timeOrigin;typeof q!="number"&&(q=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const t=[{name:"code/timeOrigin",startTime:Math.round(q)}];for(const y of performance.getEntriesByType("mark"))t.push({name:y.name,startTime:Math.round(q+y.startTime)});return t}};if(typeof process=="object"){const q=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ze(q)}else return console.trace("perf-util loaded in UNKNOWN environment"),ze()}function je(q){return q.MonacoPerformanceMarks||(q.MonacoPerformanceMarks=$e()),q.MonacoPerformanceMarks}var Fe;typeof global=="object"?Fe=global:typeof self=="object"?Fe=self:Fe={},typeof define=="function"?define("vs/base/common/performance",[],function(){return je(Fe)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=je(Fe):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),Fe.perf=je(Fe)),function(q,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var y=t();for(var M in y)(typeof exports=="object"?exports:q)[M]=y[M]}}(typeof self!="undefined"?self:this,function(){return function(q){var t={};function y(M){if(t[M])return t[M].exports;var D=t[M]={i:M,l:!1,exports:{}};return q[M].call(D.exports,D,D.exports,y),D.l=!0,D.exports}return y.m=q,y.c=t,y.d=function(M,D,b){y.o(M,D)||Object.defineProperty(M,D,{enumerable:!0,get:b})},y.r=function(M){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},y.t=function(M,D){if(1&D&&(M=y(M)),8&D||4&D&&typeof M=="object"&&M&&M.__esModule)return M;var b=Object.create(null);if(y.r(b),Object.defineProperty(b,"default",{enumerable:!0,value:M}),2&D&&typeof M!="string")for(var A in M)y.d(b,A,function(_){return M[_]}.bind(null,A));return b},y.n=function(M){var D=M&&M.__esModule?function(){return M.default}:function(){return M};return y.d(D,"a",D),D},y.o=function(M,D){return Object.prototype.hasOwnProperty.call(M,D)},y.p="",y(y.s=0)}([function(q,t,y){(function(M){var D;t=q.exports=V,D=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var b=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,_=t.re=[],m=t.src=[],g=0,T=g++;m[T]="0|[1-9]\\d*";var f=g++;m[f]="[0-9]+";var I=g++;m[I]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=g++;m[w]="("+m[T]+")\\.("+m[T]+")\\.("+m[T]+")";var l=g++;m[l]="("+m[f]+")\\.("+m[f]+")\\.("+m[f]+")";var L=g++;m[L]="(?:"+m[T]+"|"+m[I]+")";var E=g++;m[E]="(?:"+m[f]+"|"+m[I]+")";var p=g++;m[p]="(?:-("+m[L]+"(?:\\."+m[L]+")*))";var S=g++;m[S]="(?:-?("+m[E]+"(?:\\."+m[E]+")*))";var k=g++;m[k]="[0-9A-Za-z-]+";var a=g++;m[a]="(?:\\+("+m[k]+"(?:\\."+m[k]+")*))";var s=g++,e="v?"+m[w]+m[p]+"?"+m[a]+"?";m[s]="^"+e+"$";var r="[v=\\s]*"+m[l]+m[S]+"?"+m[a]+"?",i=g++;m[i]="^"+r+"$";var o=g++;m[o]="((?:<|>)?=?)";var n=g++;m[n]=m[f]+"|x|X|\\*";var u=g++;m[u]=m[T]+"|x|X|\\*";var v=g++;m[v]="[v=\\s]*("+m[u]+")(?:\\.("+m[u]+")(?:\\.("+m[u]+")(?:"+m[p]+")?"+m[a]+"?)?)?";var O=g++;m[O]="[v=\\s]*("+m[n]+")(?:\\.("+m[n]+")(?:\\.("+m[n]+")(?:"+m[S]+")?"+m[a]+"?)?)?";var R=g++;m[R]="^"+m[o]+"\\s*"+m[v]+"$";var N=g++;m[N]="^"+m[o]+"\\s*"+m[O]+"$";var j=g++;m[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=g++;m[H]="(?:~>?)";var Z=g++;m[Z]="(\\s*)"+m[H]+"\\s+",_[Z]=new RegExp(m[Z],"g");var oe=g++;m[oe]="^"+m[H]+m[v]+"$";var ne=g++;m[ne]="^"+m[H]+m[O]+"$";var ee=g++;m[ee]="(?:\\^)";var ce=g++;m[ce]="(\\s*)"+m[ee]+"\\s+",_[ce]=new RegExp(m[ce],"g");var U=g++;m[U]="^"+m[ee]+m[v]+"$";var W=g++;m[W]="^"+m[ee]+m[O]+"$";var X=g++;m[X]="^"+m[o]+"\\s*("+r+")$|^$";var C=g++;m[C]="^"+m[o]+"\\s*("+e+")$|^$";var c=g++;m[c]="(\\s*)"+m[o]+"\\s*("+r+"|"+m[v]+")",_[c]=new RegExp(m[c],"g");var h=g++;m[h]="^\\s*("+m[v]+")\\s+-\\s+("+m[v]+")\\s*$";var d=g++;m[d]="^\\s*("+m[O]+")\\s+-\\s+("+m[O]+")\\s*$";var P=g++;m[P]="(<|>)?=?\\s*\\*";for(var F=0;F<35;F++)D(F,m[F]),_[F]||(_[F]=new RegExp(m[F]));function B(z,G){if(z instanceof V)return z;if(typeof z!="string"||z.length>b||!(G?_[i]:_[s]).test(z))return null;try{return new V(z,G)}catch(x){return null}}function V(z,G){if(z instanceof V){if(z.loose===G)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>b)throw new TypeError("version is longer than "+b+" characters");if(!(this instanceof V))return new V(z,G);D("SemVer",z,G),this.loose=G;var x=z.trim().match(G?_[i]:_[s]);if(!x)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function(ie){if(/^[0-9]+$/.test(ie)){var se=+ie;if(se>=0&&se<A)return se}return ie}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}t.parse=B,t.valid=function(z,G){var x=B(z,G);return x?x.version:null},t.clean=function(z,G){var x=B(z.trim().replace(/^[=v]+/,""),G);return x?x.version:null},t.SemVer=V,V.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},V.prototype.toString=function(){return this.version},V.prototype.compare=function(z){return D("SemVer.compare",this.version,this.loose,z),z instanceof V||(z=new V(z,this.loose)),this.compareMain(z)||this.comparePre(z)},V.prototype.compareMain=function(z){return z instanceof V||(z=new V(z,this.loose)),K(this.major,z.major)||K(this.minor,z.minor)||K(this.patch,z.patch)},V.prototype.comparePre=function(z){if(z instanceof V||(z=new V(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var G=0;do{var x=this.prerelease[G],ie=z.prerelease[G];if(D("prerelease compare",G,x,ie),x===void 0&&ie===void 0)return 0;if(ie===void 0)return 1;if(x===void 0)return-1;if(x!==ie)return K(x,ie)}while(++G)},V.prototype.inc=function(z,G){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},t.inc=function(z,G,x,ie){typeof x=="string"&&(ie=x,x=void 0);try{return new V(z,x).inc(G,ie).version}catch(se){return null}},t.diff=function(z,G){if(he(z,G))return null;var x=B(z),ie=B(G);if(x.prerelease.length||ie.prerelease.length){for(var se in x)if((se==="major"||se==="minor"||se==="patch")&&x[se]!==ie[se])return"pre"+se;return"prerelease"}for(var se in x)if((se==="major"||se==="minor"||se==="patch")&&x[se]!==ie[se])return se},t.compareIdentifiers=K;var $=/^[0-9]+$/;function K(z,G){var x=$.test(z),ie=$.test(G);return x&&ie&&(z=+z,G=+G),x&&!ie?-1:ie&&!x?1:z<G?-1:z>G?1:0}function J(z,G,x){return new V(z,x).compare(new V(G,x))}function te(z,G,x){return J(z,G,x)>0}function re(z,G,x){return J(z,G,x)<0}function he(z,G,x){return J(z,G,x)===0}function de(z,G,x){return J(z,G,x)!==0}function Se(z,G,x){return J(z,G,x)>=0}function Oe(z,G,x){return J(z,G,x)<=0}function Te(z,G,x,ie){var se;switch(G){case"===":typeof z=="object"&&(z=z.version),typeof x=="object"&&(x=x.version),se=z===x;break;case"!==":typeof z=="object"&&(z=z.version),typeof x=="object"&&(x=x.version),se=z!==x;break;case"":case"=":case"==":se=he(z,x,ie);break;case"!=":se=de(z,x,ie);break;case">":se=te(z,x,ie);break;case">=":se=Se(z,x,ie);break;case"<":se=re(z,x,ie);break;case"<=":se=Oe(z,x,ie);break;default:throw new TypeError("Invalid operator: "+G)}return se}function ve(z,G){if(z instanceof ve){if(z.loose===G)return z;z=z.value}if(!(this instanceof ve))return new ve(z,G);D("comparator",z,G),this.loose=G,this.parse(z),this.semver===ke?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}t.rcompareIdentifiers=function(z,G){return K(G,z)},t.major=function(z,G){return new V(z,G).major},t.minor=function(z,G){return new V(z,G).minor},t.patch=function(z,G){return new V(z,G).patch},t.compare=J,t.compareLoose=function(z,G){return J(z,G,!0)},t.rcompare=function(z,G,x){return J(G,z,x)},t.sort=function(z,G){return z.sort(function(x,ie){return t.compare(x,ie,G)})},t.rsort=function(z,G){return z.sort(function(x,ie){return t.rcompare(x,ie,G)})},t.gt=te,t.lt=re,t.eq=he,t.neq=de,t.gte=Se,t.lte=Oe,t.cmp=Te,t.Comparator=ve;var ke={};function ye(z,G){if(z instanceof ye)return z.loose===G?z:new ye(z.raw,G);if(z instanceof ve)return new ye(z.value,G);if(!(this instanceof ye))return new ye(z,G);if(this.loose=G,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function Le(z){return!z||z.toLowerCase()==="x"||z==="*"}function qe(z,G,x,ie,se,be,ge,Re,we,De,Ae,Ee,Ie){return((G=Le(x)?"":Le(ie)?">="+x+".0.0":Le(se)?">="+x+"."+ie+".0":">="+G)+" "+(Re=Le(we)?"":Le(De)?"<"+(+we+1)+".0.0":Le(Ae)?"<"+we+"."+(+De+1)+".0":Ee?"<="+we+"."+De+"."+Ae+"-"+Ee:"<="+Re)).trim()}function Ge(z,G){for(var x=0;x<z.length;x++)if(!z[x].test(G))return!1;if(G.prerelease.length){for(x=0;x<z.length;x++)if(D(z[x].semver),z[x].semver!==ke&&z[x].semver.prerelease.length>0){var ie=z[x].semver;if(ie.major===G.major&&ie.minor===G.minor&&ie.patch===G.patch)return!0}return!1}return!0}function Ue(z,G,x){try{G=new ye(G,x)}catch(ie){return!1}return G.test(z)}function Be(z,G,x,ie){var se,be,ge,Re,we;switch(z=new V(z,ie),G=new ye(G,ie),x){case">":se=te,be=Oe,ge=re,Re=">",we=">=";break;case"<":se=re,be=Se,ge=te,Re="<",we="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(z,G,ie))return!1;for(var De=0;De<G.set.length;++De){var Ae=G.set[De],Ee=null,Ie=null;if(Ae.forEach(function(Ce){Ce.semver===ke&&(Ce=new ve(">=0.0.0")),Ee=Ee||Ce,Ie=Ie||Ce,se(Ce.semver,Ee.semver,ie)?Ee=Ce:ge(Ce.semver,Ie.semver,ie)&&(Ie=Ce)}),Ee.operator===Re||Ee.operator===we||(!Ie.operator||Ie.operator===Re)&&be(z,Ie.semver)||Ie.operator===we&&ge(z,Ie.semver))return!1}return!0}ve.prototype.parse=function(z){var G=this.loose?_[X]:_[C],x=z.match(G);if(!x)throw new TypeError("Invalid comparator: "+z);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new V(x[2],this.loose):this.semver=ke},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(z){return D("Comparator.test",z,this.loose),this.semver===ke||(typeof z=="string"&&(z=new V(z,this.loose)),Te(z,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(z,G){if(!(z instanceof ve))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new ye(z.value,G),Ue(this.value,x,G);if(z.operator==="")return x=new ye(this.value,G),Ue(z.semver,x,G);var ie=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),se=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),be=this.semver.version===z.semver.version,ge=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Re=Te(this.semver,"<",z.semver,G)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),we=Te(this.semver,">",z.semver,G)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ie||se||be&&ge||Re||we},t.Range=ye,ye.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},ye.prototype.toString=function(){return this.range},ye.prototype.parseRange=function(z){var G=this.loose;z=z.trim(),D("range",z,G);var x=G?_[d]:_[h];z=z.replace(x,qe),D("hyphen replace",z),z=z.replace(_[c],"$1$2$3"),D("comparator trim",z,_[c]),z=(z=(z=z.replace(_[Z],"$1~")).replace(_[ce],"$1^")).split(/\s+/).join(" ");var ie=G?_[X]:_[C],se=z.split(" ").map(function(be){return function(ge,Re){return D("comp",ge),ge=function(we,De){return we.trim().split(/\s+/).map(function(Ae){return function(Ee,Ie){D("caret",Ee,Ie);var Ce=Ie?_[W]:_[U];return Ee.replace(Ce,function(_e,ae,ue,me,pe){var Pe;return D("caret",Ee,_e,ae,ue,me,pe),Le(ae)?Pe="":Le(ue)?Pe=">="+ae+".0.0 <"+(+ae+1)+".0.0":Le(me)?Pe=ae==="0"?">="+ae+"."+ue+".0 <"+ae+"."+(+ue+1)+".0":">="+ae+"."+ue+".0 <"+(+ae+1)+".0.0":pe?(D("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Pe=ae==="0"?ue==="0"?">="+ae+"."+ue+"."+me+pe+" <"+ae+"."+ue+"."+(+me+1):">="+ae+"."+ue+"."+me+pe+" <"+ae+"."+(+ue+1)+".0":">="+ae+"."+ue+"."+me+pe+" <"+(+ae+1)+".0.0"):(D("no pr"),Pe=ae==="0"?ue==="0"?">="+ae+"."+ue+"."+me+" <"+ae+"."+ue+"."+(+me+1):">="+ae+"."+ue+"."+me+" <"+ae+"."+(+ue+1)+".0":">="+ae+"."+ue+"."+me+" <"+(+ae+1)+".0.0"),D("caret return",Pe),Pe})}(Ae,De)}).join(" ")}(ge,Re),D("caret",ge),ge=function(we,De){return we.trim().split(/\s+/).map(function(Ae){return function(Ee,Ie){var Ce=Ie?_[ne]:_[oe];return Ee.replace(Ce,function(_e,ae,ue,me,pe){var Pe;return D("tilde",Ee,_e,ae,ue,me,pe),Le(ae)?Pe="":Le(ue)?Pe=">="+ae+".0.0 <"+(+ae+1)+".0.0":Le(me)?Pe=">="+ae+"."+ue+".0 <"+ae+"."+(+ue+1)+".0":pe?(D("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Pe=">="+ae+"."+ue+"."+me+pe+" <"+ae+"."+(+ue+1)+".0"):Pe=">="+ae+"."+ue+"."+me+" <"+ae+"."+(+ue+1)+".0",D("tilde return",Pe),Pe})}(Ae,De)}).join(" ")}(ge,Re),D("tildes",ge),ge=function(we,De){return D("replaceXRanges",we,De),we.split(/\s+/).map(function(Ae){return function(Ee,Ie){Ee=Ee.trim();var Ce=Ie?_[N]:_[R];return Ee.replace(Ce,function(_e,ae,ue,me,pe,Pe){D("xRange",Ee,_e,ae,ue,me,pe,Pe);var Ve=Le(ue),Me=Ve||Le(me),Ne=Me||Le(pe);return ae==="="&&Ne&&(ae=""),Ve?_e=ae===">"||ae==="<"?"<0.0.0":"*":ae&&Ne?(Me&&(me=0),Ne&&(pe=0),ae===">"?(ae=">=",Me?(ue=+ue+1,me=0,pe=0):Ne&&(me=+me+1,pe=0)):ae==="<="&&(ae="<",Me?ue=+ue+1:me=+me+1),_e=ae+ue+"."+me+"."+pe):Me?_e=">="+ue+".0.0 <"+(+ue+1)+".0.0":Ne&&(_e=">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0"),D("xRange return",_e),_e})}(Ae,De)}).join(" ")}(ge,Re),D("xrange",ge),ge=function(we,De){return D("replaceStars",we,De),we.trim().replace(_[P],"")}(ge,Re),D("stars",ge),ge}(be,G)}).join(" ").split(/\s+/);return this.loose&&(se=se.filter(function(be){return!!be.match(ie)})),se=se.map(function(be){return new ve(be,G)})},ye.prototype.intersects=function(z,G){if(!(z instanceof ye))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function(ie){return z.set.some(function(se){return se.every(function(be){return ie.intersects(be,G)})})})})},t.toComparators=function(z,G){return new ye(z,G).set.map(function(x){return x.map(function(ie){return ie.value}).join(" ").trim().split(" ")})},ye.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new V(z,this.loose));for(var G=0;G<this.set.length;G++)if(Ge(this.set[G],z))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(z,G,x){var ie=null,se=null;try{var be=new ye(G,x)}catch(ge){return null}return z.forEach(function(ge){be.test(ge)&&(ie&&se.compare(ge)!==-1||(se=new V(ie=ge,x)))}),ie},t.minSatisfying=function(z,G,x){var ie=null,se=null;try{var be=new ye(G,x)}catch(ge){return null}return z.forEach(function(ge){be.test(ge)&&(ie&&se.compare(ge)!==1||(se=new V(ie=ge,x)))}),ie},t.validRange=function(z,G){try{return new ye(z,G).range||"*"}catch(x){return null}},t.ltr=function(z,G,x){return Be(z,G,"<",x)},t.gtr=function(z,G,x){return Be(z,G,">",x)},t.outside=Be,t.prerelease=function(z,G){var x=B(z,G);return x&&x.prerelease.length?x.prerelease:null},t.intersects=function(z,G,x){return z=new ye(z,x),G=new ye(G,x),z.intersects(G)},t.coerce=function(z){if(z instanceof V)return z;if(typeof z!="string")return null;var G=z.match(_[j]);return G==null?null:B((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,y(1))},function(q,t){var y,M,D=q.exports={};function b(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function _(E){if(y===setTimeout)return setTimeout(E,0);if((y===b||!y)&&setTimeout)return y=setTimeout,setTimeout(E,0);try{return y(E,0)}catch(p){try{return y.call(null,E,0)}catch(S){return y.call(this,E,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:b}catch(E){y=b}try{M=typeof clearTimeout=="function"?clearTimeout:A}catch(E){M=A}})();var m,g=[],T=!1,f=-1;function I(){T&&m&&(T=!1,m.length?g=m.concat(g):f=-1,g.length&&w())}function w(){if(!T){var E=_(I);T=!0;for(var p=g.length;p;){for(m=g,g=[];++f<p;)m&&m[f].run();f=-1,p=g.length}m=null,T=!1,function(S){if(M===clearTimeout)return clearTimeout(S);if((M===A||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(S);try{M(S)}catch(k){try{return M.call(null,S)}catch(a){return M.call(this,S)}}}(E)}}function l(E,p){this.fun=E,this.array=p}function L(){}D.nextTick=function(E){var p=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)p[S-1]=arguments[S];g.push(new l(E,p)),g.length!==1||T||_(w)},l.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=L,D.addListener=L,D.once=L,D.off=L,D.removeListener=L,D.removeAllListeners=L,D.emit=L,D.prependListener=L,D.prependOnceListener=L,D.listeners=function(E){return[]},D.binding=function(E){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(E){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Q[33],Y([0,1,15,2]),function(q,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.observe=t.transform=t.toReadable=t.toStream=t.peekStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function D(E){const p=E;return p&&[p.on,p.pause,p.resume,p.destroy].every(S=>typeof S=="function")}t.isReadableStream=D;function b(E){const p=E;return p&&D(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean"}t.isReadableBufferedStream=b;function A(E,p){return new _(E,p)}t.newWriteableStream=A;class _{constructor(p,S){this.reducer=p,this.options=S,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){var S;if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof((S=this.options)===null||S===void 0?void 0:S.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(k=>this.pendingWritePromises.push(k))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(p instanceof Error?this.error(p):p&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(S=>S(p))}emitError(p){this.listeners.error.length===0?y.onUnexpectedError(p):this.listeners.error.slice(0).forEach(S=>S(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,S){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(S),this.resume();break;case"end":this.listeners.end.push(S),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(S),this.state.flowing&&this.flowErrors();break}}removeListener(p,S){if(!this.state.destroyed){let k;switch(p){case"data":k=this.listeners.data;break;case"end":k=this.listeners.end;break;case"error":k=this.listeners.error;break}if(k){const a=k.indexOf(S);a>=0&&k.splice(a,1)}}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const S=[...this.pendingWritePromises];this.pendingWritePromises.length=0,S.forEach(k=>k())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(E,p){const S=[];let k;for(;(k=E.read())!==null;)S.push(k);return p(S)}t.consumeReadable=m;function g(E,p,S){const k=[];let a;for(;(a=E.read())!==null&&k.length<S;)k.push(a);return a===null&&k.length>0?p(k):{read:()=>{if(k.length>0)return k.shift();if(typeof a!="undefined"){const s=a;return a=void 0,s}return E.read()}}}t.peekReadable=g;function T(E,p){return new Promise((S,k)=>{const a=[];E.on("error",s=>k(s)),E.on("end",()=>S(p(a))),E.on("data",s=>a.push(s))})}t.consumeStream=T;function f(E,p){return new Promise((S,k)=>{const a=new M.DisposableStore,s=[],e=o=>{if(s.push(o),s.length>p)return a.dispose(),E.pause(),S({stream:E,buffer:s,ended:!1})};a.add(M.toDisposable(()=>E.removeListener("data",e))),E.on("data",e);const r=o=>k(o);a.add(M.toDisposable(()=>E.removeListener("error",r))),E.on("error",r);const i=()=>S({stream:E,buffer:s,ended:!0});a.add(M.toDisposable(()=>E.removeListener("end",i))),E.on("end",i)})}t.peekStream=f;function I(E,p){const S=A(p);return S.end(E),S}t.toStream=I;function w(E){let p=!1;return{read:()=>p?null:(p=!0,E)}}t.toReadable=w;function l(E,p,S){const k=A(S);return E.on("data",a=>k.write(p.data(a))),E.on("end",()=>k.end()),E.on("error",a=>k.error(p.error?p.error(a):a)),k}t.transform=l;function L(E){const p=Promise.race([new Promise(S=>E.on("end",()=>S())),new Promise(S=>E.on("error",()=>S()))]);return{errorOrEnd(){return E.resume(),p}}}t.observe=L}),define(Q[16],Y([0,1,17,33]),function(q,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const D=typeof Buffer!="undefined",b=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let _,m;class g{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return D?new g(Buffer.allocUnsafe(n)):new g(new Uint8Array(n))}static wrap(n){return D&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new g(n)}static fromString(n,u){return!((u==null?void 0:u.dontUseNodeBuffer)||!1)&&D?new g(Buffer.from(n)):b?(_||(_=new TextEncoder),new g(_.encode(n))):new g(y.encodeUTF8(n))}static concat(n,u){if(typeof u=="undefined"){u=0;for(let R=0,N=n.length;R<N;R++)u+=n[R].byteLength}const v=g.alloc(u);let O=0;for(let R=0,N=n.length;R<N;R++){const j=n[R];v.set(j,O),O+=j.byteLength}return v}toString(){return D?this.buffer.toString():A?(m||(m=new TextDecoder),m.decode(this.buffer)):y.decodeUTF8(this.buffer)}slice(n,u){return new g(this.buffer.subarray(n,u))}set(n,u){n instanceof g?this.buffer.set(n.buffer,u):this.buffer.set(n,u)}readUInt32BE(n){return I(this.buffer,n)}writeUInt32BE(n,u){w(this.buffer,n,u)}readUInt32LE(n){return l(this.buffer,n)}writeUInt32LE(n,u){L(this.buffer,n,u)}readUInt8(n){return E(this.buffer,n)}writeUInt8(n,u){p(this.buffer,n,u)}}t.VSBuffer=g;function T(o,n){return o[n+0]<<0>>>0|o[n+1]<<8>>>0}t.readUInt16LE=T;function f(o,n,u){o[u+0]=n&255,n=n>>>8,o[u+1]=n&255}t.writeUInt16LE=f;function I(o,n){return o[n]*2**24+o[n+1]*2**16+o[n+2]*2**8+o[n+3]}t.readUInt32BE=I;function w(o,n,u){o[u+3]=n,n=n>>>8,o[u+2]=n,n=n>>>8,o[u+1]=n,n=n>>>8,o[u]=n}t.writeUInt32BE=w;function l(o,n){return o[n+0]<<0>>>0|o[n+1]<<8>>>0|o[n+2]<<16>>>0|o[n+3]<<24>>>0}t.readUInt32LE=l;function L(o,n,u){o[u+0]=n&255,n=n>>>8,o[u+1]=n&255,n=n>>>8,o[u+2]=n&255,n=n>>>8,o[u+3]=n&255}t.writeUInt32LE=L;function E(o,n){return o[n]}t.readUInt8=E;function p(o,n,u){o[u]=n}t.writeUInt8=p;function S(o){return M.consumeReadable(o,n=>g.concat(n))}t.readableToBuffer=S;function k(o){return M.toReadable(o)}t.bufferToReadable=k;function a(o){return M.consumeStream(o,n=>g.concat(n))}t.streamToBuffer=a;async function s(o){return o.ended?g.concat(o.buffer):g.concat([...o.buffer,await a(o.stream)])}t.bufferedStreamToBuffer=s;function e(o){return M.toStream(o,n=>g.concat(n))}t.bufferToStream=e;function r(o){return M.transform(o,{data:n=>typeof n=="string"?g.fromString(n):g.wrap(n)},n=>g.concat(n))}t.streamToBufferReadableStream=r;function i(o){return M.newWriteableStream(n=>g.concat(n),o)}t.newWriteableBufferStream=i}),define(Q[18],Y([0,1,9]),function(q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function M(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const L=Array.isArray(l)?[]:{};return Object.keys(l).forEach(E=>{l[E]&&typeof l[E]=="object"?L[E]=M(l[E]):L[E]=l[E]}),L}t.deepClone=M;function D(l){if(!l||typeof l!="object")return l;const L=[l];for(;L.length>0;){const E=L.shift();Object.freeze(E);for(const p in E)if(b.call(E,p)){const S=E[p];typeof S=="object"&&!Object.isFrozen(S)&&L.push(S)}}return l}t.deepFreeze=D;const b=Object.prototype.hasOwnProperty;function A(l,L){return _(l,L,new Set)}t.cloneAndChange=A;function _(l,L,E){if(y.isUndefinedOrNull(l))return l;const p=L(l);if(typeof p!="undefined")return p;if(y.isArray(l)){const S=[];for(const k of l)S.push(_(k,L,E));return S}if(y.isObject(l)){if(E.has(l))throw new Error("Cannot clone recursive data-structure");E.add(l);const S={};for(let k in l)b.call(l,k)&&(S[k]=_(l[k],L,E));return E.delete(l),S}return l}function m(l,L,E=!0){return y.isObject(l)?(y.isObject(L)&&Object.keys(L).forEach(p=>{p in l?E&&(y.isObject(l[p])&&y.isObject(L[p])?m(l[p],L[p],E):l[p]=L[p]):l[p]=L[p]}),l):L}t.mixin=m;function g(l,L){if(l===L)return!0;if(l==null||L===null||L===void 0||typeof l!=typeof L||typeof l!="object"||Array.isArray(l)!==Array.isArray(L))return!1;let E,p;if(Array.isArray(l)){if(l.length!==L.length)return!1;for(E=0;E<l.length;E++)if(!g(l[E],L[E]))return!1}else{const S=[];for(p in l)S.push(p);S.sort();const k=[];for(p in L)k.push(p);if(k.sort(),!g(S,k))return!1;for(E=0;E<S.length;E++)if(!g(l[S[E]],L[S[E]]))return!1}return!0}t.equals=g;function T(l){const L=new Set;return JSON.stringify(l,(E,p)=>{if(y.isObject(p)||Array.isArray(p)){if(L.has(p))return"[Circular]";L.add(p)}return p})}t.safeStringify=T;function f(l,L,E){const p=L(l);return typeof p=="undefined"?E:p}t.getOrDefault=f;function I(l,L){const E=Object.create(null);return!l||!L||Object.keys(L).forEach(S=>{const k=l[S],a=L[S];g(k,a)||(E[S]=a)}),E}t.distinct=I;function w(l,L){const E=L.toLowerCase(),p=Object.keys(l).find(S=>S.toLowerCase()===E);return p?l[p]:l[L]}t.getCaseInsensitive=w}),define(Q[58],Y([0,1,10]),function(q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function M(g){const T=g;return T&&typeof T.type=="string"&&typeof T.severity=="string"}t.isRemoteConsoleLog=M;function D(g){const T=[];let f;try{const I=JSON.parse(g.arguments),w=I[I.length-1];w&&w.__$stack&&(I.pop(),f=w.__$stack),T.push(...I)}catch(I){T.push("Unable to log remote console arguments",g.arguments)}return{args:T,stack:f}}t.parse=D;function b(g){if(typeof g!="string")return b(D(g).stack);const T=g;if(T){const f=A(T),I=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(f||"");if(I&&I.length===4)return{uri:y.URI.file(I[1]),line:Number(I[2]),column:Number(I[3])}}}t.getFirstFrame=b;function A(g){if(!g)return g;const T=g.indexOf(`
`);return T===-1?g:g.substring(0,T)}function _(g,T){const{args:f,stack:I}=D(g),w=typeof f[0]=="string"&&f.length===1;let l=A(I);l&&(l=`(${l.trim()})`);let L=[];if(typeof f[0]=="string"?l&&w?L=[`%c[${T}] %c${f[0]} %c${l}`,m("blue"),m(""),m("grey")]:L=[`%c[${T}] %c${f[0]}`,m("blue"),m(""),...f.slice(1)]:L=[`%c[${T}]%`,m("blue"),...f],l&&!w&&L.push(l),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,L)}t.log=_;function m(g){return`color: ${g}`}}),define(Q[59],Y([0,1,17,34,3,43,11]),function(q,t,y,M,D,b,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function _(){return Object.create(null)}t.getEmptyExpression=_;const m="**",g="/",T="[/\\\\]",f="[^/\\\\]",I=/\//g;function w(c){switch(c){case 0:return"";case 1:return`${f}*?`;default:return`(?:${T}|${f}+${T}|${T}${f}+)*?`}}function l(c,h){if(!c)return[];const d=[];let P=!1,F=!1,B="";for(const V of c){switch(V){case h:if(!P&&!F){d.push(B),B="";continue}break;case"{":P=!0;break;case"}":P=!1;break;case"[":F=!0;break;case"]":F=!1;break}B+=V}return B&&d.push(B),d}t.splitGlobAware=l;function L(c){if(!c)return"";let h="";const d=l(c,g);if(d.every(P=>P===m))h=".*";else{let P=!1;d.forEach((F,B)=>{if(F===m){P||(h+=w(2),P=!0);return}let V=!1,$="",K=!1,J="";for(const te of F){if(te!=="}"&&V){$+=te;continue}if(K&&(te!=="]"||!J)){let re;te==="-"?re=te:(te==="^"||te==="!")&&!J?re="^":te===g?re="":re=y.escapeRegExpCharacters(te),J+=re;continue}switch(te){case"{":V=!0;continue;case"[":K=!0;continue;case"}":h+=`(?:${l($,",").map(de=>L(de)).join("|")})`,V=!1,$="";break;case"]":h+="["+J+"]",K=!1,J="";break;case"?":h+=f;continue;case"*":h+=w(1);continue;default:h+=y.escapeRegExpCharacters(te)}}B<d.length-1&&(d[B+1]!==m||B+2<d.length)&&(h+=T),P=!1})}return h}const E=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,k=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new b.LRUCache(1e4),r=function(){return!1},i=function(){return null};function o(c,h){if(!c)return i;let d;typeof c!="string"?d=c.pattern:d=c,d=d.trim();const P=`${d}_${!!h.trimForExclusions}`;let F=e.get(P);if(F)return n(F,c);let B;if(E.test(d)){const V=d.substr(4);F=function($,K){return typeof $=="string"&&$.endsWith(V)?d:null}}else(B=p.exec(u(d,h)))?F=v(B[1],d):(h.trimForExclusions?k:S).test(d)?F=O(d,h):(B=a.exec(u(d,h)))?F=R(B[1].substr(1),d,!0):(B=s.exec(u(d,h)))?F=R(B[1],d,!1):F=N(d);return e.set(P,F),n(F,c)}function n(c,h){return typeof h=="string"?c:function(d,P){return M.isEqualOrParent(d,h.base)?c(D.relative(h.base,d),P):null}}function u(c,h){return h.trimForExclusions&&c.endsWith("/**")?c.substr(0,c.length-2):c}function v(c,h){const d=`/${c}`,P=`\\${c}`,F=function(V,$){return typeof V!="string"?null:$?$===c?h:null:V===c||V.endsWith(d)||V.endsWith(P)?h:null},B=[c];return F.basenames=B,F.patterns=[h],F.allBasenames=B,F}function O(c,h){const d=C(c.slice(1,-1).split(",").map($=>o($,h)).filter($=>$!==i),c),P=d.length;if(!P)return i;if(P===1)return d[0];const F=function($,K){for(let J=0,te=d.length;J<te;J++)if(d[J]($,K))return c;return null},B=d.find($=>!!$.allBasenames);B&&(F.allBasenames=B.allBasenames);const V=d.reduce(($,K)=>K.allPaths?$.concat(K.allPaths):$,[]);return V.length&&(F.allPaths=V),F}function R(c,h,d){const P=D.sep===D.posix.sep,F=P?c:c.replace(I,D.sep),B=D.sep+F,V=D.posix.sep+c,$=d?function(K,J){return typeof K=="string"&&(K===F||K.endsWith(B)||!P&&(K===c||K.endsWith(V)))?h:null}:function(K,J){return typeof K=="string"&&(K===F||!P&&K===c)?h:null};return $.allPaths=[(d?"*/":"./")+c],$}function N(c){try{const h=new RegExp(`^${L(c)}$`);return function(d){return h.lastIndex=0,typeof d=="string"&&h.test(d)?c:null}}catch(h){return i}}function j(c,h,d){return!c||typeof h!="string"?!1:H(c)(h,void 0,d)}t.match=j;function H(c,h={}){if(!c)return r;if(typeof c=="string"||ee(c)){const d=o(c,h);if(d===i)return r;const P=function(F,B){return!!d(F,B)};return d.allBasenames&&(P.allBasenames=d.allBasenames),d.allPaths&&(P.allPaths=d.allPaths),P}return W(c,h)}t.parse=H;function Z(c){if(!!c){let h;return d=>(h||(h=(c()||Promise.resolve([])).then(P=>P?ne(P):{})),h.then(P=>!!P[d]))}}t.hasSiblingPromiseFn=Z;function oe(c){if(!!c){let h;return d=>{if(!h){const P=c();h=P?ne(P):{}}return!!h[d]}}}t.hasSiblingFn=oe;function ne(c){const h={};for(const d of c)h[d]=!0;return h}function ee(c){const h=c;return h&&typeof h.base=="string"&&typeof h.pattern=="string"}t.isRelativePattern=ee;function ce(c){return c.allBasenames||[]}t.getBasenameTerms=ce;function U(c){return c.allPaths||[]}t.getPathTerms=U;function W(c,h){const d=C(Object.getOwnPropertyNames(c).map($=>X($,c[$],h)).filter($=>$!==i)),P=d.length;if(!P)return i;if(!d.some($=>!!$.requiresSiblings)){if(P===1)return d[0];const $=function(te,re){for(let he=0,de=d.length;he<de;he++){const Se=d[he](te,re);if(Se)return Se}return null},K=d.find(te=>!!te.allBasenames);K&&($.allBasenames=K.allBasenames);const J=d.reduce((te,re)=>re.allPaths?te.concat(re.allPaths):te,[]);return J.length&&($.allPaths=J),$}const F=function($,K,J){let te;for(let re=0,he=d.length;re<he;re++){const de=d[re];de.requiresSiblings&&J&&(K||(K=D.basename($)),te||(te=K.substr(0,K.length-D.extname($).length)));const Se=de($,K,te,J);if(Se)return Se}return null},B=d.find($=>!!$.allBasenames);B&&(F.allBasenames=B.allBasenames);const V=d.reduce(($,K)=>K.allPaths?$.concat(K.allPaths):$,[]);return V.length&&(F.allPaths=V),F}function X(c,h,d){if(h===!1)return i;const P=o(c,d);if(P===i)return i;if(typeof h=="boolean")return P;if(h){const F=h.when;if(typeof F=="string"){const B=(V,$,K,J)=>{if(!J||!P(V,$))return null;const te=F.replace("$(basename)",K),re=J(te);return A.isThenable(re)?re.then(he=>he?c:null):re?c:null};return B.requiresSiblings=!0,B}}return P}function C(c,h){const d=c.filter($=>!!$.basenames);if(d.length<2)return c;const P=d.reduce(($,K)=>{const J=K.basenames;return J?$.concat(J):$},[]);let F;if(h){F=[];for(let $=0,K=P.length;$<K;$++)F.push(h)}else F=d.reduce(($,K)=>{const J=K.patterns;return J?$.concat(J):$},[]);const B=function($,K){if(typeof $!="string")return null;if(!K){let te;for(te=$.length;te>0;te--){const re=$.charCodeAt(te-1);if(re===47||re===92)break}K=$.substr(te)}const J=P.indexOf(K);return J!==-1?F[J]:null};B.basenames=P,B.patterns=F,B.allBasenames=P;const V=c.filter($=>!$.basenames);return V.push(B),V}}),define(Q[60],Y([0,1,16,17,10]),function(q,t,y,M,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function b(g){return JSON.stringify(g,_)}t.stringify=b;function A(g){let T=JSON.parse(g);return T=m(T),T}t.parse=A;function _(g,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:M.regExpFlags(T)}:T}function m(g,T=0){if(!g||T>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return D.URI.revive(g);case 2:return new RegExp(g.source,g.flags)}if(g instanceof y.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let f=0;f<g.length;++f)g[f]=m(g[f],T+1);else for(const f in g)Object.hasOwnProperty.call(g,f)&&(g[f]=m(g[f],T+1))}return g}t.revive=m}),define(Q[61],Y([0,1,10,3,17,7,13,21,34]),function(q,t,y,M,D,b,A,_,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function g(o,n,u){if(typeof o=="string"&&(o=y.URI.file(o)),u){const O=u.getWorkspaceFolder(o);if(O){const R=u.getWorkspace().folders.length>1;let N;if(_.isEqual(O.uri,o)?N="":N=_.relativePath(O.uri,o),R){const j=O.name?O.name:_.basename(O.uri);N=N?j+" \u2022 "+N:j}return N}}if(o.scheme!==b.Schemas.file&&o.scheme!==b.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if(m.hasDriveLetter(o.fsPath))return M.normalize(f(o.fsPath));let v=M.normalize(o.fsPath);return!A.isWindows&&(n==null?void 0:n.userHome)&&(v=w(v,n.userHome.fsPath)),v}t.getPathLabel=g;function T(o){if(!!o){typeof o=="string"&&(o=y.URI.file(o));const n=_.basename(o)||(o.scheme===b.Schemas.file?o.fsPath:o.path);return A.isWindows&&m.isRootOrDriveLetter(n)?f(n):n}}t.getBaseLabel=T;function f(o){return m.hasDriveLetter(o)?o.charAt(0).toUpperCase()+o.slice(1):o}t.normalizeDriveLetter=f;let I=Object.create(null);function w(o,n){if(A.isWindows||!o||!n)return o;let u=I.original===n?I.normalized:void 0;return u||(u=`${D.rtrim(n,M.posix.sep)}${M.posix.sep}`,I={original:n,normalized:u}),(A.isLinux?o.startsWith(u):D.startsWithIgnoreCase(o,u))&&(o=`~/${o.substr(u.length)}`),o}t.tildify=w;function l(o,n){return o.replace(/^~($|\/|\\)/,`${n}$1`)}t.untildify=l;const L="\u2026",E="\\\\",p="~";function S(o,n=M.sep){const u=new Array(o.length);let v=!1;for(let O=0;O<o.length;O++){let R=o[O];if(R===""){u[O]=`.${n}`;continue}if(!R){u[O]=R;continue}v=!0;let N="";R.indexOf(E)===0?(N=R.substr(0,R.indexOf(E)+E.length),R=R.substr(R.indexOf(E)+E.length)):R.indexOf(n)===0?(N=R.substr(0,R.indexOf(n)+n.length),R=R.substr(R.indexOf(n)+n.length)):R.indexOf(p)===0&&(N=R.substr(0,R.indexOf(p)+p.length),R=R.substr(R.indexOf(p)+p.length));const j=R.split(n);for(let H=1;v&&H<=j.length;H++)for(let Z=j.length-H;v&&Z>=0;Z--){v=!1;let oe=j.slice(Z,Z+H).join(n);for(let ne=0;!v&&ne<o.length;ne++)if(ne!==O&&o[ne]&&o[ne].indexOf(oe)>-1){const ee=Z+H===j.length,ce=Z>0&&o[ne].indexOf(n)>-1?n+oe:oe,U=o[ne].endsWith(ce);v=!ee||U}if(!v){let ne="";(j[0].endsWith(":")||N!=="")&&(Z===1&&(Z=0,H++,oe=j[0]+n+oe),Z>0&&(ne=j[0]+n),ne=N+ne),Z>0&&(ne=ne+L+n),ne=ne+oe,Z+H<j.length&&(ne=ne+n+L),u[O]=ne}}v&&(u[O]=R)}return u}t.shorten=S;var k;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(k||(k={}));function a(o,n=Object.create(null)){const u=[];let v=!1,O="";for(const R of o)if(R==="$"||v&&R==="{")O&&u.push({value:O,type:k.TEXT}),O="",v=!0;else if(R==="}"&&v){const N=n[O];if(typeof N=="string")N.length&&u.push({value:N,type:k.VARIABLE});else if(N){const j=u[u.length-1];(!j||j.type!==k.SEPARATOR)&&u.push({value:N.label,type:k.SEPARATOR})}O="",v=!1}else O+=R;return O&&!v&&u.push({value:O,type:k.TEXT}),u.filter((R,N)=>{if(R.type===k.SEPARATOR){const j=u[N-1],H=u[N+1];return[j,H].every(Z=>Z&&(Z.type===k.VARIABLE||Z.type===k.TEXT)&&Z.value.length>0)}return!0}).map(R=>R.value).join("")}t.template=a;function s(o,n){return A.isMacintosh||n?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):o.replace(/&&|&/g,u=>u==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(o,n){return A.isMacintosh||n?o.replace(/\(&&\w\)|&&/g,""):A.isWindows?o.replace(/&&|&/g,u=>u==="&"?"&&":"&"):o.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function r(o){return o.replace(/&/g,"&&")}t.unmnemonicLabel=r;function i(o){const n=o.indexOf("/")!==-1?M.posix:M.win32,u=n.basename(o),v=n.dirname(o);return u.length?{name:u,parentPath:v}:{name:v,parentPath:""}}t.splitName=i}),define(Q[44],Y([0,1,124]),function(q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class M{constructor(b="utf8"){this.stringDecoder=new y.StringDecoder(b),this.remaining=null}write(b){const A=[],_=this.remaining?this.remaining+this.stringDecoder.write(b):this.stringDecoder.write(b);if(_.length<1)return A;let m=0,g,T=m;for(;T<_.length;)if(g=_.charCodeAt(T),g===13||g===10){if(A.push(_.substring(m,T)),T++,T<_.length){const f=g;g=_.charCodeAt(T),(f===13&&g===10||f===10&&g===13)&&T++}m=T}else T++;return this.remaining=m<_.length?_.substr(m):null,A}end(){return this.remaining}}t.LineDecoder=M}),define(Q[62],Y([0,1,7]),function(q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getDefaultUserDataPath=void 0;const M=y.FileAccess.asFileUri("paths",q).fsPath,D=q.__$__nodeRequire(M);t.getDefaultUserDataPath=D.getDefaultUserDataPath}),define(Q[63],Y([0,1,22,17,3,12,45]),function(q,t,y,M,D,b,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function _(f){const I=D.dirname(f);if(f===I)return f;const w=(D.basename(f)||f).toLowerCase();try{const L=b.readdirSync(I).filter(E=>E.toLowerCase()===w);if(L.length===1){const E=_(I);if(E)return D.join(E,L[0])}else if(L.length>1){const E=L.indexOf(w);if(E>=0){const p=_(I);if(p)return D.join(p,L[E])}}}catch(l){}return null}t.realcaseSync=_;async function m(f){try{return await A.promisify(y.realpath)(f)}catch(I){const w=T(f);return await A.promisify(y.access)(w,y.constants.R_OK),w}}t.realpath=m;function g(f){try{return y.realpathSync(f)}catch(I){const w=T(f);return y.accessSync(w,y.constants.R_OK),w}}t.realpathSync=g;function T(f){return M.rtrim(D.normalize(f),D.sep)}}),define(Q[64],Y([0,1,3,22,13,125,2,12]),function(q,t,y,M,D,b,A,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function m(f,I,w){return T({path:f,isDirectory:!1},I,w)}t.watchFile=m;function g(f,I,w){return T({path:f,isDirectory:!0},I,w)}t.watchFolder=g,t.CHANGE_BUFFER_DELAY=100;function T(f,I,w){const l=y.basename(f.path),L=new Map;let E=!1,p=[A.toDisposable(()=>{L.forEach(S=>A.dispose(S)),L.clear()})];try{const S=M.watch(f.path);p.push(A.toDisposable(()=>{S.removeAllListeners(),S.close()}));const k=new Set;f.isDirectory&&_.readdir(f.path).then(a=>a.forEach(s=>k.add(s))),S.on("error",(a,s)=>{E||w(`Failed to watch ${f.path} for changes using fs.watch() (${a}, ${s})`)}),S.on("change",(a,s)=>{if(!E){let e="";if(s&&(e=s.toString(),D.isMacintosh&&(e=b.normalizeNFC(e))),!(!e||a!=="change"&&a!=="rename")){const r=f.isDirectory?y.join(f.path,e):f.path;if(f.isDirectory)if(a==="rename"){const i=L.get(r);i&&A.dispose(i);const o=setTimeout(async()=>{L.delete(r);const n=await _.exists(r);if(!E){let u;n?k.has(e)?u="changed":(u="added",k.add(e)):(k.delete(e),u="deleted"),I(u,r)}},t.CHANGE_BUFFER_DELAY);L.set(r,A.toDisposable(()=>clearTimeout(o)))}else{let i;k.has(e)?i="changed":(i="added",k.add(e)),I(i,r)}else if(a==="rename"||e!==l){const i=setTimeout(async()=>{const o=await _.exists(r);E||(o?(I("changed",r),p=[T(f,I,w)]):I("deleted",r))},t.CHANGE_BUFFER_DELAY);A.dispose(p),p=[A.toDisposable(()=>clearTimeout(i))]}else I("changed",r)}}})}catch(S){_.exists(f.path).then(k=>{k&&!E&&w(`Failed to watch ${f.path} for changes using fs.watch() (${S.toString()})`)})}return A.toDisposable(()=>{E=!0,p=A.dispose(p)})}}),define(Q[28],Y([0,1,8,2,11,29,15,16,19,9,60,17]),function(q,t,y,M,D,b,A,_,m,g,T,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.createChannelSender=t.createChannelReceiver=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var I;(function(c){c[c.Promise=100]="Promise",c[c.PromiseCancel=101]="PromiseCancel",c[c.EventListen=102]="EventListen",c[c.EventDispose=103]="EventDispose"})(I=t.RequestType||(t.RequestType={}));function w(c){switch(c){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(c){c[c.Initialize=200]="Initialize",c[c.PromiseSuccess=201]="PromiseSuccess",c[c.PromiseError=202]="PromiseError",c[c.PromiseErrorObj=203]="PromiseErrorObj",c[c.EventFire=204]="EventFire"})(l=t.ResponseType||(t.ResponseType={}));function L(c){switch(c){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(c){c[c.Uninitialized=0]="Uninitialized",c[c.Idle=1]="Idle"})(E||(E={}));class p{constructor(h){this.buffer=h,this.pos=0}read(h){const d=this.buffer.slice(this.pos,this.pos+h);return this.pos+=d.byteLength,d}}class S{constructor(){this.buffers=[]}get buffer(){return _.VSBuffer.concat(this.buffers)}write(h){this.buffers.push(h)}}var k;(function(c){c[c.Undefined=0]="Undefined",c[c.String=1]="String",c[c.Buffer=2]="Buffer",c[c.VSBuffer=3]="VSBuffer",c[c.Array=4]="Array",c[c.Object=5]="Object"})(k||(k={}));function a(c){const h=_.VSBuffer.alloc(4);return h.writeUInt32BE(c,0),h}function s(c){return c.read(4).readUInt32BE(0)}function e(c){const h=_.VSBuffer.alloc(1);return h.writeUInt8(c,0),h}const r={Undefined:e(k.Undefined),String:e(k.String),Buffer:e(k.Buffer),VSBuffer:e(k.VSBuffer),Array:e(k.Array),Object:e(k.Object)},i=typeof Buffer!="undefined";function o(c,h){if(typeof h=="undefined")c.write(r.Undefined);else if(typeof h=="string"){const d=_.VSBuffer.fromString(h);c.write(r.String),c.write(a(d.byteLength)),c.write(d)}else if(i&&Buffer.isBuffer(h)){const d=_.VSBuffer.wrap(h);c.write(r.Buffer),c.write(a(d.byteLength)),c.write(d)}else if(h instanceof _.VSBuffer)c.write(r.VSBuffer),c.write(a(h.byteLength)),c.write(h);else if(Array.isArray(h)){c.write(r.Array),c.write(a(h.length));for(const d of h)o(c,d)}else{const d=_.VSBuffer.fromString(JSON.stringify(h));c.write(r.Object),c.write(a(d.byteLength)),c.write(d)}}function n(c){switch(c.read(1).readUInt8(0)){case k.Undefined:return;case k.String:return c.read(s(c)).toString();case k.Buffer:return c.read(s(c)).buffer;case k.VSBuffer:return c.read(s(c));case k.Array:{const d=s(c),P=[];for(let F=0;F<d;F++)P.push(n(c));return P}case k.Object:return JSON.parse(c.read(s(c)).toString())}}class u{constructor(h,d,P=null,F=1e3){this.protocol=h,this.ctx=d,this.logger=P,this.timeoutDelay=F,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(h,d){this.channels.set(h,d),setTimeout(()=>this.flushPendingRequests(h),0)}sendResponse(h){switch(h.type){case 200:{const d=this.send([h.type]);this.logger&&this.logger.logOutgoing(d,0,1,L(h.type));return}case 201:case 202:case 204:case 203:{const d=this.send([h.type,h.id],h.data);this.logger&&this.logger.logOutgoing(d,h.id,1,L(h.type),h.data);return}}}send(h,d=void 0){const P=new S;return o(P,h),o(P,d),this.sendBuffer(P.buffer)}sendBuffer(h){try{return this.protocol.send(h),h.byteLength}catch(d){return 0}}onRawMessage(h){const d=new p(h),P=n(d),F=n(d),B=P[0];switch(B){case 100:return this.logger&&this.logger.logIncoming(h.byteLength,P[1],1,`${w(B)}: ${P[2]}.${P[3]}`,F),this.onPromise({type:B,id:P[1],channelName:P[2],name:P[3],arg:F});case 102:return this.logger&&this.logger.logIncoming(h.byteLength,P[1],1,`${w(B)}: ${P[2]}.${P[3]}`,F),this.onEventListen({type:B,id:P[1],channelName:P[2],name:P[3],arg:F});case 101:return this.logger&&this.logger.logIncoming(h.byteLength,P[1],1,`${w(B)}`),this.disposeActiveRequest({type:B,id:P[1]});case 103:return this.logger&&this.logger.logIncoming(h.byteLength,P[1],1,`${w(B)}`),this.disposeActiveRequest({type:B,id:P[1]})}}onPromise(h){const d=this.channels.get(h.channelName);if(!d){this.collectPendingRequest(h);return}const P=new b.CancellationTokenSource;let F;try{F=d.call(this.ctx,h.name,h.arg,P.token)}catch($){F=Promise.reject($)}const B=h.id;F.then($=>{this.sendResponse({id:B,data:$,type:201}),this.activeRequests.delete(h.id)},$=>{$ instanceof Error?this.sendResponse({id:B,data:{message:$.message,name:$.name,stack:$.stack?$.stack.split?$.stack.split(`
`):$.stack:void 0},type:202}):this.sendResponse({id:B,data:$,type:203}),this.activeRequests.delete(h.id)});const V=M.toDisposable(()=>P.cancel());this.activeRequests.set(h.id,V)}onEventListen(h){const d=this.channels.get(h.channelName);if(!d){this.collectPendingRequest(h);return}const P=h.id,B=d.listen(this.ctx,h.name,h.arg)(V=>this.sendResponse({id:P,data:V,type:204}));this.activeRequests.set(h.id,B)}disposeActiveRequest(h){const d=this.activeRequests.get(h.id);d&&(d.dispose(),this.activeRequests.delete(h.id))}collectPendingRequest(h){let d=this.pendingRequests.get(h.channelName);d||(d=[],this.pendingRequests.set(h.channelName,d));const P=setTimeout(()=>{console.error(`Unknown channel: ${h.channelName}`),h.type===100&&this.sendResponse({id:h.id,data:{name:"Unknown channel",message:`Channel name '${h.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);d.push({request:h,timeoutTimer:P})}flushPendingRequests(h){const d=this.pendingRequests.get(h);if(d){for(const P of d)switch(clearTimeout(P.timeoutTimer),P.request.type){case 100:this.onPromise(P.request);break;case 102:this.onEventListen(P.request);break}this.pendingRequests.delete(h)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(h=>h.dispose()),this.activeRequests.clear()}}t.ChannelServer=u;var v;(function(c){c[c.LocalSide=0]="LocalSide",c[c.OtherSide=1]="OtherSide"})(v=t.RequestInitiator||(t.RequestInitiator={}));class O{constructor(h,d=null){this.protocol=h,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(P=>this.onBuffer(P)),this.logger=d}getChannel(h){const d=this;return{call(P,F,B){return d.isDisposed?Promise.reject(A.canceled()):d.requestPromise(h,P,F,B)},listen(P,F){return d.isDisposed?Promise.reject(A.canceled()):d.requestEvent(h,P,F)}}}requestPromise(h,d,P,F=b.CancellationToken.None){const B=this.lastRequestId++,$={id:B,type:100,channelName:h,name:d,arg:P};if(F.isCancellationRequested)return Promise.reject(A.canceled());let K;return new Promise((te,re)=>{if(F.isCancellationRequested)return re(A.canceled());const he=()=>{const Te=ve=>{switch(ve.type){case 201:this.handlers.delete(B),te(ve.data);break;case 202:this.handlers.delete(B);const ke=new Error(ve.data.message);ke.stack=ve.data.stack,ke.name=ve.data.name,re(ke);break;case 203:this.handlers.delete(B),re(ve.data);break}};this.handlers.set(B,Te),this.sendRequest($)};let de=null;this.state===E.Idle?he():(de=D.createCancelablePromise(Te=>this.whenInitialized()),de.then(()=>{de=null,he()}));const Se=()=>{de?(de.cancel(),de=null):this.sendRequest({id:B,type:101}),re(A.canceled())},Oe=F.onCancellationRequested(Se);K=M.combinedDisposable(M.toDisposable(Se),Oe),this.activeRequests.add(K)}).finally(()=>{this.activeRequests.delete(K)})}requestEvent(h,d,P){const F=this.lastRequestId++,V={id:F,type:102,channelName:h,name:d,arg:P};let $=null;const K=new y.Emitter({onFirstListenerAdd:()=>{$=D.createCancelablePromise(te=>this.whenInitialized()),$.then(()=>{$=null,this.activeRequests.add(K),this.sendRequest(V)})},onLastListenerRemove:()=>{$?($.cancel(),$=null):(this.activeRequests.delete(K),this.sendRequest({id:F,type:103}))}}),J=te=>K.fire(te.data);return this.handlers.set(F,J),K.event}sendRequest(h){switch(h.type){case 100:case 102:{const d=this.send([h.type,h.id,h.channelName,h.name],h.arg);this.logger&&this.logger.logOutgoing(d,h.id,0,`${w(h.type)}: ${h.channelName}.${h.name}`,h.arg);return}case 101:case 103:{const d=this.send([h.type,h.id]);this.logger&&this.logger.logOutgoing(d,h.id,0,w(h.type));return}}}send(h,d=void 0){const P=new S;return o(P,h),o(P,d),this.sendBuffer(P.buffer)}sendBuffer(h){try{return this.protocol.send(h),h.byteLength}catch(d){return 0}}onBuffer(h){const d=new p(h),P=n(d),F=n(d),B=P[0];switch(B){case 200:return this.logger&&this.logger.logIncoming(h.byteLength,0,0,L(B)),this.onResponse({type:P[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(h.byteLength,P[1],0,L(B),F),this.onResponse({type:P[0],id:P[1],data:F})}}onResponse(h){if(h.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const d=this.handlers.get(h.id);d&&d(h)}whenInitialized(){return this.state===E.Idle?Promise.resolve():y.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(h=>h.dispose()),this.activeRequests.clear()}}t.ChannelClient=O;class R{constructor(h){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,h(({protocol:d,onDidClientDisconnect:P})=>{y.Event.once(d.onMessage)(B=>{const V=new p(B),$=n(V),K=new u(d,$),J=new O(d);this.channels.forEach((re,he)=>K.registerChannel(he,re));const te={channelServer:K,channelClient:J,ctx:$};this._connections.add(te),this._onDidAddConnection.fire(te),P(()=>{K.dispose(),J.dispose(),this._connections.delete(te),this._onDidRemoveConnection.fire(te)})})})}get connections(){const h=[];return this._connections.forEach(d=>h.push(d)),h}getChannel(h,d){const P=this;return{call(F,B,V){let $;if(g.isFunction(d)){let J=m.getRandomElement(P.connections.filter(d));$=J?Promise.resolve(J):y.Event.toPromise(y.Event.filter(P.onDidAddConnection,d))}else $=d.routeCall(P,F,B);const K=$.then(J=>J.channelClient.getChannel(h));return j(K).call(F,B,V)},listen(F,B){if(g.isFunction(d))return P.getMulticastEvent(h,d,F,B);const V=d.routeEvent(P,F,B).then($=>$.channelClient.getChannel(h));return j(V).listen(F,B)}}}getMulticastEvent(h,d,P,F){const B=this;let V=new M.DisposableStore;const $=new y.Emitter({onFirstListenerAdd:()=>{V=new M.DisposableStore;const K=new y.EventMultiplexer,J=new Map,te=he=>{const Se=he.channelClient.getChannel(h).listen(P,F),Oe=K.add(Se);J.set(he,Oe)},re=he=>{const de=J.get(he);!de||(de.dispose(),J.delete(he))};B.connections.filter(d).forEach(te),y.Event.filter(B.onDidAddConnection,d)(te,void 0,V),B.onDidRemoveConnection(re,void 0,V),K.event($.fire,$,V),V.add(K)},onLastListenerRemove:()=>{V.dispose()}});return $.event}registerChannel(h,d){this.channels.set(h,d),this._connections.forEach(P=>{P.channelServer.registerChannel(h,d)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=R;class N{constructor(h,d,P=null){const F=new S;o(F,d),h.send(F.buffer),this.channelClient=new O(h,P),this.channelServer=new u(h,d,P)}getChannel(h){return this.channelClient.getChannel(h)}registerChannel(h,d){this.channelServer.registerChannel(h,d)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=N;function j(c){return{call(h,d,P){return c.then(F=>F.call(h,d,P))},listen(h,d){const P=new y.Relay;return c.then(F=>P.input=F.listen(h,d)),P.event}}}t.getDelayedChannel=j;function H(c){let h=!1;return{call(d,P,F){return h?c.call(d,P,F):D.timeout(0).then(()=>h=!0).then(()=>c.call(d,P,F))},listen(d,P){if(h)return c.listen(d,P);const F=new y.Relay;return D.timeout(0).then(()=>h=!0).then(()=>F.input=c.listen(d,P)),F.event}}}t.getNextTickChannel=H;class Z{constructor(h){this.fn=h}routeCall(h){return this.route(h)}routeEvent(h){return this.route(h)}async route(h){for(const d of h.connections)if(await Promise.resolve(this.fn(d.ctx)))return Promise.resolve(d);return await y.Event.toPromise(h.onDidAddConnection),await this.route(h)}}t.StaticRouter=Z;function oe(c,h){const d=c,P=h&&h.disableMarshalling,F=new Map;for(const B in d)ee(B)&&F.set(B,y.Event.buffer(d[B],!0));return new class{listen(B,V){const $=F.get(V);if($)return $;throw new Error(`Event not found: ${V}`)}call(B,V,$){const K=d[V];if(typeof K=="function"){if(!P&&Array.isArray($))for(let J=0;J<$.length;J++)$[J]=T.revive($[J]);return K.apply(d,$)}throw new Error(`Method not found: ${V}`)}}}t.createChannelReceiver=oe;function ne(c,h){const d=h&&h.disableMarshalling;return new Proxy({},{get(P,F){var B;if(typeof F=="string")return((B=h==null?void 0:h.properties)===null||B===void 0?void 0:B.has(F))?h.properties.get(F):ee(F)?c.listen(F):async function(...V){let $;h&&!g.isUndefinedOrNull(h.context)?$=[h.context,...V]:$=V;const K=await c.call(F,$);return d?K:T.revive(K)};throw new Error(`Property not found: ${String(F)}`)}})}t.createChannelSender=ne;function ee(c){return c[0]==="o"&&c[1]==="n"&&f.isUpperAsciiLetter(c.charCodeAt(2))}const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(c){if(Array.isArray(c))return c;if(c&&typeof c=="object"&&typeof c.toString=="function"){let h=c.toString();if(h!=="[object Object]")return h}return c}function W(c){return Array.isArray(c)?c.map(U):U(c)}function X(c,h,d,P,F,B,V){V=W(V);const $=ce[F],K=$[P%$.length];let J=[`%c[${c}]%c[${String(h).padStart(7," ")}]%c[len: ${String(d).padStart(5," ")}]%c${String(P).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${K}`];/\($/.test(B)?(J=J.concat(V),J.push(")")):J.push(V),console.log.apply(console,J)}t.logWithColors=X;class C{constructor(h,d){this._outgoingPrefix=h,this._incomingPrefix=d,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(h,d,P,F,B){this._totalOutgoing+=h,X(this._outgoingPrefix,this._totalOutgoing,h,d,P,F,B)}logIncoming(h,d,P,F,B){this._totalIncoming+=h,X(this._incomingPrefix,this._totalIncoming,h,d,P,F,B)}}t.IPCLogger=C}),define(Q[65],Y([0,1,8,28,2,16,13,66]),function(q,t,y,M,D,b,A,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PersistentProtocol=t.BufferedEmitter=t.Client=t.Protocol=t.ProtocolConstants=t.ChunkStream=void 0;let m=null;function g(){return m||(m=b.VSBuffer.alloc(0)),m}class T{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,o){if(i===0)return g();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const O=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=i),O}if(this._chunks[0].byteLength>i){const O=this._chunks[0].slice(0,i);return o&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),O}let n=b.VSBuffer.alloc(i),u=0,v=0;for(;i>0;){const O=this._chunks[v];if(O.byteLength>i){const R=O.slice(0,i);n.set(R,u),u+=i,o&&(this._chunks[v]=O.slice(i),this._totalLength-=i),i-=i}else n.set(O,u),u+=O.byteLength,o?(this._chunks.shift(),this._totalLength-=O.byteLength):v++,i-=O.byteLength}return n}}t.ChunkStream=T;var f;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(f||(f={}));var I;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(I=t.ProtocolConstants||(t.ProtocolConstants={}));class w{constructor(i,o,n,u){this.type=i,this.id=o,this.ack=n,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends D.Disposable{constructor(i){super();this._onMessage=this._register(new y.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new T,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5);else{const n=this._state.messageType,u=this._state.id,v=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new w(n,u,v,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class L{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(!this._isDisposed){i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=b.VSBuffer.alloc(13);o.writeUInt8(i.type,0),o.writeUInt32BE(i.id,1),o.writeUInt32BE(i.ack,5),o.writeUInt32BE(i.data.byteLength,9),this._writeSoon(o,i.data)}}_bufferAdd(i,o){const n=this._totalLength===0;return this._data.push(i,o),this._totalLength+=i.byteLength+o.byteLength,n}_bufferTake(){const i=b.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,o){this._bufferAdd(i,o)&&A.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends D.Disposable{constructor(i){super();this._onMessage=new y.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new y.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new L(this._socket)),this._socketReader=this._register(new l(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new w(1,0,0,i))}}t.Protocol=E;class p extends M.IPCClient{constructor(i,o,n=null){super(i,o,n);this.protocol=i}static fromSocket(i,o){return new p(new E(i),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}t.Client=p;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new y.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,_.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}t.BufferedEmitter=S;class k{constructor(i){this.data=i,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],o=0,n=this._first;for(;n;)i[o++]=n.data,n=n.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const o=new k(i);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class s{constructor(){this.lastRuns=[];const i=Date.now();for(let o=0;o<s._HISTORY_LENGTH;o++)this.lastRuns[o]=i-1e3*o;setInterval(()=>{for(let o=s._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const i=Date.now(),o=(1+s._HISTORY_LENGTH)*1e3;let n=0;for(let u=0;u<s._HISTORY_LENGTH;u++)i-this.lastRuns[u]<=o&&n++;return 1-n/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class e{constructor(i,o=null){this._loadEstimator=s.getInstance(),this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new L(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new l(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),o&&this._socketReader.acceptChunk(o),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=D.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new w(5,0,0,g());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const o=new w(4,0,0,g());this._socketWriter.write(o),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,o){this._isReconnecting=!0,this._socketDisposables=D.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new L(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new l(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let o=0,n=i.length;o<n;o++)this._socketWriter.write(i[o]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new w(6,0,0,g())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const o=this._outgoingUnackMsg.toArray();for(let n=0,u=o.length;n<u;n++)this._socketWriter.write(o[n]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const n=new w(1,o,this._incomingAckId,i);this._outgoingUnackMsg.push(n),this._isReconnecting||(this._socketWriter.write(n),this._recvAckCheck())}sendControl(i){const o=new w(2,0,0,i);this._socketWriter.write(o)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const i=this._outgoingUnackMsg.peek(),o=Date.now()-i.writtenTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-o,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const i=new w(3,0,this._incomingAckId,g());this._socketWriter.write(i)}}}t.PersistentProtocol=e}),define(Q[67],Y([4,5]),function(q,t){return q.create("vs/base/common/date",t)}),define(Q[68],Y([0,1,67]),function(q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const M=60,D=M*60,b=D*24,A=b*7,_=b*30,m=b*365;function g(f,I){typeof f!="number"&&(f=f.getTime());const w=Math.round((new Date().getTime()-f)/1e3);if(w<-30)return y.localize(0,null,g(new Date().getTime()+w*1e3,!1));if(w<30)return y.localize(1,null);let l;return w<M?(l=w,I?l===1?y.localize(2,null,l):y.localize(3,null,l):l===1?y.localize(4,null,l):y.localize(5,null,l)):w<D?(l=Math.floor(w/M),I?l===1?y.localize(6,null,l):y.localize(7,null,l):l===1?y.localize(8,null,l):y.localize(9,null,l)):w<b?(l=Math.floor(w/D),I?l===1?y.localize(10,null,l):y.localize(11,null,l):l===1?y.localize(12,null,l):y.localize(13,null,l)):w<A?(l=Math.floor(w/b),I?l===1?y.localize(14,null,l):y.localize(15,null,l):l===1?y.localize(16,null,l):y.localize(17,null,l)):w<_?(l=Math.floor(w/A),I?l===1?y.localize(18,null,l):y.localize(19,null,l):l===1?y.localize(20,null,l):y.localize(21,null,l)):w<m?(l=Math.floor(w/_),I?l===1?y.localize(22,null,l):y.localize(23,null,l):l===1?y.localize(24,null,l):y.localize(25,null,l)):(l=Math.floor(w/m),I?l===1?y.localize(26,null,l):y.localize(27,null,l):l===1?y.localize(28,null,l):y.localize(29,null,l))}t.fromNow=g;function T(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=T}),define(Q[69],Y([4,5]),function(q,t){return q.create("vs/base/common/errorMessage",t)}),define(Q[31],Y([0,1,69,9,19]),function(q,t,y,M,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function b(g,T){return T&&(g.stack||g.stacktrace)?y.localize(0,null,_(g),A(g.stack)||A(g.stacktrace)):_(g)}function A(g){return Array.isArray(g)?g.join(`
`):g}function _(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?y.localize(1,null,g.message):g.message||y.localize(2,null)}function m(g=null,T=!1){if(!g)return y.localize(3,null);if(Array.isArray(g)){const f=D.coalesce(g),I=m(f[0],T);return f.length>1?y.localize(4,null,I,f.length):I}if(M.isString(g))return g;if(g.detail){const f=g.detail;if(f.error)return b(f.error,T);if(f.exception)return b(f.exception,T)}return g.stack?b(g,T):g.message?g.message:y.localize(5,null)}t.toErrorMessage=m}),define(Q[70],Y([4,5]),function(q,t){return q.create("vs/base/node/processes",t)}),define(Q[71],Y([0,1,3,22,45,35,70,9,18,34,13,44,7]),function(q,t,y,M,D,b,A,_,m,g,T,f,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function w(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(a,s){if(T.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};s&&(e.cwd=s);const r=b.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],e);return new Promise(i=>{r.once("error",o=>{i({success:!1,error:o})}),r.once("exit",(o,n)=>{i(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?w(e.status):1})}else if(T.isLinux||T.isMacintosh)try{const e=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",q).fsPath;return new Promise(r=>{b.execFile(e,[a.pid.toString()],{encoding:"utf8",shell:!0},(i,o,n)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function L(a=process.env){return a.comspec||"cmd.exe"}t.getWindowsShell=L;class E{constructor(s,e,r,i){if(e!==void 0&&r!==void 0&&i!==void 0)this.cmd=s,this.args=e,this.shell=r,this.options=i;else{const o=s;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(process.env).forEach(n=>{o[n]=process.env[n]}),Object.keys(this.options.env).forEach(n=>{o[n]=this.options.env[n]}),this.options.env=o}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const e=s.lastIndexOf(y.sep);return e!==-1&&(s=s.substring(e+1)),E.WellKnowCommands[s]?s:"other"}start(s){return T.isWindows&&(this.options&&this.options.cwd&&g.isUNC(this.options.cwd)||!this.options&&g.isUNC(process.cwd()))?Promise.reject(new Error(A.localize(0,null))):this.useExec().then(e=>{let r,i;const o=new Promise((n,u)=>{r=n,i=u});if(e){let n=this.cmd;this.args&&(n=n+" "+this.args.join(" ")),this.childProcess=b.exec(n,this.options,(u,v,O)=>{this.childProcess=null;const R=u;R&&R.killed?i({killed:this.terminateRequested,stdout:v.toString(),stderr:O.toString()}):this.handleExec(r,s,u,v,O)})}else{let n=null;const u=v=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(v,r,s,i);const O={terminated:this.terminateRequested};_.isNumber(v)&&(O.cmdCode=v),r(O)};if(this.shell&&T.isWindows){const v=m.deepClone(this.options);v.windowsVerbatimArguments=!0,v.detached=!1;let O=!1,R=!1;const N=[];let j=this.ensureQuotes(this.cmd);N.push(j.value),O=j.quoted,this.args&&this.args.forEach(Z=>{j=this.ensureQuotes(Z),N.push(j.value),R=R&&j.quoted});const H=["/s","/c"];O?R?H.push('"'+N.join(" ")+'"'):N.length>1?H.push('"'+N[0]+'" '+N.slice(1).join(" ")):H.push('"'+N[0]+'"'):H.push(N.join(" ")),n=b.spawn(L(),H,v)}else this.cmd&&(n=b.spawn(this.cmd,this.args,this.options));n&&(this.childProcess=n,this.childProcessPromise=Promise.resolve(n),this.pidResolve&&(this.pidResolve(_.isNumber(n.pid)?n.pid:-1),this.pidResolve=void 0),n.on("error",v=>{this.childProcess=null,i({terminated:this.terminateRequested,error:v})}),n.pid&&(this.childProcess.on("close",u),this.handleSpawn(n,r,s,i,!0)))}return o})}handleClose(s,e,r,i){}ensureQuotes(s){return E.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,l(s,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!T.isWindows)return s(!1);const e=b.spawn(L(),["/s","/c"]);e.on("error",r=>s(!0)),e.on("exit",r=>s(!1))})}}t.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class p extends E{constructor(s,e,r,i){super(s,e,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,e,r,i,o){[i,o].forEach((n,u)=>{const v=new f.LineDecoder;v.write(n).forEach(N=>{e({line:N,source:u===0?0:1})});const R=v.end();R&&e({line:R,source:u===0?0:1})}),s({terminated:this.terminateRequested,error:r})}handleSpawn(s,e,r,i,o){const n=new f.LineDecoder,u=new f.LineDecoder;s.stdout.on("data",v=>{n.write(v).forEach(R=>r({line:R,source:0}))}),s.stderr.on("data",v=>{u.write(v).forEach(R=>r({line:R,source:1}))}),this.stdoutLineDecoder=n,this.stderrLineDecoder=u}handleClose(s,e,r,i){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&r({line:o,source:0});const n=this.stderrLineDecoder?this.stderrLineDecoder.end():null;n&&r({line:n,source:1})}}t.LineProcess=p;function S(a){let s=[],e=!1;const r=function(i){if(e){s.push(i);return}(!a.send(i,n=>{if(n&&console.error(n),e=!1,s.length>0){const u=s.slice(0);s=[],u.forEach(v=>r(v))}})||T.isWindows)&&(e=!0)};return{send:r}}t.createQueuedSender=S;var k;(function(a){async function s(e,r,i){if(y.isAbsolute(e))return e;if(r===void 0&&(r=process.cwd()),y.dirname(e)!=="."||(i===void 0&&_.isString(process.env.PATH)&&(i=process.env.PATH.split(y.delimiter)),i===void 0||i.length===0))return y.join(r,e);async function n(u){return await D.promisify(M.exists)(u)?!(await D.promisify(M.stat)(u)).isDirectory():!1}for(let u of i){let v;if(y.isAbsolute(u)?v=y.join(u,e):v=y.join(r,u,e),await n(v))return v;let O=v+".com";if(await n(O)||(O=v+".exe",await n(O)))return O}return y.join(r,e)}a.findExecutable=s})(k=t.win32||(t.win32={}))}),define(Q[46],Y([0,1,35,2,11,18,8,71,28,58,29,15,16,13]),function(q,t,y,M,D,b,A,_,m,g,T,f,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class l extends m.ChannelServer{constructor(p){super({send:S=>{try{process.send&&process.send(S.buffer.toString("base64"))}catch(k){}},onMessage:A.Event.fromNodeEventEmitter(process,"message",S=>I.VSBuffer.wrap(Buffer.from(S,"base64")))},p);process.once("disconnect",()=>this.dispose())}}t.Server=l;class L{constructor(p,S){this.modulePath=p,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new A.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const k=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new D.Delayer(k),this.child=null,this._client=null}getChannel(p){const S=this;return{call(k,a,s){return S.requestPromise(p,k,a,s)},listen(k,a){return S.requestEvent(p,k,a)}}}requestPromise(p,S,k,a=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(f.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(p),e=D.createCancelablePromise(o=>s.call(S,k,o)),r=a.onCancellationRequested(()=>e.cancel()),i=M.toDisposable(()=>e.cancel());return this.activeRequests.add(i),e.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(p,S,k){if(!this.disposeDelayer)return A.Event.None;this.disposeDelayer.cancel();let a;const s=new A.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(p).listen(S,k)(s.fire,s),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env=Object.assign(Object.assign({},b.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(S.env=Object.assign(Object.assign({},S.env),this.options.env)),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),w.isMacintosh&&S.env&&delete S.env.DYLD_LIBRARY_PATH,this.child=y.fork(this.modulePath,p,S);const k=new A.Emitter;A.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if(g.isRemoteConsoleLog(n)){g.log(n,`IPC Library: ${this.options.serverName}`);return}k.fire(I.VSBuffer.wrap(Buffer.from(n,"base64")))});const s=this.options.useQueue?_.createQueuedSender(this.child):this.child,e=n=>this.child&&this.child.connected&&s.send(n.buffer.toString("base64")),r=k.event,i={send:e,onMessage:r};this._client=new m.ChannelClient(i);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,u)=>{process.removeListener("exit",o),this.activeRequests.forEach(v=>M.dispose(v)),this.activeRequests.clear(),n!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+u),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:u})})}return this._client}getCachedChannel(p){let S=this.channels.get(p);return S||(S=this.client.getChannel(p),this.channels.set(p,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=L}),define(Q[72],Y([4,5]),function(q,t){return q.create("vs/base/node/zip",t)}),define(Q[73],Y([4,5]),function(q,t){return q.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Q[74],Y([4,5]),function(q,t){return q.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Q[75],Y([4,5]),function(q,t){return q.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Q[76],Y([4,5]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Q[77],Y([4,5]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Q[78],Y([4,5]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Q[79],Y([4,5]),function(q,t){return q.create("vs/platform/extensions/common/extensionValidator",t)}),define(Q[80],Y([4,5]),function(q,t){return q.create("vs/platform/files/common/fileService",t)}),define(Q[81],Y([4,5]),function(q,t){return q.create("vs/platform/files/common/io",t)}),define(Q[82],Y([4,5]),function(q,t){return q.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Q[83],Y([4,5]),function(q,t){return q.create("vs/platform/request/common/request",t)}),define(Q[84],Y([4,5]),function(q,t){return q.create("vs/platform/telemetry/common/telemetryService",t)}),define(Q[85],Y([0,1,18]),function(q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const M=/^%([\w\d.-]+)%$/i;function D(b,A){const _=m=>{if(typeof m=="string"){const g=M.exec(m);if(!!g)return A[g[1]]||m}};return y.cloneAndChange(b,_)}t.localizeManifest=D}),define(Q[47],Y([0,1,79]),function(q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVersionValid=t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function D(f){return f=f.trim(),f==="*"||M.test(f)}t.isValidVersionStr=D;function b(f){if(!D(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let I=f.match(M);return I?{hasCaret:I[1]==="^",hasGreaterEquals:I[1]===">=",majorBase:I[2]==="x"?0:parseInt(I[2],10),majorMustEqual:I[2]!=="x",minorBase:I[4]==="x"?0:parseInt(I[4],10),minorMustEqual:I[4]!=="x",patchBase:I[6]==="x"?0:parseInt(I[6],10),patchMustEqual:I[6]!=="x",preRelease:I[8]||null}:null}t.parseVersion=b;function A(f){if(!f)return null;let I=f.majorBase,w=f.majorMustEqual,l=f.minorBase,L=f.minorMustEqual,E=f.patchBase,p=f.patchMustEqual;return f.hasCaret&&(I===0||(L=!1),p=!1),{majorBase:I,majorMustEqual:w,minorBase:l,minorMustEqual:L,patchBase:E,patchMustEqual:p,isMinimum:f.hasGreaterEquals}}t.normalizeVersion=A;function _(f,I){let w;typeof f=="string"?w=A(b(f)):w=f;let l;if(typeof I=="string"?l=A(b(I)):l=I,!w||!l)return!1;let L=w.majorBase,E=w.minorBase,p=w.patchBase,S=l.majorBase,k=l.minorBase,a=l.patchBase,s=l.majorMustEqual,e=l.minorMustEqual,r=l.patchMustEqual;return l.isMinimum?L>S?!0:L<S?!1:E>k?!0:E<k?!1:p>=a:(L===1&&S===0&&(!s||!e||!r)&&(S=1,k=0,a=0,s=!0,e=!1,r=!1),L<S?!1:L>S?!s:E<k?!1:E>k?!e:p<a?!1:p>a?!r:!0)}t.isValidVersion=_;function m(f,I,w){return I.isBuiltin||typeof I.main=="undefined"?!0:T(f,I.engines.vscode,w)}t.isValidExtensionVersion=m;function g(f,I){return f==="*"||T(I,f)}t.isEngineValid=g;function T(f,I,w=[]){let l=A(b(I));if(!l)return w.push(y.localize(0,null,I)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return w.push(y.localize(1,null,I)),!1}else if(!l.majorMustEqual)return w.push(y.localize(2,null,I)),!1;return _(f,l)?!0:(w.push(y.localize(3,null,f,I)),!1)}t.isVersionValid=T}),define(Q[86],Y([0,1,28,46,2,7]),function(q,t,y,M,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class A extends D.Disposable{constructor(m,g,T,f){super();this.folders=m,this.onDidFilesChange=g,this.onLogMessage=T,this.verboseLogging=f,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new M.Client(b.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=y.createChannelSender(y.getNextTickChannel(m.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.setFolders(this.folders)}setVerboseLogging(m){this.verboseLogging=m,!this.isDisposed&&this.service&&this.service.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${m}`})}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=A,A.MAX_RESTARTS=5}),define(Q[87],Y([0,1,28,46,2,7]),function(q,t,y,M,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class A extends D.Disposable{constructor(m,g,T,f,I={}){super();this.folders=m,this.onDidFilesChange=g,this.onLogMessage=T,this.verboseLogging=f,this.watcherOptions=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new M.Client(b.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=y.createChannelSender(y.getNextTickChannel(m.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.service.setRoots(this.folders)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${m}`})}setVerboseLogging(m){this.verboseLogging=m,this.service&&this.service.setVerboseLogging(m)}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=A,A.MAX_RESTARTS=5}),define(Q[88],Y([0,1,35,44,59,7]),function(q,t,y,M,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class A{constructor(m,g,T,f,I){this.watchedFolder=m,this.eventCallback=T,this.logCallback=f,this.verboseLogging=I,this.restartCounter=0,Array.isArray(g)?this.ignored=g.map(w=>D.parse(w)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${m}`),this.startWatcher()}startWatcher(){const m=[this.watchedFolder];this.verboseLogging&&m.push("-verbose"),this.handle=y.spawn(b.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",q).fsPath,m);const g=new M.LineDecoder;this.handle.stdout.on("data",T=>{const f=[];g.write(T).forEach(I=>{const w=I.split("|");if(w.length===2){const l=Number(w[0]),L=w[1];if(l>=0&&l<3){if(this.ignored&&this.ignored.some(E=>E(L))){this.verboseLogging&&this.log(L);return}f.push({type:A.changeTypeMap[l],path:L})}else this.log(w[1])}}),f.length>0&&this.eventCallback(f)}),this.handle.on("error",T=>this.onError(T)),this.handle.stderr.on("data",T=>this.onError(T)),this.handle.on("exit",(T,f)=>this.onExit(T,f))}onError(m){this.error("process error: "+m.toString())}onExit(m,g){this.handle&&(this.error(`terminated unexpectedly (code: ${m}, signal: ${g})`),this.restartCounter<=A.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(m){this.logCallback({type:"error",message:`[File Watcher (C#)] ${m}`})}log(m){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${m}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=A,A.MAX_RESTARTS=5,A.changeTypeMap=[0,1,2]}),define(Q[89],Y([0,1,88,3,17]),function(q,t,y,M,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class b{constructor(_,m,g,T){this.onDidFilesChange=m,this.onLogMessage=g,this.verboseLogging=T,this.service=void 0,this.folder=_[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(M.posix.sep)&&(this.folder.path=D.rtrim(this.folder.path,M.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new y.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,_=>this.onFileEvents(_),_=>this.onLogMessage(_),this.verboseLogging)}setVerboseLogging(_){this.verboseLogging=_,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(_){this.isDisposed||_.length>0&&this.onDidFilesChange(_)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=b}),define(Q[48],Y([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class y{constructor(b,A=[],_=!1){this.ctor=b,this.staticArguments=A,this.supportsDelayedInstantiation=_}}t.SyncDescriptor=y;const M=(D,...b)=>new y(D,b);t.createSyncDescriptor=M}),define(Q[90],Y([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class y{constructor(b){this.incoming=new Map,this.outgoing=new Map,this.data=b}}t.Node=y;class M{constructor(b){this._hashFn=b,this._nodes=new Map}roots(){const b=[];for(let A of this._nodes.values())A.outgoing.size===0&&b.push(A);return b}insertEdge(b,A){const _=this.lookupOrInsertNode(b),m=this.lookupOrInsertNode(A);_.outgoing.set(this._hashFn(A),m),m.incoming.set(this._hashFn(b),_)}removeNode(b){const A=this._hashFn(b);this._nodes.delete(A);for(let _ of this._nodes.values())_.outgoing.delete(A),_.incoming.delete(A)}lookupOrInsertNode(b){const A=this._hashFn(b);let _=this._nodes.get(A);return _||(_=new y(b),this._nodes.set(A,_)),_}lookup(b){return this._nodes.get(this._hashFn(b))}isEmpty(){return this._nodes.size===0}toString(){let b=[];for(let[A,_]of this._nodes)b.push(`${A}, (incoming)[${[..._.incoming.keys()].join(", ")}], (outgoing)[${[..._.outgoing.keys()].join(",")}]`);return b.join(`
`)}}t.Graph=M}),define(Q[91],Y([0,1,6]),function(q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=y.createDecorator("downloadService")}),define(Q[20],Y([0,1,6]),function(q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=y.createDecorator("environmentService"),t.INativeEnvironmentService=y.createDecorator("nativeEnvironmentService")}),define(Q[23],Y([0,1,74,6,7]),function(q,t,y,M,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN);function b(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=b;var A;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=5]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(A=t.SortBy||(t.SortBy={}));var _;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(_=t.SortOrder||(t.SortOrder={}));var m;(function(f){f.Uninstall="uninstall"})(m=t.StatisticType||(t.StatisticType={}));var g;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(g=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=M.createDecorator("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class T extends Error{constructor(I,w){super(I);this.code=w}}t.ExtensionManagementError=T,t.IExtensionManagementService=M.createDecorator("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=M.createDecorator("IGlobalExtensionEnablementService"),t.IExtensionTipsService=M.createDecorator("IExtensionTipsService"),t.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",q).toString(!0),t.ExtensionsLabel=y.localize(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=y.localize(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=M.createDecorator("IExtensionManagementCLIService")}),define(Q[36],Y([0,1,17,6]),function(q,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}t.isIExtensionIdentifier=D,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Themes","Testing","Visualization","Other"];var b;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(b=t.ExtensionType||(t.ExtensionType={}));class A{constructor(T){this.value=T,this._lower=T.toLowerCase()}static equals(T,f){if(typeof T=="undefined"||T===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof T=="string"||typeof f=="string"){let I=typeof T=="string"?T:T.value,w=typeof f=="string"?f:f.value;return y.equalsIgnoreCase(I,w)}return T._lower===f._lower}static toKey(T){return typeof T=="string"?T.toLowerCase():T._lower}}t.ExtensionIdentifier=A;function _(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}t.isLanguagePackExtension=_;function m(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=m,t.IBuiltinExtensionsScannerService=M.createDecorator("IBuiltinExtensionsScannerService")}),define(Q[26],Y([0,1,17,36]),function(q,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function D(w,l){return w.uuid&&l.uuid?w.uuid===l.uuid:w.id===l.id?!0:y.compareIgnoreCase(w.id,l.id)===0}t.areSameExtensions=D;class b{constructor(l,L){this.version=L,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof b?D(this,l)&&this.version===l.version:!1}}t.ExtensionIdentifierWithVersion=b;function A(w,l){return`${w}.${l}`}t.getExtensionId=A;function _(w){return w.toLocaleLowerCase()}t.adoptToGalleryExtensionId=_;function m(w,l){return _(A(w,l))}t.getGalleryExtensionId=m;function g(w,l){const L=[],E=p=>{for(const S of L)if(S.some(k=>D(l(k),l(p))))return S;return null};for(const p of w){const S=E(p);S?S.push(p):L.push([p])}return L}t.groupByExtension=g;function T(w){return{id:w.identifier.id,name:w.manifest.name,galleryId:null,publisherId:w.publisherId,publisherName:w.manifest.publisher,publisherDisplayName:w.publisherDisplayName,dependencies:w.manifest.extensionDependencies&&w.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=T;function f(w){return Object.assign({id:w.identifier.id,name:w.name,galleryId:w.identifier.uuid,publisherId:w.publisherId,publisherName:w.publisher,publisherDisplayName:w.publisherDisplayName,dependencies:!!(w.properties.dependencies&&w.properties.dependencies.length>0)},w.telemetryData)}t.getGalleryExtensionTelemetryData=f,t.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function I(w){const l=new Set;for(const L of w)L.malicious&&l.add(L.id.id);return l}t.getMaliciousExtensionsSet=I}),define(Q[92],Y([0,1,2,3,36,12]),function(q,t,y,M,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class A extends y.Disposable{constructor(m,g){super();this.environmentService=m,this.extensionsManifestCache=M.join(this.environmentService.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtension(T=>this.onDidInstallExtension(T))),this._register(g.onDidUninstallExtension(T=>this.onDidUnInstallExtension(T)))}onDidInstallExtension(m){m.error||this.invalidate()}onDidUnInstallExtension(m){m.error||this.invalidate()}invalidate(){b.rimraf(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=A}),define(Q[49],Y([0,1,81,16,24,15]),function(q,t,y,M,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function A(T,f,I,w,l,L){let E;try{await _(T,f,I,w,l,L)}catch(p){E=p}finally{E&&l.errorTransformer&&(E=l.errorTransformer(E)),I.end(E)}}t.readFileIntoStream=A;async function _(T,f,I,w,l,L){m(L);const E=await T.open(f,{create:!1});try{m(L);let p=0,S=0,k=l&&typeof l.length=="number"?l.length:void 0,a=M.VSBuffer.alloc(Math.min(l.bufferSize,typeof k=="number"?k:l.bufferSize)),s=l&&typeof l.position=="number"?l.position:0,e=0;do S=await T.read(E,s,a.buffer,e,a.byteLength-e),s+=S,e+=S,p+=S,typeof k=="number"&&(k-=S),e===a.byteLength&&(await I.write(w(a)),a=M.VSBuffer.alloc(Math.min(l.bufferSize,typeof k=="number"?k:l.bufferSize)),e=0);while(S>0&&(typeof k!="number"||k>0)&&m(L)&&g(p,l));if(e>0){let r=e;typeof k=="number"&&(r=Math.min(e,k)),I.write(w(a.slice(0,r)))}}catch(p){throw D.ensureFileSystemProviderError(p)}finally{await T.close(E)}}function m(T){if(T.isCancellationRequested)throw b.canceled();return!0}function g(T,f){if(f==null?void 0:f.limits){if(typeof f.limits.memory=="number"&&T>f.limits.memory)throw D.createFileSystemProviderError(y.localize(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof f.limits.size=="number"&&T>f.limits.size)throw D.createFileSystemProviderError(y.localize(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[50],Y([0,1,10,24,13]),function(q,t,y,M,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function b(m){return m.map(g=>({type:g.type,resource:y.URI.file(g.path)}))}t.toFileChanges=b;function A(m){const g=new _;for(const T of m)g.processEvent(T);return g.normalize()}t.normalizeFileChanges=A;class _{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(g){const T=this.mapPathToChange.get(g.path);if(T){const f=T.type,I=g.type;f===1&&I===2?(this.mapPathToChange.delete(g.path),this.normalized.splice(this.normalized.indexOf(T),1)):f===2&&I===1?T.type=0:f===1&&I===0||(T.type=I)}else this.normalized.push(g),this.mapPathToChange.set(g.path,g)}normalize(){const g=[],T=[];return this.normalized.filter(f=>f.type!==2?(g.push(f),!1):!0).sort((f,I)=>f.path.length-I.path.length).filter(f=>T.some(I=>M.isParent(f.path,I,!D.isLinux))?!1:(T.push(f.path),!0)).concat(g)}}}),define(Q[93],Y([0,1,50,2,12,63,64,11,3]),function(q,t,y,M,D,b,A,_,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class g extends M.Disposable{constructor(f,I,w,l){super();this.path=f,this.onDidFilesChange=I,this.onLogMessage=w,this.verboseLogging=l,this.fileChangesDelayer=this._register(new _.ThrottledDelayer(A.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(f){this.verboseLogging=f}async startWatching(){try{const{stat:f,symbolicLink:I}=await D.statLink(this.path);if(this.isDisposed)return;let w=this.path;if(I)try{w=await b.realpath(w)}catch(l){this.onError(l)}f.isDirectory()?this._register(A.watchFolder(w,(l,L)=>{this.onFileChange({type:l==="changed"?0:l==="added"?1:2,path:m.join(this.path,m.basename(L))})},l=>this.onError(l))):this._register(A.watchFile(w,l=>{this.onFileChange({type:l==="changed"?0:2,path:this.path})},l=>this.onError(l)))}catch(f){this.onError(f)}}onFileChange(f){this.fileChangesBuffer.push(f),this.verboseLogging&&this.onVerbose(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),this.fileChangesDelayer.trigger(async()=>{const I=this.fileChangesBuffer;this.fileChangesBuffer=[];const w=y.normalizeFileChanges(I);this.verboseLogging&&w.forEach(l=>{this.onVerbose(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`)}),w.length>0&&this.onDidFilesChange(w)})}onError(f){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${f}`})}onVerbose(f){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=g}),define(Q[51],Y([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class y{constructor(...D){this._entries=new Map;for(let[b,A]of D)this.set(b,A)}set(D,b){const A=this._entries.get(D);return this._entries.set(D,b),A}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}t.ServiceCollection=y}),define(Q[94],Y([0,1,15,90,48,6,51,11]),function(q,t,y,M,D,b,A,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const m=!1;class g extends Error{constructor(l){super("cyclic dependency between services");this.message=l.toString()}}class T{constructor(l=new A.ServiceCollection,L=!1,E){this._activeInstantiations=new Set,this._services=l,this._strict=L,this._parent=E,this._services.set(b.IInstantiationService,this)}createChild(l){return new T(l,this._strict,this)}invokeFunction(l,...L){let E=I.traceInvocation(l),p=!1;try{return l({get:(k,a)=>{if(p)throw y.illegalState("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(k,E);if(!s&&a!==b.optional)throw new Error(`[invokeFunction] unknown service '${k}'`);return s}},...L)}finally{p=!0,E.stop()}}createInstance(l,...L){let E,p;return l instanceof D.SyncDescriptor?(E=I.traceCreation(l.ctor),p=this._createInstance(l.ctor,l.staticArguments.concat(L),E)):(E=I.traceCreation(l),p=this._createInstance(l,L,E)),E.stop(),p}_createInstance(l,L=[],E){let p=b._util.getServiceDependencies(l).sort((a,s)=>a.index-s.index),S=[];for(const a of p){let s=this._getOrCreateServiceInstance(a.id,E);if(!s&&this._strict&&!a.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${a.id}.`);S.push(s)}let k=p.length>0?p[0].index:L.length;if(L.length!==k){console.warn(`[createInstance] First service dependency of ${l.name} at position ${k+1} conflicts with ${L.length} static arguments`);let a=k-L.length;a>0?L=L.concat(new Array(a)):L=L.slice(0,k)}return new l(...[...L,...S])}_setServiceInstance(l,L){if(this._services.get(l)instanceof D.SyncDescriptor)this._services.set(l,L);else if(this._parent)this._parent._setServiceInstance(l,L);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let L=this._services.get(l);return!L&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):L}_getOrCreateServiceInstance(l,L){let E=this._getServiceInstanceOrDescriptor(l);return E instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,E,L.branch(l,!0)):(L.branch(l,!1),E)}_safeCreateAndCacheServiceInstance(l,L,E){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,L,E)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,L,E){const p=new M.Graph(a=>a.id.toString());let S=0;const k=[{id:l,desc:L,_trace:E}];for(;k.length;){const a=k.pop();if(p.lookupOrInsertNode(a),S++>1e3)throw new g(p);for(let s of b._util.getServiceDependencies(a.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${l} depends on ${s.id} which is NOT registered.`),e instanceof D.SyncDescriptor){const r={id:s.id,desc:e,_trace:a._trace.branch(s.id,!0)};p.insertEdge(a,r),k.push(r)}}}for(;;){const a=p.roots();if(a.length===0){if(!p.isEmpty())throw new g(p);break}for(const{data:s}of a){if(this._getServiceInstanceOrDescriptor(s.id)instanceof D.SyncDescriptor){const r=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,r)}p.removeNode(s)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,L,E=[],p,S){if(this._services.get(l)instanceof D.SyncDescriptor)return this._createServiceInstance(L,E,p,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,L,E,p,S);throw new Error(`illegalState - creating UNKNOWN service instance ${L.name}`)}_createServiceInstance(l,L=[],E,p){if(E){const S=new _.IdleValue(()=>this._createInstance(l,L,p));return new Proxy(Object.create(null),{get(k,a){if(a in k)return k[a];let s=S.value,e=s[a];return typeof e!="function"||(e=e.bind(s),k[a]=e),e},set(k,a,s){return S.value[a]=s,!0}})}else return this._createInstance(l,L,p)}}t.InstantiationService=T;var f;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(f||(f={}));class I{constructor(l,L){this.type=l,this.name=L,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return m?new I(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):I._None}static traceCreation(l){return m?new I(0,l.name):I._None}branch(l,L){let E=new I(2,l.toString());return this._dep.push([l,L,E]),E}stop(){let l=Date.now()-this._start;I._totals+=l;let L=!1;function E(S,k){let a=[],s=new Array(S+1).join("	");for(const[e,r,i]of k._dep)if(r&&i){L=!0,a.push(`${s}CREATES -> ${e}`);let o=E(S+1,i);o&&a.push(o)}else a.push(`${s}uses -> ${e}`);return a.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${I._totals.toFixed(2)}ms)`];(l>2||L)&&console.log(p.join(`
`))}}I._None=new class extends I{constructor(){super(-1,null)}stop(){}branch(){return this}},I._totals=0}),define(Q[37],Y([0,1,6]),function(q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=y.createDecorator("localizationsService");function M(D){if(typeof D.languageId!="string"||!Array.isArray(D.translations)||D.translations.length===0)return!1;for(const b of D.translations)if(typeof b.id!="string"||typeof b.path!="string")return!1;return!(D.languageName&&typeof D.languageName!="string"||D.localizedLanguageName&&typeof D.localizedLanguageName!="string")}t.isValidLocalization=M});var le=this&&this.__decorate||function(q,t,y,M){var D=arguments.length,b=D<3?t:M===null?M=Object.getOwnPropertyDescriptor(t,y):M,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")b=Reflect.decorate(q,t,y,M);else for(var _=q.length-1;_>=0;_--)(A=q[_])&&(b=(D<3?A(b):D>3?A(t,y,b):A(t,y))||b);return D>3&&b&&Object.defineProperty(t,y,b),b},fe=this&&this.__param||function(q,t){return function(y,M){t(y,M,q)}};define(Q[95],Y([0,1,75,15,10,38,23,26,36,61,29,7,37]),function(q,t,y,M,D,b,A,_,m,g,T,f,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const w=k=>y.localize(0,null,k),l=y.localize(1,null,"ms-dotnettools.csharp");function L(k,a){return a?`${k.publisher}.${k.name}@${k.version}`:`${k.publisher}.${k.name}`}const E=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function p(k){const a=E.exec(k);return a&&a[1]?[_.adoptToGalleryExtensionId(a[1]),a[2]]:[_.adoptToGalleryExtensionId(k),void 0]}t.getIdAndVersion=p;let S=class{constructor(a,s,e){this.extensionManagementService=a,this.extensionGalleryService=s,this.localizationsService=e}get location(){}async listExtensions(a,s,e=console){let r=await this.extensionManagementService.getInstalled(1);const i=m.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(s&&s!==""){if(i.indexOf(s.toLowerCase())<0){e.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}r=r.filter(n=>n.manifest.categories?n.manifest.categories.map(v=>v.toLowerCase()).indexOf(s.toLowerCase())>-1:!1)}else if(s===""){e.log("Possible Categories: "),i.forEach(n=>{e.log(n)});return}this.location&&e.log(y.localize(2,null,this.location)),r=r.sort((n,u)=>n.identifier.id.localeCompare(u.identifier.id));let o;for(let n of r)o!==n.identifier.id&&(o=n.identifier.id,e.log(L(n.manifest,a)))}async installExtensions(a,s,e,r,i=console){const o=[],n=[];a.length&&i.log(this.location?y.localize(3,null,this.location):y.localize(4,null));const u=await this.extensionManagementService.getInstalled(1),v=(N,j)=>{const H=u.find(Z=>_.areSameExtensions(Z.identifier,{id:N}));if(H){if(!j&&!r)return i.log(y.localize(5,null,N,H.manifest.version,N)),!1;if(j&&H.manifest.version===j)return i.log(y.localize(6,null,`${N}@${j}`)),!1}return!0},O=[],R=[];for(const N of a)if(N instanceof D.URI)O.push(N);else{const[j,H]=p(N);v(j,H)&&R.push({id:j,version:H,installOptions:{isBuiltin:!1,isMachineScoped:e}})}for(const N of s){const[j,H]=p(N);v(j,H)&&R.push({id:j,version:H,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(O.length&&await Promise.all(O.map(async N=>{try{const j=await this.installVSIX(N,r,i);j&&n.push(j)}catch(j){i.error(j.message||j.stack||j),o.push(N.toString())}})),R.length){const N=await this.getGalleryExtensions(R);await Promise.all(R.map(async j=>{const H=N.get(j.id.toLowerCase());if(H)try{const Z=await this.installFromGallery(j,H,u,r,i);Z&&n.push(Z)}catch(Z){i.error(Z.message||Z.stack||Z),o.push(j.id)}else i.error(`${w(j.version?`${j.id}@${j.version}`:j.id)}
${l}`),o.push(j.id)}))}if(n.some(N=>m.isLanguagePackExtension(N))&&await this.updateLocalizationsCache(),o.length)throw new Error(y.localize(7,null,o.join(", ")))}async installVSIX(a,s,e){const r=await this.extensionManagementService.getManifest(a);if(!r)throw new Error("Invalid vsix");if(await this.validateVSIX(r,s,e))try{return await this.extensionManagementService.install(a),e.log(y.localize(8,null,g.getBaseLabel(a))),r}catch(o){if(M.isPromiseCanceledError(o))return e.log(y.localize(9,null,g.getBaseLabel(a))),null;throw o}return null}async getGalleryExtensions(a){const s=a.filter(({version:i})=>i===void 0).map(({id:i})=>i),e=a.filter(({version:i})=>i!==void 0),r=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(s,T.CancellationToken.None)).forEach(o=>r.set(o.identifier.id.toLowerCase(),o))})(),Promise.all(e.map(async({id:i,version:o})=>{const n=await this.extensionGalleryService.getCompatibleExtension({id:i},o);n&&r.set(n.identifier.id.toLowerCase(),n)}))]),r}async installFromGallery({id:a,version:s,installOptions:e},r,i,o,n){const u=await this.extensionGalleryService.getManifest(r,T.CancellationToken.None);if(u&&!this.validateExtensionKind(u,n))return null;const v=i.find(O=>_.areSameExtensions(O.identifier,r.identifier));if(v){if(r.version===v.manifest.version)return n.log(y.localize(10,null,s?`${a}@${s}`:a)),null;n.log(y.localize(11,null,a,r.version))}try{return e.isBuiltin?n.log(y.localize(12,null,a,r.version)):n.log(y.localize(13,null,a,r.version)),await this.extensionManagementService.installFromGallery(r,e),n.log(y.localize(14,null,a,r.version)),u}catch(O){if(M.isPromiseCanceledError(O))return n.log(y.localize(15,null,a)),null;throw O}}validateExtensionKind(a,s){return!0}async validateVSIX(a,s,e){const r={id:_.getGalleryExtensionId(a.publisher,a.name)},o=(await this.extensionManagementService.getInstalled(1)).find(n=>_.areSameExtensions(r,n.identifier)&&b.gt(n.manifest.version,a.version));return o&&!s?(e.log(y.localize(16,null,o.identifier.id,o.manifest.version,a.version)),!1):this.validateExtensionKind(a,e)}async uninstallExtensions(a,s,e=console){const r=async o=>{if(o instanceof D.URI){const n=await this.extensionManagementService.getManifest(o);return L(n)}return o},i=[];for(const o of a){const n=await r(o),v=(await this.extensionManagementService.getInstalled()).filter(O=>_.areSameExtensions(O.identifier,{id:n}));if(!v.length)throw new Error(`${this.notInstalled(n)}
${l}`);if(v.some(O=>O.type===0)){e.log(y.localize(17,null,n));return}if(!s&&v.some(O=>O.isBuiltin)){e.log(y.localize(18,null,n));return}e.log(y.localize(19,null,n));for(const O of v)await this.extensionManagementService.uninstall(O),i.push(O);this.location?e.log(y.localize(20,null,n,this.location)):e.log(y.localize(21,null,n))}i.some(o=>m.isLanguagePackExtension(o.manifest))&&await this.updateLocalizationsCache()}async locateExtension(a,s=console){const e=await this.extensionManagementService.getInstalled();a.forEach(r=>{e.forEach(i=>{if(i.identifier.id===r&&i.location.scheme===f.Schemas.file){s.log(i.location.fsPath);return}})})}updateLocalizationsCache(){return this.localizationsService.update()}notInstalled(a){return this.location?y.localize(22,null,a,this.location):y.localize(23,null,a)}};S=le([fe(0,A.IExtensionManagementService),fe(1,A.IExtensionGalleryService),fe(2,I.ILocalizationsService)],S),t.ExtensionManagementCLIService=S}),define(Q[14],Y([0,1,6,2,13,8,31]),function(q,t,y,M,D,b,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.DelegatedLogService=t.MultiplexLogService=t.ConsoleLogInMainService=t.LogServiceAdapter=t.ConsoleLogService=t.ConsoleLogMainService=t.AbstractLogService=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=y.createDecorator("logService"),t.ILoggerService=y.createDecorator("loggerService");function _(){return new Date().toISOString()}var m;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(m=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=m.Info;class g extends M.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogService=g;class T extends g{constructor(s=t.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!D.isWindows}trace(s,...e){this.getLevel()<=m.Trace&&(this.useColors?console.log(`[90m[main ${_()}][0m`,s,...e):console.log(`[main ${_()}]`,s,...e))}debug(s,...e){this.getLevel()<=m.Debug&&(this.useColors?console.log(`[90m[main ${_()}][0m`,s,...e):console.log(`[main ${_()}]`,s,...e))}info(s,...e){this.getLevel()<=m.Info&&(this.useColors?console.log(`[90m[main ${_()}][0m`,s,...e):console.log(`[main ${_()}]`,s,...e))}warn(s,...e){this.getLevel()<=m.Warning&&(this.useColors?console.warn(`[93m[main ${_()}][0m`,s,...e):console.warn(`[main ${_()}]`,s,...e))}error(s,...e){this.getLevel()<=m.Error&&(this.useColors?console.error(`[91m[main ${_()}][0m`,s,...e):console.error(`[main ${_()}]`,s,...e))}critical(s,...e){this.getLevel()<=m.Critical&&(this.useColors?console.error(`[90m[main ${_()}][0m`,s,...e):console.error(`[main ${_()}]`,s,...e))}dispose(){}flush(){}}t.ConsoleLogMainService=T;class f extends g{constructor(s=t.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...e){this.getLevel()<=m.Trace&&console.log("%cTRACE","color: #888",s,...e)}debug(s,...e){this.getLevel()<=m.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...e)}info(s,...e){this.getLevel()<=m.Info&&console.log("%c INFO","color: #33f",s,...e)}warn(s,...e){this.getLevel()<=m.Warning&&console.log("%c WARN","color: #993",s,...e)}error(s,...e){this.getLevel()<=m.Error&&console.log("%c  ERR","color: #f33",s,...e)}critical(s,...e){this.getLevel()<=m.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...e)}dispose(){}flush(){}}t.ConsoleLogService=f;class I extends g{constructor(s,e=t.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(e)}trace(s,...e){this.getLevel()<=m.Trace&&this.adapter.consoleLog("trace",[this.extractMessage(s),...e])}debug(s,...e){this.getLevel()<=m.Debug&&this.adapter.consoleLog("debug",[this.extractMessage(s),...e])}info(s,...e){this.getLevel()<=m.Info&&this.adapter.consoleLog("info",[this.extractMessage(s),...e])}warn(s,...e){this.getLevel()<=m.Warning&&this.adapter.consoleLog("warn",[this.extractMessage(s),...e])}error(s,...e){this.getLevel()<=m.Error&&this.adapter.consoleLog("error",[this.extractMessage(s),...e])}critical(s,...e){this.getLevel()<=m.Critical&&this.adapter.consoleLog("critical",[this.extractMessage(s),...e])}extractMessage(s){return typeof s=="string"?s:A.toErrorMessage(s,this.getLevel()<=m.Trace)}dispose(){}flush(){}}t.LogServiceAdapter=I;class w extends I{constructor(s,e=t.DEFAULT_LOG_LEVEL){super({consoleLog:(r,i)=>s.consoleLog(r,i)},e)}}t.ConsoleLogInMainService=w;class l extends g{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const e of this.logServices)e.setLevel(s);super.setLevel(s)}trace(s,...e){for(const r of this.logServices)r.trace(s,...e)}debug(s,...e){for(const r of this.logServices)r.debug(s,...e)}info(s,...e){for(const r of this.logServices)r.info(s,...e)}warn(s,...e){for(const r of this.logServices)r.warn(s,...e)}error(s,...e){for(const r of this.logServices)r.error(s,...e)}critical(s,...e){for(const r of this.logServices)r.critical(s,...e)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}t.MultiplexLogService=l;class L extends M.Disposable{constructor(s){super();this.logService=s,this._register(s)}get onDidChangeLogLevel(){return this.logService.onDidChangeLogLevel}setLevel(s){this.logService.setLevel(s)}getLevel(){return this.logService.getLevel()}trace(s,...e){this.logService.trace(s,...e)}debug(s,...e){this.logService.debug(s,...e)}info(s,...e){this.logService.info(s,...e)}warn(s,...e){this.logService.warn(s,...e)}error(s,...e){this.logService.error(s,...e)}critical(s,...e){this.logService.critical(s,...e)}flush(){this.logService.flush()}}t.DelegatedLogService=L;class E{constructor(){this.onDidChangeLogLevel=new b.Emitter().event}setLevel(s){}getLevel(){return m.Info}trace(s,...e){}debug(s,...e){}info(s,...e){}warn(s,...e){}error(s,...e){}critical(s,...e){}dispose(){}flush(){}}t.NullLogService=E;function p(a){if(a.verbose)return m.Trace;if(typeof a.logLevel=="string"){const s=S(a.logLevel.toLowerCase());if(s!==void 0)return s}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=p;function S(a){switch(a){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Critical;case"off":return m.Off}}t.parseLogLevel=S;function k(a){switch(a){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Critical:return"critical";case m.Off:return"off"}}t.LogLevelToString=k}),define(Q[96],Y([0,1,2,12,24,23,20,10,21,26,14,32,38,13]),function(q,t,y,M,D,b,A,_,m,g,T,f,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const l=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let L=class extends y.Disposable{constructor(p,S,k,a){super();this.fileService=S,this.extensionGalleryService=k,this.logService=a,this.extensionsDownloadDir=_.URI.file(p.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(p,S){await this.cleanUpPromise;const k=this.getName(p),a=m.joinPath(this.extensionsDownloadDir,k);if(!await this.fileService.exists(a)){const s=m.joinPath(this.extensionsDownloadDir,`.${k}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(p,s,S),await this.rename(s,a,Date.now()+2*60*1e3)}return a}async delete(p){}async rename(p,S,k){try{await M.rename(p.fsPath,S.fsPath)}catch(a){if(w.isWindows&&a&&a.code==="EPERM"&&Date.now()<k)return this.logService.info(`Failed renaming ${p} to ${S} with 'EPERM' error. Trying again...`),this.rename(p,S,k);throw a}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const p=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(p.children){const S=[],k=[];for(const e of p.children){const r=this.parse(e.name);r&&k.push([r,e])}const a=g.groupByExtension(k,([e])=>e),s=[];for(const e of a)e.sort((r,i)=>I.rcompare(r[0].version,i[0].version)),S.push(...e.slice(1).map(r=>r[1].resource)),s.push(e[0][1]);s.sort((e,r)=>e.mtime-r.mtime),S.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(e=>e.resource)),await Promise.all(S.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(p){this.logService.error(p)}}getName(p){return this.cache?new g.ExtensionIdentifierWithVersion(p.identifier,p.version).key().toLowerCase():f.generateUuid()}parse(p){const S=l.exec(p);return S&&S[1]&&S[2]?new g.ExtensionIdentifierWithVersion({id:S[1]},S[2]):null}};L=le([fe(0,A.INativeEnvironmentService),fe(1,D.IFileService),fe(2,b.IExtensionGalleryService),fe(3,T.ILogService)],L),t.ExtensionsDownloader=L}),define(Q[97],Y([0,1,2,14,35,31,3,11,8,7,12,20]),function(q,t,y,M,D,b,A,_,m,g,T,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let I=class extends y.Disposable{constructor(l,L){super();this.environmentService=l,this.logService=L,this.processesLimiter=new _.Limiter(5)}async postUninstall(l){const L=this.parseScript(l,"uninstall");return L&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(L.script,"uninstall",L.args,!0,l).then(()=>this.logService.info(l.identifier.id,l.manifest.version,"Finished running post uninstall script"),E=>this.logService.error(l.identifier.id,l.manifest.version,`Failed to run post uninstall script: ${E}`)))),T.rimraf(this.getExtensionStoragePath(l)).then(void 0,E=>this.logService.error("Error while removing extension storage path",E))}parseScript(l,L){const E=`vscode:${L}`;if(l.location.scheme===g.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[E]=="string"){const p=l.manifest.scripts[E].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${E} should be a node script`),null):{script:A.join(l.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(l,L,E,p,S){return new Promise((k,a)=>{const s=this.start(l,L,E,S);let e;const r=i=>{e&&(clearTimeout(e),e=null),i?a(i):k(void 0)};s.on("error",i=>{r(b.toErrorMessage(i)||"Unknown")}),s.on("exit",(i,o)=>{r(i?`post-${L} process exited with code ${i}`:void 0)}),p&&(e=setTimeout(()=>{e=null,s.kill(),a("timed out")},5e3))})}start(l,L,E,p){const S={silent:!0,execArgv:void 0},k=D.fork(l,[`--type=extension-post-${L}`,...E],S);k.stdout.setEncoding("utf8"),k.stderr.setEncoding("utf8");const a=m.Event.fromNodeEventEmitter(k.stdout,"data"),s=m.Event.fromNodeEventEmitter(k.stderr,"data");a(i=>this.logService.info(p.identifier.id,p.manifest.version,`post-${L}`,i)),s(i=>this.logService.error(p.identifier.id,p.manifest.version,`post-${L}`,i));const e=m.Event.any(m.Event.map(a,i=>({data:`%c${i}`,format:[""]})),m.Event.map(s,i=>({data:`%c${i}`,format:["color: red"]})));return m.Event.debounce(e,(i,o)=>i?{data:i.data+o.data,format:[...i.format,...o.format]}:{data:o.data,format:o.format},100)(i=>{console.group(p.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),k}getExtensionStoragePath(l){return A.join(this.environmentService.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};I=le([fe(0,f.IEnvironmentService),fe(1,M.ILogService)],I),t.ExtensionsLifecycle=I}),define(Q[98],Y([0,1,80,126,2,24,8,21,43,19,14,16,33,11,29,7,49,127]),function(q,t,y,M,D,b,A,_,m,g,T,f,I,w,l,L,E,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let S=class extends D.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueues=new Map}registerProvider(a,s){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);M.mark(`code/registerFilesystem/${a}`),this.provider.set(a,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:s});const e=new D.DisposableStore;return e.add(s.onDidChangeFile(r=>this._onDidFilesChange.fire(new b.FileChangesEvent(r,!this.isPathCaseSensitive(s))))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:a}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),D.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:s}),this.provider.delete(a),D.dispose(e)})}async activateProvider(a){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(e){e&&s.push(e)}}),!this.provider.has(a)&&await Promise.all(s)}canHandleResource(a){return this.provider.has(a.scheme)}hasCapability(a,s){const e=this.provider.get(a.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return p.Iterable.map(this.provider,([a,s])=>({scheme:a,capabilities:s.capabilities}))}async withProvider(a){if(!_.isAbsolutePath(a))throw new b.FileOperationError(y.localize(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const s=this.provider.get(a.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=y.localize(1,null,a.toString()),e}return s}async withReadProvider(a){const s=await this.withProvider(a);if(b.hasOpenReadWriteCloseCapability(s)||b.hasReadWriteCapability(s)||b.hasFileReadStreamCapability(s))return s;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const s=await this.withProvider(a);if(b.hasOpenReadWriteCloseCapability(s)||b.hasReadWriteCapability(s))return s;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,s){try{return await this.doResolveFile(a,s)}catch(e){throw b.toFileSystemProviderErrorCode(e)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError(y.localize(2,null,this.resourceForError(a)),1):b.ensureFileSystemProviderError(e)}}async doResolveFile(a,s){const e=await this.withProvider(a),r=this.isPathCaseSensitive(e),i=s==null?void 0:s.resolveTo,o=s==null?void 0:s.resolveSingleChildDescendants,n=s==null?void 0:s.resolveMetadata,u=await e.stat(a);let v;return this.toFileStat(e,a,u,void 0,!!n,(O,R)=>(v||(v=m.TernarySearchTree.forUris(()=>!r),v.set(a,!0),g.isNonEmptyArray(i)&&i.forEach(N=>v.set(N,!0))),Boolean(v.findSuperstr(O.resource)||v.get(O.resource))?!0:O.isDirectory&&o?R===1:!1))}async toFileStat(a,s,e,r,i,o){const{providerExtUri:n}=this.getExtUri(a),u={resource:s,name:n.basename(s),isFile:(e.type&b.FileType.File)!=0,isDirectory:(e.type&b.FileType.Directory)!=0,isSymbolicLink:(e.type&b.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,etag:b.etag({mtime:e.mtime,size:e.size})};if(u.isDirectory&&o(u,r)){try{const v=await a.readdir(s),O=await Promise.all(v.map(async([R,N])=>{try{const j=n.joinPath(s,R),H=i?await a.stat(j):{type:N};return await this.toFileStat(a,j,H,v.length,i,o)}catch(j){return this.logService.trace(j),null}}));u.children=g.coalesce(O)}catch(v){this.logService.trace(v),u.children=[]}return u}return u}async resolveAll(a){return Promise.all(a.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(a){const s=await this.withProvider(a);try{return!!await s.stat(a)}catch(e){return!1}}async canCreateFile(a,s){try{await this.doValidateCreateFile(a,s)}catch(e){return e}return!0}async doValidateCreateFile(a,s){if(!(s==null?void 0:s.overwrite)&&await this.exists(a))throw new b.FileOperationError(y.localize(3,null,this.resourceForError(a)),3,s)}async createFile(a,s=f.VSBuffer.fromString(""),e){await this.doValidateCreateFile(a,e);const r=await this.writeFile(a,s);return this._onDidRunOperation.fire(new b.FileOperationEvent(a,0,r)),r}async writeFile(a,s,e){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,a,e)||await this.mkdirp(r,i.dirname(a));let n;if(b.hasReadWriteCapability(r)&&!(s instanceof f.VSBuffer))if(I.isReadableStream(s)){const u=await I.peekStream(s,3);u.ended?n=f.VSBuffer.concat(u.buffer):n=u}else n=I.peekReadable(s,u=>f.VSBuffer.concat(u),3);else n=s;!b.hasOpenReadWriteCloseCapability(r)||b.hasReadWriteCapability(r)&&n instanceof f.VSBuffer?await this.doWriteUnbuffered(r,a,n):await this.doWriteBuffered(r,a,n instanceof f.VSBuffer?f.bufferToReadable(n):n)}catch(o){throw new b.FileOperationError(y.localize(4,null,this.resourceForError(a),b.ensureFileSystemProviderError(o).toString()),b.toFileOperationResult(o),e)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,s,e){let r;try{r=await a.stat(s)}catch(i){return}if((r.type&b.FileType.Directory)!=0)throw new b.FileOperationError(y.localize(5,null,this.resourceForError(s)),0,e);if(e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==b.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&e.mtime<r.mtime&&e.etag!==b.etag({mtime:e.mtime,size:r.size}))throw new b.FileOperationError(y.localize(6,null),3,e);return r}async readFile(a,s){const e=await this.withReadProvider(a),r=await this.doReadAsFileStream(e,a,Object.assign(Object.assign({},s),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await f.streamToBuffer(r.value)})}async readFileStream(a,s){const e=await this.withReadProvider(a);return this.doReadAsFileStream(e,a,s)}async doReadAsFileStream(a,s,e){const r=new l.CancellationTokenSource,i=this.validateReadFile(s,e).then(n=>n,n=>{throw r.cancel(),n});let o;try{e&&typeof e.etag=="string"&&e.etag!==b.ETAG_DISABLED&&await i;let n;!(b.hasOpenReadWriteCloseCapability(a)||b.hasFileReadStreamCapability(a))||b.hasReadWriteCapability(a)&&(e==null?void 0:e.preferUnbuffered)?n=this.readFileUnbuffered(a,s,e):b.hasFileReadStreamCapability(a)?n=this.readFileStreamed(a,s,r.token,e):n=this.readFileBuffered(a,s,r.token,e),o=I.observe(n);const u=await i;return Object.assign(Object.assign({},u),{value:n})}catch(n){throw o&&await o.errorOrEnd(),new b.FileOperationError(y.localize(7,null,this.resourceForError(s),b.ensureFileSystemProviderError(n).toString()),b.toFileOperationResult(n),e)}}readFileStreamed(a,s,e,r=Object.create(null)){const i=a.readFileStream(s,r,e);return I.transform(i,{data:o=>o instanceof f.VSBuffer?o:f.VSBuffer.wrap(o),error:o=>new b.FileOperationError(y.localize(8,null,this.resourceForError(s),b.ensureFileSystemProviderError(o).toString()),b.toFileOperationResult(o),r)},o=>f.VSBuffer.concat(o))}readFileBuffered(a,s,e,r=Object.create(null)){const i=f.newWriteableBufferStream();return E.readFileIntoStream(a,s,i,o=>o,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new b.FileOperationError(y.localize(9,null,this.resourceForError(s),b.ensureFileSystemProviderError(o).toString()),b.toFileOperationResult(o),r)}),e),i}readFileUnbuffered(a,s,e){const r=I.newWriteableStream(i=>f.VSBuffer.concat(i));return(async()=>{try{let i=await a.readFile(s);e&&typeof e.position=="number"&&(i=i.slice(e.position)),e&&typeof e.length=="number"&&(i=i.slice(0,e.length)),this.validateReadFileLimits(s,i.byteLength,e),r.end(f.VSBuffer.wrap(i))}catch(i){r.error(i)}})(),r}async validateReadFile(a,s){const e=await this.resolve(a,{resolveMetadata:!0});if(e.isDirectory)throw new b.FileOperationError(y.localize(10,null,this.resourceForError(a)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==b.ETAG_DISABLED&&s.etag===e.etag)throw new b.FileOperationError(y.localize(11,null),2,s);return this.validateReadFileLimits(a,e.size,s),e}validateReadFileLimits(a,s,e){if(e==null?void 0:e.limits){let r;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(r=9),typeof e.limits.size=="number"&&s>e.limits.size&&(r=7),typeof r=="number")throw new b.FileOperationError(y.localize(12,null,this.resourceForError(a)),r)}}async canMove(a,s,e){return this.doCanMoveCopy(a,s,"move",e)}async canCopy(a,s,e){return this.doCanMoveCopy(a,s,"copy",e)}async doCanMoveCopy(a,s,e,r){if(a.toString()!==s.toString())try{const i=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(i,a,o,s,e,r)}catch(i){return i}return!0}async move(a,s,e){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(r,a,i,s,"move",!!e),n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(a,o==="move"?2:3,n)),n}async copy(a,s,e){const r=await this.withReadProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(r,a,i,s,"copy",!!e),n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(a,o==="copy"?3:2,n)),n}async doMoveCopy(a,s,e,r,i,o){if(s.toString()===r.toString())return i;const{exists:n,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(a,s,e,r,i,o);if(n&&!u&&o&&await this.del(r,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(r)),i==="copy"){if(a===e&&b.hasFileFolderCopyCapability(a))await a.copy(s,r,{overwrite:o});else{const v=await this.resolve(s);v.isDirectory?await this.doCopyFolder(a,v,e,r):await this.doCopyFile(a,s,e,r)}return i}else return a===e?(await a.rename(s,r,{overwrite:o}),i):(await this.doMoveCopy(a,s,e,r,"copy",o),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(a,s,e,r){if(b.hasOpenReadWriteCloseCapability(a)&&b.hasOpenReadWriteCloseCapability(e))return this.doPipeBuffered(a,s,e,r);if(b.hasOpenReadWriteCloseCapability(a)&&b.hasReadWriteCapability(e))return this.doPipeBufferedToUnbuffered(a,s,e,r);if(b.hasReadWriteCapability(a)&&b.hasOpenReadWriteCloseCapability(e))return this.doPipeUnbufferedToBuffered(a,s,e,r);if(b.hasReadWriteCapability(a)&&b.hasReadWriteCapability(e))return this.doPipeUnbuffered(a,s,e,r)}async doCopyFolder(a,s,e,r){await e.mkdir(r),Array.isArray(s.children)&&await Promise.all(s.children.map(async i=>{const o=this.getExtUri(e).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(a,await this.resolve(i.resource),e,o):this.doCopyFile(a,i.resource,e,o)}))}async doValidateMoveCopy(a,s,e,r,i,o){let n=!1;if(a===e){const{providerExtUri:v,isPathCaseSensitive:O}=this.getExtUri(a);if(O||(n=v.isEqual(s,r)),n&&i==="copy")throw new Error(y.localize(13,null,this.resourceForError(s),this.resourceForError(r)));if(!n&&v.isEqualOrParent(r,s))throw new Error(y.localize(14,null,this.resourceForError(s),this.resourceForError(r)))}const u=await this.exists(r);if(u&&!n){if(!o)throw new b.FileOperationError(y.localize(15,null,this.resourceForError(s),this.resourceForError(r)),4);if(a===e){const{providerExtUri:v}=this.getExtUri(a);if(v.isEqualOrParent(s,r))throw new Error(y.localize(16,null,this.resourceForError(s),this.resourceForError(r)))}}return{exists:u,isSameResourceWithDifferentPathCase:n}}getExtUri(a){const s=this.isPathCaseSensitive(a);return{providerExtUri:s?_.extUri:_.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(s,a);const e=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(a,0,e)),e}async mkdirp(a,s){const e=[],{providerExtUri:r}=this.getExtUri(a);for(;!r.isEqual(s,r.dirname(s));)try{if(((await a.stat(s)).type&b.FileType.Directory)==0)throw new Error(y.localize(17,null,this.resourceForError(s)));break}catch(i){if(b.toFileSystemProviderErrorCode(i)!==b.FileSystemProviderErrorCode.FileNotFound)throw i;e.push(r.basename(s)),s=r.dirname(s)}for(let i=e.length-1;i>=0;i--){s=r.joinPath(s,e[i]);try{await a.mkdir(s)}catch(o){if(b.toFileSystemProviderErrorCode(o)!==b.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(a,s){try{await this.doValidateDelete(a,s)}catch(e){return e}return!0}async doValidateDelete(a,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!(s==null?void 0:s.useTrash)&&!(e.capabilities&4096))throw new Error(y.localize(18,null,this.resourceForError(a)));const i=await this.exists(a);if(!i)throw new b.FileOperationError(y.localize(19,null,this.resourceForError(a)),1);if(!!!(s==null?void 0:s.recursive)&&i){const n=await this.resolve(a);if(n.isDirectory&&Array.isArray(n.children)&&n.children.length>0)throw new Error(y.localize(20,null,this.resourceForError(a)))}return e}async del(a,s){const e=await this.doValidateDelete(a,s),r=!!(s==null?void 0:s.useTrash),i=!!(s==null?void 0:s.recursive);await e.delete(a,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new b.FileOperationEvent(a,1))}watch(a,s={recursive:!1,excludes:[]}){let e=!1,r=()=>{e=!0};return this.doWatch(a,s).then(i=>{e?D.dispose(i):r=()=>D.dispose(i)},i=>this.logService.error(i)),D.toDisposable(()=>r())}async doWatch(a,s){const e=await this.withProvider(a),r=this.toWatchKey(e,a,s),i=this.activeWatchers.get(r)||{count:0,disposable:e.watch(a,s)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,D.toDisposable(()=>{i.count--,i.count===0&&(D.dispose(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(a,s,e){const{providerExtUri:r}=this.getExtUri(a);return[r.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(a=>D.dispose(a.disposable)),this.activeWatchers.clear()}ensureWriteQueue(a,s){const{providerExtUri:e}=this.getExtUri(a),r=e.getComparisonKey(s);let i=this.writeQueues.get(r);return i||(i=new w.Queue,this.writeQueues.set(r,i),A.Event.once(i.onFinished)(()=>{this.writeQueues.delete(r),D.dispose(i)})),i}async doWriteBuffered(a,s,e){return this.ensureWriteQueue(a,s).queue(async()=>{const r=await a.open(s,{create:!0});try{I.isReadableStream(e)||I.isReadableBufferedStream(e)?await this.doWriteStreamBufferedQueued(a,r,e):await this.doWriteReadableBufferedQueued(a,r,e)}catch(i){throw b.ensureFileSystemProviderError(i)}finally{await a.close(r)}})}async doWriteStreamBufferedQueued(a,s,e){let r=0,i;if(I.isReadableBufferedStream(e)){if(e.buffer.length>0){const o=f.VSBuffer.concat(e.buffer);await this.doWriteBuffer(a,s,o,o.byteLength,r,0),r+=o.byteLength}if(e.ended)return;i=e.stream}else i=e;return new Promise(async(o,n)=>{i.on("data",async u=>{i.pause();try{await this.doWriteBuffer(a,s,u,u.byteLength,r,0)}catch(v){return n(v)}r+=u.byteLength,setTimeout(()=>i.resume())}),i.on("error",u=>n(u)),i.on("end",()=>o())})}async doWriteReadableBufferedQueued(a,s,e){let r=0,i;for(;(i=e.read())!==null;)await this.doWriteBuffer(a,s,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(a,s,e,r,i,o){let n=0;for(;n<r;)n+=await a.write(s,i+n,e.buffer,o+n,r-n)}async doWriteUnbuffered(a,s,e){return this.ensureWriteQueue(a,s).queue(()=>this.doWriteUnbufferedQueued(a,s,e))}async doWriteUnbufferedQueued(a,s,e){let r;e instanceof f.VSBuffer?r=e:I.isReadableStream(e)?r=await f.streamToBuffer(e):I.isReadableBufferedStream(e)?r=await f.bufferedStreamToBuffer(e):r=f.readableToBuffer(e),await a.writeFile(s,r.buffer,{create:!0,overwrite:!0})}async doPipeBuffered(a,s,e,r){return this.ensureWriteQueue(e,r).queue(()=>this.doPipeBufferedQueued(a,s,e,r))}async doPipeBufferedQueued(a,s,e,r){let i,o;try{i=await a.open(s,{create:!1}),o=await e.open(r,{create:!0});const n=f.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,v=0,O=0;do O=await a.read(i,u,n.buffer,v,n.byteLength-v),await this.doWriteBuffer(e,o,n,O,u,v),u+=O,v+=O,v===n.byteLength&&(v=0);while(O>0)}catch(n){throw b.ensureFileSystemProviderError(n)}finally{await Promise.all([typeof i=="number"?a.close(i):Promise.resolve(),typeof o=="number"?e.close(o):Promise.resolve()])}}async doPipeUnbuffered(a,s,e,r){return this.ensureWriteQueue(e,r).queue(()=>this.doPipeUnbufferedQueued(a,s,e,r))}async doPipeUnbufferedQueued(a,s,e,r){return e.writeFile(r,await a.readFile(s),{create:!0,overwrite:!0})}async doPipeUnbufferedToBuffered(a,s,e,r){return this.ensureWriteQueue(e,r).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,s,e,r))}async doPipeUnbufferedToBufferedQueued(a,s,e,r){const i=await e.open(r,{create:!0});try{const o=await a.readFile(s);await this.doWriteBuffer(e,i,f.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw b.ensureFileSystemProviderError(o)}finally{await e.close(i)}}async doPipeBufferedToUnbuffered(a,s,e,r){const i=await f.streamToBuffer(this.readFileBuffered(a,s,l.CancellationToken.None));await this.doWriteUnbuffered(e,r,i)}throwIfFileSystemIsReadonly(a,s){if(a.capabilities&2048)throw new b.FileOperationError(y.localize(21,null,this.resourceForError(s)),6);return a}resourceForError(a){return a.scheme===L.Schemas.file?a.fsPath:a.toString(!0)}};S=le([fe(0,T.ILogService)],S),t.FileService=S}),define(Q[99],Y([0,1,22,45,2,24,8,13,12,3,21,34,11,14,82,50,87,89,86,93,33,49,19,16]),function(q,t,y,M,D,b,A,_,m,g,T,f,I,w,l,L,E,p,S,k,a,s,e,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class i extends D.Disposable{constructor(n,u){var v;super();this.logService=n,this.options=u,this.BUFFER_SIZE=((v=this.options)===null||v===void 0?void 0:v.bufferSize)||64*1024,this.onDidChangeCapabilities=A.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Set,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new A.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new I.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8,_.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:u,symbolicLink:v}=await m.statLink(this.toFilePath(n));return{type:this.toType(u,v),ctime:u.birthtime.getTime(),mtime:u.mtime.getTime(),size:u.size}}catch(u){throw this.toFileSystemProviderError(u)}}async readdir(n){try{const u=await m.readdirWithFileTypes(this.toFilePath(n)),v=[];return await Promise.all(u.map(async O=>{try{let R;O.isSymbolicLink()?R=(await this.stat(T.joinPath(n,O.name))).type:R=this.toType(O),v.push([O.name,R])}catch(R){this.logService.trace(R)}})),v}catch(u){throw this.toFileSystemProviderError(u)}}toType(n,u){let v;return(u==null?void 0:u.dangling)?v=b.FileType.Unknown:n.isFile()?v=b.FileType.File:n.isDirectory()?v=b.FileType.Directory:v=b.FileType.Unknown,u&&(v|=b.FileType.SymbolicLink),v}async readFile(n){try{const u=this.toFilePath(n);return await m.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}}readFileStream(n,u,v){const O=a.newWriteableStream(R=>r.VSBuffer.concat(R.map(N=>r.VSBuffer.wrap(N))).buffer);return s.readFileIntoStream(this,n,O,R=>R.buffer,Object.assign(Object.assign({},u),{bufferSize:this.BUFFER_SIZE}),v),O}async writeFile(n,u,v){let O;try{const R=this.toFilePath(n);if(!v.create||!v.overwrite){if(await m.exists(R)){if(!v.overwrite)throw b.createFileSystemProviderError(l.localize(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!v.create)throw b.createFileSystemProviderError(l.localize(1,null),b.FileSystemProviderErrorCode.FileNotFound)}O=await this.open(n,{create:!0}),await this.write(O,0,u,0,u.byteLength)}catch(R){throw this.toFileSystemProviderError(R)}finally{typeof O=="number"&&await this.close(O)}}async open(n,u){try{const v=this.toFilePath(n);let O;if(u.create){if(_.isWindows&&await m.exists(v))try{await m.truncate(v,0),O="r+"}catch(N){this.logService.trace(N)}O||(O="w")}else O="r";const R=await M.promisify(y.open)(v,O);return this.mapHandleToPos.set(R,0),u.create&&this.writeHandles.add(R),R}catch(v){throw this.toFileSystemProviderError(v)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await M.promisify(y.fdatasync)(n)}catch(u){this.canFlush=!1,this.logService.error(u)}return await M.promisify(y.close)(n)}catch(u){throw this.toFileSystemProviderError(u)}}async read(n,u,v,O,R){const N=this.normalizePos(n,u);let j=null;try{const H=await M.promisify(y.read)(n,v,O,R,N);return typeof H=="number"?j=H:j=H.bytesRead,j}catch(H){throw this.toFileSystemProviderError(H)}finally{this.updatePos(n,N,j)}}normalizePos(n,u){return u===this.mapHandleToPos.get(n)?null:u}updatePos(n,u,v){const O=this.mapHandleToPos.get(n);typeof O=="number"&&(typeof u=="number"||(typeof v=="number"?this.mapHandleToPos.set(n,O+v):this.mapHandleToPos.delete(n)))}async write(n,u,v,O,R){return I.retry(()=>this.doWrite(n,u,v,O,R),100,3)}async doWrite(n,u,v,O,R){const N=this.normalizePos(n,u);let j=null;try{const H=await M.promisify(y.write)(n,v,O,R,N);return typeof H=="number"?j=H:j=H.bytesWritten,j}catch(H){throw this.toFileSystemProviderError(H)}finally{this.updatePos(n,N,j)}}async mkdir(n){try{await M.promisify(y.mkdir)(this.toFilePath(n))}catch(u){throw this.toFileSystemProviderError(u)}}async delete(n,u){try{const v=this.toFilePath(n);await this.doDelete(v,u)}catch(v){throw this.toFileSystemProviderError(v)}}async doDelete(n,u){u.recursive?await m.rimraf(n,m.RimRafMode.MOVE):await m.unlink(n)}async rename(n,u,v){const O=this.toFilePath(n),R=this.toFilePath(u);if(O!==R)try{await this.validateTargetDeleted(n,u,"move",v.overwrite),await m.move(O,R)}catch(N){throw(N.code==="EINVAL"||N.code==="EBUSY"||N.code==="ENAMETOOLONG")&&(N=new Error(l.localize(2,null,g.basename(O),g.basename(g.dirname(R)),N.toString()))),this.toFileSystemProviderError(N)}}async copy(n,u,v){const O=this.toFilePath(n),R=this.toFilePath(u);if(O!==R)try{await this.validateTargetDeleted(n,u,"copy",v.overwrite),await m.copy(O,R)}catch(N){throw(N.code==="EINVAL"||N.code==="EBUSY"||N.code==="ENAMETOOLONG")&&(N=new Error(l.localize(3,null,g.basename(O),g.basename(g.dirname(R)),N.toString()))),this.toFileSystemProviderError(N)}}async validateTargetDeleted(n,u,v,O){const R=this.toFilePath(n),N=this.toFilePath(u);let j=!1;if(!!(this.capabilities&1024)||(j=f.isEqual(R,N,!0)),j&&v==="copy")throw b.createFileSystemProviderError(l.localize(4,null),b.FileSystemProviderErrorCode.FileExists);if(!j&&await m.exists(N)){if(!O)throw b.createFileSystemProviderError(l.localize(5,null),b.FileSystemProviderErrorCode.FileExists);await this.delete(u,{recursive:!0,useTrash:!1})}}watch(n,u){return u.recursive?this.watchRecursive(n,u.excludes):this.watchNonRecursive(n)}watchRecursive(n,u){const v={path:this.toFilePath(n),excludes:u},O=e.insert(this.recursiveFoldersToWatch,v);return this.refreshRecursiveWatchers(),D.toDisposable(()=>{O(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var n,u,v;if(this.recursiveWatcher instanceof S.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(D.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let O,R;((u=(n=this.options)===null||n===void 0?void 0:n.watcher)===null||u===void 0?void 0:u.usePolling)?(O=E.FileWatcher,R=(v=this.options)===null||v===void 0?void 0:v.watcher):this.recursiveFoldersToWatch.length===1?_.isWindows?O=p.FileWatcher:O=E.FileWatcher:O=S.FileWatcher,this.recursiveWatcher=new O(this.recursiveFoldersToWatch,N=>this._onDidChangeFile.fire(L.toFileChanges(N)),N=>{N.type==="error"&&this._onDidWatchErrorOccur.fire(N.message),this.logService[N.type](N.message)},this.logService.getLevel()===w.LogLevel.Trace,R),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))}}watchNonRecursive(n){const u=new k.FileWatcher(this.toFilePath(n),O=>this._onDidChangeFile.fire(L.toFileChanges(O)),O=>{O.type==="error"&&this._onDidWatchErrorOccur.fire(O.message),this.logService[O.type](O.message)},this.logService.getLevel()===w.LogLevel.Trace),v=this.logService.onDidChangeLogLevel(()=>{u.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)});return D.combinedDisposable(u,v)}toFilePath(n){return g.normalize(n.fsPath)}toFileSystemProviderError(n){if(n instanceof b.FileSystemProviderError)return n;let u;switch(n.code){case"ENOENT":u=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":u=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":u=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":u=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":u=b.FileSystemProviderErrorCode.NoPermissions;break;default:u=b.FileSystemProviderErrorCode.Unknown}return b.createFileSystemProviderError(n,u)}dispose(){super.dispose(),D.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,D.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=i}),define(Q[100],Y([0,1,12,101,23,2,20,11,26,14,37,19,8,7,3]),function(q,t,y,M,D,b,A,_,m,g,T,f,I,w,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let L=class extends b.Disposable{constructor(S,k,a){super();this.extensionManagementService=S,this.logService=a,this._onDidLanguagesChange=this._register(new I.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new E(k,a)),this._register(S.onDidInstallExtension(({local:s})=>this.onDidInstallExtension(s))),this._register(S.onDidUninstallExtension(({identifier:s})=>this.onDidUninstallExtension(s)))}getLanguageIds(){return this.cache.getLanguagePacks().then(S=>{const k=["en",...Object.keys(S)];return f.distinct(k)})}onDidInstallExtension(S){S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",S.identifier.id),this.update().then(k=>{k&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(S){this.cache.getLanguagePacks().then(k=>{Object.keys(k).some(a=>k[a]&&k[a].extensions.some(s=>m.areSameExtensions(s.extensionIdentifier,S)))&&(this.logService.debug("Removing language packs from the extension",S.id),this.update().then(a=>{a&&this._onDidLanguagesChange.fire()}))})}update(){return Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]).then(([S,k])=>this.cache.update(k).then(a=>!f.equals(Object.keys(S),Object.keys(a))))}};L=le([fe(0,D.IExtensionManagementService),fe(1,A.INativeEnvironmentService),fe(2,g.ILogService)],L),t.LocalizationsService=L;let E=class extends b.Disposable{constructor(S,k){super();this.logService=k,this.languagePacks={},this.languagePacksFilePath=l.join(S.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new _.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(S){return this.withLanguagePacks(k=>{Object.keys(k).forEach(a=>delete k[a]),this.createLanguagePacksFromExtensions(k,...S)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(S,...k){for(const a of k)a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(S,a);Object.keys(S).forEach(a=>this.updateHash(S[a]))}createLanguagePacksFromExtension(S,k){const a=k.identifier,s=k.manifest.contributes&&k.manifest.contributes.localizations?k.manifest.contributes.localizations:[];for(const e of s)if(k.location.scheme===w.Schemas.file&&T.isValidLocalization(e)){let r=S[e.languageId];r||(r={hash:"",extensions:[],translations:{}},S[e.languageId]=r);let i=r.extensions.filter(o=>m.areSameExtensions(o.extensionIdentifier,a))[0];i?i.version=k.manifest.version:r.extensions.push({extensionIdentifier:a,version:k.manifest.version});for(const o of e.translations)r.translations[o.id]=l.join(k.location.fsPath,o.path)}}updateHash(S){if(S){const k=M.createHash("md5");for(const a of S.extensions)k.update(a.extensionIdentifier.uuid||a.extensionIdentifier.id).update(a.version);S.hash=k.digest("hex")}}withLanguagePacks(S=()=>null){return this.languagePacksFileLimiter.queue(()=>{let k=null;return y.readFile(this.languagePacksFilePath,"utf8").then(void 0,a=>a.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(a)).then(a=>{try{return JSON.parse(a)}catch(s){return{}}}).then(a=>(k=S(a),a)).then(a=>{for(const e of Object.keys(a))a[e]||delete a[e];this.languagePacks=a,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),y.writeFile(this.languagePacksFilePath,s)}).then(()=>k,a=>this.logService.error(a))})}};E=le([fe(0,A.INativeEnvironmentService),fe(1,g.ILogService)],E)}),define(Q[102],Y([0,1,3,14,24]),function(q,t,y,M,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogService=t.createRotatingLogger=void 0;async function b(g,T){try{const f=await new Promise((w,l)=>{q(["spdlog"],w,l)});f.setAsyncMode(8192,500);const I=y.join(T,`${g}.log`);return f.createRotatingLoggerAsync(g,I,5*D.ByteSize.MB,6)}catch(f){console.error(f)}return null}function A(g,T,f,I){return q.__$__nodeRequire("spdlog").createRotatingLogger(g,T,f,I)}t.createRotatingLogger=A;function _(g,T,f){switch(T){case M.LogLevel.Trace:g.trace(f);break;case M.LogLevel.Debug:g.debug(f);break;case M.LogLevel.Info:g.info(f);break;case M.LogLevel.Warning:g.warn(f);break;case M.LogLevel.Error:g.error(f);break;case M.LogLevel.Critical:g.critical(f);break;default:throw new Error("Invalid log level")}}class m extends M.AbstractLogService{constructor(T,f,I){super();this.name=T,this.logsFolder=f,this.buffer=[],this._loggerCreationPromise=void 0,this.setLevel(I),this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(w=>{this._logger&&this._logger.setLevel(w)}))}_createSpdLogLogger(){return this._loggerCreationPromise||(this._loggerCreationPromise=b(this.name,this.logsFolder).then(T=>{if(T){this._logger=T,this._logger.setLevel(this.getLevel());for(const{level:f,message:I}of this.buffer)_(this._logger,f,I);this.buffer=[]}})),this._loggerCreationPromise}_log(T,f){this._logger?_(this._logger,T,f):this.getLevel()<=T&&this.buffer.push({level:T,message:f})}trace(T,...f){this.getLevel()<=M.LogLevel.Trace&&this._log(M.LogLevel.Trace,this.format([T,...f]))}debug(T,...f){this.getLevel()<=M.LogLevel.Debug&&this._log(M.LogLevel.Debug,this.format([T,...f]))}info(T,...f){this.getLevel()<=M.LogLevel.Info&&this._log(M.LogLevel.Info,this.format([T,...f]))}warn(T,...f){this.getLevel()<=M.LogLevel.Warning&&this._log(M.LogLevel.Warning,this.format([T,...f]))}error(T,...f){if(this.getLevel()<=M.LogLevel.Error)if(T instanceof Error){const I=Array.prototype.slice.call(arguments);I[0]=T.stack,this._log(M.LogLevel.Error,this.format(I))}else this._log(M.LogLevel.Error,this.format([T,...f]))}critical(T,...f){this.getLevel()<=M.LogLevel.Critical&&this._log(M.LogLevel.Critical,this.format([T,...f]))}flush(){this._logger?this._logger.flush():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.disposeLogger()),this._loggerCreationPromise=void 0}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}format(T){let f="";for(let I=0;I<T.length;I++){let w=T[I];if(typeof w=="object")try{w=JSON.stringify(w)}catch(l){}f+=(I>0?" ":"")+w}return f}}t.SpdLogService=m}),define(Q[39],Y([0,1,6]),function(q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=y.createDecorator("productService")}),define(Q[25],Y([0,1,9,55]),function(q,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class D{constructor(){this.data=new Map}add(A,_){M.ok(y.isString(A)),M.ok(y.isObject(_)),M.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,_)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}t.Registry=new D}),define(Q[103],Y([0,1,25,8]),function(q,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function D(_){return _.length>0&&_.charAt(_.length-1)==="#"?_.substring(0,_.length-1):_}class b{constructor(){this._onDidChangeSchema=new M.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,g){this.schemasById[D(m)]=g,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new b;y.Registry.add(t.Extensions.JSONContribution,A)}),define(Q[30],Y([0,1,73,8,25,9,103]),function(q,t,y,M,D,b,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"};var _;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(_=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const m=D.Registry.as(A.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:y.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},m.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(p,S=!0){this.registerConfigurations([p],S)}registerConfigurations(p,S=!0){const k=[];p.forEach(a=>{k.push(...this.validateAndRegisterProperties(a,S)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),m.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(k)}deregisterConfigurations(p){const S=[],k=a=>{if(a.properties)for(const s in a.properties)S.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,a.properties[s]);a.allOf&&a.allOf.forEach(s=>k(s))};for(const a of p){k(a);const s=this.configurationContributors.indexOf(a);s!==-1&&this.configurationContributors.splice(s,1)}m.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}registerDefaultConfigurations(p){const S=[],k=[];for(const a of p)for(const s in a)if(S.push(s),t.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]=Object.assign(Object.assign({},this.defaultValues[s]||{}),a[s]);const e={type:"object",default:this.defaultValues[s],description:y.localize(1,null,s),$ref:t.resourceLanguageSettingsSchemaId};k.push(f(s)),this.configurationProperties[s]=e,this.defaultLanguageConfigurationOverridesNode.properties[s]=e}else{this.defaultValues[s]=a[s];const e=this.configurationProperties[s];e&&(this.updatePropertyDefaultValue(s,e),this.updateSchema(s,e))}this.registerOverrideIdentifiers(k),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterDefaultConfigurations(p){const S=[];for(const k of p)for(const a in k)if(S.push(a),delete this.defaultValues[a],t.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const s=this.configurationProperties[a];s&&(this.updatePropertyDefaultValue(a,s),this.updateSchema(a,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}notifyConfigurationSchemaUpdated(...p){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(p){for(const S of p)this.overrideIdentifiers.add(S);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(p,S=!0,k=3){k=b.isUndefinedOrNull(p.scope)?k:p.scope;let a=[],s=p.properties;if(s)for(let r in s){if(S&&l(r)){delete s[r];continue}const i=s[r];if(this.updatePropertyDefaultValue(r,i),t.OVERRIDE_PROPERTY_PATTERN.test(r)?i.scope=void 0:i.scope=b.isUndefinedOrNull(i.scope)?k:i.scope,s[r].hasOwnProperty("included")&&!s[r].included){this.excludedConfigurationProperties[r]=s[r],delete s[r];continue}else this.configurationProperties[r]=s[r];!s[r].deprecationMessage&&s[r].markdownDeprecationMessage&&(s[r].deprecationMessage=s[r].markdownDeprecationMessage),a.push(r)}let e=p.allOf;if(e)for(let r of e)a.push(...this.validateAndRegisterProperties(r,S,k));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(p){const S=k=>{let a=k.properties;if(a)for(const e in a)this.updateSchema(e,a[e]);let s=k.allOf;s&&s.forEach(S)};S(p)}updateSchema(p,S){switch(t.allSettings.properties[p]=S,S.scope){case 1:t.applicationSettings.properties[p]=S;break;case 2:t.machineSettings.properties[p]=S;break;case 6:t.machineOverridableSettings.properties[p]=S;break;case 3:t.windowSettings.properties[p]=S;break;case 4:t.resourceSettings.properties[p]=S;break;case 5:t.resourceSettings.properties[p]=S,this.resourceLanguageSettingsSchema.properties[p]=S;break}}removeFromSchema(p,S){switch(delete t.allSettings.properties[p],S.scope){case 1:delete t.applicationSettings.properties[p];break;case 2:delete t.machineSettings.properties[p];break;case 6:delete t.machineOverridableSettings.properties[p];break;case 3:delete t.windowSettings.properties[p];break;case 4:case 5:delete t.resourceSettings.properties[p];break}}updateOverridePropertyPatternKey(){for(const p of this.overrideIdentifiers.values()){const S=`[${p}]`,k={type:"object",description:y.localize(2,null),errorMessage:y.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(S,k),t.allSettings.properties[S]=k,t.applicationSettings.properties[S]=k,t.machineSettings.properties[S]=k,t.machineOverridableSettings.properties[S]=k,t.windowSettings.properties[S]=k,t.resourceSettings.properties[S]=k}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(p,S){let k=this.defaultValues[p];b.isUndefined(k)&&(k=S.default),b.isUndefined(k)&&(k=I(S.type)),S.default=k}}const T="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(T);function f(E){return E.substring(1,E.length-1)}t.overrideIdentifierFromKey=f;function I(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=I;const w=new g;D.Registry.add(t.Extensions.Configuration,w);function l(E){return E.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(E)?y.localize(5,null,E):w.getConfigurationProperties()[E]!==void 0?y.localize(6,null,E):null:y.localize(4,null)}t.validateProperty=l;function L(){const E=[],p=w.getConfigurationProperties();for(const S of Object.keys(p))E.push([S,p[S].scope]);return E.push(["launch",4]),E.push(["task",4]),E}t.getScopes=L}),define(Q[27],Y([0,1,18,9,10,25,6,30]),function(q,t,y,M,D,b,A,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=A.createDecorator("configurationService");function m(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof D.URI)}t.isConfigurationOverrides=m;var g;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(g=t.ConfigurationTarget||(t.ConfigurationTarget={}));function T(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=T;function f(r,i){const o=i?r?i.keys.filter(j=>r.keys.indexOf(j)===-1):[...i.keys]:[],n=r?i?r.keys.filter(j=>i.keys.indexOf(j)===-1):[...r.keys]:[],u=[];if(i&&r){for(const j of r.keys)if(i.keys.indexOf(j)!==-1){const H=p(r.contents,j),Z=p(i.contents,j);y.equals(H,Z)||u.push(j)}}const v=[],O=j=>{const H={};for(const Z of j)for(const oe of Z.identifiers)H[s(oe)]=Z;return H},R=i?O(i.overrides):{},N=r?O(r.overrides):{};if(Object.keys(R).length)for(const j of o){const H=R[j];H&&v.push([_.overrideIdentifierFromKey(j),H.keys])}if(Object.keys(N).length)for(const j of n){const H=N[j];H&&v.push([_.overrideIdentifierFromKey(j),H.keys])}if(Object.keys(R).length&&Object.keys(N).length)for(const j of u){const H=N[j],Z=R[j];if(H&&Z){const oe=f({contents:H.contents,keys:H.keys,overrides:[]},{contents:Z.contents,keys:Z.keys,overrides:[]});v.push([_.overrideIdentifierFromKey(j),[...oe.added,...oe.removed,...oe.updated]])}}return{added:o,removed:n,updated:u,overrides:v}}t.compare=f;function I(r,i){const o=[];for(const n of Object.keys(r))if(_.OVERRIDE_PROPERTY_PATTERN.test(n)){const u={};for(const v in r[n])u[v]=r[n][v];o.push({identifiers:[_.overrideIdentifierFromKey(n).trim()],keys:Object.keys(u),contents:w(u,i)})}return o}t.toOverrides=I;function w(r,i){const o=Object.create(null);for(let n in r)l(o,n,r[n],i);return o}t.toValuesTree=w;function l(r,i,o,n){const u=i.split("."),v=u.pop();let O=r;for(let R=0;R<u.length;R++){let N=u[R],j=O[N];switch(typeof j){case"undefined":j=O[N]=Object.create(null);break;case"object":break;default:n(`Ignoring ${i} as ${u.slice(0,R+1).join(".")} is ${JSON.stringify(j)}`);return}O=j}if(typeof O=="object"&&O!==null)try{O[v]=o}catch(R){n(`Ignoring ${i} as ${u.join(".")} is ${JSON.stringify(O)}`)}else n(`Ignoring ${i} as ${u.join(".")} is ${JSON.stringify(O)}`)}t.addToValueTree=l;function L(r,i){const o=i.split(".");E(r,o)}t.removeFromValueTree=L;function E(r,i){const o=i.shift();if(i.length===0){delete r[o];return}if(Object.keys(r).indexOf(o)!==-1){const n=r[o];typeof n=="object"&&!Array.isArray(n)&&(E(n,i),Object.keys(n).length===0&&delete r[o])}}function p(r,i,o){function n(O,R){let N=O;for(const j of R){if(typeof N!="object"||N===null)return;N=N[j]}return N}const u=i.split("."),v=n(r,u);return typeof v=="undefined"?o:v}t.getConfigurationValue=p;function S(r,i,o){Object.keys(i).forEach(n=>{n!=="__proto__"&&(n in r?M.isObject(r[n])&&M.isObject(i[n])?S(r[n],i[n],o):o&&(r[n]=i[n]):r[n]=i[n])})}t.merge=S;function k(){const r=b.Registry.as(_.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}t.getConfigurationKeys=k;function a(){const r=Object.create(null),i=b.Registry.as(_.Extensions.Configuration).getConfigurationProperties();for(let o in i){let n=i[o].default;l(r,o,n,u=>console.error(`Conflict in default settings: ${u}`))}return r}t.getDefaultValues=a;function s(r){return`[${r}]`}t.keyFromOverrideIdentifier=s;function e(r,i,o){const n=r.inspect(i),u=r.inspect(o);return typeof n.userValue!="undefined"||typeof n.workspaceValue!="undefined"||typeof n.workspaceFolderValue!="undefined"?n.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:n.defaultValue}t.getMigratedSettingValue=e}),define(Q[104],Y([0,1,57,43,19,9,18,10,30,27,25,2,8]),function(q,t,y,M,D,b,A,_,m,g,T,f,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class w{constructor(e={},r=[],i=[]){this._contents=e,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?g.getConfigurationValue(this.contents,e):this.contents}getOverrideValue(e,r){const i=this.getContentsForOverrideIdentifer(r);return i?e?g.getConfigurationValue(i,e):i:void 0}getKeysForOverrideIdentifier(e){for(const r of this.overrides)if(r.identifiers.indexOf(e)!==-1)return r.keys;return[]}override(e){const r=this.getContentsForOverrideIdentifer(e);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const o of D.distinct([...Object.keys(this.contents),...Object.keys(r)])){let n=this.contents[o],u=r[o];u&&(typeof n=="object"&&typeof u=="object"?(n=A.deepClone(n),this.mergeContents(n,u)):n=u),i[o]=n}return new w(i,this.keys,this.overrides)}merge(...e){const r=A.deepClone(this.contents),i=A.deepClone(this.overrides),o=[...this.keys];for(const n of e){this.mergeContents(r,n.contents);for(const u of n.overrides){const[v]=i.filter(O=>D.equals(O.identifiers,u.identifiers));v?this.mergeContents(v.contents,u.contents):i.push(A.deepClone(u))}for(const u of n.keys)o.indexOf(u)===-1&&o.push(u)}return new w(r,o,i)}freeze(){return this.isFrozen=!0,this}mergeContents(e,r){for(const i of Object.keys(r)){if(i in e&&b.isObject(e[i])&&b.isObject(r[i])){this.mergeContents(e[i],r[i]);continue}e[i]=A.deepClone(r[i])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?A.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const r of this.overrides)if(r.identifiers.indexOf(e)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,r){this.addKey(e),g.addToValueTree(this.contents,e,r,i=>{throw new Error(i)})}removeValue(e){this.removeKey(e)&&g.removeFromValueTree(this.contents,e)}addKey(e){let r=this.keys.length;for(let i=0;i<r;i++)e.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,e)}removeKey(e){let r=this.keys.indexOf(e);return r!==-1?(this.keys.splice(r,1),!0):!1}}t.ConfigurationModel=w;class l extends w{constructor(){const e=g.getDefaultValues(),r=g.getConfigurationKeys(),i=[];for(const o of Object.keys(e))m.OVERRIDE_PROPERTY_PATTERN.test(o)&&i.push({identifiers:[m.overrideIdentifierFromKey(o).trim()],keys:Object.keys(e[o]),contents:g.toValuesTree(e[o],n=>console.error(`Conflict in default settings file: ${n}`))});super(e,r,i)}}t.DefaultConfigurationModel=l;class L{constructor(e,r){this._name=e,this._scopes=r,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get errors(){return this._parseErrors}parseContent(e){if(!b.isUndefinedOrNull(e)){const r=this.doParseContent(e);this.parseRaw(r)}}parseRaw(e){this._raw=e;const r=this.doParseRaw(e);this._configurationModel=new w(r.contents,r.keys,r.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(e){let r={},i=null,o=[],n=[],u=[];function v(R){Array.isArray(o)?o.push(R):i&&(o[i]=R)}let O={onObjectBegin:()=>{let R={};v(R),n.push(o),o=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{o=n.pop()},onArrayBegin:()=>{let R=[];v(R),n.push(o),o=R,i=null},onArrayEnd:()=>{o=n.pop()},onLiteralValue:v,onError:(R,N,j)=>{u.push({error:R,offset:N,length:j})}};if(e)try{y.visit(e,O),r=o[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return r}doParseRaw(e){if(this._scopes){const n=T.Registry.as(m.Extensions.Configuration).getConfigurationProperties();e=this.filterByScope(e,n,!0,this._scopes)}const r=g.toValuesTree(e,n=>console.error(`Conflict in settings file ${this._name}: ${n}`)),i=Object.keys(e),o=g.toOverrides(e,n=>console.error(`Conflict in settings file ${this._name}: ${n}`));return{contents:r,keys:i,overrides:o}}filterByScope(e,r,i,o){const n={};for(let u in e)if(m.OVERRIDE_PROPERTY_PATTERN.test(u)&&i)n[u]=this.filterByScope(e[u],r,!1,o);else{const v=this.getScope(u,r);(v===void 0||o.indexOf(v)!==-1)&&(n[u]=e[u])}return n}getScope(e,r){const i=r[e];return i?typeof i.scope!="undefined"?i.scope:3:void 0}}t.ConfigurationModelParser=L;class E extends f.Disposable{constructor(e,r,i,o){super();this.userSettingsResource=e,this.scopes=r,this.fileService=o,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new L(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(I.Event.filter(this.fileService.onDidFilesChange,n=>n.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(e.value.toString()||"{}"),this.parser.configurationModel}catch(e){return new w}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}t.UserSettings=E;class p{constructor(e,r,i=new w,o=new w,n=new M.ResourceMap,u=new w,v=new M.ResourceMap,O=!0){this._defaultConfiguration=e,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=o,this._folderConfigurations=n,this._memoryConfiguration=u,this._memoryConfigurationByResource=v,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(e,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(e)}updateValue(e,r,i={}){let o;i.resource?(o=this._memoryConfigurationByResource.get(i.resource),o||(o=new w,this._memoryConfigurationByResource.set(i.resource,o))):o=this._memoryConfiguration,r===void 0?o.removeValue(e):o.setValue(e,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,r,i){const o=this.getConsolidateConfigurationModel(r,i),n=this.getFolderConfigurationModelForResource(r.resource,i),u=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,v=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),O=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),R=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),N=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),j=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,H=n?r.overrideIdentifier?n.freeze().override(r.overrideIdentifier).getValue(e):n.freeze().getValue(e):void 0,Z=r.overrideIdentifier?u.override(r.overrideIdentifier).getValue(e):u.getValue(e),oe=o.getValue(e),ne=D.distinct(D.flatten(o.overrides.map(ee=>ee.identifiers))).filter(ee=>o.getOverrideValue(e,ee)!==void 0);return{defaultValue:v,userValue:O,userLocalValue:R,userRemoteValue:N,workspaceValue:j,workspaceFolderValue:H,memoryValue:Z,value:oe,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,userRemote:N!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,workspace:j!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,workspaceFolder:H!==void 0?{value:n==null?void 0:n.freeze().getValue(e),override:r.overrideIdentifier?n==null?void 0:n.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,memory:Z!==void 0?{value:u.getValue(e),override:r.overrideIdentifier?u.getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ne.length?ne:void 0}}keys(e){const r=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,r){this._folderConfigurations.set(e,r),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,r){const i=r.filter(o=>m.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const n=m.overrideIdentifierFromKey(o),u=this._defaultConfiguration.getKeysForOverrideIdentifier(n),v=e.getKeysForOverrideIdentifier(n),O=[...v.filter(R=>u.indexOf(R)===-1),...u.filter(R=>v.indexOf(R)===-1),...u.filter(R=>!A.equals(this._defaultConfiguration.override(n).getValue(R),e.override(n).getValue(R)))];return[n,O]});return this.updateDefaultConfiguration(e),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(e){const{added:r,updated:i,removed:o,overrides:n}=g.compare(this.localUserConfiguration,e),u=[...r,...i,...o];return u.length&&this.updateLocalUserConfiguration(e),{keys:u,overrides:n}}compareAndUpdateRemoteUserConfiguration(e){const{added:r,updated:i,removed:o,overrides:n}=g.compare(this.remoteUserConfiguration,e);let u=[...r,...i,...o];return u.length&&this.updateRemoteUserConfiguration(e),{keys:u,overrides:n}}compareAndUpdateWorkspaceConfiguration(e){const{added:r,updated:i,removed:o,overrides:n}=g.compare(this.workspaceConfiguration,e);let u=[...r,...i,...o];return u.length&&this.updateWorkspaceConfiguration(e),{keys:u,overrides:n}}compareAndUpdateFolderConfiguration(e,r){const i=this.folderConfigurations.get(e),{added:o,updated:n,removed:u,overrides:v}=g.compare(i,r);let O=[...o,...n,...u];return(O.length||!i)&&this.updateFolderConfiguration(e,r),{keys:O,overrides:v}}compareAndDeleteFolderConfiguration(e){const r=this.folderConfigurations.get(e);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:i,updated:o,removed:n,overrides:u}=g.compare(r,void 0);return{keys:[...i,...o,...n],overrides:u}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,r){let i=this.getConsolidatedConfigurationModelForResource(e,r);return e.overrideIdentifier?i.override(e.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:e},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&e){const o=r.getFolder(e);o&&(i=this.getFolderConsolidatedConfiguration(o.uri)||i);const n=this._memoryConfigurationByResource.get(e);n&&(i=i.merge(n))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let r=this._foldersConsolidatedConfigurations.get(e);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(e);o?(r=i.merge(o),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(e,r)):r=i}return r}getFolderConfigurationModelForResource(e,r){if(r&&e){const i=r.getFolder(e);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,r)=>{const{contents:i,overrides:o,keys:n}=this._folderConfigurations.get(r);return e.push([r,{contents:i,overrides:o,keys:n}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>e.add(r)),this.userConfiguration.freeze().keys.forEach(r=>e.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>e.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>e.add(i))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(e).forEach(o=>r.add(o))),[...r.values()]}static parse(e){const r=this.parseConfigurationModel(e.defaults),i=this.parseConfigurationModel(e.user),o=this.parseConfigurationModel(e.workspace),n=e.folders.reduce((u,v)=>(u.set(_.URI.revive(v[0]),this.parseConfigurationModel(v[1])),u),new M.ResourceMap);return new p(r,i,new w,o,n,new w,new M.ResourceMap,!1)}static parseConfigurationModel(e){return new w(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=p;function S(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,r=new Map;for(const o of s)o.keys.forEach(n=>e.add(n)),o.overrides.forEach(([n,u])=>{const v=M.getOrSet(r,n,new Set);u.forEach(O=>v.add(O))});const i=[];return r.forEach((o,n)=>i.push([n,[...o.values()]])),{keys:[...e.values()],overrides:i}}t.mergeChanges=S;class k{constructor(e,r,i,o){this.change=e,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=o,this._previousConfiguration=void 0;const n=new Set;e.keys.forEach(v=>n.add(v)),e.overrides.forEach(([,v])=>v.forEach(O=>n.add(O))),this.affectedKeys=[...n.values()];const u=new w;this.affectedKeys.forEach(v=>u.setValue(v,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,r){var i;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(r){const o=this.previousConfiguration?this.previousConfiguration.getValue(e,r,(i=this.previous)===null||i===void 0?void 0:i.workspace):void 0,n=this.currentConfiguraiton.getValue(e,r,this.currentWorkspace);return!A.equals(o,n)}return!0}return!1}doesAffectedKeysTreeContains(e,r){let i=g.toValuesTree({[r]:!0},()=>{}),o;for(;typeof i=="object"&&(o=Object.keys(i)[0]);){if(e=e[o],!e)return!1;i=i[o]}return!0}}t.ConfigurationChangeEvent=k;class a extends k{constructor(e,r,i,o){super({keys:e.allKeys(),overrides:[]},void 0,e,r);this.source=i,this.sourceConfig=o}}t.AllKeysConfigurationChangeEvent=a}),define(Q[105],Y([0,1,25,30,2,27,104,8,11,21]),function(q,t,y,M,D,b,A,_,m,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class T extends D.Disposable{constructor(I,w){super();this.settingsResource=I,this._onDidChangeConfiguration=this._register(new _.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new A.UserSettings(this.settingsResource,void 0,g.extUriBiasedIgnorePathCase,w)),this.configuration=new A.Configuration(new A.DefaultConfigurationModel,new A.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new m.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(y.Registry.as(M.Extensions.Configuration).onDidUpdateConfiguration(l=>this.onDidDefaultConfigurationChange(l))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const I=await this.userConfiguration.loadConfiguration();this.configuration=new A.Configuration(new A.DefaultConfigurationModel,I)}getConfigurationData(){return this.configuration.toData()}getValue(I,w){const l=typeof I=="string"?I:void 0,L=b.isConfigurationOverrides(I)?I:b.isConfigurationOverrides(w)?w:{};return this.configuration.getValue(l,L,void 0)}updateValue(I,w,l,L){return Promise.reject(new Error("not supported"))}inspect(I){return this.configuration.inspect(I,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const I=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(I)}onDidChangeUserConfiguration(I){const w=this.configuration.toData(),l=this.configuration.compareAndUpdateLocalUserConfiguration(I);this.trigger(l,w,1)}onDidDefaultConfigurationChange(I){const w=this.configuration.toData(),l=this.configuration.compareAndUpdateDefaultConfiguration(new A.DefaultConfigurationModel,I);this.trigger(l,w,6)}trigger(I,w,l){const L=new A.ConfigurationChangeEvent(I,{data:w},this.configuration);L.source=l,L.sourceConfig=this.getTargetConfiguration(l),this._onDidChangeConfiguration.fire(L)}getTargetConfiguration(I){switch(I){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=T}),define(Q[52],Y([0,1,83,6,30,25,16]),function(q,t,y,M,D,b,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=M.createDecorator("requestService");function _(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}t.isSuccess=_;function m(f){return f.res.statusCode===204}async function g(f){if(!_(f))throw new Error("Server returned "+f.res.statusCode);return m(f)?null:(await A.streamToBuffer(f.stream)).toString()}t.asText=g;async function T(f){if(!_(f))throw new Error("Server returned "+f.res.statusCode);if(m(f))return null;const w=(await A.streamToBuffer(f.stream)).toString();try{return JSON.parse(w)}catch(l){throw l.message+=`:
`+w,l}}t.asJson=T,b.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:y.localize(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:y.localize(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:y.localize(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:y.localize(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[y.localize(4,null),y.localize(5,null),y.localize(6,null)],default:"override",description:y.localize(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:y.localize(8,null)}}})}),define(Q[106],Y([0,1,107,9]),function(q,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function D(A){return A.protocol==="http:"?process.env.HTTP_PROXY||process.env.http_proxy||null:A.protocol==="https:"&&(process.env.HTTPS_PROXY||process.env.https_proxy||process.env.HTTP_PROXY||process.env.http_proxy)||null}async function b(A,_={}){const m=y.parse(A),g=_.proxyUrl||D(m);if(!g)return null;const T=y.parse(g);if(!/^https?:$/.test(T.protocol||""))return null;const f={host:T.hostname||"",port:T.port||(T.protocol==="https"?"443":"80"),auth:T.auth,rejectUnauthorized:M.isBoolean(_.strictSSL)?_.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((I,w)=>{q(["http-proxy-agent"],I,w)}))(f):new(await new Promise((I,w)=>{q(["https-proxy-agent"],I,w)}))(f)}t.getProxyAgent=b}),define(Q[108],Y([0,1,32,16]),function(q,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function D(b,A,_){let m=_&&_.get("storage.serviceMachineId",0)||null;if(m)return m;try{const T=(await A.readFile(b.serviceMachineIdResource)).value.toString();m=y.isUUID(T)?T:null}catch(g){m=null}if(!m){m=y.generateUuid();try{await A.writeFile(b.serviceMachineIdResource,M.VSBuffer.fromString(m))}catch(g){}}return _&&_.store("storage.serviceMachineId",m,0,1),m}t.getServiceMachineId=D}),define(Q[109],Y([0,1,6]),function(q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IStateService=void 0,t.IStateService=y.createDecorator("stateService")}),define(Q[110],Y([0,1,3,22,20,12,9,14]),function(q,t,y,M,D,b,A,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.FileStorage=void 0;class m{constructor(f,I){this.dbPath=f,this.onError=I,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const f=await this.loadAsync();this._database||(this._database=f)}}loadSync(){try{return this.lastFlushedSerializedDatabase=M.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(f){return f.code!=="ENOENT"&&this.onError(f),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await b.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(f){return f.code!=="ENOENT"&&this.onError(f),{}}}getItem(f,I){const w=this.database[f];return A.isUndefinedOrNull(w)?I:w}setItem(f,I){if(A.isUndefinedOrNull(I))return this.removeItem(f);(typeof I=="string"||typeof I=="number"||typeof I=="boolean")&&this.database[f]===I||(this.database[f]=I,this.saveSync())}removeItem(f){A.isUndefined(this.database[f])||(this.database[f]=void 0,this.saveSync())}saveSync(){const f=JSON.stringify(this.database,null,4);if(f!==this.lastFlushedSerializedDatabase)try{b.writeFileSync(this.dbPath,f),this.lastFlushedSerializedDatabase=f}catch(I){this.onError(I)}}}t.FileStorage=m;let g=class We{constructor(f,I){this.fileStorage=new m(y.join(f.userDataPath,We.STATE_FILE),w=>I.error(w))}init(){return this.fileStorage.init()}getItem(f,I){return this.fileStorage.getItem(f,I)}setItem(f,I){this.fileStorage.setItem(f,I)}removeItem(f){this.fileStorage.removeItem(f)}};g.STATE_FILE="storage.json",g=le([fe(0,D.INativeEnvironmentService),fe(1,_.ILogService)],g),t.StateService=g}),define(Q[111],Y([0,1,6,8,2,9]),function(q,t,y,M,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const A="__$__targetStorageMarker";t.IStorageService=y.createDecorator("storageService");var _;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(_=t.WillSaveStateReason||(t.WillSaveStateReason={}));var m;(function(w){w[w.GLOBAL=0]="GLOBAL",w[w.WORKSPACE=1]="WORKSPACE"})(m=t.StorageScope||(t.StorageScope={}));var g;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(g=t.StorageTarget||(t.StorageTarget={}));class T extends D.Disposable{constructor(){super(...arguments);this._onDidChangeValue=this._register(new M.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new M.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new M.Emitter),this.onWillSaveState=this._onWillSaveState.event,this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}emitDidChangeValue(l,L){L===A?(l===0?this._globalKeyTargets=void 0:l===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:l})):this._onDidChangeValue.fire({scope:l,key:L,target:this.getKeyTargets(l)[L]})}emitWillSaveState(l){this._onWillSaveState.fire({reason:l})}store(l,L,E,p){if(b.isUndefinedOrNull(L)){this.remove(l,E);return}this.withPausedEmitters(()=>{this.updateKeyTarget(l,E,p),this.doStore(l,L,E)})}remove(l,L){this.withPausedEmitters(()=>{this.updateKeyTarget(l,L,void 0),this.doRemove(l,L)})}withPausedEmitters(l){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{l()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(l,L){const E=[],p=this.getKeyTargets(l);for(const S of Object.keys(p))p[S]===L&&E.push(S);return E}updateKeyTarget(l,L,E){const p=this.getKeyTargets(L);typeof E=="number"?p[l]!==E&&(p[l]=E,this.doStore(A,JSON.stringify(p),L)):typeof p[l]=="number"&&(delete p[l],this.doStore(A,JSON.stringify(p),L))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(l){return l===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(l){const L=this.get(A,l);if(L)try{return JSON.parse(L)}catch(E){}return Object.create(null)}isNew(l){return this.getBoolean(t.IS_NEW_KEY,l)===!0}flush(){return this._onWillSaveState.fire({reason:_.NONE}),this.doFlush()}}t.AbstractStorageService=T;class f extends T{constructor(){super(...arguments);this.globalCache=new Map,this.workspaceCache=new Map}getCache(l){return l===0?this.globalCache:this.workspaceCache}get(l,L,E){const p=this.getCache(L).get(l);return b.isUndefinedOrNull(p)?E:p}getBoolean(l,L,E){const p=this.getCache(L).get(l);return b.isUndefinedOrNull(p)?E:p==="true"}getNumber(l,L,E){const p=this.getCache(L).get(l);return b.isUndefinedOrNull(p)?E:parseInt(p,10)}doStore(l,L,E){const p=String(L);this.getCache(E).get(l)!==p&&(this.getCache(E).set(l,p),this.emitDidChangeValue(E,l))}doRemove(l,L){!this.getCache(L).delete(l)||this.emitDidChangeValue(L,l)}logStorage(){I(this.globalCache,this.workspaceCache,"inMemory","inMemory")}async migrate(l){}async doFlush(){}async close(){}}t.InMemoryStorageService=f;async function I(w,l,L,E){const p=i=>{try{return JSON.parse(i)}catch(o){return i}},S=new Map,k=new Map;w.forEach((i,o)=>{S.set(o,i),k.set(o,p(i))});const a=new Map,s=new Map;l.forEach((i,o)=>{a.set(o,i),s.set(o,p(i))}),console.group(`Storage: Global (path: ${L})`);let e=[];S.forEach((i,o)=>{e.push({key:o,value:i})}),console.table(e),console.groupEnd(),console.log(k),console.group(`Storage: Workspace (path: ${E})`);let r=[];a.forEach((i,o)=>{r.push({key:o,value:i})}),console.table(r),console.groupEnd(),console.log(s)}t.logStorage=I}),define(Q[112],Y([0,1,13,66,32,10]),function(q,t,y,M,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveCommonProperties=void 0;async function A(m,g,T,f,I,w,l,L,E){const p=Object.create(null);p["common.machineId"]=w,p.sessionID=D.generateUuid()+Date.now(),p.commitHash=f,p.version=I,p["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=y.PlatformToString(y.platform),p["common.nodePlatform"]=M.platform,p["common.nodeArch"]=T,p["common.product"]=E||"desktop";const S=_(l||[]);S&&(p["common.msftInternal"]=S);let k=0;const a=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>k++,enumerable:!0}}),y.isLinuxSnap&&(p["common.snap"]="true");try{const s=await m.readFile(b.URI.file(L));p["common.source"]=s.value.toString().slice(0,30)}catch(s){}return p}t.resolveCommonProperties=A;function _(m){const g=M.env.USERDNSDOMAIN;if(!g)return!1;const T=g.toLowerCase();return m.some(f=>T===f)}}),define(Q[40],Y([0,1,6]),function(q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ITelemetryService=void 0,t.ITelemetryService=y.createDecorator("telemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Q[113],Y([0,1,15,23,26,18,40,52,47,20,29,14,24,10,39,111,108,6,21]),function(q,t,y,M,D,b,A,_,m,g,T,f,I,w,l,L,E,p,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var k;(function(C){C[C.None=0]="None",C[C.IncludeVersions=1]="IncludeVersions",C[C.IncludeFiles=2]="IncludeFiles",C[C.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",C[C.IncludeSharedAccounts=8]="IncludeSharedAccounts",C[C.IncludeVersionProperties=16]="IncludeVersionProperties",C[C.ExcludeNonValidated=32]="ExcludeNonValidated",C[C.IncludeInstallationTargets=64]="IncludeInstallationTargets",C[C.IncludeAssetUri=128]="IncludeAssetUri",C[C.IncludeStatistics=256]="IncludeStatistics",C[C.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",C[C.Unpublished=4096]="Unpublished"})(k||(k={}));function a(...C){return String(C.reduce((c,h)=>c|h,0))}var s;(function(C){C[C.Tag=1]="Tag",C[C.ExtensionId=4]="ExtensionId",C[C.Category=5]="Category",C[C.ExtensionName=7]="ExtensionName",C[C.Target=8]="Target",C[C.Featured=9]="Featured",C[C.SearchText=10]="SearchText",C[C.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:k.None,criteria:[],assetTypes:[]};class n{constructor(c=o){this.state=c}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(c,h=this.state.pageSize){return new n(Object.assign(Object.assign({},this.state),{pageNumber:c,pageSize:h}))}withFilter(c,...h){const d=[...this.state.criteria,...h.length?h.map(P=>({filterType:c,value:P})):[{filterType:c}]];return new n(Object.assign(Object.assign({},this.state),{criteria:d}))}withSortBy(c){return new n(Object.assign(Object.assign({},this.state),{sortBy:c}))}withSortOrder(c){return new n(Object.assign(Object.assign({},this.state),{sortOrder:c}))}withFlags(...c){return new n(Object.assign(Object.assign({},this.state),{flags:c.reduce((h,d)=>h|d,0)}))}withAssetTypes(...c){return new n(Object.assign(Object.assign({},this.state),{assetTypes:c}))}get raw(){const{criteria:c,pageNumber:h,pageSize:d,sortBy:P,sortOrder:F,flags:B,assetTypes:V}=this.state;return{filters:[{criteria:c,pageNumber:h,pageSize:d,sortBy:P,sortOrder:F}],assetTypes:V,flags:B}}get searchText(){const c=this.state.criteria.filter(h=>h.filterType===s.SearchText)[0];return c&&c.value?c.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(c=>String(c.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function u(C,c){const h=(C||[]).filter(d=>d.statisticName===c)[0];return h?h.value:0}function v(C){const c="Microsoft.VisualStudio.Code.Translation.";return C.files.filter(d=>d.assetType.indexOf(c)===0).reduce((d,P)=>{const F=j(C,P.assetType);return F&&d.push([P.assetType.substring(c.length),F]),d},[])}function O(C){if(C.properties){const c=C.properties.filter(P=>P.key===e.Repository),h=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),d=c.filter(P=>h.test(P.value))[0];return d?{uri:d.value,fallbackUri:d.value}:null}return j(C,e.Repository)}function R(C){return{uri:`${C.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${C.fallbackAssetUri}/${e.VSIX}`}}function N(C){const c=j(C,e.Icon);if(c)return c;const h=M.DefaultIconPath;return{uri:h,fallbackUri:h}}function j(C,c){return C.files.filter(d=>d.assetType===c)[0]?{uri:`${C.assetUri}/${c}`,fallbackUri:`${C.fallbackAssetUri}/${c}`}:null}function H(C,c){const h=C.properties?C.properties.filter(P=>P.key===c):[],d=h.length>0&&h[0].value;return d?d.split(",").map(P=>D.adoptToGalleryExtensionId(P)):[]}function Z(C){const c=C.properties?C.properties.filter(h=>h.key===r.Engine):[];return c.length>0&&c[0].value||""}function oe(C){const c=C.properties?C.properties.filter(d=>d.key===r.LocalizedLanguages):[],h=c.length>0&&c[0].value||"";return h?h.split(","):[]}function ne(C){return C.indexOf("preview")!==-1}function ee(C){const c=C.properties?C.properties.find(h=>h.key===r.WebExtension):void 0;return!!c&&c.value==="true"}function ce(C){return C.files.some(c=>c.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?S.joinPath(w.URI.parse(C.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function U(C,c,h,d,P){const F={manifest:j(c,e.Manifest),readme:j(c,e.Details),changelog:j(c,e.Changelog),license:j(c,e.License),repository:O(c),download:R(c),icon:N(c),coreTranslations:v(c)};return{identifier:{id:D.getGalleryExtensionId(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},name:C.extensionName,version:c.version,date:c.lastUpdated,displayName:C.displayName,publisherId:C.publisher.publisherId,publisher:C.publisher.publisherName,publisherDisplayName:C.publisher.displayName,description:C.shortDescription||"",installCount:u(C.statistics,"install"),rating:u(C.statistics,"averagerating"),ratingCount:u(C.statistics,"ratingcount"),assetUri:w.URI.parse(c.assetUri),webResource:ce(c),assetTypes:c.files.map(({assetType:B})=>B),assets:F,properties:{dependencies:H(c,r.Dependency),extensionPack:H(c,r.ExtensionPack),engine:Z(c),localizedLanguages:oe(c),webExtension:ee(c)},telemetryData:{index:(d.pageNumber-1)*d.pageSize+h,searchText:d.searchText,querySource:P},preview:ne(C.flags)}}let W=class{constructor(c,h,d,P,F,B,V){this.requestService=c,this.logService=h,this.environmentService=d,this.telemetryService=P,this.fileService=F,this.productService=B;const $=B.extensionsGallery;this.extensionsGalleryUrl=$&&$.serviceUrl,this.extensionsControlUrl=$&&$.controlUrl,this.commonHeadersPromise=X(B.version,this.environmentService,this.fileService,V)}api(c=""){return`${this.extensionsGalleryUrl}${c}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(c,h){const d=[];let{total:P,firstPage:F,getPage:B}=await this.query({names:c,pageSize:c.length},h);d.push(...F);for(let V=1;d.length<P&&(F=await B(V,h),F.length);V++)d.push(...F);return d}async getCompatibleExtension(c,h){const d=await this.getCompatibleExtensionByEngine(c,h);return(d==null?void 0:d.properties.webExtension)?d.webResource?d:null:d}async getCompatibleExtensionByEngine(c,h){const d=M.isIExtensionIdentifier(c)?null:c;if(d&&d.properties.engine&&m.isEngineValid(d.properties.engine,this.productService.version))return d;const{id:P,uuid:F}=d?d.identifier:c;let B=new n().withFlags(k.IncludeAssetUri,k.IncludeStatistics,k.IncludeFiles,k.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");F?B=B.withFilter(s.ExtensionId,F):B=B.withFilter(s.ExtensionName,P);const{galleryExtensions:V}=await this.queryGallery(B,T.CancellationToken.None),[$]=V;if(!$||!$.versions.length)return null;if(h){const J=$.versions.filter(te=>te.version===h)[0];if(J){const te=U($,J,0,B);if(te.properties.engine&&m.isEngineValid(te.properties.engine,this.productService.version))return te}return null}const K=await this.getLastValidExtensionVersion($,$.versions);return K?U($,K,0,B):null}async query(c,h){const d=T.CancellationToken.isCancellationToken(c)?{}:c,P=T.CancellationToken.isCancellationToken(c)?c:h;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let F=d.text||"";const B=b.getOrDefault(d,re=>re.pageSize,50);let V=new n().withFlags(k.IncludeLatestVersionOnly,k.IncludeAssetUri,k.IncludeStatistics,k.IncludeFiles,k.IncludeVersionProperties).withPage(1,B).withFilter(s.Target,"Microsoft.VisualStudio.Code");F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,he,de)=>(V=V.withFilter(s.Category,de||he),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,he,de)=>(V=V.withFilter(s.Tag,de||he),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(V=V.withFilter(s.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),V=V.withFilter(s.SearchText,F)),V=V.withSortBy(0)):d.ids?V=V.withFilter(s.ExtensionId,...d.ids):d.names?V=V.withFilter(s.ExtensionName,...d.names):V=V.withSortBy(4),typeof d.sortBy=="number"&&(V=V.withSortBy(d.sortBy)),typeof d.sortOrder=="number"&&(V=V.withSortOrder(d.sortOrder));const{galleryExtensions:$,total:K}=await this.queryGallery(V,P),J=$.map((re,he)=>U(re,re.versions[0],he,V,d.source)),te=async(re,he)=>{if(he.isCancellationRequested)throw y.canceled();const de=V.withPage(re+1),{galleryExtensions:Se}=await this.queryGallery(de,he);return Se.map((Oe,Te)=>U(Oe,Oe.versions[0],Te,de,d.source))};return{firstPage:J,total:K,pageSize:V.pageSize,getPage:te}}async queryGallery(c,h){if(!this.isEnabled())throw new Error("No extension gallery service configured.");c=c.withFlags(c.flags,k.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,a(k.Unpublished));const d=await this.commonHeadersPromise,P=JSON.stringify(c.raw),F=Object.assign(Object.assign({},d),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(P.length)}),B=new Date().getTime();let V,$,K=0;try{if(V=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:P,headers:F},h),V.res.statusCode&&V.res.statusCode>=400&&V.res.statusCode<500)return{galleryExtensions:[],total:K};const J=await _.asJson(V);if(J){const te=J.results[0],re=te.extensions,he=te.resultMetadata&&te.resultMetadata.filter(de=>de.metadataType==="ResultCount")[0];return K=he&&he.metadataItems.filter(de=>de.name==="TotalCount")[0].count||0,{galleryExtensions:re,total:K}}return{galleryExtensions:[],total:K}}catch(J){throw $=J,J}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},c.telemetryData),{requestBodySize:String(P.length),duration:new Date().getTime()-B,success:!!V&&_.isSuccess(V),responseBodySize:V==null?void 0:V.res.headers["Content-Length"],statusCode:V?String(V.res.statusCode):void 0,errorCode:$?y.isPromiseCanceledError($)?"canceled":y.getErrorMessage($).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(K)}))}}async reportStatistic(c,h,d,P){if(!!this.isEnabled()){const F=await this.commonHeadersPromise,B=Object.assign(Object.assign({},F),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${c}/extensions/${h}/${d}/stats?statType=${P}`),headers:B},T.CancellationToken.None)}catch(V){}}}async download(c,h,d){this.logService.trace("ExtensionGalleryService#download",c.identifier.id);const P=D.getGalleryExtensionTelemetryData(c),F=new Date().getTime(),B=J=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},P),{duration:J})),V=d===1?"install":d===2?"update":"",$=V?{uri:`${c.assets.download.uri}&${V}=true`,fallbackUri:`${c.assets.download.fallbackUri}?${V}=true`}:c.assets.download,K=await this.getAsset($);await this.fileService.writeFile(h,K.stream),B(new Date().getTime()-F)}async getReadme(c,h){if(c.assets.readme){const d=await this.getAsset(c.assets.readme,{},h);return await _.asText(d)||""}return""}async getManifest(c,h){if(c.assets.manifest){const d=await this.getAsset(c.assets.manifest,{},h),P=await _.asText(d);return P?JSON.parse(P):null}return null}async getCoreTranslation(c,h){const d=c.assets.coreTranslations.filter(P=>P[0]===h.toUpperCase())[0];if(d){const P=await this.getAsset(d[1]),F=await _.asText(P);return F?JSON.parse(F):null}return null}async getChangelog(c,h){if(c.assets.changelog){const d=await this.getAsset(c.assets.changelog,{},h);return await _.asText(d)||""}return""}async getAllVersions(c,h){let d=new n().withFlags(k.IncludeVersions,k.IncludeFiles,k.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");c.identifier.uuid?d=d.withFilter(s.ExtensionId,c.identifier.uuid):d=d.withFilter(s.ExtensionName,c.identifier.id);const P=[],{galleryExtensions:F}=await this.queryGallery(d,T.CancellationToken.None);return F.length&&(h?await Promise.all(F[0].versions.map(async B=>{let V;try{V=await this.getEngine(B)}catch($){}V&&m.isEngineValid(V,this.productService.version)&&P.push({version:B.version,date:B.lastUpdated})})):P.push(...F[0].versions.map(B=>({version:B.version,date:B.lastUpdated})))),P}async getAsset(c,h={},d=T.CancellationToken.None){const P=await this.commonHeadersPromise,F={type:"GET"},B=Object.assign(Object.assign({},P),h.headers||{});h=Object.assign(Object.assign(Object.assign({},h),F),{headers:B});const V=c.uri,$=c.fallbackUri,K=Object.assign(Object.assign({},h),{url:V});try{const J=await this.requestService.request(K,d);if(J.res.statusCode===200)return J;const te=await _.asText(J);throw new Error(`Expected 200, got back ${J.res.statusCode} instead.

${te}`)}catch(J){if(y.isPromiseCanceledError(J))throw J;const te=y.getErrorMessage(J);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:V,message:te});const re=Object.assign(Object.assign({},h),{url:$});return this.requestService.request(re,d)}}async getLastValidExtensionVersion(c,h){const d=this.getLastValidExtensionVersionFromProperties(c,h);return d||this.getLastValidExtensionVersionRecursively(c,h)}getLastValidExtensionVersionFromProperties(c,h){for(const d of h){const P=Z(d);if(!P)return null;if(m.isEngineValid(P,this.productService.version))return d}return null}async getEngine(c){const h=Z(c);if(h)return h;const d=j(c,e.Manifest);if(!d)throw new Error("Manifest was not found");const P={"Accept-Encoding":"gzip"},F=await this.getAsset(d,{headers:P}),B=await _.asJson(F);if(B)return B.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(c,h){if(!h.length)return null;const d=h[0],P=await this.getEngine(d);return m.isEngineValid(P,this.productService.version)?(d.properties=d.properties||[],d.properties.push({key:r.Engine,value:P}),d):this.getLastValidExtensionVersionRecursively(c,h.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const c=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},T.CancellationToken.None);if(c.res.statusCode!==200)throw new Error("Could not get extensions report.");const h=await _.asJson(c),d=new Map;if(h)for(const P of h.malicious){const F=d.get(P)||{id:{id:P},malicious:!0,slow:!1};F.malicious=!0,d.set(P,F)}return[...d.values()]}};W=le([fe(0,_.IRequestService),fe(1,f.ILogService),fe(2,g.IEnvironmentService),fe(3,A.ITelemetryService),fe(4,I.IFileService),fe(5,l.IProductService),fe(6,p.optional(L.IStorageService))],W),t.ExtensionGalleryService=W;async function X(C,c,h,d){const P={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C}`},F=await E.getServiceMachineId(c,h,d);return P["X-Market-User-Id"]=F,P}t.resolveMarketplaceHeaders=X}),define(Q[114],Y([0,1,41,84,17,6,27,30,2,18,25]),function(q,t,y,M,D,b,A,_,m,g,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let f=class{constructor(l,L){this._configurationService=L,this._experimentProperties={},this._disposables=new m.DisposableStore,this._cleanupPatterns=[],this._appender=l.appender,this._commonProperties=l.commonProperties||Promise.resolve({}),this._piiPaths=l.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!l.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let E of this._piiPaths)this._cleanupPatterns.push(new RegExp(D.escapeRegExpCharacters(E),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(E=>{const p=/^[a-f0-9]+$/i.test(E["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!p})}))}setExperimentProperty(l,L){this._experimentProperties[l]=L}setEnabled(l){this._enabled=l}_updateUserOptIn(){var l;const L=(l=this._configurationService)===null||l===void 0?void 0:l.getValue(I);this._userOptIn=L?L.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const l=await this._commonProperties;let L=l.sessionID,E=l["common.instanceId"],p=l["common.machineId"],S=l["common.msftInternal"];return{sessionId:L,instanceId:E,machineId:p,msftInternal:S}}dispose(){this._disposables.dispose()}publicLog(l,L,E){return this.isOptedIn?this._commonProperties.then(p=>{L=g.mixin(L,p),L=g.mixin(L,this._experimentProperties),L=g.cloneAndChange(L,S=>{if(typeof S=="string")return this._cleanupInfo(S,E)}),this._appender.log(l,L)},p=>{console.error(p)}):Promise.resolve(void 0)}publicLog2(l,L,E){return this.publicLog(l,L,E)}publicLogError(l,L){return this.sendErrorTelemetry?this.publicLog(l,L,!0):Promise.resolve(void 0)}publicLogError2(l,L){return this.publicLogError(l,L)}_cleanupInfo(l,L){let E=l;if(L){const p=[];for(let s of this._cleanupPatterns)for(;;){const e=s.exec(l);if(!e)break;p.push([e.index,s.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,k=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(E="";;){const s=k.exec(l);if(!s)break;!S.test(s[0])&&p.every(([e,r])=>s.index<e||s.index>=r)&&(E+=l.substring(a,s.index)+"<REDACTED: user-file-path>",a=k.lastIndex)}a<l.length&&(E+=l.substr(a))}for(let p of this._cleanupPatterns)E=E.replace(p,"");return E}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=le([fe(1,b.optional(A.IConfigurationService))],f),t.TelemetryService=f;const I="telemetry";T.Registry.as(_.Extensions.Configuration).registerConfiguration({id:I,order:110,type:"object",title:M.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:y.default.privacyStatementUrl?M.localize(2,null,y.default.privacyStatementUrl):M.localize(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(Q[53],Y([0,1,27,18,9]),function(q,t,y,M,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(I,w){return Promise.resolve(void 0)}publicLog2(I,w){return this.publicLog(I,w)}publicLogError(I,w){return Promise.resolve(void 0)}publicLogError2(I,w){return this.publicLogError(I,w)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId"})}};function b(...I){return{log:(w,l)=>I.forEach(L=>L.log(w,l)),flush:()=>Promise.all(I.map(w=>w.flush()))}}t.combinedAppender=b,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function A(I,w){return w.onDidChangeConfiguration(l=>{l.source!==6&&I.publicLog2("updateConfiguration",{configurationSource:y.ConfigurationTargetToString(l.source),configurationKeys:T(l.sourceConfig)})})}t.configurationTelemetry=A;function _(I){const w=Object.create(null),l=Object.create(null),L=Object.create(null);g(I,L);for(let E in L){E=E.length>150?E.substr(E.length-149):E;const p=L[E];typeof p=="number"?l[E]=p:typeof p=="boolean"?l[E]=p?1:0:typeof p=="string"?w[E]=p.substring(0,1023):typeof p!="undefined"&&p!==null&&(w[E]=p)}return{properties:w,measurements:l}}t.validateTelemetryData=_;function m(I){if(!I)return"none";let w="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(L=>{I.indexOf(`${L}+`)===0&&(w=L)}),w}t.cleanRemoteAuthority=m;function g(I,w,l=0,L){if(!!I)for(let E of Object.getOwnPropertyNames(I)){const p=I[E],S=L?L+E:E;Array.isArray(p)?w[S]=M.safeStringify(p):p instanceof Date?w[S]=p.toISOString():D.isObject(p)?l<2?g(p,w,l+1,S+"."):w[S]=M.safeStringify(p):w[S]=p}}function T(I){if(!I)return[];const w=[];return f(w,"",I),w}function f(I,w,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(L=>f(I,w?`${w}.${L}`:L,l[L])):I.push(w)}}),define(Q[115],Y([0,1,15,18,53]),function(q,t,y,M,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function b(_){const m=await new Promise((T,f)=>{q(["applicationinsights"],T,f)});let g;return m.defaultClient?(g=new m.TelemetryClient(_),g.channel.setUseDiskRetryCaching(!0)):(m.setup(_).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),g=m.defaultClient),_.indexOf("AIF-")===0&&(g.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),g}class A{constructor(m,g,T){this._eventPrefix=m,this._defaultData=g,this._defaultData||(this._defaultData=Object.create(null)),typeof T=="function"?this._aiClient=T():this._aiClient=T,this._asyncAIClient=null}_withAIClient(m){if(!!this._aiClient){if(typeof this._aiClient!="string"){m(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=b(this._aiClient)),this._asyncAIClient.then(g=>{m(g)},g=>{y.onUnexpectedError(g),console.error(g)})}}log(m,g){!this._aiClient||(g=M.mixin(g,this._defaultData),g=D.validateTelemetryData(g),this._withAIClient(T=>T.trackEvent({name:this._eventPrefix+"/"+m,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(m=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,m(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=A}),define(Q[116],Y([0,1,12,22,3]),function(q,t,y,M,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;function b(A,_){const m=Object.create(null),g=(f,I)=>{const w=JSON.parse(f);m[I]=w};if(_){const f=y.readdirSync(_).filter(w=>{try{return M.statSync(D.join(_,w)).isDirectory()}catch(l){return!1}}),I=[];f.forEach(w=>{y.readdirSync(D.join(_,w)).filter(L=>L==="telemetry.json").length===1&&I.push(w)}),I.forEach(w=>{const l=M.readFileSync(D.join(_,w,"telemetry.json")).toString();g(l,w)})}let T=M.readFileSync(D.join(A,"telemetry-core.json")).toString();return g(T,"vscode-core"),T=M.readFileSync(D.join(A,"telemetry-extensions.json")).toString(),g(T,"vscode-extensions"),JSON.stringify(m,null,4)}t.buildTelemetryMessage=b}),define(Q[42],Y([0,1,72,3,22,11,12,128,129,9]),function(q,t,y,M,D,b,A,_,m,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class T extends Error{constructor(e,r){let i=r.message;switch(e){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=e,this.cause=r}}t.ExtractError=T;function f(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(r=>e&r).reduce((r,i)=>r+i,e&61440)}function I(s){if(s instanceof T)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new T(e,s)}function w(s,e,r,i,o,n){const u=M.dirname(e),v=M.join(i,u);if(!v.startsWith(i))return Promise.reject(new Error(y.localize(0,null,e)));const O=M.join(i,e);let R;return n.onCancellationRequested(()=>{R&&R.destroy()}),Promise.resolve(A.mkdirp(v)).then(()=>new Promise((N,j)=>{if(!n.isCancellationRequested)try{R=D.createWriteStream(O,{mode:r}),R.once("close",()=>N()),R.once("error",j),s.once("error",j),s.pipe(R)}catch(H){j(H)}}))}function l(s,e,r,i){let o=b.createCancelablePromise(()=>Promise.resolve()),n=0;return i.onCancellationRequested(()=>{o.cancel(),s.close()}),new Promise((u,v)=>{const O=new b.Sequencer,R=N=>{N.isCancellationRequested||(n++,s.readEntry())};s.once("error",v),s.once("close",()=>o.then(()=>{i.isCancellationRequested||s.entryCount===n?u():v(new T("Incomplete",new Error(y.localize(1,null,n,s.entryCount))))},v)),s.readEntry(),s.on("entry",N=>{if(!i.isCancellationRequested){if(!r.sourcePathRegex.test(N.fileName)){R(i);return}const j=N.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(j)){const oe=M.join(e,j);o=b.createCancelablePromise(ne=>A.mkdirp(oe).then(()=>R(ne)).then(void 0,v));return}const H=E(s,N),Z=f(N);o=b.createCancelablePromise(oe=>O.queue(()=>H.then(ne=>w(ne,j,Z,e,r,oe).then(()=>R(oe)))).then(null,v))}})})}function L(s,e=!1){return new Promise((r,i)=>{_.open(s,e?{lazyEntries:!0}:void 0,(o,n)=>{o?i(I(o)):r(g.assertIsDefined(n))})})}function E(s,e){return new Promise((r,i)=>{s.openReadStream(e,(o,n)=>{o?i(I(o)):r(g.assertIsDefined(n))})})}function p(s,e){return new Promise((r,i)=>{const o=new m.ZipFile;e.forEach(u=>{u.contents?o.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&o.addFile(u.localPath,u.path)}),o.end();const n=D.createWriteStream(s);o.outputStream.pipe(n),o.outputStream.once("error",i),n.once("error",i),n.once("finish",()=>r(s))})}t.zip=p;function S(s,e,r={},i){const o=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let n=L(s,!0);return r.overwrite&&(n=n.then(u=>A.rimraf(e).then(()=>u))),n.then(u=>l(u,e,{sourcePathRegex:o},i))}t.extract=S;function k(s,e){return L(s).then(r=>new Promise((i,o)=>{r.on("entry",n=>{n.fileName===e&&E(r,n).then(u=>i(u),u=>o(u))}),r.once("close",()=>o(new Error(y.localize(2,null,e))))}))}function a(s,e){return k(s,e).then(r=>new Promise((i,o)=>{const n=[];r.once("error",o),r.on("data",u=>n.push(u)),r.on("end",()=>i(Buffer.concat(n)))}))}t.buffer=a}),define(Q[117],Y([0,1,42,77]),function(q,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function D(b){return y.buffer(b,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch(_){throw new Error(M.localize(0,null))}})}t.getManifest=D}),define(Q[118],Y([0,1,38,2,12,3,14,23,26,11,10,20,85,78,39,42,13,19,7]),function(q,t,y,M,D,b,A,_,m,g,T,f,I,w,l,L,E,p,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const k="scanningSystem",a="scanningUser",s="extracting",e="deleting",r="renaming";let i=class extends M.Disposable{constructor(n,u,v,O){super();this.beforeRemovingExtension=n,this.logService=u,this.environmentService=v,this.productService=O,this._devSystemExtensionsPath=null,this.systemExtensionsPath=v.builtinExtensionsPath,this.extensionsPath=v.extensionsPath,this.uninstalledPath=b.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new g.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(n){const u=[];(n===null||n===0)&&u.push(this.scanSystemExtensions().then(null,v=>Promise.reject(new _.ExtensionManagementError(this.joinErrors(v).message,k)))),(n===null||n===1)&&u.push(this.scanUserExtensions(!0).then(null,v=>Promise.reject(new _.ExtensionManagementError(this.joinErrors(v).message,a))));try{const v=await Promise.all(u);return p.flatten(v)}catch(v){throw this.joinErrors(v)}}async scanUserExtensions(n){this.logService.trace("Started scanning user extensions");let[u,v]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return v=v.filter(O=>!u[new m.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),n&&(v=m.groupByExtension(v,R=>R.identifier).map(R=>R.sort((N,j)=>y.rcompare(N.manifest.version,j.manifest.version))[0])),this.logService.trace("Scanned user extensions:",v.length),v}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(n,u,v){const O=n.key(),R=b.join(this.extensionsPath,`.${O}`),N=b.join(this.extensionsPath,O);try{await D.rimraf(N)}catch(H){try{await D.rimraf(N)}catch(Z){}throw new _.ExtensionManagementError(w.localize(0,null,N,n.id),e)}await this.extractAtLocation(n,u,R,v);try{await this.rename(n,R,N,Date.now()+2*60*1e3),this.logService.info("Renamed to",N)}catch(H){this.logService.info("Rename failed. Deleting from extracted location",R);try{D.rimraf(R)}catch(Z){}throw H}let j=null;try{j=await this.scanExtension(O,this.extensionsPath,1)}catch(H){}if(j)return j;throw new Error(w.localize(1,null,this.extensionsPath))}async saveMetadataForLocalExtension(n,u){this.setMetadata(n,u),u.isMachineScoped=u.isMachineScoped||void 0,u.isBuiltin=u.isBuiltin||void 0;const v=b.join(n.location.fsPath,"package.json"),O=await D.readFile(v,"utf8"),{manifest:R}=await this.parseManifest(O);return R.__metadata=u,await D.writeFile(v,JSON.stringify(R,null,"	")),n}getUninstalledExtensions(){return this.withUninstalledExtensions(n=>n)}async withUninstalledExtensions(n){return this.uninstalledFileLimiter.queue(async()=>{let u;try{u=await D.readFile(this.uninstalledPath,"utf8")}catch(R){if(R.code!=="ENOENT")throw R}let v={};if(u)try{v=JSON.parse(u)}catch(R){}const O=n(v);return Object.keys(v).length?await D.writeFile(this.uninstalledPath,JSON.stringify(v)):await D.rimraf(this.uninstalledPath),O})}async removeExtension(n,u){this.logService.trace(`Deleting ${u} extension from disk`,n.identifier.id,n.location.fsPath),await D.rimraf(n.location.fsPath),this.logService.info("Deleted from disk",n.identifier.id,n.location.fsPath)}async removeUninstalledExtension(n){await this.removeExtension(n,"uninstalled"),await this.withUninstalledExtensions(u=>delete u[new m.ExtensionIdentifierWithVersion(n.identifier,n.manifest.version).key()])}async extractAtLocation(n,u,v,O){this.logService.trace(`Started extracting the extension from ${u} to ${v}`);try{await D.rimraf(v)}catch(R){throw new _.ExtensionManagementError(this.joinErrors(R).message,e)}try{await L.extract(u,v,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${v}:`,n.id)}catch(R){try{await D.rimraf(v)}catch(N){}throw new _.ExtensionManagementError(R.message,R instanceof L.ExtractError&&R.type?R.type:s)}}async rename(n,u,v,O){try{await D.rename(u,v)}catch(R){if(E.isWindows&&R&&R.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${u} to ${v} with 'EPERM' error. Trying again...`,n.id),this.rename(n,u,v,O);throw new _.ExtensionManagementError(R.message||w.localize(2,null,u,v),R.code||r)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const n=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return n;const u=this.scanDevSystemExtensions(),[v,O]=await Promise.all([n,u]);return[...v,...O]}async scanExtensionsInDir(n,u){const v=new g.Limiter(10),O=await D.readdir(n);return(await Promise.all(O.map(N=>v.queue(()=>this.scanExtension(N,n,u))))).filter(N=>N&&N.identifier)}async scanExtension(n,u,v){if(v===1&&n.indexOf(".")===0)return null;const O=b.join(u,n);try{const R=await D.readdir(O),{manifest:N,metadata:j}=await this.readManifest(O),H=R.filter(U=>/^readme(\.txt|\.md|)$/i.test(U))[0],Z=H?T.URI.file(b.join(O,H)):void 0,oe=R.filter(U=>/^changelog(\.txt|\.md|)$/i.test(U))[0],ne=oe?T.URI.file(b.join(O,oe)):void 0,ee={id:m.getGalleryExtensionId(N.publisher,N.name)},ce={type:v,identifier:ee,manifest:N,location:T.URI.file(O),readmeUrl:Z,changelogUrl:ne,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:v===0};return j&&this.setMetadata(ce,j),ce}catch(R){return this.logService.trace(R),null}}async scanDefaultSystemExtensions(){const n=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",n.length),n}async scanDevSystemExtensions(){const n=this.getDevSystemExtensionsList();if(n.length){const u=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",u.length),u.filter(v=>n.some(O=>m.areSameExtensions(v.identifier,{id:O})))}else return[]}setMetadata(n,u){n.publisherDisplayName=u.publisherDisplayName||null,n.publisherId=u.publisherId||null,n.identifier.uuid=u.id,n.isMachineScoped=!!u.isMachineScoped,n.isBuiltin=n.type===0||!!u.isBuiltin}async removeUninstalledExtensions(){const n=await this.getUninstalledExtensions(),u=await this.scanAllUserExtensions(),v=new Set;for(const N of u)n[new m.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version).key()]||v.add(N.identifier.id.toLowerCase());const O=m.groupByExtension(u,N=>N.identifier);await Promise.all(O.map(async N=>{const j=N.sort((H,Z)=>y.rcompare(H.manifest.version,Z.manifest.version))[0];v.has(j.identifier.id.toLowerCase())||await this.beforeRemovingExtension(j)}));const R=u.filter(N=>n[new m.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version).key()]);await Promise.all(R.map(N=>this.removeUninstalledExtension(N)))}async removeOutdatedExtensions(){const n=await this.scanAllUserExtensions(),u=[],v=m.groupByExtension(n,O=>O.identifier);u.push(...p.flatten(v.map(O=>O.sort((R,N)=>y.rcompare(R.manifest.version,N.manifest.version)).slice(1)))),await Promise.all(u.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(n=>n.name)}joinErrors(n){const u=Array.isArray(n)?n:[n];return u.length===1?u[0]instanceof Error?u[0]:new Error(u[0]):u.reduce((v,O)=>new Error(`${v.message}${v.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=b.normalize(b.join(S.FileAccess.asFileUri("",q).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(n){const u=[D.readFile(b.join(n,"package.json"),"utf8").then(N=>this.parseManifest(N)),D.readFile(b.join(n,"package.nls.json"),"utf8").then(void 0,N=>N.code!=="ENOENT"?Promise.reject(N):"{}").then(N=>JSON.parse(N))],[{manifest:v,metadata:O},R]=await Promise.all(u);return{manifest:I.localizeManifest(v,R),metadata:O}}parseManifest(n){return new Promise((u,v)=>{try{const O=JSON.parse(n),R=O.__metadata||null;u({manifest:O,metadata:R})}catch(O){v(new Error(w.localize(3,null)))}})}};i=le([fe(1,A.ILogService),fe(2,f.INativeEnvironmentService),fe(3,l.IProductService)],i),t.ExtensionsScanner=i}),define(Q[119],Y([0,1,76,3,12,2,19,42,23,26,20,11,8,38,10,41,13,14,92,31,40,47,21,32,91,6,7,29,117,96,118,97]),function(q,t,y,M,D,b,A,_,m,g,T,f,I,w,l,L,E,p,S,k,a,s,e,r,i,o,n,u,v,O,R,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const j="unsetUninstalled",H="downloading",Z="validating",oe="local",ne="unknown";let ee=class extends b.Disposable{constructor(U,W,X,C,c,h){super();this.environmentService=U,this.galleryService=W,this.logService=X,this.downloadService=C,this.telemetryService=c,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new I.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new I.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new I.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new I.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const d=this._register(h.createInstance(N.ExtensionsLifecycle));this.extensionsScanner=this._register(h.createInstance(R.ExtensionsScanner,P=>d.postUninstall(P))),this.manifestCache=this._register(new S.ExtensionsManifestCache(U,this)),this.extensionsDownloader=this._register(h.createInstance(O.ExtensionsDownloader)),this._register(b.toDisposable(()=>{this.installingExtensions.forEach(P=>P.cancel()),this.uninstallingExtensions.forEach(P=>P.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const W=await this.collectFiles(U),X=await _.zip(e.joinPath(this.environmentService.tmpDir,r.generateUuid()).fsPath,W);return l.URI.file(X)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const W=await this.downloadVsix(U),X=M.resolve(W.fsPath);return v.getManifest(X)}async collectFiles(U){const W=async C=>{let c=await D.readdir(C);c=c.map(P=>M.join(C,P));const h=await Promise.all(c.map(P=>D.stat(P)));let d=Promise.resolve([]);return h.forEach((P,F)=>{const B=c[F];P.isFile()&&(d=d.then(V=>[...V,B])),P.isDirectory()&&(d=d.then(V=>W(B).then($=>[...V,...$])))}),d};return(await W(U.location.fsPath)).map(C=>({path:`extension/${M.relative(U.location.fsPath,C)}`,localPath:C}))}async install(U,W={}){return this.logService.trace("ExtensionManagementService#install",U.toString()),f.createCancelablePromise(async X=>{const C=await this.downloadVsix(U),c=M.resolve(C.fsPath),h=await v.getManifest(c),d={id:g.getGalleryExtensionId(h.publisher,h.name)};let P=1;if(h.engines&&h.engines.vscode&&!s.isEngineValid(h.engines.vscode,L.default.version))throw new Error(y.localize(0,null,d.id,L.default.version));const F=new g.ExtensionIdentifierWithVersion(d,h.version),V=(await this.getInstalled(1)).find(K=>g.areSameExtensions(d,K.identifier));if(V)if(W.isMachineScoped=W.isMachineScoped||V.isMachineScoped,W.isBuiltin=W.isBuiltin||V.isBuiltin,P=2,F.equals(new g.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version)))try{await this.extensionsScanner.removeExtension(V,"existing")}catch(K){throw new Error(y.localize(1,null,h.displayName||h.name))}else w.gt(V.manifest.version,h.version)&&await this.uninstallExtension(V);else{const K=await this.unsetUninstalledAndGetLocal(F);if(K)try{await this.extensionsScanner.removeExtension(K,"existing")}catch(J){throw new Error(y.localize(2,null,h.displayName||h.name))}}this.logService.info("Installing the extension:",d.id),this._onInstallExtension.fire({identifier:d,zipPath:c});let $;try{$=await this.getGalleryMetadata(g.getGalleryExtensionId(h.publisher,h.name))}catch(K){}try{const K=await this.installFromZipPath(F,c,Object.assign(Object.assign({},$||{}),W),W,P,X);return this.logService.info("Successfully installed the extension:",d.id),K}catch(K){throw this.logService.error("Failed to install the extension:",d.id,K.message),K}})}async downloadVsix(U){if(U.scheme===n.Schemas.file)return U;if(!this.downloadService)throw new Error("Download service is not available");const W=e.joinPath(this.environmentService.tmpDir,r.generateUuid());return await this.downloadService.download(U,W),W}async installFromZipPath(U,W,X,C,c,h){try{const d=await this.installExtension({zipPath:W,identifierWithVersion:U,metadata:X},h);try{await this.installDependenciesAndPackExtensions(d,void 0,C)}catch(P){A.isNonEmptyArray(d.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",d.identifier.id,P.message),A.isNonEmptyArray(d.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",d.identifier.id,P.message)}return this._onDidInstallExtension.fire({identifier:U,zipPath:W,local:d,operation:c}),d}catch(d){throw this._onDidInstallExtension.fire({identifier:U,zipPath:W,operation:c,error:d}),d}}async canInstall(U){return!0}async installFromGallery(U,W={}){if(!this.galleryService.isEnabled())throw new Error(y.localize(3,null));try{U=await this.checkAndGetCompatibleVersion(U)}catch(c){const h=c&&c.code?c.code:ne;throw this.logService.error("Failed to install extension:",U.identifier.id,c?c.message:h),this.reportTelemetry(this.getTelemetryEvent(1),g.getGalleryExtensionTelemetryData(U),void 0,c),c instanceof Error&&(c.name=h),c}const X=new g.ExtensionIdentifierWithVersion(U.identifier,U.version).key();let C=this.installingExtensions.get(X);return C||(C=f.createCancelablePromise(c=>this.doInstallFromGallery(U,W,c)),this.installingExtensions.set(X,C),C.finally(()=>this.installingExtensions.delete(X))),C}async doInstallFromGallery(U,W,X){const C=new Date().getTime();let c=1;this.logService.info("Installing extension:",U.identifier.id),this._onInstallExtension.fire({identifier:U.identifier,gallery:U});try{const d=(await this.getInstalled(1)).find(B=>g.areSameExtensions(B.identifier,U.identifier));d&&(c=2);const P=await this.downloadInstallableExtension(U,c);P.metadata.isMachineScoped=W.isMachineScoped||(d==null?void 0:d.isMachineScoped),P.metadata.isBuiltin=W.isBuiltin||(d==null?void 0:d.isBuiltin);const F=await this.installExtension(P,X);try{await this.extensionsDownloader.delete(l.URI.file(P.zipPath))}catch(B){}if(!W.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(F,d,W)}catch(B){try{await this.uninstall(F)}catch(V){}throw B}return d&&w.neq(d.manifest.version,U.version)&&await this.setUninstalled(d),this.logService.info("Extensions installed successfully:",U.identifier.id),this._onDidInstallExtension.fire({identifier:U.identifier,gallery:U,local:F,operation:c}),this.reportTelemetry(this.getTelemetryEvent(c),g.getGalleryExtensionTelemetryData(U),new Date().getTime()-C,void 0),F}catch(h){const d=h&&h.code?h.code:ne;throw this.logService.error("Failed to install extension:",U.identifier.id,h?h.message:d),this._onDidInstallExtension.fire({identifier:U.identifier,gallery:U,operation:c,error:d}),this.reportTelemetry(this.getTelemetryEvent(c),g.getGalleryExtensionTelemetryData(U),new Date().getTime()-C,h),h instanceof Error&&(h.name=d),h}}async checkAndGetCompatibleVersion(U){if(await this.isMalicious(U))throw new m.ExtensionManagementError(y.localize(4,null),m.INSTALL_ERROR_MALICIOUS);const W=await this.galleryService.getCompatibleExtension(U);if(!W)throw new m.ExtensionManagementError(y.localize(5,null,U.identifier.id,L.default.version),m.INSTALL_ERROR_INCOMPATIBLE);return W}async reinstallFromGallery(U){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.galleryService.isEnabled())throw new Error(y.localize(6,null));const W=await this.findGalleryExtension(U);if(!W)throw new Error(y.localize(7,null));await this.setUninstalled(U);try{await this.extensionsScanner.removeUninstalledExtension(U)}catch(X){throw new Error(y.localize(8,null,k.toErrorMessage(X)))}await this.installFromGallery(W)}getTelemetryEvent(U){return U===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(U){const W=await this.getExtensionsReport();return g.getMaliciousExtensionsSet(W).has(U.identifier.id)}async downloadInstallableExtension(U,W){const X={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let C;try{this.logService.trace("Started downloading extension:",U.identifier.id);const c=await this.extensionsDownloader.downloadExtension(U,W);this.logService.info("Downloaded extension:",U.identifier.id,C),C=c.fsPath}catch(c){throw new m.ExtensionManagementError(this.joinErrors(c).message,H)}try{const c=await v.getManifest(C);return{zipPath:C,identifierWithVersion:new g.ExtensionIdentifierWithVersion(U.identifier,c.version),metadata:X}}catch(c){throw new m.ExtensionManagementError(this.joinErrors(c).message,Z)}}async installExtension(U,W){try{const X=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(X)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(X,U.metadata):X}catch(X){throw E.isMacintosh?new m.ExtensionManagementError(y.localize(9,null),j):new m.ExtensionManagementError(y.localize(10,null),j)}return this.extractAndInstall(U,W)}async unsetUninstalledAndGetLocal(U){return await this.isUninstalled(U)?(this.logService.trace("Removing the extension from uninstalled list:",U.id),await this.unsetUninstalled(U),this.logService.info("Removed the extension from uninstalled list:",U.id),(await this.getInstalled(1)).find(C=>new g.ExtensionIdentifierWithVersion(C.identifier,C.manifest.version).equals(U))||null):null}async extractAndInstall({zipPath:U,identifierWithVersion:W,metadata:X},C){let c=await this.extensionsScanner.extractUserExtension(W,U,C);return this.logService.info("Installation completed.",W.id),X&&(c=await this.extensionsScanner.saveMetadataForLocalExtension(c,X)),c}async installDependenciesAndPackExtensions(U,W,X){if(!!this.galleryService.isEnabled()){const C=U.manifest.extensionDependencies||[];if(U.manifest.extensionPack)for(const c of U.manifest.extensionPack)W&&W.manifest.extensionPack&&W.manifest.extensionPack.some(h=>g.areSameExtensions({id:h},{id:c}))||C.every(h=>!g.areSameExtensions({id:h},{id:c}))&&C.push(c);if(C.length){const c=await this.getInstalled(),h=C.filter(d=>c.every(({identifier:P})=>!g.areSameExtensions(P,{id:d})));if(h.length){const P=(await this.galleryService.query({names:h,pageSize:C.length},u.CancellationToken.None)).firstPage;try{await Promise.all(P.map(F=>this.installFromGallery(F,X)))}catch(F){try{await this.rollback(P)}catch(B){}throw F}}}}}async rollback(U){const X=(await this.getInstalled(1)).filter(C=>U.some(c=>new g.ExtensionIdentifierWithVersion(C.identifier,C.manifest.version).equals(new g.ExtensionIdentifierWithVersion(c.identifier,c.version))));await Promise.all(X.map(C=>this.uninstall(C)))}async uninstall(U,W={}){this.logService.trace("ExtensionManagementService#uninstall",U.identifier.id);const X=await this.getInstalled(1),C=X.find(c=>g.areSameExtensions(c.identifier,U.identifier));if(!C)throw new Error(y.localize(11,null,U.manifest.displayName||U.manifest.name));try{await this.checkForDependenciesAndUninstall(C,X,W)}catch(c){throw this.joinErrors(c)}}async updateMetadata(U,W){return this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,Object.assign(Object.assign({},U.manifest.__metadata||{}),W)),this.manifestCache.invalidate(),U}async updateExtensionScope(U,W){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,Object.assign(Object.assign({},U.manifest.__metadata||{}),{isMachineScoped:W})),this.manifestCache.invalidate(),U}async getGalleryMetadata(U){const W=await this.findGalleryExtensionByName(U);return W?{id:W.identifier.uuid,publisherDisplayName:W.publisherDisplayName,publisherId:W.publisherId}:void 0}async findGalleryExtension(U){if(U.identifier.uuid){const W=await this.findGalleryExtensionById(U.identifier.uuid);return W||this.findGalleryExtensionByName(U.identifier.id)}return this.findGalleryExtensionByName(U.identifier.id)}async findGalleryExtensionById(U){return(await this.galleryService.query({ids:[U],pageSize:1},u.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(U){return(await this.galleryService.query({names:[U],pageSize:1},u.CancellationToken.None)).firstPage[0]}joinErrors(U){const W=Array.isArray(U)?U:[U];return W.length===1?W[0]instanceof Error?W[0]:new Error(W[0]):W.reduce((X,C)=>new Error(`${X.message}${X.message?",":""}${C instanceof Error?C.message:C}`),new Error(""))}async checkForDependenciesAndUninstall(U,W,X){try{await this.preUninstallExtension(U);const C=X.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(U,W);await this.uninstallExtensions(U,C,W,X)}catch(C){throw await this.postUninstallExtension(U,new m.ExtensionManagementError(C instanceof Error?C.message:C,oe)),C}await this.postUninstallExtension(U)}async uninstallExtensions(U,W,X,C){const c=[U,...W];if(!C.donotCheckDependents)for(const h of c)this.checkForDependents(h,c,X,U);await Promise.all([this.uninstallExtension(U),...W.map(h=>this.doUninstall(h))])}checkForDependents(U,W,X,C){const c=this.getDependents(U,X);if(c.length){const h=c.filter(d=>W.indexOf(d)===-1);if(h.length)throw new Error(this.getDependentsErrorMessage(U,h,C))}}getDependentsErrorMessage(U,W,X){return X===U?W.length===1?y.localize(12,null,X.manifest.displayName||X.manifest.name,W[0].manifest.displayName||W[0].manifest.name):W.length===2?y.localize(13,null,X.manifest.displayName||X.manifest.name,W[0].manifest.displayName||W[0].manifest.name,W[1].manifest.displayName||W[1].manifest.name):y.localize(14,null,X.manifest.displayName||X.manifest.name,W[0].manifest.displayName||W[0].manifest.name,W[1].manifest.displayName||W[1].manifest.name):W.length===1?y.localize(15,null,X.manifest.displayName||X.manifest.name,U.manifest.displayName||U.manifest.name,W[0].manifest.displayName||W[0].manifest.name):W.length===2?y.localize(16,null,X.manifest.displayName||X.manifest.name,U.manifest.displayName||U.manifest.name,W[0].manifest.displayName||W[0].manifest.name,W[1].manifest.displayName||W[1].manifest.name):y.localize(17,null,X.manifest.displayName||X.manifest.name,U.manifest.displayName||U.manifest.name,W[0].manifest.displayName||W[0].manifest.name,W[1].manifest.displayName||W[1].manifest.name)}getAllPackExtensionsToUninstall(U,W,X=[]){if(X.indexOf(U)!==-1)return[];X.push(U);const C=U.manifest.extensionPack?U.manifest.extensionPack:[];if(C.length){const c=W.filter(d=>!d.isBuiltin&&C.some(P=>g.areSameExtensions({id:P},d.identifier))),h=[];for(const d of c)h.push(...this.getAllPackExtensionsToUninstall(d,W,X));return[...c,...h]}return[]}getDependents(U,W){return W.filter(X=>X.manifest.extensionDependencies&&X.manifest.extensionDependencies.some(C=>g.areSameExtensions({id:C},U.identifier)))}async doUninstall(U){try{await this.preUninstallExtension(U),await this.uninstallExtension(U)}catch(W){throw await this.postUninstallExtension(U,new m.ExtensionManagementError(W instanceof Error?W.message:W,oe)),W}await this.postUninstallExtension(U)}async preUninstallExtension(U){if(!await D.exists(U.location.fsPath))throw new Error(y.localize(18,null));this.logService.info("Uninstalling extension:",U.identifier.id),this._onUninstallExtension.fire(U.identifier)}async uninstallExtension(U){let W=this.uninstallingExtensions.get(U.identifier.id);return W||(W=f.createCancelablePromise(async()=>{const X=await this.extensionsScanner.scanUserExtensions(!1);await this.setUninstalled(...X.filter(C=>g.areSameExtensions(C.identifier,U.identifier)))}),this.uninstallingExtensions.set(U.identifier.id,W),W.finally(()=>this.uninstallingExtensions.delete(U.identifier.id))),W}async postUninstallExtension(U,W){if(W)this.logService.error("Failed to uninstall extension:",U.identifier.id,W.message);else if(this.logService.info("Successfully uninstalled extension:",U.identifier.id),U.identifier.uuid)try{await this.galleryService.reportStatistic(U.manifest.publisher,U.manifest.name,U.manifest.version,"uninstall")}catch(C){}this.reportTelemetry("extensionGallery:uninstall",g.getLocalExtensionTelemetryData(U),void 0,W);const X=W?W instanceof m.ExtensionManagementError?W.code:ne:void 0;this._onDidUninstallExtension.fire({identifier:U.identifier,error:X})}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(U){return(await this.filterUninstalled(U)).length===1}filterUninstalled(...U){return this.extensionsScanner.withUninstalledExtensions(W=>{const X=[];for(const C of U)W[C.key()]&&X.push(C.key());return X})}setUninstalled(...U){const W=U.map(X=>new g.ExtensionIdentifierWithVersion(X.identifier,X.manifest.version));return this.extensionsScanner.withUninstalledExtensions(X=>(W.forEach(C=>X[C.key()]=!0),X))}unsetUninstalled(U){return this.extensionsScanner.withUninstalledExtensions(W=>delete W[U.key()])}getExtensionsReport(){const U=new Date().getTime();return(!this.reportedExtensions||U-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=U),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const U=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${U.length} reported extensions from service`),U}catch(U){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(U,W,X,C){const c=C?C instanceof m.ExtensionManagementError?C.code:ne:void 0;this.telemetryService.publicLogError(U,Object.assign(Object.assign({},W),{success:!C,duration:X,errorcode:c}))}};ee=le([fe(0,T.INativeEnvironmentService),fe(1,m.IExtensionGalleryService),fe(2,p.ILogService),fe(3,o.optional(i.IDownloadService)),fe(4,a.ITelemetryService),fe(5,o.IInstantiationService)],ee),t.ExtensionManagementService=ee}),define(Q[120],Y([0,1,101,130,121,8,28,3,54,32,2,16,65,15,13]),function(q,t,y,M,D,b,A,_,m,g,T,f,I,w,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.connect=t.serve=t.Server=t.createStaticIPCHandle=t.createRandomIPCHandle=t.XDG_RUNTIME_DIR=t.WebSocketNodeSocket=t.NodeSocket=void 0;class L{constructor(v){this.socket=v}dispose(){this.socket.destroy()}onData(v){const O=R=>v(f.VSBuffer.wrap(R));return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(v){return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(v){return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(v){if(!this.socket.destroyed)try{this.socket.write(v.buffer)}catch(O){if(O.code==="EPIPE")return;w.onUnexpectedError(O)}}end(){this.socket.end()}drain(){return new Promise((v,O)=>{if(this.socket.bufferSize===0){v();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),v()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}t.NodeSocket=L;var E;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var p;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(p||(p={}));class S extends T.Disposable{constructor(v,O,R,N){super();this._onDidZlibFlush=this._register(new b.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=v,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=O,this._recordInflateBytes=N,O?(this._zlibInflate=D.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",j=>{console.error(j),w.onUnexpectedError(j),this._onClose.fire()}),this._zlibInflate.on("data",j=>{this._pendingInflateData.push(j)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=D.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",j=>{console.error(j),w.onUnexpectedError(j),this._onClose.fire()}),this._zlibDeflate.on("data",j=>{this._pendingDeflateData.push(j)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new I.ChunkStream,this._register(this.socket.onData(j=>this._acceptChunk(j))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?f.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):f.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this._onData.event(v)}onClose(v){return this._onClose.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){this._totalOutgoingDataBytes+=v.byteLength,this._zlibDeflate?(this._zlibDeflate.write(v.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let O=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,O=O.slice(0,O.length-4),this._isEnded||this._write(f.VSBuffer.wrap(O),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(v,!1)}_write(v,O){let R=2;v.byteLength<126?R+=0:v.byteLength<2**16?R+=2:R+=8;const N=f.VSBuffer.alloc(R);if(O?N.writeUInt8(194,0):N.writeUInt8(130,0),v.byteLength<126)N.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){N.writeUInt8(126,1);let j=1;N.writeUInt8(v.byteLength>>>8&255,++j),N.writeUInt8(v.byteLength>>>0&255,++j)}else{N.writeUInt8(127,1);let j=1;N.writeUInt8(0,++j),N.writeUInt8(0,++j),N.writeUInt8(0,++j),N.writeUInt8(0,++j),N.writeUInt8(v.byteLength>>>24&255,++j),N.writeUInt8(v.byteLength>>>16&255,++j),N.writeUInt8(v.byteLength>>>8&255,++j),N.writeUInt8(v.byteLength>>>0&255,++j)}this._totalOutgoingWireBytes+=N.byteLength+v.byteLength,this.socket.write(f.VSBuffer.concat([N,v]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(v){if(v.byteLength!==0){for(this._totalIncomingWireBytes+=v.byteLength,this._incomingData.acceptChunk(v);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const O=this._incomingData.peek(this._state.readLen),N=(O.readUInt8(0)&128)>>>7,j=O.readUInt8(1),H=(j&128)>>>7,Z=j&127;this._state.state=2,this._state.readLen=2+(H?4:0)+(Z===126?2:0)+(Z===127?8:0),this._state.fin=N,this._state.mask=0}else if(this._state.state===2){const O=this._incomingData.read(this._state.readLen),R=O.readUInt8(1),N=(R&128)>>>7;let j=R&127,H=1;j===126?j=O.readUInt8(++H)*2**8+O.readUInt8(++H):j===127&&(j=O.readUInt8(++H)*0+O.readUInt8(++H)*0+O.readUInt8(++H)*0+O.readUInt8(++H)*0+O.readUInt8(++H)*2**24+O.readUInt8(++H)*2**16+O.readUInt8(++H)*2**8+O.readUInt8(++H));let Z=0;N&&(Z=O.readUInt8(++H)*2**24+O.readUInt8(++H)*2**16+O.readUInt8(++H)*2**8+O.readUInt8(++H)),this._state.state=3,this._state.readLen=j,this._state.mask=Z}else if(this._state.state===3){const O=this._incomingData.read(this._state.readLen);k(O,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(O.buffer)),this._zlibInflate.write(O.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(f.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=O.byteLength,this._onData.fire(O))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await b.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}t.WebSocketNodeSocket=S;function k(u,v){if(v!==0){let O=u.byteLength>>>2;for(let oe=0;oe<O;oe++){const ne=u.readUInt32BE(oe*4);u.writeUInt32BE(ne^v,oe*4)}let R=O*4,N=u.byteLength-R;const j=v>>>24&255,H=v>>>16&255,Z=v>>>8&255;N>=1&&u.writeUInt8(u.readUInt8(R)^j,R),N>=2&&u.writeUInt8(u.readUInt8(R+1)^H,R+1),N>=3&&u.writeUInt8(u.readUInt8(R+2)^Z,R+2)}}t.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function s(){const u=g.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let v;return t.XDG_RUNTIME_DIR?v=_.join(t.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):v=_.join(m.tmpdir(),`vscode-ipc-${u}.sock`),r(v),v}t.createRandomIPCHandle=s;function e(u,v,O){const R=y.createHash("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${O}-${v}-sock`;let N;return t.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=_.join(t.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${O}-${v}.sock`):N=_.join(u,`${O}-${v}.sock`),r(N),N}t.createStaticIPCHandle=e;function r(u){const v=a[l.platform];typeof v=="number"&&u.length>=v&&console.warn(`WARNING: IPC handle "${u}" is longer than ${v} chars, try a shorter --user-data-dir`)}class i extends A.IPCServer{constructor(v){super(i.toClientConnectionEvent(v));this.server=v}static toClientConnectionEvent(v){const O=b.Event.fromNodeEventEmitter(v,"connection");return b.Event.map(O,R=>({protocol:new I.Protocol(new L(R)),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}t.Server=i;function o(u){return new Promise((v,O)=>{const R=M.createServer();R.on("error",O),R.listen(u,()=>{R.removeListener("error",O),v(new i(R))})})}t.serve=o;function n(u,v){return new Promise((O,R)=>{const N=M.createConnection(u,()=>{N.removeListener("error",R),O(I.Client.fromSocket(new L(N),v))});N.once("error",R)})}t.connect=n}),define(Q[122],Y([0,1,54,62,3,21,56,41,68,7,10,120]),function(q,t,y,M,D,b,A,_,m,g,T,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseUserDataDir=t.parsePathArg=t.parseSearchPort=t.parseExtensionHostPort=t.NativeEnvironmentService=void 0;class I{constructor(k){if(this._args=k,!k.logsPath){const a=m.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");k.logsPath=D.join(this.userDataPath,"logs",a)}this.logsPath=k.logsPath}get args(){return this._args}get appRoot(){return D.dirname(g.FileAccess.asFileUri("",q).fsPath)}get userHome(){return T.URI.file(y.homedir())}get userDataPath(){const k=process.env.VSCODE_PORTABLE;return k?D.join(k,"user-data"):p(this._args,process)}get appSettingsHome(){return T.URI.file(D.join(this.userDataPath,"User"))}get tmpDir(){return T.URI.file(y.tmpdir())}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return b.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return b.joinPath(this.userRoamingDataHome,"sync")}get userDataSyncLogResource(){return T.URI.file(D.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return b.joinPath(T.URI.file(D.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return T.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return T.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return b.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return b.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const k=process.env.VSCODE_PORTABLE;return k?T.URI.file(D.join(k,"argv.json")):b.joinPath(this.userHome,_.default.dataFolderName,"argv.json")}get snippetsHome(){return b.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this._args.extensionDevelopmentPath}get untitledWorkspacesHome(){return T.URI.file(D.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return D.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const k=E(this._args["builtin-extensions-dir"],process);return k||D.normalize(D.join(g.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const k=E(this._args["extensions-download-dir"],process);return k||D.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const k=E(this._args["extensions-dir"],process);if(k)return k;const a=process.env.VSCODE_EXTENSIONS;if(a)return a;const s=process.env.VSCODE_PORTABLE;return s?D.join(s,"extensions"):b.joinPath(this.userHome,_.default.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const k=this._args.extensionDevelopmentPath;if(Array.isArray(k))return k.map(a=>/^[^:/?#]+?:\/\//.test(a)?T.URI.parse(a):T.URI.file(D.normalize(a)))}get extensionTestsLocationURI(){const k=this._args.extensionTestsPath;if(k)return/^[^:/?#]+?:\/\//.test(k)?T.URI.parse(k):T.URI.file(D.normalize(k))}get disableExtensions(){if(this._args["disable-extensions"])return!0;const k=this._args["disable-extension"];if(k){if(typeof k=="string")return[k];if(Array.isArray(k)&&k.length>0)return k}return!1}get debugExtensionHost(){return w(this._args,this.isBuilt)}get debugRenderer(){return!!this._args.debugRenderer}get isBuilt(){return!process.env.VSCODE_DEV}get verbose(){return!!this._args.verbose}get logLevel(){return this._args.log}get sharedIPCHandle(){return f.createStaticIPCHandle(this.userDataPath,"shared",_.default.version)}get serviceMachineIdResource(){return b.joinPath(T.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this._args["crash-reporter-id"]}get crashReporterDirectory(){return this._args["crash-reporter-directory"]}get driverHandle(){return this._args.driver}get telemetryLogResource(){return T.URI.file(D.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this._args["disable-telemetry"]}}le([A.memoize],I.prototype,"appRoot",null),le([A.memoize],I.prototype,"userHome",null),le([A.memoize],I.prototype,"userDataPath",null),le([A.memoize],I.prototype,"appSettingsHome",null),le([A.memoize],I.prototype,"tmpDir",null),le([A.memoize],I.prototype,"userRoamingDataHome",null),le([A.memoize],I.prototype,"settingsResource",null),le([A.memoize],I.prototype,"userDataSyncHome",null),le([A.memoize],I.prototype,"userDataSyncLogResource",null),le([A.memoize],I.prototype,"sync",null),le([A.memoize],I.prototype,"machineSettingsResource",null),le([A.memoize],I.prototype,"globalStorageHome",null),le([A.memoize],I.prototype,"workspaceStorageHome",null),le([A.memoize],I.prototype,"keybindingsResource",null),le([A.memoize],I.prototype,"keyboardLayoutResource",null),le([A.memoize],I.prototype,"argvResource",null),le([A.memoize],I.prototype,"snippetsHome",null),le([A.memoize],I.prototype,"isExtensionDevelopment",null),le([A.memoize],I.prototype,"untitledWorkspacesHome",null),le([A.memoize],I.prototype,"installSourcePath",null),le([A.memoize],I.prototype,"builtinExtensionsPath",null),le([A.memoize],I.prototype,"extensionsPath",null),le([A.memoize],I.prototype,"extensionDevelopmentLocationURI",null),le([A.memoize],I.prototype,"extensionTestsLocationURI",null),le([A.memoize],I.prototype,"debugExtensionHost",null),le([A.memoize],I.prototype,"sharedIPCHandle",null),le([A.memoize],I.prototype,"serviceMachineIdResource",null),le([A.memoize],I.prototype,"telemetryLogResource",null),t.NativeEnvironmentService=I;function w(S,k){return L(S["inspect-extensions"],S["inspect-brk-extensions"],5870,k,S.debugId)}t.parseExtensionHostPort=w;function l(S,k){return L(S["inspect-search"],S["inspect-brk-search"],5876,k)}t.parseSearchPort=l;function L(S,k,a,s,e){const i=Number(k||S)||(s?null:a),o=i?Boolean(!!k):!1;return{port:i,break:o,debugId:e}}function E(S,k){if(!!S){const a=D.resolve(S);return D.normalize(S)===a?a:D.resolve(k.env.VSCODE_CWD||k.cwd(),S)}}t.parsePathArg=E;function p(S,k){return E(S["user-data-dir"],k)||D.resolve(M.getDefaultUserDataPath())}t.parseUserDataDir=p}),define(Q[123],Y([0,1,121,107,2,9,15,106,27,14,16]),function(q,t,y,M,D,b,A,_,m,g,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let f=class extends D.Disposable{constructor(w,l){super();this.logService=l,this.configure(w.getValue()),this._register(w.onDidChangeConfiguration(()=>this.configure(w.getValue()),this))}configure(w){this.proxyUrl=w.http&&w.http.proxy,this.strictSSL=!!(w.http&&w.http.proxyStrictSSL),this.authorization=w.http&&w.http.proxyAuthorization}async request(w,l){this.logService.trace("RequestService#request",w.url);const{proxyUrl:L,strictSSL:E}=this,p=w.agent?w.agent:await _.getProxyAgent(w.url||"",{proxyUrl:L,strictSSL:E});return w.agent=p,w.strictSSL=E,this.authorization&&(w.headers=Object.assign(Object.assign({},w.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(w,l)}async getNodeRequest(w){return(M.parse(w.url).protocol==="https:"?await new Promise((E,p)=>{q(["https"],E,p)}):await new Promise((E,p)=>{q(["http"],E,p)})).request}_request(w,l){return new Promise(async(L,E)=>{let p;const S=M.parse(w.url),k=w.getRawRequest?w.getRawRequest(w):await this.getNodeRequest(w),a={hostname:S.hostname,port:S.port?parseInt(S.port):S.protocol==="https:"?443:80,protocol:S.protocol,path:S.path,method:w.type||"GET",headers:w.headers,agent:w.agent,rejectUnauthorized:b.isBoolean(w.strictSSL)?w.strictSSL:!0};w.user&&w.password&&(a.auth=w.user+":"+w.password),p=k(a,s=>{const e=b.isNumber(w.followRedirects)?w.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&e>0&&s.headers.location)this._request(Object.assign(Object.assign({},w),{url:s.headers.location,followRedirects:e-1}),l).then(L,E);else{let r=s;s.headers["content-encoding"]==="gzip"&&(r=s.pipe(y.createGunzip())),L({res:s,stream:T.streamToBufferReadableStream(r)})}}),p.on("error",E),w.timeout&&p.setTimeout(w.timeout),w.data&&typeof w.data=="string"&&p.write(w.data),p.end(),l.onCancellationRequested(()=>{p.abort(),E(A.canceled())})})}async resolveProxy(w){}};f=le([fe(0,m.IConfigurationService),fe(1,g.ILogService)],f),t.RequestService=f}),define(Q[131],Y([0,1,54,22,132,3,11,41,51,48,94,20,122,23,119,113,40,53,114,112,52,123,27,105,115,12,109,110,14,7,102,116,98,24,99,2,39,95,10,100,37,15,31]),function(q,t,y,M,D,b,A,_,m,g,T,f,I,w,l,L,E,p,S,k,a,s,e,r,i,o,n,u,v,O,R,N,j,H,Z,oe,ne,ee,ce,U,W,X,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class c extends oe.Disposable{constructor(P){super();this.argv=P,D.gracefulify(M),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[P,F]=await this.initServices();return P.invokeFunction(async B=>{const V=B.get(v.ILogService),$=B.get(f.INativeEnvironmentService),K=B.get(w.IExtensionManagementCLIService);return V.info("CLI main",this.argv),this.registerErrorHandler(V),await this.doRun($,K),A.raceTimeout(p.combinedAppender(...F).flush(),1e3)})}async initServices(){const P=new m.ServiceCollection,F=new I.NativeEnvironmentService(this.argv);P.set(f.IEnvironmentService,F),P.set(f.INativeEnvironmentService,F),await Promise.all([F.appSettingsHome.fsPath,F.extensionsPath].map(ke=>ke?o.mkdirp(ke):void 0));const B=v.getLogLevel(F),V=[];V.push(new R.SpdLogService("cli",F.logsPath,B)),B===v.LogLevel.Trace&&V.push(new v.ConsoleLogService(B));const $=this._register(new v.MultiplexLogService(V));P.set(v.ILogService,$);const K=this._register(new j.FileService($));P.set(H.IFileService,K);const J=this._register(new Z.DiskFileSystemProvider($));K.registerProvider(O.Schemas.file,J);const te=this._register(new r.ConfigurationService(F.settingsResource,K));P.set(e.IConfigurationService,te),await te.initialize();const re=new u.StateService(F,$);P.set(n.IStateService,re),P.set(ne.IProductService,Object.assign({_serviceBrand:void 0},_.default));const{appRoot:he,extensionsPath:de,extensionDevelopmentLocationURI:Se,isBuilt:Oe,installSourcePath:Te}=F;P.set(a.IRequestService,new g.SyncDescriptor(s.RequestService)),P.set(w.IExtensionManagementService,new g.SyncDescriptor(l.ExtensionManagementService)),P.set(w.IExtensionGalleryService,new g.SyncDescriptor(L.ExtensionGalleryService)),P.set(w.IExtensionManagementCLIService,new g.SyncDescriptor(ee.ExtensionManagementCLIService)),P.set(W.ILocalizationsService,new g.SyncDescriptor(U.LocalizationsService));const ve=[];if(Oe&&!Se&&!F.disableTelemetry&&_.default.enableTelemetry){_.default.aiConfig&&_.default.aiConfig.asimovKey&&ve.push(new i.AppInsightsAppender("monacoworkbench",null,_.default.aiConfig.asimovKey));const ke={appender:p.combinedAppender(...ve),sendErrorTelemetry:!1,commonProperties:k.resolveCommonProperties(K,y.release(),process.arch,_.default.commit,_.default.version,re.getItem("telemetry.machineId"),_.default.msftInternalDomains,Te),piiPaths:[he,de]};P.set(E.ITelemetryService,new g.SyncDescriptor(S.TelemetryService,[ke]))}else P.set(E.ITelemetryService,p.NullTelemetryService);return[new T.InstantiationService(P),ve]}registerErrorHandler(P){X.setUnexpectedErrorHandler(F=>{const B=C.toErrorMessage(F,!0);!B||P.error(`[uncaught exception in CLI]: ${B}`)})}async doRun(P,F){if(this.argv["install-source"])return this.setInstallSource(P,this.argv["install-source"]);if(this.argv["list-extensions"])return F.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return F.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return F.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return F.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(N.buildTelemetryMessage(P.appRoot,P.extensionsPath))}asExtensionIdOrVSIX(P){return P.map(F=>/\.vsix$/i.test(F)?ce.URI.file(b.isAbsolute(F)?F:b.join(process.cwd(),F)):F)}setInstallSource(P,F){return o.writeFile(P.installSourcePath,F.slice(0,30))}}async function h(d){const P=new c(d);try{await P.run()}finally{P.dispose()}}t.main=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/622cb03f7e070a9670c94bae1a45d78d7181fbd4/core/vs/code/node/cliProcessMain.js.map
