/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/errors","vs/base/common/path","vs/base/common/arrays","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/base/common/uuid","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/codicons","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/comparers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalDataBuffering","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(se){for(var e=[],b=0,y=se.length;b<y;b++)e[b]=ve[se[b]];return e};define(ve[43],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function b(y,A){if(!y)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=b}),define(ve[50],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const b=Object.prototype.hasOwnProperty;function y(P){const S=[];for(let v in P)b.call(P,v)&&S.push(P[v]);return S}e.values=y;function A(P,S){for(let v in P)if(b.call(P,v)&&S({key:v,value:P[v]},function(){delete P[v]})===!1)return}e.forEach=A;function T(P,S){const v=Object.create(null);for(const d of P){const a=S(d);let m=v[a];m||(m=v[a]=[]),m.push(d)}return v}e.groupBy=T;function E(P){const S=Object.create(null);return P&&P.forEach((v,d)=>{S[d]=v}),S}e.fromMap=E;function k(P,S){const v=[],d=[];for(let a of P)S.has(a)||v.push(a);for(let a of S)P.has(a)||d.push(a);return{removed:v,added:d}}e.diffSets=k;function I(P,S){const v=[],d=[];for(let[a,m]of P)S.has(a)||v.push(m);for(let[a,m]of S)P.has(a)||d.push(m);return{removed:v,added:d}}e.diffMaps=I;class i{constructor(){this.map=new Map}add(S,v){let d=this.map.get(S);d||(d=new Set,this.map.set(S,d)),d.add(v)}delete(S,v){const d=this.map.get(S);!d||(d.delete(v),d.size===0&&this.map.delete(S))}forEach(S,v){const d=this.map.get(S);!d||d.forEach(v)}}e.SetMap=i}),define(ve[44],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function b(I){return(i,P,S)=>{let v=null,d=null;if(typeof S.value=="function"?(v="value",d=S.value):typeof S.get=="function"&&(v="get",d=S.get),!d)throw new Error("not supported");S[v]=I(d,P)}}e.createDecorator=b;let y=0;function A(){const I=`$memoize${y++}`;let i;const P=function(v,d,a){let m=null,p=null;if(typeof a.value=="function"?(m="value",p=a.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(m="get",p=a.get),!p)throw new Error("not supported");const f=`${I}:${d}`;a[m]=function(...c){return i=this,this.hasOwnProperty(f)||Object.defineProperty(this,f,{configurable:!0,enumerable:!1,writable:!0,value:p.apply(this,c)}),this[f]}};return P.clear=()=>{typeof i!="undefined"&&Object.getOwnPropertyNames(i).forEach(S=>{S.indexOf(I)===0&&delete i[S]})},P}e.createMemoizer=A;function T(I,i,P){return A()(I,i,P)}e.memoize=T;function E(I,i,P){return b((S,v)=>{const d=`$debounce$${v}`,a=`$debounce$result$${v}`;return function(...m){this[a]||(this[a]=P?P():void 0),clearTimeout(this[d]),i&&(this[a]=i(this[a],...m),m=[this[a]]),this[d]=setTimeout(()=>{S.apply(this,m),this[a]=P?P():void 0},I)}})}e.debounce=E;function k(I,i,P){return b((S,v)=>{const d=`$throttle$timer$${v}`,a=`$throttle$result$${v}`,m=`$throttle$lastRun$${v}`,p=`$throttle$pending$${v}`;return function(...f){if(this[a]||(this[a]=P?P():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),i&&(this[a]=i(this[a],...f)),!this[p]){const c=this[m]+I;c<=Date.now()?(this[m]=Date.now(),S.apply(this,[this[a]]),this[a]=P?P():void 0):(this[p]=!0,this[d]=setTimeout(()=>{this[p]=!1,this[m]=Date.now(),S.apply(this,[this[a]]),this[a]=P?P():void 0},c-Date.now()))}}})}e.throttle=k}),define(ve[9],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class b{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(o=>{o(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=b,e.errorHandler=new b;function y(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=y;function A(c){I(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=A;function T(c){I(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=T;function E(c){if(c instanceof Error){let{name:n,message:o}=c;const h=c.stacktrace||c.stack;return{$isError:!0,name:n,message:o,stack:h}}return c}e.transformErrorForSerialization=E;const k="Canceled";function I(c){return c instanceof Error&&c.name===k&&c.message===k}e.isPromiseCanceledError=I;class i extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=i;function P(){const c=new Error(k);return c.name=c.message,c}e.canceled=P;function S(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=S;function v(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=v;function d(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function a(c){const n=new Error(`${c} has been disposed`);return n.name="DISPOSED",n}e.disposed=a;function m(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=m;class p extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=p;class f extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=f}),define(ve[11],_e([0,1,9]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.mergeSort=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function y(F,te=0){return F[F.length-(1+te)]}e.tail=y;function A(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=A;function T(F,te,ae=(ue,we)=>ue===we){if(F===te)return!0;if(!F||!te||F.length!==te.length)return!1;for(let ue=0,we=F.length;ue<we;ue++)if(!ae(F[ue],te[ue]))return!1;return!0}e.equals=T;function E(F,te,ae){let ue=0,we=F.length-1;for(;ue<=we;){const fe=(ue+we)/2|0,De=ae(F[fe],te);if(De<0)ue=fe+1;else if(De>0)we=fe-1;else return fe}return-(ue+1)}e.binarySearch=E;function k(F,te){let ae=0,ue=F.length;if(ue===0)return 0;for(;ae<ue;){const we=Math.floor((ae+ue)/2);te(F[we])?ue=we:ae=we+1}return ae}e.findFirstInSorted=k;function I(F,te,ae){if(F=F|0,F>=te.length)throw new TypeError("invalid index");let ue=te[Math.floor(te.length*Math.random())],we=[],fe=[],De=[];for(let Se of te){const Ce=ae(Se,ue);Ce<0?we.push(Se):Ce>0?fe.push(Se):De.push(Se)}return F<we.length?I(F,we,ae):F<we.length+De.length?De[0]:I(F-(we.length+De.length),fe,ae)}e.quickSelect=I;function i(F,te){return S(F,te,0,F.length-1,[]),F}e.mergeSort=i;function P(F,te,ae,ue,we,fe){let De=ae,Se=ue+1;for(let Ce=ae;Ce<=we;Ce++)fe[Ce]=F[Ce];for(let Ce=ae;Ce<=we;Ce++)De>ue?F[Ce]=fe[Se++]:Se>we?F[Ce]=fe[De++]:te(fe[Se],fe[De])<0?F[Ce]=fe[Se++]:F[Ce]=fe[De++]}function S(F,te,ae,ue,we){if(!(ue<=ae)){const fe=ae+(ue-ae)/2|0;S(F,te,ae,fe,we),S(F,te,fe+1,ue,we),!(te(F[fe],F[fe+1])<=0)&&P(F,te,ae,fe,ue,we)}}function v(F,te){const ae=[];let ue;for(const we of i(F.slice(0),te))!ue||te(ue[0],we)!==0?(ue=[we],ae.push(ue)):ue.push(we);return ae}e.groupBy=v;function d(F,te,ae){const ue=[];function we(Se,Ce,x){if(!(Ce===0&&x.length===0)){const K=ue[ue.length-1];K&&K.start+K.deleteCount===Se?(K.deleteCount+=Ce,K.toInsert.push(...x)):ue.push({start:Se,deleteCount:Ce,toInsert:x})}}let fe=0,De=0;for(;;){if(fe===F.length){we(fe,0,te.slice(De));break}if(De===te.length){we(fe,F.length-fe,[]);break}const Se=F[fe],Ce=te[De],x=ae(Se,Ce);x===0?(fe+=1,De+=1):x<0?(we(fe,1,[]),fe+=1):x>0&&(we(fe,0,[Ce]),De+=1)}return ue}e.sortedDiff=d;function a(F,te,ae){const ue=d(F,te,ae),we=[],fe=[];for(const De of ue)we.push(...F.slice(De.start,De.start+De.deleteCount)),fe.push(...De.toInsert);return{removed:we,added:fe}}e.delta=a;function m(F,te,ae){if(ae===0)return[];const ue=F.slice(0,ae).sort(te);return f(F,te,ue,ae,F.length),ue}e.top=m;function p(F,te,ae,ue,we){return ae===0?Promise.resolve([]):new Promise((fe,De)=>{(async()=>{const Se=F.length,Ce=F.slice(0,ae).sort(te);for(let x=ae,K=Math.min(ae+ue,Se);x<Se;x=K,K=Math.min(K+ue,Se)){if(x>ae&&await new Promise(ee=>setTimeout(ee)),we&&we.isCancellationRequested)throw b.canceled();f(F,te,Ce,x,K)}return Ce})().then(fe,De)})}e.topAsync=p;function f(F,te,ae,ue,we){for(const fe=ae.length;ue<we;ue++){const De=F[ue];if(te(De,ae[fe-1])<0){ae.pop();const Se=k(ae,Ce=>te(De,Ce)<0);ae.splice(Se,0,De)}}}function c(F){return F.filter(te=>!!te)}e.coalesce=c;function n(F){let te=0;for(let ae=0;ae<F.length;ae++)F[ae]&&(F[te]=F[ae],te+=1);F.length=te}e.coalesceInPlace=n;function o(F,te,ae){F.splice(ae,0,F.splice(te,1)[0])}e.move=o;function h(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=h;function t(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=t;function s(F,te){if(!te)return F.filter((ue,we)=>F.indexOf(ue)===we);const ae=Object.create(null);return F.filter(ue=>{const we=te(ue);return ae[we]?!1:(ae[we]=!0,!0)})}e.distinct=s;function l(F){const te=new Set;return F.filter(ae=>te.has(ae)?!1:(te.add(ae),!0))}e.distinctES6=l;function u(F){const te=Object.create(null);return ae=>{const ue=F(ae);return te[ue]?!1:(te[ue]=!0,!0)}}e.uniqueFilter=u;function r(F,te){for(let ae=F.length-1;ae>=0;ae--){const ue=F[ae];if(te(ue))return ae}return-1}e.lastIndex=r;function g(F,te){return F.length>0?F[0]:te}e.firstOrDefault=g;function C(F,te,ae=(ue,we)=>ue===we){let ue=0;for(let we=0,fe=Math.min(F.length,te.length);we<fe&&ae(F[we],te[we]);we++)ue++;return ue}e.commonPrefixLength=C;function _(F){return[].concat(...F)}e.flatten=_;function D(F,te){let ae=typeof te=="number"?F:0;typeof te=="number"?ae=F:(ae=0,te=F);const ue=[];if(ae<=te)for(let we=ae;we<te;we++)ue.push(we);else for(let we=ae;we>te;we--)ue.push(we);return ue}e.range=D;function w(F,te,ae){return F.reduce((ue,we)=>(ue[te(we)]=ae?ae(we):we,ue),Object.create(null))}e.index=w;function O(F,te){return F.push(te),()=>R(F,te)}e.insert=O;function R(F,te){const ae=F.indexOf(te);if(ae>-1)return F.splice(ae,1),te}e.remove=R;function $(F,te,ae){const ue=F.slice(0,te),we=F.slice(te);return ue.concat(ae,we)}e.arrayInsert=$;function V(F,te){let ae;if(typeof te=="number"){let ue=te;ae=()=>{const we=Math.sin(ue++)*179426549;return we-Math.floor(we)}}else ae=Math.random;for(let ue=F.length-1;ue>0;ue-=1){const we=Math.floor(ae()*(ue+1)),fe=F[ue];F[ue]=F[we],F[we]=fe}}e.shuffle=V;function z(F,te){const ae=F.indexOf(te);ae>-1&&(F.splice(ae,1),F.unshift(te))}e.pushToStart=z;function U(F,te){const ae=F.indexOf(te);ae>-1&&(F.splice(ae,1),F.push(te))}e.pushToEnd=U;function q(F,te){return Array.isArray(F)?F.map(te):te(F)}e.mapArrayOrNot=q;function M(F){return Array.isArray(F)?F:[F]}e.asArray=M;function j(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=j;function re(F,te){for(const ae of F){const ue=te(ae);if(ue!==void 0)return ue}}e.mapFind=re}),define(ve[51],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function b(y){const A=this;let T=!1,E;return function(){return T||(T=!0,E=y.apply(A,arguments)),E}}e.once=b}),define(ve[52],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class b{constructor(A){this._prefix=A,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=b,e.defaultGenerator=new b("id#")}),define(ve[53],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(y){function A(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}y.is=A;const T=Object.freeze([]);function E(){return T}y.empty=E;function*k(c){yield c}y.single=k;function I(c){return c||T}y.from=I;function i(c){return!c||c[Symbol.iterator]().next().done===!0}y.isEmpty=i;function P(c){return c[Symbol.iterator]().next().value}y.first=P;function S(c,n){for(const o of c)if(n(o))return!0;return!1}y.some=S;function*v(c,n){for(const o of c)n(o)&&(yield o)}y.filter=v;function*d(c,n){for(const o of c)yield n(o)}y.map=d;function*a(...c){for(const n of c)for(const o of n)yield o}y.concat=a;function*m(c){for(const n of c)for(const o of n)yield o}y.concatNested=m;function*p(c,n,o=c.length){for(n<0&&(n+=c.length),o<0?o+=c.length:o>c.length&&(o=c.length);n<o;n++)yield c[n]}y.slice=p;function f(c,n=Number.POSITIVE_INFINITY){const o=[];if(n===0)return[o,c];const h=c[Symbol.iterator]();for(let t=0;t<n;t++){const s=h.next();if(s.done)return[o,y.empty()];o.push(s.value)}return[o,{[Symbol.iterator](){return h}}]}y.consume=f})(b=e.Iterable||(e.Iterable={}))}),define(ve[45],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var b;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(b=e.ScanError||(e.ScanError={}));var y;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(y=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function E(t,s=!1){let l=0,u=t.length,r="",g=0,C=16,_=0;function D(U){let q=0,M=0;for(;q<U;){const j=t.charCodeAt(l);if(j>=48&&j<=57)M=M*16+j-48;else if(j>=65&&j<=70)M=M*16+j-65+10;else if(j>=97&&j<=102)M=M*16+j-97+10;else break;l++,q++}return q<U&&(M=-1),M}function w(U){l=U,r="",g=0,C=16,_=0}function O(){const U=l;if(t.charCodeAt(l)===48)l++;else for(l++;l<t.length&&i(t.charCodeAt(l));)l++;if(l<t.length&&t.charCodeAt(l)===46)if(l++,l<t.length&&i(t.charCodeAt(l)))for(l++;l<t.length&&i(t.charCodeAt(l));)l++;else return _=3,t.substring(U,l);let q=l;if(l<t.length&&(t.charCodeAt(l)===69||t.charCodeAt(l)===101))if(l++,(l<t.length&&t.charCodeAt(l)===43||t.charCodeAt(l)===45)&&l++,l<t.length&&i(t.charCodeAt(l))){for(l++;l<t.length&&i(t.charCodeAt(l));)l++;q=l}else _=3;return t.substring(U,q)}function R(){let U="",q=l;for(;;){if(l>=u){U+=t.substring(q,l),_=2;break}const M=t.charCodeAt(l);if(M===34){U+=t.substring(q,l),l++;break}if(M===92){if(U+=t.substring(q,l),l++,l>=u){_=2;break}switch(t.charCodeAt(l++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:const re=D(4);re>=0?U+=String.fromCharCode(re):_=4;break;default:_=5}q=l;continue}if(M>=0&&M<=31)if(I(M)){U+=t.substring(q,l),_=2;break}else _=6;l++}return U}function $(){if(r="",_=0,g=l,l>=u)return g=u,C=17;let U=t.charCodeAt(l);if(k(U)){do l++,r+=String.fromCharCode(U),U=t.charCodeAt(l);while(k(U));return C=15}if(I(U))return l++,r+=String.fromCharCode(U),U===13&&t.charCodeAt(l)===10&&(l++,r+=`
`),C=14;switch(U){case 123:return l++,C=1;case 125:return l++,C=2;case 91:return l++,C=3;case 93:return l++,C=4;case 58:return l++,C=6;case 44:return l++,C=5;case 34:return l++,r=R(),C=10;case 47:const q=l-1;if(t.charCodeAt(l+1)===47){for(l+=2;l<u&&!I(t.charCodeAt(l));)l++;return r=t.substring(q,l),C=12}if(t.charCodeAt(l+1)===42){l+=2;const M=u-1;let j=!1;for(;l<M;){if(t.charCodeAt(l)===42&&t.charCodeAt(l+1)===47){l+=2,j=!0;break}l++}return j||(l++,_=1),r=t.substring(q,l),C=13}return r+=String.fromCharCode(U),l++,C=16;case 45:if(r+=String.fromCharCode(U),l++,l===u||!i(t.charCodeAt(l)))return C=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=O(),C=11;default:for(;l<u&&V(U);)l++,U=t.charCodeAt(l);if(g!==l){switch(r=t.substring(g,l),r){case"true":return C=8;case"false":return C=9;case"null":return C=7}return C=16}return r+=String.fromCharCode(U),l++,C=16}}function V(U){if(k(U)||I(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let U;do U=$();while(U>=12&&U<=15);return U}return{setPosition:w,getPosition:()=>l,scan:s?z:$,getToken:()=>C,getTokenValue:()=>r,getTokenOffset:()=>g,getTokenLength:()=>l-g,getTokenError:()=>_}}e.createScanner=E;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function I(t){return t===10||t===13||t===8232||t===8233}function i(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function S(t,s){const l=[],u=new Object;let r;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let C=!1;function _(D,w,O,R){g.value=D,g.offset=w,g.length=O,g.type=R,g.colonOffset=void 0,r=g}try{n(t,{onObjectBegin:(D,w)=>{if(s<=D)throw u;r=void 0,C=s>D,l.push("")},onObjectProperty:(D,w,O)=>{if(s<w||(_(D,w,O,"property"),l[l.length-1]=D,s<=w+O))throw u},onObjectEnd:(D,w)=>{if(s<=D)throw u;r=void 0,l.pop()},onArrayBegin:(D,w)=>{if(s<=D)throw u;r=void 0,l.push(0)},onArrayEnd:(D,w)=>{if(s<=D)throw u;r=void 0,l.pop()},onLiteralValue:(D,w,O)=>{if(s<w||(_(D,w,O,h(D)),s<=w+O))throw u},onSeparator:(D,w,O)=>{if(s<=w)throw u;if(D===":"&&r&&r.type==="property")r.colonOffset=w,C=!1,r=void 0;else if(D===","){const R=l[l.length-1];typeof R=="number"?l[l.length-1]=R+1:(C=!0,l[l.length-1]=""),r=void 0}}})}catch(D){if(D!==u)throw D}return{path:l,previousNode:r,isAtPropertyKey:C,matches:D=>{let w=0;for(let O=0;w<D.length&&O<l.length;O++)if(D[w]===l[O]||D[w]==="*")w++;else if(D[w]!=="**")return!1;return w===D.length}}}e.getLocation=S;function v(t,s=[],l=T.DEFAULT){let u=null,r=[];const g=[];function C(D){Array.isArray(r)?r.push(D):u!==null&&(r[u]=D)}return n(t,{onObjectBegin:()=>{const D={};C(D),g.push(r),r=D,u=null},onObjectProperty:D=>{u=D},onObjectEnd:()=>{r=g.pop()},onArrayBegin:()=>{const D=[];C(D),g.push(r),r=D,u=null},onArrayEnd:()=>{r=g.pop()},onLiteralValue:C,onError:(D,w,O)=>{s.push({error:D,offset:w,length:O})}},l),r[0]}e.parse=v;function d(t,s=[],l=T.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(D){u.type==="property"&&(u.length=D-u.offset,u=u.parent)}function g(D){return u.children.push(D),D}n(t,{onObjectBegin:D=>{u=g({type:"object",offset:D,length:-1,parent:u,children:[]})},onObjectProperty:(D,w,O)=>{u=g({type:"property",offset:w,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:D,offset:w,length:O,parent:u})},onObjectEnd:(D,w)=>{u.length=D+w-u.offset,u=u.parent,r(D+w)},onArrayBegin:(D,w)=>{u=g({type:"array",offset:D,length:-1,parent:u,children:[]})},onArrayEnd:(D,w)=>{u.length=D+w-u.offset,u=u.parent,r(D+w)},onLiteralValue:(D,w,O)=>{g({type:h(D),offset:w,length:O,parent:u,value:D}),r(w+O)},onSeparator:(D,w,O)=>{u.type==="property"&&(D===":"?u.colonOffset=w:D===","&&r(w))},onError:(D,w,O)=>{s.push({error:D,offset:w,length:O})}},l);const _=u.children[0];return _&&delete _.parent,_}e.parseTree=d;function a(t,s){if(!!t){let l=t;for(let u of s)if(typeof u=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let r=!1;for(const g of l.children)if(Array.isArray(g.children)&&g.children[0].value===u){l=g.children[1],r=!0;break}if(!r)return}else{const r=u;if(l.type!=="array"||r<0||!Array.isArray(l.children)||r>=l.children.length)return;l=l.children[r]}return l}}e.findNodeAtLocation=a;function m(t){if(!t.parent||!t.parent.children)return[];const s=m(t.parent);if(t.parent.type==="property"){const l=t.parent.children[0].value;s.push(l)}else if(t.parent.type==="array"){const l=t.parent.children.indexOf(t);l!==-1&&s.push(l)}return s}e.getNodePath=m;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":const s=Object.create(null);for(let l of t.children){const u=l.children[1];u&&(s[l.children[0].value]=p(u))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=p;function f(t,s,l=!1){return s>=t.offset&&s<t.offset+t.length||l&&s===t.offset+t.length}e.contains=f;function c(t,s,l=!1){if(f(t,s,l)){const u=t.children;if(Array.isArray(u))for(let r=0;r<u.length&&u[r].offset<=s;r++){const g=c(u[r],s,l);if(g)return g}return t}}e.findNodeAtOffset=c;function n(t,s,l=T.DEFAULT){const u=E(t,!1);function r(fe){return fe?()=>fe(u.getTokenOffset(),u.getTokenLength()):()=>!0}function g(fe){return fe?De=>fe(De,u.getTokenOffset(),u.getTokenLength()):()=>!0}const C=r(s.onObjectBegin),_=g(s.onObjectProperty),D=r(s.onObjectEnd),w=r(s.onArrayBegin),O=r(s.onArrayEnd),R=g(s.onLiteralValue),$=g(s.onSeparator),V=r(s.onComment),z=g(s.onError),U=l&&l.disallowComments,q=l&&l.allowTrailingComma;function M(){for(;;){const fe=u.scan();switch(u.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:U||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(fe){case 12:case 13:U?j(10):V();break;case 16:j(1);break;case 15:case 14:break;default:return fe}}}function j(fe,De=[],Se=[]){if(z(fe),De.length+Se.length>0){let Ce=u.getToken();for(;Ce!==17;){if(De.indexOf(Ce)!==-1){M();break}else if(Se.indexOf(Ce)!==-1)break;Ce=M()}}}function re(fe){const De=u.getTokenValue();return fe?R(De):_(De),M(),!0}function F(){switch(u.getToken()){case 11:let fe=0;try{fe=JSON.parse(u.getTokenValue()),typeof fe!="number"&&(j(2),fe=0)}catch(De){j(2)}R(fe);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return M(),!0}function te(){return u.getToken()!==10?(j(3,[],[2,5]),!1):(re(!1),u.getToken()===6?($(":"),M(),we()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function ae(){C(),M();let fe=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(fe||j(4,[],[]),$(","),M(),u.getToken()===2&&q)break}else fe&&j(6,[],[]);te()||j(4,[],[2,5]),fe=!0}return D(),u.getToken()!==2?j(7,[2],[]):M(),!0}function ue(){w(),M();let fe=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(fe||j(4,[],[]),$(","),M(),u.getToken()===4&&q)break}else fe&&j(6,[],[]);we()||j(4,[],[4,5]),fe=!0}return O(),u.getToken()!==4?j(8,[4],[]):M(),!0}function we(){switch(u.getToken()){case 3:return ue();case 1:return ae();case 10:return re(!0);default:return F()}}return M(),u.getToken()===17?l.allowEmptyContent?!0:(j(4,[],[]),!1):we()?(u.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=n;function o(t,s){let l=E(t),u=[],r,g=0,C;do switch(C=l.getPosition(),r=l.scan(),r){case 12:case 13:case 17:g!==C&&u.push(t.substring(g,C)),s!==void 0&&u.push(l.getTokenValue().replace(/[^\r\n]/g,s)),g=l.getPosition();break}while(r!==17);return u.join("")}e.stripComments=o;function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=h}),define(ve[102],_e([0,1,45]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function y(I,i,P){let S,v,d,a,m;if(i){for(a=i.offset,m=a+i.length,d=a;d>0&&!k(I,d-1);)d--;let g=m;for(;g<I.length&&!k(I,g);)g++;v=I.substring(d,g),S=T(v,P)}else v=I,S=0,d=0,a=0,m=I.length;const p=E(P,I);let f=!1,c=0,n;P.insertSpaces?n=A(" ",P.tabSize||4):n="	";const o=b.createScanner(v,!1);let h=!1;function t(){return p+A(n,S+c)}function s(){let g=o.scan();for(f=!1;g===15||g===14;)f=f||g===14,g=o.scan();return h=g===16||o.getTokenError()!==0,g}const l=[];function u(g,C,_){!h&&C<m&&_>a&&I.substring(C,_)!==g&&l.push({offset:C,length:_-C,content:g})}let r=s();if(r!==17){const g=o.getTokenOffset()+d,C=A(n,S);u(C,d,g)}for(;r!==17;){let g=o.getTokenOffset()+o.getTokenLength()+d,C=s(),_="";for(;!f&&(C===12||C===13);){const w=o.getTokenOffset()+d;u(" ",g,w),g=o.getTokenOffset()+o.getTokenLength()+d,_=C===12?t():"",C=s()}if(C===2)r!==1&&(c--,_=t());else if(C===4)r!==3&&(c--,_=t());else{switch(r){case 3:case 1:c++,_=t();break;case 5:case 12:_=t();break;case 13:f?_=t():_=" ";break;case 6:_=" ";break;case 10:if(C===6){_="";break}case 7:case 8:case 9:case 11:case 2:case 4:C===12||C===13?_=" ":C!==5&&C!==17&&(h=!0);break;case 16:h=!0;break}f&&(C===12||C===13)&&(_=t())}const D=o.getTokenOffset()+d;u(_,g,D),r=C}return l}e.format=y;function A(I,i){let P="";for(let S=0;S<i;S++)P+=I;return P}function T(I,i){let P=0,S=0;const v=i.tabSize||4;for(;P<I.length;){const d=I.charAt(P);if(d===" ")S++;else if(d==="	")S+=v;else break;P++}return Math.floor(S/v)}function E(I,i){for(let P=0;P<i.length;P++){const S=i.charAt(P);if(S==="\r")return P+1<i.length&&i.charAt(P+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return I&&I.eol||`
`}e.getEOL=E;function k(I,i){return`\r
`.indexOf(I.charAt(i))!==-1}e.isEOL=k}),define(ve[103],_e([0,1,45,102,11]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(P,S,v){return E(P,S,void 0,v)}e.removeProperty=T;function E(P,S,v,d,a){const m=S.slice(),p=[],f=b.parseTree(P,p);let c,n;for(;m.length>0&&(n=m.pop(),c=b.findNodeAtLocation(f,m),c===void 0&&v!==void 0);)typeof n=="string"?v={[n]:v}:v=[v];if(c)if(c.type==="object"&&typeof n=="string"&&Array.isArray(c.children)){const o=b.findNodeAtLocation(c,[n]);if(o!==void 0)if(v===void 0){if(!o.parent)throw new Error("Malformed AST");const h=c.children.indexOf(o.parent);let t,s=o.parent.offset+o.parent.length;if(h>0){const l=c.children[h-1];t=l.offset+l.length}else t=c.offset+1,c.children.length>1&&(s=c.children[1].offset);return k(P,{offset:t,length:s-t,content:""},d)}else return k(P,{offset:o.offset,length:o.length,content:JSON.stringify(v)},d);else{if(v===void 0)return[];const h=`${JSON.stringify(n)}: ${JSON.stringify(v)}`,t=a?a(c.children.map(l=>l.children[0].value)):c.children.length;let s;if(t>0){const l=c.children[t-1];s={offset:l.offset+l.length,length:0,content:","+h}}else c.children.length===0?s={offset:c.offset+1,length:0,content:h}:s={offset:c.offset+1,length:0,content:h+","};return k(P,s,d)}}else if(c.type==="array"&&typeof n=="number"&&Array.isArray(c.children))if(v!==void 0){const o=`${JSON.stringify(v)}`;let h;if(c.children.length===0||n===0)h={offset:c.offset+1,length:0,content:c.children.length===0?o:o+","};else{const t=n===-1||n>c.children.length?c.children.length:n,s=c.children[t-1];h={offset:s.offset+s.length,length:0,content:","+o}}return k(P,h,d)}else{const o=n,h=c.children[o];let t;if(c.children.length===1)t={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===o){const s=c.children[o-1],l=s.offset+s.length,u=c.offset+c.length;t={offset:l,length:u-2-l,content:""}}else t={offset:h.offset,length:c.children[o+1].offset-h.offset,content:""};return k(P,t,d)}else throw new Error(`Can not add ${typeof n!="number"?"index":"property"} to parent of type ${c.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return k(P,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(v)},d)}}e.setProperty=E;function k(P,S,v){let d=I(P,S),a=S.offset,m=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;a>0&&!y.isEOL(d,a-1);)a--;for(;m<d.length&&!y.isEOL(d,m);)m++}const p=y.format(d,{offset:a,length:m-a},v);for(let c=p.length-1;c>=0;c--){const n=p[c];d=I(d,n),a=Math.min(a,n.offset),m=Math.max(m,n.offset+n.length),m+=n.content.length-n.length}const f=P.length-(d.length-m)-a;return[{offset:a,length:f,content:d.substring(a,m)}]}e.withFormatting=k;function I(P,S){return P.substring(0,S.offset)+S.content+P.substring(S.offset+S.length)}e.applyEdit=I;function i(P,S){let v=A.mergeSort(S,(a,m)=>{const p=a.offset-m.offset;return p===0?a.length-m.length:p}),d=P.length;for(let a=v.length-1;a>=0;a--){let m=v[a];if(m.offset+m.length<=d)P=I(P,m);else throw new Error("Overlapping edit");d=m.offset}return P}e.applyEdits=i}),define(ve[6],_e([0,1,51,53]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let T=null;function E(n){T=n}if(e.setDisposableTracker=E,A){const n="__is_disposable_tracked__";T=new class{trackDisposable(o){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[n]||console.log(h)},3e3)}markTracked(o){if(o&&o!==m.None)try{o[n]=!0}catch(h){}}}}function k(n){!T||T.markTracked(n)}function I(n){return T&&T.trackDisposable(n),n}e.trackDisposable=I;class i extends Error{constructor(o){super(`Encounter errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=i;function P(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=P;function S(n){if(y.Iterable.is(n)){let o=[];for(const h of n)if(h){k(h);try{h.dispose()}catch(t){o.push(t)}}if(o.length===1)throw o[0];if(o.length>1)throw new i(o);return Array.isArray(n)?[]:n}else if(n)return k(n),n.dispose(),n}e.dispose=S;function v(...n){return n.forEach(k),d(()=>S(n))}e.combinedDisposable=v;function d(n){const o=I({dispose:()=>{k(o),n()}});return o}e.toDisposable=d;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(k(this),this._isDisposed=!0,this.clear())}clear(){try{S(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return k(o),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new a,I(this)}dispose(){k(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value&&this._value.dispose(),o&&k(o),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,k(this),this._value&&this._value.dispose(),this._value=void 0}}e.MutableDisposable=p;class f{constructor(){this.references=new Map}acquire(o,...h){let t=this.references.get(o);t||(t={counter:0,object:this.createReferencedObject(o,...h)},this.references.set(o,t));const{object:s}=t,l=b.once(()=>{--t.counter==0&&(this.destroyReferencedObject(o,t.object),this.references.delete(o))});return t.counter++,{object:s,dispose:l}}}e.ReferenceCollection=f;class c{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=c}),define(ve[54],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class b{constructor(T){this.element=T,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class y{constructor(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===b.Undefined}clear(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,E){const k=new b(T);if(this._first===b.Undefined)this._first=k,this._last=k;else if(E){const i=this._last;this._last=k,k.prev=i,i.next=k}else{const i=this._first;this._first=k,k.next=i,i.prev=k}this._size+=1;let I=!1;return()=>{I||(I=!0,this._remove(k))}}shift(){if(this._first!==b.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==b.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==b.Undefined&&T.next!==b.Undefined){const E=T.prev;E.next=T.next,T.next.prev=E}else T.prev===b.Undefined&&T.next===b.Undefined?(this._first=b.Undefined,this._last=b.Undefined):T.next===b.Undefined?(this._last=this._last.prev,this._last.next=b.Undefined):T.prev===b.Undefined&&(this._first=this._first.next,this._first.prev=b.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==b.Undefined;)yield T.element,T=T.next}}e.LinkedList=y}),function(se,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(se=typeof globalThis!="undefined"?globalThis:se||self,se.marked=e())}(this,function(){"use strict";function se(G,Q){for(var H=0;H<Q.length;H++){var L=Q[H];L.enumerable=L.enumerable||!1,L.configurable=!0,"value"in L&&(L.writable=!0),Object.defineProperty(G,L.key,L)}}function e(G,Q,H){return Q&&se(G.prototype,Q),H&&se(G,H),G}function b(G,Q){if(!!G){if(typeof G=="string")return y(G,Q);var H=Object.prototype.toString.call(G).slice(8,-1);if(H==="Object"&&G.constructor&&(H=G.constructor.name),H==="Map"||H==="Set")return Array.from(G);if(H==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(H))return y(G,Q)}}function y(G,Q){(Q==null||Q>G.length)&&(Q=G.length);for(var H=0,L=new Array(Q);H<Q;H++)L[H]=G[H];return L}function A(G,Q){var H;if(typeof Symbol=="undefined"||G[Symbol.iterator]==null){if(Array.isArray(G)||(H=b(G))||Q&&G&&typeof G.length=="number"){H&&(G=H);var L=0;return function(){return L>=G.length?{done:!0}:{done:!1,value:G[L++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return H=G[Symbol.iterator](),H.next.bind(H)}function T(G,Q){return Q={exports:{}},G(Q,Q.exports),Q.exports}var E=T(function(G){function Q(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function H(L){G.exports.defaults=L}G.exports={defaults:Q(),getDefaults:Q,changeDefaults:H}}),k=E.defaults,I=E.getDefaults,i=E.changeDefaults,P=/[&<>"']/,S=/[&<>"']/g,v=/[<>"']|&(?!#?\w+;)/,d=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(Q){return a[Q]};function p(G,Q){if(Q){if(P.test(G))return G.replace(S,m)}else if(v.test(G))return G.replace(d,m);return G}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(G){return G.replace(f,function(Q,H){return H=H.toLowerCase(),H==="colon"?":":H.charAt(0)==="#"?H.charAt(1)==="x"?String.fromCharCode(parseInt(H.substring(2),16)):String.fromCharCode(+H.substring(1)):""})}var n=/(^|[^\[])\^/g;function o(G,Q){G=G.source||G,Q=Q||"";var H={replace:function(J,X){return X=X.source||X,X=X.replace(n,"$1"),G=G.replace(J,X),H},getRegex:function(){return new RegExp(G,Q)}};return H}var h=/[^\w:]/g,t=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function s(G,Q,H){if(G){var L;try{L=decodeURIComponent(c(H)).replace(h,"").toLowerCase()}catch(J){return null}if(L.indexOf("javascript:")===0||L.indexOf("vbscript:")===0||L.indexOf("data:")===0)return null}Q&&!t.test(H)&&(H=C(Q,H));try{H=encodeURI(H).replace(/%25/g,"%")}catch(J){return null}return H}var l={},u=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,g=/^([^:]+:\/*[^/]*)[\s\S]*$/;function C(G,Q){l[" "+G]||(u.test(G)?l[" "+G]=G+"/":l[" "+G]=O(G,"/",!0)),G=l[" "+G];var H=G.indexOf(":")===-1;return Q.substring(0,2)==="//"?H?Q:G.replace(r,"$1")+Q:Q.charAt(0)==="/"?H?Q:G.replace(g,"$1")+Q:G+Q}var _={exec:function(){}};function D(G){for(var Q=1,H,L;Q<arguments.length;Q++){H=arguments[Q];for(L in H)Object.prototype.hasOwnProperty.call(H,L)&&(G[L]=H[L])}return G}function w(G,Q){var H=G.replace(/\|/g,function(X,ce,me){for(var Pe=!1,Fe=ce;--Fe>=0&&me[Fe]==="\\";)Pe=!Pe;return Pe?"|":" |"}),L=H.split(/ \|/),J=0;if(L.length>Q)L.splice(Q);else for(;L.length<Q;)L.push("");for(;J<L.length;J++)L[J]=L[J].trim().replace(/\\\|/g,"|");return L}function O(G,Q,H){var L=G.length;if(L===0)return"";for(var J=0;J<L;){var X=G.charAt(L-J-1);if(X===Q&&!H)J++;else if(X!==Q&&H)J++;else break}return G.substr(0,L-J)}function R(G,Q){if(G.indexOf(Q[1])===-1)return-1;for(var H=G.length,L=0,J=0;J<H;J++)if(G[J]==="\\")J++;else if(G[J]===Q[0])L++;else if(G[J]===Q[1]&&(L--,L<0))return J;return-1}function $(G){G&&G.sanitize&&!G.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function V(G,Q){if(Q<1)return"";for(var H="";Q>1;)Q&1&&(H+=G),Q>>=1,G+=G;return H+G}var z={escape:p,unescape:c,edit:o,cleanUrl:s,resolveUrl:C,noopTest:_,merge:D,splitCells:w,rtrim:O,findClosingBracket:R,checkSanitizeDeprecation:$,repeatString:V},U=E.defaults,q=z.rtrim,M=z.splitCells,j=z.escape,re=z.findClosingBracket;function F(G,Q,H){var L=Q.href,J=Q.title?j(Q.title):null,X=G[1].replace(/\\([\[\]])/g,"$1");return G[0].charAt(0)!=="!"?{type:"link",raw:H,href:L,title:J,text:X}:{type:"image",raw:H,href:L,title:J,text:j(X)}}function te(G,Q){var H=G.match(/^(\s+)(?:```)/);if(H===null)return Q;var L=H[1];return Q.split(`
`).map(function(J){var X=J.match(/^\s+/);if(X===null)return J;var ce=X[0];return ce.length>=L.length?J.slice(L.length):J}).join(`
`)}var ae=function(){function G(H){this.options=H||U}var Q=G.prototype;return Q.space=function(L){var J=this.rules.block.newline.exec(L);if(J)return J[0].length>1?{type:"space",raw:J[0]}:{raw:`
`}},Q.code=function(L,J){var X=this.rules.block.code.exec(L);if(X){var ce=J[J.length-1];if(ce&&ce.type==="paragraph")return{raw:X[0],text:X[0].trimRight()};var me=X[0].replace(/^ {4}/gm,"");return{type:"code",raw:X[0],codeBlockStyle:"indented",text:this.options.pedantic?me:q(me,`
`)}}},Q.fences=function(L){var J=this.rules.block.fences.exec(L);if(J){var X=J[0],ce=te(X,J[3]||"");return{type:"code",raw:X,lang:J[2]?J[2].trim():J[2],text:ce}}},Q.heading=function(L){var J=this.rules.block.heading.exec(L);if(J)return{type:"heading",raw:J[0],depth:J[1].length,text:J[2]}},Q.nptable=function(L){var J=this.rules.block.nptable.exec(L);if(J){var X={type:"table",header:M(J[1].replace(/^ *| *\| *$/g,"")),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:J[3]?J[3].replace(/\n$/,"").split(`
`):[],raw:J[0]};if(X.header.length===X.align.length){var ce=X.align.length,me;for(me=0;me<ce;me++)/^ *-+: *$/.test(X.align[me])?X.align[me]="right":/^ *:-+: *$/.test(X.align[me])?X.align[me]="center":/^ *:-+ *$/.test(X.align[me])?X.align[me]="left":X.align[me]=null;for(ce=X.cells.length,me=0;me<ce;me++)X.cells[me]=M(X.cells[me],X.header.length);return X}}},Q.hr=function(L){var J=this.rules.block.hr.exec(L);if(J)return{type:"hr",raw:J[0]}},Q.blockquote=function(L){var J=this.rules.block.blockquote.exec(L);if(J){var X=J[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:J[0],text:X}}},Q.list=function(L){var J=this.rules.block.list.exec(L);if(J){for(var X=J[0],ce=J[2],me=ce.length>1,Pe=ce[ce.length-1]===")",Fe={type:"list",raw:X,ordered:me,start:me?+ce.slice(0,-1):"",loose:!1,items:[]},je=J[0].match(this.rules.block.item),qe=!1,Ge,st,$e,Qe,ht,et,ft,ot=je.length,Ze=0;Ze<ot;Ze++)Ge=je[Ze],X=Ge,st=Ge.length,Ge=Ge.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ge.indexOf(`
 `)&&(st-=Ge.length,Ge=this.options.pedantic?Ge.replace(/^ {1,4}/gm,""):Ge.replace(new RegExp("^ {1,"+st+"}","gm"),"")),Ze!==ot-1&&($e=this.rules.block.bullet.exec(je[Ze+1])[0],(me?$e.length===1||!Pe&&$e[$e.length-1]===")":$e.length>1||this.options.smartLists&&$e!==ce)&&(Qe=je.slice(Ze+1).join(`
`),Fe.raw=Fe.raw.substring(0,Fe.raw.length-Qe.length),Ze=ot-1)),ht=qe||/\n\n(?!\s*$)/.test(Ge),Ze!==ot-1&&(qe=Ge.charAt(Ge.length-1)===`
`,ht||(ht=qe)),ht&&(Fe.loose=!0),et=/^\[[ xX]\] /.test(Ge),ft=void 0,et&&(ft=Ge[1]!==" ",Ge=Ge.replace(/^\[[ xX]\] +/,"")),Fe.items.push({type:"list_item",raw:X,task:et,checked:ft,loose:ht,text:Ge});return Fe}},Q.html=function(L){var J=this.rules.block.html.exec(L);if(J)return{type:this.options.sanitize?"paragraph":"html",raw:J[0],pre:!this.options.sanitizer&&(J[1]==="pre"||J[1]==="script"||J[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):j(J[0]):J[0]}},Q.def=function(L){var J=this.rules.block.def.exec(L);if(J){J[3]&&(J[3]=J[3].substring(1,J[3].length-1));var X=J[1].toLowerCase().replace(/\s+/g," ");return{tag:X,raw:J[0],href:J[2],title:J[3]}}},Q.table=function(L){var J=this.rules.block.table.exec(L);if(J){var X={type:"table",header:M(J[1].replace(/^ *| *\| *$/g,"")),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:J[3]?J[3].replace(/\n$/,"").split(`
`):[]};if(X.header.length===X.align.length){X.raw=J[0];var ce=X.align.length,me;for(me=0;me<ce;me++)/^ *-+: *$/.test(X.align[me])?X.align[me]="right":/^ *:-+: *$/.test(X.align[me])?X.align[me]="center":/^ *:-+ *$/.test(X.align[me])?X.align[me]="left":X.align[me]=null;for(ce=X.cells.length,me=0;me<ce;me++)X.cells[me]=M(X.cells[me].replace(/^ *\| *| *\| *$/g,""),X.header.length);return X}}},Q.lheading=function(L){var J=this.rules.block.lheading.exec(L);if(J)return{type:"heading",raw:J[0],depth:J[2].charAt(0)==="="?1:2,text:J[1]}},Q.paragraph=function(L){var J=this.rules.block.paragraph.exec(L);if(J)return{type:"paragraph",raw:J[0],text:J[1].charAt(J[1].length-1)===`
`?J[1].slice(0,-1):J[1]}},Q.text=function(L,J){var X=this.rules.block.text.exec(L);if(X){var ce=J[J.length-1];return ce&&ce.type==="text"?{raw:X[0],text:X[0]}:{type:"text",raw:X[0],text:X[0]}}},Q.escape=function(L){var J=this.rules.inline.escape.exec(L);if(J)return{type:"escape",raw:J[0],text:j(J[1])}},Q.tag=function(L,J,X){var ce=this.rules.inline.tag.exec(L);if(ce)return!J&&/^<a /i.test(ce[0])?J=!0:J&&/^<\/a>/i.test(ce[0])&&(J=!1),!X&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?X=!0:X&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(X=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:J,inRawBlock:X,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):j(ce[0]):ce[0]}},Q.link=function(L){var J=this.rules.inline.link.exec(L);if(J){var X=re(J[2],"()");if(X>-1){var ce=J[0].indexOf("!")===0?5:4,me=ce+J[1].length+X;J[2]=J[2].substring(0,X),J[0]=J[0].substring(0,me).trim(),J[3]=""}var Pe=J[2],Fe="";if(this.options.pedantic){var je=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);je?(Pe=je[1],Fe=je[3]):Fe=""}else Fe=J[3]?J[3].slice(1,-1):"";Pe=Pe.trim().replace(/^<([\s\S]*)>$/,"$1");var qe=F(J,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:Fe&&Fe.replace(this.rules.inline._escapes,"$1")},J[0]);return qe}},Q.reflink=function(L,J){var X;if((X=this.rules.inline.reflink.exec(L))||(X=this.rules.inline.nolink.exec(L))){var ce=(X[2]||X[1]).replace(/\s+/g," ");if(ce=J[ce.toLowerCase()],!ce||!ce.href){var me=X[0].charAt(0);return{type:"text",raw:me,text:me}}var Pe=F(X,ce,X[0]);return Pe}},Q.strong=function(L,J,X){X===void 0&&(X="");var ce=this.rules.inline.strong.start.exec(L);if(ce&&(!ce[1]||ce[1]&&(X===""||this.rules.inline.punctuation.exec(X)))){J=J.slice(-1*L.length);var me=ce[0]==="**"?this.rules.inline.strong.endAst:this.rules.inline.strong.endUnd;me.lastIndex=0;for(var Pe;(ce=me.exec(J))!=null;)if(Pe=this.rules.inline.strong.middle.exec(J.slice(0,ce.index+3)),Pe)return{type:"strong",raw:L.slice(0,Pe[0].length),text:L.slice(2,Pe[0].length-2)}}},Q.em=function(L,J,X){X===void 0&&(X="");var ce=this.rules.inline.em.start.exec(L);if(ce&&(!ce[1]||ce[1]&&(X===""||this.rules.inline.punctuation.exec(X)))){J=J.slice(-1*L.length);var me=ce[0]==="*"?this.rules.inline.em.endAst:this.rules.inline.em.endUnd;me.lastIndex=0;for(var Pe;(ce=me.exec(J))!=null;)if(Pe=this.rules.inline.em.middle.exec(J.slice(0,ce.index+2)),Pe)return{type:"em",raw:L.slice(0,Pe[0].length),text:L.slice(1,Pe[0].length-1)}}},Q.codespan=function(L){var J=this.rules.inline.code.exec(L);if(J){var X=J[2].replace(/\n/g," "),ce=/[^ ]/.test(X),me=X.startsWith(" ")&&X.endsWith(" ");return ce&&me&&(X=X.substring(1,X.length-1)),X=j(X,!0),{type:"codespan",raw:J[0],text:X}}},Q.br=function(L){var J=this.rules.inline.br.exec(L);if(J)return{type:"br",raw:J[0]}},Q.del=function(L){var J=this.rules.inline.del.exec(L);if(J)return{type:"del",raw:J[0],text:J[1]}},Q.autolink=function(L,J){var X=this.rules.inline.autolink.exec(L);if(X){var ce,me;return X[2]==="@"?(ce=j(this.options.mangle?J(X[1]):X[1]),me="mailto:"+ce):(ce=j(X[1]),me=ce),{type:"link",raw:X[0],text:ce,href:me,tokens:[{type:"text",raw:ce,text:ce}]}}},Q.url=function(L,J){var X;if(X=this.rules.inline.url.exec(L)){var ce,me;if(X[2]==="@")ce=j(this.options.mangle?J(X[0]):X[0]),me="mailto:"+ce;else{var Pe;do Pe=X[0],X[0]=this.rules.inline._backpedal.exec(X[0])[0];while(Pe!==X[0]);ce=j(X[0]),X[1]==="www."?me="http://"+ce:me=ce}return{type:"link",raw:X[0],text:ce,href:me,tokens:[{type:"text",raw:ce,text:ce}]}}},Q.inlineText=function(L,J,X){var ce=this.rules.inline.text.exec(L);if(ce){var me;return J?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):j(ce[0]):ce[0]:me=j(this.options.smartypants?X(ce[0]):ce[0]),{type:"text",raw:ce[0],text:me}}},G}(),ue=z.noopTest,we=z.edit,fe=z.merge,De={newline:/^\n+/,code:/^( {4}[^\n]+\n*)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6}) +([^\n]*?)(?: +#+)? *(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?!\1bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:ue,table:ue,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html)[^\n]+)*)/,text:/^[^\n]+/};De._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,De._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,De.def=we(De.def).replace("label",De._label).replace("title",De._title).getRegex(),De.bullet=/(?:[*+-]|\d{1,9}[.)])/,De.item=/^( *)(bull) ?[^\n]*(?:\n(?!\1bull ?)[^\n]*)*/,De.item=we(De.item,"gm").replace(/bull/g,De.bullet).getRegex(),De.list=we(De.list).replace(/bull/g,De.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+De.def.source+")").getRegex(),De._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",De._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,De.html=we(De.html,"i").replace("comment",De._comment).replace("tag",De._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),De.paragraph=we(De._paragraph).replace("hr",De.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",De._tag).getRegex(),De.blockquote=we(De.blockquote).replace("paragraph",De.paragraph).getRegex(),De.normal=fe({},De),De.gfm=fe({},De.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),De.gfm.nptable=we(De.gfm.nptable).replace("hr",De.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",De._tag).getRegex(),De.gfm.table=we(De.gfm.table).replace("hr",De.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",De._tag).getRegex(),De.pedantic=fe({},De.normal,{html:we(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",De._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^ *(#{1,6}) *([^\n]+?) *(?:#+ *)?(?:\n+|$)/,fences:ue,paragraph:we(De.normal._paragraph).replace("hr",De.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",De.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:ue,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",strong:{start:/^(?:(\*\*(?=[*punctuation]))|\*\*)(?![\s])|__/,middle:/^\*\*(?:(?:(?!overlapSkip)(?:[^*]|\\\*)|overlapSkip)|\*(?:(?!overlapSkip)(?:[^*]|\\\*)|overlapSkip)*?\*)+?\*\*$|^__(?![\s])((?:(?:(?!overlapSkip)(?:[^_]|\\_)|overlapSkip)|_(?:(?!overlapSkip)(?:[^_]|\\_)|overlapSkip)*?_)+?)__$/,endAst:/[^punctuation\s]\*\*(?!\*)|[punctuation]\*\*(?!\*)(?:(?=[punctuation_\s]|$))/,endUnd:/[^\s]__(?!_)(?:(?=[punctuation*\s])|$)/},em:{start:/^(?:(\*(?=[punctuation]))|\*)(?![*\s])|_/,middle:/^\*(?:(?:(?!overlapSkip)(?:[^*]|\\\*)|overlapSkip)|\*(?:(?!overlapSkip)(?:[^*]|\\\*)|overlapSkip)*?\*)+?\*$|^_(?![_\s])(?:(?:(?!overlapSkip)(?:[^_]|\\_)|overlapSkip)|_(?:(?!overlapSkip)(?:[^_]|\\_)|overlapSkip)*?_)+?_$/,endAst:/[^punctuation\s]\*(?!\*)|[punctuation]\*(?!\*)(?:(?=[punctuation_\s]|$))/,endUnd:/[^\s]_(?!_)(?:(?=[punctuation*\s])|$)/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:ue,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\s*punctuation])/};Se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Se.punctuation=we(Se.punctuation).replace(/punctuation/g,Se._punctuation).getRegex(),Se._blockSkip="\\[[^\\]]*?\\]\\([^\\)]*?\\)|`[^`]*?`|<[^>]*?>",Se._overlapSkip="__[^_]*?__|\\*\\*\\[^\\*\\]*?\\*\\*",Se._comment=we(De._comment).replace("(?:-->|$)","-->").getRegex(),Se.em.start=we(Se.em.start).replace(/punctuation/g,Se._punctuation).getRegex(),Se.em.middle=we(Se.em.middle).replace(/punctuation/g,Se._punctuation).replace(/overlapSkip/g,Se._overlapSkip).getRegex(),Se.em.endAst=we(Se.em.endAst,"g").replace(/punctuation/g,Se._punctuation).getRegex(),Se.em.endUnd=we(Se.em.endUnd,"g").replace(/punctuation/g,Se._punctuation).getRegex(),Se.strong.start=we(Se.strong.start).replace(/punctuation/g,Se._punctuation).getRegex(),Se.strong.middle=we(Se.strong.middle).replace(/punctuation/g,Se._punctuation).replace(/overlapSkip/g,Se._overlapSkip).getRegex(),Se.strong.endAst=we(Se.strong.endAst,"g").replace(/punctuation/g,Se._punctuation).getRegex(),Se.strong.endUnd=we(Se.strong.endUnd,"g").replace(/punctuation/g,Se._punctuation).getRegex(),Se.blockSkip=we(Se._blockSkip,"g").getRegex(),Se.overlapSkip=we(Se._overlapSkip,"g").getRegex(),Se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Se.autolink=we(Se.autolink).replace("scheme",Se._scheme).replace("email",Se._email).getRegex(),Se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Se.tag=we(Se.tag).replace("comment",Se._comment).replace("attribute",Se._attribute).getRegex(),Se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Se._href=/<(?:\\[<>]?|[^\s<>\\])*>|[^\s\x00-\x1f]*/,Se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Se.link=we(Se.link).replace("label",Se._label).replace("href",Se._href).replace("title",Se._title).getRegex(),Se.reflink=we(Se.reflink).replace("label",Se._label).getRegex(),Se.reflinkSearch=we(Se.reflinkSearch,"g").replace("reflink",Se.reflink).replace("nolink",Se.nolink).getRegex(),Se.normal=fe({},Se),Se.pedantic=fe({},Se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:we(/^!?\[(label)\]\((.*?)\)/).replace("label",Se._label).getRegex(),reflink:we(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Se._label).getRegex()}),Se.gfm=fe({},Se.normal,{escape:we(Se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^~+(?=\S)([\s\S]*?\S)~+/,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Se.gfm.url=we(Se.gfm.url,"i").replace("email",Se.gfm._extended_email).getRegex(),Se.breaks=fe({},Se.gfm,{br:we(Se.br).replace("{2,}","*").getRegex(),text:we(Se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var Ce={block:De,inline:Se},x=E.defaults,K=Ce.block,ee=Ce.inline,ne=z.repeatString;function de(G){return G.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ee(G){var Q="",H,L,J=G.length;for(H=0;H<J;H++)L=G.charCodeAt(H),Math.random()>.5&&(L="x"+L.toString(16)),Q+="&#"+L+";";return Q}var Re=function(){function G(H){this.tokens=[],this.tokens.links=Object.create(null),this.options=H||x,this.options.tokenizer=this.options.tokenizer||new ae,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var L={block:K.normal,inline:ee.normal};this.options.pedantic?(L.block=K.pedantic,L.inline=ee.pedantic):this.options.gfm&&(L.block=K.gfm,this.options.breaks?L.inline=ee.breaks:L.inline=ee.gfm),this.tokenizer.rules=L}G.lex=function(L,J){var X=new G(J);return X.lex(L)},G.lexInline=function(L,J){var X=new G(J);return X.inlineTokens(L)};var Q=G.prototype;return Q.lex=function(L){return L=L.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(L,this.tokens,!0),this.inline(this.tokens),this.tokens},Q.blockTokens=function(L,J,X){J===void 0&&(J=[]),X===void 0&&(X=!0),L=L.replace(/^ +$/gm,"");for(var ce,me,Pe,Fe;L;){if(ce=this.tokenizer.space(L)){L=L.substring(ce.raw.length),ce.type&&J.push(ce);continue}if(ce=this.tokenizer.code(L,J)){L=L.substring(ce.raw.length),ce.type?J.push(ce):(Fe=J[J.length-1],Fe.raw+=`
`+ce.raw,Fe.text+=`
`+ce.text);continue}if(ce=this.tokenizer.fences(L)){L=L.substring(ce.raw.length),J.push(ce);continue}if(ce=this.tokenizer.heading(L)){L=L.substring(ce.raw.length),J.push(ce);continue}if(ce=this.tokenizer.nptable(L)){L=L.substring(ce.raw.length),J.push(ce);continue}if(ce=this.tokenizer.hr(L)){L=L.substring(ce.raw.length),J.push(ce);continue}if(ce=this.tokenizer.blockquote(L)){L=L.substring(ce.raw.length),ce.tokens=this.blockTokens(ce.text,[],X),J.push(ce);continue}if(ce=this.tokenizer.list(L)){for(L=L.substring(ce.raw.length),Pe=ce.items.length,me=0;me<Pe;me++)ce.items[me].tokens=this.blockTokens(ce.items[me].text,[],!1);J.push(ce);continue}if(ce=this.tokenizer.html(L)){L=L.substring(ce.raw.length),J.push(ce);continue}if(X&&(ce=this.tokenizer.def(L))){L=L.substring(ce.raw.length),this.tokens.links[ce.tag]||(this.tokens.links[ce.tag]={href:ce.href,title:ce.title});continue}if(ce=this.tokenizer.table(L)){L=L.substring(ce.raw.length),J.push(ce);continue}if(ce=this.tokenizer.lheading(L)){L=L.substring(ce.raw.length),J.push(ce);continue}if(X&&(ce=this.tokenizer.paragraph(L))){L=L.substring(ce.raw.length),J.push(ce);continue}if(ce=this.tokenizer.text(L,J)){L=L.substring(ce.raw.length),ce.type?J.push(ce):(Fe=J[J.length-1],Fe.raw+=`
`+ce.raw,Fe.text+=`
`+ce.text);continue}if(L){var je="Infinite loop on byte: "+L.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return J},Q.inline=function(L){var J,X,ce,me,Pe,Fe,je=L.length;for(J=0;J<je;J++)switch(Fe=L[J],Fe.type){case"paragraph":case"text":case"heading":{Fe.tokens=[],this.inlineTokens(Fe.text,Fe.tokens);break}case"table":{for(Fe.tokens={header:[],cells:[]},me=Fe.header.length,X=0;X<me;X++)Fe.tokens.header[X]=[],this.inlineTokens(Fe.header[X],Fe.tokens.header[X]);for(me=Fe.cells.length,X=0;X<me;X++)for(Pe=Fe.cells[X],Fe.tokens.cells[X]=[],ce=0;ce<Pe.length;ce++)Fe.tokens.cells[X][ce]=[],this.inlineTokens(Pe[ce],Fe.tokens.cells[X][ce]);break}case"blockquote":{this.inline(Fe.tokens);break}case"list":{for(me=Fe.items.length,X=0;X<me;X++)this.inline(Fe.items[X].tokens);break}}return L},Q.inlineTokens=function(L,J,X,ce,me){J===void 0&&(J=[]),X===void 0&&(X=!1),ce===void 0&&(ce=!1),me===void 0&&(me="");var Pe,Fe=L,je;if(this.tokens.links){var qe=Object.keys(this.tokens.links);if(qe.length>0)for(;(je=this.tokenizer.rules.inline.reflinkSearch.exec(Fe))!=null;)qe.includes(je[0].slice(je[0].lastIndexOf("[")+1,-1))&&(Fe=Fe.slice(0,je.index)+"["+ne("a",je[0].length-2)+"]"+Fe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(je=this.tokenizer.rules.inline.blockSkip.exec(Fe))!=null;)Fe=Fe.slice(0,je.index)+"["+ne("a",je[0].length-2)+"]"+Fe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;L;){if(Pe=this.tokenizer.escape(L)){L=L.substring(Pe.raw.length),J.push(Pe);continue}if(Pe=this.tokenizer.tag(L,X,ce)){L=L.substring(Pe.raw.length),X=Pe.inLink,ce=Pe.inRawBlock,J.push(Pe);continue}if(Pe=this.tokenizer.link(L)){L=L.substring(Pe.raw.length),Pe.type==="link"&&(Pe.tokens=this.inlineTokens(Pe.text,[],!0,ce)),J.push(Pe);continue}if(Pe=this.tokenizer.reflink(L,this.tokens.links)){L=L.substring(Pe.raw.length),Pe.type==="link"&&(Pe.tokens=this.inlineTokens(Pe.text,[],!0,ce)),J.push(Pe);continue}if(Pe=this.tokenizer.strong(L,Fe,me)){L=L.substring(Pe.raw.length),Pe.tokens=this.inlineTokens(Pe.text,[],X,ce),J.push(Pe);continue}if(Pe=this.tokenizer.em(L,Fe,me)){L=L.substring(Pe.raw.length),Pe.tokens=this.inlineTokens(Pe.text,[],X,ce),J.push(Pe);continue}if(Pe=this.tokenizer.codespan(L)){L=L.substring(Pe.raw.length),J.push(Pe);continue}if(Pe=this.tokenizer.br(L)){L=L.substring(Pe.raw.length),J.push(Pe);continue}if(Pe=this.tokenizer.del(L)){L=L.substring(Pe.raw.length),Pe.tokens=this.inlineTokens(Pe.text,[],X,ce),J.push(Pe);continue}if(Pe=this.tokenizer.autolink(L,Ee)){L=L.substring(Pe.raw.length),J.push(Pe);continue}if(!X&&(Pe=this.tokenizer.url(L,Ee))){L=L.substring(Pe.raw.length),J.push(Pe);continue}if(Pe=this.tokenizer.inlineText(L,ce,de)){L=L.substring(Pe.raw.length),me=Pe.raw.slice(-1),J.push(Pe);continue}if(L){var Ge="Infinite loop on byte: "+L.charCodeAt(0);if(this.options.silent){console.error(Ge);break}else throw new Error(Ge)}}return J},e(G,null,[{key:"rules",get:function(){return{block:K,inline:ee}}}]),G}(),xe=E.defaults,be=z.cleanUrl,ke=z.escape,Te=function(){function G(H){this.options=H||xe}var Q=G.prototype;return Q.code=function(L,J,X){var ce=(J||"").match(/\S*/)[0];if(this.options.highlight){var me=this.options.highlight(L,ce);me!=null&&me!==L&&(X=!0,L=me)}return ce?'<pre><code class="'+this.options.langPrefix+ke(ce,!0)+'">'+(X?L:ke(L,!0))+`</code></pre>
`:"<pre><code>"+(X?L:ke(L,!0))+`</code></pre>
`},Q.blockquote=function(L){return`<blockquote>
`+L+`</blockquote>
`},Q.html=function(L){return L},Q.heading=function(L,J,X,ce){return this.options.headerIds?"<h"+J+' id="'+this.options.headerPrefix+ce.slug(X)+'">'+L+"</h"+J+`>
`:"<h"+J+">"+L+"</h"+J+`>
`},Q.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Q.list=function(L,J,X){var ce=J?"ol":"ul",me=J&&X!==1?' start="'+X+'"':"";return"<"+ce+me+`>
`+L+"</"+ce+`>
`},Q.listitem=function(L){return"<li>"+L+`</li>
`},Q.checkbox=function(L){return"<input "+(L?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Q.paragraph=function(L){return"<p>"+L+`</p>
`},Q.table=function(L,J){return J&&(J="<tbody>"+J+"</tbody>"),`<table>
<thead>
`+L+`</thead>
`+J+`</table>
`},Q.tablerow=function(L){return`<tr>
`+L+`</tr>
`},Q.tablecell=function(L,J){var X=J.header?"th":"td",ce=J.align?"<"+X+' align="'+J.align+'">':"<"+X+">";return ce+L+"</"+X+`>
`},Q.strong=function(L){return"<strong>"+L+"</strong>"},Q.em=function(L){return"<em>"+L+"</em>"},Q.codespan=function(L){return"<code>"+L+"</code>"},Q.br=function(){return this.options.xhtml?"<br/>":"<br>"},Q.del=function(L){return"<del>"+L+"</del>"},Q.link=function(L,J,X){if(L=be(this.options.sanitize,this.options.baseUrl,L),L===null)return X;var ce='<a href="'+ke(L)+'"';return J&&(ce+=' title="'+J+'"'),ce+=">"+X+"</a>",ce},Q.image=function(L,J,X){if(L=be(this.options.sanitize,this.options.baseUrl,L),L===null)return X;var ce='<img src="'+L+'" alt="'+X+'"';return J&&(ce+=' title="'+J+'"'),ce+=this.options.xhtml?"/>":">",ce},Q.text=function(L){return L},G}(),Ne=function(){function G(){}var Q=G.prototype;return Q.strong=function(L){return L},Q.em=function(L){return L},Q.codespan=function(L){return L},Q.del=function(L){return L},Q.html=function(L){return L},Q.text=function(L){return L},Q.link=function(L,J,X){return""+X},Q.image=function(L,J,X){return""+X},Q.br=function(){return""},G}(),pe=function(){function G(){this.seen={}}var Q=G.prototype;return Q.serialize=function(L){return L.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Q.getNextSafeSlug=function(L,J){var X=L,ce=0;if(this.seen.hasOwnProperty(X)){ce=this.seen[L];do ce++,X=L+"-"+ce;while(this.seen.hasOwnProperty(X))}return J||(this.seen[L]=ce,this.seen[X]=0),X},Q.slug=function(L,J){J===void 0&&(J={});var X=this.serialize(L);return this.getNextSafeSlug(X,J.dryrun)},G}(),ze=E.defaults,B=z.unescape,Z=function(){function G(H){this.options=H||ze,this.options.renderer=this.options.renderer||new Te,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ne,this.slugger=new pe}G.parse=function(L,J){var X=new G(J);return X.parse(L)},G.parseInline=function(L,J){var X=new G(J);return X.parseInline(L)};var Q=G.prototype;return Q.parse=function(L,J){J===void 0&&(J=!0);var X="",ce,me,Pe,Fe,je,qe,Ge,st,$e,Qe,ht,et,ft,ot,Ze,Et,vt,mt,at=L.length;for(ce=0;ce<at;ce++)switch(Qe=L[ce],Qe.type){case"space":continue;case"hr":{X+=this.renderer.hr();continue}case"heading":{X+=this.renderer.heading(this.parseInline(Qe.tokens),Qe.depth,B(this.parseInline(Qe.tokens,this.textRenderer)),this.slugger);continue}case"code":{X+=this.renderer.code(Qe.text,Qe.lang,Qe.escaped);continue}case"table":{for(st="",Ge="",Fe=Qe.header.length,me=0;me<Fe;me++)Ge+=this.renderer.tablecell(this.parseInline(Qe.tokens.header[me]),{header:!0,align:Qe.align[me]});for(st+=this.renderer.tablerow(Ge),$e="",Fe=Qe.cells.length,me=0;me<Fe;me++){for(qe=Qe.tokens.cells[me],Ge="",je=qe.length,Pe=0;Pe<je;Pe++)Ge+=this.renderer.tablecell(this.parseInline(qe[Pe]),{header:!1,align:Qe.align[Pe]});$e+=this.renderer.tablerow(Ge)}X+=this.renderer.table(st,$e);continue}case"blockquote":{$e=this.parse(Qe.tokens),X+=this.renderer.blockquote($e);continue}case"list":{for(ht=Qe.ordered,et=Qe.start,ft=Qe.loose,Fe=Qe.items.length,$e="",me=0;me<Fe;me++)Ze=Qe.items[me],Et=Ze.checked,vt=Ze.task,ot="",Ze.task&&(mt=this.renderer.checkbox(Et),ft?Ze.tokens.length>0&&Ze.tokens[0].type==="text"?(Ze.tokens[0].text=mt+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=mt+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:mt}):ot+=mt),ot+=this.parse(Ze.tokens,ft),$e+=this.renderer.listitem(ot,vt,Et);X+=this.renderer.list($e,ht,et);continue}case"html":{X+=this.renderer.html(Qe.text);continue}case"paragraph":{X+=this.renderer.paragraph(this.parseInline(Qe.tokens));continue}case"text":{for($e=Qe.tokens?this.parseInline(Qe.tokens):Qe.text;ce+1<at&&L[ce+1].type==="text";)Qe=L[++ce],$e+=`
`+(Qe.tokens?this.parseInline(Qe.tokens):Qe.text);X+=J?this.renderer.paragraph($e):$e;continue}default:{var ut='Token with "'+Qe.type+'" type was not found.';if(this.options.silent){console.error(ut);return}else throw new Error(ut)}}return X},Q.parseInline=function(L,J){J=J||this.renderer;var X="",ce,me,Pe=L.length;for(ce=0;ce<Pe;ce++)switch(me=L[ce],me.type){case"escape":{X+=J.text(me.text);break}case"html":{X+=J.html(me.text);break}case"link":{X+=J.link(me.href,me.title,this.parseInline(me.tokens,J));break}case"image":{X+=J.image(me.href,me.title,me.text);break}case"strong":{X+=J.strong(this.parseInline(me.tokens,J));break}case"em":{X+=J.em(this.parseInline(me.tokens,J));break}case"codespan":{X+=J.codespan(me.text);break}case"br":{X+=J.br();break}case"del":{X+=J.del(this.parseInline(me.tokens,J));break}case"text":{X+=J.text(me.text);break}default:{var Fe='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(Fe);return}else throw new Error(Fe)}}return X},G}(),he=z.merge,Le=z.checkSanitizeDeprecation,Oe=z.escape,We=E.getDefaults,Ke=E.changeDefaults,ie=E.defaults;function ge(G,Q,H){if(typeof G=="undefined"||G===null)throw new Error("marked(): input parameter is undefined or null");if(typeof G!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(G)+", string expected");if(typeof Q=="function"&&(H=Q,Q=null),Q=he({},ge.defaults,Q||{}),Le(Q),H){var L=Q.highlight,J;try{J=Re.lex(G,Q)}catch(Pe){return H(Pe)}var X=function(Fe){var je;if(!Fe)try{je=Z.parse(J,Q)}catch(qe){Fe=qe}return Q.highlight=L,Fe?H(Fe):H(null,je)};if(!L||L.length<3||(delete Q.highlight,!J.length))return X();var ce=0;ge.walkTokens(J,function(Pe){Pe.type==="code"&&(ce++,setTimeout(function(){L(Pe.text,Pe.lang,function(Fe,je){if(Fe)return X(Fe);je!=null&&je!==Pe.text&&(Pe.text=je,Pe.escaped=!0),ce--,ce===0&&X()})},0))}),ce===0&&X();return}try{var me=Re.lex(G,Q);return Q.walkTokens&&ge.walkTokens(me,Q.walkTokens),Z.parse(me,Q)}catch(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,Q.silent)return"<p>An error occurred:</p><pre>"+Oe(Pe.message+"",!0)+"</pre>";throw Pe}}ge.options=ge.setOptions=function(G){return he(ge.defaults,G),Ke(ge.defaults),ge},ge.getDefaults=We,ge.defaults=ie,ge.use=function(G){var Q=he({},G);if(G.renderer&&function(){var L=ge.defaults.renderer||new Te,J=function(me){var Pe=L[me];L[me]=function(){for(var Fe=arguments.length,je=new Array(Fe),qe=0;qe<Fe;qe++)je[qe]=arguments[qe];var Ge=G.renderer[me].apply(L,je);return Ge===!1&&(Ge=Pe.apply(L,je)),Ge}};for(var X in G.renderer)J(X);Q.renderer=L}(),G.tokenizer&&function(){var L=ge.defaults.tokenizer||new ae,J=function(me){var Pe=L[me];L[me]=function(){for(var Fe=arguments.length,je=new Array(Fe),qe=0;qe<Fe;qe++)je[qe]=arguments[qe];var Ge=G.tokenizer[me].apply(L,je);return Ge===!1&&(Ge=Pe.apply(L,je)),Ge}};for(var X in G.tokenizer)J(X);Q.tokenizer=L}(),G.walkTokens){var H=ge.defaults.walkTokens;Q.walkTokens=function(L){G.walkTokens(L),H&&H(L)}}ge.setOptions(Q)},ge.walkTokens=function(G,Q){for(var H=A(G),L;!(L=H()).done;){var J=L.value;switch(Q(J),J.type){case"table":{for(var X=A(J.tokens.header),ce;!(ce=X()).done;){var me=ce.value;ge.walkTokens(me,Q)}for(var Pe=A(J.tokens.cells),Fe;!(Fe=Pe()).done;)for(var je=Fe.value,qe=A(je),Ge;!(Ge=qe()).done;){var st=Ge.value;ge.walkTokens(st,Q)}break}case"list":{ge.walkTokens(J.items,Q);break}default:J.tokens&&ge.walkTokens(J.tokens,Q)}}},ge.parseInline=function(G,Q){if(typeof G=="undefined"||G===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof G!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(G)+", string expected");Q=he({},ge.defaults,Q||{}),Le(Q);try{var H=Re.lexInline(G,Q);return Q.walkTokens&&ge.walkTokens(H,Q.walkTokens),Z.parseInline(H,Q)}catch(L){if(L.message+=`
Please report this to https://github.com/markedjs/marked.`,Q.silent)return"<p>An error occurred:</p><pre>"+Oe(L.message+"",!0)+"</pre>";throw L}},ge.Parser=Z,ge.parser=Z.parse,ge.Renderer=Te,ge.TextRenderer=Ne,ge.Lexer=Re,ge.lexer=Re.lex,ge.Tokenizer=ae,ge.Slugger=pe,ge.parse=ge;var Me=ge;return Me}),define(ve[79],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function b(E,k,I){return Math.min(Math.max(E,k),I)}e.clamp=b;function y(E,k){return(k+E%k)%k}e.rot=y;class A{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=A;class T{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T});"use strict";function si(se){const e=[];typeof se=="number"&&e.push("code/timeOrigin",se);function b(A){e.push(A,Date.now())}function y(){const A=[];for(let T=0;T<e.length;T+=2)A.push({name:e[T],startTime:e[T+1]});return A}return{mark:b,getMarks:y}}function wi(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?si():{mark(se){performance.mark(se)},getMarks(){let se=performance.timeOrigin;typeof se!="number"&&(se=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const e=[{name:"code/timeOrigin",startTime:Math.round(se)}];for(const b of performance.getEntriesByType("mark"))e.push({name:b.name,startTime:Math.round(se+b.startTime)});return e}};if(typeof process=="object"){const se=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return si(se)}else return console.trace("perf-util loaded in UNKNOWN environment"),si()}function oi(se){return se.MonacoPerformanceMarks||(se.MonacoPerformanceMarks=wi()),se.MonacoPerformanceMarks}var At;typeof global=="object"?At=global:typeof self=="object"?At=self:At={},typeof define=="function"?define("vs/base/common/performance",[],function(){return oi(At)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=oi(At):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),At.perf=oi(At)),define(ve[21],_e([0,1]),function(se,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.globals=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=void 0;const y="en";let A=!1,T=!1,E=!1,k=!1,I=!1,i=!1,P=!1,S,v=y,d,a;const m=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof process!="undefined"?p=process:typeof m.vscode!="undefined"&&(p=m.vscode.process);const f=typeof((b=p==null?void 0:p.versions)===null||b===void 0?void 0:b.electron)=="string"&&p.type==="renderer";if(e.isElectronSandboxed=f&&(p==null?void 0:p.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=p==null?void 0:p.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!f)a=navigator.userAgent,A=a.indexOf("Windows")>=0,T=a.indexOf("Macintosh")>=0,P=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=a.indexOf("Linux")>=0,i=!0,S=navigator.language,v=S;else if(typeof p=="object"){A=p.platform==="win32",T=p.platform==="darwin",E=p.platform==="linux",k=E&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,S=y,v=y;const r=p.env.VSCODE_NLS_CONFIG;if(r)try{const g=JSON.parse(r),C=g.availableLanguages["*"];S=g.locale,v=C||y,d=g._translationsConfigFile}catch(g){}I=!0}else console.error("Unable to resolve platform.");var c;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(c=e.Platform||(e.Platform={}));function n(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=n;let o=0;T?o=1:A?o=3:E&&(o=2),e.isWindows=A,e.isMacintosh=T,e.isLinux=E,e.isLinuxSnap=k,e.isNative=I,e.isWeb=i,e.isIOS=P,e.platform=o,e.userAgent=a,e.language=v;var h;(function(r){function g(){return e.language}r.value=g;function C(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=C;function _(){return e.language==="en"}r.isDefault=_})(h=e.Language||(e.Language={})),e.locale=S,e.translationsConfigFile=d,e.globals=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let C=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeSetImmediateId)for(let w=0,O=C.length;w<O;w++){const R=C[w];if(R.id===D.data.vscodeSetImmediateId){C.splice(w,1),R.callback();return}}});let _=0;return D=>{const w=++_;C.push({id:w,callback:D}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(p)return p.nextTick.bind(p);const g=Promise.resolve();return C=>g.then(C)}();var t;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||P?2:A?1:3;let s=!0,l=!1;function u(){if(!l){l=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,s=new Uint16Array(r.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=u}),define(ve[37],_e([0,1,21]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let y;typeof process!="undefined"?y=process:typeof b.globals.vscode!="undefined"?y={get platform(){return b.globals.vscode.process.platform},get env(){return b.globals.vscode.process.env},nextTick(A){return b.setImmediate(A)},cwd(){return b.globals.vscode.process.env.VSCODE_CWD||b.globals.vscode.process.execPath.substr(0,b.globals.vscode.process.execPath.lastIndexOf(b.globals.vscode.process.platform==="win32"?"\\":"/"))}}:y={get platform(){return b.isWindows?"win32":b.isMacintosh?"darwin":"linux"},nextTick(A){return b.setImmediate(A)},get env(){return Object.create(null)},cwd(){return"/"}},e.cwd=y.cwd,e.env=y.env,e.platform=y.platform,e.nextTick=y.nextTick}),define(ve[10],_e([0,1,37]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const y=65,A=97,T=90,E=122,k=46,I=47,i=92,P=58,S=63;class v extends Error{constructor(o,h,t){let s;typeof h=="string"&&h.indexOf("not ")===0?(s="must not be",h=h.replace(/^not /,"")):s="must be";const l=o.indexOf(".")!==-1?"property":"argument";let u=`The "${o}" ${l} ${s} of type ${h}`;u+=`. Received type ${typeof t}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function d(n,o){if(typeof n!="string")throw new v(o,"string",n)}function a(n){return n===I||n===i}function m(n){return n===I}function p(n){return n>=y&&n<=T||n>=A&&n<=E}function f(n,o,h,t){let s="",l=0,u=-1,r=0,g=0;for(let C=0;C<=n.length;++C){if(C<n.length)g=n.charCodeAt(C);else{if(t(g))break;g=I}if(t(g)){if(!(u===C-1||r===1))if(r===2){if(s.length<2||l!==2||s.charCodeAt(s.length-1)!==k||s.charCodeAt(s.length-2)!==k){if(s.length>2){const _=s.lastIndexOf(h);_===-1?(s="",l=0):(s=s.slice(0,_),l=s.length-1-s.lastIndexOf(h)),u=C,r=0;continue}else if(s.length!==0){s="",l=0,u=C,r=0;continue}}o&&(s+=s.length>0?`${h}..`:"..",l=2)}else s.length>0?s+=`${h}${n.slice(u+1,C)}`:s=n.slice(u+1,C),l=C-u-1;u=C,r=0}else g===k&&r!==-1?++r:r=-1}return s}function c(n,o){if(o===null||typeof o!="object")throw new v("pathObject","Object",o);const h=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return h?h===o.root?`${h}${t}`:`${h}${n}${t}`:t}e.win32={resolve(...n){let o="",h="",t=!1;for(let s=n.length-1;s>=-1;s--){let l;if(s>=0){if(l=n[s],d(l,"path"),l.length===0)continue}else o.length===0?l=b.cwd():(l=b.env[`=${o}`]||b.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==o.toLowerCase()&&l.charCodeAt(2)===i)&&(l=`${o}\\`));const u=l.length;let r=0,g="",C=!1;const _=l.charCodeAt(0);if(u===1)a(_)&&(r=1,C=!0);else if(a(_))if(C=!0,a(l.charCodeAt(1))){let D=2,w=D;for(;D<u&&!a(l.charCodeAt(D));)D++;if(D<u&&D!==w){const O=l.slice(w,D);for(w=D;D<u&&a(l.charCodeAt(D));)D++;if(D<u&&D!==w){for(w=D;D<u&&!a(l.charCodeAt(D));)D++;(D===u||D!==w)&&(g=`\\\\${O}\\${l.slice(w,D)}`,r=D)}}}else r=1;else p(_)&&l.charCodeAt(1)===P&&(g=l.slice(0,2),r=2,u>2&&a(l.charCodeAt(2))&&(C=!0,r=3));if(g.length>0)if(o.length>0){if(g.toLowerCase()!==o.toLowerCase())continue}else o=g;if(t){if(o.length>0)break}else if(h=`${l.slice(r)}\\${h}`,t=C,C&&o.length>0)break}return h=f(h,!t,"\\",a),t?`${o}\\${h}`:`${o}${h}`||"."},normalize(n){d(n,"path");const o=n.length;if(o===0)return".";let h=0,t,s=!1;const l=n.charCodeAt(0);if(o===1)return m(l)?"\\":n;if(a(l))if(s=!0,a(n.charCodeAt(1))){let r=2,g=r;for(;r<o&&!a(n.charCodeAt(r));)r++;if(r<o&&r!==g){const C=n.slice(g,r);for(g=r;r<o&&a(n.charCodeAt(r));)r++;if(r<o&&r!==g){for(g=r;r<o&&!a(n.charCodeAt(r));)r++;if(r===o)return`\\\\${C}\\${n.slice(g)}\\`;r!==g&&(t=`\\\\${C}\\${n.slice(g,r)}`,h=r)}}}else h=1;else p(l)&&n.charCodeAt(1)===P&&(t=n.slice(0,2),h=2,o>2&&a(n.charCodeAt(2))&&(s=!0,h=3));let u=h<o?f(n.slice(h),!s,"\\",a):"";return u.length===0&&!s&&(u="."),u.length>0&&a(n.charCodeAt(o-1))&&(u+="\\"),t===void 0?s?`\\${u}`:u:s?`${t}\\${u}`:`${t}${u}`},isAbsolute(n){d(n,"path");const o=n.length;if(o===0)return!1;const h=n.charCodeAt(0);return a(h)||o>2&&p(h)&&n.charCodeAt(1)===P&&a(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let o,h;for(let l=0;l<n.length;++l){const u=n[l];d(u,"path"),u.length>0&&(o===void 0?o=h=u:o+=`\\${u}`)}if(o===void 0)return".";let t=!0,s=0;if(typeof h=="string"&&a(h.charCodeAt(0))){++s;const l=h.length;l>1&&a(h.charCodeAt(1))&&(++s,l>2&&(a(h.charCodeAt(2))?++s:t=!1))}if(t){for(;s<o.length&&a(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.win32.normalize(o)},relative(n,o){if(d(n,"from"),d(o,"to"),n===o)return"";const h=e.win32.resolve(n),t=e.win32.resolve(o);if(h===t||(n=h.toLowerCase(),o=t.toLowerCase(),n===o))return"";let s=0;for(;s<n.length&&n.charCodeAt(s)===i;)s++;let l=n.length;for(;l-1>s&&n.charCodeAt(l-1)===i;)l--;const u=l-s;let r=0;for(;r<o.length&&o.charCodeAt(r)===i;)r++;let g=o.length;for(;g-1>r&&o.charCodeAt(g-1)===i;)g--;const C=g-r,_=u<C?u:C;let D=-1,w=0;for(;w<_;w++){const R=n.charCodeAt(s+w);if(R!==o.charCodeAt(r+w))break;R===i&&(D=w)}if(w!==_){if(D===-1)return t}else{if(C>_){if(o.charCodeAt(r+w)===i)return t.slice(r+w+1);if(w===2)return t.slice(r+w)}u>_&&(n.charCodeAt(s+w)===i?D=w:w===2&&(D=3)),D===-1&&(D=0)}let O="";for(w=s+D+1;w<=l;++w)(w===l||n.charCodeAt(w)===i)&&(O+=O.length===0?"..":"\\..");return r+=D,O.length>0?`${O}${t.slice(r,g)}`:(t.charCodeAt(r)===i&&++r,t.slice(r,g))},toNamespacedPath(n){if(typeof n!="string")return n;if(n.length===0)return"";const o=e.win32.resolve(n);if(o.length<=2)return n;if(o.charCodeAt(0)===i){if(o.charCodeAt(1)===i){const h=o.charCodeAt(2);if(h!==S&&h!==k)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(p(o.charCodeAt(0))&&o.charCodeAt(1)===P&&o.charCodeAt(2)===i)return`\\\\?\\${o}`;return n},dirname(n){d(n,"path");const o=n.length;if(o===0)return".";let h=-1,t=0;const s=n.charCodeAt(0);if(o===1)return a(s)?n:".";if(a(s)){if(h=t=1,a(n.charCodeAt(1))){let r=2,g=r;for(;r<o&&!a(n.charCodeAt(r));)r++;if(r<o&&r!==g){for(g=r;r<o&&a(n.charCodeAt(r));)r++;if(r<o&&r!==g){for(g=r;r<o&&!a(n.charCodeAt(r));)r++;if(r===o)return n;r!==g&&(h=t=r+1)}}}}else p(s)&&n.charCodeAt(1)===P&&(h=o>2&&a(n.charCodeAt(2))?3:2,t=h);let l=-1,u=!0;for(let r=o-1;r>=t;--r)if(a(n.charCodeAt(r))){if(!u){l=r;break}}else u=!1;if(l===-1){if(h===-1)return".";l=h}return n.slice(0,l)},basename(n,o){o!==void 0&&d(o,"ext"),d(n,"path");let h=0,t=-1,s=!0,l;if(n.length>=2&&p(n.charCodeAt(0))&&n.charCodeAt(1)===P&&(h=2),o!==void 0&&o.length>0&&o.length<=n.length){if(o===n)return"";let u=o.length-1,r=-1;for(l=n.length-1;l>=h;--l){const g=n.charCodeAt(l);if(a(g)){if(!s){h=l+1;break}}else r===-1&&(s=!1,r=l+1),u>=0&&(g===o.charCodeAt(u)?--u==-1&&(t=l):(u=-1,t=r))}return h===t?t=r:t===-1&&(t=n.length),n.slice(h,t)}for(l=n.length-1;l>=h;--l)if(a(n.charCodeAt(l))){if(!s){h=l+1;break}}else t===-1&&(s=!1,t=l+1);return t===-1?"":n.slice(h,t)},extname(n){d(n,"path");let o=0,h=-1,t=0,s=-1,l=!0,u=0;n.length>=2&&n.charCodeAt(1)===P&&p(n.charCodeAt(0))&&(o=t=2);for(let r=n.length-1;r>=o;--r){const g=n.charCodeAt(r);if(a(g)){if(!l){t=r+1;break}continue}s===-1&&(l=!1,s=r+1),g===k?h===-1?h=r:u!==1&&(u=1):h!==-1&&(u=-1)}return h===-1||s===-1||u===0||u===1&&h===s-1&&h===t+1?"":n.slice(h,s)},format:c.bind(null,"\\"),parse(n){d(n,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return o;const h=n.length;let t=0,s=n.charCodeAt(0);if(h===1)return a(s)?(o.root=o.dir=n,o):(o.base=o.name=n,o);if(a(s)){if(t=1,a(n.charCodeAt(1))){let D=2,w=D;for(;D<h&&!a(n.charCodeAt(D));)D++;if(D<h&&D!==w){for(w=D;D<h&&a(n.charCodeAt(D));)D++;if(D<h&&D!==w){for(w=D;D<h&&!a(n.charCodeAt(D));)D++;D===h?t=D:D!==w&&(t=D+1)}}}}else if(p(s)&&n.charCodeAt(1)===P){if(h<=2)return o.root=o.dir=n,o;if(t=2,a(n.charCodeAt(2))){if(h===3)return o.root=o.dir=n,o;t=3}}t>0&&(o.root=n.slice(0,t));let l=-1,u=t,r=-1,g=!0,C=n.length-1,_=0;for(;C>=t;--C){if(s=n.charCodeAt(C),a(s)){if(!g){u=C+1;break}continue}r===-1&&(g=!1,r=C+1),s===k?l===-1?l=C:_!==1&&(_=1):l!==-1&&(_=-1)}return r!==-1&&(l===-1||_===0||_===1&&l===r-1&&l===u+1?o.base=o.name=n.slice(u,r):(o.name=n.slice(u,l),o.base=n.slice(u,r),o.ext=n.slice(l,r))),u>0&&u!==t?o.dir=n.slice(0,u-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...n){let o="",h=!1;for(let t=n.length-1;t>=-1&&!h;t--){const s=t>=0?n[t]:b.cwd();d(s,"path"),s.length!==0&&(o=`${s}/${o}`,h=s.charCodeAt(0)===I)}return o=f(o,!h,"/",m),h?`/${o}`:o.length>0?o:"."},normalize(n){if(d(n,"path"),n.length===0)return".";const o=n.charCodeAt(0)===I,h=n.charCodeAt(n.length-1)===I;return n=f(n,!o,"/",m),n.length===0?o?"/":h?"./":".":(h&&(n+="/"),o?`/${n}`:n)},isAbsolute(n){return d(n,"path"),n.length>0&&n.charCodeAt(0)===I},join(...n){if(n.length===0)return".";let o;for(let h=0;h<n.length;++h){const t=n[h];d(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(n,o){if(d(n,"from"),d(o,"to"),n===o||(n=e.posix.resolve(n),o=e.posix.resolve(o),n===o))return"";const h=1,t=n.length,s=t-h,l=1,u=o.length-l,r=s<u?s:u;let g=-1,C=0;for(;C<r;C++){const D=n.charCodeAt(h+C);if(D!==o.charCodeAt(l+C))break;D===I&&(g=C)}if(C===r)if(u>r){if(o.charCodeAt(l+C)===I)return o.slice(l+C+1);if(C===0)return o.slice(l+C)}else s>r&&(n.charCodeAt(h+C)===I?g=C:C===0&&(g=0));let _="";for(C=h+g+1;C<=t;++C)(C===t||n.charCodeAt(C)===I)&&(_+=_.length===0?"..":"/..");return`${_}${o.slice(l+g)}`},toNamespacedPath(n){return n},dirname(n){if(d(n,"path"),n.length===0)return".";const o=n.charCodeAt(0)===I;let h=-1,t=!0;for(let s=n.length-1;s>=1;--s)if(n.charCodeAt(s)===I){if(!t){h=s;break}}else t=!1;return h===-1?o?"/":".":o&&h===1?"//":n.slice(0,h)},basename(n,o){o!==void 0&&d(o,"ext"),d(n,"path");let h=0,t=-1,s=!0,l;if(o!==void 0&&o.length>0&&o.length<=n.length){if(o===n)return"";let u=o.length-1,r=-1;for(l=n.length-1;l>=0;--l){const g=n.charCodeAt(l);if(g===I){if(!s){h=l+1;break}}else r===-1&&(s=!1,r=l+1),u>=0&&(g===o.charCodeAt(u)?--u==-1&&(t=l):(u=-1,t=r))}return h===t?t=r:t===-1&&(t=n.length),n.slice(h,t)}for(l=n.length-1;l>=0;--l)if(n.charCodeAt(l)===I){if(!s){h=l+1;break}}else t===-1&&(s=!1,t=l+1);return t===-1?"":n.slice(h,t)},extname(n){d(n,"path");let o=-1,h=0,t=-1,s=!0,l=0;for(let u=n.length-1;u>=0;--u){const r=n.charCodeAt(u);if(r===I){if(!s){h=u+1;break}continue}t===-1&&(s=!1,t=u+1),r===k?o===-1?o=u:l!==1&&(l=1):o!==-1&&(l=-1)}return o===-1||t===-1||l===0||l===1&&o===t-1&&o===h+1?"":n.slice(o,t)},format:c.bind(null,"/"),parse(n){d(n,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return o;const h=n.charCodeAt(0)===I;let t;h?(o.root="/",t=1):t=0;let s=-1,l=0,u=-1,r=!0,g=n.length-1,C=0;for(;g>=t;--g){const _=n.charCodeAt(g);if(_===I){if(!r){l=g+1;break}continue}u===-1&&(r=!1,u=g+1),_===k?s===-1?s=g:C!==1&&(C=1):s!==-1&&(C=-1)}if(u!==-1){const _=l===0&&h?1:l;s===-1||C===0||C===1&&s===u-1&&s===l+1?o.base=o.name=n.slice(_,u):(o.name=n.slice(_,s),o.base=n.slice(_,u),o.ext=n.slice(s,u))}return l>0?o.dir=n.slice(0,l-1):h&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=b.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b.platform==="win32"?e.win32.join:e.posix.join,e.resolve=b.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=b.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=b.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=b.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=b.platform==="win32"?e.win32.extname:e.posix.extname,e.format=b.platform==="win32"?e.win32.format:e.posix.format,e.parse=b.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=b.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=b.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[55],_e([0,1,21]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const y=b.globals.performance&&typeof b.globals.performance.now=="function";class A{constructor(E){this._highResolution=y&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new A(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?b.globals.performance.now():Date.now()}}e.StopWatch=A}),define(ve[3],_e([0,1,9,51,6,54,55]),function(se,e,b,y,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.AsyncEmitter=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(c){c.None=()=>A.Disposable.None;function n(U){return(q,M=null,j)=>{let re=!1,F;return F=U(te=>{if(!re)return F?F.dispose():re=!0,q.call(M,te)},null,j),re&&F.dispose(),F}}c.once=n;function o(U,q){return r((M,j=null,re)=>U(F=>M.call(j,q(F)),null,re))}c.map=o;function h(U,q){return r((M,j=null,re)=>U(F=>{q(F),M.call(j,F)},null,re))}c.forEach=h;function t(U,q){return r((M,j=null,re)=>U(F=>q(F)&&M.call(j,F),null,re))}c.filter=t;function s(U){return U}c.signal=s;function l(...U){return(q,M=null,j)=>A.combinedDisposable(...U.map(re=>re(F=>q.call(M,F),null,j)))}c.any=l;function u(U,q,M){let j=M;return o(U,re=>(j=q(j,re),j))}c.reduce=u;function r(U){let q;const M=new v({onFirstListenerAdd(){q=U(M.fire,M)},onLastListenerRemove(){q.dispose()}});return M.event}c.snapshot=r;function g(U,q,M=100,j=!1,re){let F,te,ae,ue=0;const we=new v({leakWarningThreshold:re,onFirstListenerAdd(){F=U(fe=>{ue++,te=q(te,fe),j&&!ae&&(we.fire(te),te=void 0),clearTimeout(ae),ae=setTimeout(()=>{const De=te;te=void 0,ae=void 0,(!j||ue>1)&&we.fire(De),ue=0},M)})},onLastListenerRemove(){F.dispose()}});return we.event}c.debounce=g;function C(U){const q=new Date().getTime();return o(n(U),M=>new Date().getTime()-q)}c.stopwatch=C;function _(U){let q=!0,M;return t(U,j=>{const re=q||j!==M;return q=!1,M=j,re})}c.latch=_;function D(U,q=!1,M=[]){let j=M.slice(),re=U(ae=>{j?j.push(ae):te.fire(ae)});const F=()=>{j&&j.forEach(ae=>te.fire(ae)),j=null},te=new v({onFirstListenerAdd(){re||(re=U(ae=>te.fire(ae)))},onFirstListenerDidAdd(){j&&(q?setTimeout(F):F())},onLastListenerRemove(){re&&re.dispose(),re=null}});return te.event}c.buffer=D;class w{constructor(q){this.event=q}map(q){return new w(o(this.event,q))}forEach(q){return new w(h(this.event,q))}filter(q){return new w(t(this.event,q))}reduce(q,M){return new w(u(this.event,q,M))}latch(){return new w(_(this.event))}debounce(q,M=100,j=!1,re){return new w(g(this.event,q,M,j,re))}on(q,M,j){return this.event(q,M,j)}once(q,M,j){return n(this.event)(q,M,j)}}function O(U){return new w(U)}c.chain=O;function R(U,q,M=j=>j){const j=(...ae)=>te.fire(M(...ae)),re=()=>U.on(q,j),F=()=>U.removeListener(q,j),te=new v({onFirstListenerAdd:re,onLastListenerRemove:F});return te.event}c.fromNodeEventEmitter=R;function $(U,q,M=j=>j){const j=(...ae)=>te.fire(M(...ae)),re=()=>U.addEventListener(q,j),F=()=>U.removeEventListener(q,j),te=new v({onFirstListenerAdd:re,onLastListenerRemove:F});return te.event}c.fromDOMEventEmitter=$;function V(U){const q=new v;let M=!1;return U.then(void 0,()=>null).then(()=>{M?q.fire(void 0):setTimeout(()=>q.fire(void 0),0)}),M=!0,q.event}c.fromPromise=V;function z(U){return new Promise(q=>n(U)(q))}c.toPromise=z})(k=e.Event||(e.Event={}));class I{constructor(n){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${n}_${I._idPool++}`}start(n){this._stopWatch=new E.StopWatch(!0),this._listenerCount=n}stop(){if(this._stopWatch){const n=this._stopWatch.elapsed();this._elapsedOverall+=n,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${n.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}I._idPool=0;let i=-1;function P(c){const n=i;return i=c,{dispose(){i=n}}}e.setGlobalLeakWarningThreshold=P;class S{constructor(n,o=Math.random().toString(18).slice(2,5)){this.customThreshold=n,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(n){let o=i;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),!(o<=0||n<o)){this._stacks||(this._stacks=new Map);const h=new Error().stack.split(`
`).slice(3).join(`
`),t=this._stacks.get(h)||0;if(this._stacks.set(h,t+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let s,l=0;for(const[u,r]of this._stacks)(!s||l<r)&&(s=u,l=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${n} listeners already. MOST frequent listener (${l}):`),console.warn(s)}return()=>{const s=this._stacks.get(h)||0;this._stacks.set(h,s-1)}}}}class v{constructor(n){var o;this._disposed=!1,this._options=n,this._leakageMon=i>0?new S(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((o=this._options)===null||o===void 0?void 0:o._profName)?new I(this._options._profName):void 0}get event(){return this._event||(this._event=(n,o,h)=>{var t;this._listeners||(this._listeners=new T.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const l=this._listeners.push(o?[n,o]:n);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,n,o);const u=(t=this._leakageMon)===null||t===void 0?void 0:t.check(this._listeners.size);let r;return r={dispose:()=>{u&&u(),r.dispose=v._noop,this._disposed||(l(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},h instanceof A.DisposableStore?h.add(r):Array.isArray(h)&&h.push(r),r}),this._event}fire(n){var o,h;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,n]);for((o=this._perfMon)===null||o===void 0||o.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,s]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,s):t[0].call(t[1],s)}catch(l){b.onUnexpectedError(l)}}(h=this._perfMon)===null||h===void 0||h.stop()}}dispose(){var n,o,h;(n=this._listeners)===null||n===void 0||n.clear(),(o=this._deliveryQueue)===null||o===void 0||o.clear(),(h=this._leakageMon)===null||h===void 0||h.dispose(),this._disposed=!0}}e.Emitter=v,v._noop=function(){};class d extends v{constructor(n){super(n);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=n==null?void 0:n.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const n=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(n))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(n){this._listeners&&(this._isPaused!==0?this._eventQueue.push(n):super.fire(n))}}e.PauseableEmitter=d;class a extends v{async fireAsync(n,o,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const t of this._listeners)this._asyncDeliveryQueue.push([t,n]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[t,s]=this._asyncDeliveryQueue.shift(),l=[],u=Object.assign(Object.assign({},s),{waitUntil:r=>{if(Object.isFrozen(l))throw new Error("waitUntil can NOT be called asynchronous");h&&(r=h(r,typeof t=="function"?t:t[0])),l.push(r)}});try{typeof t=="function"?t.call(void 0,u):t[0].call(t[1],u)}catch(r){b.onUnexpectedError(r);continue}Object.freeze(l),await Promise.all(l).catch(r=>b.onUnexpectedError(r))}}}}e.AsyncEmitter=a;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(n){const o={event:n,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const h=()=>{this.hasListeners&&this.unhook(o);const t=this.events.indexOf(o);this.events.splice(t,1)};return A.toDisposable(y.once(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(n=>this.hook(n))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(n=>this.unhook(n))}hook(n){n.listener=n.event(o=>this.emitter.fire(o))}unhook(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=m;class p{constructor(){this.buffers=[]}wrapEvent(n){return(o,h,t)=>n(s=>{const l=this.buffers[this.buffers.length-1];l?l.push(()=>o.call(h,s)):o.call(h,s)},void 0,t)}bufferEvents(n){const o=[];this.buffers.push(o);const h=n();return this.buffers.pop(),o.forEach(t=>t()),h}}e.EventBufferer=p;class f{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=A.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(n){this.inputEvent=n,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=n(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=f}),define(ve[20],_e([0,1,3]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const y=Object.freeze(function(k,I){const i=setTimeout(k.bind(I),0);return{dispose(){clearTimeout(i)}}});var A;(function(k){function I(i){return i===k.None||i===k.Cancelled||i instanceof T?!0:!i||typeof i!="object"?!1:typeof i.isCancellationRequested=="boolean"&&typeof i.onCancellationRequested=="function"}k.isCancellationToken=I,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:y})})(A=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?y:(this._emitter||(this._emitter=new b.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(I){this._token=void 0,this._parentListener=void 0,this._parentListener=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=A.Cancelled}dispose(I=!1){I&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=E}),define(ve[15],_e([0,1,20,9,3,6]),function(se,e,b,y,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(z){return z&&typeof z.then=="function"}e.isThenable=E;function k(z){const U=new b.CancellationTokenSource,q=z(U.token),M=new Promise((j,re)=>{U.token.onCancellationRequested(()=>{re(y.canceled())}),Promise.resolve(q).then(F=>{U.dispose(),j(F)},F=>{U.dispose(),re(F)})});return new class{cancel(){U.cancel()}then(j,re){return M.then(j,re)}catch(j){return this.then(void 0,j)}finally(j){return M.finally(j)}}}e.createCancelablePromise=k;function I(z,U,q){return Promise.race([z,new Promise(M=>U.onCancellationRequested(()=>M(q)))])}e.raceCancellation=I;async function i(z){let U=-1;const q=z.map((j,re)=>j.then(F=>(U=re,F))),M=await Promise.race(q);return z.forEach((j,re)=>{re!==U&&j.cancel()}),M}e.raceCancellablePromises=i;function P(z,U,q){let M;const j=setTimeout(()=>{M==null||M(void 0),q==null||q()},U);return Promise.race([z.finally(()=>clearTimeout(j)),new Promise(re=>M=re)])}e.raceTimeout=P;function S(z){return new Promise((U,q)=>{const M=z();E(M)?M.then(U,q):U(M)})}e.asPromise=S;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const q=()=>{this.queuedPromise=null;const M=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,M};this.queuedPromise=new Promise(M=>{this.activePromise.then(q,q).then(M)})}return new Promise((q,M)=>{this.queuedPromise.then(q,M)})}return this.activePromise=U(),new Promise((q,M)=>{this.activePromise.then(j=>{this.activePromise=null,q(j)},j=>{this.activePromise=null,M(j)})})}}e.Throttler=v;class d{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=d;class a{constructor(){this.promiseMap=new Map}queue(U,q){var M;const re=((M=this.promiseMap.get(U))!==null&&M!==void 0?M:Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get(U)===re&&this.promiseMap.delete(U)});return this.promiseMap.set(U,re),re}}e.SequencerByKey=a;class m{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,q=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((M,j)=>{this.doResolve=M,this.doReject=j}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const M=this.task;return this.task=null,M()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(y.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=m;class p{constructor(U){this.delayer=new m(U),this.throttler=new v}trigger(U,q){return this.delayer.trigger(()=>this.throttler.queue(U),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=p;class f{constructor(){this._isOpen=!1,this._promise=new Promise((U,q)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=f;function c(z,U){return U?new Promise((q,M)=>{const j=setTimeout(q,z);U.onCancellationRequested(()=>{clearTimeout(j),M(y.canceled())})}):k(q=>c(z,q))}e.timeout=c;function n(z,U=0){const q=setTimeout(z,U);return T.toDisposable(()=>clearTimeout(q))}e.disposableTimeout=n;function o(z){return z.then(void 0,U=>{})}e.ignoreErrors=o;function h(z){const U=[];let q=0;const M=z.length;function j(){return q<M?z[q++]():null}function re(F){F!=null&&U.push(F);const te=j();return te?te.then(re):Promise.resolve(U)}return Promise.resolve(null).then(re)}e.sequence=h;function t(z,U=M=>!!M,q=null){let M=0;const j=z.length,re=()=>{if(M>=j)return Promise.resolve(q);const F=z[M++];return Promise.resolve(F()).then(ae=>U(ae)?Promise.resolve(ae):re())};return re()}e.first=t;function s(z,U=M=>!!M,q=null){if(z.length===0)return Promise.resolve(q);let M=z.length;const j=()=>{var re,F;M=-1;for(const te of z)(F=(re=te).cancel)===null||F===void 0||F.call(re)};return new Promise((re,F)=>{for(const te of z)te.then(ae=>{--M>=0&&U(ae)?(j(),re(ae)):M===0&&re(q)}).catch(ae=>{--M>=0&&(j(),F(ae))})})}e.firstParallel=s;class l{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((q,M)=>{this.outstandingPromises.push({factory:U,c:q,e:M}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const q=U.factory();q.then(U.c,U.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=l;class u extends l{constructor(){super(1)}}e.Queue=u;class r{constructor(){this.queues=new Map}queueFor(U){const q=U.toString();if(!this.queues.has(q)){const M=new u;M.onFinished(()=>{M.dispose(),this.queues.delete(q)}),this.queues.set(q,M)}return this.queues.get(q)}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=r;class g{constructor(U,q){this._token=-1,typeof U=="function"&&typeof q=="number"&&this.setIfNotSet(U,q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},q)}setIfNotSet(U,q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},q))}}e.TimeoutTimer=g;class C{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,q){this.cancel(),this._token=setInterval(()=>{U()},q)}}e.IntervalTimer=C;class _{constructor(U,q){this.timeoutToken=-1,this.runner=U,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=_;class D extends _{constructor(U,q){super(U,q);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=D,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const z=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=U=>{const q=setTimeout(()=>U(z));let M=!1;return{dispose(){M||(M=!0,clearTimeout(q))}}}}else e.runWhenIdle=(z,U)=>{const q=requestIdleCallback(z,typeof U=="number"?{timeout:U}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(q))}}}}();class w{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(q){this._error=q}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=w;async function O(z,U,q){let M;for(let j=0;j<q;j++)try{return await z()}catch(re){M=re,await c(U)}throw M}e.retry=O;class R{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var U;(U=this._pending)===null||U===void 0||U.cancel()}setPending(U,q,M){return this._pending={taskId:U,cancel:()=>M==null?void 0:M(),promise:q},q.then(()=>this.donePending(U),()=>this.donePending(U)),q}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let q,M;const j=new Promise((re,F)=>{q=re,M=F});this._next={run:U,promise:j,promiseResolve:q,promiseReject:M}}return this._next.promise}}e.TaskSequentializer=R;class ${constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,q)=>{this.completeCallback=U,this.errorCallback=q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(q=>{this.completeCallback(U),this.resolved=!0,q()})}error(U){return new Promise(q=>{this.errorCallback(U),this.rejected=!0,q()})}cancel(){new Promise(U=>{this.errorCallback(y.canceled()),this.rejected=!0,U()})}}e.DeferredPromise=V}),define(ve[46],_e([0,1,3]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class y{constructor(){this._icons=new Map,this._onDidRegister=new b.Emitter}add(P){const S=this._icons.get(P.id);S?P.description?S.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const A=new y;e.iconRegistry=A;function T(i,P){return new E(i,P)}e.registerCodicon=T;class E{constructor(P,S,v){this.id=P,this.definition=S,this.description=v,A.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=E;function k(i,P){const S=["codicon","codicon-"+i];return P&&S.push("codicon-modifier-"+P),S}e.getClassNamesArray=k;var I;(function(i){i.iconIdRegex=/^(codicon\/)?([a-z\-]+)(?:~([a-z\-]+))?$/i;function P(d){if(d instanceof E)return["codicon","codicon-"+d.id];const a=i.iconIdRegex.exec(d.id);if(!a)return P(E.error);let[,,m,p]=a;const f=["codicon","codicon-"+m];return p&&f.push("codicon-modifier-"+p),f}i.asClassNameArray=P;function S(d){return P(d).join(" ")}i.asClassName=S;function v(d){return"."+P(d).join(".")}i.asCSSSelector=v})(I=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{character:"\\ea60"}),i.plus=new i("plus",{character:"\\ea60"}),i.gistNew=new i("gist-new",{character:"\\ea60"}),i.repoCreate=new i("repo-create",{character:"\\ea60"}),i.lightbulb=new i("lightbulb",{character:"\\ea61"}),i.lightBulb=new i("light-bulb",{character:"\\ea61"}),i.repo=new i("repo",{character:"\\ea62"}),i.repoDelete=new i("repo-delete",{character:"\\ea62"}),i.gistFork=new i("gist-fork",{character:"\\ea63"}),i.repoForked=new i("repo-forked",{character:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{character:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{character:"\\ea64"}),i.recordKeys=new i("record-keys",{character:"\\ea65"}),i.keyboard=new i("keyboard",{character:"\\ea65"}),i.tag=new i("tag",{character:"\\ea66"}),i.tagAdd=new i("tag-add",{character:"\\ea66"}),i.tagRemove=new i("tag-remove",{character:"\\ea66"}),i.person=new i("person",{character:"\\ea67"}),i.personAdd=new i("person-add",{character:"\\ea67"}),i.personFollow=new i("person-follow",{character:"\\ea67"}),i.personOutline=new i("person-outline",{character:"\\ea67"}),i.personFilled=new i("person-filled",{character:"\\ea67"}),i.gitBranch=new i("git-branch",{character:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{character:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{character:"\\ea68"}),i.sourceControl=new i("source-control",{character:"\\ea68"}),i.mirror=new i("mirror",{character:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{character:"\\ea69"}),i.star=new i("star",{character:"\\ea6a"}),i.starAdd=new i("star-add",{character:"\\ea6a"}),i.starDelete=new i("star-delete",{character:"\\ea6a"}),i.starEmpty=new i("star-empty",{character:"\\ea6a"}),i.comment=new i("comment",{character:"\\ea6b"}),i.commentAdd=new i("comment-add",{character:"\\ea6b"}),i.alert=new i("alert",{character:"\\ea6c"}),i.warning=new i("warning",{character:"\\ea6c"}),i.search=new i("search",{character:"\\ea6d"}),i.searchSave=new i("search-save",{character:"\\ea6d"}),i.logOut=new i("log-out",{character:"\\ea6e"}),i.signOut=new i("sign-out",{character:"\\ea6e"}),i.logIn=new i("log-in",{character:"\\ea6f"}),i.signIn=new i("sign-in",{character:"\\ea6f"}),i.eye=new i("eye",{character:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{character:"\\ea70"}),i.eyeWatch=new i("eye-watch",{character:"\\ea70"}),i.circleFilled=new i("circle-filled",{character:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{character:"\\ea71"}),i.closeDirty=new i("close-dirty",{character:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{character:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{character:"\\ea71"}),i.debugHint=new i("debug-hint",{character:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{character:"\\ea72"}),i.edit=new i("edit",{character:"\\ea73"}),i.pencil=new i("pencil",{character:"\\ea73"}),i.info=new i("info",{character:"\\ea74"}),i.issueOpened=new i("issue-opened",{character:"\\ea74"}),i.gistPrivate=new i("gist-private",{character:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{character:"\\ea75"}),i.lock=new i("lock",{character:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{character:"\\ea75"}),i.close=new i("close",{character:"\\ea76"}),i.removeClose=new i("remove-close",{character:"\\ea76"}),i.x=new i("x",{character:"\\ea76"}),i.repoSync=new i("repo-sync",{character:"\\ea77"}),i.sync=new i("sync",{character:"\\ea77"}),i.clone=new i("clone",{character:"\\ea78"}),i.desktopDownload=new i("desktop-download",{character:"\\ea78"}),i.beaker=new i("beaker",{character:"\\ea79"}),i.microscope=new i("microscope",{character:"\\ea79"}),i.vm=new i("vm",{character:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{character:"\\ea7a"}),i.file=new i("file",{character:"\\ea7b"}),i.fileText=new i("file-text",{character:"\\ea7b"}),i.more=new i("more",{character:"\\ea7c"}),i.ellipsis=new i("ellipsis",{character:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{character:"\\ea7c"}),i.mailReply=new i("mail-reply",{character:"\\ea7d"}),i.reply=new i("reply",{character:"\\ea7d"}),i.organization=new i("organization",{character:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{character:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{character:"\\ea7e"}),i.newFile=new i("new-file",{character:"\\ea7f"}),i.fileAdd=new i("file-add",{character:"\\ea7f"}),i.newFolder=new i("new-folder",{character:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{character:"\\ea80"}),i.trash=new i("trash",{character:"\\ea81"}),i.trashcan=new i("trashcan",{character:"\\ea81"}),i.history=new i("history",{character:"\\ea82"}),i.clock=new i("clock",{character:"\\ea82"}),i.folder=new i("folder",{character:"\\ea83"}),i.fileDirectory=new i("file-directory",{character:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{character:"\\ea83"}),i.logoGithub=new i("logo-github",{character:"\\ea84"}),i.markGithub=new i("mark-github",{character:"\\ea84"}),i.github=new i("github",{character:"\\ea84"}),i.terminal=new i("terminal",{character:"\\ea85"}),i.console=new i("console",{character:"\\ea85"}),i.repl=new i("repl",{character:"\\ea85"}),i.zap=new i("zap",{character:"\\ea86"}),i.symbolEvent=new i("symbol-event",{character:"\\ea86"}),i.error=new i("error",{character:"\\ea87"}),i.stop=new i("stop",{character:"\\ea87"}),i.variable=new i("variable",{character:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{character:"\\ea88"}),i.array=new i("array",{character:"\\ea8a"}),i.symbolArray=new i("symbol-array",{character:"\\ea8a"}),i.symbolModule=new i("symbol-module",{character:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{character:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{character:"\\ea8b"}),i.symbolObject=new i("symbol-object",{character:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{character:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{character:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{character:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{character:"\\ea8f"}),i.symbolNull=new i("symbol-null",{character:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{character:"\\ea90"}),i.symbolNumber=new i("symbol-number",{character:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{character:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{character:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{character:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{character:"\\ea92"}),i.symbolKey=new i("symbol-key",{character:"\\ea93"}),i.symbolText=new i("symbol-text",{character:"\\ea93"}),i.symbolReference=new i("symbol-reference",{character:"\\ea94"}),i.goToFile=new i("go-to-file",{character:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{character:"\\ea95"}),i.symbolValue=new i("symbol-value",{character:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{character:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{character:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{character:"\\ea97"}),i.archive=new i("archive",{character:"\\ea98"}),i.arrowBoth=new i("arrow-both",{character:"\\ea99"}),i.arrowDown=new i("arrow-down",{character:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{character:"\\ea9b"}),i.arrowRight=new i("arrow-right",{character:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{character:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{character:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{character:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{character:"\\eaa0"}),i.arrowUp=new i("arrow-up",{character:"\\eaa1"}),i.bell=new i("bell",{character:"\\eaa2"}),i.bold=new i("bold",{character:"\\eaa3"}),i.book=new i("book",{character:"\\eaa4"}),i.bookmark=new i("bookmark",{character:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{character:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{character:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{character:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{character:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{character:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{character:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{character:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{character:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{character:"\\eaab"}),i.briefcase=new i("briefcase",{character:"\\eaac"}),i.broadcast=new i("broadcast",{character:"\\eaad"}),i.browser=new i("browser",{character:"\\eaae"}),i.bug=new i("bug",{character:"\\eaaf"}),i.calendar=new i("calendar",{character:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{character:"\\eab1"}),i.check=new i("check",{character:"\\eab2"}),i.checklist=new i("checklist",{character:"\\eab3"}),i.chevronDown=new i("chevron-down",{character:"\\eab4"}),i.chevronLeft=new i("chevron-left",{character:"\\eab5"}),i.chevronRight=new i("chevron-right",{character:"\\eab6"}),i.chevronUp=new i("chevron-up",{character:"\\eab7"}),i.chromeClose=new i("chrome-close",{character:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{character:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{character:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{character:"\\eabb"}),i.circleOutline=new i("circle-outline",{character:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{character:"\\eabc"}),i.circleSlash=new i("circle-slash",{character:"\\eabd"}),i.circuitBoard=new i("circuit-board",{character:"\\eabe"}),i.clearAll=new i("clear-all",{character:"\\eabf"}),i.clippy=new i("clippy",{character:"\\eac0"}),i.closeAll=new i("close-all",{character:"\\eac1"}),i.cloudDownload=new i("cloud-download",{character:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{character:"\\eac3"}),i.code=new i("code",{character:"\\eac4"}),i.collapseAll=new i("collapse-all",{character:"\\eac5"}),i.colorMode=new i("color-mode",{character:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{character:"\\eac7"}),i.compareChanges=new i("compare-changes",{character:"\\eafd"}),i.creditCard=new i("credit-card",{character:"\\eac9"}),i.dash=new i("dash",{character:"\\eacc"}),i.dashboard=new i("dashboard",{character:"\\eacd"}),i.database=new i("database",{character:"\\eace"}),i.debugContinue=new i("debug-continue",{character:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{character:"\\ead0"}),i.debugPause=new i("debug-pause",{character:"\\ead1"}),i.debugRestart=new i("debug-restart",{character:"\\ead2"}),i.debugStart=new i("debug-start",{character:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{character:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{character:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{character:"\\ead6"}),i.debugStop=new i("debug-stop",{character:"\\ead7"}),i.debug=new i("debug",{character:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{character:"\\ead9"}),i.deviceCamera=new i("device-camera",{character:"\\eada"}),i.deviceMobile=new i("device-mobile",{character:"\\eadb"}),i.diffAdded=new i("diff-added",{character:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{character:"\\eadd"}),i.diffModified=new i("diff-modified",{character:"\\eade"}),i.diffRemoved=new i("diff-removed",{character:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{character:"\\eae0"}),i.diff=new i("diff",{character:"\\eae1"}),i.discard=new i("discard",{character:"\\eae2"}),i.editorLayout=new i("editor-layout",{character:"\\eae3"}),i.emptyWindow=new i("empty-window",{character:"\\eae4"}),i.exclude=new i("exclude",{character:"\\eae5"}),i.extensions=new i("extensions",{character:"\\eae6"}),i.eyeClosed=new i("eye-closed",{character:"\\eae7"}),i.fileBinary=new i("file-binary",{character:"\\eae8"}),i.fileCode=new i("file-code",{character:"\\eae9"}),i.fileMedia=new i("file-media",{character:"\\eaea"}),i.filePdf=new i("file-pdf",{character:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{character:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{character:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{character:"\\eaee"}),i.fileZip=new i("file-zip",{character:"\\eaef"}),i.files=new i("files",{character:"\\eaf0"}),i.filter=new i("filter",{character:"\\eaf1"}),i.flame=new i("flame",{character:"\\eaf2"}),i.foldDown=new i("fold-down",{character:"\\eaf3"}),i.foldUp=new i("fold-up",{character:"\\eaf4"}),i.fold=new i("fold",{character:"\\eaf5"}),i.folderActive=new i("folder-active",{character:"\\eaf6"}),i.folderOpened=new i("folder-opened",{character:"\\eaf7"}),i.gear=new i("gear",{character:"\\eaf8"}),i.gift=new i("gift",{character:"\\eaf9"}),i.gistSecret=new i("gist-secret",{character:"\\eafa"}),i.gist=new i("gist",{character:"\\eafb"}),i.gitCommit=new i("git-commit",{character:"\\eafc"}),i.gitCompare=new i("git-compare",{character:"\\eafd"}),i.gitMerge=new i("git-merge",{character:"\\eafe"}),i.githubAction=new i("github-action",{character:"\\eaff"}),i.githubAlt=new i("github-alt",{character:"\\eb00"}),i.globe=new i("globe",{character:"\\eb01"}),i.grabber=new i("grabber",{character:"\\eb02"}),i.graph=new i("graph",{character:"\\eb03"}),i.gripper=new i("gripper",{character:"\\eb04"}),i.heart=new i("heart",{character:"\\eb05"}),i.home=new i("home",{character:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{character:"\\eb07"}),i.hubot=new i("hubot",{character:"\\eb08"}),i.inbox=new i("inbox",{character:"\\eb09"}),i.issueClosed=new i("issue-closed",{character:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{character:"\\eb0b"}),i.issues=new i("issues",{character:"\\eb0c"}),i.italic=new i("italic",{character:"\\eb0d"}),i.jersey=new i("jersey",{character:"\\eb0e"}),i.json=new i("json",{character:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{character:"\\eb10"}),i.key=new i("key",{character:"\\eb11"}),i.law=new i("law",{character:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{character:"\\eb13"}),i.linkExternal=new i("link-external",{character:"\\eb14"}),i.link=new i("link",{character:"\\eb15"}),i.listOrdered=new i("list-ordered",{character:"\\eb16"}),i.listUnordered=new i("list-unordered",{character:"\\eb17"}),i.liveShare=new i("live-share",{character:"\\eb18"}),i.loading=new i("loading",{character:"\\eb19"}),i.location=new i("location",{character:"\\eb1a"}),i.mailRead=new i("mail-read",{character:"\\eb1b"}),i.mail=new i("mail",{character:"\\eb1c"}),i.markdown=new i("markdown",{character:"\\eb1d"}),i.megaphone=new i("megaphone",{character:"\\eb1e"}),i.mention=new i("mention",{character:"\\eb1f"}),i.milestone=new i("milestone",{character:"\\eb20"}),i.mortarBoard=new i("mortar-board",{character:"\\eb21"}),i.move=new i("move",{character:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{character:"\\eb23"}),i.mute=new i("mute",{character:"\\eb24"}),i.noNewline=new i("no-newline",{character:"\\eb25"}),i.note=new i("note",{character:"\\eb26"}),i.octoface=new i("octoface",{character:"\\eb27"}),i.openPreview=new i("open-preview",{character:"\\eb28"}),i.package_=new i("package",{character:"\\eb29"}),i.paintcan=new i("paintcan",{character:"\\eb2a"}),i.pin=new i("pin",{character:"\\eb2b"}),i.play=new i("play",{character:"\\eb2c"}),i.run=new i("run",{character:"\\eb2c"}),i.plug=new i("plug",{character:"\\eb2d"}),i.preserveCase=new i("preserve-case",{character:"\\eb2e"}),i.preview=new i("preview",{character:"\\eb2f"}),i.project=new i("project",{character:"\\eb30"}),i.pulse=new i("pulse",{character:"\\eb31"}),i.question=new i("question",{character:"\\eb32"}),i.quote=new i("quote",{character:"\\eb33"}),i.radioTower=new i("radio-tower",{character:"\\eb34"}),i.reactions=new i("reactions",{character:"\\eb35"}),i.references=new i("references",{character:"\\eb36"}),i.refresh=new i("refresh",{character:"\\eb37"}),i.regex=new i("regex",{character:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{character:"\\eb39"}),i.remote=new i("remote",{character:"\\eb3a"}),i.remove=new i("remove",{character:"\\eb3b"}),i.replaceAll=new i("replace-all",{character:"\\eb3c"}),i.replace=new i("replace",{character:"\\eb3d"}),i.repoClone=new i("repo-clone",{character:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{character:"\\eb3f"}),i.repoPull=new i("repo-pull",{character:"\\eb40"}),i.repoPush=new i("repo-push",{character:"\\eb41"}),i.report=new i("report",{character:"\\eb42"}),i.requestChanges=new i("request-changes",{character:"\\eb43"}),i.rocket=new i("rocket",{character:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{character:"\\eb45"}),i.rootFolder=new i("root-folder",{character:"\\eb46"}),i.rss=new i("rss",{character:"\\eb47"}),i.ruby=new i("ruby",{character:"\\eb48"}),i.saveAll=new i("save-all",{character:"\\eb49"}),i.saveAs=new i("save-as",{character:"\\eb4a"}),i.save=new i("save",{character:"\\eb4b"}),i.screenFull=new i("screen-full",{character:"\\eb4c"}),i.screenNormal=new i("screen-normal",{character:"\\eb4d"}),i.searchStop=new i("search-stop",{character:"\\eb4e"}),i.server=new i("server",{character:"\\eb50"}),i.settingsGear=new i("settings-gear",{character:"\\eb51"}),i.settings=new i("settings",{character:"\\eb52"}),i.shield=new i("shield",{character:"\\eb53"}),i.smiley=new i("smiley",{character:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{character:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{character:"\\eb56"}),i.splitVertical=new i("split-vertical",{character:"\\eb57"}),i.squirrel=new i("squirrel",{character:"\\eb58"}),i.starFull=new i("star-full",{character:"\\eb59"}),i.starHalf=new i("star-half",{character:"\\eb5a"}),i.symbolClass=new i("symbol-class",{character:"\\eb5b"}),i.symbolColor=new i("symbol-color",{character:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{character:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{character:"\\eb5e"}),i.symbolField=new i("symbol-field",{character:"\\eb5f"}),i.symbolFile=new i("symbol-file",{character:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{character:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{character:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{character:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{character:"\\eb64"}),i.symbolProperty=new i("symbol-property",{character:"\\eb65"}),i.wrench=new i("wrench",{character:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{character:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{character:"\\eb66"}),i.tasklist=new i("tasklist",{character:"\\eb67"}),i.telescope=new i("telescope",{character:"\\eb68"}),i.textSize=new i("text-size",{character:"\\eb69"}),i.threeBars=new i("three-bars",{character:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{character:"\\eb6b"}),i.thumbsup=new i("thumbsup",{character:"\\eb6c"}),i.tools=new i("tools",{character:"\\eb6d"}),i.triangleDown=new i("triangle-down",{character:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{character:"\\eb6f"}),i.triangleRight=new i("triangle-right",{character:"\\eb70"}),i.triangleUp=new i("triangle-up",{character:"\\eb71"}),i.twitter=new i("twitter",{character:"\\eb72"}),i.unfold=new i("unfold",{character:"\\eb73"}),i.unlock=new i("unlock",{character:"\\eb74"}),i.unmute=new i("unmute",{character:"\\eb75"}),i.unverified=new i("unverified",{character:"\\eb76"}),i.verified=new i("verified",{character:"\\eb77"}),i.versions=new i("versions",{character:"\\eb78"}),i.vmActive=new i("vm-active",{character:"\\eb79"}),i.vmOutline=new i("vm-outline",{character:"\\eb7a"}),i.vmRunning=new i("vm-running",{character:"\\eb7b"}),i.watch=new i("watch",{character:"\\eb7c"}),i.whitespace=new i("whitespace",{character:"\\eb7d"}),i.wholeWord=new i("whole-word",{character:"\\eb7e"}),i.window=new i("window",{character:"\\eb7f"}),i.wordWrap=new i("word-wrap",{character:"\\eb80"}),i.zoomIn=new i("zoom-in",{character:"\\eb81"}),i.zoomOut=new i("zoom-out",{character:"\\eb82"}),i.listFilter=new i("list-filter",{character:"\\eb83"}),i.listFlat=new i("list-flat",{character:"\\eb84"}),i.listSelection=new i("list-selection",{character:"\\eb85"}),i.selection=new i("selection",{character:"\\eb85"}),i.listTree=new i("list-tree",{character:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{character:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{character:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{character:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{character:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{character:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{character:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{character:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{character:"\\eb8c"}),i.symbolString=new i("symbol-string",{character:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{character:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{character:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{character:"\\eb90"}),i.callIncoming=new i("call-incoming",{character:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{character:"\\eb93"}),i.menu=new i("menu",{character:"\\eb94"}),i.expandAll=new i("expand-all",{character:"\\eb95"}),i.feedback=new i("feedback",{character:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{character:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{character:"\\eb98"}),i.account=new i("account",{character:"\\eb99"}),i.bellDot=new i("bell-dot",{character:"\\eb9a"}),i.debugConsole=new i("debug-console",{character:"\\eb9b"}),i.library=new i("library",{character:"\\eb9c"}),i.output=new i("output",{character:"\\eb9d"}),i.runAll=new i("run-all",{character:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{character:"\\eb9f"}),i.pinned=new i("pinned",{character:"\\eba0"}),i.githubInverted=new i("github-inverted",{character:"\\eba1"}),i.debugAlt=new i("debug-alt",{character:"\\eb91"}),i.serverProcess=new i("server-process",{character:"\\eba2"}),i.serverEnvironment=new i("server-environment",{character:"\\eba3"}),i.pass=new i("pass",{character:"\\eba4"}),i.stopCircle=new i("stop-circle",{character:"\\eba5"}),i.playCircle=new i("play-circle",{character:"\\eba6"}),i.record=new i("record",{character:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{character:"\\eba8"}),i.vmConnect=new i("vm-connect",{character:"\\eba9"}),i.cloud=new i("cloud",{character:"\\ebaa"}),i.merge=new i("merge",{character:"\\ebab"}),i.exportIcon=new i("export",{character:"\\ebac"}),i.graphLeft=new i("graph-left",{character:"\\ebad"}),i.magnet=new i("magnet",{character:"\\ebae"}),i.notebook=new i("notebook",{character:"\\ebaf"}),i.redo=new i("redo",{character:"\\ebb0"}),i.checkAll=new i("check-all",{character:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{character:"\\ebb2"}),i.passFilled=new i("pass-filled",{character:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{character:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{character:"\\ebb5"}),i.combine=new i("combine",{character:"\\ebb6"}),i.gather=new i("gather",{character:"\\ebb6"}),i.table=new i("table",{character:"\\ebb7"}),i.variableGroup=new i("variable-group",{character:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{character:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{character:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{character:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{character:"\\ebbc"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(E=e.Codicon||(e.Codicon={}))}),define(ve[104],_e([0,1,10,15]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const A=new y.IdleValue(()=>{const o=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:o,collatorIsNumeric:o.resolvedOptions().numeric}}),T=new y.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),E=new y.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(o,h,t=!1){const s=o||"",l=h||"",u=A.value.collator.compare(s,l);return A.value.collatorIsNumeric&&u===0&&s!==l?s<l?-1:1:u}e.compareFileNames=k;function I(o,h){const t=T.value.collator;return o=o||"",h=h||"",m(t,o,h)}e.compareFileNamesDefault=I;function i(o,h,t=!1){t||(o=o&&o.toLowerCase(),h=h&&h.toLowerCase());const[s,l]=d(o),[u,r]=d(h);return s!==u?s<u?-1:1:l===r?0:l<r?-1:1}e.noIntlCompareFileNames=i;function P(o,h){const[t,s]=d(o),[l,u]=d(h);let r=A.value.collator.compare(s,u);if(r===0){if(A.value.collatorIsNumeric&&s!==u)return s<u?-1:1;if(r=A.value.collator.compare(t,l),A.value.collatorIsNumeric&&r===0&&t!==l)return t<l?-1:1}return r}e.compareFileExtensions=P;function S(o,h){o=o||"",h=h||"";const t=a(o),s=a(h),l=T.value.collator,u=E.value.collator;let r;return r=m(u,t,s),r!==0?r:m(l,o,h)}e.compareFileExtensionsDefault=S;const v=/^(.*?)(\.([^.]*))?$/;function d(o,h=!1){const t=o?v.exec(o):[];let s=[t&&t[1]||"",t&&t[3]||""];return h&&(!s[0]&&s[1]||s[0]&&s[0].charAt(0)===".")&&(s=[s[0]+"."+s[1],""]),s}function a(o){const h=o?v.exec(o):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function m(o,h,t){let s=o.compare(h,t);return s!==0?s:h.length!==t.length?h.length<t.length?-1:1:0}function p(o,h,t=!1){return t||(o=o&&o.toLowerCase(),h=h&&h.toLowerCase()),o===h?0:o<h?-1:1}function f(o,h,t=!1){const s=o.split(b.sep),l=h.split(b.sep),u=s.length-1,r=l.length-1;let g,C;for(let _=0;;_++){if(g=u===_,C=r===_,g&&C)return k(s[_],l[_],t);if(g)return-1;if(C)return 1;const D=p(s[_],l[_],t);if(D!==0)return D}}e.comparePaths=f;function c(o,h,t){const s=o.toLowerCase(),l=h.toLowerCase(),u=n(o,h,t);if(u)return u;const r=s.endsWith(t),g=l.endsWith(t);if(r!==g)return r?-1:1;const C=k(s,l);return C!==0?C:s.localeCompare(l)}e.compareAnything=c;function n(o,h,t){const s=o.toLowerCase(),l=h.toLowerCase(),u=s.startsWith(t),r=l.startsWith(t);if(u!==r)return u?-1:1;if(u&&r){if(s.length<l.length)return-1;if(s.length>l.length)return 1}return 0}e.compareByPrefix=n}),define(ve[105],_e([0,1,9,6]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.observe=e.transform=e.toReadable=e.toStream=e.peekStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(p){const f=p;return f&&[f.on,f.pause,f.resume,f.destroy].every(c=>typeof c=="function")}e.isReadableStream=A;function T(p){const f=p;return f&&A(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean"}e.isReadableBufferedStream=T;function E(p,f){return new k(p,f)}e.newWriteableStream=E;class k{constructor(f,c){this.reducer=f,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){var c;if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof((c=this.options)===null||c===void 0?void 0:c.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(f instanceof Error?this.error(f):f&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(c=>c(f))}emitError(f){this.listeners.error.length===0?b.onUnexpectedError(f):this.listeners.error.slice(0).forEach(c=>c(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,c){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(f,c){if(!this.state.destroyed){let n;switch(f){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const o=n.indexOf(c);o>=0&&n.splice(o,1)}}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function I(p,f){const c=[];let n;for(;(n=p.read())!==null;)c.push(n);return f(c)}e.consumeReadable=I;function i(p,f,c){const n=[];let o;for(;(o=p.read())!==null&&n.length<c;)n.push(o);return o===null&&n.length>0?f(n):{read:()=>{if(n.length>0)return n.shift();if(typeof o!="undefined"){const h=o;return o=void 0,h}return p.read()}}}e.peekReadable=i;function P(p,f){return new Promise((c,n)=>{const o=[];p.on("error",h=>n(h)),p.on("end",()=>c(f(o))),p.on("data",h=>o.push(h))})}e.consumeStream=P;function S(p,f){return new Promise((c,n)=>{const o=new y.DisposableStore,h=[],t=u=>{if(h.push(u),h.length>f)return o.dispose(),p.pause(),c({stream:p,buffer:h,ended:!1})};o.add(y.toDisposable(()=>p.removeListener("data",t))),p.on("data",t);const s=u=>n(u);o.add(y.toDisposable(()=>p.removeListener("error",s))),p.on("error",s);const l=()=>c({stream:p,buffer:h,ended:!0});o.add(y.toDisposable(()=>p.removeListener("end",l))),p.on("end",l)})}e.peekStream=S;function v(p,f){const c=E(f);return c.end(p),c}e.toStream=v;function d(p){let f=!1;return{read:()=>f?null:(f=!0,p)}}e.toReadable=d;function a(p,f,c){const n=E(c);return p.on("data",o=>n.write(f.data(o))),p.on("end",()=>n.end()),p.on("error",o=>n.error(f.error?f.error(o):o)),n}e.transform=a;function m(p){const f=Promise.race([new Promise(c=>p.on("end",()=>c())),new Promise(c=>p.on("error",()=>c()))]);return{errorOrEnd(){return p.resume(),f}}}e.observe=m}),define(ve[8],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function b(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=b;const y=/{(\d+)}/g;function A(ie,...ge){return ge.length===0?ie:ie.replace(y,function(Me,G){const Q=parseInt(G,10);return isNaN(Q)||Q<0||Q>=ge.length?Me:ge[Q]})}e.format=A;function T(ie){return ie.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}e.escape=T;function E(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function k(ie,ge){let Me=0;const G=ge.charCodeAt(0);for(let Q=ie.length-1;Q>=0;Q--)ie.charCodeAt(Q)===G&&Me++;return Me}e.count=k;function I(ie,ge,Me="\u2026"){return ie.length<=ge?ie:`${ie.substr(0,ge)}${Me}`}e.truncate=I;function i(ie,ge=" "){const Me=P(ie,ge);return S(Me,ge)}e.trim=i;function P(ie,ge){if(!ie||!ge)return ie;const Me=ge.length;if(Me===0||ie.length===0)return ie;let G=0;for(;ie.indexOf(ge,G)===G;)G=G+Me;return ie.substring(G)}e.ltrim=P;function S(ie,ge){if(!ie||!ge)return ie;const Me=ge.length,G=ie.length;if(Me===0||G===0)return ie;let Q=G,H=-1;for(;H=ie.lastIndexOf(ge,Q-1),!(H===-1||H+Me!==Q);){if(H===0)return"";Q=H}return ie.substring(0,Q)}e.rtrim=S;function v(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function d(ie){return ie.replace(/\*/g,"")}e.stripWildcards=d;function a(ie,ge,Me={}){if(!ie)throw new Error("Cannot create regex from empty string");ge||(ie=E(ie)),Me.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let G="";return Me.global&&(G+="g"),Me.matchCase||(G+="i"),Me.multiline&&(G+="m"),Me.unicode&&(G+="u"),new RegExp(ie,G)}e.createRegExp=a;function m(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function p(ie){return!!ie.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function f(ie){return(ie.global?"g":"")+(ie.ignoreCase?"i":"")+(ie.multiline?"m":"")+(ie.unicode?"u":"")}e.regExpFlags=f;function c(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=c;function n(ie){for(let ge=0,Me=ie.length;ge<Me;ge++){const G=ie.charCodeAt(ge);if(G!==32&&G!==9)return ge}return-1}e.firstNonWhitespaceIndex=n;function o(ie,ge=0,Me=ie.length){for(let G=ge;G<Me;G++){const Q=ie.charCodeAt(G);if(Q!==32&&Q!==9)return ie.substring(ge,G)}return ie.substring(ge,Me)}e.getLeadingWhitespace=o;function h(ie,ge=ie.length-1){for(let Me=ge;Me>=0;Me--){const G=ie.charCodeAt(Me);if(G!==32&&G!==9)return Me}return-1}e.lastNonWhitespaceIndex=h;function t(ie,ge){return ie<ge?-1:ie>ge?1:0}e.compare=t;function s(ie,ge,Me=0,G=ie.length,Q=0,H=ge.length){for(;Me<G&&Q<H;Me++,Q++){let X=ie.charCodeAt(Me),ce=ge.charCodeAt(Q);if(X<ce)return-1;if(X>ce)return 1}const L=G-Me,J=H-Q;return L<J?-1:L>J?1:0}e.compareSubstring=s;function l(ie,ge){return u(ie,ge,0,ie.length,0,ge.length)}e.compareIgnoreCase=l;function u(ie,ge,Me=0,G=ie.length,Q=0,H=ge.length){for(;Me<G&&Q<H;Me++,Q++){let X=ie.charCodeAt(Me),ce=ge.charCodeAt(Q);if(X!==ce){const me=X-ce;if(!(me===32&&g(ce))&&!(me===-32&&g(X)))return r(X)&&r(ce)?me:s(ie.toLowerCase(),ge.toLowerCase(),Me,G,Q,H)}}const L=G-Me,J=H-Q;return L<J?-1:L>J?1:0}e.compareSubstringIgnoreCase=u;function r(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=r;function g(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=g;function C(ie){return r(ie)||g(ie)}function _(ie,ge){return ie.length===ge.length&&D(ie,ge)}e.equalsIgnoreCase=_;function D(ie,ge,Me=ie.length){for(let G=0;G<Me;G++){const Q=ie.charCodeAt(G),H=ge.charCodeAt(G);if(Q!==H){if(C(Q)&&C(H)){const L=Math.abs(Q-H);if(L!==0&&L!==32)return!1}else if(String.fromCharCode(Q).toLowerCase()!==String.fromCharCode(H).toLowerCase())return!1}}return!0}function w(ie,ge){const Me=ge.length;return ge.length>ie.length?!1:D(ie,ge,Me)}e.startsWithIgnoreCase=w;function O(ie,ge){let Me,G=Math.min(ie.length,ge.length);for(Me=0;Me<G;Me++)if(ie.charCodeAt(Me)!==ge.charCodeAt(Me))return Me;return G}e.commonPrefixLength=O;function R(ie,ge){let Me,G=Math.min(ie.length,ge.length);const Q=ie.length-1,H=ge.length-1;for(Me=0;Me<G;Me++)if(ie.charCodeAt(Q-Me)!==ge.charCodeAt(H-Me))return Me;return G}e.commonSuffixLength=R;function $(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=$;function V(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=V;function z(ie,ge){return(ie-55296<<10)+(ge-56320)+65536}e.computeCodePoint=z;function U(ie,ge,Me){const G=ie.charCodeAt(Me);if($(G)&&Me+1<ge){const Q=ie.charCodeAt(Me+1);if(V(Q))return z(G,Q)}return G}e.getNextCodePoint=U;function q(ie,ge){const Me=ie.charCodeAt(ge-1);if(V(Me)&&ge>1){const G=ie.charCodeAt(ge-2);if($(G))return z(G,Me)}return Me}function M(ie,ge){const Me=We.getInstance(),G=ge,Q=ie.length,H=U(ie,Q,ge);ge+=H>=65536?2:1;let L=Me.getGraphemeBreakType(H);for(;ge<Q;){const J=U(ie,Q,ge),X=Me.getGraphemeBreakType(J);if(Le(L,X))break;ge+=J>=65536?2:1,L=X}return ge-G}e.nextCharLength=M;function j(ie,ge){const Me=We.getInstance(),G=ge,Q=q(ie,ge);ge-=Q>=65536?2:1;let H=Me.getGraphemeBreakType(Q);for(;ge>0;){const L=q(ie,ge),J=Me.getGraphemeBreakType(L);if(Le(J,H))break;ge-=L>=65536?2:1,H=J}return G-ge}e.prevCharLength=j;function re(ie,ge){const Me=We.getInstance(),G=ie.length,Q=ge,H=U(ie,G,ge),L=Me.getGraphemeBreakType(H);ge+=H>=65536?2:1;let J=L;for(;ge<G;){const ce=U(ie,G,ge),me=Me.getGraphemeBreakType(ce);if(Le(J,me))break;ge+=ce>=65536?2:1,J=me}const X=ge;for(ge=Q,J=L;ge>0;){const ce=q(ie,ge),me=Me.getGraphemeBreakType(ce);if(Le(me,J))break;ge-=ce>=65536?2:1,J=me}return[ge,X]}function F(ie,ge){return ge>0&&V(ie.charCodeAt(ge))?re(ie,ge-1):re(ie,ge)}e.getCharContainingOffset=F;function te(ie){const ge=ie.length;let Me=0,G=0;for(;G<ge;){const L=U(ie,ge,G);G+=L>=65536?2:1,L<128?Me+=1:L<2048?Me+=2:L<65536?Me+=3:Me+=4}const Q=new Uint8Array(Me);G=0;let H=0;for(;G<ge;){const L=U(ie,ge,G);G+=L>=65536?2:1,L<128?Q[H++]=L:L<2048?(Q[H++]=192|(L&1984)>>>6,Q[H++]=128|(L&63)>>>0):L<65536?(Q[H++]=224|(L&61440)>>>12,Q[H++]=128|(L&4032)>>>6,Q[H++]=128|(L&63)>>>0):(Q[H++]=240|(L&1835008)>>>18,Q[H++]=128|(L&258048)>>>12,Q[H++]=128|(L&4032)>>>6,Q[H++]=128|(L&63)>>>0)}return Q}e.encodeUTF8=te;function ae(ie){const ge=ie.byteLength,Me=[];let G=0;for(;G<ge;){const Q=ie[G];let H;if(Q>=240&&G+3<ge?H=(ie[G++]&7)<<18>>>0|(ie[G++]&63)<<12>>>0|(ie[G++]&63)<<6>>>0|(ie[G++]&63)<<0>>>0:Q>=224&&G+2<ge?H=(ie[G++]&15)<<12>>>0|(ie[G++]&63)<<6>>>0|(ie[G++]&63)<<0>>>0:Q>=192&&G+1<ge?H=(ie[G++]&31)<<6>>>0|(ie[G++]&63)<<0>>>0:H=ie[G++],H>=0&&H<=55295||H>=57344&&H<=65535)Me.push(String.fromCharCode(H));else if(H>=65536&&H<=1114111){const L=H-65536,J=55296+((L&1047552)>>>10),X=56320+((L&1023)>>>0);Me.push(String.fromCharCode(J)),Me.push(String.fromCharCode(X))}else Me.push(String.fromCharCode(65533))}return Me.join("")}e.decodeUTF8=ae;const ue=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function we(ie){return ue.test(ie)}e.containsRTL=we;const fe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDE73\uDE78-\uDE82\uDE90-\uDE95])/;function De(ie){return fe.test(ie)}e.containsEmoji=De;const Se=/^[\t\n\r\x20-\x7E]*$/;function Ce(ie){return Se.test(ie)}e.isBasicASCII=Ce,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function x(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=x;function K(ie){for(let ge=0,Me=ie.length;ge<Me;ge++)if(ee(ie.charCodeAt(ge)))return!0;return!1}e.containsFullWidthCharacter=K;function ee(ie){return ie=+ie,ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=ee;function ne(ie){return ie>=127462&&ie<=127487||ie>=9728&&ie<=10175||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129003||ie>=129280&&ie<=129535||ie>=129648&&ie<=129651||ie>=129656&&ie<=129666||ie>=129680&&ie<=129685}e.isEmojiImprecise=ne;function de(ie,ge){if(ie.length<ge)return ie;const Me=/\b/g;let G=0;for(;Me.test(ie)&&!(ie.length-Me.lastIndex<ge);)G=Me.lastIndex,Me.lastIndex+=1;return ie.substring(G).replace(/^\s/,"")}e.lcut=de;const Ee=/\x1B\x5B[12]?K/g,Re=/\x1b\[\d+m/g,xe=/\x1b\[0?m/g;function be(ie){return ie&&(ie=ie.replace(Ee,""),ie=ie.replace(Re,""),ie=ie.replace(xe,"")),ie}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Te(ie){return ke(ie)?ie.substr(1):ie}e.stripUTF8BOM=Te;function Ne(ie,ge){if(!ie||!ge||ie.length<ge.length)return!1;const Me=ge.length,G=ie.toLowerCase();let Q=0,H=-1;for(;Q<Me;){const L=G.indexOf(ge[Q],H+1);if(L<0)return!1;H=L,Q++}return!0}e.fuzzyContains=Ne;function pe(ie,ge=!1){return ie?(ge&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=pe;function ze(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=ze;function B(ie,ge=1){if(ge===0)return"";let Me=-1;do Me=ie.indexOf(`
`,Me+1),ge--;while(ge>0&&Me>=0);return Me===-1?ie:(ie[Me-1]==="\r"&&Me--,ie.substr(0,Me))}e.getNLines=B;function Z(ie){const ge=90-65+1;return ie=ie%(2*ge),ie<ge?String.fromCharCode(97+ie):String.fromCharCode(65+ie-ge)}e.singleLetterHash=Z;function he(ie){return We.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=he;function Le(ie,ge){return ie===0?ge!==5&&ge!==7:ie===2&&ge===3?!1:ie===4||ie===2||ie===3||ge===4||ge===2||ge===3?!0:!(ie===8&&(ge===8||ge===9||ge===11||ge===12)||(ie===11||ie===9)&&(ge===9||ge===10)||(ie===12||ie===10)&&ge===10||ge===5||ge===13||ge===7||ie===1||ie===13&&ge===14||ie===6&&ge===6)}e.breakBetweenGraphemeBreakType=Le;var Oe;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(Oe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{constructor(){this._data=Ke()}static getInstance(){return We._INSTANCE||(We._INSTANCE=new We),We._INSTANCE}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const Me=this._data,G=Me.length/3;let Q=1;for(;Q<=G;)if(ge<Me[3*Q])Q=2*Q;else if(ge>Me[3*Q+1])Q=2*Q+1;else return Me[3*Q+2];return 0}}We._INSTANCE=null;function Ke(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(ve[27],_e([0,1,8,105]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",E=typeof TextDecoder!="undefined";let k,I;class i{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return A?new i(Buffer.allocUnsafe(r)):new i(new Uint8Array(r))}static wrap(r){return A&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new i(r)}static fromString(r,g){return!((g==null?void 0:g.dontUseNodeBuffer)||!1)&&A?new i(Buffer.from(r)):T?(k||(k=new TextEncoder),new i(k.encode(r))):new i(b.encodeUTF8(r))}static concat(r,g){if(typeof g=="undefined"){g=0;for(let D=0,w=r.length;D<w;D++)g+=r[D].byteLength}const C=i.alloc(g);let _=0;for(let D=0,w=r.length;D<w;D++){const O=r[D];C.set(O,_),_+=O.byteLength}return C}toString(){return A?this.buffer.toString():E?(I||(I=new TextDecoder),I.decode(this.buffer)):b.decodeUTF8(this.buffer)}slice(r,g){return new i(this.buffer.subarray(r,g))}set(r,g){r instanceof i?this.buffer.set(r.buffer,g):this.buffer.set(r,g)}readUInt32BE(r){return v(this.buffer,r)}writeUInt32BE(r,g){d(this.buffer,r,g)}readUInt32LE(r){return a(this.buffer,r)}writeUInt32LE(r,g){m(this.buffer,r,g)}readUInt8(r){return p(this.buffer,r)}writeUInt8(r,g){f(this.buffer,r,g)}}e.VSBuffer=i;function P(u,r){return u[r+0]<<0>>>0|u[r+1]<<8>>>0}e.readUInt16LE=P;function S(u,r,g){u[g+0]=r&255,r=r>>>8,u[g+1]=r&255}e.writeUInt16LE=S;function v(u,r){return u[r]*2**24+u[r+1]*2**16+u[r+2]*2**8+u[r+3]}e.readUInt32BE=v;function d(u,r,g){u[g+3]=r,r=r>>>8,u[g+2]=r,r=r>>>8,u[g+1]=r,r=r>>>8,u[g]=r}e.writeUInt32BE=d;function a(u,r){return u[r+0]<<0>>>0|u[r+1]<<8>>>0|u[r+2]<<16>>>0|u[r+3]<<24>>>0}e.readUInt32LE=a;function m(u,r,g){u[g+0]=r&255,r=r>>>8,u[g+1]=r&255,r=r>>>8,u[g+2]=r&255,r=r>>>8,u[g+3]=r&255}e.writeUInt32LE=m;function p(u,r){return u[r]}e.readUInt8=p;function f(u,r,g){u[g]=r}e.writeUInt8=f;function c(u){return y.consumeReadable(u,r=>i.concat(r))}e.readableToBuffer=c;function n(u){return y.toReadable(u)}e.bufferToReadable=n;function o(u){return y.consumeStream(u,r=>i.concat(r))}e.streamToBuffer=o;async function h(u){return u.ended?i.concat(u.buffer):i.concat([...u.buffer,await o(u.stream)])}e.bufferedStreamToBuffer=h;function t(u){return y.toStream(u,r=>i.concat(r))}e.bufferToStream=t;function s(u){return y.transform(u,{data:r=>typeof r=="string"?i.fromString(r):i.wrap(r)},r=>i.concat(r))}e.streamToBufferReadableStream=s;function l(u){return y.newWriteableStream(r=>i.concat(r),u)}e.newWriteableBufferStream=l}),define(ve[56],_e([0,1,8]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function y(f){return A(f,0)}e.hash=y;function A(f,c){switch(typeof f){case"object":return f===null?T(349,c):Array.isArray(f)?I(f,c):i(f,c);case"string":return k(f,c);case"boolean":return E(f,c);case"number":return T(f,c);case"undefined":return T(937,c);default:return T(617,c)}}e.doHash=A;function T(f,c){return(c<<5)-c+f|0}function E(f,c){return T(f?433:863,c)}function k(f,c){c=T(149417,c);for(let n=0,o=f.length;n<o;n++)c=T(f.charCodeAt(n),c);return c}e.stringHash=k;function I(f,c){return c=T(104579,c),f.reduce((n,o)=>A(o,n),c)}function i(f,c){return c=T(181387,c),Object.keys(f).sort().reduce((n,o)=>(n=k(o,n),A(f[o],n)),c)}class P{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=A(c,this._value),this._value}}e.Hasher=P;var S;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function v(f,c,n=32){const o=n-c,h=~((1<<o)-1);return(f<<c|(h&f)>>>o)>>>0}function d(f,c=0,n=f.byteLength,o=0){for(let h=0;h<n;h++)f[c+h]=o}function a(f,c,n="0"){for(;f.length<c;)f=n+f;return f}function m(f,c=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(n=>n.toString(16).padStart(2,"0")).join(""):a((f>>>0).toString(16),c/4)}e.toHexString=m;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const n=c.length;if(n!==0){const o=this._buff;let h=this._buffLen,t=this._leftoverHighSurrogate,s,l;for(t!==0?(s=t,l=-1,t=0):(s=c.charCodeAt(0),l=0);;){let u=s;if(b.isHighSurrogate(s))if(l+1<n){const r=c.charCodeAt(l+1);b.isLowSurrogate(r)?(l++,u=b.computeCodePoint(s,r)):u=65533}else{t=s;break}else b.isLowSurrogate(s)&&(u=65533);if(h=this._push(o,h,u),l++,l<n)s=c.charCodeAt(l);else break}this._buffLen=h,this._leftoverHighSurrogate=t}}_push(c,n,o){return o<128?c[n++]=o:o<2048?(c[n++]=192|(o&1984)>>>6,c[n++]=128|(o&63)>>>0):o<65536?(c[n++]=224|(o&61440)>>>12,c[n++]=128|(o&4032)>>>6,c[n++]=128|(o&63)>>>0):(c[n++]=240|(o&1835008)>>>18,c[n++]=128|(o&258048)>>>12,c[n++]=128|(o&4032)>>>6,c[n++]=128|(o&63)>>>0),n>=64&&(this._step(),n-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),n}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=p._bigBlock32,n=this._buffDV;for(let C=0;C<64;C+=4)c.setUint32(C,n.getUint32(C,!1),!1);for(let C=64;C<320;C+=4)c.setUint32(C,v(c.getUint32(C-12,!1)^c.getUint32(C-32,!1)^c.getUint32(C-56,!1)^c.getUint32(C-64,!1),1),!1);let o=this._h0,h=this._h1,t=this._h2,s=this._h3,l=this._h4,u,r,g;for(let C=0;C<80;C++)C<20?(u=h&t|~h&s,r=1518500249):C<40?(u=h^t^s,r=1859775393):C<60?(u=h&t|h&s|t&s,r=2400959708):(u=h^t^s,r=3395469782),g=v(o,5)+u+l+r+c.getUint32(C*4,!1)&4294967295,l=s,s=t,t=v(h,30),h=o,o=g;this._h0=this._h0+o&4294967295,this._h1=this._h1+h&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+l&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ve[57],_e([0,1,8]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var y;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(y||(y={})),function(A){const T="error",E="warning",k="warn",I="info";function i(P){return P?b.equalsIgnoreCase(T,P)?A.Error:b.equalsIgnoreCase(E,P)||b.equalsIgnoreCase(k,P)?A.Warning:b.equalsIgnoreCase(I,P)?A.Info:A.Ignore:A.Ignore}A.fromValue=i}(y||(y={})),e.default=y}),define(ve[12],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function b(r){return Array.isArray(r)}e.isArray=b;function y(r){return typeof r=="string"}e.isString=y;function A(r){return Array.isArray(r)&&r.every(g=>y(g))}e.isStringArray=A;function T(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=T;function E(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=E;function k(r){return r===!0||r===!1}e.isBoolean=k;function I(r){return typeof r=="undefined"}e.isUndefined=I;function i(r){return!P(r)}e.isDefined=i;function P(r){return I(r)||r===null}e.isUndefinedOrNull=P;function S(r,g){if(!r)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}e.assertType=S;function v(r){if(P(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=v;function d(...r){const g=[];for(let C=0;C<r.length;C++){const _=r[C];if(P(_))throw new Error(`Assertion Failed: argument at index ${C} is undefined or null`);g.push(_)}return g}e.assertAllDefined=d;const a=Object.prototype.hasOwnProperty;function m(r){if(!T(r))return!1;for(let g in r)if(a.call(r,g))return!1;return!0}e.isEmptyObject=m;function p(r){return typeof r=="function"}e.isFunction=p;function f(...r){return r.length>0&&r.every(p)}e.areFunctions=f;function c(r,g){const C=Math.min(r.length,g.length);for(let _=0;_<C;_++)n(r[_],g[_])}e.validateConstraints=c;function n(r,g){if(y(g)){if(typeof r!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(p(g)){try{if(r instanceof g)return}catch(C){}if(!P(r)&&r.constructor===g||g.length===1&&g.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=n;function o(r){let g=[],C=Object.getPrototypeOf(r);for(;Object.prototype!==C;)g=g.concat(Object.getOwnPropertyNames(C)),C=Object.getPrototypeOf(C);return g}e.getAllPropertyNames=o;function h(r){const g=[];for(const C of o(r))typeof r[C]=="function"&&g.push(C);return g}e.getAllMethodNames=h;function t(r,g){const C=D=>function(){const w=Array.prototype.slice.call(arguments,0);return g(D,w)};let _={};for(const D of r)_[D]=C(D);return _}e.createProxyObject=t;function s(r){return r===null?void 0:r}e.withNullAsUndefined=s;function l(r){return typeof r=="undefined"?null:r}e.withUndefinedAsNull=l;function u(r){return class{constructor(){return new Proxy({},{get(g,C){if(g[C])return g[C];throw new Error(`Not Implemented: ${r}->${String(C)}`)}})}}}e.NotImplementedProxy=u}),define(ve[38],_e([0,1,21,8,10,12]),function(se,e,b,y,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function E(s){return s===47||s===92}e.isPathSeparator=E;function k(s){return s.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=k;function I(s,l=A.posix.sep){if(!s)return"";const u=s.length,r=s.charCodeAt(0);if(E(r)){if(E(s.charCodeAt(1))&&!E(s.charCodeAt(2))){let C=3;const _=C;for(;C<u&&!E(s.charCodeAt(C));C++);if(_!==C&&!E(s.charCodeAt(C+1))){for(C+=1;C<u;C++)if(E(s.charCodeAt(C)))return s.slice(0,C+1).replace(/[\\/]/g,l)}}return l}else if(p(r)&&s.charCodeAt(1)===58)return E(s.charCodeAt(2))?s.slice(0,2)+l:s.slice(0,2);let g=s.indexOf("://");if(g!==-1){for(g+=3;g<u;g++)if(E(s.charCodeAt(g)))return s.slice(0,g+1)}return""}e.getRoot=I;function i(s){if(!b.isWindows||!s||s.length<5)return!1;let l=s.charCodeAt(0);if(l!==92||(l=s.charCodeAt(1),l!==92))return!1;let u=2;const r=u;for(;u<s.length&&(l=s.charCodeAt(u),l!==92);u++);return!(r===u||(l=s.charCodeAt(u+1),isNaN(l)||l===92))}e.isUNC=i;const P=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,l=b.isWindows){const u=l?P:S;return!(!s||s.length===0||/^\s+$/.test(s)||(u.lastIndex=0,u.test(s))||l&&v.test(s)||s==="."||s===".."||l&&s[s.length-1]==="."||l&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function a(s,l,u){const r=s===l;return!u||r?r:!s||!l?!1:y.equalsIgnoreCase(s,l)}e.isEqual=a;function m(s,l,u,r=A.sep){if(s===l)return!0;if(!s||!l||l.length>s.length)return!1;if(u){if(!y.startsWithIgnoreCase(s,l))return!1;if(l.length===s.length)return!0;let C=l.length;return l.charAt(l.length-1)===r&&C--,s.charAt(C)===r}return l.charAt(l.length-1)!==r&&(l+=r),s.indexOf(l)===0}e.isEqualOrParent=m;function p(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=p;function f(s,l){return b.isWindows&&s.endsWith(":")&&(s+=A.sep),A.isAbsolute(s)||(s=A.join(l,s)),s=A.normalize(s),b.isWindows?(s=y.rtrim(s,A.sep),s.endsWith(":")&&(s+=A.sep)):(s=y.rtrim(s,A.sep),s||(s=A.sep)),s}e.sanitizeFilePath=f;function c(s){const l=A.normalize(s);return b.isWindows?s.length>3?!1:n(l)&&(s.length===2||l.charCodeAt(2)===92):l===A.posix.sep}e.isRootOrDriveLetter=c;function n(s){return b.isWindows?p(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=n;function o(s){return n(s)?s[0]:void 0}e.getDriveLetter=o;function h(s,l,u){return l.length>s.length?-1:s===l?0:(u&&(s=s.toLowerCase(),l=l.toLowerCase()),s.indexOf(l))}e.indexOfPath=h;function t(s){const l=s.split(":");let u,r,g;if(l.forEach(C=>{const _=Number(C);T.isNumber(_)?r===void 0?r=_:g===void 0&&(g=_):u=u?[u,C].join(":"):C}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:r!==void 0?r:void 0,column:g!==void 0?g:r!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ve[24],_e([0,1,12]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function y(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const m=Array.isArray(a)?[]:{};return Object.keys(a).forEach(p=>{a[p]&&typeof a[p]=="object"?m[p]=y(a[p]):m[p]=a[p]}),m}e.deepClone=y;function A(a){if(!a||typeof a!="object")return a;const m=[a];for(;m.length>0;){const p=m.shift();Object.freeze(p);for(const f in p)if(T.call(p,f)){const c=p[f];typeof c=="object"&&!Object.isFrozen(c)&&m.push(c)}}return a}e.deepFreeze=A;const T=Object.prototype.hasOwnProperty;function E(a,m){return k(a,m,new Set)}e.cloneAndChange=E;function k(a,m,p){if(b.isUndefinedOrNull(a))return a;const f=m(a);if(typeof f!="undefined")return f;if(b.isArray(a)){const c=[];for(const n of a)c.push(k(n,m,p));return c}if(b.isObject(a)){if(p.has(a))throw new Error("Cannot clone recursive data-structure");p.add(a);const c={};for(let n in a)T.call(a,n)&&(c[n]=k(a[n],m,p));return p.delete(a),c}return a}function I(a,m,p=!0){return b.isObject(a)?(b.isObject(m)&&Object.keys(m).forEach(f=>{f in a?p&&(b.isObject(a[f])&&b.isObject(m[f])?I(a[f],m[f],p):a[f]=m[f]):a[f]=m[f]}),a):m}e.mixin=I;function i(a,m){if(a===m)return!0;if(a==null||m===null||m===void 0||typeof a!=typeof m||typeof a!="object"||Array.isArray(a)!==Array.isArray(m))return!1;let p,f;if(Array.isArray(a)){if(a.length!==m.length)return!1;for(p=0;p<a.length;p++)if(!i(a[p],m[p]))return!1}else{const c=[];for(f in a)c.push(f);c.sort();const n=[];for(f in m)n.push(f);if(n.sort(),!i(c,n))return!1;for(p=0;p<c.length;p++)if(!i(a[c[p]],m[c[p]]))return!1}return!0}e.equals=i;function P(a){const m=new Set;return JSON.stringify(a,(p,f)=>{if(b.isObject(f)||Array.isArray(f)){if(m.has(f))return"[Circular]";m.add(f)}return f})}e.safeStringify=P;function S(a,m,p){const f=m(a);return typeof f=="undefined"?p:f}e.getOrDefault=S;function v(a,m){const p=Object.create(null);return!a||!m||Object.keys(m).forEach(c=>{const n=a[c],o=m[c];i(n,o)||(p[c]=o)}),p}e.distinct=v;function d(a,m){const p=m.toLowerCase(),f=Object.keys(a).find(c=>c.toLowerCase()===p);return f?a[f]:a[m]}e.getCaseInsensitive=d}),define(ve[80],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var b;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(b=e.Constants||(e.Constants={}));function y(T){return T<0?0:T>255?255:T|0}e.toUint8=y;function A(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=A}),define(ve[2],_e([0,1,21,10]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,T=/^\//,E=/^\/\//;function k(l,u){if(!l.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!A.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!T.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(l,u){return!l&&!u?"file":l}function i(l,u){switch(l){case"https":case"http":case"file":u?u[0]!==S&&(u=S+u):u=S;break}return u}const P="",S="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{constructor(u,r,g,C,_,D=!1){typeof u=="object"?(this.scheme=u.scheme||P,this.authority=u.authority||P,this.path=u.path||P,this.query=u.query||P,this.fragment=u.fragment||P):(this.scheme=I(u,D),this.authority=r||P,this.path=i(this.scheme,g||P),this.query=C||P,this.fragment=_||P,k(this,D))}static isUri(u){return u instanceof d?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}get fsPath(){return n(this,!1)}with(u){if(!u)return this;let{scheme:r,authority:g,path:C,query:_,fragment:D}=u;return r===void 0?r=this.scheme:r===null&&(r=P),g===void 0?g=this.authority:g===null&&(g=P),C===void 0?C=this.path:C===null&&(C=P),_===void 0?_=this.query:_===null&&(_=P),D===void 0?D=this.fragment:D===null&&(D=P),r===this.scheme&&g===this.authority&&C===this.path&&_===this.query&&D===this.fragment?this:new m(r,g,C,_,D)}static parse(u,r=!1){const g=v.exec(u);return g?new m(g[2]||P,s(g[4]||P),s(g[5]||P),s(g[7]||P),s(g[9]||P),r):new m(P,P,P,P,P)}static file(u){let r=P;if(b.isWindows&&(u=u.replace(/\\/g,S)),u[0]===S&&u[1]===S){const g=u.indexOf(S,2);g===-1?(r=u.substring(2),u=S):(r=u.substring(2,g),u=u.substring(g)||S)}return new m("file",r,u,P,P)}static from(u){return new m(u.scheme,u.authority,u.path,u.query,u.fragment)}static joinPath(u,...r){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return b.isWindows&&u.scheme==="file"?g=d.file(y.win32.join(n(u,!0),...r)).path:g=y.posix.join(u.path,...r),u.with({path:g})}toString(u=!1){return o(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof d)return u;{const r=new m(u);return r._formatted=u.external,r._fsPath=u._sep===a?u.fsPath:null,r}}else return u}}e.URI=d;const a=b.isWindows?1:void 0;class m extends d{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(u=!1){return u?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=a),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(l,u){let r,g=-1;for(let C=0;C<l.length;C++){const _=l.charCodeAt(C);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||u&&_===47)g!==-1&&(r+=encodeURIComponent(l.substring(g,C)),g=-1),r!==void 0&&(r+=l.charAt(C));else{r===void 0&&(r=l.substr(0,C));const D=p[_];D!==void 0?(g!==-1&&(r+=encodeURIComponent(l.substring(g,C)),g=-1),r+=D):g===-1&&(g=C)}}return g!==-1&&(r+=encodeURIComponent(l.substring(g))),r!==void 0?r:l}function c(l){let u;for(let r=0;r<l.length;r++){const g=l.charCodeAt(r);g===35||g===63?(u===void 0&&(u=l.substr(0,r)),u+=p[g]):u!==void 0&&(u+=l[r])}return u!==void 0?u:l}function n(l,u){let r;return l.authority&&l.path.length>1&&l.scheme==="file"?r=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?u?r=l.path.substr(1):r=l.path[1].toLowerCase()+l.path.substr(2):r=l.path,b.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=n;function o(l,u){const r=u?c:f;let g="",{scheme:C,authority:_,path:D,query:w,fragment:O}=l;if(C&&(g+=C,g+=":"),(_||C==="file")&&(g+=S,g+=S),_){let R=_.indexOf("@");if(R!==-1){const $=_.substr(0,R);_=_.substr(R+1),R=$.indexOf(":"),R===-1?g+=r($,!1):(g+=r($.substr(0,R),!1),g+=":",g+=r($.substr(R+1),!1)),g+="@"}_=_.toLowerCase(),R=_.indexOf(":"),R===-1?g+=r(_,!1):(g+=r(_.substr(0,R),!1),g+=_.substr(R))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const R=D.charCodeAt(1);R>=65&&R<=90&&(D=`/${String.fromCharCode(R+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const R=D.charCodeAt(0);R>=65&&R<=90&&(D=`${String.fromCharCode(R+32)}:${D.substr(2)}`)}g+=r(D,!0)}return w&&(g+="?",g+=r(w,!1)),O&&(g+="#",g+=u?O:f(O,!1)),g}function h(l){try{return decodeURIComponent(l)}catch(u){return l.length>3?l.substr(0,3)+h(l.substr(3)):l}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(l){return l.match(t)?l.replace(t,u=>h(u)):l}}),define(ve[22],_e([0,1,2,8]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(c,n,o){let h=c.get(n);return h===void 0&&(h=o,c.set(n,h)),h}e.getOrSet=A;function T(c){const n=[];return c.forEach((o,h)=>{n.push(`${h} => ${o}`)}),`Map(${c.size}) {${n.join(", ")}}`}e.mapToString=T;function E(c){const n=[];return c.forEach(o=>{n.push(o)}),`Set(${c.size}) {${n.join(", ")}}`}e.setToString=E;class k{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),h=this._value.charCodeAt(this._pos);return o-h}value(){return this._value[this._pos]}}e.StringIterator=k;class I{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?y.compareSubstring(n,this._value,0,n.length,this._from,this._to):y.compareSubstringIgnoreCase(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class i{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?y.compareSubstring(n,this._value,0,n.length,this._from,this._to):y.compareSubstringIgnoreCase(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=i;var P;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(P||(P={}));class S{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new i(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return y.compareIgnoreCase(n,this._value.scheme);if(this._states[this._stateIdx]===2)return y.compareIgnoreCase(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return y.compare(n,this._value.query);if(this._states[this._stateIdx]===5)return y.compare(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class d{constructor(n){this._iter=n}static forUris(n=()=>!1){return new d(new S(n))}static forPaths(){return new d(new i)}static forStrings(){return new d(new k)}static forConfigKeys(){return new d(new I)}clear(){this._root=void 0}set(n,o){const h=this._iter.reset(n);let t;for(this._root||(this._root=new v,this._root.segment=h.value()),t=this._root;;){const l=h.cmp(t.segment);if(l>0)t.left||(t.left=new v,t.left.segment=h.value()),t=t.left;else if(l<0)t.right||(t.right=new v,t.right.segment=h.value()),t=t.right;else if(h.hasNext())h.next(),t.mid||(t.mid=new v,t.mid.segment=h.value()),t=t.mid;else break}const s=t.value;return t.value=o,t.key=n,s}get(n){var o;return(o=this._getNode(n))===null||o===void 0?void 0:o.value}_getNode(n){const o=this._iter.reset(n);let h=this._root;for(;h;){const t=o.cmp(h.segment);if(t>0)h=h.left;else if(t<0)h=h.right;else if(o.hasNext())o.next(),h=h.mid;else break}return h}has(n){const o=this._getNode(n);return!((o==null?void 0:o.value)===void 0&&(o==null?void 0:o.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const h=this._iter.reset(n),t=[];let s=this._root;for(;s;){const l=h.cmp(s.segment);if(l>0)t.push([1,s]),s=s.left;else if(l<0)t.push([-1,s]),s=s.right;else if(h.hasNext())h.next(),t.push([0,s]),s=s.mid;else{for(o?(s.left=void 0,s.mid=void 0,s.right=void 0):s.value=void 0;t.length>0&&s.isEmpty();){let[u,r]=t.pop();switch(u){case 1:r.left=void 0;break;case 0:r.mid=void 0;break;case-1:r.right=void 0;break}s=r}break}}}findSubstr(n){const o=this._iter.reset(n);let h=this._root,t;for(;h;){const s=o.cmp(h.segment);if(s>0)h=h.left;else if(s<0)h=h.right;else if(o.hasNext())o.next(),t=h.value||t,h=h.mid;else break}return h&&h.value||t}findSuperstr(n){const o=this._iter.reset(n);let h=this._root;for(;h;){const t=o.cmp(h.segment);if(t>0)h=h.left;else if(t<0)h=h.right;else if(o.hasNext())o.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(n){for(const[o,h]of this)n(h,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=d;class a{constructor(n,o){this[Symbol.toStringTag]="ResourceMap",n instanceof a?(this.map=new Map(n.map),this.toKey=o!=null?o:a.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:a.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),o),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o!="undefined"&&(n=n.bind(o));for(let[h,t]of this.map)n(t,b.URI.parse(h),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield b.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[b.URI.parse(n[0]),n[1]]}*[Symbol.iterator](){for(let n of this.map)yield[b.URI.parse(n[0]),n[1]]}}e.ResourceMap=a,a.defaultToKey=c=>c.toString();var m;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(m=e.Touch||(e.Touch={}));class p{constructor(){this[Symbol.toStringTag]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,o=0){const h=this._map.get(n);if(!!h)return o!==0&&this.touch(h,o),h.value}set(n,o,h=0){let t=this._map.get(n);if(t)t.value=o,h!==0&&this.touch(t,h);else{switch(t={key:n,value:o,next:void 0,previous:void 0},h){case 0:this.addItemLast(t);break;case 1:this.addItemFirst(t);break;case 2:this.addItemLast(t);break;default:this.addItemLast(t);break}this._map.set(n,t),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,o){const h=this._state;let t=this._head;for(;t;){if(o?n.bind(o)(t.value,t.key,this):n(t.value,t.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const n=this,o=this._state;let h=this._head;const t={[Symbol.iterator](){return t},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const s={value:h.key,done:!1};return h=h.next,s}else return{value:void 0,done:!0}}};return t}values(){const n=this,o=this._state;let h=this._head;const t={[Symbol.iterator](){return t},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const s={value:h.value,done:!1};return h=h.next,s}else return{value:void 0,done:!0}}};return t}entries(){const n=this,o=this._state;let h=this._head;const t={[Symbol.iterator](){return t},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const s={value:[h.key,h.value],done:!1};return h=h.next,s}else return{value:void 0,done:!0}}};return t}[Symbol.iterator](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let o=this._head,h=this.size;for(;o&&h>n;)this._map.delete(o.key),o=o.next,h--;this._head=o,this._size=h,o&&(o.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,h=n.previous;if(!o||!h)throw new Error("Invalid list");o.previous=h,h.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const h=n.next,t=n.previous;n===this._tail?(t.next=void 0,this._tail=t):(h.previous=t,t.next=h),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const h=n.next,t=n.previous;n===this._head?(h.previous=void 0,this._head=h):(h.previous=t,t.next=h),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,h)=>{n.push([h,o])}),n}fromJSON(n){this.clear();for(const[o,h]of n)this.set(o,h)}}e.LinkedMap=p;class f extends p{constructor(n,o=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=f}),define(ve[106],_e([0,1,22,8]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function A(...be){return function(ke,Te){for(let Ne=0,pe=be.length;Ne<pe;Ne++){const ze=be[Ne](ke,Te);if(ze)return ze}return null}}e.or=A,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(be,ke,Te){if(!Te||Te.length<ke.length)return null;let Ne;return be?Ne=y.startsWithIgnoreCase(Te,ke):Ne=Te.indexOf(ke)===0,Ne?ke.length>0?[{start:0,end:ke.length}]:[]:null}function E(be,ke){const Te=ke.toLowerCase().indexOf(be.toLowerCase());return Te===-1?null:[{start:Te,end:Te+be.length}]}e.matchesContiguousSubString=E;function k(be,ke){return I(be.toLowerCase(),ke.toLowerCase(),0,0)}e.matchesSubString=k;function I(be,ke,Te,Ne){if(Te===be.length)return[];if(Ne===ke.length)return null;if(be[Te]===ke[Ne]){let pe=null;return(pe=I(be,ke,Te+1,Ne+1))?f({start:Ne,end:Ne+1},pe):null}return I(be,ke,Te,Ne+1)}function i(be){return 97<=be&&be<=122}function P(be){return 65<=be&&be<=90}e.isUpper=P;function S(be){return 48<=be&&be<=57}function v(be){return be===32||be===9||be===10||be===13}const d=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(be=>d.add(be.charCodeAt(0)));function a(be){return v(be)||d.has(be)}function m(be,ke){return be===ke||a(be)&&a(ke)}function p(be){return i(be)||P(be)||S(be)}function f(be,ke){return ke.length===0?ke=[be]:be.end===ke[0].start?ke[0].start=be.start:ke.unshift(be),ke}function c(be,ke){for(let Te=ke;Te<be.length;Te++){const Ne=be.charCodeAt(Te);if(P(Ne)||S(Ne)||Te>0&&!p(be.charCodeAt(Te-1)))return Te}return be.length}function n(be,ke,Te,Ne){if(Te===be.length)return[];if(Ne===ke.length)return null;if(be[Te]!==ke[Ne].toLowerCase())return null;{let pe=null,ze=Ne+1;for(pe=n(be,ke,Te+1,Ne+1);!pe&&(ze=c(ke,ze))<ke.length;)pe=n(be,ke,Te+1,ze),ze++;return pe===null?null:f({start:Ne,end:Ne+1},pe)}}function o(be){let ke=0,Te=0,Ne=0,pe=0,ze=0;for(let Oe=0;Oe<be.length;Oe++)ze=be.charCodeAt(Oe),P(ze)&&ke++,i(ze)&&Te++,p(ze)&&Ne++,S(ze)&&pe++;const B=ke/be.length,Z=Te/be.length,he=Ne/be.length,Le=pe/be.length;return{upperPercent:B,lowerPercent:Z,alphaPercent:he,numericPercent:Le}}function h(be){const{upperPercent:ke,lowerPercent:Te}=be;return Te===0&&ke>.6}function t(be){const{upperPercent:ke,lowerPercent:Te,alphaPercent:Ne,numericPercent:pe}=be;return Te>.2&&ke<.8&&Ne>.6&&pe<.2}function s(be){let ke=0,Te=0,Ne=0,pe=0;for(let ze=0;ze<be.length;ze++)Ne=be.charCodeAt(ze),P(Ne)&&ke++,i(Ne)&&Te++,v(Ne)&&pe++;return(ke===0||Te===0)&&pe===0?be.length<=30:ke<=5}function l(be,ke){if(!ke||(ke=ke.trim(),ke.length===0)||!s(be)||ke.length>60)return null;const Te=o(ke);if(!t(Te)){if(!h(Te))return null;ke=ke.toLowerCase()}let Ne=null,pe=0;for(be=be.toLowerCase();pe<ke.length&&(Ne=n(be,ke,0,pe))===null;)pe=c(ke,pe+1);return Ne}e.matchesCamelCase=l;function u(be,ke,Te=!1){if(!ke||ke.length===0)return null;let Ne=null,pe=0;for(be=be.toLowerCase(),ke=ke.toLowerCase();pe<ke.length&&(Ne=r(be,ke,0,pe,Te))===null;)pe=g(ke,pe+1);return Ne}e.matchesWords=u;function r(be,ke,Te,Ne,pe){if(Te===be.length)return[];if(Ne===ke.length)return null;if(m(be.charCodeAt(Te),ke.charCodeAt(Ne))){let ze=null,B=Ne+1;if(ze=r(be,ke,Te+1,Ne+1,pe),!pe)for(;!ze&&(B=g(ke,B))<ke.length;)ze=r(be,ke,Te+1,B,pe),B++;return ze===null?null:f({start:Ne,end:Ne+1},ze)}else return null}function g(be,ke){for(let Te=ke;Te<be.length;Te++)if(a(be.charCodeAt(Te))||Te>0&&a(be.charCodeAt(Te-1)))return Te;return be.length}const C=A(e.matchesPrefix,l,E),_=A(e.matchesPrefix,l,k),D=new b.LRUCache(1e4);function w(be,ke,Te=!1){if(typeof be!="string"||typeof ke!="string")return null;let Ne=D.get(be);Ne||(Ne=new RegExp(y.convertSimple2RegExpPattern(be),"i"),D.set(be,Ne));const pe=Ne.exec(ke);return pe?[{start:pe.index,end:pe.index+pe[0].length}]:Te?_(be,ke):C(be,ke)}e.matchesFuzzy=w;function O(be,ke){const Te=K(be,be.toLowerCase(),0,ke,ke.toLowerCase(),0,!0);return Te?$(Te):null}e.matchesFuzzy2=O;function R(be,ke,Te,Ne,pe,ze){const B=K(be,ke,0,Ne,pe,0,!0);if(B)return B;let Z=[],he=0,Le=ze;for(let Oe=0;Oe<ke.length&&Oe<V;++Oe){const We=pe.indexOf(ke.charAt(Oe),Le);if(We>=0)he+=1,Z.unshift(We),Le=We+1;else if(Z.length>0)break}return[he,ze,...Z]}e.anyScore=R;function $(be){if(typeof be=="undefined")return[];const ke=[],Te=be[1];for(let Ne=be.length-1;Ne>1;Ne--){const pe=be[Ne]+Te,ze=ke[ke.length-1];ze&&ze.end===pe?ze.end=pe+1:ke.push({start:pe,end:pe+1})}return ke}e.createMatches=$;const V=128;function z(){const be=[],ke=[];for(let Te=0;Te<=V;Te++)ke[Te]=0;for(let Te=0;Te<=V;Te++)be.push(ke.slice(0));return be}function U(be){const ke=[];for(let Te=0;Te<=be;Te++)ke[Te]=0;return ke}const q=U(2*V),M=U(2*V),j=z(),re=z(),F=z(),te=!1;function ae(be,ke,Te,Ne,pe){function ze(Z,he,Le=" "){for(;Z.length<he;)Z=Le+Z;return Z}let B=` |   |${Ne.split("").map(Z=>ze(Z,3)).join("|")}
`;for(let Z=0;Z<=Te;Z++)Z===0?B+=" |":B+=`${ke[Z-1]}|`,B+=be[Z].slice(0,pe+1).map(he=>ze(he.toString(),3)).join("|")+`
`;return B}function ue(be,ke,Te,Ne){be=be.substr(ke),Te=Te.substr(Ne),console.log(ae(re,be,be.length,Te,Te.length)),console.log(ae(F,be,be.length,Te,Te.length)),console.log(ae(j,be,be.length,Te,Te.length))}function we(be,ke){if(ke<0||ke>=be.length)return!1;const Te=be.codePointAt(ke);switch(Te){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!y.isEmojiImprecise(Te)}}function fe(be,ke){if(ke<0||ke>=be.length)return!1;switch(be.charCodeAt(ke)){case 32:case 9:return!0;default:return!1}}function De(be,ke,Te){return ke[be]!==Te[be]}function Se(be,ke,Te,Ne,pe,ze,B=!1){for(;ke<Te&&pe<ze;)be[ke]===Ne[pe]&&(B&&(q[ke]=pe),ke+=1),pe+=1;return ke===Te}e.isPatternInWord=Se;var Ce;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var x;(function(be){be.Default=[-100,0];function ke(Te){return!Te||Te[0]===-100&&Te[1]===0&&Te[2]===0}be.isDefault=ke})(x=e.FuzzyScore||(e.FuzzyScore={}));function K(be,ke,Te,Ne,pe,ze,B){const Z=be.length>V?V:be.length,he=Ne.length>V?V:Ne.length;if(!(Te>=Z||ze>=he||Z-Te>he-ze)&&!!Se(ke,Te,Z,pe,ze,he,!0)){ee(Z,he,Te,ze,ke,pe);let Le=1,Oe=1,We=Te,Ke=ze;const ie=[!1];for(Le=1,We=Te;We<Z;Le++,We++){const H=q[We],L=M[We],J=We+1<Z?M[We+1]:he;for(Oe=H-ze+1,Ke=H;Ke<J;Oe++,Ke++){let X=Number.MIN_SAFE_INTEGER,ce=!1;Ke<=L&&(X=ne(be,ke,We,Te,Ne,pe,Ke,he,ze,j[Le-1][Oe-1]===0,ie));let me=0;X!==Number.MAX_SAFE_INTEGER&&(ce=!0,me=X+re[Le-1][Oe-1]);const Pe=Ke>H,Fe=Pe?re[Le][Oe-1]+(j[Le][Oe-1]>0?-5:0):0,je=Ke>H+1&&j[Le][Oe-1]>0,qe=je?re[Le][Oe-2]+(j[Le][Oe-2]>0?-5:0):0;if(je&&(!Pe||qe>=Fe)&&(!ce||qe>=me))re[Le][Oe]=qe,F[Le][Oe]=3,j[Le][Oe]=0;else if(Pe&&(!ce||Fe>=me))re[Le][Oe]=Fe,F[Le][Oe]=2,j[Le][Oe]=0;else if(ce)re[Le][Oe]=me,F[Le][Oe]=1,j[Le][Oe]=j[Le-1][Oe-1]+1;else throw new Error("not possible")}}if(te&&ue(be,Te,Ne,ze),!(!ie[0]&&!B)){Le--,Oe--;const ge=[re[Le][Oe],ze];let Me=0,G=0;for(;Le>=1;){let H=Oe;do{const L=F[Le][H];if(L===3)H=H-2;else if(L===2)H=H-1;else break}while(H>=1);Me>1&&ke[Te+Le-1]===pe[ze+Oe-1]&&!De(H+ze-1,Ne,pe)&&Me+1>j[Le][H]&&(H=Oe),H===Oe?Me++:Me=1,G||(G=H),Le--,Oe=H-1,ge.push(Oe)}he===Z&&(ge[0]+=2);const Q=G-Z;return ge[0]-=Q,ge}}}e.fuzzyScore=K;function ee(be,ke,Te,Ne,pe,ze){let B=be-1,Z=ke-1;for(;B>=Te&&Z>=Ne;)pe[B]===ze[Z]&&(M[B]=Z,B--),Z--}function ne(be,ke,Te,Ne,pe,ze,B,Z,he,Le,Oe){if(ke[Te]!==ze[B])return Number.MIN_SAFE_INTEGER;let We=1,Ke=!1;return B===Te-Ne?We=be[Te]===pe[B]?7:5:De(B,pe,ze)&&(B===0||!De(B-1,pe,ze))?(We=be[Te]===pe[B]?7:5,Ke=!0):we(ze,B)&&(B===0||!we(ze,B-1))?We=5:(we(ze,B-1)||fe(ze,B-1))&&(We=5,Ke=!0),We>1&&Te===Ne&&(Oe[0]=!0),Ke||(Ke=De(B,pe,ze)||we(ze,B-1)||fe(ze,B-1)),Te===Ne?B>he&&(We-=Ke?3:5):Le?We+=Ke?2:0:We+=Ke?0:1,B+1===Z&&(We-=Ke?3:5),We}function de(be,ke,Te,Ne,pe,ze,B){return Re(be,ke,Te,Ne,pe,ze,!0,B)}e.fuzzyScoreGracefulAggressive=de;function Ee(be,ke,Te,Ne,pe,ze,B){return Re(be,ke,Te,Ne,pe,ze,!1,B)}e.fuzzyScoreGraceful=Ee;function Re(be,ke,Te,Ne,pe,ze,B,Z){let he=K(be,ke,Te,Ne,pe,ze,Z);if(he&&!B)return he;if(be.length>=3){const Le=Math.min(7,be.length-1);for(let Oe=Te+1;Oe<Le;Oe++){const We=xe(be,Oe);if(We){const Ke=K(We,We.toLowerCase(),Te,Ne,pe,ze,Z);Ke&&(Ke[0]-=3,(!he||Ke[0]>he[0])&&(he=Ke))}}}return he}function xe(be,ke){if(!(ke+1>=be.length)){const Te=be[ke],Ne=be[ke+1];if(Te!==Ne)return be.slice(0,ke)+Ne+Te+be.slice(ke+2)}}}),define(ve[29],_e([0,1,8,38,10,22,15]),function(se,e,b,y,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const I="**",i="/",P="[/\\\\]",S="[^/\\\\]",v=/\//g;function d(te){switch(te){case 0:return"";case 1:return`${S}*?`;default:return`(?:${P}|${S}+${P}|${P}${S}+)*?`}}function a(te,ae){if(!te)return[];const ue=[];let we=!1,fe=!1,De="";for(const Se of te){switch(Se){case ae:if(!we&&!fe){ue.push(De),De="";continue}break;case"{":we=!0;break;case"}":we=!1;break;case"[":fe=!0;break;case"]":fe=!1;break}De+=Se}return De&&ue.push(De),ue}e.splitGlobAware=a;function m(te){if(!te)return"";let ae="";const ue=a(te,i);if(ue.every(we=>we===I))ae=".*";else{let we=!1;ue.forEach((fe,De)=>{if(fe===I){we||(ae+=d(2),we=!0);return}let Se=!1,Ce="",x=!1,K="";for(const ee of fe){if(ee!=="}"&&Se){Ce+=ee;continue}if(x&&(ee!=="]"||!K)){let ne;ee==="-"?ne=ee:(ee==="^"||ee==="!")&&!K?ne="^":ee===i?ne="":ne=b.escapeRegExpCharacters(ee),K+=ne;continue}switch(ee){case"{":Se=!0;continue;case"[":x=!0;continue;case"}":ae+=`(?:${a(Ce,",").map(Ee=>m(Ee)).join("|")})`,Se=!1,Ce="";break;case"]":ae+="["+K+"]",x=!1,K="";break;case"?":ae+=S;continue;case"*":ae+=d(1);continue;default:ae+=b.escapeRegExpCharacters(ee)}}De<ue.length-1&&(ue[De+1]!==I||De+2<ue.length)&&(ae+=P),we=!1})}return ae}const p=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,n=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),s=function(){return!1},l=function(){return null};function u(te,ae){if(!te)return l;let ue;typeof te!="string"?ue=te.pattern:ue=te,ue=ue.trim();const we=`${ue}_${!!ae.trimForExclusions}`;let fe=t.get(we);if(fe)return r(fe,te);let De;if(p.test(ue)){const Se=ue.substr(4);fe=function(Ce,x){return typeof Ce=="string"&&Ce.endsWith(Se)?ue:null}}else(De=f.exec(g(ue,ae)))?fe=C(De[1],ue):(ae.trimForExclusions?n:c).test(ue)?fe=_(ue,ae):(De=o.exec(g(ue,ae)))?fe=D(De[1].substr(1),ue,!0):(De=h.exec(g(ue,ae)))?fe=D(De[1],ue,!1):fe=w(ue);return t.set(we,fe),r(fe,te)}function r(te,ae){return typeof ae=="string"?te:function(ue,we){return y.isEqualOrParent(ue,ae.base)?te(A.relative(ae.base,ue),we):null}}function g(te,ae){return ae.trimForExclusions&&te.endsWith("/**")?te.substr(0,te.length-2):te}function C(te,ae){const ue=`/${te}`,we=`\\${te}`,fe=function(Se,Ce){return typeof Se!="string"?null:Ce?Ce===te?ae:null:Se===te||Se.endsWith(ue)||Se.endsWith(we)?ae:null},De=[te];return fe.basenames=De,fe.patterns=[ae],fe.allBasenames=De,fe}function _(te,ae){const ue=F(te.slice(1,-1).split(",").map(Ce=>u(Ce,ae)).filter(Ce=>Ce!==l),te),we=ue.length;if(!we)return l;if(we===1)return ue[0];const fe=function(Ce,x){for(let K=0,ee=ue.length;K<ee;K++)if(ue[K](Ce,x))return te;return null},De=ue.find(Ce=>!!Ce.allBasenames);De&&(fe.allBasenames=De.allBasenames);const Se=ue.reduce((Ce,x)=>x.allPaths?Ce.concat(x.allPaths):Ce,[]);return Se.length&&(fe.allPaths=Se),fe}function D(te,ae,ue){const we=A.sep===A.posix.sep,fe=we?te:te.replace(v,A.sep),De=A.sep+fe,Se=A.posix.sep+te,Ce=ue?function(x,K){return typeof x=="string"&&(x===fe||x.endsWith(De)||!we&&(x===te||x.endsWith(Se)))?ae:null}:function(x,K){return typeof x=="string"&&(x===fe||!we&&x===te)?ae:null};return Ce.allPaths=[(ue?"*/":"./")+te],Ce}function w(te){try{const ae=new RegExp(`^${m(te)}$`);return function(ue){return ae.lastIndex=0,typeof ue=="string"&&ae.test(ue)?te:null}}catch(ae){return l}}function O(te,ae,ue){return!te||typeof ae!="string"?!1:R(te)(ae,void 0,ue)}e.match=O;function R(te,ae={}){if(!te)return s;if(typeof te=="string"||U(te)){const ue=u(te,ae);if(ue===l)return s;const we=function(fe,De){return!!ue(fe,De)};return ue.allBasenames&&(we.allBasenames=ue.allBasenames),ue.allPaths&&(we.allPaths=ue.allPaths),we}return j(te,ae)}e.parse=R;function $(te){if(!!te){let ae;return ue=>(ae||(ae=(te()||Promise.resolve([])).then(we=>we?z(we):{})),ae.then(we=>!!we[ue]))}}e.hasSiblingPromiseFn=$;function V(te){if(!!te){let ae;return ue=>{if(!ae){const we=te();ae=we?z(we):{}}return!!ae[ue]}}}e.hasSiblingFn=V;function z(te){const ae={};for(const ue of te)ae[ue]=!0;return ae}function U(te){const ae=te;return ae&&typeof ae.base=="string"&&typeof ae.pattern=="string"}e.isRelativePattern=U;function q(te){return te.allBasenames||[]}e.getBasenameTerms=q;function M(te){return te.allPaths||[]}e.getPathTerms=M;function j(te,ae){const ue=F(Object.getOwnPropertyNames(te).map(Ce=>re(Ce,te[Ce],ae)).filter(Ce=>Ce!==l)),we=ue.length;if(!we)return l;if(!ue.some(Ce=>!!Ce.requiresSiblings)){if(we===1)return ue[0];const Ce=function(ee,ne){for(let de=0,Ee=ue.length;de<Ee;de++){const Re=ue[de](ee,ne);if(Re)return Re}return null},x=ue.find(ee=>!!ee.allBasenames);x&&(Ce.allBasenames=x.allBasenames);const K=ue.reduce((ee,ne)=>ne.allPaths?ee.concat(ne.allPaths):ee,[]);return K.length&&(Ce.allPaths=K),Ce}const fe=function(Ce,x,K){let ee;for(let ne=0,de=ue.length;ne<de;ne++){const Ee=ue[ne];Ee.requiresSiblings&&K&&(x||(x=A.basename(Ce)),ee||(ee=x.substr(0,x.length-A.extname(Ce).length)));const Re=Ee(Ce,x,ee,K);if(Re)return Re}return null},De=ue.find(Ce=>!!Ce.allBasenames);De&&(fe.allBasenames=De.allBasenames);const Se=ue.reduce((Ce,x)=>x.allPaths?Ce.concat(x.allPaths):Ce,[]);return Se.length&&(fe.allPaths=Se),fe}function re(te,ae,ue){if(ae===!1)return l;const we=u(te,ue);if(we===l)return l;if(typeof ae=="boolean")return we;if(ae){const fe=ae.when;if(typeof fe=="string"){const De=(Se,Ce,x,K)=>{if(!K||!we(Se,Ce))return null;const ee=fe.replace("$(basename)",x),ne=K(ee);return E.isThenable(ne)?ne.then(de=>de?te:null):ne?te:null};return De.requiresSiblings=!0,De}}return we}function F(te,ae){const ue=te.filter(Ce=>!!Ce.basenames);if(ue.length<2)return te;const we=ue.reduce((Ce,x)=>{const K=x.basenames;return K?Ce.concat(K):Ce},[]);let fe;if(ae){fe=[];for(let Ce=0,x=we.length;Ce<x;Ce++)fe.push(ae)}else fe=ue.reduce((Ce,x)=>{const K=x.patterns;return K?Ce.concat(K):Ce},[]);const De=function(Ce,x){if(typeof Ce!="string")return null;if(!x){let ee;for(ee=Ce.length;ee>0;ee--){const ne=Ce.charCodeAt(ee-1);if(ne===47||ne===92)break}x=Ce.substr(ee)}const K=we.indexOf(x);return K!==-1?fe[K]:null};De.basenames=we,De.patterns=fe,De.allBasenames=we;const Se=te.filter(Ce=>!Ce.basenames);return Se.push(De),Se}}),define(ve[107],_e([0,1,106,8]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownUnescapeIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=/(\\)?\$\([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?\)/gi;function T(m){return m.replace(A,(p,f)=>f?p:`\\${p}`)}e.escapeIcons=T;const E=/\\\$\([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?\)/gi;function k(m){return m.replace(E,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=k;const I=/(\\)?\$\\\(([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?)\\\)/gi;function i(m){return m.replace(I,(p,f,c)=>f?p:`$(${c})`)}e.markdownUnescapeIcons=i;const P=/(\s)?(\\)?\$\([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?\)(\s)?/gi;function S(m){return m.indexOf(e.iconStartMarker)===-1?m:m.replace(P,(p,f,c,n)=>c?p:f||n||"")}e.stripIcons=S;function v(m){const p=m.indexOf(e.iconStartMarker);return p===-1?{text:m}:d(m,p)}e.parseLabelWithIcons=v;function d(m,p){const f=[];let c="";function n(g){if(g){c+=g;for(const C of g)f.push(t)}}let o=-1,h="",t=0,s,l,u=p;const r=m.length;for(n(m.substr(0,p));u<r;)s=m[u],l=m[u+1],s===e.iconStartMarker[0]&&l===e.iconStartMarker[1]?(o=u,n(h),h=e.iconStartMarker,u++):s===")"&&o!==-1?(t+=u-o+1,o=-1,h=""):o!==-1?/^[a-z0-9\-]$/i.test(s)?h+=s:(n(h),o=-1,h=""):n(s),u++;return n(h),{text:c,iconOffsets:f}}function a(m,p,f=!1){const{text:c,iconOffsets:n}=p;if(!n||n.length===0)return b.matchesFuzzy(m,c,f);const o=y.ltrim(c," "),h=c.length-o.length,t=b.matchesFuzzy(m,o,f);if(t)for(const s of t){const l=n[s.start+h]+h;s.start+=l,s.end+=l}return t}e.matchesFuzzyIconAware=a}),define(ve[81],_e([0,1,11,107,9]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(m="",p=!1){var f,c;if(this.value=m,typeof this.value!="string")throw A.illegalArgument("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1):(this.isTrusted=(f=p.isTrusted)!==null&&f!==void 0?f:void 0,this.supportThemeIcons=(c=p.supportThemeIcons)!==null&&c!==void 0?c:!1)}appendText(m,p=0){return this.value+=S(this.supportThemeIcons?y.escapeIcons(m):m).replace(/([ \t]+)/g,(f,c)=>"&nbsp;".repeat(c.length)).replace(/^>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,p){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=E;function k(a){return I(a)?!a.value:Array.isArray(a)?a.every(k):!0}e.isEmptyMarkdownString=k;function I(a){return a instanceof E?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function i(a,m){return!a&&!m?!0:!a||!m?!1:Array.isArray(a)&&Array.isArray(m)?b.equals(a,m,P):I(a)&&I(m)?P(a,m):!1}e.markedStringsEquals=i;function P(a,m){return a===m?!0:!a||!m?!1:a.value===m.value&&a.isTrusted===m.isTrusted&&a.supportThemeIcons===m.supportThemeIcons}function S(a){return a.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=S;function v(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=v;function d(a){const m=[],p=a.split("|").map(c=>c.trim());a=p[0];const f=p[1];if(f){const c=/height=(\d+)/.exec(f),n=/width=(\d+)/.exec(f),o=c?c[1]:"",h=n?n[1]:"",t=isFinite(parseInt(h)),s=isFinite(parseInt(o));t&&m.push(`width="${h}"`),s&&m.push(`height="${o}"`)}return{href:a,dimensions:m}}e.parseHrefAndDimensions=d}),define(ve[58],_e([0,1,27,8,2]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(i){return JSON.stringify(i,k)}e.stringify=T;function E(i){let P=JSON.parse(i);return P=I(P),P}e.parse=E;function k(i,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:y.regExpFlags(P)}:P}function I(i,P=0){if(!i||P>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return A.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof b.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let S=0;S<i.length;++S)i[S]=I(i[S],P+1);else for(const S in i)Object.hasOwnProperty.call(i,S)&&(i[S]=I(i[S],P+1))}return i}e.revive=I}),define(ve[16],_e([0,1,2,21]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeSettings="vscode-settings",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.vscodeWebviewResource="vscode-webview-resource",k.extension="extension",k.vscodeFileResource="vscode-file"})(A=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(I){this._preferredWebSchema=I}setDelegate(I){this._delegate=I}set(I,i,P){this._hosts[I]=i,this._ports[I]=P}setConnectionToken(I,i){this._connectionTokens[I]=i}rewrite(I){if(this._delegate)return this._delegate(I);const i=I.authority;let P=this._hosts[i];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const S=this._ports[i],v=this._connectionTokens[i];let d=`path=${encodeURIComponent(I.path)}`;return typeof v=="string"&&(d+=`&tkn=${encodeURIComponent(v)}`),b.URI.from({scheme:y.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${P}:${S}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new T;class E{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(I,i,P){const S=this.toUri(I,i);return S.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(S):y.isNative&&(P||y.isPreferringBrowserCodeLoad)&&S.scheme===A.file?S.with({scheme:A.vscodeFileResource,authority:S.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):S}asFileUri(I,i){const P=this.toUri(I,i);return P.scheme===A.vscodeFileResource?P.with({scheme:A.file,authority:P.authority!==this.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(I,i){return b.URI.isUri(I)?I:b.URI.parse(i.toUrl(I))}}e.FileAccess=new E}),define(ve[23],_e([0,1,38,10,2,8,16,21]),function(se,e,b,y,A,T,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(d){return A.uriToFsPath(d,!0)}e.originalFSPath=I;class i{constructor(a){this._ignorePathCasing=a}compare(a,m,p=!1){return a===m?0:T.compare(this.getComparisonKey(a,p),this.getComparisonKey(m,p))}isEqual(a,m,p=!1){return a===m?!0:!a||!m?!1:this.getComparisonKey(a,p)===this.getComparisonKey(m,p)}getComparisonKey(a,m=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,m,p=!1){if(a.scheme===m.scheme){if(a.scheme===E.Schemas.file)return b.isEqualOrParent(I(a),I(m),this._ignorePathCasing(a))&&a.query===m.query&&(p||a.fragment===m.fragment);if(e.isEqualAuthority(a.authority,m.authority))return b.isEqualOrParent(a.path,m.path,this._ignorePathCasing(a),"/")&&a.query===m.query&&(p||a.fragment===m.fragment)}return!1}joinPath(a,...m){return A.URI.joinPath(a,...m)}basenameOrAuthority(a){return e.basename(a)||a.authority}basename(a){return y.posix.basename(a.path)}extname(a){return y.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let m;return a.scheme===E.Schemas.file?m=A.URI.file(y.dirname(I(a))).path:(m=y.posix.dirname(a.path),a.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),m="/")),a.with({path:m})}normalizePath(a){if(!a.path.length)return a;let m;return a.scheme===E.Schemas.file?m=A.URI.file(y.normalize(I(a))).path:m=y.posix.normalize(a.path),a.with({path:m})}relativePath(a,m){if(!(a.scheme!==m.scheme||!e.isEqualAuthority(a.authority,m.authority))){if(a.scheme===E.Schemas.file){const c=y.relative(I(a),I(m));return k.isWindows?b.toSlashes(c):c}let p=a.path||"/",f=m.path||"/";if(this._ignorePathCasing(a)){let c=0;for(const n=Math.min(p.length,f.length);c<n&&!(p.charCodeAt(c)!==f.charCodeAt(c)&&p.charAt(c).toLowerCase()!==f.charAt(c).toLowerCase());c++);p=f.substr(0,c)+p.substr(c)}return y.posix.relative(p,f)}}resolvePath(a,m){if(a.scheme===E.Schemas.file){const p=A.URI.file(y.resolve(I(a),m));return a.with({authority:p.authority,path:p.path})}return m.indexOf("/")===-1&&(m=b.toSlashes(m),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m)),a.with({path:y.posix.resolve(a.path,m)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,m){return a===m||T.equalsIgnoreCase(a,m)}hasTrailingPathSeparator(a,m=y.sep){if(a.scheme===E.Schemas.file){const p=I(a);return p.length>b.getRoot(p).length&&p[p.length-1]===m}else{const p=a.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,m=y.sep){return e.hasTrailingPathSeparator(a,m)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,m=y.sep){let p=!1;if(a.scheme===E.Schemas.file){const f=I(a);p=f!==void 0&&f.length===b.getRoot(f).length&&f[f.length-1]===m}else{m="/";const f=a.path;p=f.length===1&&f.charCodeAt(f.length-1)===47}return!p&&!e.hasTrailingPathSeparator(a,m)?a.with({path:a.path+"/"}):a}}e.ExtUri=i,e.extUri=new i(()=>!1),e.extUriBiasedIgnorePathCase=new i(d=>d.scheme===E.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new i(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(d,a){const m=[];for(let p=0;p<d.length;p++){const f=a(d[p]);d.some((c,n)=>n===p?!1:e.isEqualOrParent(f,a(c)))||m.push(d[p])}return m}e.distinctParents=P;var S;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function a(m){const p=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(n=>{const[o,h]=n.split(":");o&&h&&p.set(o,h)});const c=m.path.substring(0,m.path.indexOf(";"));return c&&p.set(d.META_DATA_MIME,c),p}d.parseMetaData=a})(S=e.DataUri||(e.DataUri={}));function v(d,a,m){if(a){let p=d.path;return p&&p[0]!==y.posix.sep&&(p=y.posix.sep+p),d.with({scheme:m,authority:a,path:p})}return d.with({scheme:m})}e.toLocalResource=v}),define(ve[59],_e([0,1,2,10,8,16,21,23,38]),function(se,e,b,y,A,T,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function i(u,r,g){if(typeof u=="string"&&(u=b.URI.file(u)),g){const _=g.getWorkspaceFolder(u);if(_){const D=g.getWorkspace().folders.length>1;let w;if(k.isEqual(_.uri,u)?w="":w=k.relativePath(_.uri,u),D){const O=_.name?_.name:k.basename(_.uri);w=w?O+" \u2022 "+w:O}return w}}if(u.scheme!==T.Schemas.file&&u.scheme!==T.Schemas.untitled)return u.with({query:null,fragment:null}).toString(!0);if(I.hasDriveLetter(u.fsPath))return y.normalize(S(u.fsPath));let C=y.normalize(u.fsPath);return!E.isWindows&&(r==null?void 0:r.userHome)&&(C=d(C,r.userHome.fsPath)),C}e.getPathLabel=i;function P(u){if(!!u){typeof u=="string"&&(u=b.URI.file(u));const r=k.basename(u)||(u.scheme===T.Schemas.file?u.fsPath:u.path);return E.isWindows&&I.isRootOrDriveLetter(r)?S(r):r}}e.getBaseLabel=P;function S(u){return I.hasDriveLetter(u)?u.charAt(0).toUpperCase()+u.slice(1):u}e.normalizeDriveLetter=S;let v=Object.create(null);function d(u,r){if(E.isWindows||!u||!r)return u;let g=v.original===r?v.normalized:void 0;return g||(g=`${A.rtrim(r,y.posix.sep)}${y.posix.sep}`,v={original:r,normalized:g}),(E.isLinux?u.startsWith(g):A.startsWithIgnoreCase(u,g))&&(u=`~/${u.substr(g.length)}`),u}e.tildify=d;function a(u,r){return u.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=a;const m="\u2026",p="\\\\",f="~";function c(u,r=y.sep){const g=new Array(u.length);let C=!1;for(let _=0;_<u.length;_++){let D=u[_];if(D===""){g[_]=`.${r}`;continue}if(!D){g[_]=D;continue}C=!0;let w="";D.indexOf(p)===0?(w=D.substr(0,D.indexOf(p)+p.length),D=D.substr(D.indexOf(p)+p.length)):D.indexOf(r)===0?(w=D.substr(0,D.indexOf(r)+r.length),D=D.substr(D.indexOf(r)+r.length)):D.indexOf(f)===0&&(w=D.substr(0,D.indexOf(f)+f.length),D=D.substr(D.indexOf(f)+f.length));const O=D.split(r);for(let R=1;C&&R<=O.length;R++)for(let $=O.length-R;C&&$>=0;$--){C=!1;let V=O.slice($,$+R).join(r);for(let z=0;!C&&z<u.length;z++)if(z!==_&&u[z]&&u[z].indexOf(V)>-1){const U=$+R===O.length,q=$>0&&u[z].indexOf(r)>-1?r+V:V,M=u[z].endsWith(q);C=!U||M}if(!C){let z="";(O[0].endsWith(":")||w!=="")&&($===1&&($=0,R++,V=O[0]+r+V),$>0&&(z=O[0]+r),z=w+z),$>0&&(z=z+m+r),z=z+V,$+R<O.length&&(z=z+r+m),g[_]=z}}C&&(g[_]=D)}return g}e.shorten=c;var n;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function o(u,r=Object.create(null)){const g=[];let C=!1,_="";for(const D of u)if(D==="$"||C&&D==="{")_&&g.push({value:_,type:n.TEXT}),_="",C=!0;else if(D==="}"&&C){const w=r[_];if(typeof w=="string")w.length&&g.push({value:w,type:n.VARIABLE});else if(w){const O=g[g.length-1];(!O||O.type!==n.SEPARATOR)&&g.push({value:w.label,type:n.SEPARATOR})}_="",C=!1}else _+=D;return _&&!C&&g.push({value:_,type:n.TEXT}),g.filter((D,w)=>{if(D.type===n.SEPARATOR){const O=g[w-1],R=g[w+1];return[O,R].every($=>$&&($.type===n.VARIABLE||$.type===n.TEXT)&&$.value.length>0)}return!0}).map(D=>D.value).join("")}e.template=o;function h(u,r){return E.isMacintosh||r?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,E.isMacintosh?"&":"&&"):u.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function t(u,r){return E.isMacintosh||r?u.replace(/\(&&\w\)|&&/g,""):E.isWindows?u.replace(/&&|&/g,g=>g==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function s(u){return u.replace(/&/g,"&&")}e.unmnemonicLabel=s;function l(u){const r=u.indexOf("/")!==-1?y.posix:y.win32,g=r.basename(u),C=r.dirname(u);return g.length?{name:g,parentPath:C}:{name:C,parentPath:""}}e.splitName=l}),define(ve[108],_e([0,1,2]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function y(P){return P.toJSON()}class A{constructor(S){this._uriTransformer=S}transformIncoming(S){const v=this._uriTransformer.transformIncoming(S);return v===S?S:y(b.URI.from(v))}transformOutgoing(S){const v=this._uriTransformer.transformOutgoing(S);return v===S?S:y(b.URI.from(v))}transformOutgoingURI(S){const v=this._uriTransformer.transformOutgoing(S);return v===S?S:b.URI.from(v)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function T(P,S,v){if(!P||v>200)return null;if(typeof P=="object"){if(P instanceof b.URI)return S.transformOutgoing(P);for(let d in P)if(Object.hasOwnProperty.call(P,d)){const a=T(P[d],S,v+1);a!==null&&(P[d]=a)}}return null}function E(P,S){const v=T(P,S,0);return v===null?P:v}e.transformOutgoingURIs=E;function k(P,S,v,d){if(!P||d>200)return null;if(typeof P=="object"){if(P.$mid===1)return v?b.URI.revive(S.transformIncoming(P)):S.transformIncoming(P);for(let a in P)if(Object.hasOwnProperty.call(P,a)){const m=k(P[a],S,v,d+1);m!==null&&(P[a]=m)}}return null}function I(P,S){const v=k(P,S,!1,0);return v===null?P:v}e.transformIncomingURIs=I;function i(P,S){const v=k(P,S,!0,0);return v===null?P:v}e.transformAndReviveIncomingURIs=i}),define(ve[26],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function y(I){return b.test(I)}e.isUUID=y;const A=new Uint8Array(16),T=[];for(let I=0;I<256;I++)T.push(I.toString(16).padStart(2,"0"));const E=function(I){for(let i=0;i<I.length;i++)I[i]=Math.floor(Math.random()*256);return I};function k(){E(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let I=0,i="";return i+=T[A[I++]],i+=T[A[I++]],i+=T[A[I++]],i+=T[A[I++]],i+="-",i+=T[A[I++]],i+=T[A[I++]],i+="-",i+=T[A[I++]],i+=T[A[I++]],i+="-",i+=T[A[I++]],i+=T[A[I++]],i+="-",i+=T[A[I++]],i+=T[A[I++]],i+=T[A[I++]],i+=T[A[I++]],i+=T[A[I++]],i+=T[A[I++]],i}e.generateUuid=k}),define(ve[82],_e([0,1,80]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class y{constructor(k){let I=b.toUint8(k);this._defaultValue=I,this._asciiMap=y._createAsciiMap(I),this._map=new Map}static _createAsciiMap(k){let I=new Uint8Array(256);for(let i=0;i<256;i++)I[i]=k;return I}set(k,I){let i=b.toUint8(I);k>=0&&k<256?this._asciiMap[k]=i:this._map.set(k,i)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=y;var A;(function(E){E[E.False=0]="False",E[E.True=1]="True"})(A||(A={}));class T{constructor(){this._actual=new y(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=T}),define(ve[109],_e([0,1,82]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var y;(function(E){E[E.Regular=0]="Regular",E[E.Whitespace=1]="Whitespace",E[E.WordSeparator=2]="WordSeparator"})(y=e.WordCharacterClass||(e.WordCharacterClass={}));class A extends b.CharacterClassifier{constructor(k){super(0);for(let I=0,i=k.length;I<i;I++)this.set(k.charCodeAt(I),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=A;function T(E){let k={};return I=>(k.hasOwnProperty(I)||(k[I]=E(I)),k[I])}e.getMapForWordSeparators=T(E=>new A(E))}),define(ve[39],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class b{constructor(A,T){this.lineNumber=A,this.column=T}with(A=this.lineNumber,T=this.column){return A===this.lineNumber&&T===this.column?this:new b(A,T)}delta(A=0,T=0){return this.with(this.lineNumber+A,this.column+T)}equals(A){return b.equals(this,A)}static equals(A,T){return!A&&!T?!0:!!A&&!!T&&A.lineNumber===T.lineNumber&&A.column===T.column}isBefore(A){return b.isBefore(this,A)}static isBefore(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<T.column}isBeforeOrEqual(A){return b.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<=T.column}static compare(A,T){let E=A.lineNumber|0,k=T.lineNumber|0;if(E===k){let I=A.column|0,i=T.column|0;return I-i}return E-k}clone(){return new b(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new b(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}}e.Position=b}),define(ve[32],_e([0,1,39]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class y{constructor(T,E,k,I){T>k||T===k&&E>I?(this.startLineNumber=k,this.startColumn=I,this.endLineNumber=T,this.endColumn=E):(this.startLineNumber=T,this.startColumn=E,this.endLineNumber=k,this.endColumn=I)}isEmpty(){return y.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return y.containsPosition(this,T)}static containsPosition(T,E){return!(E.lineNumber<T.startLineNumber||E.lineNumber>T.endLineNumber||E.lineNumber===T.startLineNumber&&E.column<T.startColumn||E.lineNumber===T.endLineNumber&&E.column>T.endColumn)}containsRange(T){return y.containsRange(this,T)}static containsRange(T,E){return!(E.startLineNumber<T.startLineNumber||E.endLineNumber<T.startLineNumber||E.startLineNumber>T.endLineNumber||E.endLineNumber>T.endLineNumber||E.startLineNumber===T.startLineNumber&&E.startColumn<T.startColumn||E.endLineNumber===T.endLineNumber&&E.endColumn>T.endColumn)}strictContainsRange(T){return y.strictContainsRange(this,T)}static strictContainsRange(T,E){return!(E.startLineNumber<T.startLineNumber||E.endLineNumber<T.startLineNumber||E.startLineNumber>T.endLineNumber||E.endLineNumber>T.endLineNumber||E.startLineNumber===T.startLineNumber&&E.startColumn<=T.startColumn||E.endLineNumber===T.endLineNumber&&E.endColumn>=T.endColumn)}plusRange(T){return y.plusRange(this,T)}static plusRange(T,E){let k,I,i,P;return E.startLineNumber<T.startLineNumber?(k=E.startLineNumber,I=E.startColumn):E.startLineNumber===T.startLineNumber?(k=E.startLineNumber,I=Math.min(E.startColumn,T.startColumn)):(k=T.startLineNumber,I=T.startColumn),E.endLineNumber>T.endLineNumber?(i=E.endLineNumber,P=E.endColumn):E.endLineNumber===T.endLineNumber?(i=E.endLineNumber,P=Math.max(E.endColumn,T.endColumn)):(i=T.endLineNumber,P=T.endColumn),new y(k,I,i,P)}intersectRanges(T){return y.intersectRanges(this,T)}static intersectRanges(T,E){let k=T.startLineNumber,I=T.startColumn,i=T.endLineNumber,P=T.endColumn,S=E.startLineNumber,v=E.startColumn,d=E.endLineNumber,a=E.endColumn;return k<S?(k=S,I=v):k===S&&(I=Math.max(I,v)),i>d?(i=d,P=a):i===d&&(P=Math.min(P,a)),k>i||k===i&&I>P?null:new y(k,I,i,P)}equalsRange(T){return y.equalsRange(this,T)}static equalsRange(T,E){return!!T&&!!E&&T.startLineNumber===E.startLineNumber&&T.startColumn===E.startColumn&&T.endLineNumber===E.endLineNumber&&T.endColumn===E.endColumn}getEndPosition(){return y.getEndPosition(this)}static getEndPosition(T){return new b.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return y.getStartPosition(this)}static getStartPosition(T){return new b.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,E){return new y(this.startLineNumber,this.startColumn,T,E)}setStartPosition(T,E){return new y(T,E,this.endLineNumber,this.endColumn)}collapseToStart(){return y.collapseToStart(this)}static collapseToStart(T){return new y(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,E=T){return new y(T.lineNumber,T.column,E.lineNumber,E.column)}static lift(T){return T?new y(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,E){return!(T.endLineNumber<E.startLineNumber||T.endLineNumber===E.startLineNumber&&T.endColumn<E.startColumn||E.endLineNumber<T.startLineNumber||E.endLineNumber===T.startLineNumber&&E.endColumn<T.startColumn)}static areIntersecting(T,E){return!(T.endLineNumber<E.startLineNumber||T.endLineNumber===E.startLineNumber&&T.endColumn<=E.startColumn||E.endLineNumber<T.startLineNumber||E.endLineNumber===T.startLineNumber&&E.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,E){if(T&&E){const i=T.startLineNumber|0,P=E.startLineNumber|0;if(i===P){const S=T.startColumn|0,v=E.startColumn|0;if(S===v){const d=T.endLineNumber|0,a=E.endLineNumber|0;if(d===a){const m=T.endColumn|0,p=E.endColumn|0;return m-p}return d-a}return S-v}return i-P}return(T?1:0)-(E?1:0)}static compareRangesUsingEnds(T,E){return T.endLineNumber===E.endLineNumber?T.endColumn===E.endColumn?T.startLineNumber===E.startLineNumber?T.startColumn-E.startColumn:T.startLineNumber-E.startLineNumber:T.endColumn-E.endColumn:T.endLineNumber-E.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=y}),define(ve[110],_e([0,1,39,32]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var A;(function(E){E[E.LTR=0]="LTR",E[E.RTL=1]="RTL"})(A=e.SelectionDirection||(e.SelectionDirection={}));class T extends y.Range{constructor(k,I,i,P){super(k,I,i,P);this.selectionStartLineNumber=k,this.selectionStartColumn=I,this.positionLineNumber=i,this.positionColumn=P}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return T.selectionsEqual(this,k)}static selectionsEqual(k,I){return k.selectionStartLineNumber===I.selectionStartLineNumber&&k.selectionStartColumn===I.selectionStartColumn&&k.positionLineNumber===I.positionLineNumber&&k.positionColumn===I.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,I){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,k,I):new T(k,I,this.startLineNumber,this.startColumn)}getPosition(){return new b.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(k,I){return this.getDirection()===0?new T(k,I,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,k,I)}static fromPositions(k,I=k){return new T(k.lineNumber,k.column,I.lineNumber,I.column)}static liftSelection(k){return new T(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,I){if(k&&!I||!k&&I)return!1;if(!k&&!I)return!0;if(k.length!==I.length)return!1;for(let i=0,P=k.length;i<P;i++)if(!this.selectionsEqual(k[i],I[i]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,I,i,P,S){return S===0?new T(k,I,i,P):new T(i,P,k,I)}}e.Selection=T}),define(ve[83],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var b;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(b=e.OverviewRulerLane||(e.OverviewRulerLane={}));var y;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(y=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(d){d[d.TextDefined=0]="TextDefined",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(d){d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var E;(function(d){d[d.LF=0]="LF",d[d.CRLF=1]="CRLF"})(E=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{constructor(a){this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace)}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class I{constructor(a,m){this.range=a,this.matches=m}}e.FindMatch=I;var i;(function(d){d[d.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",d[d.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",d[d.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",d[d.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(i=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var P;(function(d){d[d.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(P=e.ModelConstants||(e.ModelConstants={}));class S{constructor(a,m,p,f,c,n){this.identifier=a,this.range=m,this.text=p,this.forceMoveMarkers=f,this.isAutoWhitespaceEdit=c,this._isTracked=n}}e.ValidAnnotatedEditOperation=S;class v{constructor(a,m,p){this.reverseEdits=a,this.changes=m,this.trimAutoWhitespaceLineNumbers=p}}e.ApplyEditsResult=v}),define(ve[111],_e([0,1,8,109,39,32,83]),function(se,e,b,y,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class I{constructor(n,o,h,t){this.searchString=n,this.isRegex=o,this.matchCase=h,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=i(this.searchString):n=this.searchString.indexOf(`
`)>=0;let o=null;try{o=b.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch(t){return null}if(!o)return null;let h=!this.isRegex&&!n;return h&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(h=this.matchCase),new P(o,this.wordSeparators?y.getMapForWordSeparators(this.wordSeparators):null,h?this.searchString:null)}}e.SearchParams=I;function i(c){if(!c||c.length===0)return!1;for(let n=0,o=c.length;n<o;n++)if(c.charCodeAt(n)===92){if(n++,n>=o)break;const t=c.charCodeAt(n);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=i;class P{constructor(n,o,h){this.regex=n,this.wordSeparators=o,this.simpleSearch=h}}e.SearchData=P;function S(c,n,o){if(!o)return new E.FindMatch(c,null);let h=[];for(let t=0,s=n.length;t<s;t++)h[t]=n[t];return new E.FindMatch(c,h)}e.createFindMatch=S;class v{constructor(n){let o=[],h=0;for(let t=0,s=n.length;t<s;t++)n.charCodeAt(t)===10&&(o[h++]=t);this._lineFeedsOffsets=o}findLineFeedCountBeforeOffset(n){const o=this._lineFeedsOffsets;let h=0,t=o.length-1;if(t===-1||n<=o[0])return 0;for(;h<t;){const s=h+((t-h)/2>>0);o[s]>=n?t=s-1:o[s+1]>=n?(h=s,t=s):h=s+1}return h+1}}class d{static findMatches(n,o,h,t,s){const l=o.parseSearchRequest();return l?l.regex.multiline?this._doFindMatchesMultiline(n,h,new f(l.wordSeparators,l.regex),t,s):this._doFindMatchesLineByLine(n,h,l,t,s):[]}static _getMultilineMatchRange(n,o,h,t,s,l){let u,r=0;t?(r=t.findLineFeedCountBeforeOffset(s),u=o+s+r):u=o+s;let g;if(t){let w=t.findLineFeedCountBeforeOffset(s+l.length)-r;g=u+l.length+w}else g=u+l.length;const C=n.getPositionAt(u),_=n.getPositionAt(g);return new T.Range(C.lineNumber,C.column,_.lineNumber,_.column)}static _doFindMatchesMultiline(n,o,h,t,s){const l=n.getOffsetAt(o.getStartPosition()),u=n.getValueInRange(o,1),r=n.getEOL()===`\r
`?new v(u):null,g=[];let C=0,_;for(h.reset(0);_=h.next(u);)if(g[C++]=S(this._getMultilineMatchRange(n,l,u,r,_.index,_[0]),_,t),C>=s)return g;return g}static _doFindMatchesLineByLine(n,o,h,t,s){const l=[];let u=0;if(o.startLineNumber===o.endLineNumber){const g=n.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return u=this._findMatchesInLine(h,g,o.startLineNumber,o.startColumn-1,u,l,t,s),l}const r=n.getLineContent(o.startLineNumber).substring(o.startColumn-1);u=this._findMatchesInLine(h,r,o.startLineNumber,o.startColumn-1,u,l,t,s);for(let g=o.startLineNumber+1;g<o.endLineNumber&&u<s;g++)u=this._findMatchesInLine(h,n.getLineContent(g),g,0,u,l,t,s);if(u<s){const g=n.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);u=this._findMatchesInLine(h,g,o.endLineNumber,0,u,l,t,s)}return l}static _findMatchesInLine(n,o,h,t,s,l,u,r){const g=n.wordSeparators;if(!u&&n.simpleSearch){const D=n.simpleSearch,w=D.length,O=o.length;let R=-w;for(;(R=o.indexOf(D,R+w))!==-1;)if((!g||p(g,o,O,R,w))&&(l[s++]=new E.FindMatch(new T.Range(h,R+1+t,h,R+1+w+t),null),s>=r))return s;return s}const C=new f(n.wordSeparators,n.regex);let _;C.reset(0);do if(_=C.next(o),_&&(l[s++]=S(new T.Range(h,_.index+1+t,h,_.index+1+_[0].length+t),_,u),s>=r))return s;while(_);return s}static findNextMatch(n,o,h,t){const s=o.parseSearchRequest();if(!s)return null;const l=new f(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(n,h,l,t):this._doFindNextMatchLineByLine(n,h,l,t)}static _doFindNextMatchMultiline(n,o,h,t){const s=new A.Position(o.lineNumber,1),l=n.getOffsetAt(s),u=n.getLineCount(),r=n.getValueInRange(new T.Range(s.lineNumber,s.column,u,n.getLineMaxColumn(u)),1),g=n.getEOL()===`\r
`?new v(r):null;h.reset(o.column-1);let C=h.next(r);return C?S(this._getMultilineMatchRange(n,l,r,g,C.index,C[0]),C,t):o.lineNumber!==1||o.column!==1?this._doFindNextMatchMultiline(n,new A.Position(1,1),h,t):null}static _doFindNextMatchLineByLine(n,o,h,t){const s=n.getLineCount(),l=o.lineNumber,u=n.getLineContent(l),r=this._findFirstMatchInLine(h,u,l,o.column,t);if(r)return r;for(let g=1;g<=s;g++){const C=(l+g-1)%s,_=n.getLineContent(C+1),D=this._findFirstMatchInLine(h,_,C+1,1,t);if(D)return D}return null}static _findFirstMatchInLine(n,o,h,t,s){n.reset(t-1);const l=n.next(o);return l?S(new T.Range(h,l.index+1,h,l.index+1+l[0].length),l,s):null}static findPreviousMatch(n,o,h,t){const s=o.parseSearchRequest();if(!s)return null;const l=new f(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(n,h,l,t):this._doFindPreviousMatchLineByLine(n,h,l,t)}static _doFindPreviousMatchMultiline(n,o,h,t){const s=this._doFindMatchesMultiline(n,new T.Range(1,1,o.lineNumber,o.column),h,t,10*k);if(s.length>0)return s[s.length-1];const l=n.getLineCount();return o.lineNumber!==l||o.column!==n.getLineMaxColumn(l)?this._doFindPreviousMatchMultiline(n,new A.Position(l,n.getLineMaxColumn(l)),h,t):null}static _doFindPreviousMatchLineByLine(n,o,h,t){const s=n.getLineCount(),l=o.lineNumber,u=n.getLineContent(l).substring(0,o.column-1),r=this._findLastMatchInLine(h,u,l,t);if(r)return r;for(let g=1;g<=s;g++){const C=(s+l-g-1)%s,_=n.getLineContent(C+1),D=this._findLastMatchInLine(h,_,C+1,t);if(D)return D}return null}static _findLastMatchInLine(n,o,h,t){let s=null,l;for(n.reset(0);l=n.next(o);)s=S(new T.Range(h,l.index+1,h,l.index+1+l[0].length),l,t);return s}}e.TextModelSearch=d;function a(c,n,o,h,t){if(h===0)return!0;const s=n.charCodeAt(h-1);if(c.get(s)!==0||s===13||s===10)return!0;if(t>0){const l=n.charCodeAt(h);if(c.get(l)!==0)return!0}return!1}function m(c,n,o,h,t){if(h+t===o)return!0;const s=n.charCodeAt(h+t);if(c.get(s)!==0||s===13||s===10)return!0;if(t>0){const l=n.charCodeAt(h+t-1);if(c.get(l)!==0)return!0}return!1}function p(c,n,o,h,t){return a(c,n,o,h,t)&&m(c,n,o,h,t)}e.isValidMatch=p;class f{constructor(n,o){this._wordSeparators=n,this._searchRegex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(n){this._searchRegex.lastIndex=n,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(n){const o=n.length;let h;do{if(this._prevMatchStartIndex+this._prevMatchLength===o||(h=this._searchRegex.exec(n),!h))return null;const t=h.index,s=h[0].length;if(t===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){b.getNextCodePoint(n,o,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=s,!this._wordSeparators||p(this._wordSeparators,n,o,t,s))return h}while(h);return null}}e.Searcher=f}),define(ve[84],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function b(k=""){let I="(-?\\d*\\.\\d\\w*)|([^";for(const i of e.USUAL_WORD_SEPARATORS)k.indexOf(i)>=0||(I+="\\"+i);return I+="\\s]+)",new RegExp(I,"g")}e.DEFAULT_WORD_REGEXP=b();function y(k){let I=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)I=k;else{let i="g";k.ignoreCase&&(i+="i"),k.multiline&&(i+="m"),k.unicode&&(i+="u"),I=new RegExp(k.source,i)}return I.lastIndex=0,I}e.ensureValidWordDefinition=y;const A={maxLen:1e3,windowSize:15,timeBudget:150};function T(k,I,i,P,S=A){if(i.length>S.maxLen){let p=k-S.maxLen/2;return p<0?p=0:P+=p,i=i.substring(p,k+S.maxLen/2),T(k,I,i,P,S)}const v=Date.now(),d=k-1-P;let a=-1,m=null;for(let p=1;!(Date.now()-v>=S.timeBudget);p++){const f=d-S.windowSize*p;I.lastIndex=Math.max(0,f);const c=E(I,i,d,a);if(!c&&m||(m=c,f<=0))break;a=f}if(m){let p={word:m[0],startColumn:P+1+m.index,endColumn:P+1+m.index+m[0].length};return I.lastIndex=0,p}return null}e.getWordAtText=T;function E(k,I,i,P){let S;for(;S=k.exec(I);){const v=S.index||0;if(v<=i&&k.lastIndex>=i)return S;if(P>0&&v>P)return null}return null}}),define(ve[112],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var b;(function(E){E[E.None=0]="None",E[E.Indent=1]="Indent",E[E.IndentOutdent=2]="IndentOutdent",E[E.Outdent=3]="Outdent"})(b=e.IndentAction||(e.IndentAction={}));class y{constructor(k){if(this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let I=0,i=k.notIn.length;I<i;I++)switch(k.notIn[I]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=y;class A{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of k)T(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),T(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),T(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),T(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&T(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.AutoClosingPairs=A;function T(E,k,I){E.has(k)?E.get(k).push(I):E.set(k,[I])}}),define(ve[60],_e([0,1,29,10]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function A(T,E,k,I){if(Array.isArray(T)){let i=0;for(const P of T){const S=A(P,E,k,I);if(S===10)return S;S>i&&(i=S)}return i}else{if(typeof T=="string")return I?T==="*"?5:T===k?10:0:0;if(T){const{language:i,pattern:P,scheme:S,hasAccessToAllModels:v}=T;if(!I&&!v)return 0;let d=0;if(S)if(S===E.scheme)d=10;else if(S==="*")d=5;else return 0;if(i)if(i===k)d=10;else if(i==="*")d=Math.max(d,5);else return 0;if(P){let a;if(typeof P=="string"?a=P:a=Object.assign(Object.assign({},P),{base:y.normalize(P.base)}),a===E.fsPath||b.match(a,E.fsPath))d=10;else return 0}return d}else return 0}}e.score=A}),define(ve[113],_e([0,1,82]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var y;(function(d){d[d.Invalid=0]="Invalid",d[d.Start=1]="Start",d[d.H=2]="H",d[d.HT=3]="HT",d[d.HTT=4]="HTT",d[d.HTTP=5]="HTTP",d[d.F=6]="F",d[d.FI=7]="FI",d[d.FIL=8]="FIL",d[d.BeforeColon=9]="BeforeColon",d[d.AfterColon=10]="AfterColon",d[d.AlmostThere=11]="AlmostThere",d[d.End=12]="End",d[d.Accept=13]="Accept",d[d.LastKnownState=14]="LastKnownState"})(y=e.State||(e.State={}));class A{constructor(a,m,p){const f=new Uint8Array(a*m);for(let c=0,n=a*m;c<n;c++)f[c]=p;this._data=f,this.rows=a,this.cols=m}get(a,m){return this._data[a*this.cols+m]}set(a,m,p){this._data[a*this.cols+m]=p}}e.Uint8Matrix=A;class T{constructor(a){let m=0,p=0;for(let c=0,n=a.length;c<n;c++){let[o,h,t]=a[c];h>m&&(m=h),o>p&&(p=o),t>p&&(p=t)}m++,p++;let f=new A(p,m,0);for(let c=0,n=a.length;c<n;c++){let[o,h,t]=a[c];f.set(o,h,t)}this._states=f,this._maxCharCode=m}nextState(a,m){return m<0||m>=this._maxCharCode?0:this._states.get(a,m)}}e.StateMachine=T;let E=null;function k(){return E===null&&(E=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),E}var I;(function(d){d[d.None=0]="None",d[d.ForceTermination=1]="ForceTermination",d[d.CannotEndIn=2]="CannotEndIn"})(I||(I={}));let i=null;function P(){if(i===null){i=new b.CharacterClassifier(0);const d=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<d.length;m++)i.set(d.charCodeAt(m),1);const a=".,;";for(let m=0;m<a.length;m++)i.set(a.charCodeAt(m),2)}return i}class S{static _createLink(a,m,p,f,c){let n=c-1;do{const o=m.charCodeAt(n);if(a.get(o)!==2)break;n--}while(n>f);if(f>0){const o=m.charCodeAt(f-1),h=m.charCodeAt(n);(o===40&&h===41||o===91&&h===93||o===123&&h===125)&&n--}return{range:{startLineNumber:p,startColumn:f+1,endLineNumber:p,endColumn:n+2},url:m.substring(f,n+1)}}static computeLinks(a,m=k()){const p=P();let f=[];for(let c=1,n=a.getLineCount();c<=n;c++){const o=a.getLineContent(c),h=o.length;let t=0,s=0,l=0,u=1,r=!1,g=!1,C=!1,_=!1;for(;t<h;){let D=!1;const w=o.charCodeAt(t);if(u===13){let O;switch(w){case 40:r=!0,O=0;break;case 41:O=r?0:1;break;case 91:C=!0,g=!0,O=0;break;case 93:C=!1,O=g?0:1;break;case 123:_=!0,O=0;break;case 125:O=_?0:1;break;case 39:O=l===34||l===96?0:1;break;case 34:O=l===39||l===96?0:1;break;case 96:O=l===39||l===34?0:1;break;case 42:O=l===42?1:0;break;case 124:O=l===124?1:0;break;case 32:O=C?0:1;break;default:O=p.get(w)}O===1&&(f.push(S._createLink(p,o,c,s,t)),D=!0)}else if(u===12){let O;w===91?(g=!0,O=0):O=p.get(w),O===1?D=!0:u=13}else u=m.nextState(u,w),u===0&&(D=!0);D&&(u=1,r=!1,g=!1,_=!1,s=t+1,l=w),t++}u===13&&f.push(S._createLink(p,o,c,s,h))}return f}}e.LinkComputer=S;function v(d){return!d||typeof d.getLineCount!="function"||typeof d.getLineContent!="function"?[]:S.computeLinks(d)}e.computeLinks=v}),define(ve[114],_e([0,1,3,6]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class A{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(E){this._onDidChange.fire({changedLanguages:E,changedColorMap:!1})}register(E,k){return this._map.set(E,k),this.fire([E]),y.toDisposable(()=>{this._map.get(E)===k&&(this._map.delete(E),this.fire([E]))})}registerPromise(E,k){let I=null,i=!1;return this._promises.set(E,k.then(P=>{this._promises.delete(E),!(i||!P)&&(I=this.register(E,P))})),y.toDisposable(()=>{i=!0,I&&I.dispose()})}getPromise(E){const k=this.get(E);if(k)return Promise.resolve(k);const I=this._promises.get(E);return I?I.then(i=>this.get(E)):null}get(E){return this._map.get(E)||null}setColorMap(E){this._colorMap=E,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=A}),define(ve[85],_e([0,1,27,21]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var A;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(A||(A={}));function T(S){for(let v=0,d=S.length;v<d;v+=4){const a=S[v+0],m=S[v+1],p=S[v+2],f=S[v+3];S[v+0]=f,S[v+1]=p,S[v+2]=m,S[v+3]=a}}function E(S){const v=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return y.isLittleEndian()||T(v),b.VSBuffer.wrap(v)}function k(S){const v=S.buffer;if(y.isLittleEndian()||T(v),v.byteOffset%4==0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const d=new Uint8Array(v.byteLength);return d.set(v),new Uint32Array(d.buffer,d.byteOffset,d.length/4)}}function I(S){const v=new Uint32Array(i(S));let d=0;if(v[d++]=S.id,S.type==="full")v[d++]=1,v[d++]=S.data.length,v.set(S.data,d),d+=S.data.length;else{v[d++]=2,v[d++]=S.deltas.length;for(const a of S.deltas)v[d++]=a.start,v[d++]=a.deleteCount,a.data?(v[d++]=a.data.length,v.set(a.data,d),d+=a.data.length):v[d++]=0}return E(v)}e.encodeSemanticTokensDto=I;function i(S){let v=0;if(v+=1+1,S.type==="full")v+=1+S.data.length;else{v+=1,v+=(1+1+1)*S.deltas.length;for(const d of S.deltas)d.data&&(v+=d.data.length)}return v}function P(S){const v=k(S);let d=0;const a=v[d++];if(v[d++]===1){const c=v[d++],n=v.subarray(d,d+c);return d+=c,{id:a,type:"full",data:n}}const p=v[d++];let f=[];for(let c=0;c<p;c++){const n=v[d++],o=v[d++],h=v[d++];let t;h>0&&(t=v.subarray(d,d+h),d+=h),f[c]={start:n,deleteCount:o,data:t}}return{id:a,type:"delta",deltas:f}}e.decodeSemanticTokensDto=P}),define(ve[86],_e([0,1,80]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class y{constructor(E,k){this.index=E,this.remainder=k}}e.PrefixSumIndexOfResult=y;class A{constructor(E){this.values=E,this.prefixSum=new Uint32Array(E.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(E,k){E=b.toUint32(E);const I=this.values,i=this.prefixSum,P=k.length;return P===0?!1:(this.values=new Uint32Array(I.length+P),this.values.set(I.subarray(0,E),0),this.values.set(I.subarray(E),E+P),this.values.set(k,E),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(i.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(E,k){return E=b.toUint32(E),k=b.toUint32(k),this.values[E]===k?!1:(this.values[E]=k,E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),!0)}removeValues(E,k){E=b.toUint32(E),k=b.toUint32(k);const I=this.values,i=this.prefixSum;if(E>=I.length)return!1;let P=I.length-E;return k>=P&&(k=P),k===0?!1:(this.values=new Uint32Array(I.length-k),this.values.set(I.subarray(0,E),0),this.values.set(I.subarray(E+k),E),this.prefixSum=new Uint32Array(this.values.length),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(i.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(E){return E<0?0:(E=b.toUint32(E),this._getAccumulatedValue(E))}_getAccumulatedValue(E){if(E<=this.prefixSumValidIndex[0])return this.prefixSum[E];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),E>=this.values.length&&(E=this.values.length-1);for(let I=k;I<=E;I++)this.prefixSum[I]=this.prefixSum[I-1]+this.values[I];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],E),this.prefixSum[E]}getIndexOf(E){E=Math.floor(E),this.getTotalValue();let k=0,I=this.values.length-1,i=0,P=0,S=0;for(;k<=I;)if(i=k+(I-k)/2|0,P=this.prefixSum[i],S=P-this.values[i],E<S)I=i-1;else if(E>=P)k=i+1;else break;return new y(i,E-S)}}e.PrefixSumComputer=A}),define(ve[115],_e([0,1,8,39,86]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(k,I,i,P){this._uri=k,this._lines=I,this._eol=i,this._versionId=P,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const I=k.changes;for(const i of I)this._acceptDeleteRange(i.range),this._acceptInsertText(new y.Position(i.range.startLineNumber,i.range.startColumn),i.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,I=this._lines.length,i=new Uint32Array(I);for(let P=0;P<I;P++)i[P]=this._lines[P].length+k;this._lineStarts=new A.PrefixSumComputer(i)}}_setLineText(k,I){this._lines[k]=I,this._lineStarts&&this._lineStarts.changeValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,I){if(I.length!==0){let i=b.splitLines(I);if(i.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+i[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}i[i.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+i[0]);let P=new Uint32Array(i.length-1);for(let S=1;S<i.length;S++)this._lines.splice(k.lineNumber+S-1,0,i[S]),P[S-1]=i[S].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,P)}}}e.MirrorTextModel=T}),define(ve[116],_e([18,19]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(ve[61],_e([0,1,116,12,11]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(i,P){return P&&(i.stack||i.stacktrace)?b.localize(0,null,k(i),E(i.stack)||E(i.stacktrace)):k(i)}function E(i){return Array.isArray(i)?i.join(`
`):i}function k(i){return typeof i.code=="string"&&typeof i.errno=="number"&&typeof i.syscall=="string"?b.localize(1,null,i.message):i.message||b.localize(2,null)}function I(i=null,P=!1){if(!i)return b.localize(3,null);if(Array.isArray(i)){const S=A.coalesce(i),v=I(S[0],P);return S.length>1?b.localize(4,null,v,S.length):v}if(y.isString(i))return i;if(i.detail){const S=i.detail;if(S.error)return T(S.error,P);if(S.exception)return T(S.exception,P)}return i.stack?T(i,P):i.message?i.message:b.localize(5,null)}e.toErrorMessage=I}),define(ve[117],_e([18,19]),function(se,e){return se.create("vs/editor/common/config/editorOptions",e)}),define(ve[118],_e([0,1,117,21,84]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(B){B[B.None=0]="None",B[B.Keep=1]="Keep",B[B.Brackets=2]="Brackets",B[B.Advanced=3]="Advanced",B[B.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(Z){this._values=Z}hasChanged(Z){return this._values[Z]}}e.ConfigurationChangedEvent=E;class k{constructor(){this._values=[]}_read(Z){return this._values[Z]}get(Z){return this._values[Z]}_write(Z,he){this._values[Z]=he}}e.ValidatedEditorOptions=k;class I{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=I;class i{constructor(Z,he,Le,Oe){this.id=Z,this.name=he,this.defaultValue=Le,this.schema=Oe}compute(Z,he,Le){return Le}}class P{constructor(Z,he=null){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0,this.deps=he}validate(Z){return this.defaultValue}}class S{constructor(Z,he,Le,Oe){this.id=Z,this.name=he,this.defaultValue=Le,this.schema=Oe}validate(Z){return typeof Z=="undefined"?this.defaultValue:Z}compute(Z,he,Le){return Le}}function v(B,Z){return typeof B=="undefined"?Z:B==="false"?!1:Boolean(B)}e.boolean=v;class d extends S{constructor(Z,he,Le,Oe=void 0){typeof Oe!="undefined"&&(Oe.type="boolean",Oe.default=Le),super(Z,he,Le,Oe)}validate(Z){return v(Z,this.defaultValue)}}class a extends S{constructor(Z,he,Le,Oe,We,Ke=void 0){typeof Ke!="undefined"&&(Ke.type="integer",Ke.default=Le,Ke.minimum=Oe,Ke.maximum=We),super(Z,he,Le,Ke),this.minimum=Oe,this.maximum=We}static clampedInt(Z,he,Le,Oe){if(typeof Z=="undefined")return he;let We=parseInt(Z,10);return isNaN(We)?he:(We=Math.max(Le,We),We=Math.min(Oe,We),We|0)}validate(Z){return a.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}class m extends S{constructor(Z,he,Le,Oe,We){typeof We!="undefined"&&(We.type="number",We.default=Le),super(Z,he,Le,We),this.validationFn=Oe}static clamp(Z,he,Le){return Z<he?he:Z>Le?Le:Z}static float(Z,he){if(typeof Z=="number")return Z;if(typeof Z=="undefined")return he;const Le=parseFloat(Z);return isNaN(Le)?he:Le}validate(Z){return this.validationFn(m.float(Z,this.defaultValue))}}class p extends S{static string(Z,he){return typeof Z!="string"?he:Z}constructor(Z,he,Le,Oe=void 0){typeof Oe!="undefined"&&(Oe.type="string",Oe.default=Le),super(Z,he,Le,Oe)}validate(Z){return p.string(Z,this.defaultValue)}}function f(B,Z,he){return typeof B!="string"||he.indexOf(B)===-1?Z:B}e.stringSet=f;class c extends S{constructor(Z,he,Le,Oe,We=void 0){typeof We!="undefined"&&(We.type="string",We.enum=Oe,We.default=Le),super(Z,he,Le,We),this._allowedValues=Oe}validate(Z){return f(Z,this.defaultValue,this._allowedValues)}}class n extends i{constructor(Z,he,Le,Oe,We,Ke,ie=void 0){typeof ie!="undefined"&&(ie.type="string",ie.enum=We,ie.default=Oe),super(Z,he,Le,ie),this._allowedValues=We,this._convert=Ke}validate(Z){return typeof Z!="string"?this.defaultValue:this._allowedValues.indexOf(Z)===-1?this.defaultValue:this._convert(Z)}}function o(B){switch(B){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends i{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",description:b.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,he,Le){return Le===0?Z.accessibilitySupport:Le}}class t extends i{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(16,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:b.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const he=Z;return{insertSpace:v(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(B){B[B.Hidden=0]="Hidden",B[B.Blink=1]="Blink",B[B.Smooth=2]="Smooth",B[B.Phase=3]="Phase",B[B.Expand=4]="Expand",B[B.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function l(B){switch(B){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(B){B[B.Line=1]="Line",B[B.Block=2]="Block",B[B.Underline=3]="Underline",B[B.LineThin=4]="LineThin",B[B.BlockOutline=5]="BlockOutline",B[B.UnderlineThin=6]="UnderlineThin"})(u=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function r(B){switch(B){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=r;function g(B){switch(B){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class C extends P{constructor(){super(121,[60,29])}compute(Z,he,Le){const Oe=["monaco-editor"];return he.get(29)&&Oe.push(he.get(29)),Z.extraEditorClassName&&Oe.push(Z.extraEditorClassName),he.get(60)==="default"?Oe.push("mouse-default"):he.get(60)==="copy"&&Oe.push("mouse-copy"),he.get(95)&&Oe.push("showUnused"),he.get(119)&&Oe.push("showDeprecated"),Oe.join(" ")}}class _ extends d{constructor(){super(28,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(Z,he,Le){return Le&&Z.emptySelectionClipboard}}class D extends i{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(31,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:Z.seedSearchStringFromSelection,description:b.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[b.localize(9,null),b.localize(10,null),b.localize(11,null)],description:b.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:b.localize(13,null),included:y.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:b.localize(14,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:b.localize(15,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const he=Z;return{cursorMoveOnType:v(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:v(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":f(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(he.loop,this.defaultValue.loop)}}}class w extends i{constructor(){super(39,"fontLigatures",w.OFF,{anyOf:[{type:"boolean",description:b.localize(16,null)},{type:"string",description:b.localize(17,null)}],description:b.localize(18,null),default:!1})}validate(Z){return typeof Z=="undefined"?this.defaultValue:typeof Z=="string"?Z==="false"?w.OFF:Z==="true"?w.ON:Z:Boolean(Z)?w.ON:w.OFF}}e.EditorFontLigatures=w,w.OFF='"liga" off, "calt" off',w.ON='"liga" on, "calt" on';class O extends P{constructor(){super(38)}compute(Z,he,Le){return Z.fontInfo}}class R extends S{constructor(){super(40,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(19,null)})}validate(Z){let he=m.float(Z,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(he,6,100)}compute(Z,he,Le){return Z.fontInfo.fontSize}}class $ extends i{constructor(){super(41,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:b.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(21,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(a.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}$.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],$.MINIMUM_VALUE=1,$.MAXIMUM_VALUE=1e3;class V extends i{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[b.localize(22,null),b.localize(23,null),b.localize(24,null)]};super(45,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:b.localize(26,null)},he),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:b.localize(27,null)},he),"editor.gotoLocation.multipleDeclarations":Object.assign({description:b.localize(28,null)},he),"editor.gotoLocation.multipleImplementations":Object.assign({description:b.localize(29,null)},he),"editor.gotoLocation.multipleReferences":Object.assign({description:b.localize(30,null)},he),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,description:b.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,description:b.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,description:b.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,description:b.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,description:b.localize(35,null)}})}validate(Z){var he,Le,Oe,We,Ke;if(!Z||typeof Z!="object")return this.defaultValue;const ie=Z;return{multiple:f(ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(he=ie.multipleDefinitions)!==null&&he!==void 0?he:f(ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Le=ie.multipleTypeDefinitions)!==null&&Le!==void 0?Le:f(ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Oe=ie.multipleDeclarations)!==null&&Oe!==void 0?Oe:f(ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(We=ie.multipleImplementations)!==null&&We!==void 0?We:f(ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ke=ie.multipleReferences)!==null&&Ke!==void 0?Ke:f(ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends i{constructor(){const Z={enabled:!0,delay:300,sticky:!0};super(48,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:b.localize(36,null)},"editor.hover.delay":{type:"number",default:Z.delay,description:b.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:b.localize(38,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const he=Z;return{enabled:v(he.enabled,this.defaultValue.enabled),delay:a.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:v(he.sticky,this.defaultValue.sticky)}}}var U;(function(B){B[B.None=0]="None",B[B.Text=1]="Text",B[B.Blocks=2]="Blocks"})(U=e.RenderMinimap||(e.RenderMinimap={}));class q extends P{constructor(){super(124,[44,52,33,59,87,54,55,89,111,114,115,116,2])}compute(Z,he,Le){return q.computeLayout(he,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio})}static computeContainedMinimapLineCount(Z){const he=Z.height/Z.lineHeight,Le=Z.scrollBeyondLastLine?he-1:0,Oe=(Z.viewLineCount+Le)/(Z.pixelRatio*Z.height),We=Math.floor(Z.viewLineCount/Oe);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:Le,desiredRatio:Oe,minimapLineCount:We}}static _computeMinimapLayout(Z,he){const Le=Z.outerWidth,Oe=Z.outerHeight,We=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(We*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const Ke=he.stableMinimapLayoutInput,ie=Ke&&Z.outerHeight===Ke.outerHeight&&Z.lineHeight===Ke.lineHeight&&Z.typicalHalfwidthCharacterWidth===Ke.typicalHalfwidthCharacterWidth&&Z.pixelRatio===Ke.pixelRatio&&Z.scrollBeyondLastLine===Ke.scrollBeyondLastLine&&Z.minimap.enabled===Ke.minimap.enabled&&Z.minimap.side===Ke.minimap.side&&Z.minimap.size===Ke.minimap.size&&Z.minimap.showSlider===Ke.minimap.showSlider&&Z.minimap.renderCharacters===Ke.minimap.renderCharacters&&Z.minimap.maxColumn===Ke.minimap.maxColumn&&Z.minimap.scale===Ke.minimap.scale&&Z.verticalScrollbarWidth===Ke.verticalScrollbarWidth&&Z.isViewportWrapping===Ke.isViewportWrapping,ge=Z.lineHeight,Me=Z.typicalHalfwidthCharacterWidth,G=Z.scrollBeyondLastLine,Q=Z.minimap.renderCharacters;let H=We>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const L=Z.minimap.maxColumn,J=Z.minimap.size,X=Z.minimap.side,ce=Z.verticalScrollbarWidth,me=Z.viewLineCount,Pe=Z.remainingWidth,Fe=Z.isViewportWrapping,je=Q?2:3;let qe=Math.floor(We*Oe);const Ge=qe/We;let st=!1,$e=!1,Qe=je*H,ht=H/We,et=1;if(J==="fill"||J==="fit"){const{typicalViewportLineCount:at,extraLinesBeyondLastLine:ut,desiredRatio:rt,minimapLineCount:St}=q.computeContainedMinimapLineCount({viewLineCount:me,scrollBeyondLastLine:G,height:Oe,lineHeight:ge,pixelRatio:We});if(me/St>1)st=!0,$e=!0,H=1,Qe=1,ht=H/We;else{let wt=!1,gt=H+1;if(J==="fit"){const yt=Math.ceil((me+ut)*Qe);Fe&&ie&&Pe<=he.stableFitRemainingWidth?(wt=!0,gt=he.stableFitMaxMinimapScale):(wt=yt>qe,Fe&&wt?(he.stableMinimapLayoutInput=Z,he.stableFitRemainingWidth=Pe):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0))}if(J==="fill"||wt){st=!0;const yt=H;Qe=Math.min(ge*We,Math.max(1,Math.floor(1/rt))),H=Math.min(gt,Math.max(1,Math.floor(Qe/je))),H>yt&&(et=Math.min(2,H/yt)),ht=H/We/et,qe=Math.ceil(Math.max(at,me+ut)*Qe),Fe&&wt&&(he.stableFitMaxMinimapScale=H)}}}const ft=Math.floor(L*ht),ot=Math.min(ft,Math.max(0,Math.floor((Pe-ce-2)*ht/(Me+ht)))+e.MINIMAP_GUTTER_WIDTH);let Ze=Math.floor(We*ot);const Et=Ze/We;Ze=Math.floor(Ze*et);const vt=Q?1:2,mt=X==="left"?0:Le-ot-ce;return{renderMinimap:vt,minimapLeft:mt,minimapWidth:ot,minimapHeightIsEditorHeight:st,minimapIsSampling:$e,minimapScale:H,minimapLineHeight:Qe,minimapCanvasInnerWidth:Ze,minimapCanvasInnerHeight:qe,minimapCanvasOuterWidth:Et,minimapCanvasOuterHeight:Ge}}static computeLayout(Z,he){const Le=he.outerWidth|0,Oe=he.outerHeight|0,We=he.lineHeight|0,Ke=he.lineNumbersDigitCount|0,ie=he.typicalHalfwidthCharacterWidth,ge=he.maxDigitWidth,Me=he.pixelRatio,G=he.viewLineCount,Q=Z.get(116),H=Q==="inherit"?Z.get(115):Q,L=H==="inherit"?Z.get(111):H,J=Z.get(114),X=Z.get(2),ce=he.isDominatedByLongLines,me=Z.get(44),Pe=Z.get(54).renderType!==0,Fe=Z.get(55),je=Z.get(89),qe=Z.get(59),Ge=Z.get(87),st=Ge.verticalScrollbarSize,$e=Ge.verticalHasArrows,Qe=Ge.arrowSize,ht=Ge.horizontalScrollbarSize,et=Z.get(52),ft=Z.get(33);let ot;if(typeof et=="string"&&/^\d+(\.\d+)?ch$/.test(et)){const Dt=parseFloat(et.substr(0,et.length-2));ot=a.clampedInt(Dt*ie,0,0,1e3)}else ot=a.clampedInt(et,0,0,1e3);ft&&(ot+=16);let Ze=0;if(Pe){const Dt=Math.max(Ke,Fe);Ze=Math.round(Dt*ge)}let Et=0;me&&(Et=We);let vt=0,mt=vt+Et,at=mt+Ze,ut=at+ot;const rt=Le-Et-Ze-ot;let St=!1,_t=!1,wt=-1;X!==2&&(H==="inherit"&&ce?(St=!0,_t=!0):L==="on"||L==="bounded"?_t=!0:L==="wordWrapColumn"&&(wt=J));const gt=q._computeMinimapLayout({outerWidth:Le,outerHeight:Oe,lineHeight:We,typicalHalfwidthCharacterWidth:ie,pixelRatio:Me,scrollBeyondLastLine:je,minimap:qe,verticalScrollbarWidth:st,viewLineCount:G,remainingWidth:rt,isViewportWrapping:_t},he.memory||new I);gt.renderMinimap!==0&&gt.minimapLeft===0&&(vt+=gt.minimapWidth,mt+=gt.minimapWidth,at+=gt.minimapWidth,ut+=gt.minimapWidth);const yt=rt-gt.minimapWidth,pt=Math.max(1,Math.floor((yt-st-2)/ie)),Pt=$e?Qe:0;return _t&&(wt=Math.max(1,pt),L==="bounded"&&(wt=Math.min(wt,J))),{width:Le,height:Oe,glyphMarginLeft:vt,glyphMarginWidth:Et,lineNumbersLeft:mt,lineNumbersWidth:Ze,decorationsLeft:at,decorationsWidth:ot,contentLeft:ut,contentWidth:yt,minimap:gt,viewportColumn:pt,isWordWrapMinified:St,isViewportWrapping:_t,wrappingColumn:wt,verticalScrollbarWidth:st,horizontalScrollbarHeight:ht,overviewRuler:{top:Pt,width:st,height:Oe-2*Pt,right:0}}}}e.EditorLayoutInfoComputer=q;class M extends i{constructor(){const Z={enabled:!0};super(51,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:b.localize(39,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:v(Z.enabled,this.defaultValue.enabled)}}}class j extends i{constructor(){const Z={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(120,"inlineHints",Z,{"editor.inlineHints.enabled":{type:"boolean",default:Z.enabled,description:b.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:Z.fontSize,description:b.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:Z.fontFamily,description:b.localize(42,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const he=Z;return{enabled:v(he.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(he.fontFamily,this.defaultValue.fontFamily)}}}class re extends a{constructor(){super(53,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:b.localize(43,null)})}compute(Z,he,Le){return Z.fontInfo.lineHeight}}class F extends i{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(59,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:b.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(45,null),b.localize(46,null),b.localize(47,null)],default:Z.size,description:b.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:b.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:b.localize(50,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:b.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:b.localize(53,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const he=Z;return{enabled:v(he.enabled,this.defaultValue.enabled),size:f(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(he.side,this.defaultValue.side,["right","left"]),showSlider:f(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(he.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(he.scale,1,1,3),maxColumn:a.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function te(B){return B==="ctrlCmd"?y.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ae extends i{constructor(){super(69,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(55,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const he=Z;return{top:a.clampedInt(he.top,0,0,1e3),bottom:a.clampedInt(he.bottom,0,0,1e3)}}}class ue extends i{constructor(){const Z={enabled:!0,cycle:!1};super(70,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:b.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:b.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const he=Z;return{enabled:v(he.enabled,this.defaultValue.enabled),cycle:v(he.cycle,this.defaultValue.cycle)}}}class we extends P{constructor(){super(122)}compute(Z,he,Le){return Z.pixelRatio}}class fe extends i{constructor(){const Z={other:!0,comments:!1,strings:!1};super(73,"quickSuggestions",Z,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Z.strings,description:b.localize(58,null)},comments:{type:"boolean",default:Z.comments,description:b.localize(59,null)},other:{type:"boolean",default:Z.other,description:b.localize(60,null)}}}],default:Z,description:b.localize(61,null)});this.defaultValue=Z}validate(Z){if(typeof Z=="boolean")return Z;if(Z&&typeof Z=="object"){const he=Z,Le={other:v(he.other,this.defaultValue.other),comments:v(he.comments,this.defaultValue.comments),strings:v(he.strings,this.defaultValue.strings)};return Le.other&&Le.comments&&Le.strings?!0:!Le.other&&!Le.comments&&!Le.strings?!1:Le}return this.defaultValue}}var De;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval",B[B.Custom=4]="Custom"})(De=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Se extends i{constructor(){super(54,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(62,null),b.localize(63,null),b.localize(64,null),b.localize(65,null)],default:"on",description:b.localize(66,null)})}validate(Z){let he=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof Z!="undefined"&&(typeof Z=="function"?(he=4,Le=Z):Z==="interval"?he=3:Z==="relative"?he=2:Z==="on"?he=1:he=0),{renderType:he,renderFn:Le}}}function Ce(B){const Z=B.get(82);return Z==="editable"?B.get(75):Z!=="on"}e.filterValidationDecorations=Ce;class x extends i{constructor(){const Z=[],he={type:"number",description:b.localize(67,null)};super(86,"rulers",Z,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:b.localize(68,null),format:"color-hex"}}}]},default:Z,description:b.localize(69,null)})}validate(Z){if(Array.isArray(Z)){let he=[];for(let Le of Z)if(typeof Le=="number")he.push({column:a.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const Oe=Le;he.push({column:a.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return he.sort((Le,Oe)=>Le.column-Oe.column),he}return this.defaultValue}}function K(B,Z){if(typeof B!="string")return Z;switch(B){case"hidden":return 2;case"visible":return 3;default:return 1}}class ee extends i{constructor(){super(87,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const he=Z,Le=a.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=a.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:K(he.vertical,this.defaultValue.vertical),horizontal:K(he.horizontal,this.defaultValue.horizontal),useShadows:v(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:a.clampedInt(he.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:a.clampedInt(he.verticalSliderSize,Oe,0,1e3),scrollByPage:v(he.scrollByPage,this.defaultValue.scrollByPage)}}}class ne extends i{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(101,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(70,null),b.localize(71,null)],default:Z.insertMode,description:b.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:b.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:b.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:b.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:b.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:b.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:b.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:b.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(109,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const he=Z;return{insertMode:f(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(he.showIcons,this.defaultValue.showIcons),showStatusBar:v(he.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:v(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(he.showMethods,this.defaultValue.showMethods),showFunctions:v(he.showFunctions,this.defaultValue.showFunctions),showConstructors:v(he.showConstructors,this.defaultValue.showConstructors),showFields:v(he.showFields,this.defaultValue.showFields),showVariables:v(he.showVariables,this.defaultValue.showVariables),showClasses:v(he.showClasses,this.defaultValue.showClasses),showStructs:v(he.showStructs,this.defaultValue.showStructs),showInterfaces:v(he.showInterfaces,this.defaultValue.showInterfaces),showModules:v(he.showModules,this.defaultValue.showModules),showProperties:v(he.showProperties,this.defaultValue.showProperties),showEvents:v(he.showEvents,this.defaultValue.showEvents),showOperators:v(he.showOperators,this.defaultValue.showOperators),showUnits:v(he.showUnits,this.defaultValue.showUnits),showValues:v(he.showValues,this.defaultValue.showValues),showConstants:v(he.showConstants,this.defaultValue.showConstants),showEnums:v(he.showEnums,this.defaultValue.showEnums),showEnumMembers:v(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(he.showKeywords,this.defaultValue.showKeywords),showWords:v(he.showWords,this.defaultValue.showWords),showColors:v(he.showColors,this.defaultValue.showColors),showFiles:v(he.showFiles,this.defaultValue.showFiles),showReferences:v(he.showReferences,this.defaultValue.showReferences),showFolders:v(he.showFolders,this.defaultValue.showFolders),showTypeParameters:v(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(he.showSnippets,this.defaultValue.showSnippets),showUsers:v(he.showUsers,this.defaultValue.showUsers),showIssues:v(he.showIssues,this.defaultValue.showIssues)}}}class de extends i{constructor(){super(97,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(110,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ee extends P{constructor(){super(123,[75])}compute(Z,he,Le){return he.get(75)?!0:Z.tabFocusMode}}var Re;(function(B){B[B.None=0]="None",B[B.Same=1]="Same",B[B.Indent=2]="Indent",B[B.DeepIndent=3]="DeepIndent"})(Re=e.WrappingIndent||(e.WrappingIndent={}));function xe(B){switch(B){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class be extends P{constructor(){super(125,[124])}compute(Z,he,Le){const Oe=he.get(124);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}const ke="Consolas, 'Courier New', monospace",Te="Menlo, Monaco, 'Courier New', monospace",Ne="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:y.isMacintosh?Te:y.isLinux?Ne:ke,fontWeight:"normal",fontSize:y.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function pe(B){return e.editorOptionsRegistry[B.id]=B,B}var ze;(function(B){B[B.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",B[B.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",B[B.accessibilitySupport=2]="accessibilitySupport",B[B.accessibilityPageSize=3]="accessibilityPageSize",B[B.ariaLabel=4]="ariaLabel",B[B.autoClosingBrackets=5]="autoClosingBrackets",B[B.autoClosingOvertype=6]="autoClosingOvertype",B[B.autoClosingQuotes=7]="autoClosingQuotes",B[B.autoIndent=8]="autoIndent",B[B.automaticLayout=9]="automaticLayout",B[B.autoSurround=10]="autoSurround",B[B.codeLens=11]="codeLens",B[B.codeLensFontFamily=12]="codeLensFontFamily",B[B.codeLensFontSize=13]="codeLensFontSize",B[B.colorDecorators=14]="colorDecorators",B[B.columnSelection=15]="columnSelection",B[B.comments=16]="comments",B[B.contextmenu=17]="contextmenu",B[B.copyWithSyntaxHighlighting=18]="copyWithSyntaxHighlighting",B[B.cursorBlinking=19]="cursorBlinking",B[B.cursorSmoothCaretAnimation=20]="cursorSmoothCaretAnimation",B[B.cursorStyle=21]="cursorStyle",B[B.cursorSurroundingLines=22]="cursorSurroundingLines",B[B.cursorSurroundingLinesStyle=23]="cursorSurroundingLinesStyle",B[B.cursorWidth=24]="cursorWidth",B[B.disableLayerHinting=25]="disableLayerHinting",B[B.disableMonospaceOptimizations=26]="disableMonospaceOptimizations",B[B.dragAndDrop=27]="dragAndDrop",B[B.emptySelectionClipboard=28]="emptySelectionClipboard",B[B.extraEditorClassName=29]="extraEditorClassName",B[B.fastScrollSensitivity=30]="fastScrollSensitivity",B[B.find=31]="find",B[B.fixedOverflowWidgets=32]="fixedOverflowWidgets",B[B.folding=33]="folding",B[B.foldingStrategy=34]="foldingStrategy",B[B.foldingHighlight=35]="foldingHighlight",B[B.unfoldOnClickAfterEndOfLine=36]="unfoldOnClickAfterEndOfLine",B[B.fontFamily=37]="fontFamily",B[B.fontInfo=38]="fontInfo",B[B.fontLigatures=39]="fontLigatures",B[B.fontSize=40]="fontSize",B[B.fontWeight=41]="fontWeight",B[B.formatOnPaste=42]="formatOnPaste",B[B.formatOnType=43]="formatOnType",B[B.glyphMargin=44]="glyphMargin",B[B.gotoLocation=45]="gotoLocation",B[B.hideCursorInOverviewRuler=46]="hideCursorInOverviewRuler",B[B.highlightActiveIndentGuide=47]="highlightActiveIndentGuide",B[B.hover=48]="hover",B[B.inDiffEditor=49]="inDiffEditor",B[B.letterSpacing=50]="letterSpacing",B[B.lightbulb=51]="lightbulb",B[B.lineDecorationsWidth=52]="lineDecorationsWidth",B[B.lineHeight=53]="lineHeight",B[B.lineNumbers=54]="lineNumbers",B[B.lineNumbersMinChars=55]="lineNumbersMinChars",B[B.linkedEditing=56]="linkedEditing",B[B.links=57]="links",B[B.matchBrackets=58]="matchBrackets",B[B.minimap=59]="minimap",B[B.mouseStyle=60]="mouseStyle",B[B.mouseWheelScrollSensitivity=61]="mouseWheelScrollSensitivity",B[B.mouseWheelZoom=62]="mouseWheelZoom",B[B.multiCursorMergeOverlapping=63]="multiCursorMergeOverlapping",B[B.multiCursorModifier=64]="multiCursorModifier",B[B.multiCursorPaste=65]="multiCursorPaste",B[B.occurrencesHighlight=66]="occurrencesHighlight",B[B.overviewRulerBorder=67]="overviewRulerBorder",B[B.overviewRulerLanes=68]="overviewRulerLanes",B[B.padding=69]="padding",B[B.parameterHints=70]="parameterHints",B[B.peekWidgetDefaultFocus=71]="peekWidgetDefaultFocus",B[B.definitionLinkOpensInPeek=72]="definitionLinkOpensInPeek",B[B.quickSuggestions=73]="quickSuggestions",B[B.quickSuggestionsDelay=74]="quickSuggestionsDelay",B[B.readOnly=75]="readOnly",B[B.renameOnType=76]="renameOnType",B[B.renderControlCharacters=77]="renderControlCharacters",B[B.renderIndentGuides=78]="renderIndentGuides",B[B.renderFinalNewline=79]="renderFinalNewline",B[B.renderLineHighlight=80]="renderLineHighlight",B[B.renderLineHighlightOnlyWhenFocus=81]="renderLineHighlightOnlyWhenFocus",B[B.renderValidationDecorations=82]="renderValidationDecorations",B[B.renderWhitespace=83]="renderWhitespace",B[B.revealHorizontalRightPadding=84]="revealHorizontalRightPadding",B[B.roundedSelection=85]="roundedSelection",B[B.rulers=86]="rulers",B[B.scrollbar=87]="scrollbar",B[B.scrollBeyondLastColumn=88]="scrollBeyondLastColumn",B[B.scrollBeyondLastLine=89]="scrollBeyondLastLine",B[B.scrollPredominantAxis=90]="scrollPredominantAxis",B[B.selectionClipboard=91]="selectionClipboard",B[B.selectionHighlight=92]="selectionHighlight",B[B.selectOnLineNumbers=93]="selectOnLineNumbers",B[B.showFoldingControls=94]="showFoldingControls",B[B.showUnused=95]="showUnused",B[B.snippetSuggestions=96]="snippetSuggestions",B[B.smartSelect=97]="smartSelect",B[B.smoothScrolling=98]="smoothScrolling",B[B.stickyTabStops=99]="stickyTabStops",B[B.stopRenderingLineAfter=100]="stopRenderingLineAfter",B[B.suggest=101]="suggest",B[B.suggestFontSize=102]="suggestFontSize",B[B.suggestLineHeight=103]="suggestLineHeight",B[B.suggestOnTriggerCharacters=104]="suggestOnTriggerCharacters",B[B.suggestSelection=105]="suggestSelection",B[B.tabCompletion=106]="tabCompletion",B[B.tabIndex=107]="tabIndex",B[B.unusualLineTerminators=108]="unusualLineTerminators",B[B.useTabStops=109]="useTabStops",B[B.wordSeparators=110]="wordSeparators",B[B.wordWrap=111]="wordWrap",B[B.wordWrapBreakAfterCharacters=112]="wordWrapBreakAfterCharacters",B[B.wordWrapBreakBeforeCharacters=113]="wordWrapBreakBeforeCharacters",B[B.wordWrapColumn=114]="wordWrapColumn",B[B.wordWrapOverride1=115]="wordWrapOverride1",B[B.wordWrapOverride2=116]="wordWrapOverride2",B[B.wrappingIndent=117]="wrappingIndent",B[B.wrappingStrategy=118]="wrappingStrategy",B[B.showDeprecated=119]="showDeprecated",B[B.inlineHints=120]="inlineHints",B[B.editorClassName=121]="editorClassName",B[B.pixelRatio=122]="pixelRatio",B[B.tabFocusMode=123]="tabFocusMode",B[B.layoutInfo=124]="layoutInfo",B[B.wrappingInfo=125]="wrappingInfo"})(ze=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:pe(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(111,null)})),acceptSuggestionOnEnter:pe(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(112,null),""],markdownDescription:b.localize(113,null)})),accessibilitySupport:pe(new h),accessibilityPageSize:pe(new a(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(114,null)})),ariaLabel:pe(new p(4,"ariaLabel",b.localize(115,null))),autoClosingBrackets:pe(new c(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(116,null),b.localize(117,null),""],description:b.localize(118,null)})),autoClosingOvertype:pe(new c(6,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(119,null),""],description:b.localize(120,null)})),autoClosingQuotes:pe(new c(7,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(121,null),b.localize(122,null),""],description:b.localize(123,null)})),autoIndent:pe(new n(8,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[b.localize(124,null),b.localize(125,null),b.localize(126,null),b.localize(127,null),b.localize(128,null)],description:b.localize(129,null)})),automaticLayout:pe(new d(9,"automaticLayout",!1)),autoSurround:pe(new c(10,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(130,null),b.localize(131,null),b.localize(132,null),""],description:b.localize(133,null)})),stickyTabStops:pe(new d(99,"stickyTabStops",!1,{description:b.localize(134,null)})),codeLens:pe(new d(11,"codeLens",!0,{description:b.localize(135,null)})),codeLensFontFamily:pe(new p(12,"codeLensFontFamily","",{description:b.localize(136,null)})),codeLensFontSize:pe(new a(13,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:b.localize(137,null)})),colorDecorators:pe(new d(14,"colorDecorators",!0,{description:b.localize(138,null)})),columnSelection:pe(new d(15,"columnSelection",!1,{description:b.localize(139,null)})),comments:pe(new t),contextmenu:pe(new d(17,"contextmenu",!0)),copyWithSyntaxHighlighting:pe(new d(18,"copyWithSyntaxHighlighting",!0,{description:b.localize(140,null)})),cursorBlinking:pe(new n(19,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:b.localize(141,null)})),cursorSmoothCaretAnimation:pe(new d(20,"cursorSmoothCaretAnimation",!1,{description:b.localize(142,null)})),cursorStyle:pe(new n(21,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],g,{description:b.localize(143,null)})),cursorSurroundingLines:pe(new a(22,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(144,null)})),cursorSurroundingLinesStyle:pe(new c(23,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(145,null),b.localize(146,null)],description:b.localize(147,null)})),cursorWidth:pe(new a(24,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(148,null)})),disableLayerHinting:pe(new d(25,"disableLayerHinting",!1)),disableMonospaceOptimizations:pe(new d(26,"disableMonospaceOptimizations",!1)),dragAndDrop:pe(new d(27,"dragAndDrop",!0,{description:b.localize(149,null)})),emptySelectionClipboard:pe(new _),extraEditorClassName:pe(new p(29,"extraEditorClassName","")),fastScrollSensitivity:pe(new m(30,"fastScrollSensitivity",5,B=>B<=0?5:B,{markdownDescription:b.localize(150,null)})),find:pe(new D),fixedOverflowWidgets:pe(new d(32,"fixedOverflowWidgets",!1)),folding:pe(new d(33,"folding",!0,{description:b.localize(151,null)})),foldingStrategy:pe(new c(34,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(152,null),b.localize(153,null)],description:b.localize(154,null)})),foldingHighlight:pe(new d(35,"foldingHighlight",!0,{description:b.localize(155,null)})),unfoldOnClickAfterEndOfLine:pe(new d(36,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(156,null)})),fontFamily:pe(new p(37,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(157,null)})),fontInfo:pe(new O),fontLigatures2:pe(new w),fontSize:pe(new R),fontWeight:pe(new $),formatOnPaste:pe(new d(42,"formatOnPaste",!1,{description:b.localize(158,null)})),formatOnType:pe(new d(43,"formatOnType",!1,{description:b.localize(159,null)})),glyphMargin:pe(new d(44,"glyphMargin",!0,{description:b.localize(160,null)})),gotoLocation:pe(new V),hideCursorInOverviewRuler:pe(new d(46,"hideCursorInOverviewRuler",!1,{description:b.localize(161,null)})),highlightActiveIndentGuide:pe(new d(47,"highlightActiveIndentGuide",!0,{description:b.localize(162,null)})),hover:pe(new z),inDiffEditor:pe(new d(49,"inDiffEditor",!1)),letterSpacing:pe(new m(50,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,B=>m.clamp(B,-5,20),{description:b.localize(163,null)})),lightbulb:pe(new M),lineDecorationsWidth:pe(new S(52,"lineDecorationsWidth",10)),lineHeight:pe(new re),lineNumbers:pe(new Se),lineNumbersMinChars:pe(new a(55,"lineNumbersMinChars",5,1,300)),linkedEditing:pe(new d(56,"linkedEditing",!1,{description:b.localize(164,null)})),links:pe(new d(57,"links",!0,{description:b.localize(165,null)})),matchBrackets:pe(new c(58,"matchBrackets","always",["always","near","never"],{description:b.localize(166,null)})),minimap:pe(new F),mouseStyle:pe(new c(60,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:pe(new m(61,"mouseWheelScrollSensitivity",1,B=>B===0?1:B,{markdownDescription:b.localize(167,null)})),mouseWheelZoom:pe(new d(62,"mouseWheelZoom",!1,{markdownDescription:b.localize(168,null)})),multiCursorMergeOverlapping:pe(new d(63,"multiCursorMergeOverlapping",!0,{description:b.localize(169,null)})),multiCursorModifier:pe(new n(64,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],te,{markdownEnumDescriptions:[b.localize(170,null),b.localize(171,null)],markdownDescription:b.localize(172,null)})),multiCursorPaste:pe(new c(65,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(173,null),b.localize(174,null)],markdownDescription:b.localize(175,null)})),occurrencesHighlight:pe(new d(66,"occurrencesHighlight",!0,{description:b.localize(176,null)})),overviewRulerBorder:pe(new d(67,"overviewRulerBorder",!0,{description:b.localize(177,null)})),overviewRulerLanes:pe(new a(68,"overviewRulerLanes",3,0,3)),padding:pe(new ae),parameterHints:pe(new ue),peekWidgetDefaultFocus:pe(new c(71,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(178,null),b.localize(179,null)],description:b.localize(180,null)})),definitionLinkOpensInPeek:pe(new d(72,"definitionLinkOpensInPeek",!1,{description:b.localize(181,null)})),quickSuggestions:pe(new fe),quickSuggestionsDelay:pe(new a(74,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(182,null)})),readOnly:pe(new d(75,"readOnly",!1)),renameOnType:pe(new d(76,"renameOnType",!1,{description:b.localize(183,null),markdownDeprecationMessage:b.localize(184,null)})),renderControlCharacters:pe(new d(77,"renderControlCharacters",!1,{description:b.localize(185,null)})),renderIndentGuides:pe(new d(78,"renderIndentGuides",!0,{description:b.localize(186,null)})),renderFinalNewline:pe(new d(79,"renderFinalNewline",!0,{description:b.localize(187,null)})),renderLineHighlight:pe(new c(80,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(188,null)],description:b.localize(189,null)})),renderLineHighlightOnlyWhenFocus:pe(new d(81,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(190,null)})),renderValidationDecorations:pe(new c(82,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:pe(new c(83,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(191,null),b.localize(192,null),b.localize(193,null),""],description:b.localize(194,null)})),revealHorizontalRightPadding:pe(new a(84,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:pe(new d(85,"roundedSelection",!0,{description:b.localize(195,null)})),rulers:pe(new x),scrollbar:pe(new ee),scrollBeyondLastColumn:pe(new a(88,"scrollBeyondLastColumn",5,0,1073741824,{description:b.localize(196,null)})),scrollBeyondLastLine:pe(new d(89,"scrollBeyondLastLine",!0,{description:b.localize(197,null)})),scrollPredominantAxis:pe(new d(90,"scrollPredominantAxis",!0,{description:b.localize(198,null)})),selectionClipboard:pe(new d(91,"selectionClipboard",!0,{description:b.localize(199,null),included:y.isLinux})),selectionHighlight:pe(new d(92,"selectionHighlight",!0,{description:b.localize(200,null)})),selectOnLineNumbers:pe(new d(93,"selectOnLineNumbers",!0)),showFoldingControls:pe(new c(94,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[b.localize(201,null),b.localize(202,null)],description:b.localize(203,null)})),showUnused:pe(new d(95,"showUnused",!0,{description:b.localize(204,null)})),showDeprecated:pe(new d(119,"showDeprecated",!0,{description:b.localize(205,null)})),inlineHints:pe(new j),snippetSuggestions:pe(new c(96,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(206,null),b.localize(207,null),b.localize(208,null),b.localize(209,null)],description:b.localize(210,null)})),smartSelect:pe(new de),smoothScrolling:pe(new d(98,"smoothScrolling",!1,{description:b.localize(211,null)})),stopRenderingLineAfter:pe(new a(100,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:pe(new ne),suggestFontSize:pe(new a(102,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(212,null)})),suggestLineHeight:pe(new a(103,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(213,null)})),suggestOnTriggerCharacters:pe(new d(104,"suggestOnTriggerCharacters",!0,{description:b.localize(214,null)})),suggestSelection:pe(new c(105,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(215,null),b.localize(216,null),b.localize(217,null)],description:b.localize(218,null)})),tabCompletion:pe(new c(106,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(219,null),b.localize(220,null),b.localize(221,null)],description:b.localize(222,null)})),tabIndex:pe(new a(107,"tabIndex",0,-1,1073741824)),unusualLineTerminators:pe(new c(108,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(223,null),b.localize(224,null),b.localize(225,null)],description:b.localize(226,null)})),useTabStops:pe(new d(109,"useTabStops",!0,{description:b.localize(227,null)})),wordSeparators:pe(new p(110,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:b.localize(228,null)})),wordWrap:pe(new c(111,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(229,null),b.localize(230,null),b.localize(231,null),b.localize(232,null)],description:b.localize(233,null)})),wordWrapBreakAfterCharacters:pe(new p(112,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:pe(new p(113,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:pe(new a(114,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(234,null)})),wordWrapOverride1:pe(new c(115,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:pe(new c(116,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:pe(new n(117,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],xe,{enumDescriptions:[b.localize(235,null),b.localize(236,null),b.localize(237,null),b.localize(238,null)],description:b.localize(239,null)})),wrappingStrategy:pe(new c(118,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[b.localize(240,null),b.localize(241,null)],description:b.localize(242,null)})),editorClassName:pe(new C),pixelRatio:pe(new we),tabFocusMode:pe(new Ee),layoutInfo:pe(new q),wrappingInfo:pe(new be)}}),define(ve[119],_e([18,19]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[120],_e([18,19]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(ve[121],_e([18,19]),function(se,e){return se.create("vs/platform/markers/common/markers",e)}),define(ve[122],_e([18,19]),function(se,e){return se.create("vs/platform/theme/common/iconRegistry",e)}),define(ve[123],_e([18,19]),function(se,e){return se.create("vs/platform/workspaces/common/workspaces",e)}),define(ve[124],_e([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ve[125],_e([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[126],_e([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(ve[127],_e([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[128],_e([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[129],_e([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[130],_e([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[131],_e([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[132],_e([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[133],_e([18,19]),function(se,e){return se.create("vs/workbench/common/views",e)}),define(ve[134],_e([18,19]),function(se,e){return se.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[135],_e([18,19]),function(se,e){return se.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ve[136],_e([18,19]),function(se,e){return se.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[87],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class b{constructor(T,E=[],k=!1){this.ctor=T,this.staticArguments=E,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=b;const y=(A,...T)=>new b(A,T);e.createSyncDescriptor=y}),define(ve[62],_e([0,1,87]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const y=[];function A(E,k,I){y.push([E,new b.SyncDescriptor(k,[],I)])}e.registerSingleton=A;function T(){return y}e.getSingletonServiceDescriptors=T}),define(ve[137],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class b{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=b;class y{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let E of this._nodes.values())E.outgoing.size===0&&T.push(E);return T}insertEdge(T,E){const k=this.lookupOrInsertNode(T),I=this.lookupOrInsertNode(E);k.outgoing.set(this._hashFn(E),I),I.incoming.set(this._hashFn(T),k)}removeNode(T){const E=this._hashFn(T);this._nodes.delete(E);for(let k of this._nodes.values())k.outgoing.delete(E),k.incoming.delete(E)}lookupOrInsertNode(T){const E=this._hashFn(T);let k=this._nodes.get(E);return k||(k=new b(T),this._nodes.set(E,k)),k}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[E,k]of this._nodes)T.push(`${E}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return T.join(`
`)}}e.Graph=y}),define(ve[4],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.createDecorator=e.IInstantiationService=e._util=void 0;var b;(function(E){E.serviceIds=new Map,E.DI_TARGET="$di$target",E.DI_DEPENDENCIES="$di$dependencies";function k(I){return I[E.DI_DEPENDENCIES]||[]}E.getServiceDependencies=k})(b=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function y(E,k,I,i){k[b.DI_TARGET]===k?k[b.DI_DEPENDENCIES].push({id:E,index:I,optional:i}):(k[b.DI_DEPENDENCIES]=[{id:E,index:I,optional:i}],k[b.DI_TARGET]=k)}function A(E){if(b.serviceIds.has(E))return b.serviceIds.get(E);const k=function(I,i,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");y(k,I,P,!1)};return k.toString=()=>E,b.serviceIds.set(E,k),k}e.createDecorator=A;function T(E){return function(k,I,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");y(E,k,i,!0)}}e.optional=T}),define(ve[138],_e([0,1,4]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=b.createDecorator("modelService");function y(A){return!A.isTooLargeForSyncing()&&!A.isForSimpleWidget}e.shouldSynchronizeModel=y}),define(ve[139],_e([0,1,3,56,6,22,79,60,138]),function(se,e,b,y,A,T,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function i(v){return typeof v=="string"?!1:Array.isArray(v)?v.every(i):!!v.exclusive}class P{constructor(){this._clock=0,this._entries=[],this._onDidChange=new b.Emitter}get onDidChange(){return this._onDidChange.event}register(d,a){let m={selector:d,provider:a,_score:-1,_time:this._clock++};return this._entries.push(m),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),A.toDisposable(()=>{if(m){let p=this._entries.indexOf(m);p>=0&&(this._entries.splice(p,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),m=void 0)}})}has(d){return this.all(d).length>0}all(d){if(!d)return[];this._updateScores(d);const a=[];for(let m of this._entries)m._score>0&&a.push(m.provider);return a}ordered(d){const a=[];return this._orderedForEach(d,m=>a.push(m.provider)),a}orderedGroups(d){const a=[];let m,p;return this._orderedForEach(d,f=>{m&&p===f._score?m.push(f.provider):(p=f._score,m=[f.provider],a.push(m))}),a}_orderedForEach(d,a){if(!!d){this._updateScores(d);for(const m of this._entries)m._score>0&&a(m)}}_updateScores(d){let a={uri:d.uri.toString(),language:d.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let m of this._entries)if(m._score=k.score(m.selector,d.uri,d.getLanguageIdentifier().language,I.shouldSynchronizeModel(d)),i(m.selector)&&m._score>0){for(let p of this._entries)p._score=0;m._score=1e3;break}this._entries.sort(P._compareByScoreAndTime)}}static _compareByScoreAndTime(d,a){return d._score<a._score?1:d._score>a._score?-1:d._time<a._time?1:d._time>a._time?-1:0}}e.LanguageFeatureRegistry=P;class S{constructor(d,a,m=Number.MAX_SAFE_INTEGER){this._registry=d,this.min=a,this.max=m,this._cache=new T.LRUCache(50,.7)}_key(d){return d.id+y.hash(this._registry.all(d))}_clamp(d){return d===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(d*1.3)))}get(d){const a=this._key(d),m=this._cache.get(a);return this._clamp(m==null?void 0:m.value)}update(d,a){const m=this._key(d);let p=this._cache.get(m);return p||(p=new E.MovingAverage,this._cache.set(m,p)),p.update(a),this.get(d)}}e.LanguageFeatureRequestDelays=S}),define(ve[63],_e([0,1,2,32,139,114,46]),function(se,e,b,y,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var k;(function(_){_[_.Null=0]="Null",_[_.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));class I{constructor(D,w){this.language=D,this.id=w}}e.LanguageIdentifier=I;var i;(function(_){_[_.NotSet=-1]="NotSet",_[_.None=0]="None",_[_.Italic=1]="Italic",_[_.Bold=2]="Bold",_[_.Underline=4]="Underline"})(i=e.FontStyle||(e.FontStyle={}));var P;(function(_){_[_.None=0]="None",_[_.DefaultForeground=1]="DefaultForeground",_[_.DefaultBackground=2]="DefaultBackground"})(P=e.ColorId||(e.ColorId={}));var S;(function(_){_[_.Other=0]="Other",_[_.Comment=1]="Comment",_[_.String=2]="String",_[_.RegEx=4]="RegEx"})(S=e.StandardTokenType||(e.StandardTokenType={}));var v;(function(_){_[_.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",_[_.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",_[_.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",_[_.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",_[_.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",_[_.ITALIC_MASK=2048]="ITALIC_MASK",_[_.BOLD_MASK=4096]="BOLD_MASK",_[_.UNDERLINE_MASK=8192]="UNDERLINE_MASK",_[_.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",_[_.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",_[_.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",_[_.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",_[_.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",_[_.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",_[_.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",_[_.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",_[_.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",_[_.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(v=e.MetadataConsts||(e.MetadataConsts={}));class d{static getLanguageId(D){return(D&255)>>>0}static getTokenType(D){return(D&1792)>>>8}static getFontStyle(D){return(D&14336)>>>11}static getForeground(D){return(D&8372224)>>>14}static getBackground(D){return(D&4286578688)>>>23}static getClassNameFromMetadata(D){let w=this.getForeground(D),O="mtk"+w,R=this.getFontStyle(D);return R&1&&(O+=" mtki"),R&2&&(O+=" mtkb"),R&4&&(O+=" mtku"),O}static getInlineStyleFromMetadata(D,w){const O=this.getForeground(D),R=this.getFontStyle(D);let $=`color: ${w[O]};`;return R&1&&($+="font-style: italic;"),R&2&&($+="font-weight: bold;"),R&4&&($+="text-decoration: underline;"),$}}e.TokenMetadata=d;var a;(function(_){_[_.Method=0]="Method",_[_.Function=1]="Function",_[_.Constructor=2]="Constructor",_[_.Field=3]="Field",_[_.Variable=4]="Variable",_[_.Class=5]="Class",_[_.Struct=6]="Struct",_[_.Interface=7]="Interface",_[_.Module=8]="Module",_[_.Property=9]="Property",_[_.Event=10]="Event",_[_.Operator=11]="Operator",_[_.Unit=12]="Unit",_[_.Value=13]="Value",_[_.Constant=14]="Constant",_[_.Enum=15]="Enum",_[_.EnumMember=16]="EnumMember",_[_.Keyword=17]="Keyword",_[_.Text=18]="Text",_[_.Color=19]="Color",_[_.File=20]="File",_[_.Reference=21]="Reference",_[_.Customcolor=22]="Customcolor",_[_.Folder=23]="Folder",_[_.TypeParameter=24]="TypeParameter",_[_.User=25]="User",_[_.Issue=26]="Issue",_[_.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let _=Object.create(null);return _[0]="symbol-method",_[1]="symbol-function",_[2]="symbol-constructor",_[3]="symbol-field",_[4]="symbol-variable",_[5]="symbol-class",_[6]="symbol-struct",_[7]="symbol-interface",_[8]="symbol-module",_[9]="symbol-property",_[10]="symbol-event",_[11]="symbol-operator",_[12]="symbol-unit",_[13]="symbol-value",_[14]="symbol-constant",_[15]="symbol-enum",_[16]="symbol-enum-member",_[17]="symbol-keyword",_[27]="symbol-snippet",_[18]="symbol-text",_[19]="symbol-color",_[20]="symbol-file",_[21]="symbol-reference",_[22]="symbol-customcolor",_[23]="symbol-folder",_[24]="symbol-type-parameter",_[25]="account",_[26]="issues",function(D){const w=_[D];let O=w&&E.iconRegistry.get(w);return O||(console.info("No codicon found for CompletionItemKind "+D),O=E.Codicon.symbolProperty),O.classNames}}(),e.completionKindFromString=function(){let _=Object.create(null);return _.method=0,_.function=1,_.constructor=2,_.field=3,_.variable=4,_.class=5,_.struct=6,_.interface=7,_.module=8,_.property=9,_.event=10,_.operator=11,_.unit=12,_.value=13,_.constant=14,_.enum=15,_["enum-member"]=16,_.enumMember=16,_.keyword=17,_.snippet=27,_.text=18,_.color=19,_.file=20,_.reference=21,_.customcolor=22,_.folder=23,_["type-parameter"]=24,_.typeParameter=24,_.account=25,_.issue=26,function(D,w){let O=_[D];return typeof O=="undefined"&&!w&&(O=9),O}}();var m;(function(_){_[_.Deprecated=1]="Deprecated"})(m=e.CompletionItemTag||(e.CompletionItemTag={}));var p;(function(_){_[_.KeepWhitespace=1]="KeepWhitespace",_[_.InsertAsSnippet=4]="InsertAsSnippet"})(p=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var f;(function(_){_[_.Invoke=0]="Invoke",_[_.TriggerCharacter=1]="TriggerCharacter",_[_.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var c;(function(_){_[_.Auto=1]="Auto",_[_.Manual=2]="Manual"})(c=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var n;(function(_){_[_.Invoke=1]="Invoke",_[_.TriggerCharacter=2]="TriggerCharacter",_[_.ContentChange=3]="ContentChange"})(n=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var o;(function(_){_[_.Text=0]="Text",_[_.Read=1]="Read",_[_.Write=2]="Write"})(o=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function h(_){return _&&b.URI.isUri(_.uri)&&y.Range.isIRange(_.range)&&(y.Range.isIRange(_.originSelectionRange)||y.Range.isIRange(_.targetSelectionRange))}e.isLocationLink=h;var t;(function(_){_[_.File=0]="File",_[_.Module=1]="Module",_[_.Namespace=2]="Namespace",_[_.Package=3]="Package",_[_.Class=4]="Class",_[_.Method=5]="Method",_[_.Property=6]="Property",_[_.Field=7]="Field",_[_.Constructor=8]="Constructor",_[_.Enum=9]="Enum",_[_.Interface=10]="Interface",_[_.Function=11]="Function",_[_.Variable=12]="Variable",_[_.Constant=13]="Constant",_[_.String=14]="String",_[_.Number=15]="Number",_[_.Boolean=16]="Boolean",_[_.Array=17]="Array",_[_.Object=18]="Object",_[_.Key=19]="Key",_[_.Null=20]="Null",_[_.EnumMember=21]="EnumMember",_[_.Struct=22]="Struct",_[_.Event=23]="Event",_[_.Operator=24]="Operator",_[_.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var s;(function(_){_[_.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var l;(function(_){const D=new Map;D.set("file",0),D.set("module",1),D.set("namespace",2),D.set("package",3),D.set("class",4),D.set("method",5),D.set("property",6),D.set("field",7),D.set("constructor",8),D.set("enum",9),D.set("interface",10),D.set("function",11),D.set("variable",12),D.set("constant",13),D.set("string",14),D.set("number",15),D.set("boolean",16),D.set("array",17),D.set("object",18),D.set("key",19),D.set("null",20),D.set("enum-member",21),D.set("struct",22),D.set("event",23),D.set("operator",24),D.set("type-parameter",25);const w=new Map;w.set(0,"file"),w.set(1,"module"),w.set(2,"namespace"),w.set(3,"package"),w.set(4,"class"),w.set(5,"method"),w.set(6,"property"),w.set(7,"field"),w.set(8,"constructor"),w.set(9,"enum"),w.set(10,"interface"),w.set(11,"function"),w.set(12,"variable"),w.set(13,"constant"),w.set(14,"string"),w.set(15,"number"),w.set(16,"boolean"),w.set(17,"array"),w.set(18,"object"),w.set(19,"key"),w.set(20,"null"),w.set(21,"enum-member"),w.set(22,"struct"),w.set(23,"event"),w.set(24,"operator"),w.set(25,"type-parameter");function O(V){return D.get(V)}_.fromString=O;function R(V){return w.get(V)}_.toString=R;function $(V,z){const U=w.get(V);let q=U&&E.iconRegistry.get("symbol-"+U);return q||(console.info("No codicon found for SymbolKind "+V),q=E.Codicon.symbolProperty),`${z?"inline":"block"} ${q.classNames}`}_.toCssClassName=$})(l=e.SymbolKinds||(e.SymbolKinds={}));class u{constructor(D){this.value=D}}e.FoldingRangeKind=u,u.Comment=new u("comment"),u.Imports=new u("imports"),u.Region=new u("region");var r;(function(_){_[_.Collapsed=0]="Collapsed",_[_.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var g;(function(_){_[_.Editing=0]="Editing",_[_.Preview=1]="Preview"})(g=e.CommentMode||(e.CommentMode={})),e.ReferenceProviderRegistry=new A.LanguageFeatureRegistry,e.RenameProviderRegistry=new A.LanguageFeatureRegistry,e.CompletionProviderRegistry=new A.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new A.LanguageFeatureRegistry,e.HoverProviderRegistry=new A.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new A.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new A.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new A.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new A.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new A.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.LinkProviderRegistry=new A.LanguageFeatureRegistry,e.ColorProviderRegistry=new A.LanguageFeatureRegistry,e.SelectionRangeRegistry=new A.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var C;(function(_){_[_.None=0]="None",_[_.Option=1]="Option",_[_.Default=2]="Default",_[_.Preferred=3]="Preferred"})(C=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[140],_e([0,1,6,12,4,3,54,53]),function(se,e,b,y,A,T,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=A.createDecorator("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(I,i){if(!I)throw new Error("invalid command");if(typeof I=="string"){if(!i)throw new Error("invalid command");return this.registerCommand({id:I,handler:i})}if(I.description){const a=[];for(let p of I.description.args)a.push(p.constraint);const m=I.handler;I.handler=function(p,...f){return y.validateConstraints(f,a),m(p,...f)}}const{id:P}=I;let S=this._commands.get(P);S||(S=new E.LinkedList,this._commands.set(P,S));let v=S.unshift(I),d=b.toDisposable(()=>{v();const a=this._commands.get(P);(a==null?void 0:a.isEmpty())&&this._commands.delete(P)});return this._onDidRegisterCommand.fire(P),d}registerCommandAlias(I,i){return e.CommandsRegistry.registerCommand(I,(P,...S)=>P.get(e.ICommandService).executeCommand(i,...S))}getCommand(I){const i=this._commands.get(I);if(!(!i||i.isEmpty()))return k.Iterable.first(i)}getCommands(){const I=new Map;for(const i of this._commands.keys()){const P=this.getCommand(i);P&&I.set(i,P)}return I}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>b.Disposable.None,onDidExecuteCommand:()=>b.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(ve[64],_e([0,1,8,4,21]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=A.userAgent||"";const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",A.isMacintosh),E.set("isLinux",A.isLinux),E.set("isWindows",A.isWindows),E.set("isWeb",A.isWeb),E.set("isMacNative",A.isMacintosh&&!A.isWeb),E.set("isEdge",T.indexOf("Edg/")>=0),E.set("isFirefox",T.indexOf("Firefox")>=0),E.set("isChrome",T.indexOf("Chrome")>=0),E.set("isSafari",T.indexOf("Safari")>=0),E.set("isIPad",T.indexOf("iPad")>=0);const k=Object.prototype.hasOwnProperty;var I;(function(D){D[D.False=0]="False",D[D.True=1]="True",D[D.Defined=2]="Defined",D[D.Not=3]="Not",D[D.Equals=4]="Equals",D[D.NotEquals=5]="NotEquals",D[D.And=6]="And",D[D.Regex=7]="Regex",D[D.NotRegex=8]="NotRegex",D[D.Or=9]="Or",D[D.In=10]="In",D[D.NotIn=11]="NotIn",D[D.Greater=12]="Greater",D[D.GreaterEquals=13]="GreaterEquals",D[D.Smaller=14]="Smaller",D[D.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class i{static false(){return S.INSTANCE}static true(){return v.INSTANCE}static has(w){return d.create(w)}static equals(w,O){return a.create(w,O)}static notEquals(w,O){return f.create(w,O)}static regex(w,O){return s.create(w,O)}static in(w,O){return m.create(w,O)}static not(w){return c.create(w)}static and(...w){return u.create(w)}static or(...w){return r.create(w)}static greater(w,O){return n.create(w,O)}static less(w,O){return h.create(w,O)}static deserialize(w,O=!1){if(!!w)return this._deserializeOrExpression(w,O)}static _deserializeOrExpression(w,O){let R=w.split("||");return r.create(R.map($=>this._deserializeAndExpression($,O)))}static _deserializeAndExpression(w,O){let R=w.split("&&");return u.create(R.map($=>this._deserializeOne($,O)))}static _deserializeOne(w,O){if(w=w.trim(),w.indexOf("!=")>=0){let R=w.split("!=");return f.create(R[0].trim(),this._deserializeValue(R[1],O))}if(w.indexOf("==")>=0){let R=w.split("==");return a.create(R[0].trim(),this._deserializeValue(R[1],O))}if(w.indexOf("=~")>=0){let R=w.split("=~");return s.create(R[0].trim(),this._deserializeRegexValue(R[1],O))}if(w.indexOf(" in ")>=0){let R=w.split(" in ");return m.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(w)){const R=w.split(">=");return o.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(w)){const R=w.split(">");return n.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(w)){const R=w.split("<=");return t.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(w)){const R=w.split("<");return h.create(R[0].trim(),R[1].trim())}return/^\!\s*/.test(w)?c.create(w.substr(1).trim()):d.create(w)}static _deserializeValue(w,O){if(w=w.trim(),w==="true")return!0;if(w==="false")return!1;let R=/^'([^']*)'$/.exec(w);return R?R[1].trim():w}static _deserializeRegexValue(w,O){if(b.isFalsyOrWhitespace(w)){if(O)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let R=w.indexOf("/"),$=w.lastIndexOf("/");if(R===$||R<0){if(O)throw new Error(`bad regexp-value '${w}', missing /-enclosure`);return console.warn(`bad regexp-value '${w}', missing /-enclosure`),null}let V=w.slice(R+1,$),z=w[$+1]==="i"?"i":"";try{return new RegExp(V,z)}catch(U){if(O)throw new Error(`bad regexp-value '${w}', parse error: ${U}`);return console.warn(`bad regexp-value '${w}', parse error: ${U}`),null}}}e.ContextKeyExpr=i;function P(D,w){return D.cmp(w)}class S{constructor(){this.type=0}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=S,S.INSTANCE=new S;class v{constructor(){this.type=1}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return S.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class d{constructor(w){this.key=w,this.type=2}static create(w){const O=E.get(w);return typeof O=="boolean"?O?v.INSTANCE:S.INSTANCE:new d(w)}cmp(w){return w.type!==this.type?this.type-w.type:C(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return c.create(this.key)}}e.ContextKeyDefinedExpr=d;class a{constructor(w,O){this.key=w,this.value=O,this.type=4}static create(w,O){if(typeof O=="boolean")return O?d.create(w):c.create(w);const R=E.get(w);return typeof R=="boolean"?O===(R?"true":"false")?v.INSTANCE:S.INSTANCE:new a(w,O)}cmp(w){return w.type!==this.type?this.type-w.type:_(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class m{constructor(w,O){this.key=w,this.valueKey=O,this.type=10}static create(w,O){return new m(w,O)}cmp(w){return w.type!==this.type?this.type-w.type:_(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}evaluate(w){const O=w.getValue(this.valueKey),R=w.getValue(this.key);return Array.isArray(O)?O.indexOf(R)>=0:typeof R=="string"&&typeof O=="object"&&O!==null?k.call(O,R):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return p.create(this)}}e.ContextKeyInExpr=m;class p{constructor(w){this._actual=w,this.type=11}static create(w){return new p(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new p(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class f{constructor(w,O){this.key=w,this.value=O,this.type=5}static create(w,O){if(typeof O=="boolean")return O?c.create(w):d.create(w);const R=E.get(w);return typeof R=="boolean"?O===(R?"true":"false")?S.INSTANCE:v.INSTANCE:new f(w,O)}cmp(w){return w.type!==this.type?this.type-w.type:_(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=f;class c{constructor(w){this.key=w,this.type=3}static create(w){const O=E.get(w);return typeof O=="boolean"?O?S.INSTANCE:v.INSTANCE:new c(w)}cmp(w){return w.type!==this.type?this.type-w.type:C(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return d.create(this.key)}}e.ContextKeyNotExpr=c;class n{constructor(w,O){this.key=w,this.value=O,this.type=12}static create(w,O){return new n(w,O)}cmp(w){return w.type!==this.type?this.type-w.type:_(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=n;class o{constructor(w,O){this.key=w,this.value=O,this.type=13}static create(w,O){return new o(w,O)}cmp(w){return w.type!==this.type?this.type-w.type:_(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=o;class h{constructor(w,O){this.key=w,this.value=O,this.type=14}static create(w,O){return new h(w,O)}cmp(w){return w.type!==this.type?this.type-w.type:_(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeySmallerExpr=h;class t{constructor(w,O){this.key=w,this.value=O,this.type=15}static create(w,O){return new t(w,O)}cmp(w){return w.type!==this.type?this.type-w.type:_(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return n.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class s{constructor(w,O){this.key=w,this.regexp=O,this.type=7}static create(w,O){return new s(w,O)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const O=this.regexp?this.regexp.source:"",R=w.regexp?w.regexp.source:"";return O<R?-1:O>R?1:0}equals(w){if(w.type===this.type){const O=this.regexp?this.regexp.source:"",R=w.regexp?w.regexp.source:"";return this.key===w.key&&O===R}return!1}evaluate(w){let O=w.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return l.create(this)}}e.ContextKeyRegexExpr=s;class l{constructor(w){this._actual=w,this.type=8}static create(w){return new l(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new l(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=l;class u{constructor(w){this.expr=w,this.type=6}static create(w){return u._normalizeArr(w)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let O=0,R=this.expr.length;O<R;O++){const $=P(this.expr[O],w.expr[O]);if($!==0)return $}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let O=0,R=this.expr.length;O<R;O++)if(!this.expr[O].equals(w.expr[O]))return!1;return!0}return!1}evaluate(w){for(let O=0,R=this.expr.length;O<R;O++)if(!this.expr[O].evaluate(w))return!1;return!0}static _normalizeArr(w){const O=[];let R=!1;for(const $ of w)if(!!$){if($.type===1){R=!0;continue}if($.type===0)return S.INSTANCE;if($.type===6){O.push(...$.expr);continue}O.push($)}if(O.length===0&&R)return v.INSTANCE;if(O.length!==0){if(O.length===1)return O[0];for(O.sort(P);O.length>1;){const $=O[O.length-1];if($.type!==9)break;O.pop();const V=O.pop(),z=r.create($.expr.map(U=>u.create([U,V])));z&&(O.push(z),O.sort(P))}return O.length===1?O[0]:new u(O)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(let O of this.expr)w.push(...O.keys());return w}map(w){return new u(this.expr.map(O=>O.map(w)))}negate(){let w=[];for(let O of this.expr)w.push(O.negate());return r.create(w)}}e.ContextKeyAndExpr=u;class r{constructor(w){this.expr=w,this.type=9}static create(w){const O=r._normalizeArr(w);if(O.length!==0)return O.length===1?O[0]:new r(O)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let O=0,R=this.expr.length;O<R;O++){const $=P(this.expr[O],w.expr[O]);if($!==0)return $}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let O=0,R=this.expr.length;O<R;O++)if(!this.expr[O].equals(w.expr[O]))return!1;return!0}return!1}evaluate(w){for(let O=0,R=this.expr.length;O<R;O++)if(this.expr[O].evaluate(w))return!0;return!1}static _normalizeArr(w){let O=[],R=!1;if(w){for(let $=0,V=w.length;$<V;$++){const z=w[$];if(!!z){if(z.type===0){R=!0;continue}if(z.type===1)return[v.INSTANCE];if(z.type===9){O=O.concat(z.expr);continue}O.push(z)}}if(O.length===0&&R)return[S.INSTANCE];O.sort(P)}return O}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(let O of this.expr)w.push(...O.keys());return w}map(w){return new r(this.expr.map(O=>O.map(w)))}negate(){let w=[];for(let R of this.expr)w.push(R.negate());const O=R=>R.type===9?R.expr:[R];for(;w.length>1;){const R=w.shift(),$=w.shift(),V=[];for(const z of O(R))for(const U of O($))V.push(i.and(z,U));w.unshift(i.or(...V))}return w[0]}}e.ContextKeyOrExpr=r;class g extends d{constructor(w,O){super(w);this._defaultValue=O}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return i.not(this.key)}isEqualTo(w){return i.equals(this.key,w)}notEqualsTo(w){return i.notEquals(this.key,w)}}e.RawContextKey=g,e.IContextKeyService=y.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function C(D,w){return D<w?-1:D>w?1:0}function _(D,w,O,R){return D<O?-1:D>O?1:w<R?-1:w>R?1:0}}),define(ve[141],_e([0,1,4]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=b.createDecorator("environmentService"),e.INativeEnvironmentService=b.createDecorator("nativeEnvironmentService")}),define(ve[25],_e([0,1,8,4]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Themes","Testing","Visualization","Other"];var T;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class E{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,S){if(typeof P=="undefined"||P===null)return typeof S=="undefined"||S===null;if(typeof S=="undefined"||S===null)return!1;if(typeof P=="string"||typeof S=="string"){let v=typeof P=="string"?P:P.value,d=typeof S=="string"?S:S.value;return b.equalsIgnoreCase(v,d)}return P._lower===S._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=E;function k(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function I(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=I,e.IBuiltinExtensionsScannerService=y.createDecorator("IBuiltinExtensionsScannerService")}),define(ve[142],_e([0,1,8,25]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(d,a){return d.uuid&&a.uuid?d.uuid===a.uuid:d.id===a.id?!0:b.compareIgnoreCase(d.id,a.id)===0}e.areSameExtensions=A;class T{constructor(a,m){this.version=m,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof T?A(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=T;function E(d,a){return`${d}.${a}`}e.getExtensionId=E;function k(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function I(d,a){return k(E(d,a))}e.getGalleryExtensionId=I;function i(d,a){const m=[],p=f=>{for(const c of m)if(c.some(n=>A(a(n),a(f))))return c;return null};for(const f of d){const c=p(f);c?c.push(f):m.push([f])}return m}e.groupByExtension=i;function P(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=P;function S(d){return Object.assign({id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0)},d.telemetryData)}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function v(d){const a=new Set;for(const m of d)m.malicious&&a.add(m.id.id);return a}e.getMaliciousExtensionsSet=v}),define(ve[65],_e([0,1,120,10,2,4,8,12,22]),function(se,e,b,y,A,T,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.IFileService=void 0,e.IFileService=T.createDecorator("fileService");var i;(function(R){R[R.Unknown=0]="Unknown",R[R.File=1]="File",R[R.Directory=2]="Directory",R[R.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var P;(function(R){R[R.FileReadWrite=2]="FileReadWrite",R[R.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",R[R.FileReadStream=16]="FileReadStream",R[R.FileFolderCopy=8]="FileFolderCopy",R[R.PathCaseSensitive=1024]="PathCaseSensitive",R[R.Readonly=2048]="Readonly",R[R.Trash=4096]="Trash"})(P=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function S(R){return!!(R.capabilities&2)}e.hasReadWriteCapability=S;function v(R){return!!(R.capabilities&8)}e.hasFileFolderCopyCapability=v;function d(R){return!!(R.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function a(R){return!!(R.capabilities&16)}e.hasFileReadStreamCapability=a;var m;(function(R){R.FileExists="EntryExists",R.FileNotFound="EntryNotFound",R.FileNotADirectory="EntryNotADirectory",R.FileIsADirectory="EntryIsADirectory",R.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",R.FileTooLarge="EntryTooLarge",R.NoPermissions="NoPermissions",R.Unavailable="Unavailable",R.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor($,V){super($);this.code=V}}e.FileSystemProviderError=p;function f(R,$){const V=new p(R.toString(),$);return n(V,$),V}e.createFileSystemProviderError=f;function c(R){return R||f(b.localize(0,null),m.Unknown)}e.ensureFileSystemProviderError=c;function n(R,$){return R.name=$?`${$} (FileSystemError)`:"FileSystemError",R}e.markAsFileSystemProviderError=n;function o(R){if(!R)return m.Unknown;if(R instanceof p)return R.code;const $=/^(.+) \(FileSystemError\)$/.exec(R.name);if(!$)return m.Unknown;switch($[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=o;function h(R){if(R instanceof g)return R.fileOperationResult;switch(o(R)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=h;var t;(function(R){R[R.CREATE=0]="CREATE",R[R.DELETE=1]="DELETE",R[R.MOVE=2]="MOVE",R[R.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class s{constructor($,V,z){this.resource=$,this.operation=V,this.target=z}isOperation($){return this.operation===$}}e.FileOperationEvent=s;var l;(function(R){R[R.UPDATED=0]="UPDATED",R[R.ADDED=1]="ADDED",R[R.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class u{constructor($,V){this.ignorePathCasing=V,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=$;for(const z of $)switch(z.type){case 1:this.added||(this.added=I.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(z.resource,z);break;case 0:this.updated||(this.updated=I.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(z.resource,z);break;case 2:this.deleted||(this.deleted=I.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(z.resource,z);break}}contains($,...V){return this.doContains($,{includeChildren:!1},...V)}affects($,...V){return this.doContains($,{includeChildren:!0},...V)}doContains($,V,...z){var U,q,M,j,re,F;if(!$)return!1;const te=z.length>0;return!!((!te||z.includes(1))&&(((U=this.added)===null||U===void 0?void 0:U.get($))||V.includeChildren&&((q=this.added)===null||q===void 0?void 0:q.findSuperstr($)))||(!te||z.includes(0))&&(((M=this.updated)===null||M===void 0?void 0:M.get($))||V.includeChildren&&((j=this.updated)===null||j===void 0?void 0:j.findSuperstr($)))||(!te||z.includes(2))&&(((re=this.deleted)===null||re===void 0?void 0:re.findSubstr($))||V.includeChildren&&((F=this.deleted)===null||F===void 0?void 0:F.findSuperstr($))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType($){const V=[],z=$===1?this.added:$===0?this.updated:this.deleted;if(z)for(const[,U]of z)V.push(U);return V}filter($){return new u(this.changes.filter(V=>$(V)),this.ignorePathCasing)}}e.FileChangesEvent=u;function r(R,$,V){return!R||!$||R===$||$.length>R.length?!1:($.charAt($.length-1)!==y.sep&&($+=y.sep),V?E.startsWithIgnoreCase(R,$):R.indexOf($)===0)}e.isParent=r;class g extends Error{constructor($,V,z){super($);this.fileOperationResult=V,this.options=z}static isFileOperationError($){return $ instanceof Error&&!k.isUndefinedOrNull($.fileOperationResult)}}e.FileOperationError=g;var C;(function(R){R[R.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",R[R.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",R[R.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",R[R.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",R[R.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",R[R.FILE_READ_ONLY=5]="FILE_READ_ONLY",R[R.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",R[R.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",R[R.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",R[R.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",R[R.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",R[R.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(C=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(R){R[R.FILE=0]="FILE",R[R.FOLDER=1]="FOLDER",R[R.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function D(R){if(!(typeof R.size!="number"||typeof R.mtime!="number"))return R.mtime.toString(29)+R.size.toString(31)}e.etag=D;async function w(R,$){if(!$.canHandleResource(A.URI.from({scheme:R.scheme})))return new Promise(V=>{const z=$.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===R.scheme&&U.added&&(z.dispose(),V())})})}e.whenProviderRegistered=w,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize($){return k.isNumber($)||($=0),$<O.KB?b.localize(1,null,$.toFixed(0)):$<O.MB?b.localize(2,null,($/O.KB).toFixed(2)):$<O.GB?b.localize(3,null,($/O.MB).toFixed(2)):$<O.TB?b.localize(4,null,($/O.GB).toFixed(2)):b.localize(5,null,($/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB}),define(ve[66],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class b{constructor(...A){this._entries=new Map;for(let[T,E]of A)this.set(T,E)}set(A,T){const E=this._entries.get(A);return this._entries.set(A,T),E}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=b}),define(ve[143],_e([0,1,9,137,87,4,66,15]),function(se,e,b,y,A,T,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const I=!1;class i extends Error{constructor(a){super("cyclic dependency between services");this.message=a.toString()}}class P{constructor(a=new E.ServiceCollection,m=!1,p){this._activeInstantiations=new Set,this._services=a,this._strict=m,this._parent=p,this._services.set(T.IInstantiationService,this)}createChild(a){return new P(a,this._strict,this)}invokeFunction(a,...m){let p=v.traceInvocation(a),f=!1;try{return a({get:(n,o)=>{if(f)throw b.illegalState("service accessor is only valid during the invocation of its target method");const h=this._getOrCreateServiceInstance(n,p);if(!h&&o!==T.optional)throw new Error(`[invokeFunction] unknown service '${n}'`);return h}},...m)}finally{f=!0,p.stop()}}createInstance(a,...m){let p,f;return a instanceof A.SyncDescriptor?(p=v.traceCreation(a.ctor),f=this._createInstance(a.ctor,a.staticArguments.concat(m),p)):(p=v.traceCreation(a),f=this._createInstance(a,m,p)),p.stop(),f}_createInstance(a,m=[],p){let f=T._util.getServiceDependencies(a).sort((o,h)=>o.index-h.index),c=[];for(const o of f){let h=this._getOrCreateServiceInstance(o.id,p);if(!h&&this._strict&&!o.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${o.id}.`);c.push(h)}let n=f.length>0?f[0].index:m.length;if(m.length!==n){console.warn(`[createInstance] First service dependency of ${a.name} at position ${n+1} conflicts with ${m.length} static arguments`);let o=n-m.length;o>0?m=m.concat(new Array(o)):m=m.slice(0,n)}return new a(...[...m,...c])}_setServiceInstance(a,m){if(this._services.get(a)instanceof A.SyncDescriptor)this._services.set(a,m);else if(this._parent)this._parent._setServiceInstance(a,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let m=this._services.get(a);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):m}_getOrCreateServiceInstance(a,m){let p=this._getServiceInstanceOrDescriptor(a);return p instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,p,m.branch(a,!0)):(m.branch(a,!1),p)}_safeCreateAndCacheServiceInstance(a,m,p){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,m,p)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,m,p){const f=new y.Graph(o=>o.id.toString());let c=0;const n=[{id:a,desc:m,_trace:p}];for(;n.length;){const o=n.pop();if(f.lookupOrInsertNode(o),c++>1e3)throw new i(f);for(let h of T._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(h.id);if(!t&&!h.optional&&console.warn(`[createInstance] ${a} depends on ${h.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const s={id:h.id,desc:t,_trace:o._trace.branch(h.id,!0)};f.insertEdge(o,s),n.push(s)}}}for(;;){const o=f.roots();if(o.length===0){if(!f.isEmpty())throw new i(f);break}for(const{data:h}of o){if(this._getServiceInstanceOrDescriptor(h.id)instanceof A.SyncDescriptor){const s=this._createServiceInstanceWithOwner(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this._setServiceInstance(h.id,s)}f.removeNode(h)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,m,p=[],f,c){if(this._services.get(a)instanceof A.SyncDescriptor)return this._createServiceInstance(m,p,f,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,m,p,f,c);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(a,m=[],p,f){if(p){const c=new k.IdleValue(()=>this._createInstance(a,m,f));return new Proxy(Object.create(null),{get(n,o){if(o in n)return n[o];let h=c.value,t=h[o];return typeof t!="function"||(t=t.bind(h),n[o]=t),t},set(n,o,h){return c.value[o]=h,!0}})}else return this._createInstance(a,m,f)}}e.InstantiationService=P;var S;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(S||(S={}));class v{constructor(a,m){this.type=a,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return I?new v(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(a){return I?new v(0,a.name):v._None}branch(a,m){let p=new v(2,a.toString());return this._dep.push([a,m,p]),p}stop(){let a=Date.now()-this._start;v._totals+=a;let m=!1;function p(c,n){let o=[],h=new Array(c+1).join("	");for(const[t,s,l]of n._dep)if(s&&l){m=!0,o.push(`${h}CREATES -> ${t}`);let u=p(c+1,l);u&&o.push(u)}else o.push(`${h}uses -> ${t}`);return o.join(`
`)}let f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(a>2||m)&&console.log(f.join(`
`))}}v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(ve[17],_e([0,1,4,6,21,3,61]),function(se,e,b,y,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.DelegatedLogService=e.MultiplexLogService=e.ConsoleLogInMainService=e.LogServiceAdapter=e.ConsoleLogService=e.ConsoleLogMainService=e.AbstractLogService=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=b.createDecorator("logService"),e.ILoggerService=b.createDecorator("loggerService");function k(){return new Date().toISOString()}var I;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(I=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=I.Info;class i extends y.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(h){this.level!==h&&(this.level=h,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogService=i;class P extends i{constructor(h=e.DEFAULT_LOG_LEVEL){super();this.setLevel(h),this.useColors=!A.isWindows}trace(h,...t){this.getLevel()<=I.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,h,...t):console.log(`[main ${k()}]`,h,...t))}debug(h,...t){this.getLevel()<=I.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,h,...t):console.log(`[main ${k()}]`,h,...t))}info(h,...t){this.getLevel()<=I.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,h,...t):console.log(`[main ${k()}]`,h,...t))}warn(h,...t){this.getLevel()<=I.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,h,...t):console.warn(`[main ${k()}]`,h,...t))}error(h,...t){this.getLevel()<=I.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,h,...t):console.error(`[main ${k()}]`,h,...t))}critical(h,...t){this.getLevel()<=I.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,h,...t):console.error(`[main ${k()}]`,h,...t))}dispose(){}flush(){}}e.ConsoleLogMainService=P;class S extends i{constructor(h=e.DEFAULT_LOG_LEVEL){super();this.setLevel(h)}trace(h,...t){this.getLevel()<=I.Trace&&console.log("%cTRACE","color: #888",h,...t)}debug(h,...t){this.getLevel()<=I.Debug&&console.log("%cDEBUG","background: #eee; color: #888",h,...t)}info(h,...t){this.getLevel()<=I.Info&&console.log("%c INFO","color: #33f",h,...t)}warn(h,...t){this.getLevel()<=I.Warning&&console.log("%c WARN","color: #993",h,...t)}error(h,...t){this.getLevel()<=I.Error&&console.log("%c  ERR","color: #f33",h,...t)}critical(h,...t){this.getLevel()<=I.Critical&&console.log("%cCRITI","background: #f33; color: white",h,...t)}dispose(){}flush(){}}e.ConsoleLogService=S;class v extends i{constructor(h,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=h,this.setLevel(t)}trace(h,...t){this.getLevel()<=I.Trace&&this.adapter.consoleLog("trace",[this.extractMessage(h),...t])}debug(h,...t){this.getLevel()<=I.Debug&&this.adapter.consoleLog("debug",[this.extractMessage(h),...t])}info(h,...t){this.getLevel()<=I.Info&&this.adapter.consoleLog("info",[this.extractMessage(h),...t])}warn(h,...t){this.getLevel()<=I.Warning&&this.adapter.consoleLog("warn",[this.extractMessage(h),...t])}error(h,...t){this.getLevel()<=I.Error&&this.adapter.consoleLog("error",[this.extractMessage(h),...t])}critical(h,...t){this.getLevel()<=I.Critical&&this.adapter.consoleLog("critical",[this.extractMessage(h),...t])}extractMessage(h){return typeof h=="string"?h:E.toErrorMessage(h,this.getLevel()<=I.Trace)}dispose(){}flush(){}}e.LogServiceAdapter=v;class d extends v{constructor(h,t=e.DEFAULT_LOG_LEVEL){super({consoleLog:(s,l)=>h.consoleLog(s,l)},t)}}e.ConsoleLogInMainService=d;class a extends i{constructor(h){super();this.logServices=h,h.length&&this.setLevel(h[0].getLevel())}setLevel(h){for(const t of this.logServices)t.setLevel(h);super.setLevel(h)}trace(h,...t){for(const s of this.logServices)s.trace(h,...t)}debug(h,...t){for(const s of this.logServices)s.debug(h,...t)}info(h,...t){for(const s of this.logServices)s.info(h,...t)}warn(h,...t){for(const s of this.logServices)s.warn(h,...t)}error(h,...t){for(const s of this.logServices)s.error(h,...t)}critical(h,...t){for(const s of this.logServices)s.critical(h,...t)}flush(){for(const h of this.logServices)h.flush()}dispose(){for(const h of this.logServices)h.dispose()}}e.MultiplexLogService=a;class m extends y.Disposable{constructor(h){super();this.logService=h,this._register(h)}get onDidChangeLogLevel(){return this.logService.onDidChangeLogLevel}setLevel(h){this.logService.setLevel(h)}getLevel(){return this.logService.getLevel()}trace(h,...t){this.logService.trace(h,...t)}debug(h,...t){this.logService.debug(h,...t)}info(h,...t){this.logService.info(h,...t)}warn(h,...t){this.logService.warn(h,...t)}error(h,...t){this.logService.error(h,...t)}critical(h,...t){this.logService.critical(h,...t)}flush(){this.logService.flush()}}e.DelegatedLogService=m;class p{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(h){}getLevel(){return I.Info}trace(h,...t){}debug(h,...t){}info(h,...t){}warn(h,...t){}error(h,...t){}critical(h,...t){}dispose(){}flush(){}}e.NullLogService=p;function f(o){if(o.verbose)return I.Trace;if(typeof o.logLevel=="string"){const h=c(o.logLevel.toLowerCase());if(h!==void 0)return h}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function c(o){switch(o){case"trace":return I.Trace;case"debug":return I.Debug;case"info":return I.Info;case"warn":return I.Warning;case"error":return I.Error;case"critical":return I.Critical;case"off":return I.Off}}e.parseLogLevel=c;function n(o){switch(o){case I.Trace:return"trace";case I.Debug:return"debug";case I.Info:return"info";case I.Warning:return"warn";case I.Error:return"error";case I.Critical:return"critical";case I.Off:return"off"}}e.LogLevelToString=n}),define(ve[88],_e([0,1,4,121,57]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(I){I[I.Unnecessary=1]="Unnecessary",I[I.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var E;(function(I){I[I.Hint=1]="Hint",I[I.Info=2]="Info",I[I.Warning=4]="Warning",I[I.Error=8]="Error"})(E=e.MarkerSeverity||(e.MarkerSeverity={})),function(I){function i(a,m){return m-a}I.compare=i;const P=Object.create(null);P[I.Error]=y.localize(0,null),P[I.Warning]=y.localize(1,null),P[I.Info]=y.localize(2,null);function S(a){return P[a]||""}I.toString=S;function v(a){switch(a){case A.default.Error:return I.Error;case A.default.Warning:return I.Warning;case A.default.Info:return I.Info;case A.default.Ignore:return I.Hint}}I.fromSeverity=v;function d(a){switch(a){case I.Error:return A.default.Error;case I.Warning:return A.default.Warning;case I.Info:return A.default.Info;case I.Hint:return A.default.Ignore}}I.toSeverity=d}(E=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(I){const i="";function P(v){return S(v,!0)}I.makeKey=P;function S(v,d){let a=[i];return v.source?a.push(v.source.replace("\xA6","\\\xA6")):a.push(i),v.code?typeof v.code=="string"?a.push(v.code.replace("\xA6","\\\xA6")):a.push(v.code.value.replace("\xA6","\\\xA6")):a.push(i),v.severity!==void 0&&v.severity!==null?a.push(E.toString(v.severity)):a.push(i),v.message&&d?a.push(v.message.replace("\xA6","\\\xA6")):a.push(i),v.startLineNumber!==void 0&&v.startLineNumber!==null?a.push(v.startLineNumber.toString()):a.push(i),v.startColumn!==void 0&&v.startColumn!==null?a.push(v.startColumn.toString()):a.push(i),v.endLineNumber!==void 0&&v.endLineNumber!==null?a.push(v.endLineNumber.toString()):a.push(i),v.endColumn!==void 0&&v.endColumn!==null?a.push(v.endColumn.toString()):a.push(i),a.push(i),a.join("\xA6")}I.makeKeyOptionalMessage=S})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=b.createDecorator("markerService")}),define(ve[144],_e([0,1,57,4,3]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=b.default,e.INotificationService=y.createDecorator("notificationService");var T;(function(i){i[i.WORKSPACE=0]="WORKSPACE",i[i.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var E;(function(i){i[i.OFF=0]="OFF",i[i.SILENT=1]="SILENT",i[i.ERROR=2]="ERROR"})(E=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new I,this.onDidClose=A.Event.None,this.onDidChangeVisibility=A.Event.None}updateSeverity(P){}updateMessage(P){}updateActions(P){}close(){}}e.NoOpNotification=k;class I{infinite(){}done(){}total(P){}worked(P){}}e.NoOpProgress=I}),define(ve[145],_e([0,1,4,20,6]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=b.createDecorator("progressService");var T;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class E{constructor(i){this.callback=i}get value(){return this._value}report(i){this._value=i,this.callback(this._value)}}e.Progress=E,E.None=Object.freeze({report(){}});class k extends A.Disposable{constructor(i){super();this.progressIndicator=i,this.currentOperationId=0,this.currentOperationDisposables=this._register(new A.DisposableStore)}start(i){this.stop();const P=++this.currentOperationId,S=new y.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{P===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},i),this.currentOperationDisposables.add(A.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(A.toDisposable(()=>S.cancel())),this.currentOperationDisposables.add(A.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:P,token:S.token,stop:()=>this.doStop(P),isCurrent:()=>this.currentOperationId===P}}stop(){this.doStop(this.currentOperationId)}doStop(i){this.currentOperationId===i&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=b.createDecorator("editorProgressService")}),define(ve[30],_e([0,1,12,43]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(E,k){y.ok(b.isString(E)),y.ok(b.isObject(k)),y.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,k)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}e.Registry=new A}),define(ve[89],_e([0,1,30,3]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class T{constructor(){this._onDidChangeSchema=new y.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(I,i){this.schemasById[A(I)]=i,this._onDidChangeSchema.fire(I)}notifySchemaChanged(I){this._onDidChangeSchema.fire(I)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new T;b.Registry.add(e.Extensions.JSONContribution,E)}),define(ve[67],_e([0,1,119,3,30,12,89]),function(se,e,b,y,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const I=A.Registry.as(E.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new y.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new y.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:b.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(f,c=!0){this.registerConfigurations([f],c)}registerConfigurations(f,c=!0){const n=[];f.forEach(o=>{n.push(...this.validateAndRegisterProperties(o,c)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(n)}deregisterConfigurations(f){const c=[],n=o=>{if(o.properties)for(const h in o.properties)c.push(h),delete this.configurationProperties[h],this.removeFromSchema(h,o.properties[h]);o.allOf&&o.allOf.forEach(h=>n(h))};for(const o of f){n(o);const h=this.configurationContributors.indexOf(o);h!==-1&&this.configurationContributors.splice(h,1)}I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}registerDefaultConfigurations(f){const c=[],n=[];for(const o of f)for(const h in o)if(c.push(h),e.OVERRIDE_PROPERTY_PATTERN.test(h)){this.defaultValues[h]=Object.assign(Object.assign({},this.defaultValues[h]||{}),o[h]);const t={type:"object",default:this.defaultValues[h],description:b.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId};n.push(S(h)),this.configurationProperties[h]=t,this.defaultLanguageConfigurationOverridesNode.properties[h]=t}else{this.defaultValues[h]=o[h];const t=this.configurationProperties[h];t&&(this.updatePropertyDefaultValue(h,t),this.updateSchema(h,t))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(f){const c=[];for(const n of f)for(const o in n)if(c.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const h=this.configurationProperties[o];h&&(this.updatePropertyDefaultValue(o,h),this.updateSchema(o,h))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...f){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(f){for(const c of f)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(f,c=!0,n=3){n=T.isUndefinedOrNull(f.scope)?n:f.scope;let o=[],h=f.properties;if(h)for(let s in h){if(c&&a(s)){delete h[s];continue}const l=h[s];if(this.updatePropertyDefaultValue(s,l),e.OVERRIDE_PROPERTY_PATTERN.test(s)?l.scope=void 0:l.scope=T.isUndefinedOrNull(l.scope)?n:l.scope,h[s].hasOwnProperty("included")&&!h[s].included){this.excludedConfigurationProperties[s]=h[s],delete h[s];continue}else this.configurationProperties[s]=h[s];!h[s].deprecationMessage&&h[s].markdownDeprecationMessage&&(h[s].deprecationMessage=h[s].markdownDeprecationMessage),o.push(s)}let t=f.allOf;if(t)for(let s of t)o.push(...this.validateAndRegisterProperties(s,c,n));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(f){const c=n=>{let o=n.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let h=n.allOf;h&&h.forEach(c)};c(f)}updateSchema(f,c){switch(e.allSettings.properties[f]=c,c.scope){case 1:e.applicationSettings.properties[f]=c;break;case 2:e.machineSettings.properties[f]=c;break;case 6:e.machineOverridableSettings.properties[f]=c;break;case 3:e.windowSettings.properties[f]=c;break;case 4:e.resourceSettings.properties[f]=c;break;case 5:e.resourceSettings.properties[f]=c,this.resourceLanguageSettingsSchema.properties[f]=c;break}}removeFromSchema(f,c){switch(delete e.allSettings.properties[f],c.scope){case 1:delete e.applicationSettings.properties[f];break;case 2:delete e.machineSettings.properties[f];break;case 6:delete e.machineOverridableSettings.properties[f];break;case 3:delete e.windowSettings.properties[f];break;case 4:case 5:delete e.resourceSettings.properties[f];break}}updateOverridePropertyPatternKey(){for(const f of this.overrideIdentifiers.values()){const c=`[${f}]`,n={type:"object",description:b.localize(2,null),errorMessage:b.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,n),e.allSettings.properties[c]=n,e.applicationSettings.properties[c]=n,e.machineSettings.properties[c]=n,e.machineOverridableSettings.properties[c]=n,e.windowSettings.properties[c]=n,e.resourceSettings.properties[c]=n}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(f,c){let n=this.defaultValues[f];T.isUndefined(n)&&(n=c.default),T.isUndefined(n)&&(n=v(c.type)),c.default=n}}const P="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(P);function S(p){return p.substring(1,p.length-1)}e.overrideIdentifierFromKey=S;function v(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const d=new i;A.Registry.add(e.Extensions.Configuration,d);function a(p){return p.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(p)?b.localize(5,null,p):d.getConfigurationProperties()[p]!==void 0?b.localize(6,null,p):null:b.localize(4,null)}e.validateProperty=a;function m(){const p=[],f=d.getConfigurationProperties();for(const c of Object.keys(f))p.push([c,f[c].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=m}),define(ve[90],_e([0,1,24,12,2,30,4,67]),function(se,e,b,y,A,T,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=E.createDecorator("configurationService");function I(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof A.URI)}e.isConfigurationOverrides=I;var i;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(i=e.ConfigurationTarget||(e.ConfigurationTarget={}));function P(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=P;function S(s,l){const u=l?s?l.keys.filter(O=>s.keys.indexOf(O)===-1):[...l.keys]:[],r=s?l?s.keys.filter(O=>l.keys.indexOf(O)===-1):[...s.keys]:[],g=[];if(l&&s){for(const O of s.keys)if(l.keys.indexOf(O)!==-1){const R=f(s.contents,O),$=f(l.contents,O);b.equals(R,$)||g.push(O)}}const C=[],_=O=>{const R={};for(const $ of O)for(const V of $.identifiers)R[h(V)]=$;return R},D=l?_(l.overrides):{},w=s?_(s.overrides):{};if(Object.keys(D).length)for(const O of u){const R=D[O];R&&C.push([k.overrideIdentifierFromKey(O),R.keys])}if(Object.keys(w).length)for(const O of r){const R=w[O];R&&C.push([k.overrideIdentifierFromKey(O),R.keys])}if(Object.keys(D).length&&Object.keys(w).length)for(const O of g){const R=w[O],$=D[O];if(R&&$){const V=S({contents:R.contents,keys:R.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});C.push([k.overrideIdentifierFromKey(O),[...V.added,...V.removed,...V.updated]])}}return{added:u,removed:r,updated:g,overrides:C}}e.compare=S;function v(s,l){const u=[];for(const r of Object.keys(s))if(k.OVERRIDE_PROPERTY_PATTERN.test(r)){const g={};for(const C in s[r])g[C]=s[r][C];u.push({identifiers:[k.overrideIdentifierFromKey(r).trim()],keys:Object.keys(g),contents:d(g,l)})}return u}e.toOverrides=v;function d(s,l){const u=Object.create(null);for(let r in s)a(u,r,s[r],l);return u}e.toValuesTree=d;function a(s,l,u,r){const g=l.split("."),C=g.pop();let _=s;for(let D=0;D<g.length;D++){let w=g[D],O=_[w];switch(typeof O){case"undefined":O=_[w]=Object.create(null);break;case"object":break;default:r(`Ignoring ${l} as ${g.slice(0,D+1).join(".")} is ${JSON.stringify(O)}`);return}_=O}if(typeof _=="object"&&_!==null)try{_[C]=u}catch(D){r(`Ignoring ${l} as ${g.join(".")} is ${JSON.stringify(_)}`)}else r(`Ignoring ${l} as ${g.join(".")} is ${JSON.stringify(_)}`)}e.addToValueTree=a;function m(s,l){const u=l.split(".");p(s,u)}e.removeFromValueTree=m;function p(s,l){const u=l.shift();if(l.length===0){delete s[u];return}if(Object.keys(s).indexOf(u)!==-1){const r=s[u];typeof r=="object"&&!Array.isArray(r)&&(p(r,l),Object.keys(r).length===0&&delete s[u])}}function f(s,l,u){function r(_,D){let w=_;for(const O of D){if(typeof w!="object"||w===null)return;w=w[O]}return w}const g=l.split("."),C=r(s,g);return typeof C=="undefined"?u:C}e.getConfigurationValue=f;function c(s,l,u){Object.keys(l).forEach(r=>{r!=="__proto__"&&(r in s?y.isObject(s[r])&&y.isObject(l[r])?c(s[r],l[r],u):u&&(s[r]=l[r]):s[r]=l[r])})}e.merge=c;function n(){const s=T.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=n;function o(){const s=Object.create(null),l=T.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let u in l){let r=l[u].default;a(s,u,r,g=>console.error(`Conflict in default settings: ${g}`))}return s}e.getDefaultValues=o;function h(s){return`[${s}]`}e.keyFromOverrideIdentifier=h;function t(s,l,u){const r=s.inspect(l),g=s.inspect(u);return typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:r.defaultValue}e.getMigratedSettingValue=t}),define(ve[146],_e([0,1,45,22,11,12,24,2,67,90,30,6,3]),function(se,e,b,y,A,T,E,k,I,i,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(t={},s=[],l=[]){this._contents=t,this._keys=s,this._overrides=l,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?i.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,s){const l=this.getContentsForOverrideIdentifer(s);return l?t?i.getConfigurationValue(l,t):l:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let l={};for(const u of A.distinct([...Object.keys(this.contents),...Object.keys(s)])){let r=this.contents[u],g=s[u];g&&(typeof r=="object"&&typeof g=="object"?(r=E.deepClone(r),this.mergeContents(r,g)):r=g),l[u]=r}return new d(l,this.keys,this.overrides)}merge(...t){const s=E.deepClone(this.contents),l=E.deepClone(this.overrides),u=[...this.keys];for(const r of t){this.mergeContents(s,r.contents);for(const g of r.overrides){const[C]=l.filter(_=>A.equals(_.identifiers,g.identifiers));C?this.mergeContents(C.contents,g.contents):l.push(E.deepClone(g))}for(const g of r.keys)u.indexOf(g)===-1&&u.push(g)}return new d(s,u,l)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const l of Object.keys(s)){if(l in t&&T.isObject(t[l])&&T.isObject(s[l])){this.mergeContents(t[l],s[l]);continue}t[l]=E.deepClone(s[l])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?E.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),i.addToValueTree(this.contents,t,s,l=>{throw new Error(l)})}removeValue(t){this.removeKey(t)&&i.removeFromValueTree(this.contents,t)}addKey(t){let s=this.keys.length;for(let l=0;l<s;l++)t.indexOf(this.keys[l])===0&&(s=l);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=d;class a extends d{constructor(){const t=i.getDefaultValues(),s=i.getConfigurationKeys(),l=[];for(const u of Object.keys(t))I.OVERRIDE_PROPERTY_PATTERN.test(u)&&l.push({identifiers:[I.overrideIdentifierFromKey(u).trim()],keys:Object.keys(t[u]),contents:i.toValuesTree(t[u],r=>console.error(`Conflict in default settings file: ${r}`))});super(t,s,l)}}e.DefaultConfigurationModel=a;class m{constructor(t,s){this._name=t,this._scopes=s,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get errors(){return this._parseErrors}parseContent(t){if(!T.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s)}}parseRaw(t){this._raw=t;const s=this.doParseRaw(t);this._configurationModel=new d(s.contents,s.keys,s.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let s={},l=null,u=[],r=[],g=[];function C(D){Array.isArray(u)?u.push(D):l&&(u[l]=D)}let _={onObjectBegin:()=>{let D={};C(D),r.push(u),u=D,l=null},onObjectProperty:D=>{l=D},onObjectEnd:()=>{u=r.pop()},onArrayBegin:()=>{let D=[];C(D),r.push(u),u=D,l=null},onArrayEnd:()=>{u=r.pop()},onLiteralValue:C,onError:(D,w,O)=>{g.push({error:D,offset:w,length:O})}};if(t)try{b.visit(t,_),s=u[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return s}doParseRaw(t){if(this._scopes){const r=P.Registry.as(I.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,r,!0,this._scopes)}const s=i.toValuesTree(t,r=>console.error(`Conflict in settings file ${this._name}: ${r}`)),l=Object.keys(t),u=i.toOverrides(t,r=>console.error(`Conflict in settings file ${this._name}: ${r}`));return{contents:s,keys:l,overrides:u}}filterByScope(t,s,l,u){const r={};for(let g in t)if(I.OVERRIDE_PROPERTY_PATTERN.test(g)&&l)r[g]=this.filterByScope(t[g],s,!1,u);else{const C=this.getScope(g,s);(C===void 0||u.indexOf(C)!==-1)&&(r[g]=t[g])}return r}getScope(t,s){const l=s[t];return l?typeof l.scope!="undefined"?l.scope:3:void 0}}e.ConfigurationModelParser=m;class p extends S.Disposable{constructor(t,s,l,u){super();this.userSettingsResource=t,this.scopes=s,this.fileService=u,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(l.dirname(this.userSettingsResource))),this._register(v.Event.filter(this.fileService.onDidFilesChange,r=>r.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new d}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=p;class f{constructor(t,s,l=new d,u=new d,r=new y.ResourceMap,g=new d,C=new y.ResourceMap,_=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=l,this._workspaceConfiguration=u,this._folderConfigurations=r,this._memoryConfiguration=g,this._memoryConfigurationByResource=C,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new y.ResourceMap,this._userConfiguration=null}getValue(t,s,l){return this.getConsolidateConfigurationModel(s,l).getValue(t)}updateValue(t,s,l={}){let u;l.resource?(u=this._memoryConfigurationByResource.get(l.resource),u||(u=new d,this._memoryConfigurationByResource.set(l.resource,u))):u=this._memoryConfiguration,s===void 0?u.removeValue(t):u.setValue(t,s),l.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,l){const u=this.getConsolidateConfigurationModel(s,l),r=this.getFolderConfigurationModelForResource(s.resource,l),g=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,C=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),_=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),D=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),w=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),O=l?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,R=r?s.overrideIdentifier?r.freeze().override(s.overrideIdentifier).getValue(t):r.freeze().getValue(t):void 0,$=s.overrideIdentifier?g.override(s.overrideIdentifier).getValue(t):g.getValue(t),V=u.getValue(t),z=A.distinct(A.flatten(u.overrides.map(U=>U.identifiers))).filter(U=>u.getOverrideValue(t,U)!==void 0);return{defaultValue:C,userValue:_,userLocalValue:D,userRemoteValue:w,workspaceValue:O,workspaceFolderValue:R,memoryValue:$,value:V,default:C!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:D!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:w!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:R!==void 0?{value:r==null?void 0:r.freeze().getValue(t),override:s.overrideIdentifier?r==null?void 0:r.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:g.getValue(t),override:s.overrideIdentifier?g.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const l=s.filter(u=>I.OVERRIDE_PROPERTY_PATTERN.test(u)).map(u=>{const r=I.overrideIdentifierFromKey(u),g=this._defaultConfiguration.getKeysForOverrideIdentifier(r),C=t.getKeysForOverrideIdentifier(r),_=[...C.filter(D=>g.indexOf(D)===-1),...g.filter(D=>C.indexOf(D)===-1),...g.filter(D=>!E.equals(this._defaultConfiguration.override(r).getValue(D),t.override(r).getValue(D)))];return[r,_]});return this.updateDefaultConfiguration(t),{keys:s,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:l,removed:u,overrides:r}=i.compare(this.localUserConfiguration,t),g=[...s,...l,...u];return g.length&&this.updateLocalUserConfiguration(t),{keys:g,overrides:r}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:l,removed:u,overrides:r}=i.compare(this.remoteUserConfiguration,t);let g=[...s,...l,...u];return g.length&&this.updateRemoteUserConfiguration(t),{keys:g,overrides:r}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:l,removed:u,overrides:r}=i.compare(this.workspaceConfiguration,t);let g=[...s,...l,...u];return g.length&&this.updateWorkspaceConfiguration(t),{keys:g,overrides:r}}compareAndUpdateFolderConfiguration(t,s){const l=this.folderConfigurations.get(t),{added:u,updated:r,removed:g,overrides:C}=i.compare(l,s);let _=[...u,...r,...g];return(_.length||!l)&&this.updateFolderConfiguration(t,s),{keys:_,overrides:C}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:l,updated:u,removed:r,overrides:g}=i.compare(s,void 0);return{keys:[...l,...u,...r],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let l=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?l.override(t.overrideIdentifier):l}getConsolidatedConfigurationModelForResource({resource:t},s){let l=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const u=s.getFolder(t);u&&(l=this.getFolderConsolidatedConfiguration(u.uri)||l);const r=this._memoryConfigurationByResource.get(t);r&&(l=l.merge(r))}return l}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const l=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(t);u?(s=l.merge(u),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=l}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const l=s.getFolder(t);if(l)return this._folderConfigurations.get(l.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:l,overrides:u,keys:r}=this._folderConfigurations.get(s);return t.push([s,{contents:l,overrides:u,keys:r}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(l=>t.add(l))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>s.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>s.add(l)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>s.add(l)),this._folderConfigurations.forEach(l=>l.getKeysForOverrideIdentifier(t).forEach(u=>s.add(u))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),l=this.parseConfigurationModel(t.user),u=this.parseConfigurationModel(t.workspace),r=t.folders.reduce((g,C)=>(g.set(k.URI.revive(C[0]),this.parseConfigurationModel(C[1])),g),new y.ResourceMap);return new f(s,l,new d,u,r,new d,new y.ResourceMap,!1)}static parseConfigurationModel(t){return new d(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=f;function c(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const t=new Set,s=new Map;for(const u of h)u.keys.forEach(r=>t.add(r)),u.overrides.forEach(([r,g])=>{const C=y.getOrSet(s,r,new Set);g.forEach(_=>C.add(_))});const l=[];return s.forEach((u,r)=>l.push([r,[...u.values()]])),{keys:[...t.values()],overrides:l}}e.mergeChanges=c;class n{constructor(t,s,l,u){this.change=t,this.previous=s,this.currentConfiguraiton=l,this.currentWorkspace=u,this._previousConfiguration=void 0;const r=new Set;t.keys.forEach(C=>r.add(C)),t.overrides.forEach(([,C])=>C.forEach(_=>r.add(_))),this.affectedKeys=[...r.values()];const g=new d;this.affectedKeys.forEach(C=>g.setValue(C,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){var l;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const u=this.previousConfiguration?this.previousConfiguration.getValue(t,s,(l=this.previous)===null||l===void 0?void 0:l.workspace):void 0,r=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!E.equals(u,r)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let l=i.toValuesTree({[s]:!0},()=>{}),u;for(;typeof l=="object"&&(u=Object.keys(l)[0]);){if(t=t[u],!t)return!1;l=l[u]}return!0}}e.ConfigurationChangeEvent=n;class o extends n{constructor(t,s,l,u){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=l,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=o}),define(ve[91],_e([0,1,4]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=b.createDecorator("remoteAuthorityResolverService");var y;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(y=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(E,k=y.Unknown,I){super(E);this._message=E,this._code=k,this._detail=I,this.isHandled=k===y.NotAvailable&&I===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(E){return E instanceof A&&E._code===y.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof A&&E._code===y.NoResolverFound}static isHandled(E){return E instanceof A&&E.isHandled}}e.RemoteAuthorityResolverError=A}),define(ve[92],_e([0,1,16]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function y(T){return T.scheme===b.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=y;function A(T){if(!!T){const E=T.indexOf("+");return E<0?T:T.substr(0,E)}}e.getRemoteName=A}),define(ve[147],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var b;(function(y){y.DARK="dark",y.LIGHT="light",y.HIGH_CONTRAST="hc"})(b=e.ColorScheme||(e.ColorScheme={}))}),define(ve[148],_e([0,1,4,6,30,3,147,46]),function(se,e,b,y,A,T,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=b.createDecorator("themeService");var I;(function(p){function f(c){return c&&typeof c=="object"&&typeof c.id=="string"}p.isThemeColor=f})(I=e.ThemeColor||(e.ThemeColor={}));function i(p){return{id:p}}e.themeColorFromId=i;var P;(function(p){function f(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||I.isThemeColor(t.color))}p.isThemeIcon=f;const c=/^\$\(([a-z.]+\/)?([a-z-~]+)\)$/i;function n(t){const s=c.exec(t);if(!!s){let[,l,u]=s;return!l||l==="codicon/"?{id:u}:{id:l+u}}}p.fromString=n;function o(t,s){let l=t.id;const u=l.lastIndexOf("~");return u!==-1&&(l=l.substring(0,u)),s&&(l=`${l}~${s}`),{id:l}}p.modify=o;function h(t,s){var l,u;return t.id===s.id&&((l=t.color)===null||l===void 0?void 0:l.id)===((u=s.color)===null||u===void 0?void 0:u.id)}p.isEqual=h,p.asClassNameArray=k.CSSIcon.asClassNameArray,p.asClassName=k.CSSIcon.asClassName,p.asCSSSelector=k.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function S(p){switch(p){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=S,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(f){return this.themingParticipants.push(f),this.onThemingParticipantAddedEmitter.fire(f),y.toDisposable(()=>{const c=this.themingParticipants.indexOf(f);this.themingParticipants.splice(c,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new v;A.Registry.add(e.Extensions.ThemingContribution,d);function a(p){return d.onColorThemeChange(p)}e.registerThemingParticipant=a;class m extends y.Disposable{constructor(f){super();this.themeService=f,this.theme=f.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(c=>this.onThemeChange(c)))}onThemeChange(f){this.theme=f,this.updateStyles()}updateStyles(){}getColor(f,c){let n=this.theme.getColor(f);return n&&c&&(n=c(n,this.theme)),n?n.toString():null}}e.Themable=m}),define(ve[149],_e([0,1,30,148,3,122,89,15,46]),function(se,e,b,y,A,T,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class i{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:T.localize(0,null)},fontCharacter:{type:"string",description:T.localize(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",enum:[],enumDescriptions:[]},this.iconsById={}}registerIcon(f,c,n,o){const h=this.iconsById[f];if(h){if(n&&!h.description){h.description=n,this.iconSchema.properties[f].markdownDescription=`${n} $(${f})`;const l=this.iconReferenceSchema.enum.indexOf(f);l!==-1&&(this.iconReferenceSchema.enumDescriptions[l]=n),this._onDidChange.fire()}return h}let t={id:f,description:n,defaults:c,deprecationMessage:o};this.iconsById[f]=t;let s={$ref:"#/definitions/icons"};return o&&(s.deprecationMessage=o),n&&(s.markdownDescription=`${n}: $(${f})`),this.iconSchema.properties[f]=s,this.iconReferenceSchema.enum.push(f),this.iconReferenceSchema.enumDescriptions.push(n||""),this._onDidChange.fire(),{id:f}}deregisterIcon(f){delete this.iconsById[f],delete this.iconSchema.properties[f];const c=this.iconReferenceSchema.enum.indexOf(f);c!==-1&&(this.iconReferenceSchema.enum.splice(c,1),this.iconReferenceSchema.enumDescriptions.splice(c,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(f=>this.iconsById[f])}getIcon(f){return this.iconsById[f]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}getCSS(){const f=[];for(let c in this.iconsById){const n=this.formatRule(c);n&&f.push(n)}return f.join(`
`)}formatRule(f){let c=this.iconsById[f].defaults;for(;y.ThemeIcon.isThemeIcon(c);){const n=this.iconsById[c.id];if(!n)return;c=n.defaults}return`.codicon-${f}:before { content: '${c.character}'; }`}toString(){const f=(h,t)=>h.id.localeCompare(t.id),c=h=>{for(;y.ThemeIcon.isThemeIcon(h.defaults);)h=this.iconsById[h.defaults.id];return`codicon codicon-${h?h.id:""}`};let n=[];n.push("| preview     | identifier                        | default codicon id                | description"),n.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.iconsById).map(h=>this.iconsById[h]);for(const h of o.filter(t=>!!t.description).sort(f))n.push(`|<i class="${c(h)}"></i>|${h.id}|${y.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);n.push("| preview     | identifier                        "),n.push("| ----------- | --------------------------------- |");for(const h of o.filter(t=>!y.ThemeIcon.isThemeIcon(t.defaults)).sort(f))n.push(`|<i class="${c(h)}"></i>|${h.id}|`);return n.join(`
`)}}const P=new i;b.Registry.add(e.Extensions.IconContribution,P);function S(p,f,c,n){return P.registerIcon(p,f,c,n)}e.registerIcon=S;function v(){return P}e.getIconRegistry=v;function d(){for(const p of I.iconRegistry.all)P.registerIcon(p.id,p.definition,p.description);I.iconRegistry.onDidRegister(p=>P.registerIcon(p.id,p.definition,p.description))}d(),e.iconsSchemaId="vscode://schemas/icons";let a=b.Registry.as(E.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,P.getIconSchema());const m=new k.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);P.onDidChange(()=>{m.isScheduled()||m.schedule()}),e.widgetClose=S("widget-close",I.Codicon.close,T.localize(2,null)),e.gotoPreviousLocation=S("goto-previous-location",I.Codicon.arrowUp,T.localize(3,null)),e.gotoNextLocation=S("goto-next-location",I.Codicon.arrowDown,T.localize(4,null)),e.syncing=y.ThemeIcon.modify(I.Codicon.sync,"spin")}),define(ve[47],_e([0,1,2,23,4,22]),function(se,e,b,y,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=A.createDecorator("contextService");var E;(function(v){v[v.EMPTY=1]="EMPTY",v[v.FOLDER=2]="FOLDER",v[v.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function k(v){const d=v;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=k;function I(v){const d=v;return!!(d&&typeof d=="object"&&b.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=I;class i{constructor(d,a,m,p){this._id=d,this._configuration=m,this._ignorePathCasing=p,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(d){this._id=d.id,this._configuration=d.configuration,this._ignorePathCasing=d._ignorePathCasing,this.folders=d.folders}get folders(){return this._folders}set folders(d){this._folders=d,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(d){this._configuration=d}getFolder(d){return d&&this._foldersMap.findSubstr(d.with({scheme:d.scheme,authority:d.authority,path:d.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const d of this.folders)this._foldersMap.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=i;class P{constructor(d,a){this.raw=a,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return y.joinPath(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=P;function S(v){return new P({uri:v,index:0,name:y.basenameOrAuthority(v)},{uri:v.toString()})}e.toWorkspaceFolder=S}),define(ve[150],_e([0,1,4,123,47,2,21,10,23,103,45,16,59,38,92]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:y.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(V){return(typeof V=="string"?k.extname(V):I.extname(V))===m}e.hasWorkspaceFileExtension=p,e.IWorkspacesService=b.createDecorator("workspacesService");function f(V){return V.hasOwnProperty("workspace")}e.isRecentWorkspace=f;function c(V){return V.hasOwnProperty("folderUri")}e.isRecentFolder=c;function n(V){return V.hasOwnProperty("fileUri")}e.isRecentFile=n;function o(V){const z=V;return typeof(z==null?void 0:z.id)=="string"&&T.URI.isUri(z.uri)}e.isSingleFolderWorkspaceIdentifier=o;function h(V){if(V.configuration)return{id:V.id,configPath:V.configuration};if(V.folders.length===1)return{id:V.id,uri:V.folders[0].uri}}e.toWorkspaceIdentifier=h;function t(V){const z=V;return typeof(z==null?void 0:z.id)=="string"&&T.URI.isUri(z.configPath)}e.isWorkspaceIdentifier=t;function s(V){if(V==null?void 0:V.uri)return{id:V.id,uri:T.URI.revive(V.uri)};if(V==null?void 0:V.configPath)return{id:V.id,configPath:T.URI.revive(V.configPath)}}e.reviveIdentifier=s;function l(V,z){return I.extUriBiasedIgnorePathCase.isEqualOrParent(V,z.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function u(V){return r(V)||g(V)}e.isStoredWorkspaceFolder=u;function r(V){const z=V;return typeof(z==null?void 0:z.path)=="string"&&(!z.name||typeof z.name=="string")}e.isRawFileWorkspaceFolder=r;function g(V){const z=V;return typeof(z==null?void 0:z.uri)=="string"&&(!z.name||typeof z.name=="string")}e.isRawUriWorkspaceFolder=g;function C(V,z,U,q,M=!E.isWindows,j){if(V.scheme!==q.scheme)return{name:U,uri:V.toString(!0)};let re=z?void 0:j.relativePath(q,V);if(re!==void 0)re.length===0?re=".":E.isWindows&&V.scheme===S.Schemas.file&&!M&&(re=re.replace(/\//g,"\\"));else if(V.scheme===S.Schemas.file)re=V.fsPath,E.isWindows&&(re=v.normalizeDriveLetter(re),M&&(re=d.toSlashes(re)));else{if(!j.isEqualAuthority(V.authority,q.authority))return{name:U,uri:V.toString(!0)};re=V.path}return{name:U,path:re}}e.getStoredWorkspaceFolder=C;function _(V,z,U){let q=[],M=new Set;const j=U.dirname(z);for(let re of V){let F=null;if(r(re))re.path&&(F=U.resolvePath(j,re.path));else if(g(re))try{F=T.URI.parse(re.uri),F.path[0]!=="/"&&(F=F.with({path:"/"+F.path}))}catch(te){console.warn(te)}if(F){let te=U.getComparisonKey(F);if(!M.has(te)){M.add(te);const ae=re.name||U.basenameOrAuthority(F);q.push(new A.WorkspaceFolder({uri:F,name:ae,index:q.length},re))}}}return q}e.toWorkspaceFolders=_;function D(V,z,U,q,M){let j=w(z,V);const re=M.dirname(z),F=M.dirname(q),te=[],ae=O(j.folders);for(const De of j.folders){const Se=r(De)?M.resolvePath(re,De.path):T.URI.parse(De.uri);let Ce;U?Ce=!1:Ce=!r(De)||k.isAbsolute(De.path),te.push(C(Se,Ce,De.name,F,ae,M))}const ue={insertSpaces:!1,tabSize:4,eol:E.isLinux||E.isMacintosh?`
`:`\r
`},we=i.setProperty(V,["folders"],te,ue);let fe=i.applyEdits(V,we);return j.remoteAuthority===a.getRemoteAuthority(q)&&(fe=i.applyEdits(fe,i.removeProperty(fe,["remoteAuthority"],ue))),fe}e.rewriteWorkspaceFileForNewLocation=D;function w(V,z){let U=P.parse(z);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(q=>u(q));else throw new Error(`${V} looks like an invalid workspace file.`);return U}function O(V){return E.isWindows?V.some(z=>r(z)&&z.path.indexOf("/")>=0):!0}e.useSlashForPath=O;function R(V,z){const U={workspaces:[],files:[]};if(V){const q=function(j,re){for(let F=0;F<j.length;F++)try{re(j[F],F)}catch(te){z.warn(`Error restoring recent entry ${JSON.stringify(j[F])}: ${te.toString()}. Skip entry.`)}},M=V;Array.isArray(M.workspaces3)&&q(M.workspaces3,(j,re)=>{const F=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[re]||void 0;typeof j=="object"&&typeof j.id=="string"&&typeof j.configURIPath=="string"?U.workspaces.push({label:F,workspace:{id:j.id,configPath:T.URI.parse(j.configURIPath)}}):typeof j=="string"&&U.workspaces.push({label:F,folderUri:T.URI.parse(j)})}),Array.isArray(M.files2)&&q(M.files2,(j,re)=>{const F=Array.isArray(M.fileLabels)&&M.fileLabels[re]||void 0;typeof j=="string"&&U.files.push({label:F,fileUri:T.URI.parse(j)})})}return U}e.restoreRecentlyOpened=R;function $(V){const z={workspaces3:[],files2:[]};let U=!1;const q=[];for(const j of V.workspaces)c(j)?z.workspaces3.push(j.folderUri.toString()):z.workspaces3.push({id:j.workspace.id,configURIPath:j.workspace.configPath.toString()}),q.push(j.label||null),U=U||!!j.label;U&&(z.workspaceLabels=q),U=!1;const M=[];for(const j of V.files)z.files2.push(j.fileUri.toString()),M.push(j.label||null),U=U||!!j.label;return U&&(z.fileLabels=M),z}e.toStoreData=$}),define(ve[68],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class b{constructor(A){this.id=A,this._data=new Map,this._idPool=1}add(A){const T=this._idPool++;return this._data.set(T,A),this.logDebugInfo(),T}get(A,T){return this._data.has(A)?this._data.get(A)[T]:void 0}delete(A){this._data.delete(A),this.logDebugInfo()}logDebugInfo(){!b.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=b,b.enableDebugLogging=!1}),define(ve[151],_e([0,1,2,3]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class A{constructor(){this._onDidChangeTabs=new y.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(E){this._tabs=E.map(k=>({name:k.name,group:k.group,resource:b.URI.revive(k.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(ve[48],_e([0,1,16,4]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(b.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(E,k){k===null?this._providerInfo.delete(E):this._providerInfo.set(E,k)}isFreeScheme(E){return!this._providerInfo.has(E)&&!this._systemSchemes.has(E)}getCapabilities(E){return this._providerInfo.get(E)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=y.createDecorator("IExtHostFileSystemInfo")}),define(ve[28],_e([0,1,4]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=b.createDecorator("IExtHostInitDataService")}),define(ve[152],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class b{constructor(T,E,k){this._id=T,this._shared=E,this._storage=k,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)})}get whenReady(){return this._init}get(T,E){let k=this._value[T];return typeof k=="undefined"&&(k=E),k}update(T,E){return this._value[T]=E,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=b;class y extends b{constructor(T,E){super(T.identifier.value,!0,E);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=y}),define(ve[13],_e([0,1,4]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=b.createDecorator("IExtHostRpcService");class y{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=y});var Xe=this&&this.__classPrivateFieldSet||function(se,e,b){if(!e.has(se))throw new TypeError("attempted to set private field on non-instance");return e.set(se,b),b},Ue=this&&this.__classPrivateFieldGet||function(se,e){if(!e.has(se))throw new TypeError("attempted to get private field on non-instance");return e.get(se)};define(ve[153],_e([0,1,25,3]),function(se,e,b,y){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(k,I){A.set(this,void 0),this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._id=b.ExtensionIdentifier.toKey(k.identifier),Xe(this,A,I),Ue(this,A).onDidChangePassword(i=>{i.extensionId===this._id&&this._onDidChange.fire({key:i.key})})}get(k){return Ue(this,A).get(this._id,k)}store(k,I){return Ue(this,A).store(this._id,k,I)}delete(k){return Ue(this,A).delete(this._id,k)}}e.ExtensionSecrets=T,A=new WeakMap});var He=this&&this.__decorate||function(se,e,b,y){var A=arguments.length,T=A<3?e:y===null?y=Object.getOwnPropertyDescriptor(e,b):y,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(se,e,b,y);else for(var k=se.length-1;k>=0;k--)(E=se[k])&&(T=(A<3?E(T):A>3?E(e,b,T):E(e,b))||T);return A>3&&T&&Object.defineProperty(e,b,T),T},Be=this&&this.__param||function(se,e){return function(b,y){e(b,y,se)}};define(ve[69],_e([0,1,4,3,13]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(k){function I(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public}}k.fromApiTunnel=I;function i(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.public}}k.fromServiceTunnel=i})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=b.createDecorator("IExtHostTunnelService");let E=class{constructor(I){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,i){}async getTunnels(){return[]}async setTunnelExtensionFunctions(I){return{dispose:()=>{}}}async $forwardPort(I,i){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};E=He([Be(0,A.IExtHostRpcService)],E),e.ExtHostTunnelService=E}),define(ve[70],_e([0,1,4]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=b.createDecorator("IURITransformerService");class y{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=E=>E,this.transformOutgoing=E=>E,this.transformOutgoingURI=E=>E,this.transformOutgoingScheme=E=>E)}}e.URITransformerService=y}),define(ve[71],_e([0,1,2]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function y(T,E,k){const I=T.webviewResourceRoot.replace("{{resource}}",k.scheme+A(k)).replace("{{uuid}}",E);return b.URI.parse(I)}e.asWebviewUri=y;function A(T){return T.toString().replace(/^\S+?:/,"")}}),define(ve[154],_e([0,1,3,6,71,26]),function(se,e,b,y,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class E{constructor(I,i,P){this._proxy=I,this._editors=i,this._initData=P,this._handlePool=0,this._disposables=new y.DisposableStore,this._insets=new Map,this._disposables.add(i.onDidChangeVisibleTextEditors(()=>{const S=i.getVisibleTextEditors();for(const v of this._insets.values())S.indexOf(v.editor)<0&&v.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,i,P,S,v){let d;for(const o of this._editors.getVisibleTextEditors())if(o===I){d=o;break}if(!d)throw new Error("not a visible editor");const a=this,m=this._handlePool++,p=new b.Emitter,f=new b.Emitter,c=new class{constructor(){this._uuid=T.generateUuid(),this._html="",this._options=Object.create(null)}asWebviewUri(o){return A.asWebviewUri(a._initData,this._uuid,o)}get cspSource(){return a._initData.webviewCspSource}set options(o){this._options=o,a._proxy.$setOptions(m,o)}get options(){return this._options}set html(o){this._html=o,a._proxy.$setHtml(m,o)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(o){return a._proxy.$postMessage(m,o)}},n=new class{constructor(){this.editor=I,this.line=i,this.height=P,this.webview=c,this.onDidDispose=f.event}dispose(){a._insets.has(m)&&(a._insets.delete(m),a._proxy.$disposeEditorInset(m),f.fire(),f.dispose(),p.dispose())}};return this._proxy.$createEditorInset(m,d.id,d.document.uri,i+1,P,S||{},v.identifier,v.extensionLocation),this._insets.set(m,{editor:I,inset:n,onDidReceiveMessage:p}),n}$onDidDispose(I){const i=this._insets.get(I);i&&i.inset.dispose()}$onDidReceiveMessage(I,i){const P=this._insets.get(I);P&&P.onDidReceiveMessage.fire(i)}}e.ExtHostEditorInsets=E}),define(ve[155],_e([0,1,3,64,133,4,6,22,30,11,50,24,46,149]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=d.registerIcon("default-view-icon",v.Codicon.window,A.localize(0,null));var a;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var m;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel"})(m=e.ViewContainerLocation||(e.ViewContainerLocation={}));function p(u){switch(u){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=p;class f extends E.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new b.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new b.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return i.flatten([...this.viewContainers.values()])}registerViewContainer(r,g,C){const _=this.get(r.id);if(_)return _;const D=r;return k.getOrSet(this.viewContainers,g,[]).push(D),C&&this.defaultViewContainers.push(D),this._onDidRegister.fire({viewContainer:D,viewContainerLocation:g}),D}deregisterViewContainer(r){for(const g of this.viewContainers.keys()){const C=this.viewContainers.get(g),_=C==null?void 0:C.indexOf(r);if(_!==-1){C==null||C.splice(_,1),C.length===0&&this.viewContainers.delete(g),this._onDidDeregister.fire({viewContainer:r,viewContainerLocation:g});return}}}get(r){return this.all.filter(g=>g.id===r)[0]}getViewContainers(r){return[...this.viewContainers.get(r)||[]]}getViewContainerLocation(r){return[...this.viewContainers.keys()].filter(g=>this.getViewContainers(g).filter(C=>(C==null?void 0:C.id)===r.id).length>0)[0]}getDefaultViewContainer(r){return this.defaultViewContainers.find(g=>this.getViewContainerLocation(g)===r)}}I.Registry.add(a.ViewContainersRegistry,new f);var c;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(c=e.ViewContentGroups||(e.ViewContentGroups={}));function n(u,r){var g,C,_,D;const w=(g=u.group)!==null&&g!==void 0?g:c.More,O=(C=r.group)!==null&&C!==void 0?C:c.More;return w!==O?w.localeCompare(O):((_=u.order)!==null&&_!==void 0?_:5)-((D=r.order)!==null&&D!==void 0?D:5)}class o extends E.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new b.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new b.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new b.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new b.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new P.SetMap}registerViews(r,g){this.registerViews2([{views:r,viewContainer:g}])}registerViews2(r){r.forEach(({views:g,viewContainer:C})=>this.addViews(g,C)),this._onViewsRegistered.fire(r)}deregisterViews(r,g){const C=this.removeViews(r,g);C.length&&this._onViewsDeregistered.fire({views:C,viewContainer:g})}moveViews(r,g){for(const C of this._views.keys())if(C!==g){const _=this.removeViews(r,C);_.length&&(this.addViews(_,g),this._onDidChangeContainer.fire({views:_,from:C,to:g}))}}getViews(r){return this._views.get(r)||[]}getView(r){for(const g of this._viewContainers){const C=(this._views.get(g)||[]).filter(_=>_.id===r)[0];if(C)return C}return null}getViewContainer(r){for(const g of this._viewContainers)if((this._views.get(g)||[]).filter(_=>_.id===r)[0])return g;return null}registerViewWelcomeContent(r,g){return this._viewWelcomeContents.add(r,g),this._onDidChangeViewWelcomeContent.fire(r),E.toDisposable(()=>{this._viewWelcomeContents.delete(r,g),this._onDidChangeViewWelcomeContent.fire(r)})}getViewWelcomeContent(r){const g=[];return this._viewWelcomeContents.forEach(r,C=>g.push(C)),i.mergeSort(g,n),g}addViews(r,g){let C=this._views.get(g);C||(C=[],this._views.set(g,C),this._viewContainers.push(g));for(const _ of r){if(this.getView(_.id)!==null)throw new Error(A.localize(1,null,_.id));C.push(_)}}removeViews(r,g){const C=this._views.get(g);if(!C)return[];const _=[],D=[];for(const w of C)r.includes(w)?_.push(w):D.push(w);return _.length&&(D.length?this._views.set(g,D):(this._views.delete(g),this._viewContainers.splice(this._viewContainers.indexOf(g),1))),_}}I.Registry.add(a.ViewsRegistry,new o),e.IViewsService=T.createDecorator("viewsService"),e.FocusedViewContext=new y.RawContextKey("focusedView","");function h(u){return`view.${u}.visible`}e.getVisbileViewContextKey=h,e.IViewDescriptorService=T.createDecorator("viewDescriptorService");var t;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(t=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class l{constructor(r,g){this.resolved=!1,this._hasResolve=!1,S.mixin(this,r),this._hasResolve=!!g,this.resolve=async C=>{var _,D;if(g&&!this.resolved){const w=await g(C);w&&(this.tooltip=(_=this.tooltip)!==null&&_!==void 0?_:w.tooltip,this.command=(D=this.command)!==null&&D!==void 0?D:w.command)}C.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=l}),define(ve[156],_e([0,1,2,140,150,17,141,155]),function(se,e,b,y,A,T,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function I(m){return(p,...f)=>m(p.get(y.ICommandService),...f)}class i{static execute(p,f){const c={forceReuseWindow:f&&f.reuseWindow,remoteAuthority:f&&f.remoteAuthority};return p.executeCommand("_files.newWindow",c)}}e.NewWindowAPICommand=i,i.ID="vscode.newWindow",y.CommandsRegistry.registerCommand({id:i.ID,handler:I(i.execute),description:{description:"Opens an new window",args:[]}}),y.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(m,p){return m.get(A.IWorkspacesService).removeRecentlyOpened([p])});class P{static execute(p,f){return typeof f=="string"?f=f.match(/^[^:/?#]+:\/\//)?b.URI.parse(f):b.URI.file(f):f=b.URI.revive(f),p.executeCommand("_workbench.removeFromRecentlyOpened",f)}}e.RemoveFromRecentlyOpenedAPICommand=P,P.ID="vscode.removeFromRecentlyOpened",y.CommandsRegistry.registerCommand(P.ID,I(P.execute));class S{static execute(p,f){const c=typeof f=="string"?{extensionId:f}:f;return p.executeCommand("workbench.action.openIssueReporter",c)}}e.OpenIssueReporter=S,S.ID="vscode.openIssueReporter",y.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(m,p){const f=m.get(A.IWorkspacesService);let c;const n=p.uri,o=p.label;return p.type==="workspace"?c={workspace:await f.getWorkspaceIdentifier(n),label:o}:p.type==="folder"?c={folderUri:n,label:o}:c={fileUri:n,label:o},f.addRecentlyOpened([c])}),y.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(m){return m.get(A.IWorkspacesService).getRecentlyOpened()}),y.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(m,p){const f=m.get(T.ILogService),c=m.get(E.IEnvironmentService);c.isExtensionDevelopment&&!!c.extensionTestsLocationURI&&f.setLevel(p)}),y.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(m){return m.get(T.ILogService).getLevel()}),y.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(m,p){const f=m.get(k.IViewDescriptorService),c=f.getViewContainerById(p.destinationId);if(!!c){for(const n of p.viewIds){const o=f.getViewDescriptorById(n);(o==null?void 0:o.canMoveView)&&f.moveViewsToContainer([o],c,k.ViewVisibilityState.Default)}await m.get(k.IViewsService).openViewContainer(c.id,!0)}});class v{static execute(p,f){return!Array.isArray(f==null?void 0:f.viewIds)||typeof(f==null?void 0:f.destinationId)!="string"?Promise.reject("Invalid arguments"):p.executeCommand("_workbench.action.moveViews",f)}}e.MoveViewsAPICommand=v,v.ID="vscode.moveViews",y.CommandsRegistry.registerCommand({id:v.ID,handler:I(v.execute),description:{description:"Move Views",args:[]}});class d{static execute(p,f){return p.executeCommand("_workbench.open",f)}}d.ID="vscode.open",y.CommandsRegistry.registerCommand(d.ID,I(d.execute));class a{static execute(p,f,c,n,o){return p.executeCommand("_workbench.diff",[f,c,n])}}a.ID="vscode.diff",y.CommandsRegistry.registerCommand(a.ID,I(a.execute))}),define(ve[157],_e([0,1,3,15,134]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new b.Emitter,this._onExit=new b.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,I,i,P){const S={command:k};if(I&&Object.keys(I).length>0&&(S.arguments=I),this.internalSend("request",S),typeof P=="number"){const v=setTimeout(()=>{clearTimeout(v);const d=this.pendingRequests.get(S.seq);if(d){this.pendingRequests.delete(S.seq);const a={type:"response",seq:0,request_seq:S.seq,success:!1,command:k,message:A.localize(0,null,P,k)};d(a)}},P)}return i&&this.pendingRequests.set(S.seq,i),S.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,I){return k.type!=="event"||I.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await y.timeout(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const I=k,i=this.pendingRequests.get(I.request_seq);i&&(this.pendingRequests.delete(I.request_seq),i(I));break}}}internalSend(k,I){I.type=k,I.seq=this.sequence++,this.sendMessage(I)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((I,i)=>k.set(i,I)),await y.timeout(500),k.forEach((I,i)=>{I({type:"response",seq:0,request_seq:i,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(i)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(ve[158],_e([0,1,8,2,10,24,16]),function(se,e,b,y,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function I(s,l,u){return s.replace(k,function(r,g){return l&&g.length>0&&g[0]!=="_"?r:u&&u.hasOwnProperty(g)?u[g]:r})}e.formatPII=I;function i(s){const l={};for(const u of Object.keys(s))u.startsWith("!")||(l[u]=s[u]);return l}e.filterExceptionsFromTelemetry=i;function P(s){return s.configuration.request==="attach"&&!S(s)}e.isSessionAttach=P;function S(s){let l=s.configuration.type;if(!!l)return l==="vslsShare"&&(l=s.configuration.adapterProxy.configuration.type),b.equalsIgnoreCase(l,"extensionhost")||b.equalsIgnoreCase(l,"pwa-extensionhost")?s:s.parentSession?S(s.parentSession):void 0}e.getExtensionHostDebugSession=S;function v(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=v;function d(s,l,u){let r,g=0,C=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,_=null;for(;_=C.exec(s);){let D=_.index+1,w=D+_[0].length;if(D<=l&&w>=u){r=_[0],g=D;break}}if(r){let D=/\w+/g,w=null;for(;(w=D.exec(r))&&!(w.index+1+g+w[0].length>=u););w&&(r=r.substring(0,D.lastIndex))}return r?{start:g,end:g+r.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(s){return!!(s&&s.match(a))}e.isUri=m;function p(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(m(s.path))return y.URI.parse(s.path);if(A.isAbsolute(s.path))return y.URI.file(s.path)}return s.path}function f(s){if(typeof s.path=="object"){const l=y.URI.revive(s.path);if(l)return l.scheme===E.Schemas.file?l.fsPath:l.toString()}return s.path}function c(s,l){const u=l?p:f,r=T.deepClone(s);return o(r,(g,C)=>{g&&C&&(C.path=u(C))}),r}e.convertToDAPaths=c;function n(s,l){const u=l?p:f,r=T.deepClone(s);return o(r,(g,C)=>{!g&&C&&(C.path=u(C))}),r}e.convertToVSCPaths=n;function o(s,l){switch(s.type){case"event":const u=s;switch(u.event){case"output":l(!1,u.body.source);break;case"loadedSource":l(!1,u.body.source);break;case"breakpoint":l(!1,u.body.breakpoint.source);break;default:break}break;case"request":const r=s;switch(r.command){case"setBreakpoints":l(!0,r.arguments.source);break;case"breakpointLocations":l(!0,r.arguments.source);break;case"source":l(!0,r.arguments.source);break;case"gotoTargets":l(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(C=>l(!1,C));break;default:break}break;case"response":const g=s;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(C=>l(!1,C.source));break;case"loadedSources":g.body.sources.forEach(C=>l(!1,C));break;case"scopes":g.body.scopes.forEach(C=>l(!1,C.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(C=>l(!1,C.source));break;case"setBreakpoints":g.body.breakpoints.forEach(C=>l(!1,C.source));break;default:break}break}}function h(s){return s.filter(l=>{var u;return!((u=l.presentation)===null||u===void 0?void 0:u.hidden)}).sort((l,u)=>l.presentation?u.presentation?l.presentation.group?u.presentation.group?l.presentation.group!==u.presentation.group?l.presentation.group.localeCompare(u.presentation.group):t(l.presentation.order,u.presentation.order):-1:u.presentation.group?1:t(l.presentation.order,u.presentation.order):-1:u.presentation?1:0)}e.getVisibleAndSorted=h;function t(s,l){return typeof s!="number"?typeof l!="number"?0:1:typeof l!="number"?-1:s-l}}),define(ve[33],_e([0,1,29,26,16,10,21,64]),function(se,e,b,y,A,T,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellStatusbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.NotebookCellsChangeType=e.addIdToOutput=e.isTransformedDisplayOutput=e.MimeTypeRendererResolver=e.NotebookCellRunState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellOutputKind=e.CellKind=void 0;var I;(function(D){D[D.Markdown=1]="Markdown",D[D.Code=2]="Code"})(I=e.CellKind||(e.CellKind={}));var i;(function(D){D[D.Text=1]="Text",D[D.Error=2]="Error",D[D.Rich=3]="Rich"})(i=e.CellOutputKind||(e.CellOutputKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(D){D[D.Running=1]="Running",D[D.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,runnable:!0,cellEditable:!0,cellRunnable:!0,cellHasExecutionOrder:!0,displayOrder:e.NOTEBOOK_DISPLAY_ORDER,custom:{},runState:P.Idle,languages:[],trusted:!0};var S;(function(D){D[D.Running=1]="Running",D[D.Idle=2]="Idle",D[D.Success=3]="Success",D[D.Error=4]="Error"})(S=e.NotebookCellRunState||(e.NotebookCellRunState={}));var v;(function(D){D[D.Core=0]="Core",D[D.Active=1]="Active",D[D.Lazy=2]="Lazy"})(v=e.MimeTypeRendererResolver||(e.MimeTypeRendererResolver={}));function d(D){return D.outputKind===i.Rich&&!!D.outputId}e.isTransformedDisplayOutput=d;const a=(D,w=y.generateUuid())=>D.outputKind===i.Rich?Object.assign(Object.assign({},D),{outputId:w}):D;e.addIdToOutput=a;var m;(function(D){D[D.ModelChange=1]="ModelChange",D[D.Move=2]="Move",D[D.CellClearOutput=3]="CellClearOutput",D[D.CellsClearOutput=4]="CellsClearOutput",D[D.ChangeLanguage=5]="ChangeLanguage",D[D.Initialize=6]="Initialize",D[D.ChangeCellMetadata=7]="ChangeCellMetadata",D[D.Output=8]="Output",D[D.ChangeCellContent=9]="ChangeCellContent",D[D.ChangeDocumentMetadata=10]="ChangeDocumentMetadata",D[D.Unknown=11]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var p;(function(D){D[D.Replace=1]="Replace",D[D.Output=2]="Output",D[D.Metadata=3]="Metadata",D[D.CellLanguage=4]="CellLanguage",D[D.DocumentMetadata=5]="DocumentMetadata",D[D.OutputsSplice=6]="OutputsSplice",D[D.Move=7]="Move",D[D.Unknown=8]="Unknown",D[D.CellContent=9]="CellContent"})(p=e.CellEditType||(e.CellEditType={}));function f(D){const w=c.parse(D);return w?w.notebook.toString():D.toString()}e.getCellUndoRedoComparisonKey=f;var c;(function(D){D.scheme=A.Schemas.vscodeNotebookCell;const w=/^ch(\d{7,})/;function O(z,U){return z.with({scheme:D.scheme,fragment:`ch${U.toString().padStart(7,"0")}${z.scheme!==A.Schemas.file?z.scheme:""}`})}D.generate=O;function R(z){if(z.scheme===D.scheme){const U=w.exec(z.fragment);if(!!U)return{handle:Number(U[1]),notebook:z.with({scheme:z.fragment.substr(U[0].length)||A.Schemas.file,fragment:null})}}}D.parse=R;function $(z,U){return z.with({scheme:A.Schemas.vscodeNotebookCellMetadata,fragment:`ch${U.toString().padStart(7,"0")}${z.scheme!==A.Schemas.file?z.scheme:""}`})}D.generateCellMetadataUri=$;function V(z){if(z.scheme===A.Schemas.vscodeNotebookCellMetadata){const U=w.exec(z.fragment);if(!!U)return{handle:Number(U[1]),notebook:z.with({scheme:z.fragment.substr(U[0].length)||A.Schemas.file,fragment:null})}}}D.parseCellMetadataUri=V})(c=e.CellUri||(e.CellUri={}));function n(D){return["application/json","text/markdown","image/png","text/plain"].indexOf(D)>-1}e.mimeTypeIsAlwaysSecure=n;function o(D){return["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain","text/x-javascript"].indexOf(D)>-1}e.mimeTypeSupportedByCore=o;function h(D,w){return E.isWindows&&(D=D.replace(/\//g,"\\"),w=w.replace(/\//g,"\\")),b.match(D,w)}function t(D,w,O,R){let $=0;for(let V=0;V<w.length;V++){if(h(w[V],D))return $;$++}for(let V=0;V<O.length;V++){if(h(O[V],D))return $;$++}for(let V=0;V<R.length;V++){if(h(R[V],D))return $;$++}return $}function s(D,w,O,R){return D.sort((V,z)=>t(V,w,O,R)-t(z,w,O,R))}e.sortMimeTypes=s;function l(D,w,O,R=($,V)=>$===V){const $=[];function V(q,M,j){if(!(M===0&&j.length===0)){const re=$[$.length-1];re&&re.start+re.deleteCount===q?(re.deleteCount+=M,re.toInsert.push(...j)):$.push({start:q,deleteCount:M,toInsert:j})}}let z=0,U=0;for(;;){if(z===D.length){V(z,0,w.slice(U));break}if(U===w.length){V(z,D.length-z,[]);break}const q=D[z],M=w[U];if(R(q,M)){z+=1,U+=1;continue}O(M)?(V(z,1,[]),z+=1):(V(z,0,[M]),U+=1)}return $}e.diff=l,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new k.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var u;(function(D){D.default="default",D.option="option"})(u=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(D){const w=D;return!!((typeof w.include=="string"||b.isRelativePattern(w.include))&&(typeof w.exclude=="string"||b.isRelativePattern(w.exclude)))}e.isDocumentExcludePattern=r;function g(D,w,O){if(Array.isArray(D.viewType)&&D.viewType.indexOf(w)>=0||D.viewType===w)return!0;if(D.filenamePattern){let R=r(D.filenamePattern)?D.filenamePattern.include:D.filenamePattern,$=r(D.filenamePattern)?D.filenamePattern.exclude:void 0;if(b.match(R,T.basename(O.fsPath).toLowerCase()))return!($&&b.match($,T.basename(O.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=g;class C{constructor(w){this.textModel=w}getElements(){const w=new Int32Array(this.textModel.cells.length);for(let O=0;O<this.textModel.cells.length;O++)w[O]=this.textModel.cells[O].getHashValue();return w}}e.CellSequence=C,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview";var _;(function(D){D[D.LEFT=0]="LEFT",D[D.RIGHT=1]="RIGHT"})(_=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}))}),define(ve[159],_e([0,1,3,56,6,16,23,2,26,33,68]),function(se,e,b,y,A,T,E,k,I,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;function S(p){const f=new b.Emitter;return{proxy:new Proxy(p,{set(n,o,h,t){return n[o]=h,f.fire(),!0}}),onDidChange:f.event}}class v{constructor(f,c,n,o){this.start=f,this.deletedCount=c,this.deletedItems=n,this.items=o}static asApiEvent(f){return Object.freeze({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems.map(c=>c.cell),items:f.items.map(c=>c.cell)})}}class d extends A.Disposable{constructor(f,c,n,o){var h;super();this._mainThreadBulkEdits=f,this._notebook=c,this._extHostDocument=n,this._cellData=o,this._onDidDispose=new b.Emitter,this.onDidDispose=this._onDidDispose.event,this._onDidChangeOutputs=new b.Emitter,this.onDidChangeOutputs=this._onDidChangeOutputs.event,this._outputMapping=new WeakMap,this.handle=o.handle,this.uri=k.URI.revive(o.uri),this.cellKind=o.cellKind,this._outputs=o.outputs;for(const s of this._outputs)this._outputMapping.set(s,s.outputId),delete s.outputId;const t=S((h=o.metadata)!==null&&h!==void 0?h:{});this._metadata=t.proxy,this._metadataChangeListener=this._register(t.onDidChange(()=>{this._updateMetadata()}))}static asModelAddData(f,c){return{EOL:c.eol,lines:c.source,modeId:c.language,uri:c.uri,isDirty:!1,versionId:1,notebook:f}}get cell(){if(!this._cell){const f=this,c=this._extHostDocument.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return f._notebook.getCellIndex(f)},notebook:f._notebook.notebookDocument,uri:f.uri,cellKind:this._cellData.cellKind,document:c.document,get language(){return c.document.languageId},get outputs(){return f._outputs},set outputs(n){f._updateOutputs(n)},get metadata(){return f._metadata},set metadata(n){f.setMetadata(n),f._updateMetadata()}})}return this._cell}dispose(){super.dispose(),this._onDidDispose.fire()}setOutputs(f){this._outputs=f}_updateOutputs(f){const n=i.diff(this._outputs||[],f||[],o=>this._outputMapping.has(o)).map(o=>{for(let h=o.start;h<o.start+o.deleteCount;h++)this._outputMapping.delete(this._outputs[h]);return{deleteCount:o.deleteCount,start:o.start,toInsert:o.toInsert.map(h=>{if(h.outputKind===i.CellOutputKind.Rich){const t=I.generateUuid();return this._outputMapping.set(h,t),Object.assign(Object.assign({},h),{outputId:t})}return this._outputMapping.set(h,void 0),h})}});this._outputs=f,this._onDidChangeOutputs.fire(n)}setMetadata(f){this._metadataChangeListener.dispose();const c=S(f);this._metadata=c.proxy,this._metadataChangeListener=this._register(c.onDidChange(()=>{this._updateMetadata()}))}_updateMetadata(){const f=this._notebook.notebookDocument.cells.indexOf(this.cell),c={_type:3,metadata:void 0,resource:this._notebook.uri,notebookVersionId:this._notebook.notebookDocument.version,edit:{editType:3,index:f,metadata:this._metadata}};return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit({edits:[c]})}}e.ExtHostCell=d;function a(p){const f=p.scheme===T.Schemas.file||p.scheme===T.Schemas.untitled?p.fsPath:p.toString();return y.hash(f)+""}class m extends A.Disposable{constructor(f,c,n,o,h,t,s,l,u){super();this._proxy=f,this._documentsAndEditors=c,this._mainThreadBulkEdits=n,this._emitter=o,this._viewType=h,this._contentOptions=t,this.uri=l,this._storagePath=u,this.handle=m._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._backupCounter=1,this._disposed=!1,this._languages=[],this._edits=new P.Cache("notebook documents");const r=S(s);this._metadata=r.proxy,this._metadataChangeListener=this._register(r.onDidChange(()=>{this._tryUpdateMetadata()}))}dispose(){this._disposed=!0,super.dispose(),A.dispose(this._cellDisposableMapping.values())}_updateMetadata(f){this._metadataChangeListener.dispose(),f=Object.assign(Object.assign({},i.notebookDocumentMetadataDefaults),f),this._metadataChangeListener&&this._metadataChangeListener.dispose();const c=S(f);this._metadata=c.proxy,this._metadataChangeListener=this._register(c.onDidChange(()=>{this._tryUpdateMetadata()})),this._tryUpdateMetadata()}_tryUpdateMetadata(){const f={_type:3,metadata:void 0,edit:{editType:5,metadata:this._metadata},resource:this.uri,notebookVersionId:this.notebookDocument.version};return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit({edits:[f]})}get notebookDocument(){if(!this._notebook){const f=this;this._notebook=Object.freeze({get uri(){return f.uri},get version(){return f._versionId},get fileName(){return f.uri.fsPath},get viewType(){return f._viewType},get isDirty(){return f._isDirty},get isUntitled(){return f.uri.scheme===T.Schemas.untitled},get cells(){return f._cells.map(c=>c.cell)},get languages(){return f._languages},set languages(c){f._trySetLanguages(c)},get metadata(){return f._metadata},set metadata(c){f._updateMetadata(c)},get contentOptions(){return f._contentOptions}})}return this._notebook}_trySetLanguages(f){this._languages=f,this._proxy.$updateNotebookLanguages(this._viewType,this.uri,this._languages)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const f=a(this.uri)+this._backupCounter++;return E.joinPath(this._storagePath,f)}updateBackup(f){var c;(c=this._backup)===null||c===void 0||c.delete(),this._backup=f}disposeBackup(){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(f){const c=Object.assign(Object.assign({},i.notebookDocumentMetadataDefaults),f.metadata);this._metadataChangeListener&&this._metadataChangeListener.dispose();const n=S(c);this._metadata=n.proxy,this._metadataChangeListener=this._register(n.onDidChange(()=>{this._tryUpdateMetadata()})),this._emitter.emitDocumentMetadataChange({document:this.notebookDocument})}acceptModelChanged(f,c){this._versionId=f.versionId,this._isDirty=c,f.rawEvents.forEach(n=>{n.kind===i.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(n.changes,!0),n.kind===i.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(n.changes,!1):n.kind===i.NotebookCellsChangeType.Move?this._moveCell(n.index,n.newIdx):n.kind===i.NotebookCellsChangeType.Output?this._setCellOutputs(n.index,n.outputs):n.kind===i.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(n.index,n.language):n.kind===i.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(n.index,n.metadata)})}_spliceNotebookCells(f,c){if(!this._disposed){const n=[],o=[],h=[];f.reverse().forEach(t=>{var s;const u=t[2].map(g=>{const C=new d(this._mainThreadBulkEdits,this,this._documentsAndEditors,g);if(c||o.push(d.asModelAddData(this.notebookDocument,g)),!this._cellDisposableMapping.has(C.handle)){const D=new A.DisposableStore;D.add(C),this._cellDisposableMapping.set(C.handle,D)}return this._cellDisposableMapping.get(C.handle).add(C.onDidChangeOutputs(D=>{this.eventuallyUpdateCellOutputs(C,D)})),C});for(let g=t[0];g<t[0]+t[1];g++)(s=this._cellDisposableMapping.get(this._cells[g].handle))===null||s===void 0||s.dispose(),this._cellDisposableMapping.delete(this._cells[g].handle);const r=this._cells.splice(t[0],t[1],...u);for(let g of r)h.push(g.uri);n.push(new v(t[0],t[1],r,u))}),this._documentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:o,removedDocuments:h}),c||this._emitter.emitModelChange({document:this.notebookDocument,changes:n.map(v.asApiEvent)})}}_moveCell(f,c){const n=this._cells.splice(f,1);this._cells.splice(c,0,...n);const o=[{start:f,deletedCount:1,deletedItems:n.map(h=>h.cell),items:[]},{start:c,deletedCount:0,deletedItems:[],items:n.map(h=>h.cell)}];this._emitter.emitModelChange({document:this.notebookDocument,changes:o})}_setCellOutputs(f,c){const n=this._cells[f];n.setOutputs(c),this._emitter.emitCellOutputsChange({document:this.notebookDocument,cells:[n.cell]})}_changeCellLanguage(f,c){const n=this._cells[f],o={document:this.notebookDocument,cell:n.cell,language:c};this._emitter.emitCellLanguageChange(o)}_changeCellMetadata(f,c){const n=this._cells[f];n.setMetadata(c||{});const o={document:this.notebookDocument,cell:n.cell};this._emitter.emitCellMetadataChange(o)}async eventuallyUpdateCellOutputs(f,c){const n=c.map(o=>{const h=o.toInsert;return[o.start,o.deleteCount,h]});!n.length||(await this._proxy.$spliceNotebookCellOutputs(this._viewType,this.uri,f.handle,n),this._emitter.emitCellOutputsChange({document:this.notebookDocument,cells:[f.cell]}))}getCell(f){return this._cells.find(c=>c.handle===f)}getCellIndex(f){return this._cells.indexOf(f)}addEdit(f){return this._edits.add([f])}async undo(f,c){await this.getEdit(f).undo()}async redo(f,c){await this.getEdit(f).redo()}getEdit(f){const c=this._edits.get(f,0);if(!c)throw new Error("No edit found");return c}disposeEdits(f){for(const c of f)this._edits.delete(c)}}e.ExtHostNotebookDocument=m,m._handlePool=0});var Xe=this&&this.__classPrivateFieldSet||function(se,e,b){if(!e.has(se))throw new TypeError("attempted to set private field on non-instance");return e.set(se,b),b},Ue=this&&this.__classPrivateFieldGet||function(se,e){if(!e.has(se))throw new TypeError("attempted to get private field on non-instance");return e.get(se)};define(ve[7],_e([0,1,11,9,81,22,12,2,26,65,91,33]),function(se,e,b,y,A,T,E,k,I,i,P,S){"use strict";var v,d,a,m,p,f,c,n,o,h,t,s,l,u,r,g,C,_,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TestState=e.TestMessageSeverity=e.TestRunState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookRunState=e.NotebookCellRunState=e.CellOutputKind=e.CellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTrigger=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function w(W){function N(){return Reflect.construct(W,arguments,this.constructor)}return Object.defineProperty(N,"name",Object.getOwnPropertyDescriptor(W,"name")),Object.setPrototypeOf(N,W),Object.setPrototypeOf(N.prototype,W.prototype),N}let O=f=class{constructor(N){v.set(this,void 0),Xe(this,v,N)}static from(...N){let oe=N;return new f(function(){if(oe){for(const Ie of oe)Ie&&typeof Ie.dispose=="function"&&Ie.dispose();oe=void 0}})}dispose(){typeof Ue(this,v)=="function"&&(Ue(this,v).call(this),Xe(this,v,void 0))}};v=new WeakMap,O=f=He([w],O),e.Disposable=O;let R=c=class{constructor(N,oe){if(N<0)throw y.illegalArgument("line must be non-negative");if(oe<0)throw y.illegalArgument("character must be non-negative");this._line=N,this._character=oe}static Min(...N){if(N.length===0)throw new TypeError;let oe=N[0];for(let Ie=1;Ie<N.length;Ie++){const Ve=N[Ie];Ve.isBefore(oe)&&(oe=Ve)}return oe}static Max(...N){if(N.length===0)throw new TypeError;let oe=N[0];for(let Ie=1;Ie<N.length;Ie++){const Ve=N[Ie];Ve.isAfter(oe)&&(oe=Ve)}return oe}static isPosition(N){if(!N)return!1;if(N instanceof c)return!0;let{line:oe,character:Ie}=N;return typeof oe=="number"&&typeof Ie=="number"}get line(){return this._line}get character(){return this._character}isBefore(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<N._character}isBeforeOrEqual(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<=N._character}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this._line===N._line&&this._character===N._character}compareTo(N){return this._line<N._line?-1:this._line>N.line?1:this._character<N._character?-1:this._character>N._character?1:0}translate(N,oe=0){if(N===null||oe===null)throw y.illegalArgument();let Ie;return typeof N=="undefined"?Ie=0:typeof N=="number"?Ie=N:(Ie=typeof N.lineDelta=="number"?N.lineDelta:0,oe=typeof N.characterDelta=="number"?N.characterDelta:0),Ie===0&&oe===0?this:new c(this.line+Ie,this.character+oe)}with(N,oe=this.character){if(N===null||oe===null)throw y.illegalArgument();let Ie;return typeof N=="undefined"?Ie=this.line:typeof N=="number"?Ie=N:(Ie=typeof N.line=="number"?N.line:this.line,oe=typeof N.character=="number"?N.character:this.character),Ie===this.line&&oe===this.character?this:new c(Ie,oe)}toJSON(){return{line:this.line,character:this.character}}};R=c=He([w],R),e.Position=R;let $=n=class{constructor(N,oe,Ie,Ve){let Je,nt;if(typeof N=="number"&&typeof oe=="number"&&typeof Ie=="number"&&typeof Ve=="number"?(Je=new R(N,oe),nt=new R(Ie,Ve)):N instanceof R&&oe instanceof R&&(Je=N,nt=oe),!Je||!nt)throw new Error("Invalid arguments");Je.isBefore(nt)?(this._start=Je,this._end=nt):(this._start=nt,this._end=Je)}static isRange(N){return N instanceof n?!0:N?R.isPosition(N.start)&&R.isPosition(N.end):!1}get start(){return this._start}get end(){return this._end}contains(N){return N instanceof n?this.contains(N._start)&&this.contains(N._end):N instanceof R?!(N.isBefore(this._start)||this._end.isBefore(N)):!1}isEqual(N){return this._start.isEqual(N._start)&&this._end.isEqual(N._end)}intersection(N){const oe=R.Max(N.start,this._start),Ie=R.Min(N.end,this._end);if(!oe.isAfter(Ie))return new n(oe,Ie)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const oe=R.Min(N.start,this._start),Ie=R.Max(N.end,this.end);return new n(oe,Ie)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(N,oe=this.end){if(N===null||oe===null)throw y.illegalArgument();let Ie;return N?R.isPosition(N)?Ie=N:(Ie=N.start||this.start,oe=N.end||this.end):Ie=this.start,Ie.isEqual(this._start)&&oe.isEqual(this.end)?this:new n(Ie,oe)}toJSON(){return[this.start,this.end]}};$=n=He([w],$),e.Range=$;let V=o=class extends ${constructor(N,oe,Ie,Ve){let Je,nt;if(typeof N=="number"&&typeof oe=="number"&&typeof Ie=="number"&&typeof Ve=="number"?(Je=new R(N,oe),nt=new R(Ie,Ve)):N instanceof R&&oe instanceof R&&(Je=N,nt=oe),!Je||!nt)throw new Error("Invalid arguments");super(Je,nt);this._anchor=Je,this._active=nt}static isSelection(N){return N instanceof o?!0:N?$.isRange(N)&&R.isPosition(N.anchor)&&R.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};V=o=He([w],V),e.Selection=V;class z{constructor(N,oe,Ie){if(typeof N!="string"||N.length===0)throw y.illegalArgument("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw y.illegalArgument("port");if(typeof Ie!="undefined"&&(typeof Ie!="string"||Ie.length===0||!/^[0-9A-Za-z\-]+$/.test(Ie)))throw y.illegalArgument("connectionToken");this.host=N,this.port=Math.round(oe),this.connectionToken=Ie}}e.ResolvedAuthority=z;class U extends Error{constructor(N,oe=P.RemoteAuthorityResolverErrorCode.Unknown,Ie){super(N);this._message=N,this._code=oe,this._detail=Ie,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype)}static NotAvailable(N,oe){return new U(N,P.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(N){return new U(N,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=U;var q;(function(W){W[W.LF=1]="LF",W[W.CRLF=2]="CRLF"})(q=e.EndOfLine||(e.EndOfLine={}));var M;(function(W){W[W.Replace=1]="Replace",W[W.Append=2]="Append",W[W.Prepend=3]="Prepend"})(M=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let j=h=class{constructor(N,oe){this._range=N,this._newText=oe}static isTextEdit(N){return N instanceof h?!0:N?$.isRange(N)&&typeof N.newText=="string":!1}static replace(N,oe){return new h(N,oe)}static insert(N,oe){return h.replace(new $(N,N),oe)}static delete(N){return h.replace(N,"")}static setEndOfLine(N){const oe=new h(new $(new R(0,0),new R(0,0)),"");return oe.newEol=N,oe}get range(){return this._range}set range(N){if(N&&!$.isRange(N))throw y.illegalArgument("range");this._range=N}get newText(){return this._newText||""}set newText(N){if(N&&typeof N!="string")throw y.illegalArgument("newText");this._newText=N}get newEol(){return this._newEol}set newEol(N){if(N&&typeof N!="number")throw y.illegalArgument("newEol");this._newEol=N}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};j=h=He([w],j),e.TextEdit=j;var re;(function(W){W[W.File=1]="File",W[W.Text=2]="Text",W[W.Cell=3]="Cell"})(re=e.FileEditType||(e.FileEditType={}));let F=class{constructor(){this._edits=new Array}_allEntries(){return this._edits}renameFile(N,oe,Ie,Ve){this._edits.push({_type:1,from:N,to:oe,options:Ie,metadata:Ve})}createFile(N,oe,Ie){this._edits.push({_type:1,from:void 0,to:N,options:oe,metadata:Ie})}deleteFile(N,oe,Ie){this._edits.push({_type:1,from:N,to:void 0,options:oe,metadata:Ie})}replaceNotebookMetadata(N,oe,Ie){this._edits.push({_type:3,metadata:Ie,uri:N,edit:{editType:5,metadata:Object.assign(Object.assign({},S.notebookDocumentMetadataDefaults),oe)},notebookMetadata:oe})}replaceNotebookCells(N,oe,Ie,Ve,Je){(oe!==Ie||Ve.length>0)&&this._edits.push({_type:3,metadata:Je,uri:N,edit:{editType:1,index:oe,count:Ie-oe,cells:Ve.map(nt=>Object.assign(Object.assign({},nt),{outputs:nt.outputs.map(Y=>S.addIdToOutput(Y))}))}})}replaceNotebookCellOutput(N,oe,Ie,Ve){this._edits.push({_type:3,metadata:Ve,uri:N,edit:{editType:2,index:oe,outputs:Ie.map(Je=>$t.isNotebookCellOutput(Je)?S.addIdToOutput(Je.toJSON()):S.addIdToOutput(Je))}})}replaceNotebookCellMetadata(N,oe,Ie,Ve){this._edits.push({_type:3,metadata:Ve,uri:N,edit:{editType:3,index:oe,metadata:Ie}})}replace(N,oe,Ie,Ve){this._edits.push({_type:2,uri:N,edit:new j(oe,Ie),metadata:Ve})}insert(N,oe,Ie,Ve){this.replace(N,new $(oe,oe),Ie,Ve)}delete(N,oe,Ie){this.replace(N,oe,"",Ie)}has(N){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===N.toString())}set(N,oe){if(oe)for(const Ie of oe)Ie&&this._edits.push({_type:2,uri:N,edit:Ie});else{for(let Ie=0;Ie<this._edits.length;Ie++){const Ve=this._edits[Ie];Ve._type===2&&Ve.uri.toString()===N.toString()&&(this._edits[Ie]=void 0)}b.coalesceInPlace(this._edits)}}get(N){const oe=[];for(let Ie of this._edits)Ie._type===2&&Ie.uri.toString()===N.toString()&&oe.push(Ie.edit);return oe}entries(){const N=new T.ResourceMap;for(let oe of this._edits)if(oe._type===2){let Ie=N.get(oe.uri);Ie||(Ie=[oe.uri,[]],N.set(oe.uri,Ie)),Ie[1].push(oe.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};F=He([w],F),e.WorkspaceEdit=F;let te=t=class{constructor(N){this._tabstop=1,this.value=N||""}static isSnippetString(N){return N instanceof t?!0:N?typeof N.value=="string":!1}static _escape(N){return N.replace(/\$|}|\\/g,"\\$&")}appendText(N){return this.value+=t._escape(N),this}appendTabstop(N=this._tabstop++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,oe=this._tabstop++){if(typeof N=="function"){const Ie=new t;Ie._tabstop=this._tabstop,N(Ie),this._tabstop=Ie._tabstop,N=Ie.value}else N=t._escape(N);return this.value+="${",this.value+=oe,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,oe=this._tabstop++){const Ie=N.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=Ie,this.value+="|}",this}appendVariable(N,oe){if(typeof oe=="function"){const Ie=new t;Ie._tabstop=this._tabstop,oe(Ie),this._tabstop=Ie._tabstop,oe=Ie.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};te=t=He([w],te),e.SnippetString=te;var ae;(function(W){W[W.Unnecessary=1]="Unnecessary",W[W.Deprecated=2]="Deprecated"})(ae=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(W){W[W.Hint=3]="Hint",W[W.Information=2]="Information",W[W.Warning=1]="Warning",W[W.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let we=s=class{constructor(N,oe){if(this.uri=N,oe)if(oe instanceof $)this.range=oe;else if(oe instanceof R)this.range=new $(oe,oe);else throw new Error("Illegal argument")}static isLocation(N){return N instanceof s?!0:N?$.isRange(N.range)&&k.URI.isUri(N.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};we=s=He([w],we),e.Location=we;let fe=class{constructor(N,oe){this.location=N,this.message=oe}static is(N){return N?typeof N.message=="string"&&N.location&&$.isRange(N.location.range)&&k.URI.isUri(N.location.uri):!1}static isEqual(N,oe){return N===oe?!0:!N||!oe?!1:N.message===oe.message&&N.location.range.isEqual(oe.location.range)&&N.location.uri.toString()===oe.location.uri.toString()}};fe=He([w],fe),e.DiagnosticRelatedInformation=fe;let De=class{constructor(N,oe,Ie=ue.Error){if(!$.isRange(N))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=N,this.message=oe,this.severity=Ie}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,oe){return N===oe?!0:!N||!oe?!1:N.message===oe.message&&N.severity===oe.severity&&N.code===oe.code&&N.severity===oe.severity&&N.source===oe.source&&N.range.isEqual(oe.range)&&b.equals(N.tags,oe.tags)&&b.equals(N.relatedInformation,oe.relatedInformation,fe.isEqual)}};De=He([w],De),e.Diagnostic=De;let Se=class{constructor(N,oe){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:A.isMarkdownString(N)?this.contents=[N]:this.contents=[N],this.range=oe}};Se=He([w],Se),e.Hover=Se;var Ce;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(Ce=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let x=class{constructor(N,oe=Ce.Text){this.range=N,this.kind=oe}toJSON(){return{range:this.range,kind:Ce[this.kind]}}};x=He([w],x),e.DocumentHighlight=x;var K;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(K=e.SymbolKind||(e.SymbolKind={}));var ee;(function(W){W[W.Deprecated=1]="Deprecated"})(ee=e.SymbolTag||(e.SymbolTag={}));let ne=l=class{constructor(N,oe,Ie,Ve,Je){this.name=N,this.kind=oe,this.containerName=Je,typeof Ie=="string"&&(this.containerName=Ie),Ve instanceof we?this.location=Ve:Ie instanceof $&&(this.location=new we(Ve,Ie)),l.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:K[this.kind],location:this.location,containerName:this.containerName}}};ne=l=He([w],ne),e.SymbolInformation=ne;let de=u=class{constructor(N,oe,Ie,Ve,Je){this.name=N,this.detail=oe,this.kind=Ie,this.range=Ve,this.selectionRange=Je,this.children=[],u.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children&&N.children.forEach(u.validate)}};de=u=He([w],de),e.DocumentSymbol=de;var Ee;(function(W){W[W.Automatic=1]="Automatic",W[W.Manual=2]="Manual"})(Ee=e.CodeActionTrigger||(e.CodeActionTrigger={}));let Re=class{constructor(N,oe){this.title=N,this.kind=oe}};Re=He([w],Re),e.CodeAction=Re;let xe=r=class{constructor(N){this.value=N}append(N){return new r(this.value?this.value+r.sep+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+r.sep)}};xe.sep=".",xe=r=He([w],xe),e.CodeActionKind=xe,xe.Empty=new xe(""),xe.QuickFix=xe.Empty.append("quickfix"),xe.Refactor=xe.Empty.append("refactor"),xe.RefactorExtract=xe.Refactor.append("extract"),xe.RefactorInline=xe.Refactor.append("inline"),xe.RefactorRewrite=xe.Refactor.append("rewrite"),xe.Source=xe.Empty.append("source"),xe.SourceOrganizeImports=xe.Source.append("organizeImports"),xe.SourceFixAll=xe.Source.append("fixAll");let be=class{constructor(N,oe){if(this.range=N,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};be=He([w],be),e.SelectionRange=be;class ke{constructor(N,oe,Ie,Ve,Je,nt){this.kind=N,this.name=oe,this.detail=Ie,this.uri=Ve,this.range=Je,this.selectionRange=nt}}e.CallHierarchyItem=ke;class Te{constructor(N,oe){this.fromRanges=oe,this.from=N}}e.CallHierarchyIncomingCall=Te;class Ne{constructor(N,oe){this.fromRanges=oe,this.to=N}}e.CallHierarchyOutgoingCall=Ne;let pe=class{constructor(N,oe){this.range=N,this.command=oe}get isResolved(){return!!this.command}};pe=He([w],pe),e.CodeLens=pe;let ze=g=class{constructor(N,oe=!1){d.set(this,void 0),Xe(this,d,new A.MarkdownString(N,{supportThemeIcons:oe}))}static isMarkdownString(N){return N instanceof g?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}get value(){return Ue(this,d).value}set value(N){Ue(this,d).value=N}get isTrusted(){return Ue(this,d).isTrusted}set isTrusted(N){Ue(this,d).isTrusted=N}get supportThemeIcons(){return Ue(this,d).supportThemeIcons}appendText(N){return Ue(this,d).appendText(N),this}appendMarkdown(N){return Ue(this,d).appendMarkdown(N),this}appendCodeblock(N,oe){return Ue(this,d).appendCodeblock(oe!=null?oe:"",N),this}};d=new WeakMap,ze=g=He([w],ze),e.MarkdownString=ze;let B=class{constructor(N,oe){this.label=N,this.documentation=oe}};B=He([w],B),e.ParameterInformation=B;let Z=class{constructor(N,oe){this.label=N,this.documentation=oe,this.parameters=[]}};Z=He([w],Z),e.SignatureInformation=Z;let he=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};he=He([w],he),e.SignatureHelp=he;var Le;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(Le=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));let Oe=class{constructor(N,oe,Ie,Ve,Je){this.text=N,this.range=oe,this.description=Ie,this.whitespaceBefore=Ve,this.whitespaceAfter=Je}};Oe=He([w],Oe),e.InlineHint=Oe;var We;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(We=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function(W){W[W.Text=0]="Text",W[W.Method=1]="Method",W[W.Function=2]="Function",W[W.Constructor=3]="Constructor",W[W.Field=4]="Field",W[W.Variable=5]="Variable",W[W.Class=6]="Class",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Unit=10]="Unit",W[W.Value=11]="Value",W[W.Enum=12]="Enum",W[W.Keyword=13]="Keyword",W[W.Snippet=14]="Snippet",W[W.Color=15]="Color",W[W.File=16]="File",W[W.Reference=17]="Reference",W[W.Folder=18]="Folder",W[W.EnumMember=19]="EnumMember",W[W.Constant=20]="Constant",W[W.Struct=21]="Struct",W[W.Event=22]="Event",W[W.Operator=23]="Operator",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue"})(Ke=e.CompletionItemKind||(e.CompletionItemKind={}));var ie;(function(W){W[W.Deprecated=1]="Deprecated"})(ie=e.CompletionItemTag||(e.CompletionItemTag={}));let ge=class{constructor(N,oe){this.label=N,this.kind=oe}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ge=He([w],ge),e.CompletionItem=ge;let Me=class{constructor(N=[],oe=!1){this.items=N,this.isIncomplete=oe}};Me=He([w],Me),e.CompletionList=Me;var G;(function(W){W[W.Active=-1]="Active",W[W.Beside=-2]="Beside",W[W.One=1]="One",W[W.Two=2]="Two",W[W.Three=3]="Three",W[W.Four=4]="Four",W[W.Five=5]="Five",W[W.Six=6]="Six",W[W.Seven=7]="Seven",W[W.Eight=8]="Eight",W[W.Nine=9]="Nine"})(G=e.ViewColumn||(e.ViewColumn={}));var Q;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(Q=e.StatusBarAlignment||(e.StatusBarAlignment={}));var H;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative"})(H=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var L;(function(W){W[W.Manual=1]="Manual",W[W.AfterDelay=2]="AfterDelay",W[W.FocusOut=3]="FocusOut"})(L=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var J;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(J=e.TextEditorRevealType||(e.TextEditorRevealType={}));var X;(function(W){W[W.Keyboard=1]="Keyboard",W[W.Mouse=2]="Mouse",W[W.Command=3]="Command"})(X=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ce;(function(W){W[W.OpenOpen=0]="OpenOpen",W[W.ClosedClosed=1]="ClosedClosed",W[W.OpenClosed=2]="OpenClosed",W[W.ClosedOpen=3]="ClosedOpen"})(ce=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(W){function N(oe){switch(oe){case"keyboard":return W.Keyboard;case"mouse":return W.Mouse;case"api":return W.Command}}W.fromValue=N}(X=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let me=class{constructor(N,oe){if(oe&&!k.URI.isUri(oe))throw y.illegalArgument("target");if(!$.isRange(N)||N.isEmpty)throw y.illegalArgument("range");this.range=N,this.target=oe}};me=He([w],me),e.DocumentLink=me;let Pe=class{constructor(N,oe,Ie,Ve){this.red=N,this.green=oe,this.blue=Ie,this.alpha=Ve}};Pe=He([w],Pe),e.Color=Pe;let Fe=class{constructor(N,oe){if(oe&&!(oe instanceof Pe))throw y.illegalArgument("color");if(!$.isRange(N)||N.isEmpty)throw y.illegalArgument("range");this.range=N,this.color=oe}};Fe=He([w],Fe),e.ColorInformation=Fe;let je=class{constructor(N){if(!N||typeof N!="string")throw y.illegalArgument("label");this.label=N}};je=He([w],je),e.ColorPresentation=je;var qe;(function(W){W[W.RGB=0]="RGB",W[W.HEX=1]="HEX",W[W.HSL=2]="HSL"})(qe=e.ColorFormat||(e.ColorFormat={}));var Ge;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information"})(Ge=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var st;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(st=e.TaskRevealKind||(e.TaskRevealKind={}));var $e;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})($e=e.TaskPanelKind||(e.TaskPanelKind={}));let Qe=C=class{constructor(N,oe){if(typeof N!="string"||typeof oe!="string")throw y.illegalArgument("name");this._id=N}static from(N){switch(N){case"clean":return C.Clean;case"build":return C.Build;case"rebuild":return C.Rebuild;case"test":return C.Test;default:return}}get id(){return this._id}};Qe.Clean=new C("clean","Clean"),Qe.Build=new C("build","Build"),Qe.Rebuild=new C("rebuild","Rebuild"),Qe.Test=new C("test","Test"),Qe=C=He([w],Qe),e.TaskGroup=Qe;function ht(W){let N="";for(let oe=0;oe<W.length;oe++)N+=W[oe].replace(/,/g,",,")+",";return N}let et=class{constructor(N,oe,Ie){if(typeof N!="string")throw y.illegalArgument("process");this._args=[],this._process=N,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=Ie):this._options=oe)}get process(){return this._process}set process(N){if(typeof N!="string")throw y.illegalArgument("process");this._process=N}get args(){return this._args}set args(N){Array.isArray(N)||(N=[]),this._args=N}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("process"),this._process!==void 0&&N.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)N.push(oe);return ht(N)}};et=He([w],et),e.ProcessExecution=et;let ft=class{constructor(N,oe,Ie){if(this._args=[],Array.isArray(oe)){if(!N)throw y.illegalArgument("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw y.illegalArgument("command");this._command=N,this._args=oe,this._options=Ie}else{if(typeof N!="string")throw y.illegalArgument("commandLine");this._commandLine=N,this._options=oe}}get commandLine(){return this._commandLine}set commandLine(N){if(typeof N!="string")throw y.illegalArgument("commandLine");this._commandLine=N}get command(){return this._command?this._command:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw y.illegalArgument("command");this._command=N}get args(){return this._args}set args(N){this._args=N||[]}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("shell"),this._commandLine!==void 0&&N.push(this._commandLine),this._command!==void 0&&N.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)N.push(typeof oe=="string"?oe:oe.value);return ht(N)}};ft=He([w],ft),e.ShellExecution=ft;var ot;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(ot=e.ShellQuoting||(e.ShellQuoting={}));var Ze;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace"})(Ze=e.TaskScope||(e.TaskScope={}));class Et{constructor(N){this._callback=N}computeId(){return"customExecution"+I.generateUuid()}set callback(N){this._callback=N}get callback(){return this._callback}}e.CustomExecution=Et;let vt=_=class{constructor(N,oe,Ie,Ve,Je,nt){this.__deprecated=!1,this._definition=this.definition=N;let Y;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=Ie,this.execution=Ve,Y=Je,this.__deprecated=!0):oe===Ze.Global||oe===Ze.Workspace?(this.target=oe,this._name=this.name=Ie,this._source=this.source=Ve,this.execution=Je,Y=nt):(this.target=oe,this._name=this.name=Ie,this._source=this.source=Ve,this.execution=Je,Y=nt),typeof Y=="string"?(this._problemMatchers=[Y],this._hasDefinedMatchers=!0):Array.isArray(Y)?(this._problemMatchers=Y,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(N){this.__id=N}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof et?this._definition={type:_.ProcessType,id:this._execution.computeId()}:this._execution instanceof ft?this._definition={type:_.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:_.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:_.EmptyType,id:I.generateUuid()}}get definition(){return this._definition}set definition(N){if(N==null)throw y.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=N}get scope(){return this._scope}set target(N){this.clear(),this._scope=N}get name(){return this._name}set name(N){if(typeof N!="string")throw y.illegalArgument("name");this.clear(),this._name=N}get execution(){return this._execution}set execution(N){N===null&&(N=void 0),this.clear(),this._execution=N;const oe=this._definition.type;(_.EmptyType===oe||_.ProcessType===oe||_.ShellType===oe||_.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(N){if(Array.isArray(N))this.clear(),this._problemMatchers=N,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.clear(),this._isBackground=N}get source(){return this._source}set source(N){if(typeof N!="string"||N.length===0)throw y.illegalArgument("source must be a string of length > 0");this.clear(),this._source=N}get group(){return this._group}set group(N){N===null&&(N=void 0),this.clear(),this._group=N}get detail(){return this._detail}set detail(N){N===null&&(N=void 0),this._detail=N}get presentationOptions(){return this._presentationOptions}set presentationOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._presentationOptions=N}get runOptions(){return this._runOptions}set runOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._runOptions=N}};vt.ExtensionCallbackType="customExecution",vt.ProcessType="process",vt.ShellType="shell",vt.EmptyType="$empty",vt=_=He([w],vt),e.Task=vt;var mt;(function(W){W[W.SourceControl=1]="SourceControl",W[W.Window=10]="Window",W[W.Notification=15]="Notification"})(mt=e.ProgressLocation||(e.ProgressLocation={}));let at=class{constructor(N,oe=ut.None){this.collapsibleState=oe,k.URI.isUri(N)?this.resourceUri=N:this.label=N}};at=He([w],at),e.TreeItem=at;var ut;(function(W){W[W.None=0]="None",W[W.Collapsed=1]="Collapsed",W[W.Expanded=2]="Expanded"})(ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let rt=class{constructor(N,oe){this.id=N,this.color=oe}};rt=He([w],rt),e.ThemeIcon=rt,rt.File=new rt("file"),rt.Folder=new rt("folder");let St=class{constructor(N){this.id=N}};St=He([w],St),e.ThemeColor=St;var _t;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.WorkspaceFolder=3]="WorkspaceFolder"})(_t=e.ConfigurationTarget||(e.ConfigurationTarget={}));let wt=class{constructor(N,oe){if(typeof N!="string"&&(!N||!k.URI.isUri(N)&&!k.URI.isUri(N.uri)))throw y.illegalArgument("base");if(typeof oe!="string")throw y.illegalArgument("pattern");typeof N=="string"?(this.baseFolder=k.URI.file(N),this.base=N):k.URI.isUri(N)?(this.baseFolder=N,this.base=N.fsPath):(this.baseFolder=N.uri,this.base=N.uri.fsPath),this.pattern=oe}};wt=He([w],wt),e.RelativePattern=wt;let gt=class{constructor(N,oe,Ie,Ve){this.enabled=typeof N=="boolean"?N:!0,typeof oe=="string"&&(this.condition=oe),typeof Ie=="string"&&(this.hitCondition=Ie),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=I.generateUuid()),this._id}};gt=He([w],gt),e.Breakpoint=gt;let yt=class extends gt{constructor(N,oe,Ie,Ve,Je){super(oe,Ie,Ve,Je);if(N===null)throw y.illegalArgument("location");this.location=N}};yt=He([w],yt),e.SourceBreakpoint=yt;let pt=class extends gt{constructor(N,oe,Ie,Ve,Je){super(oe,Ie,Ve,Je);this.functionName=N}};pt=He([w],pt),e.FunctionBreakpoint=pt;let Pt=class extends gt{constructor(N,oe,Ie,Ve,Je,nt,Y){super(Ve,Je,nt,Y);if(!oe)throw y.illegalArgument("dataId");this.label=N,this.dataId=oe,this.canPersist=Ie}};Pt=He([w],Pt),e.DataBreakpoint=Pt;let Dt=class{constructor(N,oe,Ie){this.command=N,this.args=oe||[],this.options=Ie}};Dt=He([w],Dt),e.DebugAdapterExecutable=Dt;let tt=class{constructor(N,oe){this.port=N,this.host=oe}};tt=He([w],tt),e.DebugAdapterServer=tt;let bt=class{constructor(N){this.path=N}};bt=He([w],bt),e.DebugAdapterNamedPipeServer=bt;let Ot=class{constructor(N){this.implementation=N}};Ot=He([w],Ot),e.DebugAdapterInlineImplementation=Ot;let xt=class{constructor(N,oe){this.range=N,this.expression=oe}};xt=He([w],xt),e.EvaluatableExpression=xt;var Ft;(function(W){W[W.Changed=1]="Changed",W[W.Created=2]="Created",W[W.Deleted=3]="Deleted"})(Ft=e.FileChangeType||(e.FileChangeType={}));let it=D=class extends Error{constructor(N,oe=i.FileSystemProviderErrorCode.Unknown,Ie){var Ve;super(k.URI.isUri(N)?N.toString(!0):N);this.code=(Ve=Ie==null?void 0:Ie.name)!==null&&Ve!==void 0?Ve:"Unknown",i.markAsFileSystemProviderError(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof Ie=="function"&&Error.captureStackTrace(this,Ie)}static FileExists(N){return new D(N,i.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(N){return new D(N,i.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(N){return new D(N,i.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(N){return new D(N,i.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(N){return new D(N,i.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(N){return new D(N,i.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}};it=D=He([w],it),e.FileSystemError=it;let Wt=class{constructor(N,oe,Ie){this.start=N,this.end=oe,this.kind=Ie}};Wt=He([w],Wt),e.FoldingRange=Wt;var kt;(function(W){W[W.Comment=1]="Comment",W[W.Imports=2]="Imports",W[W.Region=3]="Region"})(kt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Rt;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(Rt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Zt;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(Zt=e.CommentMode||(e.CommentMode={}));class li{constructor(N,oe=[]){this.tokenTypes=N,this.tokenModifiers=oe}}e.SemanticTokensLegend=li;function ei(W){return typeof W=="undefined"||E.isStringArray(W)}class Ht{constructor(N){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,N){this._hasLegend=!0;for(let oe=0,Ie=N.tokenTypes.length;oe<Ie;oe++)this._tokenTypeStrToInt.set(N.tokenTypes[oe],oe);for(let oe=0,Ie=N.tokenModifiers.length;oe<Ie;oe++)this._tokenModifierStrToInt.set(N.tokenModifiers[oe],oe)}}push(N,oe,Ie,Ve,Je){if(typeof N=="number"&&typeof oe=="number"&&typeof Ie=="number"&&typeof Ve=="number"&&(typeof Je=="number"||typeof Je=="undefined"))return typeof Je=="undefined"&&(Je=0),this._pushEncoded(N,oe,Ie,Ve,Je);if($.isRange(N)&&typeof oe=="string"&&ei(Ie))return this._push(N,oe,Ie);throw y.illegalArgument()}_push(N,oe,Ie){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ve=N.start.line,Je=N.start.character,nt=N.end.character-N.start.character,Y=this._tokenTypeStrToInt.get(oe);let le=0;if(Ie)for(const ye of Ie){if(!this._tokenModifierStrToInt.has(ye))throw new Error("`tokenModifier` is not in the provided legend");const Ye=this._tokenModifierStrToInt.get(ye);le|=1<<Ye>>>0}this._pushEncoded(Ve,Je,nt,Y,le)}_pushEncoded(N,oe,Ie,Ve,Je){if(this._dataIsSortedAndDeltaEncoded&&(N<this._prevLine||N===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const le=this._data.length/5|0;let ye=0,Ye=0;for(let lt=0;lt<le;lt++){let dt=this._data[5*lt],Yt=this._data[5*lt+1];dt===0?(dt=ye,Yt+=Ye):dt+=ye,this._data[5*lt]=dt,this._data[5*lt+1]=Yt,ye=dt,Ye=Yt}}let nt=N,Y=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(nt-=this._prevLine,nt===0&&(Y-=this._prevChar)),this._data[this._dataLen++]=nt,this._data[this._dataLen++]=Y,this._data[this._dataLen++]=Ie,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=Je,this._prevLine=N,this._prevChar=oe}static _sortAndDeltaEncode(N){let oe=[];const Ie=N.length/5|0;for(let Y=0;Y<Ie;Y++)oe[Y]=Y;oe.sort((Y,le)=>{const ye=N[5*Y],Ye=N[5*le];if(ye===Ye){const lt=N[5*Y+1],dt=N[5*le+1];return lt-dt}return ye-Ye});const Ve=new Uint32Array(N.length);let Je=0,nt=0;for(let Y=0;Y<Ie;Y++){const le=5*oe[Y],ye=N[le+0],Ye=N[le+1],lt=N[le+2],dt=N[le+3],Yt=N[le+4],pi=ye-Je,Ei=pi===0?Ye-nt:Ye,Xt=5*Y;Ve[Xt+0]=pi,Ve[Xt+1]=Ei,Ve[Xt+2]=lt,Ve[Xt+3]=dt,Ve[Xt+4]=Yt,Je=ye,nt=Ye}return Ve}build(N){return this._dataIsSortedAndDeltaEncoded?new Nt(new Uint32Array(this._data),N):new Nt(Ht._sortAndDeltaEncode(this._data),N)}}e.SemanticTokensBuilder=Ht;class Nt{constructor(N,oe){this.resultId=oe,this.data=N}}e.SemanticTokens=Nt;class Ct{constructor(N,oe,Ie){this.start=N,this.deleteCount=oe,this.data=Ie}}e.SemanticTokensEdit=Ct;class ci{constructor(N,oe){this.resultId=oe,this.edits=N}}e.SemanticTokensEdits=ci;var zt;(function(W){W[W.Separate=0]="Separate",W[W.MergeWithParent=1]="MergeWithParent"})(zt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Bt;(function(W){W[W.Initial=1]="Initial",W[W.Dynamic=2]="Dynamic"})(Bt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Ut=class{constructor(){}};Ut.Back={iconPath:new rt("arrow-left")},Ut=He([w],Ut),e.QuickInputButtons=Ut;var ui;(function(W){W[W.UI=1]="UI",W[W.Workspace=2]="Workspace"})(ui=e.ExtensionKind||(e.ExtensionKind={}));class Tt{constructor(N,oe,Ie){this.badge=N,this.tooltip=oe,this.color=Ie}static validate(N){if(N.badge&&N.badge.length!==1&&N.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Tt;let Vt=class{constructor(N){this.kind=N}};Vt=He([w],Vt),e.ColorTheme=Vt;var di;(function(W){W[W.Light=1]="Light",W[W.Dark=2]="Dark",W[W.HighContrast=3]="HighContrast"})(di=e.ColorThemeKind||(e.ColorThemeKind={}));class jt{constructor(N,oe,Ie){this.mime=N,this.value=oe,this.metadata=Ie}static isNotebookCellOutputItem(N){return N instanceof jt}}e.NotebookCellOutputItem=jt;class $t{constructor(N,oe){this.outputs=N,this.metadata=oe}static isNotebookCellOutput(N){return N instanceof $t}toJSON(){let N={},oe={},Ie=!1;for(let Ve of this.outputs)N[Ve.mime]=Ve.value,Ve.metadata&&(oe[Ve.mime]=Ve.metadata,Ie=!0);return{outputKind:Kt.Rich,data:N,metadata:Ie?{custom:oe}:void 0}}}e.NotebookCellOutput=$t;var qt;(function(W){W[W.Markdown=1]="Markdown",W[W.Code=2]="Code"})(qt=e.CellKind||(e.CellKind={}));var Kt;(function(W){W[W.Text=1]="Text",W[W.Error=2]="Error",W[W.Rich=3]="Rich"})(Kt=e.CellOutputKind||(e.CellOutputKind={}));var ti;(function(W){W[W.Running=1]="Running",W[W.Idle=2]="Idle",W[W.Success=3]="Success",W[W.Error=4]="Error"})(ti=e.NotebookCellRunState||(e.NotebookCellRunState={}));var Gt;(function(W){W[W.Running=1]="Running",W[W.Idle=2]="Idle"})(Gt=e.NotebookRunState||(e.NotebookRunState={}));var Ae;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(Ae=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Qt;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Qt=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let Lt=class{constructor(N,oe){this.label=N,this.timestamp=oe}};Lt=He([w],Lt),e.TimelineItem=Lt;var ct;(function(W){W[W.Production=1]="Production",W[W.Development=2]="Development",W[W.Test=3]="Test"})(ct=e.ExtensionMode||(e.ExtensionMode={}));var hi;(function(W){W[W.Node=1]="Node",W[W.Webworker=2]="Webworker"})(hi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var fi;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=4]="RegEx"})(fi=e.StandardTokenType||(e.StandardTokenType={}));class ii{constructor(N,oe){this.ranges=N,this.wordPattern=oe}}e.LinkedEditingRanges=ii;var ni;(function(W){W[W.Unset=0]="Unset",W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(ni=e.TestRunState||(e.TestRunState={}));var mi;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information",W[W.Hint=3]="Hint"})(mi=e.TestMessageSeverity||(e.TestMessageSeverity={}));let Jt=class{constructor(N,oe=[],Ie){a.set(this,void 0),m.set(this,void 0),p.set(this,void 0),Xe(this,a,N),Xe(this,p,Object.freeze(oe.map(Ve=>Object.freeze(Ve)))),Xe(this,m,Ie)}get runState(){return Ue(this,a)}get duration(){return Ue(this,m)}get messages(){return Ue(this,p)}};a=new WeakMap,m=new WeakMap,p=new WeakMap,Jt=He([w],Jt),e.TestState=Jt;var gi;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(gi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[93],_e([0,1,43,16,8,115,84,7,11]),function(se,e,b,y,A,T,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const i=new Map;function P(a,m){m?i.set(a,m):i.delete(a)}e.setWordDefinitionFor=P;function S(a){return i.get(a)}e.getWordDefinitionFor=S;class v extends T.MirrorTextModel{constructor(m,p,f,c,n,o,h,t){super(p,f,c,n);this._proxy=m,this._languageId=o,this._isDirty=h,this._notebook=t,this._isDisposed=!1}dispose(){b.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(m){return I.equals(this._lines,m)}get document(){if(!this._document){const m=this;this._document={get uri(){return m._uri},get fileName(){return m._uri.fsPath},get isUntitled(){return m._uri.scheme===y.Schemas.untitled},get languageId(){return m._languageId},get version(){return m._versionId},get isClosed(){return m._isDisposed},get isDirty(){return m._isDirty},get notebook(){return m._notebook},save(){return m._save()},getText(p){return p?m._getTextInRange(p):m.getText()},get eol(){return m._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return m._lines.length},lineAt(p){return m._lineAt(p)},offsetAt(p){return m._offsetAt(p)},positionAt(p){return m._positionAt(p)},validateRange(p){return m._validateRange(p)},validatePosition(p){return m._validatePosition(p)},getWordRangeAtPosition(p,f){return m._getWordRangeAtPosition(p,f)}}}return Object.freeze(this._document)}_acceptLanguageId(m){b.ok(!this._isDisposed),this._languageId=m}_acceptIsDirty(m){b.ok(!this._isDisposed),this._isDirty=m}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(m){const p=this._validateRange(m);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const f=this._eol,c=p.start.line,n=p.end.line,o=[];o.push(this._lines[c].substring(p.start.character));for(let h=c+1;h<n;h++)o.push(this._lines[h]);return o.push(this._lines[n].substring(0,p.end.character)),o.join(f)}_lineAt(m){let p;if(m instanceof k.Position?p=m.line:typeof m=="number"&&(p=m),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new d(p,this._lines[p],p===this._lines.length-1)}_offsetAt(m){return m=this._validatePosition(m),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(m.line-1)+m.character}_positionAt(m){m=Math.floor(m),m=Math.max(0,m),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(m),f=this._lines[p.index].length;return new k.Position(p.index,Math.min(p.remainder,f))}_validateRange(m){if(!(m instanceof k.Range))throw new Error("Invalid argument");const p=this._validatePosition(m.start),f=this._validatePosition(m.end);return p===m.start&&f===m.end?m:new k.Range(p.line,p.character,f.line,f.character)}_validatePosition(m){if(!(m instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return m.with(0,0);let{line:p,character:f}=m,c=!1;if(p<0)p=0,f=0,c=!0;else if(p>=this._lines.length)p=this._lines.length-1,f=this._lines[p].length,c=!0;else{const n=this._lines[p].length;f<0?(f=0,c=!0):f>n&&(f=n,c=!0)}return c?new k.Position(p,f):m}_getWordRangeAtPosition(m,p){const f=this._validatePosition(m);if(!p)p=S(this._languageId);else if(A.regExpLeadsToEndlessLoop(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const c=E.getWordAtText(f.character+1,E.ensureValidWordDefinition(p),this._lines[f.line],0);if(c)return new k.Range(f.line,c.startColumn-1,f.line,c.endColumn-1)}}e.ExtHostDocumentData=v;class d{constructor(m,p,f){this._line=m,this._text=p,this._isLastLine=f}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=d}),define(ve[160],_e([0,1,7,3,86,6,60,33,22,2,26]),function(se,e,b,y,A,T,E,k,I,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class S{constructor(d,a,m,p){this._notebook=m,this._selector=p,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this.uri=i.URI.from({scheme:"vscode-concat-doc",path:P.generateUuid()}),this._init(),this._disposables.add(a.onDidChangeDocument(c=>{const n=this._cellUris.get(c.document.uri);n!==void 0&&(this._cellLengths.changeValue(n,this._cells[n].document.getText().length+1),this._cellLines.changeValue(n,this._cells[n].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const f=c=>{c===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(d.onDidChangeCellLanguage(c=>f(c.document))),this._disposables.add(d.onDidChangeNotebookCells(c=>f(c.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const d=[],a=[];for(const m of this._notebook.cells)m.cellKind===k.CellKind.Code&&(!this._selector||E.score(this._selector,m.uri,m.language,!0))&&(this._cellUris.set(m.uri,this._cells.length),this._cells.push(m),d.push(m.document.getText().length+1),a.push(m.document.lineCount));this._cellLengths=new A.PrefixSumComputer(new Uint32Array(d)),this._cellLines=new A.PrefixSumComputer(new Uint32Array(a))}get version(){return this._versionId}getText(d){var a,m;if(!d){let o="";for(const h of this._cells)o+=h.document.getText()+`
`;return o=o.slice(0,-1),o}if(d.isEmpty)return"";const p=this.locationAt(d.start),f=this.locationAt(d.end),c=this._cells[(a=this._cellUris.get(p.uri))!==null&&a!==void 0?a:-1],n=this._cells[(m=this._cellUris.get(f.uri))!==null&&m!==void 0?m:-1];if(!c||!n)return"";if(c===n)return c.document.getText(new b.Range(p.range.start,f.range.end));{const o=c.document.getText(new b.Range(p.range.start,new b.Position(c.document.lineCount,0))),h=n.document.getText(new b.Range(new b.Position(0,0),f.range.end));return o+`
`+h}}offsetAt(d){const a=this._cellLines.getIndexOf(d.line),m=this._cellLengths.getAccumulatedValue(a.index-1),p=this._cells[a.index].document.offsetAt(d.with(a.remainder));return m+p}positionAt(d){if(typeof d=="number"){const m=this._cellLengths.getIndexOf(d),p=this._cellLines.getAccumulatedValue(m.index-1);return this._cells[m.index].document.positionAt(m.remainder).translate(p)}const a=this._cellUris.get(d.uri);if(a!==void 0){const m=this._cellLines.getAccumulatedValue(a-1);return new b.Position(m+d.range.start.line,d.range.start.character)}return new b.Position(0,0)}locationAt(d){b.Range.isRange(d)||(d=new b.Range(d,d));const a=this._cellLines.getIndexOf(d.start.line);let m=a;d.isEmpty||(m=this._cellLines.getIndexOf(d.end.line));const p=new b.Position(a.remainder,d.start.character),f=new b.Position(m.remainder,d.end.character),c=new b.Range(p,f),n=this._cells[a.index];return new b.Location(n.uri,n.document.validateRange(c))}contains(d){return this._cellUris.has(d)}validateRange(d){const a=this.validatePosition(d.start),m=this.validatePosition(d.end);return d.with(a,m)}validatePosition(d){const a=this._cellLines.getIndexOf(d.line),m=new b.Position(a.remainder,d.character),p=this._cells[a.index].document.validatePosition(m),f=this._cellLines.getAccumulatedValue(a.index-1);return new b.Position(f+p.line,p.character)}}e.ExtHostNotebookConcatDocument=S}),define(ve[161],_e([0,1,9,3,6,7,33]),function(se,e,b,y,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class k{constructor(P){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=P}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(P){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:Object.assign(Object.assign({},E.notebookDocumentMetadataDefaults),P)})}replaceCellMetadata(P,S){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:P,metadata:S})}replaceCellOutput(P,S){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:P,outputs:S.map(v=>T.NotebookCellOutput.isNotebookCellOutput(v)?E.addIdToOutput(v.toJSON()):E.addIdToOutput(v))})}replaceCells(P,S,v){this._throwIfFinalized(),!(P===S&&v.length===0)&&this._collectedEdits.push({editType:1,index:P,count:S-P,cells:v.map(d=>Object.assign(Object.assign({},d),{outputs:d.outputs.map(a=>E.addIdToOutput(a))}))})}}class I extends A.Disposable{constructor(P,S,v,d,a){super();this.id=P,this._viewType=S,this._proxy=v,this._webComm=d,this.notebookData=a,this._visibleRanges=[],this._active=!1,this._visible=!1,this._onDidDispose=new y.Emitter,this._onDidReceiveMessage=new y.Emitter,this.onDidDispose=this._onDidDispose.event,this.onDidReceiveMessage=this._onDidReceiveMessage.event,this._hasDecorationsForKey=Object.create(null),this._register(this._webComm.onDidReceiveMessage(m=>{this._onDidReceiveMessage.fire(m)}))}get viewColumn(){return this._viewColumn}set viewColumn(P){throw b.readonly("viewColumn")}get kernel(){return this._kernel}set kernel(P){throw b.readonly("kernel")}_acceptKernel(P){this._kernel=P}get visible(){return this._visible}set visible(P){throw b.readonly("visible")}_acceptVisibility(P){this._visible=P}get visibleRanges(){return this._visibleRanges}set visibleRanges(P){throw b.readonly("visibleRanges")}_acceptVisibleRanges(P){this._visibleRanges=P}get active(){return this._active}set active(P){throw b.readonly("active")}_acceptActive(P){this._active=P}get document(){return this.notebookData.notebookDocument}edit(P){const S=new k(this.document.version);return P(S),this._applyEdit(S.finalize())}_applyEdit(P){if(P.cellEdits.length===0)return Promise.resolve(!0);const S=[];let v=-1;for(let d=0;d<P.cellEdits.length;d++){if(v<0){S.push(P.cellEdits[d]),v++;continue}const m=S[v];if(m.editType===1&&P.cellEdits[d].editType===1){const p=P.cellEdits[d];if(p.editType!==5&&p.editType!==8&&m.index===p.index){m.cells.push(...P.cellEdits[d].cells),m.count+=P.cellEdits[d].count;continue}}S.push(P.cellEdits[d]),v++}return this._proxy.$tryApplyEdits(this._viewType,this.document.uri,P.documentVersionId,S)}setDecorations(P,S){const v=S.start===S.end;if(!(v&&!this._hasDecorationsForKey[P.key]))return v?delete this._hasDecorationsForKey[P.key]:this._hasDecorationsForKey[P.key]=!0,this._proxy.$trySetDecorations(this.id,S,P.key)}revealRange(P,S){this._proxy.$tryRevealRange(this.id,P,S||T.NotebookEditorRevealType.Default)}async postMessage(P){return this._webComm.postMessage(P)}asWebviewUri(P){return this._webComm.asWebviewUri(P)}dispose(){this._onDidDispose.fire(),super.dispose()}}e.ExtHostNotebookEditor=I}),define(ve[162],_e([0,1,7,13,3]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(k){this._actual=new b.ColorTheme(b.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new A.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let I=k==="light"?b.ColorThemeKind.Light:k==="dark"?b.ColorThemeKind.Dark:b.ColorThemeKind.HighContrast;this._actual=new b.ColorTheme(I),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=He([Be(0,y.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(ve[163],_e([0,1,4,64]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new y.RawContextKey("customExecutionSupported",!0),e.ShellExecutionSupportedContext=new y.RawContextKey("shellExecutionSupported",!1),e.ProcessExecutionSupportedContext=new y.RawContextKey("processExecutionSupported",!1),e.ITaskService=b.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[164],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function b(A){return[...A.entries()]}e.serializeEnvironmentVariableCollection=b;function y(A){return new Map(A)}e.deserializeEnvironmentVariableCollection=y}),define(ve[165],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class b{constructor(A){this._callback=A,this._terminalBufferMap=new Map}dispose(){for(const A of this._terminalBufferMap.values())A.dispose()}startBuffering(A,T,E=5){let k;return k=T(I=>{const i=typeof I=="string"?I:I.data;let P=this._terminalBufferMap.get(A);if(P){P.data.push(i);return}const S=setTimeout(()=>this._flushBuffer(A),E);P={data:[i],timeoutId:S,dispose:()=>{clearTimeout(S),this._flushBuffer(A),k.dispose()}},this._terminalBufferMap.set(A,P)}),k}stopBuffering(A){const T=this._terminalBufferMap.get(A);T&&T.dispose()}_flushBuffer(A){const T=this._terminalBufferMap.get(A);T&&(this._terminalBufferMap.delete(A),this._callback(A,T.data.join("")))}}e.TerminalDataBufferer=b}),define(ve[166],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.collectTestResults=e.EMPTY_TEST_RESULT=void 0,e.EMPTY_TEST_RESULT={};const b=k=>k[0]||{};e.collectTestResults=b;var y;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.Remove=2]="Remove",k[k.DeltaDiscoverComplete=3]="DeltaDiscoverComplete",k[k.DeltaRootsComplete=4]="DeltaRootsComplete"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));const A=(k,I)=>`${k}:${I.toString()}`;e.getTestSubscriptionKey=A;class T{add(I){}update(I){}remove(I,i){}complete(){}}e.IncrementalChangeCollector=T;class E{constructor(){this.items=new Map,this.roots=new Set}apply(I){const i=this.createChangeCollector();for(const P of I)switch(P[0]){case 0:{const S=P[1];if(S.parent){if(this.items.has(S.parent)){const v=this.items.get(S.parent);v.children.add(S.id);const d=this.createItem(S,v);this.items.set(S.id,d),i.add(d)}}else{this.roots.add(S.id);const v=this.createItem(S);this.items.set(S.id,v),i.add(v)}break}case 1:{const S=P[1],v=this.items.get(S.id);v&&(Object.assign(v.item,S.item),i.update(v));break}case 2:{const S=this.items.get(P[1]);if(!S)break;S.parent?this.items.get(S.parent).children.delete(S.id):this.roots.delete(S.id);const v=[[P[1]]];for(;v.length;)for(const d of v.pop()){const a=this.items.get(d);a&&(v.push(a.children),this.items.delete(d),i.remove(a,a!==S))}break}case 3:this.updateBusyProviders(P[1]);break;case 4:this.updatePendingRoots(P[1]);break}i.complete()}updateBusyProviders(I){}updatePendingRoots(I){}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=E}),define(ve[167],_e([0,1,10,37,12,24,21,59,136]),function(se,e,b,y,A,T,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class i{constructor(S,v,d){if(this._contributedVariables=new Map,this._context=S,this._labelService=v,d)if(E.isWindows){const a=Object.create(null);this._envVariables=a,Object.keys(d).forEach(m=>{a[m.toLowerCase()]=d[m]})}else this._envVariables=d}resolve(S,v){return this.recursiveResolve(S?S.uri:void 0,v)}resolveAnyBase(S,v,d,a){const m=T.deepClone(v);return E.isWindows&&m.windows?Object.keys(m.windows).forEach(p=>m[p]=m.windows[p]):E.isMacintosh&&m.osx?Object.keys(m.osx).forEach(p=>m[p]=m.osx[p]):E.isLinux&&m.linux&&Object.keys(m.linux).forEach(p=>m[p]=m.linux[p]),delete m.windows,delete m.osx,delete m.linux,this.recursiveResolve(S?S.uri:void 0,m,d,a)}resolveAny(S,v,d){return this.resolveAnyBase(S,v,d)}resolveAnyMap(S,v,d){const a=new Map;return{newConfig:this.resolveAnyBase(S,v,d,a),resolvedVariables:a}}resolveWithInteractionReplace(S,v,d,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,v,d,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,v){if(this._contributedVariables.has(S))throw new Error("Variable "+S+" is contributed twice.");this._contributedVariables.set(S,v)}recursiveResolve(S,v,d,a){if(A.isString(v))return this.resolveString(S,v,d,a);if(A.isArray(v))return v.map(m=>this.recursiveResolve(S,m,d,a));if(A.isObject(v)){let m=Object.create(null);return Object.keys(v).forEach(p=>{const f=this.resolveString(S,p,d,a);m[f]=this.recursiveResolve(S,v[p],d,a)}),m}return v}resolveString(S,v,d,a){return v.replace(i.VARIABLE_REGEXP,(p,f)=>{if(f.includes(i.VARIABLE_LHS))return p;let c=this.evaluateSingleVariable(p,f,S,d);return a&&a.set(f,c),c})}fsPath(S){return this._labelService?this._labelService.getUriLabel(S,{noPrefix:!0}):S.fsPath}evaluateSingleVariable(S,v,d,a){let m;const p=v.split(":");p.length>1&&(v=p[0],m=p[1]);const f=()=>{const o=this._context.getFilePath();if(o)return o;throw new Error(I.localize(0,null,S))},c=()=>{const o=f();if(this._context.getWorkspaceFolderPathForFile){const h=this._context.getWorkspaceFolderPathForFile();if(h)return h}throw new Error(I.localize(1,null,S,b.basename(o)))},n=()=>{if(m){const o=this._context.getFolderUri(m);if(o)return o;throw new Error(I.localize(2,null,S,m))}if(d)return d;throw this._context.getWorkspaceFolderCount()>1?new Error(I.localize(3,null,S)):new Error(I.localize(4,null,S))};switch(v){case"env":if(m){if(this._envVariables){const o=this._envVariables[E.isWindows?m.toLowerCase():m];if(A.isString(o))return o}return""}throw new Error(I.localize(5,null,S));case"config":if(m){const o=this._context.getConfigurationValue(d,m);if(A.isUndefinedOrNull(o))throw new Error(I.localize(6,null,S,m));if(A.isObject(o))throw new Error(I.localize(7,null,S,m));return o}throw new Error(I.localize(8,null,S));case"command":return this.resolveFromMap(S,m,a,"command");case"input":return this.resolveFromMap(S,m,a,"input");default:switch(v){case"workspaceRoot":case"workspaceFolder":return k.normalizeDriveLetter(this.fsPath(n()));case"cwd":return d||m?k.normalizeDriveLetter(this.fsPath(n())):y.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return b.basename(this.fsPath(n()));case"lineNumber":const o=this._context.getLineNumber();if(o)return o;throw new Error(I.localize(9,null,S));case"selectedText":const h=this._context.getSelectedText();if(h)return h;throw new Error(I.localize(10,null,S));case"file":return f();case"fileWorkspaceFolder":return c();case"relativeFile":return d||m?b.relative(this.fsPath(n()),f()):f();case"relativeFileDirname":const t=b.dirname(f());if(d||m){const u=b.relative(this.fsPath(n()),t);return u.length===0?".":u}return t;case"fileDirname":return b.dirname(f());case"fileExtname":return b.extname(f());case"fileBasename":return b.basename(f());case"fileBasenameNoExtension":const s=b.basename(f());return s.slice(0,s.length-b.extname(s).length);case"fileDirnameBasename":return b.basename(b.dirname(f()));case"execPath":const l=this._context.getExecPath();return l||S;case"pathSeparator":return b.sep;default:try{return this.resolveFromMap(S,v,a,void 0)}catch(u){return S}}}}resolveFromMap(S,v,d,a){if(v&&d){const m=a===void 0?d[v]:d[a+":"+v];if(typeof m=="string")return m;throw new Error(I.localize(11,null,S))}return S}}e.AbstractVariableResolverService=i,i.VARIABLE_LHS="${",i.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[168],_e([0,1,4]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=b.createDecorator("editorGroupsService");var y;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var A;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var E;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(E=e.GroupsArrangement||(e.GroupsArrangement={}));var k;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(k=e.MergeGroupMode||(e.MergeGroupMode={}));var I;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I=e.GroupsOrder||(e.GroupsOrder={}));var i;(function(v){v[v.GROUP_ACTIVE=0]="GROUP_ACTIVE",v[v.GROUP_INDEX=1]="GROUP_INDEX",v[v.EDITOR_OPEN=2]="EDITOR_OPEN",v[v.EDITOR_CLOSE=3]="EDITOR_CLOSE",v[v.EDITOR_MOVE=4]="EDITOR_MOVE",v[v.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",v[v.EDITOR_LABEL=6]="EDITOR_LABEL",v[v.EDITOR_PIN=7]="EDITOR_PIN",v[v.EDITOR_STICKY=8]="EDITOR_STICKY",v[v.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(i=e.GroupChangeKind||(e.GroupChangeKind={}));var P;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(P=e.OpenEditorContext||(e.OpenEditorContext={}));function S(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=S}),define(ve[169],_e([0,1,4]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=b.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ve[14],_e([0,1,63,7,2,32,81,88,169,12,220,58,24,11,33]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItem=e.TestState=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutputItem=e.NotebookCellOutput=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var m;(function(G){function Q(L){const{selectionStartLineNumber:J,selectionStartColumn:X,positionLineNumber:ce,positionColumn:me}=L,Pe=new y.Position(J-1,X-1),Fe=new y.Position(ce-1,me-1);return new y.Selection(Pe,Fe)}G.to=Q;function H(L){const{anchor:J,active:X}=L;return{selectionStartLineNumber:J.line+1,selectionStartColumn:J.character+1,positionLineNumber:X.line+1,positionColumn:X.character+1}}G.from=H})(m=e.Selection||(e.Selection={}));var p;(function(G){function Q(L){if(!!L){const{start:J,end:X}=L;return{startLineNumber:J.line+1,startColumn:J.character+1,endLineNumber:X.line+1,endColumn:X.character+1}}}G.from=Q;function H(L){if(!!L){const{startLineNumber:J,startColumn:X,endLineNumber:ce,endColumn:me}=L;return new y.Range(J-1,X-1,ce-1,me-1)}}G.to=H})(p=e.Range||(e.Range={}));var f;(function(G){function Q(H){switch(H){case 1:return y.StandardTokenType.Comment;case 0:return y.StandardTokenType.Other;case 4:return y.StandardTokenType.RegEx;case 2:return y.StandardTokenType.String}}G.to=Q})(f=e.TokenType||(e.TokenType={}));var c;(function(G){function Q(L){return new y.Position(L.lineNumber-1,L.column-1)}G.to=Q;function H(L){return{lineNumber:L.line+1,column:L.character+1}}G.from=H})(c=e.Position||(e.Position={}));var n;(function(G){function Q(L){switch(L){case y.DiagnosticTag.Unnecessary:return 1;case y.DiagnosticTag.Deprecated:return 2}}G.from=Q;function H(L){switch(L){case 1:return y.DiagnosticTag.Unnecessary;case 2:return y.DiagnosticTag.Deprecated;default:return}}G.to=H})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(G){function Q(L){let J;return L.code&&(i.isString(L.code)||i.isNumber(L.code)?J=String(L.code):J={value:String(L.code.value),target:L.code.target}),Object.assign(Object.assign({},p.from(L.range)),{message:L.message,source:L.source,code:J,severity:t.from(L.severity),relatedInformation:L.relatedInformation&&L.relatedInformation.map(h.from),tags:Array.isArray(L.tags)?d.coalesce(L.tags.map(n.from)):void 0})}G.from=Q;function H(L){var J;const X=new y.Diagnostic(p.to(L),L.message,t.to(L.severity));return X.source=L.source,X.code=i.isString(L.code)?L.code:(J=L.code)===null||J===void 0?void 0:J.value,X.relatedInformation=L.relatedInformation&&L.relatedInformation.map(h.to),X.tags=L.tags&&d.coalesce(L.tags.map(n.to)),X}G.to=H})(o=e.Diagnostic||(e.Diagnostic={}));var h;(function(G){function Q(L){return Object.assign(Object.assign({},p.from(L.location.range)),{message:L.message,resource:L.location.uri})}G.from=Q;function H(L){return new y.DiagnosticRelatedInformation(new y.Location(L.resource,p.to(L)),L.message)}G.to=H})(h=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var t;(function(G){function Q(L){switch(L){case y.DiagnosticSeverity.Error:return k.MarkerSeverity.Error;case y.DiagnosticSeverity.Warning:return k.MarkerSeverity.Warning;case y.DiagnosticSeverity.Information:return k.MarkerSeverity.Info;case y.DiagnosticSeverity.Hint:return k.MarkerSeverity.Hint}return k.MarkerSeverity.Error}G.from=Q;function H(L){switch(L){case k.MarkerSeverity.Info:return y.DiagnosticSeverity.Information;case k.MarkerSeverity.Warning:return y.DiagnosticSeverity.Warning;case k.MarkerSeverity.Error:return y.DiagnosticSeverity.Error;case k.MarkerSeverity.Hint:return y.DiagnosticSeverity.Hint;default:return y.DiagnosticSeverity.Error}}G.to=H})(t=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(G){function Q(L){return typeof L=="number"&&L>=y.ViewColumn.One?L-1:L===y.ViewColumn.Beside?I.SIDE_GROUP:I.ACTIVE_GROUP}G.from=Q;function H(L){if(typeof L=="number"&&L>=0)return L+1;throw new Error("invalid 'EditorGroupColumn'")}G.to=H})(s=e.ViewColumn||(e.ViewColumn={}));function l(G){return typeof G.range!="undefined"}function u(G){return G.length===0?!0:!!l(G[0])}e.isDecorationOptionsArr=u;var r;(function(G){function Q(me){return me.map(G.from)}G.fromMany=Q;function H(me){return me&&typeof me=="object"&&typeof me.language=="string"&&typeof me.value=="string"}function L(me){let Pe;if(H(me)){const{language:Ge,value:st}=me;Pe={value:"```"+Ge+`
`+st+"\n```\n"}}else y.MarkdownString.isMarkdownString(me)?Pe={value:me.value,isTrusted:me.isTrusted,supportThemeIcons:me.supportThemeIcons}:typeof me=="string"?Pe={value:me}:Pe={value:""};const Fe=Object.create(null);Pe.uris=Fe;const je=Ge=>{try{let st=A.URI.parse(Ge,!0);st=st.with({query:J(st.query,Fe)}),Fe[Ge]=st}catch(st){}return""},qe=new P.Renderer;return qe.link=je,qe.image=Ge=>je(E.parseHrefAndDimensions(Ge).href),P(Pe.value,{renderer:qe}),Pe}G.from=L;function J(me,Pe){if(!me)return me;let Fe;try{Fe=S.parse(me)}catch(qe){}if(!Fe)return me;let je=!1;return Fe=v.cloneAndChange(Fe,qe=>{if(A.URI.isUri(qe)){const Ge=`__uri_${Math.random().toString(16).slice(2,8)}`;return Pe[Ge]=qe,je=!0,Ge}else return}),je?JSON.stringify(Fe):me}function X(me){const Pe=new y.MarkdownString(me.value,me.supportThemeIcons);return Pe.isTrusted=me.isTrusted,Pe}G.to=X;function ce(me){if(!!me)return typeof me=="string"?me:G.from(me)}G.fromStrict=ce})(r=e.MarkdownString||(e.MarkdownString={}));function g(G){return u(G)?G.map(Q=>({range:p.from(Q.range),hoverMessage:Array.isArray(Q.hoverMessage)?r.fromMany(Q.hoverMessage):Q.hoverMessage?r.from(Q.hoverMessage):void 0,renderOptions:Q.renderOptions})):G.map(Q=>({range:p.from(Q)}))}e.fromRangeOrRangeWithMessage=g;function C(G){return typeof G=="undefined"?G:typeof G=="string"?A.URI.file(G):G}e.pathOrURIToURI=C;var _;(function(G){function Q(H){return typeof H=="undefined"?H:{contentText:H.contentText,contentIconPath:H.contentIconPath?C(H.contentIconPath):void 0,border:H.border,borderColor:H.borderColor,fontStyle:H.fontStyle,fontWeight:H.fontWeight,textDecoration:H.textDecoration,color:H.color,backgroundColor:H.backgroundColor,margin:H.margin,width:H.width,height:H.height}}G.from=Q})(_=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var D;(function(G){function Q(H){return typeof H=="undefined"?H:{backgroundColor:H.backgroundColor,outline:H.outline,outlineColor:H.outlineColor,outlineStyle:H.outlineStyle,outlineWidth:H.outlineWidth,border:H.border,borderColor:H.borderColor,borderRadius:H.borderRadius,borderSpacing:H.borderSpacing,borderStyle:H.borderStyle,borderWidth:H.borderWidth,fontStyle:H.fontStyle,fontWeight:H.fontWeight,textDecoration:H.textDecoration,cursor:H.cursor,color:H.color,opacity:H.opacity,letterSpacing:H.letterSpacing,gutterIconPath:H.gutterIconPath?C(H.gutterIconPath):void 0,gutterIconSize:H.gutterIconSize,overviewRulerColor:H.overviewRulerColor,before:H.before?_.from(H.before):void 0,after:H.after?_.from(H.after):void 0}}G.from=Q})(D=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var w;(function(G){function Q(H){if(typeof H=="undefined")return H;switch(H){case y.DecorationRangeBehavior.OpenOpen:return 0;case y.DecorationRangeBehavior.ClosedClosed:return 1;case y.DecorationRangeBehavior.OpenClosed:return 2;case y.DecorationRangeBehavior.ClosedOpen:return 3}}G.from=Q})(w=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(G){function Q(H){return{isWholeLine:H.isWholeLine,rangeBehavior:H.rangeBehavior?w.from(H.rangeBehavior):void 0,overviewRulerLane:H.overviewRulerLane,light:H.light?D.from(H.light):void 0,dark:H.dark?D.from(H.dark):void 0,backgroundColor:H.backgroundColor,outline:H.outline,outlineColor:H.outlineColor,outlineStyle:H.outlineStyle,outlineWidth:H.outlineWidth,border:H.border,borderColor:H.borderColor,borderRadius:H.borderRadius,borderSpacing:H.borderSpacing,borderStyle:H.borderStyle,borderWidth:H.borderWidth,fontStyle:H.fontStyle,fontWeight:H.fontWeight,textDecoration:H.textDecoration,cursor:H.cursor,color:H.color,opacity:H.opacity,letterSpacing:H.letterSpacing,gutterIconPath:H.gutterIconPath?C(H.gutterIconPath):void 0,gutterIconSize:H.gutterIconSize,overviewRulerColor:H.overviewRulerColor,before:H.before?_.from(H.before):void 0,after:H.after?_.from(H.after):void 0}}G.from=Q})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var R;(function(G){function Q(L){return{text:L.newText,eol:L.newEol&&Ne.from(L.newEol),range:p.from(L.range)}}G.from=Q;function H(L){const J=new y.TextEdit(p.to(L.range),L.text);return J.newEol=typeof L.eol=="undefined"?void 0:Ne.to(L.eol),J}G.to=H})(R=e.TextEdit||(e.TextEdit={}));var $;(function(G){function Q(L,J,X){var ce;const me={edits:[]};if(L instanceof y.WorkspaceEdit)for(let Pe of L._allEntries())if(Pe._type===1)me.edits.push({_type:1,oldUri:Pe.from,newUri:Pe.to,options:Pe.options,metadata:Pe.metadata});else if(Pe._type===2){const Fe=J==null?void 0:J.getDocument(Pe.uri);me.edits.push({_type:2,resource:Pe.uri,edit:R.from(Pe.edit),modelVersionId:Fe==null?void 0:Fe.version,metadata:Pe.metadata})}else Pe._type===3&&me.edits.push({_type:3,metadata:Pe.metadata,resource:Pe.uri,edit:Pe.edit,notebookMetadata:Pe.notebookMetadata,notebookVersionId:(ce=X==null?void 0:X.lookupNotebookDocument(Pe.uri))===null||ce===void 0?void 0:ce.notebookDocument.version});return me}G.from=Q;function H(L){const J=new y.WorkspaceEdit;for(const X of L.edits)X.edit?J.replace(A.URI.revive(X.resource),p.to(X.edit.range),X.edit.text):J.renameFile(A.URI.revive(X.oldUri),A.URI.revive(X.newUri),X.options);return J}G.to=H})($=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(G){const Q=Object.create(null);Q[y.SymbolKind.File]=0,Q[y.SymbolKind.Module]=1,Q[y.SymbolKind.Namespace]=2,Q[y.SymbolKind.Package]=3,Q[y.SymbolKind.Class]=4,Q[y.SymbolKind.Method]=5,Q[y.SymbolKind.Property]=6,Q[y.SymbolKind.Field]=7,Q[y.SymbolKind.Constructor]=8,Q[y.SymbolKind.Enum]=9,Q[y.SymbolKind.Interface]=10,Q[y.SymbolKind.Function]=11,Q[y.SymbolKind.Variable]=12,Q[y.SymbolKind.Constant]=13,Q[y.SymbolKind.String]=14,Q[y.SymbolKind.Number]=15,Q[y.SymbolKind.Boolean]=16,Q[y.SymbolKind.Array]=17,Q[y.SymbolKind.Object]=18,Q[y.SymbolKind.Key]=19,Q[y.SymbolKind.Null]=20,Q[y.SymbolKind.EnumMember]=21,Q[y.SymbolKind.Struct]=22,Q[y.SymbolKind.Event]=23,Q[y.SymbolKind.Operator]=24,Q[y.SymbolKind.TypeParameter]=25;function H(J){return typeof Q[J]=="number"?Q[J]:6}G.from=H;function L(J){for(const X in Q)if(Q[X]===J)return Number(X);return y.SymbolKind.Property}G.to=L})(V=e.SymbolKind||(e.SymbolKind={}));var z;(function(G){function Q(L){switch(L){case y.SymbolTag.Deprecated:return 1}}G.from=Q;function H(L){switch(L){case 1:return y.SymbolTag.Deprecated}}G.to=H})(z=e.SymbolTag||(e.SymbolTag={}));var U;(function(G){function Q(L){return{name:L.name,kind:V.from(L.kind),tags:L.tags&&L.tags.map(z.from),containerName:L.containerName,location:F.from(L.location)}}G.from=Q;function H(L){const J=new y.SymbolInformation(L.name,V.to(L.kind),L.containerName,F.to(L.location));return J.tags=L.tags&&L.tags.map(z.to),J}G.to=H})(U=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var q;(function(G){function Q(L){var J,X;const ce={name:L.name||"!!MISSING: name!!",detail:L.detail,range:p.from(L.range),selectionRange:p.from(L.selectionRange),kind:V.from(L.kind),tags:(X=(J=L.tags)===null||J===void 0?void 0:J.map(z.from))!==null&&X!==void 0?X:[]};return L.children&&(ce.children=L.children.map(Q)),ce}G.from=Q;function H(L){const J=new y.DocumentSymbol(L.name,L.detail,V.to(L.kind),p.to(L.range),p.to(L.selectionRange));return d.isNonEmptyArray(L.tags)&&(J.tags=L.tags.map(z.to)),L.children&&(J.children=L.children.map(H)),J}G.to=H})(q=e.DocumentSymbol||(e.DocumentSymbol={}));var M;(function(G){function Q(H){const L=new y.CallHierarchyItem(V.to(H.kind),H.name,H.detail||"",A.URI.revive(H.uri),p.to(H.range),p.to(H.selectionRange));return L._sessionId=H._sessionId,L._itemId=H._itemId,L}G.to=Q})(M=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(G){function Q(H){return new y.CallHierarchyIncomingCall(M.to(H.from),H.fromRanges.map(L=>p.to(L)))}G.to=Q})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var re;(function(G){function Q(H){return new y.CallHierarchyOutgoingCall(M.to(H.to),H.fromRanges.map(L=>p.to(L)))}G.to=Q})(re=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var F;(function(G){function Q(L){return{range:L.range&&p.from(L.range),uri:L.uri}}G.from=Q;function H(L){return new y.Location(L.uri,p.to(L.range))}G.to=H})(F=e.location||(e.location={}));var te;(function(G){function Q(L){const J=L,X=L;return{originSelectionRange:J.originSelectionRange?p.from(J.originSelectionRange):void 0,uri:J.targetUri?J.targetUri:X.uri,range:p.from(J.targetRange?J.targetRange:X.range),targetSelectionRange:J.targetSelectionRange?p.from(J.targetSelectionRange):void 0}}G.from=Q;function H(L){return{targetUri:L.uri,targetRange:p.to(L.range),targetSelectionRange:L.targetSelectionRange?p.to(L.targetSelectionRange):void 0,originSelectionRange:L.originSelectionRange?p.to(L.originSelectionRange):void 0}}G.to=H})(te=e.DefinitionLink||(e.DefinitionLink={}));var ae;(function(G){function Q(L){return{range:p.from(L.range),contents:r.fromMany(L.contents)}}G.from=Q;function H(L){return new y.Hover(L.contents.map(r.to),p.to(L.range))}G.to=H})(ae=e.Hover||(e.Hover={}));var ue;(function(G){function Q(L){return{range:p.from(L.range),expression:L.expression}}G.from=Q;function H(L){return new y.EvaluatableExpression(p.to(L.range),L.expression)}G.to=H})(ue=e.EvaluatableExpression||(e.EvaluatableExpression={}));var we;(function(G){function Q(L){return{range:p.from(L.range),kind:L.kind}}G.from=Q;function H(L){return new y.DocumentHighlight(p.to(L.range),L.kind)}G.to=H})(we=e.DocumentHighlight||(e.DocumentHighlight={}));var fe;(function(G){function Q(H){switch(H){case 1:return y.CompletionTriggerKind.TriggerCharacter;case 2:return y.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return y.CompletionTriggerKind.Invoke}}G.to=Q})(fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var De;(function(G){function Q(H){return{triggerKind:fe.to(H.triggerKind),triggerCharacter:H.triggerCharacter}}G.to=Q})(De=e.CompletionContext||(e.CompletionContext={}));var Se;(function(G){function Q(L){switch(L){case y.CompletionItemTag.Deprecated:return 1}}G.from=Q;function H(L){switch(L){case 1:return y.CompletionItemTag.Deprecated}}G.to=H})(Se=e.CompletionItemTag||(e.CompletionItemTag={}));var Ce;(function(G){const Q=new Map([[y.CompletionItemKind.Method,0],[y.CompletionItemKind.Function,1],[y.CompletionItemKind.Constructor,2],[y.CompletionItemKind.Field,3],[y.CompletionItemKind.Variable,4],[y.CompletionItemKind.Class,5],[y.CompletionItemKind.Interface,7],[y.CompletionItemKind.Struct,6],[y.CompletionItemKind.Module,8],[y.CompletionItemKind.Property,9],[y.CompletionItemKind.Unit,12],[y.CompletionItemKind.Value,13],[y.CompletionItemKind.Constant,14],[y.CompletionItemKind.Enum,15],[y.CompletionItemKind.EnumMember,16],[y.CompletionItemKind.Keyword,17],[y.CompletionItemKind.Snippet,27],[y.CompletionItemKind.Text,18],[y.CompletionItemKind.Color,19],[y.CompletionItemKind.File,20],[y.CompletionItemKind.Reference,21],[y.CompletionItemKind.Folder,23],[y.CompletionItemKind.Event,10],[y.CompletionItemKind.Operator,11],[y.CompletionItemKind.TypeParameter,24],[y.CompletionItemKind.Issue,26],[y.CompletionItemKind.User,25]]);function H(X){var ce;return(ce=Q.get(X))!==null&&ce!==void 0?ce:9}G.from=H;const L=new Map([[0,y.CompletionItemKind.Method],[1,y.CompletionItemKind.Function],[2,y.CompletionItemKind.Constructor],[3,y.CompletionItemKind.Field],[4,y.CompletionItemKind.Variable],[5,y.CompletionItemKind.Class],[7,y.CompletionItemKind.Interface],[6,y.CompletionItemKind.Struct],[8,y.CompletionItemKind.Module],[9,y.CompletionItemKind.Property],[12,y.CompletionItemKind.Unit],[13,y.CompletionItemKind.Value],[14,y.CompletionItemKind.Constant],[15,y.CompletionItemKind.Enum],[16,y.CompletionItemKind.EnumMember],[17,y.CompletionItemKind.Keyword],[27,y.CompletionItemKind.Snippet],[18,y.CompletionItemKind.Text],[19,y.CompletionItemKind.Color],[20,y.CompletionItemKind.File],[21,y.CompletionItemKind.Reference],[23,y.CompletionItemKind.Folder],[10,y.CompletionItemKind.Event],[11,y.CompletionItemKind.Operator],[24,y.CompletionItemKind.TypeParameter],[25,y.CompletionItemKind.User],[26,y.CompletionItemKind.Issue]]);function J(X){var ce;return(ce=L.get(X))!==null&&ce!==void 0?ce:y.CompletionItemKind.Property}G.to=J})(Ce=e.CompletionItemKind||(e.CompletionItemKind={}));var x;(function(G){function Q(H,L){var J;const X=new y.CompletionItem(typeof H.label=="string"?H.label:H.label.name);return typeof H.label!="string"&&(X.label2=H.label),X.insertText=H.insertText,X.kind=Ce.to(H.kind),X.tags=(J=H.tags)===null||J===void 0?void 0:J.map(Se.to),X.detail=H.detail,X.documentation=E.isMarkdownString(H.documentation)?r.to(H.documentation):H.documentation,X.sortText=H.sortText,X.filterText=H.filterText,X.preselect=H.preselect,X.commitCharacters=H.commitCharacters,T.Range.isIRange(H.range)?X.range=p.to(H.range):typeof H.range=="object"&&(X.range={inserting:p.to(H.range.insert),replacing:p.to(H.range.replace)}),X.keepWhitespace=typeof H.insertTextRules=="undefined"?!1:Boolean(H.insertTextRules&1),typeof H.insertTextRules!="undefined"&&H.insertTextRules&4?X.insertText=new y.SnippetString(H.insertText):(X.insertText=H.insertText,X.textEdit=X.range instanceof y.Range?new y.TextEdit(X.range,X.insertText):void 0),H.additionalTextEdits&&H.additionalTextEdits.length>0&&(X.additionalTextEdits=H.additionalTextEdits.map(ce=>R.to(ce))),X.command=L&&H.command?L.fromInternal(H.command):void 0,X}G.to=Q})(x=e.CompletionItem||(e.CompletionItem={}));var K;(function(G){function Q(L){return{label:L.label,documentation:L.documentation?r.fromStrict(L.documentation):void 0}}G.from=Q;function H(L){return{label:L.label,documentation:E.isMarkdownString(L.documentation)?r.to(L.documentation):L.documentation}}G.to=H})(K=e.ParameterInformation||(e.ParameterInformation={}));var ee;(function(G){function Q(L){return{label:L.label,documentation:L.documentation?r.fromStrict(L.documentation):void 0,parameters:Array.isArray(L.parameters)?L.parameters.map(K.from):[],activeParameter:L.activeParameter}}G.from=Q;function H(L){return{label:L.label,documentation:E.isMarkdownString(L.documentation)?r.to(L.documentation):L.documentation,parameters:Array.isArray(L.parameters)?L.parameters.map(K.to):[],activeParameter:L.activeParameter}}G.to=H})(ee=e.SignatureInformation||(e.SignatureInformation={}));var ne;(function(G){function Q(L){return{activeSignature:L.activeSignature,activeParameter:L.activeParameter,signatures:Array.isArray(L.signatures)?L.signatures.map(ee.from):[]}}G.from=Q;function H(L){return{activeSignature:L.activeSignature,activeParameter:L.activeParameter,signatures:Array.isArray(L.signatures)?L.signatures.map(ee.to):[]}}G.to=H})(ne=e.SignatureHelp||(e.SignatureHelp={}));var de;(function(G){function Q(L){return{text:L.text,range:p.from(L.range),description:L.description&&r.fromStrict(L.description),whitespaceBefore:L.whitespaceBefore,whitespaceAfter:L.whitespaceAfter}}G.from=Q;function H(L){return new y.InlineHint(L.text,p.to(L.range),E.isMarkdownString(L.description)?r.to(L.description):L.description,L.whitespaceBefore,L.whitespaceAfter)}G.to=H})(de=e.InlineHint||(e.InlineHint={}));var Ee;(function(G){function Q(L){return{range:p.from(L.range),url:L.target,tooltip:L.tooltip}}G.from=Q;function H(L){let J;if(L.url)try{J=typeof L.url=="string"?A.URI.parse(L.url,!0):A.URI.revive(L.url)}catch(X){}return new y.DocumentLink(p.to(L.range),J)}G.to=H})(Ee=e.DocumentLink||(e.DocumentLink={}));var Re;(function(G){function Q(L){const J=new y.ColorPresentation(L.label);return L.textEdit&&(J.textEdit=R.to(L.textEdit)),L.additionalTextEdits&&(J.additionalTextEdits=L.additionalTextEdits.map(X=>R.to(X))),J}G.to=Q;function H(L){return{label:L.label,textEdit:L.textEdit?R.from(L.textEdit):void 0,additionalTextEdits:L.additionalTextEdits?L.additionalTextEdits.map(J=>R.from(J)):void 0}}G.from=H})(Re=e.ColorPresentation||(e.ColorPresentation={}));var xe;(function(G){function Q(L){return new y.Color(L[0],L[1],L[2],L[3])}G.to=Q;function H(L){return[L.red,L.green,L.blue,L.alpha]}G.from=H})(xe=e.Color||(e.Color={}));var be;(function(G){function Q(L){return{range:p.from(L.range)}}G.from=Q;function H(L){return new y.SelectionRange(p.to(L.range))}G.to=H})(be=e.SelectionRange||(e.SelectionRange={}));var ke;(function(G){function Q(H){switch(H){case 2:return y.TextDocumentSaveReason.AfterDelay;case 1:return y.TextDocumentSaveReason.Manual;case 3:case 4:return y.TextDocumentSaveReason.FocusOut}}G.to=Q})(ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Te;(function(G){function Q(L){switch(L){case y.TextEditorLineNumbersStyle.Off:return 0;case y.TextEditorLineNumbersStyle.Relative:return 2;case y.TextEditorLineNumbersStyle.On:default:return 1}}G.from=Q;function H(L){switch(L){case 0:return y.TextEditorLineNumbersStyle.Off;case 2:return y.TextEditorLineNumbersStyle.Relative;case 1:default:return y.TextEditorLineNumbersStyle.On}}G.to=H})(Te=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ne;(function(G){function Q(L){if(L===y.EndOfLine.CRLF)return 1;if(L===y.EndOfLine.LF)return 0}G.from=Q;function H(L){if(L===1)return y.EndOfLine.CRLF;if(L===0)return y.EndOfLine.LF}G.to=H})(Ne=e.EndOfLine||(e.EndOfLine={}));var pe;(function(G){function Q(H){if(typeof H=="object")return H.viewId;switch(H){case y.ProgressLocation.SourceControl:return 3;case y.ProgressLocation.Window:return 10;case y.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}G.from=Q})(pe=e.ProgressLocation||(e.ProgressLocation={}));var ze;(function(G){function Q(H){const L={start:H.start+1,end:H.end+1};return H.kind&&(L.kind=B.from(H.kind)),L}G.from=Q})(ze=e.FoldingRange||(e.FoldingRange={}));var B;(function(G){function Q(H){if(H)switch(H){case y.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case y.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case y.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}G.from=Q})(B=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Z;(function(G){function Q(H){if(H)return{pinned:typeof H.preview=="boolean"?!H.preview:void 0,inactive:H.background,preserveFocus:H.preserveFocus,selection:typeof H.selection=="object"?p.from(H.selection):void 0,override:typeof H.override=="boolean"?!1:void 0}}G.from=Q})(Z=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var he;(function(G){function Q(L){return L instanceof y.RelativePattern||typeof L=="string"?L:H(L)?new y.RelativePattern(L.base,L.pattern):L}G.from=Q;function H(L){const J=L;return J&&typeof J.base=="string"&&typeof J.pattern=="string"}})(he=e.GlobPattern||(e.GlobPattern={}));var Le;(function(G){function Q(H){if(H)return Array.isArray(H)?H.map(Q):typeof H=="string"?H:{language:H.language,scheme:H.scheme,pattern:typeof H.pattern=="undefined"?void 0:he.from(H.pattern),exclusive:H.exclusive}}G.from=Q})(Le=e.LanguageSelector||(e.LanguageSelector={}));var Oe;(function(G){function Q(H){return H.toJSON()}G.from=Q})(Oe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var We;(function(G){function Q(H){return{outputKind:a.CellOutputKind.Rich,data:{[H.mime]:H.value},metadata:H.metadata&&{custom:H.metadata}}}G.from=Q})(We=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ke;(function(G){function Q(X){if(X!=null){if(X instanceof y.RelativePattern||typeof X=="string")return X;if(J(X))return new y.RelativePattern(X.base,X.pattern);if(L(X))return{include:he.from(X.include)||void 0,exclude:he.from(X.exclude)||void 0}}}G.from=Q;function H(X){return typeof X=="string"?X:J(X)?{base:X.base,pattern:X.pattern}:{include:X.include,exclude:X.exclude}}G.to=H;function L(X){const ce=X,me=he.from(ce.include);if(!(me&&me instanceof y.RelativePattern||typeof me=="string"))return!1;const Pe=he.from(ce.exclude);return!!(Pe&&Pe instanceof y.RelativePattern||typeof Pe=="string")}function J(X){const ce=X;return ce&&typeof ce.base=="string"&&typeof ce.pattern=="string"}})(Ke=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ie;(function(G){function Q(H){return{backgroundColor:H.backgroundColor,borderColor:H.borderColor,top:H.top?_.from(H.top):void 0}}G.from=Q})(ie=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ge;(function(G){function Q(L){return{runState:L.runState,duration:L.duration,messages:L.messages.map(J=>({message:r.fromStrict(J.message)||"",severity:J.severity,expectedOutput:J.expectedOutput,actualOutput:J.actualOutput,location:J.location?F.from(J.location):void 0}))}}G.from=Q;function H(L){return new y.TestState(L.runState,L.messages.map(J=>({message:typeof J.message=="string"?J.message:r.to(J.message),severity:J.severity,expectedOutput:J.expectedOutput,actualOutput:J.actualOutput,location:J.location&&F.to({range:J.location.range,uri:A.URI.revive(J.location.uri)})})),L.duration)}G.to=H})(ge=e.TestState||(e.TestState={}));var Me;(function(G){function Q(L,J){var X,ce,me;return{extId:(X=L.id)!==null&&X!==void 0?X:J?`${J}\0${L.label}`:L.label,label:L.label,location:L.location?F.from(L.location):void 0,debuggable:(ce=L.debuggable)!==null&&ce!==void 0?ce:!1,description:L.description,runnable:(me=L.runnable)!==null&&me!==void 0?me:!0,state:ge.from(L.state)}}G.from=Q;function H(L){return{id:L.extId,label:L.label,location:L.location&&F.to({range:L.location.range,uri:A.URI.revive(L.location.uri)}),debuggable:L.debuggable,description:L.description,runnable:L.runnable,state:ge.to(L.state)}}G.toShallow=H})(Me=e.TestItem||(e.TestItem={}))}),define(ve[170],_e([0,1,2,9,7,14,54]),function(se,e,b,y,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(i,P,S,v={timeout:1500,errors:3}){this._logService=i,this._documents=P,this._mainThreadBulkEdits=S,this._thresholds=v,this._callbacks=new E.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(i){return(P,S,v)=>{const a={dispose:this._callbacks.push([P,S,i])};return Array.isArray(v)&&v.push(a),a}}async $participateInSave(i,P){const S=b.URI.revive(i);let v=!1;const d=setTimeout(()=>v=!0,this._thresholds.timeout),a=[];try{for(let m of[...this._callbacks]){if(v)break;const p=this._documents.getDocument(S),f=await this._deliverEventAsyncAndBlameBadListeners(m,{document:p,reason:T.TextDocumentSaveReason.to(P)});a.push(f)}}finally{clearTimeout(d)}return a}_deliverEventAsyncAndBlameBadListeners([i,P,S],v){const d=this._badListeners.get(i);return typeof d=="number"&&d>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(S,i,P,v).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const m=this._badListeners.get(i);this._badListeners.set(i,m?m+1:1),typeof m=="number"&&m>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(i,P,S,v){const d=[],a=Date.now(),{document:m,reason:p}=v,{version:f}=m,c=Object.freeze({document:m,reason:p,waitUntil(n){if(Object.isFrozen(d))throw y.illegalState("waitUntil can not be called async");d.push(Promise.resolve(n))}});try{P.apply(S,[c])}catch(n){return Promise.reject(n)}return Object.freeze(d),new Promise((n,o)=>{const h=setTimeout(()=>o(new Error("timeout")),this._thresholds.timeout);return Promise.all(d).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${i.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(h),n(t)}).catch(t=>{clearTimeout(h),o(t)})}).then(n=>{const o={edits:[]};for(const h of n)if(Array.isArray(h)&&h.every(t=>t instanceof A.TextEdit))for(const{newText:t,newEol:s,range:l}of h)o.edits.push({_type:2,resource:m.uri,edit:{range:l&&T.Range.from(l),text:t,eol:s&&T.EndOfLine.from(s)}});if(o.edits.length!==0)return f===m.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(ve[171],_e([0,1,3,29,2,14,7]),function(se,e,b,y,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(P,S,v,d,a){this._onDidCreate=new b.Emitter,this._onDidChange=new b.Emitter,this._onDidDelete=new b.Emitter,this._config=0,v&&(this._config+=1),d&&(this._config+=2),a&&(this._config+=4);const m=y.parse(S),p=P(f=>{if(!v)for(let c of f.created){const n=A.URI.revive(c);m(n.fsPath)&&this._onDidCreate.fire(n)}if(!d)for(let c of f.changed){const n=A.URI.revive(c);m(n.fsPath)&&this._onDidChange.fire(n)}if(!a)for(let c of f.deleted){const n=A.URI.revive(c);m(n.fsPath)&&this._onDidDelete.fire(n)}});this._disposable=E.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,p)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class I{constructor(P,S,v){this._logService=S,this._extHostDocumentsAndEditors=v,this._onFileSystemEvent=new b.Emitter,this._onDidRenameFile=new b.Emitter,this._onDidCreateFile=new b.Emitter,this._onDidDeleteFile=new b.Emitter,this._onWillRenameFile=new b.AsyncEmitter,this._onWillCreateFile=new b.AsyncEmitter,this._onWillDeleteFile=new b.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(P,S,v,d){return new k(this._onFileSystemEvent.event,P,S,v,d)}$onFileEvent(P){this._onFileSystemEvent.fire(P)}$onDidRunFileOperation(P,S){switch(P){case 2:this._onDidRenameFile.fire(Object.freeze({files:S.map(v=>({oldUri:A.URI.revive(v.source),newUri:A.URI.revive(v.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:S.map(v=>A.URI.revive(v.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:S.map(v=>A.URI.revive(v.target))}));break;default:}}getOnWillRenameFileEvent(P){return this._createWillExecuteEvent(P,this._onWillRenameFile)}getOnWillCreateFileEvent(P){return this._createWillExecuteEvent(P,this._onWillCreateFile)}getOnWillDeleteFileEvent(P){return this._createWillExecuteEvent(P,this._onWillDeleteFile)}_createWillExecuteEvent(P,S){return(v,d,a)=>{const m=function(f){v.call(d,f)};return m.extension=P,S.event(m,void 0,a)}}async $onWillRunFileOperation(P,S,v,d){switch(P){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:S.map(a=>({oldUri:A.URI.revive(a.source),newUri:A.URI.revive(a.target)}))},v,d);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:S.map(a=>A.URI.revive(a.target))},v,d);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:S.map(a=>A.URI.revive(a.target))},v,d)}}async _fireWillEvent(P,S,v,d){const a=new Set,m=[];if(await P.fireAsync(S,d,async(f,c)=>{var n;const o=Date.now(),h=await Promise.resolve(f);h instanceof E.WorkspaceEdit&&(m.push(h),a.add((n=c.extension.displayName)!==null&&n!==void 0?n:c.extension.identifier.value)),Date.now()-o>v&&this._logService.warn("SLOW file-participant",c.extension.identifier)}),!d.isCancellationRequested&&m.length!==0){const p={edits:[]};for(let f of m){let{edits:c}=T.WorkspaceEdit.from(f,this._extHostDocumentsAndEditors);p.edits=p.edits.concat(c)}return{edit:p,extensionNames:Array.from(a)}}}}e.ExtHostFileSystemEventService=I}),define(ve[172],_e([0,1,14,145,128,20,44]),function(se,e,b,y,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class k{constructor(S){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=S}withProgress(S,v,d){const a=this._handles++,{title:m,location:p,cancellable:f}=v,c=A.localize(0,null,S.displayName||S.name);return this._proxy.$startProgress(a,{location:b.ProgressLocation.from(p),title:m,source:c,cancellable:f},S),this._withProgress(a,d,!!f)}_withProgress(S,v,d){let a;d&&(a=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(S,a));const m=f=>{this._proxy.$progressEnd(f),this._mapHandleToCancellationSource.delete(f),a&&a.dispose()};let p;try{p=v(new i(this._proxy,S),d&&a?a.token:T.CancellationToken.None)}catch(f){throw m(S),f}return p.then(f=>m(S),f=>m(S)),p}$acceptProgressCanceled(S){const v=this._mapHandleToCancellationSource.get(S);v&&(v.cancel(),this._mapHandleToCancellationSource.delete(S))}}e.ExtHostProgress=k;function I(P,S){return P.message=S.message,typeof S.increment=="number"&&(typeof P.increment=="number"?P.increment+=S.increment:P.increment=S.increment),P}class i extends y.Progress{constructor(S,v){super(d=>this.throttledReport(d));this._proxy=S,this._handle=v}throttledReport(S){this._proxy.$progressReport(this._handle,S)}}He([E.throttle(100,(P,S)=>I(P,S),()=>Object.create(null))],i.prototype,"throttledReport",null)}),define(ve[94],_e([0,1,43,9,52,14,7]),function(se,e,b,y,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(v,d){this.key=k._Keys.nextId(),this._proxy=v,this._proxy.$registerTextEditorDecorationType(this.key,T.DecorationRenderOptions.from(d))}dispose(){this._proxy.$removeTextEditorDecorationType(this.key)}}e.TextEditorDecorationType=k,k._Keys=new A.IdGenerator("TextEditorDecorationType");class I{constructor(v,d){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=v,this._documentVersionId=v.version,this._undoStopBefore=d.undoStopBefore,this._undoStopAfter=d.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(v,d){this._throwIfFinalized();let a=null;if(v instanceof E.Position)a=new E.Range(v,v);else if(v instanceof E.Range)a=v;else throw new Error("Unrecognized location");this._pushEdit(a,d,!1)}insert(v,d){this._throwIfFinalized(),this._pushEdit(new E.Range(v,v),d,!0)}delete(v){this._throwIfFinalized();let d=null;if(v instanceof E.Range)d=v;else throw new Error("Unrecognized location");this._pushEdit(d,null,!0)}_pushEdit(v,d,a){const m=this._document.validateRange(v);this._collectedEdits.push({range:m,text:d,forceMoveMarkers:a})}setEndOfLine(v){if(this._throwIfFinalized(),v!==E.EndOfLine.LF&&v!==E.EndOfLine.CRLF)throw y.illegalArgument("endOfLine");this._setEndOfLine=v}}e.TextEditorEdit=I;class i{constructor(v,d,a,m){this._proxy=v,this._id=d,this._accept(a),this._logService=m}_accept(v){this._tabSize=v.tabSize,this._indentSize=v.indentSize,this._insertSpaces=v.insertSpaces,this._cursorStyle=v.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(v.lineNumbers)}get tabSize(){return this._tabSize}_validateTabSize(v){if(v==="auto")return"auto";if(typeof v=="number"){const d=Math.floor(v);return d>0?d:null}if(typeof v=="string"){const d=parseInt(v,10);return isNaN(d)?null:d>0?d:null}return null}set tabSize(v){const d=this._validateTabSize(v);if(d!==null){if(typeof d=="number"){if(this._tabSize===d)return;this._tabSize=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:d}))}}get indentSize(){return this._indentSize}_validateIndentSize(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const d=Math.floor(v);return d>0?d:null}if(typeof v=="string"){const d=parseInt(v,10);return isNaN(d)?null:d>0?d:null}return null}set indentSize(v){const d=this._validateIndentSize(v);if(d!==null){if(typeof d=="number"){if(this._indentSize===d)return;this._indentSize=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{indentSize:d}))}}get insertSpaces(){return this._insertSpaces}_validateInsertSpaces(v){return v==="auto"?"auto":v==="false"?!1:Boolean(v)}set insertSpaces(v){const d=this._validateInsertSpaces(v);if(typeof d=="boolean"){if(this._insertSpaces===d)return;this._insertSpaces=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:d}))}get cursorStyle(){return this._cursorStyle}set cursorStyle(v){this._cursorStyle!==v&&(this._cursorStyle=v,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:v})))}get lineNumbers(){return this._lineNumbers}set lineNumbers(v){this._lineNumbers!==v&&(this._lineNumbers=v,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(v)})))}assign(v){const d={};let a=!1;if(typeof v.tabSize!="undefined"){const m=this._validateTabSize(v.tabSize);m==="auto"?(a=!0,d.tabSize=m):typeof m=="number"&&this._tabSize!==m&&(this._tabSize=m,a=!0,d.tabSize=m)}if(typeof v.insertSpaces!="undefined"){const m=this._validateInsertSpaces(v.insertSpaces);m==="auto"?(a=!0,d.insertSpaces=m):this._insertSpaces!==m&&(this._insertSpaces=m,a=!0,d.insertSpaces=m)}typeof v.cursorStyle!="undefined"&&this._cursorStyle!==v.cursorStyle&&(this._cursorStyle=v.cursorStyle,a=!0,d.cursorStyle=v.cursorStyle),typeof v.lineNumbers!="undefined"&&this._lineNumbers!==v.lineNumbers&&(this._lineNumbers=v.lineNumbers,a=!0,d.lineNumbers=T.TextEditorLineNumbersStyle.from(v.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,d))}_warnOnError(v){v.catch(d=>this._logService.warn(d))}}e.ExtHostTextEditorOptions=i;class P{constructor(v,d,a,m,p,f,c,n){this.id=v,this._proxy=d,this._logService=a,this._disposed=!1,this._documentData=m,this._selections=p,this._options=new i(this._proxy,this.id,f,a),this._visibleRanges=c,this._viewColumn=n,this._hasDecorationsForKey=Object.create(null)}dispose(){b.ok(!this._disposed),this._disposed=!0}show(v){this._proxy.$tryShowEditor(this.id,T.ViewColumn.from(v))}hide(){this._proxy.$tryHideEditor(this.id)}get document(){return this._documentData.document}set document(v){throw y.readonly("document")}get options(){return this._options}set options(v){this._disposed||this._options.assign(v)}_acceptOptions(v){b.ok(!this._disposed),this._options._accept(v)}get visibleRanges(){return this._visibleRanges}set visibleRanges(v){throw y.readonly("visibleRanges")}_acceptVisibleRanges(v){b.ok(!this._disposed),this._visibleRanges=v}get viewColumn(){return this._viewColumn}set viewColumn(v){throw y.readonly("viewColumn")}_acceptViewColumn(v){b.ok(!this._disposed),this._viewColumn=v}get selection(){return this._selections&&this._selections[0]}set selection(v){if(!(v instanceof E.Selection))throw y.illegalArgument("selection");this._selections=[v],this._trySetSelection()}get selections(){return this._selections}set selections(v){if(!Array.isArray(v)||v.some(d=>!(d instanceof E.Selection)))throw y.illegalArgument("selections");this._selections=v,this._trySetSelection()}setDecorations(v,d){const a=d.length===0;a&&!this._hasDecorationsForKey[v.key]||(a?delete this._hasDecorationsForKey[v.key]:this._hasDecorationsForKey[v.key]=!0,this._runOnProxy(()=>{if(T.isDecorationOptionsArr(d))return this._proxy.$trySetDecorations(this.id,v.key,T.fromRangeOrRangeWithMessage(d));{const m=new Array(4*d.length);for(let p=0,f=d.length;p<f;p++){const c=d[p];m[4*p]=c.start.line+1,m[4*p+1]=c.start.character+1,m[4*p+2]=c.end.line+1,m[4*p+3]=c.end.character+1}return this._proxy.$trySetDecorationsFast(this.id,v.key,m)}}))}revealRange(v,d){this._runOnProxy(()=>this._proxy.$tryRevealRange(this.id,T.Range.from(v),d||E.TextEditorRevealType.Default))}_trySetSelection(){const v=this._selections.map(T.Selection.from);return this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,v))}_acceptSelections(v){b.ok(!this._disposed),this._selections=v}edit(v,d={undoStopBefore:!0,undoStopAfter:!0}){if(this._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new I(this._documentData.document,d);return v(a),this._applyEdit(a)}_applyEdit(v){const d=v.finalize();if(d.edits.length===0&&!d.setEndOfLine)return Promise.resolve(!0);const a=d.edits.map(p=>p.range);a.sort((p,f)=>p.end.line===f.end.line?p.end.character===f.end.character?p.start.line===f.start.line?p.start.character-f.start.character:p.start.line-f.start.line:p.end.character-f.end.character:p.end.line-f.end.line);for(let p=0,f=a.length-1;p<f;p++){const c=a[p].end;if(a[p+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=d.edits.map(p=>({range:T.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,d.documentVersionId,m,{setEndOfLine:typeof d.setEndOfLine=="number"?T.EndOfLine.from(d.setEndOfLine):void 0,undoStopBefore:d.undoStopBefore,undoStopAfter:d.undoStopAfter})}insertSnippet(v,d,a={undoStopBefore:!0,undoStopAfter:!0}){if(this._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let m;if(!d||Array.isArray(d)&&d.length===0)m=this._selections.map(p=>T.Range.from(p));else if(d instanceof E.Position){const{lineNumber:p,column:f}=T.Position.from(d);m=[{startLineNumber:p,startColumn:f,endLineNumber:p,endColumn:f}]}else if(d instanceof E.Range)m=[T.Range.from(d)];else{m=[];for(const p of d)if(p instanceof E.Range)m.push(T.Range.from(p));else{const{lineNumber:f,column:c}=T.Position.from(p);m.push({startLineNumber:f,startColumn:c,endLineNumber:f,endColumn:c})}}return this._proxy.$tryInsertSnippet(this.id,v.value,m,a)}_runOnProxy(v){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,d=>(d instanceof Error&&d.name==="DISPOSED"||this._logService.warn(d),null))}}e.ExtHostTextEditor=P}),define(ve[173],_e([0,1,131,23,2,3,6,15,7,12,11,14,20]),function(se,e,b,y,A,T,E,k,I,i,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(p,f){if(i.isString(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let c;return Array.isArray(p.highlights)&&(c=p.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),c=c.length?c:void 0),{label:p.label,highlights:c}}}class a{constructor(f,c,n){this._proxy=f,this.commands=c,this.logService=n,this.treeViews=new Map;function o(h){return h&&h.$treeViewId&&h.$treeItemHandle}c.registerArgumentProcessor({processArgument:h=>o(h)?this.convertArgument(h):Array.isArray(h)&&h.length>0?h.map(t=>o(t)?this.convertArgument(t):t):h})}registerTreeDataProvider(f,c,n){const o=this.createTreeView(f,{treeDataProvider:c},n);return{dispose:()=>o.dispose()}}createTreeView(f,c,n){if(!c||!c.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=this.createExtHostTreeView(f,c,n);return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get message(){return o.message},set message(h){o.message=h},get title(){return o.title},set title(h){o.title=h},get description(){return o.description},set description(h){o.description=h},reveal:(h,t)=>o.reveal(h,t),dispose:()=>{this.treeViews.delete(f),o.dispose()}}}$getChildren(f,c){const n=this.treeViews.get(f);return n?n.getChildren(c):Promise.reject(new Error(b.localize(0,null,f)))}async $hasResolve(f){const c=this.treeViews.get(f);if(!c)throw new Error(b.localize(1,null,f));return c.hasResolve}$resolve(f,c,n){const o=this.treeViews.get(f);if(!o)throw new Error(b.localize(2,null,f));return o.resolveTreeItem(c,n)}$setExpanded(f,c,n){const o=this.treeViews.get(f);if(!o)throw new Error(b.localize(3,null,f));o.setExpanded(c,n)}$setSelection(f,c){const n=this.treeViews.get(f);if(!n)throw new Error(b.localize(4,null,f));n.setSelection(c)}$setVisible(f,c){const n=this.treeViews.get(f);if(!n)throw new Error(b.localize(5,null,f));n.setVisible(c)}createExtHostTreeView(f,c,n){const o=new m(f,c,this._proxy,this.commands.converter,this.logService,n);return this.treeViews.set(f,o),o}convertArgument(f){const c=this.treeViews.get(f.$treeViewId);return c?c.getExtensionElement(f.$treeItemHandle):null}}e.ExtHostTreeViews=a;class m extends E.Disposable{constructor(f,c,n,o,h,t){super();if(this.viewId=f,this.proxy=n,this.commands=o,this.logService=h,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new v.CancellationTokenSource,t.contributes&&t.contributes.views)for(const u in t.contributes.views)for(const r of t.contributes.views[u])r.id===f&&(this._title=r.name);this.dataProvider=c.treeDataProvider,this.proxy.$registerTreeViewDataProvider(f,{showCollapseAll:!!c.showCollapseAll,canSelectMany:!!c.canSelectMany}),this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(u=>this._onDidChangeData.fire({message:!1,element:u})));let s,l;this._register(T.Event.debounce(this._onDidChangeData.event,(u,r)=>(u||(u={message:!1,elements:[]}),r.element!==!1&&(s||(s=new Promise(g=>l=g),this.refreshPromise=this.refreshPromise.then(()=>s)),u.elements.push(r.element)),r.message&&(u.message=!0),u),200,!0)(({message:u,elements:r})=>{r.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const g=l;return s=null,this.refresh(r).then(()=>g())})),u&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(f=>this.getExtensionElement(f)).filter(f=>!i.isUndefinedOrNull(f))}getChildren(f){const c=f?this.getExtensionElement(f):void 0;if(f&&!c)return this.logService.error(`No tree item with id '${f}' found.`),Promise.resolve([]);const n=this.getChildrenNodes(f);return(n?Promise.resolve(n):this.fetchChildrenNodes(c)).then(o=>o.map(h=>h.item))}getExtensionElement(f){return this.elements.get(f)}reveal(f,c){c=c||{select:!0,focus:!1};const n=i.isUndefinedOrNull(c.select)?!0:c.select,o=i.isUndefinedOrNull(c.focus)?!1:c.focus,h=i.isUndefinedOrNull(c.expand)?!1:c.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):f?this.refreshPromise.then(()=>this.resolveUnknownParentChain(f)).then(t=>this.resolveTreeNode(f,t[t.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:t.map(l=>l.item)},{select:n,focus:o,expand:h})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:n,focus:o,expand:h})}get message(){return this._message}set message(f){this._message=f,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(f){this._title=f,this.proxy.$setTitle(this.viewId,f,this._description)}get description(){return this._description}set description(f){this._description=f,this.proxy.$setTitle(this.viewId,this._title,f)}setExpanded(f,c){const n=this.getExtensionElement(f);n&&(c?this._onDidExpandElement.fire(Object.freeze({element:n})):this._onDidCollapseElement.fire(Object.freeze({element:n})))}setSelection(f){P.equals(this._selectedHandles,f)||(this._selectedHandles=f,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(f){f!==this._visible&&(this._visible=f,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(f,c){var n;if(!!this.dataProvider.resolveTreeItem){const o=this.elements.get(f);if(o){const h=this.nodes.get(o);if(h){const t=(n=await this.dataProvider.resolveTreeItem(h.extensionItem,o,c))!==null&&n!==void 0?n:h.extensionItem;return h.item.tooltip=this.getTooltip(t.tooltip),h.item.command=this.getCommand(h.disposableStore,t.command),h.item}}}}resolveUnknownParentChain(f){return this.resolveParent(f).then(c=>c?this.resolveUnknownParentChain(c).then(n=>this.resolveTreeNode(c,n[n.length-1]).then(o=>(n.push(o),n))):Promise.resolve([]))}resolveParent(f){const c=this.nodes.get(f);return c?Promise.resolve(c.parent?this.elements.get(c.parent.item.handle):void 0):k.asPromise(()=>this.dataProvider.getParent(f))}resolveTreeNode(f,c){const n=this.nodes.get(f);return n?Promise.resolve(n):k.asPromise(()=>this.dataProvider.getTreeItem(f)).then(o=>this.createHandle(f,o,c,!0)).then(o=>this.getChildren(c?c.item.handle:void 0).then(()=>{const h=this.getExtensionElement(o);if(h){const t=this.nodes.get(h);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${o}`)}))}getChildrenNodes(f){if(f){let c;if(typeof f=="string"){const n=this.getExtensionElement(f);c=n?this.nodes.get(n):void 0}else c=f;return c&&c.children||null}return this.roots}async fetchChildrenNodes(f){this.clearChildren(f);const c=new v.CancellationTokenSource(this._refreshCancellationSource.token);try{const n=f?this.nodes.get(f):void 0,o=await this.dataProvider.getChildren(f);if(c.token.isCancellationRequested)return[];const h=await Promise.all(P.coalesce(o||[]).map(async t=>{const s=await this.dataProvider.getTreeItem(t);return s&&!c.token.isCancellationRequested?this.createAndRegisterTreeNode(t,s,n):null}));return c.token.isCancellationRequested?[]:P.coalesce(h)}finally{c.dispose()}}refresh(f){if(f.some(n=>!n))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new v.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const n=this.getHandlesToRefresh(f);if(n.length)return this.refreshHandles(n)}return Promise.resolve(void 0)}getHandlesToRefresh(f){const c=new Set;for(const o of f){const h=this.nodes.get(o);if(h&&!c.has(h.item.handle)){let t=h;for(;t&&t.parent&&!c.has(t.parent.item.handle);){const s=this.elements.get(t.parent.item.handle);t=s?this.nodes.get(s):void 0}t&&!t.parent&&c.add(h.item.handle)}}const n=[];return c.forEach(o=>{const h=this.elements.get(o);if(h){const t=this.nodes.get(h);t&&(!t.parent||!c.has(t.parent.item.handle))&&n.push(o)}}),n}refreshHandles(f){const c={};return Promise.all(f.map(n=>this.refreshNode(n).then(o=>{o&&(c[n]=o.item)}))).then(()=>Object.keys(c).length?this.proxy.$refresh(this.viewId,c):void 0)}refreshNode(f){const c=this.getExtensionElement(f);if(c){const n=this.nodes.get(c);if(n)return this.clearChildren(c),k.asPromise(()=>this.dataProvider.getTreeItem(c)).then(o=>{if(o){const h=this.createTreeNode(c,o,n.parent);return this.updateNodeCache(c,h,n,n.parent),n.dispose(),h}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(f,c,n){const o=this.createTreeNode(f,c,n);if(c.id&&this.elements.has(o.item.handle))throw new Error(b.localize(6,null,c.id));return this.addNodeToCache(f,o),this.addNodeToParentCache(o,n),o}getTooltip(f){return I.MarkdownString.isMarkdownString(f)?S.MarkdownString.from(f):f}getCommand(f,c){return c?this.commands.toInternal(c,f):void 0}createTreeNode(f,c,n){const o=new E.DisposableStore,h=this.createHandle(f,c,n),t=this.getLightIconPath(c);return{item:{handle:h,parentHandle:n?n.item.handle:void 0,label:d(c.label,this.extension),description:c.description,resourceUri:c.resourceUri,tooltip:this.getTooltip(c.tooltip),command:this.getCommand(o,c.command),contextValue:c.contextValue,icon:t,iconDark:this.getDarkIconPath(c)||t,themeIcon:this.getThemeIcon(c),collapsibleState:i.isUndefinedOrNull(c.collapsibleState)?I.TreeItemCollapsibleState.None:c.collapsibleState,accessibilityInformation:c.accessibilityInformation},extensionItem:c,parent:n,children:void 0,disposableStore:o,dispose(){o.dispose()}}}getThemeIcon(f){return f.iconPath instanceof I.ThemeIcon?f.iconPath:void 0}createHandle(f,{id:c,label:n,resourceUri:o},h,t){if(c)return`${m.ID_HANDLE_PREFIX}/${c}`;const s=d(n,this.extension),l=h?h.item.handle:m.LABEL_HANDLE_PREFIX;let u=s?s.label:o?y.basename(o):"";u=u.indexOf("/")!==-1?u.replace("/","//"):u;const r=this.nodes.has(f)?this.nodes.get(f).item.handle:void 0,g=this.getChildrenNodes(h)||[];let C,_=0;do{if(C=`${l}/${_}:${u}`,t||!this.elements.has(C)||r===C)break;_++}while(_<=g.length);return C}getLightIconPath(f){if(f.iconPath&&!(f.iconPath instanceof I.ThemeIcon))return typeof f.iconPath=="string"||A.URI.isUri(f.iconPath)?this.getIconPath(f.iconPath):this.getIconPath(f.iconPath.light)}getDarkIconPath(f){if(f.iconPath&&!(f.iconPath instanceof I.ThemeIcon)&&f.iconPath.dark)return this.getIconPath(f.iconPath.dark)}getIconPath(f){return A.URI.isUri(f)?f:A.URI.file(f)}addNodeToCache(f,c){this.elements.set(c.item.handle,f),this.nodes.set(f,c)}updateNodeCache(f,c,n,o){this.elements.delete(c.item.handle),this.nodes.delete(f),c.item.handle!==n.item.handle&&this.elements.delete(n.item.handle),this.addNodeToCache(f,c);const h=this.getChildrenNodes(o)||[],t=h.filter(s=>s.item.handle===n.item.handle)[0];t&&h.splice(h.indexOf(t),1,c)}addNodeToParentCache(f,c){c?(c.children||(c.children=[]),c.children.push(f)):(this.roots||(this.roots=[]),this.roots.push(f))}clearChildren(f){if(f){const c=this.nodes.get(f);if(c){if(c.children)for(const n of c.children){const o=this.elements.get(n.item.handle);o&&this.clear(o)}c.children=void 0}}else this.clearAll()}clear(f){const c=this.nodes.get(f);if(c){if(c.children)for(const n of c.children){const o=this.elements.get(n.item.handle);o&&this.clear(o)}this.nodes.delete(f),this.elements.delete(c.item.handle),c.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(f=>f.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}m.LABEL_HANDLE_PREFIX="0",m.ID_HANDLE_PREFIX="1"}),define(ve[174],_e([0,1,15,44,26,14]),function(se,e,b,y,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.OwnedTestCollection=void 0;class E{constructor(){this.testIdToInternal=new Map}getTestById(v){return this.testIdToInternal.get(v)}createForHierarchy(v=()=>{}){return new k(this.testIdToInternal,v)}}e.OwnedTestCollection=E;class k{constructor(v,d){this.testIdToInternal=v,this.publishDiff=d,this.testItemToInternal=new Map,this.diff=[],this.disposed=!1,this.debounceSendDiff=new b.RunOnceScheduler(()=>this.throttleSendDiff(),2)}addRoot(v,d){this.addItem(v,d,null),this.debounceSendDiff.schedule()}getTestByReference(v){return this.testItemToInternal.get(v)}onItemChange(v,d){const a=this.testItemToInternal.get(v);if(!a){this.disposed||console.warn("Received a TestProvider.onDidChangeTest for a test that wasn't seen before as a child.");return}this.addItem(v,d,a.parent),this.debounceSendDiff.schedule()}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){this.diff.push(v),this.debounceSendDiff.schedule()}dispose(){for(const v of this.testItemToInternal.values())this.testIdToInternal.delete(v.id);this.diff=[],this.disposed=!0}getId(){return A.generateUuid()}addItem(v,d,a){let m=this.testItemToInternal.get(v);const p=a?this.testIdToInternal.get(a):null;if(m?m.previousEquals(v)||(m.item=T.TestItem.from(v,p==null?void 0:p.item.extId),m.previousEquals=P(v),this.diff.push([1,{id:m.id,parent:a,providerId:d,item:m.item}])):(m={actual:v,id:this.getId(),parent:a,item:T.TestItem.from(v,p==null?void 0:p.item.extId),providerId:d,previousChildren:new Set,previousEquals:P(v)},this.testItemToInternal.set(v,m),this.testIdToInternal.set(m.id,m),this.diff.push([0,{id:m.id,parent:a,providerId:d,item:m.item}])),v.children){const f=m.previousChildren,c=new Set;for(const n of v.children){const o=this.addItem(n,d,m.id);f.delete(o.id),c.add(o.id)}for(const n of f)this.removeItembyId(n);m.previousChildren=c}return m}removeItembyId(v){this.diff.push([2,v]);const d=[this.testIdToInternal.get(v)];for(;d.length;){const a=d.pop();if(!!a){this.testIdToInternal.delete(a.id),this.testItemToInternal.delete(a.actual);for(const m of a.previousChildren)d.push(this.testIdToInternal.get(m))}}}throttleSendDiff(){this.flushDiff()}flushDiff(){const v=this.collectDiff();v.length&&this.publishDiff(v)}}He([y.throttle(200)],k.prototype,"throttleSendDiff",null),e.SingleUseTestCollection=k;const i=Object.keys({id:null,label:null,location:null,state:null,debuggable:null,description:null,runnable:null}),P=S=>{const v=[];for(const d of i)v.push(S[d]);return d=>{for(let a=0;a<i.length;a++)if(v[a]!==d[i[a]])return!1;return!0}}}),define(ve[175],_e([0,1,25,3,10]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(P){this.removedDueToLooping=P}}e.DeltaExtensionsResult=T;class E{constructor(P){this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=P,this._initialize()}_initialize(){this._extensionDescriptions.sort(I),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const P of this._extensionDescriptions){if(this._extensionsMap.has(b.ExtensionIdentifier.toKey(P.identifier))){console.error("Extension `"+P.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(b.ExtensionIdentifier.toKey(P.identifier),P),this._extensionsArr.push(P),Array.isArray(P.activationEvents))for(let S of P.activationEvents)S==="onUri"&&(S=`onUri:${b.ExtensionIdentifier.toKey(P.identifier)}`),this._activationMap.has(S)||this._activationMap.set(S,[]),this._activationMap.get(S).push(P)}}keepOnly(P){const S=new Set;P.forEach(v=>S.add(b.ExtensionIdentifier.toKey(v))),this._extensionDescriptions=this._extensionDescriptions.filter(v=>S.has(b.ExtensionIdentifier.toKey(v.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(P,S){P.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(P));const v=E._findLoopingExtensions(this._extensionDescriptions);if(S=S.concat(v.map(d=>d.identifier)),S.length>0){const d=new Set;S.forEach(a=>d.add(b.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!d.has(b.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(v)}static _findLoopingExtensions(P){const S=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,f){this.addNode(p),this.addNode(f),this._arcs.has(p)?this._arcs.get(p).push(f):this._arcs.set(p,[f])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,f){const c=S.getArcs(p);for(let n=0;n<c.length;n++)if(!f.has(c[n]))return!1;return!0}getNodes(){return this._nodesArr}};let v=new Map;for(let p of P){const f=b.ExtensionIdentifier.toKey(p.identifier);if(v.set(f,p),p.extensionDependencies)for(let c of p.extensionDependencies){const n=b.ExtensionIdentifier.toKey(c);S.addArc(f,n)}}let d=new Set;S.getNodes().filter(p=>S.getArcs(p).length===0).forEach(p=>d.add(p));let a=S.getNodes().filter(p=>!d.has(p)),m;do{m=!1;for(let p=0;p<a.length;p++){const f=a[p];S.hasOnlyGoodArcs(f,d)&&(a.splice(p,1),p--,d.add(f),m=!0)}}while(m);return a.map(p=>v.get(p))}containsActivationEvent(P){return this._activationMap.has(P)}containsExtension(P){return this._extensionsMap.has(b.ExtensionIdentifier.toKey(P))}getExtensionDescriptionsForActivationEvent(P){const S=this._activationMap.get(P);return S?S.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(P){const S=this._extensionsMap.get(b.ExtensionIdentifier.toKey(P));return S||void 0}}e.ExtensionDescriptionRegistry=E;var k;(function(i){i[i.Builtin=0]="Builtin",i[i.User=1]="User",i[i.Dev=2]="Dev"})(k||(k={}));function I(i,P){const S=i.isBuiltin?0:i.isUnderDevelopment?2:1,v=P.isBuiltin?0:P.isUnderDevelopment?2:1;if(S!==v)return S-v;const d=A.posix.basename(i.extensionLocation.path),a=A.posix.basename(P.extensionLocation.path);return d<a?-1:d>a?1:0}}),define(ve[176],_e([0,1,27]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var y;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.StartTimeout60s=56]="StartTimeout60s",k[k.UnexpectedError=81]="UnexpectedError"})(y=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function T(k){const I=b.VSBuffer.alloc(1);switch(k){case 0:I.writeUInt8(1,0);break;case 1:I.writeUInt8(2,0);break;case 2:I.writeUInt8(3,0);break}return I}e.createMessageOfType=T;function E(k,I){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return I===0;case 2:return I===1;case 3:return I===2;default:return!1}}e.isMessageOfType=E}),define(ve[34],_e([0,1,3,2,4,25,142]),function(se,e,b,y,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:y.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=A.createDecorator("extensionService");class k{constructor(c){this.dependency=c}}e.MissingDependencyError=k;var I;(function(f){f[f.LocalProcess=0]="LocalProcess",f[f.LocalWebWorker=1]="LocalWebWorker",f[f.Remote=2]="Remote"})(I=e.ExtensionHostKind||(e.ExtensionHostKind={}));class i{constructor(c,n,o,h){this.codeLoadingTime=c,this.activateCallTime=n,this.activateResolvedTime=o,this.activationReason=h}}e.ActivationTimes=i;class P{constructor(c,n){this.description=c,this.value=n}}e.ExtensionPointContribution=P,e.ExtensionHostLogFileName="exthost";var S;(function(f){f[f.Normal=0]="Normal",f[f.Immediate=1]="Immediate"})(S=e.ActivationKind||(e.ActivationKind={}));function v(f){f.enableProposedApi||d(f)}e.checkProposedApiEnabled=v;function d(f){throw new Error(`[${f.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${f.identifier.value}`)}e.throwProposedApiError=d;function a(f){return{type:f.isBuiltin?0:1,isBuiltin:f.isBuiltin||f.isUserBuiltin,identifier:{id:E.getGalleryExtensionId(f.publisher,f.name),uuid:f.uuid},manifest:f,location:f.extensionLocation}}e.toExtension=a;function m(f){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(f.identifier.id),isBuiltin:f.type===0,isUserBuiltin:f.type===1&&f.isBuiltin,isUnderDevelopment:!1,extensionLocation:f.location},f.manifest),{uuid:f.identifier.uuid})}e.toExtensionDescription=m;class p{constructor(){this.onDidRegisterExtensions=b.Event.None,this.onDidChangeExtensionsStatus=b.Event.None,this.onDidChangeExtensions=b.Event.None,this.onWillActivateByEvent=b.Event.None,this.onDidChangeResponsiveChange=b.Event.None}activateByEvent(c){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(c){return Promise.resolve(0)}restartExtensionHost(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(c,n){}_activateById(c,n){return Promise.resolve()}_onWillActivateExtension(c){}_onDidActivateExtension(c,n,o,h,t){}_onExtensionRuntimeError(c,n){}_onExtensionHostExit(c){}}e.NullExtensionService=p}),define(ve[177],_e([0,1,126,25,34,17]),function(se,e,b,y,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const E=Promise.resolve(void 0);class k{constructor(m,p,f,c){this.startup=m,this.codeLoadingTime=p,this.activateCallTime=f,this.activateResolvedTime=c}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class I{constructor(m){this._startup=m,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(m,p){return m===-1||p===-1?-1:p-m}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class i{constructor(m,p,f,c,n,o){this.activationFailed=m,this.activationFailedError=p,this.activationTimes=f,this.module=c,this.exports=n,this.subscriptions=o}}e.ActivatedExtension=i;class P extends i{constructor(m){super(!1,null,m,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class S extends i{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=S;class v extends i{constructor(m){super(!0,m,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=v;let d=class{constructor(m,p,f,c,n){this._logService=n,this._registry=m,this._resolvedExtensionsSet=new Set,p.forEach(o=>this._resolvedExtensionsSet.add(y.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,f.forEach(o=>this._hostExtensionsMap.set(y.ExtensionIdentifier.toKey(o),o)),this._host=c,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(m){const p=y.ExtensionIdentifier.toKey(m);return this._activatedExtensions.has(p)}getActivatedExtension(m){const p=y.ExtensionIdentifier.toKey(m),f=this._activatedExtensions.get(p);if(!f)throw new Error("Extension `"+m.value+"` is not known or not activated");return f}activateByEvent(m,p){if(this._alreadyActivatedEvents[m])return E;const f=this._registry.getExtensionDescriptionsForActivationEvent(m);return this._activateExtensions(f.map(c=>({id:c.identifier,reason:{startup:p,extensionId:c.identifier,activationEvent:m}}))).then(()=>{this._alreadyActivatedEvents[m]=!0})}activateById(m,p){const f=this._registry.getExtensionDescription(m);if(!f)throw new Error("Extension `"+m+"` is not known");return this._activateExtensions([{id:f.identifier,reason:p}])}_handleActivateRequest(m,p,f){if(this._hostExtensionsMap.has(y.ExtensionIdentifier.toKey(m.id))){p[y.ExtensionIdentifier.toKey(m.id)]=m;return}const c=this._registry.getExtensionDescription(m.id);if(!c){this._host.onExtensionActivationError(m.id,new A.MissingDependencyError(m.id.value));const h=new Error(`Unknown dependency '${m.id.value}'`);this._activatedExtensions.set(y.ExtensionIdentifier.toKey(m.id),new v(h));return}const n=typeof c.extensionDependencies=="undefined"?[]:c.extensionDependencies;let o=!0;for(let h=0,t=n.length;h<t;h++){const s=n[h];if(!this._resolvedExtensionsSet.has(y.ExtensionIdentifier.toKey(s))){const l=this._activatedExtensions.get(y.ExtensionIdentifier.toKey(s));if(!(l&&!l.activationFailed)){if(l&&l.activationFailed){this._host.onExtensionActivationError(c.identifier,b.localize(0,null,c.displayName||c.identifier.value,s));const g=new Error(`Dependency ${s} failed to activate`);g.detail=l.activationFailedError,this._activatedExtensions.set(y.ExtensionIdentifier.toKey(c.identifier),new v(g));return}if(this._hostExtensionsMap.has(y.ExtensionIdentifier.toKey(s))){o=!1,p[y.ExtensionIdentifier.toKey(s)]={id:this._hostExtensionsMap.get(y.ExtensionIdentifier.toKey(s)),reason:m.reason};continue}const u=this._registry.getExtensionDescription(s);if(u){o=!1,p[y.ExtensionIdentifier.toKey(s)]={id:u.identifier,reason:m.reason};continue}this._host.onExtensionActivationError(c.identifier,new A.MissingDependencyError(s));const r=new Error(`Unknown dependency '${s}'`);this._activatedExtensions.set(y.ExtensionIdentifier.toKey(c.identifier),new v(r));return}}}o?p[y.ExtensionIdentifier.toKey(c.identifier)]=m:f.push(m)}_activateExtensions(m){if(m.length===0||(m=m.filter(n=>!this._activatedExtensions.has(y.ExtensionIdentifier.toKey(n.id))),m.length===0))return Promise.resolve(void 0);const p=Object.create(null),f=[];for(let n=0,o=m.length;n<o;n++)this._handleActivateRequest(m[n],p,f);for(let n=0,o=f.length;n<o;n++){const h=y.ExtensionIdentifier.toKey(f[n].id);p[h]&&delete p[h]}const c=Object.keys(p).map(n=>p[n]);return f.length===0?Promise.all(c.map(n=>this._activateExtension(n.id,n.reason))).then(n=>{}):this._activateExtensions(c).then(n=>this._activateExtensions(f))}_activateExtension(m,p){const f=y.ExtensionIdentifier.toKey(m);if(this._activatedExtensions.has(f))return Promise.resolve(void 0);const c=this._activatingExtensions.get(f);if(c)return c;const n=this._host.actualActivateExtension(m,p).then(void 0,o=>(this._host.onExtensionActivationError(m,b.localize(1,null,m.value,o.message)),this._logService.error(`Activating extension ${m.value} failed due to an error:`),this._logService.error(o),new v(o))).then(o=>{this._activatedExtensions.set(f,o),this._activatingExtensions.delete(f)});return this._activatingExtensions.set(f,n),n}};d=He([Be(4,T.ILogService)],d),e.ExtensionsActivator=d}),define(ve[178],_e([0,1,9]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class y{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,E)=>{this._actualOk=T,this._actualErr=E,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):b.onUnexpectedError(T))}then(T,E){return this._ensureActual().then(T,E)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=y}),define(ve[95],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class b{constructor(I,i){this.isMain=I,this.sid=i,this.nid=++b.count}}e.ProxyIdentifier=b,b.count=0;const y=[];function A(k){const I=new b(!0,k);return y[I.nid]=I,I}e.createMainContextProxyIdentifier=A;function T(k){const I=new b(!1,k);return y[I.nid]=I,I}e.createExtHostContextProxyIdentifier=T;function E(k){return y[k].sid}e.getStringIdentifierForProxy=E}),define(ve[5],_e([0,1,2,95,58]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var E;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(E=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var I;(function(c){c[c.Markdown=1]="Markdown",c[c.Code=2]="Code"})(I=e.CellKind||(e.CellKind={}));var i;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(i=e.CellOutputKind||(e.CellOutputKind={}));var P;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(P=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var S;(function(c){c.name="$ident";function n(h,t){return Object.defineProperty(h,c.name,{value:t,enumerable:!0}),h}c.mixin=n;function o(h){return h[c.name]}c.of=o})(S=e.ObjectIdentifier||(e.ObjectIdentifier={}));class v{static mixin(n){return n._id=v._n++,n}}e.IdObject=v,v._n=0;var d;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n",c.label2="o"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var a;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(a=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(m=e.WorkspaceEditType||(e.WorkspaceEditType={}));function p(c){if(c&&c.edits)for(const n of c.edits)typeof n.resource=="object"?n.resource=b.URI.revive(n.resource):(n.newUri=b.URI.revive(n.newUri),n.oldUri=b.URI.revive(n.oldUri)),n.metadata&&n.metadata.iconPath&&(n.metadata=A.revive(n.metadata));return c}e.reviveWorkspaceEditDto=p;var f;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:y.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:y.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:y.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:y.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:y.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:y.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:y.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:y.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:y.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:y.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:y.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:y.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:y.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:y.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:y.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:y.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:y.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:y.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:y.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:y.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:y.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:y.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:y.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:y.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:y.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:y.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:y.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:y.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:y.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:y.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:y.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:y.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:y.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:y.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:y.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:y.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:y.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:y.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:y.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:y.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:y.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:y.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:y.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:y.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:y.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:y.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:y.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadTheming:y.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:y.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:y.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:y.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:y.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:y.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:y.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:y.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:y.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:y.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:y.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:y.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:y.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:y.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:y.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:y.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:y.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:y.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:y.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:y.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:y.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:y.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:y.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:y.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:y.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:y.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:y.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:y.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:y.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:y.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:y.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:y.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:y.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:y.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:y.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:y.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:y.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:y.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:y.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:y.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:y.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:y.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:y.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostTheming:y.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:y.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:y.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:y.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:y.createMainContextProxyIdentifier("ExtHostTesting")}}),define(ve[72],_e([0,1,5,3,4]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(k){this._onDidChangePassword=new y.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(b.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,I){return this._proxy.$getPassword(k,I)}store(k,I,i){return this._proxy.$setPassword(k,I,i)}delete(k,I){return this._proxy.$deletePassword(k,I)}}e.ExtHostSecretState=T,e.IExtHostSecretState=A.createDecorator("IExtHostSecretState")}),define(ve[73],_e([0,1,4,17,5,13]),function(se,e,b,y,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=b.createDecorator("IExtHostApiDeprecationService");let E=class{constructor(I,i){this._extHostLogService=i,this._reportedUsages=new Set,this._telemetryShape=I.getProxy(A.MainContext.MainThreadTelemetry)}report(I,i,P){const S=this.getUsageKey(I,i);this._reportedUsages.has(S)||(this._reportedUsages.add(S),i.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${I}' is deprecated. ${P}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:i.identifier.value,apiId:I}))}getUsageKey(I,i){return`${I}-${i.identifier.value}`}};E=He([Be(0,T.IExtHostRpcService),Be(1,y.ILogService)],E),e.ExtHostApiDeprecationService=E,e.NullApiDeprecationService=Object.freeze(new class{report(k,I,i){}})}),define(ve[179],_e([0,1,3,5,7,25]),function(se,e,b,y,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class E{constructor(I){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new b.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new b.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=I.getProxy(y.MainContext.MainThreadAuthentication)}$setProviders(I){return this._providers=I,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(I,i,P,S={}){const v=T.ExtensionIdentifier.toKey(I.identifier),d=this._inFlightRequests.get(v)||[],a=P.sort().join(" ");let m=d.find(p=>p.scopes===a);if(m)return m.result;{const p=this._getSession(I,v,i,P,S);m={scopes:a,result:p},d.push(m),this._inFlightRequests.set(v,d);try{await p}finally{const f=d.findIndex(c=>c.scopes===a);f>-1&&(d.splice(f),this._inFlightRequests.set(v,d))}return p}}async _getSession(I,i,P,S,v={}){await this._proxy.$ensureProvider(P);const d=this._authenticationProviders.get(P),a=I.displayName||I.name;if(!d)return this._proxy.$getSession(P,S,i,a,v);const m=S.sort().join(" "),p=(await d.provider.getSessions()).filter(c=>c.scopes.slice().sort().join(" ")===m);let f;if(p.length){if(d.options.supportsMultipleAccounts){const c=await this._proxy.$selectSession(P,d.label,i,a,p,S,!!v.clearSessionPreference);f=p.find(n=>n.id===c.id)}else if(f=p[0],!await this._proxy.$getSessionsPrompt(P,f.account.label,d.label,i,a))throw new Error("User did not consent to login.")}else if(v.createIfNone){if(!await this._proxy.$loginPrompt(d.label,a))throw new Error("User did not consent to login.");f=await d.provider.login(S),await this._proxy.$setTrustedExtensionAndAccountPreference(P,f.account.label,i,a,f.id)}else await this._proxy.$requestNewSession(P,S,i,a);return f}async logout(I,i){const P=this._authenticationProviders.get(I);return P?P.provider.logout(i):this._proxy.$logout(I,i)}registerAuthenticationProvider(I,i,P,S){var v;if(this._authenticationProviders.get(I))throw new Error(`An authentication provider with id '${I}' is already registered.`);this._authenticationProviders.set(I,{label:i,provider:P,options:S!=null?S:{supportsMultipleAccounts:!1}}),this._providers.find(a=>a.id===I)||this._providers.push({id:I,label:i});const d=P.onDidChangeSessions(a=>{this._proxy.$sendDidChangeSessions(I,a)});return this._proxy.$registerAuthenticationProvider(I,i,(v=S==null?void 0:S.supportsMultipleAccounts)!==null&&v!==void 0?v:!1),new A.Disposable(()=>{d.dispose(),this._authenticationProviders.delete(I);const a=this._providers.findIndex(m=>m.id===I);a>-1&&this._providers.splice(a),this._proxy.$unregisterAuthenticationProvider(I)})}$login(I,i){const P=this._authenticationProviders.get(I);if(P)return Promise.resolve(P.provider.login(i));throw new Error(`Unable to find authentication provider with handle: ${I}`)}$logout(I,i){const P=this._authenticationProviders.get(I);if(P)return Promise.resolve(P.provider.logout(i));throw new Error(`Unable to find authentication provider with handle: ${I}`)}$getSessions(I){const i=this._authenticationProviders.get(I);if(i)return Promise.resolve(i.provider.getSessions());throw new Error(`Unable to find authentication provider with handle: ${I}`)}async $getSessionAccessToken(I,i){const P=this._authenticationProviders.get(I);if(P){const v=(await P.provider.getSessions()).find(d=>d.id===i);if(v)return v.accessToken;throw new Error(`Unable to find session with id: ${i}`)}throw new Error(`Unable to find authentication provider with handle: ${I}`)}$onDidChangeAuthenticationSessions(I,i,P){return this._onDidChangeSessions.fire(Object.assign({provider:{id:I,label:i}},P)),Promise.resolve()}$onDidChangeAuthenticationProviders(I,i){return I.forEach(P=>{this._providers.some(S=>S.id===P.id)||this._providers.push(P)}),i.forEach(P=>{const S=this._providers.findIndex(v=>v.id===P.id);S>-1&&this._providers.splice(S)}),this._onDidChangeAuthenticationProviders.fire({added:I,removed:i}),Promise.resolve()}}e.ExtHostAuthentication=E}),define(ve[180],_e([0,1,5,13,14]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(k,I,i){this._extHostDocumentsAndEditors=I,this._extHostNotebooks=i,this._proxy=k.getProxy(b.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const I=A.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors,this._extHostNotebooks);return this._proxy.$tryApplyWorkspaceEdit(I)}};T=He([Be(0,y.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(ve[181],_e([0,1,5]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class y{constructor(T){this._proxy=T.getProxy(b.MainContext.MainThreadClipboard)}readText(){return this._proxy.$readText()}writeText(T){return this._proxy.$writeText(T)}}e.ExtHostClipboard=y}),define(ve[74],_e([0,1,12,7,14,24,5,11,17,58,32,39,2,6,4,13]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let p=class{constructor(t,s){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadCommands),this._logService=s,this.converter=new f(this,l=>{const u=this._apiCommands.get(l);return(u==null?void 0:u.result)===n.Void?u:void 0},s),this._argumentProcessors=[{processArgument(l){return i.revive(l)}},{processArgument(l){return T.cloneAndChange(l,function(u){if(P.Range.isIRange(u))return A.Range.to(u);if(S.Position.isIPosition(u))return A.Position.to(u);if(P.Range.isIRange(u.range)&&v.URI.isUri(u.uri))return A.location.to(u);if(!Array.isArray(u))return u})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const s=this.registerCommand(!1,t.id,async(...l)=>{const u=t.args.map((g,C)=>{if(!g.validate(l[C]))throw new Error(`Invalid argument '${g.name}' when running '${t.id}', received: ${l[C]}`);return g.convert(l[C])}),r=await this.executeCommand(t.internalId,...u);return t.result.convert(r,l,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new y.Disposable(()=>{s.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,s,l,u,r){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:l,thisArg:u,description:r}),t&&this._proxy.$registerCommand(s),new y.Disposable(()=>{this._commands.delete(s)&&t&&this._proxy.$unregisterCommand(s)})}executeCommand(t,...s){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,s,!0)}async _doExecuteCommand(t,s,l){if(this._commands.has(t))return this._executeContributedCommand(t,s);{const u=T.cloneAndChange(s,function(r){if(r instanceof y.Position)return A.Position.from(r);if(r instanceof y.Range)return A.Range.from(r);if(r instanceof y.Location)return A.location.from(r);if(!Array.isArray(r))return r});try{const r=await this._proxy.$executeCommand(t,u,l);return i.revive(r)}catch(r){if(r instanceof Error&&r.message==="$executeCommand:retry")return this._doExecuteCommand(t,s,!1);throw r}}}async _executeContributedCommand(t,s){const l=this._commands.get(t);if(!l)throw new Error("Unknown command");let{callback:u,thisArg:r,description:g}=l;if(g)for(let C=0;C<g.args.length;C++)try{b.validateConstraint(s[C],g.args[C].constraint)}catch(_){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${g.args[C].name}' - ${g.args[C].description}`)}try{return await u.apply(r,s)}catch(C){throw this._logService.error(C,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(s=s.map(l=>this._argumentProcessors.reduce((u,r)=>r.processArgument(u),l)),this._executeContributedCommand(t,s)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(s=>(t&&(s=s.filter(l=>l[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[s,l]of this._commands){let{description:u}=l;u&&(t[s]=u)}return Promise.resolve(t)}};p=He([Be(0,m.IExtHostRpcService),Be(1,I.ILogService)],p),e.ExtHostCommands=p,e.IExtHostCommands=a.createDecorator("IExtHostCommands");class f{constructor(t,s,l){this._commands=t,this._lookupApiCommand=s,this._logService=l,this._cache=new Map,this._cachIdPool=0,this._delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._commands.registerCommand(!0,this._delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,s){if(!!t){const l={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return l;const u=this._lookupApiCommand(t.command);if(u)l.id=u.internalId,l.arguments=u.args.map((r,g)=>r.convert(t.arguments&&t.arguments[g]));else if(k.isNonEmptyArray(t.arguments)){const r=++this._cachIdPool;this._cache.set(r,t),s.add(d.toDisposable(()=>{this._cache.delete(r),this._logService.trace("CommandsConverter#DISPOSE",r)})),l.$ident=r,l.id=this._delegatingCommandId,l.arguments=[r],this._logService.trace("CommandsConverter#CREATE",t.command,r)}return l}}fromInternal(t){const s=E.ObjectIdentifier.of(t);return typeof s=="number"?this._cache.get(s):{command:t.id,title:t.title,arguments:t.arguments}}_executeConvertedCommand(...t){const s=this._cache.get(t[0]);return this._logService.trace("CommandsConverter#EXECUTE",t[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=f;class c{constructor(t,s,l,u){this.name=t,this.description=s,this.validate=l,this.convert=u}optional(){return new c(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,s){return new c(t!=null?t:this.name,s!=null?s:this.description,this.validate,this.convert)}}e.ApiCommandArgument=c,c.Uri=new c("uri","Uri of a text document",h=>v.URI.isUri(h),h=>h),c.Position=new c("position","A position in a text document",h=>y.Position.isPosition(h),A.Position.from),c.Range=new c("range","A range in a text document",h=>y.Range.isRange(h),A.Range.from),c.Selection=new c("selection","A selection in a text document",h=>y.Selection.isSelection(h),A.Selection.from),c.Number=new c("number","",h=>typeof h=="number",h=>h),c.String=new c("string","",h=>typeof h=="string",h=>h),c.CallHierarchyItem=new c("item","A call hierarchy item",h=>h instanceof y.CallHierarchyItem,A.CallHierarchyItem.to);class n{constructor(t,s){this.description=t,this.convert=s}}e.ApiCommandResult=n,n.Void=new n("no result",h=>h);class o{constructor(t,s,l,u,r){this.id=t,this.internalId=s,this.description=l,this.args=u,this.result=r}}e.ApiCommand=o}),define(ve[182],_e([0,1,6,14,7,63,74,156,11,85]),function(se,e,b,y,A,T,E,k,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const P=[new E.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",v(y.DocumentHighlight.to))),new E.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(a,m)=>{if(!I.isFalsyOrEmpty(a)){class p extends A.SymbolInformation{static to(c){const n=new p(c.name,y.SymbolKind.to(c.kind),c.containerName||"",new A.Location(m[0],y.Range.to(c.range)));return n.detail=c.detail,n.range=n.location.range,n.selectionRange=y.Range.to(c.selectionRange),n.children=c.children?c.children.map(p.to):[],n}}return a.map(p.to)}})),new E.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new E.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new E.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,new E.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new E.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new E.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new E.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new E.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new E.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new E.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location-instances.",v(y.location.to))),new E.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Hover-instances.",v(y.Hover.to))),new E.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("position","A positions in a text document",a=>Array.isArray(a)&&a.every(m=>A.Position.isPosition(m)),a=>a.map(y.Position.from))],new E.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(m=>{let p;for(const f of m.reverse())p=new A.SelectionRange(y.Range.to(f),p);return p}))),new E.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[E.ApiCommandArgument.String.with("query","Search string")],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const m=[];if(Array.isArray(a))for(let p of a)m.push(...p[1].map(y.WorkspaceSymbol.to));return m})),new E.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(y.CallHierarchyItem.to))),new E.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(y.CallHierarchyIncomingCall.to))),new E.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(y.CallHierarchyOutgoingCall.to))),new E.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("newName","The new symbol name")],new E.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return y.WorkspaceEdit.to(a)}})),new E.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new E.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(y.DocumentLink.to))),new E.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new A.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const m=i.decodeSemanticTokensDto(a);if(m.type==="full")return new A.SemanticTokens(m.data,void 0)}})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new A.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const m=i.decodeSemanticTokensDto(a);if(m.type==="full")return new A.SemanticTokens(m.data,void 0)}})),new E.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new E.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,m,p)=>{if(!a)return new A.CompletionList([]);const f=a.suggestions.map(c=>y.CompletionItem.to(c,p));return new A.CompletionList(f,a.incomplete)})),new E.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new E.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return y.SignatureHelp.to(a)})),new E.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new E.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,m,p)=>v(f=>new A.CodeLens(y.Range.to(f.range),f.command&&p.fromInternal(f.command)))(a))),new E.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>A.Range.isRange(a),a=>A.Selection.isSelection(a)?y.Selection.from(a):y.Range.from(a)),E.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new E.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,m,p)=>v(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(f.command)}else{const c=new A.CodeAction(f.title,f.kind?new A.CodeActionKind(f.kind):void 0);return f.edit&&(c.edit=y.WorkspaceEdit.to(f.edit)),f.command&&(c.command=p.fromInternal(f.command)),c.isPreferred=f.isPreferred,c}})(a))),new E.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(m=>new A.ColorInformation(y.Range.to(m.range),y.Color.to(m.color))):[])),new E.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new E.ApiCommandArgument("color","The color to show and insert",a=>a instanceof A.Color,y.Color.from),new E.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:y.Range.from(a.range)}))],new E.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(y.ColorPresentation.to):[])),new E.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of InlineHint objects",a=>a.map(y.InlineHint.to))),new E.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new E.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",v(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientMetadata:a.options.transientMetadata},filenamePattern:a.filenamePattern.map(m=>y.NotebookExclusiveDocumentPattern.to(m))})))),new E.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or a http(s) url. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[y.ViewColumn.from(a.viewColumn),y.TextEditorOpenOptions.from(a)])).optional(),E.ApiCommandArgument.String.with("label","").optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[E.ApiCommandArgument.Uri.with("resource","Resource to open"),E.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[y.ViewColumn.from(a.viewColumn),y.TextEditorOpenOptions.from(a)])).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[E.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),E.ApiCommandArgument.Uri.with("right","Rigth-hand side resource of the diff editor"),E.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[y.ViewColumn.from(a.viewColumn),y.TextEditorOpenOptions.from(a)]).optional()],E.ApiCommandResult.Void)];class S{constructor(m){this._disposables=new b.DisposableStore,this._commands=m}static register(m){return P.forEach(m.registerApiCommand,m),new S(m).registerCommands()}registerCommands(){const m=p=>(...f)=>p(this._commands,...f);this._register(k.RemoveFromRecentlyOpenedAPICommand.ID,m(k.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:p=>typeof p=="string"}]}),this._register(k.OpenIssueReporter.ID,m(k.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:p=>typeof p=="string"||typeof p=="object"&&typeof p.extensionId=="string"}]})}_register(m,p,f){const c=this._commands.registerCommand(!1,m,p,this,f);this._disposables.add(c)}}e.ExtHostApiCommands=S;function v(a){return m=>{if(Array.isArray(m))return m.map(a)}}function d(a){if(!!Array.isArray(a)){const m=[];for(const p of a)T.isLocationLink(p)?m.push(y.DefinitionLink.to(p)):m.push(y.location.to(p));return m}}}),define(ve[183],_e([0,1,15,44,3,6,2,63,25,14,7,5]),function(se,e,b,y,A,T,E,k,I,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class v{constructor(o,h,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=o.getProxy(S.MainContext.MainThreadComments),h.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===6){const l=this._commentControllers.get(s.handle);return l||s}else if(s&&s.$mid===7){const l=this._commentControllers.get(s.commentControlHandle);if(!l)return s;const u=l.getCommentThread(s.commentThreadHandle);return u||s}else if(s&&s.$mid===8){const l=this._commentControllers.get(s.thread.commentControlHandle);if(!l)return s;const u=l.getCommentThread(s.thread.commentThreadHandle);return u?{thread:u,text:s.text}:s}else if(s&&s.$mid===9){const l=this._commentControllers.get(s.thread.commentControlHandle);if(!l)return s;const u=l.getCommentThread(s.thread.commentThreadHandle);if(!u)return s;let r=s.commentUniqueId,g=u.getCommentByUniqueId(r);return g||s}else if(s&&s.$mid===10){const l=this._commentControllers.get(s.thread.commentControlHandle);if(!l)return s;const u=l.getCommentThread(s.thread.commentThreadHandle);if(!u)return s;let r=s.text,g=s.commentUniqueId,C=u.getCommentByUniqueId(g);return C?(C.body=r,C):s}return s}})}createCommentController(o,h,t){const s=v.handlePool++,l=new a(o,s,this._proxy,h,t);this._commentControllers.set(l.handle,l);const u=this._commentControllersByExtension.get(I.ExtensionIdentifier.toKey(o.identifier))||[];return u.push(l),this._commentControllersByExtension.set(I.ExtensionIdentifier.toKey(o.identifier),u),l}$createCommentThreadTemplate(o,h,t){const s=this._commentControllers.get(o);!s||s.$createCommentThreadTemplate(h,t)}async $updateCommentThreadTemplate(o,h,t){const s=this._commentControllers.get(o);!s||s.$updateCommentThreadTemplate(h,t)}$deleteCommentThread(o,h){const t=this._commentControllers.get(o);t&&t.$deleteCommentThread(h)}$provideCommentingRanges(o,h,t){const s=this._commentControllers.get(o);if(!s||!s.commentingRangeProvider)return Promise.resolve(void 0);const l=this._documents.getDocument(E.URI.revive(h));return b.asPromise(()=>s.commentingRangeProvider.provideCommentingRanges(l,t)).then(u=>u?u.map(r=>i.Range.from(r)):void 0)}$toggleReaction(o,h,t,s,l){const u=this._commentControllers.get(o);return!u||!u.reactionHandler?Promise.resolve(void 0):b.asPromise(()=>{const r=u.getCommentThread(h);if(r){const g=r.getCommentByUniqueId(s.uniqueIdInThread);if(u!==void 0&&g&&u.reactionHandler)return u.reactionHandler(g,f(l))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=v,v.handlePool=0;class d{constructor(o,h,t,s,l,u,r){this._proxy=o,this._commentController=h,this._id=t,this._uri=s,this._range=l,this._comments=u,this.handle=d._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new A.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${h.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,i.Range.from(this._range),r),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=u}set threadId(o){this._id=o}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(o){o.isEqual(this._range)||(this._range=o,this.modifications.range=o,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(o){this._canReply!==o&&(this._canReply=o,this.modifications.canReply=o,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(o){this._label=o,this.modifications.label=o,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(o){this._contextValue=o,this.modifications.contextValue=o,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(o){this._comments=o,this.modifications.comments=o,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(o){this._collapseState=o,this.modifications.collapsibleState=o,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const o=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),h={};o("range")&&(h.range=i.Range.from(this._range)),o("label")&&(h.label=this.label),o("contextValue")&&(h.contextValue=this.contextValue),o("comments")&&(h.comments=this._comments.map(t=>m(this,this._commentController,t,this._commentsMap))),o("collapsibleState")&&(h.collapseState=c(this._collapseState)),o("canReply")&&(h.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,h)}}getCommentByUniqueId(o){for(let h of this._commentsMap){let t=h[0],s=h[1];if(o===s)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(o=>o.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}d._handlePool=0,He([y.debounce(100)],d.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=d;class a{constructor(o,h,t,s,l){this._extension=o,this._handle=h,this._proxy=t,this._id=s,this._label=l,this._threads=new Map,this._proxy.$registerCommentController(this.handle,s,l)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(o){this._reactionHandler=o,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!o})}get options(){return this._options}set options(o){this._options=o,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(o,h,t,s){if(typeof o=="string"){const l=new d(this._proxy,this,o,h,t,s,this._extension.identifier);return this._threads.set(l.handle,l),l}else{const l=new d(this._proxy,this,void 0,o,h,t,this._extension.identifier);return this._threads.set(l.handle,l),l}}$createCommentThreadTemplate(o,h){const t=new d(this._proxy,this,void 0,E.URI.revive(o),i.Range.to(h),[],this._extension.identifier);return t.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(o,h){let t=this._threads.get(o);t&&(t.range=i.Range.to(h))}$deleteCommentThread(o){let h=this._threads.get(o);h&&h.dispose(),this._threads.delete(o)}getCommentThread(o){return this._threads.get(o)}dispose(){this._threads.forEach(o=>{o.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function m(n,o,h,t){let s=t.get(h);s||(s=++n.commentHandle,t.set(h,s));const l=h.author&&h.author.iconPath?h.author.iconPath.toString():void 0;return{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:s,body:i.MarkdownString.from(h.body),userName:h.author.name,userIconPath:l,label:h.label,commentReactions:h.reactions?h.reactions.map(u=>p(u)):void 0}}function p(n){return{label:n.label,iconPath:n.iconPath?i.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function f(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?E.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function c(n){if(n!==void 0)switch(n){case P.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}}),define(ve[96],_e([0,1,2,5,7,4,13,17,11,8,10]),function(se,e,b,y,A,T,E,k,I,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let S=class ri{constructor(d,a){this._logService=a,this._provider=new Map,this._proxy=d.getProxy(y.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,a){const m=ri._handlePool++;this._provider.set(m,{provider:d,extensionId:a}),this._proxy.$registerDecorationProvider(m,a.value);const p=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(f=>{if(!f){this._proxy.$onDidChange(m,null);return}let c=I.asArray(f);if(c.length<=ri._maxEventSize){this._proxy.$onDidChange(m,c);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,c.length);const n=c.map(t=>({uri:t,rank:i.count(t.path,"/")})),o=I.groupBy(n,(t,s)=>t.rank-s.rank||i.compare(t.uri.path,s.uri.path));let h=[];e:for(let t of o){let s;for(let l of t){let u=P.dirname(l.uri.path);if(s!==u&&(s=u,h.push(l.uri)>=ri._maxEventSize))break e}}this._proxy.$onDidChange(m,h)});return new A.Disposable(()=>{p==null||p.dispose(),this._proxy.$unregisterDecorationProvider(m),this._provider.delete(m)})}async $provideDecorations(d,a,m){if(!this._provider.has(d))return Object.create(null);const p=Object.create(null),{provider:f,extensionId:c}=this._provider.get(d);return await Promise.all(a.map(async n=>{try{const{uri:o,id:h}=n,t=await Promise.resolve(f.provideFileDecoration(b.URI.revive(o),m));if(!t)return;try{A.FileDecoration.validate(t),p[h]=[t.propagate,t.tooltip,t.badge,t.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${c.value}': ${s}`)}}catch(o){this._logService.error(o)}})),p}};S._handlePool=0,S._maxEventSize=250,S=He([Be(0,E.IExtHostRpcService),Be(1,k.ILogService)],S),e.ExtHostDecorations=S,e.IExtHostDecorations=T.createDecorator("IExtHostDecorations")}),define(ve[184],_e([0,1,125,88,2,5,7,14,11,3,17,22]),function(se,e,b,y,A,T,E,k,I,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{constructor(m,p,f,c,n){this._name=m,this._owner=p,this._maxDiagnosticsPerFile=f,this._proxy=c,this._onDidChangeDiagnostics=n,this._isDisposed=!1,this._data=new S.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(m,p){if(!m){this.clear();return}this._checkDisposed();let f=[];if(A.URI.isUri(m)){if(!p){this.delete(m);return}this._data.set(m,p.slice()),f=[m]}else if(Array.isArray(m)){f=[];let n;m=I.mergeSort([...m],v._compareIndexedTuplesByUri);for(const o of m){const[h,t]=o;if((!n||h.toString()!==n.toString())&&(n&&this._data.get(n).length===0&&this._data.delete(n),n=h,f.push(h),this._data.set(h,[])),t){const s=this._data.get(h);s&&s.push(...t)}else{const s=this._data.get(h);s&&(s.length=0)}}}if(this._onDidChangeDiagnostics.fire(f),!!this._proxy){const c=[];for(let n of f){let o=[];const h=this._data.get(n);if(h)if(h.length>this._maxDiagnosticsPerFile){o=[];const t=[E.DiagnosticSeverity.Error,E.DiagnosticSeverity.Warning,E.DiagnosticSeverity.Information,E.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(let l of h)if(l.severity===t[s]&&o.push(k.Diagnostic.from(l))===this._maxDiagnosticsPerFile)break e;o.push({severity:y.MarkerSeverity.Info,message:b.localize(0,null,h.length-this._maxDiagnosticsPerFile),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=h.map(t=>k.Diagnostic.from(t));c.push([n,o])}this._proxy.$changeMany(this._owner,c)}}delete(m){this._checkDisposed(),this._onDidChangeDiagnostics.fire([m]),this._data.delete(m),this._proxy&&this._proxy.$changeMany(this._owner,[[m,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(m,p){this._checkDisposed();for(let f of this._data.keys())m.apply(p,[f,this.get(f),this])}get(m){this._checkDisposed();const p=this._data.get(m);return Array.isArray(p)?Object.freeze(p.slice(0)):[]}has(m){return this._checkDisposed(),Array.isArray(this._data.get(m))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(m,p){return m[0].toString()<p[0].toString()?-1:m[0].toString()>p[0].toString()?1:0}}e.DiagnosticCollection=v;let d=class Mt{constructor(m,p){this._logService=p,this._collections=new Map,this._onDidChangeDiagnostics=new i.Emitter,this.onDidChangeDiagnostics=i.Event.map(i.Event.debounce(this._onDidChangeDiagnostics.event,Mt._debouncer,50),Mt._mapper),this._proxy=m.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(m,p){return m?m.concat(p):p}static _mapper(m){const p=[],f=new Set;for(const c of m)typeof c=="string"?f.has(c)||(f.add(c),p.push(A.URI.parse(c))):f.has(c.toString())||(f.add(c.toString()),p.push(c));return Object.freeze(p),{uris:p}}createDiagnosticCollection(m,p){const{_collections:f,_proxy:c,_onDidChangeDiagnostics:n,_logService:o}=this,h=new class{$changeMany(l,u){c.$changeMany(l,u),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,l,u.length===0?"CLEARING":u)}$clear(l){c.$clear(l),o.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,l)}dispose(){c.dispose()}};let t;if(!p)p="_generated_diagnostic_collection_name_#"+Mt._idPool++,t=p;else if(!f.has(p))t=p;else{this._logService.warn(`DiagnosticCollection with name '${p}' does already exist.`);do t=p+Mt._idPool++;while(f.has(t))}return new class extends v{constructor(){super(p,t,Mt._maxDiagnosticsPerFile,h,n);f.set(t,this)}dispose(){super.dispose(),f.delete(t)}}}getDiagnostics(m){if(m)return this._getDiagnostics(m);{const p=new Map,f=[];for(const c of this._collections.values())c.forEach((n,o)=>{let h=p.get(n.toString());typeof h=="undefined"&&(h=f.length,p.set(n.toString(),h),f.push([n,[]])),f[h][1]=f[h][1].concat(...o)});return f}}_getDiagnostics(m){let p=[];for(let f of this._collections.values())f.has(m)&&(p=p.concat(f.get(m)));return p}$acceptMarkersChange(m){if(!this._mirrorCollection){const p="_generated_mirror",f=new v(p,p,Mt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(p,f),this._mirrorCollection=f}for(const[p,f]of m)this._mirrorCollection.set(A.URI.revive(p),f.map(k.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=He([Be(1,P.ILogService)],d),e.ExtHostDiagnostics=d}),define(ve[185],_e([0,1,2,5]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(E){this._proxy=E.getProxy(y.MainContext.MainThreadDialogs)}showOpenDialog(E){return this._proxy.$showOpenDialog(E).then(k=>k?k.map(I=>b.URI.revive(I)):void 0)}showSaveDialog(E){return this._proxy.$showSaveDialog(E).then(k=>k?b.URI.revive(k):void 0)}}e.ExtHostDialogs=A}),define(ve[186],_e([0,1,9,2,7,5,16,20,8]),function(se,e,b,y,A,T,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class i{constructor(S,v,d){this._documentsAndEditors=v,this._logService=d,this._documentContentProviders=new Map,this._proxy=S.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,v){if(Object.keys(E.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const d=i._handlePool++;this._documentContentProviders.set(d,v),this._proxy.$registerTextContentProvider(d,S);let a;return typeof v.onDidChange=="function"&&(a=v.onDidChange(m=>{if(m.scheme!==S){this._logService.warn(`Provider for scheme '${S}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(m)&&this.$provideTextDocumentContent(d,m).then(p=>{if(!(!p&&typeof p!="string")){const f=this._documentsAndEditors.getDocument(m);if(!!f){const c=I.splitLines(p);if(!f.equalLines(c))return this._proxy.$onVirtualDocumentChange(m,p)}}},b.onUnexpectedError)})),new A.Disposable(()=>{this._documentContentProviders.delete(d)&&this._proxy.$unregisterTextContentProvider(d),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(S,v){const d=this._documentContentProviders.get(S);return d?Promise.resolve(d.provideTextDocumentContent(y.URI.revive(v),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.ExtHostDocumentContentProvider=i,i._handlePool=0}),define(ve[187],_e([0,1,3,6,2,5,93,14,12,24]),function(se,e,b,y,A,T,E,k,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(v,d){this._onDidAddDocument=new b.Emitter,this._onDidRemoveDocument=new b.Emitter,this._onDidChangeDocument=new b.Emitter,this._onDidSaveDocument=new b.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new y.DisposableStore,this._documentLoader=new Map,this._proxy=v.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=d,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const m of a)this._onDidRemoveDocument.fire(m.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const m of a)this._onDidAddDocument.fire(m.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(v){if(!!v){const d=this._documentsAndEditors.getDocument(v);if(d)return d}}getDocument(v){const d=this.getDocumentData(v);if(!(d==null?void 0:d.document))throw new Error(`Unable to retrieve document from URI '${v}'`);return d.document}ensureDocumentData(v){const d=this._documentsAndEditors.getDocument(v);if(d)return Promise.resolve(d);let a=this._documentLoader.get(v.toString());return a||(a=this._proxy.$tryOpenDocument(v).then(m=>{this._documentLoader.delete(v.toString());const p=A.URI.revive(m);return I.assertIsDefined(this._documentsAndEditors.getDocument(p))},m=>(this._documentLoader.delete(v.toString()),Promise.reject(m))),this._documentLoader.set(v.toString(),a)),a}createDocumentData(v){return this._proxy.$tryCreateDocument(v).then(d=>A.URI.revive(d))}$acceptModelModeChanged(v,d,a){const m=A.URI.revive(v),p=this._documentsAndEditors.getDocument(m);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(a),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(v){const d=A.URI.revive(v),a=this._documentsAndEditors.getDocument(d);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(v,d){const a=A.URI.revive(v),m=this._documentsAndEditors.getDocument(a);if(!m)throw new Error("unknown document");m._acceptIsDirty(d),this._onDidChangeDocument.fire({document:m.document,contentChanges:[]})}$acceptModelChanged(v,d,a){const m=A.URI.revive(v),p=this._documentsAndEditors.getDocument(m);if(!p)throw new Error("unknown document");p._acceptIsDirty(a),p.onEvents(d),this._onDidChangeDocument.fire(i.deepFreeze({document:p.document,contentChanges:d.changes.map(f=>({range:k.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text}))}))}setWordDefinitionFor(v,d){E.setWordDefinitionFor(v,d)}}e.ExtHostDocuments=P}),define(ve[40],_e([0,1,43,3,6,2,4,5,93,13,94,14,17,22,16,53]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class p{constructor(n){this.value=n,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let f=class{constructor(n,o){this._extHostRpc=n,this._logService=o,this._activeEditorId=null,this._editors=new Map,this._documents=new d.ResourceMap,this._onDidAddDocuments=new y.Emitter,this._onDidRemoveDocuments=new y.Emitter,this._onDidChangeVisibleTextEditors=new y.Emitter,this._onDidChangeActiveTextEditor=new y.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const o=[],h=[],t=[];if(n.removedDocuments)for(const s of n.removedDocuments){const l=T.URI.revive(s),u=this._documents.get(l);(u==null?void 0:u.unref())&&(this._documents.delete(l),o.push(u.value))}if(n.addedDocuments)for(const s of n.addedDocuments){const l=T.URI.revive(s.uri);let u=this._documents.get(l);if(u&&l.scheme!==a.Schemas.vscodeNotebookCell)throw new Error(`document '${l} already exists!'`);u||(u=new p(new I.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),l,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(l,u),h.push(u.value)),u.ref()}if(n.removedEditors)for(const s of n.removedEditors){const l=this._editors.get(s);this._editors.delete(s),l&&t.push(l)}if(n.addedEditors)for(const s of n.addedEditors){const l=T.URI.revive(s.documentUri);b.ok(this._documents.has(l),`document '${l}' does not exist`),b.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const u=this._documents.get(l).value,r=new P.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,u,s.selections.map(S.Selection.to),s.options,s.visibleRanges.map(g=>S.Range.to(g)),typeof s.editorPosition=="number"?S.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,r)}n.newActiveEditor!==void 0&&(b.ok(n.newActiveEditor===null||this._editors.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this._activeEditorId=n.newActiveEditor),A.dispose(o),A.dispose(t),n.removedDocuments&&this._onDidRemoveDocuments.fire(o),n.addedDocuments&&this._onDidAddDocuments.fire(h),(n.removedEditors||n.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors()),n.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(n){var o;return(o=this._documents.get(n))===null||o===void 0?void 0:o.value}allDocuments(){return m.Iterable.map(this._documents.values(),n=>n.value)}getEditor(n){return this._editors.get(n)}activeEditor(){if(this._activeEditorId)return this._editors.get(this._activeEditorId)}allEditors(){return[...this._editors.values()]}};f=He([Be(0,i.IExtHostRpcService),Be(1,v.ILogService)],f),e.ExtHostDocumentsAndEditors=f,e.IExtHostDocumentsAndEditors=E.createDecorator("IExtHostDocumentsAndEditors")}),define(ve[188],_e([0,1,2,5,6,7,14,113,8,27]),function(se,e,b,y,A,T,E,k,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this._schemes=[]}add(d){this._stateMachine=void 0,this._schemes.push(d)}delete(d){const a=this._schemes.indexOf(d);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const d=this._schemes.sort(),a=[];let m,p,f=14,c=14;for(const n of d){let o=m?I.commonPrefixLength(m,n):0;for(o===0?p=1:p=c;o<n.length;o++)o+1===n.length?(f=c,c=9):c+=1,a.push([p,n.toUpperCase().charCodeAt(o),c]),a.push([p,n.toLowerCase().charCodeAt(o),c]),p=c;m=n,c=f}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new k.StateMachine(a)}}provideDocumentLinks(d){this._initStateMachine();const a=[],m=k.LinkComputer.computeLinks({getLineContent(p){return d.lineAt(p-1).text},getLineCount(){return d.lineCount}},this._stateMachine);for(const p of m){const f=E.DocumentLink.to(p);f.target&&a.push(f)}return a}}class S{constructor(d,a){this._extHostLanguageFeatures=a,this._linkProvider=new P,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=d.getProxy(y.MainContext.MainThreadFileSystem)}dispose(){var d;(d=this._linkProviderRegistration)===null||d===void 0||d.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(d,a,m,p={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const f=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(f,m);let c=2;p.isCaseSensitive&&(c+=1024),p.isReadonly&&(c+=2048),typeof m.copy=="function"&&(c+=8),typeof m.open=="function"&&typeof m.close=="function"&&typeof m.read=="function"&&typeof m.write=="function"&&(c+=4),this._proxy.$registerFileSystemProvider(f,a,c).catch(o=>{console.error(`FAILED to register filesystem provider of ${d.value}-extension for the scheme ${a}`),console.error(o)});const n=m.onDidChangeFile(o=>{const h=[];for(const t of o){let{uri:s,type:l}=t;if(s.scheme===a){let u;switch(l){case T.FileChangeType.Changed:u=0;break;case T.FileChangeType.Created:u=1;break;case T.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:s,type:u})}}this._proxy.$onFileSystemChange(f,h)});return A.toDisposable(()=>{n.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(f),this._proxy.$unregisterProvider(f)})}static _asIStat(d){const{type:a,ctime:m,mtime:p,size:f}=d;return{type:a,ctime:m,mtime:p,size:f}}$stat(d,a){return Promise.resolve(this._getFsProvider(d).stat(b.URI.revive(a))).then(S._asIStat)}$readdir(d,a){return Promise.resolve(this._getFsProvider(d).readDirectory(b.URI.revive(a)))}$readFile(d,a){return Promise.resolve(this._getFsProvider(d).readFile(b.URI.revive(a))).then(m=>i.VSBuffer.wrap(m))}$writeFile(d,a,m,p){return Promise.resolve(this._getFsProvider(d).writeFile(b.URI.revive(a),m.buffer,p))}$delete(d,a,m){return Promise.resolve(this._getFsProvider(d).delete(b.URI.revive(a),m))}$rename(d,a,m,p){return Promise.resolve(this._getFsProvider(d).rename(b.URI.revive(a),b.URI.revive(m),p))}$copy(d,a,m,p){const f=this._getFsProvider(d);if(!f.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(f.copy(b.URI.revive(a),b.URI.revive(m),p))}$mkdir(d,a){return Promise.resolve(this._getFsProvider(d).createDirectory(b.URI.revive(a)))}$watch(d,a,m,p){const f=this._getFsProvider(d).watch(b.URI.revive(m),p);this._watches.set(a,f)}$unwatch(d,a){const m=this._watches.get(a);m&&(m.dispose(),this._watches.delete(a))}$open(d,a,m){const p=this._getFsProvider(d);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(b.URI.revive(a),m))}$close(d,a){const m=this._getFsProvider(d);if(!m.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(m.close(a))}$read(d,a,m,p){const f=this._getFsProvider(d);if(!f.read)throw new Error('FileSystemProvider does not implement "read"');const c=i.VSBuffer.alloc(p);return Promise.resolve(f.read(a,m,c.buffer,0,p)).then(n=>c.slice(0,n))}$write(d,a,m,p){const f=this._getFsProvider(d);if(!f.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(f.write(a,m,p.buffer,0,p.byteLength))}_getFsProvider(d){const a=this._fsProvider.get(d);if(!a){const m=new Error;throw m.name="ENOPRO",m.message="no provider",m}return a}}e.ExtHostFileSystem=S}),define(ve[75],_e([0,1,5,65,7,27,4,13,48]),function(se,e,b,y,A,T,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let i=class It{constructor(S,v){this._fileSystemInfo=v,this._proxy=S.getProxy(b.MainContext.MainThreadFileSystem)}stat(S){return this._proxy.$stat(S).catch(It._handleError)}readDirectory(S){return this._proxy.$readdir(S).catch(It._handleError)}createDirectory(S){return this._proxy.$mkdir(S).catch(It._handleError)}async readFile(S){return this._proxy.$readFile(S).then(v=>v.buffer).catch(It._handleError)}writeFile(S,v){return this._proxy.$writeFile(S,T.VSBuffer.wrap(v)).catch(It._handleError)}delete(S,v){return this._proxy.$delete(S,Object.assign({recursive:!1,useTrash:!1},v)).catch(It._handleError)}rename(S,v,d){return this._proxy.$rename(S,v,Object.assign({overwrite:!1},d)).catch(It._handleError)}copy(S,v,d){return this._proxy.$copy(S,v,Object.assign({overwrite:!1},d)).catch(It._handleError)}isWritableFileSystem(S){const v=this._fileSystemInfo.getCapabilities(S);if(typeof v=="number")return!(v&2048)}static _handleError(S){if(!(S instanceof Error))throw new A.FileSystemError(String(S));if(S.name==="ENOPRO")throw A.FileSystemError.Unavailable(S.message);switch(S.name){case y.FileSystemProviderErrorCode.FileExists:throw A.FileSystemError.FileExists(S.message);case y.FileSystemProviderErrorCode.FileNotFound:throw A.FileSystemError.FileNotFound(S.message);case y.FileSystemProviderErrorCode.FileNotADirectory:throw A.FileSystemError.FileNotADirectory(S.message);case y.FileSystemProviderErrorCode.FileIsADirectory:throw A.FileSystemError.FileIsADirectory(S.message);case y.FileSystemProviderErrorCode.NoPermissions:throw A.FileSystemError.NoPermissions(S.message);case y.FileSystemProviderErrorCode.Unavailable:throw A.FileSystemError.Unavailable(S.message);default:throw new A.FileSystemError(S.message,S.name)}}};i=He([Be(0,k.IExtHostRpcService),Be(1,I.IExtHostFileSystemInfo)],i),e.ExtHostConsumerFileSystem=i,e.IExtHostConsumerFileSystem=E.createDecorator("IExtHostConsumerFileSystem")}),define(ve[189],_e([0,1,6,5]),function(se,e,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class A{constructor(E){this._handlePool=0,this._proxy=E.getProxy(y.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(E){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,E),b.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=A}),define(ve[190],_e([0,1,2,24,14,7,15,5,8,32,11,12,110,6,85,52,68,55,9]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d,a,m,p,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class n{constructor(x,K){this._documents=x,this._provider=K}provideDocumentSymbols(x,K){const ee=this._documents.getDocument(x);return E.asPromise(()=>this._provider.provideDocumentSymbols(ee,K)).then(ne=>{if(!P.isFalsyOrEmpty(ne))return ne[0]instanceof T.DocumentSymbol?ne.map(A.DocumentSymbol.from):n._asDocumentSymbolTree(ne)})}static _asDocumentSymbolTree(x){var K;x=x.slice(0).sort((de,Ee)=>{let Re=de.location.range.start.compareTo(Ee.location.range.start);return Re===0&&(Re=Ee.location.range.end.compareTo(de.location.range.end)),Re});const ee=[],ne=[];for(const de of x){const Ee={name:de.name||"!!MISSING: name!!",kind:A.SymbolKind.from(de.kind),tags:((K=de.tags)===null||K===void 0?void 0:K.map(A.SymbolTag.from))||[],detail:"",containerName:de.containerName,range:A.Range.from(de.location.range),selectionRange:A.Range.from(de.location.range),children:[]};for(;;){if(ne.length===0){ne.push(Ee),ee.push(Ee);break}const Re=ne[ne.length-1];if(i.Range.containsRange(Re.range,Ee.range)&&!i.Range.equalsRange(Re.range,Ee.range)){Re.children&&Re.children.push(Ee),ne.push(Ee);break}ne.pop()}}return ee}}class o{constructor(x,K,ee){this._documents=x,this._commands=K,this._provider=ee,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,K){const ee=this._documents.getDocument(x),ne=await this._provider.provideCodeLenses(ee,K);if(!(!ne||K.isCancellationRequested)){const de=this._cache.add(ne),Ee=new d.DisposableStore;this._disposables.set(de,Ee);const Re={cacheId:de,lenses:[]};for(let xe=0;xe<ne.length;xe++)Re.lenses.push({cacheId:[de,xe],range:A.Range.from(ne[xe].range),command:this._commands.toInternal(ne[xe].command,Ee)});return Re}}async resolveCodeLens(x,K){var ee;const ne=x.cacheId&&this._cache.get(...x.cacheId);if(!!ne){let de;if(typeof this._provider.resolveCodeLens!="function"||ne.isResolved?de=ne:de=await this._provider.resolveCodeLens(ne,K),de||(de=ne),!K.isCancellationRequested){const Ee=x.cacheId&&this._disposables.get(x.cacheId[0]);if(!!Ee)return x.command=this._commands.toInternal((ee=de.command)!==null&&ee!==void 0?ee:o._badCmd,Ee),x}}}releaseCodeLenses(x){var K;(K=this._disposables.get(x))===null||K===void 0||K.dispose(),this._disposables.delete(x),this._cache.delete(x)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function h(Ce){return Array.isArray(Ce)?Ce.map(A.DefinitionLink.from):Ce?[A.DefinitionLink.from(Ce)]:[]}class t{constructor(x,K){this._documents=x,this._provider=K}provideDefinition(x,K,ee){const ne=this._documents.getDocument(x),de=A.Position.to(K);return E.asPromise(()=>this._provider.provideDefinition(ne,de,ee)).then(h)}}class s{constructor(x,K){this._documents=x,this._provider=K}provideDeclaration(x,K,ee){const ne=this._documents.getDocument(x),de=A.Position.to(K);return E.asPromise(()=>this._provider.provideDeclaration(ne,de,ee)).then(h)}}class l{constructor(x,K){this._documents=x,this._provider=K}provideImplementation(x,K,ee){const ne=this._documents.getDocument(x),de=A.Position.to(K);return E.asPromise(()=>this._provider.provideImplementation(ne,de,ee)).then(h)}}class u{constructor(x,K){this._documents=x,this._provider=K}provideTypeDefinition(x,K,ee){const ne=this._documents.getDocument(x),de=A.Position.to(K);return E.asPromise(()=>this._provider.provideTypeDefinition(ne,de,ee)).then(h)}}class r{constructor(x,K){this._documents=x,this._provider=K}provideHover(x,K,ee){const ne=this._documents.getDocument(x),de=A.Position.to(K);return E.asPromise(()=>this._provider.provideHover(ne,de,ee)).then(Ee=>{if(!(!Ee||P.isFalsyOrEmpty(Ee.contents)))return Ee.range||(Ee.range=ne.getWordRangeAtPosition(de)),Ee.range||(Ee.range=new T.Range(de,de)),A.Hover.from(Ee)})}}class g{constructor(x,K){this._documents=x,this._provider=K}provideEvaluatableExpression(x,K,ee){const ne=this._documents.getDocument(x),de=A.Position.to(K);return E.asPromise(()=>this._provider.provideEvaluatableExpression(ne,de,ee)).then(Ee=>{if(Ee)return A.EvaluatableExpression.from(Ee)})}}class C{constructor(x,K){this._documents=x,this._provider=K}provideDocumentHighlights(x,K,ee){const ne=this._documents.getDocument(x),de=A.Position.to(K);return E.asPromise(()=>this._provider.provideDocumentHighlights(ne,de,ee)).then(Ee=>{if(Array.isArray(Ee))return Ee.map(A.DocumentHighlight.from)})}}class _{constructor(x,K){this._documents=x,this._provider=K}provideLinkedEditingRanges(x,K,ee){const ne=this._documents.getDocument(x),de=A.Position.to(K);return E.asPromise(()=>this._provider.provideLinkedEditingRanges(ne,de,ee)).then(Ee=>{if(Ee&&Array.isArray(Ee.ranges))return{ranges:P.coalesce(Ee.ranges.map(A.Range.from)),wordPattern:Ee.wordPattern}})}}class D{constructor(x,K){this._documents=x,this._provider=K}provideReferences(x,K,ee,ne){const de=this._documents.getDocument(x),Ee=A.Position.to(K);return E.asPromise(()=>this._provider.provideReferences(de,Ee,ee,ne)).then(Re=>{if(Array.isArray(Re))return Re.map(A.location.from)})}}class w{constructor(x,K,ee,ne,de,Ee,Re){this._documents=x,this._commands=K,this._diagnostics=ee,this._provider=ne,this._logService=de,this._extension=Ee,this._apiDeprecation=Re,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(x,K,ee,ne){const de=this._documents.getDocument(x),Ee=v.Selection.isISelection(K)?A.Selection.to(K):A.Range.to(K),Re=[];for(const be of this._diagnostics.getDiagnostics(x))if(Ee.intersection(be.range)&&Re.push(be)>w._maxCodeActionsPerFile)break;const xe={diagnostics:Re,only:ee.only?new T.CodeActionKind(ee.only):void 0};return E.asPromise(()=>this._provider.provideCodeActions(de,Ee,xe,ne)).then(be=>{var ke;if(!(!P.isNonEmptyArray(be)||ne.isCancellationRequested)){const Te=this._cache.add(be),Ne=new d.DisposableStore;this._disposables.set(Te,Ne);const pe=[];for(let ze=0;ze<be.length;ze++){const B=be[ze];!B||(w._isCommand(B)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),pe.push({_isSynthetic:!0,title:B.title,command:this._commands.toInternal(B,Ne)})):(xe.only&&(B.kind?xe.only.contains(B.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${xe.only.value} 'requested but returned code action is of kind '${B.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${xe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),pe.push({cacheId:[Te,ze],title:B.title,command:B.command&&this._commands.toInternal(B.command,Ne),diagnostics:B.diagnostics&&B.diagnostics.map(A.Diagnostic.from),edit:B.edit&&A.WorkspaceEdit.from(B.edit),kind:B.kind&&B.kind.value,isPreferred:B.isPreferred,disabled:(ke=B.disabled)===null||ke===void 0?void 0:ke.reason})))}return{cacheId:Te,actions:pe}}})}async resolveCodeAction(x,K){var ee;const[ne,de]=x,Ee=this._cache.get(ne,de);if(!(!Ee||w._isCommand(Ee))&&!!this._provider.resolveCodeAction){const Re=(ee=await this._provider.resolveCodeAction(Ee,K))!==null&&ee!==void 0?ee:Ee;return(Re==null?void 0:Re.edit)?A.WorkspaceEdit.from(Re.edit):void 0}}releaseCodeActions(x){var K;(K=this._disposables.get(x))===null||K===void 0||K.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}w._maxCodeActionsPerFile=1e3;class O{constructor(x,K){this._documents=x,this._provider=K}provideDocumentFormattingEdits(x,K,ee){const ne=this._documents.getDocument(x);return E.asPromise(()=>this._provider.provideDocumentFormattingEdits(ne,K,ee)).then(de=>{if(Array.isArray(de))return de.map(A.TextEdit.from)})}}class R{constructor(x,K){this._documents=x,this._provider=K}provideDocumentRangeFormattingEdits(x,K,ee,ne){const de=this._documents.getDocument(x),Ee=A.Range.to(K);return E.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(de,Ee,ee,ne)).then(Re=>{if(Array.isArray(Re))return Re.map(A.TextEdit.from)})}}class ${constructor(x,K){this._documents=x,this._provider=K,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(x,K,ee,ne,de){const Ee=this._documents.getDocument(x),Re=A.Position.to(K);return E.asPromise(()=>this._provider.provideOnTypeFormattingEdits(Ee,Re,ee,ne,de)).then(xe=>{if(Array.isArray(xe))return xe.map(A.TextEdit.from)})}}class V{constructor(x,K){this._provider=x,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(x,K){const ee=k.IdObject.mixin({symbols:[]});return E.asPromise(()=>this._provider.provideWorkspaceSymbols(x,K)).then(ne=>{if(P.isNonEmptyArray(ne)){for(const de of ne)if(!!de){if(!de.name){this._logService.warn("INVALID SymbolInformation, lacks name",de);continue}const Ee=k.IdObject.mixin(A.WorkspaceSymbol.from(de));this._symbolCache.set(Ee._id,de),ee.symbols.push(Ee)}}}).then(()=>(ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee))}async resolveWorkspaceSymbol(x,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return x;const ee=this._symbolCache.get(x._id);if(ee){const ne=await E.asPromise(()=>this._provider.resolveWorkspaceSymbol(ee,K));return ne&&y.mixin(x,A.WorkspaceSymbol.from(ne),!0)}}releaseWorkspaceSymbols(x){const K=this._resultCache.get(x);if(K){for(let[ee,ne]=K;ee<=ne;ee++)this._symbolCache.delete(ee);this._resultCache.delete(x)}}}class z{constructor(x,K,ee){this._documents=x,this._provider=K,this._logService=ee}static supportsResolving(x){return typeof x.prepareRename=="function"}provideRenameEdits(x,K,ee,ne){const de=this._documents.getDocument(x),Ee=A.Position.to(K);return E.asPromise(()=>this._provider.provideRenameEdits(de,Ee,ee,ne)).then(Re=>{if(!!Re)return A.WorkspaceEdit.from(Re)},Re=>{const xe=z._asMessage(Re);return xe?{rejectReason:xe,edits:void 0}:Promise.reject(Re)})}resolveRenameLocation(x,K,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ne=this._documents.getDocument(x),de=A.Position.to(K);return E.asPromise(()=>this._provider.prepareRename(ne,de,ee)).then(Ee=>{let Re,xe;if(T.Range.isRange(Ee)?(Re=Ee,xe=ne.getText(Ee)):S.isObject(Ee)&&(Re=Ee.range,xe=Ee.placeholder),!!Re){if(Re.start.line>de.line||Re.end.line<de.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:A.Range.from(Re),text:xe}}},Ee=>{const Re=z._asMessage(Ee);return Re?{rejectReason:Re,range:void 0,text:void 0}:Promise.reject(Ee)})}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class U{constructor(x,K){this.resultId=x,this.tokens=K}}class q{constructor(x,K){this._documents=x,this._provider=K,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(x,K,ee){const ne=this._documents.getDocument(x),de=K!==0?this._previousResults.get(K):null;return E.asPromise(()=>de&&typeof de.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ne,de.resultId,ee):this._provider.provideDocumentSemanticTokens(ne,ee)).then(Ee=>(de&&this._previousResults.delete(K),Ee?(Ee=q._fixProvidedSemanticTokens(Ee),this._send(q._convertToEdits(de,Ee),Ee)):null))}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return q._isSemanticTokens(x)?q._isCorrectSemanticTokens(x)?x:new T.SemanticTokens(new Uint32Array(x.data),x.resultId):q._isSemanticTokensEdits(x)?q._isCorrectSemanticTokensEdits(x)?x:new T.SemanticTokensEdits(x.edits.map(K=>new T.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const K of x.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,K){if(!q._isSemanticTokens(K)||!x||!x.tokens)return K;const ee=x.tokens,ne=ee.length,de=K.data,Ee=de.length;let Re=0;const xe=Math.min(ne,Ee);for(;Re<xe&&ee[Re]===de[Re];)Re++;if(Re===ne&&Re===Ee)return new T.SemanticTokensEdits([],K.resultId);let be=0;const ke=xe-Re;for(;be<ke&&ee[ne-be-1]===de[Ee-be-1];)be++;return new T.SemanticTokensEdits([{start:Re,deleteCount:ne-Re-be,data:de.subarray(Re,Ee-be)}],K.resultId)}_send(x,K){if(q._isSemanticTokens(x)){const ee=this._nextResultId++;return this._previousResults.set(ee,new U(x.resultId,x.data)),a.encodeSemanticTokensDto({id:ee,type:"full",data:x.data})}if(q._isSemanticTokensEdits(x)){const ee=this._nextResultId++;return q._isSemanticTokens(K)?this._previousResults.set(ee,new U(K.resultId,K.data)):this._previousResults.set(ee,new U(x.resultId)),a.encodeSemanticTokensDto({id:ee,type:"delta",deltas:(x.edits||[]).map(ne=>({start:ne.start,deleteCount:ne.deleteCount,data:ne.data}))})}return null}}e.DocumentSemanticTokensAdapter=q;class M{constructor(x,K){this._documents=x,this._provider=K}provideDocumentRangeSemanticTokens(x,K,ee){const ne=this._documents.getDocument(x);return E.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(ne,A.Range.to(K),ee)).then(de=>de?this._send(de):null)}_send(x){return a.encodeSemanticTokensDto({id:0,type:"full",data:x.data})}}e.DocumentRangeSemanticTokensAdapter=M;class j{constructor(x,K,ee,ne,de){this._documents=x,this._commands=K,this._provider=ee,this._apiDeprecation=ne,this._extension=de,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}async provideCompletionItems(x,K,ee,ne){const de=this._documents.getDocument(x),Ee=A.Position.to(K),Re=de.getWordRangeAtPosition(Ee)||new T.Range(Ee,Ee),xe=Re.with({end:Ee}),be=new f.StopWatch(!0),ke=await E.asPromise(()=>this._provider.provideCompletionItems(de,Ee,ne,A.CompletionContext.to(ee)));if(!!ke&&!ne.isCancellationRequested){const Te=Array.isArray(ke)?new T.CompletionList(ke):ke,Ne=j.supportsResolving(this._provider)?this._cache.add(Te.items):this._cache.add([]),pe=new d.DisposableStore;this._disposables.set(Ne,pe);const ze=[],B={x:Ne,b:ze,a:{replace:A.Range.from(Re),insert:A.Range.from(xe)},c:Te.isIncomplete||void 0,d:be.elapsed()};for(let Z=0;Z<Te.items.length;Z++){const he=Te.items[Z],Le=this._convertCompletionItem(he,[Ne,Z],xe,Re);ze.push(Le)}return B}}async resolveCompletionItem(x,K){if(typeof this._provider.resolveCompletionItem=="function"){const ee=this._cache.get(...x);if(!!ee){const ne=await E.asPromise(()=>this._provider.resolveCompletionItem(ee,K));if(!!ne)return this._convertCompletionItem(ne,x)}}}releaseCompletionItems(x){var K;(K=this._disposables.get(x))===null||K===void 0||K.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,K,ee,ne){var de;const Ee=this._disposables.get(K[0]);if(!Ee)throw Error("DisposableStore is missing...");const Re={x:K,a:(de=x.label)!==null&&de!==void 0?de:"",o:x.label2,b:x.kind!==void 0?A.CompletionItemKind.from(x.kind):void 0,n:x.tags&&x.tags.map(A.CompletionItemTag.from),c:x.detail,d:typeof x.documentation=="undefined"?void 0:A.MarkdownString.fromStrict(x.documentation),e:x.sortText!==x.label?x.sortText:void 0,f:x.filterText!==x.label?x.filterText:void 0,g:x.preselect||void 0,i:x.keepWhitespace?1:0,k:x.commitCharacters,l:x.additionalTextEdits&&x.additionalTextEdits.map(A.TextEdit.from),m:this._commands.toInternal(x.command,Ee)};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Re.h=x.textEdit.newText):typeof x.insertText=="string"?Re.h=x.insertText:x.insertText instanceof T.SnippetString&&(Re.h=x.insertText.value,Re.i|=4);let xe;return x.textEdit?xe=x.textEdit.range:x.range&&(xe=x.range),T.Range.isRange(xe)?Re.j=A.Range.from(xe):xe&&(!(ee==null?void 0:ee.isEqual(xe.inserting))||!(ne==null?void 0:ne.isEqual(xe.replacing)))&&(Re.j={insert:A.Range.from(xe.inserting),replace:A.Range.from(xe.replacing)}),Re}}class re{constructor(x,K){this._documents=x,this._provider=K,this._cache=new p.Cache("SignatureHelp")}provideSignatureHelp(x,K,ee,ne){const de=this._documents.getDocument(x),Ee=A.Position.to(K),Re=this.reviveContext(ee);return E.asPromise(()=>this._provider.provideSignatureHelp(de,Ee,ne,Re)).then(xe=>{if(xe){const be=this._cache.add([xe]);return Object.assign(Object.assign({},A.SignatureHelp.from(xe)),{id:be})}})}reviveContext(x){let K;if(x.activeSignatureHelp){const ee=A.SignatureHelp.to(x.activeSignatureHelp),ne=this._cache.get(x.activeSignatureHelp.id,0);ne?(K=ne,K.activeSignature=ee.activeSignature,K.activeParameter=ee.activeParameter):K=ee}return Object.assign(Object.assign({},x),{activeSignatureHelp:K})}releaseSignatureHelp(x){this._cache.delete(x)}}class F{constructor(x,K){this._documents=x,this._provider=K}provideInlineHints(x,K,ee){const ne=this._documents.getDocument(x);return E.asPromise(()=>this._provider.provideInlineHints(ne,A.Range.to(K),ee)).then(de=>de?{hints:de.map(A.InlineHint.from)}:void 0)}}class te{constructor(x,K){this._documents=x,this._provider=K,this._cache=new p.Cache("DocumentLink")}provideLinks(x,K){const ee=this._documents.getDocument(x);return E.asPromise(()=>this._provider.provideDocumentLinks(ee,K)).then(ne=>{if(!(!Array.isArray(ne)||ne.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ne.map(A.DocumentLink.from)};{const de=this._cache.add(ne),Ee={links:[],id:de};for(let Re=0;Re<ne.length;Re++){const xe=A.DocumentLink.from(ne[Re]);xe.cacheId=[de,Re],Ee.links.push(xe)}return Ee}}})}resolveLink(x,K){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ee=this._cache.get(...x);return ee?E.asPromise(()=>this._provider.resolveDocumentLink(ee,K)).then(ne=>ne&&A.DocumentLink.from(ne)||void 0):Promise.resolve(void 0)}releaseLinks(x){this._cache.delete(x)}}class ae{constructor(x,K){this._documents=x,this._provider=K}provideColors(x,K){const ee=this._documents.getDocument(x);return E.asPromise(()=>this._provider.provideDocumentColors(ee,K)).then(ne=>Array.isArray(ne)?ne.map(Ee=>({color:A.Color.from(Ee.color),range:A.Range.from(Ee.range)})):[])}provideColorPresentations(x,K,ee){const ne=this._documents.getDocument(x),de=A.Range.to(K.range),Ee=A.Color.to(K.color);return E.asPromise(()=>this._provider.provideColorPresentations(Ee,{document:ne,range:de},ee)).then(Re=>{if(!!Array.isArray(Re))return Re.map(A.ColorPresentation.from)})}}class ue{constructor(x,K){this._documents=x,this._provider=K}provideFoldingRanges(x,K,ee){const ne=this._documents.getDocument(x);return E.asPromise(()=>this._provider.provideFoldingRanges(ne,K,ee)).then(de=>{if(!!Array.isArray(de))return de.map(A.FoldingRange.from)})}}class we{constructor(x,K,ee){this._documents=x,this._provider=K,this._logService=ee}provideSelectionRanges(x,K,ee){const ne=this._documents.getDocument(x),de=K.map(A.Position.to);return E.asPromise(()=>this._provider.provideSelectionRanges(ne,de,ee)).then(Ee=>{if(!P.isNonEmptyArray(Ee))return[];if(Ee.length!==de.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Re=[];for(let xe=0;xe<de.length;xe++){const be=[];Re.push(be);let ke=de[xe],Te=Ee[xe];for(;;){if(!Te.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(be.push(A.SelectionRange.from(Te)),!Te.parent)break;ke=Te.range,Te=Te.parent}}return Re})}}class fe{constructor(x,K){this._documents=x,this._provider=K,this._idPool=new m.IdGenerator(""),this._cache=new Map}async prepareSession(x,K,ee){const ne=this._documents.getDocument(x),de=A.Position.to(K),Ee=await this._provider.prepareCallHierarchy(ne,de,ee);if(!!Ee){const Re=this._idPool.nextId();return this._cache.set(Re,new Map),Array.isArray(Ee)?Ee.map(xe=>this._cacheAndConvertItem(Re,xe)):[this._cacheAndConvertItem(Re,Ee)]}}async provideCallsTo(x,K,ee){const ne=this._itemFromCache(x,K);if(!ne)throw new Error("missing call hierarchy item");const de=await this._provider.provideCallHierarchyIncomingCalls(ne,ee);if(!!de)return de.map(Ee=>({from:this._cacheAndConvertItem(x,Ee.from),fromRanges:Ee.fromRanges.map(Re=>A.Range.from(Re))}))}async provideCallsFrom(x,K,ee){const ne=this._itemFromCache(x,K);if(!ne)throw new Error("missing call hierarchy item");const de=await this._provider.provideCallHierarchyOutgoingCalls(ne,ee);if(!!de)return de.map(Ee=>({to:this._cacheAndConvertItem(x,Ee.to),fromRanges:Ee.fromRanges.map(Re=>A.Range.from(Re))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,K){var ee;const ne=this._cache.get(x),de={_sessionId:x,_itemId:ne.size.toString(36),name:K.name,detail:K.detail,kind:A.SymbolKind.from(K.kind),uri:K.uri,range:A.Range.from(K.range),selectionRange:A.Range.from(K.selectionRange),tags:(ee=K.tags)===null||ee===void 0?void 0:ee.map(A.SymbolTag.from)};return ne.set(de._itemId,K),de}_itemFromCache(x,K){const ee=this._cache.get(x);return ee==null?void 0:ee.get(K)}}class De{constructor(x,K){this.adapter=x,this.extension=K}}class Se{constructor(x,K,ee,ne,de,Ee,Re){this._adapter=new Map,this._uriTransformer=K,this._proxy=x.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ne,this._diagnostics=de,this._logService=Ee,this._apiDeprecation=Re}_transformDocumentSelector(x){return P.coalesce(P.asArray(x).map(K=>this._doTransformDocumentSelector(K)))}_doTransformDocumentSelector(x){if(typeof x=="string")return{$serialized:!0,language:x};if(x)return{$serialized:!0,language:x.language,scheme:this._transformScheme(x.scheme),pattern:typeof x.pattern=="undefined"?void 0:A.GlobPattern.from(x.pattern),exclusive:x.exclusive}}_transformScheme(x){return this._uriTransformer&&typeof x=="string"?this._uriTransformer.transformOutgoingScheme(x):x}_createDisposable(x){return new T.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return Se._handlePool++}_withAdapter(x,K,ee,ne,de=!1){const Ee=this._adapter.get(x);if(!Ee)return Promise.resolve(ne);if(Ee.adapter instanceof K){let Re;Ee.extension&&(Re=Date.now(),this._logService.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${K.name}'`));const xe=ee(Ee.adapter,Ee.extension),be=Ee.extension;return be&&Promise.resolve(xe).then(()=>this._logService.trace(`[${be.identifier.value}] provider DONE after ${Date.now()-Re}ms`),ke=>{de&&ke instanceof c.CancellationError||(this._logService.error(`[${be.identifier.value}] provider FAILED`),this._logService.error(ke))}),xe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(x,K){const ee=this._nextHandle();return this._adapter.set(ee,new De(x,K)),ee}static _extLabel(x){return x.displayName||x.name}registerDocumentSymbolProvider(x,K,ee,ne){const de=this._addNewAdapter(new n(this._documents,ee),x),Ee=ne&&ne.label||Se._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(de,this._transformDocumentSelector(K),Ee),this._createDisposable(de)}$provideDocumentSymbols(x,K,ee){return this._withAdapter(x,n,ne=>ne.provideDocumentSymbols(b.URI.revive(K),ee),void 0)}registerCodeLensProvider(x,K,ee){const ne=this._nextHandle(),de=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ne,new De(new o(this._documents,this._commands.converter,ee),x)),this._proxy.$registerCodeLensSupport(ne,this._transformDocumentSelector(K),de);let Ee=this._createDisposable(ne);if(de!==void 0){const Re=ee.onDidChangeCodeLenses(xe=>this._proxy.$emitCodeLensEvent(de));Ee=T.Disposable.from(Ee,Re)}return Ee}$provideCodeLenses(x,K,ee){return this._withAdapter(x,o,ne=>ne.provideCodeLenses(b.URI.revive(K),ee),void 0)}$resolveCodeLens(x,K,ee){return this._withAdapter(x,o,ne=>ne.resolveCodeLens(K,ee),void 0)}$releaseCodeLenses(x,K){this._withAdapter(x,o,ee=>Promise.resolve(ee.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(x,K,ee){const ne=this._addNewAdapter(new t(this._documents,ee),x);return this._proxy.$registerDefinitionSupport(ne,this._transformDocumentSelector(K)),this._createDisposable(ne)}$provideDefinition(x,K,ee,ne){return this._withAdapter(x,t,de=>de.provideDefinition(b.URI.revive(K),ee,ne),[])}registerDeclarationProvider(x,K,ee){const ne=this._addNewAdapter(new s(this._documents,ee),x);return this._proxy.$registerDeclarationSupport(ne,this._transformDocumentSelector(K)),this._createDisposable(ne)}$provideDeclaration(x,K,ee,ne){return this._withAdapter(x,s,de=>de.provideDeclaration(b.URI.revive(K),ee,ne),[])}registerImplementationProvider(x,K,ee){const ne=this._addNewAdapter(new l(this._documents,ee),x);return this._proxy.$registerImplementationSupport(ne,this._transformDocumentSelector(K)),this._createDisposable(ne)}$provideImplementation(x,K,ee,ne){return this._withAdapter(x,l,de=>de.provideImplementation(b.URI.revive(K),ee,ne),[])}registerTypeDefinitionProvider(x,K,ee){const ne=this._addNewAdapter(new u(this._documents,ee),x);return this._proxy.$registerTypeDefinitionSupport(ne,this._transformDocumentSelector(K)),this._createDisposable(ne)}$provideTypeDefinition(x,K,ee,ne){return this._withAdapter(x,u,de=>de.provideTypeDefinition(b.URI.revive(K),ee,ne),[])}registerHoverProvider(x,K,ee,ne){const de=this._addNewAdapter(new r(this._documents,ee),x);return this._proxy.$registerHoverProvider(de,this._transformDocumentSelector(K)),this._createDisposable(de)}$provideHover(x,K,ee,ne){return this._withAdapter(x,r,de=>de.provideHover(b.URI.revive(K),ee,ne),void 0)}registerEvaluatableExpressionProvider(x,K,ee,ne){const de=this._addNewAdapter(new g(this._documents,ee),x);return this._proxy.$registerEvaluatableExpressionProvider(de,this._transformDocumentSelector(K)),this._createDisposable(de)}$provideEvaluatableExpression(x,K,ee,ne){return this._withAdapter(x,g,de=>de.provideEvaluatableExpression(b.URI.revive(K),ee,ne),void 0)}registerDocumentHighlightProvider(x,K,ee){const ne=this._addNewAdapter(new C(this._documents,ee),x);return this._proxy.$registerDocumentHighlightProvider(ne,this._transformDocumentSelector(K)),this._createDisposable(ne)}$provideDocumentHighlights(x,K,ee,ne){return this._withAdapter(x,C,de=>de.provideDocumentHighlights(b.URI.revive(K),ee,ne),void 0)}registerLinkedEditingRangeProvider(x,K,ee){const ne=this._addNewAdapter(new _(this._documents,ee),x);return this._proxy.$registerLinkedEditingRangeProvider(ne,this._transformDocumentSelector(K)),this._createDisposable(ne)}$provideLinkedEditingRanges(x,K,ee,ne){return this._withAdapter(x,_,async de=>{const Ee=await de.provideLinkedEditingRanges(b.URI.revive(K),ee,ne);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?Se._serializeRegExp(Ee.wordPattern):void 0}},void 0)}registerReferenceProvider(x,K,ee){const ne=this._addNewAdapter(new D(this._documents,ee),x);return this._proxy.$registerReferenceSupport(ne,this._transformDocumentSelector(K)),this._createDisposable(ne)}$provideReferences(x,K,ee,ne,de){return this._withAdapter(x,D,Ee=>Ee.provideReferences(b.URI.revive(K),ee,ne,de),void 0)}registerCodeActionProvider(x,K,ee,ne){var de,Ee;const Re=new d.DisposableStore,xe=this._addNewAdapter(new w(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerQuickFixSupport(xe,this._transformDocumentSelector(K),{providedKinds:(de=ne==null?void 0:ne.providedCodeActionKinds)===null||de===void 0?void 0:de.map(be=>be.value),documentation:(Ee=ne==null?void 0:ne.documentation)===null||Ee===void 0?void 0:Ee.map(be=>({kind:be.kind.value,command:this._commands.converter.toInternal(be.command,Re)}))},Se._extLabel(x),Boolean(ee.resolveCodeAction)),Re.add(this._createDisposable(xe)),Re}$provideCodeActions(x,K,ee,ne,de){return this._withAdapter(x,w,Ee=>Ee.provideCodeActions(b.URI.revive(K),ee,ne,de),void 0)}$resolveCodeAction(x,K,ee){return this._withAdapter(x,w,ne=>ne.resolveCodeAction(K,ee),void 0)}$releaseCodeActions(x,K){this._withAdapter(x,w,ee=>Promise.resolve(ee.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(x,K,ee){const ne=this._addNewAdapter(new O(this._documents,ee),x);return this._proxy.$registerDocumentFormattingSupport(ne,this._transformDocumentSelector(K),x.identifier,x.displayName||x.name),this._createDisposable(ne)}$provideDocumentFormattingEdits(x,K,ee,ne){return this._withAdapter(x,O,de=>de.provideDocumentFormattingEdits(b.URI.revive(K),ee,ne),void 0)}registerDocumentRangeFormattingEditProvider(x,K,ee){const ne=this._addNewAdapter(new R(this._documents,ee),x);return this._proxy.$registerRangeFormattingSupport(ne,this._transformDocumentSelector(K),x.identifier,x.displayName||x.name),this._createDisposable(ne)}$provideDocumentRangeFormattingEdits(x,K,ee,ne,de){return this._withAdapter(x,R,Ee=>Ee.provideDocumentRangeFormattingEdits(b.URI.revive(K),ee,ne,de),void 0)}registerOnTypeFormattingEditProvider(x,K,ee,ne){const de=this._addNewAdapter(new $(this._documents,ee),x);return this._proxy.$registerOnTypeFormattingSupport(de,this._transformDocumentSelector(K),ne,x.identifier),this._createDisposable(de)}$provideOnTypeFormattingEdits(x,K,ee,ne,de,Ee){return this._withAdapter(x,$,Re=>Re.provideOnTypeFormattingEdits(b.URI.revive(K),ee,ne,de,Ee),void 0)}registerWorkspaceSymbolProvider(x,K){const ee=this._addNewAdapter(new V(K,this._logService),x);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(x,K,ee){return this._withAdapter(x,V,ne=>ne.provideWorkspaceSymbols(K,ee),{symbols:[]})}$resolveWorkspaceSymbol(x,K,ee){return this._withAdapter(x,V,ne=>ne.resolveWorkspaceSymbol(K,ee),void 0)}$releaseWorkspaceSymbols(x,K){this._withAdapter(x,V,ee=>ee.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(x,K,ee){const ne=this._addNewAdapter(new z(this._documents,ee,this._logService),x);return this._proxy.$registerRenameSupport(ne,this._transformDocumentSelector(K),z.supportsResolving(ee)),this._createDisposable(ne)}$provideRenameEdits(x,K,ee,ne,de){return this._withAdapter(x,z,Ee=>Ee.provideRenameEdits(b.URI.revive(K),ee,ne,de),void 0)}$resolveRenameLocation(x,K,ee,ne){return this._withAdapter(x,z,de=>de.resolveRenameLocation(b.URI.revive(K),ee,ne),void 0)}registerDocumentSemanticTokensProvider(x,K,ee,ne){const de=this._nextHandle(),Ee=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(de,new De(new q(this._documents,ee),x)),this._proxy.$registerDocumentSemanticTokensProvider(de,this._transformDocumentSelector(K),ne,Ee);let Re=this._createDisposable(de);if(Ee){const xe=ee.onDidChangeSemanticTokens(be=>this._proxy.$emitDocumentSemanticTokensEvent(Ee));Re=T.Disposable.from(Re,xe)}return Re}$provideDocumentSemanticTokens(x,K,ee,ne){return this._withAdapter(x,q,de=>de.provideDocumentSemanticTokens(b.URI.revive(K),ee,ne),null,!0)}$releaseDocumentSemanticTokens(x,K){this._withAdapter(x,q,ee=>ee.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(x,K,ee,ne){const de=this._addNewAdapter(new M(this._documents,ee),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(de,this._transformDocumentSelector(K),ne),this._createDisposable(de)}$provideDocumentRangeSemanticTokens(x,K,ee,ne){return this._withAdapter(x,M,de=>de.provideDocumentRangeSemanticTokens(b.URI.revive(K),ee,ne),null,!0)}registerCompletionItemProvider(x,K,ee,ne){const de=this._addNewAdapter(new j(this._documents,this._commands.converter,ee,this._apiDeprecation,x),x);return this._proxy.$registerSuggestSupport(de,this._transformDocumentSelector(K),ne,j.supportsResolving(ee),`${x.identifier.value}(${ne.join("")})`),this._createDisposable(de)}$provideCompletionItems(x,K,ee,ne,de){return this._withAdapter(x,j,Ee=>Ee.provideCompletionItems(b.URI.revive(K),ee,ne,de),void 0)}$resolveCompletionItem(x,K,ee){return this._withAdapter(x,j,ne=>ne.resolveCompletionItem(K,ee),void 0)}$releaseCompletionItems(x,K){this._withAdapter(x,j,ee=>ee.releaseCompletionItems(K),void 0)}registerSignatureHelpProvider(x,K,ee,ne){const de=Array.isArray(ne)?{triggerCharacters:ne,retriggerCharacters:[]}:ne,Ee=this._addNewAdapter(new re(this._documents,ee),x);return this._proxy.$registerSignatureHelpProvider(Ee,this._transformDocumentSelector(K),de),this._createDisposable(Ee)}$provideSignatureHelp(x,K,ee,ne,de){return this._withAdapter(x,re,Ee=>Ee.provideSignatureHelp(b.URI.revive(K),ee,ne,de),void 0)}$releaseSignatureHelp(x,K){this._withAdapter(x,re,ee=>ee.releaseSignatureHelp(K),void 0)}registerInlineHintsProvider(x,K,ee){const ne=typeof ee.onDidChangeInlineHints=="function"?this._nextHandle():void 0,de=this._addNewAdapter(new F(this._documents,ee),x);this._proxy.$registerInlineHintsProvider(de,this._transformDocumentSelector(K),ne);let Ee=this._createDisposable(de);if(ne!==void 0){const Re=ee.onDidChangeInlineHints(xe=>this._proxy.$emitInlineHintsEvent(ne));Ee=T.Disposable.from(Ee,Re)}return Ee}$provideInlineHints(x,K,ee,ne){return this._withAdapter(x,F,de=>de.provideInlineHints(b.URI.revive(K),ee,ne),void 0)}registerDocumentLinkProvider(x,K,ee){const ne=this._addNewAdapter(new te(this._documents,ee),x);return this._proxy.$registerDocumentLinkProvider(ne,this._transformDocumentSelector(K),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ne)}$provideDocumentLinks(x,K,ee){return this._withAdapter(x,te,ne=>ne.provideLinks(b.URI.revive(K),ee),void 0)}$resolveDocumentLink(x,K,ee){return this._withAdapter(x,te,ne=>ne.resolveLink(K,ee),void 0)}$releaseDocumentLinks(x,K){this._withAdapter(x,te,ee=>ee.releaseLinks(K),void 0)}registerColorProvider(x,K,ee){const ne=this._addNewAdapter(new ae(this._documents,ee),x);return this._proxy.$registerDocumentColorProvider(ne,this._transformDocumentSelector(K)),this._createDisposable(ne)}$provideDocumentColors(x,K,ee){return this._withAdapter(x,ae,ne=>ne.provideColors(b.URI.revive(K),ee),[])}$provideColorPresentations(x,K,ee,ne){return this._withAdapter(x,ae,de=>de.provideColorPresentations(b.URI.revive(K),ee,ne),void 0)}registerFoldingRangeProvider(x,K,ee){const ne=this._nextHandle(),de=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ne,new De(new ue(this._documents,ee),x)),this._proxy.$registerFoldingRangeProvider(ne,this._transformDocumentSelector(K),de);let Ee=this._createDisposable(ne);if(de!==void 0){const Re=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(de));Ee=T.Disposable.from(Ee,Re)}return Ee}$provideFoldingRanges(x,K,ee,ne){return this._withAdapter(x,ue,de=>de.provideFoldingRanges(b.URI.revive(K),ee,ne),void 0)}registerSelectionRangeProvider(x,K,ee){const ne=this._addNewAdapter(new we(this._documents,ee,this._logService),x);return this._proxy.$registerSelectionRangeProvider(ne,this._transformDocumentSelector(K)),this._createDisposable(ne)}$provideSelectionRanges(x,K,ee,ne){return this._withAdapter(x,we,de=>de.provideSelectionRanges(b.URI.revive(K),ee,ne),[])}registerCallHierarchyProvider(x,K,ee){const ne=this._addNewAdapter(new fe(this._documents,ee),x);return this._proxy.$registerCallHierarchyProvider(ne,this._transformDocumentSelector(K)),this._createDisposable(ne)}$prepareCallHierarchy(x,K,ee,ne){return this._withAdapter(x,fe,de=>Promise.resolve(de.prepareSession(b.URI.revive(K),ee,ne)),void 0)}$provideCallHierarchyIncomingCalls(x,K,ee,ne){return this._withAdapter(x,fe,de=>de.provideCallsTo(K,ee,ne),void 0)}$provideCallHierarchyOutgoingCalls(x,K,ee,ne){return this._withAdapter(x,fe,de=>de.provideCallsFrom(K,ee,ne),void 0)}$releaseCallHierarchy(x,K){this._withAdapter(x,fe,ee=>Promise.resolve(ee.releaseSession(K)),void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:I.regExpFlags(x)}}static _serializeIndentationRule(x){return{decreaseIndentPattern:Se._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:Se._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?Se._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?Se._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:Se._serializeRegExp(x.beforeText),afterText:x.afterText?Se._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?Se._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(Se._serializeOnEnterRule)}setLanguageConfiguration(x,K,ee){let{wordPattern:ne}=ee;if(ne&&I.regExpLeadsToEndlessLoop(ne))throw new Error(`Invalid language configuration: wordPattern '${ne}' is not allowed to match the empty string.`);ne?this._documents.setWordDefinitionFor(K,ne):this._documents.setWordDefinitionFor(K,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const de=this._nextHandle(),Ee={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?Se._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?Se._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?Se._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(de,K,Ee),this._createDisposable(de)}$setWordDefinitions(x){for(const K of x)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=Se,Se._handlePool=0}),define(ve[191],_e([0,1,5,14,7]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(k,I){this._proxy=k.getProxy(b.MainContext.MainThreadLanguages),this._documents=I}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(k,I){await this._proxy.$changeLanguage(k,I);const i=this._documents.getDocumentData(k);if(!i)throw new Error(`document '${k.toString}' NOT found`);return i.document}async tokenAtPosition(k,I){var i;const P=k.version,S=y.Position.from(I),v=await this._proxy.$tokensAtPosition(k.uri,S),d={type:A.StandardTokenType.Other,range:(i=k.getWordRangeAtPosition(I))!==null&&i!==void 0?i:new A.Range(I.line,I.character,I.line,I.character)};if(!v)return d;const a={range:y.Range.to(v.range),type:y.TokenType.to(v.type)};return!a.range.contains(I)||P!==k.version?d:a}}e.ExtHostLanguages=T}),define(ve[192],_e([0,1,5,17,34]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(k){return k&&k.title}let E=class{constructor(I,i){this._logService=i,this._proxy=I.getProxy(b.MainContext.MainThreadMessageService)}showMessage(I,i,P,S,v){const d={extension:I};let a;typeof S=="string"||T(S)?a=[S,...v]:(d.modal=S&&S.modal,d.useCustom=S&&S.useCustom,a=v),d.useCustom&&A.checkProposedApiEnabled(I);const m=[];for(let p=0;p<a.length;p++){const f=a[p];if(typeof f=="string")m.push({title:f,handle:p,isCloseAffordance:!1});else if(typeof f=="object"){let{title:c,isCloseAffordance:n}=f;m.push({title:c,isCloseAffordance:!!n,handle:p})}else this._logService.warn("Invalid message item:",f)}return this._proxy.$showMessage(i,P,d,m).then(p=>{if(typeof p=="number")return a[p]})}};E=He([Be(1,y.ILogService)],E),e.ExtHostMessageService=E}),define(ve[193],_e([0,1,20,3,6,2,26,5,14,7,71,33,22,159,161,52,12]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d,a,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class f extends A.Disposable{constructor(r,g,C,_,D){super();this._editorId=r,this.uri=g,this._proxy=C,this._webviewInitData=_,this.document=D,this._onDidReceiveDocumentMessage=new y.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:w=>this._proxy.$postMessage(this._editorId,void 0,w),asWebviewUri:w=>this._asWebviewUri(w)}}onDidReceiveMessage(r,g){var C;this._onDidReceiveDocumentMessage.fire(g),r!==void 0&&((C=this._rendererIdToEmitters.get(r))===null||C===void 0||C.fire(g))}getRendererComm(r){const g=new y.Emitter;return this._rendererIdToEmitters.set(r,g),{editorId:this._editorId,onDidReceiveMessage:g.event,postMessage:C=>this._proxy.$postMessage(this._editorId,r,C),asWebviewUri:C=>this._asWebviewUri(C)}}_asWebviewUri(r){return P.asWebviewUri(this._webviewInitData,this._editorId,r)}}class c extends A.Disposable{constructor(r,g,C,_){super();this._proxy=r,this._handle=g,this._extension=C,this._provider=_,this._kernelToFriendlyId=new Map,this._friendlyIdToKernel=new Map,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(D=>{const w=D==null?void 0:D.uri;this._proxy.$onNotebookKernelChange(this._handle,w)}))}async provideKernels(r,g){const C=await this._provider.provideKernels(r.notebookDocument,g)||[],_=new Map;let D=0;const w=new Set,O=C.map(R=>{let $=this._kernelToFriendlyId.get(R);return $===void 0&&(R.id&&w.has(R.id)?$=`${this._extension.identifier.value}_${R.id}_${D++}`:$=`${this._extension.identifier.value}_${R.id||E.generateUuid()}`,this._kernelToFriendlyId.set(R,$)),_.set(R,$),{id:R.id,friendlyId:$,label:R.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,description:R.description,detail:R.detail,isPreferred:R.isPreferred,preloads:R.preloads}});return this._kernelToFriendlyId=_,this._friendlyIdToKernel.clear(),this._kernelToFriendlyId.forEach((R,$)=>{this._friendlyIdToKernel.set(R,$)}),O}getKernelByFriendlyId(r){return this._friendlyIdToKernel.get(r)}async resolveNotebook(r,g,C,_){const D=this._friendlyIdToKernel.get(r);if(D&&this._provider.resolveKernel)return this._provider.resolveKernel(D,g.notebookDocument,C,_)}async executeNotebook(r,g,C){const _=this._friendlyIdToKernel.get(r);if(!!_)return n(C?D=>_.executeCell(g.notebookDocument,C.cell,D):D=>_.executeAllCells(g.notebookDocument,D))}async cancelNotebook(r,g,C){const _=this._friendlyIdToKernel.get(r);if(!!_)return C?_.cancelCellExecution(g.notebookDocument,C.cell):_.cancelAllCellsExecution(g.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=c;async function n(u){const r=new b.CancellationTokenSource;try{await u(r.token)}finally{r.dispose()}}class o{constructor(r,g){this.key=o._Keys.nextId(),this._proxy=r,this._proxy.$registerNotebookEditorDecorationType(this.key,I.NotebookDecorationRenderOptions.from(g))}dispose(){this._proxy.$removeNotebookEditorDecorationType(this.key)}}e.NotebookEditorDecorationType=o,o._Keys=new m.IdGenerator("NotebookEditorDecorationType");class h{constructor(r,g,C,_,D,w){this._documentsAndEditors=C,this._webviewInitData=_,this.logService=D,this._extensionStoragePaths=w,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new v.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new y.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new y.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new y.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new y.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new y.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellLanguage=new y.Emitter,this.onDidChangeCellLanguage=this._onDidChangeCellLanguage.event,this._onDidChangeCellMetadata=new y.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new y.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidOpenNotebookDocument=new y.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new y.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new y.Emitter,this.onDidSaveNotebookDocument=this._onDidCloseNotebookDocument.event,this.visibleNotebookEditors=[],this._onDidChangeActiveNotebookKernel=new y.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new y.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._proxy=r.getProxy(k.MainContext.MainThreadNotebook),this._mainThreadBulkEdits=r.getProxy(k.MainContext.MainThreadBulkEdits),this._commandsConverter=g.converter,g.registerArgumentProcessor({processArgument:O=>{var R;if(O&&O.$mid===12){const $=(R=O.notebookEditor)===null||R===void 0?void 0:R.notebookUri,V=O.cell.handle,z=this._documents.get($),U=z==null?void 0:z.getCell(V);if(U)return U.cell}return O}})}get outputDisplayOrder(){return this._outputDisplayOrder}get activeNotebookEditor(){return this._activeNotebookEditor}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(r){return this._documents.get(r)}registerNotebookContentProvider(r,g,C,_){var D,w,O;if(this._notebookContentProviders.has(g))throw new Error(`Notebook provider for '${g}' already registered`);this._notebookContentProviders.set(g,{extension:r,provider:C});const R=[];R.push(C.onDidChangeNotebook?C.onDidChangeNotebook(z=>{const U=this._documents.get(T.URI.revive(z.document.uri));if(!U)throw new Error(`Notebook document ${z.document.uri.toString()} not found`);if(t(z)){const q=U.addEdit(z);this._proxy.$onUndoableContentChange(z.document.uri,g,q,z.label)}else this._proxy.$onContentChange(z.document.uri,g)}):A.Disposable.None),R.push(C.onDidChangeNotebookContentOptions?C.onDidChangeNotebookContentOptions(()=>{this._proxy.$updateNotebookProviderOptions(g,C.options)}):A.Disposable.None);const $=!!C.backupNotebook,V=(D=_==null?void 0:_.viewOptions)===null||D===void 0?void 0:D.filenamePattern.map(z=>I.NotebookExclusiveDocumentPattern.from(z)).filter(z=>z!==void 0);return((w=_==null?void 0:_.viewOptions)===null||w===void 0?void 0:w.filenamePattern)&&!V&&console.warn(`Notebook content provider view options file name pattern is invalid ${(O=_==null?void 0:_.viewOptions)===null||O===void 0?void 0:O.filenamePattern}`),this._proxy.$registerNotebookProvider({id:r.identifier,location:r.extensionLocation,description:r.description},g,$,{transientOutputs:(_==null?void 0:_.transientOutputs)||!1,transientMetadata:(_==null?void 0:_.transientMetadata)||{},viewOptions:(_==null?void 0:_.viewOptions)&&V?{displayName:_.viewOptions.displayName,filenamePattern:V,exclusive:_.viewOptions.exclusive||!1}:void 0}),new i.Disposable(()=>{R.forEach(z=>z.dispose()),this._notebookContentProviders.delete(g),this._proxy.$unregisterNotebookProvider(g)})}registerNotebookKernelProvider(r,g,C){const _=h._notebookKernelProviderHandlePool++,D=new c(this._proxy,_,r,C);return this._notebookKernelProviders.set(_,D),this._proxy.$registerNotebookKernelProvider({id:r.identifier,location:r.extensionLocation,description:r.description},_,{viewType:g.viewType,filenamePattern:g.filenamePattern?I.NotebookExclusiveDocumentPattern.from(g.filenamePattern):void 0}),new i.Disposable(()=>{D.dispose(),this._notebookKernelProviders.delete(_),this._proxy.$unregisterNotebookKernelProvider(_)})}createNotebookEditorDecorationType(r){return new o(this._proxy,r)}async openNotebookDocument(r,g){const C=this._documents.get(T.URI.revive(r));if(C)return Promise.resolve(C.notebookDocument);await this._proxy.$tryOpenDocument(r,g);const _=this._documents.get(T.URI.revive(r));return p.assertIsDefined(_==null?void 0:_.notebookDocument)}_withAdapter(r,g,C){const _=this._documents.get(T.URI.revive(g));if(!_)return[];const D=this._notebookKernelProviders.get(r);return D?C(D,_):[]}async showNotebookDocument(r,g){var C;let _;typeof g=="object"?_={position:I.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selection:g.selection,pinned:typeof g.preview=="boolean"?!g.preview:void 0}:_={preserveFocus:!1};const D=await this._proxy.$tryShowNotebookDocument(r.uri,r.viewType,_),w=D&&((C=this._editors.get(D))===null||C===void 0?void 0:C.editor);if(w)return w;throw D?new Error(`Could NOT open editor for "${r.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.toString()}".`)}async $provideNotebookKernels(r,g,C){return this._withAdapter(r,g,(_,D)=>_.provideKernels(D,C))}async $resolveNotebookKernel(r,g,C,_,D){await this._withAdapter(r,C,async(w,O)=>{const R=this._webviewComm.get(g);R&&await w.resolveNotebook(_,O,R.contentProviderComm,D)})}async $resolveNotebookData(r,g,C){const _=this._notebookContentProviders.get(r);if(!_)throw new Error(`NO provider for '${r}'`);const D=await _.provider.openNotebook(T.URI.revive(g),{backupId:C});return{metadata:Object.assign(Object.assign({},S.notebookDocumentMetadataDefaults),D.metadata),languages:D.languages,cells:D.cells.map(w=>Object.assign(Object.assign({},w),{outputs:w.outputs.map(O=>S.addIdToOutput(O))}))}}async $resolveNotebookEditor(r,g,C){const _=this._notebookContentProviders.get(r),D=T.URI.revive(g),w=this._documents.get(D);if(!(!w||!_)){let O=this._webviewComm.get(C);O||(O=new f(C,D,this._proxy,this._webviewInitData,w),this._webviewComm.set(C,O)),!!_.provider.resolveNotebook&&await _.provider.resolveNotebook(w.notebookDocument,O.contentProviderComm)}}async $executeNotebookKernelFromProvider(r,g,C,_){await this._withAdapter(r,g,async(D,w)=>{const O=_!==void 0?w.getCell(_):void 0;return D.executeNotebook(C,w,O)})}async $cancelNotebookKernelFromProvider(r,g,C,_){await this._withAdapter(r,g,async(D,w)=>{const O=_!==void 0?w.getCell(_):void 0;return D.cancelNotebook(C,w,O)})}async $saveNotebook(r,g,C){const _=this._documents.get(T.URI.revive(g));return _&&this._notebookContentProviders.has(r)?(await this._notebookContentProviders.get(r).provider.saveNotebook(_.notebookDocument,C),!0):!1}async $saveNotebookAs(r,g,C,_){const D=this._documents.get(T.URI.revive(g));return D&&this._notebookContentProviders.has(r)?(await this._notebookContentProviders.get(r).provider.saveNotebookAs(T.URI.revive(C),D.notebookDocument,_),!0):!1}async $undoNotebook(r,g,C,_){const D=this._documents.get(T.URI.revive(g));!D||D.undo(C,_)}async $redoNotebook(r,g,C,_){const D=this._documents.get(T.URI.revive(g));!D||D.redo(C,_)}async $backup(r,g,C){const _=this._documents.get(T.URI.revive(g)),D=this._notebookContentProviders.get(r);if(_&&D&&D.provider.backupNotebook){const w=await D.provider.backupNotebook(_.notebookDocument,{destination:_.getNewBackupUri()},C);return _.updateBackup(w),w.id}}$acceptDisplayOrder(r){this._outputDisplayOrder=r}$acceptNotebookActiveKernelChange(r){r.providerHandle!==void 0&&this._withAdapter(r.providerHandle,r.uri,async(g,C)=>{const _=r.kernelFriendlyId?g.getKernelByFriendlyId(r.kernelFriendlyId):void 0;this._editors.forEach(D=>{D.editor.notebookData===C&&D.editor._acceptKernel(_)}),this._onDidChangeActiveNotebookKernel.fire({document:C.notebookDocument,kernel:_})})}_getEditorFromURI(r){const g=T.URI.revive(r).toString();let C;return this._editors.forEach(_=>{_.editor.document.uri.toString()===g&&(C=_)}),C}$onDidReceiveMessage(r,g,C){var _;(_=this._webviewComm.get(r))===null||_===void 0||_.onDidReceiveMessage(g,C)}$acceptModelChanged(r,g,C){const _=this._documents.get(T.URI.revive(r));_&&_.acceptModelChanged(g,C)}$acceptModelSaved(r){const g=this._documents.get(T.URI.revive(r));g&&this._onDidSaveNotebookDocument.fire(g.notebookDocument)}$acceptEditorPropertiesChanged(r,g){var C;this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",r,g);let _;if(this._editors.forEach(D=>{D.editor.id===r&&(_=D)}),!!_&&(g.visibleRanges&&(_.editor._acceptVisibleRanges(g.visibleRanges.ranges),this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:_.editor,visibleRanges:_.editor.visibleRanges})),g.selections)){if(g.selections.selections.length){const D=g.selections.selections[0];_.editor.selection=(C=_.editor.notebookData.getCell(D))===null||C===void 0?void 0:C.cell}else _.editor.selection=void 0;this._onDidChangeNotebookEditorSelection.fire({notebookEditor:_.editor,selection:_.editor.selection})}}$acceptDocumentPropertiesChanged(r,g){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",r.path,g);const C=this._getEditorFromURI(r);!C||g.metadata&&C.editor.notebookData.acceptDocumentPropertiesChanged(g)}_createExtHostEditor(r,g,C,_){var D,w;const O=r.uri;let R=this._webviewComm.get(g);R||(R=new f(g,O,this._proxy,this._webviewInitData,r),this._webviewComm.set(g,R));const $=new a.ExtHostNotebookEditor(g,r.notebookDocument.viewType,this._proxy,R.contentProviderComm,r);if(C.length){const V=C[0];$.selection=(D=$.notebookData.getCell(V))===null||D===void 0?void 0:D.cell}else $.selection=void 0;$._acceptVisibleRanges(_),(w=this._editors.get(g))===null||w===void 0||w.editor.dispose(),this._editors.set(g,{editor:$})}$acceptDocumentAndEditorsDelta(r){var g,C,_,D,w;let O=!1;if(r.removedDocuments)for(const $ of r.removedDocuments){const V=T.URI.revive($),z=this._documents.get(V);z&&(z.dispose(),this._documents.delete(V),this._documentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:z.notebookDocument.cells.map(U=>U.uri)}),this._onDidCloseNotebookDocument.fire(z.notebookDocument));for(const U of this._editors.values())U.editor.document.uri.toString()===V.toString()&&(U.editor.dispose(),this._editors.delete(U.editor.id),O=!0)}if(r.addedDocuments){const $=[];for(const V of r.addedDocuments){const z=T.URI.revive(V.uri),U=V.viewType,q=this._notebookContentProviders.get(U),M=q&&((g=this._extensionStoragePaths.workspaceValue(q.extension))!==null&&g!==void 0?g:this._extensionStoragePaths.globalValue(q.extension));if(this._documents.has(z))throw new Error(`adding EXISTING notebook ${z}`);const j=this,re=new d.ExtHostNotebookDocument(this._proxy,this._documentsAndEditors,this._mainThreadBulkEdits,{emitModelChange(F){j._onDidChangeNotebookCells.fire(F)},emitCellOutputsChange(F){j._onDidChangeCellOutputs.fire(F)},emitCellLanguageChange(F){j._onDidChangeCellLanguage.fire(F)},emitCellMetadataChange(F){j._onDidChangeCellMetadata.fire(F)},emitDocumentMetadataChange(F){j._onDidChangeNotebookDocumentMetadata.fire(F)}},U,V.contentOptions,Object.assign(Object.assign({},S.notebookDocumentMetadataDefaults),V.metadata),z,M);re.acceptModelChanged({versionId:V.versionId,rawEvents:[{kind:S.NotebookCellsChangeType.Initialize,changes:[[0,0,V.cells]]}]},!1),$.push(...V.cells.map(F=>d.ExtHostCell.asModelAddData(re.notebookDocument,F))),(C=this._documents.get(z))===null||C===void 0||C.dispose(),this._documents.set(z,re),V.attachedEditor&&(this._createExtHostEditor(re,V.attachedEditor.id,V.attachedEditor.selections,V.attachedEditor.visibleRanges),O=!0),this._documentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:$}),this._onDidOpenNotebookDocument.fire(re.notebookDocument)}}if(r.addedEditors)for(const $ of r.addedEditors){if(this._editors.has($.id))return;const V=T.URI.revive($.documentUri),z=this._documents.get(V);z&&(this._createExtHostEditor(z,$.id,$.selections,$.visibleRanges),O=!0)}const R=[];if(r.removedEditors)for(const $ of r.removedEditors){const V=this._editors.get($);V&&(O=!0,this._editors.delete($),((_=this.activeNotebookEditor)===null||_===void 0?void 0:_.id)===V.editor.id&&(this._activeNotebookEditor=void 0),R.push(V))}if(O&&R.forEach($=>{$.editor.dispose()}),r.visibleEditors){this.visibleNotebookEditors=r.visibleEditors.map(V=>this._editors.get(V).editor).filter(V=>!!V);const $=new Set;this.visibleNotebookEditors.forEach(V=>$.add(V.id));for(const V of this._editors.values()){const z=$.has(V.editor.id);V.editor._acceptVisibility(z)}this.visibleNotebookEditors=[...this._editors.values()].map(V=>V.editor).filter(V=>V.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}if(r.newActiveEditor!==void 0){if(r.newActiveEditor){this._activeNotebookEditor=(D=this._editors.get(r.newActiveEditor))===null||D===void 0?void 0:D.editor,(w=this._activeNotebookEditor)===null||w===void 0||w._acceptActive(!0);for(const $ of this._editors.values())$.editor!==this.activeNotebookEditor&&$.editor._acceptActive(!1)}else{this._activeNotebookEditor=void 0;for(const $ of this._editors.values())$.editor._acceptActive(!1)}this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor)}}createNotebookCellStatusBarItemInternal(r,g,C){const _=new s(this._proxy,this._commandsConverter,r,g,C),D=S.CellUri.parse(r.uri);if(D){const w=this._documents.get(D.notebook);if(w){const O=w.getCell(D.handle);O&&y.Event.once(O.onDidDispose)(()=>_.dispose())}}return _}}e.ExtHostNotebookController=h,h._notebookKernelProviderHandlePool=0;function t(u){return typeof u.undo=="function"&&typeof u.redo=="function"}class s extends A.Disposable{constructor(r,g,C,_,D){super();this._proxy=r,this._commands=g,this._cell=C,this._priority=D,this._id=s.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new A.DisposableStore),this._alignment=_!=null?_:i.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=l(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(r){this._alignment=r,this.update()}get priority(){return this._priority}set priority(r){this._priority=r,this.update()}get text(){return this._text}set text(r){this._text=r,this.update()}get tooltip(){return this._tooltip}set tooltip(r){this._tooltip=r,this.update()}get command(){var r;return(r=this._command)===null||r===void 0?void 0:r.fromApi}set command(r){var g;((g=this._command)===null||g===void 0?void 0:g.fromApi)!==r&&(this._internalCommandRegistration.clear(),typeof r=="string"?this._command={fromApi:r,internal:this._commands.toInternal({title:"",command:r},this._internalCommandRegistration)}:r?this._command={fromApi:r,internal:this._commands.toInternal(r,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(r){this._accessibilityInformation=r,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var r;if(!this._isDisposed){const g={alignment:this.alignment===i.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.uri,command:(r=this._command)===null||r===void 0?void 0:r.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,g)}}}e.NotebookCellStatusBarItemInternal=s,s.NEXT_ID=0;function l(u){return Object.freeze({cell:u.cell,get alignment(){return u.alignment},set alignment(r){u.alignment=r},get priority(){return u.priority},set priority(r){u.priority=r},get text(){return u.text},set text(r){u.text=r},get tooltip(){return u.tooltip},set tooltip(r){u.tooltip=r},get command(){return u.command},set command(r){u.command=r},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(r){u.accessibilityInformation=r},show(){u.show()},hide(){u.hide()},dispose(){u.dispose()}})}}),define(ve[97],_e([0,1,5,3,6,27,4,13]),function(se,e,b,y,A,T,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class I extends A.Disposable{constructor(a,m,p,f){super();this._onDidAppend=this._register(new y.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=f,this._id=f.$register(this.name,m,p),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?T.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(m=>this._proxy.$clear(m,a))}show(a,m){this.validate(),this._id.then(p=>this._proxy.$reveal(p,!!(typeof a=="boolean"?a:m)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=I;class i extends I{constructor(a,m){super(a,!1,void 0,m)}append(a){super.append(a),this._id.then(m=>this._proxy.$append(m,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=i;class P extends I{constructor(a,m,p){super(a,!0,m,p)}append(a){throw new Error("Not supported")}}class S{constructor(a,m){this.name=a,this._channel=m}append(a){this._channel.then(m=>m.append(a))}appendLine(a){this._channel.then(m=>m.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,m){this._channel.then(p=>p.show(a,m))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=S;let v=class{constructor(a){this._proxy=a.getProxy(b.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new i(a,this._proxy)}createOutputChannelFromLogFile(a,m){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!m)throw new Error("illegal argument `file`. must not be falsy");return new P(a,m,this._proxy)}};v=He([Be(0,k.IExtHostRpcService)],v),e.ExtHostOutputService=v,e.IExtHostOutputService=E.createDecorator("IExtHostOutputService")}),define(ve[194],_e([0,1,15,20,3,6,5,2,7,9,11]),function(se,e,b,y,A,T,E,k,I,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickOpen=void 0;class S{constructor(n,o,h){this._sessions=new Map,this._instances=0,this._proxy=n.getProxy(E.MainContext.MainThreadQuickOpen),this._workspace=o,this._commands=h}showQuickPick(n,o,h,t=y.CancellationToken.None){this._onDidSelectItem=void 0;const s=Promise.resolve(n),l=++this._instances,u=this._proxy.$show(l,{placeHolder:h&&h.placeHolder,matchOnDescription:h&&h.matchOnDescription,matchOnDetail:h&&h.matchOnDetail,ignoreFocusLost:h&&h.ignoreFocusOut,canPickMany:h&&h.canPickMany},t),r={},g=u.then(()=>r);return Promise.race([g,s]).then(C=>{if(C!==r)return s.then(_=>{const D=[];for(let w=0;w<_.length;w++){const O=_[w];let R,$,V,z,U;typeof O=="string"?R=O:(R=O.label,$=O.description,V=O.detail,z=O.picked,U=O.alwaysShow),D.push({label:R,description:$,handle:w,detail:V,picked:z,alwaysShow:U})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=w=>{h.onDidSelectItem(_[w])}),this._proxy.$setItems(l,D),u.then(w=>{if(typeof w=="number")return _[w];if(Array.isArray(w))return w.map(O=>_[O])})})}).then(void 0,C=>{if(!i.isPromiseCanceledError(C))return this._proxy.$setError(l,C),Promise.reject(C)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,o=y.CancellationToken.None){return this._validateInput=n?n.validateInput:void 0,this._proxy.$input(n,typeof this._validateInput=="function",o).then(void 0,h=>{if(!i.isPromiseCanceledError(h))return Promise.reject(h)})}$validateInput(n){return this._validateInput?b.asPromise(()=>this._validateInput(n)):Promise.resolve(void 0)}async showWorkspaceFolderPick(n,o=y.CancellationToken.None){const h=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!!h){const t=await this._workspace.getWorkspaceFolders2();if(!!t)return t.find(s=>s.uri.toString()===h.uri.toString())}}createQuickPick(n,o){const h=new p(this._proxy,n,o,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(n){const o=new f(this._proxy,n,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(n,o){const h=this._sessions.get(n);h&&h._fireDidChangeValue(o)}$onDidAccept(n){const o=this._sessions.get(n);o&&o._fireDidAccept()}$onDidChangeActive(n,o){const h=this._sessions.get(n);h instanceof p&&h._fireDidChangeActive(o)}$onDidChangeSelection(n,o){const h=this._sessions.get(n);h instanceof p&&h._fireDidChangeSelection(o)}$onDidTriggerButton(n,o){const h=this._sessions.get(n);h&&h._fireDidTriggerButton(o)}$onDidHide(n){const o=this._sessions.get(n);o&&o._fireDidHide()}}e.ExtHostQuickOpen=S;class v{constructor(n,o,h){this._proxy=n,this._extensionId=o,this._onDidDispose=h,this._id=p._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new A.Emitter,this._onDidChangeValueEmitter=new A.Emitter,this._onDidTriggerButtonEmitter=new A.Emitter,this._onDidHideEmitter=new A.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((o,h)=>{const t=o===I.QuickInputButtons.Back?-1:h;this._handlesToButtons.set(t,o)}),this.update({buttons:n.map((o,h)=>({iconPath:d(o.iconPath),tooltip:o.tooltip,handle:o===I.QuickInputButtons.Back?-1:h}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const o=this._handlesToButtons.get(n);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=T.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),this._proxy.$dispose(this._id))}update(n){if(!this._disposed){for(const o of Object.keys(n)){const h=n[o];this._pendingUpdate[o]=h===void 0?null:h}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){this._proxy.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function d(c){if(c instanceof I.ThemeIcon)return{id:c.id};const n=m(c),o=a(c);return{dark:typeof n=="string"?k.URI.file(n):n,light:typeof o=="string"?k.URI.file(o):o}}function a(c){return typeof c=="object"&&"light"in c?c.light:c}function m(c){return typeof c=="object"&&"dark"in c?c.dark:c}class p extends v{constructor(n,o,h,t){super(n,o,t);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new A.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new A.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((o,h)=>{this._handlesToItems.set(h,o),this._itemsToHandles.set(o,h)}),this.update({items:n.map((o,h)=>({label:o.label,description:o.description,handle:h,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(n){const o=P.coalesce(n.map(h=>this._handlesToItems.get(h)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(n){const o=P.coalesce(n.map(h=>this._handlesToItems.get(h)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}}class f extends v{constructor(n,o,h){super(n,o,h);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,this.update({validationMessage:n})}}}),define(ve[195],_e([0,1,2,3,44,6,15,5,11,104,17,25,34]),function(se,e,b,y,A,T,E,k,I,i,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(u){if(u)return typeof u.iconPath=="string"?b.URI.file(u.iconPath):u.iconPath}function a(u,r){if(!u.iconPath&&!r.iconPath)return 0;if(u.iconPath){if(!r.iconPath)return 1}else return-1;const g=typeof u.iconPath=="string"?u.iconPath:u.iconPath.fsPath,C=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath;return i.comparePaths(g,C)}function m(u,r){let g=0;if(u.strikeThrough!==r.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==r.faded)return u.faded?1:-1;if(u.tooltip!==r.tooltip)return(u.tooltip||"").localeCompare(r.tooltip||"");if(g=a(u,r),g!==0)return g;if(u.light&&r.light)g=a(u.light,r.light);else{if(u.light)return 1;if(r.light)return-1}if(g!==0)return g;if(u.dark&&r.dark)g=a(u.dark,r.dark);else{if(u.dark)return 1;if(r.dark)return-1}return g}function p(u,r){if(u.command!==r.command)return u.command<r.command?-1:1;if(u.title!==r.title)return u.title<r.title?-1:1;if(u.tooltip!==r.tooltip){if(u.tooltip!==void 0&&r.tooltip!==void 0)return u.tooltip<r.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(r.tooltip!==void 0)return-1}if(u.arguments===r.arguments)return 0;if(u.arguments)if(r.arguments){if(u.arguments.length!==r.arguments.length)return u.arguments.length-r.arguments.length}else return 1;else return-1;for(let g=0;g<u.arguments.length;g++){const C=u.arguments[g],_=r.arguments[g];if(C!==_)return C<_?-1:1}return 0}function f(u,r){let g=i.comparePaths(u.resourceUri.fsPath,r.resourceUri.fsPath,!0);if(g!==0)return g;if(u.command&&r.command)g=p(u.command,r.command);else{if(u.command)return 1;if(r.command)return-1}if(g!==0)return g;if(u.decorations&&r.decorations)g=m(u.decorations,r.decorations);else{if(u.decorations)return 1;if(r.decorations)return-1}return g}function c(u,r){for(let g=0;g<u.length;g++)if(u[g]!==r[g])return!1;return!0}function n(u,r){return u.command===r.command&&u.title===r.title&&u.tooltip===r.tooltip&&(u.arguments&&r.arguments?c(u.arguments,r.arguments):u.arguments===r.arguments)}function o(u,r){return I.equals(u,r,n)}class h{constructor(r,g,C){this._extension=r,this._proxy=g,this._sourceControlHandle=C,this._value="",this._onDidChange=new y.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(r){this._proxy.$setInputBoxValue(this._sourceControlHandle,r),this.updateValue(r)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(r){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,r),this._placeholder=r}get validateInput(){return v.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(r){if(v.checkProposedApiEnabled(this._extension),r&&typeof r!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=r,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!r)}get visible(){return this._visible}set visible(r){r=!!r,this._visible!==r&&(this._visible=r,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,r))}$onInputBoxValueChange(r){this.updateValue(r)}updateValue(r){this._value=r,this._onDidChange.fire(r)}}e.ExtHostSCMInputBox=h;class t{constructor(r,g,C,_,D){this._proxy=r,this._commands=g,this._sourceControlHandle=C,this._id=_,this._label=D,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new y.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new y.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(r){this._label=r,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,r)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(r){this._hideWhenEmpty=r,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(r){this._resourceStates=[...r],this._onDidUpdateResourceStates.fire()}getResourceState(r){return this._resourceStatesMap.get(r)}$executeResourceCommand(r,g){const C=this._resourceStatesCommandsMap.get(r);return C?E.asPromise(()=>this._commands.executeCommand(C.command,...C.arguments||[],g)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var r;const g=[...this._resourceStates].sort(f),_=I.sortedDiff(this._resourceSnapshot,g,f).map(O=>{const R=O.toInsert.map($=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,$);const z=$.resourceUri,U=d($.decorations),q=$.decorations&&d($.decorations.light)||U,M=$.decorations&&d($.decorations.dark)||U,j=[];let re;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const fe=new T.DisposableStore;re=this._commands.converter.toInternal($.command,fe),this._resourceStatesDisposablesMap.set(V,fe)}else this._resourceStatesCommandsMap.set(V,$.command);q&&j.push(q),M&&M.toString()!==(q==null?void 0:q.toString())&&j.push(M);const F=$.decorations&&$.decorations.tooltip||"",te=$.decorations&&!!$.decorations.strikeThrough,ae=$.decorations&&!!$.decorations.faded,ue=$.contextValue||"";return{rawResource:[V,z,j,F,te,ae,ue,re],handle:V}});return{start:O.start,deleteCount:O.deleteCount,toInsert:R}}),D=_.map(({start:O,deleteCount:R,toInsert:$})=>[O,R,$.map(V=>V.rawResource)]),w=_.reverse();for(const{start:O,deleteCount:R,toInsert:$}of w){const V=$.map(U=>U.handle),z=this._handlesSnapshot.splice(O,R,...V);for(const U of z)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),(r=this._resourceStatesDisposablesMap.get(U))===null||r===void 0||r.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=g,D}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class s{constructor(r,g,C,_,D,w){this._proxy=g,this._commands=C,this._id=_,this._label=D,this._rootUri=w,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new y.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=s._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new h(r,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,_,D,w)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(r){this._count!==r&&(this._count=r,this._proxy.$updateSourceControl(this.handle,{count:r}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(r){this._quickDiffProvider=r,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!r})}get commitTemplate(){return this._commitTemplate}set commitTemplate(r){r!==this._commitTemplate&&(this._commitTemplate=r,this._proxy.$updateSourceControl(this.handle,{commitTemplate:r}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(r){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=r;const g=this._commands.converter.toInternal(r,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:g})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(r){if(!(this._statusBarCommands&&r&&o(this._statusBarCommands,r))){this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=r;const g=(r||[]).map(C=>this._commands.converter.toInternal(C,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:g})}}get selected(){return this._selected}createResourceGroup(r,g){const C=new t(this._proxy,this._commands,this.handle,r,g),_=y.Event.once(C.onDidDispose)(()=>this.createdResourceGroups.delete(C));return this.createdResourceGroups.set(C,_),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const r=[],g=[];for(const[C,_]of this.createdResourceGroups){_.dispose();const D=C.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(C),this.eventuallyUpdateResourceStates()});y.Event.once(C.onDidDispose)(()=>{this.updatedResourceGroups.delete(C),D.dispose(),this._groups.delete(C.handle),this._proxy.$unregisterGroup(this.handle,C.handle)}),r.push([C.handle,C.id,C.label,C.features]);const w=C._takeResourceStateSnapshot();w.length>0&&g.push([C.handle,w]),this._groups.set(C.handle,C)}this._proxy.$registerGroups(this.handle,r,g),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const r=[];this.updatedResourceGroups.forEach(g=>{const C=g._takeResourceStateSnapshot();C.length!==0&&r.push([g.handle,C])}),r.length>0&&this._proxy.$spliceResourceStates(this.handle,r),this.updatedResourceGroups.clear()}getResourceGroup(r){return this._groups.get(r)}setSelectionState(r){this._selected=r,this._onDidChangeSelection.fire(r)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(r=>r.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}s._handlePool=0,He([A.debounce(100)],s.prototype,"eventuallyAddResourceGroups",null),He([A.debounce(100)],s.prototype,"eventuallyUpdateResourceStates",null);let l=class vi{constructor(r,g,C){this._commands=g,this.logService=C,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new y.Emitter,this._proxy=r.getProxy(k.MainContext.MainThreadSCM),this._telemetry=r.getProxy(k.MainContext.MainThreadTelemetry),g.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===3){const D=this._sourceControls.get(_.sourceControlHandle);if(!D)return _;const w=D.getResourceGroup(_.groupHandle);return w?w.getResourceState(_.handle):_}else if(_&&_.$mid===4){const D=this._sourceControls.get(_.sourceControlHandle);return D?D.getResourceGroup(_.groupHandle):_}else if(_&&_.$mid===5){const D=this._sourceControls.get(_.handle);return D||_}return _}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(r,g,C,_){this.logService.trace("ExtHostSCM#createSourceControl",r.identifier.value,g,C,_),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:r.identifier.value});const D=vi._handlePool++,w=new s(r,this._proxy,this._commands,g,C,_);this._sourceControls.set(D,w);const O=this._sourceControlsByExtension.get(S.ExtensionIdentifier.toKey(r.identifier))||[];return O.push(w),this._sourceControlsByExtension.set(S.ExtensionIdentifier.toKey(r.identifier),O),w}getLastInputBox(r){this.logService.trace("ExtHostSCM#getLastInputBox",r.identifier.value);const g=this._sourceControlsByExtension.get(S.ExtensionIdentifier.toKey(r.identifier)),C=g&&g[g.length-1];return C&&C.inputBox}$provideOriginalResource(r,g,C){const _=b.URI.revive(g);this.logService.trace("ExtHostSCM#$provideOriginalResource",r,_.toString());const D=this._sourceControls.get(r);return!D||!D.quickDiffProvider||!D.quickDiffProvider.provideOriginalResource?Promise.resolve(null):E.asPromise(()=>D.quickDiffProvider.provideOriginalResource(_,C)).then(w=>w||null)}$onInputBoxValueChange(r,g){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",r);const C=this._sourceControls.get(r);return C&&C.inputBox.$onInputBoxValueChange(g),Promise.resolve(void 0)}$executeResourceCommand(r,g,C,_){this.logService.trace("ExtHostSCM#$executeResourceCommand",r,g,C);const D=this._sourceControls.get(r);if(!D)return Promise.resolve(void 0);const w=D.getResourceGroup(g);return w?w.$executeResourceCommand(C,_):Promise.resolve(void 0)}$validateInput(r,g,C){this.logService.trace("ExtHostSCM#$validateInput",r);const _=this._sourceControls.get(r);return!_||!_.inputBox.validateInput?Promise.resolve(void 0):E.asPromise(()=>_.inputBox.validateInput(g,C)).then(D=>D?Promise.resolve([D.message,D.type]):Promise.resolve(void 0))}$setSelectedSourceControl(r){var g,C;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",r),r!==void 0&&((g=this._sourceControls.get(r))===null||g===void 0||g.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((C=this._sourceControls.get(this._selectedSourceControlHandle))===null||C===void 0||C.setSelectionState(!1)),this._selectedSourceControlHandle=r,Promise.resolve(void 0)}};l._handlePool=0,l=He([Be(2,P.ILogService)],l),e.ExtHostSCM=l}),define(ve[196],_e([0,1,7,5,129,6]),function(se,e,b,y,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class E{constructor(P,S,v,d,a=b.StatusBarAlignment.Left,m,p){this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,this._id=E.ID_GEN++,this._proxy=P,this._commands=S,this._statusId=v,this._statusName=d,this._alignment=a,this._priority=m,this._accessibilityInformation=p}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var P;return(P=this._command)===null||P===void 0?void 0:P.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(P){this._text=P,this.update()}set tooltip(P){this._tooltip=P,this.update()}set color(P){this._color=P,this.update()}set backgroundColor(P){P&&!E.ALLOWED_BACKGROUND_COLORS.has(P.id)&&(P=void 0),this._backgroundColor=P,this.update()}set command(P){var S;((S=this._command)===null||S===void 0?void 0:S.fromApi)!==P&&(this._internalCommandRegistration.clear(),typeof P=="string"?this._command={fromApi:P,internal:this._commands.toInternal({title:"",command:P},this._internalCommandRegistration)}:P?this._command={fromApi:P,internal:this._commands.toInternal(P,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(P){this._accessibilityInformation=P,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this._proxy.$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var P;this._timeoutHandle=void 0;let S=this._color;this._backgroundColor&&(S=E.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),this._proxy.$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(P=this._command)===null||P===void 0?void 0:P.internal,S,this._backgroundColor,this._alignment===b.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=E,E.ID_GEN=0,E.ALLOWED_BACKGROUND_COLORS=(()=>{const i=new Map;return i.set("statusBarItem.errorBackground",new b.ThemeColor("statusBarItem.errorForeground")),i})();class k{constructor(P){this._messages=[],this._item=P.createStatusBarEntry("status.extensionMessage",A.localize(0,null),b.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(P){const S={message:P};return this._messages.unshift(S),this._update(),new b.Disposable(()=>{const v=this._messages.indexOf(S);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(P,S){this._proxy=P.getProxy(y.MainContext.MainThreadStatusBar),this._commands=S,this._statusMessage=new k(this)}createStatusBarEntry(P,S,v,d,a){return new E(this._proxy,this._commands,P,S,v,d,a)}setStatusBarMessage(P,S){const v=this._statusMessage.setMessage(P);let d;return typeof S=="number"?d=setTimeout(()=>v.dispose(),S):typeof S!="undefined"&&S.then(()=>v.dispose(),()=>v.dispose()),new b.Disposable(()=>{v.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=I}),define(ve[76],_e([0,1,5,3,4]),function(se,e,b,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(k){this._onDidChangeStorage=new y.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(b.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,I){this._proxy.$registerExtensionStorageKeysToSync(k,I)}getValue(k,I,i){return this._proxy.$getValue(k,I).then(P=>P||i)}setValue(k,I,i){return this._proxy.$setValue(k,I,i)}$acceptValue(k,I,i){this._onDidChangeStorage.fire({shared:k,key:I,value:i})}}e.ExtHostStorage=T,e.IExtHostStorage=A.createDecorator("IExtHostStorage")}),define(ve[77],_e([0,1,4,28,17,75,2]),function(se,e,b,y,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=b.createDecorator("IExtensionStoragePaths");let k=class{constructor(i,P,S){var v;this._logService=P,this._extHostFileSystem=S,this._workspace=(v=i.workspace)!==null&&v!==void 0?v:void 0,this._environment=i.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(d=>this._value=d)}async _getOrCreateWorkspaceStoragePath(){var i;if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,S=E.URI.joinPath(this._environment.workspaceStorageHome,P);try{return await this._extHostFileSystem.stat(S),this._logService.trace("[ExtHostStorage] storage dir already exists",S),S}catch(v){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",S),await this._extHostFileSystem.createDirectory(S),await this._extHostFileSystem.writeFile(E.URI.joinPath(S,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(i=E.URI.revive(this._workspace.configuration))===null||i===void 0?void 0:i.toString(),name:this._workspace.name},void 0,2))),S}catch(v){this._logService.error("[ExtHostStorage]",v);return}}workspaceValue(i){if(this._value)return E.URI.joinPath(this._value,i.identifier.value)}globalValue(i){return E.URI.joinPath(this._environment.globalStorageHome,i.identifier.value.toLowerCase())}};k=He([Be(0,y.IExtHostInitDataService),Be(1,A.ILogService),Be(2,T.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(ve[41],_e([0,1,3,5,4,2,13,165,6,7,130,9,164,20,26]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=A.createDecorator("IExtHostTerminalService");class m{constructor(t,s,l,u){this._proxy=t,this._id=s,this._creationOptions=l,this._name=u,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(r=>this._pidPromiseComplete=r)}async create(t,s,l,u,r,g,C,_){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:s,cwd:l,env:u,waitOnExit:r,strictEnv:g,hideFromUser:C,isFeatureTerminal:_})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}dispose(){this._disposed||(this._disposed=!0,this._proxy.$dispose(this._id))}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}get name(){return this._name||""}set name(t){this._name=t}get exitStatus(){return this._exitStatus}get dimensions(){if(!(this._cols===void 0||this._rows===void 0))return{columns:this._cols,rows:this._rows}}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,s){return t===this._cols&&s===this._rows||t===0||s===0?!1:(this._cols=t,this._rows=s,!0)}get processId(){return this._pidPromise}get creationOptions(){return this._creationOptions}sendText(t,s=!0){this._checkDisposed(),this._proxy.$sendText(this._id,t,s)}show(t){this._checkDisposed(),this._proxy.$show(this._id,t)}hide(){this._checkDisposed(),this._proxy.$hide(this._id)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=m;class p{constructor(t){this._pty=t,this._onProcessData=new b.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new b.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new b.Emitter,this._onProcessTitleChanged=new b.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new b.Emitter}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,s){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:s})}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose&&this._pty.onDidClose((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(s=>this._onProcessOverrideDimensions.fire(s&&{cols:s.columns,rows:s.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=p;let f=1,c=class extends I.Disposable{constructor(t,s){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new b.Emitter,this._onDidOpenTerminal=new b.Emitter,this._onDidChangeActiveTerminal=new b.Emitter,this._onDidChangeTerminalDimensions=new b.Emitter,this._proxy=s.getProxy(y.MainContext.MainThreadTerminalService),this._bufferer=new k.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new b.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[l,u]of this._terminalProcesses)u.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal}get terminals(){return this._terminals}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const s=new m(this._proxy,a.generateUuid(),t,t.name),l=new p(t.pty);return s.createExtensionTerminal().then(u=>{const r=this._setupExtHostProcessListeners(u,l);this._terminalProcessDisposables[u]=r}),this._terminals.push(s),s}attachPtyToTerminal(t,s){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const u=new p(s),r=this._setupExtHostProcessListeners(t,u);this._terminalProcessDisposables[t]=r}async $acceptActiveTerminalChanged(t){const s=this._activeTerminal;if(t===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const l=this._getTerminalById(t);l&&(this._activeTerminal=l,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal))}async $acceptTerminalProcessData(t,s){const l=this._getTerminalById(t);l&&this._onDidWriteTerminalData.fire({terminal:l,data:s})}async $acceptTerminalDimensions(t,s,l){const u=this._getTerminalById(t);u&&u.setDimensions(s,l)&&this._onDidChangeTerminalDimensions.fire({terminal:u,dimensions:u.dimensions})}async $acceptTerminalMaximumDimensions(t,s,l){var u;(u=this._terminalProcesses.get(t))===null||u===void 0||u.resize(s,l)}async $acceptTerminalTitleChange(t,s){const l=this._getTerminalById(t);l&&(l.name=s)}async $acceptTerminalClosed(t,s){const l=this._getTerminalObjectIndexById(this.terminals,t);if(l!==null){const u=this._terminals.splice(l,1)[0];u.setExitCode(s),this._onDidCloseTerminal.fire(u)}}$acceptTerminalOpened(t,s,l,u){if(s){const C=this._getTerminalObjectIndexById(this._terminals,s);if(C!==null){this.terminals[C]._id=t,this._onDidOpenTerminal.fire(this.terminals[C]),this.terminals[C].isOpen=!0;return}}const r={name:u.name,shellPath:u.executable,shellArgs:u.args,cwd:typeof u.cwd=="string"?u.cwd:T.URI.revive(u.cwd),env:u.env,hideFromUser:u.hideFromUser},g=new m(this._proxy,t,r,l);this._terminals.push(g),this._onDidOpenTerminal.fire(g),g.isOpen=!0}async $acceptTerminalProcessId(t,s){const l=this._getTerminalById(t);l&&l._setProcessId(s)}async $startExtensionTerminal(t,s){const l=this._getTerminalById(t);if(!l)return{message:P.localize(0,null,t)};l.isOpen||await new Promise(r=>{const g=this.onDidOpenTerminal(async C=>{C===l&&(g.dispose(),r())})});const u=this._terminalProcesses.get(t);u?u.startSendingEvents(s):this._extensionTerminalAwaitingStart[t]={initialDimensions:s}}_setupExtHostProcessListeners(t,s){const l=new I.DisposableStore;l.add(s.onProcessReady(r=>this._proxy.$sendProcessReady(t,r.pid,r.cwd))),l.add(s.onProcessTitleChanged(r=>this._proxy.$sendProcessTitle(t,r))),this._bufferer.startBuffering(t,s.onProcessData),l.add(s.onProcessExit(r=>this._onProcessExit(t,r))),s.onProcessOverrideDimensions&&l.add(s.onProcessOverrideDimensions(r=>this._proxy.$sendOverrideDimensions(t,r))),this._terminalProcesses.set(t,s);const u=this._extensionTerminalAwaitingStart[t];return u&&s instanceof p&&(s.startSendingEvents(u.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),l}$acceptProcessAckDataEvent(t,s){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.acknowledgeDataEvent(s)}$acceptProcessInput(t,s){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.input(s)}$acceptProcessResize(t,s,l){var u;try{(u=this._terminalProcesses.get(t))===null||u===void 0||u.resize(s,l)}catch(r){if(r.code!=="EPIPE"&&r.code!=="ERR_IPC_CHANNEL_CLOSED")throw r}}$acceptProcessShutdown(t,s){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.shutdown(s)}$acceptProcessRequestInitialCwd(t){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.getInitialCwd().then(l=>this._proxy.$sendProcessInitialCwd(t,l))}$acceptProcessRequestCwd(t){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.getCwd().then(l=>this._proxy.$sendProcessCwd(t,l))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new i.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,s){const l=this._getTerminalById(t);if(!l)return[];this._terminalLinkCache.delete(t);const u=this._terminalLinkCancellationSource.get(t);u&&u.dispose(!0);const r=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,r);const g=[],C={terminal:l,line:s},_=[];for(const O of this._linkProviders)_.push(new Promise(async R=>{r.token.onCancellationRequested(()=>R({provider:O,links:[]}));const $=await O.provideTerminalLinks(C,r.token)||[];r.token.isCancellationRequested||R({provider:O,links:$})}));const D=await Promise.all(_);if(r.token.isCancellationRequested)return[];const w=new Map;for(const O of D)O&&O.links.length>0&&g.push(...O.links.map(R=>{const $={id:f++,startIndex:R.startIndex,length:R.length,label:R.tooltip};return w.set($.id,{provider:O.provider,link:R}),$}));return this._terminalLinkCache.set(t,w),g}$activateLink(t,s){var l;const u=(l=this._terminalLinkCache.get(t))===null||l===void 0?void 0:l.get(s);!u||u.provider.handleTerminalLink(u.link)}_onProcessExit(t,s){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const l=this._terminalProcessDisposables[t];l&&(l.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,s)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,s){const l=this._getTerminalObjectIndexById(t,s);return l!==null?t[l]:null}_getTerminalObjectIndexById(t,s){let l=null;return t.some((u,r)=>u._id===s?(l=r,!0):!1),l}getEnvironmentVariableCollection(t){let s=this._environmentVariableCollections.get(t.identifier.value);return s||(s=new n,this._setEnvironmentVariableCollection(t.identifier.value,s)),s}_syncEnvironmentVariableCollection(t,s){const l=v.serializeEnvironmentVariableCollection(s.map);this._proxy.$setEnvironmentVariableCollection(t,s.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(t){t.forEach(s=>{const l=s[0],u=new n(s[1]);this._setEnvironmentVariableCollection(l,u)})}_setEnvironmentVariableCollection(t,s){this._environmentVariableCollections.set(t,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,s)})}};c=He([Be(1,E.IExtHostRpcService)],c),e.BaseExtHostTerminalService=c;class n{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new b.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,s){this._setIfDiffers(t,{value:s,type:i.EnvironmentVariableMutatorType.Replace})}append(t,s){this._setIfDiffers(t,{value:s,type:i.EnvironmentVariableMutatorType.Append})}prepend(t,s){this._setIfDiffers(t,{value:s,type:i.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,s){const l=this.map.get(t);(!l||l.value!==s.value||l.type!==s.type)&&(this.map.set(t,s),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,s){this.map.forEach((l,u)=>t.call(s,u,l,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=n;let o=class extends c{constructor(t){super(!1,t)}createTerminal(t,s,l){throw new S.NotSupportedError}createTerminalFromOptions(t){throw new S.NotSupportedError}getDefaultShell(t,s){return""}getDefaultShellArgs(t,s){throw new S.NotSupportedError}$spawnExtHostProcess(t,s,l,u,r,g){throw new S.NotSupportedError}$getAvailableShells(){throw new S.NotSupportedError}async $getDefaultShellAndArgs(t){throw new S.NotSupportedError}$acceptWorkspacePermissionsChanged(t){}};o=He([Be(0,E.IExtHostRpcService)],o),e.WorkerExtHostTerminalService=o}),define(ve[197],_e([0,1,3,11,5,94,14,7]),function(se,e,b,y,A,T,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class I{constructor(P,S){this._extHostDocumentsAndEditors=S,this._onDidChangeTextEditorSelection=new b.Emitter,this._onDidChangeTextEditorOptions=new b.Emitter,this._onDidChangeTextEditorVisibleRanges=new b.Emitter,this._onDidChangeTextEditorViewColumn=new b.Emitter,this._onDidChangeActiveTextEditor=new b.Emitter,this._onDidChangeVisibleTextEditors=new b.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=P.getProxy(A.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(v=>this._onDidChangeVisibleTextEditors.fire(v)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(v=>this._onDidChangeActiveTextEditor.fire(v))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(){return this._extHostDocumentsAndEditors.allEditors()}async showTextDocument(P,S,v){let d;typeof S=="number"?d={position:E.ViewColumn.from(S),preserveFocus:v}:typeof S=="object"?d={position:E.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?E.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:d={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(P.uri,d),m=a&&this._extHostDocumentsAndEditors.getEditor(a);if(m)return m;throw a?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}createTextEditorDecorationType(P){return new T.TextEditorDecorationType(this._proxy,P)}$acceptEditorPropertiesChanged(P,S){const v=this._extHostDocumentsAndEditors.getEditor(P);if(!v)throw new Error("unknown text editor");if(S.options&&v._acceptOptions(S.options),S.selections){const d=S.selections.selections.map(E.Selection.to);v._acceptSelections(d)}if(S.visibleRanges){const d=y.coalesce(S.visibleRanges.map(E.Range.to));v._acceptVisibleRanges(d)}if(S.options&&this._onDidChangeTextEditorOptions.fire({textEditor:v,options:Object.assign(Object.assign({},S.options),{lineNumbers:E.TextEditorLineNumbersStyle.to(S.options.lineNumbers)})}),S.selections){const d=k.TextEditorSelectionChangeKind.fromValue(S.selections.source),a=S.selections.selections.map(E.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:v,selections:a,kind:d})}if(S.visibleRanges){const d=y.coalesce(S.visibleRanges.map(E.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:v,visibleRanges:d})}}$acceptEditorPositionData(P){for(const S in P){const v=this._extHostDocumentsAndEditors.getEditor(S);if(!v)throw new Error("Unknown text editor");const d=E.ViewColumn.to(P[S]);v.viewColumn!==d&&(v._acceptViewColumn(d),this._onDidChangeTextEditorViewColumn.fire({textEditor:v,viewColumn:d}))}}getDiffInformation(P){return Promise.resolve(this._proxy.$getDiffInformation(P))}}e.ExtHostEditors=I});var ai=this&&this.__rest||function(se,e){var b={};for(var y in se)Object.prototype.hasOwnProperty.call(se,y)&&e.indexOf(y)<0&&(b[y]=se[y]);if(se!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,y=Object.getOwnPropertySymbols(se);A<y.length;A++)e.indexOf(y[A])<0&&Object.prototype.propertyIsEnumerable.call(se,y[A])&&(b[y[A]]=se[y[A]]);return b};define(ve[198],_e([0,1,2,4,5,6,7]),function(se,e,b,y,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=y.createDecorator("IExtHostTimeline");class k{constructor(P,S){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=P.getProxy(A.MainContext.MainThreadTimeline),S.registerArgumentProcessor({processArgument:v=>{var d,a;if(v&&v.$mid===11){const m=v.uri===void 0?void 0:b.URI.revive(v.uri);return(a=(d=this._itemsBySourceAndUriMap.get(v.source))===null||d===void 0?void 0:d.get(I(m)))===null||a===void 0?void 0:a.get(v.handle)}return v}})}async $getTimeline(P,S,v,d,a){const m=this._providers.get(P);return m==null?void 0:m.provideTimeline(b.URI.revive(S),v,d,a)}registerTimelineProvider(P,S,v,d){const a=new T.DisposableStore,m=this.convertTimelineItem(S.id,d,a).bind(this);let p;S.onDidChange&&(p=S.onDidChange(c=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},c),{id:S.id})),this));const f=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},S),{scheme:P,onDidChange:void 0,async provideTimeline(c,n,o,h){var t;(h==null?void 0:h.resetCache)&&(a.clear(),(t=f.get(S.id))===null||t===void 0||t.clear());const s=await S.provideTimeline(c,n,o);if(s!=null){const l=m(c,h);return Object.assign(Object.assign({},s),{source:S.id,items:s.items.map(l)})}},dispose(){var c;for(const n of f.values())(c=n.get(S.id))===null||c===void 0||c.clear();p==null||p.dispose(),a.dispose()}}))}convertTimelineItem(P,S,v){return(d,a)=>{let m;if(a==null?void 0:a.cacheResults){let p=this._itemsBySourceAndUriMap.get(P);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(P,p));const f=I(d);m=p.get(f),m===void 0&&(m=new Map,p.set(f,m))}return p=>{var f,c;const{iconPath:n}=p,o=ai(p,["iconPath"]),h=`${P}|${(f=p.id)!==null&&f!==void 0?f:p.timestamp}`;m==null||m.set(h,p);let t,s,l;return p.iconPath&&(n instanceof E.ThemeIcon?l={id:n.id}:b.URI.isUri(n)?(t=n,s=n):{light:t,dark:s}=n),Object.assign(Object.assign({},o),{id:(c=o.id)!==null&&c!==void 0?c:void 0,handle:h,source:P,command:p.command?S.toInternal(p.command,v):void 0,icon:t,iconDark:s,themeIcon:l,accessibilityInformation:p.accessibilityInformation})}}}registerTimelineProviderCore(P){if(this._providers.get(P.id))throw new Error(`Timeline Provider ${P.id} already exists.`);return this._proxy.$registerTimelineProvider({id:P.id,label:P.label,scheme:P.scheme}),this._providers.set(P.id,P),T.toDisposable(()=>{var v;for(const d of this._itemsBySourceAndUriMap.values())(v=d.get(P.id))===null||v===void 0||v.clear();this._providers.delete(P.id),this._proxy.$unregisterTimelineProvider(P.id),P.dispose()})}}e.ExtHostTimeline=k;function I(i){return i==null?void 0:i.toString()}}),define(ve[199],_e([0,1,6,16,2,5]),function(se,e,b,y,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class E{constructor(I){this._openers=new Map,this._proxy=I.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(I,i,P,S){if(this._openers.has(i))throw new Error(`Opener with id '${i}' already registered`);const v=S.schemes.find(d=>!E.supportedSchemes.has(d));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this._openers.set(i,P),this._proxy.$registerUriOpener(i,S.schemes,I,S.label),b.toDisposable(()=>{this._openers.delete(i),this._proxy.$unregisterUriOpener(i)})}async $canOpenUri(I,i,P){const S=this._openers.get(I);if(!S)throw new Error(`Unknown opener with id: ${I}`);const v=A.URI.revive(i);return S.canOpenExternalUri(v,P)}async $openUri(I,i,P){const S=this._openers.get(I);if(!S)throw new Error(`Unknown opener id: '${I}'`);return S.openExternalUri(A.URI.revive(i.resolvedUri),{sourceUri:A.URI.revive(i.sourceUri)},P)}}e.ExtHostUriOpeners=E,E.supportedSchemes=new Set([y.Schemas.http,y.Schemas.https])}),define(ve[200],_e([0,1,5,2,6,9,25]),function(se,e,b,y,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(i){this.handles=new Set,this.handlers=new Map,this._proxy=i.getProxy(b.MainContext.MainThreadUrls)}registerUriHandler(i,P){if(this.handles.has(E.ExtensionIdentifier.toKey(i)))throw new Error(`Protocol handler already registered for extension ${i}`);const S=k.HandlePool++;return this.handles.add(E.ExtensionIdentifier.toKey(i)),this.handlers.set(S,P),this._proxy.$registerUriHandler(S,i),A.toDisposable(()=>{this.handles.delete(E.ExtensionIdentifier.toKey(i)),this.handlers.delete(S),this._proxy.$unregisterUriHandler(S)})}$handleExternalUri(i,P){const S=this.handlers.get(i);if(!S)return Promise.resolve(void 0);try{S.handleUri(y.URI.revive(P))}catch(v){T.onUnexpectedError(v)}return Promise.resolve(void 0)}async createAppUri(i){return y.URI.revive(await this._proxy.$createAppUri(i))}}e.ExtHostUrls=k,k.HandlePool=0});var Xe=this&&this.__classPrivateFieldSet||function(se,e,b){if(!e.has(se))throw new TypeError("attempted to set private field on non-instance");return e.set(se,b),b},Ue=this&&this.__classPrivateFieldGet||function(se,e){if(!e.has(se))throw new TypeError("attempted to get private field on non-instance");return e.get(se)};define(ve[49],_e([0,1,3,2,71,5]),function(se,e,b,y,A,T){"use strict";var E,k,I,i,P,S,v,d,a,m,p;Object.defineProperty(e,"__esModule",{value:!0}),e.convertWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.ExtHostWebview=void 0;class f{constructor(l,u,r,g,C,_,D){E.set(this,void 0),k.set(this,void 0),I.set(this,void 0),i.set(this,void 0),P.set(this,void 0),S.set(this,void 0),v.set(this,""),d.set(this,void 0),a.set(this,!1),m.set(this,!1),this._onMessageEmitter=new b.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,p.set(this,new b.Emitter),this._onDidDispose=Ue(this,p).event,Xe(this,E,l),Xe(this,k,u),Xe(this,d,r),Xe(this,i,g),Xe(this,P,C),Xe(this,S,_),Xe(this,I,D)}dispose(){Xe(this,a,!0),Ue(this,p).fire(),Ue(this,p).dispose(),this._onMessageEmitter.dispose()}asWebviewUri(l){return Xe(this,m,!0),A.asWebviewUri(Ue(this,i),Ue(this,E),l)}get cspSource(){return Ue(this,i).webviewCspSource.replace("{{uuid}}",Ue(this,E))}get html(){return this.assertNotDisposed(),Ue(this,v)}set html(l){this.assertNotDisposed(),Ue(this,v)!==l&&(Xe(this,v,l),!Ue(this,m)&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(l)&&(Xe(this,m,!0),Ue(this,I).report("Webview vscode-resource: uris",Ue(this,S),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,k).$setHtml(Ue(this,E),l))}get options(){return this.assertNotDisposed(),Ue(this,d)}set options(l){this.assertNotDisposed(),Ue(this,k).$setOptions(Ue(this,E),o(Ue(this,S),Ue(this,P),l)),Xe(this,d,l)}async postMessage(l){return Ue(this,a)?!1:Ue(this,k).$postMessage(Ue(this,E),l)}assertNotDisposed(){if(Ue(this,a))throw new Error("Webview is disposed")}}e.ExtHostWebview=f,E=new WeakMap,k=new WeakMap,I=new WeakMap,i=new WeakMap,P=new WeakMap,S=new WeakMap,v=new WeakMap,d=new WeakMap,a=new WeakMap,m=new WeakMap,p=new WeakMap;class c{constructor(l,u,r,g,C){this.initData=u,this.workspace=r,this._logService=g,this._deprecationService=C,this._webviews=new Map,this._webviewProxy=l.getProxy(T.MainContext.MainThreadWebviews)}$onMessage(l,u){const r=this.getWebview(l);r&&r._onMessageEmitter.fire(u)}$onMissingCsp(l,u){this._logService.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(l,u,r){const g=new f(l,this._webviewProxy,h(u),this.initData,this.workspace,r,this._deprecationService);return this._webviews.set(l,g),g._onDidDispose(()=>{this._webviews.delete(l)}),g}deleteWebview(l){this._webviews.delete(l)}getWebview(l){return this._webviews.get(l)}}e.ExtHostWebviews=c;function n(s){return{id:s.identifier,location:s.extensionLocation}}e.toExtensionData=n;function o(s,l,u){return Object.assign(Object.assign({},u),{localResourceRoots:u.localResourceRoots||t(s,l)})}e.convertWebviewOptions=o;function h(s){var l;return Object.assign(Object.assign({},s),{localResourceRoots:(l=s.localResourceRoots)===null||l===void 0?void 0:l.map(u=>y.URI.from(u))})}function t(s,l){return[...((l==null?void 0:l.getWorkspaceFolders())||[]).map(u=>u.uri),s.extensionLocation]}}),define(ve[201],_e([0,1,20,56,6,16,23,2,14,49,68,5,7]),function(se,e,b,y,A,T,E,k,I,i,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class d{constructor(t,s){this.document=t,this._storagePath=s,this._backupCounter=1,this._edits=new P.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,s){await this.getEdit(t).undo(),s||this.disposeBackup()}async redo(t,s){await this.getEdit(t).redo(),s||this.disposeBackup()}disposeEdits(t){for(const s of t)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=o(this.document.uri)+this._backupCounter++;return E.joinPath(this._storagePath,t)}updateBackup(t){var s;(s=this._backup)===null||s===void 0||s.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const s=this._edits.get(t,0);if(!s)throw new Error("No edit found");return s}}class a{constructor(){this._documents=new Map}get(t,s){return this._documents.get(this.key(t,s))}add(t,s,l){const u=this.key(t,s.uri);if(this._documents.has(u))throw new Error(`Document already exists for viewType:${t} resource:${s.uri}`);const r=new d(s,l);return this._documents.set(u,r),r}delete(t,s){const l=this.key(t,s.uri);this._documents.delete(l)}key(t,s){return`${t}@@@${s}`}}var m;(function(h){h[h.Text=0]="Text",h[h.Custom=1]="Custom"})(m||(m={}));class p{constructor(){this._providers=new Map}addTextProvider(t,s,l){return this.add(0,t,s,l)}addCustomProvider(t,s,l){return this.add(1,t,s,l)}get(t){return this._providers.get(t)}add(t,s,l,u){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:t,extension:l,provider:u}),new v.Disposable(()=>this._providers.delete(s))}}class f{constructor(t,s,l,u,r){this._extHostDocuments=s,this._extensionStoragePaths=l,this._extHostWebview=u,this._extHostWebviewPanels=r,this._editorProviders=new p,this._documents=new a,this._proxy=t.getProxy(S.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,s,l,u){const r=new A.DisposableStore;return c(l)?(r.add(this._editorProviders.addTextProvider(s,t,l)),this._proxy.$registerTextEditorProvider(i.toExtensionData(t),s,u.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor})):(r.add(this._editorProviders.addCustomProvider(s,t,l)),this.supportEditing(l)&&r.add(l.onDidChangeCustomDocument(g=>{const C=this.getCustomDocumentEntry(s,g.document.uri);if(n(g)){const _=C.addEdit(g);this._proxy.$onDidEdit(g.document.uri,s,_,g.label)}else this._proxy.$onContentChange(g.document.uri,s)})),this._proxy.$registerCustomEditorProvider(i.toExtensionData(t),s,u.webviewOptions||{},!!u.supportsMultipleEditorsPerDocument)),v.Disposable.from(r,new v.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(t,s,l,u){var r;const g=this._editorProviders.get(s);if(!g)throw new Error(`No provider found for '${s}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${s}'`);const C=k.URI.revive(t),_=await g.provider.openCustomDocument(C,{backupId:l},u);let D;return this.supportEditing(g.provider)&&this._extensionStoragePaths&&(D=(r=this._extensionStoragePaths.workspaceValue(g.extension))!==null&&r!==void 0?r:this._extensionStoragePaths.globalValue(g.extension)),this._documents.add(s,_,D),{editable:this.supportEditing(g.provider)}}async $disposeCustomDocument(t,s){const l=this._editorProviders.get(s);if(!l)throw new Error(`No provider found for '${s}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${s}'`);const u=k.URI.revive(t),{document:r}=this.getCustomDocumentEntry(s,u);this._documents.delete(s,r),r.dispose()}async $resolveWebviewEditor(t,s,l,u,r,g,C){const _=this._editorProviders.get(l);if(!_)throw new Error(`No provider found for '${l}'`);const D=I.ViewColumn.to(r),w=this._extHostWebview.createNewWebview(s,g,_.extension),O=this._extHostWebviewPanels.createNewWebviewPanel(s,l,u,D,g,w),R=k.URI.revive(t);switch(_.type){case 1:{const{document:$}=this.getCustomDocumentEntry(l,R);return _.provider.resolveCustomEditor($,O,C)}case 0:{const $=this._extHostDocuments.getDocument(R);return _.provider.resolveCustomTextEditor($,O,C)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,s,l){this.getCustomDocumentEntry(s,t).disposeEdits(l)}async $onMoveCustomEditor(t,s,l){const u=this._editorProviders.get(l);if(!u)throw new Error(`No provider found for '${l}'`);if(!u.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const r=this._extHostWebviewPanels.getWebviewPanel(t);if(!r)throw new Error("No webview found");const g=k.URI.revive(s),C=this._extHostDocuments.getDocument(g);await u.provider.moveCustomTextEditor(C,r,b.CancellationToken.None)}async $undo(t,s,l,u){return this.getCustomDocumentEntry(s,t).undo(l,u)}async $redo(t,s,l,u){return this.getCustomDocumentEntry(s,t).redo(l,u)}async $revert(t,s,l){const u=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).revertCustomDocument(u.document,l),u.disposeBackup()}async $onSave(t,s,l){const u=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).saveCustomDocument(u.document,l),u.disposeBackup()}async $onSaveAs(t,s,l,u){const r=this.getCustomDocumentEntry(s,t);return this.getCustomEditorProvider(s).saveCustomDocumentAs(r.document,k.URI.revive(l),u)}async $backup(t,s,l){const u=this.getCustomDocumentEntry(s,t),g=await this.getCustomEditorProvider(s).backupCustomDocument(u.document,{destination:u.getNewBackupUri()},l);return u.updateBackup(g),g.id}getCustomDocumentEntry(t,s){const l=this._documents.get(t,k.URI.revive(s));if(!l)throw new Error("No custom document found");return l}getCustomEditorProvider(t){const s=this._editorProviders.get(t),l=s==null?void 0:s.provider;if(!l||!this.supportEditing(l))throw new Error("Custom document is not editable");return l}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=f;function c(h){return typeof h.resolveCustomTextEditor=="function"}function n(h){return typeof h.undo=="function"&&typeof h.redo=="function"}function o(h){const t=h.scheme===T.Schemas.file||h.scheme===T.Schemas.untitled?h.fsPath:h.toString();return y.hash(t)+""}});var Xe=this&&this.__classPrivateFieldSet||function(se,e,b){if(!e.has(se))throw new TypeError("attempted to set private field on non-instance");return e.set(se,b),b},Ue=this&&this.__classPrivateFieldGet||function(se,e){if(!e.has(se))throw new TypeError("attempted to get private field on non-instance");return e.get(se)};define(ve[202],_e([0,1,3,6,2,26,14,49,5,7]),function(se,e,b,y,A,T,E,k,I,i){"use strict";var P,S,v,d,a,m,p,f,c,n,o,h,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends y.Disposable{constructor(r,g,C,_,D,w,O){super();P.set(this,void 0),S.set(this,void 0),v.set(this,void 0),d.set(this,void 0),a.set(this,void 0),m.set(this,void 0),p.set(this,void 0),f.set(this,void 0),c.set(this,!0),n.set(this,!0),o.set(this,!1),h.set(this,this._register(new b.Emitter)),this.onDidDispose=Ue(this,h).event,t.set(this,this._register(new b.Emitter)),this.onDidChangeViewState=Ue(this,t).event,Xe(this,P,r),Xe(this,S,g),Xe(this,v,C),Xe(this,a,w),Xe(this,f,D),Xe(this,m,_),Xe(this,d,O)}dispose(){Ue(this,o)||(Xe(this,o,!0),Ue(this,h).fire(),Ue(this,S).$disposeWebview(Ue(this,P)),Ue(this,d).dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,d)}get viewType(){return this.assertNotDisposed(),Ue(this,v)}get title(){return this.assertNotDisposed(),Ue(this,m)}set title(r){this.assertNotDisposed(),Ue(this,m)!==r&&(Xe(this,m,r),Ue(this,S).$setTitle(Ue(this,P),r))}get iconPath(){return this.assertNotDisposed(),Ue(this,p)}set iconPath(r){this.assertNotDisposed(),Ue(this,p)!==r&&(Xe(this,p,r),Ue(this,S).$setIconPath(Ue(this,P),A.URI.isUri(r)?{light:r,dark:r}:r))}get options(){return Ue(this,a)}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,f)=="number"&&Ue(this,f)<0))return Ue(this,f)}get active(){return this.assertNotDisposed(),Ue(this,n)}get visible(){return this.assertNotDisposed(),Ue(this,c)}_updateViewState(r){Ue(this,o)||(this.active!==r.active||this.visible!==r.visible||this.viewColumn!==r.viewColumn)&&(Xe(this,n,r.active),Xe(this,c,r.visible),Xe(this,f,r.viewColumn),Ue(this,t).fire({webviewPanel:this}))}reveal(r,g){this.assertNotDisposed(),Ue(this,S).$reveal(Ue(this,P),{viewColumn:r?E.ViewColumn.from(r):void 0,preserveFocus:!!g})}assertNotDisposed(){if(Ue(this,o))throw new Error("Webview is disposed")}}P=new WeakMap,S=new WeakMap,v=new WeakMap,d=new WeakMap,a=new WeakMap,m=new WeakMap,p=new WeakMap,f=new WeakMap,c=new WeakMap,n=new WeakMap,o=new WeakMap,h=new WeakMap,t=new WeakMap;class l{constructor(r,g,C){this.webviews=g,this.workspace=C,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=r.getProxy(I.MainContext.MainThreadWebviewPanels)}static newHandle(){return T.generateUuid()}createWebviewPanel(r,g,C,_,D={}){const w=typeof _=="object"?_.viewColumn:_,O={viewColumn:E.ViewColumn.from(w),preserveFocus:typeof _=="object"&&!!_.preserveFocus},R=l.newHandle();this._proxy.$createWebviewPanel(k.toExtensionData(r),R,g,C,O,k.convertWebviewOptions(r,this.workspace,D));const $=this.webviews.createNewWebview(R,D,r);return this.createNewWebviewPanel(R,g,C,w,D,$)}$onDidChangeWebviewPanelViewStates(r){const g=Object.keys(r);g.sort((C,_)=>{const D=r[C],w=r[_];return D.active?1:w.active?-1:+D.visible-+w.visible});for(const C of g){const _=this.getWebviewPanel(C);if(!!_){const D=r[C];_._updateViewState({active:D.active,visible:D.visible,viewColumn:E.ViewColumn.to(D.position)})}}}async $onDidDisposeWebviewPanel(r){const g=this.getWebviewPanel(r);g==null||g.dispose(),this._webviewPanels.delete(r),this.webviews.deleteWebview(r)}registerWebviewPanelSerializer(r,g,C){if(this._serializers.has(g))throw new Error(`Serializer for '${g}' already registered`);return this._serializers.set(g,{serializer:C,extension:r}),this._proxy.$registerSerializer(g),new i.Disposable(()=>{this._serializers.delete(g),this._proxy.$unregisterSerializer(g)})}async $deserializeWebviewPanel(r,g,C,_,D,w){const O=this._serializers.get(g);if(!O)throw new Error(`No serializer found for '${g}'`);const{serializer:R,extension:$}=O,V=this.webviews.createNewWebview(r,w,$),z=this.createNewWebviewPanel(r,g,C,D,w,V);await R.deserializeWebviewPanel(z,_)}createNewWebviewPanel(r,g,C,_,D,w){const O=new s(r,this._proxy,g,C,_,D,w);return this._webviewPanels.set(r,O),O}getWebviewPanel(r){return this._webviewPanels.get(r)}}e.ExtHostWebviewPanels=l});var Xe=this&&this.__classPrivateFieldSet||function(se,e,b){if(!e.has(se))throw new TypeError("attempted to set private field on non-instance");return e.set(se,b),b},Ue=this&&this.__classPrivateFieldGet||function(se,e){if(!e.has(se))throw new TypeError("attempted to get private field on non-instance");return e.get(se)};define(ve[203],_e([0,1,3,6,49,5,7]),function(se,e,b,y,A,T,E){"use strict";var k,I,i,P,S,v,d,a,m,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class f extends y.Disposable{constructor(o,h,t,s,l,u){super();k.set(this,void 0),I.set(this,void 0),i.set(this,void 0),P.set(this,void 0),S.set(this,!1),v.set(this,void 0),d.set(this,void 0),a.set(this,void 0),m.set(this,this._register(new b.Emitter)),this.onDidChangeVisibility=Ue(this,m).event,p.set(this,this._register(new b.Emitter)),this.onDidDispose=Ue(this,p).event,Xe(this,i,t),Xe(this,d,s),Xe(this,k,o),Xe(this,I,h),Xe(this,P,l),Xe(this,v,u)}dispose(){Ue(this,S)||(Xe(this,S,!0),Ue(this,p).fire(),Ue(this,P).dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,d)}set title(o){this.assertNotDisposed(),Ue(this,d)!==o&&(Xe(this,d,o),Ue(this,I).$setWebviewViewTitle(Ue(this,k),o))}get description(){return this.assertNotDisposed(),Ue(this,a)}set description(o){this.assertNotDisposed(),Ue(this,a)!==o&&(Xe(this,a,o),Ue(this,I).$setWebviewViewDescription(Ue(this,k),o))}get visible(){return Ue(this,v)}get webview(){return Ue(this,P)}get viewType(){return Ue(this,i)}_setVisible(o){o===Ue(this,v)||Ue(this,S)||(Xe(this,v,o),Ue(this,m).fire())}show(o){this.assertNotDisposed(),Ue(this,I).$show(Ue(this,k),!!o)}assertNotDisposed(){if(Ue(this,S))throw new Error("Webview is disposed")}}k=new WeakMap,I=new WeakMap,i=new WeakMap,P=new WeakMap,S=new WeakMap,v=new WeakMap,d=new WeakMap,a=new WeakMap,m=new WeakMap,p=new WeakMap;class c{constructor(o,h){this._extHostWebview=h,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=o.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(o,h,t,s){if(this._viewProviders.has(h))throw new Error(`View provider for '${h}' already registered`);return this._viewProviders.set(h,{provider:t,extension:o}),this._proxy.$registerWebviewViewProvider(A.toExtensionData(o),h,s),new E.Disposable(()=>{this._viewProviders.delete(h),this._proxy.$unregisterWebviewViewProvider(h)})}async $resolveWebviewView(o,h,t,s,l){const u=this._viewProviders.get(h);if(!u)throw new Error(`No view provider found for '${h}'`);const{provider:r,extension:g}=u,C=this._extHostWebview.createNewWebview(o,{},g),_=new f(o,this._proxy,h,t,C,!0);this._webviewViews.set(o,_),await r.resolveWebviewView(_,{state:s},l)}async $onDidChangeWebviewViewVisibility(o,h){this.getWebviewView(o)._setVisible(h)}async $disposeWebviewView(o){const h=this.getWebviewView(o);this._webviewViews.delete(o),h.dispose(),this._extHostWebview.deleteWebview(o)}getWebviewView(o){const h=this._webviewViews.get(o);if(!h)throw new Error("No webview found");return h}}e.ExtHostWebviewViews=c}),define(ve[98],_e([0,1,3,5,2,16,8,4,13]),function(se,e,b,y,A,T,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let i=class _i{constructor(S){this._onDidChangeWindowState=new b.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=_i.InitialState,this._proxy=S.getProxy(y.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(v=>this.$onDidChangeWindowFocus(v))}get state(){return this._state}$onDidChangeWindowFocus(S){S!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:S}),this._onDidChangeWindowState.fire(this._state))}openUri(S,v){let d;if(typeof S=="string"){d=S;try{S=A.URI.parse(S)}catch(a){return Promise.reject(`Invalid uri - '${S}'`)}}return E.isFalsyOrWhitespace(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this._proxy.$openUri(S,d,v)}async asExternalUri(S,v){if(E.isFalsyOrWhitespace(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([T.Schemas.http,T.Schemas.https]).has(S.scheme))return Promise.reject(`Invalid scheme '${S.scheme}'`);const d=await this._proxy.$asExternalUri(S,v);return A.URI.from(d)}};i.InitialState={focused:!0},i=He([Be(0,I.IExtHostRpcService)],i),e.ExtHostWindow=i,e.IExtHostWindow=k.createDecorator("IExtHostWindow")}),define(ve[204],_e([0,1,17,5,28,13]),function(se,e,b,y,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let E=class extends b.AbstractLogService{constructor(I,i){super();this._proxy=I.getProxy(y.MainContext.MainThreadLog),this._logFile=i.logFile.toJSON(),this.setLevel(i.logLevel)}$setLevel(I){this.setLevel(I)}trace(I,...i){this.getLevel()<=b.LogLevel.Trace&&this._proxy.$log(this._logFile,b.LogLevel.Trace,Array.from(arguments))}debug(I,...i){this.getLevel()<=b.LogLevel.Debug&&this._proxy.$log(this._logFile,b.LogLevel.Debug,Array.from(arguments))}info(I,...i){this.getLevel()<=b.LogLevel.Info&&this._proxy.$log(this._logFile,b.LogLevel.Info,Array.from(arguments))}warn(I,...i){this.getLevel()<=b.LogLevel.Warning&&this._proxy.$log(this._logFile,b.LogLevel.Warning,Array.from(arguments))}error(I,...i){this.getLevel()<=b.LogLevel.Error&&this._proxy.$log(this._logFile,b.LogLevel.Error,Array.from(arguments))}critical(I,...i){this.getLevel()<=b.LogLevel.Critical&&this._proxy.$log(this._logFile,b.LogLevel.Critical,Array.from(arguments))}flush(){}};E=He([Be(0,T.IExtHostRpcService),Be(1,A.IExtHostInitDataService)],E),e.ExtHostLogService=E}),define(ve[205],_e([0,1,15,20,9,3,6,108,178,95,27]),function(se,e,b,y,A,T,E,k,I,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function S(t,s){try{return JSON.stringify(t,s)}catch(l){return"null"}}function v(t,s){return JSON.stringify(t,s)}function d(t){return t?(s,l)=>l&&l.$mid===1?t.transformOutgoing(l):l:null}var a;(function(t){t[t.LocalSide=0]="LocalSide",t[t.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(t){t[t.Responsive=0]="Responsive",t[t.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const p=()=>{};class f extends E.Disposable{constructor(s,l=null,u=null){super();this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=s,this._logger=l,this._uriTransformer=u,this._uriReplacer=d(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let r=0,g=i.ProxyIdentifier.count;r<g;r++)this._locals[r]=null,this._proxies[r]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new b.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(r=>this._receiveOneMessage(r))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(s=>{this._pendingRPCReplies[s].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(s){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(s){this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(s){this._responsiveState!==s&&(this._responsiveState=s,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(s){return this._uriTransformer?k.transformIncomingURIs(s,this._uriTransformer):s}getProxy(s){const l=s.nid;return this._proxies[l]||(this._proxies[l]=this._createProxy(l)),this._proxies[l]}_createProxy(s){let l={get:(u,r)=>(typeof r=="string"&&!u[r]&&r.charCodeAt(0)===36&&(u[r]=(...g)=>this._remoteCall(s,r,g)),u[r])};return new Proxy(Object.create(null),l)}set(s,l){return this._locals[s.nid]=l,l}assertRegistered(s){for(let l=0,u=s.length;l<u;l++){const r=s[l];if(!this._locals[r.nid])throw new Error(`Missing actor ${r.sid} (isMain: ${r.isMain})`)}}_receiveOneMessage(s){if(!this._isDisposed){const l=s.byteLength,u=c.read(s,0),r=u.readUInt8(),g=u.readUInt32();switch(r){case 1:case 2:{let{rpcId:C,method:_,args:D}=n.deserializeRequestJSONArgs(u);this._uriTransformer&&(D=k.transformIncomingURIs(D,this._uriTransformer)),this._receiveRequest(l,g,C,_,D,r===2);break}case 3:case 4:{let{rpcId:C,method:_,args:D}=n.deserializeRequestMixedArgs(u);this._uriTransformer&&(D=k.transformIncomingURIs(D,this._uriTransformer)),this._receiveRequest(l,g,C,_,D,r===4);break}case 5:{this._logger&&this._logger.logIncoming(l,g,0,"ack"),this._onDidReceiveAcknowledge(g);break}case 6:{this._receiveCancel(l,g);break}case 7:{this._receiveReply(l,g,void 0);break}case 9:{let C=n.deserializeReplyOKJSON(u);this._uriTransformer&&(C=k.transformIncomingURIs(C,this._uriTransformer)),this._receiveReply(l,g,C);break}case 8:{let C=n.deserializeReplyOKVSBuffer(u);this._receiveReply(l,g,C);break}case 10:{let C=n.deserializeReplyErrError(u);this._uriTransformer&&(C=k.transformIncomingURIs(C,this._uriTransformer)),this._receiveReplyErr(l,g,C);break}case 11:{this._receiveReplyErr(l,g,void 0);break}default:console.error("received unexpected message"),console.error(s)}}}_receiveRequest(s,l,u,r,g,C){this._logger&&this._logger.logIncoming(s,l,1,`receiveRequest ${i.getStringIdentifierForProxy(u)}.${r}(`,g);const _=String(l);let D,w;if(C){const R=new y.CancellationTokenSource;g.push(R.token),D=this._invokeHandler(u,r,g),w=()=>R.cancel()}else D=this._invokeHandler(u,r,g),w=p;this._cancelInvokedHandlers[_]=w;const O=n.serializeAcknowledged(l);this._logger&&this._logger.logOutgoing(O.byteLength,l,1,"ack"),this._protocol.send(O),D.then(R=>{delete this._cancelInvokedHandlers[_];const $=n.serializeReplyOK(l,R,this._uriReplacer);this._logger&&this._logger.logOutgoing($.byteLength,l,1,"reply:",R),this._protocol.send($)},R=>{delete this._cancelInvokedHandlers[_];const $=n.serializeReplyErr(l,R);this._logger&&this._logger.logOutgoing($.byteLength,l,1,"replyErr:",R),this._protocol.send($)})}_receiveCancel(s,l){this._logger&&this._logger.logIncoming(s,l,1,"receiveCancel");const u=String(l);this._cancelInvokedHandlers[u]&&this._cancelInvokedHandlers[u]()}_receiveReply(s,l,u){this._logger&&this._logger.logIncoming(s,l,0,"receiveReply:",u);const r=String(l);if(!!this._pendingRPCReplies.hasOwnProperty(r)){const g=this._pendingRPCReplies[r];delete this._pendingRPCReplies[r],g.resolveOk(u)}}_receiveReplyErr(s,l,u){this._logger&&this._logger.logIncoming(s,l,0,"receiveReplyErr:",u);const r=String(l);if(!!this._pendingRPCReplies.hasOwnProperty(r)){const g=this._pendingRPCReplies[r];delete this._pendingRPCReplies[r];let C;u&&(u.$isError?(C=new Error,C.name=u.name,C.message=u.message,C.stack=u.stack):C=u),g.resolveErr(C)}}_invokeHandler(s,l,u){try{return Promise.resolve(this._doInvokeHandler(s,l,u))}catch(r){return Promise.reject(r)}}_doInvokeHandler(s,l,u){const r=this._locals[s];if(!r)throw new Error("Unknown actor "+i.getStringIdentifierForProxy(s));let g=r[l];if(typeof g!="function")throw new Error("Unknown method "+l+" on actor "+i.getStringIdentifierForProxy(s));return g.apply(r,u)}_remoteCall(s,l,u){if(this._isDisposed)return Promise.reject(A.canceled());let r=null;if(u.length>0&&y.CancellationToken.isCancellationToken(u[u.length-1])&&(r=u.pop()),r&&r.isCancellationRequested)return Promise.reject(A.canceled());const g=n.serializeRequestArguments(u,this._uriReplacer),C=++this._lastMessageId,_=String(C),D=new I.LazyPromise;r&&r.onCancellationRequested(()=>{const O=n.serializeCancel(C);this._logger&&this._logger.logOutgoing(O.byteLength,C,0,"cancel"),this._protocol.send(n.serializeCancel(C))}),this._pendingRPCReplies[_]=D,this._onWillSendRequest(C);const w=n.serializeRequest(C,s,l,g,!!r);return this._logger&&this._logger.logOutgoing(w.byteLength,C,0,`request: ${i.getStringIdentifierForProxy(s)}.${l}(`,u),this._protocol.send(w),D}}e.RPCProtocol=f,f.UNRESPONSIVE_TIME=3*1e3;class c{constructor(s,l){this._buff=s,this._offset=l}static alloc(s,l,u){let r=new c(P.VSBuffer.alloc(u+1+4),0);return r.writeUInt8(s),r.writeUInt32(l),r}static read(s,l){return new c(s,l)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(s){this._buff.writeUInt8(s,this._offset),this._offset+=1}readUInt8(){const s=this._buff.readUInt8(this._offset);return this._offset+=1,s}writeUInt32(s){this._buff.writeUInt32BE(s,this._offset),this._offset+=4}readUInt32(){const s=this._buff.readUInt32BE(this._offset);return this._offset+=4,s}static sizeShortString(s){return 1+s.byteLength}writeShortString(s){this._buff.writeUInt8(s.byteLength,this._offset),this._offset+=1,this._buff.set(s,this._offset),this._offset+=s.byteLength}readShortString(){const s=this._buff.readUInt8(this._offset);this._offset+=1;const u=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,u}static sizeLongString(s){return 4+s.byteLength}writeLongString(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readLongString(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const u=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,u}writeBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}static sizeVSBuffer(s){return 4+s.byteLength}writeVSBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readVSBuffer(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const l=this._buff.slice(this._offset,this._offset+s);return this._offset+=s,l}static sizeMixedArray(s,l){let u=0;u+=1;for(let r=0,g=s.length;r<g;r++){const C=s[r],_=l[r];switch(u+=1,_){case 1:u+=this.sizeLongString(C);break;case 2:u+=this.sizeVSBuffer(C);break;case 3:break}}return u}writeMixedArray(s,l){this._buff.writeUInt8(s.length,this._offset),this._offset+=1;for(let u=0,r=s.length;u<r;u++){const g=s[u];switch(l[u]){case 1:this.writeUInt8(1),this.writeLongString(g);break;case 2:this.writeUInt8(2),this.writeVSBuffer(g);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const s=this._buff.readUInt8(this._offset);this._offset+=1;let l=new Array(s);for(let u=0;u<s;u++)switch(this.readUInt8()){case 1:l[u]=this.readLongString();break;case 2:l[u]=this.readVSBuffer();break;case 3:l[u]=void 0;break}return l}}class n{static _arrayContainsBufferOrUndefined(s){for(let l=0,u=s.length;l<u;l++)if(s[l]instanceof P.VSBuffer||typeof s[l]=="undefined")return!0;return!1}static serializeRequestArguments(s,l){if(this._arrayContainsBufferOrUndefined(s)){let u=[],r=[];for(let g=0,C=s.length;g<C;g++){const _=s[g];_ instanceof P.VSBuffer?(u[g]=_,r[g]=2):typeof _=="undefined"?(u[g]=P.VSBuffer.alloc(0),r[g]=3):(u[g]=P.VSBuffer.fromString(v(_,l)),r[g]=1)}return{type:"mixed",args:u,argsType:r}}return{type:"simple",args:v(s,l)}}static serializeRequest(s,l,u,r,g){return r.type==="mixed"?this._requestMixedArgs(s,l,u,r.args,r.argsType,g):this._requestJSONArgs(s,l,u,r.args,g)}static _requestJSONArgs(s,l,u,r,g){const C=P.VSBuffer.fromString(u),_=P.VSBuffer.fromString(r);let D=0;D+=c.sizeUInt8(),D+=c.sizeShortString(C),D+=c.sizeLongString(_);let w=c.alloc(g?2:1,s,D);return w.writeUInt8(l),w.writeShortString(C),w.writeLongString(_),w.buffer}static deserializeRequestJSONArgs(s){const l=s.readUInt8(),u=s.readShortString(),r=s.readLongString();return{rpcId:l,method:u,args:JSON.parse(r)}}static _requestMixedArgs(s,l,u,r,g,C){const _=P.VSBuffer.fromString(u);let D=0;D+=c.sizeUInt8(),D+=c.sizeShortString(_),D+=c.sizeMixedArray(r,g);let w=c.alloc(C?4:3,s,D);return w.writeUInt8(l),w.writeShortString(_),w.writeMixedArray(r,g),w.buffer}static deserializeRequestMixedArgs(s){const l=s.readUInt8(),u=s.readShortString(),r=s.readMixedArray(),g=new Array(r.length);for(let C=0,_=r.length;C<_;C++){const D=r[C];typeof D=="string"?g[C]=JSON.parse(D):g[C]=D}return{rpcId:l,method:u,args:g}}static serializeAcknowledged(s){return c.alloc(5,s,0).buffer}static serializeCancel(s){return c.alloc(6,s,0).buffer}static serializeReplyOK(s,l,u){return typeof l=="undefined"?this._serializeReplyOKEmpty(s):l instanceof P.VSBuffer?this._serializeReplyOKVSBuffer(s,l):this._serializeReplyOKJSON(s,S(l,u))}static _serializeReplyOKEmpty(s){return c.alloc(7,s,0).buffer}static _serializeReplyOKVSBuffer(s,l){let u=0;u+=c.sizeVSBuffer(l);let r=c.alloc(8,s,u);return r.writeVSBuffer(l),r.buffer}static deserializeReplyOKVSBuffer(s){return s.readVSBuffer()}static _serializeReplyOKJSON(s,l){const u=P.VSBuffer.fromString(l);let r=0;r+=c.sizeLongString(u);let g=c.alloc(9,s,r);return g.writeLongString(u),g.buffer}static deserializeReplyOKJSON(s){const l=s.readLongString();return JSON.parse(l)}static serializeReplyErr(s,l){return l?this._serializeReplyErrEror(s,l):this._serializeReplyErrEmpty(s)}static _serializeReplyErrEror(s,l){const u=P.VSBuffer.fromString(S(A.transformErrorForSerialization(l),null));let r=0;r+=c.sizeLongString(u);let g=c.alloc(10,s,r);return g.writeLongString(u),g.buffer}static deserializeReplyErrError(s){const l=s.readLongString();return JSON.parse(l)}static _serializeReplyErrEmpty(s){return c.alloc(11,s,0).buffer}}var o;(function(t){t[t.RequestJSONArgs=1]="RequestJSONArgs",t[t.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",t[t.RequestMixedArgs=3]="RequestMixedArgs",t[t.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",t[t.Acknowledged=5]="Acknowledged",t[t.Cancel=6]="Cancel",t[t.ReplyOKEmpty=7]="ReplyOKEmpty",t[t.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",t[t.ReplyOKJSON=9]="ReplyOKJSON",t[t.ReplyErrError=10]="ReplyErrError",t[t.ReplyErrEmpty=11]="ReplyErrEmpty"})(o||(o={}));var h;(function(t){t[t.String=1]="String",t[t.VSBuffer=2]="VSBuffer",t[t.Undefined=3]="Undefined"})(h||(h={}))}),define(ve[206],_e([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const b=function(T){const E=k=>{self.removeEventListener("message",E);const I=k.data;Object.defineProperties(self,{postMessage:{value(i,P){I.postMessage(i,P)}},onmessage:{get(){return I.onmessage},set(i){I.onmessage=i}}}),I.addEventListener("message",i=>{self.dispatchEvent(new MessageEvent("message",{data:i.data}))}),I.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",E)}.toString();class y extends EventTarget{constructor(T,E,k){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const I=`((${b})('${E}'))`,i=new Blob([I],{type:"application/javascript"}),P=URL.createObjectURL(i),S=new MessageChannel,v=P,d={type:"_newWorker",id:v,port:S.port2,url:P,options:k};T(d,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{const a={type:"_terminateWorker",id:v};S.port1.postMessage(a),URL.revokeObjectURL(P),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(a){S.port1.onmessage=a}},onmessageerror:{get(){return S.port1.onmessageerror},set(a){S.port1.onmessageerror=a}}}),S.port1.addEventListener("messageerror",a=>{const m=new MessageEvent("messageerror",{data:a.data});this.dispatchEvent(m)}),S.port1.addEventListener("message",a=>{const m=new MessageEvent("message",{data:a.data});this.dispatchEvent(m)}),S.port1.start()}}e.NestedWorker=y}),define(ve[207],_e([0,1,4]),function(se,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=b.createDecorator("remoteAgentService")}),define(ve[208],_e([0,1,16,10,21,2,4,207]),function(se,e,b,y,A,T,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=E.createDecorator("pathService");let I=class{constructor(P,S){this.localUserHome=P,this.remoteAgentService=S,this.resolveOS=(async()=>{const v=await this.remoteAgentService.getEnvironment();return(v==null?void 0:v.os)||A.OS})(),this.resolveUserHome=(async()=>{const v=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(v==null?void 0:v.userHome)||P})()}async userHome(P){return(P==null?void 0:P.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(P=>P===1?y.win32:y.posix)}async fileURI(P){let S="";if(await this.resolveOS===1&&(P=P.replace(/\\/g,"/")),P[0]==="/"&&P[1]==="/"){const d=P.indexOf("/",2);d===-1?(S=P.substring(2),P="/"):(S=P.substring(2,d),P=P.substring(d)||"/")}return T.URI.from({scheme:b.Schemas.file,authority:S,path:P,query:"",fragment:""})}};I=He([Be(1,k.IRemoteAgentService)],I),e.AbstractPathService=I}),define(ve[42],_e([0,1,11,29,24,38,8,4,10,9]),function(se,e,b,y,A,T,E,k,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",S=" characters skipped \u27EB",v=(P.length+S.length+5)*2;e.ISearchService=k.createDecorator("searchService");var d;(function(M){M[M.file=0]="file",M[M.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var a;(function(M){M[M.File=1]="File",M[M.Text=2]="Text"})(a=e.QueryType||(e.QueryType={}));function m(M){return!!M.preview}e.resultIsMatch=m;function p(M){return!!M.resource}e.isFileMatch=p;function f(M){return!!M.message}e.isProgressMessage=f;var c;(function(M){M[M.Normal=0]="Normal",M[M.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class n{constructor(j){this.resource=j,this.results=[]}}e.FileMatch=n;class o{constructor(j,re,F){this.ranges=re;const te=Array.isArray(re)?re:[re];if(F&&F.matchLines===1&&h(te)){j=E.getNLines(j,F.matchLines);let ae="",ue=0,we=0;const fe=Math.floor(F.charsPerLine/5),De=[];for(const Se of te){const Ce=Math.max(Se.startColumn-fe,0),x=Se.startColumn+F.charsPerLine;if(Ce>we+fe+v){const K=P+(Ce-we)+S;ae+=K+j.slice(Ce,x),ue+=Ce-(we+K.length)}else ae+=j.slice(we,x);De.push(new s(0,Se.startColumn-ue,Se.endColumn-ue)),we=x}this.preview={text:ae,matches:Array.isArray(this.ranges)?De:De[0]}}else{const ae=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:j,matches:b.mapArrayOrNot(re,ue=>new t(ue.startLineNumber-ae,ue.startColumn,ue.endLineNumber-ae,ue.endColumn))}}}}e.TextSearchMatch=o;function h(M){const j=M[0].startLineNumber;for(const re of M)if(re.startLineNumber!==j||re.endLineNumber!==j)return!1;return!0}class t{constructor(j,re,F,te){this.startLineNumber=j,this.startColumn=re,this.endLineNumber=F,this.endColumn=te}}e.SearchRange=t;class s extends t{constructor(j,re,F){super(j,re,j,F)}}e.OneLineRange=s;var l;(function(M){M.Default="default",M.FileNames="fileNames",M.Type="type",M.Modified="modified",M.CountDescending="countDescending",M.CountAscending="countAscending"})(l=e.SearchSortOrder||(e.SearchSortOrder={}));function u(M,j=!0){const re=M&&M.files&&M.files.exclude,F=j&&M&&M.search&&M.search.exclude;if(!(!re&&!F)){if(!re||!F)return re||F;let te=Object.create(null);return te=A.mixin(te,A.deepClone(re)),te=A.mixin(te,A.deepClone(F),!0),te}}e.getExcludes=u;function r(M,j){return M.excludePattern&&y.match(M.excludePattern,j)?!1:M.includePattern||M.usingSearchPaths?M.includePattern&&y.match(M.includePattern,j)?!0:M.usingSearchPaths?!!M.folderQueries&&M.folderQueries.some(re=>{const F=re.folder.fsPath;if(T.isEqualOrParent(j,F)){const te=I.relative(F,j);return!re.includePattern||!!y.match(re.includePattern,te)}else return!1}):!1:!0}e.pathIncludedInQuery=r;var g;(function(M){M[M.unknownEncoding=1]="unknownEncoding",M[M.regexParseError=2]="regexParseError",M[M.globParseError=3]="globParseError",M[M.invalidLiteral=4]="invalidLiteral",M[M.rgProcessError=5]="rgProcessError",M[M.other=6]="other",M[M.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class C extends Error{constructor(j,re){super(j);this.code=re}}e.SearchError=C;function _(M){const j=M.message;if(i.isPromiseCanceledError(M))return new C(j,g.canceled);try{const re=JSON.parse(j);return new C(re.message,re.code)}catch(re){return new C(j,g.other)}}e.deserializeSearchError=_;function D(M){const j={message:M.message,code:M.code};return new Error(JSON.stringify(j))}e.serializeSearchError=D;function w(M){return M.type==="error"?!0:M.type==="success"}e.isSerializedSearchComplete=w;function O(M){return M.type==="success"}e.isSerializedSearchSuccess=O;function R(M){return!!M.path}e.isSerializedFileMatch=R;function $(M,j){const re=M.searchPath?M.searchPath:M.relativePath;return E.fuzzyContains(re,j)}e.isFilePatternMatch=$;class V{constructor(j){this.path=j,this.results=[]}addMatch(j){this.results.push(j)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=V;function z(M,j){const re=Object.assign(Object.assign({},M||{}),j||{});return Object.keys(re).filter(F=>{const te=re[F];return typeof te=="boolean"&&te})}e.resolvePatternsForProvider=z;class U{constructor(j,re){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},j.excludePattern||{}),re.excludePattern||{}),this._parsedExcludeExpression=y.parse(this._excludeExpression);let F=j.includePattern;re.includePattern&&(F?F=Object.assign(Object.assign({},F),re.includePattern):F=re.includePattern),F&&(this._parsedIncludeExpression=y.parse(F))}includedInQuerySync(j,re,F){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(j,re,F)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(j,re,F))}includedInQuery(j,re,F){return Promise.resolve(this._parsedExcludeExpression(j,re,F)).then(ae=>!!ae).then(ae=>ae?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(j,re,F)).then(ue=>!!ue):Promise.resolve(!0)).then(ae=>ae)}hasSiblingExcludeClauses(){return q(this._excludeExpression)}}e.QueryGlobTester=U;function q(M){for(const j in M)if(typeof M[j]!="boolean")return!0;return!1}}),define(ve[31],_e([0,1,11,15,20,3,22,16,79,23,8,12,2,132,4,17,144,47,48,28,13,7,42,5]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d,a,m,p,f,c,n,o,h,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function l(O,R,$){return new i.ExtUri(V=>C(V,$)).isEqual(O,R)}function u(O,R,$){return l(O.uri,R.uri,$)?0:P.compare(O.uri.toString(),R.uri.toString())}function r(O,R,$){return O.index!==R.index?O.index<R.index?-1:1:l(O.uri,R.uri,$)?P.compare(O.name,R.name):P.compare(O.uri.toString(),R.uri.toString())}function g(O,R,$,V){const z=O.slice(0).sort((q,M)=>$(q,M,V)),U=R.slice(0).sort((q,M)=>$(q,M,V));return b.delta(z,U,(q,M)=>$(q,M,V))}function C(O,R){const $=R.getCapabilities(O.scheme);return!($&&$&1024)}class _ extends f.Workspace{constructor(R,$,V,z,U,q){super(R,V.map(M=>new f.WorkspaceFolder(M)),z,q);this._name=$,this._isUntitled=U,this._workspaceFolders=[],this._structure=E.TernarySearchTree.forUris(q),V.forEach(M=>{this._workspaceFolders.push(M),this._structure.set(M.uri,M)})}static toExtHostWorkspace(R,$,V,z){if(!R)return{workspace:null,added:[],removed:[]};const{id:U,name:q,folders:M,configuration:j,isUntitled:re}=R,F=[],te=$;$?M.forEach((fe,De)=>{const Se=v.URI.revive(fe.uri),Ce=_._findFolder(V||$,Se,z);Ce?(Ce.name=fe.name,Ce.index=fe.index,F.push(Ce)):F.push({uri:Se,name:fe.name,index:De})}):F.push(...M.map(({uri:fe,name:De,index:Se})=>({uri:v.URI.revive(fe),name:De,index:Se}))),F.sort((fe,De)=>fe.index<De.index?-1:1);const ae=new _(U,q,F,j?v.URI.revive(j):null,!!re,fe=>C(fe,z)),{added:ue,removed:we}=g(te?te.workspaceFolders:[],ae.workspaceFolders,u,z);return{workspace:ae,added:ue,removed:we}}static _findFolder(R,$,V){for(let z=0;z<R.folders.length;z++){const U=R.workspaceFolders[z];if(l(U.uri,$,V))return U}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,$){return $&&this._structure.get(R)&&(R=i.dirname(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let D=class{constructor(R,$,V,z){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._activeSearchCallbacks=[],this._logService=z,this._extHostFileSystemInfo=V,this._requestIdProvider=new I.Counter,this._barrier=new y.Barrier,this._proxy=R.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(s.MainContext.MainThreadMessageService);const U=$.workspace;this._confirmedWorkspace=U?new _(U.id,U.name,[],U.configuration?v.URI.revive(U.configuration):null,!!U.isUntitled,q=>C(q,V)):void 0}$initializeWorkspace(R){this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?v.URI.from({scheme:k.Schemas.untitled,path:i.basename(i.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,$,V,...z){const U=[];if(Array.isArray(z)&&z.forEach(F=>{v.URI.isUri(F.uri)&&!U.some(te=>l(te.uri,F.uri,this._extHostFileSystemInfo))&&U.push({uri:F.uri,name:F.name||i.basenameOrAuthority(F.uri)})}),this._unconfirmedWorkspace||[$,V].some(F=>typeof F!="number"||F<0)||V===0&&U.length===0)return!1;const q=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+V>q.length)return!1;const M=q.slice(0);M.splice($,V,...U.map(F=>({uri:F.uri,name:F.name||i.basenameOrAuthority(F.uri),index:void 0})));for(let F=0;F<M.length;F++){const te=M[F];if(M.some((ae,ue)=>ue!==F&&l(te.uri,ae.uri,this._extHostFileSystemInfo)))return!1}M.forEach((F,te)=>F.index=te);const{added:j,removed:re}=g(q,M,r,this._extHostFileSystemInfo);if(j.length===0&&re.length===0)return!1;if(this._proxy){const F=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(F,$,V,U).then(void 0,te=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,d.localize(0,null,F,te.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(M),!0}getWorkspaceFolder(R,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,$)}async getWorkspaceFolder2(R,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,$)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!!this._actualWorkspace){const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}}getRelativePath(R,$){let V,z="";if(typeof R=="string"?(V=v.URI.file(R),z=R):typeof R!="undefined"&&(V=R,z=R.fsPath),!V)return z;const U=this.getWorkspaceFolder(V,!0);if(!U)return z;typeof $=="undefined"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let q=i.relativePath(U.uri,V);return $&&U.name&&(q=`${U.name}/${q}`),q}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=_.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:$,added:V,removed:z}=_.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:V,removed:z}))}findFiles(R,$,V,z,U=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let q;if($===null?q=!1:$&&(typeof $=="string"?q=$:q=$.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:M,folder:j}=w(R);return this._proxy.$startFileSearch(S.withUndefinedAsNull(M),S.withUndefinedAsNull(j),S.withUndefinedAsNull(q),S.withUndefinedAsNull(V),U).then(re=>Array.isArray(re)?re.map(F=>v.URI.revive(F)):[])}async findTextInFiles(R,$,V,z,U=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const q=this._requestIdProvider.getNext(),M=typeof $.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:j,folder:re}=w($.include),F=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,te={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:M,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:j,excludePattern:F},ae=!1;if(this._activeSearchCallbacks[q]=ue=>{if(!ae){const we=v.URI.revive(ue.resource);ue.results.forEach(fe=>{t.resultIsMatch(fe)?V({uri:we,preview:{text:fe.preview.text,matches:b.mapArrayOrNot(fe.preview.matches,De=>new h.Range(De.startLineNumber,De.startColumn,De.endLineNumber,De.endColumn))},ranges:b.mapArrayOrNot(fe.ranges,De=>new h.Range(De.startLineNumber,De.startColumn,De.endLineNumber,De.endColumn))}):V({uri:we,text:fe.text,lineNumber:fe.lineNumber})})}},U.isCancellationRequested)return{};try{const ue=await this._proxy.$startTextSearch(R,S.withUndefinedAsNull(re),te,q,U);return delete this._activeSearchCallbacks[q],ue||{}}catch(ue){throw delete this._activeSearchCallbacks[q],ue}}$handleTextSearchResult(R,$){this._activeSearchCallbacks[$]&&this._activeSearchCallbacks[$](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}};D=He([Be(0,o.IExtHostRpcService),Be(1,n.IExtHostInitDataService),Be(2,c.IExtHostFileSystemInfo),Be(3,m.ILogService)],D),e.ExtHostWorkspace=D,e.IExtHostWorkspace=a.createDecorator("IExtHostWorkspace");function w(O){let R,$;return O&&(typeof O=="string"?R=O:(R=O.pattern,$=O.baseFolder||v.URI.file(O.base))),{includePattern:R,folder:$}}}),define(ve[35],_e([0,1,24,3,31,5,7,146,67,12,15,4,13,17,2]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(s,l){if(l){const u=l.split(".");let r=s;for(let g=0;r&&g<u.length;g++)r=r[u[g]];return r}}function p(s){return s instanceof a.URI}function f(s){return s&&s.uri instanceof a.URI&&s.languageId&&typeof s.languageId=="string"}function c(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function n(s){return s&&s.uri instanceof a.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function o(s){if(p(s))return{resource:s};if(f(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(c(s))return{overrideIdentifier:s.languageId};if(n(s))return{resource:s.uri};if(s===null)return{resource:null}}let h=class{constructor(l,u,r){this._proxy=l.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=u,this._logService=r,this._barrier=new P.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(l=>this._actual)}$initializeConfiguration(l){this._actual=new t(this._proxy,this._extHostWorkspace,l,this._logService),this._barrier.open()}$acceptConfigurationChanged(l,u){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(l,u))}};h=He([Be(0,v.IExtHostRpcService),Be(1,A.IExtHostWorkspace),Be(2,d.ILogService)],h),e.ExtHostConfiguration=h;class t{constructor(l,u,r,g){this._onDidChangeConfiguration=new y.Emitter,this._proxy=l,this._logService=g,this._extHostWorkspace=u,this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(l,u){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(u,r))}getConfiguration(l,u,r){const g=o(u)||{},C=this._toReadonlyValue(l?m(this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace),l):this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace));l&&this._validateConfigurationAccess(l,g,r==null?void 0:r.identifier);function _(w){if(w==null)return null;if(typeof w=="boolean")return w?1:4;switch(w){case E.ConfigurationTarget.Global:return 1;case E.ConfigurationTarget.Workspace:return 4;case E.ConfigurationTarget.WorkspaceFolder:return 5}}const D={has(w){return typeof m(C,w)!="undefined"},get:(w,O)=>{this._validateConfigurationAccess(l?`${l}.${w}`:w,g,r==null?void 0:r.identifier);let R=m(C,w);if(typeof R=="undefined")R=O;else{let $;const V=(z,U)=>{let q;const M=()=>{$=$||b.deepClone(C),q=q||m($,U)};return i.isObject(z)?new Proxy(z,{get:(j,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return M(),()=>q;if($)return q=q||m($,U),q[re];const F=j[re];return typeof re=="string"?V(F,`${U}.${re}`):F},set:(j,re,F)=>(M(),q&&(q[re]=F),!0),deleteProperty:(j,re)=>(M(),q&&delete q[re],!0),defineProperty:(j,re,F)=>(M(),q&&Object.defineProperty(q,re,F),!0)}):z};R=V(R,w)}return R},update:(w,O,R,$)=>{w=l?`${l}.${w}`:w;const V=_(R);return O!==void 0?this._proxy.$updateConfigurationOption(V,w,O,g,$):this._proxy.$removeConfigurationOption(V,w,g,$)},inspect:w=>{var O,R,$,V,z,U,q,M;w=l?`${l}.${w}`:w;const j=b.deepClone(this._configuration.inspect(w,g,this._extHostWorkspace.workspace));if(j)return{key:w,defaultValue:(O=j.default)===null||O===void 0?void 0:O.value,globalValue:(R=j.user)===null||R===void 0?void 0:R.value,workspaceValue:($=j.workspace)===null||$===void 0?void 0:$.value,workspaceFolderValue:(V=j.workspaceFolder)===null||V===void 0?void 0:V.value,defaultLanguageValue:(z=j.default)===null||z===void 0?void 0:z.override,globalLanguageValue:(U=j.user)===null||U===void 0?void 0:U.override,workspaceLanguageValue:(q=j.workspace)===null||q===void 0?void 0:q.override,workspaceFolderLanguageValue:(M=j.workspaceFolder)===null||M===void 0?void 0:M.override,languageIds:j.overrideIdentifiers}}};return typeof C=="object"&&b.mixin(D,C,!1),Object.freeze(D)}_toReadonlyValue(l){const u=r=>i.isObject(r)?new Proxy(r,{get:(g,C)=>u(g[C]),set:(g,C,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(C)}' of object`)},deleteProperty:(g,C)=>{throw new Error(`TypeError: Cannot delete read only property '${String(C)}' of object`)},defineProperty:(g,C)=>{throw new Error(`TypeError: Cannot define property '${String(C)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return u(l)}_validateConfigurationAccess(l,u,r){const g=I.OVERRIDE_PROPERTY_PATTERN.test(l)?4:this._configurationScopes.get(l),C=r?`[${r.value}] `:"";if(g===4){typeof(u==null?void 0:u.resource)=="undefined"&&this._logService.warn(`${C}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){(u==null?void 0:u.resource)&&this._logService.warn(`${C}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(l,u){const r=new k.ConfigurationChangeEvent(l,u,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(g,C)=>r.affectsConfiguration(g,o(C))})}_toMap(l){return l.reduce((u,r)=>(u.set(r[0],r[1]),u),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=S.createDecorator("IExtHostConfiguration")}),define(ve[99],_e([0,1,2,15,3,5,7,31,40,35,20,41,13,28,4,16,21,17,73,163,9]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d,a,m,p,f,c,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var h;(function(V){function z(q){if(q!=null)return q}V.from=z;function U(q){if(q!=null)return q}V.to=U})(h=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var t;(function(V){function z(q){if(q!=null)return q}V.from=z;function U(q){if(q!=null)return q}V.to=U})(t=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(V){function z(q){if(q!=null)return q}V.from=z;function U(q){if(q!=null)return q}V.to=U})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var l;(function(V){function z(M){if(M){const j=M;return j&&!!j.process}else return!1}V.is=z;function U(M){if(M!=null){const j={process:M.process,args:M.args};return M.options&&(j.options=s.from(M.options)),j}}V.from=U;function q(M){if(M!=null)return new E.ProcessExecution(M.process,M.args,M.options)}V.to=q})(l=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(V){function z(q){if(q!=null)return q}V.from=z;function U(q){if(q!=null)return q}V.to=U})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var r;(function(V){function z(M){if(M){const j=M;return j&&(!!j.commandLine||!!j.command)}else return!1}V.is=z;function U(M){if(M!=null){const j={};return M.commandLine!==void 0?j.commandLine=M.commandLine:(j.command=M.command,j.args=M.args),M.options&&(j.options=u.from(M.options)),j}}V.from=U;function q(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new E.ShellExecution(M.commandLine,M.options):new E.ShellExecution(M.command,M.args?M.args:[],M.options)}V.to=q})(r=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var g;(function(V){function z(M){if(M){let j=M;return j&&j.customExecution==="customExecution"}else return!1}V.is=z;function U(M){return{customExecution:"customExecution"}}V.from=U;function q(M,j){return j.get(M)}V.to=q})(g=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var C;(function(V){function z(U,q){let M;return U.scope!==void 0&&typeof U.scope!="number"?M=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===E.TaskScope.Workspace&&q&&q.workspaceFile?M=q.workspaceFile:M=n.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:M}}V.from=z})(C=e.TaskHandleDTO||(e.TaskHandleDTO={}));var _;(function(V){function z(M,j){if(M==null)return[];const re=[];for(let F of M){const te=U(F,j);te&&re.push(te)}return re}V.fromMany=z;function U(M,j){if(M!=null){let re;M.execution instanceof E.ProcessExecution?re=l.from(M.execution):M.execution instanceof E.ShellExecution?re=r.from(M.execution):M.execution&&M.execution instanceof E.CustomExecution&&(re=g.from(M.execution));const F=h.from(M.definition);let te;if(M.scope?typeof M.scope=="number"?te=M.scope:te=M.scope.uri:te=E.TaskScope.Workspace,!(!F||!te)){const ae=M.group?M.group.id:void 0;return{_id:M._id,definition:F,name:M.name,source:{extensionId:j.identifier.value,label:M.source,scope:te},execution:re,isBackground:M.isBackground,group:ae,presentationOptions:t.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}}}V.from=U;async function q(M,j,re){if(M!=null){let F;l.is(M.execution)?F=l.to(M.execution):r.is(M.execution)?F=r.to(M.execution):g.is(M.execution)&&(F=g.to(M._id,re));const te=h.to(M.definition);let ae;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?ae=M.source.scope:ae=await j.resolveWorkspaceFolder(b.URI.revive(M.source.scope)):ae=E.TaskScope.Workspace),!(!te||!ae)){const ue=new E.Task(te,ae,M.name,M.source.label,F,M.problemMatchers);return M.isBackground!==void 0&&(ue.isBackground=M.isBackground),M.group!==void 0&&(ue.group=E.TaskGroup.from(M.group)),M.presentationOptions&&(ue.presentationOptions=t.to(M.presentationOptions)),M._id&&(ue._id=M._id),M.detail&&(ue.detail=M.detail),ue}}}V.to=q})(_=e.TaskDTO||(e.TaskDTO={}));var D;(function(V){function z(q){return q}V.from=z;function U(q){if(!!q)return Object.assign(Object.create(null),q)}V.to=U})(D=e.TaskFilterDTO||(e.TaskFilterDTO={}));class w{constructor(z,U,q){this._tasks=z,this._id=U,this._task=q}get task(){return this._task}terminate(){this._tasks.terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}var O;(function(V){function z(U){return{id:U._id,task:void 0}}V.from=z})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let R=class{constructor(z,U,q,M,j,re,F,te){this._onDidExecuteTask=new A.Emitter,this._onDidTerminateTask=new A.Emitter,this._onDidTaskProcessStarted=new A.Emitter,this._onDidTaskProcessEnded=new A.Emitter,this._proxy=z.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=q,this._editorService=M,this._configurationService=j,this._terminalService=re,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=F,this._deprecationService=te,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,U,q){if(!q)return new E.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:U,provider:q,extension:z}),this._proxy.$registerTaskProvider(M,U),new E.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(z,U){this._proxy.$registerTaskSystem(z,U)}fetchTasks(z){return this._proxy.$fetchTasks(D.from(z)).then(async U=>{const q=[];for(let M of U){const j=await _.to(M,this._workspaceProvider,this._providedCustomExecutions2);j&&q.push(j)}return q})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(U=>z.push(U)),z}terminateTask(z){if(!(z instanceof w))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,U,q){const M=this._providedCustomExecutions2.get(z.id);if(M){if(this._activeCustomExecutions2.get(z.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(z.id,M),this._terminalService.attachPtyToTerminal(U,await M.callback(q))}this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const U=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:U})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const U=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:U,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const U=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:U,exitCode:z.exitCode})}$provideTasks(z,U){const q=this._handlers.get(z);if(!q)return Promise.reject(new Error("no handler found"));const M=[],j=y.asPromise(()=>q.provider.provideTasks(P.CancellationToken.None)).then(re=>this.provideTasksInternal(U,M,q,re));return new Promise(re=>{j.then(F=>{Promise.all(M).then(()=>{re(F)})})})}async $resolveTask(z,U){const q=this._handlers.get(z);if(!q)return Promise.reject(new Error("no handler found"));if(U.definition.type!==q.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${q.type}].`);const M=await _.to(U,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const j=await q.provider.resolveTask(M,P.CancellationToken.None);if(!!j){this.checkDeprecation(j,q);const re=_.from(j,q.extension);if(!re)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(re.execution)&&await this.addCustomExecution(re,j,!0),await this.resolveTaskInternal(re)}}nextHandle(){return this._handleCounter++}async addCustomExecution(z,U,q){const M=await this._proxy.$createTaskId(z);!q&&!this._providedCustomExecutions2.has(M)&&this._notProvidedCustomExecutions.add(M),this._providedCustomExecutions2.set(M,U.execution)}async getTaskExecution(z,U){if(typeof z=="string"){const j=this._taskExecutionPromises.get(z);if(!j)throw new Error("Unexpected: The specified task is missing an execution");return j}let q=this._taskExecutionPromises.get(z.id);if(q)return q;const M=new Promise(async(j,re)=>{const F=U||await _.to(z.task,this._workspaceProvider,this._providedCustomExecutions2);F?j(new w(this,z.id,F)):re("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(z.id,M),M.then(j=>(this._taskExecutions.set(z.id,j),j),j=>Promise.reject(j))}checkDeprecation(z,U){z._deprecated&&this._deprecationService.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let q=this._notProvidedCustomExecutions.values(),M=q.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=q.next()}};R=He([Be(0,v.IExtHostRpcService),Be(1,d.IExtHostInitDataService),Be(2,k.IExtHostWorkspace),Be(3,I.IExtHostDocumentsAndEditors),Be(4,i.IExtHostConfiguration),Be(5,S.IExtHostTerminalService),Be(6,f.ILogService),Be(7,c.IExtHostApiDeprecationService)],R),e.ExtHostTaskBase=R;let $=class extends R{constructor(z,U,q,M,j,re,F,te){super(z,U,q,M,j,re,F,te);this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(z,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const q=_.from(U,z);if(q===void 0)throw new Error("Task is not valid");if(g.is(q.execution))await this.addCustomExecution(q,U,!1);else throw new o.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(q),U);return this._proxy.$executeTask(q).catch(j=>{throw new Error(j)}),M}provideTasksInternal(z,U,q,M){const j=[];if(M)for(let re of M){this.checkDeprecation(re,q),(!re.definition||!z[re.definition.type])&&this._logService.warn(`The task [${re.source}, ${re.name}] uses an undefined task type. The task will be ignored in the future.`);const F=_.from(re,q.extension);F&&g.is(F.execution)?(j.push(F),U.push(this.addCustomExecution(F,re,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:j,extension:q.extension}}async resolveTaskInternal(z){if(g.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,U){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(z,U,q){}};$=He([Be(0,v.IExtHostRpcService),Be(1,d.IExtHostInitDataService),Be(2,k.IExtHostWorkspace),Be(3,I.IExtHostDocumentsAndEditors),Be(4,i.IExtHostConfiguration),Be(5,S.IExtHostTerminalService),Be(6,f.ILogService),Be(7,c.IExtHostApiDeprecationService)],$),e.WorkerExtHostTask=$,e.IExtHostTask=a.createDecorator("IExtHostTask")});var Xe=this&&this.__classPrivateFieldSet||function(se,e,b){if(!e.has(se))throw new TypeError("attempted to set private field on non-instance");return e.set(se,b),b},Ue=this&&this.__classPrivateFieldGet||function(se,e){if(!e.has(se))throw new TypeError("attempted to get private field on non-instance");return e.get(se)},ai=this&&this.__rest||function(se,e){var b={};for(var y in se)Object.prototype.hasOwnProperty.call(se,y)&&e.indexOf(y)<0&&(b[y]=se[y]);if(se!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,y=Object.getOwnPropertySymbols(se);A<y.length;A++)e.indexOf(y[A])<0&&Object.prototype.propertyIsEnumerable.call(se,y[A])&&(b[y[A]]=se[y[A]]);return b};define(ve[209],_e([0,1,11,15,20,3,51,6,12,2,26,5,40,13,14,7,31,174,166]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d,a,m,p,f,c){"use strict";var n,o;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.ExtHostTesting=void 0;const h=(O,R)=>`${O}:${R.toString()}`;let t=class{constructor(R,$,V){this.documents=$,this.workspace=V,this.resultsChangedEmitter=new T.Emitter,this.providers=new Map,this.ownedTests=new f.OwnedTestCollection,this.testSubscriptions=new Map,this.onLastResultsChanged=this.resultsChangedEmitter.event,this.proxy=R.getProxy(S.MainContext.MainThreadTesting),this.workspaceObservers=new D(this.proxy),this.textDocumentObservers=new w(this.proxy,$)}registerTestProvider(R){const $=P.generateUuid();this.providers.set($,R),this.proxy.$registerTestProvider($);const V=[...this.testSubscriptions.keys()];return setTimeout(()=>{var z;for(const U of V)(z=this.testSubscriptions.get(U))===null||z===void 0||z.subscribeFn($,R)},0),new m.Disposable(()=>{this.providers.delete($),this.proxy.$unregisterTestProvider($)})}createTextDocumentTestObserver(R){return this.textDocumentObservers.checkout(R.uri)}createWorkspaceTestObserver(R){return this.workspaceObservers.checkout(R.uri)}async runTests(R,$=A.CancellationToken.None){await this.proxy.$runTests({tests:R.tests.map(V=>{var z,U;return(U=(z=this.workspaceObservers.getMirroredTestDataByReference(V))!==null&&z!==void 0?z:b.mapFind(this.testSubscriptions.values(),q=>q.collection.getTestByReference(V)))!==null&&U!==void 0?U:this.textDocumentObservers.getMirroredTestDataByReference(V)}).filter(I.isDefined).map(V=>({providerId:V.providerId,testId:V.id})),debug:R.debug},$)}$publishTestResults(R){const $=V=>Object.assign(Object.assign({},a.TestItem.toShallow(V.item)),{children:V.children.map($)});this.lastResults={tests:R.tests.map($)},this.resultsChangedEmitter.fire()}async $subscribeToTests(R,$){const V=i.URI.revive($),z=h(R,V);if(!this.testSubscriptions.has(z)){let U;if(R===1){let re=this.documents.getDocument(V);if(!re){const F=new k.DisposableStore;re=await new Promise(te=>{F.add(y.disposableTimeout(()=>te(void 0),5e3)),F.add(this.documents.onDidAddDocuments(ae=>{const ue=ae.find(we=>we.document.uri.toString()===V.toString());ue&&te(ue)}))}).finally(()=>F.dispose())}if(re){const F=await this.workspace.getWorkspaceFolder2(V,!1);U=te=>te.createDocumentTestHierarchy?te.createDocumentTestHierarchy(re.document):this.createDefaultDocumentTestHierarchy(te,re.document,F)}}else{const re=await this.workspace.getWorkspaceFolder2(V,!1);re&&(U=F=>{var te;return(te=F.createWorkspaceTestHierarchy)===null||te===void 0?void 0:te.call(F,re)})}if(!!U){const q=(re,F)=>{try{const te=U(F);if(!te)return;j.pushDiff([3,1]),M.add(te),j.addRoot(te.root,re),Promise.resolve(te.discoveredInitialTests).then(()=>j.pushDiff([3,-1])),te.onDidChangeTest(ae=>j.onItemChange(ae,re))}catch(te){console.error(te)}},M=new k.DisposableStore,j=M.add(this.ownedTests.createForHierarchy(re=>this.proxy.$publishDiff(R,$,re)));for(const[re,F]of this.providers)q(re,F);j.pushDiff([4,-1]),this.testSubscriptions.set(z,{store:M,collection:j,subscribeFn:q})}}}$unsubscribeFromTests(R,$){var V;const z=i.URI.revive($),U=h(R,z);(V=this.testSubscriptions.get(U))===null||V===void 0||V.store.dispose(),this.testSubscriptions.delete(U)}$acceptDiff(R,$,V){R===1?this.textDocumentObservers.acceptDiff(i.URI.revive($),V):this.workspaceObservers.acceptDiff(i.URI.revive($),V)}async $runTestsForProvider(R,$){const V=this.providers.get(R.providerId);if(!V||!V.runTests)return c.EMPTY_TEST_RESULT;const z=R.ids.map(U=>{var q;return(q=this.ownedTests.getTestById(U))===null||q===void 0?void 0:q.actual}).filter(I.isDefined).map(U=>U instanceof s?U.actual:U);if(!z.length)return c.EMPTY_TEST_RESULT;try{await V.runTests({tests:z,debug:R.debug},$);for(const{collection:U}of this.testSubscriptions.values())U.flushDiff();return c.EMPTY_TEST_RESULT}catch(U){throw console.error(U),U}}$lookupTest(R){const $=this.ownedTests.getTestById(R.testId);if(!$)return Promise.resolve(void 0);const{actual:V,previousChildren:z,previousEquals:U}=$,q=ai($,["actual","previousChildren","previousEquals"]);return Promise.resolve(q)}createDefaultDocumentTestHierarchy(R,$,V){var z;if(!!V){const U=(z=R.createWorkspaceTestHierarchy)===null||z===void 0?void 0:z.call(R,V);if(!!U){const q=new T.Emitter;return U.onDidChangeTest(M=>{const j=s.getWrapperForTestItem(M,$);if(j.hasNodeMatchingFilter){if(j.reset(),j.hasNodeMatchingFilter){q.fire(j);return}q.fire(j.visibleParent);return}const F=j.visibleParent;j.reset(),!!j.hasNodeMatchingFilter&&(F.reset(),q.fire(F))}),{root:s.getWrapperForTestItem(U.root,$),dispose:()=>{q.dispose(),s.removeFilter($)},onDidChangeTest:q.event}}}}};t=He([Be(0,d.IExtHostRpcService),Be(1,v.IExtHostDocumentsAndEditors),Be(2,p.IExtHostWorkspace)],t),e.ExtHostTesting=t;class s{constructor(R,$,V){this.actual=R,this.filterDocument=$,this.parent=V,this.getWrappedChildren()}static removeFilter(R){this.wrapperMap.delete(R)}static getWrapperForTestItem(R,$,V){let z=this.wrapperMap.get($);if(z==null?void 0:z.has(R))return z.get(R);z||(z=new WeakMap,this.wrapperMap.set($,z));const U=new s(R,$,V);return z.set(R,U),U}get label(){return this.actual.label}get debuggable(){return this.actual.debuggable}get description(){return this.actual.description}get location(){return this.actual.location}get runnable(){return this.actual.runnable}get state(){return this.actual.state}get children(){return this.getWrappedChildren().filter(R=>R.hasNodeMatchingFilter)}get visibleParent(){return this.hasNodeMatchingFilter?this:this.parent.visibleParent}get hasNodeMatchingFilter(){var R;return this.matchesFilter===void 0&&(this.matchesFilter=!this.parent||((R=this.actual.location)===null||R===void 0?void 0:R.uri.toString())===this.filterDocument.uri.toString()||this.getWrappedChildren().some($=>$.hasNodeMatchingFilter)),this.matchesFilter}reset(){var R;this!==this.visibleParent&&((R=this.parent)===null||R===void 0||R.reset()),this.matchesFilter=void 0}getWrappedChildren(){var R;return((R=this.actual.children)===null||R===void 0?void 0:R.map($=>s.getWrapperForTestItem($,this.filterDocument,this)))||[]}}e.TestItemFilteredWrapper=s,s.wrapperMap=new WeakMap;class l extends c.IncrementalChangeCollector{constructor(R,$){super();this.collection=R,this.emitter=$,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,a.TestItem.toShallow(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.id);return}this.removed.add(R)}getChangeEvent(){const{collection:R,added:$,updated:V,removed:z}=this;return{get added(){return[...$].map(R.getPublicTestItem,R)},get updated(){return[...V].map(R.getPublicTestItem,R)},get removed(){return[...z].map(R.getPublicTestItem,R)},get commonChangeAncestor(){let U;const q=F=>{if(!!F){const te=new Array(F.depth+1);for(let ae=F.depth;ae>=0;ae--){if(!F)return;te[F.depth]=F,F=F.parent?R.getMirroredTestDataById(F.parent):void 0}return te}},M=F=>{if(!(U&&U.length===0)){const te=q(F);if(!!te){if(!U){U=te;return}for(let ae=U.length-1;ae>=0;ae--)U[ae]!==te[ae]&&U.pop()}}},j=F=>{if(!(U&&U.length===0))if(F.parent===null)U=[];else{const te=R.getMirroredTestDataById(F.parent);te&&M(te)}};for(const F of $)j(F);for(const F of V)M(F);for(const F of z)j(F);const re=U&&U[U.length-1];return re?R.getPublicTestItem(re):null}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class u extends c.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(R){let $=[];for(const V of R){const z=this.items.get(V);z&&$.push(this.getPublicTestItem(z))}return $}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){const $=r(R);return $?this.items.get($):void 0}createItem(R,$){return Object.assign(Object.assign({},R),{revived:a.TestItem.toShallow(R.item),depth:$?$.depth+1:0,children:new Set})}createChangeCollector(){return new l(this,this.changeEmitter)}getPublicTestItem(R){return R.wrapped||(R.wrapped=new C(R,this)),R.wrapped}}e.MirroredTestCollection=u;const r=O=>O[g],g=Symbol("MirroredItemId");class C{constructor(R,$){n.set(this,void 0),o.set(this,void 0),Xe(this,n,R),Xe(this,o,$)}get id(){return Ue(this,n).revived.id}get label(){return Ue(this,n).revived.label}get description(){return Ue(this,n).revived.description}get state(){return Ue(this,n).revived.state}get location(){return Ue(this,n).revived.location}get runnable(){var R;return(R=Ue(this,n).revived.runnable)!==null&&R!==void 0?R:!0}get debuggable(){var R;return(R=Ue(this,n).revived.debuggable)!==null&&R!==void 0?R:!1}get children(){return Ue(this,o).getAllAsTestItem(Ue(this,n).children)}get[(n=new WeakMap,o=new WeakMap,g)](){return Ue(this,n).id}toJSON(){return{id:this.id,label:this.label,description:this.description,state:this.state,location:this.location,runnable:this.runnable,debuggable:this.debuggable,children:this.children.map($=>$.toJSON()),providerId:Ue(this,n).providerId,testId:Ue(this,n).id}}}class _{constructor(){this.resources=new Map}checkout(R){var $,V;const z=R.toString(),U=($=this.resources.get(z))!==null&&$!==void 0?$:this.createObserverData(R);return(V=U.pendingDeletion)===null||V===void 0||V.dispose(),U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,onDidDiscoverInitialTests:new T.Emitter().event,get tests(){return U.tests.rootTestItems},dispose:E.once(()=>{--U.observers||(U.pendingDeletion=this.eventuallyDispose(R))})}}getMirroredTestDataByReference(R){for(const{tests:$}of this.resources.values()){const V=$.getMirroredTestDataByReference(R);if(V)return V}}eventuallyDispose(R){return y.disposableTimeout(()=>this.unlisten(R),10*1e3)}createObserverData(R){const $=new u,V=this.listen(R,U=>$.apply(U)),z={observers:0,tests:$,listener:V};return this.resources.set(R.toString(),z),z}unlisten(R){var $;const V=R.toString(),z=this.resources.get(V);z&&(z.observers=-1,($=z.pendingDeletion)===null||$===void 0||$.dispose(),z.listener.dispose(),this.resources.delete(V))}}class D extends _{constructor(R){super();this.proxy=R,this.diffListeners=new Map}acceptDiff(R,$){var V;(V=this.diffListeners.get(R.toString()))===null||V===void 0||V($)}listen(R,$){this.proxy.$subscribeToDiffs(0,R);const V=R.toString();return this.diffListeners.set(V,$),new m.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,R),this.diffListeners.delete(V)})}}class w extends _{constructor(R,$){super();this.proxy=R,this.documents=$,this.diffListeners=new Map}acceptDiff(R,$){var V;(V=this.diffListeners.get(R.toString()))===null||V===void 0||V($)}listen(R,$){if(!this.documents.getDocument(R))return new m.Disposable(()=>{});const z=R.toString();return this.diffListeners.set(z,$),this.proxy.$subscribeToDiffs(1,R),new m.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,R),this.diffListeners.delete(z)})}}}),define(ve[210],_e([0,1,11,50,29,59,22,16,10,23,8,12,2,111,135,90,47,168,208,42]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d,a,m,p,f,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let o=class{constructor(_,D,w,O){this.configurationService=_,this.workspaceContextService=D,this.editorGroupsService=w,this.pathService=O}text(_,D,w={}){_=this.getContentPattern(_,w);const O=this.configurationService.getValue(),R=D&&D.some(V=>!this.configurationService.getValue({resource:V}).search.useRipgrep),$=this.commonQuery(D==null?void 0:D.map(p.toWorkspaceFolder),w);return Object.assign(Object.assign({},$),{type:2,contentPattern:_,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:O.search.usePCRE2||R||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles})}getContentPattern(_,D){const w=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const O=Object.assign(Object.assign({},_),{wordSeparators:w.editor.wordSeparators});return this.isCaseSensitive(_,D)&&(O.isCaseSensitive=!0),this.isMultiline(_)&&(O.isMultiline=!0),O}file(_,D={}){const w=this.commonQuery(_,D);return Object.assign(Object.assign({},w),{type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey})}handleIncludeExclude(_,D){return _?(_=Array.isArray(_)?_.map(u):u(_),D?this.parseSearchPaths(_):{pattern:t(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],D={}){const w=this.handleIncludeExclude(D.includePattern,D.expandPatterns),O=this.handleIncludeExclude(D.excludePattern,D.expandPatterns),R=_.length>1,$=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,D,O)):_.map(U=>this.getFolderQueryForRoot(U,D,O,R))).filter(U=>!!U),V={_reason:D._reason,folderQueries:$,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:O.pattern,includePattern:w.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const q=b.coalesce(b.flatten(this.editorGroupsService.groups.map(j=>j.editors.map(re=>re.resource)))).filter(j=>n.pathIncludedInQuery(V,j.fsPath)),M=this.commonQueryFromFileList(q);return Object.assign(Object.assign({},V),M)}const z=D.extraFileResources&&D.extraFileResources.filter(U=>n.pathIncludedInQuery(V,U.fsPath));return V.extraFileResources=z&&z.length?z:void 0,V}commonQueryFromFileList(_){const D=[],w=new E.ResourceMap,O={};let R=!1;return _.forEach($=>{var V,z;if($.scheme!==k.Schemas.walkThrough){const U=i.isAbsolutePath($),q=$.scheme===k.Schemas.userData;if(U&&!q){const M=(z=(V=this.workspaceContextService.getWorkspaceFolder($))===null||V===void 0?void 0:V.uri)!==null&&z!==void 0?z:$.with({path:I.dirname($.fsPath)});let j=w.get(M);j||(R=!0,j={folder:M,includePattern:{}},D.push(j),w.set(M,j));const re=I.relative(M.fsPath,$.fsPath);S.assertIsDefined(j.includePattern)[re.replace(/\\/g,"/")]=!0}else $.fsPath&&(R=!0,O[$.fsPath]=!0)}}),{folderQueries:D,includePattern:O,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(_,D){if(D.isSmartCase){if(_.isRegExp){if(P.containsUppercaseCharacter(_.pattern,!0))return!0}else if(P.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&d.isMultilineRegexSource(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const D=M=>I.isAbsolute(M)||/^\.\.?([\/\\]|$)/.test(M),O=(Array.isArray(_)?_:s(_)).map(M=>{const j=this.pathService.resolvedUserHome;return j?T.untildify(M,j.scheme===k.Schemas.file?j.fsPath:j.path):M}),R=y.groupBy(O,M=>D(M)?"searchPaths":"exprSegments"),$=(R.exprSegments||[]).map(M=>P.rtrim(M,"/")).map(M=>P.rtrim(M,"\\")).map(M=>(M[0]==="."&&(M="*"+M),l(M))),V={},z=this.expandSearchPathPatterns(R.searchPaths||[]);z&&z.length&&(V.searchPaths=z);const U=b.flatten($),q=t(...U);return q&&(V.pattern=q),V}getExcludesForFolder(_,D){return D.disregardExcludeSettings?void 0:n.getExcludes(_,!D.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const D=b.flatten(_.map(O=>{let{pathPortion:R,globPortion:$}=h(O);$&&($=r($));const V=this.expandOneSearchPath(R);return b.flatten(V.map(z=>this.resolveOneSearchPathPattern(z,$)))})),w=new Map;return D.forEach(O=>{const R=O.searchPath.toString(),$=w.get(R);$?O.pattern&&($.pattern=$.pattern||{},$.pattern[O.pattern]=!0):w.set(R,{searchPath:O.searchPath,pattern:O.pattern?t(O.pattern):void 0})}),Array.from(w.values())}expandOneSearchPath(_){if(I.isAbsolute(_)){const D=this.workspaceContextService.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==k.Schemas.file?[{searchPath:D[0].uri.with({path:_})}]:[{searchPath:v.URI.file(I.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const D=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=u(_),_.startsWith("../")||_===".."){const O=I.posix.resolve(D.path,_);return[{searchPath:D.with({path:O})}]}const w=r(_);return[{searchPath:D,pattern:w}]}else{if(_==="./"||_===".\\")return[];{const D=_.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(D){const w=D[1],O=this.workspaceContextService.getWorkspace().folders.filter(R=>R.name===w);if(O.length)return O.map(R=>{const $=D[2];return{searchPath:R.uri,pattern:$&&r($)}});{const R=a.localize(0,null,w);throw new Error(R)}}}}return[]}resolveOneSearchPathPattern(_,D){const w=_.pattern&&D?`${_.pattern}/${D}`:_.pattern||D,O=[{searchPath:_.searchPath,pattern:w}];return w&&!w.endsWith("**")&&O.push({searchPath:_.searchPath,pattern:w+"/**"}),O}getFolderQueryForSearchPath(_,D,w){const O=this.getFolderQueryForRoot(p.toWorkspaceFolder(_.searchPath),D,w,!1);return O?Object.assign(Object.assign({},O),{includePattern:_.pattern}):null}getFolderQueryForRoot(_,D,w,O){let R;const $=v.URI.isUri(_)?_:_.uri;if(w.searchPaths){const M=w.searchPaths.filter(j=>i.isEqual(j.searchPath,$))[0];if(M&&!M.pattern)return null;M&&(R=M.pattern)}const V=this.configurationService.getValue({resource:$}),z=this.getExcludesForFolder(V,D),U=Object.assign(Object.assign({},z||{}),R||{}),q=v.URI.isUri(_)?i.basename(_):_.name;return{folder:$,folderName:O?q:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:V.files&&V.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!V.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!V.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!V.search.followSymlinks}}};o=He([Be(0,m.IConfigurationService),Be(1,p.IWorkspaceContextService),Be(2,f.IEditorGroupsService),Be(3,c.IPathService)],o),e.QueryBuilder=o;function h(C){const _=C.match(/[\*\{\}\(\)\[\]\?]/);if(_){const D=_.index,w=C.substr(0,D).match(/[/|\\][^/\\]*$/);if(w){let O=C.substr(0,w.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:C.substr((w.index||0)+1)}}}return{pathPortion:C}}function t(...C){return C.length?C.reduce((_,D)=>(_[D]=!0,_),Object.create(null)):void 0}function s(C){return A.splitGlobAware(C,",").map(_=>_.trim()).filter(_=>!!_.length)}function l(C){return[`**/${C}/**`,`**/${C}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function u(C){return C.replace(/\\/g,"/")}function r(C){return u(C).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(C,_){C=b.distinct(C,O=>O.toString());const D=[],w=_.getWorkspace();return C&&C.forEach(O=>{let R;if(_.getWorkbenchState()===2)R=i.relativePath(w.folders[0].uri,O),R&&R!=="."&&(R="./"+R);else{const $=_.getWorkspaceFolder(O);if($){const V=$.name;if(w.folders.filter(U=>U.name===V).length===1){const U=i.relativePath($.uri,O);U===""?R=`./${$.name}`:R=`./${$.name}/${U}`}else R=O.fsPath}}R&&D.push(R)}),D}e.resolveResourcesForSearchIncludes=g}),define(ve[211],_e([0,1,23,2,20,9,4,210,42,47]),function(se,e,b,y,A,T,E,k,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const P=7e3;function S(m,p){const f=p.activationEvents;if(!f)return Promise.resolve(void 0);const c=[],n=[];for(const u of f)if(/^workspaceContains:/.test(u)){const r=u.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||m.forceUsingSearch?n.push(r):c.push(r)}if(c.length===0&&n.length===0)return Promise.resolve(void 0);let o;const h=new Promise((u,r)=>{o=u}),t=u=>o({activationEvent:u}),s=Promise.all(c.map(u=>v(m,u,t))).then(()=>{}),l=d(m,p.identifier,n,t);return Promise.all([s,l]).then(()=>{o(void 0)}),h}e.checkActivateWorkspaceContainsExtension=S;async function v(m,p,f){for(const c of m.folders)if(await m.exists(b.joinPath(y.URI.revive(c),p))){f(`workspaceContains:${p}`);return}}async function d(m,p,f,c){if(f.length===0)return Promise.resolve(void 0);const n=new A.CancellationTokenSource,o=m.checkExists(m.folders,f,n.token),h=setTimeout(async()=>{n.cancel(),c(`workspaceContainsTimeout:${f.join(",")}`)},P);let t=!1;try{t=await o}catch(s){T.isPromiseCanceledError(s)||T.onUnexpectedError(s)}n.dispose(),clearTimeout(h),t&&c(`workspaceContains:${f.join(",")}`)}function a(m,p,f,c){const n=m.get(E.IInstantiationService),o=m.get(I.ISearchService),t=n.createInstance(k.QueryBuilder).file(p.map(s=>i.toWorkspaceFolder(y.URI.revive(s))),{_reason:"checkExists",includePattern:f,exists:!0});return o.fileSearch(t,c).then(s=>!!s.limitHit,s=>T.isPromiseCanceledError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=a}),define(ve[36],_e([0,1,127,10,78,23,15,6,22,2,17,5,35,177,76,31,34,175,9,25,16,27,152,7,91,4,28,77,13,66,69,41,3,211,72,153]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d,a,m,p,f,c,n,o,h,t,s,l,u,r,g,C,_,D,w,O,R,$,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=u.createDecorator("IHostUtils");let z=class bi extends k.Disposable{constructor(M,j,re,F,te,ae,ue,we,fe,De){super();this._onDidChangeRemoteConnectionData=this._register(new O.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=j,this._extHostContext=re,this._initData=ue,this._extHostWorkspace=F,this._extHostConfiguration=te,this._logService=ae,this._extHostTunnelService=fe,this._extHostTerminalService=De,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(S.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(S.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(S.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new E.Barrier,this._readyToStartExtensionHost=new E.Barrier,this._readyToRunExtensions=new E.Barrier,this._registry=new f.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new $.ExtHostSecretState(this._extHostContext),this._storagePath=we,this._instaService=M.createChild(new _.ServiceCollection([a.IExtHostStorage,this._storage],[$.IExtHostSecretState,this._secretState]));const Se=new Set;this._initData.hostExtensions.forEach(Ce=>Se.add(n.ExtensionIdentifier.toKey(Ce))),this._activator=new d.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ce,x)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ce,x)},actualActivateExtension:async(Ce,x)=>{if(Se.has(n.ExtensionIdentifier.toKey(Ce)))return await this._mainThreadExtensionsProxy.$activateExtension(Ce,x),new d.HostExtension;const K=this._registry.getExtensionDescription(Ce);return this._activateExtension(K,x)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),A.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){c.onUnexpectedError(M)}}async deactivateAll(){let M=[];try{M=this._registry.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this._deactivate(te))}catch(j){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,j){return this._activator.activateByEvent(M,j)}_activateById(M,j){return this._activator.activateById(M,j)}activateByIdWithErrors(M,j){return this._activateById(M,j).then(()=>{const re=this._activator.getActivatedExtension(M);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=I.TernarySearchTree.forPaths(),j=this._registry.getAllExtensionDescriptions().map(re=>{if(!!this._getEntryPoint(re))return this._hostUtils.realpath(re.extensionLocation.fsPath).then(F=>M.set(i.URI.file(F).fsPath,re))});this._extensionPathIndex=Promise.all(j).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let j=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return j;const re=this._activator.getActivatedExtension(M);if(!re)return j;try{typeof re.module.deactivate=="function"&&(j=Promise.resolve(re.module.deactivate()).then(void 0,F=>Promise.resolve(void 0)))}catch(F){}try{k.dispose(re.subscriptions)}catch(F){}return j}async _activateExtension(M,j){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,j).then(re=>{const F=re.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,F.codeLoadingTime,F.activateCallTime,F.activateResolvedTime,j),this._logExtensionActivationTimes(M,j,"success",F),re},re=>{throw this._logExtensionActivationTimes(M,j,"failure"),re})}_logExtensionActivationTimes(M,j,re,F){const te=U(M,j);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},te),F||{}),{outcome:re}))}_doActivateExtension(M,j){const re=U(M,j);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",re);const F=this._getEntryPoint(M);if(!F)return Promise.resolve(new d.EmptyExtension(d.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(j)}`),this._logService.flush();const te=new d.ExtensionActivationTimesBuilder(j.startup);return Promise.all([this._loadCommonJSModule(M.identifier,T.joinPath(M.extensionLocation,F),te),this._loadExtensionContext(M)]).then(ae=>(A.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),bi._callActivate(this._logService,M.identifier,ae[0],ae[1],te))).then(ae=>(A.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),ae))}_loadExtensionContext(M){const j=new t.ExtensionGlobalMemento(M,this._storage),re=new t.ExtensionMemento(M.identifier.value,!1,this._storage),F=new V.ExtensionSecrets(M,this._secretState),te=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([j.whenReady,re.whenReady,this._storagePath.whenReady]).then(()=>{const ae=this;return Object.freeze({globalState:j,workspaceState:re,secrets:F,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(ue){return y.join(M.extensionLocation.fsPath,ue)},get storagePath(){var ue;return(ue=ae._storagePath.workspaceValue(M))===null||ue===void 0?void 0:ue.fsPath},get globalStoragePath(){return ae._storagePath.globalValue(M).fsPath},get logPath(){return y.join(ae._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return i.URI.joinPath(ae._initData.logsLocation,M.identifier.value)},get storageUri(){return ae._storagePath.workspaceValue(M)},get globalStorageUri(){return ae._storagePath.globalValue(M)},get extensionMode(){return te},get extensionRuntime(){return p.checkProposedApiEnabled(M),ae.extensionRuntime},get environmentVariableCollection(){return ae._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,j,re,F,te){return re=re||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,j,re,F,te).then(ae=>new d.ActivatedExtension(!1,null,te.build(),re,ae,F.subscriptions))}static _callActivateOptional(M,j,re,F,te){if(typeof re.activate=="function")try{te.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${j.value}`);const ae=typeof global=="object"?global:self,ue=re.activate.apply(ae,[F]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(ue).then(we=>(te.activateResolveStop(),we))}catch(ae){return Promise.reject(ae)}else return Promise.resolve(re)}_activateOneStartupFinished(M,j){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:j}).then(void 0,re=>{this._logService.error(re)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(A.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const j of M.activationEvents)j==="onStartupFinished"&&this._activateOneStartupFinished(M,j)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,te=>{this._logService.error(te)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(te=>this._handleWorkspaceContainsEagerExtensions(te.added)));const j=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],re=this._handleWorkspaceContainsEagerExtensions(j),F=Promise.all([M,re]).then(()=>{});return Promise.race([F,E.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),F}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(j=>this._handleWorkspaceContainsEagerExtension(M,j))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,j){if(!this.isActivated(j.identifier)){const re=!this._initData.remote.isRemote&&!!this._initData.remote.authority,F={folders:M.map(ae=>ae.uri),forceUsingSearch:re,exists:ae=>this._hostUtils.exists(ae.fsPath),checkExists:(ae,ue,we)=>this._mainThreadWorkspaceProxy.$checkExists(ae,ue,we)},te=await R.checkActivateWorkspaceContainsExtension(F,j);if(!!te)return this._activateById(j.identifier,{startup:!0,extensionId:j.identifier,activationEvent:te.activationEvent}).then(void 0,ae=>this._logService.error(ae))}}_handleExtensionTests(){return this._doHandleExtensionTests().then(void 0,M=>(console.error(M),Promise.reject(M)))}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:j}=this._initData.environment;if(!(M&&j&&j.scheme===o.Schemas.file))return Promise.resolve(void 0);const re=T.originalFSPath(j);let F,te;try{F=await this._loadCommonJSModule(null,i.URI.file(re),new d.ExtensionActivationTimesBuilder(!1))}catch(ae){te=ae}return F&&typeof F.run=="function"?new Promise((ae,ue)=>{const we=(De,Se)=>{De?ue(De.toString()):ae(void 0),this._testRunnerExit(De||typeof Se=="number"&&Se>0?1:0)},fe=F.run(re,we);fe&&fe.then&&fe.then(()=>{ae(),this._testRunnerExit(0)}).catch(De=>{ue(De.toString()),this._testRunnerExit(1)})}):(this._testRunnerExit(1),Promise.reject(new Error(te?te.toString():b.localize(0,null,re))))}_testRunnerExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.flush();const j=this._mainThreadExtensionsProxy.$onExtensionHostExit(M),re=this._extHostContext.drain();Promise.race([Promise.all([j,re]),E.timeout(5e3)]).then(()=>{this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>this._handleExtensionTests()).then(()=>{this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,j){return this._resolvers[M]=j,k.toDisposable(()=>{delete this._resolvers[M]})}async $resolveAuthority(M,j){const re=M.indexOf("+");if(re===-1)throw new Error("Not an authority that can be resolved!");const F=M.substr(0,re);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${F}`,!1);const te=this._resolvers[F];if(!te)return{type:"error",error:{code:l.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${F}.`,detail:void 0}};try{A.mark(`code/extHost/willResolveAuthority/${F}`);const ae=await te.resolve(M,{resolveAttempt:j});A.mark(`code/extHost/didResolveAuthorityOK/${F}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(te));const ue={authority:M,host:ae.host,port:ae.port,connectionToken:ae.connectionToken},we={extensionHostEnv:ae.extensionHostEnv};return{type:"ok",value:{authority:ue,options:we,tunnelInformation:{environmentTunnels:ae.environmentTunnels}}}}catch(ae){if(A.mark(`code/extHost/didResolveAuthorityError/${F}`),ae instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae}}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,j){return j===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(re=>this._activateByEvent(M,!1))}async $activate(M,j){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,j),!0):!1}async $deltaExtensions(M,j){M.forEach(F=>F.extensionLocation=i.URI.revive(F.extensionLocation));const re=await this.getExtensionPathIndex();return await Promise.all(j.map(async F=>{const te=this._registry.getExtensionDescription(F);if(!!te){const ae=await this._hostUtils.realpath(te.extensionLocation.fsPath);re.delete(i.URI.file(ae).fsPath)}})),await Promise.all(M.map(async F=>{const te=await this._hostUtils.realpath(F.extensionLocation.fsPath);re.set(i.URI.file(te).fsPath,F)})),this._registry.deltaExtensions(M,j),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let j=h.VSBuffer.alloc(M),re=Math.random()%256;for(let F=0;F<M;F++)j.writeUInt8(re,F);return j}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};z=He([Be(0,u.IInstantiationService),Be(1,e.IHostUtils),Be(2,C.IExtHostRpcService),Be(3,m.IExtHostWorkspace),Be(4,v.IExtHostConfiguration),Be(5,P.ILogService),Be(6,r.IExtHostInitDataService),Be(7,g.IExtensionStoragePaths),Be(8,D.IExtHostTunnelService),Be(9,w.IExtHostTerminalService)],z),e.AbstractExtHostExtensionService=z;function U(q,M){return{id:q.identifier.value,name:q.name,extensionVersion:q.version,publisherDisplayName:q.publisher,activationEvents:q.activationEvents?q.activationEvents.join(","):null,isBuiltin:q.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=u.createDecorator("IExtHostExtensionService")}),define(ve[100],_e([0,1,10,2,3,15,5,7,157,31,36,40,167,35,158,13,4,12]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d,a,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=p.createDecorator("IExtHostDebugService");let c=class{constructor(r,g,C,_,D){this._workspaceService=g,this._extensionService=C,this._editorsService=_,this._configurationService=D,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new A.Emitter,this._onDidTerminateDebugSession=new A.Emitter,this._onDidChangeActiveDebugSession=new A.Emitter,this._onDidReceiveDebugSessionCustomEvent=new A.Emitter,this._debugServiceProxy=r.getProxy(E.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new A.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new o(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(w=>{w.onDidChange(O=>{this.registerAllDebugTypes(w)}),this.registerAllDebugTypes(w)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole}asDebugSourceUri(r,g){const C=r;if(typeof C.sourceReference=="number"&&C.sourceReference>0){let _=`debug:${encodeURIComponent(C.path||"")}`,D="?";return g&&(_+=`${D}session=${encodeURIComponent(g.id)}`,D="&"),_+=`${D}ref=${C.sourceReference}`,y.URI.parse(_)}else{if(C.path)return y.URI.file(C.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const g=[];for(const C of r.getAllExtensionDescriptions())if(C.contributes){const _=C.contributes.debuggers;if(_&&_.length>0)for(const D of _)a.isDebuggerMainContribution(D)&&g.push(D.type)}this._debugServiceProxy.$registerDebugTypes(g)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(g=>r.push(g)),r}addBreakpoints(r){this.startBreakpoints();const g=r.filter(D=>{const w=D.id;return this._breakpoints.has(w)?!1:(this._breakpoints.set(w,D),!0)});this.fireBreakpointChanges(g,[],[]);const C=[],_=new Map;for(const D of g)if(D instanceof k.SourceBreakpoint){let w=_.get(D.location.uri.toString());w||(w={type:"sourceMulti",uri:D.location.uri,lines:[]},_.set(D.location.uri.toString(),w),C.push(w)),w.lines.push({id:D.id,enabled:D.enabled,condition:D.condition,hitCondition:D.hitCondition,logMessage:D.logMessage,line:D.location.range.start.line,character:D.location.range.start.character})}else D instanceof k.FunctionBreakpoint&&C.push({type:"function",id:D.id,enabled:D.enabled,hitCondition:D.hitCondition,logMessage:D.logMessage,condition:D.condition,functionName:D.functionName});return this._debugServiceProxy.$registerBreakpoints(C)}removeBreakpoints(r){this.startBreakpoints();const g=r.filter(w=>this._breakpoints.delete(w.id));this.fireBreakpointChanges([],g,[]);const C=g.filter(w=>w instanceof k.SourceBreakpoint).map(w=>w.id),_=g.filter(w=>w instanceof k.FunctionBreakpoint).map(w=>w.id),D=g.filter(w=>w instanceof k.DataBreakpoint).map(w=>w.id);return this._debugServiceProxy.$unregisterBreakpoints(C,_,D)}startDebugging(r,g,C){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,g,{parentSessionID:C.parentSession?C.parentSession.id:void 0,repl:C.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:C.noDebug,compact:C.compact})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,g,C){if(!g)return new k.Disposable(()=>{});const _=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:_,provider:g}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,C,!!g.provideDebugConfigurations,!!g.resolveDebugConfiguration,!!g.resolveDebugConfigurationWithSubstitutedVariables,_),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(D=>D.provider!==g),this._debugServiceProxy.$unregisterDebugConfigurationProvider(_)})}registerDebugAdapterDescriptorFactory(r,g,C){if(!C)return new k.Disposable(()=>{});if(!this.definesDebugType(r,g))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${g}' debugger.`);if(this.getAdapterDescriptorFactoryByType(g))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const _=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:g,handle:_,factory:C}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(g,_),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(D=>D.factory!==C),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(_)})}registerDebugAdapterTrackerFactory(r,g){if(!g)return new k.Disposable(()=>{});const C=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:C,factory:g}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(_=>_.factory!==g)})}async $runInTerminal(r){return Promise.resolve(void 0)}async $substituteVariables(r,g){if(!this._variableResolver){const[D,w]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(D||[],this._editorsService,w)}let C;const _=await this.getFolder(r);return _&&(C={uri:_.uri,name:_.name,index:_.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAny(C,g)}createDebugAdapter(r,g){if(r.type==="implementation")return new s(r.implementation)}createSignService(){}async $startDASession(r,g){const C=this,_=await this.getSession(g);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(_.type),_).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}' (extension might have failed to activate)`);const w=this.convertToDto(D),O=this.createDebugAdapter(w,_);if(!O)throw new Error(`Couldn't create a debug adapter for type '${_.type}'.`);const R=O;return this._debugAdapters.set(r,R),this.getDebugAdapterTrackers(_).then($=>($&&this._debugAdaptersTrackers.set(r,$),R.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const z=V,U={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const q=await this._signService.sign(z.arguments.value);U.body={signature:q},R.sendResponse(U)}else throw new Error("no signer")}catch(q){U.success=!1,U.message=q.message,R.sendResponse(U)}}else $&&$.onDidSendMessage&&$.onDidSendMessage(V),V=a.convertToVSCPaths(V,!0),C._debugServiceProxy.$acceptDAMessage(r,V)}),R.onError(V=>{$&&$.onError&&$.onError(V),this._debugServiceProxy.$acceptDAError(r,V.name,V.message,V.stack)}),R.onExit(V=>{$&&$.onExit&&$.onExit(f.withNullAsUndefined(V),void 0),this._debugServiceProxy.$acceptDAExit(r,f.withNullAsUndefined(V),void 0)}),$&&$.onWillStartSession&&$.onWillStartSession(),R.startSession()))})}$sendDAMessage(r,g){g=a.convertToDAPaths(g,!1);const C=this._debugAdaptersTrackers.get(r);C&&C.onWillReceiveMessage&&C.onWillReceiveMessage(g);const _=this._debugAdapters.get(r);_&&_.sendMessage(g)}$stopDASession(r){const g=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),g&&g.onWillStopSession&&g.onWillStopSession();const C=this._debugAdapters.get(r);return this._debugAdapters.delete(r),C?C.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const g=[],C=[],_=[];if(r.added)for(const D of r.added){const w=D.id;if(w&&!this._breakpoints.has(w)){let O;if(D.type==="function")O=new k.FunctionBreakpoint(D.functionName,D.enabled,D.condition,D.hitCondition,D.logMessage);else if(D.type==="data")O=new k.DataBreakpoint(D.label,D.dataId,D.canPersist,D.enabled,D.hitCondition,D.condition,D.logMessage);else{const R=y.URI.revive(D.uri);O=new k.SourceBreakpoint(new k.Location(R,new k.Position(D.line,D.character)),D.enabled,D.condition,D.hitCondition,D.logMessage)}O._id=w,this._breakpoints.set(w,O),g.push(O)}}if(r.removed)for(const D of r.removed){const w=this._breakpoints.get(D);w&&(this._breakpoints.delete(D),C.push(w))}if(r.changed){for(const D of r.changed)if(D.id){const w=this._breakpoints.get(D.id);if(w){if(w instanceof k.FunctionBreakpoint&&D.type==="function"){const O=w;O.enabled=D.enabled,O.condition=D.condition,O.hitCondition=D.hitCondition,O.logMessage=D.logMessage,O.functionName=D.functionName}else if(w instanceof k.SourceBreakpoint&&D.type==="source"){const O=w;O.enabled=D.enabled,O.condition=D.condition,O.hitCondition=D.hitCondition,O.logMessage=D.logMessage,O.location=new k.Location(y.URI.revive(D.uri),new k.Position(D.line,D.character))}_.push(w)}}}this.fireBreakpointChanges(g,C,_)}$provideDebugConfigurations(r,g,C){return T.asPromise(async()=>{const _=this.getConfigProviderByHandle(r);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const D=await this.getFolder(g);return _.provideDebugConfigurations(D,C)}).then(_=>{if(!_)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return _})}$resolveDebugConfiguration(r,g,C,_){return T.asPromise(async()=>{const D=this.getConfigProviderByHandle(r);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const w=await this.getFolder(g);return D.resolveDebugConfiguration(w,C,_)})}$resolveDebugConfigurationWithSubstitutedVariables(r,g,C,_){return T.asPromise(async()=>{const D=this.getConfigProviderByHandle(r);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const w=await this.getFolder(g);return D.resolveDebugConfigurationWithSubstitutedVariables(w,C,_)})}async $provideDebugAdapter(r,g){const C=this.getAdapterDescriptorFactoryByHandle(r);if(!C)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const _=await this.getSession(g);return this.getAdapterDescriptor(C,_).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}'`);return this.convertToDto(D)})}async $acceptDebugSessionStarted(r){const g=await this.getSession(r);this._onDidStartDebugSession.fire(g)}async $acceptDebugSessionTerminated(r){const g=await this.getSession(r);g&&(this._onDidTerminateDebugSession.fire(g),this._debugSessions.delete(g.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,g){const C=await this.getSession(r);C&&C._acceptNameChanged(g)}async $acceptDebugSessionCustomEvent(r,g){const _={session:await this.getSession(r),event:g.event,body:g.body};this._onDidReceiveDebugSessionCustomEvent.fire(_)}convertToDto(r){if(r instanceof k.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof k.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const g=this._adapterFactories.filter(C=>C.type===r);if(g.length>0)return g[0].factory}getAdapterDescriptorFactoryByHandle(r){const g=this._adapterFactories.filter(C=>C.handle===r);if(g.length>0)return g[0].factory}getConfigProviderByHandle(r){const g=this._configProviders.filter(C=>C.handle===r);if(g.length>0)return g[0].provider}definesDebugType(r,g){if(r.contributes){const C=r.contributes.debuggers;if(C&&C.length>0){for(const _ of C)if(_.label&&_.type&&_.type===g)return!0}}return!1}getDebugAdapterTrackers(r){const C=r.configuration.type,_=this._trackerFactories.filter(D=>D.type===C||D.type==="*").map(D=>T.asPromise(()=>D.factory.createDebugAdapterTracker(r)).then(w=>w,w=>null));return Promise.race([Promise.all(_).then(D=>{const w=D.filter(O=>!!O);if(w.length>0)return new t(w)}),new Promise((D,w)=>{const O=setTimeout(()=>{clearTimeout(O),w(new Error("timeout"))},1e3)})]).catch(D=>{})}async getAdapterDescriptor(r,g){const C=g.configuration.debugServer;if(typeof C=="number")return Promise.resolve(new k.DebugAdapterServer(C));if(r){const D=await this._extensionService.getExtensionRegistry();return T.asPromise(()=>r.createDebugAdapterDescriptor(g,this.daExecutableFromPackage(g,D))).then(w=>{if(w)return w})}const _=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(g,_))}daExecutableFromPackage(r,g){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,g,C){(r.length>0||g.length>0||C.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:g,changed:C}))}async getSession(r){if(r)if(typeof r=="string"){const g=this._debugSessions.get(r);if(g)return g}else{let g=this._debugSessions.get(r.id);if(!g){const C=await this.getFolder(r.folderUri);g=new n(this._debugServiceProxy,r.id,r.type,r.name,C,r.configuration),this._debugSessions.set(g.id,g),this._debugServiceProxy.$sessionCached(g.id)}return g}throw new Error("cannot find session")}getFolder(r){if(r){const g=y.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(g)}return Promise.resolve(void 0)}};c=He([Be(0,m.IExtHostRpcService),Be(1,i.IExtHostWorkspace),Be(2,P.IExtHostExtensionService),Be(3,S.IExtHostDocumentsAndEditors),Be(4,d.IExtHostConfiguration)],c),e.ExtHostDebugServiceBase=c;class n{constructor(r,g,C,_,D,w){this._debugServiceProxy=r,this._id=g,this._type=C,this._name=_,this._workspaceFolder=D,this._configuration=w}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,g){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,g)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=n;class o{constructor(r){this._debugServiceProxy=r}append(r){this._debugServiceProxy.$appendDebugConsole(r)}appendLine(r){this.append(r+`
`)}}e.ExtHostDebugConsole=o;class h extends v.AbstractVariableResolverService{constructor(r,g,C,_,D){super({getFolderUri:w=>{const O=r.filter(R=>R.name===w);if(O&&O.length>0)return O[0].uri},getWorkspaceFolderCount:()=>r.length,getConfigurationValue:(w,O)=>C.getConfiguration(void 0,w).get(O),getExecPath:()=>_?_.VSCODE_EXEC_PATH:void 0,getFilePath:()=>{if(g){const w=g.activeEditor();if(w)return b.normalize(w.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(g&&D){const w=g.activeEditor();if(w){const O=D.getWorkspaceFolder(w.document.uri);if(O)return b.normalize(O.uri.fsPath)}}},getSelectedText:()=>{if(g){const w=g.activeEditor();if(w&&!w.selection.isEmpty)return w.document.getText(w.selection)}},getLineNumber:()=>{if(g){const w=g.activeEditor();if(w)return String(w.selection.end.line+1)}}},void 0,_)}}e.ExtHostVariableResolverService=h;class t{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(g=>g.onWillReceiveMessage?g.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(g=>g.onDidSendMessage?g.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(g=>g.onError?g.onError(r):void 0)}onExit(r,g){this.trackers.forEach(C=>C.onExit?C.onExit(r,g):void 0)}}class s extends I.AbstractDebugAdapter{constructor(r){super();this.implementation=r,r.onDidSendMessage(g=>{this.acceptMessage(g)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let l=class extends c{constructor(r,g,C,_,D){super(r,g,C,_,D)}createVariableResolver(r,g,C){return new h(r,g,C)}};l=He([Be(0,m.IExtHostRpcService),Be(1,i.IExtHostWorkspace),Be(2,P.IExtHostExtensionService),Be(3,S.IExtHostDocumentsAndEditors),Be(4,d.IExtHostConfiguration)],l),e.WorkerExtHostDebugService=l}),define(ve[212],_e([0,1,78,2,5,35,34,25,13,28,4,36,37,17]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(n,o,h,t,s,l,u){this._apiFactory=n,this._extensionRegistry=o,this._instaService=h,this._extHostConfiguration=t,this._extHostExtensionService=s,this._initData=l,this._logService=u,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),b.mark("code/extHost/willWaitForConfig");const n=await this._extHostConfiguration.getConfigProvider();b.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new m(this._apiFactory,o,this._extensionRegistry,n,this._logService)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(f,o,this._initData.environment.appUriScheme))}register(n){if(Array.isArray(n.nodeModuleName))for(let o of n.nodeModuleName)this._factories.set(o,n);else this._factories.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this._alternatives.push(o=>n.alternativeModuleName(o))}};a=He([Be(2,P.IInstantiationService),Be(3,T.IExtHostConfiguration),Be(4,S.IExtHostExtensionService),Be(5,i.IExtHostInitDataService),Be(6,d.ILogService)],a),e.RequireInterceptor=a;class m{constructor(n,o,h,t,s){this._apiFactory=n,this._extensionPaths=o,this._extensionRegistry=h,this._configProvider=t,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(n,o){const h=this._extensionPaths.findSubstr(o.fsPath);if(h){let t=this._extApiImpl.get(k.ExtensionIdentifier.toKey(h.identifier));return t||(t=this._apiFactory(h,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(h.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((s,l)=>t+=`	${l} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(E.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(n,o){this.nodeModuleName="keytar";const{environment:h}=o,t=n.getProxy(A.MainContext.MainThreadKeytar);if(h.appRoot){let s=h.appRoot.fsPath;v.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,l)=>t.$getPassword(s,l),setPassword:(s,l,u)=>t.$setPassword(s,l,u),deletePassword:(s,l)=>t.$deletePassword(s,l),findPassword:s=>t.$findPassword(s),findCredentials(s){return t.$findCredentials(s)}}}load(n,o){return this._impl}alternativeModuleName(n){const o=n.length;if(!(o<=7||!this.alternativeNames)){const h=o-7;if((n.charAt(h)==="/"||n.charAt(h)==="\\")&&n.endsWith("keytar")&&(n=n.replace(/\\/g,"/"),this.alternativeNames.has(n)))return"keytar"}}};p=He([Be(0,I.IExtHostRpcService),Be(1,i.IExtHostInitDataService)],p);let f=class{constructor(n,o,h){this._extensionPaths=n,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=h.getProxy(A.MainContext.MainThreadTelemetry);const t=h.getProxy(A.MainContext.MainThreadWindow);this._impl=(s,l)=>{const u=y.URI.parse(s);return l?this.callOriginal(s,l):u.scheme==="http"||u.scheme==="https"?t.$openUri(u,s,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this._appUriScheme?t.$openUri(u,s,{}):this.callOriginal(s,l)}}load(n,o,h){const t=this._extensionPaths.findSubstr(o.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=h(n),this._impl}callOriginal(n,o){return this.sendNoForwardTelemetry(),this._original(n,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};f=He([Be(2,I.IExtHostRpcService)],f)}),define(ve[213],_e([0,1,15,9,78,6,2,5,205,17,62,66,28,143,13,70,36,41]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d,a,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class c{constructor(o,h,t,s){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const l=new I.RPCProtocol(o,null,s);h=c._transform(h,l);const u=new S.ServiceCollection(...P.getSingletonServiceDescriptors());u.set(v.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},h)),u.set(a.IExtHostRpcService,new a.ExtHostRpcService(l)),u.set(m.IURITransformerService,new m.URITransformerService(s)),u.set(p.IHostUtils,t);const r=new d.InstantiationService(u,!0),g=r.invokeFunction(w=>w.get(f.IExtHostTerminalService));this._disposables.add(g),this._logService=r.invokeFunction(w=>w.get(i.ILogService)),A.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",h),this._extensionService=r.invokeFunction(w=>w.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const C=new WeakMap;this._extensionService.getExtensionPathIndex().then(w=>{Error.prepareStackTrace=(O,R)=>{let $="",V,z;for(const U of R)$+=`
	at ${U.toString()}`,z=U.getFileName(),!V&&z&&(V=w.findSubstr(z));return C.set(O,V),`${O.name||"Error"}: ${O.message||""}${$}`}});const _=l.getProxy(k.MainContext.MainThreadExtensionService),D=l.getProxy(k.MainContext.MainThreadErrors);y.setUnexpectedErrorHandler(w=>{const O=y.transformErrorForSerialization(w),R=C.get(w);R?_.$onExtensionRuntimeError(R.identifier,O):D.$onUnexpectedError(O)})}terminate(o){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${o}`),this._logService.flush(),this._disposables.dispose(),y.setUnexpectedErrorHandler(t=>{});const h=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([b.timeout(4e3),h]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(o,h){o.extensions.forEach(s=>s.extensionLocation=E.URI.revive(h.transformIncomingURIs(s.extensionLocation))),o.environment.appRoot=E.URI.revive(h.transformIncomingURIs(o.environment.appRoot));const t=o.environment.extensionDevelopmentLocationURI;return t&&(o.environment.extensionDevelopmentLocationURI=t.map(s=>E.URI.revive(h.transformIncomingURIs(s)))),o.environment.extensionTestsLocationURI=E.URI.revive(h.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=E.URI.revive(h.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=E.URI.revive(h.transformIncomingURIs(o.environment.workspaceStorageHome)),o.logsLocation=E.URI.revive(h.transformIncomingURIs(o.logsLocation)),o.logFile=E.URI.revive(h.transformIncomingURIs(o.logFile)),o.workspace=h.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=c}),define(ve[214],_e([0,1,10,20,61,29,23,55,42,37]),function(se,e,b,y,A,T,E,k,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(d,a,m){this.config=d,this.provider=a,this.sessionToken=m,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&T.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&T.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const a=this.config.folderQueries||[];return new Promise((m,p)=>{const f=c=>{this.resultCount++,d(c)};if(this.isCanceled)return m({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(c=>{const n=c.toString(),o=b.basename(n);this.globalExcludePattern&&this.globalExcludePattern(n,o)||this.matchFile(f,{base:c,basename:o})}),Promise.all(a.map(c=>this.searchInFolder(c,f))).then(c=>{m({limitHit:this.isLimitHit,stats:c[0]||void 0})},c=>{p(new Error(A.toErrorMessage(c)))})})}searchInFolder(d,a){const m=new y.CancellationTokenSource;return new Promise((p,f)=>{const c=this.getSearchOptionsForFolder(d),n=this.initDirectoryTree(),o=new I.QueryGlobTester(this.config,d),h=!o.hasSiblingExcludeClauses();let t;new Promise(s=>i.nextTick(s)).then(()=>(this.activeCancellationTokens.add(m),t=k.StopWatch.create(),this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},c,m.token))).then(s=>{const l=t.elapsed(),u=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(s&&s.forEach(r=>{const g=b.posix.relative(d.folder.path,r.path);if(h){const C=b.basename(r.path);this.matchFile(a,{base:d.folder,relativePath:g,basename:C});return}this.addDirectoryEntries(n,d.folder,g,a)}),this.activeCancellationTokens.delete(m),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(n,o,a),{providerTime:l,postProcessTime:u.elapsed()})}).then(s=>{m.dispose(),p(s)},s=>{m.dispose(),f(s)})})}getSearchOptionsForFolder(d){const a=I.resolvePatternsForProvider(this.config.includePattern,d.includePattern),m=I.resolvePatternsForProvider(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:m,includes:a,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},a,m,p){if(m===this.filePattern){const c=b.basename(this.filePattern);this.matchFile(p,{base:a,relativePath:this.filePattern,basename:c})}function f(c){const n=b.basename(c),o=b.dirname(c);let h=d[o];h||(h=d[o]=[],f(o)),h.push({base:a,relativePath:c,basename:n})}f(m)}matchDirectoryTree({rootEntries:d,pathToEntries:a},m,p){const f=this,c=this.filePattern;function n(o){const h=T.hasSiblingFn(()=>o.map(t=>t.basename));for(let t=0,s=o.length;t<s;t++){const l=o[t],{relativePath:u,basename:r}=l;if(!!m.includedInQuerySync(u,r,c!==r?h:void 0)){const g=a[u];if(g)n(g);else{if(u===c)continue;f.matchFile(p,l)}if(f.isLimitHit)break}}}n(d)}matchFile(d,a){(!this.includePattern||a.relativePath&&this.includePattern(a.relativePath,a.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(a))}}class S{constructor(){this.sessions=new Map}fileSearch(d,a,m,p){const f=this.getSessionTokenSource(d.cacheKey),c=new P(d,a,f&&f.token);let n=0;const o=h=>{n+=h.length,m(h.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(c,S.BATCH_SIZE,o,p).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:h.stats}}))}clearCache(d){const a=this.getSessionTokenSource(d);a&&a.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new y.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:E.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,a,m,p){p.onCancellationRequested(()=>{d.cancel()});const f=n=>{n&&(c.push(n),a>0&&c.length>=a&&(m(c),c=[]))};let c=[];return d.search(f).then(n=>(c.length&&m(c),n),n=>(c.length&&m(c),Promise.reject(n)))}}e.FileSearchManager=S,S.BATCH_SIZE=512}),define(ve[215],_e([0,1,10,11,20,61,23,29,2,42,37,16]),function(se,e,b,y,A,T,E,k,I,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class v{constructor(n,o,h){this.query=n,this.provider=o,this.fileUtils=h,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(n,o){const h=this.query.folderQueries||[],t=new A.CancellationTokenSource;return o.onCancellationRequested(()=>t.cancel()),new Promise((s,l)=>{this.collector=new a(n);let u=!1;const r=(g,C)=>{if(!u&&!this.isLimitHit){const _=this.resultSize(g);p(g)&&typeof this.query.maxResults=="number"&&this.resultCount+_>this.query.maxResults&&(this.isLimitHit=!0,u=!0,t.cancel(),g=this.trimResultToSize(g,this.query.maxResults-this.resultCount));const D=this.resultSize(g);this.resultCount+=D,(D>0||!p(g))&&this.collector.add(g,C)}};Promise.all(h.map((g,C)=>this.searchInFolder(g,_=>r(_,C),t.token))).then(g=>{t.dispose(),this.collector.flush();const C=g.some(_=>!!_&&!!_.limitHit);s({limitHit:this.isLimitHit||C,stats:{type:"textSearchProvider"}})},g=>{t.dispose();const C=T.toErrorMessage(g);l(new Error(C))})})}resultSize(n){return p(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}trimResultToSize(n,o){const h=Array.isArray(n.ranges)?n.ranges:[n.ranges],t=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:h.slice(0,o),preview:{matches:t.slice(0,o),text:n.preview.text},uri:n.uri}}searchInFolder(n,o,h){const t=new i.QueryGlobTester(this.query,n),s=[],l={report:r=>{if(!!this.validateProviderResult(r)){const g=n.folder.scheme===S.Schemas.file?k.hasSiblingPromiseFn(()=>this.fileUtils.readdir(E.dirname(r.uri))):void 0,C=E.relativePath(n.folder,r.uri);C&&s.push(t.includedInQuery(C,b.basename(C),g).then(_=>{_&&o(r)}))}}},u=this.getSearchOptionsForFolder(n);return new Promise(r=>P.nextTick(r)).then(()=>this.provider.provideTextSearchResults(d(this.query.contentPattern),u,l,h)).then(r=>Promise.all(s).then(()=>r))}validateProviderResult(n){if(p(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(n){const o=i.resolvePatternsForProvider(this.query.includePattern,n.includePattern),h=i.resolvePatternsForProvider(this.query.excludePattern,n.excludePattern),t={folder:I.URI.from(n.folder),excludes:h,includes:o,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.fileUtils.toCanonicalName(n.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=v;function d(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class a{constructor(n){this._onResult=n,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new f(512,o=>this.sendItems(o))}add(n,o){this._currentFileMatch&&(this._currentFolderIdx!==o||!E.isEqual(this._currentUri,n.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=o,this._currentFileMatch={resource:n.uri,results:[]}),this._currentFileMatch.results.push(m(n))}pushToCollector(){const n=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,n)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(n){this._onResult(n)}}e.TextSearchResultsCollector=a;function m(c){return p(c)?{preview:{matches:y.mapArrayOrNot(c.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:c.preview.text},ranges:y.mapArrayOrNot(c.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function p(c){return!!c.preview}e.extensionResultIsMatch=p;class f{constructor(n,o){this.maxBatchSize=n,this.cb=o,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(n,o){!n||this.addItemToBatch(n,o)}addItems(n,o){!n||this.addItemsToBatch(n,o)}addItemToBatch(n,o){this.batch.push(n),this.batchSize+=o,this.onUpdate()}addItemsToBatch(n,o){this.batch=this.batch.concat(n),this.batchSize+=o,this.onUpdate()}onUpdate(){this.totalNumberCompleted<f.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},f.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=f,f.TIMEOUT=4e3,f.START_BATCH_AFTER_COUNT=50}),define(ve[101],_e([0,1,6,5,4,214,13,70,17,2,215]),function(se,e,b,y,A,T,E,k,I,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=A.createDecorator("IExtHostSearch");let S=class{constructor(m,p,f){this.extHostRpc=m,this._uriTransformer=p,this._logService=f,this._proxy=this.extHostRpc.getProxy(y.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}registerTextSearchProvider(m,p){if(this._textSearchUsedSchemes.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this._textSearchUsedSchemes.add(m);const f=this._handlePool++;return this._textSearchProvider.set(f,p),this._proxy.$registerTextSearchProvider(f,this._transformScheme(m)),b.toDisposable(()=>{this._textSearchUsedSchemes.delete(m),this._textSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}registerFileSearchProvider(m,p){if(this._fileSearchUsedSchemes.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this._fileSearchUsedSchemes.add(m);const f=this._handlePool++;return this._fileSearchProvider.set(f,p),this._proxy.$registerFileSearchProvider(f,this._transformScheme(m)),b.toDisposable(()=>{this._fileSearchUsedSchemes.delete(m),this._fileSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(m,p,f,c){const n=v(f),o=this._fileSearchProvider.get(m);if(o)return this._fileSearchManager.fileSearch(n,o,h=>{this._proxy.$handleFileMatch(m,p,h.map(t=>t.resource))},c);throw new Error("unknown provider: "+m)}$clearCache(m){return this._fileSearchManager.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,p,f,c){const n=this._textSearchProvider.get(m);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const o=v(f);return this.createTextSearchManager(o,n).search(t=>this._proxy.$handleTextMatch(m,p,t),c)}createTextSearchManager(m,p){return new P.TextSearchManager(m,p,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f})}};S=He([Be(0,E.IExtHostRpcService),Be(1,k.IURITransformerService),Be(2,I.ILogService)],S),e.ExtHostSearch=S;function v(a){return Object.assign(Object.assign({},a),{folderQueries:a.folderQueries&&a.folderQueries.map(d),extraFileResources:a.extraFileResources&&a.extraFileResources.map(m=>i.URI.revive(m))})}e.reviveQuery=v;function d(a){return Object.assign(Object.assign({},a),{folder:i.URI.revive(a.folder)})}}),define(ve[216],_e([0,1,124,20,9,3,10,57,2,118,83,112,60,65,5,182,181,74,183,35,184,185,186,170,187,40,36,188,171,190,191,192,97,172,194,195,196,76,41,197,173,14,7,200,49,98,31,34,23,50,154,189,92,96,99,100,101,17,70,13,28,193,162,69,73,179,198,160,77,75,203,201,202,180,48,209,199,72,151]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d,a,m,p,f,c,n,o,h,t,s,l,u,r,g,C,_,D,w,O,R,$,V,z,U,q,M,j,re,F,te,ae,ue,we,fe,De,Se,Ce,x,K,ee,ne,de,Ee,Re,xe,be,ke,Te,Ne,pe,ze,B,Z,he,Le,Oe,We,Ke,ie,ge,Me,G,Q,H,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function J(ce){const me=ce.get(ke.IExtHostInitDataService),Pe=ce.get(Me.IExtHostFileSystemInfo),Fe=ce.get(Oe.IExtHostConsumerFileSystem),je=ce.get(r.IExtHostExtensionService),qe=ce.get(we.IExtHostWorkspace),Ge=ce.get(n.IExtHostConfiguration),st=ce.get(xe.IURITransformerService),$e=ce.get(be.IExtHostRpcService),Qe=ce.get(U.IExtHostStorage),ht=ce.get(Le.IExtensionStoragePaths),et=ce.get(Re.ILogService),ft=ce.get(pe.IExtHostTunnelService),ot=ce.get(ze.IExtHostApiDeprecationService),Ze=ce.get(ue.IExtHostWindow),Et=ce.get(H.IExtHostSecretState);$e.set(a.ExtHostContext.ExtHostFileSystemInfo,Pe),$e.set(a.ExtHostContext.ExtHostLogService,et),$e.set(a.ExtHostContext.ExtHostWorkspace,qe),$e.set(a.ExtHostContext.ExtHostConfiguration,Ge),$e.set(a.ExtHostContext.ExtHostExtensionService,je),$e.set(a.ExtHostContext.ExtHostStorage,Qe),$e.set(a.ExtHostContext.ExtHostTunnelService,ft),$e.set(a.ExtHostContext.ExtHostWindow,Ze),$e.set(a.ExtHostContext.ExtHostSecretState,Et);const vt=$e.set(a.ExtHostContext.ExtHostDecorations,ce.get(ee.IExtHostDecorations)),mt=$e.set(a.ExtHostContext.ExtHostDocumentsAndEditors,ce.get(u.IExtHostDocumentsAndEditors)),at=$e.set(a.ExtHostContext.ExtHostCommands,ce.get(f.IExtHostCommands)),ut=$e.set(a.ExtHostContext.ExtHostTerminalService,ce.get(q.IExtHostTerminalService)),rt=$e.set(a.ExtHostContext.ExtHostDebugService,ce.get(de.IExtHostDebugService)),St=$e.set(a.ExtHostContext.ExtHostSearch,ce.get(Ee.IExtHostSearch)),_t=$e.set(a.ExtHostContext.ExtHostTask,ce.get(ne.IExtHostTask)),wt=$e.set(a.ExtHostContext.ExtHostOutputService,ce.get(O.IExtHostOutputService)),gt=$e.set(a.ExtHostContext.ExtHostEditorTabs,new L.ExtHostEditorTabs),yt=$e.set(a.ExtHostContext.ExtHostUrls,new te.ExtHostUrls($e)),pt=$e.set(a.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments($e,mt)),Pt=$e.set(a.ExtHostContext.ExtHostDocumentContentProviders,new t.ExtHostDocumentContentProvider($e,mt,et)),Dt=$e.set(a.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(et,pt,$e.getProxy(a.MainContext.MainThreadBulkEdits))),tt=$e.set(a.ExtHostContext.ExtHostNotebook,new Te.ExtHostNotebookController($e,at,mt,me.environment,et,ht)),bt=$e.set(a.ExtHostContext.ExtHostEditors,new M.ExtHostEditors($e,mt)),Ot=$e.set(a.ExtHostContext.ExtHostTreeViews,new j.ExtHostTreeViews($e.getProxy(a.MainContext.MainThreadTreeViews),at,et)),xt=$e.set(a.ExtHostContext.ExtHostEditorInsets,new Ce.ExtHostEditorInsets($e.getProxy(a.MainContext.MainThreadEditorInsets),bt,me.environment)),Ft=$e.set(a.ExtHostContext.ExtHostDiagnostics,new o.ExtHostDiagnostics($e,et)),it=$e.set(a.ExtHostContext.ExtHostLanguageFeatures,new _.ExtHostLanguageFeatures($e,st,pt,at,Ft,et,ot)),Wt=$e.set(a.ExtHostContext.ExtHostFileSystem,new g.ExtHostFileSystem($e,it)),kt=$e.set(a.ExtHostContext.ExtHostFileSystemEventService,new C.ExtHostFileSystemEventService($e,et,mt)),Rt=$e.set(a.ExtHostContext.ExtHostQuickOpen,new $.ExtHostQuickOpen($e,qe,at)),Zt=$e.set(a.ExtHostContext.ExtHostSCM,new V.ExtHostSCM($e,at,et)),li=$e.set(a.ExtHostContext.ExtHostComments,new c.ExtHostComments($e,at,pt)),ei=$e.set(a.ExtHostContext.ExtHostProgress,new R.ExtHostProgress($e.getProxy(a.MainContext.MainThreadProgress))),Ht=$e.set(a.ExtHostContext.ExtHosLabelService,new x.ExtHostLabelService($e)),Nt=$e.set(a.ExtHostContext.ExtHostTheming,new Ne.ExtHostTheming($e)),Ct=$e.set(a.ExtHostContext.ExtHostAuthentication,new B.ExtHostAuthentication($e)),ci=$e.set(a.ExtHostContext.ExtHostTimeline,new Z.ExtHostTimeline($e,at)),zt=$e.set(a.ExtHostContext.ExtHostWebviews,new ae.ExtHostWebviews($e,me.environment,qe,et,ot)),Bt=$e.set(a.ExtHostContext.ExtHostWebviewPanels,new ie.ExtHostWebviewPanels($e,zt,qe)),Ut=$e.set(a.ExtHostContext.ExtHostCustomEditors,new Ke.ExtHostCustomEditors($e,pt,ht,zt,Bt)),ui=$e.set(a.ExtHostContext.ExtHostWebviewViews,new We.ExtHostWebviewViews($e,zt)),Tt=$e.set(a.ExtHostContext.ExtHostTesting,new G.ExtHostTesting($e,mt,qe)),Vt=$e.set(a.ExtHostContext.ExtHostUriOpeners,new Q.ExtHostUriOpeners($e)),di=Se.values(a.ExtHostContext);$e.assertRegistered(di);const jt=new ge.ExtHostBulkEdits($e,mt,tt),$t=new p.ExtHostClipboard($e),qt=new w.ExtHostMessageService($e,et),Kt=new h.ExtHostDialogs($e),ti=new z.ExtHostStatusBar($e,at.converter),Gt=new D.ExtHostLanguages($e,pt);return m.ExtHostApiCommands.register(at),function(Ae,Qt,Lt){const ct=function(){let Y=!Ae.isUnderDevelopment;function le(ye){Y||(et.info(`Extension '${Ae.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function ye(Ye){return Array.isArray(Ye)?Ye.forEach(ye):typeof Ye=="string"?le(Ye):(typeof Ye.scheme=="undefined"&&le(Ye),!Ae.enableProposedApi&&typeof Ye.exclusive=="boolean"&&fe.throwProposedApiError(Ae)),Ye}}(),hi={getSession(Y,le,ye){return Ct.getSession(Ae,Y,le,ye)},get onDidChangeSessions(){return Ct.onDidChangeSessions},registerAuthenticationProvider(Y,le,ye,Ye){return fe.checkProposedApiEnabled(Ae),Ct.registerAuthenticationProvider(Y,le,ye,Ye)},get onDidChangeAuthenticationProviders(){return fe.checkProposedApiEnabled(Ae),Ct.onDidChangeAuthenticationProviders},get providers(){return fe.checkProposedApiEnabled(Ae),Ct.providers},logout(Y,le){return fe.checkProposedApiEnabled(Ae),Ct.logout(Y,le)}},fi={registerCommand(Y,le,ye){return at.registerCommand(!0,Y,le,ye)},registerTextEditorCommand(Y,le,ye){return at.registerCommand(!0,Y,(...Ye)=>{const lt=bt.getActiveTextEditor();if(!lt){et.warn("Cannot execute "+Y+" because there is no active text editor.");return}return lt.edit(dt=>{le.apply(ye,[lt,dt,...Ye])}).then(dt=>{dt||et.warn("Edits from command "+Y+" were not applied.")},dt=>{et.warn("An error occurred while running command "+Y,dt)})})},registerDiffInformationCommand:(Y,le,ye)=>(fe.checkProposedApiEnabled(Ae),at.registerCommand(!0,Y,async(...Ye)=>{const lt=bt.getActiveTextEditor();if(!lt){et.warn("Cannot execute "+Y+" because there is no active text editor.");return}const dt=await bt.getDiffInformation(lt.id);le.apply(ye,[dt,...Ye])})),executeCommand(Y,...le){return at.executeCommand(Y,...le)},getCommands(Y=!1){return at.getCommands(Y)}},ii={get machineId(){return me.telemetryInfo.machineId},get sessionId(){return me.telemetryInfo.sessionId},get language(){return me.environment.appLanguage},get appName(){return me.environment.appName},get appRoot(){var Y,le;return(le=(Y=me.environment.appRoot)===null||Y===void 0?void 0:Y.fsPath)!==null&&le!==void 0?le:""},get uriScheme(){return me.environment.appUriScheme},get clipboard(){return $t},get shell(){return ut.getDefaultShell(!1,Lt)},openExternal(Y,le){return Ze.openUri(Y,{allowTunneling:!!me.remote.authority,allowContributedOpeners:le==null?void 0:le.allowContributedOpeners})},asExternalUri(Y){return Y.scheme===me.environment.appUriScheme?yt.createAppUri(Y):Ze.asExternalUri(Y,{allowTunneling:!!me.remote.authority})},get remoteName(){return K.getRemoteName(me.remote.authority)},get uiKind(){return me.uiKind}};me.environment.extensionTestsLocationURI||Object.freeze(ii);const ni=me.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,mi={registerTestProvider(Y){return fe.checkProposedApiEnabled(Ae),Tt.registerTestProvider(Y)},createDocumentTestObserver(Y){return fe.checkProposedApiEnabled(Ae),Tt.createTextDocumentTestObserver(Y)},createWorkspaceTestObserver(Y){return fe.checkProposedApiEnabled(Ae),Tt.createWorkspaceTestObserver(Y)},runTests(Y){return fe.checkProposedApiEnabled(Ae),Tt.runTests(Y)},get onDidChangeTestResults(){return fe.checkProposedApiEnabled(Ae),Tt.onLastResultsChanged},get testResults(){return fe.checkProposedApiEnabled(Ae),Tt.lastResults}},Jt={getExtension(Y){const le=Qt.getExtensionDescription(Y);if(le)return new X(je,Ae.identifier,le,ni)},get all(){return Qt.getAllExtensionDescriptions().map(Y=>new X(je,Ae.identifier,Y,ni))},get onDidChange(){return Qt.onDidChange}},gi={createDiagnosticCollection(Y){return Ft.createDiagnosticCollection(Ae.identifier,Y)},get onDidChangeDiagnostics(){return Ft.onDidChangeDiagnostics},getDiagnostics:Y=>Ft.getDiagnostics(Y),getLanguages(){return Gt.getLanguages()},setTextDocumentLanguage(Y,le){return Gt.changeLanguage(Y.uri,le)},match(Y,le){return v.score(re.LanguageSelector.from(Y),le.uri,le.languageId,!0)},registerCodeActionsProvider(Y,le,ye){return it.registerCodeActionProvider(Ae,ct(Y),le,ye)},registerCodeLensProvider(Y,le){return it.registerCodeLensProvider(Ae,ct(Y),le)},registerDefinitionProvider(Y,le){return it.registerDefinitionProvider(Ae,ct(Y),le)},registerDeclarationProvider(Y,le){return it.registerDeclarationProvider(Ae,ct(Y),le)},registerImplementationProvider(Y,le){return it.registerImplementationProvider(Ae,ct(Y),le)},registerTypeDefinitionProvider(Y,le){return it.registerTypeDefinitionProvider(Ae,ct(Y),le)},registerHoverProvider(Y,le){return it.registerHoverProvider(Ae,ct(Y),le,Ae.identifier)},registerEvaluatableExpressionProvider(Y,le){return it.registerEvaluatableExpressionProvider(Ae,ct(Y),le,Ae.identifier)},registerDocumentHighlightProvider(Y,le){return it.registerDocumentHighlightProvider(Ae,ct(Y),le)},registerLinkedEditingRangeProvider(Y,le){return it.registerLinkedEditingRangeProvider(Ae,ct(Y),le)},registerReferenceProvider(Y,le){return it.registerReferenceProvider(Ae,ct(Y),le)},registerRenameProvider(Y,le){return it.registerRenameProvider(Ae,ct(Y),le)},registerDocumentSymbolProvider(Y,le,ye){return it.registerDocumentSymbolProvider(Ae,ct(Y),le,ye)},registerWorkspaceSymbolProvider(Y){return it.registerWorkspaceSymbolProvider(Ae,Y)},registerDocumentFormattingEditProvider(Y,le){return it.registerDocumentFormattingEditProvider(Ae,ct(Y),le)},registerDocumentRangeFormattingEditProvider(Y,le){return it.registerDocumentRangeFormattingEditProvider(Ae,ct(Y),le)},registerOnTypeFormattingEditProvider(Y,le,ye,...Ye){return it.registerOnTypeFormattingEditProvider(Ae,ct(Y),le,[ye].concat(Ye))},registerDocumentSemanticTokensProvider(Y,le,ye){return it.registerDocumentSemanticTokensProvider(Ae,ct(Y),le,ye)},registerDocumentRangeSemanticTokensProvider(Y,le,ye){return it.registerDocumentRangeSemanticTokensProvider(Ae,ct(Y),le,ye)},registerSignatureHelpProvider(Y,le,ye,...Ye){return typeof ye=="object"?it.registerSignatureHelpProvider(Ae,ct(Y),le,ye):it.registerSignatureHelpProvider(Ae,ct(Y),le,typeof ye=="undefined"?[]:[ye,...Ye])},registerCompletionItemProvider(Y,le,...ye){return it.registerCompletionItemProvider(Ae,ct(Y),le,ye)},registerDocumentLinkProvider(Y,le){return it.registerDocumentLinkProvider(Ae,ct(Y),le)},registerColorProvider(Y,le){return it.registerColorProvider(Ae,ct(Y),le)},registerFoldingRangeProvider(Y,le){return it.registerFoldingRangeProvider(Ae,ct(Y),le)},registerSelectionRangeProvider(Y,le){return it.registerSelectionRangeProvider(Ae,Y,le)},registerCallHierarchyProvider(Y,le){return it.registerCallHierarchyProvider(Ae,Y,le)},setLanguageConfiguration:(Y,le)=>it.setLanguageConfiguration(Ae,Y,le),getTokenInformationAtPosition(Y,le){return fe.checkProposedApiEnabled(Ae),Gt.tokenAtPosition(Y,le)},registerInlineHintsProvider(Y,le){return fe.checkProposedApiEnabled(Ae),it.registerInlineHintsProvider(Ae,Y,le)}},W={get activeTextEditor(){return bt.getActiveTextEditor()},get visibleTextEditors(){return bt.getVisibleTextEditors()},get activeTerminal(){return ut.activeTerminal},get terminals(){return ut.terminals},async showTextDocument(Y,le,ye){const Ye=await(I.URI.isUri(Y)?Promise.resolve(N.openTextDocument(Y)):Promise.resolve(Y));return bt.showTextDocument(Ye,le,ye)},createTextEditorDecorationType(Y){return bt.createTextEditorDecorationType(Y)},onDidChangeActiveTextEditor(Y,le,ye){return bt.onDidChangeActiveTextEditor(Y,le,ye)},onDidChangeVisibleTextEditors(Y,le,ye){return bt.onDidChangeVisibleTextEditors(Y,le,ye)},onDidChangeTextEditorSelection(Y,le,ye){return bt.onDidChangeTextEditorSelection(Y,le,ye)},onDidChangeTextEditorOptions(Y,le,ye){return bt.onDidChangeTextEditorOptions(Y,le,ye)},onDidChangeTextEditorVisibleRanges(Y,le,ye){return bt.onDidChangeTextEditorVisibleRanges(Y,le,ye)},onDidChangeTextEditorViewColumn(Y,le,ye){return bt.onDidChangeTextEditorViewColumn(Y,le,ye)},onDidCloseTerminal(Y,le,ye){return ut.onDidCloseTerminal(Y,le,ye)},onDidOpenTerminal(Y,le,ye){return ut.onDidOpenTerminal(Y,le,ye)},onDidChangeActiveTerminal(Y,le,ye){return ut.onDidChangeActiveTerminal(Y,le,ye)},onDidChangeTerminalDimensions(Y,le,ye){return fe.checkProposedApiEnabled(Ae),ut.onDidChangeTerminalDimensions(Y,le,ye)},onDidWriteTerminalData(Y,le,ye){return fe.checkProposedApiEnabled(Ae),ut.onDidWriteTerminalData(Y,le,ye)},get state(){return Ze.state},onDidChangeWindowState(Y,le,ye){return Ze.onDidChangeWindowState(Y,le,ye)},showInformationMessage(Y,...le){return qt.showMessage(Ae,k.default.Info,Y,le[0],le.slice(1))},showWarningMessage(Y,...le){return qt.showMessage(Ae,k.default.Warning,Y,le[0],le.slice(1))},showErrorMessage(Y,...le){return qt.showMessage(Ae,k.default.Error,Y,le[0],le.slice(1))},showQuickPick(Y,le,ye){return Rt.showQuickPick(Y,!!Ae.enableProposedApi,le,ye)},showWorkspaceFolderPick(Y){return Rt.showWorkspaceFolderPick(Y)},showInputBox(Y,le){return Rt.showInput(Y,le)},showOpenDialog(Y){return Kt.showOpenDialog(Y)},showSaveDialog(Y){return Kt.showSaveDialog(Y)},createStatusBarItem(Y,le){let ye,Ye,lt,dt;return Y&&typeof Y!="number"?(ye=Y.id,Ye=Y.name,lt=Y.alignment,le=Y.priority,dt=Y.accessibilityInformation):(ye=Ae.identifier.value,Ye=b.localize(0,null,Ae.displayName||Ae.name),lt=Y),ti.createStatusBarEntry(ye,Ye,lt,le,dt)},setStatusBarMessage(Y,le){return ti.setStatusBarMessage(Y,le)},withScmProgress(Y){return ot.report("window.withScmProgress",Ae,"Use 'withProgress' instead."),ei.withProgress(Ae,{location:F.ProgressLocation.SourceControl},(le,ye)=>Y({report(Ye){}}))},withProgress(Y,le){return ei.withProgress(Ae,Y,le)},createOutputChannel(Y){return wt.createOutputChannel(Y)},createWebviewPanel(Y,le,ye,Ye){return Bt.createWebviewPanel(Ae,Y,le,ye,Ye)},createWebviewTextEditorInset(Y,le,ye,Ye){return fe.checkProposedApiEnabled(Ae),xt.createWebviewEditorInset(Y,le,ye,Ye,Ae)},createTerminal(Y,le,ye){return typeof Y=="object"?"pty"in Y?ut.createExtensionTerminal(Y):ut.createTerminalFromOptions(Y):ut.createTerminal(Y,le,ye)},registerTerminalLinkProvider(Y){return ut.registerLinkProvider(Y)},registerTreeDataProvider(Y,le){return Ot.registerTreeDataProvider(Y,le,Ae)},createTreeView(Y,le){return Ot.createTreeView(Y,le,Ae)},registerWebviewPanelSerializer:(Y,le)=>Bt.registerWebviewPanelSerializer(Ae,Y,le),registerCustomEditorProvider:(Y,le,ye={})=>Ut.registerCustomEditorProvider(Ae,Y,le,ye),registerFileDecorationProvider(Y){return vt.registerFileDecorationProvider(Y,Ae.identifier)},registerUriHandler(Y){return yt.registerUriHandler(Ae.identifier,Y)},createQuickPick(){return Rt.createQuickPick(Ae.identifier,!!Ae.enableProposedApi)},createInputBox(){return Rt.createInputBox(Ae.identifier)},get activeColorTheme(){return Nt.activeColorTheme},onDidChangeActiveColorTheme(Y,le,ye){return Nt.onDidChangeActiveColorTheme(Y,le,ye)},registerWebviewViewProvider(Y,le,ye){return ui.registerWebviewViewProvider(Ae,Y,le,ye==null?void 0:ye.webviewOptions)},get activeNotebookEditor(){return fe.checkProposedApiEnabled(Ae),tt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,le,ye){return fe.checkProposedApiEnabled(Ae),tt.onDidChangeActiveNotebookEditor(Y,le,ye)},get visibleNotebookEditors(){return fe.checkProposedApiEnabled(Ae),tt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return fe.checkProposedApiEnabled(Ae),tt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,le,ye){return fe.checkProposedApiEnabled(Ae),tt.onDidChangeNotebookEditorSelection(Y,le,ye)},onDidChangeNotebookEditorVisibleRanges(Y,le,ye){return fe.checkProposedApiEnabled(Ae),tt.onDidChangeNotebookEditorVisibleRanges(Y,le,ye)},showNotebookDocument(Y,le){return fe.checkProposedApiEnabled(Ae),tt.showNotebookDocument(Y,le)},registerExternalUriOpener(Y,le,ye){return fe.checkProposedApiEnabled(Ae),Vt.registerExternalUriOpener(Ae.identifier,Y,le,ye)},get openEditors(){return fe.checkProposedApiEnabled(Ae),gt.tabs},get onDidChangeOpenEditors(){return fe.checkProposedApiEnabled(Ae),gt.onDidChangeTabs}},N={get rootPath(){return ot.report("workspace.rootPath",Ae,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),qe.getPath()},set rootPath(Y){throw A.readonly()},getWorkspaceFolder(Y){return qe.getWorkspaceFolder(Y)},get workspaceFolders(){return qe.getWorkspaceFolders()},get name(){return qe.name},set name(Y){throw A.readonly()},get workspaceFile(){return qe.workspaceFile},set workspaceFile(Y){throw A.readonly()},updateWorkspaceFolders:(Y,le,...ye)=>qe.updateWorkspaceFolders(Ae,Y,le||0,...ye),onDidChangeWorkspaceFolders:function(Y,le,ye){return qe.onDidChangeWorkspace(Y,le,ye)},asRelativePath:(Y,le)=>qe.getRelativePath(Y,le),findFiles:(Y,le,ye,Ye)=>qe.findFiles(re.GlobPattern.from(Y),re.GlobPattern.from(le),ye,Ae.identifier,Ye),findTextInFiles:(Y,le,ye,Ye)=>{let lt,dt;return typeof le=="object"?(lt=le,dt=ye):(lt={},dt=le,Ye=ye),qe.findTextInFiles(Y,lt||{},dt,Ae.identifier,Ye)},saveAll:Y=>qe.saveAll(Y),applyEdit(Y){return jt.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,le,ye,Ye)=>kt.createFileSystemWatcher(re.GlobPattern.from(Y),le,ye,Ye),get textDocuments(){return pt.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw A.readonly()},openTextDocument(Y){let le;const ye=Y;if(typeof Y=="string")le=Promise.resolve(I.URI.file(Y));else if(I.URI.isUri(Y))le=Promise.resolve(Y);else if(!ye||typeof ye=="object")le=pt.createDocumentData(ye);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(Ye=>pt.ensureDocumentData(Ye).then(lt=>lt.document))},onDidOpenTextDocument:(Y,le,ye)=>pt.onDidAddDocument(Y,le,ye),onDidCloseTextDocument:(Y,le,ye)=>pt.onDidRemoveDocument(Y,le,ye),onDidChangeTextDocument:(Y,le,ye)=>pt.onDidChangeDocument(Y,le,ye),onDidSaveTextDocument:(Y,le,ye)=>pt.onDidSaveDocument(Y,le,ye),onWillSaveTextDocument:(Y,le,ye)=>Dt.getOnWillSaveTextDocumentEvent(Ae)(Y,le,ye),onDidChangeConfiguration:(Y,le,ye)=>Lt.onDidChangeConfiguration(Y,le,ye),getConfiguration(Y,le){return le=arguments.length===1?void 0:le,Lt.getConfiguration(Y,le,Ae)},registerTextDocumentContentProvider(Y,le){return Pt.registerTextDocumentContentProvider(Y,le)},registerTaskProvider:(Y,le)=>(ot.report("window.registerTaskProvider",Ae,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(Ae,Y,le)),registerFileSystemProvider(Y,le,ye){return Wt.registerFileSystemProvider(Ae.identifier,Y,le,ye)},get fs(){return Fe},registerFileSearchProvider:(Y,le)=>(fe.checkProposedApiEnabled(Ae),St.registerFileSearchProvider(Y,le)),registerTextSearchProvider:(Y,le)=>(fe.checkProposedApiEnabled(Ae),St.registerTextSearchProvider(Y,le)),registerRemoteAuthorityResolver:(Y,le)=>(fe.checkProposedApiEnabled(Ae),je.registerRemoteAuthorityResolver(Y,le)),registerResourceLabelFormatter:Y=>(fe.checkProposedApiEnabled(Ae),Ht.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,le,ye)=>kt.onDidCreateFile(Y,le,ye),onDidDeleteFiles:(Y,le,ye)=>kt.onDidDeleteFile(Y,le,ye),onDidRenameFiles:(Y,le,ye)=>kt.onDidRenameFile(Y,le,ye),onWillCreateFiles:(Y,le,ye)=>kt.getOnWillCreateFileEvent(Ae)(Y,le,ye),onWillDeleteFiles:(Y,le,ye)=>kt.getOnWillDeleteFileEvent(Ae)(Y,le,ye),onWillRenameFiles:(Y,le,ye)=>kt.getOnWillRenameFileEvent(Ae)(Y,le,ye),openTunnel:Y=>(fe.checkProposedApiEnabled(Ae),ft.openTunnel(Ae,Y).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return fe.checkProposedApiEnabled(Ae),ft.getTunnels()},onDidChangeTunnels:(Y,le,ye)=>(fe.checkProposedApiEnabled(Ae),ft.onDidChangeTunnels(Y,le,ye)),registerTimelineProvider:(Y,le)=>(fe.checkProposedApiEnabled(Ae),ci.registerTimelineProvider(Y,le,Ae.identifier,at.converter))},oe={get inputBox(){return ot.report("scm.inputBox",Ae,"Use 'SourceControl.inputBox' instead"),Zt.getLastInputBox(Ae)},createSourceControl(Y,le,ye){return Zt.createSourceControl(Ae,Y,le,ye)}},Ie={createCommentController(Y,le){return li.createCommentController(Ae,Y,le)}},Ve={get activeDebugSession(){return rt.activeDebugSession},get activeDebugConsole(){return rt.activeDebugConsole},get breakpoints(){return rt.breakpoints},onDidStartDebugSession(Y,le,ye){return rt.onDidStartDebugSession(Y,le,ye)},onDidTerminateDebugSession(Y,le,ye){return rt.onDidTerminateDebugSession(Y,le,ye)},onDidChangeActiveDebugSession(Y,le,ye){return rt.onDidChangeActiveDebugSession(Y,le,ye)},onDidReceiveDebugSessionCustomEvent(Y,le,ye){return rt.onDidReceiveDebugSessionCustomEvent(Y,le,ye)},onDidChangeBreakpoints(Y,le,ye){return rt.onDidChangeBreakpoints(Y,le,ye)},registerDebugConfigurationProvider(Y,le,ye){return rt.registerDebugConfigurationProvider(Y,le,ye||F.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,le){return rt.registerDebugAdapterDescriptorFactory(Ae,Y,le)},registerDebugAdapterTrackerFactory(Y,le){return rt.registerDebugAdapterTrackerFactory(Y,le)},startDebugging(Y,le,ye){return!ye||typeof ye=="object"&&"configuration"in ye?rt.startDebugging(Y,le,{parentSession:ye}):rt.startDebugging(Y,le,ye||{})},stopDebugging(Y){return rt.stopDebugging(Y)},addBreakpoints(Y){return rt.addBreakpoints(Y)},removeBreakpoints(Y){return rt.removeBreakpoints(Y)},asDebugSourceUri(Y,le){return rt.asDebugSourceUri(Y,le)}},Je={registerTaskProvider:(Y,le)=>_t.registerTaskProvider(Ae,Y,le),fetchTasks:Y=>_t.fetchTasks(Y),executeTask:Y=>_t.executeTask(Ae,Y),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(Y,le,ye)=>_t.onDidStartTask(Y,le,ye),onDidEndTask:(Y,le,ye)=>_t.onDidEndTask(Y,le,ye),onDidStartTaskProcess:(Y,le,ye)=>_t.onDidStartTaskProcess(Y,le,ye),onDidEndTaskProcess:(Y,le,ye)=>_t.onDidEndTaskProcess(Y,le,ye)},nt={openNotebookDocument:(Y,le)=>(fe.checkProposedApiEnabled(Ae),tt.openNotebookDocument(Y,le)),get onDidOpenNotebookDocument(){return fe.checkProposedApiEnabled(Ae),tt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return fe.checkProposedApiEnabled(Ae),tt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return fe.checkProposedApiEnabled(Ae),tt.onDidSaveNotebookDocument},get notebookDocuments(){return fe.checkProposedApiEnabled(Ae),tt.notebookDocuments.map(Y=>Y.notebookDocument)},get visibleNotebookEditors(){return fe.checkProposedApiEnabled(Ae),tt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return fe.checkProposedApiEnabled(Ae),tt.onDidChangeVisibleNotebookEditors},get onDidChangeActiveNotebookKernel(){return fe.checkProposedApiEnabled(Ae),tt.onDidChangeActiveNotebookKernel},registerNotebookContentProvider:(Y,le,ye)=>(fe.checkProposedApiEnabled(Ae),tt.registerNotebookContentProvider(Ae,Y,le,ye)),registerNotebookKernelProvider:(Y,le)=>(fe.checkProposedApiEnabled(Ae),tt.registerNotebookKernelProvider(Ae,Y,le)),createNotebookEditorDecorationType(Y){return fe.checkProposedApiEnabled(Ae),tt.createNotebookEditorDecorationType(Y)},get activeNotebookEditor(){return fe.checkProposedApiEnabled(Ae),tt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,le,ye){return fe.checkProposedApiEnabled(Ae),tt.onDidChangeActiveNotebookEditor(Y,le,ye)},onDidChangeNotebookDocumentMetadata(Y,le,ye){return fe.checkProposedApiEnabled(Ae),tt.onDidChangeNotebookDocumentMetadata(Y,le,ye)},onDidChangeNotebookCells(Y,le,ye){return fe.checkProposedApiEnabled(Ae),tt.onDidChangeNotebookCells(Y,le,ye)},onDidChangeNotebookEditorSelection(Y,le,ye){return fe.checkProposedApiEnabled(Ae),tt.onDidChangeNotebookEditorSelection(Y,le,ye)},onDidChangeNotebookEditorVisibleRanges(Y,le,ye){return fe.checkProposedApiEnabled(Ae),tt.onDidChangeNotebookEditorVisibleRanges(Y,le,ye)},onDidChangeCellOutputs(Y,le,ye){return fe.checkProposedApiEnabled(Ae),tt.onDidChangeCellOutputs(Y,le,ye)},onDidChangeCellLanguage(Y,le,ye){return fe.checkProposedApiEnabled(Ae),tt.onDidChangeCellLanguage(Y,le,ye)},onDidChangeCellMetadata(Y,le,ye){return fe.checkProposedApiEnabled(Ae),tt.onDidChangeCellMetadata(Y,le,ye)},createConcatTextDocument(Y,le){return fe.checkProposedApiEnabled(Ae),new he.ExtHostNotebookConcatDocument(tt,pt,Y,le)},createCellStatusBarItem(Y,le,ye){return fe.checkProposedApiEnabled(Ae),tt.createNotebookCellStatusBarItemInternal(Y,le,ye)}};return{version:me.version,authentication:hi,commands:fi,comments:Ie,debug:Ve,env:ii,extensions:Jt,languages:gi,notebook:nt,scm:oe,tasks:Je,test:mi,window:W,workspace:N,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:y.CancellationTokenSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTrigger:F.CodeActionTrigger,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:F.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,EventEmitter:T.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:d.FileType,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,Hover:F.Hover,IndentAction:S.IndentAction,InlineHint:F.InlineHint,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:P.OverviewRulerLane,ParameterInformation:F.ParameterInformation,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:i.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,UIKind:a.UIKind,Uri:I.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,get RemoteAuthorityResolverError(){return F.RemoteAuthorityResolverError},get ResolvedAuthority(){return F.ResolvedAuthority},get SourceControlInputBoxValidationType(){return F.SourceControlInputBoxValidationType},get ExtensionRuntime(){return F.ExtensionRuntime},get TimelineItem(){return F.TimelineItem},get CellKind(){return F.CellKind},get CellOutputKind(){return F.CellOutputKind},get NotebookCellRunState(){return F.NotebookCellRunState},get NotebookRunState(){return F.NotebookRunState},get NotebookCellStatusBarAlignment(){return F.NotebookCellStatusBarAlignment},get NotebookEditorRevealType(){return F.NotebookEditorRevealType},get NotebookCellOutput(){return F.NotebookCellOutput},get NotebookCellOutputItem(){return F.NotebookCellOutputItem},get LinkedEditingRanges(){return F.LinkedEditingRanges},get TestRunState(){return F.TestRunState},get TestMessageSeverity(){return F.TestMessageSeverity},get TestState(){return F.TestState}}}}e.createApiFactoryAndRegisterActors=J;class X{constructor(me,Pe,Fe,je){this._extensionService=me,this._originExtensionId=Pe,this._identifier=Fe.identifier,this.id=Fe.identifier.value,this.extensionUri=Fe.extensionLocation,this.extensionPath=E.normalize(De.originalFSPath(Fe.extensionLocation)),this.packageJSON=Fe,this.extensionKind=je}get isActive(){return this._extensionService.isActivated(this._identifier)}get exports(){if(this.packageJSON.api!=="none")return this._extensionService.getExtensionExports(this._identifier)}activate(){return this._extensionService.activateByIdWithErrors(this._identifier,{startup:!1,extensionId:this._originExtensionId,activationEvent:"api"}).then(()=>this.exports)}}}),define(ve[217],_e([0,1,62,97,31,96,35,74,40,41,99,100,101,77,76,69,73,98,75,48,72]),function(se,e,b,y,A,T,E,k,I,i,P,S,v,d,a,m,p,f,c,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),b.registerSingleton(d.IExtensionStoragePaths,d.ExtensionStoragePaths),b.registerSingleton(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),b.registerSingleton(k.IExtHostCommands,k.ExtHostCommands),b.registerSingleton(E.IExtHostConfiguration,E.ExtHostConfiguration),b.registerSingleton(c.IExtHostConsumerFileSystem,c.ExtHostConsumerFileSystem),b.registerSingleton(S.IExtHostDebugService,S.WorkerExtHostDebugService),b.registerSingleton(T.IExtHostDecorations,T.ExtHostDecorations),b.registerSingleton(I.IExtHostDocumentsAndEditors,I.ExtHostDocumentsAndEditors),b.registerSingleton(n.IExtHostFileSystemInfo,n.ExtHostFileSystemInfo),b.registerSingleton(y.IExtHostOutputService,y.ExtHostOutputService),b.registerSingleton(v.IExtHostSearch,v.ExtHostSearch),b.registerSingleton(a.IExtHostStorage,a.ExtHostStorage),b.registerSingleton(P.IExtHostTask,P.WorkerExtHostTask),b.registerSingleton(i.IExtHostTerminalService,i.WorkerExtHostTerminalService),b.registerSingleton(m.IExtHostTunnelService,m.ExtHostTunnelService),b.registerSingleton(f.IExtHostWindow,f.ExtHostWindow),b.registerSingleton(A.IExtHostWorkspace,A.ExtHostWorkspace),b.registerSingleton(o.IExtHostSecretState,o.ExtHostSecretState)}),define(ve[218],_e([0,1,216,36,212,7,15]),function(se,e,b,y,A,T,E){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var I;(function(v){var d;const a=(d=self.trustedTypes)===null||d===void 0?void 0:d.createPolicy("TrustedFunctionWorkaround",{createScript:(p,...f)=>{f.forEach(h=>{var t;if(!((t=self.trustedTypes)===null||t===void 0?void 0:t.isScript(h)))throw new Error("TrustedScripts only, please")});const c=f.slice(0,-1).join(","),n=f.pop().toString();return`(function anonymous(${c}) {
${n}
})`}});function m(...p){return a?self.eval(a.createScript("",...p)):new Function(...p)}v.create=m})(I||(I={}));class i extends A.RequireInterceptor{_installInterceptor(){}getModule(d,a){for(let m of this._alternatives){let p=m(d);if(p){d=p;break}}if(this._factories.has(d))return this._factories.get(d).load(d,a,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends y.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const d=this._instaService.invokeFunction(b.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(i,d,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(d){return d.browser}async _loadCommonJSModule(d,a,m){var p,f,c,n,o,h,t,s;a=a.with({path:S(a.path,".js")}),d&&performance.mark(`code/extHost/willFetchExtensionCode/${d.value}`);const l=await fetch(a.toString(!0));if(d&&performance.mark(`code/extHost/didFetchExtensionCode/${d.value}`),l.status!==200)throw new Error(l.statusText);const u=await l.text(),r=`${a.toString(!0)}#vscode-extension`,g=`${u}
//# sourceURL=${r}`;let C;try{C=I.create((f=(p=P._ttpExtensionScripts)===null||p===void 0?void 0:p.createScript("module"))!==null&&f!==void 0?f:"module",(n=(c=P._ttpExtensionScripts)===null||c===void 0?void 0:c.createScript("exports"))!==null&&n!==void 0?n:"exports",(h=(o=P._ttpExtensionScripts)===null||o===void 0?void 0:o.createScript("require"))!==null&&h!==void 0?h:"require",(s=(t=P._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript(g))!==null&&s!==void 0?s:g)}catch(O){throw d?console.error(`Loading code for extension ${d.value} failed: ${O.message}`):console.error(`Loading code failed: ${O.message}`),console.error(`${a.toString(!0)}${typeof O.line=="number"?` line ${O.line}`:""}${typeof O.column=="number"?` column ${O.column}`:""}`),console.error(O),O}const _={},D={exports:_},w=O=>{const R=this._fakeModules.getModule(O,a);if(R===void 0)throw new Error(`Cannot load module '${O}'`);return R};try{return m.codeLoadingStart(),d&&performance.mark(`code/extHost/willLoadExtensionCode/${d.value}`),C(D,_,w),D.exports!==_?D.exports:_}finally{d&&performance.mark(`code/extHost/didLoadExtensionCode/${d.value}`),m.codeLoadingStop()}}async $setRemoteEnvironment(d){throw new Error("Not supported")}async _waitForDebuggerAttachment(d=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const a=Date.now()+d;for(;Date.now()<a&&!("__jsDebugIsReady"in globalThis);)await E.timeout(10)}}}e.ExtHostExtensionService=P,P._ttpExtensionScripts=(k=self.trustedTypes)===null||k===void 0?void 0:k.createPolicy("ExtensionScripts",{createScript:v=>v});function S(v,d){return v.endsWith(d)?v:v+d}}),define(ve[219],_e([0,1,62,17,36,218,204]),function(se,e,b,y,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),b.registerSingleton(A.IExtHostExtensionService,T.ExtHostExtensionService),b.registerSingleton(y.ILogService,E.ExtHostLogService)}),define(ve[221],_e([0,1,27,3,176,213,206,10,78,217,219]),function(se,e,b,y,A,T,E,k,I){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0});const P=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const S=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const p=(i=self.trustedTypes)===null||i===void 0?void 0:i.createPolicy("extensionHostWorker",{createScriptURL:c=>c}),f=self.Worker;Worker=function(c,n){const o=`importScripts('${c}');`;n=n||{},n.name=n.name||k.basename(c.toString());const h=new Blob([o],{type:"application/javascript"}),t=URL.createObjectURL(h);return new f(p?p.createScriptURL(t):t,n)}}else self.Worker=class extends E.NestedWorker{constructor(p,f){super(S,p,Object.assign({name:k.basename(p.toString())},f))}};const v=new class{exit(p){P()}async exists(p){return!0}async realpath(p){return p}};class d{constructor(){const f=new MessageChannel,c=new y.Emitter;let n=!1;S(f.port2,[f.port2]),f.port1.onmessage=o=>{const{data:h}=o;if(!(h instanceof ArrayBuffer)){console.warn("UNKNOWN data received",h);return}const t=b.VSBuffer.wrap(new Uint8Array(h,0,h.byteLength));if(A.isMessageOfType(t,2)){n=!0,m("received terminate message from renderer");return}c.fire(t)},this.protocol={onMessage:c.event,send:o=>{if(!n){const h=o.buffer.buffer.slice(o.buffer.byteOffset,o.buffer.byteOffset+o.buffer.byteLength);f.port1.postMessage(h,[h])}}}}}function a(p){return new Promise(f=>{const c=p.onMessage(n=>{c.dispose();const o=JSON.parse(n.toString());p.send(A.createMessageOfType(0)),f({protocol:p,initData:o})});p.send(A.createMessageOfType(1))})}let m=p=>P();(function(){const f=new d;I.mark("code/extHost/willConnectToRenderer"),a(f.protocol).then(c=>{I.mark("code/extHost/didWaitForInitData");const n=new T.ExtensionHostMain(c.protocol,c.initData,v,null);m=o=>n.terminate(o)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/622cb03f7e070a9670c94bae1a45d78d7181fbd4/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
